--

-- Created by Luocs.xu.

-- User: bike

-- Date: 2018/3/27

-- To change this template use File | Settings | File Templates.

--

-- 兼容新版本的sysbench
-- 原生的sysbench.rand.uniform发现不够均匀，采用lua的库函数
function get_uniform(s, e)
	return math.random(math.floor(s), math.floor(e))
end
sb_rand = sysbench.rand.default
sb_rand_str = sysbench.rand.string
sb_rand_uniform = get_uniform
sb_rand_gaussian = sysbench.rand.gaussian
sb_rand_special = sysbench.rand.special
sb_rand_pareto = sysbench.rand.pareto_new
get_global_seq = sysbench.rand.get_global_seq
set_global_seq_min = sysbench.rand.set_global_seq_min

function set_rand_uniform()
    -- 如果采用了随机种子，恢复成默认sysbench生成随机数的方式
    -- 只能在thread_init 和 cmd_prepare/cmd_warmup 中调用
    if (sysbench.opt.rand_seed > 0) then
        sb_rand_uniform = sysbench.rand.uniform
    else
        sb_rand_uniform = get_uniform
    end
end

sysbench.cmdline.options = {
   table_size =
      {"Number of rows per table", 10000},
   tables =
      {"Number of tables", 1},
   db_type =
      {"Storage engine, if MySQL is used", "mysql"},
}



function init()

end

function thread_init()
   drv = sysbench.sql.driver()
   con = drv:connect()

end

function thread_done()
   con:disconnect()
end


function makePoint(x,y)
    return "POINT("..x.." "..y..")"
end


function create_insert(con,table_id)
    local total = sysbench.opt.table_size
    local table_name="battle_2018_user_position"..table_id
    local sql = [[

    CREATE TABLE ]] ..table_name.. [[ (

        `id` int(11) NOT NULL AUTO_INCREMENT,

        `user_id` int(11) NOT NULL,

        `position` geometry NOT NULL,

        `geo_hash` varchar(100) NOT NULL,

        `last_update` datetime NOT NULL,

        `create_time` datetime NOT NULL,

        PRIMARY KEY (`id`),

        SPATIAL KEY `idx_position` (`position`),

        KEY `idx_user_id` (`user_id`)

    ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4

    ]]
    con:query(sql)
--    print("create table "..table_name)

    con:bulk_insert_init("insert into " ..table_name.. "(user_id, position, geo_hash, last_update, create_time) values")
    for userid=1, total do
        local time = os.date("%Y-%m-%d %H:%M:%S", os.time())
        local x_f = sb_rand_uniform(73,135)
        local y_f = sb_rand_uniform(5,53)
        local x_h = sb_rand_uniform(100000000, 999999999)
        local y_h = sb_rand_uniform(100000000, 999999999)
        local x = x_f.."."..x_h
        local y = y_f.."."..y_h
        local mypoi = makePoint(x,y)
        con:bulk_insert_next("("..userid..",st_geomfromtext('"..mypoi.."'),ST_GeoHash("..x..","..y..",10),'"..time.."',now())")
        --break
    end
    print ("Creating table "..table_name)
    con:bulk_insert_done()
end

function prepare()

    local drv = sysbench.sql.driver()
    local con = drv:connect()
--    set_rand_uniform()
   --con:query("select * from sbtest1 into outfile '/tmp/sbtest1.out'")
--    print ("sysbench.tid"..sysbench.tid)
--    print ("sysbenchthreads"..sysbench.opt.threads)
--    print ("ssybenchtales"..sysbench.opt.tables)
    for i = sysbench.tid % sysbench.opt.threads + 1, sysbench.opt.tables
    do
--        print ("create insert "..i)
        create_insert(con, i)
    end

end


--function cleanup()
--    local drv = sysbench.sql.driver()
--    local con = drv:connect()
--    local sql = "drop table if exists " .. table_name
--    print(sql)
--    con:query(sql)
--end

function cleanup()
    local drv = sysbench.sql.driver()
    local con = drv:connect()
    for i = 1,sysbench.opt.tables do
         print("Dropping table ".. "battle_2018_user_position" ..i ..",".. "...")
         con:query("DROP TABLE IF EXISTS battle_2018_user_position".. i )
    end
end


function Split(szFullString, szSeparator)
    local nFindStartIndex = 1
    local nSplitIndex = 1
    local nSplitArray = {}
    while true do
        local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)
        if not nFindLastIndex then
            nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, string.len(szFullString))
            break
        end
        nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, nFindLastIndex - 1)
        nFindStartIndex = nFindLastIndex + string.len(szSeparator)
        nSplitIndex = nSplitIndex + 1
    end
    return nSplitArray
end



