#!/usr/bin/env sysbench



sysbench.cmdline.options = {
    short_prepare = {"whether to use short prepare in long connection",false}
}


function prepare()
   drv = sysbench.sql.driver()
   con = drv:connect()
   con:query("drop table if exists short_big_prepare")
   con:query("create table short_big_prepare(id int)")
   con:query("insert into short_big_prepare values(1)")
   con:disconnect()
end

function cleanup()
end

function thread_init()
   drv = sysbench.sql.driver()
   con = drv:connect()
   query = "select * from short_big_prepare where id in (?"
   params = {}
   for i=1,5000
   do
        query = query .. ",?"
   end
   query = query .. ");"

   short_prepare = sysbench.opt.short_prepare
   if not short_prepare then
      stmt = con:prepare(query)
   end
end

function thread_done()
	if con then
        if not short_prepare then
            stmt:close()
        end
		con:disconnect()
	end
end

function event()
   if short_prepare then
       stmt = con:prepare(query)
   end
   params = {}
   for i=1, 5000
   do
   	    params[i] = stmt:bind_create(sysbench.sql.type.INT)
        params[i]:set(i)
   end
   params[5001] = stmt:bind_create(sysbench.sql.type.INT)
   params[5001]:set(5001)
   stmt:bind_param(unpack(params))
   stmt:execute()
   if short_prepare then
       stmt:close()
   end
end
