require("dataqueue")
BASE_PATH = "/pod_resource"

-- 兼容新版本的sysbench
-- 原生的sysbench.rand.uniform发现不够均匀，采用lua的库函数
function get_uniform(s, e)
	return math.random(math.floor(s), math.floor(e))
end
sb_rand = sysbench.rand.default
sb_rand_str = sysbench.rand.string
--sb_rand_uniform = get_uniform
sb_rand_gaussian = sysbench.rand.gaussian
sb_rand_special = sysbench.rand.special
sb_rand_pareto = sysbench.rand.pareto_new
get_global_seq = sysbench.rand.get_global_seq
set_global_seq_min = sysbench.rand.set_global_seq_min

function set_rand_uniform()
    -- 如果采用了随机种子，恢复成默认sysbench生成随机数的方式
    -- 只能在thread_init 和 cmd_prepare/cmd_warmup 中调用
    if (sysbench.opt.rand_seed > 0) then
        sb_rand_uniform = sysbench.rand.uniform
    else
        sb_rand_uniform = get_uniform
    end
end

function get_filename(con,isinit)
    drv = sysbench.sql.driver()
    local host
    local port
    if drv:name() == "pgsql" then
        host = sysbench.opt.pgsql_host
        port = sysbench.opt.pgsql_port
    else
        host = con:query_row("select @@hostname")
        port = con:query_row("select @@port")
    end
	local queueInitfile
	if isinit ~= 1 then
    	queueInitfile=BASE_PATH .. "/prepare_"..host..":"..port
	else
		queueInitfile=BASE_PATH .. "/init_prepare_"..host..":"..port
		print(queueInitfile)
	end

    return queueInitfile
end

function random_filequeue(filename)
	local shuffilename=string.gsub(filename,"init_","")
	local execmd="shuf "..filename.." -o "..shuffilename
	print(execmd..".....")
	os.execute(execmd)
	execmd="rm -f "..filename
	print(execmd..".....")
	os.execute(execmd)
end


function flush_file(f, seq, f_table)
    if math.fmod(seq,5000) == 0 then
        for i=1,#f_table do
            f:write(f_table[i] .. "\n")
            f:flush()
            f_table[i]=nil
        end
        f_table=nil
    end
end


function create_insert(con,table_id)

    local i
    local cart_id
    local user_id
    local query
    local seq
    local filename=get_filename(con,1)
    local tmpfiletable={}
    i = table_id
    seq=1
    print("Creating table ".."member_cart_" .. i ..",".. "...")
    if drv:name() == "pgsql" then
        query = [[
            CREATE TABLE member_cart_]] .. i .. [[(
            cart_id bigint NOT NULL ,
            sku_id bigint NOT NULL DEFAULT '0',
            item_id bigint NOT NULL ,
            quantity bigint NOT NULL ,
            user_id bigint NOT NULL ,
            status smallint NOT NULL ,
            type smallint NOT NULL DEFAULT '0' ,
            sub_type bigint NOT NULL DEFAULT '0' ,
            gmt_create timestamp NOT NULL ,
            gmt_modified timestamp NOT NULL ,
            attribute varchar(2048) DEFAULT NULL ,
            attribute_cc bigint NOT NULL DEFAULT '0' ,
            sync_version bigint DEFAULT NULL ,
            ex1 bigint DEFAULT NULL ,
            ex2 varchar(500) DEFAULT NULL ,
            seller_id bigint NOT NULL DEFAULT '0' ,
            ext_status smallint NOT NULL DEFAULT '0' ,
            PRIMARY KEY (user_id,cart_id)
            )]]
    else

    query = [[

        CREATE TABLE `member_cart_]] .. i .. [[` (
  `cart_id` bigint(20) NOT NULL COMMENT '购物车id',
  `sku_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '存放商品的skuId，无sku时，为0',
  `item_id` bigint(20) NOT NULL COMMENT '外部id：商品id或者skuid',
  `quantity` bigint(20) NOT NULL COMMENT '购买数量',
  `user_id` bigint(20) NOT NULL COMMENT '用户id',
  `status` tinyint(4) NOT NULL COMMENT '状态1：正常-1：删除',
  `type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '默认值0，保留字段，日后业务扩展使用',
  `sub_type` bigint(20) NOT NULL DEFAULT '0' COMMENT '购物车类型',
  `gmt_create` datetime NOT NULL COMMENT '属性创建时间',
  `gmt_modified` datetime NOT NULL COMMENT '属性修改时间',
  `attribute` varchar(2048) DEFAULT NULL COMMENT '用于存放附件信息，例如套餐id列表',
  `attribute_cc` int(11) NOT NULL DEFAULT '0' COMMENT '防并发',
  `sync_version` int(11) DEFAULT NULL COMMENT '版本',
  `ex1` bigint(20) DEFAULT NULL COMMENT '保留字段',
  `ex2` varchar(500) DEFAULT NULL COMMENT '保留字段',
  `seller_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '卖家id',
  `ext_status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '购物车其他维度的状态，默认值为0. 为个性化需求做扩展的，后面会结合attribute一起使用',
  PRIMARY KEY (`user_id`,`cart_id`)
) ENGINE=]].. sysbench.opt.mysql_table_engine ..[[ DEFAULT CHARSET=utf8 COMMENT='会员购物车';]]
end

        con:query(query)
        if drv:name() == "pgsql" then
            con:bulk_insert_init("INSERT INTO member_cart_" .. i .. " (cart_id,sku_id,item_id,quantity,user_id,status,type,sub_type,gmt_create,gmt_modified,attribute,attribute_cc,sync_version,ex1,ex2,seller_id,ext_status) VALUES")
        else
        con:bulk_insert_init("INSERT INTO member_cart_" .. i .. " (`cart_id`,`sku_id`,`item_id`,`quantity`,`user_id`,`status`,`type`,`sub_type`,`gmt_create`,`gmt_modified`,`attribute`,`attribute_cc`,`sync_version`,`ex1`,`ex2`,`seller_id`,`ext_status`) VALUES")
        end
        local f=io.open(filename,"a+")
        print(f)
        -- bulk insert
        for cart_id = 1, sysbench.opt.table_size do
            local range_id = sb_rand(1, 13)
            local repeat_id = sb_rand_uniform(range_id *10-10,range_id *10)
            local user_id=sb_rand_uniform(1,20000000)
            local min_cartid=seq+1
	    local max_cartid=min_cartid+repeat_id
	    for r=0, repeat_id do
                seq=seq+1
                con:bulk_insert_next("("..seq..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..user_id..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 10)..","..sb_rand_uniform(1, 10000000000)..",".."now(),".."now(),".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 10000000000)..",".."'"..sb_rand_str(string.rep('@', 200)).."',"..sb_rand_uniform(1, 10000000000)..","..sb_rand_uniform(1, 100)..")")
                --rowtext="echo "..user_id..","..seq..",member_cart_".. i ..","..repeat_id..">> "..filename
                local rowtext=user_id..","..seq..","..i..","..repeat_id..","..min_cartid..","..max_cartid
                table.insert(tmpfiletable,rowtext)
                --print(rowtext)
                --os.execute(rowtext)
                flush_file(f, seq, tmpfiletable)
            end

        end
        --commit
        con:bulk_insert_done()
        flush_file(f, 0, tmpfiletable)
        f:close()
    end

function init()
   assert(event ~= nil,
          "this script is meant to be included by other OLTP scripts and " ..
             "should not be called directly.")
  -- 队列长度2^20,初始化7个队列，0号队列存储初始化数据,1-5号队列为均匀insert，10号队列为update/select

  local hasfile=os.execute('ls '.. BASE_PATH .. '/init_prepare*')
  print(hasfile)
  if hasfile == 0 then
  	local tmp=io.popen('ls '.. BASE_PATH .. '/init_prepare*')
	for filename in tmp:lines() do
		random_filequeue(filename)
	end
	tmp:close()
  end

  dataqueue.queueInit(0,25)
  dataqueue.queueInit(1,20)
  dataqueue.queueInit(2,20)
  dataqueue.queueInit(3,20)
  dataqueue.queueInit(4,20)
  dataqueue.queueInit(5,20)
  dataqueue.queueInit(10,20)
end


function thread_init()
   drv = sysbench.sql.driver()
   con = drv:connect()
    set_rand_uniform()
   --con:query("set sql_log_bin=off")
   filename = get_filename(con,0)
end

function thread_done()
   con:disconnect()
   -- 任务结束后释放队列
   dataqueue.queueDestroy(0,sysbench.opt.threads)
   dataqueue.queueDestroy(1,sysbench.opt.threads)
   dataqueue.queueDestroy(2,sysbench.opt.threads)
   dataqueue.queueDestroy(3,sysbench.opt.threads)
   dataqueue.queueDestroy(4,sysbench.opt.threads)
   dataqueue.queueDestroy(5,sysbench.opt.threads)
   dataqueue.queueDestroy(10,sysbench.opt.threads)
end



function cleanup()
    local i
    local drv = sysbench.sql.driver()
    local con = drv:connect()
    local queueInitfile=get_filename(con,0)
    for i = 1,sysbench.opt.tables do
         print("Dropping table ".. "member_cart_" .. i ..",".. "...")
         con:query("DROP TABLE IF EXISTS member_cart_".. i )
    end
    os.execute("rm -f "..queueInitfile)
end


function cmd_prepare()
   local drv = sysbench.sql.driver()
   local con = drv:connect()
   local i
   set_rand_uniform()
   for i = sysbench.tid % sysbench.opt.threads + 1, sysbench.opt.tables,
   sysbench.opt.threads do
       create_insert(con,i)
   end
  --con:query("select * from sbtest1 into outfile '/tmp/sbtest1.out'")
end

-- Implement parallel prepare and warmup commands, define 'prewarm' as an alias
-- for 'warmup'
sysbench.cmdline.commands = {
   prepare = {cmd_prepare, sysbench.cmdline.PARALLEL_COMMAND},
   warmup = {cmd_warmup, sysbench.cmdline.PARALLEL_COMMAND},
   prewarm = {cmd_warmup, sysbench.cmdline.PARALLEL_COMMAND}
}

function lua_string_split(str, split_char)
    local sub_str_tab = {};
    while (true) do
        local pos = string.find(str, split_char);
        if (not pos) then
            sub_str_tab[#sub_str_tab + 1] = str;
            break;
        end
        local sub_str = string.sub(str, 1, pos - 1);
        sub_str_tab[#sub_str_tab + 1] = sub_str;
        str = string.sub(str, pos + 1, #str);
    end

    return sub_str_tab;
end

function is_include(value, tab)
    for k,v in ipairs(tab) do
      if v == value then
          return 1
      end
    end
    return 0
end

function random_in(minvalue,maxvalue,in_count)
    local instr=""
    local i=0
    local tmp={}
    local str=""
    local invalue
    while in_count>0 do
        invalue=sb_rand_uniform(minvalue,maxvalue)
        if is_include(invalue,tmp) == 0 then
            instr=instr..tostring(invalue)..","
            in_count=in_count-1
            i=i+1
            tmp[i]=invalue
        end
    end
    return string.sub(instr,1,-2)
end

sysbench.cmdline.options = {

   row_len =
      {"length of average pad column, max 3000", 100},
   table_size =
      {"Number of rows per table", 10000},
   oltp_range_size =
      {"Range size for range SELECT queries", 100},
   tables =
      {"Number of tables", 1},
   mysql_table_engine =
      {"Storage engine, if MySQL is used", "innodb"},

    addcarts={"addcarts",483},
    queryCartsList={"queryCartsList",1619},
    queryItemByCarts={"queryItemByCarts",818},
    updateItemQuantity={"updateItemQuantity",240},
    deleteByOrder={"deleteByOrder",498},
    deleteByUser={"deleteByUser",167},
    --insert={"insert carts",30},
    --update_single={"update_single",26},
    --update_batch={"update batch",4},
    --select_numberic={"select num",11},
    --select_list={"select list",36}

}
