-- sysbench --mysql-host=127.0.0.1 --mysql-port=2250 --mysql-user=root
--          --mysql-password=Passw0rd --db-driver=mysql short_con.lua
--          --threads=1 --time=5 --mysql-db=test --report-interval=1
--          --target_tps=5 --ignore-mysql-errors=2003 run

require("timed_event")

if sysbench.cmdline.command == nil then
   error("Command is required. Supported commands: prepare, run, cleanup, help")
end

-- Command line options
sysbench.cmdline.options = {
   checksum_method =
      {"CPU bound checksum algorithm: MD5|CRC|MEMCPY", "MD5"},
   target_tps =
      {"Desired transaction throughput (trx/sec). Default(-1) is no limit.", -1}
}

function thread_init(thread_id)
    drv = sysbench.sql.driver()
    con = drv:connect()

    timed_event_init(thread_id)
end

function event(thread_id)

  if string.upper(sysbench.opt.checksum_method) == "CRC" then
    con:query("SELECT BENCHMARK(100000000,crc32('0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef'))")
  elseif string.upper(sysbench.opt.checksum_method) == "MD5" then
    con:query("SELECT BENCHMARK(10000000,md5('0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef'))")
  elseif string.upper(sysbench.opt.checksum_method) == "MEMCPY" then
    con:query("SELECT BENCHMARK(1000,repeat('abcde12345abcde12345abcde12345abcde12345abcde12345',1000000))")
  else
    print("Checksum method must be CRC or MD5")
    os.exit()
 end

  throttle_event(thread_id) --Calculate the time delay to achieve target TPS

end



