#!/usr/bin/env sysbench
-- Copyright (C) 2006-2017 Alexey Kopytov <akopytov@gmail.com>

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

-- ----------------------------------------------------------------------
-- Insert-Only OLTP benchmark
-- ----------------------------------------------------------------------

require("oltp_common")

sysbench.cmdline.commands.prepare = {
   function ()
      if (not sysbench.opt.auto_inc) then
         -- Create empty tables on prepare when --auto-inc is off, since IDs
         -- generated on prepare may collide later with values generated by
         -- sysbench.rand.unique()
         sysbench.opt.table_size=0
      end

      cmd_prepare()
   end,
   sysbench.cmdline.PARALLEL_COMMAND
}

function prepare_statements()
   -- To support PG temp table
   if sysbench.opt.pg_temp_table then
      for i = 1, sysbench.opt.tables, 1 do
         create_table(drv, con, i)
      end
   end
end

function event()
	
	for i=sysbench.opt.table_size ,1 ,-1 do
	insert()
    end
    truncate()
 end	 

function truncate()
   local table_name = "sbtest" .. sysbench.rand.uniform(1, sysbench.opt.tables)
       local max_op =  sysbench.opt.pg_partition_num-10
   local op_type = sysbench.rand.uniform(1,max_op)
   print(op_type)
   if op_type%10 <5 then
	   table_name=table_name.."_p"..op_type
   end	   
  print(string.format("truncate  %s ",table_name))
   con:query(string.format("truncate  %s ",table_name))

end


function insert()
   local table_name = "sbtest" .. sysbench.rand.uniform(1, sysbench.opt.tables)
   local k_val = sysbench.rand.default(1, sysbench.opt.table_size)
   local c_val = get_c_value()
   local pad_val = get_pad_value()

   if (drv:name() == "pgsql" and sysbench.opt.auto_inc) and (not sysbench.opt.pg_global_temp_table)then
	 -- print(string.format("INSERT INTO %s (k, c, pad) VALUES " ..
	   --                                "(%d, '%s', '%s')",
		--							                                 table_name, k_val, c_val, pad_val))

      con:query(string.format("INSERT INTO %s (k, c, pad) VALUES " ..
                                 "(%d, '%s', '%s')",
                              table_name, k_val, c_val, pad_val))
   else
      if (sysbench.opt.auto_inc and drv:name() ~= "pgsql") then
         i = 0
      else
         -- Convert a uint32_t value to SQL INT
         i = sysbench.rand.unique() - 2147483648
      end
      print(string.format("INSERT INTO %s (id, k, c, pad) VALUES " ..
	                                   "(%d, %d, '%s', '%s')",
									                                 table_name, i, k_val, c_val, pad_val))
      con:query(string.format("INSERT INTO %s (id, k, c, pad) VALUES " ..
                                 "(%d, %d, '%s', '%s')",
                              table_name, i, k_val, c_val, pad_val))
   end
   throttle_event() --Calculate the time delay to achieve target TPS
end
