#!/usr/bin/env sysbench
-- Copyright (C) 2006-2017 Alexey Kopytov <akopytov@gmail.com>

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

-- ----------------------------------------------------------------------
-- Read/Write OLTP benchmark
-- ----------------------------------------------------------------------
require("oltp_common")

function prepare_statements()

   if not sysbench.opt.skip_trx then
      prepare_begin()
      prepare_commit()
   end

end

function event(thread_id)
   if not sysbench.opt.skip_trx then
      begin()
   end

    if (sysbench.opt.threads % sysbench.opt.tables ~= 0) then
        print "Number of threads must be n times of table counts!"
        os.exit()
    end

    partition_count = sysbench.opt.threads / sysbench.opt.tables
    partition_rows = sysbench.opt.tablesize / partition_count 
    partition_number = thread_id % partition_count -- 0 ~ # of partitions - 1
    table_num = thread_id % sysbench.opt.tables + 1
    range_begin = partition_number * partition_rows
    range_end =  (partition_number+1)* partition_rows
   
    query = "select count(*) from sbtest"..table_num.." where id between "..range_begin.." and "..range_end
    print(query)
    con:query(query)



   if not sysbench.opt.skip_trx then
      commit()
   end
   throttle_event() --Calculate the time delay to achieve target TPS
end
