--[[
****************************************************************************
To test async ddl:drop table

****************************************************************************
--]]

require("timed_event")

if sysbench.cmdline.command == nil then
    error("Command is required. Supported commands: run")
end

-- Command line options
sysbench.cmdline.options = {
    intrusive =
       {"Include intrusive DDL operations", "no"},
    report_csv =
       {"Report output in csv (yes, no)", "no"},
    target_tps =
       {"Desiried transaction throughput (TPS)",-1}

}
tables = {}
n_table = 0

function thread_init(thread_id)
    local i, j, k, n_fks
    local stmt
    local child_keys, parent_keys

    timed_event_init()

    drv = sysbench.sql.driver()
    con = drv:connect()
    ddl_con = drv:connect()

    if drv:name() == "mysql" then
      con:query("SET autocommit=0")
    end

end

-- The main event loop
function event()
    -- Enum current schema tables
    rs = con:query("select table_name from information_schema.tables " ..
                   "where table_type = 'BASE TABLE' and table_name like 'tb_drop%'")

    if rs.nrows == 0 then
        print("No table to drop!")
        os.exit(0)
    end
    n_table = rs.nrows
    for i = 1, n_table do
        row = rs:fetch_row()
        tables[i] = tostring(row[1])
    end
    cur_table = tables[sysbench.rand.uniform(1,n_table)]
    -- Get current ro lag,
    --[[
    -- comment the following out, since sbtest does not have sufficient privilege to get replay_lag
    -- have to control it in the test case...
    rs = con:query("select replay_lag from pg_stat_replication where application_name like 'replica%'")

    if rs.nrows == 0 then
        print("No ro replication slot !")
        return
    end

    row = rs:fetch_row()
    replay_lag = tostring(row[1])
    --]]
    --stmt =[[select EXTRACT(EPOCH FROM %s)]]:format(replay_lag)
    --[[
    rs = con:query(stmt)
    replay_lag = (row[1])

    if replay_lag > 10 then
        print("RO lag is more than 10s, let's drop tables!")
    else
        print("RO lag is "..replay_lag)
    end
    --]]
    local max_op =  1
    local op_type = sysbench.rand.uniform(1,max_op)
    if op_type == 1 then
        op = "drop_table"
    end
    _G[op](cur_table)
    throttle_event()
end

function drop_table(table_name)
    print("drop table async "..table_name)
    ddl_con:query("DROP TABLE IF EXISTS ".. table_name.. " CASCADE")
end

function sysbench.hooks.before_restart_event(err)
  sleep(1)
  con:query("ROLLBACK")
end

function sysbench.hooks.report_intermediate(stat)
    -- --   print("my stat: ", val)
       if  sysbench.opt.report_csv == "yes" then
           sysbench.report_csv(stat)
       else
           sysbench.report_default(stat)
       end
end
