-- Command line options
sysbench.cmdline.options = {
    table_size =
       {"Number of rows per table", 1000},
    tables =
       {"Number of tables", 1},
}

function prepare()
   local drv = sysbench.sql.driver()
   local con = drv:connect()

   for i = 1, sysbench.opt.tables do
     print(string.format("Create and Insert table 'sbtest%d'...", i))
     create_stmt = string.format([[create table sbtest%s (data int)]],i)
     con:query(create_stmt)
     insert_stmt = string.format([[insert into sbtest%s select id from generate_series(1,%s) as id]], i, sysbench.opt.table_size)
     con:query(insert_stmt)
   end
   con:disconnect()
end

function cleanup()
   local drv = sysbench.sql.driver()
   local con = drv:connect()

   for i = 1, sysbench.opt.tables do
      print(string.format("Dropping table 'sbtest%d'...", i))
      con:query("drop table if exists sbtest" .. i )
   end
   con:disconnect()
end

function select_count()
   local drv = sysbench.sql.driver()
   local con = drv:connect()   
   
   for i = 1, sysbench.opt.tables do
     select_stmt = string.format([[select count (*) from sbtest%s]], i)
     con:query(select_stmt)
   end
   con:disconnect()
end

-- The main event loop
function event()
    select_count()
end
