sysbench.cmdline.options={
	sqlfile=
	{"the absoulute path for the sqlfile",nil},
	interval=
	{"s,the interval time when to execute the file",0}
}

function thread_init(thread_id)
--   local curTime=os.date("%Y-%m-%d %H:%M:%S")
--   print("current Time ==>"..curTime)
   drv = sysbench.sql.driver()
   con = drv:connect()
   if sysbench.opt.sqlfile == nil then
   		print("[ERROR] sqlfile is a required parameter")	
	   os.exit()	
   end
  
   sqls={}
   parameters={}
   --read sql file, and put it in a array，sql clause is split by ;
   for line in io.lines(sysbench.opt.sqlfile) do
	   parameters_pos=string.match(line,"params##.+")
	   if parameters_pos ~= nil then
		   input_parameters=string.sub(parameters_pos,9,string.len(parameters_pos)-2)
		   sourceSQL=string.gsub(line,parameters_pos,"")
		   table.insert(sqls,sourceSQL)
		   table.insert(parameters,input_parameters)
	   else 
		   if string.len(line)  > 0 then
		   		table.insert(sqls,line)
		   		table.insert(parameters,nil)
		   end
	   end
   end
	
	if sysbench.opt.threads < #sqls then
		pos=sysbench.rand.uniform(1, #sqls)
	else
		pos=((thread_id%#sqls)+1)
		--print(thread_id..' pos='..pos)
	end
   sourceSQL=sqls[pos]
   input_parameters=parameters[pos]
end

--input: #a,b,c,d# || #a~b# || #{sql}#
function  get_specific_value(inputs)
	inputs=string.gsub(inputs,'#','')
	if string.find(inputs,",") ~=nil then
		inputs=string.gsub(inputs,","," ")
		results={}
		for word in string.gmatch(inputs,"[^%s]+") do
			if word ~= nil then
				table.insert(results,word)
			end
		end
    	randomPos=sysbench.rand.uniform(1,#results)
		return results[randomPos]
	elseif string.find(inputs,"~") then
		local startPos=string.find(inputs,"~")
		local startV=string.sub(inputs,1,startPos-1)
		local endV=string.sub(inputs,startPos+1,string.len(inputs))
		local result=sysbench.rand.uniform(tonumber(startV),tonumber(endV))
		return result
	elseif string.find(inputs,":") then
		local startPos=string.find(inputs,":")
		local tableName=string.sub(inputs,1,startPos-1)
		local columnName=string.sub(inputs,startPos+1,string.len(inputs))
		pos=sysbench.rand.uniform(1,1000)
		local select_sql="select "..columnName.." from "..tableName.." limit "..pos..",1"
	    local result=con:query_row(select_sql)
		return result
	else
		print("ERROR sqlfile including not formated parameters"..inputs)
		os.exit()
	end
end

function event(thread_id)
	--check if params###a,b,c,d,f# #1,2,3,4,5### specific value ||  params###12~35# ## range || params###tableName:columnName# ##
	if sysbench.opt.threads < #sqls then
	   pos=sysbench.rand.uniform(1, #sqls)
	   sourceSQL=sqls[pos]
	   input_parameters=parameters[pos]
	end

	if input_parameters ~= nil then
		local parameterPos=1
		executeSQL=sourceSQL
		for onePara in string.gmatch(input_parameters, "[^%s]+") do
			local replace=string.format("@@para%d",parameterPos)
			--print("parameter------>>>"..replace.." onePara----->>>"..onePara)
			executeSQL=string.gsub(executeSQL,replace,get_specific_value(onePara))
			parameterPos=parameterPos+1
		end
	--	print(executeSQL)
		con:query(executeSQL)
	else
		con:query(sourceSQL)
	end

	if sysbench.opt.interval >0 then
    	os.execute("sleep " .. sysbench.opt.interval)
	end
end
