#!/usr/bin/env sysbench
-- Copyright (C) 2006-2017 Alexey Kopytov <akopytov@gmail.com>

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

-- ----------------------------------------------------------------------
-- OLTP Point Select benchmark
-- ----------------------------------------------------------------------

require("oltp_common")

sysbench.cmdline.options.short_prepare = {"whether to use short prepare in long connection",false }

--function prepare_statements()
--   -- use 1 query per event, rather than sysbench.opt.point_selects which
--   -- defaults to 10 in other OLTP scripts
--   sysbench.opt.point_selects=1
--
--   prepare_point_selects()
--   close_statements()
--end


function thread_init()
    drv = sysbench.sql.driver()
    con = drv:connect()

    short_prepare = sysbench.opt.short_prepare
    if not short_prepare then
        local id = sysbench.rand.uniform(1, sysbench.opt.tables)
        stmt = con:prepare("SELECT c FROM sbtest" .. id .. " WHERE id=1")
    end
end

function thread_done()
	if con then
        if not short_prepare then
            stmt:close()
        end
		con:disconnect()
	end
end

function event()
    if short_prepare then
        local id = sysbench.rand.uniform(1, sysbench.opt.tables)
        stmt = con:prepare("SELECT c FROM sbtest" .. id .. " WHERE id=1")
    end
    stmt:execute()
    if short_prepare then
        stmt:close()
    end
end

