sysbench.cmdline.options = {
    is_update_info_on_run =
    {"Is update info on run (yes, no)", "no"},
    update_info_on_run_frequency =
    {"Update info on run frequency (1,1000000000000)", "1000000"},
    global_read_view_wait_out_time =
    {"global read view wait out_time(ms) (1,1000000000000)", "100000"},
    query_check_range =
    {"global read view wait time(s) (1,1000000000000)", "10"},
}


function thread_init(thread_id)
    drv = sysbench.sql.driver()
    con = drv:connect()
    replica_con = {}
    counts={}
    mins={}
    tables,primary_keys,counts,mins=get_table_info(con,sysbench.opt.mysql_db)
    query_check_range=tonumber(sysbench.opt.query_check_range)
    update_table_info_count=0
    update_info_on_run_frequency=tonumber(sysbench.opt.update_info_on_run_frequency)
    is_update_info_on_run=sysbench.opt.is_update_info_on_run
    global_read_view_wait_out_time=sysbench.opt.global_read_view_wait_out_time

    rs = con:query("select slave_host, slave_port from information_schema.INNODB_LOG_READER where role = 'replica' and status = 'active'")

    replica_count = rs.nrows
    for i = 1, replica_count do
        row = rs:fetch_row()
        local slave_host = tostring(row[1])
        --处理ip为127.0.0.1的ro，ip和rw保持一致
        if( tostring(slave_host).find(tostring("127.0.0.1"),1) ) then
            slave_host=sysbench.opt.mysql_host[1]
        end
        local slave_port = tonumber(row[2])
        replica_con[i] = ffi.C.db_connection_create2(drv, tostring(slave_host), slave_port)
        --      replica_con[i] = ffi.C.db_connection_create2(drv, tostring("10.101.168.69"), tonumber("3306"))
        if replica_con[i] == nil then
            print("Connection to replica failed")
            os.exit()
        end


    end

end


function event()
    update_table_info_count=update_table_info_count+1
    --定时更新信息
    if((tostring(is_update_info_on_run)==tostring("yes")) and (update_table_info_count%update_info_on_run_frequency==0)) then
        tables,primary_keys,counts,mins=get_table_info(con,sysbench.opt.mysql_db)
    end
    for i = 1, replica_count do
        sampling_compare_data(con,replica_con[i],tables,primary_keys,counts,mins,sysbench.opt.mysql_db)
    end

end

function sampling_compare_data(rw_con,ro_con,tables,primary_keys,counts,mins,db)
    for i,v in ipairs(tables) do
        local table=v
        local primary_key=primary_keys[i]
        local random_section = sysbench.rand.uniform(0,tonumber(counts[i])-1)
        local lower_bound=mins[i] + random_section
        local upper_bound=mins[i] + random_section+query_check_range
        global_read_view=create_global_read_view(rw_con)

        compare_sql="select group_concat(columns.column_name Separator  ';') as column_name , query_table.* from information_schema.COLUMNS as columns ,"..table.." as  query_table where COLUMNS.table_name = '"..table.."' AND COLUMNS.table_schema = '"..db.."'  and query_table."..primary_key.." between "..lower_bound.." and  "..upper_bound .." group by  COLUMNS.table_name, query_table."..primary_key.." order by query_table.".. primary_key  .." with consistent snapshot '"..global_read_view.."' wait  "..tostring(global_read_view_wait_out_time)
--        print(compare_sql)
        state ,rw_rs=pcall(con_query,rw_con,compare_sql)
        if(state==false) then
            -- 表不存在异常退出
            if(string.find(rw_rs,"Table ",1) and  string.find(rw_rs,"doesn't exist",1) ) then
                print("table not exit and ignore check :\n error info is "..rw_rs)
                --更新元数据信息
                tables,primary_keys,counts,mins=get_table_info(rw_con,sysbench.opt.mysql_db)
                return
            end
        end

        state ,ro_rs=pcall(con_query,ro_con,compare_sql)
        if(state==false) then
            print(rw_rs)
            -- 表不存在异常退出
            if(string.find(ro_rs,"Table ",1) and  string.find(ro_rs,"doesn't exist",1) ) then
                print("table not exit and ignore check :\n error info is "..rw_rs)
                tables,primary_keys,counts,mins=get_table_info(rw_con,sysbench.opt.mysql_db)
                return
            end
        end

        rw_data,rw_column_name=get_data(rw_rs)
        ro_data,ro_column_name=get_data(ro_rs)

        data_compare(rw_data,ro_data,rw_column_name,ro_column_name,rw_con,compare_sql)

        --删除global_read_view 异常忽略
        pcall(delete_global_read_view,con,global_read_view)

    end
end


function con_query (conn,sql)
    return conn:query(sql)
end

function get_data(rs)
    local index=0
    local value ={}
    local column_name=""
    for i = 1, rs.nrows do
        row = rs:fetch_row()
        one_row_value="\n"
        for i,v in ipairs(row) do
            one_row_value=one_row_value.." "..tostring(row[i])
            if(index==0) then
                column_name=column_name.." "..tostring(row[i])
                index=-1
            end
        end
        value[i]=one_row_value
    end
    return value,column_name
end


function data_compare(rw_data,ro_data,rw_column_name,ro_column_name,conn,sql)
    if(rw_data~=nil) then
        if(rw_data~=nil) then
            if(table.getn(rw_data) ~= table.getn(ro_data)) then
                error("\n compare fail \n  sql is :"..sql.." , \n data count not same ! \n rw_data count is  "..rw_rs.nrows.. ",ro_data count is "..ro_rs.nrows .. " \n rw_data is:"..print_data(rw_data) .." \n ro_data is:"..print_data(ro_data))
            else
                if(rw_column_name~=ro_column_name) then
                    --表列名信息不一致，直接退出
                    print("column name not same and ignore check :\n rw_column_name is:"..rw_column_name .."\n ro_column_name is:"..ro_column_name )
                    tables,primary_keys,counts,mins=get_table_info(conn,sysbench.opt.mysql_db)
                    return
                end
                for i = 1, table.getn(rw_data) do
                    if(rw_data[i]~=ro_data[i]) then
                        error("\n compare fail \n sql is :"..sql.." ,\n data value is not same ! \n diff data is : \n rw diff data is :"..rw_data[i].."\n ro diff data is :"..ro_data[i].." \n All data  is: \n rw all data is:  "..print_data(rw_data) .." \n ro all data is:"..print_data(ro_data))
                    end
                end
            end
        else
            error("\n compare fail \n sql is :"..sql.." ,data value is not same,rw is not nil ,but ro is nil  \n  All data  is, rw all data is  "..print_data(rw_data) .." ro all data is nil ")
        end
    end
end

function print_data(data)
    all_value=""
    for i,v in ipairs(data) do
        all_value=all_value..data[i]
    end
    return all_value
end


function get_count(con,table)
    rs=con:query("select count(*) from " ..table)
    if(rs~=nil) then
        row = rs:fetch_row()
        if(row[1]~=nil) then
            return row[1]
        end
    end
    return tonumber(0)
end

function get_min(con,table,primary_key)
    rs=con:query("select min("..primary_key..") from " ..table)
    if(rs~=nil) then
        row = rs:fetch_row()
        if(row[1]~=nil) then
            return row[1]
        end
    end
    return tonumber(0)
end

function create_global_read_view(con)
    return con:query_row("export consistent snapshot cluster")
end

function delete_global_read_view(con,global_read_view)
    con:query_row("release consistent snapshot '"..global_read_view.."'")
end

function get_table_info(con,db)
    tables={}
    primary_key_tables={}
    primary_keys={}
    counts={}
    mins={}
    rs = con:query("show tables")
    table_count = rs.nrows
    for i = 1, table_count do
        row = rs:fetch_row()
        tables[i]=tostring(row[1])
    end
    index=1
    for i,v in ipairs(tables) do
        local table=v
        rs=con:query_row("SELECT column_name FROM INFORMATION_SCHEMA.`KEY_COLUMN_USAGE` WHERE table_name='"..table.."' AND constraint_name='PRIMARY' and CONSTRAINT_SCHEMA='"..db.."'")
        local primary_key=rs
        if(primary_key~=nil) then
            primary_key_tables[index]=table
            primary_keys[index]=primary_key
            mins[index]=get_min(con,table,primary_key)
            counts[index]=get_count(con,table)
            index=index+1
        else
            print("Table "..table.. " have no primary_key" )
        end
    end
    return primary_key_tables,primary_keys,counts,mins
end


function sysbench.hooks.report_intermediate(stat)
    -- --   print("my stat: ", val)
    if  sysbench.opt.report_csv == "yes" then
        sysbench.report_csv(stat)
    else
        sysbench.report_default(stat)
    end
end

