
-- Command line options
sysbench.cmdline.options = {
	skip_trx = 
	    {"Don't start explicit transactions and execute all queries " ..
		 "in the AUTOCOMMIT mode", false},
    short_prepare =
        {"whether to use short prepare in long connection",false}
}

function thread_init(thread_id)

    drv = sysbench.sql.driver()
    con = drv:connect()
    short_prepare = sysbench.opt.short_prepare
    if not short_prepare then
        stmt = con:prepare("select 1")
    end
    if drv:name() == "mysql" then
        if not sysbench.opt.skip_trx then
            con:query("SET autocommit=0")
        end
    end
    myid = thread_id
end

function thread_done()
   if con then
       -- long prepare need to close stmt
       if not short_prepare then
	       stmt:close()
       end
	   con:disconnect()
   end
end

function event()
  -- con:query("select 1")
  if short_prepare then
      stmt = con:prepare("select 1")
  end
  stmt:execute()
  if short_prepare then
      stmt:close()
  end
  -- print(string.format("My id = %d'...", myid))
end

function sysbench.hooks.before_restart_event(err)
  con:query("ROLLBACK")
end

function sysbench.hooks.report_intermediate(stat)
-- --   print("my stat: ", val)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end


