
-- Command line options
sysbench.cmdline.options = {
    skip_trx =  
	    {"Don't start explicit transactions and execute all queries " ..
		 "in the AUTOCOMMIT mode", false},
    packet_size = 
	    {"Packet length for query", 2000},
    short_prepare =
        {"whether to use short prepare in long connection",false }
}

function thread_done()
   if con then
       -- long prepare need to close stmt
       if not short_prepare then
	       stmt:close()
       end
	   con:disconnect()
   end
end

function thread_init(thread_id)

    drv = sysbench.sql.driver()
    con = drv:connect()

    short_prepare = sysbench.opt.short_prepare
    if not short_prepare then
        sql = "select '" .. sysbench.rand.string(string.rep("@", sysbench.opt.packet_size)) .. "'"
        stmt = con:prepare(sql)
    end
    if drv:name() == "mysql" then
        if not sysbench.opt.skip_trx then
            con:query("SET autocommit=0")
        end
    end
    myid = thread_id
end

function event()
    if short_prepare then
        sql = "select '" .. sysbench.rand.string(string.rep("@", sysbench.opt.packet_size)) .. "'"
        stmt = con:prepare(sql)
    end
    stmt:execute()
    if short_prepare then
        stmt:close()
    end
end

function sysbench.hooks.before_restart_event(err)
  con:query("ROLLBACK")
end

function sysbench.hooks.report_intermediate(stat)
-- --   print("my stat: ", val)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end

