-- sysbench --mysql-host=127.0.0.1 --mysql-port=2250 --mysql-user=root 
--          --mysql-password=Passw0rd --db-driver=mysql short_con.lua  
--          --threads=1 --time=5 --mysql-db=test --report-interval=1 
--          --target_tps=5 --ignore-mysql-errors=2003 run

require("timed_event")

if sysbench.cmdline.command == nil then
   error("Command is required. Supported commands: prepare, run, cleanup, help")
end

-- Command line options
sysbench.cmdline.options = {
  skip_trx =
      {"Don't start explicit transactions and execute all queries " ..
       "in the AUTOCOMMIT mode", false},
   target_tps =
      {"Desired transaction throughput (trx/sec). Default(-1) is no limit.", -1}
} 

function thread_init()
  drv = sysbench.sql.driver()
  timed_event_init(thread_id)
end

function event()
  conn = nil
  retry = 0
  while (conn == nil and retry < MAX_RETRY) do  --retry for 5 minutes
    conn=ffi.C.db_connection_create(drv)
    if conn == nil then       -- connection failure
        ffi.C.usleep(1000000) -- sleep 1 second before retry
        retry = retry + 1
    end
  end
  -- ffi.C.usleep(20000) --Inject some dely to test
  if retry == MAX_RETRY then
    print("Max connect retry time reached, aborting")
    os.exit()
  end
  
  if not sysbench.opt.skip_trx and drv:name()=="mysql" then
    conn:query("SET autocommit=0")
  end
  conn:query("begin")
  conn:query("select k from sbtest1 where id = 1")
  conn:query("export consistent snapshot cluster")
  conn:query("commit")
  conn:disconnect()
  ffi.C.db_connection_free(conn)

  throttle_event(thread_id) --Calculate the time delay to achieve target TPS

end



