-- sysbench --mysql-host=127.0.0.1 --mysql-port=2250 --mysql-user=root 
--          --mysql-password=Passw0rd --db-driver=mysql short_con.lua  
--          --threads=1 --time=5 --mysql-db=test --report-interval=1 
--          --target_tps=5 --ignore-mysql-errors=2003 run

require("timed_event")

if sysbench.cmdline.command == nil then
   error("Command is required. Supported commands: prepare, run, cleanup, help")
end

-- Command line options
sysbench.cmdline.options = {
    skip_trx =
        {"Don't start explicit transactions and execute all queries " ..
         "in the AUTOCOMMIT mode", false},
    packet_size =
        {"Packet length for query", 2000},
    target_tps =
        {"Desired transaction throughput (trx/sec)", -1},
    max_reconnect =
        {"How many times to try to connect before failing the test, default is 10. " ..
                "Reconnect interval is 1 second.", 10 }
}

function thread_init(thread_id)
  drv = sysbench.sql.driver()
  timed_event_init(thread_id)
  sql = "select '" .. sysbench.rand.string(string.rep("@", sysbench.opt.packet_size)) .. "'"
end

function event(thread_id)
  conn = nil
  retry = 0
  while (conn == nil and retry < sysbench.opt.max_reconnect) do  --retry for 5 minutes
    conn=ffi.C.db_connection_create(drv)
    if conn == nil then       -- connection failure
        ffi.C.usleep(1000000) -- sleep 1 second before retry
        retry = retry + 1
    end
  end
  if conn == nil then
      print("Max connect retry time ("..sysbench.opt.max_reconnect..") reached, aborting")
      ffi.C.sb_counter_inc(sysbench.tid, ffi.C.SB_CNT_ERROR)
      ffi.C.sb_counter_dec(sysbench.tid, ffi.C.SB_CNT_TRX)
  else
      if not sysbench.opt.skip_trx then
          conn:query("SET autocommit=0")
      end
      conn:query(sql)
      conn:disconnect()
      ffi.C.db_connection_free(conn)
      throttle_event(thread_id) --Calculate the time delay to achieve target TPS
  end
end



