--
-- Created by IntelliJ IDEA.
-- User: chenrongyao
-- Date: 2017/9/18
-- Time: 下午5:22
-- To change this template use File | Settings | File Templates.
--

-- 兼容新版本的sysbench
-- 原生的sysbench.rand.uniform发现不够均匀，采用lua的库函数


sysbench.cmdline.options = {
    mysql_table_engine = {"Storage engine, if MySQL is used", "innodb"}
}

function thread_done()
    if con then
        con:disconnect()
	end
end

function get_uniform(s, e)
	return math.random(math.floor(s), math.floor(e))
end
sb_rand = sysbench.rand.default
sb_rand_str = sysbench.rand.string
sb_rand_uniform = get_uniform
sb_rand_gaussian = sysbench.rand.gaussian
sb_rand_special = sysbench.rand.special
sb_rand_pareto = sysbench.rand.pareto_new
get_global_seq = sysbench.rand.get_global_seq
set_global_seq_min = sysbench.rand.set_global_seq_min


function create_insert(table_id, drv, con)
    local i
    local pk
    local query

    i = table_id

    print("Creating table ".."tc_biz_order_" .. i .. "...")

    if drv:name() == "pgsql"
    then
        query = [[

        CREATE TABLE "tc_biz_order_]] .. i .. [[" (
    "biz_order_id" bigint NOT NULL,
    "out_order_id" varchar(32) NOT NULL,
    "buyer_nick" varchar(32) NOT NULL,
    "seller_nick" varchar(32) NOT NULL,
    "buyer_id" bigint NOT NULL,
    "seller_id" bigint NOT NULL,
    "auction_id" bigint NOT NULL ,
    "snap_path" varchar(64) NOT NULL ,
    "auction_title" varchar(64) DEFAULT NULL ,
    "auction_price" bigint NOT NULL ,
    "buy_amount" int NOT NULL ,
    "biz_type" int NOT NULL ,
    "pay_status" tinyint NOT NULL ,
    "logistics_status" tinyint NOT NULL ,
    "gmt_create" datetime NOT NULL ,
    "gmt_modified" datetime NOT NULL ,
    "status" tinyint DEFAULT NULL ,
    "sub_biz_type" int DEFAULT NULL ,
    "fail_reason" varchar(256) DEFAULT NULL ,
    "buyer_rate_status" tinyint DEFAULT NULL ,
    "seller_rate_status" tinyint DEFAULT NULL ,
    "seller_memo" varchar(256) DEFAULT NULL ,
    "buyer_memo" varchar(256) DEFAULT NULL ,
    "seller_flag" int DEFAULT NULL ,
    "buyer_flag" int DEFAULT NULL ,
    "buyer_message_path" varchar(64) DEFAULT NULL ,
    "refund_status" tinyint DEFAULT NULL ,
    "attributes" varchar(4000) DEFAULT NULL,
    "attributes_cc" int DEFAULT NULL ,
    "ip" bigint DEFAULT NULL ,
    "end_time" datetime DEFAULT NULL ,
    "pay_time" datetime DEFAULT NULL ,
    "auction_pict_url" varchar(100) DEFAULT NULL ,
    "is_detail" tinyint DEFAULT NULL ,
    "is_main" tinyint DEFAULT NULL ,
    "point_rate" int DEFAULT NULL ,
    "parent_id" bigint DEFAULT NULL ,
    "adjust_fee" bigint DEFAULT NULL ,
    "discount_fee" bigint DEFAULT NULL ,
    "refund_fee" bigint DEFAULT NULL ,
    "confirm_paid_fee" bigint DEFAULT NULL ,
    "cod_status" int DEFAULT NULL ,
    "trade_tag" int DEFAULT NULL ,
    "shop_id" bigint DEFAULT NULL ,
    "sync_version" int DEFAULT NULL ,
    "out_trade_status" tinyint DEFAULT NULL ,
    "options" bigint DEFAULT NULL ,
    "attribute1" bigint DEFAULT NULL ,
    "attribute2" bigint DEFAULT NULL ,
    "attribute3" int DEFAULT NULL ,
    "attribute4" int DEFAULT NULL ,
    "ignore_sold_quantity" tinyint DEFAULT NULL ,
    "attribute11" varchar(1000) DEFAULT NULL ,
    "from_group" smallint DEFAULT '0' ,
    "gmt_create_tc" datetime DEFAULT NULL,
    constraint ID_BIZ_ORDER_PRIMARY primary key("biz_order_id"),
    constraint IND_BIZ_ORDER_GMT unique ("gmt_modified"),
    constraint ind_biz_order_selleridgmt unique ("seller_id","gmt_modified","is_main","biz_type","status","from_group"),
    constraint ind_biz_order_parentid unique ("parent_id","from_group"),
    constraint ind_biz_order_status unique ("seller_id","pay_status","gmt_create","logistics_status","from_group"),
    constraint ind_biz_order_sellerid unique ("seller_id","gmt_create","is_main","pay_status","biz_type","status","logistics_status","sub_biz_type","refund_status","seller_rate_status","buyer_rate_status","end_time","trade_tag","options","auction_title","from_group"),
    constraint idx_biz_paytime unique ("auction_id","biz_type","from_group","is_detail","pay_time"),
    constraint idx_sid_bt_st_im unique("seller_id","gmt_create_tc","is_main","biz_type","status","from_group"),
    constraint ind_biz_order_auctionid unique("auction_id","gmt_create","is_detail","pay_status","biz_type","status","cod_status","buy_amount","ignore_sold_quantity","buyer_rate_status","seller_rate_status","trade_tag","shop_id","from_group"));
    Comment on column tc_biz_order_1.biz_order_id  is '业务订单id';
    Comment on column tc_biz_order_1.out_order_id  is '外部系统订单id';
    Comment on column tc_biz_order_1.buyer_nick  is '买家昵称';
    Comment on column tc_biz_order_1.seller_nick  is '卖家昵称';
    Comment on column tc_biz_order_1.buyer_id  is '买家id';
    Comment on column tc_biz_order_1.seller_id  is '卖家id';
    Comment on column tc_biz_order_1.auction_id  is '商品id';
    Comment on column tc_biz_order_1.snap_path  is '商品快照在文件系统里的相对路径';
    Comment on column tc_biz_order_1.auction_title  is '商品标题';
    Comment on column tc_biz_order_1.auction_price  is '商品价格';
    Comment on column tc_biz_order_1.buy_amount  is '购买数量';
    Comment on column tc_biz_order_1.biz_type  is '业务类型';
    Comment on column tc_biz_order_1.pay_status  is '支付状态';
    Comment on column tc_biz_order_1.logistics_status  is '物流状态';
    Comment on column tc_biz_order_1.gmt_create  is '创建时间';
    Comment on column tc_biz_order_1.gmt_modified  is '修改时间';
    Comment on column tc_biz_order_1.status  is '状态';
    Comment on column tc_biz_order_1.sub_biz_type  is '子业务类型';
    Comment on column tc_biz_order_1.fail_reason  is '失败原因';
    Comment on column tc_biz_order_1.buyer_rate_status  is '买家评价状态';
    Comment on column tc_biz_order_1.seller_rate_status  is '卖家评价状态';
    Comment on column tc_biz_order_1.seller_memo  is '卖家的给交易的备注';
    Comment on column tc_biz_order_1.buyer_memo  is '买家给交易的备注';
    Comment on column tc_biz_order_1.seller_flag  is '卖家给交易的标志';
    Comment on column tc_biz_order_1.buyer_flag  is '买家给交易的备注';
    Comment on column tc_biz_order_1.buyer_message_path  is '买家购买留言的消息文件路径';
    Comment on column tc_biz_order_1.refund_status  is '退款状态';
    Comment on column tc_biz_order_1.attributes_cc  is '属性更新用的校验码';
    Comment on column tc_biz_order_1.ip  is '购买ip';
    Comment on column tc_biz_order_1.end_time  is '交易结束时间';
    Comment on column tc_biz_order_1.pay_time  is '支付时间';
    Comment on column tc_biz_order_1.auction_pict_url  is '商品图片标题';
    Comment on column tc_biz_order_1.is_detail  is '是否是子订单 1表示子订单';
    Comment on column tc_biz_order_1.is_main  is '是否是父订单 1表示父订单';
    Comment on column tc_biz_order_1.point_rate  is '积分返点比率';
    Comment on column tc_biz_order_1.parent_id  is '父订单ID，如果是父订单，为NULL，如果是单件商品的订单，等于biz_order_id';
    Comment on column tc_biz_order_1.adjust_fee  is '卖家修改价格时对单商品的价格调整';
    Comment on column tc_biz_order_1.discount_fee  is '单商品的系统折扣，比如折扣券';
    Comment on column tc_biz_order_1.refund_fee  is '退款金额';
    Comment on column tc_biz_order_1.confirm_paid_fee  is '已经确认收货的金额';
    Comment on column tc_biz_order_1.cod_status  is 'tc_logistics_order表中cod_status字段的冗余';
    Comment on column tc_biz_order_1.trade_tag  is '订单tag标志 1点卡软件待充 2话费软件待充';
    Comment on column tc_biz_order_1.shop_id  is '店铺id';
    Comment on column tc_biz_order_1.sync_version  is '更新版本号，用在tddl';
    Comment on column tc_biz_order_1.out_trade_status  is '外部订单的交易状态(需要索引，外部订单状态的个性化搜索)';
    Comment on column tc_biz_order_1.options  is '用位数代表不同的交易来源';
    Comment on column tc_biz_order_1.attribute1  is '保留字段';
    Comment on column tc_biz_order_1.attribute2  is '保留字段';
    Comment on column tc_biz_order_1.attribute3  is '保留字段';
    Comment on column tc_biz_order_1.attribute4  is '保留字段';
    Comment on column tc_biz_order_1.ignore_sold_quantity  is '1:排除聚划算类似促销导致的销量，0:表示不排除';
    Comment on column tc_biz_order_1.attribute11  is '保留字段';
    Comment on column tc_biz_order_1.from_group  is '区分b2b订单和淘宝订单';

        ]]
    else
        query = [[

        CREATE TABLE `tc_biz_order_]] .. i .. [[` (
  `biz_order_id` bigint(20) NOT NULL COMMENT '业务订单id',
  `out_order_id` varchar(32) NOT NULL COMMENT '外部系统订单id',
  `buyer_nick` varchar(32) NOT NULL COMMENT '买家昵称',
  `seller_nick` varchar(32) NOT NULL COMMENT '卖家昵称',
  `buyer_id` bigint(20) NOT NULL COMMENT '买家id',
  `seller_id` bigint(20) NOT NULL COMMENT '卖家id',
  `auction_id` bigint(20) NOT NULL COMMENT '商品id',
  `snap_path` varchar(64) NOT NULL COMMENT '商品快照在文件系统里的相对路径',
  `auction_title` varchar(64) DEFAULT NULL COMMENT '商品标题',
  `auction_price` bigint(20) NOT NULL COMMENT '商品价格',
  `buy_amount` int(11) NOT NULL COMMENT '购买数量',
  `biz_type` int(11) NOT NULL COMMENT '业务类型',
  `pay_status` tinyint(4) NOT NULL COMMENT '支付状态',
  `logistics_status` tinyint(4) NOT NULL COMMENT '物流状态',
  `gmt_create` datetime NOT NULL COMMENT '创建时间',
  `gmt_modified` datetime NOT NULL COMMENT '修改时间',
  `status` tinyint(4) DEFAULT NULL COMMENT '状态',
  `sub_biz_type` int(11) DEFAULT NULL COMMENT '子业务类型',
  `fail_reason` varchar(256) DEFAULT NULL COMMENT '失败原因',
  `buyer_rate_status` tinyint(4) DEFAULT NULL COMMENT '买家评价状态',
  `seller_rate_status` tinyint(4) DEFAULT NULL COMMENT '卖家评价状态',
  `seller_memo` varchar(256) DEFAULT NULL COMMENT '卖家的给交易的备注',
  `buyer_memo` varchar(256) DEFAULT NULL COMMENT '买家给交易的备注',
  `seller_flag` int(11) DEFAULT NULL COMMENT '卖家给交易的标志',
  `buyer_flag` int(11) DEFAULT NULL COMMENT '买家给交易的备注',
  `buyer_message_path` varchar(64) DEFAULT NULL COMMENT '买家购买留言的消息文件路径',
  `refund_status` tinyint(4) DEFAULT NULL COMMENT '退款状态',
  `attributes` varchar(4000) DEFAULT NULL,
  `attributes_cc` int(11) DEFAULT NULL COMMENT '属性更新用的校验码',
  `ip` bigint(20) DEFAULT NULL COMMENT '购买ip',
  `end_time` datetime DEFAULT NULL COMMENT '交易结束时间',
  `pay_time` datetime DEFAULT NULL COMMENT '支付时间',
  `auction_pict_url` varchar(100) DEFAULT NULL COMMENT '商品图片标题',
  `is_detail` tinyint(4) DEFAULT NULL COMMENT '是否是子订单 1表示子订单',
  `is_main` tinyint(4) DEFAULT NULL COMMENT '是否是父订单 1表示父订单',
  `point_rate` int(11) DEFAULT NULL COMMENT '积分返点比率',
  `parent_id` bigint(20) DEFAULT NULL COMMENT '父订单ID，如果是父订单，为NULL，如果是单件商品的订单，等于biz_order_id',
  `adjust_fee` bigint(20) DEFAULT NULL COMMENT '卖家修改价格时对单商品的价格调整',
  `discount_fee` bigint(20) DEFAULT NULL COMMENT '单商品的系统折扣，比如折扣券',
  `refund_fee` bigint(20) DEFAULT NULL COMMENT '退款金额',
  `confirm_paid_fee` bigint(20) DEFAULT NULL COMMENT '已经确认收货的金额',
  `cod_status` int(11) DEFAULT NULL COMMENT 'tc_logistics_order表中cod_status字段的冗余',
  `trade_tag` int(11) DEFAULT NULL COMMENT '订单tag标志 1点卡软件待充 2话费软件待充',
  `shop_id` bigint(20) DEFAULT NULL COMMENT '店铺id',
  `sync_version` int(11) DEFAULT NULL COMMENT '更新版本号，用在tddl',
  `out_trade_status` tinyint(4) DEFAULT NULL COMMENT '外部订单的交易状态(需要索引，外部订单状态的个性化搜索)',
  `options` bigint(20) DEFAULT NULL COMMENT '用位数代表不同的交易来源',
  `attribute1` bigint(20) DEFAULT NULL COMMENT '保留字段',
  `attribute2` bigint(20) DEFAULT NULL COMMENT '保留字段',
  `attribute3` int(11) DEFAULT NULL COMMENT '保留字段',
  `attribute4` int(11) DEFAULT NULL COMMENT '保留字段',
  `ignore_sold_quantity` tinyint(4) DEFAULT NULL COMMENT '1:排除聚划算类似促销导致的销量，0:表示不排除',
  `attribute11` varchar(1000) DEFAULT NULL COMMENT '保留字段',
  `from_group` smallint(6) DEFAULT '0' COMMENT '区分b2b订单和淘宝订单',
  `gmt_create_tc` datetime DEFAULT NULL,
  PRIMARY KEY (`BIZ_ORDER_ID`) comment 'cf1-tc_biz_order_]].. i ..[[',
  KEY `IND_BIZ_ORDER_GMT` (`GMT_MODIFIED`) comment 'cf2-tc_biz_order_]].. i ..[[',
  KEY `ind_biz_order_selleridgmt` (`SELLER_ID`,`GMT_MODIFIED`,`IS_MAIN`,`BIZ_TYPE`,`STATUS`,`from_group`) comment 'cf3-tc_biz_order_]].. i ..[[',
  KEY `ind_biz_order_parentid` (`PARENT_ID`,`from_group`) comment 'cf4-tc_biz_order_]].. i ..[[',
  KEY `ind_biz_order_status` (`SELLER_ID`,`PAY_STATUS`,`GMT_CREATE`,`LOGISTICS_STATUS`,`from_group`) comment 'cf5-tc_biz_order_]].. i ..[[',
  KEY `ind_biz_order_sellerid` (`SELLER_ID`,`GMT_CREATE`,`IS_MAIN`,`PAY_STATUS`,`BIZ_TYPE`,`STATUS`,`LOGISTICS_STATUS`,`SUB_BIZ_TYPE`,`REFUND_STATUS`,`SELLER_RATE_STATUS`,`BUYER_RATE_STATUS`,`END_TIME`,`TRADE_TAG`,`OPTIONS`,`AUCTION_TITLE`,`from_group`) comment 'cf6-tc_biz_order_]].. i ..[[',
  KEY `idx_biz_paytime` (`AUCTION_ID`,`BIZ_TYPE`,`from_group`,`IS_DETAIL`,`PAY_TIME`) comment 'cf7-tc_biz_order_]].. i ..[[',
  KEY `idx_sid_bt_st_im` (`SELLER_ID`,`gmt_create_tc`,`IS_MAIN`,`BIZ_TYPE`,`STATUS`,`from_group`) comment 'cf8-tc_biz_order_]].. i ..[[',
  KEY `ind_biz_order_auctionid` (`AUCTION_ID`,`GMT_CREATE`,`IS_DETAIL`,`PAY_STATUS`,`BIZ_TYPE`,`STATUS`,`COD_STATUS`,`BUY_AMOUNT`,`IGNORE_SOLD_QUANTITY`,`BUYER_RATE_STATUS`,`SELLER_RATE_STATUS`,`TRADE_TAG`,`SHOP_ID`,`from_group`) comment 'cf9-tc_biz_order_]].. i ..[['
) ENGINE=]].. sysbench.opt.mysql_table_engine .. [[ DEFAULT CHARSET=gbk;

        ]]
    end

    con:query(query)
    con:bulk_insert_init("INSERT INTO tc_biz_order_" .. i .. " (auction_price,from_group,gmt_modified,snap_path,ip,confirm_paid_fee,logistics_status,shop_id,pay_time,trade_tag,auction_pict_url,refund_status,parent_id,cod_status,buyer_memo,buyer_rate_status,out_order_id,gmt_create,biz_type,sub_biz_type,point_rate,seller_memo,sync_version,pay_status,status,buyer_flag,seller_flag,options,buy_amount,refund_fee,biz_order_id,is_detail,seller_id,fail_reason,seller_rate_status,buyer_nick,discount_fee,adjust_fee,seller_nick,attributes_cc,auction_id,end_time,attributes,is_main,auction_title,buyer_id, gmt_create_tc) VALUES")

    -- bulk insert
    for pk = 1, oltp_table_size do
		-- print(pk)
		query = "("..sb_rand(1, 1000)..","..sb_rand(1, 10)..",".."now(),".."'"..sb_rand_str(string.rep('@', 37)).."',"..sb_rand(1, 10000000000)..","..sb_rand(1, 100)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..",".."now(),"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 32)).."',"..sb_rand(1, 10)..","..sb_rand(1, 1000000000000)..","..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 42)).."',"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 14)).."',".."now(),"..sb_rand(1, 1000)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 76)).."',"..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..pk..","..sb_rand(1, 10)..","..sb_rand(1, 100000000)..",".."'"..sb_rand_str(string.rep('@', 12)).."',"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 10)).."',"..sb_rand(1, 10)..","..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 9)).."',"..sb_rand(1, 10)..","..sb_rand(1, 1000000)..",".."now(),".."'"..sb_rand_str(string.rep('@', 2000)).."',"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 51)).."',"..sb_rand(1, 1000000000)..",now()"..")"
        -- print(query)
		con:bulk_insert_next(query)
        -- con:bulk_insert_next("("..sb_rand(1, 1000)..","..sb_rand(1, 10)..",".."now(),".."'"..sb_rand_str(string.rep('@', 37)).."',"..sb_rand(1, 10000000000)..","..sb_rand(1, 100)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..",".."now(),"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 32)).."',"..sb_rand(1, 10)..","..sb_rand(1, 1000000000000)..","..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 42)).."',"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 14)).."',".."now(),"..sb_rand(1, 1000)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 76)).."',"..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..sb_rand(1, 10)..","..pk..","..sb_rand(1, 10)..","..sb_rand(1, 100000000)..",".."'"..sb_rand_str(string.rep('@', 12)).."',"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 10)).."',"..sb_rand(1, 10)..","..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 9)).."',"..sb_rand(1, 10)..","..sb_rand(1, 1000000)..",".."now(),".."'"..sb_rand_str(string.rep('@', 2000)).."',"..sb_rand(1, 10)..",".."'"..sb_rand_str(string.rep('@', 51)).."',"..sb_rand(1, 1000000000)..",now()"..")")
    end
    --commit
    con:bulk_insert_done()
end

    function cleanup()
	   local drv = sysbench.sql.driver()
	   local con = drv:connect()
       local i

       set_vars()

       for i = 1,oltp_tables_count do
       print("Dropping table ".. "tc_biz_order_" .. i .."...")
       con:query("DROP TABLE IF EXISTS tc_biz_order_".. i )

       end
    end

    function prepare()
	   local drv = sysbench.sql.driver()
	   local con = drv:connect()
       local query
       local i
       local j

       set_vars()

       for i = 1,oltp_tables_count do
         create_insert(i, drv, con)
       end

       return 0
    end



    function set_vars()
       oltp_table_size = tonumber(oltp_table_size) or 10000
       oltp_range_size = tonumber(oltp_range_size) or 100
       oltp_tables_count = tonumber(oltp_tables_count) or 1
       oltp_point_selects = tonumber(oltp_point_selects) or 10
       oltp_simple_ranges = tonumber(oltp_simple_ranges) or 1
       oltp_sum_ranges = tonumber(oltp_sum_ranges) or 1
       oltp_order_ranges = tonumber(oltp_order_ranges) or 1
       oltp_distinct_ranges = tonumber(oltp_distinct_ranges) or 1
       oltp_index_updates = tonumber(oltp_index_updates) or 1
       oltp_non_index_updates = tonumber(oltp_non_index_updates) or 1
       oltp_delete_inserts = tonumber(oltp_delete_inserts) or 1
        -- rongyao.cry add global sequence
       global_seq_min = tonumber(global_seq_min) or 1
       global_seq_range = tonumber(global_seq_range) or 100
       global_seq_gap = tonumber(global_seq_gap) or 0

       if (oltp_range_selects == 'off') then
          oltp_range_selects = false
       else
          oltp_range_selects = true
       end

       if (oltp_auto_inc == 'off') then
          oltp_auto_inc = false
       else
          oltp_auto_inc = true
       end

       if (oltp_read_only == 'on') then
          oltp_read_only = true
       else
          oltp_read_only = false
       end

       if (oltp_write_only == 'on') then
          oltp_write_only = true
       else
          oltp_write_only = false
       end

       if (oltp_read_only and oltp_write_only) then
          error("--oltp-read-only and --oltp-write-only are mutually exclusive")
       end

       if (oltp_skip_trx == 'on') then
          oltp_skip_trx = true
       else
          oltp_skip_trx = false
       end

       if (oltp_create_secondary == 'off') then
          oltp_create_secondary = false
       else
          oltp_create_secondary = true
       end

       if (pgsql_variant == 'redshift') then
          oltp_create_secondary = false
          oltp_delete_inserts = 0
       end

    end
