--[[
****************************************************************************
Input parameters:

--simsim-databases = N: the number of databases to create/use (1 by default)
****************************************************************************
--]]

require("timed_event")

if sysbench.cmdline.command == nil then
    error("Command is required. Supported commands: prepare, run, cleanup, help")
end

-- Command line options
sysbench.cmdline.options = {
    report_csv =
       {"Report output in csv (yes, no)", "no"},
    target_tps = 
       {"Desiried transaction throughput (TPS)",-1}
}

function thread_init(thread_id)
    drv = sysbench.sql.driver()
    con = drv:connect()
    timed_event_init()
end


-- The main event loop
function event(thread_id)
    local i 
   --con:query("BEGIN")

   for i = 1, 1 do
        table_no_1 = sysbench.rand.default(0, 100)

        -- sqlstmt = string.format([[CREATE TEMPORARY TABLE if not exists `TEMP_DATASYNC_PRODUCT_%s_%s` (ID bigint not null primary key auto_increment	,DomainID CHAR(36)
        sqlstmt = string.format([[CREATE TABLE if not exists `TEMP_DATASYNC_PRODUCT_%s_%s` (ID bigint not null primary key auto_increment	,DomainID CHAR(36),LastUpdatePersonID NVARCHAR(50)
        ,LastUpdateAccountID NVARCHAR(50)
        ,LastUpdateDateTime DATETIME
        ,CreatePersonID NVARCHAR(50)
        ,CreateAccountID NVARCHAR(50)
        ,CreateDateTime DATETIME
        ,IsDelete BIT
        ,ProductNumber NVARCHAR(50)
        ,ProductName NVARCHAR(50)
        ,ProductBelongKey NVARCHAR(50)
        ,Origin NVARCHAR(50)
        ,ProductCategoryKey NVARCHAR(50)
        ,Spec NVARCHAR(50)
        ,BarCode NVARCHAR(50)
        ,StandardPrice DECIMAL
        ,MaxPrice DECIMAL
        ,MinPrce DECIMAL
        ,SKU NVARCHAR(50)
        ,CostPrice DECIMAL
        ,ProductUnitID CHAR(36)
        ,ProductUnit NVARCHAR(50)
        ,Remark NVARCHAR(200)
        ,IsEnabled BIT
        ,ProductTypeKey NVARCHAR(50)
        ,F01 INT
        ,F02 INT
        ,F03 INT
        ,F04 INT
        ,F05 INT
        ,F11 NVARCHAR(200)
        ,F12 NVARCHAR(200)
        ,F13 NVARCHAR(200)
        ,F14 NVARCHAR(200)
        ,F15 NVARCHAR(200)
        ,F16 NVARCHAR(200)
        ,F17 NVARCHAR(200)
        ,F18 NVARCHAR(200)
        ,F19 NVARCHAR(200)
        ,F21 DATETIME
        ,F22 DATETIME
        ,F23 DATETIME
        ,F24 DATETIME
        ,F25 DATETIME
        ,`Order` INT
        )ENGINE=InnoDB AUTO_INCREMENT=65 DEFAULT CHARSET=utf8]],
        thread_id, table_no_1)
        con:query(sqlstmt)

        --sqlstmt = string.format([[drop temporary table if exists `TEMP_DATASYNC_PRODUCT_%s_%s`]], thread_id, table_no_1)
        sqlstmt = string.format([[drop table if exists `TEMP_DATASYNC_PRODUCT_%s_%s`]], thread_id, table_no_1)con:query(sqlstmt)
        --con:query("COMMIT")
    end
    throttle_event() --Calculate the time delay to achieve target TPS
end


function sysbench.hooks.before_restart_event(err)
  con:query("ROLLBACK")
end

function sysbench.hooks.report_intermediate(stat)
-- --   print("my stat: ", val)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end