-- /root/sysbench/bin/sysbench --ratio=10 --mysql_password=Passw0rd --report_interval=1 --mysql_db=tpch10g --mysql_host=100.81.231.222 --db_driver=mysql --mysql_user=myadmin --threads=10 --mysql_port=5200 --time=0 --events=0  --db-ps-mode=disable tpch_long_query.lua run
require("timed_event")

if sysbench.cmdline.command == nil then
    error("Command is required. Supported commands: run")
end

sysbench.cmdline.options={
    ratio = {"short query vs long query",10},
    report_csv =
       {"Report output in csv (yes, no)", "no"},
    target_tps =
       {"Desiried transaction throughput (TPS)",-1 }

}

function thread_init(thread_id)


    if sysbench.opt.ratio <1 then
        error("ratio should >= 1 ")
        return
    end
   drv = sysbench.sql.driver()
   short_con = drv:connect()
   long_con = drv:connect()


end

function event()

--   print (sysbench.opt.ratio)
--   print ("do short query")
   for i=1,(sysbench.opt.ratio)
   do
       op_type = sysbench.rand.uniform(1,10)
       stmt= short_stmt (op_type)
       short_con:query(stmt)
   end

    local long_num = sysbench.rand.uniform(1,22)
    local long_file  = "queries/tpch/tpch"..long_num..".sql"
    stmt = stmt_from(long_file)
    long_con:query(stmt)


end

function file_exists(file)
   -- print ("check file exsits"..file)
  local f = io.open(file, "rb")
  if f then f:close() end
  return f ~= nil
end

function stmt_from(file)
    if not file_exists(file) then
        print ("file not exists")
        return {}
    end
    local stmt = ""
    local myfile = io.open(file,'r')
    for line in myfile:lines()  do
        if string.sub(line,1,2) =="--" then
            -- print ("annotation")
        else
            stmt = stmt.." "..line
        end
    end
    -- print (stmt)
    return stmt
end

function query_short()

    local op_type = sysbench.rand.uniform(1,10)

	if op_type ==1 then
		stmt = ([[select n_nationkey,n_name
		from %s.nation where n_nationkey = %s]]):format(
            sysbench.opt.mysql_db,sysbench.rand.uniform(0,24))
    elseif op_type == 2 then
        stmt  = ([[select now()]])
    elseif op_type == 3 then
        stmt = ([[select 1]])
    elseif op_type == 4 then
        stmt = ([[select n_nationkey,n_name from %s.nation order by n_nationkey limit 1]]):format(sysbench.opt.mysql_db)
    elseif op_type ==5 then
        stmt =([[select r_regionkey,r_name from %s.region where r_regionkey = %s]]):format(
            sysbench.opt.mysql_db,
            sysbench.rand.uniform(0,4))
    elseif op_type == 6 then
        stmt = ([[select * from %s.region order by r_regionkey]]):format(sysbench.opt.mysql_db)
    elseif op_type == 7 then
        stmt = ([[select min(r_regionkey) from %s.region]]):format(sysbench.opt.mysql_db)
    elseif op_type ==8 then
        stmt = ([[select min(n_nationkey) from %s.nation]]):format(sysbench.opt.mysql_db)
    elseif op_type ==9 then
        stmt = ([[select min(s_suppkey) from %s.supplier]]):format(sysbench.opt.mysql_db)
    else
        stmt=  ([[select s_suppkey,s_nationkey from %s.supplier where s_suppkey = %s]]):format(
            sysbench.opt.mysql_db,sysbench.rand.uniform(0,1000))
    end
    print(stmt)
    short_con:query(stmt)

end

function short_stmt (num)
    if op_type ==1 then
		stmt = ([[select n_nationkey,n_name
		from %s.nation where n_nationkey = %s]]):format(
            sysbench.opt.mysql_db,sysbench.rand.uniform(0,24))
    elseif op_type == 2 then
        stmt  = ([[select now()]])
    elseif op_type == 3 then
        stmt = ([[select 1]])
    elseif op_type == 4 then
        stmt = ([[select n_nationkey,n_name from %s.nation order by n_nationkey limit 1]]):format(sysbench.opt.mysql_db)
    elseif op_type ==5 then
        stmt =([[select r_regionkey,r_name from %s.region where r_regionkey = %s]]):format(
            sysbench.opt.mysql_db,
            sysbench.rand.uniform(0,4))
    elseif op_type == 6 then
        stmt = ([[select * from %s.region order by r_regionkey]]):format(sysbench.opt.mysql_db)
    elseif op_type == 7 then
        stmt = ([[select min(r_regionkey) from %s.region]]):format(sysbench.opt.mysql_db)
    elseif op_type ==8 then
        stmt = ([[select min(n_nationkey) from %s.nation]]):format(sysbench.opt.mysql_db)
    elseif op_type ==9 then
        stmt = ([[select min(s_suppkey) from %s.supplier]]):format(sysbench.opt.mysql_db)
    else
        stmt=  ([[select s_suppkey,s_nationkey from %s.supplier where s_suppkey = %s]]):format(
            sysbench.opt.mysql_db,sysbench.rand.uniform(0,1000))
    end
    return stmt
end

function query_long()
    local qry_num = sysbench.rand.uniform(1,22)
    local filename  = "queries/tpch/tpch"..qry_num..".sql"
    stmt = stmt_from(filename)
    return stmt

end

function sysbench.hooks.report_intermediate(stat)
   if  sysbench.opt.report_csv == "yes" then
       sysbench.report_csv(stat)
   else
       sysbench.report_default(stat)
   end
end



