#!/usr/bin/env sysbench
-- -------------------------------------------------------------------------- --
-- correctness test for pg
-- -------------------------------------------------------------------------- --

cursize=0

transaction_depth = 50

-- for migration

migration_limit = 50

migration_table_amount = 10

migration_table_name_prefix = "transaction_detail_copy"

function thread_init()
    drv = sysbench.sql.driver()
    con = drv:connect()
end

function prepare()

    local drv = sysbench.sql.driver()
    local con = drv:connect()

   -- 1. create table

    print("drop table transaction_detail")
    con:query("drop table if exists transaction_detail")

    print("Create table transaction_detail")
    con:query("create table if not exists transaction_detail ( transaction_detail_id serial primary key , transaction_id integer , cny decimal ,    jpy decimal ,    gbp decimal ,    eur decimal ,    hkd decimal )")

    print("drop table transaction_total")
    con:query("drop table if exists transaction_total")

    print("Create table transaction_total")
    con:query("create table if not exists transaction_total ( transaction_id serial primary key , cny decimal, jpy decimal ,    gbp decimal ,    eur decimal ,    hkd decimal )")

    print("drop table check_sql")
    con:query("drop table if exists check_sql")

    print("Create table check_sql")
    con:query("create table if not exists check_sql (  key bigint NOT NULL ,  delete_sql varchar NOT NULL ,  insert_sql varchar NOT NULL ,CONSTRAINT pk_public_check_sql PRIMARY KEY (key) )")

    print("drop table check_sql")
    con:query("drop table if exists transaction_total_check")

    print("Create table transaction_total_check")
    con:query("create table transaction_total_check as select * from transaction_total")


   -- 2. init check dml
   prepare_sql_check()

   -- 3. init migration table
   init_migration_table()

end

-- 2. init check dml
function prepare_sql_check()

   local drv = sysbench.sql.driver()
   local con = drv:connect()

   print('init check sql .....')


    con:query("insert into check_sql values(-5000,'delete from transaction_total_check where cny = -5000 and jpy = -500000 and gbp = -3500.0 and eur = -555000 and  hkd = -4500.0','')")

    con:query("insert into check_sql values(-4999,'delete from transaction_total_check where cny = -4999 and jpy = -499900 and gbp = -3499.3 and eur = -554889 and  hkd = -4499.1','')")

    con:query("insert into check_sql values(-4998,'delete from transaction_total_check where cny = -4998 and jpy = -499800 and gbp = -3498.6 and eur = -554778 and  hkd = -4498.2','')")

    con:query("insert into check_sql values(-4997,'delete from transaction_total_check where cny = -4997 and jpy = -499700 and gbp = -3497.9 and eur = -554667 and  hkd = -4497.3','')")

    con:query("insert into check_sql values(-4996,'delete from transaction_total_check where cny = -4996 and jpy = -499600 and gbp = -3497.2 and eur = -554556 and  hkd = -4496.4','')")

    con:query("insert into check_sql values(-4995,'delete from transaction_total_check where cny = -4995 and jpy = -499500 and gbp = -3496.5 and eur = -554445 and  hkd = -4495.5','')")

    con:query("insert into check_sql values(-4994,'delete from transaction_total_check where cny = -4994 and jpy = -499400 and gbp = -3495.8 and eur = -554334 and  hkd = -4494.6','')")

    con:query("insert into check_sql values(-4993,'delete from transaction_total_check where cny = -4993 and jpy = -499300 and gbp = -3495.1 and eur = -554223 and  hkd = -4493.7','')")

    con:query("insert into check_sql values(-4992,'delete from transaction_total_check where cny = -4992 and jpy = -499200 and gbp = -3494.4 and eur = -554112 and  hkd = -4492.8','')")

    con:query("insert into check_sql values(-4991,'delete from transaction_total_check where cny = -4991 and jpy = -499100 and gbp = -3493.7 and eur = -554001 and  hkd = -4491.9','')")

    con:query("insert into check_sql values(-4990,'delete from transaction_total_check where cny = -4990 and jpy = -499000 and gbp = -3493.0 and eur = -553890 and  hkd = -4491.0','')")

    con:query("insert into check_sql values(-4989,'delete from transaction_total_check where cny = -4989 and jpy = -498900 and gbp = -3492.3 and eur = -553779 and  hkd = -4490.1','')")

    con:query("insert into check_sql values(-4988,'delete from transaction_total_check where cny = -4988 and jpy = -498800 and gbp = -3491.6 and eur = -553668 and  hkd = -4489.2','')")

    con:query("insert into check_sql values(-4987,'delete from transaction_total_check where cny = -4987 and jpy = -498700 and gbp = -3490.9 and eur = -553557 and  hkd = -4488.3','')")

    con:query("insert into check_sql values(-4986,'delete from transaction_total_check where cny = -4986 and jpy = -498600 and gbp = -3490.2 and eur = -553446 and  hkd = -4487.4','')")

    con:query("insert into check_sql values(-4985,'delete from transaction_total_check where cny = -4985 and jpy = -498500 and gbp = -3489.5 and eur = -553335 and  hkd = -4486.5','')")

    con:query("insert into check_sql values(-4984,'delete from transaction_total_check where cny = -4984 and jpy = -498400 and gbp = -3488.8 and eur = -553224 and  hkd = -4485.6','')")

    con:query("insert into check_sql values(-4983,'delete from transaction_total_check where cny = -4983 and jpy = -498300 and gbp = -3488.1 and eur = -553113 and  hkd = -4484.7','')")

    con:query("insert into check_sql values(-4982,'delete from transaction_total_check where cny = -4982 and jpy = -498200 and gbp = -3487.4 and eur = -553002 and  hkd = -4483.8','')")

    con:query("insert into check_sql values(-4981,'delete from transaction_total_check where cny = -4981 and jpy = -498100 and gbp = -3486.7 and eur = -552891 and  hkd = -4482.9','')")

    con:query("insert into check_sql values(-4980,'delete from transaction_total_check where cny = -4980 and jpy = -498000 and gbp = -3486.0 and eur = -552780 and  hkd = -4482.0','')")

    con:query("insert into check_sql values(-4979,'delete from transaction_total_check where cny = -4979 and jpy = -497900 and gbp = -3485.3 and eur = -552669 and  hkd = -4481.1','')")

    con:query("insert into check_sql values(-4978,'delete from transaction_total_check where cny = -4978 and jpy = -497800 and gbp = -3484.6 and eur = -552558 and  hkd = -4480.2','')")

    con:query("insert into check_sql values(-4977,'delete from transaction_total_check where cny = -4977 and jpy = -497700 and gbp = -3483.9 and eur = -552447 and  hkd = -4479.3','')")

    con:query("insert into check_sql values(-4976,'delete from transaction_total_check where cny = -4976 and jpy = -497600 and gbp = -3483.2 and eur = -552336 and  hkd = -4478.4','')")

    con:query("insert into check_sql values(-4975,'delete from transaction_total_check where cny = -4975 and jpy = -497500 and gbp = -3482.5 and eur = -552225 and  hkd = -4477.5','')")

    con:query("insert into check_sql values(-4974,'delete from transaction_total_check where cny = -4974 and jpy = -497400 and gbp = -3481.8 and eur = -552114 and  hkd = -4476.6','')")

    con:query("insert into check_sql values(-4973,'delete from transaction_total_check where cny = -4973 and jpy = -497300 and gbp = -3481.1 and eur = -552003 and  hkd = -4475.7','')")

    con:query("insert into check_sql values(-4972,'delete from transaction_total_check where cny = -4972 and jpy = -497200 and gbp = -3480.4 and eur = -551892 and  hkd = -4474.8','')")

    con:query("insert into check_sql values(-4971,'delete from transaction_total_check where cny = -4971 and jpy = -497100 and gbp = -3479.7 and eur = -551781 and  hkd = -4473.9','')")

    con:query("insert into check_sql values(-4970,'delete from transaction_total_check where cny = -4970 and jpy = -497000 and gbp = -3479.0 and eur = -551670 and  hkd = -4473.0','')")

    con:query("insert into check_sql values(-4969,'delete from transaction_total_check where cny = -4969 and jpy = -496900 and gbp = -3478.3 and eur = -551559 and  hkd = -4472.1','')")

    con:query("insert into check_sql values(-4968,'delete from transaction_total_check where cny = -4968 and jpy = -496800 and gbp = -3477.6 and eur = -551448 and  hkd = -4471.2','')")

    con:query("insert into check_sql values(-4967,'delete from transaction_total_check where cny = -4967 and jpy = -496700 and gbp = -3476.9 and eur = -551337 and  hkd = -4470.3','')")

    con:query("insert into check_sql values(-4966,'delete from transaction_total_check where cny = -4966 and jpy = -496600 and gbp = -3476.2 and eur = -551226 and  hkd = -4469.4','')")

    con:query("insert into check_sql values(-4965,'delete from transaction_total_check where cny = -4965 and jpy = -496500 and gbp = -3475.5 and eur = -551115 and  hkd = -4468.5','')")

    con:query("insert into check_sql values(-4964,'delete from transaction_total_check where cny = -4964 and jpy = -496400 and gbp = -3474.8 and eur = -551004 and  hkd = -4467.6','')")

    con:query("insert into check_sql values(-4963,'delete from transaction_total_check where cny = -4963 and jpy = -496300 and gbp = -3474.1 and eur = -550893 and  hkd = -4466.7','')")

    con:query("insert into check_sql values(-4962,'delete from transaction_total_check where cny = -4962 and jpy = -496200 and gbp = -3473.4 and eur = -550782 and  hkd = -4465.8','')")

    con:query("insert into check_sql values(-4961,'delete from transaction_total_check where cny = -4961 and jpy = -496100 and gbp = -3472.7 and eur = -550671 and  hkd = -4464.9','')")

    con:query("insert into check_sql values(-4960,'delete from transaction_total_check where cny = -4960 and jpy = -496000 and gbp = -3472.0 and eur = -550560 and  hkd = -4464.0','')")

    con:query("insert into check_sql values(-4959,'delete from transaction_total_check where cny = -4959 and jpy = -495900 and gbp = -3471.3 and eur = -550449 and  hkd = -4463.1','')")

    con:query("insert into check_sql values(-4958,'delete from transaction_total_check where cny = -4958 and jpy = -495800 and gbp = -3470.6 and eur = -550338 and  hkd = -4462.2','')")

    con:query("insert into check_sql values(-4957,'delete from transaction_total_check where cny = -4957 and jpy = -495700 and gbp = -3469.9 and eur = -550227 and  hkd = -4461.3','')")

    con:query("insert into check_sql values(-4956,'delete from transaction_total_check where cny = -4956 and jpy = -495600 and gbp = -3469.2 and eur = -550116 and  hkd = -4460.4','')")

    con:query("insert into check_sql values(-4955,'delete from transaction_total_check where cny = -4955 and jpy = -495500 and gbp = -3468.5 and eur = -550005 and  hkd = -4459.5','')")

    con:query("insert into check_sql values(-4954,'delete from transaction_total_check where cny = -4954 and jpy = -495400 and gbp = -3467.8 and eur = -549894 and  hkd = -4458.6','')")

    con:query("insert into check_sql values(-4953,'delete from transaction_total_check where cny = -4953 and jpy = -495300 and gbp = -3467.1 and eur = -549783 and  hkd = -4457.7','')")

    con:query("insert into check_sql values(-4952,'delete from transaction_total_check where cny = -4952 and jpy = -495200 and gbp = -3466.4 and eur = -549672 and  hkd = -4456.8','')")

    con:query("insert into check_sql values(-4951,'delete from transaction_total_check where cny = -4951 and jpy = -495100 and gbp = -3465.7 and eur = -549561 and  hkd = -4455.9','')")

    con:query("insert into check_sql values(-4950,'delete from transaction_total_check where cny = -4950 and jpy = -495000 and gbp = -3465.0 and eur = -549450 and  hkd = -4455.0','')")

    con:query("insert into check_sql values(-4949,'delete from transaction_total_check where cny = -4949 and jpy = -494900 and gbp = -3464.3 and eur = -549339 and  hkd = -4454.1','')")

    con:query("insert into check_sql values(-4948,'delete from transaction_total_check where cny = -4948 and jpy = -494800 and gbp = -3463.6 and eur = -549228 and  hkd = -4453.2','')")

    con:query("insert into check_sql values(-4947,'delete from transaction_total_check where cny = -4947 and jpy = -494700 and gbp = -3462.9 and eur = -549117 and  hkd = -4452.3','')")

    con:query("insert into check_sql values(-4946,'delete from transaction_total_check where cny = -4946 and jpy = -494600 and gbp = -3462.2 and eur = -549006 and  hkd = -4451.4','')")

    con:query("insert into check_sql values(-4945,'delete from transaction_total_check where cny = -4945 and jpy = -494500 and gbp = -3461.5 and eur = -548895 and  hkd = -4450.5','')")

    con:query("insert into check_sql values(-4944,'delete from transaction_total_check where cny = -4944 and jpy = -494400 and gbp = -3460.8 and eur = -548784 and  hkd = -4449.6','')")

    con:query("insert into check_sql values(-4943,'delete from transaction_total_check where cny = -4943 and jpy = -494300 and gbp = -3460.1 and eur = -548673 and  hkd = -4448.7','')")

    con:query("insert into check_sql values(-4942,'delete from transaction_total_check where cny = -4942 and jpy = -494200 and gbp = -3459.4 and eur = -548562 and  hkd = -4447.8','')")

    con:query("insert into check_sql values(-4941,'delete from transaction_total_check where cny = -4941 and jpy = -494100 and gbp = -3458.7 and eur = -548451 and  hkd = -4446.9','')")

    con:query("insert into check_sql values(-4940,'delete from transaction_total_check where cny = -4940 and jpy = -494000 and gbp = -3458.0 and eur = -548340 and  hkd = -4446.0','')")

    con:query("insert into check_sql values(-4939,'delete from transaction_total_check where cny = -4939 and jpy = -493900 and gbp = -3457.3 and eur = -548229 and  hkd = -4445.1','')")

    con:query("insert into check_sql values(-4938,'delete from transaction_total_check where cny = -4938 and jpy = -493800 and gbp = -3456.6 and eur = -548118 and  hkd = -4444.2','')")

    con:query("insert into check_sql values(-4937,'delete from transaction_total_check where cny = -4937 and jpy = -493700 and gbp = -3455.9 and eur = -548007 and  hkd = -4443.3','')")

    con:query("insert into check_sql values(-4936,'delete from transaction_total_check where cny = -4936 and jpy = -493600 and gbp = -3455.2 and eur = -547896 and  hkd = -4442.4','')")

    con:query("insert into check_sql values(-4935,'delete from transaction_total_check where cny = -4935 and jpy = -493500 and gbp = -3454.5 and eur = -547785 and  hkd = -4441.5','')")

    con:query("insert into check_sql values(-4934,'delete from transaction_total_check where cny = -4934 and jpy = -493400 and gbp = -3453.8 and eur = -547674 and  hkd = -4440.6','')")

    con:query("insert into check_sql values(-4933,'delete from transaction_total_check where cny = -4933 and jpy = -493300 and gbp = -3453.1 and eur = -547563 and  hkd = -4439.7','')")

    con:query("insert into check_sql values(-4932,'delete from transaction_total_check where cny = -4932 and jpy = -493200 and gbp = -3452.4 and eur = -547452 and  hkd = -4438.8','')")

    con:query("insert into check_sql values(-4931,'delete from transaction_total_check where cny = -4931 and jpy = -493100 and gbp = -3451.7 and eur = -547341 and  hkd = -4437.9','')")

    con:query("insert into check_sql values(-4930,'delete from transaction_total_check where cny = -4930 and jpy = -493000 and gbp = -3451.0 and eur = -547230 and  hkd = -4437.0','')")

    con:query("insert into check_sql values(-4929,'delete from transaction_total_check where cny = -4929 and jpy = -492900 and gbp = -3450.3 and eur = -547119 and  hkd = -4436.1','')")

    con:query("insert into check_sql values(-4928,'delete from transaction_total_check where cny = -4928 and jpy = -492800 and gbp = -3449.6 and eur = -547008 and  hkd = -4435.2','')")

    con:query("insert into check_sql values(-4927,'delete from transaction_total_check where cny = -4927 and jpy = -492700 and gbp = -3448.9 and eur = -546897 and  hkd = -4434.3','')")

    con:query("insert into check_sql values(-4926,'delete from transaction_total_check where cny = -4926 and jpy = -492600 and gbp = -3448.2 and eur = -546786 and  hkd = -4433.4','')")

    con:query("insert into check_sql values(-4925,'delete from transaction_total_check where cny = -4925 and jpy = -492500 and gbp = -3447.5 and eur = -546675 and  hkd = -4432.5','')")

    con:query("insert into check_sql values(-4924,'delete from transaction_total_check where cny = -4924 and jpy = -492400 and gbp = -3446.8 and eur = -546564 and  hkd = -4431.6','')")

    con:query("insert into check_sql values(-4923,'delete from transaction_total_check where cny = -4923 and jpy = -492300 and gbp = -3446.1 and eur = -546453 and  hkd = -4430.7','')")

    con:query("insert into check_sql values(-4922,'delete from transaction_total_check where cny = -4922 and jpy = -492200 and gbp = -3445.4 and eur = -546342 and  hkd = -4429.8','')")

    con:query("insert into check_sql values(-4921,'delete from transaction_total_check where cny = -4921 and jpy = -492100 and gbp = -3444.7 and eur = -546231 and  hkd = -4428.9','')")

    con:query("insert into check_sql values(-4920,'delete from transaction_total_check where cny = -4920 and jpy = -492000 and gbp = -3444.0 and eur = -546120 and  hkd = -4428.0','')")

    con:query("insert into check_sql values(-4919,'delete from transaction_total_check where cny = -4919 and jpy = -491900 and gbp = -3443.3 and eur = -546009 and  hkd = -4427.1','')")

    con:query("insert into check_sql values(-4918,'delete from transaction_total_check where cny = -4918 and jpy = -491800 and gbp = -3442.6 and eur = -545898 and  hkd = -4426.2','')")

    con:query("insert into check_sql values(-4917,'delete from transaction_total_check where cny = -4917 and jpy = -491700 and gbp = -3441.9 and eur = -545787 and  hkd = -4425.3','')")

    con:query("insert into check_sql values(-4916,'delete from transaction_total_check where cny = -4916 and jpy = -491600 and gbp = -3441.2 and eur = -545676 and  hkd = -4424.4','')")

    con:query("insert into check_sql values(-4915,'delete from transaction_total_check where cny = -4915 and jpy = -491500 and gbp = -3440.5 and eur = -545565 and  hkd = -4423.5','')")

    con:query("insert into check_sql values(-4914,'delete from transaction_total_check where cny = -4914 and jpy = -491400 and gbp = -3439.8 and eur = -545454 and  hkd = -4422.6','')")

    con:query("insert into check_sql values(-4913,'delete from transaction_total_check where cny = -4913 and jpy = -491300 and gbp = -3439.1 and eur = -545343 and  hkd = -4421.7','')")

    con:query("insert into check_sql values(-4912,'delete from transaction_total_check where cny = -4912 and jpy = -491200 and gbp = -3438.4 and eur = -545232 and  hkd = -4420.8','')")

    con:query("insert into check_sql values(-4911,'delete from transaction_total_check where cny = -4911 and jpy = -491100 and gbp = -3437.7 and eur = -545121 and  hkd = -4419.9','')")

    con:query("insert into check_sql values(-4910,'delete from transaction_total_check where cny = -4910 and jpy = -491000 and gbp = -3437.0 and eur = -545010 and  hkd = -4419.0','')")

    con:query("insert into check_sql values(-4909,'delete from transaction_total_check where cny = -4909 and jpy = -490900 and gbp = -3436.3 and eur = -544899 and  hkd = -4418.1','')")

    con:query("insert into check_sql values(-4908,'delete from transaction_total_check where cny = -4908 and jpy = -490800 and gbp = -3435.6 and eur = -544788 and  hkd = -4417.2','')")

    con:query("insert into check_sql values(-4907,'delete from transaction_total_check where cny = -4907 and jpy = -490700 and gbp = -3434.9 and eur = -544677 and  hkd = -4416.3','')")

    con:query("insert into check_sql values(-4906,'delete from transaction_total_check where cny = -4906 and jpy = -490600 and gbp = -3434.2 and eur = -544566 and  hkd = -4415.4','')")

    con:query("insert into check_sql values(-4905,'delete from transaction_total_check where cny = -4905 and jpy = -490500 and gbp = -3433.5 and eur = -544455 and  hkd = -4414.5','')")

    con:query("insert into check_sql values(-4904,'delete from transaction_total_check where cny = -4904 and jpy = -490400 and gbp = -3432.8 and eur = -544344 and  hkd = -4413.6','')")

    con:query("insert into check_sql values(-4903,'delete from transaction_total_check where cny = -4903 and jpy = -490300 and gbp = -3432.1 and eur = -544233 and  hkd = -4412.7','')")

    con:query("insert into check_sql values(-4902,'delete from transaction_total_check where cny = -4902 and jpy = -490200 and gbp = -3431.4 and eur = -544122 and  hkd = -4411.8','')")

    con:query("insert into check_sql values(-4901,'delete from transaction_total_check where cny = -4901 and jpy = -490100 and gbp = -3430.7 and eur = -544011 and  hkd = -4410.9','')")

    con:query("insert into check_sql values(-4900,'delete from transaction_total_check where cny = -4900 and jpy = -490000 and gbp = -3430.0 and eur = -543900 and  hkd = -4410.0','')")

    con:query("insert into check_sql values(-4899,'delete from transaction_total_check where cny = -4899 and jpy = -489900 and gbp = -3429.3 and eur = -543789 and  hkd = -4409.1','')")

    con:query("insert into check_sql values(-4898,'delete from transaction_total_check where cny = -4898 and jpy = -489800 and gbp = -3428.6 and eur = -543678 and  hkd = -4408.2','')")

    con:query("insert into check_sql values(-4897,'delete from transaction_total_check where cny = -4897 and jpy = -489700 and gbp = -3427.9 and eur = -543567 and  hkd = -4407.3','')")

    con:query("insert into check_sql values(-4896,'delete from transaction_total_check where cny = -4896 and jpy = -489600 and gbp = -3427.2 and eur = -543456 and  hkd = -4406.4','')")

    con:query("insert into check_sql values(-4895,'delete from transaction_total_check where cny = -4895 and jpy = -489500 and gbp = -3426.5 and eur = -543345 and  hkd = -4405.5','')")

    con:query("insert into check_sql values(-4894,'delete from transaction_total_check where cny = -4894 and jpy = -489400 and gbp = -3425.8 and eur = -543234 and  hkd = -4404.6','')")

    con:query("insert into check_sql values(-4893,'delete from transaction_total_check where cny = -4893 and jpy = -489300 and gbp = -3425.1 and eur = -543123 and  hkd = -4403.7','')")

    con:query("insert into check_sql values(-4892,'delete from transaction_total_check where cny = -4892 and jpy = -489200 and gbp = -3424.4 and eur = -543012 and  hkd = -4402.8','')")

    con:query("insert into check_sql values(-4891,'delete from transaction_total_check where cny = -4891 and jpy = -489100 and gbp = -3423.7 and eur = -542901 and  hkd = -4401.9','')")

    con:query("insert into check_sql values(-4890,'delete from transaction_total_check where cny = -4890 and jpy = -489000 and gbp = -3423.0 and eur = -542790 and  hkd = -4401.0','')")

    con:query("insert into check_sql values(-4889,'delete from transaction_total_check where cny = -4889 and jpy = -488900 and gbp = -3422.3 and eur = -542679 and  hkd = -4400.1','')")

    con:query("insert into check_sql values(-4888,'delete from transaction_total_check where cny = -4888 and jpy = -488800 and gbp = -3421.6 and eur = -542568 and  hkd = -4399.2','')")

    con:query("insert into check_sql values(-4887,'delete from transaction_total_check where cny = -4887 and jpy = -488700 and gbp = -3420.9 and eur = -542457 and  hkd = -4398.3','')")

    con:query("insert into check_sql values(-4886,'delete from transaction_total_check where cny = -4886 and jpy = -488600 and gbp = -3420.2 and eur = -542346 and  hkd = -4397.4','')")

    con:query("insert into check_sql values(-4885,'delete from transaction_total_check where cny = -4885 and jpy = -488500 and gbp = -3419.5 and eur = -542235 and  hkd = -4396.5','')")

    con:query("insert into check_sql values(-4884,'delete from transaction_total_check where cny = -4884 and jpy = -488400 and gbp = -3418.8 and eur = -542124 and  hkd = -4395.6','')")

    con:query("insert into check_sql values(-4883,'delete from transaction_total_check where cny = -4883 and jpy = -488300 and gbp = -3418.1 and eur = -542013 and  hkd = -4394.7','')")

    con:query("insert into check_sql values(-4882,'delete from transaction_total_check where cny = -4882 and jpy = -488200 and gbp = -3417.4 and eur = -541902 and  hkd = -4393.8','')")

    con:query("insert into check_sql values(-4881,'delete from transaction_total_check where cny = -4881 and jpy = -488100 and gbp = -3416.7 and eur = -541791 and  hkd = -4392.9','')")

    con:query("insert into check_sql values(-4880,'delete from transaction_total_check where cny = -4880 and jpy = -488000 and gbp = -3416.0 and eur = -541680 and  hkd = -4392.0','')")

    con:query("insert into check_sql values(-4879,'delete from transaction_total_check where cny = -4879 and jpy = -487900 and gbp = -3415.3 and eur = -541569 and  hkd = -4391.1','')")

    con:query("insert into check_sql values(-4878,'delete from transaction_total_check where cny = -4878 and jpy = -487800 and gbp = -3414.6 and eur = -541458 and  hkd = -4390.2','')")

    con:query("insert into check_sql values(-4877,'delete from transaction_total_check where cny = -4877 and jpy = -487700 and gbp = -3413.9 and eur = -541347 and  hkd = -4389.3','')")

    con:query("insert into check_sql values(-4876,'delete from transaction_total_check where cny = -4876 and jpy = -487600 and gbp = -3413.2 and eur = -541236 and  hkd = -4388.4','')")

    con:query("insert into check_sql values(-4875,'delete from transaction_total_check where cny = -4875 and jpy = -487500 and gbp = -3412.5 and eur = -541125 and  hkd = -4387.5','')")

    con:query("insert into check_sql values(-4874,'delete from transaction_total_check where cny = -4874 and jpy = -487400 and gbp = -3411.8 and eur = -541014 and  hkd = -4386.6','')")

    con:query("insert into check_sql values(-4873,'delete from transaction_total_check where cny = -4873 and jpy = -487300 and gbp = -3411.1 and eur = -540903 and  hkd = -4385.7','')")

    con:query("insert into check_sql values(-4872,'delete from transaction_total_check where cny = -4872 and jpy = -487200 and gbp = -3410.4 and eur = -540792 and  hkd = -4384.8','')")

    con:query("insert into check_sql values(-4871,'delete from transaction_total_check where cny = -4871 and jpy = -487100 and gbp = -3409.7 and eur = -540681 and  hkd = -4383.9','')")

    con:query("insert into check_sql values(-4870,'delete from transaction_total_check where cny = -4870 and jpy = -487000 and gbp = -3409.0 and eur = -540570 and  hkd = -4383.0','')")

    con:query("insert into check_sql values(-4869,'delete from transaction_total_check where cny = -4869 and jpy = -486900 and gbp = -3408.3 and eur = -540459 and  hkd = -4382.1','')")

    con:query("insert into check_sql values(-4868,'delete from transaction_total_check where cny = -4868 and jpy = -486800 and gbp = -3407.6 and eur = -540348 and  hkd = -4381.2','')")

    con:query("insert into check_sql values(-4867,'delete from transaction_total_check where cny = -4867 and jpy = -486700 and gbp = -3406.9 and eur = -540237 and  hkd = -4380.3','')")

    con:query("insert into check_sql values(-4866,'delete from transaction_total_check where cny = -4866 and jpy = -486600 and gbp = -3406.2 and eur = -540126 and  hkd = -4379.4','')")

    con:query("insert into check_sql values(-4865,'delete from transaction_total_check where cny = -4865 and jpy = -486500 and gbp = -3405.5 and eur = -540015 and  hkd = -4378.5','')")

    con:query("insert into check_sql values(-4864,'delete from transaction_total_check where cny = -4864 and jpy = -486400 and gbp = -3404.8 and eur = -539904 and  hkd = -4377.6','')")

    con:query("insert into check_sql values(-4863,'delete from transaction_total_check where cny = -4863 and jpy = -486300 and gbp = -3404.1 and eur = -539793 and  hkd = -4376.7','')")

    con:query("insert into check_sql values(-4862,'delete from transaction_total_check where cny = -4862 and jpy = -486200 and gbp = -3403.4 and eur = -539682 and  hkd = -4375.8','')")

    con:query("insert into check_sql values(-4861,'delete from transaction_total_check where cny = -4861 and jpy = -486100 and gbp = -3402.7 and eur = -539571 and  hkd = -4374.9','')")

    con:query("insert into check_sql values(-4860,'delete from transaction_total_check where cny = -4860 and jpy = -486000 and gbp = -3402.0 and eur = -539460 and  hkd = -4374.0','')")

    con:query("insert into check_sql values(-4859,'delete from transaction_total_check where cny = -4859 and jpy = -485900 and gbp = -3401.3 and eur = -539349 and  hkd = -4373.1','')")

    con:query("insert into check_sql values(-4858,'delete from transaction_total_check where cny = -4858 and jpy = -485800 and gbp = -3400.6 and eur = -539238 and  hkd = -4372.2','')")

    con:query("insert into check_sql values(-4857,'delete from transaction_total_check where cny = -4857 and jpy = -485700 and gbp = -3399.9 and eur = -539127 and  hkd = -4371.3','')")

    con:query("insert into check_sql values(-4856,'delete from transaction_total_check where cny = -4856 and jpy = -485600 and gbp = -3399.2 and eur = -539016 and  hkd = -4370.4','')")

    con:query("insert into check_sql values(-4855,'delete from transaction_total_check where cny = -4855 and jpy = -485500 and gbp = -3398.5 and eur = -538905 and  hkd = -4369.5','')")

    con:query("insert into check_sql values(-4854,'delete from transaction_total_check where cny = -4854 and jpy = -485400 and gbp = -3397.8 and eur = -538794 and  hkd = -4368.6','')")

    con:query("insert into check_sql values(-4853,'delete from transaction_total_check where cny = -4853 and jpy = -485300 and gbp = -3397.1 and eur = -538683 and  hkd = -4367.7','')")

    con:query("insert into check_sql values(-4852,'delete from transaction_total_check where cny = -4852 and jpy = -485200 and gbp = -3396.4 and eur = -538572 and  hkd = -4366.8','')")

    con:query("insert into check_sql values(-4851,'delete from transaction_total_check where cny = -4851 and jpy = -485100 and gbp = -3395.7 and eur = -538461 and  hkd = -4365.9','')")

    con:query("insert into check_sql values(-4850,'delete from transaction_total_check where cny = -4850 and jpy = -485000 and gbp = -3395.0 and eur = -538350 and  hkd = -4365.0','')")

    con:query("insert into check_sql values(-4849,'delete from transaction_total_check where cny = -4849 and jpy = -484900 and gbp = -3394.3 and eur = -538239 and  hkd = -4364.1','')")

    con:query("insert into check_sql values(-4848,'delete from transaction_total_check where cny = -4848 and jpy = -484800 and gbp = -3393.6 and eur = -538128 and  hkd = -4363.2','')")

    con:query("insert into check_sql values(-4847,'delete from transaction_total_check where cny = -4847 and jpy = -484700 and gbp = -3392.9 and eur = -538017 and  hkd = -4362.3','')")

    con:query("insert into check_sql values(-4846,'delete from transaction_total_check where cny = -4846 and jpy = -484600 and gbp = -3392.2 and eur = -537906 and  hkd = -4361.4','')")

    con:query("insert into check_sql values(-4845,'delete from transaction_total_check where cny = -4845 and jpy = -484500 and gbp = -3391.5 and eur = -537795 and  hkd = -4360.5','')")

    con:query("insert into check_sql values(-4844,'delete from transaction_total_check where cny = -4844 and jpy = -484400 and gbp = -3390.8 and eur = -537684 and  hkd = -4359.6','')")

    con:query("insert into check_sql values(-4843,'delete from transaction_total_check where cny = -4843 and jpy = -484300 and gbp = -3390.1 and eur = -537573 and  hkd = -4358.7','')")

    con:query("insert into check_sql values(-4842,'delete from transaction_total_check where cny = -4842 and jpy = -484200 and gbp = -3389.4 and eur = -537462 and  hkd = -4357.8','')")

    con:query("insert into check_sql values(-4841,'delete from transaction_total_check where cny = -4841 and jpy = -484100 and gbp = -3388.7 and eur = -537351 and  hkd = -4356.9','')")

    con:query("insert into check_sql values(-4840,'delete from transaction_total_check where cny = -4840 and jpy = -484000 and gbp = -3388.0 and eur = -537240 and  hkd = -4356.0','')")

    con:query("insert into check_sql values(-4839,'delete from transaction_total_check where cny = -4839 and jpy = -483900 and gbp = -3387.3 and eur = -537129 and  hkd = -4355.1','')")

    con:query("insert into check_sql values(-4838,'delete from transaction_total_check where cny = -4838 and jpy = -483800 and gbp = -3386.6 and eur = -537018 and  hkd = -4354.2','')")

    con:query("insert into check_sql values(-4837,'delete from transaction_total_check where cny = -4837 and jpy = -483700 and gbp = -3385.9 and eur = -536907 and  hkd = -4353.3','')")

    con:query("insert into check_sql values(-4836,'delete from transaction_total_check where cny = -4836 and jpy = -483600 and gbp = -3385.2 and eur = -536796 and  hkd = -4352.4','')")

    con:query("insert into check_sql values(-4835,'delete from transaction_total_check where cny = -4835 and jpy = -483500 and gbp = -3384.5 and eur = -536685 and  hkd = -4351.5','')")

    con:query("insert into check_sql values(-4834,'delete from transaction_total_check where cny = -4834 and jpy = -483400 and gbp = -3383.8 and eur = -536574 and  hkd = -4350.6','')")

    con:query("insert into check_sql values(-4833,'delete from transaction_total_check where cny = -4833 and jpy = -483300 and gbp = -3383.1 and eur = -536463 and  hkd = -4349.7','')")

    con:query("insert into check_sql values(-4832,'delete from transaction_total_check where cny = -4832 and jpy = -483200 and gbp = -3382.4 and eur = -536352 and  hkd = -4348.8','')")

    con:query("insert into check_sql values(-4831,'delete from transaction_total_check where cny = -4831 and jpy = -483100 and gbp = -3381.7 and eur = -536241 and  hkd = -4347.9','')")

    con:query("insert into check_sql values(-4830,'delete from transaction_total_check where cny = -4830 and jpy = -483000 and gbp = -3381.0 and eur = -536130 and  hkd = -4347.0','')")

    con:query("insert into check_sql values(-4829,'delete from transaction_total_check where cny = -4829 and jpy = -482900 and gbp = -3380.3 and eur = -536019 and  hkd = -4346.1','')")

    con:query("insert into check_sql values(-4828,'delete from transaction_total_check where cny = -4828 and jpy = -482800 and gbp = -3379.6 and eur = -535908 and  hkd = -4345.2','')")

    con:query("insert into check_sql values(-4827,'delete from transaction_total_check where cny = -4827 and jpy = -482700 and gbp = -3378.9 and eur = -535797 and  hkd = -4344.3','')")

    con:query("insert into check_sql values(-4826,'delete from transaction_total_check where cny = -4826 and jpy = -482600 and gbp = -3378.2 and eur = -535686 and  hkd = -4343.4','')")

    con:query("insert into check_sql values(-4825,'delete from transaction_total_check where cny = -4825 and jpy = -482500 and gbp = -3377.5 and eur = -535575 and  hkd = -4342.5','')")

    con:query("insert into check_sql values(-4824,'delete from transaction_total_check where cny = -4824 and jpy = -482400 and gbp = -3376.8 and eur = -535464 and  hkd = -4341.6','')")

    con:query("insert into check_sql values(-4823,'delete from transaction_total_check where cny = -4823 and jpy = -482300 and gbp = -3376.1 and eur = -535353 and  hkd = -4340.7','')")

    con:query("insert into check_sql values(-4822,'delete from transaction_total_check where cny = -4822 and jpy = -482200 and gbp = -3375.4 and eur = -535242 and  hkd = -4339.8','')")

    con:query("insert into check_sql values(-4821,'delete from transaction_total_check where cny = -4821 and jpy = -482100 and gbp = -3374.7 and eur = -535131 and  hkd = -4338.9','')")

    con:query("insert into check_sql values(-4820,'delete from transaction_total_check where cny = -4820 and jpy = -482000 and gbp = -3374.0 and eur = -535020 and  hkd = -4338.0','')")

    con:query("insert into check_sql values(-4819,'delete from transaction_total_check where cny = -4819 and jpy = -481900 and gbp = -3373.3 and eur = -534909 and  hkd = -4337.1','')")

    con:query("insert into check_sql values(-4818,'delete from transaction_total_check where cny = -4818 and jpy = -481800 and gbp = -3372.6 and eur = -534798 and  hkd = -4336.2','')")

    con:query("insert into check_sql values(-4817,'delete from transaction_total_check where cny = -4817 and jpy = -481700 and gbp = -3371.9 and eur = -534687 and  hkd = -4335.3','')")

    con:query("insert into check_sql values(-4816,'delete from transaction_total_check where cny = -4816 and jpy = -481600 and gbp = -3371.2 and eur = -534576 and  hkd = -4334.4','')")

    con:query("insert into check_sql values(-4815,'delete from transaction_total_check where cny = -4815 and jpy = -481500 and gbp = -3370.5 and eur = -534465 and  hkd = -4333.5','')")

    con:query("insert into check_sql values(-4814,'delete from transaction_total_check where cny = -4814 and jpy = -481400 and gbp = -3369.8 and eur = -534354 and  hkd = -4332.6','')")

    con:query("insert into check_sql values(-4813,'delete from transaction_total_check where cny = -4813 and jpy = -481300 and gbp = -3369.1 and eur = -534243 and  hkd = -4331.7','')")

    con:query("insert into check_sql values(-4812,'delete from transaction_total_check where cny = -4812 and jpy = -481200 and gbp = -3368.4 and eur = -534132 and  hkd = -4330.8','')")

    con:query("insert into check_sql values(-4811,'delete from transaction_total_check where cny = -4811 and jpy = -481100 and gbp = -3367.7 and eur = -534021 and  hkd = -4329.9','')")

    con:query("insert into check_sql values(-4810,'delete from transaction_total_check where cny = -4810 and jpy = -481000 and gbp = -3367.0 and eur = -533910 and  hkd = -4329.0','')")

    con:query("insert into check_sql values(-4809,'delete from transaction_total_check where cny = -4809 and jpy = -480900 and gbp = -3366.3 and eur = -533799 and  hkd = -4328.1','')")

    con:query("insert into check_sql values(-4808,'delete from transaction_total_check where cny = -4808 and jpy = -480800 and gbp = -3365.6 and eur = -533688 and  hkd = -4327.2','')")

    con:query("insert into check_sql values(-4807,'delete from transaction_total_check where cny = -4807 and jpy = -480700 and gbp = -3364.9 and eur = -533577 and  hkd = -4326.3','')")

    con:query("insert into check_sql values(-4806,'delete from transaction_total_check where cny = -4806 and jpy = -480600 and gbp = -3364.2 and eur = -533466 and  hkd = -4325.4','')")

    con:query("insert into check_sql values(-4805,'delete from transaction_total_check where cny = -4805 and jpy = -480500 and gbp = -3363.5 and eur = -533355 and  hkd = -4324.5','')")

    con:query("insert into check_sql values(-4804,'delete from transaction_total_check where cny = -4804 and jpy = -480400 and gbp = -3362.8 and eur = -533244 and  hkd = -4323.6','')")

    con:query("insert into check_sql values(-4803,'delete from transaction_total_check where cny = -4803 and jpy = -480300 and gbp = -3362.1 and eur = -533133 and  hkd = -4322.7','')")

    con:query("insert into check_sql values(-4802,'delete from transaction_total_check where cny = -4802 and jpy = -480200 and gbp = -3361.4 and eur = -533022 and  hkd = -4321.8','')")

    con:query("insert into check_sql values(-4801,'delete from transaction_total_check where cny = -4801 and jpy = -480100 and gbp = -3360.7 and eur = -532911 and  hkd = -4320.9','')")

    con:query("insert into check_sql values(-4800,'delete from transaction_total_check where cny = -4800 and jpy = -480000 and gbp = -3360.0 and eur = -532800 and  hkd = -4320.0','')")

    con:query("insert into check_sql values(-4799,'delete from transaction_total_check where cny = -4799 and jpy = -479900 and gbp = -3359.3 and eur = -532689 and  hkd = -4319.1','')")

    con:query("insert into check_sql values(-4798,'delete from transaction_total_check where cny = -4798 and jpy = -479800 and gbp = -3358.6 and eur = -532578 and  hkd = -4318.2','')")

    con:query("insert into check_sql values(-4797,'delete from transaction_total_check where cny = -4797 and jpy = -479700 and gbp = -3357.9 and eur = -532467 and  hkd = -4317.3','')")

    con:query("insert into check_sql values(-4796,'delete from transaction_total_check where cny = -4796 and jpy = -479600 and gbp = -3357.2 and eur = -532356 and  hkd = -4316.4','')")

    con:query("insert into check_sql values(-4795,'delete from transaction_total_check where cny = -4795 and jpy = -479500 and gbp = -3356.5 and eur = -532245 and  hkd = -4315.5','')")

    con:query("insert into check_sql values(-4794,'delete from transaction_total_check where cny = -4794 and jpy = -479400 and gbp = -3355.8 and eur = -532134 and  hkd = -4314.6','')")

    con:query("insert into check_sql values(-4793,'delete from transaction_total_check where cny = -4793 and jpy = -479300 and gbp = -3355.1 and eur = -532023 and  hkd = -4313.7','')")

    con:query("insert into check_sql values(-4792,'delete from transaction_total_check where cny = -4792 and jpy = -479200 and gbp = -3354.4 and eur = -531912 and  hkd = -4312.8','')")

    con:query("insert into check_sql values(-4791,'delete from transaction_total_check where cny = -4791 and jpy = -479100 and gbp = -3353.7 and eur = -531801 and  hkd = -4311.9','')")

    con:query("insert into check_sql values(-4790,'delete from transaction_total_check where cny = -4790 and jpy = -479000 and gbp = -3353.0 and eur = -531690 and  hkd = -4311.0','')")

    con:query("insert into check_sql values(-4789,'delete from transaction_total_check where cny = -4789 and jpy = -478900 and gbp = -3352.3 and eur = -531579 and  hkd = -4310.1','')")

    con:query("insert into check_sql values(-4788,'delete from transaction_total_check where cny = -4788 and jpy = -478800 and gbp = -3351.6 and eur = -531468 and  hkd = -4309.2','')")

    con:query("insert into check_sql values(-4787,'delete from transaction_total_check where cny = -4787 and jpy = -478700 and gbp = -3350.9 and eur = -531357 and  hkd = -4308.3','')")

    con:query("insert into check_sql values(-4786,'delete from transaction_total_check where cny = -4786 and jpy = -478600 and gbp = -3350.2 and eur = -531246 and  hkd = -4307.4','')")

    con:query("insert into check_sql values(-4785,'delete from transaction_total_check where cny = -4785 and jpy = -478500 and gbp = -3349.5 and eur = -531135 and  hkd = -4306.5','')")

    con:query("insert into check_sql values(-4784,'delete from transaction_total_check where cny = -4784 and jpy = -478400 and gbp = -3348.8 and eur = -531024 and  hkd = -4305.6','')")

    con:query("insert into check_sql values(-4783,'delete from transaction_total_check where cny = -4783 and jpy = -478300 and gbp = -3348.1 and eur = -530913 and  hkd = -4304.7','')")

    con:query("insert into check_sql values(-4782,'delete from transaction_total_check where cny = -4782 and jpy = -478200 and gbp = -3347.4 and eur = -530802 and  hkd = -4303.8','')")

    con:query("insert into check_sql values(-4781,'delete from transaction_total_check where cny = -4781 and jpy = -478100 and gbp = -3346.7 and eur = -530691 and  hkd = -4302.9','')")

    con:query("insert into check_sql values(-4780,'delete from transaction_total_check where cny = -4780 and jpy = -478000 and gbp = -3346.0 and eur = -530580 and  hkd = -4302.0','')")

    con:query("insert into check_sql values(-4779,'delete from transaction_total_check where cny = -4779 and jpy = -477900 and gbp = -3345.3 and eur = -530469 and  hkd = -4301.1','')")

    con:query("insert into check_sql values(-4778,'delete from transaction_total_check where cny = -4778 and jpy = -477800 and gbp = -3344.6 and eur = -530358 and  hkd = -4300.2','')")

    con:query("insert into check_sql values(-4777,'delete from transaction_total_check where cny = -4777 and jpy = -477700 and gbp = -3343.9 and eur = -530247 and  hkd = -4299.3','')")

    con:query("insert into check_sql values(-4776,'delete from transaction_total_check where cny = -4776 and jpy = -477600 and gbp = -3343.2 and eur = -530136 and  hkd = -4298.4','')")

    con:query("insert into check_sql values(-4775,'delete from transaction_total_check where cny = -4775 and jpy = -477500 and gbp = -3342.5 and eur = -530025 and  hkd = -4297.5','')")

    con:query("insert into check_sql values(-4774,'delete from transaction_total_check where cny = -4774 and jpy = -477400 and gbp = -3341.8 and eur = -529914 and  hkd = -4296.6','')")

    con:query("insert into check_sql values(-4773,'delete from transaction_total_check where cny = -4773 and jpy = -477300 and gbp = -3341.1 and eur = -529803 and  hkd = -4295.7','')")

    con:query("insert into check_sql values(-4772,'delete from transaction_total_check where cny = -4772 and jpy = -477200 and gbp = -3340.4 and eur = -529692 and  hkd = -4294.8','')")

    con:query("insert into check_sql values(-4771,'delete from transaction_total_check where cny = -4771 and jpy = -477100 and gbp = -3339.7 and eur = -529581 and  hkd = -4293.9','')")

    con:query("insert into check_sql values(-4770,'delete from transaction_total_check where cny = -4770 and jpy = -477000 and gbp = -3339.0 and eur = -529470 and  hkd = -4293.0','')")

    con:query("insert into check_sql values(-4769,'delete from transaction_total_check where cny = -4769 and jpy = -476900 and gbp = -3338.3 and eur = -529359 and  hkd = -4292.1','')")

    con:query("insert into check_sql values(-4768,'delete from transaction_total_check where cny = -4768 and jpy = -476800 and gbp = -3337.6 and eur = -529248 and  hkd = -4291.2','')")

    con:query("insert into check_sql values(-4767,'delete from transaction_total_check where cny = -4767 and jpy = -476700 and gbp = -3336.9 and eur = -529137 and  hkd = -4290.3','')")

    con:query("insert into check_sql values(-4766,'delete from transaction_total_check where cny = -4766 and jpy = -476600 and gbp = -3336.2 and eur = -529026 and  hkd = -4289.4','')")

    con:query("insert into check_sql values(-4765,'delete from transaction_total_check where cny = -4765 and jpy = -476500 and gbp = -3335.5 and eur = -528915 and  hkd = -4288.5','')")

    con:query("insert into check_sql values(-4764,'delete from transaction_total_check where cny = -4764 and jpy = -476400 and gbp = -3334.8 and eur = -528804 and  hkd = -4287.6','')")

    con:query("insert into check_sql values(-4763,'delete from transaction_total_check where cny = -4763 and jpy = -476300 and gbp = -3334.1 and eur = -528693 and  hkd = -4286.7','')")

    con:query("insert into check_sql values(-4762,'delete from transaction_total_check where cny = -4762 and jpy = -476200 and gbp = -3333.4 and eur = -528582 and  hkd = -4285.8','')")

    con:query("insert into check_sql values(-4761,'delete from transaction_total_check where cny = -4761 and jpy = -476100 and gbp = -3332.7 and eur = -528471 and  hkd = -4284.9','')")

    con:query("insert into check_sql values(-4760,'delete from transaction_total_check where cny = -4760 and jpy = -476000 and gbp = -3332.0 and eur = -528360 and  hkd = -4284.0','')")

    con:query("insert into check_sql values(-4759,'delete from transaction_total_check where cny = -4759 and jpy = -475900 and gbp = -3331.3 and eur = -528249 and  hkd = -4283.1','')")

    con:query("insert into check_sql values(-4758,'delete from transaction_total_check where cny = -4758 and jpy = -475800 and gbp = -3330.6 and eur = -528138 and  hkd = -4282.2','')")

    con:query("insert into check_sql values(-4757,'delete from transaction_total_check where cny = -4757 and jpy = -475700 and gbp = -3329.9 and eur = -528027 and  hkd = -4281.3','')")

    con:query("insert into check_sql values(-4756,'delete from transaction_total_check where cny = -4756 and jpy = -475600 and gbp = -3329.2 and eur = -527916 and  hkd = -4280.4','')")

    con:query("insert into check_sql values(-4755,'delete from transaction_total_check where cny = -4755 and jpy = -475500 and gbp = -3328.5 and eur = -527805 and  hkd = -4279.5','')")

    con:query("insert into check_sql values(-4754,'delete from transaction_total_check where cny = -4754 and jpy = -475400 and gbp = -3327.8 and eur = -527694 and  hkd = -4278.6','')")

    con:query("insert into check_sql values(-4753,'delete from transaction_total_check where cny = -4753 and jpy = -475300 and gbp = -3327.1 and eur = -527583 and  hkd = -4277.7','')")

    con:query("insert into check_sql values(-4752,'delete from transaction_total_check where cny = -4752 and jpy = -475200 and gbp = -3326.4 and eur = -527472 and  hkd = -4276.8','')")

    con:query("insert into check_sql values(-4751,'delete from transaction_total_check where cny = -4751 and jpy = -475100 and gbp = -3325.7 and eur = -527361 and  hkd = -4275.9','')")

    con:query("insert into check_sql values(-4750,'delete from transaction_total_check where cny = -4750 and jpy = -475000 and gbp = -3325.0 and eur = -527250 and  hkd = -4275.0','')")

    con:query("insert into check_sql values(-4749,'delete from transaction_total_check where cny = -4749 and jpy = -474900 and gbp = -3324.3 and eur = -527139 and  hkd = -4274.1','')")

    con:query("insert into check_sql values(-4748,'delete from transaction_total_check where cny = -4748 and jpy = -474800 and gbp = -3323.6 and eur = -527028 and  hkd = -4273.2','')")

    con:query("insert into check_sql values(-4747,'delete from transaction_total_check where cny = -4747 and jpy = -474700 and gbp = -3322.9 and eur = -526917 and  hkd = -4272.3','')")

    con:query("insert into check_sql values(-4746,'delete from transaction_total_check where cny = -4746 and jpy = -474600 and gbp = -3322.2 and eur = -526806 and  hkd = -4271.4','')")

    con:query("insert into check_sql values(-4745,'delete from transaction_total_check where cny = -4745 and jpy = -474500 and gbp = -3321.5 and eur = -526695 and  hkd = -4270.5','')")

    con:query("insert into check_sql values(-4744,'delete from transaction_total_check where cny = -4744 and jpy = -474400 and gbp = -3320.8 and eur = -526584 and  hkd = -4269.6','')")

    con:query("insert into check_sql values(-4743,'delete from transaction_total_check where cny = -4743 and jpy = -474300 and gbp = -3320.1 and eur = -526473 and  hkd = -4268.7','')")

    con:query("insert into check_sql values(-4742,'delete from transaction_total_check where cny = -4742 and jpy = -474200 and gbp = -3319.4 and eur = -526362 and  hkd = -4267.8','')")

    con:query("insert into check_sql values(-4741,'delete from transaction_total_check where cny = -4741 and jpy = -474100 and gbp = -3318.7 and eur = -526251 and  hkd = -4266.9','')")

    con:query("insert into check_sql values(-4740,'delete from transaction_total_check where cny = -4740 and jpy = -474000 and gbp = -3318.0 and eur = -526140 and  hkd = -4266.0','')")

    con:query("insert into check_sql values(-4739,'delete from transaction_total_check where cny = -4739 and jpy = -473900 and gbp = -3317.3 and eur = -526029 and  hkd = -4265.1','')")

    con:query("insert into check_sql values(-4738,'delete from transaction_total_check where cny = -4738 and jpy = -473800 and gbp = -3316.6 and eur = -525918 and  hkd = -4264.2','')")

    con:query("insert into check_sql values(-4737,'delete from transaction_total_check where cny = -4737 and jpy = -473700 and gbp = -3315.9 and eur = -525807 and  hkd = -4263.3','')")

    con:query("insert into check_sql values(-4736,'delete from transaction_total_check where cny = -4736 and jpy = -473600 and gbp = -3315.2 and eur = -525696 and  hkd = -4262.4','')")

    con:query("insert into check_sql values(-4735,'delete from transaction_total_check where cny = -4735 and jpy = -473500 and gbp = -3314.5 and eur = -525585 and  hkd = -4261.5','')")

    con:query("insert into check_sql values(-4734,'delete from transaction_total_check where cny = -4734 and jpy = -473400 and gbp = -3313.8 and eur = -525474 and  hkd = -4260.6','')")

    con:query("insert into check_sql values(-4733,'delete from transaction_total_check where cny = -4733 and jpy = -473300 and gbp = -3313.1 and eur = -525363 and  hkd = -4259.7','')")

    con:query("insert into check_sql values(-4732,'delete from transaction_total_check where cny = -4732 and jpy = -473200 and gbp = -3312.4 and eur = -525252 and  hkd = -4258.8','')")

    con:query("insert into check_sql values(-4731,'delete from transaction_total_check where cny = -4731 and jpy = -473100 and gbp = -3311.7 and eur = -525141 and  hkd = -4257.9','')")

    con:query("insert into check_sql values(-4730,'delete from transaction_total_check where cny = -4730 and jpy = -473000 and gbp = -3311.0 and eur = -525030 and  hkd = -4257.0','')")

    con:query("insert into check_sql values(-4729,'delete from transaction_total_check where cny = -4729 and jpy = -472900 and gbp = -3310.3 and eur = -524919 and  hkd = -4256.1','')")

    con:query("insert into check_sql values(-4728,'delete from transaction_total_check where cny = -4728 and jpy = -472800 and gbp = -3309.6 and eur = -524808 and  hkd = -4255.2','')")

    con:query("insert into check_sql values(-4727,'delete from transaction_total_check where cny = -4727 and jpy = -472700 and gbp = -3308.9 and eur = -524697 and  hkd = -4254.3','')")

    con:query("insert into check_sql values(-4726,'delete from transaction_total_check where cny = -4726 and jpy = -472600 and gbp = -3308.2 and eur = -524586 and  hkd = -4253.4','')")

    con:query("insert into check_sql values(-4725,'delete from transaction_total_check where cny = -4725 and jpy = -472500 and gbp = -3307.5 and eur = -524475 and  hkd = -4252.5','')")

    con:query("insert into check_sql values(-4724,'delete from transaction_total_check where cny = -4724 and jpy = -472400 and gbp = -3306.8 and eur = -524364 and  hkd = -4251.6','')")

    con:query("insert into check_sql values(-4723,'delete from transaction_total_check where cny = -4723 and jpy = -472300 and gbp = -3306.1 and eur = -524253 and  hkd = -4250.7','')")

    con:query("insert into check_sql values(-4722,'delete from transaction_total_check where cny = -4722 and jpy = -472200 and gbp = -3305.4 and eur = -524142 and  hkd = -4249.8','')")

    con:query("insert into check_sql values(-4721,'delete from transaction_total_check where cny = -4721 and jpy = -472100 and gbp = -3304.7 and eur = -524031 and  hkd = -4248.9','')")

    con:query("insert into check_sql values(-4720,'delete from transaction_total_check where cny = -4720 and jpy = -472000 and gbp = -3304.0 and eur = -523920 and  hkd = -4248.0','')")

    con:query("insert into check_sql values(-4719,'delete from transaction_total_check where cny = -4719 and jpy = -471900 and gbp = -3303.3 and eur = -523809 and  hkd = -4247.1','')")

    con:query("insert into check_sql values(-4718,'delete from transaction_total_check where cny = -4718 and jpy = -471800 and gbp = -3302.6 and eur = -523698 and  hkd = -4246.2','')")

    con:query("insert into check_sql values(-4717,'delete from transaction_total_check where cny = -4717 and jpy = -471700 and gbp = -3301.9 and eur = -523587 and  hkd = -4245.3','')")

    con:query("insert into check_sql values(-4716,'delete from transaction_total_check where cny = -4716 and jpy = -471600 and gbp = -3301.2 and eur = -523476 and  hkd = -4244.4','')")

    con:query("insert into check_sql values(-4715,'delete from transaction_total_check where cny = -4715 and jpy = -471500 and gbp = -3300.5 and eur = -523365 and  hkd = -4243.5','')")

    con:query("insert into check_sql values(-4714,'delete from transaction_total_check where cny = -4714 and jpy = -471400 and gbp = -3299.8 and eur = -523254 and  hkd = -4242.6','')")

    con:query("insert into check_sql values(-4713,'delete from transaction_total_check where cny = -4713 and jpy = -471300 and gbp = -3299.1 and eur = -523143 and  hkd = -4241.7','')")

    con:query("insert into check_sql values(-4712,'delete from transaction_total_check where cny = -4712 and jpy = -471200 and gbp = -3298.4 and eur = -523032 and  hkd = -4240.8','')")

    con:query("insert into check_sql values(-4711,'delete from transaction_total_check where cny = -4711 and jpy = -471100 and gbp = -3297.7 and eur = -522921 and  hkd = -4239.9','')")

    con:query("insert into check_sql values(-4710,'delete from transaction_total_check where cny = -4710 and jpy = -471000 and gbp = -3297.0 and eur = -522810 and  hkd = -4239.0','')")

    con:query("insert into check_sql values(-4709,'delete from transaction_total_check where cny = -4709 and jpy = -470900 and gbp = -3296.3 and eur = -522699 and  hkd = -4238.1','')")

    con:query("insert into check_sql values(-4708,'delete from transaction_total_check where cny = -4708 and jpy = -470800 and gbp = -3295.6 and eur = -522588 and  hkd = -4237.2','')")

    con:query("insert into check_sql values(-4707,'delete from transaction_total_check where cny = -4707 and jpy = -470700 and gbp = -3294.9 and eur = -522477 and  hkd = -4236.3','')")

    con:query("insert into check_sql values(-4706,'delete from transaction_total_check where cny = -4706 and jpy = -470600 and gbp = -3294.2 and eur = -522366 and  hkd = -4235.4','')")

    con:query("insert into check_sql values(-4705,'delete from transaction_total_check where cny = -4705 and jpy = -470500 and gbp = -3293.5 and eur = -522255 and  hkd = -4234.5','')")

    con:query("insert into check_sql values(-4704,'delete from transaction_total_check where cny = -4704 and jpy = -470400 and gbp = -3292.8 and eur = -522144 and  hkd = -4233.6','')")

    con:query("insert into check_sql values(-4703,'delete from transaction_total_check where cny = -4703 and jpy = -470300 and gbp = -3292.1 and eur = -522033 and  hkd = -4232.7','')")

    con:query("insert into check_sql values(-4702,'delete from transaction_total_check where cny = -4702 and jpy = -470200 and gbp = -3291.4 and eur = -521922 and  hkd = -4231.8','')")

    con:query("insert into check_sql values(-4701,'delete from transaction_total_check where cny = -4701 and jpy = -470100 and gbp = -3290.7 and eur = -521811 and  hkd = -4230.9','')")

    con:query("insert into check_sql values(-4700,'delete from transaction_total_check where cny = -4700 and jpy = -470000 and gbp = -3290.0 and eur = -521700 and  hkd = -4230.0','')")

    con:query("insert into check_sql values(-4699,'delete from transaction_total_check where cny = -4699 and jpy = -469900 and gbp = -3289.3 and eur = -521589 and  hkd = -4229.1','')")

    con:query("insert into check_sql values(-4698,'delete from transaction_total_check where cny = -4698 and jpy = -469800 and gbp = -3288.6 and eur = -521478 and  hkd = -4228.2','')")

    con:query("insert into check_sql values(-4697,'delete from transaction_total_check where cny = -4697 and jpy = -469700 and gbp = -3287.9 and eur = -521367 and  hkd = -4227.3','')")

    con:query("insert into check_sql values(-4696,'delete from transaction_total_check where cny = -4696 and jpy = -469600 and gbp = -3287.2 and eur = -521256 and  hkd = -4226.4','')")

    con:query("insert into check_sql values(-4695,'delete from transaction_total_check where cny = -4695 and jpy = -469500 and gbp = -3286.5 and eur = -521145 and  hkd = -4225.5','')")

    con:query("insert into check_sql values(-4694,'delete from transaction_total_check where cny = -4694 and jpy = -469400 and gbp = -3285.8 and eur = -521034 and  hkd = -4224.6','')")

    con:query("insert into check_sql values(-4693,'delete from transaction_total_check where cny = -4693 and jpy = -469300 and gbp = -3285.1 and eur = -520923 and  hkd = -4223.7','')")

    con:query("insert into check_sql values(-4692,'delete from transaction_total_check where cny = -4692 and jpy = -469200 and gbp = -3284.4 and eur = -520812 and  hkd = -4222.8','')")

    con:query("insert into check_sql values(-4691,'delete from transaction_total_check where cny = -4691 and jpy = -469100 and gbp = -3283.7 and eur = -520701 and  hkd = -4221.9','')")

    con:query("insert into check_sql values(-4690,'delete from transaction_total_check where cny = -4690 and jpy = -469000 and gbp = -3283.0 and eur = -520590 and  hkd = -4221.0','')")

    con:query("insert into check_sql values(-4689,'delete from transaction_total_check where cny = -4689 and jpy = -468900 and gbp = -3282.3 and eur = -520479 and  hkd = -4220.1','')")

    con:query("insert into check_sql values(-4688,'delete from transaction_total_check where cny = -4688 and jpy = -468800 and gbp = -3281.6 and eur = -520368 and  hkd = -4219.2','')")

    con:query("insert into check_sql values(-4687,'delete from transaction_total_check where cny = -4687 and jpy = -468700 and gbp = -3280.9 and eur = -520257 and  hkd = -4218.3','')")

    con:query("insert into check_sql values(-4686,'delete from transaction_total_check where cny = -4686 and jpy = -468600 and gbp = -3280.2 and eur = -520146 and  hkd = -4217.4','')")

    con:query("insert into check_sql values(-4685,'delete from transaction_total_check where cny = -4685 and jpy = -468500 and gbp = -3279.5 and eur = -520035 and  hkd = -4216.5','')")

    con:query("insert into check_sql values(-4684,'delete from transaction_total_check where cny = -4684 and jpy = -468400 and gbp = -3278.8 and eur = -519924 and  hkd = -4215.6','')")

    con:query("insert into check_sql values(-4683,'delete from transaction_total_check where cny = -4683 and jpy = -468300 and gbp = -3278.1 and eur = -519813 and  hkd = -4214.7','')")

    con:query("insert into check_sql values(-4682,'delete from transaction_total_check where cny = -4682 and jpy = -468200 and gbp = -3277.4 and eur = -519702 and  hkd = -4213.8','')")

    con:query("insert into check_sql values(-4681,'delete from transaction_total_check where cny = -4681 and jpy = -468100 and gbp = -3276.7 and eur = -519591 and  hkd = -4212.9','')")

    con:query("insert into check_sql values(-4680,'delete from transaction_total_check where cny = -4680 and jpy = -468000 and gbp = -3276.0 and eur = -519480 and  hkd = -4212.0','')")

    con:query("insert into check_sql values(-4679,'delete from transaction_total_check where cny = -4679 and jpy = -467900 and gbp = -3275.3 and eur = -519369 and  hkd = -4211.1','')")

    con:query("insert into check_sql values(-4678,'delete from transaction_total_check where cny = -4678 and jpy = -467800 and gbp = -3274.6 and eur = -519258 and  hkd = -4210.2','')")

    con:query("insert into check_sql values(-4677,'delete from transaction_total_check where cny = -4677 and jpy = -467700 and gbp = -3273.9 and eur = -519147 and  hkd = -4209.3','')")

    con:query("insert into check_sql values(-4676,'delete from transaction_total_check where cny = -4676 and jpy = -467600 and gbp = -3273.2 and eur = -519036 and  hkd = -4208.4','')")

    con:query("insert into check_sql values(-4675,'delete from transaction_total_check where cny = -4675 and jpy = -467500 and gbp = -3272.5 and eur = -518925 and  hkd = -4207.5','')")

    con:query("insert into check_sql values(-4674,'delete from transaction_total_check where cny = -4674 and jpy = -467400 and gbp = -3271.8 and eur = -518814 and  hkd = -4206.6','')")

    con:query("insert into check_sql values(-4673,'delete from transaction_total_check where cny = -4673 and jpy = -467300 and gbp = -3271.1 and eur = -518703 and  hkd = -4205.7','')")

    con:query("insert into check_sql values(-4672,'delete from transaction_total_check where cny = -4672 and jpy = -467200 and gbp = -3270.4 and eur = -518592 and  hkd = -4204.8','')")

    con:query("insert into check_sql values(-4671,'delete from transaction_total_check where cny = -4671 and jpy = -467100 and gbp = -3269.7 and eur = -518481 and  hkd = -4203.9','')")

    con:query("insert into check_sql values(-4670,'delete from transaction_total_check where cny = -4670 and jpy = -467000 and gbp = -3269.0 and eur = -518370 and  hkd = -4203.0','')")

    con:query("insert into check_sql values(-4669,'delete from transaction_total_check where cny = -4669 and jpy = -466900 and gbp = -3268.3 and eur = -518259 and  hkd = -4202.1','')")

    con:query("insert into check_sql values(-4668,'delete from transaction_total_check where cny = -4668 and jpy = -466800 and gbp = -3267.6 and eur = -518148 and  hkd = -4201.2','')")

    con:query("insert into check_sql values(-4667,'delete from transaction_total_check where cny = -4667 and jpy = -466700 and gbp = -3266.9 and eur = -518037 and  hkd = -4200.3','')")

    con:query("insert into check_sql values(-4666,'delete from transaction_total_check where cny = -4666 and jpy = -466600 and gbp = -3266.2 and eur = -517926 and  hkd = -4199.4','')")

    con:query("insert into check_sql values(-4665,'delete from transaction_total_check where cny = -4665 and jpy = -466500 and gbp = -3265.5 and eur = -517815 and  hkd = -4198.5','')")

    con:query("insert into check_sql values(-4664,'delete from transaction_total_check where cny = -4664 and jpy = -466400 and gbp = -3264.8 and eur = -517704 and  hkd = -4197.6','')")

    con:query("insert into check_sql values(-4663,'delete from transaction_total_check where cny = -4663 and jpy = -466300 and gbp = -3264.1 and eur = -517593 and  hkd = -4196.7','')")

    con:query("insert into check_sql values(-4662,'delete from transaction_total_check where cny = -4662 and jpy = -466200 and gbp = -3263.4 and eur = -517482 and  hkd = -4195.8','')")

    con:query("insert into check_sql values(-4661,'delete from transaction_total_check where cny = -4661 and jpy = -466100 and gbp = -3262.7 and eur = -517371 and  hkd = -4194.9','')")

    con:query("insert into check_sql values(-4660,'delete from transaction_total_check where cny = -4660 and jpy = -466000 and gbp = -3262.0 and eur = -517260 and  hkd = -4194.0','')")

    con:query("insert into check_sql values(-4659,'delete from transaction_total_check where cny = -4659 and jpy = -465900 and gbp = -3261.3 and eur = -517149 and  hkd = -4193.1','')")

    con:query("insert into check_sql values(-4658,'delete from transaction_total_check where cny = -4658 and jpy = -465800 and gbp = -3260.6 and eur = -517038 and  hkd = -4192.2','')")

    con:query("insert into check_sql values(-4657,'delete from transaction_total_check where cny = -4657 and jpy = -465700 and gbp = -3259.9 and eur = -516927 and  hkd = -4191.3','')")

    con:query("insert into check_sql values(-4656,'delete from transaction_total_check where cny = -4656 and jpy = -465600 and gbp = -3259.2 and eur = -516816 and  hkd = -4190.4','')")

    con:query("insert into check_sql values(-4655,'delete from transaction_total_check where cny = -4655 and jpy = -465500 and gbp = -3258.5 and eur = -516705 and  hkd = -4189.5','')")

    con:query("insert into check_sql values(-4654,'delete from transaction_total_check where cny = -4654 and jpy = -465400 and gbp = -3257.8 and eur = -516594 and  hkd = -4188.6','')")

    con:query("insert into check_sql values(-4653,'delete from transaction_total_check where cny = -4653 and jpy = -465300 and gbp = -3257.1 and eur = -516483 and  hkd = -4187.7','')")

    con:query("insert into check_sql values(-4652,'delete from transaction_total_check where cny = -4652 and jpy = -465200 and gbp = -3256.4 and eur = -516372 and  hkd = -4186.8','')")

    con:query("insert into check_sql values(-4651,'delete from transaction_total_check where cny = -4651 and jpy = -465100 and gbp = -3255.7 and eur = -516261 and  hkd = -4185.9','')")

    con:query("insert into check_sql values(-4650,'delete from transaction_total_check where cny = -4650 and jpy = -465000 and gbp = -3255.0 and eur = -516150 and  hkd = -4185.0','')")

    con:query("insert into check_sql values(-4649,'delete from transaction_total_check where cny = -4649 and jpy = -464900 and gbp = -3254.3 and eur = -516039 and  hkd = -4184.1','')")

    con:query("insert into check_sql values(-4648,'delete from transaction_total_check where cny = -4648 and jpy = -464800 and gbp = -3253.6 and eur = -515928 and  hkd = -4183.2','')")

    con:query("insert into check_sql values(-4647,'delete from transaction_total_check where cny = -4647 and jpy = -464700 and gbp = -3252.9 and eur = -515817 and  hkd = -4182.3','')")

    con:query("insert into check_sql values(-4646,'delete from transaction_total_check where cny = -4646 and jpy = -464600 and gbp = -3252.2 and eur = -515706 and  hkd = -4181.4','')")

    con:query("insert into check_sql values(-4645,'delete from transaction_total_check where cny = -4645 and jpy = -464500 and gbp = -3251.5 and eur = -515595 and  hkd = -4180.5','')")

    con:query("insert into check_sql values(-4644,'delete from transaction_total_check where cny = -4644 and jpy = -464400 and gbp = -3250.8 and eur = -515484 and  hkd = -4179.6','')")

    con:query("insert into check_sql values(-4643,'delete from transaction_total_check where cny = -4643 and jpy = -464300 and gbp = -3250.1 and eur = -515373 and  hkd = -4178.7','')")

    con:query("insert into check_sql values(-4642,'delete from transaction_total_check where cny = -4642 and jpy = -464200 and gbp = -3249.4 and eur = -515262 and  hkd = -4177.8','')")

    con:query("insert into check_sql values(-4641,'delete from transaction_total_check where cny = -4641 and jpy = -464100 and gbp = -3248.7 and eur = -515151 and  hkd = -4176.9','')")

    con:query("insert into check_sql values(-4640,'delete from transaction_total_check where cny = -4640 and jpy = -464000 and gbp = -3248.0 and eur = -515040 and  hkd = -4176.0','')")

    con:query("insert into check_sql values(-4639,'delete from transaction_total_check where cny = -4639 and jpy = -463900 and gbp = -3247.3 and eur = -514929 and  hkd = -4175.1','')")

    con:query("insert into check_sql values(-4638,'delete from transaction_total_check where cny = -4638 and jpy = -463800 and gbp = -3246.6 and eur = -514818 and  hkd = -4174.2','')")

    con:query("insert into check_sql values(-4637,'delete from transaction_total_check where cny = -4637 and jpy = -463700 and gbp = -3245.9 and eur = -514707 and  hkd = -4173.3','')")

    con:query("insert into check_sql values(-4636,'delete from transaction_total_check where cny = -4636 and jpy = -463600 and gbp = -3245.2 and eur = -514596 and  hkd = -4172.4','')")

    con:query("insert into check_sql values(-4635,'delete from transaction_total_check where cny = -4635 and jpy = -463500 and gbp = -3244.5 and eur = -514485 and  hkd = -4171.5','')")

    con:query("insert into check_sql values(-4634,'delete from transaction_total_check where cny = -4634 and jpy = -463400 and gbp = -3243.8 and eur = -514374 and  hkd = -4170.6','')")

    con:query("insert into check_sql values(-4633,'delete from transaction_total_check where cny = -4633 and jpy = -463300 and gbp = -3243.1 and eur = -514263 and  hkd = -4169.7','')")

    con:query("insert into check_sql values(-4632,'delete from transaction_total_check where cny = -4632 and jpy = -463200 and gbp = -3242.4 and eur = -514152 and  hkd = -4168.8','')")

    con:query("insert into check_sql values(-4631,'delete from transaction_total_check where cny = -4631 and jpy = -463100 and gbp = -3241.7 and eur = -514041 and  hkd = -4167.9','')")

    con:query("insert into check_sql values(-4630,'delete from transaction_total_check where cny = -4630 and jpy = -463000 and gbp = -3241.0 and eur = -513930 and  hkd = -4167.0','')")

    con:query("insert into check_sql values(-4629,'delete from transaction_total_check where cny = -4629 and jpy = -462900 and gbp = -3240.3 and eur = -513819 and  hkd = -4166.1','')")

    con:query("insert into check_sql values(-4628,'delete from transaction_total_check where cny = -4628 and jpy = -462800 and gbp = -3239.6 and eur = -513708 and  hkd = -4165.2','')")

    con:query("insert into check_sql values(-4627,'delete from transaction_total_check where cny = -4627 and jpy = -462700 and gbp = -3238.9 and eur = -513597 and  hkd = -4164.3','')")

    con:query("insert into check_sql values(-4626,'delete from transaction_total_check where cny = -4626 and jpy = -462600 and gbp = -3238.2 and eur = -513486 and  hkd = -4163.4','')")

    con:query("insert into check_sql values(-4625,'delete from transaction_total_check where cny = -4625 and jpy = -462500 and gbp = -3237.5 and eur = -513375 and  hkd = -4162.5','')")

    con:query("insert into check_sql values(-4624,'delete from transaction_total_check where cny = -4624 and jpy = -462400 and gbp = -3236.8 and eur = -513264 and  hkd = -4161.6','')")

    con:query("insert into check_sql values(-4623,'delete from transaction_total_check where cny = -4623 and jpy = -462300 and gbp = -3236.1 and eur = -513153 and  hkd = -4160.7','')")

    con:query("insert into check_sql values(-4622,'delete from transaction_total_check where cny = -4622 and jpy = -462200 and gbp = -3235.4 and eur = -513042 and  hkd = -4159.8','')")

    con:query("insert into check_sql values(-4621,'delete from transaction_total_check where cny = -4621 and jpy = -462100 and gbp = -3234.7 and eur = -512931 and  hkd = -4158.9','')")

    con:query("insert into check_sql values(-4620,'delete from transaction_total_check where cny = -4620 and jpy = -462000 and gbp = -3234.0 and eur = -512820 and  hkd = -4158.0','')")

    con:query("insert into check_sql values(-4619,'delete from transaction_total_check where cny = -4619 and jpy = -461900 and gbp = -3233.3 and eur = -512709 and  hkd = -4157.1','')")

    con:query("insert into check_sql values(-4618,'delete from transaction_total_check where cny = -4618 and jpy = -461800 and gbp = -3232.6 and eur = -512598 and  hkd = -4156.2','')")

    con:query("insert into check_sql values(-4617,'delete from transaction_total_check where cny = -4617 and jpy = -461700 and gbp = -3231.9 and eur = -512487 and  hkd = -4155.3','')")

    con:query("insert into check_sql values(-4616,'delete from transaction_total_check where cny = -4616 and jpy = -461600 and gbp = -3231.2 and eur = -512376 and  hkd = -4154.4','')")

    con:query("insert into check_sql values(-4615,'delete from transaction_total_check where cny = -4615 and jpy = -461500 and gbp = -3230.5 and eur = -512265 and  hkd = -4153.5','')")

    con:query("insert into check_sql values(-4614,'delete from transaction_total_check where cny = -4614 and jpy = -461400 and gbp = -3229.8 and eur = -512154 and  hkd = -4152.6','')")

    con:query("insert into check_sql values(-4613,'delete from transaction_total_check where cny = -4613 and jpy = -461300 and gbp = -3229.1 and eur = -512043 and  hkd = -4151.7','')")

    con:query("insert into check_sql values(-4612,'delete from transaction_total_check where cny = -4612 and jpy = -461200 and gbp = -3228.4 and eur = -511932 and  hkd = -4150.8','')")

    con:query("insert into check_sql values(-4611,'delete from transaction_total_check where cny = -4611 and jpy = -461100 and gbp = -3227.7 and eur = -511821 and  hkd = -4149.9','')")

    con:query("insert into check_sql values(-4610,'delete from transaction_total_check where cny = -4610 and jpy = -461000 and gbp = -3227.0 and eur = -511710 and  hkd = -4149.0','')")

    con:query("insert into check_sql values(-4609,'delete from transaction_total_check where cny = -4609 and jpy = -460900 and gbp = -3226.3 and eur = -511599 and  hkd = -4148.1','')")

    con:query("insert into check_sql values(-4608,'delete from transaction_total_check where cny = -4608 and jpy = -460800 and gbp = -3225.6 and eur = -511488 and  hkd = -4147.2','')")

    con:query("insert into check_sql values(-4607,'delete from transaction_total_check where cny = -4607 and jpy = -460700 and gbp = -3224.9 and eur = -511377 and  hkd = -4146.3','')")

    con:query("insert into check_sql values(-4606,'delete from transaction_total_check where cny = -4606 and jpy = -460600 and gbp = -3224.2 and eur = -511266 and  hkd = -4145.4','')")

    con:query("insert into check_sql values(-4605,'delete from transaction_total_check where cny = -4605 and jpy = -460500 and gbp = -3223.5 and eur = -511155 and  hkd = -4144.5','')")

    con:query("insert into check_sql values(-4604,'delete from transaction_total_check where cny = -4604 and jpy = -460400 and gbp = -3222.8 and eur = -511044 and  hkd = -4143.6','')")

    con:query("insert into check_sql values(-4603,'delete from transaction_total_check where cny = -4603 and jpy = -460300 and gbp = -3222.1 and eur = -510933 and  hkd = -4142.7','')")

    con:query("insert into check_sql values(-4602,'delete from transaction_total_check where cny = -4602 and jpy = -460200 and gbp = -3221.4 and eur = -510822 and  hkd = -4141.8','')")

    con:query("insert into check_sql values(-4601,'delete from transaction_total_check where cny = -4601 and jpy = -460100 and gbp = -3220.7 and eur = -510711 and  hkd = -4140.9','')")

    con:query("insert into check_sql values(-4600,'delete from transaction_total_check where cny = -4600 and jpy = -460000 and gbp = -3220.0 and eur = -510600 and  hkd = -4140.0','')")

    con:query("insert into check_sql values(-4599,'delete from transaction_total_check where cny = -4599 and jpy = -459900 and gbp = -3219.3 and eur = -510489 and  hkd = -4139.1','')")

    con:query("insert into check_sql values(-4598,'delete from transaction_total_check where cny = -4598 and jpy = -459800 and gbp = -3218.6 and eur = -510378 and  hkd = -4138.2','')")

    con:query("insert into check_sql values(-4597,'delete from transaction_total_check where cny = -4597 and jpy = -459700 and gbp = -3217.9 and eur = -510267 and  hkd = -4137.3','')")

    con:query("insert into check_sql values(-4596,'delete from transaction_total_check where cny = -4596 and jpy = -459600 and gbp = -3217.2 and eur = -510156 and  hkd = -4136.4','')")

    con:query("insert into check_sql values(-4595,'delete from transaction_total_check where cny = -4595 and jpy = -459500 and gbp = -3216.5 and eur = -510045 and  hkd = -4135.5','')")

    con:query("insert into check_sql values(-4594,'delete from transaction_total_check where cny = -4594 and jpy = -459400 and gbp = -3215.8 and eur = -509934 and  hkd = -4134.6','')")

    con:query("insert into check_sql values(-4593,'delete from transaction_total_check where cny = -4593 and jpy = -459300 and gbp = -3215.1 and eur = -509823 and  hkd = -4133.7','')")

    con:query("insert into check_sql values(-4592,'delete from transaction_total_check where cny = -4592 and jpy = -459200 and gbp = -3214.4 and eur = -509712 and  hkd = -4132.8','')")

    con:query("insert into check_sql values(-4591,'delete from transaction_total_check where cny = -4591 and jpy = -459100 and gbp = -3213.7 and eur = -509601 and  hkd = -4131.9','')")

    con:query("insert into check_sql values(-4590,'delete from transaction_total_check where cny = -4590 and jpy = -459000 and gbp = -3213.0 and eur = -509490 and  hkd = -4131.0','')")

    con:query("insert into check_sql values(-4589,'delete from transaction_total_check where cny = -4589 and jpy = -458900 and gbp = -3212.3 and eur = -509379 and  hkd = -4130.1','')")

    con:query("insert into check_sql values(-4588,'delete from transaction_total_check where cny = -4588 and jpy = -458800 and gbp = -3211.6 and eur = -509268 and  hkd = -4129.2','')")

    con:query("insert into check_sql values(-4587,'delete from transaction_total_check where cny = -4587 and jpy = -458700 and gbp = -3210.9 and eur = -509157 and  hkd = -4128.3','')")

    con:query("insert into check_sql values(-4586,'delete from transaction_total_check where cny = -4586 and jpy = -458600 and gbp = -3210.2 and eur = -509046 and  hkd = -4127.4','')")

    con:query("insert into check_sql values(-4585,'delete from transaction_total_check where cny = -4585 and jpy = -458500 and gbp = -3209.5 and eur = -508935 and  hkd = -4126.5','')")

    con:query("insert into check_sql values(-4584,'delete from transaction_total_check where cny = -4584 and jpy = -458400 and gbp = -3208.8 and eur = -508824 and  hkd = -4125.6','')")

    con:query("insert into check_sql values(-4583,'delete from transaction_total_check where cny = -4583 and jpy = -458300 and gbp = -3208.1 and eur = -508713 and  hkd = -4124.7','')")

    con:query("insert into check_sql values(-4582,'delete from transaction_total_check where cny = -4582 and jpy = -458200 and gbp = -3207.4 and eur = -508602 and  hkd = -4123.8','')")

    con:query("insert into check_sql values(-4581,'delete from transaction_total_check where cny = -4581 and jpy = -458100 and gbp = -3206.7 and eur = -508491 and  hkd = -4122.9','')")

    con:query("insert into check_sql values(-4580,'delete from transaction_total_check where cny = -4580 and jpy = -458000 and gbp = -3206.0 and eur = -508380 and  hkd = -4122.0','')")

    con:query("insert into check_sql values(-4579,'delete from transaction_total_check where cny = -4579 and jpy = -457900 and gbp = -3205.3 and eur = -508269 and  hkd = -4121.1','')")

    con:query("insert into check_sql values(-4578,'delete from transaction_total_check where cny = -4578 and jpy = -457800 and gbp = -3204.6 and eur = -508158 and  hkd = -4120.2','')")

    con:query("insert into check_sql values(-4577,'delete from transaction_total_check where cny = -4577 and jpy = -457700 and gbp = -3203.9 and eur = -508047 and  hkd = -4119.3','')")

    con:query("insert into check_sql values(-4576,'delete from transaction_total_check where cny = -4576 and jpy = -457600 and gbp = -3203.2 and eur = -507936 and  hkd = -4118.4','')")

    con:query("insert into check_sql values(-4575,'delete from transaction_total_check where cny = -4575 and jpy = -457500 and gbp = -3202.5 and eur = -507825 and  hkd = -4117.5','')")

    con:query("insert into check_sql values(-4574,'delete from transaction_total_check where cny = -4574 and jpy = -457400 and gbp = -3201.8 and eur = -507714 and  hkd = -4116.6','')")

    con:query("insert into check_sql values(-4573,'delete from transaction_total_check where cny = -4573 and jpy = -457300 and gbp = -3201.1 and eur = -507603 and  hkd = -4115.7','')")

    con:query("insert into check_sql values(-4572,'delete from transaction_total_check where cny = -4572 and jpy = -457200 and gbp = -3200.4 and eur = -507492 and  hkd = -4114.8','')")

    con:query("insert into check_sql values(-4571,'delete from transaction_total_check where cny = -4571 and jpy = -457100 and gbp = -3199.7 and eur = -507381 and  hkd = -4113.9','')")

    con:query("insert into check_sql values(-4570,'delete from transaction_total_check where cny = -4570 and jpy = -457000 and gbp = -3199.0 and eur = -507270 and  hkd = -4113.0','')")

    con:query("insert into check_sql values(-4569,'delete from transaction_total_check where cny = -4569 and jpy = -456900 and gbp = -3198.3 and eur = -507159 and  hkd = -4112.1','')")

    con:query("insert into check_sql values(-4568,'delete from transaction_total_check where cny = -4568 and jpy = -456800 and gbp = -3197.6 and eur = -507048 and  hkd = -4111.2','')")

    con:query("insert into check_sql values(-4567,'delete from transaction_total_check where cny = -4567 and jpy = -456700 and gbp = -3196.9 and eur = -506937 and  hkd = -4110.3','')")

    con:query("insert into check_sql values(-4566,'delete from transaction_total_check where cny = -4566 and jpy = -456600 and gbp = -3196.2 and eur = -506826 and  hkd = -4109.4','')")

    con:query("insert into check_sql values(-4565,'delete from transaction_total_check where cny = -4565 and jpy = -456500 and gbp = -3195.5 and eur = -506715 and  hkd = -4108.5','')")

    con:query("insert into check_sql values(-4564,'delete from transaction_total_check where cny = -4564 and jpy = -456400 and gbp = -3194.8 and eur = -506604 and  hkd = -4107.6','')")

    con:query("insert into check_sql values(-4563,'delete from transaction_total_check where cny = -4563 and jpy = -456300 and gbp = -3194.1 and eur = -506493 and  hkd = -4106.7','')")

    con:query("insert into check_sql values(-4562,'delete from transaction_total_check where cny = -4562 and jpy = -456200 and gbp = -3193.4 and eur = -506382 and  hkd = -4105.8','')")

    con:query("insert into check_sql values(-4561,'delete from transaction_total_check where cny = -4561 and jpy = -456100 and gbp = -3192.7 and eur = -506271 and  hkd = -4104.9','')")

    con:query("insert into check_sql values(-4560,'delete from transaction_total_check where cny = -4560 and jpy = -456000 and gbp = -3192.0 and eur = -506160 and  hkd = -4104.0','')")

    con:query("insert into check_sql values(-4559,'delete from transaction_total_check where cny = -4559 and jpy = -455900 and gbp = -3191.3 and eur = -506049 and  hkd = -4103.1','')")

    con:query("insert into check_sql values(-4558,'delete from transaction_total_check where cny = -4558 and jpy = -455800 and gbp = -3190.6 and eur = -505938 and  hkd = -4102.2','')")

    con:query("insert into check_sql values(-4557,'delete from transaction_total_check where cny = -4557 and jpy = -455700 and gbp = -3189.9 and eur = -505827 and  hkd = -4101.3','')")

    con:query("insert into check_sql values(-4556,'delete from transaction_total_check where cny = -4556 and jpy = -455600 and gbp = -3189.2 and eur = -505716 and  hkd = -4100.4','')")

    con:query("insert into check_sql values(-4555,'delete from transaction_total_check where cny = -4555 and jpy = -455500 and gbp = -3188.5 and eur = -505605 and  hkd = -4099.5','')")

    con:query("insert into check_sql values(-4554,'delete from transaction_total_check where cny = -4554 and jpy = -455400 and gbp = -3187.8 and eur = -505494 and  hkd = -4098.6','')")

    con:query("insert into check_sql values(-4553,'delete from transaction_total_check where cny = -4553 and jpy = -455300 and gbp = -3187.1 and eur = -505383 and  hkd = -4097.7','')")

    con:query("insert into check_sql values(-4552,'delete from transaction_total_check where cny = -4552 and jpy = -455200 and gbp = -3186.4 and eur = -505272 and  hkd = -4096.8','')")

    con:query("insert into check_sql values(-4551,'delete from transaction_total_check where cny = -4551 and jpy = -455100 and gbp = -3185.7 and eur = -505161 and  hkd = -4095.9','')")

    con:query("insert into check_sql values(-4550,'delete from transaction_total_check where cny = -4550 and jpy = -455000 and gbp = -3185.0 and eur = -505050 and  hkd = -4095.0','')")

    con:query("insert into check_sql values(-4549,'delete from transaction_total_check where cny = -4549 and jpy = -454900 and gbp = -3184.3 and eur = -504939 and  hkd = -4094.1','')")

    con:query("insert into check_sql values(-4548,'delete from transaction_total_check where cny = -4548 and jpy = -454800 and gbp = -3183.6 and eur = -504828 and  hkd = -4093.2','')")

    con:query("insert into check_sql values(-4547,'delete from transaction_total_check where cny = -4547 and jpy = -454700 and gbp = -3182.9 and eur = -504717 and  hkd = -4092.3','')")

    con:query("insert into check_sql values(-4546,'delete from transaction_total_check where cny = -4546 and jpy = -454600 and gbp = -3182.2 and eur = -504606 and  hkd = -4091.4','')")

    con:query("insert into check_sql values(-4545,'delete from transaction_total_check where cny = -4545 and jpy = -454500 and gbp = -3181.5 and eur = -504495 and  hkd = -4090.5','')")

    con:query("insert into check_sql values(-4544,'delete from transaction_total_check where cny = -4544 and jpy = -454400 and gbp = -3180.8 and eur = -504384 and  hkd = -4089.6','')")

    con:query("insert into check_sql values(-4543,'delete from transaction_total_check where cny = -4543 and jpy = -454300 and gbp = -3180.1 and eur = -504273 and  hkd = -4088.7','')")

    con:query("insert into check_sql values(-4542,'delete from transaction_total_check where cny = -4542 and jpy = -454200 and gbp = -3179.4 and eur = -504162 and  hkd = -4087.8','')")

    con:query("insert into check_sql values(-4541,'delete from transaction_total_check where cny = -4541 and jpy = -454100 and gbp = -3178.7 and eur = -504051 and  hkd = -4086.9','')")

    con:query("insert into check_sql values(-4540,'delete from transaction_total_check where cny = -4540 and jpy = -454000 and gbp = -3178.0 and eur = -503940 and  hkd = -4086.0','')")

    con:query("insert into check_sql values(-4539,'delete from transaction_total_check where cny = -4539 and jpy = -453900 and gbp = -3177.3 and eur = -503829 and  hkd = -4085.1','')")

    con:query("insert into check_sql values(-4538,'delete from transaction_total_check where cny = -4538 and jpy = -453800 and gbp = -3176.6 and eur = -503718 and  hkd = -4084.2','')")

    con:query("insert into check_sql values(-4537,'delete from transaction_total_check where cny = -4537 and jpy = -453700 and gbp = -3175.9 and eur = -503607 and  hkd = -4083.3','')")

    con:query("insert into check_sql values(-4536,'delete from transaction_total_check where cny = -4536 and jpy = -453600 and gbp = -3175.2 and eur = -503496 and  hkd = -4082.4','')")

    con:query("insert into check_sql values(-4535,'delete from transaction_total_check where cny = -4535 and jpy = -453500 and gbp = -3174.5 and eur = -503385 and  hkd = -4081.5','')")

    con:query("insert into check_sql values(-4534,'delete from transaction_total_check where cny = -4534 and jpy = -453400 and gbp = -3173.8 and eur = -503274 and  hkd = -4080.6','')")

    con:query("insert into check_sql values(-4533,'delete from transaction_total_check where cny = -4533 and jpy = -453300 and gbp = -3173.1 and eur = -503163 and  hkd = -4079.7','')")

    con:query("insert into check_sql values(-4532,'delete from transaction_total_check where cny = -4532 and jpy = -453200 and gbp = -3172.4 and eur = -503052 and  hkd = -4078.8','')")

    con:query("insert into check_sql values(-4531,'delete from transaction_total_check where cny = -4531 and jpy = -453100 and gbp = -3171.7 and eur = -502941 and  hkd = -4077.9','')")

    con:query("insert into check_sql values(-4530,'delete from transaction_total_check where cny = -4530 and jpy = -453000 and gbp = -3171.0 and eur = -502830 and  hkd = -4077.0','')")

    con:query("insert into check_sql values(-4529,'delete from transaction_total_check where cny = -4529 and jpy = -452900 and gbp = -3170.3 and eur = -502719 and  hkd = -4076.1','')")

    con:query("insert into check_sql values(-4528,'delete from transaction_total_check where cny = -4528 and jpy = -452800 and gbp = -3169.6 and eur = -502608 and  hkd = -4075.2','')")

    con:query("insert into check_sql values(-4527,'delete from transaction_total_check where cny = -4527 and jpy = -452700 and gbp = -3168.9 and eur = -502497 and  hkd = -4074.3','')")

    con:query("insert into check_sql values(-4526,'delete from transaction_total_check where cny = -4526 and jpy = -452600 and gbp = -3168.2 and eur = -502386 and  hkd = -4073.4','')")

    con:query("insert into check_sql values(-4525,'delete from transaction_total_check where cny = -4525 and jpy = -452500 and gbp = -3167.5 and eur = -502275 and  hkd = -4072.5','')")

    con:query("insert into check_sql values(-4524,'delete from transaction_total_check where cny = -4524 and jpy = -452400 and gbp = -3166.8 and eur = -502164 and  hkd = -4071.6','')")

    con:query("insert into check_sql values(-4523,'delete from transaction_total_check where cny = -4523 and jpy = -452300 and gbp = -3166.1 and eur = -502053 and  hkd = -4070.7','')")

    con:query("insert into check_sql values(-4522,'delete from transaction_total_check where cny = -4522 and jpy = -452200 and gbp = -3165.4 and eur = -501942 and  hkd = -4069.8','')")

    con:query("insert into check_sql values(-4521,'delete from transaction_total_check where cny = -4521 and jpy = -452100 and gbp = -3164.7 and eur = -501831 and  hkd = -4068.9','')")

    con:query("insert into check_sql values(-4520,'delete from transaction_total_check where cny = -4520 and jpy = -452000 and gbp = -3164.0 and eur = -501720 and  hkd = -4068.0','')")

    con:query("insert into check_sql values(-4519,'delete from transaction_total_check where cny = -4519 and jpy = -451900 and gbp = -3163.3 and eur = -501609 and  hkd = -4067.1','')")

    con:query("insert into check_sql values(-4518,'delete from transaction_total_check where cny = -4518 and jpy = -451800 and gbp = -3162.6 and eur = -501498 and  hkd = -4066.2','')")

    con:query("insert into check_sql values(-4517,'delete from transaction_total_check where cny = -4517 and jpy = -451700 and gbp = -3161.9 and eur = -501387 and  hkd = -4065.3','')")

    con:query("insert into check_sql values(-4516,'delete from transaction_total_check where cny = -4516 and jpy = -451600 and gbp = -3161.2 and eur = -501276 and  hkd = -4064.4','')")

    con:query("insert into check_sql values(-4515,'delete from transaction_total_check where cny = -4515 and jpy = -451500 and gbp = -3160.5 and eur = -501165 and  hkd = -4063.5','')")

    con:query("insert into check_sql values(-4514,'delete from transaction_total_check where cny = -4514 and jpy = -451400 and gbp = -3159.8 and eur = -501054 and  hkd = -4062.6','')")

    con:query("insert into check_sql values(-4513,'delete from transaction_total_check where cny = -4513 and jpy = -451300 and gbp = -3159.1 and eur = -500943 and  hkd = -4061.7','')")

    con:query("insert into check_sql values(-4512,'delete from transaction_total_check where cny = -4512 and jpy = -451200 and gbp = -3158.4 and eur = -500832 and  hkd = -4060.8','')")

    con:query("insert into check_sql values(-4511,'delete from transaction_total_check where cny = -4511 and jpy = -451100 and gbp = -3157.7 and eur = -500721 and  hkd = -4059.9','')")

    con:query("insert into check_sql values(-4510,'delete from transaction_total_check where cny = -4510 and jpy = -451000 and gbp = -3157.0 and eur = -500610 and  hkd = -4059.0','')")

    con:query("insert into check_sql values(-4509,'delete from transaction_total_check where cny = -4509 and jpy = -450900 and gbp = -3156.3 and eur = -500499 and  hkd = -4058.1','')")

    con:query("insert into check_sql values(-4508,'delete from transaction_total_check where cny = -4508 and jpy = -450800 and gbp = -3155.6 and eur = -500388 and  hkd = -4057.2','')")

    con:query("insert into check_sql values(-4507,'delete from transaction_total_check where cny = -4507 and jpy = -450700 and gbp = -3154.9 and eur = -500277 and  hkd = -4056.3','')")

    con:query("insert into check_sql values(-4506,'delete from transaction_total_check where cny = -4506 and jpy = -450600 and gbp = -3154.2 and eur = -500166 and  hkd = -4055.4','')")

    con:query("insert into check_sql values(-4505,'delete from transaction_total_check where cny = -4505 and jpy = -450500 and gbp = -3153.5 and eur = -500055 and  hkd = -4054.5','')")

    con:query("insert into check_sql values(-4504,'delete from transaction_total_check where cny = -4504 and jpy = -450400 and gbp = -3152.8 and eur = -499944 and  hkd = -4053.6','')")

    con:query("insert into check_sql values(-4503,'delete from transaction_total_check where cny = -4503 and jpy = -450300 and gbp = -3152.1 and eur = -499833 and  hkd = -4052.7','')")

    con:query("insert into check_sql values(-4502,'delete from transaction_total_check where cny = -4502 and jpy = -450200 and gbp = -3151.4 and eur = -499722 and  hkd = -4051.8','')")

    con:query("insert into check_sql values(-4501,'delete from transaction_total_check where cny = -4501 and jpy = -450100 and gbp = -3150.7 and eur = -499611 and  hkd = -4050.9','')")

    con:query("insert into check_sql values(-4500,'delete from transaction_total_check where cny = -4500 and jpy = -450000 and gbp = -3150.0 and eur = -499500 and  hkd = -4050.0','')")

    con:query("insert into check_sql values(-4499,'delete from transaction_total_check where cny = -4499 and jpy = -449900 and gbp = -3149.3 and eur = -499389 and  hkd = -4049.1','')")

    con:query("insert into check_sql values(-4498,'delete from transaction_total_check where cny = -4498 and jpy = -449800 and gbp = -3148.6 and eur = -499278 and  hkd = -4048.2','')")

    con:query("insert into check_sql values(-4497,'delete from transaction_total_check where cny = -4497 and jpy = -449700 and gbp = -3147.9 and eur = -499167 and  hkd = -4047.3','')")

    con:query("insert into check_sql values(-4496,'delete from transaction_total_check where cny = -4496 and jpy = -449600 and gbp = -3147.2 and eur = -499056 and  hkd = -4046.4','')")

    con:query("insert into check_sql values(-4495,'delete from transaction_total_check where cny = -4495 and jpy = -449500 and gbp = -3146.5 and eur = -498945 and  hkd = -4045.5','')")

    con:query("insert into check_sql values(-4494,'delete from transaction_total_check where cny = -4494 and jpy = -449400 and gbp = -3145.8 and eur = -498834 and  hkd = -4044.6','')")

    con:query("insert into check_sql values(-4493,'delete from transaction_total_check where cny = -4493 and jpy = -449300 and gbp = -3145.1 and eur = -498723 and  hkd = -4043.7','')")

    con:query("insert into check_sql values(-4492,'delete from transaction_total_check where cny = -4492 and jpy = -449200 and gbp = -3144.4 and eur = -498612 and  hkd = -4042.8','')")

    con:query("insert into check_sql values(-4491,'delete from transaction_total_check where cny = -4491 and jpy = -449100 and gbp = -3143.7 and eur = -498501 and  hkd = -4041.9','')")

    con:query("insert into check_sql values(-4490,'delete from transaction_total_check where cny = -4490 and jpy = -449000 and gbp = -3143.0 and eur = -498390 and  hkd = -4041.0','')")

    con:query("insert into check_sql values(-4489,'delete from transaction_total_check where cny = -4489 and jpy = -448900 and gbp = -3142.3 and eur = -498279 and  hkd = -4040.1','')")

    con:query("insert into check_sql values(-4488,'delete from transaction_total_check where cny = -4488 and jpy = -448800 and gbp = -3141.6 and eur = -498168 and  hkd = -4039.2','')")

    con:query("insert into check_sql values(-4487,'delete from transaction_total_check where cny = -4487 and jpy = -448700 and gbp = -3140.9 and eur = -498057 and  hkd = -4038.3','')")

    con:query("insert into check_sql values(-4486,'delete from transaction_total_check where cny = -4486 and jpy = -448600 and gbp = -3140.2 and eur = -497946 and  hkd = -4037.4','')")

    con:query("insert into check_sql values(-4485,'delete from transaction_total_check where cny = -4485 and jpy = -448500 and gbp = -3139.5 and eur = -497835 and  hkd = -4036.5','')")

    con:query("insert into check_sql values(-4484,'delete from transaction_total_check where cny = -4484 and jpy = -448400 and gbp = -3138.8 and eur = -497724 and  hkd = -4035.6','')")

    con:query("insert into check_sql values(-4483,'delete from transaction_total_check where cny = -4483 and jpy = -448300 and gbp = -3138.1 and eur = -497613 and  hkd = -4034.7','')")

    con:query("insert into check_sql values(-4482,'delete from transaction_total_check where cny = -4482 and jpy = -448200 and gbp = -3137.4 and eur = -497502 and  hkd = -4033.8','')")

    con:query("insert into check_sql values(-4481,'delete from transaction_total_check where cny = -4481 and jpy = -448100 and gbp = -3136.7 and eur = -497391 and  hkd = -4032.9','')")

    con:query("insert into check_sql values(-4480,'delete from transaction_total_check where cny = -4480 and jpy = -448000 and gbp = -3136.0 and eur = -497280 and  hkd = -4032.0','')")

    con:query("insert into check_sql values(-4479,'delete from transaction_total_check where cny = -4479 and jpy = -447900 and gbp = -3135.3 and eur = -497169 and  hkd = -4031.1','')")

    con:query("insert into check_sql values(-4478,'delete from transaction_total_check where cny = -4478 and jpy = -447800 and gbp = -3134.6 and eur = -497058 and  hkd = -4030.2','')")

    con:query("insert into check_sql values(-4477,'delete from transaction_total_check where cny = -4477 and jpy = -447700 and gbp = -3133.9 and eur = -496947 and  hkd = -4029.3','')")

    con:query("insert into check_sql values(-4476,'delete from transaction_total_check where cny = -4476 and jpy = -447600 and gbp = -3133.2 and eur = -496836 and  hkd = -4028.4','')")

    con:query("insert into check_sql values(-4475,'delete from transaction_total_check where cny = -4475 and jpy = -447500 and gbp = -3132.5 and eur = -496725 and  hkd = -4027.5','')")

    con:query("insert into check_sql values(-4474,'delete from transaction_total_check where cny = -4474 and jpy = -447400 and gbp = -3131.8 and eur = -496614 and  hkd = -4026.6','')")

    con:query("insert into check_sql values(-4473,'delete from transaction_total_check where cny = -4473 and jpy = -447300 and gbp = -3131.1 and eur = -496503 and  hkd = -4025.7','')")

    con:query("insert into check_sql values(-4472,'delete from transaction_total_check where cny = -4472 and jpy = -447200 and gbp = -3130.4 and eur = -496392 and  hkd = -4024.8','')")

    con:query("insert into check_sql values(-4471,'delete from transaction_total_check where cny = -4471 and jpy = -447100 and gbp = -3129.7 and eur = -496281 and  hkd = -4023.9','')")

    con:query("insert into check_sql values(-4470,'delete from transaction_total_check where cny = -4470 and jpy = -447000 and gbp = -3129.0 and eur = -496170 and  hkd = -4023.0','')")

    con:query("insert into check_sql values(-4469,'delete from transaction_total_check where cny = -4469 and jpy = -446900 and gbp = -3128.3 and eur = -496059 and  hkd = -4022.1','')")

    con:query("insert into check_sql values(-4468,'delete from transaction_total_check where cny = -4468 and jpy = -446800 and gbp = -3127.6 and eur = -495948 and  hkd = -4021.2','')")

    con:query("insert into check_sql values(-4467,'delete from transaction_total_check where cny = -4467 and jpy = -446700 and gbp = -3126.9 and eur = -495837 and  hkd = -4020.3','')")

    con:query("insert into check_sql values(-4466,'delete from transaction_total_check where cny = -4466 and jpy = -446600 and gbp = -3126.2 and eur = -495726 and  hkd = -4019.4','')")

    con:query("insert into check_sql values(-4465,'delete from transaction_total_check where cny = -4465 and jpy = -446500 and gbp = -3125.5 and eur = -495615 and  hkd = -4018.5','')")

    con:query("insert into check_sql values(-4464,'delete from transaction_total_check where cny = -4464 and jpy = -446400 and gbp = -3124.8 and eur = -495504 and  hkd = -4017.6','')")

    con:query("insert into check_sql values(-4463,'delete from transaction_total_check where cny = -4463 and jpy = -446300 and gbp = -3124.1 and eur = -495393 and  hkd = -4016.7','')")

    con:query("insert into check_sql values(-4462,'delete from transaction_total_check where cny = -4462 and jpy = -446200 and gbp = -3123.4 and eur = -495282 and  hkd = -4015.8','')")

    con:query("insert into check_sql values(-4461,'delete from transaction_total_check where cny = -4461 and jpy = -446100 and gbp = -3122.7 and eur = -495171 and  hkd = -4014.9','')")

    con:query("insert into check_sql values(-4460,'delete from transaction_total_check where cny = -4460 and jpy = -446000 and gbp = -3122.0 and eur = -495060 and  hkd = -4014.0','')")

    con:query("insert into check_sql values(-4459,'delete from transaction_total_check where cny = -4459 and jpy = -445900 and gbp = -3121.3 and eur = -494949 and  hkd = -4013.1','')")

    con:query("insert into check_sql values(-4458,'delete from transaction_total_check where cny = -4458 and jpy = -445800 and gbp = -3120.6 and eur = -494838 and  hkd = -4012.2','')")

    con:query("insert into check_sql values(-4457,'delete from transaction_total_check where cny = -4457 and jpy = -445700 and gbp = -3119.9 and eur = -494727 and  hkd = -4011.3','')")

    con:query("insert into check_sql values(-4456,'delete from transaction_total_check where cny = -4456 and jpy = -445600 and gbp = -3119.2 and eur = -494616 and  hkd = -4010.4','')")

    con:query("insert into check_sql values(-4455,'delete from transaction_total_check where cny = -4455 and jpy = -445500 and gbp = -3118.5 and eur = -494505 and  hkd = -4009.5','')")

    con:query("insert into check_sql values(-4454,'delete from transaction_total_check where cny = -4454 and jpy = -445400 and gbp = -3117.8 and eur = -494394 and  hkd = -4008.6','')")

    con:query("insert into check_sql values(-4453,'delete from transaction_total_check where cny = -4453 and jpy = -445300 and gbp = -3117.1 and eur = -494283 and  hkd = -4007.7','')")

    con:query("insert into check_sql values(-4452,'delete from transaction_total_check where cny = -4452 and jpy = -445200 and gbp = -3116.4 and eur = -494172 and  hkd = -4006.8','')")

    con:query("insert into check_sql values(-4451,'delete from transaction_total_check where cny = -4451 and jpy = -445100 and gbp = -3115.7 and eur = -494061 and  hkd = -4005.9','')")

    con:query("insert into check_sql values(-4450,'delete from transaction_total_check where cny = -4450 and jpy = -445000 and gbp = -3115.0 and eur = -493950 and  hkd = -4005.0','')")

    con:query("insert into check_sql values(-4449,'delete from transaction_total_check where cny = -4449 and jpy = -444900 and gbp = -3114.3 and eur = -493839 and  hkd = -4004.1','')")

    con:query("insert into check_sql values(-4448,'delete from transaction_total_check where cny = -4448 and jpy = -444800 and gbp = -3113.6 and eur = -493728 and  hkd = -4003.2','')")

    con:query("insert into check_sql values(-4447,'delete from transaction_total_check where cny = -4447 and jpy = -444700 and gbp = -3112.9 and eur = -493617 and  hkd = -4002.3','')")

    con:query("insert into check_sql values(-4446,'delete from transaction_total_check where cny = -4446 and jpy = -444600 and gbp = -3112.2 and eur = -493506 and  hkd = -4001.4','')")

    con:query("insert into check_sql values(-4445,'delete from transaction_total_check where cny = -4445 and jpy = -444500 and gbp = -3111.5 and eur = -493395 and  hkd = -4000.5','')")

    con:query("insert into check_sql values(-4444,'delete from transaction_total_check where cny = -4444 and jpy = -444400 and gbp = -3110.8 and eur = -493284 and  hkd = -3999.6','')")

    con:query("insert into check_sql values(-4443,'delete from transaction_total_check where cny = -4443 and jpy = -444300 and gbp = -3110.1 and eur = -493173 and  hkd = -3998.7','')")

    con:query("insert into check_sql values(-4442,'delete from transaction_total_check where cny = -4442 and jpy = -444200 and gbp = -3109.4 and eur = -493062 and  hkd = -3997.8','')")

    con:query("insert into check_sql values(-4441,'delete from transaction_total_check where cny = -4441 and jpy = -444100 and gbp = -3108.7 and eur = -492951 and  hkd = -3996.9','')")

    con:query("insert into check_sql values(-4440,'delete from transaction_total_check where cny = -4440 and jpy = -444000 and gbp = -3108.0 and eur = -492840 and  hkd = -3996.0','')")

    con:query("insert into check_sql values(-4439,'delete from transaction_total_check where cny = -4439 and jpy = -443900 and gbp = -3107.3 and eur = -492729 and  hkd = -3995.1','')")

    con:query("insert into check_sql values(-4438,'delete from transaction_total_check where cny = -4438 and jpy = -443800 and gbp = -3106.6 and eur = -492618 and  hkd = -3994.2','')")

    con:query("insert into check_sql values(-4437,'delete from transaction_total_check where cny = -4437 and jpy = -443700 and gbp = -3105.9 and eur = -492507 and  hkd = -3993.3','')")

    con:query("insert into check_sql values(-4436,'delete from transaction_total_check where cny = -4436 and jpy = -443600 and gbp = -3105.2 and eur = -492396 and  hkd = -3992.4','')")

    con:query("insert into check_sql values(-4435,'delete from transaction_total_check where cny = -4435 and jpy = -443500 and gbp = -3104.5 and eur = -492285 and  hkd = -3991.5','')")

    con:query("insert into check_sql values(-4434,'delete from transaction_total_check where cny = -4434 and jpy = -443400 and gbp = -3103.8 and eur = -492174 and  hkd = -3990.6','')")

    con:query("insert into check_sql values(-4433,'delete from transaction_total_check where cny = -4433 and jpy = -443300 and gbp = -3103.1 and eur = -492063 and  hkd = -3989.7','')")

    con:query("insert into check_sql values(-4432,'delete from transaction_total_check where cny = -4432 and jpy = -443200 and gbp = -3102.4 and eur = -491952 and  hkd = -3988.8','')")

    con:query("insert into check_sql values(-4431,'delete from transaction_total_check where cny = -4431 and jpy = -443100 and gbp = -3101.7 and eur = -491841 and  hkd = -3987.9','')")

    con:query("insert into check_sql values(-4430,'delete from transaction_total_check where cny = -4430 and jpy = -443000 and gbp = -3101.0 and eur = -491730 and  hkd = -3987.0','')")

    con:query("insert into check_sql values(-4429,'delete from transaction_total_check where cny = -4429 and jpy = -442900 and gbp = -3100.3 and eur = -491619 and  hkd = -3986.1','')")

    con:query("insert into check_sql values(-4428,'delete from transaction_total_check where cny = -4428 and jpy = -442800 and gbp = -3099.6 and eur = -491508 and  hkd = -3985.2','')")

    con:query("insert into check_sql values(-4427,'delete from transaction_total_check where cny = -4427 and jpy = -442700 and gbp = -3098.9 and eur = -491397 and  hkd = -3984.3','')")

    con:query("insert into check_sql values(-4426,'delete from transaction_total_check where cny = -4426 and jpy = -442600 and gbp = -3098.2 and eur = -491286 and  hkd = -3983.4','')")

    con:query("insert into check_sql values(-4425,'delete from transaction_total_check where cny = -4425 and jpy = -442500 and gbp = -3097.5 and eur = -491175 and  hkd = -3982.5','')")

    con:query("insert into check_sql values(-4424,'delete from transaction_total_check where cny = -4424 and jpy = -442400 and gbp = -3096.8 and eur = -491064 and  hkd = -3981.6','')")

    con:query("insert into check_sql values(-4423,'delete from transaction_total_check where cny = -4423 and jpy = -442300 and gbp = -3096.1 and eur = -490953 and  hkd = -3980.7','')")

    con:query("insert into check_sql values(-4422,'delete from transaction_total_check where cny = -4422 and jpy = -442200 and gbp = -3095.4 and eur = -490842 and  hkd = -3979.8','')")

    con:query("insert into check_sql values(-4421,'delete from transaction_total_check where cny = -4421 and jpy = -442100 and gbp = -3094.7 and eur = -490731 and  hkd = -3978.9','')")

    con:query("insert into check_sql values(-4420,'delete from transaction_total_check where cny = -4420 and jpy = -442000 and gbp = -3094.0 and eur = -490620 and  hkd = -3978.0','')")

    con:query("insert into check_sql values(-4419,'delete from transaction_total_check where cny = -4419 and jpy = -441900 and gbp = -3093.3 and eur = -490509 and  hkd = -3977.1','')")

    con:query("insert into check_sql values(-4418,'delete from transaction_total_check where cny = -4418 and jpy = -441800 and gbp = -3092.6 and eur = -490398 and  hkd = -3976.2','')")

    con:query("insert into check_sql values(-4417,'delete from transaction_total_check where cny = -4417 and jpy = -441700 and gbp = -3091.9 and eur = -490287 and  hkd = -3975.3','')")

    con:query("insert into check_sql values(-4416,'delete from transaction_total_check where cny = -4416 and jpy = -441600 and gbp = -3091.2 and eur = -490176 and  hkd = -3974.4','')")

    con:query("insert into check_sql values(-4415,'delete from transaction_total_check where cny = -4415 and jpy = -441500 and gbp = -3090.5 and eur = -490065 and  hkd = -3973.5','')")

    con:query("insert into check_sql values(-4414,'delete from transaction_total_check where cny = -4414 and jpy = -441400 and gbp = -3089.8 and eur = -489954 and  hkd = -3972.6','')")

    con:query("insert into check_sql values(-4413,'delete from transaction_total_check where cny = -4413 and jpy = -441300 and gbp = -3089.1 and eur = -489843 and  hkd = -3971.7','')")

    con:query("insert into check_sql values(-4412,'delete from transaction_total_check where cny = -4412 and jpy = -441200 and gbp = -3088.4 and eur = -489732 and  hkd = -3970.8','')")

    con:query("insert into check_sql values(-4411,'delete from transaction_total_check where cny = -4411 and jpy = -441100 and gbp = -3087.7 and eur = -489621 and  hkd = -3969.9','')")

    con:query("insert into check_sql values(-4410,'delete from transaction_total_check where cny = -4410 and jpy = -441000 and gbp = -3087.0 and eur = -489510 and  hkd = -3969.0','')")

    con:query("insert into check_sql values(-4409,'delete from transaction_total_check where cny = -4409 and jpy = -440900 and gbp = -3086.3 and eur = -489399 and  hkd = -3968.1','')")

    con:query("insert into check_sql values(-4408,'delete from transaction_total_check where cny = -4408 and jpy = -440800 and gbp = -3085.6 and eur = -489288 and  hkd = -3967.2','')")

    con:query("insert into check_sql values(-4407,'delete from transaction_total_check where cny = -4407 and jpy = -440700 and gbp = -3084.9 and eur = -489177 and  hkd = -3966.3','')")

    con:query("insert into check_sql values(-4406,'delete from transaction_total_check where cny = -4406 and jpy = -440600 and gbp = -3084.2 and eur = -489066 and  hkd = -3965.4','')")

    con:query("insert into check_sql values(-4405,'delete from transaction_total_check where cny = -4405 and jpy = -440500 and gbp = -3083.5 and eur = -488955 and  hkd = -3964.5','')")

    con:query("insert into check_sql values(-4404,'delete from transaction_total_check where cny = -4404 and jpy = -440400 and gbp = -3082.8 and eur = -488844 and  hkd = -3963.6','')")

    con:query("insert into check_sql values(-4403,'delete from transaction_total_check where cny = -4403 and jpy = -440300 and gbp = -3082.1 and eur = -488733 and  hkd = -3962.7','')")

    con:query("insert into check_sql values(-4402,'delete from transaction_total_check where cny = -4402 and jpy = -440200 and gbp = -3081.4 and eur = -488622 and  hkd = -3961.8','')")

    con:query("insert into check_sql values(-4401,'delete from transaction_total_check where cny = -4401 and jpy = -440100 and gbp = -3080.7 and eur = -488511 and  hkd = -3960.9','')")

    con:query("insert into check_sql values(-4400,'delete from transaction_total_check where cny = -4400 and jpy = -440000 and gbp = -3080.0 and eur = -488400 and  hkd = -3960.0','')")

    con:query("insert into check_sql values(-4399,'delete from transaction_total_check where cny = -4399 and jpy = -439900 and gbp = -3079.3 and eur = -488289 and  hkd = -3959.1','')")

    con:query("insert into check_sql values(-4398,'delete from transaction_total_check where cny = -4398 and jpy = -439800 and gbp = -3078.6 and eur = -488178 and  hkd = -3958.2','')")

    con:query("insert into check_sql values(-4397,'delete from transaction_total_check where cny = -4397 and jpy = -439700 and gbp = -3077.9 and eur = -488067 and  hkd = -3957.3','')")

    con:query("insert into check_sql values(-4396,'delete from transaction_total_check where cny = -4396 and jpy = -439600 and gbp = -3077.2 and eur = -487956 and  hkd = -3956.4','')")

    con:query("insert into check_sql values(-4395,'delete from transaction_total_check where cny = -4395 and jpy = -439500 and gbp = -3076.5 and eur = -487845 and  hkd = -3955.5','')")

    con:query("insert into check_sql values(-4394,'delete from transaction_total_check where cny = -4394 and jpy = -439400 and gbp = -3075.8 and eur = -487734 and  hkd = -3954.6','')")

    con:query("insert into check_sql values(-4393,'delete from transaction_total_check where cny = -4393 and jpy = -439300 and gbp = -3075.1 and eur = -487623 and  hkd = -3953.7','')")

    con:query("insert into check_sql values(-4392,'delete from transaction_total_check where cny = -4392 and jpy = -439200 and gbp = -3074.4 and eur = -487512 and  hkd = -3952.8','')")

    con:query("insert into check_sql values(-4391,'delete from transaction_total_check where cny = -4391 and jpy = -439100 and gbp = -3073.7 and eur = -487401 and  hkd = -3951.9','')")

    con:query("insert into check_sql values(-4390,'delete from transaction_total_check where cny = -4390 and jpy = -439000 and gbp = -3073.0 and eur = -487290 and  hkd = -3951.0','')")

    con:query("insert into check_sql values(-4389,'delete from transaction_total_check where cny = -4389 and jpy = -438900 and gbp = -3072.3 and eur = -487179 and  hkd = -3950.1','')")

    con:query("insert into check_sql values(-4388,'delete from transaction_total_check where cny = -4388 and jpy = -438800 and gbp = -3071.6 and eur = -487068 and  hkd = -3949.2','')")

    con:query("insert into check_sql values(-4387,'delete from transaction_total_check where cny = -4387 and jpy = -438700 and gbp = -3070.9 and eur = -486957 and  hkd = -3948.3','')")

    con:query("insert into check_sql values(-4386,'delete from transaction_total_check where cny = -4386 and jpy = -438600 and gbp = -3070.2 and eur = -486846 and  hkd = -3947.4','')")

    con:query("insert into check_sql values(-4385,'delete from transaction_total_check where cny = -4385 and jpy = -438500 and gbp = -3069.5 and eur = -486735 and  hkd = -3946.5','')")

    con:query("insert into check_sql values(-4384,'delete from transaction_total_check where cny = -4384 and jpy = -438400 and gbp = -3068.8 and eur = -486624 and  hkd = -3945.6','')")

    con:query("insert into check_sql values(-4383,'delete from transaction_total_check where cny = -4383 and jpy = -438300 and gbp = -3068.1 and eur = -486513 and  hkd = -3944.7','')")

    con:query("insert into check_sql values(-4382,'delete from transaction_total_check where cny = -4382 and jpy = -438200 and gbp = -3067.4 and eur = -486402 and  hkd = -3943.8','')")

    con:query("insert into check_sql values(-4381,'delete from transaction_total_check where cny = -4381 and jpy = -438100 and gbp = -3066.7 and eur = -486291 and  hkd = -3942.9','')")

    con:query("insert into check_sql values(-4380,'delete from transaction_total_check where cny = -4380 and jpy = -438000 and gbp = -3066.0 and eur = -486180 and  hkd = -3942.0','')")

    con:query("insert into check_sql values(-4379,'delete from transaction_total_check where cny = -4379 and jpy = -437900 and gbp = -3065.3 and eur = -486069 and  hkd = -3941.1','')")

    con:query("insert into check_sql values(-4378,'delete from transaction_total_check where cny = -4378 and jpy = -437800 and gbp = -3064.6 and eur = -485958 and  hkd = -3940.2','')")

    con:query("insert into check_sql values(-4377,'delete from transaction_total_check where cny = -4377 and jpy = -437700 and gbp = -3063.9 and eur = -485847 and  hkd = -3939.3','')")

    con:query("insert into check_sql values(-4376,'delete from transaction_total_check where cny = -4376 and jpy = -437600 and gbp = -3063.2 and eur = -485736 and  hkd = -3938.4','')")

    con:query("insert into check_sql values(-4375,'delete from transaction_total_check where cny = -4375 and jpy = -437500 and gbp = -3062.5 and eur = -485625 and  hkd = -3937.5','')")

    con:query("insert into check_sql values(-4374,'delete from transaction_total_check where cny = -4374 and jpy = -437400 and gbp = -3061.8 and eur = -485514 and  hkd = -3936.6','')")

    con:query("insert into check_sql values(-4373,'delete from transaction_total_check where cny = -4373 and jpy = -437300 and gbp = -3061.1 and eur = -485403 and  hkd = -3935.7','')")

    con:query("insert into check_sql values(-4372,'delete from transaction_total_check where cny = -4372 and jpy = -437200 and gbp = -3060.4 and eur = -485292 and  hkd = -3934.8','')")

    con:query("insert into check_sql values(-4371,'delete from transaction_total_check where cny = -4371 and jpy = -437100 and gbp = -3059.7 and eur = -485181 and  hkd = -3933.9','')")

    con:query("insert into check_sql values(-4370,'delete from transaction_total_check where cny = -4370 and jpy = -437000 and gbp = -3059.0 and eur = -485070 and  hkd = -3933.0','')")

    con:query("insert into check_sql values(-4369,'delete from transaction_total_check where cny = -4369 and jpy = -436900 and gbp = -3058.3 and eur = -484959 and  hkd = -3932.1','')")

    con:query("insert into check_sql values(-4368,'delete from transaction_total_check where cny = -4368 and jpy = -436800 and gbp = -3057.6 and eur = -484848 and  hkd = -3931.2','')")

    con:query("insert into check_sql values(-4367,'delete from transaction_total_check where cny = -4367 and jpy = -436700 and gbp = -3056.9 and eur = -484737 and  hkd = -3930.3','')")

    con:query("insert into check_sql values(-4366,'delete from transaction_total_check where cny = -4366 and jpy = -436600 and gbp = -3056.2 and eur = -484626 and  hkd = -3929.4','')")

    con:query("insert into check_sql values(-4365,'delete from transaction_total_check where cny = -4365 and jpy = -436500 and gbp = -3055.5 and eur = -484515 and  hkd = -3928.5','')")

    con:query("insert into check_sql values(-4364,'delete from transaction_total_check where cny = -4364 and jpy = -436400 and gbp = -3054.8 and eur = -484404 and  hkd = -3927.6','')")

    con:query("insert into check_sql values(-4363,'delete from transaction_total_check where cny = -4363 and jpy = -436300 and gbp = -3054.1 and eur = -484293 and  hkd = -3926.7','')")

    con:query("insert into check_sql values(-4362,'delete from transaction_total_check where cny = -4362 and jpy = -436200 and gbp = -3053.4 and eur = -484182 and  hkd = -3925.8','')")

    con:query("insert into check_sql values(-4361,'delete from transaction_total_check where cny = -4361 and jpy = -436100 and gbp = -3052.7 and eur = -484071 and  hkd = -3924.9','')")

    con:query("insert into check_sql values(-4360,'delete from transaction_total_check where cny = -4360 and jpy = -436000 and gbp = -3052.0 and eur = -483960 and  hkd = -3924.0','')")

    con:query("insert into check_sql values(-4359,'delete from transaction_total_check where cny = -4359 and jpy = -435900 and gbp = -3051.3 and eur = -483849 and  hkd = -3923.1','')")

    con:query("insert into check_sql values(-4358,'delete from transaction_total_check where cny = -4358 and jpy = -435800 and gbp = -3050.6 and eur = -483738 and  hkd = -3922.2','')")

    con:query("insert into check_sql values(-4357,'delete from transaction_total_check where cny = -4357 and jpy = -435700 and gbp = -3049.9 and eur = -483627 and  hkd = -3921.3','')")

    con:query("insert into check_sql values(-4356,'delete from transaction_total_check where cny = -4356 and jpy = -435600 and gbp = -3049.2 and eur = -483516 and  hkd = -3920.4','')")

    con:query("insert into check_sql values(-4355,'delete from transaction_total_check where cny = -4355 and jpy = -435500 and gbp = -3048.5 and eur = -483405 and  hkd = -3919.5','')")

    con:query("insert into check_sql values(-4354,'delete from transaction_total_check where cny = -4354 and jpy = -435400 and gbp = -3047.8 and eur = -483294 and  hkd = -3918.6','')")

    con:query("insert into check_sql values(-4353,'delete from transaction_total_check where cny = -4353 and jpy = -435300 and gbp = -3047.1 and eur = -483183 and  hkd = -3917.7','')")

    con:query("insert into check_sql values(-4352,'delete from transaction_total_check where cny = -4352 and jpy = -435200 and gbp = -3046.4 and eur = -483072 and  hkd = -3916.8','')")

    con:query("insert into check_sql values(-4351,'delete from transaction_total_check where cny = -4351 and jpy = -435100 and gbp = -3045.7 and eur = -482961 and  hkd = -3915.9','')")

    con:query("insert into check_sql values(-4350,'delete from transaction_total_check where cny = -4350 and jpy = -435000 and gbp = -3045.0 and eur = -482850 and  hkd = -3915.0','')")

    con:query("insert into check_sql values(-4349,'delete from transaction_total_check where cny = -4349 and jpy = -434900 and gbp = -3044.3 and eur = -482739 and  hkd = -3914.1','')")

    con:query("insert into check_sql values(-4348,'delete from transaction_total_check where cny = -4348 and jpy = -434800 and gbp = -3043.6 and eur = -482628 and  hkd = -3913.2','')")

    con:query("insert into check_sql values(-4347,'delete from transaction_total_check where cny = -4347 and jpy = -434700 and gbp = -3042.9 and eur = -482517 and  hkd = -3912.3','')")

    con:query("insert into check_sql values(-4346,'delete from transaction_total_check where cny = -4346 and jpy = -434600 and gbp = -3042.2 and eur = -482406 and  hkd = -3911.4','')")

    con:query("insert into check_sql values(-4345,'delete from transaction_total_check where cny = -4345 and jpy = -434500 and gbp = -3041.5 and eur = -482295 and  hkd = -3910.5','')")

    con:query("insert into check_sql values(-4344,'delete from transaction_total_check where cny = -4344 and jpy = -434400 and gbp = -3040.8 and eur = -482184 and  hkd = -3909.6','')")

    con:query("insert into check_sql values(-4343,'delete from transaction_total_check where cny = -4343 and jpy = -434300 and gbp = -3040.1 and eur = -482073 and  hkd = -3908.7','')")

    con:query("insert into check_sql values(-4342,'delete from transaction_total_check where cny = -4342 and jpy = -434200 and gbp = -3039.4 and eur = -481962 and  hkd = -3907.8','')")

    con:query("insert into check_sql values(-4341,'delete from transaction_total_check where cny = -4341 and jpy = -434100 and gbp = -3038.7 and eur = -481851 and  hkd = -3906.9','')")

    con:query("insert into check_sql values(-4340,'delete from transaction_total_check where cny = -4340 and jpy = -434000 and gbp = -3038.0 and eur = -481740 and  hkd = -3906.0','')")

    con:query("insert into check_sql values(-4339,'delete from transaction_total_check where cny = -4339 and jpy = -433900 and gbp = -3037.3 and eur = -481629 and  hkd = -3905.1','')")

    con:query("insert into check_sql values(-4338,'delete from transaction_total_check where cny = -4338 and jpy = -433800 and gbp = -3036.6 and eur = -481518 and  hkd = -3904.2','')")

    con:query("insert into check_sql values(-4337,'delete from transaction_total_check where cny = -4337 and jpy = -433700 and gbp = -3035.9 and eur = -481407 and  hkd = -3903.3','')")

    con:query("insert into check_sql values(-4336,'delete from transaction_total_check where cny = -4336 and jpy = -433600 and gbp = -3035.2 and eur = -481296 and  hkd = -3902.4','')")

    con:query("insert into check_sql values(-4335,'delete from transaction_total_check where cny = -4335 and jpy = -433500 and gbp = -3034.5 and eur = -481185 and  hkd = -3901.5','')")

    con:query("insert into check_sql values(-4334,'delete from transaction_total_check where cny = -4334 and jpy = -433400 and gbp = -3033.8 and eur = -481074 and  hkd = -3900.6','')")

    con:query("insert into check_sql values(-4333,'delete from transaction_total_check where cny = -4333 and jpy = -433300 and gbp = -3033.1 and eur = -480963 and  hkd = -3899.7','')")

    con:query("insert into check_sql values(-4332,'delete from transaction_total_check where cny = -4332 and jpy = -433200 and gbp = -3032.4 and eur = -480852 and  hkd = -3898.8','')")

    con:query("insert into check_sql values(-4331,'delete from transaction_total_check where cny = -4331 and jpy = -433100 and gbp = -3031.7 and eur = -480741 and  hkd = -3897.9','')")

    con:query("insert into check_sql values(-4330,'delete from transaction_total_check where cny = -4330 and jpy = -433000 and gbp = -3031.0 and eur = -480630 and  hkd = -3897.0','')")

    con:query("insert into check_sql values(-4329,'delete from transaction_total_check where cny = -4329 and jpy = -432900 and gbp = -3030.3 and eur = -480519 and  hkd = -3896.1','')")

    con:query("insert into check_sql values(-4328,'delete from transaction_total_check where cny = -4328 and jpy = -432800 and gbp = -3029.6 and eur = -480408 and  hkd = -3895.2','')")

    con:query("insert into check_sql values(-4327,'delete from transaction_total_check where cny = -4327 and jpy = -432700 and gbp = -3028.9 and eur = -480297 and  hkd = -3894.3','')")

    con:query("insert into check_sql values(-4326,'delete from transaction_total_check where cny = -4326 and jpy = -432600 and gbp = -3028.2 and eur = -480186 and  hkd = -3893.4','')")

    con:query("insert into check_sql values(-4325,'delete from transaction_total_check where cny = -4325 and jpy = -432500 and gbp = -3027.5 and eur = -480075 and  hkd = -3892.5','')")

    con:query("insert into check_sql values(-4324,'delete from transaction_total_check where cny = -4324 and jpy = -432400 and gbp = -3026.8 and eur = -479964 and  hkd = -3891.6','')")

    con:query("insert into check_sql values(-4323,'delete from transaction_total_check where cny = -4323 and jpy = -432300 and gbp = -3026.1 and eur = -479853 and  hkd = -3890.7','')")

    con:query("insert into check_sql values(-4322,'delete from transaction_total_check where cny = -4322 and jpy = -432200 and gbp = -3025.4 and eur = -479742 and  hkd = -3889.8','')")

    con:query("insert into check_sql values(-4321,'delete from transaction_total_check where cny = -4321 and jpy = -432100 and gbp = -3024.7 and eur = -479631 and  hkd = -3888.9','')")

    con:query("insert into check_sql values(-4320,'delete from transaction_total_check where cny = -4320 and jpy = -432000 and gbp = -3024.0 and eur = -479520 and  hkd = -3888.0','')")

    con:query("insert into check_sql values(-4319,'delete from transaction_total_check where cny = -4319 and jpy = -431900 and gbp = -3023.3 and eur = -479409 and  hkd = -3887.1','')")

    con:query("insert into check_sql values(-4318,'delete from transaction_total_check where cny = -4318 and jpy = -431800 and gbp = -3022.6 and eur = -479298 and  hkd = -3886.2','')")

    con:query("insert into check_sql values(-4317,'delete from transaction_total_check where cny = -4317 and jpy = -431700 and gbp = -3021.9 and eur = -479187 and  hkd = -3885.3','')")

    con:query("insert into check_sql values(-4316,'delete from transaction_total_check where cny = -4316 and jpy = -431600 and gbp = -3021.2 and eur = -479076 and  hkd = -3884.4','')")

    con:query("insert into check_sql values(-4315,'delete from transaction_total_check where cny = -4315 and jpy = -431500 and gbp = -3020.5 and eur = -478965 and  hkd = -3883.5','')")

    con:query("insert into check_sql values(-4314,'delete from transaction_total_check where cny = -4314 and jpy = -431400 and gbp = -3019.8 and eur = -478854 and  hkd = -3882.6','')")

    con:query("insert into check_sql values(-4313,'delete from transaction_total_check where cny = -4313 and jpy = -431300 and gbp = -3019.1 and eur = -478743 and  hkd = -3881.7','')")

    con:query("insert into check_sql values(-4312,'delete from transaction_total_check where cny = -4312 and jpy = -431200 and gbp = -3018.4 and eur = -478632 and  hkd = -3880.8','')")

    con:query("insert into check_sql values(-4311,'delete from transaction_total_check where cny = -4311 and jpy = -431100 and gbp = -3017.7 and eur = -478521 and  hkd = -3879.9','')")

    con:query("insert into check_sql values(-4310,'delete from transaction_total_check where cny = -4310 and jpy = -431000 and gbp = -3017.0 and eur = -478410 and  hkd = -3879.0','')")

    con:query("insert into check_sql values(-4309,'delete from transaction_total_check where cny = -4309 and jpy = -430900 and gbp = -3016.3 and eur = -478299 and  hkd = -3878.1','')")

    con:query("insert into check_sql values(-4308,'delete from transaction_total_check where cny = -4308 and jpy = -430800 and gbp = -3015.6 and eur = -478188 and  hkd = -3877.2','')")

    con:query("insert into check_sql values(-4307,'delete from transaction_total_check where cny = -4307 and jpy = -430700 and gbp = -3014.9 and eur = -478077 and  hkd = -3876.3','')")

    con:query("insert into check_sql values(-4306,'delete from transaction_total_check where cny = -4306 and jpy = -430600 and gbp = -3014.2 and eur = -477966 and  hkd = -3875.4','')")

    con:query("insert into check_sql values(-4305,'delete from transaction_total_check where cny = -4305 and jpy = -430500 and gbp = -3013.5 and eur = -477855 and  hkd = -3874.5','')")

    con:query("insert into check_sql values(-4304,'delete from transaction_total_check where cny = -4304 and jpy = -430400 and gbp = -3012.8 and eur = -477744 and  hkd = -3873.6','')")

    con:query("insert into check_sql values(-4303,'delete from transaction_total_check where cny = -4303 and jpy = -430300 and gbp = -3012.1 and eur = -477633 and  hkd = -3872.7','')")

    con:query("insert into check_sql values(-4302,'delete from transaction_total_check where cny = -4302 and jpy = -430200 and gbp = -3011.4 and eur = -477522 and  hkd = -3871.8','')")

    con:query("insert into check_sql values(-4301,'delete from transaction_total_check where cny = -4301 and jpy = -430100 and gbp = -3010.7 and eur = -477411 and  hkd = -3870.9','')")

    con:query("insert into check_sql values(-4300,'delete from transaction_total_check where cny = -4300 and jpy = -430000 and gbp = -3010.0 and eur = -477300 and  hkd = -3870.0','')")

    con:query("insert into check_sql values(-4299,'delete from transaction_total_check where cny = -4299 and jpy = -429900 and gbp = -3009.3 and eur = -477189 and  hkd = -3869.1','')")

    con:query("insert into check_sql values(-4298,'delete from transaction_total_check where cny = -4298 and jpy = -429800 and gbp = -3008.6 and eur = -477078 and  hkd = -3868.2','')")

    con:query("insert into check_sql values(-4297,'delete from transaction_total_check where cny = -4297 and jpy = -429700 and gbp = -3007.9 and eur = -476967 and  hkd = -3867.3','')")

    con:query("insert into check_sql values(-4296,'delete from transaction_total_check where cny = -4296 and jpy = -429600 and gbp = -3007.2 and eur = -476856 and  hkd = -3866.4','')")

    con:query("insert into check_sql values(-4295,'delete from transaction_total_check where cny = -4295 and jpy = -429500 and gbp = -3006.5 and eur = -476745 and  hkd = -3865.5','')")

    con:query("insert into check_sql values(-4294,'delete from transaction_total_check where cny = -4294 and jpy = -429400 and gbp = -3005.8 and eur = -476634 and  hkd = -3864.6','')")

    con:query("insert into check_sql values(-4293,'delete from transaction_total_check where cny = -4293 and jpy = -429300 and gbp = -3005.1 and eur = -476523 and  hkd = -3863.7','')")

    con:query("insert into check_sql values(-4292,'delete from transaction_total_check where cny = -4292 and jpy = -429200 and gbp = -3004.4 and eur = -476412 and  hkd = -3862.8','')")

    con:query("insert into check_sql values(-4291,'delete from transaction_total_check where cny = -4291 and jpy = -429100 and gbp = -3003.7 and eur = -476301 and  hkd = -3861.9','')")

    con:query("insert into check_sql values(-4290,'delete from transaction_total_check where cny = -4290 and jpy = -429000 and gbp = -3003.0 and eur = -476190 and  hkd = -3861.0','')")

    con:query("insert into check_sql values(-4289,'delete from transaction_total_check where cny = -4289 and jpy = -428900 and gbp = -3002.3 and eur = -476079 and  hkd = -3860.1','')")

    con:query("insert into check_sql values(-4288,'delete from transaction_total_check where cny = -4288 and jpy = -428800 and gbp = -3001.6 and eur = -475968 and  hkd = -3859.2','')")

    con:query("insert into check_sql values(-4287,'delete from transaction_total_check where cny = -4287 and jpy = -428700 and gbp = -3000.9 and eur = -475857 and  hkd = -3858.3','')")

    con:query("insert into check_sql values(-4286,'delete from transaction_total_check where cny = -4286 and jpy = -428600 and gbp = -3000.2 and eur = -475746 and  hkd = -3857.4','')")

    con:query("insert into check_sql values(-4285,'delete from transaction_total_check where cny = -4285 and jpy = -428500 and gbp = -2999.5 and eur = -475635 and  hkd = -3856.5','')")

    con:query("insert into check_sql values(-4284,'delete from transaction_total_check where cny = -4284 and jpy = -428400 and gbp = -2998.8 and eur = -475524 and  hkd = -3855.6','')")

    con:query("insert into check_sql values(-4283,'delete from transaction_total_check where cny = -4283 and jpy = -428300 and gbp = -2998.1 and eur = -475413 and  hkd = -3854.7','')")

    con:query("insert into check_sql values(-4282,'delete from transaction_total_check where cny = -4282 and jpy = -428200 and gbp = -2997.4 and eur = -475302 and  hkd = -3853.8','')")

    con:query("insert into check_sql values(-4281,'delete from transaction_total_check where cny = -4281 and jpy = -428100 and gbp = -2996.7 and eur = -475191 and  hkd = -3852.9','')")

    con:query("insert into check_sql values(-4280,'delete from transaction_total_check where cny = -4280 and jpy = -428000 and gbp = -2996.0 and eur = -475080 and  hkd = -3852.0','')")

    con:query("insert into check_sql values(-4279,'delete from transaction_total_check where cny = -4279 and jpy = -427900 and gbp = -2995.3 and eur = -474969 and  hkd = -3851.1','')")

    con:query("insert into check_sql values(-4278,'delete from transaction_total_check where cny = -4278 and jpy = -427800 and gbp = -2994.6 and eur = -474858 and  hkd = -3850.2','')")

    con:query("insert into check_sql values(-4277,'delete from transaction_total_check where cny = -4277 and jpy = -427700 and gbp = -2993.9 and eur = -474747 and  hkd = -3849.3','')")

    con:query("insert into check_sql values(-4276,'delete from transaction_total_check where cny = -4276 and jpy = -427600 and gbp = -2993.2 and eur = -474636 and  hkd = -3848.4','')")

    con:query("insert into check_sql values(-4275,'delete from transaction_total_check where cny = -4275 and jpy = -427500 and gbp = -2992.5 and eur = -474525 and  hkd = -3847.5','')")

    con:query("insert into check_sql values(-4274,'delete from transaction_total_check where cny = -4274 and jpy = -427400 and gbp = -2991.8 and eur = -474414 and  hkd = -3846.6','')")

    con:query("insert into check_sql values(-4273,'delete from transaction_total_check where cny = -4273 and jpy = -427300 and gbp = -2991.1 and eur = -474303 and  hkd = -3845.7','')")

    con:query("insert into check_sql values(-4272,'delete from transaction_total_check where cny = -4272 and jpy = -427200 and gbp = -2990.4 and eur = -474192 and  hkd = -3844.8','')")

    con:query("insert into check_sql values(-4271,'delete from transaction_total_check where cny = -4271 and jpy = -427100 and gbp = -2989.7 and eur = -474081 and  hkd = -3843.9','')")

    con:query("insert into check_sql values(-4270,'delete from transaction_total_check where cny = -4270 and jpy = -427000 and gbp = -2989.0 and eur = -473970 and  hkd = -3843.0','')")

    con:query("insert into check_sql values(-4269,'delete from transaction_total_check where cny = -4269 and jpy = -426900 and gbp = -2988.3 and eur = -473859 and  hkd = -3842.1','')")

    con:query("insert into check_sql values(-4268,'delete from transaction_total_check where cny = -4268 and jpy = -426800 and gbp = -2987.6 and eur = -473748 and  hkd = -3841.2','')")

    con:query("insert into check_sql values(-4267,'delete from transaction_total_check where cny = -4267 and jpy = -426700 and gbp = -2986.9 and eur = -473637 and  hkd = -3840.3','')")

    con:query("insert into check_sql values(-4266,'delete from transaction_total_check where cny = -4266 and jpy = -426600 and gbp = -2986.2 and eur = -473526 and  hkd = -3839.4','')")

    con:query("insert into check_sql values(-4265,'delete from transaction_total_check where cny = -4265 and jpy = -426500 and gbp = -2985.5 and eur = -473415 and  hkd = -3838.5','')")

    con:query("insert into check_sql values(-4264,'delete from transaction_total_check where cny = -4264 and jpy = -426400 and gbp = -2984.8 and eur = -473304 and  hkd = -3837.6','')")

    con:query("insert into check_sql values(-4263,'delete from transaction_total_check where cny = -4263 and jpy = -426300 and gbp = -2984.1 and eur = -473193 and  hkd = -3836.7','')")

    con:query("insert into check_sql values(-4262,'delete from transaction_total_check where cny = -4262 and jpy = -426200 and gbp = -2983.4 and eur = -473082 and  hkd = -3835.8','')")

    con:query("insert into check_sql values(-4261,'delete from transaction_total_check where cny = -4261 and jpy = -426100 and gbp = -2982.7 and eur = -472971 and  hkd = -3834.9','')")

    con:query("insert into check_sql values(-4260,'delete from transaction_total_check where cny = -4260 and jpy = -426000 and gbp = -2982.0 and eur = -472860 and  hkd = -3834.0','')")

    con:query("insert into check_sql values(-4259,'delete from transaction_total_check where cny = -4259 and jpy = -425900 and gbp = -2981.3 and eur = -472749 and  hkd = -3833.1','')")

    con:query("insert into check_sql values(-4258,'delete from transaction_total_check where cny = -4258 and jpy = -425800 and gbp = -2980.6 and eur = -472638 and  hkd = -3832.2','')")

    con:query("insert into check_sql values(-4257,'delete from transaction_total_check where cny = -4257 and jpy = -425700 and gbp = -2979.9 and eur = -472527 and  hkd = -3831.3','')")

    con:query("insert into check_sql values(-4256,'delete from transaction_total_check where cny = -4256 and jpy = -425600 and gbp = -2979.2 and eur = -472416 and  hkd = -3830.4','')")

    con:query("insert into check_sql values(-4255,'delete from transaction_total_check where cny = -4255 and jpy = -425500 and gbp = -2978.5 and eur = -472305 and  hkd = -3829.5','')")

    con:query("insert into check_sql values(-4254,'delete from transaction_total_check where cny = -4254 and jpy = -425400 and gbp = -2977.8 and eur = -472194 and  hkd = -3828.6','')")

    con:query("insert into check_sql values(-4253,'delete from transaction_total_check where cny = -4253 and jpy = -425300 and gbp = -2977.1 and eur = -472083 and  hkd = -3827.7','')")

    con:query("insert into check_sql values(-4252,'delete from transaction_total_check where cny = -4252 and jpy = -425200 and gbp = -2976.4 and eur = -471972 and  hkd = -3826.8','')")

    con:query("insert into check_sql values(-4251,'delete from transaction_total_check where cny = -4251 and jpy = -425100 and gbp = -2975.7 and eur = -471861 and  hkd = -3825.9','')")

    con:query("insert into check_sql values(-4250,'delete from transaction_total_check where cny = -4250 and jpy = -425000 and gbp = -2975.0 and eur = -471750 and  hkd = -3825.0','')")

    con:query("insert into check_sql values(-4249,'delete from transaction_total_check where cny = -4249 and jpy = -424900 and gbp = -2974.3 and eur = -471639 and  hkd = -3824.1','')")

    con:query("insert into check_sql values(-4248,'delete from transaction_total_check where cny = -4248 and jpy = -424800 and gbp = -2973.6 and eur = -471528 and  hkd = -3823.2','')")

    con:query("insert into check_sql values(-4247,'delete from transaction_total_check where cny = -4247 and jpy = -424700 and gbp = -2972.9 and eur = -471417 and  hkd = -3822.3','')")

    con:query("insert into check_sql values(-4246,'delete from transaction_total_check where cny = -4246 and jpy = -424600 and gbp = -2972.2 and eur = -471306 and  hkd = -3821.4','')")

    con:query("insert into check_sql values(-4245,'delete from transaction_total_check where cny = -4245 and jpy = -424500 and gbp = -2971.5 and eur = -471195 and  hkd = -3820.5','')")

    con:query("insert into check_sql values(-4244,'delete from transaction_total_check where cny = -4244 and jpy = -424400 and gbp = -2970.8 and eur = -471084 and  hkd = -3819.6','')")

    con:query("insert into check_sql values(-4243,'delete from transaction_total_check where cny = -4243 and jpy = -424300 and gbp = -2970.1 and eur = -470973 and  hkd = -3818.7','')")

    con:query("insert into check_sql values(-4242,'delete from transaction_total_check where cny = -4242 and jpy = -424200 and gbp = -2969.4 and eur = -470862 and  hkd = -3817.8','')")

    con:query("insert into check_sql values(-4241,'delete from transaction_total_check where cny = -4241 and jpy = -424100 and gbp = -2968.7 and eur = -470751 and  hkd = -3816.9','')")

    con:query("insert into check_sql values(-4240,'delete from transaction_total_check where cny = -4240 and jpy = -424000 and gbp = -2968.0 and eur = -470640 and  hkd = -3816.0','')")

    con:query("insert into check_sql values(-4239,'delete from transaction_total_check where cny = -4239 and jpy = -423900 and gbp = -2967.3 and eur = -470529 and  hkd = -3815.1','')")

    con:query("insert into check_sql values(-4238,'delete from transaction_total_check where cny = -4238 and jpy = -423800 and gbp = -2966.6 and eur = -470418 and  hkd = -3814.2','')")

    con:query("insert into check_sql values(-4237,'delete from transaction_total_check where cny = -4237 and jpy = -423700 and gbp = -2965.9 and eur = -470307 and  hkd = -3813.3','')")

    con:query("insert into check_sql values(-4236,'delete from transaction_total_check where cny = -4236 and jpy = -423600 and gbp = -2965.2 and eur = -470196 and  hkd = -3812.4','')")

    con:query("insert into check_sql values(-4235,'delete from transaction_total_check where cny = -4235 and jpy = -423500 and gbp = -2964.5 and eur = -470085 and  hkd = -3811.5','')")

    con:query("insert into check_sql values(-4234,'delete from transaction_total_check where cny = -4234 and jpy = -423400 and gbp = -2963.8 and eur = -469974 and  hkd = -3810.6','')")

    con:query("insert into check_sql values(-4233,'delete from transaction_total_check where cny = -4233 and jpy = -423300 and gbp = -2963.1 and eur = -469863 and  hkd = -3809.7','')")

    con:query("insert into check_sql values(-4232,'delete from transaction_total_check where cny = -4232 and jpy = -423200 and gbp = -2962.4 and eur = -469752 and  hkd = -3808.8','')")

    con:query("insert into check_sql values(-4231,'delete from transaction_total_check where cny = -4231 and jpy = -423100 and gbp = -2961.7 and eur = -469641 and  hkd = -3807.9','')")

    con:query("insert into check_sql values(-4230,'delete from transaction_total_check where cny = -4230 and jpy = -423000 and gbp = -2961.0 and eur = -469530 and  hkd = -3807.0','')")

    con:query("insert into check_sql values(-4229,'delete from transaction_total_check where cny = -4229 and jpy = -422900 and gbp = -2960.3 and eur = -469419 and  hkd = -3806.1','')")

    con:query("insert into check_sql values(-4228,'delete from transaction_total_check where cny = -4228 and jpy = -422800 and gbp = -2959.6 and eur = -469308 and  hkd = -3805.2','')")

    con:query("insert into check_sql values(-4227,'delete from transaction_total_check where cny = -4227 and jpy = -422700 and gbp = -2958.9 and eur = -469197 and  hkd = -3804.3','')")

    con:query("insert into check_sql values(-4226,'delete from transaction_total_check where cny = -4226 and jpy = -422600 and gbp = -2958.2 and eur = -469086 and  hkd = -3803.4','')")

    con:query("insert into check_sql values(-4225,'delete from transaction_total_check where cny = -4225 and jpy = -422500 and gbp = -2957.5 and eur = -468975 and  hkd = -3802.5','')")

    con:query("insert into check_sql values(-4224,'delete from transaction_total_check where cny = -4224 and jpy = -422400 and gbp = -2956.8 and eur = -468864 and  hkd = -3801.6','')")

    con:query("insert into check_sql values(-4223,'delete from transaction_total_check where cny = -4223 and jpy = -422300 and gbp = -2956.1 and eur = -468753 and  hkd = -3800.7','')")

    con:query("insert into check_sql values(-4222,'delete from transaction_total_check where cny = -4222 and jpy = -422200 and gbp = -2955.4 and eur = -468642 and  hkd = -3799.8','')")

    con:query("insert into check_sql values(-4221,'delete from transaction_total_check where cny = -4221 and jpy = -422100 and gbp = -2954.7 and eur = -468531 and  hkd = -3798.9','')")

    con:query("insert into check_sql values(-4220,'delete from transaction_total_check where cny = -4220 and jpy = -422000 and gbp = -2954.0 and eur = -468420 and  hkd = -3798.0','')")

    con:query("insert into check_sql values(-4219,'delete from transaction_total_check where cny = -4219 and jpy = -421900 and gbp = -2953.3 and eur = -468309 and  hkd = -3797.1','')")

    con:query("insert into check_sql values(-4218,'delete from transaction_total_check where cny = -4218 and jpy = -421800 and gbp = -2952.6 and eur = -468198 and  hkd = -3796.2','')")

    con:query("insert into check_sql values(-4217,'delete from transaction_total_check where cny = -4217 and jpy = -421700 and gbp = -2951.9 and eur = -468087 and  hkd = -3795.3','')")

    con:query("insert into check_sql values(-4216,'delete from transaction_total_check where cny = -4216 and jpy = -421600 and gbp = -2951.2 and eur = -467976 and  hkd = -3794.4','')")

    con:query("insert into check_sql values(-4215,'delete from transaction_total_check where cny = -4215 and jpy = -421500 and gbp = -2950.5 and eur = -467865 and  hkd = -3793.5','')")

    con:query("insert into check_sql values(-4214,'delete from transaction_total_check where cny = -4214 and jpy = -421400 and gbp = -2949.8 and eur = -467754 and  hkd = -3792.6','')")

    con:query("insert into check_sql values(-4213,'delete from transaction_total_check where cny = -4213 and jpy = -421300 and gbp = -2949.1 and eur = -467643 and  hkd = -3791.7','')")

    con:query("insert into check_sql values(-4212,'delete from transaction_total_check where cny = -4212 and jpy = -421200 and gbp = -2948.4 and eur = -467532 and  hkd = -3790.8','')")

    con:query("insert into check_sql values(-4211,'delete from transaction_total_check where cny = -4211 and jpy = -421100 and gbp = -2947.7 and eur = -467421 and  hkd = -3789.9','')")

    con:query("insert into check_sql values(-4210,'delete from transaction_total_check where cny = -4210 and jpy = -421000 and gbp = -2947.0 and eur = -467310 and  hkd = -3789.0','')")

    con:query("insert into check_sql values(-4209,'delete from transaction_total_check where cny = -4209 and jpy = -420900 and gbp = -2946.3 and eur = -467199 and  hkd = -3788.1','')")

    con:query("insert into check_sql values(-4208,'delete from transaction_total_check where cny = -4208 and jpy = -420800 and gbp = -2945.6 and eur = -467088 and  hkd = -3787.2','')")

    con:query("insert into check_sql values(-4207,'delete from transaction_total_check where cny = -4207 and jpy = -420700 and gbp = -2944.9 and eur = -466977 and  hkd = -3786.3','')")

    con:query("insert into check_sql values(-4206,'delete from transaction_total_check where cny = -4206 and jpy = -420600 and gbp = -2944.2 and eur = -466866 and  hkd = -3785.4','')")

    con:query("insert into check_sql values(-4205,'delete from transaction_total_check where cny = -4205 and jpy = -420500 and gbp = -2943.5 and eur = -466755 and  hkd = -3784.5','')")

    con:query("insert into check_sql values(-4204,'delete from transaction_total_check where cny = -4204 and jpy = -420400 and gbp = -2942.8 and eur = -466644 and  hkd = -3783.6','')")

    con:query("insert into check_sql values(-4203,'delete from transaction_total_check where cny = -4203 and jpy = -420300 and gbp = -2942.1 and eur = -466533 and  hkd = -3782.7','')")

    con:query("insert into check_sql values(-4202,'delete from transaction_total_check where cny = -4202 and jpy = -420200 and gbp = -2941.4 and eur = -466422 and  hkd = -3781.8','')")

    con:query("insert into check_sql values(-4201,'delete from transaction_total_check where cny = -4201 and jpy = -420100 and gbp = -2940.7 and eur = -466311 and  hkd = -3780.9','')")

    con:query("insert into check_sql values(-4200,'delete from transaction_total_check where cny = -4200 and jpy = -420000 and gbp = -2940.0 and eur = -466200 and  hkd = -3780.0','')")

    con:query("insert into check_sql values(-4199,'delete from transaction_total_check where cny = -4199 and jpy = -419900 and gbp = -2939.3 and eur = -466089 and  hkd = -3779.1','')")

    con:query("insert into check_sql values(-4198,'delete from transaction_total_check where cny = -4198 and jpy = -419800 and gbp = -2938.6 and eur = -465978 and  hkd = -3778.2','')")

    con:query("insert into check_sql values(-4197,'delete from transaction_total_check where cny = -4197 and jpy = -419700 and gbp = -2937.9 and eur = -465867 and  hkd = -3777.3','')")

    con:query("insert into check_sql values(-4196,'delete from transaction_total_check where cny = -4196 and jpy = -419600 and gbp = -2937.2 and eur = -465756 and  hkd = -3776.4','')")

    con:query("insert into check_sql values(-4195,'delete from transaction_total_check where cny = -4195 and jpy = -419500 and gbp = -2936.5 and eur = -465645 and  hkd = -3775.5','')")

    con:query("insert into check_sql values(-4194,'delete from transaction_total_check where cny = -4194 and jpy = -419400 and gbp = -2935.8 and eur = -465534 and  hkd = -3774.6','')")

    con:query("insert into check_sql values(-4193,'delete from transaction_total_check where cny = -4193 and jpy = -419300 and gbp = -2935.1 and eur = -465423 and  hkd = -3773.7','')")

    con:query("insert into check_sql values(-4192,'delete from transaction_total_check where cny = -4192 and jpy = -419200 and gbp = -2934.4 and eur = -465312 and  hkd = -3772.8','')")

    con:query("insert into check_sql values(-4191,'delete from transaction_total_check where cny = -4191 and jpy = -419100 and gbp = -2933.7 and eur = -465201 and  hkd = -3771.9','')")

    con:query("insert into check_sql values(-4190,'delete from transaction_total_check where cny = -4190 and jpy = -419000 and gbp = -2933.0 and eur = -465090 and  hkd = -3771.0','')")

    con:query("insert into check_sql values(-4189,'delete from transaction_total_check where cny = -4189 and jpy = -418900 and gbp = -2932.3 and eur = -464979 and  hkd = -3770.1','')")

    con:query("insert into check_sql values(-4188,'delete from transaction_total_check where cny = -4188 and jpy = -418800 and gbp = -2931.6 and eur = -464868 and  hkd = -3769.2','')")

    con:query("insert into check_sql values(-4187,'delete from transaction_total_check where cny = -4187 and jpy = -418700 and gbp = -2930.9 and eur = -464757 and  hkd = -3768.3','')")

    con:query("insert into check_sql values(-4186,'delete from transaction_total_check where cny = -4186 and jpy = -418600 and gbp = -2930.2 and eur = -464646 and  hkd = -3767.4','')")

    con:query("insert into check_sql values(-4185,'delete from transaction_total_check where cny = -4185 and jpy = -418500 and gbp = -2929.5 and eur = -464535 and  hkd = -3766.5','')")

    con:query("insert into check_sql values(-4184,'delete from transaction_total_check where cny = -4184 and jpy = -418400 and gbp = -2928.8 and eur = -464424 and  hkd = -3765.6','')")

    con:query("insert into check_sql values(-4183,'delete from transaction_total_check where cny = -4183 and jpy = -418300 and gbp = -2928.1 and eur = -464313 and  hkd = -3764.7','')")

    con:query("insert into check_sql values(-4182,'delete from transaction_total_check where cny = -4182 and jpy = -418200 and gbp = -2927.4 and eur = -464202 and  hkd = -3763.8','')")

    con:query("insert into check_sql values(-4181,'delete from transaction_total_check where cny = -4181 and jpy = -418100 and gbp = -2926.7 and eur = -464091 and  hkd = -3762.9','')")

    con:query("insert into check_sql values(-4180,'delete from transaction_total_check where cny = -4180 and jpy = -418000 and gbp = -2926.0 and eur = -463980 and  hkd = -3762.0','')")

    con:query("insert into check_sql values(-4179,'delete from transaction_total_check where cny = -4179 and jpy = -417900 and gbp = -2925.3 and eur = -463869 and  hkd = -3761.1','')")

    con:query("insert into check_sql values(-4178,'delete from transaction_total_check where cny = -4178 and jpy = -417800 and gbp = -2924.6 and eur = -463758 and  hkd = -3760.2','')")

    con:query("insert into check_sql values(-4177,'delete from transaction_total_check where cny = -4177 and jpy = -417700 and gbp = -2923.9 and eur = -463647 and  hkd = -3759.3','')")

    con:query("insert into check_sql values(-4176,'delete from transaction_total_check where cny = -4176 and jpy = -417600 and gbp = -2923.2 and eur = -463536 and  hkd = -3758.4','')")

    con:query("insert into check_sql values(-4175,'delete from transaction_total_check where cny = -4175 and jpy = -417500 and gbp = -2922.5 and eur = -463425 and  hkd = -3757.5','')")

    con:query("insert into check_sql values(-4174,'delete from transaction_total_check where cny = -4174 and jpy = -417400 and gbp = -2921.8 and eur = -463314 and  hkd = -3756.6','')")

    con:query("insert into check_sql values(-4173,'delete from transaction_total_check where cny = -4173 and jpy = -417300 and gbp = -2921.1 and eur = -463203 and  hkd = -3755.7','')")

    con:query("insert into check_sql values(-4172,'delete from transaction_total_check where cny = -4172 and jpy = -417200 and gbp = -2920.4 and eur = -463092 and  hkd = -3754.8','')")

    con:query("insert into check_sql values(-4171,'delete from transaction_total_check where cny = -4171 and jpy = -417100 and gbp = -2919.7 and eur = -462981 and  hkd = -3753.9','')")

    con:query("insert into check_sql values(-4170,'delete from transaction_total_check where cny = -4170 and jpy = -417000 and gbp = -2919.0 and eur = -462870 and  hkd = -3753.0','')")

    con:query("insert into check_sql values(-4169,'delete from transaction_total_check where cny = -4169 and jpy = -416900 and gbp = -2918.3 and eur = -462759 and  hkd = -3752.1','')")

    con:query("insert into check_sql values(-4168,'delete from transaction_total_check where cny = -4168 and jpy = -416800 and gbp = -2917.6 and eur = -462648 and  hkd = -3751.2','')")

    con:query("insert into check_sql values(-4167,'delete from transaction_total_check where cny = -4167 and jpy = -416700 and gbp = -2916.9 and eur = -462537 and  hkd = -3750.3','')")

    con:query("insert into check_sql values(-4166,'delete from transaction_total_check where cny = -4166 and jpy = -416600 and gbp = -2916.2 and eur = -462426 and  hkd = -3749.4','')")

    con:query("insert into check_sql values(-4165,'delete from transaction_total_check where cny = -4165 and jpy = -416500 and gbp = -2915.5 and eur = -462315 and  hkd = -3748.5','')")

    con:query("insert into check_sql values(-4164,'delete from transaction_total_check where cny = -4164 and jpy = -416400 and gbp = -2914.8 and eur = -462204 and  hkd = -3747.6','')")

    con:query("insert into check_sql values(-4163,'delete from transaction_total_check where cny = -4163 and jpy = -416300 and gbp = -2914.1 and eur = -462093 and  hkd = -3746.7','')")

    con:query("insert into check_sql values(-4162,'delete from transaction_total_check where cny = -4162 and jpy = -416200 and gbp = -2913.4 and eur = -461982 and  hkd = -3745.8','')")

    con:query("insert into check_sql values(-4161,'delete from transaction_total_check where cny = -4161 and jpy = -416100 and gbp = -2912.7 and eur = -461871 and  hkd = -3744.9','')")

    con:query("insert into check_sql values(-4160,'delete from transaction_total_check where cny = -4160 and jpy = -416000 and gbp = -2912.0 and eur = -461760 and  hkd = -3744.0','')")

    con:query("insert into check_sql values(-4159,'delete from transaction_total_check where cny = -4159 and jpy = -415900 and gbp = -2911.3 and eur = -461649 and  hkd = -3743.1','')")

    con:query("insert into check_sql values(-4158,'delete from transaction_total_check where cny = -4158 and jpy = -415800 and gbp = -2910.6 and eur = -461538 and  hkd = -3742.2','')")

    con:query("insert into check_sql values(-4157,'delete from transaction_total_check where cny = -4157 and jpy = -415700 and gbp = -2909.9 and eur = -461427 and  hkd = -3741.3','')")

    con:query("insert into check_sql values(-4156,'delete from transaction_total_check where cny = -4156 and jpy = -415600 and gbp = -2909.2 and eur = -461316 and  hkd = -3740.4','')")

    con:query("insert into check_sql values(-4155,'delete from transaction_total_check where cny = -4155 and jpy = -415500 and gbp = -2908.5 and eur = -461205 and  hkd = -3739.5','')")

    con:query("insert into check_sql values(-4154,'delete from transaction_total_check where cny = -4154 and jpy = -415400 and gbp = -2907.8 and eur = -461094 and  hkd = -3738.6','')")

    con:query("insert into check_sql values(-4153,'delete from transaction_total_check where cny = -4153 and jpy = -415300 and gbp = -2907.1 and eur = -460983 and  hkd = -3737.7','')")

    con:query("insert into check_sql values(-4152,'delete from transaction_total_check where cny = -4152 and jpy = -415200 and gbp = -2906.4 and eur = -460872 and  hkd = -3736.8','')")

    con:query("insert into check_sql values(-4151,'delete from transaction_total_check where cny = -4151 and jpy = -415100 and gbp = -2905.7 and eur = -460761 and  hkd = -3735.9','')")

    con:query("insert into check_sql values(-4150,'delete from transaction_total_check where cny = -4150 and jpy = -415000 and gbp = -2905.0 and eur = -460650 and  hkd = -3735.0','')")

    con:query("insert into check_sql values(-4149,'delete from transaction_total_check where cny = -4149 and jpy = -414900 and gbp = -2904.3 and eur = -460539 and  hkd = -3734.1','')")

    con:query("insert into check_sql values(-4148,'delete from transaction_total_check where cny = -4148 and jpy = -414800 and gbp = -2903.6 and eur = -460428 and  hkd = -3733.2','')")

    con:query("insert into check_sql values(-4147,'delete from transaction_total_check where cny = -4147 and jpy = -414700 and gbp = -2902.9 and eur = -460317 and  hkd = -3732.3','')")

    con:query("insert into check_sql values(-4146,'delete from transaction_total_check where cny = -4146 and jpy = -414600 and gbp = -2902.2 and eur = -460206 and  hkd = -3731.4','')")

    con:query("insert into check_sql values(-4145,'delete from transaction_total_check where cny = -4145 and jpy = -414500 and gbp = -2901.5 and eur = -460095 and  hkd = -3730.5','')")

    con:query("insert into check_sql values(-4144,'delete from transaction_total_check where cny = -4144 and jpy = -414400 and gbp = -2900.8 and eur = -459984 and  hkd = -3729.6','')")

    con:query("insert into check_sql values(-4143,'delete from transaction_total_check where cny = -4143 and jpy = -414300 and gbp = -2900.1 and eur = -459873 and  hkd = -3728.7','')")

    con:query("insert into check_sql values(-4142,'delete from transaction_total_check where cny = -4142 and jpy = -414200 and gbp = -2899.4 and eur = -459762 and  hkd = -3727.8','')")

    con:query("insert into check_sql values(-4141,'delete from transaction_total_check where cny = -4141 and jpy = -414100 and gbp = -2898.7 and eur = -459651 and  hkd = -3726.9','')")

    con:query("insert into check_sql values(-4140,'delete from transaction_total_check where cny = -4140 and jpy = -414000 and gbp = -2898.0 and eur = -459540 and  hkd = -3726.0','')")

    con:query("insert into check_sql values(-4139,'delete from transaction_total_check where cny = -4139 and jpy = -413900 and gbp = -2897.3 and eur = -459429 and  hkd = -3725.1','')")

    con:query("insert into check_sql values(-4138,'delete from transaction_total_check where cny = -4138 and jpy = -413800 and gbp = -2896.6 and eur = -459318 and  hkd = -3724.2','')")

    con:query("insert into check_sql values(-4137,'delete from transaction_total_check where cny = -4137 and jpy = -413700 and gbp = -2895.9 and eur = -459207 and  hkd = -3723.3','')")

    con:query("insert into check_sql values(-4136,'delete from transaction_total_check where cny = -4136 and jpy = -413600 and gbp = -2895.2 and eur = -459096 and  hkd = -3722.4','')")

    con:query("insert into check_sql values(-4135,'delete from transaction_total_check where cny = -4135 and jpy = -413500 and gbp = -2894.5 and eur = -458985 and  hkd = -3721.5','')")

    con:query("insert into check_sql values(-4134,'delete from transaction_total_check where cny = -4134 and jpy = -413400 and gbp = -2893.8 and eur = -458874 and  hkd = -3720.6','')")

    con:query("insert into check_sql values(-4133,'delete from transaction_total_check where cny = -4133 and jpy = -413300 and gbp = -2893.1 and eur = -458763 and  hkd = -3719.7','')")

    con:query("insert into check_sql values(-4132,'delete from transaction_total_check where cny = -4132 and jpy = -413200 and gbp = -2892.4 and eur = -458652 and  hkd = -3718.8','')")

    con:query("insert into check_sql values(-4131,'delete from transaction_total_check where cny = -4131 and jpy = -413100 and gbp = -2891.7 and eur = -458541 and  hkd = -3717.9','')")

    con:query("insert into check_sql values(-4130,'delete from transaction_total_check where cny = -4130 and jpy = -413000 and gbp = -2891.0 and eur = -458430 and  hkd = -3717.0','')")

    con:query("insert into check_sql values(-4129,'delete from transaction_total_check where cny = -4129 and jpy = -412900 and gbp = -2890.3 and eur = -458319 and  hkd = -3716.1','')")

    con:query("insert into check_sql values(-4128,'delete from transaction_total_check where cny = -4128 and jpy = -412800 and gbp = -2889.6 and eur = -458208 and  hkd = -3715.2','')")

    con:query("insert into check_sql values(-4127,'delete from transaction_total_check where cny = -4127 and jpy = -412700 and gbp = -2888.9 and eur = -458097 and  hkd = -3714.3','')")

    con:query("insert into check_sql values(-4126,'delete from transaction_total_check where cny = -4126 and jpy = -412600 and gbp = -2888.2 and eur = -457986 and  hkd = -3713.4','')")

    con:query("insert into check_sql values(-4125,'delete from transaction_total_check where cny = -4125 and jpy = -412500 and gbp = -2887.5 and eur = -457875 and  hkd = -3712.5','')")

    con:query("insert into check_sql values(-4124,'delete from transaction_total_check where cny = -4124 and jpy = -412400 and gbp = -2886.8 and eur = -457764 and  hkd = -3711.6','')")

    con:query("insert into check_sql values(-4123,'delete from transaction_total_check where cny = -4123 and jpy = -412300 and gbp = -2886.1 and eur = -457653 and  hkd = -3710.7','')")

    con:query("insert into check_sql values(-4122,'delete from transaction_total_check where cny = -4122 and jpy = -412200 and gbp = -2885.4 and eur = -457542 and  hkd = -3709.8','')")

    con:query("insert into check_sql values(-4121,'delete from transaction_total_check where cny = -4121 and jpy = -412100 and gbp = -2884.7 and eur = -457431 and  hkd = -3708.9','')")

    con:query("insert into check_sql values(-4120,'delete from transaction_total_check where cny = -4120 and jpy = -412000 and gbp = -2884.0 and eur = -457320 and  hkd = -3708.0','')")

    con:query("insert into check_sql values(-4119,'delete from transaction_total_check where cny = -4119 and jpy = -411900 and gbp = -2883.3 and eur = -457209 and  hkd = -3707.1','')")

    con:query("insert into check_sql values(-4118,'delete from transaction_total_check where cny = -4118 and jpy = -411800 and gbp = -2882.6 and eur = -457098 and  hkd = -3706.2','')")

    con:query("insert into check_sql values(-4117,'delete from transaction_total_check where cny = -4117 and jpy = -411700 and gbp = -2881.9 and eur = -456987 and  hkd = -3705.3','')")

    con:query("insert into check_sql values(-4116,'delete from transaction_total_check where cny = -4116 and jpy = -411600 and gbp = -2881.2 and eur = -456876 and  hkd = -3704.4','')")

    con:query("insert into check_sql values(-4115,'delete from transaction_total_check where cny = -4115 and jpy = -411500 and gbp = -2880.5 and eur = -456765 and  hkd = -3703.5','')")

    con:query("insert into check_sql values(-4114,'delete from transaction_total_check where cny = -4114 and jpy = -411400 and gbp = -2879.8 and eur = -456654 and  hkd = -3702.6','')")

    con:query("insert into check_sql values(-4113,'delete from transaction_total_check where cny = -4113 and jpy = -411300 and gbp = -2879.1 and eur = -456543 and  hkd = -3701.7','')")

    con:query("insert into check_sql values(-4112,'delete from transaction_total_check where cny = -4112 and jpy = -411200 and gbp = -2878.4 and eur = -456432 and  hkd = -3700.8','')")

    con:query("insert into check_sql values(-4111,'delete from transaction_total_check where cny = -4111 and jpy = -411100 and gbp = -2877.7 and eur = -456321 and  hkd = -3699.9','')")

    con:query("insert into check_sql values(-4110,'delete from transaction_total_check where cny = -4110 and jpy = -411000 and gbp = -2877.0 and eur = -456210 and  hkd = -3699.0','')")

    con:query("insert into check_sql values(-4109,'delete from transaction_total_check where cny = -4109 and jpy = -410900 and gbp = -2876.3 and eur = -456099 and  hkd = -3698.1','')")

    con:query("insert into check_sql values(-4108,'delete from transaction_total_check where cny = -4108 and jpy = -410800 and gbp = -2875.6 and eur = -455988 and  hkd = -3697.2','')")

    con:query("insert into check_sql values(-4107,'delete from transaction_total_check where cny = -4107 and jpy = -410700 and gbp = -2874.9 and eur = -455877 and  hkd = -3696.3','')")

    con:query("insert into check_sql values(-4106,'delete from transaction_total_check where cny = -4106 and jpy = -410600 and gbp = -2874.2 and eur = -455766 and  hkd = -3695.4','')")

    con:query("insert into check_sql values(-4105,'delete from transaction_total_check where cny = -4105 and jpy = -410500 and gbp = -2873.5 and eur = -455655 and  hkd = -3694.5','')")

    con:query("insert into check_sql values(-4104,'delete from transaction_total_check where cny = -4104 and jpy = -410400 and gbp = -2872.8 and eur = -455544 and  hkd = -3693.6','')")

    con:query("insert into check_sql values(-4103,'delete from transaction_total_check where cny = -4103 and jpy = -410300 and gbp = -2872.1 and eur = -455433 and  hkd = -3692.7','')")

    con:query("insert into check_sql values(-4102,'delete from transaction_total_check where cny = -4102 and jpy = -410200 and gbp = -2871.4 and eur = -455322 and  hkd = -3691.8','')")

    con:query("insert into check_sql values(-4101,'delete from transaction_total_check where cny = -4101 and jpy = -410100 and gbp = -2870.7 and eur = -455211 and  hkd = -3690.9','')")

    con:query("insert into check_sql values(-4100,'delete from transaction_total_check where cny = -4100 and jpy = -410000 and gbp = -2870.0 and eur = -455100 and  hkd = -3690.0','')")

    con:query("insert into check_sql values(-4099,'delete from transaction_total_check where cny = -4099 and jpy = -409900 and gbp = -2869.3 and eur = -454989 and  hkd = -3689.1','')")

    con:query("insert into check_sql values(-4098,'delete from transaction_total_check where cny = -4098 and jpy = -409800 and gbp = -2868.6 and eur = -454878 and  hkd = -3688.2','')")

    con:query("insert into check_sql values(-4097,'delete from transaction_total_check where cny = -4097 and jpy = -409700 and gbp = -2867.9 and eur = -454767 and  hkd = -3687.3','')")

    con:query("insert into check_sql values(-4096,'delete from transaction_total_check where cny = -4096 and jpy = -409600 and gbp = -2867.2 and eur = -454656 and  hkd = -3686.4','')")

    con:query("insert into check_sql values(-4095,'delete from transaction_total_check where cny = -4095 and jpy = -409500 and gbp = -2866.5 and eur = -454545 and  hkd = -3685.5','')")

    con:query("insert into check_sql values(-4094,'delete from transaction_total_check where cny = -4094 and jpy = -409400 and gbp = -2865.8 and eur = -454434 and  hkd = -3684.6','')")

    con:query("insert into check_sql values(-4093,'delete from transaction_total_check where cny = -4093 and jpy = -409300 and gbp = -2865.1 and eur = -454323 and  hkd = -3683.7','')")

    con:query("insert into check_sql values(-4092,'delete from transaction_total_check where cny = -4092 and jpy = -409200 and gbp = -2864.4 and eur = -454212 and  hkd = -3682.8','')")

    con:query("insert into check_sql values(-4091,'delete from transaction_total_check where cny = -4091 and jpy = -409100 and gbp = -2863.7 and eur = -454101 and  hkd = -3681.9','')")

    con:query("insert into check_sql values(-4090,'delete from transaction_total_check where cny = -4090 and jpy = -409000 and gbp = -2863.0 and eur = -453990 and  hkd = -3681.0','')")

    con:query("insert into check_sql values(-4089,'delete from transaction_total_check where cny = -4089 and jpy = -408900 and gbp = -2862.3 and eur = -453879 and  hkd = -3680.1','')")

    con:query("insert into check_sql values(-4088,'delete from transaction_total_check where cny = -4088 and jpy = -408800 and gbp = -2861.6 and eur = -453768 and  hkd = -3679.2','')")

    con:query("insert into check_sql values(-4087,'delete from transaction_total_check where cny = -4087 and jpy = -408700 and gbp = -2860.9 and eur = -453657 and  hkd = -3678.3','')")

    con:query("insert into check_sql values(-4086,'delete from transaction_total_check where cny = -4086 and jpy = -408600 and gbp = -2860.2 and eur = -453546 and  hkd = -3677.4','')")

    con:query("insert into check_sql values(-4085,'delete from transaction_total_check where cny = -4085 and jpy = -408500 and gbp = -2859.5 and eur = -453435 and  hkd = -3676.5','')")

    con:query("insert into check_sql values(-4084,'delete from transaction_total_check where cny = -4084 and jpy = -408400 and gbp = -2858.8 and eur = -453324 and  hkd = -3675.6','')")

    con:query("insert into check_sql values(-4083,'delete from transaction_total_check where cny = -4083 and jpy = -408300 and gbp = -2858.1 and eur = -453213 and  hkd = -3674.7','')")

    con:query("insert into check_sql values(-4082,'delete from transaction_total_check where cny = -4082 and jpy = -408200 and gbp = -2857.4 and eur = -453102 and  hkd = -3673.8','')")

    con:query("insert into check_sql values(-4081,'delete from transaction_total_check where cny = -4081 and jpy = -408100 and gbp = -2856.7 and eur = -452991 and  hkd = -3672.9','')")

    con:query("insert into check_sql values(-4080,'delete from transaction_total_check where cny = -4080 and jpy = -408000 and gbp = -2856.0 and eur = -452880 and  hkd = -3672.0','')")

    con:query("insert into check_sql values(-4079,'delete from transaction_total_check where cny = -4079 and jpy = -407900 and gbp = -2855.3 and eur = -452769 and  hkd = -3671.1','')")

    con:query("insert into check_sql values(-4078,'delete from transaction_total_check where cny = -4078 and jpy = -407800 and gbp = -2854.6 and eur = -452658 and  hkd = -3670.2','')")

    con:query("insert into check_sql values(-4077,'delete from transaction_total_check where cny = -4077 and jpy = -407700 and gbp = -2853.9 and eur = -452547 and  hkd = -3669.3','')")

    con:query("insert into check_sql values(-4076,'delete from transaction_total_check where cny = -4076 and jpy = -407600 and gbp = -2853.2 and eur = -452436 and  hkd = -3668.4','')")

    con:query("insert into check_sql values(-4075,'delete from transaction_total_check where cny = -4075 and jpy = -407500 and gbp = -2852.5 and eur = -452325 and  hkd = -3667.5','')")

    con:query("insert into check_sql values(-4074,'delete from transaction_total_check where cny = -4074 and jpy = -407400 and gbp = -2851.8 and eur = -452214 and  hkd = -3666.6','')")

    con:query("insert into check_sql values(-4073,'delete from transaction_total_check where cny = -4073 and jpy = -407300 and gbp = -2851.1 and eur = -452103 and  hkd = -3665.7','')")

    con:query("insert into check_sql values(-4072,'delete from transaction_total_check where cny = -4072 and jpy = -407200 and gbp = -2850.4 and eur = -451992 and  hkd = -3664.8','')")

    con:query("insert into check_sql values(-4071,'delete from transaction_total_check where cny = -4071 and jpy = -407100 and gbp = -2849.7 and eur = -451881 and  hkd = -3663.9','')")

    con:query("insert into check_sql values(-4070,'delete from transaction_total_check where cny = -4070 and jpy = -407000 and gbp = -2849.0 and eur = -451770 and  hkd = -3663.0','')")

    con:query("insert into check_sql values(-4069,'delete from transaction_total_check where cny = -4069 and jpy = -406900 and gbp = -2848.3 and eur = -451659 and  hkd = -3662.1','')")

    con:query("insert into check_sql values(-4068,'delete from transaction_total_check where cny = -4068 and jpy = -406800 and gbp = -2847.6 and eur = -451548 and  hkd = -3661.2','')")

    con:query("insert into check_sql values(-4067,'delete from transaction_total_check where cny = -4067 and jpy = -406700 and gbp = -2846.9 and eur = -451437 and  hkd = -3660.3','')")

    con:query("insert into check_sql values(-4066,'delete from transaction_total_check where cny = -4066 and jpy = -406600 and gbp = -2846.2 and eur = -451326 and  hkd = -3659.4','')")

    con:query("insert into check_sql values(-4065,'delete from transaction_total_check where cny = -4065 and jpy = -406500 and gbp = -2845.5 and eur = -451215 and  hkd = -3658.5','')")

    con:query("insert into check_sql values(-4064,'delete from transaction_total_check where cny = -4064 and jpy = -406400 and gbp = -2844.8 and eur = -451104 and  hkd = -3657.6','')")

    con:query("insert into check_sql values(-4063,'delete from transaction_total_check where cny = -4063 and jpy = -406300 and gbp = -2844.1 and eur = -450993 and  hkd = -3656.7','')")

    con:query("insert into check_sql values(-4062,'delete from transaction_total_check where cny = -4062 and jpy = -406200 and gbp = -2843.4 and eur = -450882 and  hkd = -3655.8','')")

    con:query("insert into check_sql values(-4061,'delete from transaction_total_check where cny = -4061 and jpy = -406100 and gbp = -2842.7 and eur = -450771 and  hkd = -3654.9','')")

    con:query("insert into check_sql values(-4060,'delete from transaction_total_check where cny = -4060 and jpy = -406000 and gbp = -2842.0 and eur = -450660 and  hkd = -3654.0','')")

    con:query("insert into check_sql values(-4059,'delete from transaction_total_check where cny = -4059 and jpy = -405900 and gbp = -2841.3 and eur = -450549 and  hkd = -3653.1','')")

    con:query("insert into check_sql values(-4058,'delete from transaction_total_check where cny = -4058 and jpy = -405800 and gbp = -2840.6 and eur = -450438 and  hkd = -3652.2','')")

    con:query("insert into check_sql values(-4057,'delete from transaction_total_check where cny = -4057 and jpy = -405700 and gbp = -2839.9 and eur = -450327 and  hkd = -3651.3','')")

    con:query("insert into check_sql values(-4056,'delete from transaction_total_check where cny = -4056 and jpy = -405600 and gbp = -2839.2 and eur = -450216 and  hkd = -3650.4','')")

    con:query("insert into check_sql values(-4055,'delete from transaction_total_check where cny = -4055 and jpy = -405500 and gbp = -2838.5 and eur = -450105 and  hkd = -3649.5','')")

    con:query("insert into check_sql values(-4054,'delete from transaction_total_check where cny = -4054 and jpy = -405400 and gbp = -2837.8 and eur = -449994 and  hkd = -3648.6','')")

    con:query("insert into check_sql values(-4053,'delete from transaction_total_check where cny = -4053 and jpy = -405300 and gbp = -2837.1 and eur = -449883 and  hkd = -3647.7','')")

    con:query("insert into check_sql values(-4052,'delete from transaction_total_check where cny = -4052 and jpy = -405200 and gbp = -2836.4 and eur = -449772 and  hkd = -3646.8','')")

    con:query("insert into check_sql values(-4051,'delete from transaction_total_check where cny = -4051 and jpy = -405100 and gbp = -2835.7 and eur = -449661 and  hkd = -3645.9','')")

    con:query("insert into check_sql values(-4050,'delete from transaction_total_check where cny = -4050 and jpy = -405000 and gbp = -2835.0 and eur = -449550 and  hkd = -3645.0','')")

    con:query("insert into check_sql values(-4049,'delete from transaction_total_check where cny = -4049 and jpy = -404900 and gbp = -2834.3 and eur = -449439 and  hkd = -3644.1','')")

    con:query("insert into check_sql values(-4048,'delete from transaction_total_check where cny = -4048 and jpy = -404800 and gbp = -2833.6 and eur = -449328 and  hkd = -3643.2','')")

    con:query("insert into check_sql values(-4047,'delete from transaction_total_check where cny = -4047 and jpy = -404700 and gbp = -2832.9 and eur = -449217 and  hkd = -3642.3','')")

    con:query("insert into check_sql values(-4046,'delete from transaction_total_check where cny = -4046 and jpy = -404600 and gbp = -2832.2 and eur = -449106 and  hkd = -3641.4','')")

    con:query("insert into check_sql values(-4045,'delete from transaction_total_check where cny = -4045 and jpy = -404500 and gbp = -2831.5 and eur = -448995 and  hkd = -3640.5','')")

    con:query("insert into check_sql values(-4044,'delete from transaction_total_check where cny = -4044 and jpy = -404400 and gbp = -2830.8 and eur = -448884 and  hkd = -3639.6','')")

    con:query("insert into check_sql values(-4043,'delete from transaction_total_check where cny = -4043 and jpy = -404300 and gbp = -2830.1 and eur = -448773 and  hkd = -3638.7','')")

    con:query("insert into check_sql values(-4042,'delete from transaction_total_check where cny = -4042 and jpy = -404200 and gbp = -2829.4 and eur = -448662 and  hkd = -3637.8','')")

    con:query("insert into check_sql values(-4041,'delete from transaction_total_check where cny = -4041 and jpy = -404100 and gbp = -2828.7 and eur = -448551 and  hkd = -3636.9','')")

    con:query("insert into check_sql values(-4040,'delete from transaction_total_check where cny = -4040 and jpy = -404000 and gbp = -2828.0 and eur = -448440 and  hkd = -3636.0','')")

    con:query("insert into check_sql values(-4039,'delete from transaction_total_check where cny = -4039 and jpy = -403900 and gbp = -2827.3 and eur = -448329 and  hkd = -3635.1','')")

    con:query("insert into check_sql values(-4038,'delete from transaction_total_check where cny = -4038 and jpy = -403800 and gbp = -2826.6 and eur = -448218 and  hkd = -3634.2','')")

    con:query("insert into check_sql values(-4037,'delete from transaction_total_check where cny = -4037 and jpy = -403700 and gbp = -2825.9 and eur = -448107 and  hkd = -3633.3','')")

    con:query("insert into check_sql values(-4036,'delete from transaction_total_check where cny = -4036 and jpy = -403600 and gbp = -2825.2 and eur = -447996 and  hkd = -3632.4','')")

    con:query("insert into check_sql values(-4035,'delete from transaction_total_check where cny = -4035 and jpy = -403500 and gbp = -2824.5 and eur = -447885 and  hkd = -3631.5','')")

    con:query("insert into check_sql values(-4034,'delete from transaction_total_check where cny = -4034 and jpy = -403400 and gbp = -2823.8 and eur = -447774 and  hkd = -3630.6','')")

    con:query("insert into check_sql values(-4033,'delete from transaction_total_check where cny = -4033 and jpy = -403300 and gbp = -2823.1 and eur = -447663 and  hkd = -3629.7','')")

    con:query("insert into check_sql values(-4032,'delete from transaction_total_check where cny = -4032 and jpy = -403200 and gbp = -2822.4 and eur = -447552 and  hkd = -3628.8','')")

    con:query("insert into check_sql values(-4031,'delete from transaction_total_check where cny = -4031 and jpy = -403100 and gbp = -2821.7 and eur = -447441 and  hkd = -3627.9','')")

    con:query("insert into check_sql values(-4030,'delete from transaction_total_check where cny = -4030 and jpy = -403000 and gbp = -2821.0 and eur = -447330 and  hkd = -3627.0','')")

    con:query("insert into check_sql values(-4029,'delete from transaction_total_check where cny = -4029 and jpy = -402900 and gbp = -2820.3 and eur = -447219 and  hkd = -3626.1','')")

    con:query("insert into check_sql values(-4028,'delete from transaction_total_check where cny = -4028 and jpy = -402800 and gbp = -2819.6 and eur = -447108 and  hkd = -3625.2','')")

    con:query("insert into check_sql values(-4027,'delete from transaction_total_check where cny = -4027 and jpy = -402700 and gbp = -2818.9 and eur = -446997 and  hkd = -3624.3','')")

    con:query("insert into check_sql values(-4026,'delete from transaction_total_check where cny = -4026 and jpy = -402600 and gbp = -2818.2 and eur = -446886 and  hkd = -3623.4','')")

    con:query("insert into check_sql values(-4025,'delete from transaction_total_check where cny = -4025 and jpy = -402500 and gbp = -2817.5 and eur = -446775 and  hkd = -3622.5','')")

    con:query("insert into check_sql values(-4024,'delete from transaction_total_check where cny = -4024 and jpy = -402400 and gbp = -2816.8 and eur = -446664 and  hkd = -3621.6','')")

    con:query("insert into check_sql values(-4023,'delete from transaction_total_check where cny = -4023 and jpy = -402300 and gbp = -2816.1 and eur = -446553 and  hkd = -3620.7','')")

    con:query("insert into check_sql values(-4022,'delete from transaction_total_check where cny = -4022 and jpy = -402200 and gbp = -2815.4 and eur = -446442 and  hkd = -3619.8','')")

    con:query("insert into check_sql values(-4021,'delete from transaction_total_check where cny = -4021 and jpy = -402100 and gbp = -2814.7 and eur = -446331 and  hkd = -3618.9','')")

    con:query("insert into check_sql values(-4020,'delete from transaction_total_check where cny = -4020 and jpy = -402000 and gbp = -2814.0 and eur = -446220 and  hkd = -3618.0','')")

    con:query("insert into check_sql values(-4019,'delete from transaction_total_check where cny = -4019 and jpy = -401900 and gbp = -2813.3 and eur = -446109 and  hkd = -3617.1','')")

    con:query("insert into check_sql values(-4018,'delete from transaction_total_check where cny = -4018 and jpy = -401800 and gbp = -2812.6 and eur = -445998 and  hkd = -3616.2','')")

    con:query("insert into check_sql values(-4017,'delete from transaction_total_check where cny = -4017 and jpy = -401700 and gbp = -2811.9 and eur = -445887 and  hkd = -3615.3','')")

    con:query("insert into check_sql values(-4016,'delete from transaction_total_check where cny = -4016 and jpy = -401600 and gbp = -2811.2 and eur = -445776 and  hkd = -3614.4','')")

    con:query("insert into check_sql values(-4015,'delete from transaction_total_check where cny = -4015 and jpy = -401500 and gbp = -2810.5 and eur = -445665 and  hkd = -3613.5','')")

    con:query("insert into check_sql values(-4014,'delete from transaction_total_check where cny = -4014 and jpy = -401400 and gbp = -2809.8 and eur = -445554 and  hkd = -3612.6','')")

    con:query("insert into check_sql values(-4013,'delete from transaction_total_check where cny = -4013 and jpy = -401300 and gbp = -2809.1 and eur = -445443 and  hkd = -3611.7','')")

    con:query("insert into check_sql values(-4012,'delete from transaction_total_check where cny = -4012 and jpy = -401200 and gbp = -2808.4 and eur = -445332 and  hkd = -3610.8','')")

    con:query("insert into check_sql values(-4011,'delete from transaction_total_check where cny = -4011 and jpy = -401100 and gbp = -2807.7 and eur = -445221 and  hkd = -3609.9','')")

    con:query("insert into check_sql values(-4010,'delete from transaction_total_check where cny = -4010 and jpy = -401000 and gbp = -2807.0 and eur = -445110 and  hkd = -3609.0','')")

    con:query("insert into check_sql values(-4009,'delete from transaction_total_check where cny = -4009 and jpy = -400900 and gbp = -2806.3 and eur = -444999 and  hkd = -3608.1','')")

    con:query("insert into check_sql values(-4008,'delete from transaction_total_check where cny = -4008 and jpy = -400800 and gbp = -2805.6 and eur = -444888 and  hkd = -3607.2','')")

    con:query("insert into check_sql values(-4007,'delete from transaction_total_check where cny = -4007 and jpy = -400700 and gbp = -2804.9 and eur = -444777 and  hkd = -3606.3','')")

    con:query("insert into check_sql values(-4006,'delete from transaction_total_check where cny = -4006 and jpy = -400600 and gbp = -2804.2 and eur = -444666 and  hkd = -3605.4','')")

    con:query("insert into check_sql values(-4005,'delete from transaction_total_check where cny = -4005 and jpy = -400500 and gbp = -2803.5 and eur = -444555 and  hkd = -3604.5','')")

    con:query("insert into check_sql values(-4004,'delete from transaction_total_check where cny = -4004 and jpy = -400400 and gbp = -2802.8 and eur = -444444 and  hkd = -3603.6','')")

    con:query("insert into check_sql values(-4003,'delete from transaction_total_check where cny = -4003 and jpy = -400300 and gbp = -2802.1 and eur = -444333 and  hkd = -3602.7','')")

    con:query("insert into check_sql values(-4002,'delete from transaction_total_check where cny = -4002 and jpy = -400200 and gbp = -2801.4 and eur = -444222 and  hkd = -3601.8','')")

    con:query("insert into check_sql values(-4001,'delete from transaction_total_check where cny = -4001 and jpy = -400100 and gbp = -2800.7 and eur = -444111 and  hkd = -3600.9','')")

    con:query("insert into check_sql values(-4000,'delete from transaction_total_check where cny = -4000 and jpy = -400000 and gbp = -2800.0 and eur = -444000 and  hkd = -3600.0','')")

    con:query("insert into check_sql values(-3999,'delete from transaction_total_check where cny = -3999 and jpy = -399900 and gbp = -2799.3 and eur = -443889 and  hkd = -3599.1','')")

    con:query("insert into check_sql values(-3998,'delete from transaction_total_check where cny = -3998 and jpy = -399800 and gbp = -2798.6 and eur = -443778 and  hkd = -3598.2','')")

    con:query("insert into check_sql values(-3997,'delete from transaction_total_check where cny = -3997 and jpy = -399700 and gbp = -2797.9 and eur = -443667 and  hkd = -3597.3','')")

    con:query("insert into check_sql values(-3996,'delete from transaction_total_check where cny = -3996 and jpy = -399600 and gbp = -2797.2 and eur = -443556 and  hkd = -3596.4','')")

    con:query("insert into check_sql values(-3995,'delete from transaction_total_check where cny = -3995 and jpy = -399500 and gbp = -2796.5 and eur = -443445 and  hkd = -3595.5','')")

    con:query("insert into check_sql values(-3994,'delete from transaction_total_check where cny = -3994 and jpy = -399400 and gbp = -2795.8 and eur = -443334 and  hkd = -3594.6','')")

    con:query("insert into check_sql values(-3993,'delete from transaction_total_check where cny = -3993 and jpy = -399300 and gbp = -2795.1 and eur = -443223 and  hkd = -3593.7','')")

    con:query("insert into check_sql values(-3992,'delete from transaction_total_check where cny = -3992 and jpy = -399200 and gbp = -2794.4 and eur = -443112 and  hkd = -3592.8','')")

    con:query("insert into check_sql values(-3991,'delete from transaction_total_check where cny = -3991 and jpy = -399100 and gbp = -2793.7 and eur = -443001 and  hkd = -3591.9','')")

    con:query("insert into check_sql values(-3990,'delete from transaction_total_check where cny = -3990 and jpy = -399000 and gbp = -2793.0 and eur = -442890 and  hkd = -3591.0','')")

    con:query("insert into check_sql values(-3989,'delete from transaction_total_check where cny = -3989 and jpy = -398900 and gbp = -2792.3 and eur = -442779 and  hkd = -3590.1','')")

    con:query("insert into check_sql values(-3988,'delete from transaction_total_check where cny = -3988 and jpy = -398800 and gbp = -2791.6 and eur = -442668 and  hkd = -3589.2','')")

    con:query("insert into check_sql values(-3987,'delete from transaction_total_check where cny = -3987 and jpy = -398700 and gbp = -2790.9 and eur = -442557 and  hkd = -3588.3','')")

    con:query("insert into check_sql values(-3986,'delete from transaction_total_check where cny = -3986 and jpy = -398600 and gbp = -2790.2 and eur = -442446 and  hkd = -3587.4','')")

    con:query("insert into check_sql values(-3985,'delete from transaction_total_check where cny = -3985 and jpy = -398500 and gbp = -2789.5 and eur = -442335 and  hkd = -3586.5','')")

    con:query("insert into check_sql values(-3984,'delete from transaction_total_check where cny = -3984 and jpy = -398400 and gbp = -2788.8 and eur = -442224 and  hkd = -3585.6','')")

    con:query("insert into check_sql values(-3983,'delete from transaction_total_check where cny = -3983 and jpy = -398300 and gbp = -2788.1 and eur = -442113 and  hkd = -3584.7','')")

    con:query("insert into check_sql values(-3982,'delete from transaction_total_check where cny = -3982 and jpy = -398200 and gbp = -2787.4 and eur = -442002 and  hkd = -3583.8','')")

    con:query("insert into check_sql values(-3981,'delete from transaction_total_check where cny = -3981 and jpy = -398100 and gbp = -2786.7 and eur = -441891 and  hkd = -3582.9','')")

    con:query("insert into check_sql values(-3980,'delete from transaction_total_check where cny = -3980 and jpy = -398000 and gbp = -2786.0 and eur = -441780 and  hkd = -3582.0','')")

    con:query("insert into check_sql values(-3979,'delete from transaction_total_check where cny = -3979 and jpy = -397900 and gbp = -2785.3 and eur = -441669 and  hkd = -3581.1','')")

    con:query("insert into check_sql values(-3978,'delete from transaction_total_check where cny = -3978 and jpy = -397800 and gbp = -2784.6 and eur = -441558 and  hkd = -3580.2','')")

    con:query("insert into check_sql values(-3977,'delete from transaction_total_check where cny = -3977 and jpy = -397700 and gbp = -2783.9 and eur = -441447 and  hkd = -3579.3','')")

    con:query("insert into check_sql values(-3976,'delete from transaction_total_check where cny = -3976 and jpy = -397600 and gbp = -2783.2 and eur = -441336 and  hkd = -3578.4','')")

    con:query("insert into check_sql values(-3975,'delete from transaction_total_check where cny = -3975 and jpy = -397500 and gbp = -2782.5 and eur = -441225 and  hkd = -3577.5','')")

    con:query("insert into check_sql values(-3974,'delete from transaction_total_check where cny = -3974 and jpy = -397400 and gbp = -2781.8 and eur = -441114 and  hkd = -3576.6','')")

    con:query("insert into check_sql values(-3973,'delete from transaction_total_check where cny = -3973 and jpy = -397300 and gbp = -2781.1 and eur = -441003 and  hkd = -3575.7','')")

    con:query("insert into check_sql values(-3972,'delete from transaction_total_check where cny = -3972 and jpy = -397200 and gbp = -2780.4 and eur = -440892 and  hkd = -3574.8','')")

    con:query("insert into check_sql values(-3971,'delete from transaction_total_check where cny = -3971 and jpy = -397100 and gbp = -2779.7 and eur = -440781 and  hkd = -3573.9','')")

    con:query("insert into check_sql values(-3970,'delete from transaction_total_check where cny = -3970 and jpy = -397000 and gbp = -2779.0 and eur = -440670 and  hkd = -3573.0','')")

    con:query("insert into check_sql values(-3969,'delete from transaction_total_check where cny = -3969 and jpy = -396900 and gbp = -2778.3 and eur = -440559 and  hkd = -3572.1','')")

    con:query("insert into check_sql values(-3968,'delete from transaction_total_check where cny = -3968 and jpy = -396800 and gbp = -2777.6 and eur = -440448 and  hkd = -3571.2','')")

    con:query("insert into check_sql values(-3967,'delete from transaction_total_check where cny = -3967 and jpy = -396700 and gbp = -2776.9 and eur = -440337 and  hkd = -3570.3','')")

    con:query("insert into check_sql values(-3966,'delete from transaction_total_check where cny = -3966 and jpy = -396600 and gbp = -2776.2 and eur = -440226 and  hkd = -3569.4','')")

    con:query("insert into check_sql values(-3965,'delete from transaction_total_check where cny = -3965 and jpy = -396500 and gbp = -2775.5 and eur = -440115 and  hkd = -3568.5','')")

    con:query("insert into check_sql values(-3964,'delete from transaction_total_check where cny = -3964 and jpy = -396400 and gbp = -2774.8 and eur = -440004 and  hkd = -3567.6','')")

    con:query("insert into check_sql values(-3963,'delete from transaction_total_check where cny = -3963 and jpy = -396300 and gbp = -2774.1 and eur = -439893 and  hkd = -3566.7','')")

    con:query("insert into check_sql values(-3962,'delete from transaction_total_check where cny = -3962 and jpy = -396200 and gbp = -2773.4 and eur = -439782 and  hkd = -3565.8','')")

    con:query("insert into check_sql values(-3961,'delete from transaction_total_check where cny = -3961 and jpy = -396100 and gbp = -2772.7 and eur = -439671 and  hkd = -3564.9','')")

    con:query("insert into check_sql values(-3960,'delete from transaction_total_check where cny = -3960 and jpy = -396000 and gbp = -2772.0 and eur = -439560 and  hkd = -3564.0','')")

    con:query("insert into check_sql values(-3959,'delete from transaction_total_check where cny = -3959 and jpy = -395900 and gbp = -2771.3 and eur = -439449 and  hkd = -3563.1','')")

    con:query("insert into check_sql values(-3958,'delete from transaction_total_check where cny = -3958 and jpy = -395800 and gbp = -2770.6 and eur = -439338 and  hkd = -3562.2','')")

    con:query("insert into check_sql values(-3957,'delete from transaction_total_check where cny = -3957 and jpy = -395700 and gbp = -2769.9 and eur = -439227 and  hkd = -3561.3','')")

    con:query("insert into check_sql values(-3956,'delete from transaction_total_check where cny = -3956 and jpy = -395600 and gbp = -2769.2 and eur = -439116 and  hkd = -3560.4','')")

    con:query("insert into check_sql values(-3955,'delete from transaction_total_check where cny = -3955 and jpy = -395500 and gbp = -2768.5 and eur = -439005 and  hkd = -3559.5','')")

    con:query("insert into check_sql values(-3954,'delete from transaction_total_check where cny = -3954 and jpy = -395400 and gbp = -2767.8 and eur = -438894 and  hkd = -3558.6','')")

    con:query("insert into check_sql values(-3953,'delete from transaction_total_check where cny = -3953 and jpy = -395300 and gbp = -2767.1 and eur = -438783 and  hkd = -3557.7','')")

    con:query("insert into check_sql values(-3952,'delete from transaction_total_check where cny = -3952 and jpy = -395200 and gbp = -2766.4 and eur = -438672 and  hkd = -3556.8','')")

    con:query("insert into check_sql values(-3951,'delete from transaction_total_check where cny = -3951 and jpy = -395100 and gbp = -2765.7 and eur = -438561 and  hkd = -3555.9','')")

    con:query("insert into check_sql values(-3950,'delete from transaction_total_check where cny = -3950 and jpy = -395000 and gbp = -2765.0 and eur = -438450 and  hkd = -3555.0','')")

    con:query("insert into check_sql values(-3949,'delete from transaction_total_check where cny = -3949 and jpy = -394900 and gbp = -2764.3 and eur = -438339 and  hkd = -3554.1','')")

    con:query("insert into check_sql values(-3948,'delete from transaction_total_check where cny = -3948 and jpy = -394800 and gbp = -2763.6 and eur = -438228 and  hkd = -3553.2','')")

    con:query("insert into check_sql values(-3947,'delete from transaction_total_check where cny = -3947 and jpy = -394700 and gbp = -2762.9 and eur = -438117 and  hkd = -3552.3','')")

    con:query("insert into check_sql values(-3946,'delete from transaction_total_check where cny = -3946 and jpy = -394600 and gbp = -2762.2 and eur = -438006 and  hkd = -3551.4','')")

    con:query("insert into check_sql values(-3945,'delete from transaction_total_check where cny = -3945 and jpy = -394500 and gbp = -2761.5 and eur = -437895 and  hkd = -3550.5','')")

    con:query("insert into check_sql values(-3944,'delete from transaction_total_check where cny = -3944 and jpy = -394400 and gbp = -2760.8 and eur = -437784 and  hkd = -3549.6','')")

    con:query("insert into check_sql values(-3943,'delete from transaction_total_check where cny = -3943 and jpy = -394300 and gbp = -2760.1 and eur = -437673 and  hkd = -3548.7','')")

    con:query("insert into check_sql values(-3942,'delete from transaction_total_check where cny = -3942 and jpy = -394200 and gbp = -2759.4 and eur = -437562 and  hkd = -3547.8','')")

    con:query("insert into check_sql values(-3941,'delete from transaction_total_check where cny = -3941 and jpy = -394100 and gbp = -2758.7 and eur = -437451 and  hkd = -3546.9','')")

    con:query("insert into check_sql values(-3940,'delete from transaction_total_check where cny = -3940 and jpy = -394000 and gbp = -2758.0 and eur = -437340 and  hkd = -3546.0','')")

    con:query("insert into check_sql values(-3939,'delete from transaction_total_check where cny = -3939 and jpy = -393900 and gbp = -2757.3 and eur = -437229 and  hkd = -3545.1','')")

    con:query("insert into check_sql values(-3938,'delete from transaction_total_check where cny = -3938 and jpy = -393800 and gbp = -2756.6 and eur = -437118 and  hkd = -3544.2','')")

    con:query("insert into check_sql values(-3937,'delete from transaction_total_check where cny = -3937 and jpy = -393700 and gbp = -2755.9 and eur = -437007 and  hkd = -3543.3','')")

    con:query("insert into check_sql values(-3936,'delete from transaction_total_check where cny = -3936 and jpy = -393600 and gbp = -2755.2 and eur = -436896 and  hkd = -3542.4','')")

    con:query("insert into check_sql values(-3935,'delete from transaction_total_check where cny = -3935 and jpy = -393500 and gbp = -2754.5 and eur = -436785 and  hkd = -3541.5','')")

    con:query("insert into check_sql values(-3934,'delete from transaction_total_check where cny = -3934 and jpy = -393400 and gbp = -2753.8 and eur = -436674 and  hkd = -3540.6','')")

    con:query("insert into check_sql values(-3933,'delete from transaction_total_check where cny = -3933 and jpy = -393300 and gbp = -2753.1 and eur = -436563 and  hkd = -3539.7','')")

    con:query("insert into check_sql values(-3932,'delete from transaction_total_check where cny = -3932 and jpy = -393200 and gbp = -2752.4 and eur = -436452 and  hkd = -3538.8','')")

    con:query("insert into check_sql values(-3931,'delete from transaction_total_check where cny = -3931 and jpy = -393100 and gbp = -2751.7 and eur = -436341 and  hkd = -3537.9','')")

    con:query("insert into check_sql values(-3930,'delete from transaction_total_check where cny = -3930 and jpy = -393000 and gbp = -2751.0 and eur = -436230 and  hkd = -3537.0','')")

    con:query("insert into check_sql values(-3929,'delete from transaction_total_check where cny = -3929 and jpy = -392900 and gbp = -2750.3 and eur = -436119 and  hkd = -3536.1','')")

    con:query("insert into check_sql values(-3928,'delete from transaction_total_check where cny = -3928 and jpy = -392800 and gbp = -2749.6 and eur = -436008 and  hkd = -3535.2','')")

    con:query("insert into check_sql values(-3927,'delete from transaction_total_check where cny = -3927 and jpy = -392700 and gbp = -2748.9 and eur = -435897 and  hkd = -3534.3','')")

    con:query("insert into check_sql values(-3926,'delete from transaction_total_check where cny = -3926 and jpy = -392600 and gbp = -2748.2 and eur = -435786 and  hkd = -3533.4','')")

    con:query("insert into check_sql values(-3925,'delete from transaction_total_check where cny = -3925 and jpy = -392500 and gbp = -2747.5 and eur = -435675 and  hkd = -3532.5','')")

    con:query("insert into check_sql values(-3924,'delete from transaction_total_check where cny = -3924 and jpy = -392400 and gbp = -2746.8 and eur = -435564 and  hkd = -3531.6','')")

    con:query("insert into check_sql values(-3923,'delete from transaction_total_check where cny = -3923 and jpy = -392300 and gbp = -2746.1 and eur = -435453 and  hkd = -3530.7','')")

    con:query("insert into check_sql values(-3922,'delete from transaction_total_check where cny = -3922 and jpy = -392200 and gbp = -2745.4 and eur = -435342 and  hkd = -3529.8','')")

    con:query("insert into check_sql values(-3921,'delete from transaction_total_check where cny = -3921 and jpy = -392100 and gbp = -2744.7 and eur = -435231 and  hkd = -3528.9','')")

    con:query("insert into check_sql values(-3920,'delete from transaction_total_check where cny = -3920 and jpy = -392000 and gbp = -2744.0 and eur = -435120 and  hkd = -3528.0','')")

    con:query("insert into check_sql values(-3919,'delete from transaction_total_check where cny = -3919 and jpy = -391900 and gbp = -2743.3 and eur = -435009 and  hkd = -3527.1','')")

    con:query("insert into check_sql values(-3918,'delete from transaction_total_check where cny = -3918 and jpy = -391800 and gbp = -2742.6 and eur = -434898 and  hkd = -3526.2','')")

    con:query("insert into check_sql values(-3917,'delete from transaction_total_check where cny = -3917 and jpy = -391700 and gbp = -2741.9 and eur = -434787 and  hkd = -3525.3','')")

    con:query("insert into check_sql values(-3916,'delete from transaction_total_check where cny = -3916 and jpy = -391600 and gbp = -2741.2 and eur = -434676 and  hkd = -3524.4','')")

    con:query("insert into check_sql values(-3915,'delete from transaction_total_check where cny = -3915 and jpy = -391500 and gbp = -2740.5 and eur = -434565 and  hkd = -3523.5','')")

    con:query("insert into check_sql values(-3914,'delete from transaction_total_check where cny = -3914 and jpy = -391400 and gbp = -2739.8 and eur = -434454 and  hkd = -3522.6','')")

    con:query("insert into check_sql values(-3913,'delete from transaction_total_check where cny = -3913 and jpy = -391300 and gbp = -2739.1 and eur = -434343 and  hkd = -3521.7','')")

    con:query("insert into check_sql values(-3912,'delete from transaction_total_check where cny = -3912 and jpy = -391200 and gbp = -2738.4 and eur = -434232 and  hkd = -3520.8','')")

    con:query("insert into check_sql values(-3911,'delete from transaction_total_check where cny = -3911 and jpy = -391100 and gbp = -2737.7 and eur = -434121 and  hkd = -3519.9','')")

    con:query("insert into check_sql values(-3910,'delete from transaction_total_check where cny = -3910 and jpy = -391000 and gbp = -2737.0 and eur = -434010 and  hkd = -3519.0','')")

    con:query("insert into check_sql values(-3909,'delete from transaction_total_check where cny = -3909 and jpy = -390900 and gbp = -2736.3 and eur = -433899 and  hkd = -3518.1','')")

    con:query("insert into check_sql values(-3908,'delete from transaction_total_check where cny = -3908 and jpy = -390800 and gbp = -2735.6 and eur = -433788 and  hkd = -3517.2','')")

    con:query("insert into check_sql values(-3907,'delete from transaction_total_check where cny = -3907 and jpy = -390700 and gbp = -2734.9 and eur = -433677 and  hkd = -3516.3','')")

    con:query("insert into check_sql values(-3906,'delete from transaction_total_check where cny = -3906 and jpy = -390600 and gbp = -2734.2 and eur = -433566 and  hkd = -3515.4','')")

    con:query("insert into check_sql values(-3905,'delete from transaction_total_check where cny = -3905 and jpy = -390500 and gbp = -2733.5 and eur = -433455 and  hkd = -3514.5','')")

    con:query("insert into check_sql values(-3904,'delete from transaction_total_check where cny = -3904 and jpy = -390400 and gbp = -2732.8 and eur = -433344 and  hkd = -3513.6','')")

    con:query("insert into check_sql values(-3903,'delete from transaction_total_check where cny = -3903 and jpy = -390300 and gbp = -2732.1 and eur = -433233 and  hkd = -3512.7','')")

    con:query("insert into check_sql values(-3902,'delete from transaction_total_check where cny = -3902 and jpy = -390200 and gbp = -2731.4 and eur = -433122 and  hkd = -3511.8','')")

    con:query("insert into check_sql values(-3901,'delete from transaction_total_check where cny = -3901 and jpy = -390100 and gbp = -2730.7 and eur = -433011 and  hkd = -3510.9','')")

    con:query("insert into check_sql values(-3900,'delete from transaction_total_check where cny = -3900 and jpy = -390000 and gbp = -2730.0 and eur = -432900 and  hkd = -3510.0','')")

    con:query("insert into check_sql values(-3899,'delete from transaction_total_check where cny = -3899 and jpy = -389900 and gbp = -2729.3 and eur = -432789 and  hkd = -3509.1','')")

    con:query("insert into check_sql values(-3898,'delete from transaction_total_check where cny = -3898 and jpy = -389800 and gbp = -2728.6 and eur = -432678 and  hkd = -3508.2','')")

    con:query("insert into check_sql values(-3897,'delete from transaction_total_check where cny = -3897 and jpy = -389700 and gbp = -2727.9 and eur = -432567 and  hkd = -3507.3','')")

    con:query("insert into check_sql values(-3896,'delete from transaction_total_check where cny = -3896 and jpy = -389600 and gbp = -2727.2 and eur = -432456 and  hkd = -3506.4','')")

    con:query("insert into check_sql values(-3895,'delete from transaction_total_check where cny = -3895 and jpy = -389500 and gbp = -2726.5 and eur = -432345 and  hkd = -3505.5','')")

    con:query("insert into check_sql values(-3894,'delete from transaction_total_check where cny = -3894 and jpy = -389400 and gbp = -2725.8 and eur = -432234 and  hkd = -3504.6','')")

    con:query("insert into check_sql values(-3893,'delete from transaction_total_check where cny = -3893 and jpy = -389300 and gbp = -2725.1 and eur = -432123 and  hkd = -3503.7','')")

    con:query("insert into check_sql values(-3892,'delete from transaction_total_check where cny = -3892 and jpy = -389200 and gbp = -2724.4 and eur = -432012 and  hkd = -3502.8','')")

    con:query("insert into check_sql values(-3891,'delete from transaction_total_check where cny = -3891 and jpy = -389100 and gbp = -2723.7 and eur = -431901 and  hkd = -3501.9','')")

    con:query("insert into check_sql values(-3890,'delete from transaction_total_check where cny = -3890 and jpy = -389000 and gbp = -2723.0 and eur = -431790 and  hkd = -3501.0','')")

    con:query("insert into check_sql values(-3889,'delete from transaction_total_check where cny = -3889 and jpy = -388900 and gbp = -2722.3 and eur = -431679 and  hkd = -3500.1','')")

    con:query("insert into check_sql values(-3888,'delete from transaction_total_check where cny = -3888 and jpy = -388800 and gbp = -2721.6 and eur = -431568 and  hkd = -3499.2','')")

    con:query("insert into check_sql values(-3887,'delete from transaction_total_check where cny = -3887 and jpy = -388700 and gbp = -2720.9 and eur = -431457 and  hkd = -3498.3','')")

    con:query("insert into check_sql values(-3886,'delete from transaction_total_check where cny = -3886 and jpy = -388600 and gbp = -2720.2 and eur = -431346 and  hkd = -3497.4','')")

    con:query("insert into check_sql values(-3885,'delete from transaction_total_check where cny = -3885 and jpy = -388500 and gbp = -2719.5 and eur = -431235 and  hkd = -3496.5','')")

    con:query("insert into check_sql values(-3884,'delete from transaction_total_check where cny = -3884 and jpy = -388400 and gbp = -2718.8 and eur = -431124 and  hkd = -3495.6','')")

    con:query("insert into check_sql values(-3883,'delete from transaction_total_check where cny = -3883 and jpy = -388300 and gbp = -2718.1 and eur = -431013 and  hkd = -3494.7','')")

    con:query("insert into check_sql values(-3882,'delete from transaction_total_check where cny = -3882 and jpy = -388200 and gbp = -2717.4 and eur = -430902 and  hkd = -3493.8','')")

    con:query("insert into check_sql values(-3881,'delete from transaction_total_check where cny = -3881 and jpy = -388100 and gbp = -2716.7 and eur = -430791 and  hkd = -3492.9','')")

    con:query("insert into check_sql values(-3880,'delete from transaction_total_check where cny = -3880 and jpy = -388000 and gbp = -2716.0 and eur = -430680 and  hkd = -3492.0','')")

    con:query("insert into check_sql values(-3879,'delete from transaction_total_check where cny = -3879 and jpy = -387900 and gbp = -2715.3 and eur = -430569 and  hkd = -3491.1','')")

    con:query("insert into check_sql values(-3878,'delete from transaction_total_check where cny = -3878 and jpy = -387800 and gbp = -2714.6 and eur = -430458 and  hkd = -3490.2','')")

    con:query("insert into check_sql values(-3877,'delete from transaction_total_check where cny = -3877 and jpy = -387700 and gbp = -2713.9 and eur = -430347 and  hkd = -3489.3','')")

    con:query("insert into check_sql values(-3876,'delete from transaction_total_check where cny = -3876 and jpy = -387600 and gbp = -2713.2 and eur = -430236 and  hkd = -3488.4','')")

    con:query("insert into check_sql values(-3875,'delete from transaction_total_check where cny = -3875 and jpy = -387500 and gbp = -2712.5 and eur = -430125 and  hkd = -3487.5','')")

    con:query("insert into check_sql values(-3874,'delete from transaction_total_check where cny = -3874 and jpy = -387400 and gbp = -2711.8 and eur = -430014 and  hkd = -3486.6','')")

    con:query("insert into check_sql values(-3873,'delete from transaction_total_check where cny = -3873 and jpy = -387300 and gbp = -2711.1 and eur = -429903 and  hkd = -3485.7','')")

    con:query("insert into check_sql values(-3872,'delete from transaction_total_check where cny = -3872 and jpy = -387200 and gbp = -2710.4 and eur = -429792 and  hkd = -3484.8','')")

    con:query("insert into check_sql values(-3871,'delete from transaction_total_check where cny = -3871 and jpy = -387100 and gbp = -2709.7 and eur = -429681 and  hkd = -3483.9','')")

    con:query("insert into check_sql values(-3870,'delete from transaction_total_check where cny = -3870 and jpy = -387000 and gbp = -2709.0 and eur = -429570 and  hkd = -3483.0','')")

    con:query("insert into check_sql values(-3869,'delete from transaction_total_check where cny = -3869 and jpy = -386900 and gbp = -2708.3 and eur = -429459 and  hkd = -3482.1','')")

    con:query("insert into check_sql values(-3868,'delete from transaction_total_check where cny = -3868 and jpy = -386800 and gbp = -2707.6 and eur = -429348 and  hkd = -3481.2','')")

    con:query("insert into check_sql values(-3867,'delete from transaction_total_check where cny = -3867 and jpy = -386700 and gbp = -2706.9 and eur = -429237 and  hkd = -3480.3','')")

    con:query("insert into check_sql values(-3866,'delete from transaction_total_check where cny = -3866 and jpy = -386600 and gbp = -2706.2 and eur = -429126 and  hkd = -3479.4','')")

    con:query("insert into check_sql values(-3865,'delete from transaction_total_check where cny = -3865 and jpy = -386500 and gbp = -2705.5 and eur = -429015 and  hkd = -3478.5','')")

    con:query("insert into check_sql values(-3864,'delete from transaction_total_check where cny = -3864 and jpy = -386400 and gbp = -2704.8 and eur = -428904 and  hkd = -3477.6','')")

    con:query("insert into check_sql values(-3863,'delete from transaction_total_check where cny = -3863 and jpy = -386300 and gbp = -2704.1 and eur = -428793 and  hkd = -3476.7','')")

    con:query("insert into check_sql values(-3862,'delete from transaction_total_check where cny = -3862 and jpy = -386200 and gbp = -2703.4 and eur = -428682 and  hkd = -3475.8','')")

    con:query("insert into check_sql values(-3861,'delete from transaction_total_check where cny = -3861 and jpy = -386100 and gbp = -2702.7 and eur = -428571 and  hkd = -3474.9','')")

    con:query("insert into check_sql values(-3860,'delete from transaction_total_check where cny = -3860 and jpy = -386000 and gbp = -2702.0 and eur = -428460 and  hkd = -3474.0','')")

    con:query("insert into check_sql values(-3859,'delete from transaction_total_check where cny = -3859 and jpy = -385900 and gbp = -2701.3 and eur = -428349 and  hkd = -3473.1','')")

    con:query("insert into check_sql values(-3858,'delete from transaction_total_check where cny = -3858 and jpy = -385800 and gbp = -2700.6 and eur = -428238 and  hkd = -3472.2','')")

    con:query("insert into check_sql values(-3857,'delete from transaction_total_check where cny = -3857 and jpy = -385700 and gbp = -2699.9 and eur = -428127 and  hkd = -3471.3','')")

    con:query("insert into check_sql values(-3856,'delete from transaction_total_check where cny = -3856 and jpy = -385600 and gbp = -2699.2 and eur = -428016 and  hkd = -3470.4','')")

    con:query("insert into check_sql values(-3855,'delete from transaction_total_check where cny = -3855 and jpy = -385500 and gbp = -2698.5 and eur = -427905 and  hkd = -3469.5','')")

    con:query("insert into check_sql values(-3854,'delete from transaction_total_check where cny = -3854 and jpy = -385400 and gbp = -2697.8 and eur = -427794 and  hkd = -3468.6','')")

    con:query("insert into check_sql values(-3853,'delete from transaction_total_check where cny = -3853 and jpy = -385300 and gbp = -2697.1 and eur = -427683 and  hkd = -3467.7','')")

    con:query("insert into check_sql values(-3852,'delete from transaction_total_check where cny = -3852 and jpy = -385200 and gbp = -2696.4 and eur = -427572 and  hkd = -3466.8','')")

    con:query("insert into check_sql values(-3851,'delete from transaction_total_check where cny = -3851 and jpy = -385100 and gbp = -2695.7 and eur = -427461 and  hkd = -3465.9','')")

    con:query("insert into check_sql values(-3850,'delete from transaction_total_check where cny = -3850 and jpy = -385000 and gbp = -2695.0 and eur = -427350 and  hkd = -3465.0','')")

    con:query("insert into check_sql values(-3849,'delete from transaction_total_check where cny = -3849 and jpy = -384900 and gbp = -2694.3 and eur = -427239 and  hkd = -3464.1','')")

    con:query("insert into check_sql values(-3848,'delete from transaction_total_check where cny = -3848 and jpy = -384800 and gbp = -2693.6 and eur = -427128 and  hkd = -3463.2','')")

    con:query("insert into check_sql values(-3847,'delete from transaction_total_check where cny = -3847 and jpy = -384700 and gbp = -2692.9 and eur = -427017 and  hkd = -3462.3','')")

    con:query("insert into check_sql values(-3846,'delete from transaction_total_check where cny = -3846 and jpy = -384600 and gbp = -2692.2 and eur = -426906 and  hkd = -3461.4','')")

    con:query("insert into check_sql values(-3845,'delete from transaction_total_check where cny = -3845 and jpy = -384500 and gbp = -2691.5 and eur = -426795 and  hkd = -3460.5','')")

    con:query("insert into check_sql values(-3844,'delete from transaction_total_check where cny = -3844 and jpy = -384400 and gbp = -2690.8 and eur = -426684 and  hkd = -3459.6','')")

    con:query("insert into check_sql values(-3843,'delete from transaction_total_check where cny = -3843 and jpy = -384300 and gbp = -2690.1 and eur = -426573 and  hkd = -3458.7','')")

    con:query("insert into check_sql values(-3842,'delete from transaction_total_check where cny = -3842 and jpy = -384200 and gbp = -2689.4 and eur = -426462 and  hkd = -3457.8','')")

    con:query("insert into check_sql values(-3841,'delete from transaction_total_check where cny = -3841 and jpy = -384100 and gbp = -2688.7 and eur = -426351 and  hkd = -3456.9','')")

    con:query("insert into check_sql values(-3840,'delete from transaction_total_check where cny = -3840 and jpy = -384000 and gbp = -2688.0 and eur = -426240 and  hkd = -3456.0','')")

    con:query("insert into check_sql values(-3839,'delete from transaction_total_check where cny = -3839 and jpy = -383900 and gbp = -2687.3 and eur = -426129 and  hkd = -3455.1','')")

    con:query("insert into check_sql values(-3838,'delete from transaction_total_check where cny = -3838 and jpy = -383800 and gbp = -2686.6 and eur = -426018 and  hkd = -3454.2','')")

    con:query("insert into check_sql values(-3837,'delete from transaction_total_check where cny = -3837 and jpy = -383700 and gbp = -2685.9 and eur = -425907 and  hkd = -3453.3','')")

    con:query("insert into check_sql values(-3836,'delete from transaction_total_check where cny = -3836 and jpy = -383600 and gbp = -2685.2 and eur = -425796 and  hkd = -3452.4','')")

    con:query("insert into check_sql values(-3835,'delete from transaction_total_check where cny = -3835 and jpy = -383500 and gbp = -2684.5 and eur = -425685 and  hkd = -3451.5','')")

    con:query("insert into check_sql values(-3834,'delete from transaction_total_check where cny = -3834 and jpy = -383400 and gbp = -2683.8 and eur = -425574 and  hkd = -3450.6','')")

    con:query("insert into check_sql values(-3833,'delete from transaction_total_check where cny = -3833 and jpy = -383300 and gbp = -2683.1 and eur = -425463 and  hkd = -3449.7','')")

    con:query("insert into check_sql values(-3832,'delete from transaction_total_check where cny = -3832 and jpy = -383200 and gbp = -2682.4 and eur = -425352 and  hkd = -3448.8','')")

    con:query("insert into check_sql values(-3831,'delete from transaction_total_check where cny = -3831 and jpy = -383100 and gbp = -2681.7 and eur = -425241 and  hkd = -3447.9','')")

    con:query("insert into check_sql values(-3830,'delete from transaction_total_check where cny = -3830 and jpy = -383000 and gbp = -2681.0 and eur = -425130 and  hkd = -3447.0','')")

    con:query("insert into check_sql values(-3829,'delete from transaction_total_check where cny = -3829 and jpy = -382900 and gbp = -2680.3 and eur = -425019 and  hkd = -3446.1','')")

    con:query("insert into check_sql values(-3828,'delete from transaction_total_check where cny = -3828 and jpy = -382800 and gbp = -2679.6 and eur = -424908 and  hkd = -3445.2','')")

    con:query("insert into check_sql values(-3827,'delete from transaction_total_check where cny = -3827 and jpy = -382700 and gbp = -2678.9 and eur = -424797 and  hkd = -3444.3','')")

    con:query("insert into check_sql values(-3826,'delete from transaction_total_check where cny = -3826 and jpy = -382600 and gbp = -2678.2 and eur = -424686 and  hkd = -3443.4','')")

    con:query("insert into check_sql values(-3825,'delete from transaction_total_check where cny = -3825 and jpy = -382500 and gbp = -2677.5 and eur = -424575 and  hkd = -3442.5','')")

    con:query("insert into check_sql values(-3824,'delete from transaction_total_check where cny = -3824 and jpy = -382400 and gbp = -2676.8 and eur = -424464 and  hkd = -3441.6','')")

    con:query("insert into check_sql values(-3823,'delete from transaction_total_check where cny = -3823 and jpy = -382300 and gbp = -2676.1 and eur = -424353 and  hkd = -3440.7','')")

    con:query("insert into check_sql values(-3822,'delete from transaction_total_check where cny = -3822 and jpy = -382200 and gbp = -2675.4 and eur = -424242 and  hkd = -3439.8','')")

    con:query("insert into check_sql values(-3821,'delete from transaction_total_check where cny = -3821 and jpy = -382100 and gbp = -2674.7 and eur = -424131 and  hkd = -3438.9','')")

    con:query("insert into check_sql values(-3820,'delete from transaction_total_check where cny = -3820 and jpy = -382000 and gbp = -2674.0 and eur = -424020 and  hkd = -3438.0','')")

    con:query("insert into check_sql values(-3819,'delete from transaction_total_check where cny = -3819 and jpy = -381900 and gbp = -2673.3 and eur = -423909 and  hkd = -3437.1','')")

    con:query("insert into check_sql values(-3818,'delete from transaction_total_check where cny = -3818 and jpy = -381800 and gbp = -2672.6 and eur = -423798 and  hkd = -3436.2','')")

    con:query("insert into check_sql values(-3817,'delete from transaction_total_check where cny = -3817 and jpy = -381700 and gbp = -2671.9 and eur = -423687 and  hkd = -3435.3','')")

    con:query("insert into check_sql values(-3816,'delete from transaction_total_check where cny = -3816 and jpy = -381600 and gbp = -2671.2 and eur = -423576 and  hkd = -3434.4','')")

    con:query("insert into check_sql values(-3815,'delete from transaction_total_check where cny = -3815 and jpy = -381500 and gbp = -2670.5 and eur = -423465 and  hkd = -3433.5','')")

    con:query("insert into check_sql values(-3814,'delete from transaction_total_check where cny = -3814 and jpy = -381400 and gbp = -2669.8 and eur = -423354 and  hkd = -3432.6','')")

    con:query("insert into check_sql values(-3813,'delete from transaction_total_check where cny = -3813 and jpy = -381300 and gbp = -2669.1 and eur = -423243 and  hkd = -3431.7','')")

    con:query("insert into check_sql values(-3812,'delete from transaction_total_check where cny = -3812 and jpy = -381200 and gbp = -2668.4 and eur = -423132 and  hkd = -3430.8','')")

    con:query("insert into check_sql values(-3811,'delete from transaction_total_check where cny = -3811 and jpy = -381100 and gbp = -2667.7 and eur = -423021 and  hkd = -3429.9','')")

    con:query("insert into check_sql values(-3810,'delete from transaction_total_check where cny = -3810 and jpy = -381000 and gbp = -2667.0 and eur = -422910 and  hkd = -3429.0','')")

    con:query("insert into check_sql values(-3809,'delete from transaction_total_check where cny = -3809 and jpy = -380900 and gbp = -2666.3 and eur = -422799 and  hkd = -3428.1','')")

    con:query("insert into check_sql values(-3808,'delete from transaction_total_check where cny = -3808 and jpy = -380800 and gbp = -2665.6 and eur = -422688 and  hkd = -3427.2','')")

    con:query("insert into check_sql values(-3807,'delete from transaction_total_check where cny = -3807 and jpy = -380700 and gbp = -2664.9 and eur = -422577 and  hkd = -3426.3','')")

    con:query("insert into check_sql values(-3806,'delete from transaction_total_check where cny = -3806 and jpy = -380600 and gbp = -2664.2 and eur = -422466 and  hkd = -3425.4','')")

    con:query("insert into check_sql values(-3805,'delete from transaction_total_check where cny = -3805 and jpy = -380500 and gbp = -2663.5 and eur = -422355 and  hkd = -3424.5','')")

    con:query("insert into check_sql values(-3804,'delete from transaction_total_check where cny = -3804 and jpy = -380400 and gbp = -2662.8 and eur = -422244 and  hkd = -3423.6','')")

    con:query("insert into check_sql values(-3803,'delete from transaction_total_check where cny = -3803 and jpy = -380300 and gbp = -2662.1 and eur = -422133 and  hkd = -3422.7','')")

    con:query("insert into check_sql values(-3802,'delete from transaction_total_check where cny = -3802 and jpy = -380200 and gbp = -2661.4 and eur = -422022 and  hkd = -3421.8','')")

    con:query("insert into check_sql values(-3801,'delete from transaction_total_check where cny = -3801 and jpy = -380100 and gbp = -2660.7 and eur = -421911 and  hkd = -3420.9','')")

    con:query("insert into check_sql values(-3800,'delete from transaction_total_check where cny = -3800 and jpy = -380000 and gbp = -2660.0 and eur = -421800 and  hkd = -3420.0','')")

    con:query("insert into check_sql values(-3799,'delete from transaction_total_check where cny = -3799 and jpy = -379900 and gbp = -2659.3 and eur = -421689 and  hkd = -3419.1','')")

    con:query("insert into check_sql values(-3798,'delete from transaction_total_check where cny = -3798 and jpy = -379800 and gbp = -2658.6 and eur = -421578 and  hkd = -3418.2','')")

    con:query("insert into check_sql values(-3797,'delete from transaction_total_check where cny = -3797 and jpy = -379700 and gbp = -2657.9 and eur = -421467 and  hkd = -3417.3','')")

    con:query("insert into check_sql values(-3796,'delete from transaction_total_check where cny = -3796 and jpy = -379600 and gbp = -2657.2 and eur = -421356 and  hkd = -3416.4','')")

    con:query("insert into check_sql values(-3795,'delete from transaction_total_check where cny = -3795 and jpy = -379500 and gbp = -2656.5 and eur = -421245 and  hkd = -3415.5','')")

    con:query("insert into check_sql values(-3794,'delete from transaction_total_check where cny = -3794 and jpy = -379400 and gbp = -2655.8 and eur = -421134 and  hkd = -3414.6','')")

    con:query("insert into check_sql values(-3793,'delete from transaction_total_check where cny = -3793 and jpy = -379300 and gbp = -2655.1 and eur = -421023 and  hkd = -3413.7','')")

    con:query("insert into check_sql values(-3792,'delete from transaction_total_check where cny = -3792 and jpy = -379200 and gbp = -2654.4 and eur = -420912 and  hkd = -3412.8','')")

    con:query("insert into check_sql values(-3791,'delete from transaction_total_check where cny = -3791 and jpy = -379100 and gbp = -2653.7 and eur = -420801 and  hkd = -3411.9','')")

    con:query("insert into check_sql values(-3790,'delete from transaction_total_check where cny = -3790 and jpy = -379000 and gbp = -2653.0 and eur = -420690 and  hkd = -3411.0','')")

    con:query("insert into check_sql values(-3789,'delete from transaction_total_check where cny = -3789 and jpy = -378900 and gbp = -2652.3 and eur = -420579 and  hkd = -3410.1','')")

    con:query("insert into check_sql values(-3788,'delete from transaction_total_check where cny = -3788 and jpy = -378800 and gbp = -2651.6 and eur = -420468 and  hkd = -3409.2','')")

    con:query("insert into check_sql values(-3787,'delete from transaction_total_check where cny = -3787 and jpy = -378700 and gbp = -2650.9 and eur = -420357 and  hkd = -3408.3','')")

    con:query("insert into check_sql values(-3786,'delete from transaction_total_check where cny = -3786 and jpy = -378600 and gbp = -2650.2 and eur = -420246 and  hkd = -3407.4','')")

    con:query("insert into check_sql values(-3785,'delete from transaction_total_check where cny = -3785 and jpy = -378500 and gbp = -2649.5 and eur = -420135 and  hkd = -3406.5','')")

    con:query("insert into check_sql values(-3784,'delete from transaction_total_check where cny = -3784 and jpy = -378400 and gbp = -2648.8 and eur = -420024 and  hkd = -3405.6','')")

    con:query("insert into check_sql values(-3783,'delete from transaction_total_check where cny = -3783 and jpy = -378300 and gbp = -2648.1 and eur = -419913 and  hkd = -3404.7','')")

    con:query("insert into check_sql values(-3782,'delete from transaction_total_check where cny = -3782 and jpy = -378200 and gbp = -2647.4 and eur = -419802 and  hkd = -3403.8','')")

    con:query("insert into check_sql values(-3781,'delete from transaction_total_check where cny = -3781 and jpy = -378100 and gbp = -2646.7 and eur = -419691 and  hkd = -3402.9','')")

    con:query("insert into check_sql values(-3780,'delete from transaction_total_check where cny = -3780 and jpy = -378000 and gbp = -2646.0 and eur = -419580 and  hkd = -3402.0','')")

    con:query("insert into check_sql values(-3779,'delete from transaction_total_check where cny = -3779 and jpy = -377900 and gbp = -2645.3 and eur = -419469 and  hkd = -3401.1','')")

    con:query("insert into check_sql values(-3778,'delete from transaction_total_check where cny = -3778 and jpy = -377800 and gbp = -2644.6 and eur = -419358 and  hkd = -3400.2','')")

    con:query("insert into check_sql values(-3777,'delete from transaction_total_check where cny = -3777 and jpy = -377700 and gbp = -2643.9 and eur = -419247 and  hkd = -3399.3','')")

    con:query("insert into check_sql values(-3776,'delete from transaction_total_check where cny = -3776 and jpy = -377600 and gbp = -2643.2 and eur = -419136 and  hkd = -3398.4','')")

    con:query("insert into check_sql values(-3775,'delete from transaction_total_check where cny = -3775 and jpy = -377500 and gbp = -2642.5 and eur = -419025 and  hkd = -3397.5','')")

    con:query("insert into check_sql values(-3774,'delete from transaction_total_check where cny = -3774 and jpy = -377400 and gbp = -2641.8 and eur = -418914 and  hkd = -3396.6','')")

    con:query("insert into check_sql values(-3773,'delete from transaction_total_check where cny = -3773 and jpy = -377300 and gbp = -2641.1 and eur = -418803 and  hkd = -3395.7','')")

    con:query("insert into check_sql values(-3772,'delete from transaction_total_check where cny = -3772 and jpy = -377200 and gbp = -2640.4 and eur = -418692 and  hkd = -3394.8','')")

    con:query("insert into check_sql values(-3771,'delete from transaction_total_check where cny = -3771 and jpy = -377100 and gbp = -2639.7 and eur = -418581 and  hkd = -3393.9','')")

    con:query("insert into check_sql values(-3770,'delete from transaction_total_check where cny = -3770 and jpy = -377000 and gbp = -2639.0 and eur = -418470 and  hkd = -3393.0','')")

    con:query("insert into check_sql values(-3769,'delete from transaction_total_check where cny = -3769 and jpy = -376900 and gbp = -2638.3 and eur = -418359 and  hkd = -3392.1','')")

    con:query("insert into check_sql values(-3768,'delete from transaction_total_check where cny = -3768 and jpy = -376800 and gbp = -2637.6 and eur = -418248 and  hkd = -3391.2','')")

    con:query("insert into check_sql values(-3767,'delete from transaction_total_check where cny = -3767 and jpy = -376700 and gbp = -2636.9 and eur = -418137 and  hkd = -3390.3','')")

    con:query("insert into check_sql values(-3766,'delete from transaction_total_check where cny = -3766 and jpy = -376600 and gbp = -2636.2 and eur = -418026 and  hkd = -3389.4','')")

    con:query("insert into check_sql values(-3765,'delete from transaction_total_check where cny = -3765 and jpy = -376500 and gbp = -2635.5 and eur = -417915 and  hkd = -3388.5','')")

    con:query("insert into check_sql values(-3764,'delete from transaction_total_check where cny = -3764 and jpy = -376400 and gbp = -2634.8 and eur = -417804 and  hkd = -3387.6','')")

    con:query("insert into check_sql values(-3763,'delete from transaction_total_check where cny = -3763 and jpy = -376300 and gbp = -2634.1 and eur = -417693 and  hkd = -3386.7','')")

    con:query("insert into check_sql values(-3762,'delete from transaction_total_check where cny = -3762 and jpy = -376200 and gbp = -2633.4 and eur = -417582 and  hkd = -3385.8','')")

    con:query("insert into check_sql values(-3761,'delete from transaction_total_check where cny = -3761 and jpy = -376100 and gbp = -2632.7 and eur = -417471 and  hkd = -3384.9','')")

    con:query("insert into check_sql values(-3760,'delete from transaction_total_check where cny = -3760 and jpy = -376000 and gbp = -2632.0 and eur = -417360 and  hkd = -3384.0','')")

    con:query("insert into check_sql values(-3759,'delete from transaction_total_check where cny = -3759 and jpy = -375900 and gbp = -2631.3 and eur = -417249 and  hkd = -3383.1','')")

    con:query("insert into check_sql values(-3758,'delete from transaction_total_check where cny = -3758 and jpy = -375800 and gbp = -2630.6 and eur = -417138 and  hkd = -3382.2','')")

    con:query("insert into check_sql values(-3757,'delete from transaction_total_check where cny = -3757 and jpy = -375700 and gbp = -2629.9 and eur = -417027 and  hkd = -3381.3','')")

    con:query("insert into check_sql values(-3756,'delete from transaction_total_check where cny = -3756 and jpy = -375600 and gbp = -2629.2 and eur = -416916 and  hkd = -3380.4','')")

    con:query("insert into check_sql values(-3755,'delete from transaction_total_check where cny = -3755 and jpy = -375500 and gbp = -2628.5 and eur = -416805 and  hkd = -3379.5','')")

    con:query("insert into check_sql values(-3754,'delete from transaction_total_check where cny = -3754 and jpy = -375400 and gbp = -2627.8 and eur = -416694 and  hkd = -3378.6','')")

    con:query("insert into check_sql values(-3753,'delete from transaction_total_check where cny = -3753 and jpy = -375300 and gbp = -2627.1 and eur = -416583 and  hkd = -3377.7','')")

    con:query("insert into check_sql values(-3752,'delete from transaction_total_check where cny = -3752 and jpy = -375200 and gbp = -2626.4 and eur = -416472 and  hkd = -3376.8','')")

    con:query("insert into check_sql values(-3751,'delete from transaction_total_check where cny = -3751 and jpy = -375100 and gbp = -2625.7 and eur = -416361 and  hkd = -3375.9','')")

    con:query("insert into check_sql values(-3750,'delete from transaction_total_check where cny = -3750 and jpy = -375000 and gbp = -2625.0 and eur = -416250 and  hkd = -3375.0','')")

    con:query("insert into check_sql values(-3749,'delete from transaction_total_check where cny = -3749 and jpy = -374900 and gbp = -2624.3 and eur = -416139 and  hkd = -3374.1','')")

    con:query("insert into check_sql values(-3748,'delete from transaction_total_check where cny = -3748 and jpy = -374800 and gbp = -2623.6 and eur = -416028 and  hkd = -3373.2','')")

    con:query("insert into check_sql values(-3747,'delete from transaction_total_check where cny = -3747 and jpy = -374700 and gbp = -2622.9 and eur = -415917 and  hkd = -3372.3','')")

    con:query("insert into check_sql values(-3746,'delete from transaction_total_check where cny = -3746 and jpy = -374600 and gbp = -2622.2 and eur = -415806 and  hkd = -3371.4','')")

    con:query("insert into check_sql values(-3745,'delete from transaction_total_check where cny = -3745 and jpy = -374500 and gbp = -2621.5 and eur = -415695 and  hkd = -3370.5','')")

    con:query("insert into check_sql values(-3744,'delete from transaction_total_check where cny = -3744 and jpy = -374400 and gbp = -2620.8 and eur = -415584 and  hkd = -3369.6','')")

    con:query("insert into check_sql values(-3743,'delete from transaction_total_check where cny = -3743 and jpy = -374300 and gbp = -2620.1 and eur = -415473 and  hkd = -3368.7','')")

    con:query("insert into check_sql values(-3742,'delete from transaction_total_check where cny = -3742 and jpy = -374200 and gbp = -2619.4 and eur = -415362 and  hkd = -3367.8','')")

    con:query("insert into check_sql values(-3741,'delete from transaction_total_check where cny = -3741 and jpy = -374100 and gbp = -2618.7 and eur = -415251 and  hkd = -3366.9','')")

    con:query("insert into check_sql values(-3740,'delete from transaction_total_check where cny = -3740 and jpy = -374000 and gbp = -2618.0 and eur = -415140 and  hkd = -3366.0','')")

    con:query("insert into check_sql values(-3739,'delete from transaction_total_check where cny = -3739 and jpy = -373900 and gbp = -2617.3 and eur = -415029 and  hkd = -3365.1','')")

    con:query("insert into check_sql values(-3738,'delete from transaction_total_check where cny = -3738 and jpy = -373800 and gbp = -2616.6 and eur = -414918 and  hkd = -3364.2','')")

    con:query("insert into check_sql values(-3737,'delete from transaction_total_check where cny = -3737 and jpy = -373700 and gbp = -2615.9 and eur = -414807 and  hkd = -3363.3','')")

    con:query("insert into check_sql values(-3736,'delete from transaction_total_check where cny = -3736 and jpy = -373600 and gbp = -2615.2 and eur = -414696 and  hkd = -3362.4','')")

    con:query("insert into check_sql values(-3735,'delete from transaction_total_check where cny = -3735 and jpy = -373500 and gbp = -2614.5 and eur = -414585 and  hkd = -3361.5','')")

    con:query("insert into check_sql values(-3734,'delete from transaction_total_check where cny = -3734 and jpy = -373400 and gbp = -2613.8 and eur = -414474 and  hkd = -3360.6','')")

    con:query("insert into check_sql values(-3733,'delete from transaction_total_check where cny = -3733 and jpy = -373300 and gbp = -2613.1 and eur = -414363 and  hkd = -3359.7','')")

    con:query("insert into check_sql values(-3732,'delete from transaction_total_check where cny = -3732 and jpy = -373200 and gbp = -2612.4 and eur = -414252 and  hkd = -3358.8','')")

    con:query("insert into check_sql values(-3731,'delete from transaction_total_check where cny = -3731 and jpy = -373100 and gbp = -2611.7 and eur = -414141 and  hkd = -3357.9','')")

    con:query("insert into check_sql values(-3730,'delete from transaction_total_check where cny = -3730 and jpy = -373000 and gbp = -2611.0 and eur = -414030 and  hkd = -3357.0','')")

    con:query("insert into check_sql values(-3729,'delete from transaction_total_check where cny = -3729 and jpy = -372900 and gbp = -2610.3 and eur = -413919 and  hkd = -3356.1','')")

    con:query("insert into check_sql values(-3728,'delete from transaction_total_check where cny = -3728 and jpy = -372800 and gbp = -2609.6 and eur = -413808 and  hkd = -3355.2','')")

    con:query("insert into check_sql values(-3727,'delete from transaction_total_check where cny = -3727 and jpy = -372700 and gbp = -2608.9 and eur = -413697 and  hkd = -3354.3','')")

    con:query("insert into check_sql values(-3726,'delete from transaction_total_check where cny = -3726 and jpy = -372600 and gbp = -2608.2 and eur = -413586 and  hkd = -3353.4','')")

    con:query("insert into check_sql values(-3725,'delete from transaction_total_check where cny = -3725 and jpy = -372500 and gbp = -2607.5 and eur = -413475 and  hkd = -3352.5','')")

    con:query("insert into check_sql values(-3724,'delete from transaction_total_check where cny = -3724 and jpy = -372400 and gbp = -2606.8 and eur = -413364 and  hkd = -3351.6','')")

    con:query("insert into check_sql values(-3723,'delete from transaction_total_check where cny = -3723 and jpy = -372300 and gbp = -2606.1 and eur = -413253 and  hkd = -3350.7','')")

    con:query("insert into check_sql values(-3722,'delete from transaction_total_check where cny = -3722 and jpy = -372200 and gbp = -2605.4 and eur = -413142 and  hkd = -3349.8','')")

    con:query("insert into check_sql values(-3721,'delete from transaction_total_check where cny = -3721 and jpy = -372100 and gbp = -2604.7 and eur = -413031 and  hkd = -3348.9','')")

    con:query("insert into check_sql values(-3720,'delete from transaction_total_check where cny = -3720 and jpy = -372000 and gbp = -2604.0 and eur = -412920 and  hkd = -3348.0','')")

    con:query("insert into check_sql values(-3719,'delete from transaction_total_check where cny = -3719 and jpy = -371900 and gbp = -2603.3 and eur = -412809 and  hkd = -3347.1','')")

    con:query("insert into check_sql values(-3718,'delete from transaction_total_check where cny = -3718 and jpy = -371800 and gbp = -2602.6 and eur = -412698 and  hkd = -3346.2','')")

    con:query("insert into check_sql values(-3717,'delete from transaction_total_check where cny = -3717 and jpy = -371700 and gbp = -2601.9 and eur = -412587 and  hkd = -3345.3','')")

    con:query("insert into check_sql values(-3716,'delete from transaction_total_check where cny = -3716 and jpy = -371600 and gbp = -2601.2 and eur = -412476 and  hkd = -3344.4','')")

    con:query("insert into check_sql values(-3715,'delete from transaction_total_check where cny = -3715 and jpy = -371500 and gbp = -2600.5 and eur = -412365 and  hkd = -3343.5','')")

    con:query("insert into check_sql values(-3714,'delete from transaction_total_check where cny = -3714 and jpy = -371400 and gbp = -2599.8 and eur = -412254 and  hkd = -3342.6','')")

    con:query("insert into check_sql values(-3713,'delete from transaction_total_check where cny = -3713 and jpy = -371300 and gbp = -2599.1 and eur = -412143 and  hkd = -3341.7','')")

    con:query("insert into check_sql values(-3712,'delete from transaction_total_check where cny = -3712 and jpy = -371200 and gbp = -2598.4 and eur = -412032 and  hkd = -3340.8','')")

    con:query("insert into check_sql values(-3711,'delete from transaction_total_check where cny = -3711 and jpy = -371100 and gbp = -2597.7 and eur = -411921 and  hkd = -3339.9','')")

    con:query("insert into check_sql values(-3710,'delete from transaction_total_check where cny = -3710 and jpy = -371000 and gbp = -2597.0 and eur = -411810 and  hkd = -3339.0','')")

    con:query("insert into check_sql values(-3709,'delete from transaction_total_check where cny = -3709 and jpy = -370900 and gbp = -2596.3 and eur = -411699 and  hkd = -3338.1','')")

    con:query("insert into check_sql values(-3708,'delete from transaction_total_check where cny = -3708 and jpy = -370800 and gbp = -2595.6 and eur = -411588 and  hkd = -3337.2','')")

    con:query("insert into check_sql values(-3707,'delete from transaction_total_check where cny = -3707 and jpy = -370700 and gbp = -2594.9 and eur = -411477 and  hkd = -3336.3','')")

    con:query("insert into check_sql values(-3706,'delete from transaction_total_check where cny = -3706 and jpy = -370600 and gbp = -2594.2 and eur = -411366 and  hkd = -3335.4','')")

    con:query("insert into check_sql values(-3705,'delete from transaction_total_check where cny = -3705 and jpy = -370500 and gbp = -2593.5 and eur = -411255 and  hkd = -3334.5','')")

    con:query("insert into check_sql values(-3704,'delete from transaction_total_check where cny = -3704 and jpy = -370400 and gbp = -2592.8 and eur = -411144 and  hkd = -3333.6','')")

    con:query("insert into check_sql values(-3703,'delete from transaction_total_check where cny = -3703 and jpy = -370300 and gbp = -2592.1 and eur = -411033 and  hkd = -3332.7','')")

    con:query("insert into check_sql values(-3702,'delete from transaction_total_check where cny = -3702 and jpy = -370200 and gbp = -2591.4 and eur = -410922 and  hkd = -3331.8','')")

    con:query("insert into check_sql values(-3701,'delete from transaction_total_check where cny = -3701 and jpy = -370100 and gbp = -2590.7 and eur = -410811 and  hkd = -3330.9','')")

    con:query("insert into check_sql values(-3700,'delete from transaction_total_check where cny = -3700 and jpy = -370000 and gbp = -2590.0 and eur = -410700 and  hkd = -3330.0','')")

    con:query("insert into check_sql values(-3699,'delete from transaction_total_check where cny = -3699 and jpy = -369900 and gbp = -2589.3 and eur = -410589 and  hkd = -3329.1','')")

    con:query("insert into check_sql values(-3698,'delete from transaction_total_check where cny = -3698 and jpy = -369800 and gbp = -2588.6 and eur = -410478 and  hkd = -3328.2','')")

    con:query("insert into check_sql values(-3697,'delete from transaction_total_check where cny = -3697 and jpy = -369700 and gbp = -2587.9 and eur = -410367 and  hkd = -3327.3','')")

    con:query("insert into check_sql values(-3696,'delete from transaction_total_check where cny = -3696 and jpy = -369600 and gbp = -2587.2 and eur = -410256 and  hkd = -3326.4','')")

    con:query("insert into check_sql values(-3695,'delete from transaction_total_check where cny = -3695 and jpy = -369500 and gbp = -2586.5 and eur = -410145 and  hkd = -3325.5','')")

    con:query("insert into check_sql values(-3694,'delete from transaction_total_check where cny = -3694 and jpy = -369400 and gbp = -2585.8 and eur = -410034 and  hkd = -3324.6','')")

    con:query("insert into check_sql values(-3693,'delete from transaction_total_check where cny = -3693 and jpy = -369300 and gbp = -2585.1 and eur = -409923 and  hkd = -3323.7','')")

    con:query("insert into check_sql values(-3692,'delete from transaction_total_check where cny = -3692 and jpy = -369200 and gbp = -2584.4 and eur = -409812 and  hkd = -3322.8','')")

    con:query("insert into check_sql values(-3691,'delete from transaction_total_check where cny = -3691 and jpy = -369100 and gbp = -2583.7 and eur = -409701 and  hkd = -3321.9','')")

    con:query("insert into check_sql values(-3690,'delete from transaction_total_check where cny = -3690 and jpy = -369000 and gbp = -2583.0 and eur = -409590 and  hkd = -3321.0','')")

    con:query("insert into check_sql values(-3689,'delete from transaction_total_check where cny = -3689 and jpy = -368900 and gbp = -2582.3 and eur = -409479 and  hkd = -3320.1','')")

    con:query("insert into check_sql values(-3688,'delete from transaction_total_check where cny = -3688 and jpy = -368800 and gbp = -2581.6 and eur = -409368 and  hkd = -3319.2','')")

    con:query("insert into check_sql values(-3687,'delete from transaction_total_check where cny = -3687 and jpy = -368700 and gbp = -2580.9 and eur = -409257 and  hkd = -3318.3','')")

    con:query("insert into check_sql values(-3686,'delete from transaction_total_check where cny = -3686 and jpy = -368600 and gbp = -2580.2 and eur = -409146 and  hkd = -3317.4','')")

    con:query("insert into check_sql values(-3685,'delete from transaction_total_check where cny = -3685 and jpy = -368500 and gbp = -2579.5 and eur = -409035 and  hkd = -3316.5','')")

    con:query("insert into check_sql values(-3684,'delete from transaction_total_check where cny = -3684 and jpy = -368400 and gbp = -2578.8 and eur = -408924 and  hkd = -3315.6','')")

    con:query("insert into check_sql values(-3683,'delete from transaction_total_check where cny = -3683 and jpy = -368300 and gbp = -2578.1 and eur = -408813 and  hkd = -3314.7','')")

    con:query("insert into check_sql values(-3682,'delete from transaction_total_check where cny = -3682 and jpy = -368200 and gbp = -2577.4 and eur = -408702 and  hkd = -3313.8','')")

    con:query("insert into check_sql values(-3681,'delete from transaction_total_check where cny = -3681 and jpy = -368100 and gbp = -2576.7 and eur = -408591 and  hkd = -3312.9','')")

    con:query("insert into check_sql values(-3680,'delete from transaction_total_check where cny = -3680 and jpy = -368000 and gbp = -2576.0 and eur = -408480 and  hkd = -3312.0','')")

    con:query("insert into check_sql values(-3679,'delete from transaction_total_check where cny = -3679 and jpy = -367900 and gbp = -2575.3 and eur = -408369 and  hkd = -3311.1','')")

    con:query("insert into check_sql values(-3678,'delete from transaction_total_check where cny = -3678 and jpy = -367800 and gbp = -2574.6 and eur = -408258 and  hkd = -3310.2','')")

    con:query("insert into check_sql values(-3677,'delete from transaction_total_check where cny = -3677 and jpy = -367700 and gbp = -2573.9 and eur = -408147 and  hkd = -3309.3','')")

    con:query("insert into check_sql values(-3676,'delete from transaction_total_check where cny = -3676 and jpy = -367600 and gbp = -2573.2 and eur = -408036 and  hkd = -3308.4','')")

    con:query("insert into check_sql values(-3675,'delete from transaction_total_check where cny = -3675 and jpy = -367500 and gbp = -2572.5 and eur = -407925 and  hkd = -3307.5','')")

    con:query("insert into check_sql values(-3674,'delete from transaction_total_check where cny = -3674 and jpy = -367400 and gbp = -2571.8 and eur = -407814 and  hkd = -3306.6','')")

    con:query("insert into check_sql values(-3673,'delete from transaction_total_check where cny = -3673 and jpy = -367300 and gbp = -2571.1 and eur = -407703 and  hkd = -3305.7','')")

    con:query("insert into check_sql values(-3672,'delete from transaction_total_check where cny = -3672 and jpy = -367200 and gbp = -2570.4 and eur = -407592 and  hkd = -3304.8','')")

    con:query("insert into check_sql values(-3671,'delete from transaction_total_check where cny = -3671 and jpy = -367100 and gbp = -2569.7 and eur = -407481 and  hkd = -3303.9','')")

    con:query("insert into check_sql values(-3670,'delete from transaction_total_check where cny = -3670 and jpy = -367000 and gbp = -2569.0 and eur = -407370 and  hkd = -3303.0','')")

    con:query("insert into check_sql values(-3669,'delete from transaction_total_check where cny = -3669 and jpy = -366900 and gbp = -2568.3 and eur = -407259 and  hkd = -3302.1','')")

    con:query("insert into check_sql values(-3668,'delete from transaction_total_check where cny = -3668 and jpy = -366800 and gbp = -2567.6 and eur = -407148 and  hkd = -3301.2','')")

    con:query("insert into check_sql values(-3667,'delete from transaction_total_check where cny = -3667 and jpy = -366700 and gbp = -2566.9 and eur = -407037 and  hkd = -3300.3','')")

    con:query("insert into check_sql values(-3666,'delete from transaction_total_check where cny = -3666 and jpy = -366600 and gbp = -2566.2 and eur = -406926 and  hkd = -3299.4','')")

    con:query("insert into check_sql values(-3665,'delete from transaction_total_check where cny = -3665 and jpy = -366500 and gbp = -2565.5 and eur = -406815 and  hkd = -3298.5','')")

    con:query("insert into check_sql values(-3664,'delete from transaction_total_check where cny = -3664 and jpy = -366400 and gbp = -2564.8 and eur = -406704 and  hkd = -3297.6','')")

    con:query("insert into check_sql values(-3663,'delete from transaction_total_check where cny = -3663 and jpy = -366300 and gbp = -2564.1 and eur = -406593 and  hkd = -3296.7','')")

    con:query("insert into check_sql values(-3662,'delete from transaction_total_check where cny = -3662 and jpy = -366200 and gbp = -2563.4 and eur = -406482 and  hkd = -3295.8','')")

    con:query("insert into check_sql values(-3661,'delete from transaction_total_check where cny = -3661 and jpy = -366100 and gbp = -2562.7 and eur = -406371 and  hkd = -3294.9','')")

    con:query("insert into check_sql values(-3660,'delete from transaction_total_check where cny = -3660 and jpy = -366000 and gbp = -2562.0 and eur = -406260 and  hkd = -3294.0','')")

    con:query("insert into check_sql values(-3659,'delete from transaction_total_check where cny = -3659 and jpy = -365900 and gbp = -2561.3 and eur = -406149 and  hkd = -3293.1','')")

    con:query("insert into check_sql values(-3658,'delete from transaction_total_check where cny = -3658 and jpy = -365800 and gbp = -2560.6 and eur = -406038 and  hkd = -3292.2','')")

    con:query("insert into check_sql values(-3657,'delete from transaction_total_check where cny = -3657 and jpy = -365700 and gbp = -2559.9 and eur = -405927 and  hkd = -3291.3','')")

    con:query("insert into check_sql values(-3656,'delete from transaction_total_check where cny = -3656 and jpy = -365600 and gbp = -2559.2 and eur = -405816 and  hkd = -3290.4','')")

    con:query("insert into check_sql values(-3655,'delete from transaction_total_check where cny = -3655 and jpy = -365500 and gbp = -2558.5 and eur = -405705 and  hkd = -3289.5','')")

    con:query("insert into check_sql values(-3654,'delete from transaction_total_check where cny = -3654 and jpy = -365400 and gbp = -2557.8 and eur = -405594 and  hkd = -3288.6','')")

    con:query("insert into check_sql values(-3653,'delete from transaction_total_check where cny = -3653 and jpy = -365300 and gbp = -2557.1 and eur = -405483 and  hkd = -3287.7','')")

    con:query("insert into check_sql values(-3652,'delete from transaction_total_check where cny = -3652 and jpy = -365200 and gbp = -2556.4 and eur = -405372 and  hkd = -3286.8','')")

    con:query("insert into check_sql values(-3651,'delete from transaction_total_check where cny = -3651 and jpy = -365100 and gbp = -2555.7 and eur = -405261 and  hkd = -3285.9','')")

    con:query("insert into check_sql values(-3650,'delete from transaction_total_check where cny = -3650 and jpy = -365000 and gbp = -2555.0 and eur = -405150 and  hkd = -3285.0','')")

    con:query("insert into check_sql values(-3649,'delete from transaction_total_check where cny = -3649 and jpy = -364900 and gbp = -2554.3 and eur = -405039 and  hkd = -3284.1','')")

    con:query("insert into check_sql values(-3648,'delete from transaction_total_check where cny = -3648 and jpy = -364800 and gbp = -2553.6 and eur = -404928 and  hkd = -3283.2','')")

    con:query("insert into check_sql values(-3647,'delete from transaction_total_check where cny = -3647 and jpy = -364700 and gbp = -2552.9 and eur = -404817 and  hkd = -3282.3','')")

    con:query("insert into check_sql values(-3646,'delete from transaction_total_check where cny = -3646 and jpy = -364600 and gbp = -2552.2 and eur = -404706 and  hkd = -3281.4','')")

    con:query("insert into check_sql values(-3645,'delete from transaction_total_check where cny = -3645 and jpy = -364500 and gbp = -2551.5 and eur = -404595 and  hkd = -3280.5','')")

    con:query("insert into check_sql values(-3644,'delete from transaction_total_check where cny = -3644 and jpy = -364400 and gbp = -2550.8 and eur = -404484 and  hkd = -3279.6','')")

    con:query("insert into check_sql values(-3643,'delete from transaction_total_check where cny = -3643 and jpy = -364300 and gbp = -2550.1 and eur = -404373 and  hkd = -3278.7','')")

    con:query("insert into check_sql values(-3642,'delete from transaction_total_check where cny = -3642 and jpy = -364200 and gbp = -2549.4 and eur = -404262 and  hkd = -3277.8','')")

    con:query("insert into check_sql values(-3641,'delete from transaction_total_check where cny = -3641 and jpy = -364100 and gbp = -2548.7 and eur = -404151 and  hkd = -3276.9','')")

    con:query("insert into check_sql values(-3640,'delete from transaction_total_check where cny = -3640 and jpy = -364000 and gbp = -2548.0 and eur = -404040 and  hkd = -3276.0','')")

    con:query("insert into check_sql values(-3639,'delete from transaction_total_check where cny = -3639 and jpy = -363900 and gbp = -2547.3 and eur = -403929 and  hkd = -3275.1','')")

    con:query("insert into check_sql values(-3638,'delete from transaction_total_check where cny = -3638 and jpy = -363800 and gbp = -2546.6 and eur = -403818 and  hkd = -3274.2','')")

    con:query("insert into check_sql values(-3637,'delete from transaction_total_check where cny = -3637 and jpy = -363700 and gbp = -2545.9 and eur = -403707 and  hkd = -3273.3','')")

    con:query("insert into check_sql values(-3636,'delete from transaction_total_check where cny = -3636 and jpy = -363600 and gbp = -2545.2 and eur = -403596 and  hkd = -3272.4','')")

    con:query("insert into check_sql values(-3635,'delete from transaction_total_check where cny = -3635 and jpy = -363500 and gbp = -2544.5 and eur = -403485 and  hkd = -3271.5','')")

    con:query("insert into check_sql values(-3634,'delete from transaction_total_check where cny = -3634 and jpy = -363400 and gbp = -2543.8 and eur = -403374 and  hkd = -3270.6','')")

    con:query("insert into check_sql values(-3633,'delete from transaction_total_check where cny = -3633 and jpy = -363300 and gbp = -2543.1 and eur = -403263 and  hkd = -3269.7','')")

    con:query("insert into check_sql values(-3632,'delete from transaction_total_check where cny = -3632 and jpy = -363200 and gbp = -2542.4 and eur = -403152 and  hkd = -3268.8','')")

    con:query("insert into check_sql values(-3631,'delete from transaction_total_check where cny = -3631 and jpy = -363100 and gbp = -2541.7 and eur = -403041 and  hkd = -3267.9','')")

    con:query("insert into check_sql values(-3630,'delete from transaction_total_check where cny = -3630 and jpy = -363000 and gbp = -2541.0 and eur = -402930 and  hkd = -3267.0','')")

    con:query("insert into check_sql values(-3629,'delete from transaction_total_check where cny = -3629 and jpy = -362900 and gbp = -2540.3 and eur = -402819 and  hkd = -3266.1','')")

    con:query("insert into check_sql values(-3628,'delete from transaction_total_check where cny = -3628 and jpy = -362800 and gbp = -2539.6 and eur = -402708 and  hkd = -3265.2','')")

    con:query("insert into check_sql values(-3627,'delete from transaction_total_check where cny = -3627 and jpy = -362700 and gbp = -2538.9 and eur = -402597 and  hkd = -3264.3','')")

    con:query("insert into check_sql values(-3626,'delete from transaction_total_check where cny = -3626 and jpy = -362600 and gbp = -2538.2 and eur = -402486 and  hkd = -3263.4','')")

    con:query("insert into check_sql values(-3625,'delete from transaction_total_check where cny = -3625 and jpy = -362500 and gbp = -2537.5 and eur = -402375 and  hkd = -3262.5','')")

    con:query("insert into check_sql values(-3624,'delete from transaction_total_check where cny = -3624 and jpy = -362400 and gbp = -2536.8 and eur = -402264 and  hkd = -3261.6','')")

    con:query("insert into check_sql values(-3623,'delete from transaction_total_check where cny = -3623 and jpy = -362300 and gbp = -2536.1 and eur = -402153 and  hkd = -3260.7','')")

    con:query("insert into check_sql values(-3622,'delete from transaction_total_check where cny = -3622 and jpy = -362200 and gbp = -2535.4 and eur = -402042 and  hkd = -3259.8','')")

    con:query("insert into check_sql values(-3621,'delete from transaction_total_check where cny = -3621 and jpy = -362100 and gbp = -2534.7 and eur = -401931 and  hkd = -3258.9','')")

    con:query("insert into check_sql values(-3620,'delete from transaction_total_check where cny = -3620 and jpy = -362000 and gbp = -2534.0 and eur = -401820 and  hkd = -3258.0','')")

    con:query("insert into check_sql values(-3619,'delete from transaction_total_check where cny = -3619 and jpy = -361900 and gbp = -2533.3 and eur = -401709 and  hkd = -3257.1','')")

    con:query("insert into check_sql values(-3618,'delete from transaction_total_check where cny = -3618 and jpy = -361800 and gbp = -2532.6 and eur = -401598 and  hkd = -3256.2','')")

    con:query("insert into check_sql values(-3617,'delete from transaction_total_check where cny = -3617 and jpy = -361700 and gbp = -2531.9 and eur = -401487 and  hkd = -3255.3','')")

    con:query("insert into check_sql values(-3616,'delete from transaction_total_check where cny = -3616 and jpy = -361600 and gbp = -2531.2 and eur = -401376 and  hkd = -3254.4','')")

    con:query("insert into check_sql values(-3615,'delete from transaction_total_check where cny = -3615 and jpy = -361500 and gbp = -2530.5 and eur = -401265 and  hkd = -3253.5','')")

    con:query("insert into check_sql values(-3614,'delete from transaction_total_check where cny = -3614 and jpy = -361400 and gbp = -2529.8 and eur = -401154 and  hkd = -3252.6','')")

    con:query("insert into check_sql values(-3613,'delete from transaction_total_check where cny = -3613 and jpy = -361300 and gbp = -2529.1 and eur = -401043 and  hkd = -3251.7','')")

    con:query("insert into check_sql values(-3612,'delete from transaction_total_check where cny = -3612 and jpy = -361200 and gbp = -2528.4 and eur = -400932 and  hkd = -3250.8','')")

    con:query("insert into check_sql values(-3611,'delete from transaction_total_check where cny = -3611 and jpy = -361100 and gbp = -2527.7 and eur = -400821 and  hkd = -3249.9','')")

    con:query("insert into check_sql values(-3610,'delete from transaction_total_check where cny = -3610 and jpy = -361000 and gbp = -2527.0 and eur = -400710 and  hkd = -3249.0','')")

    con:query("insert into check_sql values(-3609,'delete from transaction_total_check where cny = -3609 and jpy = -360900 and gbp = -2526.3 and eur = -400599 and  hkd = -3248.1','')")

    con:query("insert into check_sql values(-3608,'delete from transaction_total_check where cny = -3608 and jpy = -360800 and gbp = -2525.6 and eur = -400488 and  hkd = -3247.2','')")

    con:query("insert into check_sql values(-3607,'delete from transaction_total_check where cny = -3607 and jpy = -360700 and gbp = -2524.9 and eur = -400377 and  hkd = -3246.3','')")

    con:query("insert into check_sql values(-3606,'delete from transaction_total_check where cny = -3606 and jpy = -360600 and gbp = -2524.2 and eur = -400266 and  hkd = -3245.4','')")

    con:query("insert into check_sql values(-3605,'delete from transaction_total_check where cny = -3605 and jpy = -360500 and gbp = -2523.5 and eur = -400155 and  hkd = -3244.5','')")

    con:query("insert into check_sql values(-3604,'delete from transaction_total_check where cny = -3604 and jpy = -360400 and gbp = -2522.8 and eur = -400044 and  hkd = -3243.6','')")

    con:query("insert into check_sql values(-3603,'delete from transaction_total_check where cny = -3603 and jpy = -360300 and gbp = -2522.1 and eur = -399933 and  hkd = -3242.7','')")

    con:query("insert into check_sql values(-3602,'delete from transaction_total_check where cny = -3602 and jpy = -360200 and gbp = -2521.4 and eur = -399822 and  hkd = -3241.8','')")

    con:query("insert into check_sql values(-3601,'delete from transaction_total_check where cny = -3601 and jpy = -360100 and gbp = -2520.7 and eur = -399711 and  hkd = -3240.9','')")

    con:query("insert into check_sql values(-3600,'delete from transaction_total_check where cny = -3600 and jpy = -360000 and gbp = -2520.0 and eur = -399600 and  hkd = -3240.0','')")

    con:query("insert into check_sql values(-3599,'delete from transaction_total_check where cny = -3599 and jpy = -359900 and gbp = -2519.3 and eur = -399489 and  hkd = -3239.1','')")

    con:query("insert into check_sql values(-3598,'delete from transaction_total_check where cny = -3598 and jpy = -359800 and gbp = -2518.6 and eur = -399378 and  hkd = -3238.2','')")

    con:query("insert into check_sql values(-3597,'delete from transaction_total_check where cny = -3597 and jpy = -359700 and gbp = -2517.9 and eur = -399267 and  hkd = -3237.3','')")

    con:query("insert into check_sql values(-3596,'delete from transaction_total_check where cny = -3596 and jpy = -359600 and gbp = -2517.2 and eur = -399156 and  hkd = -3236.4','')")

    con:query("insert into check_sql values(-3595,'delete from transaction_total_check where cny = -3595 and jpy = -359500 and gbp = -2516.5 and eur = -399045 and  hkd = -3235.5','')")

    con:query("insert into check_sql values(-3594,'delete from transaction_total_check where cny = -3594 and jpy = -359400 and gbp = -2515.8 and eur = -398934 and  hkd = -3234.6','')")

    con:query("insert into check_sql values(-3593,'delete from transaction_total_check where cny = -3593 and jpy = -359300 and gbp = -2515.1 and eur = -398823 and  hkd = -3233.7','')")

    con:query("insert into check_sql values(-3592,'delete from transaction_total_check where cny = -3592 and jpy = -359200 and gbp = -2514.4 and eur = -398712 and  hkd = -3232.8','')")

    con:query("insert into check_sql values(-3591,'delete from transaction_total_check where cny = -3591 and jpy = -359100 and gbp = -2513.7 and eur = -398601 and  hkd = -3231.9','')")

    con:query("insert into check_sql values(-3590,'delete from transaction_total_check where cny = -3590 and jpy = -359000 and gbp = -2513.0 and eur = -398490 and  hkd = -3231.0','')")

    con:query("insert into check_sql values(-3589,'delete from transaction_total_check where cny = -3589 and jpy = -358900 and gbp = -2512.3 and eur = -398379 and  hkd = -3230.1','')")

    con:query("insert into check_sql values(-3588,'delete from transaction_total_check where cny = -3588 and jpy = -358800 and gbp = -2511.6 and eur = -398268 and  hkd = -3229.2','')")

    con:query("insert into check_sql values(-3587,'delete from transaction_total_check where cny = -3587 and jpy = -358700 and gbp = -2510.9 and eur = -398157 and  hkd = -3228.3','')")

    con:query("insert into check_sql values(-3586,'delete from transaction_total_check where cny = -3586 and jpy = -358600 and gbp = -2510.2 and eur = -398046 and  hkd = -3227.4','')")

    con:query("insert into check_sql values(-3585,'delete from transaction_total_check where cny = -3585 and jpy = -358500 and gbp = -2509.5 and eur = -397935 and  hkd = -3226.5','')")

    con:query("insert into check_sql values(-3584,'delete from transaction_total_check where cny = -3584 and jpy = -358400 and gbp = -2508.8 and eur = -397824 and  hkd = -3225.6','')")

    con:query("insert into check_sql values(-3583,'delete from transaction_total_check where cny = -3583 and jpy = -358300 and gbp = -2508.1 and eur = -397713 and  hkd = -3224.7','')")

    con:query("insert into check_sql values(-3582,'delete from transaction_total_check where cny = -3582 and jpy = -358200 and gbp = -2507.4 and eur = -397602 and  hkd = -3223.8','')")

    con:query("insert into check_sql values(-3581,'delete from transaction_total_check where cny = -3581 and jpy = -358100 and gbp = -2506.7 and eur = -397491 and  hkd = -3222.9','')")

    con:query("insert into check_sql values(-3580,'delete from transaction_total_check where cny = -3580 and jpy = -358000 and gbp = -2506.0 and eur = -397380 and  hkd = -3222.0','')")

    con:query("insert into check_sql values(-3579,'delete from transaction_total_check where cny = -3579 and jpy = -357900 and gbp = -2505.3 and eur = -397269 and  hkd = -3221.1','')")

    con:query("insert into check_sql values(-3578,'delete from transaction_total_check where cny = -3578 and jpy = -357800 and gbp = -2504.6 and eur = -397158 and  hkd = -3220.2','')")

    con:query("insert into check_sql values(-3577,'delete from transaction_total_check where cny = -3577 and jpy = -357700 and gbp = -2503.9 and eur = -397047 and  hkd = -3219.3','')")

    con:query("insert into check_sql values(-3576,'delete from transaction_total_check where cny = -3576 and jpy = -357600 and gbp = -2503.2 and eur = -396936 and  hkd = -3218.4','')")

    con:query("insert into check_sql values(-3575,'delete from transaction_total_check where cny = -3575 and jpy = -357500 and gbp = -2502.5 and eur = -396825 and  hkd = -3217.5','')")

    con:query("insert into check_sql values(-3574,'delete from transaction_total_check where cny = -3574 and jpy = -357400 and gbp = -2501.8 and eur = -396714 and  hkd = -3216.6','')")

    con:query("insert into check_sql values(-3573,'delete from transaction_total_check where cny = -3573 and jpy = -357300 and gbp = -2501.1 and eur = -396603 and  hkd = -3215.7','')")

    con:query("insert into check_sql values(-3572,'delete from transaction_total_check where cny = -3572 and jpy = -357200 and gbp = -2500.4 and eur = -396492 and  hkd = -3214.8','')")

    con:query("insert into check_sql values(-3571,'delete from transaction_total_check where cny = -3571 and jpy = -357100 and gbp = -2499.7 and eur = -396381 and  hkd = -3213.9','')")

    con:query("insert into check_sql values(-3570,'delete from transaction_total_check where cny = -3570 and jpy = -357000 and gbp = -2499.0 and eur = -396270 and  hkd = -3213.0','')")

    con:query("insert into check_sql values(-3569,'delete from transaction_total_check where cny = -3569 and jpy = -356900 and gbp = -2498.3 and eur = -396159 and  hkd = -3212.1','')")

    con:query("insert into check_sql values(-3568,'delete from transaction_total_check where cny = -3568 and jpy = -356800 and gbp = -2497.6 and eur = -396048 and  hkd = -3211.2','')")

    con:query("insert into check_sql values(-3567,'delete from transaction_total_check where cny = -3567 and jpy = -356700 and gbp = -2496.9 and eur = -395937 and  hkd = -3210.3','')")

    con:query("insert into check_sql values(-3566,'delete from transaction_total_check where cny = -3566 and jpy = -356600 and gbp = -2496.2 and eur = -395826 and  hkd = -3209.4','')")

    con:query("insert into check_sql values(-3565,'delete from transaction_total_check where cny = -3565 and jpy = -356500 and gbp = -2495.5 and eur = -395715 and  hkd = -3208.5','')")

    con:query("insert into check_sql values(-3564,'delete from transaction_total_check where cny = -3564 and jpy = -356400 and gbp = -2494.8 and eur = -395604 and  hkd = -3207.6','')")

    con:query("insert into check_sql values(-3563,'delete from transaction_total_check where cny = -3563 and jpy = -356300 and gbp = -2494.1 and eur = -395493 and  hkd = -3206.7','')")

    con:query("insert into check_sql values(-3562,'delete from transaction_total_check where cny = -3562 and jpy = -356200 and gbp = -2493.4 and eur = -395382 and  hkd = -3205.8','')")

    con:query("insert into check_sql values(-3561,'delete from transaction_total_check where cny = -3561 and jpy = -356100 and gbp = -2492.7 and eur = -395271 and  hkd = -3204.9','')")

    con:query("insert into check_sql values(-3560,'delete from transaction_total_check where cny = -3560 and jpy = -356000 and gbp = -2492.0 and eur = -395160 and  hkd = -3204.0','')")

    con:query("insert into check_sql values(-3559,'delete from transaction_total_check where cny = -3559 and jpy = -355900 and gbp = -2491.3 and eur = -395049 and  hkd = -3203.1','')")

    con:query("insert into check_sql values(-3558,'delete from transaction_total_check where cny = -3558 and jpy = -355800 and gbp = -2490.6 and eur = -394938 and  hkd = -3202.2','')")

    con:query("insert into check_sql values(-3557,'delete from transaction_total_check where cny = -3557 and jpy = -355700 and gbp = -2489.9 and eur = -394827 and  hkd = -3201.3','')")

    con:query("insert into check_sql values(-3556,'delete from transaction_total_check where cny = -3556 and jpy = -355600 and gbp = -2489.2 and eur = -394716 and  hkd = -3200.4','')")

    con:query("insert into check_sql values(-3555,'delete from transaction_total_check where cny = -3555 and jpy = -355500 and gbp = -2488.5 and eur = -394605 and  hkd = -3199.5','')")

    con:query("insert into check_sql values(-3554,'delete from transaction_total_check where cny = -3554 and jpy = -355400 and gbp = -2487.8 and eur = -394494 and  hkd = -3198.6','')")

    con:query("insert into check_sql values(-3553,'delete from transaction_total_check where cny = -3553 and jpy = -355300 and gbp = -2487.1 and eur = -394383 and  hkd = -3197.7','')")

    con:query("insert into check_sql values(-3552,'delete from transaction_total_check where cny = -3552 and jpy = -355200 and gbp = -2486.4 and eur = -394272 and  hkd = -3196.8','')")

    con:query("insert into check_sql values(-3551,'delete from transaction_total_check where cny = -3551 and jpy = -355100 and gbp = -2485.7 and eur = -394161 and  hkd = -3195.9','')")

    con:query("insert into check_sql values(-3550,'delete from transaction_total_check where cny = -3550 and jpy = -355000 and gbp = -2485.0 and eur = -394050 and  hkd = -3195.0','')")

    con:query("insert into check_sql values(-3549,'delete from transaction_total_check where cny = -3549 and jpy = -354900 and gbp = -2484.3 and eur = -393939 and  hkd = -3194.1','')")

    con:query("insert into check_sql values(-3548,'delete from transaction_total_check where cny = -3548 and jpy = -354800 and gbp = -2483.6 and eur = -393828 and  hkd = -3193.2','')")

    con:query("insert into check_sql values(-3547,'delete from transaction_total_check where cny = -3547 and jpy = -354700 and gbp = -2482.9 and eur = -393717 and  hkd = -3192.3','')")

    con:query("insert into check_sql values(-3546,'delete from transaction_total_check where cny = -3546 and jpy = -354600 and gbp = -2482.2 and eur = -393606 and  hkd = -3191.4','')")

    con:query("insert into check_sql values(-3545,'delete from transaction_total_check where cny = -3545 and jpy = -354500 and gbp = -2481.5 and eur = -393495 and  hkd = -3190.5','')")

    con:query("insert into check_sql values(-3544,'delete from transaction_total_check where cny = -3544 and jpy = -354400 and gbp = -2480.8 and eur = -393384 and  hkd = -3189.6','')")

    con:query("insert into check_sql values(-3543,'delete from transaction_total_check where cny = -3543 and jpy = -354300 and gbp = -2480.1 and eur = -393273 and  hkd = -3188.7','')")

    con:query("insert into check_sql values(-3542,'delete from transaction_total_check where cny = -3542 and jpy = -354200 and gbp = -2479.4 and eur = -393162 and  hkd = -3187.8','')")

    con:query("insert into check_sql values(-3541,'delete from transaction_total_check where cny = -3541 and jpy = -354100 and gbp = -2478.7 and eur = -393051 and  hkd = -3186.9','')")

    con:query("insert into check_sql values(-3540,'delete from transaction_total_check where cny = -3540 and jpy = -354000 and gbp = -2478.0 and eur = -392940 and  hkd = -3186.0','')")

    con:query("insert into check_sql values(-3539,'delete from transaction_total_check where cny = -3539 and jpy = -353900 and gbp = -2477.3 and eur = -392829 and  hkd = -3185.1','')")

    con:query("insert into check_sql values(-3538,'delete from transaction_total_check where cny = -3538 and jpy = -353800 and gbp = -2476.6 and eur = -392718 and  hkd = -3184.2','')")

    con:query("insert into check_sql values(-3537,'delete from transaction_total_check where cny = -3537 and jpy = -353700 and gbp = -2475.9 and eur = -392607 and  hkd = -3183.3','')")

    con:query("insert into check_sql values(-3536,'delete from transaction_total_check where cny = -3536 and jpy = -353600 and gbp = -2475.2 and eur = -392496 and  hkd = -3182.4','')")

    con:query("insert into check_sql values(-3535,'delete from transaction_total_check where cny = -3535 and jpy = -353500 and gbp = -2474.5 and eur = -392385 and  hkd = -3181.5','')")

    con:query("insert into check_sql values(-3534,'delete from transaction_total_check where cny = -3534 and jpy = -353400 and gbp = -2473.8 and eur = -392274 and  hkd = -3180.6','')")

    con:query("insert into check_sql values(-3533,'delete from transaction_total_check where cny = -3533 and jpy = -353300 and gbp = -2473.1 and eur = -392163 and  hkd = -3179.7','')")

    con:query("insert into check_sql values(-3532,'delete from transaction_total_check where cny = -3532 and jpy = -353200 and gbp = -2472.4 and eur = -392052 and  hkd = -3178.8','')")

    con:query("insert into check_sql values(-3531,'delete from transaction_total_check where cny = -3531 and jpy = -353100 and gbp = -2471.7 and eur = -391941 and  hkd = -3177.9','')")

    con:query("insert into check_sql values(-3530,'delete from transaction_total_check where cny = -3530 and jpy = -353000 and gbp = -2471.0 and eur = -391830 and  hkd = -3177.0','')")

    con:query("insert into check_sql values(-3529,'delete from transaction_total_check where cny = -3529 and jpy = -352900 and gbp = -2470.3 and eur = -391719 and  hkd = -3176.1','')")

    con:query("insert into check_sql values(-3528,'delete from transaction_total_check where cny = -3528 and jpy = -352800 and gbp = -2469.6 and eur = -391608 and  hkd = -3175.2','')")

    con:query("insert into check_sql values(-3527,'delete from transaction_total_check where cny = -3527 and jpy = -352700 and gbp = -2468.9 and eur = -391497 and  hkd = -3174.3','')")

    con:query("insert into check_sql values(-3526,'delete from transaction_total_check where cny = -3526 and jpy = -352600 and gbp = -2468.2 and eur = -391386 and  hkd = -3173.4','')")

    con:query("insert into check_sql values(-3525,'delete from transaction_total_check where cny = -3525 and jpy = -352500 and gbp = -2467.5 and eur = -391275 and  hkd = -3172.5','')")

    con:query("insert into check_sql values(-3524,'delete from transaction_total_check where cny = -3524 and jpy = -352400 and gbp = -2466.8 and eur = -391164 and  hkd = -3171.6','')")

    con:query("insert into check_sql values(-3523,'delete from transaction_total_check where cny = -3523 and jpy = -352300 and gbp = -2466.1 and eur = -391053 and  hkd = -3170.7','')")

    con:query("insert into check_sql values(-3522,'delete from transaction_total_check where cny = -3522 and jpy = -352200 and gbp = -2465.4 and eur = -390942 and  hkd = -3169.8','')")

    con:query("insert into check_sql values(-3521,'delete from transaction_total_check where cny = -3521 and jpy = -352100 and gbp = -2464.7 and eur = -390831 and  hkd = -3168.9','')")

    con:query("insert into check_sql values(-3520,'delete from transaction_total_check where cny = -3520 and jpy = -352000 and gbp = -2464.0 and eur = -390720 and  hkd = -3168.0','')")

    con:query("insert into check_sql values(-3519,'delete from transaction_total_check where cny = -3519 and jpy = -351900 and gbp = -2463.3 and eur = -390609 and  hkd = -3167.1','')")

    con:query("insert into check_sql values(-3518,'delete from transaction_total_check where cny = -3518 and jpy = -351800 and gbp = -2462.6 and eur = -390498 and  hkd = -3166.2','')")

    con:query("insert into check_sql values(-3517,'delete from transaction_total_check where cny = -3517 and jpy = -351700 and gbp = -2461.9 and eur = -390387 and  hkd = -3165.3','')")

    con:query("insert into check_sql values(-3516,'delete from transaction_total_check where cny = -3516 and jpy = -351600 and gbp = -2461.2 and eur = -390276 and  hkd = -3164.4','')")

    con:query("insert into check_sql values(-3515,'delete from transaction_total_check where cny = -3515 and jpy = -351500 and gbp = -2460.5 and eur = -390165 and  hkd = -3163.5','')")

    con:query("insert into check_sql values(-3514,'delete from transaction_total_check where cny = -3514 and jpy = -351400 and gbp = -2459.8 and eur = -390054 and  hkd = -3162.6','')")

    con:query("insert into check_sql values(-3513,'delete from transaction_total_check where cny = -3513 and jpy = -351300 and gbp = -2459.1 and eur = -389943 and  hkd = -3161.7','')")

    con:query("insert into check_sql values(-3512,'delete from transaction_total_check where cny = -3512 and jpy = -351200 and gbp = -2458.4 and eur = -389832 and  hkd = -3160.8','')")

    con:query("insert into check_sql values(-3511,'delete from transaction_total_check where cny = -3511 and jpy = -351100 and gbp = -2457.7 and eur = -389721 and  hkd = -3159.9','')")

    con:query("insert into check_sql values(-3510,'delete from transaction_total_check where cny = -3510 and jpy = -351000 and gbp = -2457.0 and eur = -389610 and  hkd = -3159.0','')")

    con:query("insert into check_sql values(-3509,'delete from transaction_total_check where cny = -3509 and jpy = -350900 and gbp = -2456.3 and eur = -389499 and  hkd = -3158.1','')")

    con:query("insert into check_sql values(-3508,'delete from transaction_total_check where cny = -3508 and jpy = -350800 and gbp = -2455.6 and eur = -389388 and  hkd = -3157.2','')")

    con:query("insert into check_sql values(-3507,'delete from transaction_total_check where cny = -3507 and jpy = -350700 and gbp = -2454.9 and eur = -389277 and  hkd = -3156.3','')")

    con:query("insert into check_sql values(-3506,'delete from transaction_total_check where cny = -3506 and jpy = -350600 and gbp = -2454.2 and eur = -389166 and  hkd = -3155.4','')")

    con:query("insert into check_sql values(-3505,'delete from transaction_total_check where cny = -3505 and jpy = -350500 and gbp = -2453.5 and eur = -389055 and  hkd = -3154.5','')")

    con:query("insert into check_sql values(-3504,'delete from transaction_total_check where cny = -3504 and jpy = -350400 and gbp = -2452.8 and eur = -388944 and  hkd = -3153.6','')")

    con:query("insert into check_sql values(-3503,'delete from transaction_total_check where cny = -3503 and jpy = -350300 and gbp = -2452.1 and eur = -388833 and  hkd = -3152.7','')")

    con:query("insert into check_sql values(-3502,'delete from transaction_total_check where cny = -3502 and jpy = -350200 and gbp = -2451.4 and eur = -388722 and  hkd = -3151.8','')")

    con:query("insert into check_sql values(-3501,'delete from transaction_total_check where cny = -3501 and jpy = -350100 and gbp = -2450.7 and eur = -388611 and  hkd = -3150.9','')")

    con:query("insert into check_sql values(-3500,'delete from transaction_total_check where cny = -3500 and jpy = -350000 and gbp = -2450.0 and eur = -388500 and  hkd = -3150.0','')")

    con:query("insert into check_sql values(-3499,'delete from transaction_total_check where cny = -3499 and jpy = -349900 and gbp = -2449.3 and eur = -388389 and  hkd = -3149.1','')")

    con:query("insert into check_sql values(-3498,'delete from transaction_total_check where cny = -3498 and jpy = -349800 and gbp = -2448.6 and eur = -388278 and  hkd = -3148.2','')")

    con:query("insert into check_sql values(-3497,'delete from transaction_total_check where cny = -3497 and jpy = -349700 and gbp = -2447.9 and eur = -388167 and  hkd = -3147.3','')")

    con:query("insert into check_sql values(-3496,'delete from transaction_total_check where cny = -3496 and jpy = -349600 and gbp = -2447.2 and eur = -388056 and  hkd = -3146.4','')")

    con:query("insert into check_sql values(-3495,'delete from transaction_total_check where cny = -3495 and jpy = -349500 and gbp = -2446.5 and eur = -387945 and  hkd = -3145.5','')")

    con:query("insert into check_sql values(-3494,'delete from transaction_total_check where cny = -3494 and jpy = -349400 and gbp = -2445.8 and eur = -387834 and  hkd = -3144.6','')")

    con:query("insert into check_sql values(-3493,'delete from transaction_total_check where cny = -3493 and jpy = -349300 and gbp = -2445.1 and eur = -387723 and  hkd = -3143.7','')")

    con:query("insert into check_sql values(-3492,'delete from transaction_total_check where cny = -3492 and jpy = -349200 and gbp = -2444.4 and eur = -387612 and  hkd = -3142.8','')")

    con:query("insert into check_sql values(-3491,'delete from transaction_total_check where cny = -3491 and jpy = -349100 and gbp = -2443.7 and eur = -387501 and  hkd = -3141.9','')")

    con:query("insert into check_sql values(-3490,'delete from transaction_total_check where cny = -3490 and jpy = -349000 and gbp = -2443.0 and eur = -387390 and  hkd = -3141.0','')")

    con:query("insert into check_sql values(-3489,'delete from transaction_total_check where cny = -3489 and jpy = -348900 and gbp = -2442.3 and eur = -387279 and  hkd = -3140.1','')")

    con:query("insert into check_sql values(-3488,'delete from transaction_total_check where cny = -3488 and jpy = -348800 and gbp = -2441.6 and eur = -387168 and  hkd = -3139.2','')")

    con:query("insert into check_sql values(-3487,'delete from transaction_total_check where cny = -3487 and jpy = -348700 and gbp = -2440.9 and eur = -387057 and  hkd = -3138.3','')")

    con:query("insert into check_sql values(-3486,'delete from transaction_total_check where cny = -3486 and jpy = -348600 and gbp = -2440.2 and eur = -386946 and  hkd = -3137.4','')")

    con:query("insert into check_sql values(-3485,'delete from transaction_total_check where cny = -3485 and jpy = -348500 and gbp = -2439.5 and eur = -386835 and  hkd = -3136.5','')")

    con:query("insert into check_sql values(-3484,'delete from transaction_total_check where cny = -3484 and jpy = -348400 and gbp = -2438.8 and eur = -386724 and  hkd = -3135.6','')")

    con:query("insert into check_sql values(-3483,'delete from transaction_total_check where cny = -3483 and jpy = -348300 and gbp = -2438.1 and eur = -386613 and  hkd = -3134.7','')")

    con:query("insert into check_sql values(-3482,'delete from transaction_total_check where cny = -3482 and jpy = -348200 and gbp = -2437.4 and eur = -386502 and  hkd = -3133.8','')")

    con:query("insert into check_sql values(-3481,'delete from transaction_total_check where cny = -3481 and jpy = -348100 and gbp = -2436.7 and eur = -386391 and  hkd = -3132.9','')")

    con:query("insert into check_sql values(-3480,'delete from transaction_total_check where cny = -3480 and jpy = -348000 and gbp = -2436.0 and eur = -386280 and  hkd = -3132.0','')")

    con:query("insert into check_sql values(-3479,'delete from transaction_total_check where cny = -3479 and jpy = -347900 and gbp = -2435.3 and eur = -386169 and  hkd = -3131.1','')")

    con:query("insert into check_sql values(-3478,'delete from transaction_total_check where cny = -3478 and jpy = -347800 and gbp = -2434.6 and eur = -386058 and  hkd = -3130.2','')")

    con:query("insert into check_sql values(-3477,'delete from transaction_total_check where cny = -3477 and jpy = -347700 and gbp = -2433.9 and eur = -385947 and  hkd = -3129.3','')")

    con:query("insert into check_sql values(-3476,'delete from transaction_total_check where cny = -3476 and jpy = -347600 and gbp = -2433.2 and eur = -385836 and  hkd = -3128.4','')")

    con:query("insert into check_sql values(-3475,'delete from transaction_total_check where cny = -3475 and jpy = -347500 and gbp = -2432.5 and eur = -385725 and  hkd = -3127.5','')")

    con:query("insert into check_sql values(-3474,'delete from transaction_total_check where cny = -3474 and jpy = -347400 and gbp = -2431.8 and eur = -385614 and  hkd = -3126.6','')")

    con:query("insert into check_sql values(-3473,'delete from transaction_total_check where cny = -3473 and jpy = -347300 and gbp = -2431.1 and eur = -385503 and  hkd = -3125.7','')")

    con:query("insert into check_sql values(-3472,'delete from transaction_total_check where cny = -3472 and jpy = -347200 and gbp = -2430.4 and eur = -385392 and  hkd = -3124.8','')")

    con:query("insert into check_sql values(-3471,'delete from transaction_total_check where cny = -3471 and jpy = -347100 and gbp = -2429.7 and eur = -385281 and  hkd = -3123.9','')")

    con:query("insert into check_sql values(-3470,'delete from transaction_total_check where cny = -3470 and jpy = -347000 and gbp = -2429.0 and eur = -385170 and  hkd = -3123.0','')")

    con:query("insert into check_sql values(-3469,'delete from transaction_total_check where cny = -3469 and jpy = -346900 and gbp = -2428.3 and eur = -385059 and  hkd = -3122.1','')")

    con:query("insert into check_sql values(-3468,'delete from transaction_total_check where cny = -3468 and jpy = -346800 and gbp = -2427.6 and eur = -384948 and  hkd = -3121.2','')")

    con:query("insert into check_sql values(-3467,'delete from transaction_total_check where cny = -3467 and jpy = -346700 and gbp = -2426.9 and eur = -384837 and  hkd = -3120.3','')")

    con:query("insert into check_sql values(-3466,'delete from transaction_total_check where cny = -3466 and jpy = -346600 and gbp = -2426.2 and eur = -384726 and  hkd = -3119.4','')")

    con:query("insert into check_sql values(-3465,'delete from transaction_total_check where cny = -3465 and jpy = -346500 and gbp = -2425.5 and eur = -384615 and  hkd = -3118.5','')")

    con:query("insert into check_sql values(-3464,'delete from transaction_total_check where cny = -3464 and jpy = -346400 and gbp = -2424.8 and eur = -384504 and  hkd = -3117.6','')")

    con:query("insert into check_sql values(-3463,'delete from transaction_total_check where cny = -3463 and jpy = -346300 and gbp = -2424.1 and eur = -384393 and  hkd = -3116.7','')")

    con:query("insert into check_sql values(-3462,'delete from transaction_total_check where cny = -3462 and jpy = -346200 and gbp = -2423.4 and eur = -384282 and  hkd = -3115.8','')")

    con:query("insert into check_sql values(-3461,'delete from transaction_total_check where cny = -3461 and jpy = -346100 and gbp = -2422.7 and eur = -384171 and  hkd = -3114.9','')")

    con:query("insert into check_sql values(-3460,'delete from transaction_total_check where cny = -3460 and jpy = -346000 and gbp = -2422.0 and eur = -384060 and  hkd = -3114.0','')")

    con:query("insert into check_sql values(-3459,'delete from transaction_total_check where cny = -3459 and jpy = -345900 and gbp = -2421.3 and eur = -383949 and  hkd = -3113.1','')")

    con:query("insert into check_sql values(-3458,'delete from transaction_total_check where cny = -3458 and jpy = -345800 and gbp = -2420.6 and eur = -383838 and  hkd = -3112.2','')")

    con:query("insert into check_sql values(-3457,'delete from transaction_total_check where cny = -3457 and jpy = -345700 and gbp = -2419.9 and eur = -383727 and  hkd = -3111.3','')")

    con:query("insert into check_sql values(-3456,'delete from transaction_total_check where cny = -3456 and jpy = -345600 and gbp = -2419.2 and eur = -383616 and  hkd = -3110.4','')")

    con:query("insert into check_sql values(-3455,'delete from transaction_total_check where cny = -3455 and jpy = -345500 and gbp = -2418.5 and eur = -383505 and  hkd = -3109.5','')")

    con:query("insert into check_sql values(-3454,'delete from transaction_total_check where cny = -3454 and jpy = -345400 and gbp = -2417.8 and eur = -383394 and  hkd = -3108.6','')")

    con:query("insert into check_sql values(-3453,'delete from transaction_total_check where cny = -3453 and jpy = -345300 and gbp = -2417.1 and eur = -383283 and  hkd = -3107.7','')")

    con:query("insert into check_sql values(-3452,'delete from transaction_total_check where cny = -3452 and jpy = -345200 and gbp = -2416.4 and eur = -383172 and  hkd = -3106.8','')")

    con:query("insert into check_sql values(-3451,'delete from transaction_total_check where cny = -3451 and jpy = -345100 and gbp = -2415.7 and eur = -383061 and  hkd = -3105.9','')")

    con:query("insert into check_sql values(-3450,'delete from transaction_total_check where cny = -3450 and jpy = -345000 and gbp = -2415.0 and eur = -382950 and  hkd = -3105.0','')")

    con:query("insert into check_sql values(-3449,'delete from transaction_total_check where cny = -3449 and jpy = -344900 and gbp = -2414.3 and eur = -382839 and  hkd = -3104.1','')")

    con:query("insert into check_sql values(-3448,'delete from transaction_total_check where cny = -3448 and jpy = -344800 and gbp = -2413.6 and eur = -382728 and  hkd = -3103.2','')")

    con:query("insert into check_sql values(-3447,'delete from transaction_total_check where cny = -3447 and jpy = -344700 and gbp = -2412.9 and eur = -382617 and  hkd = -3102.3','')")

    con:query("insert into check_sql values(-3446,'delete from transaction_total_check where cny = -3446 and jpy = -344600 and gbp = -2412.2 and eur = -382506 and  hkd = -3101.4','')")

    con:query("insert into check_sql values(-3445,'delete from transaction_total_check where cny = -3445 and jpy = -344500 and gbp = -2411.5 and eur = -382395 and  hkd = -3100.5','')")

    con:query("insert into check_sql values(-3444,'delete from transaction_total_check where cny = -3444 and jpy = -344400 and gbp = -2410.8 and eur = -382284 and  hkd = -3099.6','')")

    con:query("insert into check_sql values(-3443,'delete from transaction_total_check where cny = -3443 and jpy = -344300 and gbp = -2410.1 and eur = -382173 and  hkd = -3098.7','')")

    con:query("insert into check_sql values(-3442,'delete from transaction_total_check where cny = -3442 and jpy = -344200 and gbp = -2409.4 and eur = -382062 and  hkd = -3097.8','')")

    con:query("insert into check_sql values(-3441,'delete from transaction_total_check where cny = -3441 and jpy = -344100 and gbp = -2408.7 and eur = -381951 and  hkd = -3096.9','')")

    con:query("insert into check_sql values(-3440,'delete from transaction_total_check where cny = -3440 and jpy = -344000 and gbp = -2408.0 and eur = -381840 and  hkd = -3096.0','')")

    con:query("insert into check_sql values(-3439,'delete from transaction_total_check where cny = -3439 and jpy = -343900 and gbp = -2407.3 and eur = -381729 and  hkd = -3095.1','')")

    con:query("insert into check_sql values(-3438,'delete from transaction_total_check where cny = -3438 and jpy = -343800 and gbp = -2406.6 and eur = -381618 and  hkd = -3094.2','')")

    con:query("insert into check_sql values(-3437,'delete from transaction_total_check where cny = -3437 and jpy = -343700 and gbp = -2405.9 and eur = -381507 and  hkd = -3093.3','')")

    con:query("insert into check_sql values(-3436,'delete from transaction_total_check where cny = -3436 and jpy = -343600 and gbp = -2405.2 and eur = -381396 and  hkd = -3092.4','')")

    con:query("insert into check_sql values(-3435,'delete from transaction_total_check where cny = -3435 and jpy = -343500 and gbp = -2404.5 and eur = -381285 and  hkd = -3091.5','')")

    con:query("insert into check_sql values(-3434,'delete from transaction_total_check where cny = -3434 and jpy = -343400 and gbp = -2403.8 and eur = -381174 and  hkd = -3090.6','')")

    con:query("insert into check_sql values(-3433,'delete from transaction_total_check where cny = -3433 and jpy = -343300 and gbp = -2403.1 and eur = -381063 and  hkd = -3089.7','')")

    con:query("insert into check_sql values(-3432,'delete from transaction_total_check where cny = -3432 and jpy = -343200 and gbp = -2402.4 and eur = -380952 and  hkd = -3088.8','')")

    con:query("insert into check_sql values(-3431,'delete from transaction_total_check where cny = -3431 and jpy = -343100 and gbp = -2401.7 and eur = -380841 and  hkd = -3087.9','')")

    con:query("insert into check_sql values(-3430,'delete from transaction_total_check where cny = -3430 and jpy = -343000 and gbp = -2401.0 and eur = -380730 and  hkd = -3087.0','')")

    con:query("insert into check_sql values(-3429,'delete from transaction_total_check where cny = -3429 and jpy = -342900 and gbp = -2400.3 and eur = -380619 and  hkd = -3086.1','')")

    con:query("insert into check_sql values(-3428,'delete from transaction_total_check where cny = -3428 and jpy = -342800 and gbp = -2399.6 and eur = -380508 and  hkd = -3085.2','')")

    con:query("insert into check_sql values(-3427,'delete from transaction_total_check where cny = -3427 and jpy = -342700 and gbp = -2398.9 and eur = -380397 and  hkd = -3084.3','')")

    con:query("insert into check_sql values(-3426,'delete from transaction_total_check where cny = -3426 and jpy = -342600 and gbp = -2398.2 and eur = -380286 and  hkd = -3083.4','')")

    con:query("insert into check_sql values(-3425,'delete from transaction_total_check where cny = -3425 and jpy = -342500 and gbp = -2397.5 and eur = -380175 and  hkd = -3082.5','')")

    con:query("insert into check_sql values(-3424,'delete from transaction_total_check where cny = -3424 and jpy = -342400 and gbp = -2396.8 and eur = -380064 and  hkd = -3081.6','')")

    con:query("insert into check_sql values(-3423,'delete from transaction_total_check where cny = -3423 and jpy = -342300 and gbp = -2396.1 and eur = -379953 and  hkd = -3080.7','')")

    con:query("insert into check_sql values(-3422,'delete from transaction_total_check where cny = -3422 and jpy = -342200 and gbp = -2395.4 and eur = -379842 and  hkd = -3079.8','')")

    con:query("insert into check_sql values(-3421,'delete from transaction_total_check where cny = -3421 and jpy = -342100 and gbp = -2394.7 and eur = -379731 and  hkd = -3078.9','')")

    con:query("insert into check_sql values(-3420,'delete from transaction_total_check where cny = -3420 and jpy = -342000 and gbp = -2394.0 and eur = -379620 and  hkd = -3078.0','')")

    con:query("insert into check_sql values(-3419,'delete from transaction_total_check where cny = -3419 and jpy = -341900 and gbp = -2393.3 and eur = -379509 and  hkd = -3077.1','')")

    con:query("insert into check_sql values(-3418,'delete from transaction_total_check where cny = -3418 and jpy = -341800 and gbp = -2392.6 and eur = -379398 and  hkd = -3076.2','')")

    con:query("insert into check_sql values(-3417,'delete from transaction_total_check where cny = -3417 and jpy = -341700 and gbp = -2391.9 and eur = -379287 and  hkd = -3075.3','')")

    con:query("insert into check_sql values(-3416,'delete from transaction_total_check where cny = -3416 and jpy = -341600 and gbp = -2391.2 and eur = -379176 and  hkd = -3074.4','')")

    con:query("insert into check_sql values(-3415,'delete from transaction_total_check where cny = -3415 and jpy = -341500 and gbp = -2390.5 and eur = -379065 and  hkd = -3073.5','')")

    con:query("insert into check_sql values(-3414,'delete from transaction_total_check where cny = -3414 and jpy = -341400 and gbp = -2389.8 and eur = -378954 and  hkd = -3072.6','')")

    con:query("insert into check_sql values(-3413,'delete from transaction_total_check where cny = -3413 and jpy = -341300 and gbp = -2389.1 and eur = -378843 and  hkd = -3071.7','')")

    con:query("insert into check_sql values(-3412,'delete from transaction_total_check where cny = -3412 and jpy = -341200 and gbp = -2388.4 and eur = -378732 and  hkd = -3070.8','')")

    con:query("insert into check_sql values(-3411,'delete from transaction_total_check where cny = -3411 and jpy = -341100 and gbp = -2387.7 and eur = -378621 and  hkd = -3069.9','')")

    con:query("insert into check_sql values(-3410,'delete from transaction_total_check where cny = -3410 and jpy = -341000 and gbp = -2387.0 and eur = -378510 and  hkd = -3069.0','')")

    con:query("insert into check_sql values(-3409,'delete from transaction_total_check where cny = -3409 and jpy = -340900 and gbp = -2386.3 and eur = -378399 and  hkd = -3068.1','')")

    con:query("insert into check_sql values(-3408,'delete from transaction_total_check where cny = -3408 and jpy = -340800 and gbp = -2385.6 and eur = -378288 and  hkd = -3067.2','')")

    con:query("insert into check_sql values(-3407,'delete from transaction_total_check where cny = -3407 and jpy = -340700 and gbp = -2384.9 and eur = -378177 and  hkd = -3066.3','')")

    con:query("insert into check_sql values(-3406,'delete from transaction_total_check where cny = -3406 and jpy = -340600 and gbp = -2384.2 and eur = -378066 and  hkd = -3065.4','')")

    con:query("insert into check_sql values(-3405,'delete from transaction_total_check where cny = -3405 and jpy = -340500 and gbp = -2383.5 and eur = -377955 and  hkd = -3064.5','')")

    con:query("insert into check_sql values(-3404,'delete from transaction_total_check where cny = -3404 and jpy = -340400 and gbp = -2382.8 and eur = -377844 and  hkd = -3063.6','')")

    con:query("insert into check_sql values(-3403,'delete from transaction_total_check where cny = -3403 and jpy = -340300 and gbp = -2382.1 and eur = -377733 and  hkd = -3062.7','')")

    con:query("insert into check_sql values(-3402,'delete from transaction_total_check where cny = -3402 and jpy = -340200 and gbp = -2381.4 and eur = -377622 and  hkd = -3061.8','')")

    con:query("insert into check_sql values(-3401,'delete from transaction_total_check where cny = -3401 and jpy = -340100 and gbp = -2380.7 and eur = -377511 and  hkd = -3060.9','')")

    con:query("insert into check_sql values(-3400,'delete from transaction_total_check where cny = -3400 and jpy = -340000 and gbp = -2380.0 and eur = -377400 and  hkd = -3060.0','')")

    con:query("insert into check_sql values(-3399,'delete from transaction_total_check where cny = -3399 and jpy = -339900 and gbp = -2379.3 and eur = -377289 and  hkd = -3059.1','')")

    con:query("insert into check_sql values(-3398,'delete from transaction_total_check where cny = -3398 and jpy = -339800 and gbp = -2378.6 and eur = -377178 and  hkd = -3058.2','')")

    con:query("insert into check_sql values(-3397,'delete from transaction_total_check where cny = -3397 and jpy = -339700 and gbp = -2377.9 and eur = -377067 and  hkd = -3057.3','')")

    con:query("insert into check_sql values(-3396,'delete from transaction_total_check where cny = -3396 and jpy = -339600 and gbp = -2377.2 and eur = -376956 and  hkd = -3056.4','')")

    con:query("insert into check_sql values(-3395,'delete from transaction_total_check where cny = -3395 and jpy = -339500 and gbp = -2376.5 and eur = -376845 and  hkd = -3055.5','')")

    con:query("insert into check_sql values(-3394,'delete from transaction_total_check where cny = -3394 and jpy = -339400 and gbp = -2375.8 and eur = -376734 and  hkd = -3054.6','')")

    con:query("insert into check_sql values(-3393,'delete from transaction_total_check where cny = -3393 and jpy = -339300 and gbp = -2375.1 and eur = -376623 and  hkd = -3053.7','')")

    con:query("insert into check_sql values(-3392,'delete from transaction_total_check where cny = -3392 and jpy = -339200 and gbp = -2374.4 and eur = -376512 and  hkd = -3052.8','')")

    con:query("insert into check_sql values(-3391,'delete from transaction_total_check where cny = -3391 and jpy = -339100 and gbp = -2373.7 and eur = -376401 and  hkd = -3051.9','')")

    con:query("insert into check_sql values(-3390,'delete from transaction_total_check where cny = -3390 and jpy = -339000 and gbp = -2373.0 and eur = -376290 and  hkd = -3051.0','')")

    con:query("insert into check_sql values(-3389,'delete from transaction_total_check where cny = -3389 and jpy = -338900 and gbp = -2372.3 and eur = -376179 and  hkd = -3050.1','')")

    con:query("insert into check_sql values(-3388,'delete from transaction_total_check where cny = -3388 and jpy = -338800 and gbp = -2371.6 and eur = -376068 and  hkd = -3049.2','')")

    con:query("insert into check_sql values(-3387,'delete from transaction_total_check where cny = -3387 and jpy = -338700 and gbp = -2370.9 and eur = -375957 and  hkd = -3048.3','')")

    con:query("insert into check_sql values(-3386,'delete from transaction_total_check where cny = -3386 and jpy = -338600 and gbp = -2370.2 and eur = -375846 and  hkd = -3047.4','')")

    con:query("insert into check_sql values(-3385,'delete from transaction_total_check where cny = -3385 and jpy = -338500 and gbp = -2369.5 and eur = -375735 and  hkd = -3046.5','')")

    con:query("insert into check_sql values(-3384,'delete from transaction_total_check where cny = -3384 and jpy = -338400 and gbp = -2368.8 and eur = -375624 and  hkd = -3045.6','')")

    con:query("insert into check_sql values(-3383,'delete from transaction_total_check where cny = -3383 and jpy = -338300 and gbp = -2368.1 and eur = -375513 and  hkd = -3044.7','')")

    con:query("insert into check_sql values(-3382,'delete from transaction_total_check where cny = -3382 and jpy = -338200 and gbp = -2367.4 and eur = -375402 and  hkd = -3043.8','')")

    con:query("insert into check_sql values(-3381,'delete from transaction_total_check where cny = -3381 and jpy = -338100 and gbp = -2366.7 and eur = -375291 and  hkd = -3042.9','')")

    con:query("insert into check_sql values(-3380,'delete from transaction_total_check where cny = -3380 and jpy = -338000 and gbp = -2366.0 and eur = -375180 and  hkd = -3042.0','')")

    con:query("insert into check_sql values(-3379,'delete from transaction_total_check where cny = -3379 and jpy = -337900 and gbp = -2365.3 and eur = -375069 and  hkd = -3041.1','')")

    con:query("insert into check_sql values(-3378,'delete from transaction_total_check where cny = -3378 and jpy = -337800 and gbp = -2364.6 and eur = -374958 and  hkd = -3040.2','')")

    con:query("insert into check_sql values(-3377,'delete from transaction_total_check where cny = -3377 and jpy = -337700 and gbp = -2363.9 and eur = -374847 and  hkd = -3039.3','')")

    con:query("insert into check_sql values(-3376,'delete from transaction_total_check where cny = -3376 and jpy = -337600 and gbp = -2363.2 and eur = -374736 and  hkd = -3038.4','')")

    con:query("insert into check_sql values(-3375,'delete from transaction_total_check where cny = -3375 and jpy = -337500 and gbp = -2362.5 and eur = -374625 and  hkd = -3037.5','')")

    con:query("insert into check_sql values(-3374,'delete from transaction_total_check where cny = -3374 and jpy = -337400 and gbp = -2361.8 and eur = -374514 and  hkd = -3036.6','')")

    con:query("insert into check_sql values(-3373,'delete from transaction_total_check where cny = -3373 and jpy = -337300 and gbp = -2361.1 and eur = -374403 and  hkd = -3035.7','')")

    con:query("insert into check_sql values(-3372,'delete from transaction_total_check where cny = -3372 and jpy = -337200 and gbp = -2360.4 and eur = -374292 and  hkd = -3034.8','')")

    con:query("insert into check_sql values(-3371,'delete from transaction_total_check where cny = -3371 and jpy = -337100 and gbp = -2359.7 and eur = -374181 and  hkd = -3033.9','')")

    con:query("insert into check_sql values(-3370,'delete from transaction_total_check where cny = -3370 and jpy = -337000 and gbp = -2359.0 and eur = -374070 and  hkd = -3033.0','')")

    con:query("insert into check_sql values(-3369,'delete from transaction_total_check where cny = -3369 and jpy = -336900 and gbp = -2358.3 and eur = -373959 and  hkd = -3032.1','')")

    con:query("insert into check_sql values(-3368,'delete from transaction_total_check where cny = -3368 and jpy = -336800 and gbp = -2357.6 and eur = -373848 and  hkd = -3031.2','')")

    con:query("insert into check_sql values(-3367,'delete from transaction_total_check where cny = -3367 and jpy = -336700 and gbp = -2356.9 and eur = -373737 and  hkd = -3030.3','')")

    con:query("insert into check_sql values(-3366,'delete from transaction_total_check where cny = -3366 and jpy = -336600 and gbp = -2356.2 and eur = -373626 and  hkd = -3029.4','')")

    con:query("insert into check_sql values(-3365,'delete from transaction_total_check where cny = -3365 and jpy = -336500 and gbp = -2355.5 and eur = -373515 and  hkd = -3028.5','')")

    con:query("insert into check_sql values(-3364,'delete from transaction_total_check where cny = -3364 and jpy = -336400 and gbp = -2354.8 and eur = -373404 and  hkd = -3027.6','')")

    con:query("insert into check_sql values(-3363,'delete from transaction_total_check where cny = -3363 and jpy = -336300 and gbp = -2354.1 and eur = -373293 and  hkd = -3026.7','')")

    con:query("insert into check_sql values(-3362,'delete from transaction_total_check where cny = -3362 and jpy = -336200 and gbp = -2353.4 and eur = -373182 and  hkd = -3025.8','')")

    con:query("insert into check_sql values(-3361,'delete from transaction_total_check where cny = -3361 and jpy = -336100 and gbp = -2352.7 and eur = -373071 and  hkd = -3024.9','')")

    con:query("insert into check_sql values(-3360,'delete from transaction_total_check where cny = -3360 and jpy = -336000 and gbp = -2352.0 and eur = -372960 and  hkd = -3024.0','')")

    con:query("insert into check_sql values(-3359,'delete from transaction_total_check where cny = -3359 and jpy = -335900 and gbp = -2351.3 and eur = -372849 and  hkd = -3023.1','')")

    con:query("insert into check_sql values(-3358,'delete from transaction_total_check where cny = -3358 and jpy = -335800 and gbp = -2350.6 and eur = -372738 and  hkd = -3022.2','')")

    con:query("insert into check_sql values(-3357,'delete from transaction_total_check where cny = -3357 and jpy = -335700 and gbp = -2349.9 and eur = -372627 and  hkd = -3021.3','')")

    con:query("insert into check_sql values(-3356,'delete from transaction_total_check where cny = -3356 and jpy = -335600 and gbp = -2349.2 and eur = -372516 and  hkd = -3020.4','')")

    con:query("insert into check_sql values(-3355,'delete from transaction_total_check where cny = -3355 and jpy = -335500 and gbp = -2348.5 and eur = -372405 and  hkd = -3019.5','')")

    con:query("insert into check_sql values(-3354,'delete from transaction_total_check where cny = -3354 and jpy = -335400 and gbp = -2347.8 and eur = -372294 and  hkd = -3018.6','')")

    con:query("insert into check_sql values(-3353,'delete from transaction_total_check where cny = -3353 and jpy = -335300 and gbp = -2347.1 and eur = -372183 and  hkd = -3017.7','')")

    con:query("insert into check_sql values(-3352,'delete from transaction_total_check where cny = -3352 and jpy = -335200 and gbp = -2346.4 and eur = -372072 and  hkd = -3016.8','')")

    con:query("insert into check_sql values(-3351,'delete from transaction_total_check where cny = -3351 and jpy = -335100 and gbp = -2345.7 and eur = -371961 and  hkd = -3015.9','')")

    con:query("insert into check_sql values(-3350,'delete from transaction_total_check where cny = -3350 and jpy = -335000 and gbp = -2345.0 and eur = -371850 and  hkd = -3015.0','')")

    con:query("insert into check_sql values(-3349,'delete from transaction_total_check where cny = -3349 and jpy = -334900 and gbp = -2344.3 and eur = -371739 and  hkd = -3014.1','')")

    con:query("insert into check_sql values(-3348,'delete from transaction_total_check where cny = -3348 and jpy = -334800 and gbp = -2343.6 and eur = -371628 and  hkd = -3013.2','')")

    con:query("insert into check_sql values(-3347,'delete from transaction_total_check where cny = -3347 and jpy = -334700 and gbp = -2342.9 and eur = -371517 and  hkd = -3012.3','')")

    con:query("insert into check_sql values(-3346,'delete from transaction_total_check where cny = -3346 and jpy = -334600 and gbp = -2342.2 and eur = -371406 and  hkd = -3011.4','')")

    con:query("insert into check_sql values(-3345,'delete from transaction_total_check where cny = -3345 and jpy = -334500 and gbp = -2341.5 and eur = -371295 and  hkd = -3010.5','')")

    con:query("insert into check_sql values(-3344,'delete from transaction_total_check where cny = -3344 and jpy = -334400 and gbp = -2340.8 and eur = -371184 and  hkd = -3009.6','')")

    con:query("insert into check_sql values(-3343,'delete from transaction_total_check where cny = -3343 and jpy = -334300 and gbp = -2340.1 and eur = -371073 and  hkd = -3008.7','')")

    con:query("insert into check_sql values(-3342,'delete from transaction_total_check where cny = -3342 and jpy = -334200 and gbp = -2339.4 and eur = -370962 and  hkd = -3007.8','')")

    con:query("insert into check_sql values(-3341,'delete from transaction_total_check where cny = -3341 and jpy = -334100 and gbp = -2338.7 and eur = -370851 and  hkd = -3006.9','')")

    con:query("insert into check_sql values(-3340,'delete from transaction_total_check where cny = -3340 and jpy = -334000 and gbp = -2338.0 and eur = -370740 and  hkd = -3006.0','')")

    con:query("insert into check_sql values(-3339,'delete from transaction_total_check where cny = -3339 and jpy = -333900 and gbp = -2337.3 and eur = -370629 and  hkd = -3005.1','')")

    con:query("insert into check_sql values(-3338,'delete from transaction_total_check where cny = -3338 and jpy = -333800 and gbp = -2336.6 and eur = -370518 and  hkd = -3004.2','')")

    con:query("insert into check_sql values(-3337,'delete from transaction_total_check where cny = -3337 and jpy = -333700 and gbp = -2335.9 and eur = -370407 and  hkd = -3003.3','')")

    con:query("insert into check_sql values(-3336,'delete from transaction_total_check where cny = -3336 and jpy = -333600 and gbp = -2335.2 and eur = -370296 and  hkd = -3002.4','')")

    con:query("insert into check_sql values(-3335,'delete from transaction_total_check where cny = -3335 and jpy = -333500 and gbp = -2334.5 and eur = -370185 and  hkd = -3001.5','')")

    con:query("insert into check_sql values(-3334,'delete from transaction_total_check where cny = -3334 and jpy = -333400 and gbp = -2333.8 and eur = -370074 and  hkd = -3000.6','')")

    con:query("insert into check_sql values(-3333,'delete from transaction_total_check where cny = -3333 and jpy = -333300 and gbp = -2333.1 and eur = -369963 and  hkd = -2999.7','')")

    con:query("insert into check_sql values(-3332,'delete from transaction_total_check where cny = -3332 and jpy = -333200 and gbp = -2332.4 and eur = -369852 and  hkd = -2998.8','')")

    con:query("insert into check_sql values(-3331,'delete from transaction_total_check where cny = -3331 and jpy = -333100 and gbp = -2331.7 and eur = -369741 and  hkd = -2997.9','')")

    con:query("insert into check_sql values(-3330,'delete from transaction_total_check where cny = -3330 and jpy = -333000 and gbp = -2331.0 and eur = -369630 and  hkd = -2997.0','')")

    con:query("insert into check_sql values(-3329,'delete from transaction_total_check where cny = -3329 and jpy = -332900 and gbp = -2330.3 and eur = -369519 and  hkd = -2996.1','')")

    con:query("insert into check_sql values(-3328,'delete from transaction_total_check where cny = -3328 and jpy = -332800 and gbp = -2329.6 and eur = -369408 and  hkd = -2995.2','')")

    con:query("insert into check_sql values(-3327,'delete from transaction_total_check where cny = -3327 and jpy = -332700 and gbp = -2328.9 and eur = -369297 and  hkd = -2994.3','')")

    con:query("insert into check_sql values(-3326,'delete from transaction_total_check where cny = -3326 and jpy = -332600 and gbp = -2328.2 and eur = -369186 and  hkd = -2993.4','')")

    con:query("insert into check_sql values(-3325,'delete from transaction_total_check where cny = -3325 and jpy = -332500 and gbp = -2327.5 and eur = -369075 and  hkd = -2992.5','')")

    con:query("insert into check_sql values(-3324,'delete from transaction_total_check where cny = -3324 and jpy = -332400 and gbp = -2326.8 and eur = -368964 and  hkd = -2991.6','')")

    con:query("insert into check_sql values(-3323,'delete from transaction_total_check where cny = -3323 and jpy = -332300 and gbp = -2326.1 and eur = -368853 and  hkd = -2990.7','')")

    con:query("insert into check_sql values(-3322,'delete from transaction_total_check where cny = -3322 and jpy = -332200 and gbp = -2325.4 and eur = -368742 and  hkd = -2989.8','')")

    con:query("insert into check_sql values(-3321,'delete from transaction_total_check where cny = -3321 and jpy = -332100 and gbp = -2324.7 and eur = -368631 and  hkd = -2988.9','')")

    con:query("insert into check_sql values(-3320,'delete from transaction_total_check where cny = -3320 and jpy = -332000 and gbp = -2324.0 and eur = -368520 and  hkd = -2988.0','')")

    con:query("insert into check_sql values(-3319,'delete from transaction_total_check where cny = -3319 and jpy = -331900 and gbp = -2323.3 and eur = -368409 and  hkd = -2987.1','')")

    con:query("insert into check_sql values(-3318,'delete from transaction_total_check where cny = -3318 and jpy = -331800 and gbp = -2322.6 and eur = -368298 and  hkd = -2986.2','')")

    con:query("insert into check_sql values(-3317,'delete from transaction_total_check where cny = -3317 and jpy = -331700 and gbp = -2321.9 and eur = -368187 and  hkd = -2985.3','')")

    con:query("insert into check_sql values(-3316,'delete from transaction_total_check where cny = -3316 and jpy = -331600 and gbp = -2321.2 and eur = -368076 and  hkd = -2984.4','')")

    con:query("insert into check_sql values(-3315,'delete from transaction_total_check where cny = -3315 and jpy = -331500 and gbp = -2320.5 and eur = -367965 and  hkd = -2983.5','')")

    con:query("insert into check_sql values(-3314,'delete from transaction_total_check where cny = -3314 and jpy = -331400 and gbp = -2319.8 and eur = -367854 and  hkd = -2982.6','')")

    con:query("insert into check_sql values(-3313,'delete from transaction_total_check where cny = -3313 and jpy = -331300 and gbp = -2319.1 and eur = -367743 and  hkd = -2981.7','')")

    con:query("insert into check_sql values(-3312,'delete from transaction_total_check where cny = -3312 and jpy = -331200 and gbp = -2318.4 and eur = -367632 and  hkd = -2980.8','')")

    con:query("insert into check_sql values(-3311,'delete from transaction_total_check where cny = -3311 and jpy = -331100 and gbp = -2317.7 and eur = -367521 and  hkd = -2979.9','')")

    con:query("insert into check_sql values(-3310,'delete from transaction_total_check where cny = -3310 and jpy = -331000 and gbp = -2317.0 and eur = -367410 and  hkd = -2979.0','')")

    con:query("insert into check_sql values(-3309,'delete from transaction_total_check where cny = -3309 and jpy = -330900 and gbp = -2316.3 and eur = -367299 and  hkd = -2978.1','')")

    con:query("insert into check_sql values(-3308,'delete from transaction_total_check where cny = -3308 and jpy = -330800 and gbp = -2315.6 and eur = -367188 and  hkd = -2977.2','')")

    con:query("insert into check_sql values(-3307,'delete from transaction_total_check where cny = -3307 and jpy = -330700 and gbp = -2314.9 and eur = -367077 and  hkd = -2976.3','')")

    con:query("insert into check_sql values(-3306,'delete from transaction_total_check where cny = -3306 and jpy = -330600 and gbp = -2314.2 and eur = -366966 and  hkd = -2975.4','')")

    con:query("insert into check_sql values(-3305,'delete from transaction_total_check where cny = -3305 and jpy = -330500 and gbp = -2313.5 and eur = -366855 and  hkd = -2974.5','')")

    con:query("insert into check_sql values(-3304,'delete from transaction_total_check where cny = -3304 and jpy = -330400 and gbp = -2312.8 and eur = -366744 and  hkd = -2973.6','')")

    con:query("insert into check_sql values(-3303,'delete from transaction_total_check where cny = -3303 and jpy = -330300 and gbp = -2312.1 and eur = -366633 and  hkd = -2972.7','')")

    con:query("insert into check_sql values(-3302,'delete from transaction_total_check where cny = -3302 and jpy = -330200 and gbp = -2311.4 and eur = -366522 and  hkd = -2971.8','')")

    con:query("insert into check_sql values(-3301,'delete from transaction_total_check where cny = -3301 and jpy = -330100 and gbp = -2310.7 and eur = -366411 and  hkd = -2970.9','')")

    con:query("insert into check_sql values(-3300,'delete from transaction_total_check where cny = -3300 and jpy = -330000 and gbp = -2310.0 and eur = -366300 and  hkd = -2970.0','')")

    con:query("insert into check_sql values(-3299,'delete from transaction_total_check where cny = -3299 and jpy = -329900 and gbp = -2309.3 and eur = -366189 and  hkd = -2969.1','')")

    con:query("insert into check_sql values(-3298,'delete from transaction_total_check where cny = -3298 and jpy = -329800 and gbp = -2308.6 and eur = -366078 and  hkd = -2968.2','')")

    con:query("insert into check_sql values(-3297,'delete from transaction_total_check where cny = -3297 and jpy = -329700 and gbp = -2307.9 and eur = -365967 and  hkd = -2967.3','')")

    con:query("insert into check_sql values(-3296,'delete from transaction_total_check where cny = -3296 and jpy = -329600 and gbp = -2307.2 and eur = -365856 and  hkd = -2966.4','')")

    con:query("insert into check_sql values(-3295,'delete from transaction_total_check where cny = -3295 and jpy = -329500 and gbp = -2306.5 and eur = -365745 and  hkd = -2965.5','')")

    con:query("insert into check_sql values(-3294,'delete from transaction_total_check where cny = -3294 and jpy = -329400 and gbp = -2305.8 and eur = -365634 and  hkd = -2964.6','')")

    con:query("insert into check_sql values(-3293,'delete from transaction_total_check where cny = -3293 and jpy = -329300 and gbp = -2305.1 and eur = -365523 and  hkd = -2963.7','')")

    con:query("insert into check_sql values(-3292,'delete from transaction_total_check where cny = -3292 and jpy = -329200 and gbp = -2304.4 and eur = -365412 and  hkd = -2962.8','')")

    con:query("insert into check_sql values(-3291,'delete from transaction_total_check where cny = -3291 and jpy = -329100 and gbp = -2303.7 and eur = -365301 and  hkd = -2961.9','')")

    con:query("insert into check_sql values(-3290,'delete from transaction_total_check where cny = -3290 and jpy = -329000 and gbp = -2303.0 and eur = -365190 and  hkd = -2961.0','')")

    con:query("insert into check_sql values(-3289,'delete from transaction_total_check where cny = -3289 and jpy = -328900 and gbp = -2302.3 and eur = -365079 and  hkd = -2960.1','')")

    con:query("insert into check_sql values(-3288,'delete from transaction_total_check where cny = -3288 and jpy = -328800 and gbp = -2301.6 and eur = -364968 and  hkd = -2959.2','')")

    con:query("insert into check_sql values(-3287,'delete from transaction_total_check where cny = -3287 and jpy = -328700 and gbp = -2300.9 and eur = -364857 and  hkd = -2958.3','')")

    con:query("insert into check_sql values(-3286,'delete from transaction_total_check where cny = -3286 and jpy = -328600 and gbp = -2300.2 and eur = -364746 and  hkd = -2957.4','')")

    con:query("insert into check_sql values(-3285,'delete from transaction_total_check where cny = -3285 and jpy = -328500 and gbp = -2299.5 and eur = -364635 and  hkd = -2956.5','')")

    con:query("insert into check_sql values(-3284,'delete from transaction_total_check where cny = -3284 and jpy = -328400 and gbp = -2298.8 and eur = -364524 and  hkd = -2955.6','')")

    con:query("insert into check_sql values(-3283,'delete from transaction_total_check where cny = -3283 and jpy = -328300 and gbp = -2298.1 and eur = -364413 and  hkd = -2954.7','')")

    con:query("insert into check_sql values(-3282,'delete from transaction_total_check where cny = -3282 and jpy = -328200 and gbp = -2297.4 and eur = -364302 and  hkd = -2953.8','')")

    con:query("insert into check_sql values(-3281,'delete from transaction_total_check where cny = -3281 and jpy = -328100 and gbp = -2296.7 and eur = -364191 and  hkd = -2952.9','')")

    con:query("insert into check_sql values(-3280,'delete from transaction_total_check where cny = -3280 and jpy = -328000 and gbp = -2296.0 and eur = -364080 and  hkd = -2952.0','')")

    con:query("insert into check_sql values(-3279,'delete from transaction_total_check where cny = -3279 and jpy = -327900 and gbp = -2295.3 and eur = -363969 and  hkd = -2951.1','')")

    con:query("insert into check_sql values(-3278,'delete from transaction_total_check where cny = -3278 and jpy = -327800 and gbp = -2294.6 and eur = -363858 and  hkd = -2950.2','')")

    con:query("insert into check_sql values(-3277,'delete from transaction_total_check where cny = -3277 and jpy = -327700 and gbp = -2293.9 and eur = -363747 and  hkd = -2949.3','')")

    con:query("insert into check_sql values(-3276,'delete from transaction_total_check where cny = -3276 and jpy = -327600 and gbp = -2293.2 and eur = -363636 and  hkd = -2948.4','')")

    con:query("insert into check_sql values(-3275,'delete from transaction_total_check where cny = -3275 and jpy = -327500 and gbp = -2292.5 and eur = -363525 and  hkd = -2947.5','')")

    con:query("insert into check_sql values(-3274,'delete from transaction_total_check where cny = -3274 and jpy = -327400 and gbp = -2291.8 and eur = -363414 and  hkd = -2946.6','')")

    con:query("insert into check_sql values(-3273,'delete from transaction_total_check where cny = -3273 and jpy = -327300 and gbp = -2291.1 and eur = -363303 and  hkd = -2945.7','')")

    con:query("insert into check_sql values(-3272,'delete from transaction_total_check where cny = -3272 and jpy = -327200 and gbp = -2290.4 and eur = -363192 and  hkd = -2944.8','')")

    con:query("insert into check_sql values(-3271,'delete from transaction_total_check where cny = -3271 and jpy = -327100 and gbp = -2289.7 and eur = -363081 and  hkd = -2943.9','')")

    con:query("insert into check_sql values(-3270,'delete from transaction_total_check where cny = -3270 and jpy = -327000 and gbp = -2289.0 and eur = -362970 and  hkd = -2943.0','')")

    con:query("insert into check_sql values(-3269,'delete from transaction_total_check where cny = -3269 and jpy = -326900 and gbp = -2288.3 and eur = -362859 and  hkd = -2942.1','')")

    con:query("insert into check_sql values(-3268,'delete from transaction_total_check where cny = -3268 and jpy = -326800 and gbp = -2287.6 and eur = -362748 and  hkd = -2941.2','')")

    con:query("insert into check_sql values(-3267,'delete from transaction_total_check where cny = -3267 and jpy = -326700 and gbp = -2286.9 and eur = -362637 and  hkd = -2940.3','')")

    con:query("insert into check_sql values(-3266,'delete from transaction_total_check where cny = -3266 and jpy = -326600 and gbp = -2286.2 and eur = -362526 and  hkd = -2939.4','')")

    con:query("insert into check_sql values(-3265,'delete from transaction_total_check where cny = -3265 and jpy = -326500 and gbp = -2285.5 and eur = -362415 and  hkd = -2938.5','')")

    con:query("insert into check_sql values(-3264,'delete from transaction_total_check where cny = -3264 and jpy = -326400 and gbp = -2284.8 and eur = -362304 and  hkd = -2937.6','')")

    con:query("insert into check_sql values(-3263,'delete from transaction_total_check where cny = -3263 and jpy = -326300 and gbp = -2284.1 and eur = -362193 and  hkd = -2936.7','')")

    con:query("insert into check_sql values(-3262,'delete from transaction_total_check where cny = -3262 and jpy = -326200 and gbp = -2283.4 and eur = -362082 and  hkd = -2935.8','')")

    con:query("insert into check_sql values(-3261,'delete from transaction_total_check where cny = -3261 and jpy = -326100 and gbp = -2282.7 and eur = -361971 and  hkd = -2934.9','')")

    con:query("insert into check_sql values(-3260,'delete from transaction_total_check where cny = -3260 and jpy = -326000 and gbp = -2282.0 and eur = -361860 and  hkd = -2934.0','')")

    con:query("insert into check_sql values(-3259,'delete from transaction_total_check where cny = -3259 and jpy = -325900 and gbp = -2281.3 and eur = -361749 and  hkd = -2933.1','')")

    con:query("insert into check_sql values(-3258,'delete from transaction_total_check where cny = -3258 and jpy = -325800 and gbp = -2280.6 and eur = -361638 and  hkd = -2932.2','')")

    con:query("insert into check_sql values(-3257,'delete from transaction_total_check where cny = -3257 and jpy = -325700 and gbp = -2279.9 and eur = -361527 and  hkd = -2931.3','')")

    con:query("insert into check_sql values(-3256,'delete from transaction_total_check where cny = -3256 and jpy = -325600 and gbp = -2279.2 and eur = -361416 and  hkd = -2930.4','')")

    con:query("insert into check_sql values(-3255,'delete from transaction_total_check where cny = -3255 and jpy = -325500 and gbp = -2278.5 and eur = -361305 and  hkd = -2929.5','')")

    con:query("insert into check_sql values(-3254,'delete from transaction_total_check where cny = -3254 and jpy = -325400 and gbp = -2277.8 and eur = -361194 and  hkd = -2928.6','')")

    con:query("insert into check_sql values(-3253,'delete from transaction_total_check where cny = -3253 and jpy = -325300 and gbp = -2277.1 and eur = -361083 and  hkd = -2927.7','')")

    con:query("insert into check_sql values(-3252,'delete from transaction_total_check where cny = -3252 and jpy = -325200 and gbp = -2276.4 and eur = -360972 and  hkd = -2926.8','')")

    con:query("insert into check_sql values(-3251,'delete from transaction_total_check where cny = -3251 and jpy = -325100 and gbp = -2275.7 and eur = -360861 and  hkd = -2925.9','')")

    con:query("insert into check_sql values(-3250,'delete from transaction_total_check where cny = -3250 and jpy = -325000 and gbp = -2275.0 and eur = -360750 and  hkd = -2925.0','')")

    con:query("insert into check_sql values(-3249,'delete from transaction_total_check where cny = -3249 and jpy = -324900 and gbp = -2274.3 and eur = -360639 and  hkd = -2924.1','')")

    con:query("insert into check_sql values(-3248,'delete from transaction_total_check where cny = -3248 and jpy = -324800 and gbp = -2273.6 and eur = -360528 and  hkd = -2923.2','')")

    con:query("insert into check_sql values(-3247,'delete from transaction_total_check where cny = -3247 and jpy = -324700 and gbp = -2272.9 and eur = -360417 and  hkd = -2922.3','')")

    con:query("insert into check_sql values(-3246,'delete from transaction_total_check where cny = -3246 and jpy = -324600 and gbp = -2272.2 and eur = -360306 and  hkd = -2921.4','')")

    con:query("insert into check_sql values(-3245,'delete from transaction_total_check where cny = -3245 and jpy = -324500 and gbp = -2271.5 and eur = -360195 and  hkd = -2920.5','')")

    con:query("insert into check_sql values(-3244,'delete from transaction_total_check where cny = -3244 and jpy = -324400 and gbp = -2270.8 and eur = -360084 and  hkd = -2919.6','')")

    con:query("insert into check_sql values(-3243,'delete from transaction_total_check where cny = -3243 and jpy = -324300 and gbp = -2270.1 and eur = -359973 and  hkd = -2918.7','')")

    con:query("insert into check_sql values(-3242,'delete from transaction_total_check where cny = -3242 and jpy = -324200 and gbp = -2269.4 and eur = -359862 and  hkd = -2917.8','')")

    con:query("insert into check_sql values(-3241,'delete from transaction_total_check where cny = -3241 and jpy = -324100 and gbp = -2268.7 and eur = -359751 and  hkd = -2916.9','')")

    con:query("insert into check_sql values(-3240,'delete from transaction_total_check where cny = -3240 and jpy = -324000 and gbp = -2268.0 and eur = -359640 and  hkd = -2916.0','')")

    con:query("insert into check_sql values(-3239,'delete from transaction_total_check where cny = -3239 and jpy = -323900 and gbp = -2267.3 and eur = -359529 and  hkd = -2915.1','')")

    con:query("insert into check_sql values(-3238,'delete from transaction_total_check where cny = -3238 and jpy = -323800 and gbp = -2266.6 and eur = -359418 and  hkd = -2914.2','')")

    con:query("insert into check_sql values(-3237,'delete from transaction_total_check where cny = -3237 and jpy = -323700 and gbp = -2265.9 and eur = -359307 and  hkd = -2913.3','')")

    con:query("insert into check_sql values(-3236,'delete from transaction_total_check where cny = -3236 and jpy = -323600 and gbp = -2265.2 and eur = -359196 and  hkd = -2912.4','')")

    con:query("insert into check_sql values(-3235,'delete from transaction_total_check where cny = -3235 and jpy = -323500 and gbp = -2264.5 and eur = -359085 and  hkd = -2911.5','')")

    con:query("insert into check_sql values(-3234,'delete from transaction_total_check where cny = -3234 and jpy = -323400 and gbp = -2263.8 and eur = -358974 and  hkd = -2910.6','')")

    con:query("insert into check_sql values(-3233,'delete from transaction_total_check where cny = -3233 and jpy = -323300 and gbp = -2263.1 and eur = -358863 and  hkd = -2909.7','')")

    con:query("insert into check_sql values(-3232,'delete from transaction_total_check where cny = -3232 and jpy = -323200 and gbp = -2262.4 and eur = -358752 and  hkd = -2908.8','')")

    con:query("insert into check_sql values(-3231,'delete from transaction_total_check where cny = -3231 and jpy = -323100 and gbp = -2261.7 and eur = -358641 and  hkd = -2907.9','')")

    con:query("insert into check_sql values(-3230,'delete from transaction_total_check where cny = -3230 and jpy = -323000 and gbp = -2261.0 and eur = -358530 and  hkd = -2907.0','')")

    con:query("insert into check_sql values(-3229,'delete from transaction_total_check where cny = -3229 and jpy = -322900 and gbp = -2260.3 and eur = -358419 and  hkd = -2906.1','')")

    con:query("insert into check_sql values(-3228,'delete from transaction_total_check where cny = -3228 and jpy = -322800 and gbp = -2259.6 and eur = -358308 and  hkd = -2905.2','')")

    con:query("insert into check_sql values(-3227,'delete from transaction_total_check where cny = -3227 and jpy = -322700 and gbp = -2258.9 and eur = -358197 and  hkd = -2904.3','')")

    con:query("insert into check_sql values(-3226,'delete from transaction_total_check where cny = -3226 and jpy = -322600 and gbp = -2258.2 and eur = -358086 and  hkd = -2903.4','')")

    con:query("insert into check_sql values(-3225,'delete from transaction_total_check where cny = -3225 and jpy = -322500 and gbp = -2257.5 and eur = -357975 and  hkd = -2902.5','')")

    con:query("insert into check_sql values(-3224,'delete from transaction_total_check where cny = -3224 and jpy = -322400 and gbp = -2256.8 and eur = -357864 and  hkd = -2901.6','')")

    con:query("insert into check_sql values(-3223,'delete from transaction_total_check where cny = -3223 and jpy = -322300 and gbp = -2256.1 and eur = -357753 and  hkd = -2900.7','')")

    con:query("insert into check_sql values(-3222,'delete from transaction_total_check where cny = -3222 and jpy = -322200 and gbp = -2255.4 and eur = -357642 and  hkd = -2899.8','')")

    con:query("insert into check_sql values(-3221,'delete from transaction_total_check where cny = -3221 and jpy = -322100 and gbp = -2254.7 and eur = -357531 and  hkd = -2898.9','')")

    con:query("insert into check_sql values(-3220,'delete from transaction_total_check where cny = -3220 and jpy = -322000 and gbp = -2254.0 and eur = -357420 and  hkd = -2898.0','')")

    con:query("insert into check_sql values(-3219,'delete from transaction_total_check where cny = -3219 and jpy = -321900 and gbp = -2253.3 and eur = -357309 and  hkd = -2897.1','')")

    con:query("insert into check_sql values(-3218,'delete from transaction_total_check where cny = -3218 and jpy = -321800 and gbp = -2252.6 and eur = -357198 and  hkd = -2896.2','')")

    con:query("insert into check_sql values(-3217,'delete from transaction_total_check where cny = -3217 and jpy = -321700 and gbp = -2251.9 and eur = -357087 and  hkd = -2895.3','')")

    con:query("insert into check_sql values(-3216,'delete from transaction_total_check where cny = -3216 and jpy = -321600 and gbp = -2251.2 and eur = -356976 and  hkd = -2894.4','')")

    con:query("insert into check_sql values(-3215,'delete from transaction_total_check where cny = -3215 and jpy = -321500 and gbp = -2250.5 and eur = -356865 and  hkd = -2893.5','')")

    con:query("insert into check_sql values(-3214,'delete from transaction_total_check where cny = -3214 and jpy = -321400 and gbp = -2249.8 and eur = -356754 and  hkd = -2892.6','')")

    con:query("insert into check_sql values(-3213,'delete from transaction_total_check where cny = -3213 and jpy = -321300 and gbp = -2249.1 and eur = -356643 and  hkd = -2891.7','')")

    con:query("insert into check_sql values(-3212,'delete from transaction_total_check where cny = -3212 and jpy = -321200 and gbp = -2248.4 and eur = -356532 and  hkd = -2890.8','')")

    con:query("insert into check_sql values(-3211,'delete from transaction_total_check where cny = -3211 and jpy = -321100 and gbp = -2247.7 and eur = -356421 and  hkd = -2889.9','')")

    con:query("insert into check_sql values(-3210,'delete from transaction_total_check where cny = -3210 and jpy = -321000 and gbp = -2247.0 and eur = -356310 and  hkd = -2889.0','')")

    con:query("insert into check_sql values(-3209,'delete from transaction_total_check where cny = -3209 and jpy = -320900 and gbp = -2246.3 and eur = -356199 and  hkd = -2888.1','')")

    con:query("insert into check_sql values(-3208,'delete from transaction_total_check where cny = -3208 and jpy = -320800 and gbp = -2245.6 and eur = -356088 and  hkd = -2887.2','')")

    con:query("insert into check_sql values(-3207,'delete from transaction_total_check where cny = -3207 and jpy = -320700 and gbp = -2244.9 and eur = -355977 and  hkd = -2886.3','')")

    con:query("insert into check_sql values(-3206,'delete from transaction_total_check where cny = -3206 and jpy = -320600 and gbp = -2244.2 and eur = -355866 and  hkd = -2885.4','')")

    con:query("insert into check_sql values(-3205,'delete from transaction_total_check where cny = -3205 and jpy = -320500 and gbp = -2243.5 and eur = -355755 and  hkd = -2884.5','')")

    con:query("insert into check_sql values(-3204,'delete from transaction_total_check where cny = -3204 and jpy = -320400 and gbp = -2242.8 and eur = -355644 and  hkd = -2883.6','')")

    con:query("insert into check_sql values(-3203,'delete from transaction_total_check where cny = -3203 and jpy = -320300 and gbp = -2242.1 and eur = -355533 and  hkd = -2882.7','')")

    con:query("insert into check_sql values(-3202,'delete from transaction_total_check where cny = -3202 and jpy = -320200 and gbp = -2241.4 and eur = -355422 and  hkd = -2881.8','')")

    con:query("insert into check_sql values(-3201,'delete from transaction_total_check where cny = -3201 and jpy = -320100 and gbp = -2240.7 and eur = -355311 and  hkd = -2880.9','')")

    con:query("insert into check_sql values(-3200,'delete from transaction_total_check where cny = -3200 and jpy = -320000 and gbp = -2240.0 and eur = -355200 and  hkd = -2880.0','')")

    con:query("insert into check_sql values(-3199,'delete from transaction_total_check where cny = -3199 and jpy = -319900 and gbp = -2239.3 and eur = -355089 and  hkd = -2879.1','')")

    con:query("insert into check_sql values(-3198,'delete from transaction_total_check where cny = -3198 and jpy = -319800 and gbp = -2238.6 and eur = -354978 and  hkd = -2878.2','')")

    con:query("insert into check_sql values(-3197,'delete from transaction_total_check where cny = -3197 and jpy = -319700 and gbp = -2237.9 and eur = -354867 and  hkd = -2877.3','')")

    con:query("insert into check_sql values(-3196,'delete from transaction_total_check where cny = -3196 and jpy = -319600 and gbp = -2237.2 and eur = -354756 and  hkd = -2876.4','')")

    con:query("insert into check_sql values(-3195,'delete from transaction_total_check where cny = -3195 and jpy = -319500 and gbp = -2236.5 and eur = -354645 and  hkd = -2875.5','')")

    con:query("insert into check_sql values(-3194,'delete from transaction_total_check where cny = -3194 and jpy = -319400 and gbp = -2235.8 and eur = -354534 and  hkd = -2874.6','')")

    con:query("insert into check_sql values(-3193,'delete from transaction_total_check where cny = -3193 and jpy = -319300 and gbp = -2235.1 and eur = -354423 and  hkd = -2873.7','')")

    con:query("insert into check_sql values(-3192,'delete from transaction_total_check where cny = -3192 and jpy = -319200 and gbp = -2234.4 and eur = -354312 and  hkd = -2872.8','')")

    con:query("insert into check_sql values(-3191,'delete from transaction_total_check where cny = -3191 and jpy = -319100 and gbp = -2233.7 and eur = -354201 and  hkd = -2871.9','')")

    con:query("insert into check_sql values(-3190,'delete from transaction_total_check where cny = -3190 and jpy = -319000 and gbp = -2233.0 and eur = -354090 and  hkd = -2871.0','')")

    con:query("insert into check_sql values(-3189,'delete from transaction_total_check where cny = -3189 and jpy = -318900 and gbp = -2232.3 and eur = -353979 and  hkd = -2870.1','')")

    con:query("insert into check_sql values(-3188,'delete from transaction_total_check where cny = -3188 and jpy = -318800 and gbp = -2231.6 and eur = -353868 and  hkd = -2869.2','')")

    con:query("insert into check_sql values(-3187,'delete from transaction_total_check where cny = -3187 and jpy = -318700 and gbp = -2230.9 and eur = -353757 and  hkd = -2868.3','')")

    con:query("insert into check_sql values(-3186,'delete from transaction_total_check where cny = -3186 and jpy = -318600 and gbp = -2230.2 and eur = -353646 and  hkd = -2867.4','')")

    con:query("insert into check_sql values(-3185,'delete from transaction_total_check where cny = -3185 and jpy = -318500 and gbp = -2229.5 and eur = -353535 and  hkd = -2866.5','')")

    con:query("insert into check_sql values(-3184,'delete from transaction_total_check where cny = -3184 and jpy = -318400 and gbp = -2228.8 and eur = -353424 and  hkd = -2865.6','')")

    con:query("insert into check_sql values(-3183,'delete from transaction_total_check where cny = -3183 and jpy = -318300 and gbp = -2228.1 and eur = -353313 and  hkd = -2864.7','')")

    con:query("insert into check_sql values(-3182,'delete from transaction_total_check where cny = -3182 and jpy = -318200 and gbp = -2227.4 and eur = -353202 and  hkd = -2863.8','')")

    con:query("insert into check_sql values(-3181,'delete from transaction_total_check where cny = -3181 and jpy = -318100 and gbp = -2226.7 and eur = -353091 and  hkd = -2862.9','')")

    con:query("insert into check_sql values(-3180,'delete from transaction_total_check where cny = -3180 and jpy = -318000 and gbp = -2226.0 and eur = -352980 and  hkd = -2862.0','')")

    con:query("insert into check_sql values(-3179,'delete from transaction_total_check where cny = -3179 and jpy = -317900 and gbp = -2225.3 and eur = -352869 and  hkd = -2861.1','')")

    con:query("insert into check_sql values(-3178,'delete from transaction_total_check where cny = -3178 and jpy = -317800 and gbp = -2224.6 and eur = -352758 and  hkd = -2860.2','')")

    con:query("insert into check_sql values(-3177,'delete from transaction_total_check where cny = -3177 and jpy = -317700 and gbp = -2223.9 and eur = -352647 and  hkd = -2859.3','')")

    con:query("insert into check_sql values(-3176,'delete from transaction_total_check where cny = -3176 and jpy = -317600 and gbp = -2223.2 and eur = -352536 and  hkd = -2858.4','')")

    con:query("insert into check_sql values(-3175,'delete from transaction_total_check where cny = -3175 and jpy = -317500 and gbp = -2222.5 and eur = -352425 and  hkd = -2857.5','')")

    con:query("insert into check_sql values(-3174,'delete from transaction_total_check where cny = -3174 and jpy = -317400 and gbp = -2221.8 and eur = -352314 and  hkd = -2856.6','')")

    con:query("insert into check_sql values(-3173,'delete from transaction_total_check where cny = -3173 and jpy = -317300 and gbp = -2221.1 and eur = -352203 and  hkd = -2855.7','')")

    con:query("insert into check_sql values(-3172,'delete from transaction_total_check where cny = -3172 and jpy = -317200 and gbp = -2220.4 and eur = -352092 and  hkd = -2854.8','')")

    con:query("insert into check_sql values(-3171,'delete from transaction_total_check where cny = -3171 and jpy = -317100 and gbp = -2219.7 and eur = -351981 and  hkd = -2853.9','')")

    con:query("insert into check_sql values(-3170,'delete from transaction_total_check where cny = -3170 and jpy = -317000 and gbp = -2219.0 and eur = -351870 and  hkd = -2853.0','')")

    con:query("insert into check_sql values(-3169,'delete from transaction_total_check where cny = -3169 and jpy = -316900 and gbp = -2218.3 and eur = -351759 and  hkd = -2852.1','')")

    con:query("insert into check_sql values(-3168,'delete from transaction_total_check where cny = -3168 and jpy = -316800 and gbp = -2217.6 and eur = -351648 and  hkd = -2851.2','')")

    con:query("insert into check_sql values(-3167,'delete from transaction_total_check where cny = -3167 and jpy = -316700 and gbp = -2216.9 and eur = -351537 and  hkd = -2850.3','')")

    con:query("insert into check_sql values(-3166,'delete from transaction_total_check where cny = -3166 and jpy = -316600 and gbp = -2216.2 and eur = -351426 and  hkd = -2849.4','')")

    con:query("insert into check_sql values(-3165,'delete from transaction_total_check where cny = -3165 and jpy = -316500 and gbp = -2215.5 and eur = -351315 and  hkd = -2848.5','')")

    con:query("insert into check_sql values(-3164,'delete from transaction_total_check where cny = -3164 and jpy = -316400 and gbp = -2214.8 and eur = -351204 and  hkd = -2847.6','')")

    con:query("insert into check_sql values(-3163,'delete from transaction_total_check where cny = -3163 and jpy = -316300 and gbp = -2214.1 and eur = -351093 and  hkd = -2846.7','')")

    con:query("insert into check_sql values(-3162,'delete from transaction_total_check where cny = -3162 and jpy = -316200 and gbp = -2213.4 and eur = -350982 and  hkd = -2845.8','')")

    con:query("insert into check_sql values(-3161,'delete from transaction_total_check where cny = -3161 and jpy = -316100 and gbp = -2212.7 and eur = -350871 and  hkd = -2844.9','')")

    con:query("insert into check_sql values(-3160,'delete from transaction_total_check where cny = -3160 and jpy = -316000 and gbp = -2212.0 and eur = -350760 and  hkd = -2844.0','')")

    con:query("insert into check_sql values(-3159,'delete from transaction_total_check where cny = -3159 and jpy = -315900 and gbp = -2211.3 and eur = -350649 and  hkd = -2843.1','')")

    con:query("insert into check_sql values(-3158,'delete from transaction_total_check where cny = -3158 and jpy = -315800 and gbp = -2210.6 and eur = -350538 and  hkd = -2842.2','')")

    con:query("insert into check_sql values(-3157,'delete from transaction_total_check where cny = -3157 and jpy = -315700 and gbp = -2209.9 and eur = -350427 and  hkd = -2841.3','')")

    con:query("insert into check_sql values(-3156,'delete from transaction_total_check where cny = -3156 and jpy = -315600 and gbp = -2209.2 and eur = -350316 and  hkd = -2840.4','')")

    con:query("insert into check_sql values(-3155,'delete from transaction_total_check where cny = -3155 and jpy = -315500 and gbp = -2208.5 and eur = -350205 and  hkd = -2839.5','')")

    con:query("insert into check_sql values(-3154,'delete from transaction_total_check where cny = -3154 and jpy = -315400 and gbp = -2207.8 and eur = -350094 and  hkd = -2838.6','')")

    con:query("insert into check_sql values(-3153,'delete from transaction_total_check where cny = -3153 and jpy = -315300 and gbp = -2207.1 and eur = -349983 and  hkd = -2837.7','')")

    con:query("insert into check_sql values(-3152,'delete from transaction_total_check where cny = -3152 and jpy = -315200 and gbp = -2206.4 and eur = -349872 and  hkd = -2836.8','')")

    con:query("insert into check_sql values(-3151,'delete from transaction_total_check where cny = -3151 and jpy = -315100 and gbp = -2205.7 and eur = -349761 and  hkd = -2835.9','')")

    con:query("insert into check_sql values(-3150,'delete from transaction_total_check where cny = -3150 and jpy = -315000 and gbp = -2205.0 and eur = -349650 and  hkd = -2835.0','')")

    con:query("insert into check_sql values(-3149,'delete from transaction_total_check where cny = -3149 and jpy = -314900 and gbp = -2204.3 and eur = -349539 and  hkd = -2834.1','')")

    con:query("insert into check_sql values(-3148,'delete from transaction_total_check where cny = -3148 and jpy = -314800 and gbp = -2203.6 and eur = -349428 and  hkd = -2833.2','')")

    con:query("insert into check_sql values(-3147,'delete from transaction_total_check where cny = -3147 and jpy = -314700 and gbp = -2202.9 and eur = -349317 and  hkd = -2832.3','')")

    con:query("insert into check_sql values(-3146,'delete from transaction_total_check where cny = -3146 and jpy = -314600 and gbp = -2202.2 and eur = -349206 and  hkd = -2831.4','')")

    con:query("insert into check_sql values(-3145,'delete from transaction_total_check where cny = -3145 and jpy = -314500 and gbp = -2201.5 and eur = -349095 and  hkd = -2830.5','')")

    con:query("insert into check_sql values(-3144,'delete from transaction_total_check where cny = -3144 and jpy = -314400 and gbp = -2200.8 and eur = -348984 and  hkd = -2829.6','')")

    con:query("insert into check_sql values(-3143,'delete from transaction_total_check where cny = -3143 and jpy = -314300 and gbp = -2200.1 and eur = -348873 and  hkd = -2828.7','')")

    con:query("insert into check_sql values(-3142,'delete from transaction_total_check where cny = -3142 and jpy = -314200 and gbp = -2199.4 and eur = -348762 and  hkd = -2827.8','')")

    con:query("insert into check_sql values(-3141,'delete from transaction_total_check where cny = -3141 and jpy = -314100 and gbp = -2198.7 and eur = -348651 and  hkd = -2826.9','')")

    con:query("insert into check_sql values(-3140,'delete from transaction_total_check where cny = -3140 and jpy = -314000 and gbp = -2198.0 and eur = -348540 and  hkd = -2826.0','')")

    con:query("insert into check_sql values(-3139,'delete from transaction_total_check where cny = -3139 and jpy = -313900 and gbp = -2197.3 and eur = -348429 and  hkd = -2825.1','')")

    con:query("insert into check_sql values(-3138,'delete from transaction_total_check where cny = -3138 and jpy = -313800 and gbp = -2196.6 and eur = -348318 and  hkd = -2824.2','')")

    con:query("insert into check_sql values(-3137,'delete from transaction_total_check where cny = -3137 and jpy = -313700 and gbp = -2195.9 and eur = -348207 and  hkd = -2823.3','')")

    con:query("insert into check_sql values(-3136,'delete from transaction_total_check where cny = -3136 and jpy = -313600 and gbp = -2195.2 and eur = -348096 and  hkd = -2822.4','')")

    con:query("insert into check_sql values(-3135,'delete from transaction_total_check where cny = -3135 and jpy = -313500 and gbp = -2194.5 and eur = -347985 and  hkd = -2821.5','')")

    con:query("insert into check_sql values(-3134,'delete from transaction_total_check where cny = -3134 and jpy = -313400 and gbp = -2193.8 and eur = -347874 and  hkd = -2820.6','')")

    con:query("insert into check_sql values(-3133,'delete from transaction_total_check where cny = -3133 and jpy = -313300 and gbp = -2193.1 and eur = -347763 and  hkd = -2819.7','')")

    con:query("insert into check_sql values(-3132,'delete from transaction_total_check where cny = -3132 and jpy = -313200 and gbp = -2192.4 and eur = -347652 and  hkd = -2818.8','')")

    con:query("insert into check_sql values(-3131,'delete from transaction_total_check where cny = -3131 and jpy = -313100 and gbp = -2191.7 and eur = -347541 and  hkd = -2817.9','')")

    con:query("insert into check_sql values(-3130,'delete from transaction_total_check where cny = -3130 and jpy = -313000 and gbp = -2191.0 and eur = -347430 and  hkd = -2817.0','')")

    con:query("insert into check_sql values(-3129,'delete from transaction_total_check where cny = -3129 and jpy = -312900 and gbp = -2190.3 and eur = -347319 and  hkd = -2816.1','')")

    con:query("insert into check_sql values(-3128,'delete from transaction_total_check where cny = -3128 and jpy = -312800 and gbp = -2189.6 and eur = -347208 and  hkd = -2815.2','')")

    con:query("insert into check_sql values(-3127,'delete from transaction_total_check where cny = -3127 and jpy = -312700 and gbp = -2188.9 and eur = -347097 and  hkd = -2814.3','')")

    con:query("insert into check_sql values(-3126,'delete from transaction_total_check where cny = -3126 and jpy = -312600 and gbp = -2188.2 and eur = -346986 and  hkd = -2813.4','')")

    con:query("insert into check_sql values(-3125,'delete from transaction_total_check where cny = -3125 and jpy = -312500 and gbp = -2187.5 and eur = -346875 and  hkd = -2812.5','')")

    con:query("insert into check_sql values(-3124,'delete from transaction_total_check where cny = -3124 and jpy = -312400 and gbp = -2186.8 and eur = -346764 and  hkd = -2811.6','')")

    con:query("insert into check_sql values(-3123,'delete from transaction_total_check where cny = -3123 and jpy = -312300 and gbp = -2186.1 and eur = -346653 and  hkd = -2810.7','')")

    con:query("insert into check_sql values(-3122,'delete from transaction_total_check where cny = -3122 and jpy = -312200 and gbp = -2185.4 and eur = -346542 and  hkd = -2809.8','')")

    con:query("insert into check_sql values(-3121,'delete from transaction_total_check where cny = -3121 and jpy = -312100 and gbp = -2184.7 and eur = -346431 and  hkd = -2808.9','')")

    con:query("insert into check_sql values(-3120,'delete from transaction_total_check where cny = -3120 and jpy = -312000 and gbp = -2184.0 and eur = -346320 and  hkd = -2808.0','')")

    con:query("insert into check_sql values(-3119,'delete from transaction_total_check where cny = -3119 and jpy = -311900 and gbp = -2183.3 and eur = -346209 and  hkd = -2807.1','')")

    con:query("insert into check_sql values(-3118,'delete from transaction_total_check where cny = -3118 and jpy = -311800 and gbp = -2182.6 and eur = -346098 and  hkd = -2806.2','')")

    con:query("insert into check_sql values(-3117,'delete from transaction_total_check where cny = -3117 and jpy = -311700 and gbp = -2181.9 and eur = -345987 and  hkd = -2805.3','')")

    con:query("insert into check_sql values(-3116,'delete from transaction_total_check where cny = -3116 and jpy = -311600 and gbp = -2181.2 and eur = -345876 and  hkd = -2804.4','')")

    con:query("insert into check_sql values(-3115,'delete from transaction_total_check where cny = -3115 and jpy = -311500 and gbp = -2180.5 and eur = -345765 and  hkd = -2803.5','')")

    con:query("insert into check_sql values(-3114,'delete from transaction_total_check where cny = -3114 and jpy = -311400 and gbp = -2179.8 and eur = -345654 and  hkd = -2802.6','')")

    con:query("insert into check_sql values(-3113,'delete from transaction_total_check where cny = -3113 and jpy = -311300 and gbp = -2179.1 and eur = -345543 and  hkd = -2801.7','')")

    con:query("insert into check_sql values(-3112,'delete from transaction_total_check where cny = -3112 and jpy = -311200 and gbp = -2178.4 and eur = -345432 and  hkd = -2800.8','')")

    con:query("insert into check_sql values(-3111,'delete from transaction_total_check where cny = -3111 and jpy = -311100 and gbp = -2177.7 and eur = -345321 and  hkd = -2799.9','')")

    con:query("insert into check_sql values(-3110,'delete from transaction_total_check where cny = -3110 and jpy = -311000 and gbp = -2177.0 and eur = -345210 and  hkd = -2799.0','')")

    con:query("insert into check_sql values(-3109,'delete from transaction_total_check where cny = -3109 and jpy = -310900 and gbp = -2176.3 and eur = -345099 and  hkd = -2798.1','')")

    con:query("insert into check_sql values(-3108,'delete from transaction_total_check where cny = -3108 and jpy = -310800 and gbp = -2175.6 and eur = -344988 and  hkd = -2797.2','')")

    con:query("insert into check_sql values(-3107,'delete from transaction_total_check where cny = -3107 and jpy = -310700 and gbp = -2174.9 and eur = -344877 and  hkd = -2796.3','')")

    con:query("insert into check_sql values(-3106,'delete from transaction_total_check where cny = -3106 and jpy = -310600 and gbp = -2174.2 and eur = -344766 and  hkd = -2795.4','')")

    con:query("insert into check_sql values(-3105,'delete from transaction_total_check where cny = -3105 and jpy = -310500 and gbp = -2173.5 and eur = -344655 and  hkd = -2794.5','')")

    con:query("insert into check_sql values(-3104,'delete from transaction_total_check where cny = -3104 and jpy = -310400 and gbp = -2172.8 and eur = -344544 and  hkd = -2793.6','')")

    con:query("insert into check_sql values(-3103,'delete from transaction_total_check where cny = -3103 and jpy = -310300 and gbp = -2172.1 and eur = -344433 and  hkd = -2792.7','')")

    con:query("insert into check_sql values(-3102,'delete from transaction_total_check where cny = -3102 and jpy = -310200 and gbp = -2171.4 and eur = -344322 and  hkd = -2791.8','')")

    con:query("insert into check_sql values(-3101,'delete from transaction_total_check where cny = -3101 and jpy = -310100 and gbp = -2170.7 and eur = -344211 and  hkd = -2790.9','')")

    con:query("insert into check_sql values(-3100,'delete from transaction_total_check where cny = -3100 and jpy = -310000 and gbp = -2170.0 and eur = -344100 and  hkd = -2790.0','')")

    con:query("insert into check_sql values(-3099,'delete from transaction_total_check where cny = -3099 and jpy = -309900 and gbp = -2169.3 and eur = -343989 and  hkd = -2789.1','')")

    con:query("insert into check_sql values(-3098,'delete from transaction_total_check where cny = -3098 and jpy = -309800 and gbp = -2168.6 and eur = -343878 and  hkd = -2788.2','')")

    con:query("insert into check_sql values(-3097,'delete from transaction_total_check where cny = -3097 and jpy = -309700 and gbp = -2167.9 and eur = -343767 and  hkd = -2787.3','')")

    con:query("insert into check_sql values(-3096,'delete from transaction_total_check where cny = -3096 and jpy = -309600 and gbp = -2167.2 and eur = -343656 and  hkd = -2786.4','')")

    con:query("insert into check_sql values(-3095,'delete from transaction_total_check where cny = -3095 and jpy = -309500 and gbp = -2166.5 and eur = -343545 and  hkd = -2785.5','')")

    con:query("insert into check_sql values(-3094,'delete from transaction_total_check where cny = -3094 and jpy = -309400 and gbp = -2165.8 and eur = -343434 and  hkd = -2784.6','')")

    con:query("insert into check_sql values(-3093,'delete from transaction_total_check where cny = -3093 and jpy = -309300 and gbp = -2165.1 and eur = -343323 and  hkd = -2783.7','')")

    con:query("insert into check_sql values(-3092,'delete from transaction_total_check where cny = -3092 and jpy = -309200 and gbp = -2164.4 and eur = -343212 and  hkd = -2782.8','')")

    con:query("insert into check_sql values(-3091,'delete from transaction_total_check where cny = -3091 and jpy = -309100 and gbp = -2163.7 and eur = -343101 and  hkd = -2781.9','')")

    con:query("insert into check_sql values(-3090,'delete from transaction_total_check where cny = -3090 and jpy = -309000 and gbp = -2163.0 and eur = -342990 and  hkd = -2781.0','')")

    con:query("insert into check_sql values(-3089,'delete from transaction_total_check where cny = -3089 and jpy = -308900 and gbp = -2162.3 and eur = -342879 and  hkd = -2780.1','')")

    con:query("insert into check_sql values(-3088,'delete from transaction_total_check where cny = -3088 and jpy = -308800 and gbp = -2161.6 and eur = -342768 and  hkd = -2779.2','')")

    con:query("insert into check_sql values(-3087,'delete from transaction_total_check where cny = -3087 and jpy = -308700 and gbp = -2160.9 and eur = -342657 and  hkd = -2778.3','')")

    con:query("insert into check_sql values(-3086,'delete from transaction_total_check where cny = -3086 and jpy = -308600 and gbp = -2160.2 and eur = -342546 and  hkd = -2777.4','')")

    con:query("insert into check_sql values(-3085,'delete from transaction_total_check where cny = -3085 and jpy = -308500 and gbp = -2159.5 and eur = -342435 and  hkd = -2776.5','')")

    con:query("insert into check_sql values(-3084,'delete from transaction_total_check where cny = -3084 and jpy = -308400 and gbp = -2158.8 and eur = -342324 and  hkd = -2775.6','')")

    con:query("insert into check_sql values(-3083,'delete from transaction_total_check where cny = -3083 and jpy = -308300 and gbp = -2158.1 and eur = -342213 and  hkd = -2774.7','')")

    con:query("insert into check_sql values(-3082,'delete from transaction_total_check where cny = -3082 and jpy = -308200 and gbp = -2157.4 and eur = -342102 and  hkd = -2773.8','')")

    con:query("insert into check_sql values(-3081,'delete from transaction_total_check where cny = -3081 and jpy = -308100 and gbp = -2156.7 and eur = -341991 and  hkd = -2772.9','')")

    con:query("insert into check_sql values(-3080,'delete from transaction_total_check where cny = -3080 and jpy = -308000 and gbp = -2156.0 and eur = -341880 and  hkd = -2772.0','')")

    con:query("insert into check_sql values(-3079,'delete from transaction_total_check where cny = -3079 and jpy = -307900 and gbp = -2155.3 and eur = -341769 and  hkd = -2771.1','')")

    con:query("insert into check_sql values(-3078,'delete from transaction_total_check where cny = -3078 and jpy = -307800 and gbp = -2154.6 and eur = -341658 and  hkd = -2770.2','')")

    con:query("insert into check_sql values(-3077,'delete from transaction_total_check where cny = -3077 and jpy = -307700 and gbp = -2153.9 and eur = -341547 and  hkd = -2769.3','')")

    con:query("insert into check_sql values(-3076,'delete from transaction_total_check where cny = -3076 and jpy = -307600 and gbp = -2153.2 and eur = -341436 and  hkd = -2768.4','')")

    con:query("insert into check_sql values(-3075,'delete from transaction_total_check where cny = -3075 and jpy = -307500 and gbp = -2152.5 and eur = -341325 and  hkd = -2767.5','')")

    con:query("insert into check_sql values(-3074,'delete from transaction_total_check where cny = -3074 and jpy = -307400 and gbp = -2151.8 and eur = -341214 and  hkd = -2766.6','')")

    con:query("insert into check_sql values(-3073,'delete from transaction_total_check where cny = -3073 and jpy = -307300 and gbp = -2151.1 and eur = -341103 and  hkd = -2765.7','')")

    con:query("insert into check_sql values(-3072,'delete from transaction_total_check where cny = -3072 and jpy = -307200 and gbp = -2150.4 and eur = -340992 and  hkd = -2764.8','')")

    con:query("insert into check_sql values(-3071,'delete from transaction_total_check where cny = -3071 and jpy = -307100 and gbp = -2149.7 and eur = -340881 and  hkd = -2763.9','')")

    con:query("insert into check_sql values(-3070,'delete from transaction_total_check where cny = -3070 and jpy = -307000 and gbp = -2149.0 and eur = -340770 and  hkd = -2763.0','')")

    con:query("insert into check_sql values(-3069,'delete from transaction_total_check where cny = -3069 and jpy = -306900 and gbp = -2148.3 and eur = -340659 and  hkd = -2762.1','')")

    con:query("insert into check_sql values(-3068,'delete from transaction_total_check where cny = -3068 and jpy = -306800 and gbp = -2147.6 and eur = -340548 and  hkd = -2761.2','')")

    con:query("insert into check_sql values(-3067,'delete from transaction_total_check where cny = -3067 and jpy = -306700 and gbp = -2146.9 and eur = -340437 and  hkd = -2760.3','')")

    con:query("insert into check_sql values(-3066,'delete from transaction_total_check where cny = -3066 and jpy = -306600 and gbp = -2146.2 and eur = -340326 and  hkd = -2759.4','')")

    con:query("insert into check_sql values(-3065,'delete from transaction_total_check where cny = -3065 and jpy = -306500 and gbp = -2145.5 and eur = -340215 and  hkd = -2758.5','')")

    con:query("insert into check_sql values(-3064,'delete from transaction_total_check where cny = -3064 and jpy = -306400 and gbp = -2144.8 and eur = -340104 and  hkd = -2757.6','')")

    con:query("insert into check_sql values(-3063,'delete from transaction_total_check where cny = -3063 and jpy = -306300 and gbp = -2144.1 and eur = -339993 and  hkd = -2756.7','')")

    con:query("insert into check_sql values(-3062,'delete from transaction_total_check where cny = -3062 and jpy = -306200 and gbp = -2143.4 and eur = -339882 and  hkd = -2755.8','')")

    con:query("insert into check_sql values(-3061,'delete from transaction_total_check where cny = -3061 and jpy = -306100 and gbp = -2142.7 and eur = -339771 and  hkd = -2754.9','')")

    con:query("insert into check_sql values(-3060,'delete from transaction_total_check where cny = -3060 and jpy = -306000 and gbp = -2142.0 and eur = -339660 and  hkd = -2754.0','')")

    con:query("insert into check_sql values(-3059,'delete from transaction_total_check where cny = -3059 and jpy = -305900 and gbp = -2141.3 and eur = -339549 and  hkd = -2753.1','')")

    con:query("insert into check_sql values(-3058,'delete from transaction_total_check where cny = -3058 and jpy = -305800 and gbp = -2140.6 and eur = -339438 and  hkd = -2752.2','')")

    con:query("insert into check_sql values(-3057,'delete from transaction_total_check where cny = -3057 and jpy = -305700 and gbp = -2139.9 and eur = -339327 and  hkd = -2751.3','')")

    con:query("insert into check_sql values(-3056,'delete from transaction_total_check where cny = -3056 and jpy = -305600 and gbp = -2139.2 and eur = -339216 and  hkd = -2750.4','')")

    con:query("insert into check_sql values(-3055,'delete from transaction_total_check where cny = -3055 and jpy = -305500 and gbp = -2138.5 and eur = -339105 and  hkd = -2749.5','')")

    con:query("insert into check_sql values(-3054,'delete from transaction_total_check where cny = -3054 and jpy = -305400 and gbp = -2137.8 and eur = -338994 and  hkd = -2748.6','')")

    con:query("insert into check_sql values(-3053,'delete from transaction_total_check where cny = -3053 and jpy = -305300 and gbp = -2137.1 and eur = -338883 and  hkd = -2747.7','')")

    con:query("insert into check_sql values(-3052,'delete from transaction_total_check where cny = -3052 and jpy = -305200 and gbp = -2136.4 and eur = -338772 and  hkd = -2746.8','')")

    con:query("insert into check_sql values(-3051,'delete from transaction_total_check where cny = -3051 and jpy = -305100 and gbp = -2135.7 and eur = -338661 and  hkd = -2745.9','')")

    con:query("insert into check_sql values(-3050,'delete from transaction_total_check where cny = -3050 and jpy = -305000 and gbp = -2135.0 and eur = -338550 and  hkd = -2745.0','')")

    con:query("insert into check_sql values(-3049,'delete from transaction_total_check where cny = -3049 and jpy = -304900 and gbp = -2134.3 and eur = -338439 and  hkd = -2744.1','')")

    con:query("insert into check_sql values(-3048,'delete from transaction_total_check where cny = -3048 and jpy = -304800 and gbp = -2133.6 and eur = -338328 and  hkd = -2743.2','')")

    con:query("insert into check_sql values(-3047,'delete from transaction_total_check where cny = -3047 and jpy = -304700 and gbp = -2132.9 and eur = -338217 and  hkd = -2742.3','')")

    con:query("insert into check_sql values(-3046,'delete from transaction_total_check where cny = -3046 and jpy = -304600 and gbp = -2132.2 and eur = -338106 and  hkd = -2741.4','')")

    con:query("insert into check_sql values(-3045,'delete from transaction_total_check where cny = -3045 and jpy = -304500 and gbp = -2131.5 and eur = -337995 and  hkd = -2740.5','')")

    con:query("insert into check_sql values(-3044,'delete from transaction_total_check where cny = -3044 and jpy = -304400 and gbp = -2130.8 and eur = -337884 and  hkd = -2739.6','')")

    con:query("insert into check_sql values(-3043,'delete from transaction_total_check where cny = -3043 and jpy = -304300 and gbp = -2130.1 and eur = -337773 and  hkd = -2738.7','')")

    con:query("insert into check_sql values(-3042,'delete from transaction_total_check where cny = -3042 and jpy = -304200 and gbp = -2129.4 and eur = -337662 and  hkd = -2737.8','')")

    con:query("insert into check_sql values(-3041,'delete from transaction_total_check where cny = -3041 and jpy = -304100 and gbp = -2128.7 and eur = -337551 and  hkd = -2736.9','')")

    con:query("insert into check_sql values(-3040,'delete from transaction_total_check where cny = -3040 and jpy = -304000 and gbp = -2128.0 and eur = -337440 and  hkd = -2736.0','')")

    con:query("insert into check_sql values(-3039,'delete from transaction_total_check where cny = -3039 and jpy = -303900 and gbp = -2127.3 and eur = -337329 and  hkd = -2735.1','')")

    con:query("insert into check_sql values(-3038,'delete from transaction_total_check where cny = -3038 and jpy = -303800 and gbp = -2126.6 and eur = -337218 and  hkd = -2734.2','')")

    con:query("insert into check_sql values(-3037,'delete from transaction_total_check where cny = -3037 and jpy = -303700 and gbp = -2125.9 and eur = -337107 and  hkd = -2733.3','')")

    con:query("insert into check_sql values(-3036,'delete from transaction_total_check where cny = -3036 and jpy = -303600 and gbp = -2125.2 and eur = -336996 and  hkd = -2732.4','')")

    con:query("insert into check_sql values(-3035,'delete from transaction_total_check where cny = -3035 and jpy = -303500 and gbp = -2124.5 and eur = -336885 and  hkd = -2731.5','')")

    con:query("insert into check_sql values(-3034,'delete from transaction_total_check where cny = -3034 and jpy = -303400 and gbp = -2123.8 and eur = -336774 and  hkd = -2730.6','')")

    con:query("insert into check_sql values(-3033,'delete from transaction_total_check where cny = -3033 and jpy = -303300 and gbp = -2123.1 and eur = -336663 and  hkd = -2729.7','')")

    con:query("insert into check_sql values(-3032,'delete from transaction_total_check where cny = -3032 and jpy = -303200 and gbp = -2122.4 and eur = -336552 and  hkd = -2728.8','')")

    con:query("insert into check_sql values(-3031,'delete from transaction_total_check where cny = -3031 and jpy = -303100 and gbp = -2121.7 and eur = -336441 and  hkd = -2727.9','')")

    con:query("insert into check_sql values(-3030,'delete from transaction_total_check where cny = -3030 and jpy = -303000 and gbp = -2121.0 and eur = -336330 and  hkd = -2727.0','')")

    con:query("insert into check_sql values(-3029,'delete from transaction_total_check where cny = -3029 and jpy = -302900 and gbp = -2120.3 and eur = -336219 and  hkd = -2726.1','')")

    con:query("insert into check_sql values(-3028,'delete from transaction_total_check where cny = -3028 and jpy = -302800 and gbp = -2119.6 and eur = -336108 and  hkd = -2725.2','')")

    con:query("insert into check_sql values(-3027,'delete from transaction_total_check where cny = -3027 and jpy = -302700 and gbp = -2118.9 and eur = -335997 and  hkd = -2724.3','')")

    con:query("insert into check_sql values(-3026,'delete from transaction_total_check where cny = -3026 and jpy = -302600 and gbp = -2118.2 and eur = -335886 and  hkd = -2723.4','')")

    con:query("insert into check_sql values(-3025,'delete from transaction_total_check where cny = -3025 and jpy = -302500 and gbp = -2117.5 and eur = -335775 and  hkd = -2722.5','')")

    con:query("insert into check_sql values(-3024,'delete from transaction_total_check where cny = -3024 and jpy = -302400 and gbp = -2116.8 and eur = -335664 and  hkd = -2721.6','')")

    con:query("insert into check_sql values(-3023,'delete from transaction_total_check where cny = -3023 and jpy = -302300 and gbp = -2116.1 and eur = -335553 and  hkd = -2720.7','')")

    con:query("insert into check_sql values(-3022,'delete from transaction_total_check where cny = -3022 and jpy = -302200 and gbp = -2115.4 and eur = -335442 and  hkd = -2719.8','')")

    con:query("insert into check_sql values(-3021,'delete from transaction_total_check where cny = -3021 and jpy = -302100 and gbp = -2114.7 and eur = -335331 and  hkd = -2718.9','')")

    con:query("insert into check_sql values(-3020,'delete from transaction_total_check where cny = -3020 and jpy = -302000 and gbp = -2114.0 and eur = -335220 and  hkd = -2718.0','')")

    con:query("insert into check_sql values(-3019,'delete from transaction_total_check where cny = -3019 and jpy = -301900 and gbp = -2113.3 and eur = -335109 and  hkd = -2717.1','')")

    con:query("insert into check_sql values(-3018,'delete from transaction_total_check where cny = -3018 and jpy = -301800 and gbp = -2112.6 and eur = -334998 and  hkd = -2716.2','')")

    con:query("insert into check_sql values(-3017,'delete from transaction_total_check where cny = -3017 and jpy = -301700 and gbp = -2111.9 and eur = -334887 and  hkd = -2715.3','')")

    con:query("insert into check_sql values(-3016,'delete from transaction_total_check where cny = -3016 and jpy = -301600 and gbp = -2111.2 and eur = -334776 and  hkd = -2714.4','')")

    con:query("insert into check_sql values(-3015,'delete from transaction_total_check where cny = -3015 and jpy = -301500 and gbp = -2110.5 and eur = -334665 and  hkd = -2713.5','')")

    con:query("insert into check_sql values(-3014,'delete from transaction_total_check where cny = -3014 and jpy = -301400 and gbp = -2109.8 and eur = -334554 and  hkd = -2712.6','')")

    con:query("insert into check_sql values(-3013,'delete from transaction_total_check where cny = -3013 and jpy = -301300 and gbp = -2109.1 and eur = -334443 and  hkd = -2711.7','')")

    con:query("insert into check_sql values(-3012,'delete from transaction_total_check where cny = -3012 and jpy = -301200 and gbp = -2108.4 and eur = -334332 and  hkd = -2710.8','')")

    con:query("insert into check_sql values(-3011,'delete from transaction_total_check where cny = -3011 and jpy = -301100 and gbp = -2107.7 and eur = -334221 and  hkd = -2709.9','')")

    con:query("insert into check_sql values(-3010,'delete from transaction_total_check where cny = -3010 and jpy = -301000 and gbp = -2107.0 and eur = -334110 and  hkd = -2709.0','')")

    con:query("insert into check_sql values(-3009,'delete from transaction_total_check where cny = -3009 and jpy = -300900 and gbp = -2106.3 and eur = -333999 and  hkd = -2708.1','')")

    con:query("insert into check_sql values(-3008,'delete from transaction_total_check where cny = -3008 and jpy = -300800 and gbp = -2105.6 and eur = -333888 and  hkd = -2707.2','')")

    con:query("insert into check_sql values(-3007,'delete from transaction_total_check where cny = -3007 and jpy = -300700 and gbp = -2104.9 and eur = -333777 and  hkd = -2706.3','')")

    con:query("insert into check_sql values(-3006,'delete from transaction_total_check where cny = -3006 and jpy = -300600 and gbp = -2104.2 and eur = -333666 and  hkd = -2705.4','')")

    con:query("insert into check_sql values(-3005,'delete from transaction_total_check where cny = -3005 and jpy = -300500 and gbp = -2103.5 and eur = -333555 and  hkd = -2704.5','')")

    con:query("insert into check_sql values(-3004,'delete from transaction_total_check where cny = -3004 and jpy = -300400 and gbp = -2102.8 and eur = -333444 and  hkd = -2703.6','')")

    con:query("insert into check_sql values(-3003,'delete from transaction_total_check where cny = -3003 and jpy = -300300 and gbp = -2102.1 and eur = -333333 and  hkd = -2702.7','')")

    con:query("insert into check_sql values(-3002,'delete from transaction_total_check where cny = -3002 and jpy = -300200 and gbp = -2101.4 and eur = -333222 and  hkd = -2701.8','')")

    con:query("insert into check_sql values(-3001,'delete from transaction_total_check where cny = -3001 and jpy = -300100 and gbp = -2100.7 and eur = -333111 and  hkd = -2700.9','')")

    con:query("insert into check_sql values(-3000,'delete from transaction_total_check where cny = -3000 and jpy = -300000 and gbp = -2100.0 and eur = -333000 and  hkd = -2700.0','')")

    con:query("insert into check_sql values(-2999,'delete from transaction_total_check where cny = -2999 and jpy = -299900 and gbp = -2099.3 and eur = -332889 and  hkd = -2699.1','')")

    con:query("insert into check_sql values(-2998,'delete from transaction_total_check where cny = -2998 and jpy = -299800 and gbp = -2098.6 and eur = -332778 and  hkd = -2698.2','')")

    con:query("insert into check_sql values(-2997,'delete from transaction_total_check where cny = -2997 and jpy = -299700 and gbp = -2097.9 and eur = -332667 and  hkd = -2697.3','')")

    con:query("insert into check_sql values(-2996,'delete from transaction_total_check where cny = -2996 and jpy = -299600 and gbp = -2097.2 and eur = -332556 and  hkd = -2696.4','')")

    con:query("insert into check_sql values(-2995,'delete from transaction_total_check where cny = -2995 and jpy = -299500 and gbp = -2096.5 and eur = -332445 and  hkd = -2695.5','')")

    con:query("insert into check_sql values(-2994,'delete from transaction_total_check where cny = -2994 and jpy = -299400 and gbp = -2095.8 and eur = -332334 and  hkd = -2694.6','')")

    con:query("insert into check_sql values(-2993,'delete from transaction_total_check where cny = -2993 and jpy = -299300 and gbp = -2095.1 and eur = -332223 and  hkd = -2693.7','')")

    con:query("insert into check_sql values(-2992,'delete from transaction_total_check where cny = -2992 and jpy = -299200 and gbp = -2094.4 and eur = -332112 and  hkd = -2692.8','')")

    con:query("insert into check_sql values(-2991,'delete from transaction_total_check where cny = -2991 and jpy = -299100 and gbp = -2093.7 and eur = -332001 and  hkd = -2691.9','')")

    con:query("insert into check_sql values(-2990,'delete from transaction_total_check where cny = -2990 and jpy = -299000 and gbp = -2093.0 and eur = -331890 and  hkd = -2691.0','')")

    con:query("insert into check_sql values(-2989,'delete from transaction_total_check where cny = -2989 and jpy = -298900 and gbp = -2092.3 and eur = -331779 and  hkd = -2690.1','')")

    con:query("insert into check_sql values(-2988,'delete from transaction_total_check where cny = -2988 and jpy = -298800 and gbp = -2091.6 and eur = -331668 and  hkd = -2689.2','')")

    con:query("insert into check_sql values(-2987,'delete from transaction_total_check where cny = -2987 and jpy = -298700 and gbp = -2090.9 and eur = -331557 and  hkd = -2688.3','')")

    con:query("insert into check_sql values(-2986,'delete from transaction_total_check where cny = -2986 and jpy = -298600 and gbp = -2090.2 and eur = -331446 and  hkd = -2687.4','')")

    con:query("insert into check_sql values(-2985,'delete from transaction_total_check where cny = -2985 and jpy = -298500 and gbp = -2089.5 and eur = -331335 and  hkd = -2686.5','')")

    con:query("insert into check_sql values(-2984,'delete from transaction_total_check where cny = -2984 and jpy = -298400 and gbp = -2088.8 and eur = -331224 and  hkd = -2685.6','')")

    con:query("insert into check_sql values(-2983,'delete from transaction_total_check where cny = -2983 and jpy = -298300 and gbp = -2088.1 and eur = -331113 and  hkd = -2684.7','')")

    con:query("insert into check_sql values(-2982,'delete from transaction_total_check where cny = -2982 and jpy = -298200 and gbp = -2087.4 and eur = -331002 and  hkd = -2683.8','')")

    con:query("insert into check_sql values(-2981,'delete from transaction_total_check where cny = -2981 and jpy = -298100 and gbp = -2086.7 and eur = -330891 and  hkd = -2682.9','')")

    con:query("insert into check_sql values(-2980,'delete from transaction_total_check where cny = -2980 and jpy = -298000 and gbp = -2086.0 and eur = -330780 and  hkd = -2682.0','')")

    con:query("insert into check_sql values(-2979,'delete from transaction_total_check where cny = -2979 and jpy = -297900 and gbp = -2085.3 and eur = -330669 and  hkd = -2681.1','')")

    con:query("insert into check_sql values(-2978,'delete from transaction_total_check where cny = -2978 and jpy = -297800 and gbp = -2084.6 and eur = -330558 and  hkd = -2680.2','')")

    con:query("insert into check_sql values(-2977,'delete from transaction_total_check where cny = -2977 and jpy = -297700 and gbp = -2083.9 and eur = -330447 and  hkd = -2679.3','')")

    con:query("insert into check_sql values(-2976,'delete from transaction_total_check where cny = -2976 and jpy = -297600 and gbp = -2083.2 and eur = -330336 and  hkd = -2678.4','')")

    con:query("insert into check_sql values(-2975,'delete from transaction_total_check where cny = -2975 and jpy = -297500 and gbp = -2082.5 and eur = -330225 and  hkd = -2677.5','')")

    con:query("insert into check_sql values(-2974,'delete from transaction_total_check where cny = -2974 and jpy = -297400 and gbp = -2081.8 and eur = -330114 and  hkd = -2676.6','')")

    con:query("insert into check_sql values(-2973,'delete from transaction_total_check where cny = -2973 and jpy = -297300 and gbp = -2081.1 and eur = -330003 and  hkd = -2675.7','')")

    con:query("insert into check_sql values(-2972,'delete from transaction_total_check where cny = -2972 and jpy = -297200 and gbp = -2080.4 and eur = -329892 and  hkd = -2674.8','')")

    con:query("insert into check_sql values(-2971,'delete from transaction_total_check where cny = -2971 and jpy = -297100 and gbp = -2079.7 and eur = -329781 and  hkd = -2673.9','')")

    con:query("insert into check_sql values(-2970,'delete from transaction_total_check where cny = -2970 and jpy = -297000 and gbp = -2079.0 and eur = -329670 and  hkd = -2673.0','')")

    con:query("insert into check_sql values(-2969,'delete from transaction_total_check where cny = -2969 and jpy = -296900 and gbp = -2078.3 and eur = -329559 and  hkd = -2672.1','')")

    con:query("insert into check_sql values(-2968,'delete from transaction_total_check where cny = -2968 and jpy = -296800 and gbp = -2077.6 and eur = -329448 and  hkd = -2671.2','')")

    con:query("insert into check_sql values(-2967,'delete from transaction_total_check where cny = -2967 and jpy = -296700 and gbp = -2076.9 and eur = -329337 and  hkd = -2670.3','')")

    con:query("insert into check_sql values(-2966,'delete from transaction_total_check where cny = -2966 and jpy = -296600 and gbp = -2076.2 and eur = -329226 and  hkd = -2669.4','')")

    con:query("insert into check_sql values(-2965,'delete from transaction_total_check where cny = -2965 and jpy = -296500 and gbp = -2075.5 and eur = -329115 and  hkd = -2668.5','')")

    con:query("insert into check_sql values(-2964,'delete from transaction_total_check where cny = -2964 and jpy = -296400 and gbp = -2074.8 and eur = -329004 and  hkd = -2667.6','')")

    con:query("insert into check_sql values(-2963,'delete from transaction_total_check where cny = -2963 and jpy = -296300 and gbp = -2074.1 and eur = -328893 and  hkd = -2666.7','')")

    con:query("insert into check_sql values(-2962,'delete from transaction_total_check where cny = -2962 and jpy = -296200 and gbp = -2073.4 and eur = -328782 and  hkd = -2665.8','')")

    con:query("insert into check_sql values(-2961,'delete from transaction_total_check where cny = -2961 and jpy = -296100 and gbp = -2072.7 and eur = -328671 and  hkd = -2664.9','')")

    con:query("insert into check_sql values(-2960,'delete from transaction_total_check where cny = -2960 and jpy = -296000 and gbp = -2072.0 and eur = -328560 and  hkd = -2664.0','')")

    con:query("insert into check_sql values(-2959,'delete from transaction_total_check where cny = -2959 and jpy = -295900 and gbp = -2071.3 and eur = -328449 and  hkd = -2663.1','')")

    con:query("insert into check_sql values(-2958,'delete from transaction_total_check where cny = -2958 and jpy = -295800 and gbp = -2070.6 and eur = -328338 and  hkd = -2662.2','')")

    con:query("insert into check_sql values(-2957,'delete from transaction_total_check where cny = -2957 and jpy = -295700 and gbp = -2069.9 and eur = -328227 and  hkd = -2661.3','')")

    con:query("insert into check_sql values(-2956,'delete from transaction_total_check where cny = -2956 and jpy = -295600 and gbp = -2069.2 and eur = -328116 and  hkd = -2660.4','')")

    con:query("insert into check_sql values(-2955,'delete from transaction_total_check where cny = -2955 and jpy = -295500 and gbp = -2068.5 and eur = -328005 and  hkd = -2659.5','')")

    con:query("insert into check_sql values(-2954,'delete from transaction_total_check where cny = -2954 and jpy = -295400 and gbp = -2067.8 and eur = -327894 and  hkd = -2658.6','')")

    con:query("insert into check_sql values(-2953,'delete from transaction_total_check where cny = -2953 and jpy = -295300 and gbp = -2067.1 and eur = -327783 and  hkd = -2657.7','')")

    con:query("insert into check_sql values(-2952,'delete from transaction_total_check where cny = -2952 and jpy = -295200 and gbp = -2066.4 and eur = -327672 and  hkd = -2656.8','')")

    con:query("insert into check_sql values(-2951,'delete from transaction_total_check where cny = -2951 and jpy = -295100 and gbp = -2065.7 and eur = -327561 and  hkd = -2655.9','')")

    con:query("insert into check_sql values(-2950,'delete from transaction_total_check where cny = -2950 and jpy = -295000 and gbp = -2065.0 and eur = -327450 and  hkd = -2655.0','')")

    con:query("insert into check_sql values(-2949,'delete from transaction_total_check where cny = -2949 and jpy = -294900 and gbp = -2064.3 and eur = -327339 and  hkd = -2654.1','')")

    con:query("insert into check_sql values(-2948,'delete from transaction_total_check where cny = -2948 and jpy = -294800 and gbp = -2063.6 and eur = -327228 and  hkd = -2653.2','')")

    con:query("insert into check_sql values(-2947,'delete from transaction_total_check where cny = -2947 and jpy = -294700 and gbp = -2062.9 and eur = -327117 and  hkd = -2652.3','')")

    con:query("insert into check_sql values(-2946,'delete from transaction_total_check where cny = -2946 and jpy = -294600 and gbp = -2062.2 and eur = -327006 and  hkd = -2651.4','')")

    con:query("insert into check_sql values(-2945,'delete from transaction_total_check where cny = -2945 and jpy = -294500 and gbp = -2061.5 and eur = -326895 and  hkd = -2650.5','')")

    con:query("insert into check_sql values(-2944,'delete from transaction_total_check where cny = -2944 and jpy = -294400 and gbp = -2060.8 and eur = -326784 and  hkd = -2649.6','')")

    con:query("insert into check_sql values(-2943,'delete from transaction_total_check where cny = -2943 and jpy = -294300 and gbp = -2060.1 and eur = -326673 and  hkd = -2648.7','')")

    con:query("insert into check_sql values(-2942,'delete from transaction_total_check where cny = -2942 and jpy = -294200 and gbp = -2059.4 and eur = -326562 and  hkd = -2647.8','')")

    con:query("insert into check_sql values(-2941,'delete from transaction_total_check where cny = -2941 and jpy = -294100 and gbp = -2058.7 and eur = -326451 and  hkd = -2646.9','')")

    con:query("insert into check_sql values(-2940,'delete from transaction_total_check where cny = -2940 and jpy = -294000 and gbp = -2058.0 and eur = -326340 and  hkd = -2646.0','')")

    con:query("insert into check_sql values(-2939,'delete from transaction_total_check where cny = -2939 and jpy = -293900 and gbp = -2057.3 and eur = -326229 and  hkd = -2645.1','')")

    con:query("insert into check_sql values(-2938,'delete from transaction_total_check where cny = -2938 and jpy = -293800 and gbp = -2056.6 and eur = -326118 and  hkd = -2644.2','')")

    con:query("insert into check_sql values(-2937,'delete from transaction_total_check where cny = -2937 and jpy = -293700 and gbp = -2055.9 and eur = -326007 and  hkd = -2643.3','')")

    con:query("insert into check_sql values(-2936,'delete from transaction_total_check where cny = -2936 and jpy = -293600 and gbp = -2055.2 and eur = -325896 and  hkd = -2642.4','')")

    con:query("insert into check_sql values(-2935,'delete from transaction_total_check where cny = -2935 and jpy = -293500 and gbp = -2054.5 and eur = -325785 and  hkd = -2641.5','')")

    con:query("insert into check_sql values(-2934,'delete from transaction_total_check where cny = -2934 and jpy = -293400 and gbp = -2053.8 and eur = -325674 and  hkd = -2640.6','')")

    con:query("insert into check_sql values(-2933,'delete from transaction_total_check where cny = -2933 and jpy = -293300 and gbp = -2053.1 and eur = -325563 and  hkd = -2639.7','')")

    con:query("insert into check_sql values(-2932,'delete from transaction_total_check where cny = -2932 and jpy = -293200 and gbp = -2052.4 and eur = -325452 and  hkd = -2638.8','')")

    con:query("insert into check_sql values(-2931,'delete from transaction_total_check where cny = -2931 and jpy = -293100 and gbp = -2051.7 and eur = -325341 and  hkd = -2637.9','')")

    con:query("insert into check_sql values(-2930,'delete from transaction_total_check where cny = -2930 and jpy = -293000 and gbp = -2051.0 and eur = -325230 and  hkd = -2637.0','')")

    con:query("insert into check_sql values(-2929,'delete from transaction_total_check where cny = -2929 and jpy = -292900 and gbp = -2050.3 and eur = -325119 and  hkd = -2636.1','')")

    con:query("insert into check_sql values(-2928,'delete from transaction_total_check where cny = -2928 and jpy = -292800 and gbp = -2049.6 and eur = -325008 and  hkd = -2635.2','')")

    con:query("insert into check_sql values(-2927,'delete from transaction_total_check where cny = -2927 and jpy = -292700 and gbp = -2048.9 and eur = -324897 and  hkd = -2634.3','')")

    con:query("insert into check_sql values(-2926,'delete from transaction_total_check where cny = -2926 and jpy = -292600 and gbp = -2048.2 and eur = -324786 and  hkd = -2633.4','')")

    con:query("insert into check_sql values(-2925,'delete from transaction_total_check where cny = -2925 and jpy = -292500 and gbp = -2047.5 and eur = -324675 and  hkd = -2632.5','')")

    con:query("insert into check_sql values(-2924,'delete from transaction_total_check where cny = -2924 and jpy = -292400 and gbp = -2046.8 and eur = -324564 and  hkd = -2631.6','')")

    con:query("insert into check_sql values(-2923,'delete from transaction_total_check where cny = -2923 and jpy = -292300 and gbp = -2046.1 and eur = -324453 and  hkd = -2630.7','')")

    con:query("insert into check_sql values(-2922,'delete from transaction_total_check where cny = -2922 and jpy = -292200 and gbp = -2045.4 and eur = -324342 and  hkd = -2629.8','')")

    con:query("insert into check_sql values(-2921,'delete from transaction_total_check where cny = -2921 and jpy = -292100 and gbp = -2044.7 and eur = -324231 and  hkd = -2628.9','')")

    con:query("insert into check_sql values(-2920,'delete from transaction_total_check where cny = -2920 and jpy = -292000 and gbp = -2044.0 and eur = -324120 and  hkd = -2628.0','')")

    con:query("insert into check_sql values(-2919,'delete from transaction_total_check where cny = -2919 and jpy = -291900 and gbp = -2043.3 and eur = -324009 and  hkd = -2627.1','')")

    con:query("insert into check_sql values(-2918,'delete from transaction_total_check where cny = -2918 and jpy = -291800 and gbp = -2042.6 and eur = -323898 and  hkd = -2626.2','')")

    con:query("insert into check_sql values(-2917,'delete from transaction_total_check where cny = -2917 and jpy = -291700 and gbp = -2041.9 and eur = -323787 and  hkd = -2625.3','')")

    con:query("insert into check_sql values(-2916,'delete from transaction_total_check where cny = -2916 and jpy = -291600 and gbp = -2041.2 and eur = -323676 and  hkd = -2624.4','')")

    con:query("insert into check_sql values(-2915,'delete from transaction_total_check where cny = -2915 and jpy = -291500 and gbp = -2040.5 and eur = -323565 and  hkd = -2623.5','')")

    con:query("insert into check_sql values(-2914,'delete from transaction_total_check where cny = -2914 and jpy = -291400 and gbp = -2039.8 and eur = -323454 and  hkd = -2622.6','')")

    con:query("insert into check_sql values(-2913,'delete from transaction_total_check where cny = -2913 and jpy = -291300 and gbp = -2039.1 and eur = -323343 and  hkd = -2621.7','')")

    con:query("insert into check_sql values(-2912,'delete from transaction_total_check where cny = -2912 and jpy = -291200 and gbp = -2038.4 and eur = -323232 and  hkd = -2620.8','')")

    con:query("insert into check_sql values(-2911,'delete from transaction_total_check where cny = -2911 and jpy = -291100 and gbp = -2037.7 and eur = -323121 and  hkd = -2619.9','')")

    con:query("insert into check_sql values(-2910,'delete from transaction_total_check where cny = -2910 and jpy = -291000 and gbp = -2037.0 and eur = -323010 and  hkd = -2619.0','')")

    con:query("insert into check_sql values(-2909,'delete from transaction_total_check where cny = -2909 and jpy = -290900 and gbp = -2036.3 and eur = -322899 and  hkd = -2618.1','')")

    con:query("insert into check_sql values(-2908,'delete from transaction_total_check where cny = -2908 and jpy = -290800 and gbp = -2035.6 and eur = -322788 and  hkd = -2617.2','')")

    con:query("insert into check_sql values(-2907,'delete from transaction_total_check where cny = -2907 and jpy = -290700 and gbp = -2034.9 and eur = -322677 and  hkd = -2616.3','')")

    con:query("insert into check_sql values(-2906,'delete from transaction_total_check where cny = -2906 and jpy = -290600 and gbp = -2034.2 and eur = -322566 and  hkd = -2615.4','')")

    con:query("insert into check_sql values(-2905,'delete from transaction_total_check where cny = -2905 and jpy = -290500 and gbp = -2033.5 and eur = -322455 and  hkd = -2614.5','')")

    con:query("insert into check_sql values(-2904,'delete from transaction_total_check where cny = -2904 and jpy = -290400 and gbp = -2032.8 and eur = -322344 and  hkd = -2613.6','')")

    con:query("insert into check_sql values(-2903,'delete from transaction_total_check where cny = -2903 and jpy = -290300 and gbp = -2032.1 and eur = -322233 and  hkd = -2612.7','')")

    con:query("insert into check_sql values(-2902,'delete from transaction_total_check where cny = -2902 and jpy = -290200 and gbp = -2031.4 and eur = -322122 and  hkd = -2611.8','')")

    con:query("insert into check_sql values(-2901,'delete from transaction_total_check where cny = -2901 and jpy = -290100 and gbp = -2030.7 and eur = -322011 and  hkd = -2610.9','')")

    con:query("insert into check_sql values(-2900,'delete from transaction_total_check where cny = -2900 and jpy = -290000 and gbp = -2030.0 and eur = -321900 and  hkd = -2610.0','')")

    con:query("insert into check_sql values(-2899,'delete from transaction_total_check where cny = -2899 and jpy = -289900 and gbp = -2029.3 and eur = -321789 and  hkd = -2609.1','')")

    con:query("insert into check_sql values(-2898,'delete from transaction_total_check where cny = -2898 and jpy = -289800 and gbp = -2028.6 and eur = -321678 and  hkd = -2608.2','')")

    con:query("insert into check_sql values(-2897,'delete from transaction_total_check where cny = -2897 and jpy = -289700 and gbp = -2027.9 and eur = -321567 and  hkd = -2607.3','')")

    con:query("insert into check_sql values(-2896,'delete from transaction_total_check where cny = -2896 and jpy = -289600 and gbp = -2027.2 and eur = -321456 and  hkd = -2606.4','')")

    con:query("insert into check_sql values(-2895,'delete from transaction_total_check where cny = -2895 and jpy = -289500 and gbp = -2026.5 and eur = -321345 and  hkd = -2605.5','')")

    con:query("insert into check_sql values(-2894,'delete from transaction_total_check where cny = -2894 and jpy = -289400 and gbp = -2025.8 and eur = -321234 and  hkd = -2604.6','')")

    con:query("insert into check_sql values(-2893,'delete from transaction_total_check where cny = -2893 and jpy = -289300 and gbp = -2025.1 and eur = -321123 and  hkd = -2603.7','')")

    con:query("insert into check_sql values(-2892,'delete from transaction_total_check where cny = -2892 and jpy = -289200 and gbp = -2024.4 and eur = -321012 and  hkd = -2602.8','')")

    con:query("insert into check_sql values(-2891,'delete from transaction_total_check where cny = -2891 and jpy = -289100 and gbp = -2023.7 and eur = -320901 and  hkd = -2601.9','')")

    con:query("insert into check_sql values(-2890,'delete from transaction_total_check where cny = -2890 and jpy = -289000 and gbp = -2023.0 and eur = -320790 and  hkd = -2601.0','')")

    con:query("insert into check_sql values(-2889,'delete from transaction_total_check where cny = -2889 and jpy = -288900 and gbp = -2022.3 and eur = -320679 and  hkd = -2600.1','')")

    con:query("insert into check_sql values(-2888,'delete from transaction_total_check where cny = -2888 and jpy = -288800 and gbp = -2021.6 and eur = -320568 and  hkd = -2599.2','')")

    con:query("insert into check_sql values(-2887,'delete from transaction_total_check where cny = -2887 and jpy = -288700 and gbp = -2020.9 and eur = -320457 and  hkd = -2598.3','')")

    con:query("insert into check_sql values(-2886,'delete from transaction_total_check where cny = -2886 and jpy = -288600 and gbp = -2020.2 and eur = -320346 and  hkd = -2597.4','')")

    con:query("insert into check_sql values(-2885,'delete from transaction_total_check where cny = -2885 and jpy = -288500 and gbp = -2019.5 and eur = -320235 and  hkd = -2596.5','')")

    con:query("insert into check_sql values(-2884,'delete from transaction_total_check where cny = -2884 and jpy = -288400 and gbp = -2018.8 and eur = -320124 and  hkd = -2595.6','')")

    con:query("insert into check_sql values(-2883,'delete from transaction_total_check where cny = -2883 and jpy = -288300 and gbp = -2018.1 and eur = -320013 and  hkd = -2594.7','')")

    con:query("insert into check_sql values(-2882,'delete from transaction_total_check where cny = -2882 and jpy = -288200 and gbp = -2017.4 and eur = -319902 and  hkd = -2593.8','')")

    con:query("insert into check_sql values(-2881,'delete from transaction_total_check where cny = -2881 and jpy = -288100 and gbp = -2016.7 and eur = -319791 and  hkd = -2592.9','')")

    con:query("insert into check_sql values(-2880,'delete from transaction_total_check where cny = -2880 and jpy = -288000 and gbp = -2016.0 and eur = -319680 and  hkd = -2592.0','')")

    con:query("insert into check_sql values(-2879,'delete from transaction_total_check where cny = -2879 and jpy = -287900 and gbp = -2015.3 and eur = -319569 and  hkd = -2591.1','')")

    con:query("insert into check_sql values(-2878,'delete from transaction_total_check where cny = -2878 and jpy = -287800 and gbp = -2014.6 and eur = -319458 and  hkd = -2590.2','')")

    con:query("insert into check_sql values(-2877,'delete from transaction_total_check where cny = -2877 and jpy = -287700 and gbp = -2013.9 and eur = -319347 and  hkd = -2589.3','')")

    con:query("insert into check_sql values(-2876,'delete from transaction_total_check where cny = -2876 and jpy = -287600 and gbp = -2013.2 and eur = -319236 and  hkd = -2588.4','')")

    con:query("insert into check_sql values(-2875,'delete from transaction_total_check where cny = -2875 and jpy = -287500 and gbp = -2012.5 and eur = -319125 and  hkd = -2587.5','')")

    con:query("insert into check_sql values(-2874,'delete from transaction_total_check where cny = -2874 and jpy = -287400 and gbp = -2011.8 and eur = -319014 and  hkd = -2586.6','')")

    con:query("insert into check_sql values(-2873,'delete from transaction_total_check where cny = -2873 and jpy = -287300 and gbp = -2011.1 and eur = -318903 and  hkd = -2585.7','')")

    con:query("insert into check_sql values(-2872,'delete from transaction_total_check where cny = -2872 and jpy = -287200 and gbp = -2010.4 and eur = -318792 and  hkd = -2584.8','')")

    con:query("insert into check_sql values(-2871,'delete from transaction_total_check where cny = -2871 and jpy = -287100 and gbp = -2009.7 and eur = -318681 and  hkd = -2583.9','')")

    con:query("insert into check_sql values(-2870,'delete from transaction_total_check where cny = -2870 and jpy = -287000 and gbp = -2009.0 and eur = -318570 and  hkd = -2583.0','')")

    con:query("insert into check_sql values(-2869,'delete from transaction_total_check where cny = -2869 and jpy = -286900 and gbp = -2008.3 and eur = -318459 and  hkd = -2582.1','')")

    con:query("insert into check_sql values(-2868,'delete from transaction_total_check where cny = -2868 and jpy = -286800 and gbp = -2007.6 and eur = -318348 and  hkd = -2581.2','')")

    con:query("insert into check_sql values(-2867,'delete from transaction_total_check where cny = -2867 and jpy = -286700 and gbp = -2006.9 and eur = -318237 and  hkd = -2580.3','')")

    con:query("insert into check_sql values(-2866,'delete from transaction_total_check where cny = -2866 and jpy = -286600 and gbp = -2006.2 and eur = -318126 and  hkd = -2579.4','')")

    con:query("insert into check_sql values(-2865,'delete from transaction_total_check where cny = -2865 and jpy = -286500 and gbp = -2005.5 and eur = -318015 and  hkd = -2578.5','')")

    con:query("insert into check_sql values(-2864,'delete from transaction_total_check where cny = -2864 and jpy = -286400 and gbp = -2004.8 and eur = -317904 and  hkd = -2577.6','')")

    con:query("insert into check_sql values(-2863,'delete from transaction_total_check where cny = -2863 and jpy = -286300 and gbp = -2004.1 and eur = -317793 and  hkd = -2576.7','')")

    con:query("insert into check_sql values(-2862,'delete from transaction_total_check where cny = -2862 and jpy = -286200 and gbp = -2003.4 and eur = -317682 and  hkd = -2575.8','')")

    con:query("insert into check_sql values(-2861,'delete from transaction_total_check where cny = -2861 and jpy = -286100 and gbp = -2002.7 and eur = -317571 and  hkd = -2574.9','')")

    con:query("insert into check_sql values(-2860,'delete from transaction_total_check where cny = -2860 and jpy = -286000 and gbp = -2002.0 and eur = -317460 and  hkd = -2574.0','')")

    con:query("insert into check_sql values(-2859,'delete from transaction_total_check where cny = -2859 and jpy = -285900 and gbp = -2001.3 and eur = -317349 and  hkd = -2573.1','')")

    con:query("insert into check_sql values(-2858,'delete from transaction_total_check where cny = -2858 and jpy = -285800 and gbp = -2000.6 and eur = -317238 and  hkd = -2572.2','')")

    con:query("insert into check_sql values(-2857,'delete from transaction_total_check where cny = -2857 and jpy = -285700 and gbp = -1999.9 and eur = -317127 and  hkd = -2571.3','')")

    con:query("insert into check_sql values(-2856,'delete from transaction_total_check where cny = -2856 and jpy = -285600 and gbp = -1999.2 and eur = -317016 and  hkd = -2570.4','')")

    con:query("insert into check_sql values(-2855,'delete from transaction_total_check where cny = -2855 and jpy = -285500 and gbp = -1998.5 and eur = -316905 and  hkd = -2569.5','')")

    con:query("insert into check_sql values(-2854,'delete from transaction_total_check where cny = -2854 and jpy = -285400 and gbp = -1997.8 and eur = -316794 and  hkd = -2568.6','')")

    con:query("insert into check_sql values(-2853,'delete from transaction_total_check where cny = -2853 and jpy = -285300 and gbp = -1997.1 and eur = -316683 and  hkd = -2567.7','')")

    con:query("insert into check_sql values(-2852,'delete from transaction_total_check where cny = -2852 and jpy = -285200 and gbp = -1996.4 and eur = -316572 and  hkd = -2566.8','')")

    con:query("insert into check_sql values(-2851,'delete from transaction_total_check where cny = -2851 and jpy = -285100 and gbp = -1995.7 and eur = -316461 and  hkd = -2565.9','')")

    con:query("insert into check_sql values(-2850,'delete from transaction_total_check where cny = -2850 and jpy = -285000 and gbp = -1995.0 and eur = -316350 and  hkd = -2565.0','')")

    con:query("insert into check_sql values(-2849,'delete from transaction_total_check where cny = -2849 and jpy = -284900 and gbp = -1994.3 and eur = -316239 and  hkd = -2564.1','')")

    con:query("insert into check_sql values(-2848,'delete from transaction_total_check where cny = -2848 and jpy = -284800 and gbp = -1993.6 and eur = -316128 and  hkd = -2563.2','')")

    con:query("insert into check_sql values(-2847,'delete from transaction_total_check where cny = -2847 and jpy = -284700 and gbp = -1992.9 and eur = -316017 and  hkd = -2562.3','')")

    con:query("insert into check_sql values(-2846,'delete from transaction_total_check where cny = -2846 and jpy = -284600 and gbp = -1992.2 and eur = -315906 and  hkd = -2561.4','')")

    con:query("insert into check_sql values(-2845,'delete from transaction_total_check where cny = -2845 and jpy = -284500 and gbp = -1991.5 and eur = -315795 and  hkd = -2560.5','')")

    con:query("insert into check_sql values(-2844,'delete from transaction_total_check where cny = -2844 and jpy = -284400 and gbp = -1990.8 and eur = -315684 and  hkd = -2559.6','')")

    con:query("insert into check_sql values(-2843,'delete from transaction_total_check where cny = -2843 and jpy = -284300 and gbp = -1990.1 and eur = -315573 and  hkd = -2558.7','')")

    con:query("insert into check_sql values(-2842,'delete from transaction_total_check where cny = -2842 and jpy = -284200 and gbp = -1989.4 and eur = -315462 and  hkd = -2557.8','')")

    con:query("insert into check_sql values(-2841,'delete from transaction_total_check where cny = -2841 and jpy = -284100 and gbp = -1988.7 and eur = -315351 and  hkd = -2556.9','')")

    con:query("insert into check_sql values(-2840,'delete from transaction_total_check where cny = -2840 and jpy = -284000 and gbp = -1988.0 and eur = -315240 and  hkd = -2556.0','')")

    con:query("insert into check_sql values(-2839,'delete from transaction_total_check where cny = -2839 and jpy = -283900 and gbp = -1987.3 and eur = -315129 and  hkd = -2555.1','')")

    con:query("insert into check_sql values(-2838,'delete from transaction_total_check where cny = -2838 and jpy = -283800 and gbp = -1986.6 and eur = -315018 and  hkd = -2554.2','')")

    con:query("insert into check_sql values(-2837,'delete from transaction_total_check where cny = -2837 and jpy = -283700 and gbp = -1985.9 and eur = -314907 and  hkd = -2553.3','')")

    con:query("insert into check_sql values(-2836,'delete from transaction_total_check where cny = -2836 and jpy = -283600 and gbp = -1985.2 and eur = -314796 and  hkd = -2552.4','')")

    con:query("insert into check_sql values(-2835,'delete from transaction_total_check where cny = -2835 and jpy = -283500 and gbp = -1984.5 and eur = -314685 and  hkd = -2551.5','')")

    con:query("insert into check_sql values(-2834,'delete from transaction_total_check where cny = -2834 and jpy = -283400 and gbp = -1983.8 and eur = -314574 and  hkd = -2550.6','')")

    con:query("insert into check_sql values(-2833,'delete from transaction_total_check where cny = -2833 and jpy = -283300 and gbp = -1983.1 and eur = -314463 and  hkd = -2549.7','')")

    con:query("insert into check_sql values(-2832,'delete from transaction_total_check where cny = -2832 and jpy = -283200 and gbp = -1982.4 and eur = -314352 and  hkd = -2548.8','')")

    con:query("insert into check_sql values(-2831,'delete from transaction_total_check where cny = -2831 and jpy = -283100 and gbp = -1981.7 and eur = -314241 and  hkd = -2547.9','')")

    con:query("insert into check_sql values(-2830,'delete from transaction_total_check where cny = -2830 and jpy = -283000 and gbp = -1981.0 and eur = -314130 and  hkd = -2547.0','')")

    con:query("insert into check_sql values(-2829,'delete from transaction_total_check where cny = -2829 and jpy = -282900 and gbp = -1980.3 and eur = -314019 and  hkd = -2546.1','')")

    con:query("insert into check_sql values(-2828,'delete from transaction_total_check where cny = -2828 and jpy = -282800 and gbp = -1979.6 and eur = -313908 and  hkd = -2545.2','')")

    con:query("insert into check_sql values(-2827,'delete from transaction_total_check where cny = -2827 and jpy = -282700 and gbp = -1978.9 and eur = -313797 and  hkd = -2544.3','')")

    con:query("insert into check_sql values(-2826,'delete from transaction_total_check where cny = -2826 and jpy = -282600 and gbp = -1978.2 and eur = -313686 and  hkd = -2543.4','')")

    con:query("insert into check_sql values(-2825,'delete from transaction_total_check where cny = -2825 and jpy = -282500 and gbp = -1977.5 and eur = -313575 and  hkd = -2542.5','')")

    con:query("insert into check_sql values(-2824,'delete from transaction_total_check where cny = -2824 and jpy = -282400 and gbp = -1976.8 and eur = -313464 and  hkd = -2541.6','')")

    con:query("insert into check_sql values(-2823,'delete from transaction_total_check where cny = -2823 and jpy = -282300 and gbp = -1976.1 and eur = -313353 and  hkd = -2540.7','')")

    con:query("insert into check_sql values(-2822,'delete from transaction_total_check where cny = -2822 and jpy = -282200 and gbp = -1975.4 and eur = -313242 and  hkd = -2539.8','')")

    con:query("insert into check_sql values(-2821,'delete from transaction_total_check where cny = -2821 and jpy = -282100 and gbp = -1974.7 and eur = -313131 and  hkd = -2538.9','')")

    con:query("insert into check_sql values(-2820,'delete from transaction_total_check where cny = -2820 and jpy = -282000 and gbp = -1974.0 and eur = -313020 and  hkd = -2538.0','')")

    con:query("insert into check_sql values(-2819,'delete from transaction_total_check where cny = -2819 and jpy = -281900 and gbp = -1973.3 and eur = -312909 and  hkd = -2537.1','')")

    con:query("insert into check_sql values(-2818,'delete from transaction_total_check where cny = -2818 and jpy = -281800 and gbp = -1972.6 and eur = -312798 and  hkd = -2536.2','')")

    con:query("insert into check_sql values(-2817,'delete from transaction_total_check where cny = -2817 and jpy = -281700 and gbp = -1971.9 and eur = -312687 and  hkd = -2535.3','')")

    con:query("insert into check_sql values(-2816,'delete from transaction_total_check where cny = -2816 and jpy = -281600 and gbp = -1971.2 and eur = -312576 and  hkd = -2534.4','')")

    con:query("insert into check_sql values(-2815,'delete from transaction_total_check where cny = -2815 and jpy = -281500 and gbp = -1970.5 and eur = -312465 and  hkd = -2533.5','')")

    con:query("insert into check_sql values(-2814,'delete from transaction_total_check where cny = -2814 and jpy = -281400 and gbp = -1969.8 and eur = -312354 and  hkd = -2532.6','')")

    con:query("insert into check_sql values(-2813,'delete from transaction_total_check where cny = -2813 and jpy = -281300 and gbp = -1969.1 and eur = -312243 and  hkd = -2531.7','')")

    con:query("insert into check_sql values(-2812,'delete from transaction_total_check where cny = -2812 and jpy = -281200 and gbp = -1968.4 and eur = -312132 and  hkd = -2530.8','')")

    con:query("insert into check_sql values(-2811,'delete from transaction_total_check where cny = -2811 and jpy = -281100 and gbp = -1967.7 and eur = -312021 and  hkd = -2529.9','')")

    con:query("insert into check_sql values(-2810,'delete from transaction_total_check where cny = -2810 and jpy = -281000 and gbp = -1967.0 and eur = -311910 and  hkd = -2529.0','')")

    con:query("insert into check_sql values(-2809,'delete from transaction_total_check where cny = -2809 and jpy = -280900 and gbp = -1966.3 and eur = -311799 and  hkd = -2528.1','')")

    con:query("insert into check_sql values(-2808,'delete from transaction_total_check where cny = -2808 and jpy = -280800 and gbp = -1965.6 and eur = -311688 and  hkd = -2527.2','')")

    con:query("insert into check_sql values(-2807,'delete from transaction_total_check where cny = -2807 and jpy = -280700 and gbp = -1964.9 and eur = -311577 and  hkd = -2526.3','')")

    con:query("insert into check_sql values(-2806,'delete from transaction_total_check where cny = -2806 and jpy = -280600 and gbp = -1964.2 and eur = -311466 and  hkd = -2525.4','')")

    con:query("insert into check_sql values(-2805,'delete from transaction_total_check where cny = -2805 and jpy = -280500 and gbp = -1963.5 and eur = -311355 and  hkd = -2524.5','')")

    con:query("insert into check_sql values(-2804,'delete from transaction_total_check where cny = -2804 and jpy = -280400 and gbp = -1962.8 and eur = -311244 and  hkd = -2523.6','')")

    con:query("insert into check_sql values(-2803,'delete from transaction_total_check where cny = -2803 and jpy = -280300 and gbp = -1962.1 and eur = -311133 and  hkd = -2522.7','')")

    con:query("insert into check_sql values(-2802,'delete from transaction_total_check where cny = -2802 and jpy = -280200 and gbp = -1961.4 and eur = -311022 and  hkd = -2521.8','')")

    con:query("insert into check_sql values(-2801,'delete from transaction_total_check where cny = -2801 and jpy = -280100 and gbp = -1960.7 and eur = -310911 and  hkd = -2520.9','')")

    con:query("insert into check_sql values(-2800,'delete from transaction_total_check where cny = -2800 and jpy = -280000 and gbp = -1960.0 and eur = -310800 and  hkd = -2520.0','')")

    con:query("insert into check_sql values(-2799,'delete from transaction_total_check where cny = -2799 and jpy = -279900 and gbp = -1959.3 and eur = -310689 and  hkd = -2519.1','')")

    con:query("insert into check_sql values(-2798,'delete from transaction_total_check where cny = -2798 and jpy = -279800 and gbp = -1958.6 and eur = -310578 and  hkd = -2518.2','')")

    con:query("insert into check_sql values(-2797,'delete from transaction_total_check where cny = -2797 and jpy = -279700 and gbp = -1957.9 and eur = -310467 and  hkd = -2517.3','')")

    con:query("insert into check_sql values(-2796,'delete from transaction_total_check where cny = -2796 and jpy = -279600 and gbp = -1957.2 and eur = -310356 and  hkd = -2516.4','')")

    con:query("insert into check_sql values(-2795,'delete from transaction_total_check where cny = -2795 and jpy = -279500 and gbp = -1956.5 and eur = -310245 and  hkd = -2515.5','')")

    con:query("insert into check_sql values(-2794,'delete from transaction_total_check where cny = -2794 and jpy = -279400 and gbp = -1955.8 and eur = -310134 and  hkd = -2514.6','')")

    con:query("insert into check_sql values(-2793,'delete from transaction_total_check where cny = -2793 and jpy = -279300 and gbp = -1955.1 and eur = -310023 and  hkd = -2513.7','')")

    con:query("insert into check_sql values(-2792,'delete from transaction_total_check where cny = -2792 and jpy = -279200 and gbp = -1954.4 and eur = -309912 and  hkd = -2512.8','')")

    con:query("insert into check_sql values(-2791,'delete from transaction_total_check where cny = -2791 and jpy = -279100 and gbp = -1953.7 and eur = -309801 and  hkd = -2511.9','')")

    con:query("insert into check_sql values(-2790,'delete from transaction_total_check where cny = -2790 and jpy = -279000 and gbp = -1953.0 and eur = -309690 and  hkd = -2511.0','')")

    con:query("insert into check_sql values(-2789,'delete from transaction_total_check where cny = -2789 and jpy = -278900 and gbp = -1952.3 and eur = -309579 and  hkd = -2510.1','')")

    con:query("insert into check_sql values(-2788,'delete from transaction_total_check where cny = -2788 and jpy = -278800 and gbp = -1951.6 and eur = -309468 and  hkd = -2509.2','')")

    con:query("insert into check_sql values(-2787,'delete from transaction_total_check where cny = -2787 and jpy = -278700 and gbp = -1950.9 and eur = -309357 and  hkd = -2508.3','')")

    con:query("insert into check_sql values(-2786,'delete from transaction_total_check where cny = -2786 and jpy = -278600 and gbp = -1950.2 and eur = -309246 and  hkd = -2507.4','')")

    con:query("insert into check_sql values(-2785,'delete from transaction_total_check where cny = -2785 and jpy = -278500 and gbp = -1949.5 and eur = -309135 and  hkd = -2506.5','')")

    con:query("insert into check_sql values(-2784,'delete from transaction_total_check where cny = -2784 and jpy = -278400 and gbp = -1948.8 and eur = -309024 and  hkd = -2505.6','')")

    con:query("insert into check_sql values(-2783,'delete from transaction_total_check where cny = -2783 and jpy = -278300 and gbp = -1948.1 and eur = -308913 and  hkd = -2504.7','')")

    con:query("insert into check_sql values(-2782,'delete from transaction_total_check where cny = -2782 and jpy = -278200 and gbp = -1947.4 and eur = -308802 and  hkd = -2503.8','')")

    con:query("insert into check_sql values(-2781,'delete from transaction_total_check where cny = -2781 and jpy = -278100 and gbp = -1946.7 and eur = -308691 and  hkd = -2502.9','')")

    con:query("insert into check_sql values(-2780,'delete from transaction_total_check where cny = -2780 and jpy = -278000 and gbp = -1946.0 and eur = -308580 and  hkd = -2502.0','')")

    con:query("insert into check_sql values(-2779,'delete from transaction_total_check where cny = -2779 and jpy = -277900 and gbp = -1945.3 and eur = -308469 and  hkd = -2501.1','')")

    con:query("insert into check_sql values(-2778,'delete from transaction_total_check where cny = -2778 and jpy = -277800 and gbp = -1944.6 and eur = -308358 and  hkd = -2500.2','')")

    con:query("insert into check_sql values(-2777,'delete from transaction_total_check where cny = -2777 and jpy = -277700 and gbp = -1943.9 and eur = -308247 and  hkd = -2499.3','')")

    con:query("insert into check_sql values(-2776,'delete from transaction_total_check where cny = -2776 and jpy = -277600 and gbp = -1943.2 and eur = -308136 and  hkd = -2498.4','')")

    con:query("insert into check_sql values(-2775,'delete from transaction_total_check where cny = -2775 and jpy = -277500 and gbp = -1942.5 and eur = -308025 and  hkd = -2497.5','')")

    con:query("insert into check_sql values(-2774,'delete from transaction_total_check where cny = -2774 and jpy = -277400 and gbp = -1941.8 and eur = -307914 and  hkd = -2496.6','')")

    con:query("insert into check_sql values(-2773,'delete from transaction_total_check where cny = -2773 and jpy = -277300 and gbp = -1941.1 and eur = -307803 and  hkd = -2495.7','')")

    con:query("insert into check_sql values(-2772,'delete from transaction_total_check where cny = -2772 and jpy = -277200 and gbp = -1940.4 and eur = -307692 and  hkd = -2494.8','')")

    con:query("insert into check_sql values(-2771,'delete from transaction_total_check where cny = -2771 and jpy = -277100 and gbp = -1939.7 and eur = -307581 and  hkd = -2493.9','')")

    con:query("insert into check_sql values(-2770,'delete from transaction_total_check where cny = -2770 and jpy = -277000 and gbp = -1939.0 and eur = -307470 and  hkd = -2493.0','')")

    con:query("insert into check_sql values(-2769,'delete from transaction_total_check where cny = -2769 and jpy = -276900 and gbp = -1938.3 and eur = -307359 and  hkd = -2492.1','')")

    con:query("insert into check_sql values(-2768,'delete from transaction_total_check where cny = -2768 and jpy = -276800 and gbp = -1937.6 and eur = -307248 and  hkd = -2491.2','')")

    con:query("insert into check_sql values(-2767,'delete from transaction_total_check where cny = -2767 and jpy = -276700 and gbp = -1936.9 and eur = -307137 and  hkd = -2490.3','')")

    con:query("insert into check_sql values(-2766,'delete from transaction_total_check where cny = -2766 and jpy = -276600 and gbp = -1936.2 and eur = -307026 and  hkd = -2489.4','')")

    con:query("insert into check_sql values(-2765,'delete from transaction_total_check where cny = -2765 and jpy = -276500 and gbp = -1935.5 and eur = -306915 and  hkd = -2488.5','')")

    con:query("insert into check_sql values(-2764,'delete from transaction_total_check where cny = -2764 and jpy = -276400 and gbp = -1934.8 and eur = -306804 and  hkd = -2487.6','')")

    con:query("insert into check_sql values(-2763,'delete from transaction_total_check where cny = -2763 and jpy = -276300 and gbp = -1934.1 and eur = -306693 and  hkd = -2486.7','')")

    con:query("insert into check_sql values(-2762,'delete from transaction_total_check where cny = -2762 and jpy = -276200 and gbp = -1933.4 and eur = -306582 and  hkd = -2485.8','')")

    con:query("insert into check_sql values(-2761,'delete from transaction_total_check where cny = -2761 and jpy = -276100 and gbp = -1932.7 and eur = -306471 and  hkd = -2484.9','')")

    con:query("insert into check_sql values(-2760,'delete from transaction_total_check where cny = -2760 and jpy = -276000 and gbp = -1932.0 and eur = -306360 and  hkd = -2484.0','')")

    con:query("insert into check_sql values(-2759,'delete from transaction_total_check where cny = -2759 and jpy = -275900 and gbp = -1931.3 and eur = -306249 and  hkd = -2483.1','')")

    con:query("insert into check_sql values(-2758,'delete from transaction_total_check where cny = -2758 and jpy = -275800 and gbp = -1930.6 and eur = -306138 and  hkd = -2482.2','')")

    con:query("insert into check_sql values(-2757,'delete from transaction_total_check where cny = -2757 and jpy = -275700 and gbp = -1929.9 and eur = -306027 and  hkd = -2481.3','')")

    con:query("insert into check_sql values(-2756,'delete from transaction_total_check where cny = -2756 and jpy = -275600 and gbp = -1929.2 and eur = -305916 and  hkd = -2480.4','')")

    con:query("insert into check_sql values(-2755,'delete from transaction_total_check where cny = -2755 and jpy = -275500 and gbp = -1928.5 and eur = -305805 and  hkd = -2479.5','')")

    con:query("insert into check_sql values(-2754,'delete from transaction_total_check where cny = -2754 and jpy = -275400 and gbp = -1927.8 and eur = -305694 and  hkd = -2478.6','')")

    con:query("insert into check_sql values(-2753,'delete from transaction_total_check where cny = -2753 and jpy = -275300 and gbp = -1927.1 and eur = -305583 and  hkd = -2477.7','')")

    con:query("insert into check_sql values(-2752,'delete from transaction_total_check where cny = -2752 and jpy = -275200 and gbp = -1926.4 and eur = -305472 and  hkd = -2476.8','')")

    con:query("insert into check_sql values(-2751,'delete from transaction_total_check where cny = -2751 and jpy = -275100 and gbp = -1925.7 and eur = -305361 and  hkd = -2475.9','')")

    con:query("insert into check_sql values(-2750,'delete from transaction_total_check where cny = -2750 and jpy = -275000 and gbp = -1925.0 and eur = -305250 and  hkd = -2475.0','')")

    con:query("insert into check_sql values(-2749,'delete from transaction_total_check where cny = -2749 and jpy = -274900 and gbp = -1924.3 and eur = -305139 and  hkd = -2474.1','')")

    con:query("insert into check_sql values(-2748,'delete from transaction_total_check where cny = -2748 and jpy = -274800 and gbp = -1923.6 and eur = -305028 and  hkd = -2473.2','')")

    con:query("insert into check_sql values(-2747,'delete from transaction_total_check where cny = -2747 and jpy = -274700 and gbp = -1922.9 and eur = -304917 and  hkd = -2472.3','')")

    con:query("insert into check_sql values(-2746,'delete from transaction_total_check where cny = -2746 and jpy = -274600 and gbp = -1922.2 and eur = -304806 and  hkd = -2471.4','')")

    con:query("insert into check_sql values(-2745,'delete from transaction_total_check where cny = -2745 and jpy = -274500 and gbp = -1921.5 and eur = -304695 and  hkd = -2470.5','')")

    con:query("insert into check_sql values(-2744,'delete from transaction_total_check where cny = -2744 and jpy = -274400 and gbp = -1920.8 and eur = -304584 and  hkd = -2469.6','')")

    con:query("insert into check_sql values(-2743,'delete from transaction_total_check where cny = -2743 and jpy = -274300 and gbp = -1920.1 and eur = -304473 and  hkd = -2468.7','')")

    con:query("insert into check_sql values(-2742,'delete from transaction_total_check where cny = -2742 and jpy = -274200 and gbp = -1919.4 and eur = -304362 and  hkd = -2467.8','')")

    con:query("insert into check_sql values(-2741,'delete from transaction_total_check where cny = -2741 and jpy = -274100 and gbp = -1918.7 and eur = -304251 and  hkd = -2466.9','')")

    con:query("insert into check_sql values(-2740,'delete from transaction_total_check where cny = -2740 and jpy = -274000 and gbp = -1918.0 and eur = -304140 and  hkd = -2466.0','')")

    con:query("insert into check_sql values(-2739,'delete from transaction_total_check where cny = -2739 and jpy = -273900 and gbp = -1917.3 and eur = -304029 and  hkd = -2465.1','')")

    con:query("insert into check_sql values(-2738,'delete from transaction_total_check where cny = -2738 and jpy = -273800 and gbp = -1916.6 and eur = -303918 and  hkd = -2464.2','')")

    con:query("insert into check_sql values(-2737,'delete from transaction_total_check where cny = -2737 and jpy = -273700 and gbp = -1915.9 and eur = -303807 and  hkd = -2463.3','')")

    con:query("insert into check_sql values(-2736,'delete from transaction_total_check where cny = -2736 and jpy = -273600 and gbp = -1915.2 and eur = -303696 and  hkd = -2462.4','')")

    con:query("insert into check_sql values(-2735,'delete from transaction_total_check where cny = -2735 and jpy = -273500 and gbp = -1914.5 and eur = -303585 and  hkd = -2461.5','')")

    con:query("insert into check_sql values(-2734,'delete from transaction_total_check where cny = -2734 and jpy = -273400 and gbp = -1913.8 and eur = -303474 and  hkd = -2460.6','')")

    con:query("insert into check_sql values(-2733,'delete from transaction_total_check where cny = -2733 and jpy = -273300 and gbp = -1913.1 and eur = -303363 and  hkd = -2459.7','')")

    con:query("insert into check_sql values(-2732,'delete from transaction_total_check where cny = -2732 and jpy = -273200 and gbp = -1912.4 and eur = -303252 and  hkd = -2458.8','')")

    con:query("insert into check_sql values(-2731,'delete from transaction_total_check where cny = -2731 and jpy = -273100 and gbp = -1911.7 and eur = -303141 and  hkd = -2457.9','')")

    con:query("insert into check_sql values(-2730,'delete from transaction_total_check where cny = -2730 and jpy = -273000 and gbp = -1911.0 and eur = -303030 and  hkd = -2457.0','')")

    con:query("insert into check_sql values(-2729,'delete from transaction_total_check where cny = -2729 and jpy = -272900 and gbp = -1910.3 and eur = -302919 and  hkd = -2456.1','')")

    con:query("insert into check_sql values(-2728,'delete from transaction_total_check where cny = -2728 and jpy = -272800 and gbp = -1909.6 and eur = -302808 and  hkd = -2455.2','')")

    con:query("insert into check_sql values(-2727,'delete from transaction_total_check where cny = -2727 and jpy = -272700 and gbp = -1908.9 and eur = -302697 and  hkd = -2454.3','')")

    con:query("insert into check_sql values(-2726,'delete from transaction_total_check where cny = -2726 and jpy = -272600 and gbp = -1908.2 and eur = -302586 and  hkd = -2453.4','')")

    con:query("insert into check_sql values(-2725,'delete from transaction_total_check where cny = -2725 and jpy = -272500 and gbp = -1907.5 and eur = -302475 and  hkd = -2452.5','')")

    con:query("insert into check_sql values(-2724,'delete from transaction_total_check where cny = -2724 and jpy = -272400 and gbp = -1906.8 and eur = -302364 and  hkd = -2451.6','')")

    con:query("insert into check_sql values(-2723,'delete from transaction_total_check where cny = -2723 and jpy = -272300 and gbp = -1906.1 and eur = -302253 and  hkd = -2450.7','')")

    con:query("insert into check_sql values(-2722,'delete from transaction_total_check where cny = -2722 and jpy = -272200 and gbp = -1905.4 and eur = -302142 and  hkd = -2449.8','')")

    con:query("insert into check_sql values(-2721,'delete from transaction_total_check where cny = -2721 and jpy = -272100 and gbp = -1904.7 and eur = -302031 and  hkd = -2448.9','')")

    con:query("insert into check_sql values(-2720,'delete from transaction_total_check where cny = -2720 and jpy = -272000 and gbp = -1904.0 and eur = -301920 and  hkd = -2448.0','')")

    con:query("insert into check_sql values(-2719,'delete from transaction_total_check where cny = -2719 and jpy = -271900 and gbp = -1903.3 and eur = -301809 and  hkd = -2447.1','')")

    con:query("insert into check_sql values(-2718,'delete from transaction_total_check where cny = -2718 and jpy = -271800 and gbp = -1902.6 and eur = -301698 and  hkd = -2446.2','')")

    con:query("insert into check_sql values(-2717,'delete from transaction_total_check where cny = -2717 and jpy = -271700 and gbp = -1901.9 and eur = -301587 and  hkd = -2445.3','')")

    con:query("insert into check_sql values(-2716,'delete from transaction_total_check where cny = -2716 and jpy = -271600 and gbp = -1901.2 and eur = -301476 and  hkd = -2444.4','')")

    con:query("insert into check_sql values(-2715,'delete from transaction_total_check where cny = -2715 and jpy = -271500 and gbp = -1900.5 and eur = -301365 and  hkd = -2443.5','')")

    con:query("insert into check_sql values(-2714,'delete from transaction_total_check where cny = -2714 and jpy = -271400 and gbp = -1899.8 and eur = -301254 and  hkd = -2442.6','')")

    con:query("insert into check_sql values(-2713,'delete from transaction_total_check where cny = -2713 and jpy = -271300 and gbp = -1899.1 and eur = -301143 and  hkd = -2441.7','')")

    con:query("insert into check_sql values(-2712,'delete from transaction_total_check where cny = -2712 and jpy = -271200 and gbp = -1898.4 and eur = -301032 and  hkd = -2440.8','')")

    con:query("insert into check_sql values(-2711,'delete from transaction_total_check where cny = -2711 and jpy = -271100 and gbp = -1897.7 and eur = -300921 and  hkd = -2439.9','')")

    con:query("insert into check_sql values(-2710,'delete from transaction_total_check where cny = -2710 and jpy = -271000 and gbp = -1897.0 and eur = -300810 and  hkd = -2439.0','')")

    con:query("insert into check_sql values(-2709,'delete from transaction_total_check where cny = -2709 and jpy = -270900 and gbp = -1896.3 and eur = -300699 and  hkd = -2438.1','')")

    con:query("insert into check_sql values(-2708,'delete from transaction_total_check where cny = -2708 and jpy = -270800 and gbp = -1895.6 and eur = -300588 and  hkd = -2437.2','')")

    con:query("insert into check_sql values(-2707,'delete from transaction_total_check where cny = -2707 and jpy = -270700 and gbp = -1894.9 and eur = -300477 and  hkd = -2436.3','')")

    con:query("insert into check_sql values(-2706,'delete from transaction_total_check where cny = -2706 and jpy = -270600 and gbp = -1894.2 and eur = -300366 and  hkd = -2435.4','')")

    con:query("insert into check_sql values(-2705,'delete from transaction_total_check where cny = -2705 and jpy = -270500 and gbp = -1893.5 and eur = -300255 and  hkd = -2434.5','')")

    con:query("insert into check_sql values(-2704,'delete from transaction_total_check where cny = -2704 and jpy = -270400 and gbp = -1892.8 and eur = -300144 and  hkd = -2433.6','')")

    con:query("insert into check_sql values(-2703,'delete from transaction_total_check where cny = -2703 and jpy = -270300 and gbp = -1892.1 and eur = -300033 and  hkd = -2432.7','')")

    con:query("insert into check_sql values(-2702,'delete from transaction_total_check where cny = -2702 and jpy = -270200 and gbp = -1891.4 and eur = -299922 and  hkd = -2431.8','')")

    con:query("insert into check_sql values(-2701,'delete from transaction_total_check where cny = -2701 and jpy = -270100 and gbp = -1890.7 and eur = -299811 and  hkd = -2430.9','')")

    con:query("insert into check_sql values(-2700,'delete from transaction_total_check where cny = -2700 and jpy = -270000 and gbp = -1890.0 and eur = -299700 and  hkd = -2430.0','')")

    con:query("insert into check_sql values(-2699,'delete from transaction_total_check where cny = -2699 and jpy = -269900 and gbp = -1889.3 and eur = -299589 and  hkd = -2429.1','')")

    con:query("insert into check_sql values(-2698,'delete from transaction_total_check where cny = -2698 and jpy = -269800 and gbp = -1888.6 and eur = -299478 and  hkd = -2428.2','')")

    con:query("insert into check_sql values(-2697,'delete from transaction_total_check where cny = -2697 and jpy = -269700 and gbp = -1887.9 and eur = -299367 and  hkd = -2427.3','')")

    con:query("insert into check_sql values(-2696,'delete from transaction_total_check where cny = -2696 and jpy = -269600 and gbp = -1887.2 and eur = -299256 and  hkd = -2426.4','')")

    con:query("insert into check_sql values(-2695,'delete from transaction_total_check where cny = -2695 and jpy = -269500 and gbp = -1886.5 and eur = -299145 and  hkd = -2425.5','')")

    con:query("insert into check_sql values(-2694,'delete from transaction_total_check where cny = -2694 and jpy = -269400 and gbp = -1885.8 and eur = -299034 and  hkd = -2424.6','')")

    con:query("insert into check_sql values(-2693,'delete from transaction_total_check where cny = -2693 and jpy = -269300 and gbp = -1885.1 and eur = -298923 and  hkd = -2423.7','')")

    con:query("insert into check_sql values(-2692,'delete from transaction_total_check where cny = -2692 and jpy = -269200 and gbp = -1884.4 and eur = -298812 and  hkd = -2422.8','')")

    con:query("insert into check_sql values(-2691,'delete from transaction_total_check where cny = -2691 and jpy = -269100 and gbp = -1883.7 and eur = -298701 and  hkd = -2421.9','')")

    con:query("insert into check_sql values(-2690,'delete from transaction_total_check where cny = -2690 and jpy = -269000 and gbp = -1883.0 and eur = -298590 and  hkd = -2421.0','')")

    con:query("insert into check_sql values(-2689,'delete from transaction_total_check where cny = -2689 and jpy = -268900 and gbp = -1882.3 and eur = -298479 and  hkd = -2420.1','')")

    con:query("insert into check_sql values(-2688,'delete from transaction_total_check where cny = -2688 and jpy = -268800 and gbp = -1881.6 and eur = -298368 and  hkd = -2419.2','')")

    con:query("insert into check_sql values(-2687,'delete from transaction_total_check where cny = -2687 and jpy = -268700 and gbp = -1880.9 and eur = -298257 and  hkd = -2418.3','')")

    con:query("insert into check_sql values(-2686,'delete from transaction_total_check where cny = -2686 and jpy = -268600 and gbp = -1880.2 and eur = -298146 and  hkd = -2417.4','')")

    con:query("insert into check_sql values(-2685,'delete from transaction_total_check where cny = -2685 and jpy = -268500 and gbp = -1879.5 and eur = -298035 and  hkd = -2416.5','')")

    con:query("insert into check_sql values(-2684,'delete from transaction_total_check where cny = -2684 and jpy = -268400 and gbp = -1878.8 and eur = -297924 and  hkd = -2415.6','')")

    con:query("insert into check_sql values(-2683,'delete from transaction_total_check where cny = -2683 and jpy = -268300 and gbp = -1878.1 and eur = -297813 and  hkd = -2414.7','')")

    con:query("insert into check_sql values(-2682,'delete from transaction_total_check where cny = -2682 and jpy = -268200 and gbp = -1877.4 and eur = -297702 and  hkd = -2413.8','')")

    con:query("insert into check_sql values(-2681,'delete from transaction_total_check where cny = -2681 and jpy = -268100 and gbp = -1876.7 and eur = -297591 and  hkd = -2412.9','')")

    con:query("insert into check_sql values(-2680,'delete from transaction_total_check where cny = -2680 and jpy = -268000 and gbp = -1876.0 and eur = -297480 and  hkd = -2412.0','')")

    con:query("insert into check_sql values(-2679,'delete from transaction_total_check where cny = -2679 and jpy = -267900 and gbp = -1875.3 and eur = -297369 and  hkd = -2411.1','')")

    con:query("insert into check_sql values(-2678,'delete from transaction_total_check where cny = -2678 and jpy = -267800 and gbp = -1874.6 and eur = -297258 and  hkd = -2410.2','')")

    con:query("insert into check_sql values(-2677,'delete from transaction_total_check where cny = -2677 and jpy = -267700 and gbp = -1873.9 and eur = -297147 and  hkd = -2409.3','')")

    con:query("insert into check_sql values(-2676,'delete from transaction_total_check where cny = -2676 and jpy = -267600 and gbp = -1873.2 and eur = -297036 and  hkd = -2408.4','')")

    con:query("insert into check_sql values(-2675,'delete from transaction_total_check where cny = -2675 and jpy = -267500 and gbp = -1872.5 and eur = -296925 and  hkd = -2407.5','')")

    con:query("insert into check_sql values(-2674,'delete from transaction_total_check where cny = -2674 and jpy = -267400 and gbp = -1871.8 and eur = -296814 and  hkd = -2406.6','')")

    con:query("insert into check_sql values(-2673,'delete from transaction_total_check where cny = -2673 and jpy = -267300 and gbp = -1871.1 and eur = -296703 and  hkd = -2405.7','')")

    con:query("insert into check_sql values(-2672,'delete from transaction_total_check where cny = -2672 and jpy = -267200 and gbp = -1870.4 and eur = -296592 and  hkd = -2404.8','')")

    con:query("insert into check_sql values(-2671,'delete from transaction_total_check where cny = -2671 and jpy = -267100 and gbp = -1869.7 and eur = -296481 and  hkd = -2403.9','')")

    con:query("insert into check_sql values(-2670,'delete from transaction_total_check where cny = -2670 and jpy = -267000 and gbp = -1869.0 and eur = -296370 and  hkd = -2403.0','')")

    con:query("insert into check_sql values(-2669,'delete from transaction_total_check where cny = -2669 and jpy = -266900 and gbp = -1868.3 and eur = -296259 and  hkd = -2402.1','')")

    con:query("insert into check_sql values(-2668,'delete from transaction_total_check where cny = -2668 and jpy = -266800 and gbp = -1867.6 and eur = -296148 and  hkd = -2401.2','')")

    con:query("insert into check_sql values(-2667,'delete from transaction_total_check where cny = -2667 and jpy = -266700 and gbp = -1866.9 and eur = -296037 and  hkd = -2400.3','')")

    con:query("insert into check_sql values(-2666,'delete from transaction_total_check where cny = -2666 and jpy = -266600 and gbp = -1866.2 and eur = -295926 and  hkd = -2399.4','')")

    con:query("insert into check_sql values(-2665,'delete from transaction_total_check where cny = -2665 and jpy = -266500 and gbp = -1865.5 and eur = -295815 and  hkd = -2398.5','')")

    con:query("insert into check_sql values(-2664,'delete from transaction_total_check where cny = -2664 and jpy = -266400 and gbp = -1864.8 and eur = -295704 and  hkd = -2397.6','')")

    con:query("insert into check_sql values(-2663,'delete from transaction_total_check where cny = -2663 and jpy = -266300 and gbp = -1864.1 and eur = -295593 and  hkd = -2396.7','')")

    con:query("insert into check_sql values(-2662,'delete from transaction_total_check where cny = -2662 and jpy = -266200 and gbp = -1863.4 and eur = -295482 and  hkd = -2395.8','')")

    con:query("insert into check_sql values(-2661,'delete from transaction_total_check where cny = -2661 and jpy = -266100 and gbp = -1862.7 and eur = -295371 and  hkd = -2394.9','')")

    con:query("insert into check_sql values(-2660,'delete from transaction_total_check where cny = -2660 and jpy = -266000 and gbp = -1862.0 and eur = -295260 and  hkd = -2394.0','')")

    con:query("insert into check_sql values(-2659,'delete from transaction_total_check where cny = -2659 and jpy = -265900 and gbp = -1861.3 and eur = -295149 and  hkd = -2393.1','')")

    con:query("insert into check_sql values(-2658,'delete from transaction_total_check where cny = -2658 and jpy = -265800 and gbp = -1860.6 and eur = -295038 and  hkd = -2392.2','')")

    con:query("insert into check_sql values(-2657,'delete from transaction_total_check where cny = -2657 and jpy = -265700 and gbp = -1859.9 and eur = -294927 and  hkd = -2391.3','')")

    con:query("insert into check_sql values(-2656,'delete from transaction_total_check where cny = -2656 and jpy = -265600 and gbp = -1859.2 and eur = -294816 and  hkd = -2390.4','')")

    con:query("insert into check_sql values(-2655,'delete from transaction_total_check where cny = -2655 and jpy = -265500 and gbp = -1858.5 and eur = -294705 and  hkd = -2389.5','')")

    con:query("insert into check_sql values(-2654,'delete from transaction_total_check where cny = -2654 and jpy = -265400 and gbp = -1857.8 and eur = -294594 and  hkd = -2388.6','')")

    con:query("insert into check_sql values(-2653,'delete from transaction_total_check where cny = -2653 and jpy = -265300 and gbp = -1857.1 and eur = -294483 and  hkd = -2387.7','')")

    con:query("insert into check_sql values(-2652,'delete from transaction_total_check where cny = -2652 and jpy = -265200 and gbp = -1856.4 and eur = -294372 and  hkd = -2386.8','')")

    con:query("insert into check_sql values(-2651,'delete from transaction_total_check where cny = -2651 and jpy = -265100 and gbp = -1855.7 and eur = -294261 and  hkd = -2385.9','')")

    con:query("insert into check_sql values(-2650,'delete from transaction_total_check where cny = -2650 and jpy = -265000 and gbp = -1855.0 and eur = -294150 and  hkd = -2385.0','')")

    con:query("insert into check_sql values(-2649,'delete from transaction_total_check where cny = -2649 and jpy = -264900 and gbp = -1854.3 and eur = -294039 and  hkd = -2384.1','')")

    con:query("insert into check_sql values(-2648,'delete from transaction_total_check where cny = -2648 and jpy = -264800 and gbp = -1853.6 and eur = -293928 and  hkd = -2383.2','')")

    con:query("insert into check_sql values(-2647,'delete from transaction_total_check where cny = -2647 and jpy = -264700 and gbp = -1852.9 and eur = -293817 and  hkd = -2382.3','')")

    con:query("insert into check_sql values(-2646,'delete from transaction_total_check where cny = -2646 and jpy = -264600 and gbp = -1852.2 and eur = -293706 and  hkd = -2381.4','')")

    con:query("insert into check_sql values(-2645,'delete from transaction_total_check where cny = -2645 and jpy = -264500 and gbp = -1851.5 and eur = -293595 and  hkd = -2380.5','')")

    con:query("insert into check_sql values(-2644,'delete from transaction_total_check where cny = -2644 and jpy = -264400 and gbp = -1850.8 and eur = -293484 and  hkd = -2379.6','')")

    con:query("insert into check_sql values(-2643,'delete from transaction_total_check where cny = -2643 and jpy = -264300 and gbp = -1850.1 and eur = -293373 and  hkd = -2378.7','')")

    con:query("insert into check_sql values(-2642,'delete from transaction_total_check where cny = -2642 and jpy = -264200 and gbp = -1849.4 and eur = -293262 and  hkd = -2377.8','')")

    con:query("insert into check_sql values(-2641,'delete from transaction_total_check where cny = -2641 and jpy = -264100 and gbp = -1848.7 and eur = -293151 and  hkd = -2376.9','')")

    con:query("insert into check_sql values(-2640,'delete from transaction_total_check where cny = -2640 and jpy = -264000 and gbp = -1848.0 and eur = -293040 and  hkd = -2376.0','')")

    con:query("insert into check_sql values(-2639,'delete from transaction_total_check where cny = -2639 and jpy = -263900 and gbp = -1847.3 and eur = -292929 and  hkd = -2375.1','')")

    con:query("insert into check_sql values(-2638,'delete from transaction_total_check where cny = -2638 and jpy = -263800 and gbp = -1846.6 and eur = -292818 and  hkd = -2374.2','')")

    con:query("insert into check_sql values(-2637,'delete from transaction_total_check where cny = -2637 and jpy = -263700 and gbp = -1845.9 and eur = -292707 and  hkd = -2373.3','')")

    con:query("insert into check_sql values(-2636,'delete from transaction_total_check where cny = -2636 and jpy = -263600 and gbp = -1845.2 and eur = -292596 and  hkd = -2372.4','')")

    con:query("insert into check_sql values(-2635,'delete from transaction_total_check where cny = -2635 and jpy = -263500 and gbp = -1844.5 and eur = -292485 and  hkd = -2371.5','')")

    con:query("insert into check_sql values(-2634,'delete from transaction_total_check where cny = -2634 and jpy = -263400 and gbp = -1843.8 and eur = -292374 and  hkd = -2370.6','')")

    con:query("insert into check_sql values(-2633,'delete from transaction_total_check where cny = -2633 and jpy = -263300 and gbp = -1843.1 and eur = -292263 and  hkd = -2369.7','')")

    con:query("insert into check_sql values(-2632,'delete from transaction_total_check where cny = -2632 and jpy = -263200 and gbp = -1842.4 and eur = -292152 and  hkd = -2368.8','')")

    con:query("insert into check_sql values(-2631,'delete from transaction_total_check where cny = -2631 and jpy = -263100 and gbp = -1841.7 and eur = -292041 and  hkd = -2367.9','')")

    con:query("insert into check_sql values(-2630,'delete from transaction_total_check where cny = -2630 and jpy = -263000 and gbp = -1841.0 and eur = -291930 and  hkd = -2367.0','')")

    con:query("insert into check_sql values(-2629,'delete from transaction_total_check where cny = -2629 and jpy = -262900 and gbp = -1840.3 and eur = -291819 and  hkd = -2366.1','')")

    con:query("insert into check_sql values(-2628,'delete from transaction_total_check where cny = -2628 and jpy = -262800 and gbp = -1839.6 and eur = -291708 and  hkd = -2365.2','')")

    con:query("insert into check_sql values(-2627,'delete from transaction_total_check where cny = -2627 and jpy = -262700 and gbp = -1838.9 and eur = -291597 and  hkd = -2364.3','')")

    con:query("insert into check_sql values(-2626,'delete from transaction_total_check where cny = -2626 and jpy = -262600 and gbp = -1838.2 and eur = -291486 and  hkd = -2363.4','')")

    con:query("insert into check_sql values(-2625,'delete from transaction_total_check where cny = -2625 and jpy = -262500 and gbp = -1837.5 and eur = -291375 and  hkd = -2362.5','')")

    con:query("insert into check_sql values(-2624,'delete from transaction_total_check where cny = -2624 and jpy = -262400 and gbp = -1836.8 and eur = -291264 and  hkd = -2361.6','')")

    con:query("insert into check_sql values(-2623,'delete from transaction_total_check where cny = -2623 and jpy = -262300 and gbp = -1836.1 and eur = -291153 and  hkd = -2360.7','')")

    con:query("insert into check_sql values(-2622,'delete from transaction_total_check where cny = -2622 and jpy = -262200 and gbp = -1835.4 and eur = -291042 and  hkd = -2359.8','')")

    con:query("insert into check_sql values(-2621,'delete from transaction_total_check where cny = -2621 and jpy = -262100 and gbp = -1834.7 and eur = -290931 and  hkd = -2358.9','')")

    con:query("insert into check_sql values(-2620,'delete from transaction_total_check where cny = -2620 and jpy = -262000 and gbp = -1834.0 and eur = -290820 and  hkd = -2358.0','')")

    con:query("insert into check_sql values(-2619,'delete from transaction_total_check where cny = -2619 and jpy = -261900 and gbp = -1833.3 and eur = -290709 and  hkd = -2357.1','')")

    con:query("insert into check_sql values(-2618,'delete from transaction_total_check where cny = -2618 and jpy = -261800 and gbp = -1832.6 and eur = -290598 and  hkd = -2356.2','')")

    con:query("insert into check_sql values(-2617,'delete from transaction_total_check where cny = -2617 and jpy = -261700 and gbp = -1831.9 and eur = -290487 and  hkd = -2355.3','')")

    con:query("insert into check_sql values(-2616,'delete from transaction_total_check where cny = -2616 and jpy = -261600 and gbp = -1831.2 and eur = -290376 and  hkd = -2354.4','')")

    con:query("insert into check_sql values(-2615,'delete from transaction_total_check where cny = -2615 and jpy = -261500 and gbp = -1830.5 and eur = -290265 and  hkd = -2353.5','')")

    con:query("insert into check_sql values(-2614,'delete from transaction_total_check where cny = -2614 and jpy = -261400 and gbp = -1829.8 and eur = -290154 and  hkd = -2352.6','')")

    con:query("insert into check_sql values(-2613,'delete from transaction_total_check where cny = -2613 and jpy = -261300 and gbp = -1829.1 and eur = -290043 and  hkd = -2351.7','')")

    con:query("insert into check_sql values(-2612,'delete from transaction_total_check where cny = -2612 and jpy = -261200 and gbp = -1828.4 and eur = -289932 and  hkd = -2350.8','')")

    con:query("insert into check_sql values(-2611,'delete from transaction_total_check where cny = -2611 and jpy = -261100 and gbp = -1827.7 and eur = -289821 and  hkd = -2349.9','')")

    con:query("insert into check_sql values(-2610,'delete from transaction_total_check where cny = -2610 and jpy = -261000 and gbp = -1827.0 and eur = -289710 and  hkd = -2349.0','')")

    con:query("insert into check_sql values(-2609,'delete from transaction_total_check where cny = -2609 and jpy = -260900 and gbp = -1826.3 and eur = -289599 and  hkd = -2348.1','')")

    con:query("insert into check_sql values(-2608,'delete from transaction_total_check where cny = -2608 and jpy = -260800 and gbp = -1825.6 and eur = -289488 and  hkd = -2347.2','')")

    con:query("insert into check_sql values(-2607,'delete from transaction_total_check where cny = -2607 and jpy = -260700 and gbp = -1824.9 and eur = -289377 and  hkd = -2346.3','')")

    con:query("insert into check_sql values(-2606,'delete from transaction_total_check where cny = -2606 and jpy = -260600 and gbp = -1824.2 and eur = -289266 and  hkd = -2345.4','')")

    con:query("insert into check_sql values(-2605,'delete from transaction_total_check where cny = -2605 and jpy = -260500 and gbp = -1823.5 and eur = -289155 and  hkd = -2344.5','')")

    con:query("insert into check_sql values(-2604,'delete from transaction_total_check where cny = -2604 and jpy = -260400 and gbp = -1822.8 and eur = -289044 and  hkd = -2343.6','')")

    con:query("insert into check_sql values(-2603,'delete from transaction_total_check where cny = -2603 and jpy = -260300 and gbp = -1822.1 and eur = -288933 and  hkd = -2342.7','')")

    con:query("insert into check_sql values(-2602,'delete from transaction_total_check where cny = -2602 and jpy = -260200 and gbp = -1821.4 and eur = -288822 and  hkd = -2341.8','')")

    con:query("insert into check_sql values(-2601,'delete from transaction_total_check where cny = -2601 and jpy = -260100 and gbp = -1820.7 and eur = -288711 and  hkd = -2340.9','')")

    con:query("insert into check_sql values(-2600,'delete from transaction_total_check where cny = -2600 and jpy = -260000 and gbp = -1820.0 and eur = -288600 and  hkd = -2340.0','')")

    con:query("insert into check_sql values(-2599,'delete from transaction_total_check where cny = -2599 and jpy = -259900 and gbp = -1819.3 and eur = -288489 and  hkd = -2339.1','')")

    con:query("insert into check_sql values(-2598,'delete from transaction_total_check where cny = -2598 and jpy = -259800 and gbp = -1818.6 and eur = -288378 and  hkd = -2338.2','')")

    con:query("insert into check_sql values(-2597,'delete from transaction_total_check where cny = -2597 and jpy = -259700 and gbp = -1817.9 and eur = -288267 and  hkd = -2337.3','')")

    con:query("insert into check_sql values(-2596,'delete from transaction_total_check where cny = -2596 and jpy = -259600 and gbp = -1817.2 and eur = -288156 and  hkd = -2336.4','')")

    con:query("insert into check_sql values(-2595,'delete from transaction_total_check where cny = -2595 and jpy = -259500 and gbp = -1816.5 and eur = -288045 and  hkd = -2335.5','')")

    con:query("insert into check_sql values(-2594,'delete from transaction_total_check where cny = -2594 and jpy = -259400 and gbp = -1815.8 and eur = -287934 and  hkd = -2334.6','')")

    con:query("insert into check_sql values(-2593,'delete from transaction_total_check where cny = -2593 and jpy = -259300 and gbp = -1815.1 and eur = -287823 and  hkd = -2333.7','')")

    con:query("insert into check_sql values(-2592,'delete from transaction_total_check where cny = -2592 and jpy = -259200 and gbp = -1814.4 and eur = -287712 and  hkd = -2332.8','')")

    con:query("insert into check_sql values(-2591,'delete from transaction_total_check where cny = -2591 and jpy = -259100 and gbp = -1813.7 and eur = -287601 and  hkd = -2331.9','')")

    con:query("insert into check_sql values(-2590,'delete from transaction_total_check where cny = -2590 and jpy = -259000 and gbp = -1813.0 and eur = -287490 and  hkd = -2331.0','')")

    con:query("insert into check_sql values(-2589,'delete from transaction_total_check where cny = -2589 and jpy = -258900 and gbp = -1812.3 and eur = -287379 and  hkd = -2330.1','')")

    con:query("insert into check_sql values(-2588,'delete from transaction_total_check where cny = -2588 and jpy = -258800 and gbp = -1811.6 and eur = -287268 and  hkd = -2329.2','')")

    con:query("insert into check_sql values(-2587,'delete from transaction_total_check where cny = -2587 and jpy = -258700 and gbp = -1810.9 and eur = -287157 and  hkd = -2328.3','')")

    con:query("insert into check_sql values(-2586,'delete from transaction_total_check where cny = -2586 and jpy = -258600 and gbp = -1810.2 and eur = -287046 and  hkd = -2327.4','')")

    con:query("insert into check_sql values(-2585,'delete from transaction_total_check where cny = -2585 and jpy = -258500 and gbp = -1809.5 and eur = -286935 and  hkd = -2326.5','')")

    con:query("insert into check_sql values(-2584,'delete from transaction_total_check where cny = -2584 and jpy = -258400 and gbp = -1808.8 and eur = -286824 and  hkd = -2325.6','')")

    con:query("insert into check_sql values(-2583,'delete from transaction_total_check where cny = -2583 and jpy = -258300 and gbp = -1808.1 and eur = -286713 and  hkd = -2324.7','')")

    con:query("insert into check_sql values(-2582,'delete from transaction_total_check where cny = -2582 and jpy = -258200 and gbp = -1807.4 and eur = -286602 and  hkd = -2323.8','')")

    con:query("insert into check_sql values(-2581,'delete from transaction_total_check where cny = -2581 and jpy = -258100 and gbp = -1806.7 and eur = -286491 and  hkd = -2322.9','')")

    con:query("insert into check_sql values(-2580,'delete from transaction_total_check where cny = -2580 and jpy = -258000 and gbp = -1806.0 and eur = -286380 and  hkd = -2322.0','')")

    con:query("insert into check_sql values(-2579,'delete from transaction_total_check where cny = -2579 and jpy = -257900 and gbp = -1805.3 and eur = -286269 and  hkd = -2321.1','')")

    con:query("insert into check_sql values(-2578,'delete from transaction_total_check where cny = -2578 and jpy = -257800 and gbp = -1804.6 and eur = -286158 and  hkd = -2320.2','')")

    con:query("insert into check_sql values(-2577,'delete from transaction_total_check where cny = -2577 and jpy = -257700 and gbp = -1803.9 and eur = -286047 and  hkd = -2319.3','')")

    con:query("insert into check_sql values(-2576,'delete from transaction_total_check where cny = -2576 and jpy = -257600 and gbp = -1803.2 and eur = -285936 and  hkd = -2318.4','')")

    con:query("insert into check_sql values(-2575,'delete from transaction_total_check where cny = -2575 and jpy = -257500 and gbp = -1802.5 and eur = -285825 and  hkd = -2317.5','')")

    con:query("insert into check_sql values(-2574,'delete from transaction_total_check where cny = -2574 and jpy = -257400 and gbp = -1801.8 and eur = -285714 and  hkd = -2316.6','')")

    con:query("insert into check_sql values(-2573,'delete from transaction_total_check where cny = -2573 and jpy = -257300 and gbp = -1801.1 and eur = -285603 and  hkd = -2315.7','')")

    con:query("insert into check_sql values(-2572,'delete from transaction_total_check where cny = -2572 and jpy = -257200 and gbp = -1800.4 and eur = -285492 and  hkd = -2314.8','')")

    con:query("insert into check_sql values(-2571,'delete from transaction_total_check where cny = -2571 and jpy = -257100 and gbp = -1799.7 and eur = -285381 and  hkd = -2313.9','')")

    con:query("insert into check_sql values(-2570,'delete from transaction_total_check where cny = -2570 and jpy = -257000 and gbp = -1799.0 and eur = -285270 and  hkd = -2313.0','')")

    con:query("insert into check_sql values(-2569,'delete from transaction_total_check where cny = -2569 and jpy = -256900 and gbp = -1798.3 and eur = -285159 and  hkd = -2312.1','')")

    con:query("insert into check_sql values(-2568,'delete from transaction_total_check where cny = -2568 and jpy = -256800 and gbp = -1797.6 and eur = -285048 and  hkd = -2311.2','')")

    con:query("insert into check_sql values(-2567,'delete from transaction_total_check where cny = -2567 and jpy = -256700 and gbp = -1796.9 and eur = -284937 and  hkd = -2310.3','')")

    con:query("insert into check_sql values(-2566,'delete from transaction_total_check where cny = -2566 and jpy = -256600 and gbp = -1796.2 and eur = -284826 and  hkd = -2309.4','')")

    con:query("insert into check_sql values(-2565,'delete from transaction_total_check where cny = -2565 and jpy = -256500 and gbp = -1795.5 and eur = -284715 and  hkd = -2308.5','')")

    con:query("insert into check_sql values(-2564,'delete from transaction_total_check where cny = -2564 and jpy = -256400 and gbp = -1794.8 and eur = -284604 and  hkd = -2307.6','')")

    con:query("insert into check_sql values(-2563,'delete from transaction_total_check where cny = -2563 and jpy = -256300 and gbp = -1794.1 and eur = -284493 and  hkd = -2306.7','')")

    con:query("insert into check_sql values(-2562,'delete from transaction_total_check where cny = -2562 and jpy = -256200 and gbp = -1793.4 and eur = -284382 and  hkd = -2305.8','')")

    con:query("insert into check_sql values(-2561,'delete from transaction_total_check where cny = -2561 and jpy = -256100 and gbp = -1792.7 and eur = -284271 and  hkd = -2304.9','')")

    con:query("insert into check_sql values(-2560,'delete from transaction_total_check where cny = -2560 and jpy = -256000 and gbp = -1792.0 and eur = -284160 and  hkd = -2304.0','')")

    con:query("insert into check_sql values(-2559,'delete from transaction_total_check where cny = -2559 and jpy = -255900 and gbp = -1791.3 and eur = -284049 and  hkd = -2303.1','')")

    con:query("insert into check_sql values(-2558,'delete from transaction_total_check where cny = -2558 and jpy = -255800 and gbp = -1790.6 and eur = -283938 and  hkd = -2302.2','')")

    con:query("insert into check_sql values(-2557,'delete from transaction_total_check where cny = -2557 and jpy = -255700 and gbp = -1789.9 and eur = -283827 and  hkd = -2301.3','')")

    con:query("insert into check_sql values(-2556,'delete from transaction_total_check where cny = -2556 and jpy = -255600 and gbp = -1789.2 and eur = -283716 and  hkd = -2300.4','')")

    con:query("insert into check_sql values(-2555,'delete from transaction_total_check where cny = -2555 and jpy = -255500 and gbp = -1788.5 and eur = -283605 and  hkd = -2299.5','')")

    con:query("insert into check_sql values(-2554,'delete from transaction_total_check where cny = -2554 and jpy = -255400 and gbp = -1787.8 and eur = -283494 and  hkd = -2298.6','')")

    con:query("insert into check_sql values(-2553,'delete from transaction_total_check where cny = -2553 and jpy = -255300 and gbp = -1787.1 and eur = -283383 and  hkd = -2297.7','')")

    con:query("insert into check_sql values(-2552,'delete from transaction_total_check where cny = -2552 and jpy = -255200 and gbp = -1786.4 and eur = -283272 and  hkd = -2296.8','')")

    con:query("insert into check_sql values(-2551,'delete from transaction_total_check where cny = -2551 and jpy = -255100 and gbp = -1785.7 and eur = -283161 and  hkd = -2295.9','')")

    con:query("insert into check_sql values(-2550,'delete from transaction_total_check where cny = -2550 and jpy = -255000 and gbp = -1785.0 and eur = -283050 and  hkd = -2295.0','')")

    con:query("insert into check_sql values(-2549,'delete from transaction_total_check where cny = -2549 and jpy = -254900 and gbp = -1784.3 and eur = -282939 and  hkd = -2294.1','')")

    con:query("insert into check_sql values(-2548,'delete from transaction_total_check where cny = -2548 and jpy = -254800 and gbp = -1783.6 and eur = -282828 and  hkd = -2293.2','')")

    con:query("insert into check_sql values(-2547,'delete from transaction_total_check where cny = -2547 and jpy = -254700 and gbp = -1782.9 and eur = -282717 and  hkd = -2292.3','')")

    con:query("insert into check_sql values(-2546,'delete from transaction_total_check where cny = -2546 and jpy = -254600 and gbp = -1782.2 and eur = -282606 and  hkd = -2291.4','')")

    con:query("insert into check_sql values(-2545,'delete from transaction_total_check where cny = -2545 and jpy = -254500 and gbp = -1781.5 and eur = -282495 and  hkd = -2290.5','')")

    con:query("insert into check_sql values(-2544,'delete from transaction_total_check where cny = -2544 and jpy = -254400 and gbp = -1780.8 and eur = -282384 and  hkd = -2289.6','')")

    con:query("insert into check_sql values(-2543,'delete from transaction_total_check where cny = -2543 and jpy = -254300 and gbp = -1780.1 and eur = -282273 and  hkd = -2288.7','')")

    con:query("insert into check_sql values(-2542,'delete from transaction_total_check where cny = -2542 and jpy = -254200 and gbp = -1779.4 and eur = -282162 and  hkd = -2287.8','')")

    con:query("insert into check_sql values(-2541,'delete from transaction_total_check where cny = -2541 and jpy = -254100 and gbp = -1778.7 and eur = -282051 and  hkd = -2286.9','')")

    con:query("insert into check_sql values(-2540,'delete from transaction_total_check where cny = -2540 and jpy = -254000 and gbp = -1778.0 and eur = -281940 and  hkd = -2286.0','')")

    con:query("insert into check_sql values(-2539,'delete from transaction_total_check where cny = -2539 and jpy = -253900 and gbp = -1777.3 and eur = -281829 and  hkd = -2285.1','')")

    con:query("insert into check_sql values(-2538,'delete from transaction_total_check where cny = -2538 and jpy = -253800 and gbp = -1776.6 and eur = -281718 and  hkd = -2284.2','')")

    con:query("insert into check_sql values(-2537,'delete from transaction_total_check where cny = -2537 and jpy = -253700 and gbp = -1775.9 and eur = -281607 and  hkd = -2283.3','')")

    con:query("insert into check_sql values(-2536,'delete from transaction_total_check where cny = -2536 and jpy = -253600 and gbp = -1775.2 and eur = -281496 and  hkd = -2282.4','')")

    con:query("insert into check_sql values(-2535,'delete from transaction_total_check where cny = -2535 and jpy = -253500 and gbp = -1774.5 and eur = -281385 and  hkd = -2281.5','')")

    con:query("insert into check_sql values(-2534,'delete from transaction_total_check where cny = -2534 and jpy = -253400 and gbp = -1773.8 and eur = -281274 and  hkd = -2280.6','')")

    con:query("insert into check_sql values(-2533,'delete from transaction_total_check where cny = -2533 and jpy = -253300 and gbp = -1773.1 and eur = -281163 and  hkd = -2279.7','')")

    con:query("insert into check_sql values(-2532,'delete from transaction_total_check where cny = -2532 and jpy = -253200 and gbp = -1772.4 and eur = -281052 and  hkd = -2278.8','')")

    con:query("insert into check_sql values(-2531,'delete from transaction_total_check where cny = -2531 and jpy = -253100 and gbp = -1771.7 and eur = -280941 and  hkd = -2277.9','')")

    con:query("insert into check_sql values(-2530,'delete from transaction_total_check where cny = -2530 and jpy = -253000 and gbp = -1771.0 and eur = -280830 and  hkd = -2277.0','')")

    con:query("insert into check_sql values(-2529,'delete from transaction_total_check where cny = -2529 and jpy = -252900 and gbp = -1770.3 and eur = -280719 and  hkd = -2276.1','')")

    con:query("insert into check_sql values(-2528,'delete from transaction_total_check where cny = -2528 and jpy = -252800 and gbp = -1769.6 and eur = -280608 and  hkd = -2275.2','')")

    con:query("insert into check_sql values(-2527,'delete from transaction_total_check where cny = -2527 and jpy = -252700 and gbp = -1768.9 and eur = -280497 and  hkd = -2274.3','')")

    con:query("insert into check_sql values(-2526,'delete from transaction_total_check where cny = -2526 and jpy = -252600 and gbp = -1768.2 and eur = -280386 and  hkd = -2273.4','')")

    con:query("insert into check_sql values(-2525,'delete from transaction_total_check where cny = -2525 and jpy = -252500 and gbp = -1767.5 and eur = -280275 and  hkd = -2272.5','')")

    con:query("insert into check_sql values(-2524,'delete from transaction_total_check where cny = -2524 and jpy = -252400 and gbp = -1766.8 and eur = -280164 and  hkd = -2271.6','')")

    con:query("insert into check_sql values(-2523,'delete from transaction_total_check where cny = -2523 and jpy = -252300 and gbp = -1766.1 and eur = -280053 and  hkd = -2270.7','')")

    con:query("insert into check_sql values(-2522,'delete from transaction_total_check where cny = -2522 and jpy = -252200 and gbp = -1765.4 and eur = -279942 and  hkd = -2269.8','')")

    con:query("insert into check_sql values(-2521,'delete from transaction_total_check where cny = -2521 and jpy = -252100 and gbp = -1764.7 and eur = -279831 and  hkd = -2268.9','')")

    con:query("insert into check_sql values(-2520,'delete from transaction_total_check where cny = -2520 and jpy = -252000 and gbp = -1764.0 and eur = -279720 and  hkd = -2268.0','')")

    con:query("insert into check_sql values(-2519,'delete from transaction_total_check where cny = -2519 and jpy = -251900 and gbp = -1763.3 and eur = -279609 and  hkd = -2267.1','')")

    con:query("insert into check_sql values(-2518,'delete from transaction_total_check where cny = -2518 and jpy = -251800 and gbp = -1762.6 and eur = -279498 and  hkd = -2266.2','')")

    con:query("insert into check_sql values(-2517,'delete from transaction_total_check where cny = -2517 and jpy = -251700 and gbp = -1761.9 and eur = -279387 and  hkd = -2265.3','')")

    con:query("insert into check_sql values(-2516,'delete from transaction_total_check where cny = -2516 and jpy = -251600 and gbp = -1761.2 and eur = -279276 and  hkd = -2264.4','')")

    con:query("insert into check_sql values(-2515,'delete from transaction_total_check where cny = -2515 and jpy = -251500 and gbp = -1760.5 and eur = -279165 and  hkd = -2263.5','')")

    con:query("insert into check_sql values(-2514,'delete from transaction_total_check where cny = -2514 and jpy = -251400 and gbp = -1759.8 and eur = -279054 and  hkd = -2262.6','')")

    con:query("insert into check_sql values(-2513,'delete from transaction_total_check where cny = -2513 and jpy = -251300 and gbp = -1759.1 and eur = -278943 and  hkd = -2261.7','')")

    con:query("insert into check_sql values(-2512,'delete from transaction_total_check where cny = -2512 and jpy = -251200 and gbp = -1758.4 and eur = -278832 and  hkd = -2260.8','')")

    con:query("insert into check_sql values(-2511,'delete from transaction_total_check where cny = -2511 and jpy = -251100 and gbp = -1757.7 and eur = -278721 and  hkd = -2259.9','')")

    con:query("insert into check_sql values(-2510,'delete from transaction_total_check where cny = -2510 and jpy = -251000 and gbp = -1757.0 and eur = -278610 and  hkd = -2259.0','')")

    con:query("insert into check_sql values(-2509,'delete from transaction_total_check where cny = -2509 and jpy = -250900 and gbp = -1756.3 and eur = -278499 and  hkd = -2258.1','')")

    con:query("insert into check_sql values(-2508,'delete from transaction_total_check where cny = -2508 and jpy = -250800 and gbp = -1755.6 and eur = -278388 and  hkd = -2257.2','')")

    con:query("insert into check_sql values(-2507,'delete from transaction_total_check where cny = -2507 and jpy = -250700 and gbp = -1754.9 and eur = -278277 and  hkd = -2256.3','')")

    con:query("insert into check_sql values(-2506,'delete from transaction_total_check where cny = -2506 and jpy = -250600 and gbp = -1754.2 and eur = -278166 and  hkd = -2255.4','')")

    con:query("insert into check_sql values(-2505,'delete from transaction_total_check where cny = -2505 and jpy = -250500 and gbp = -1753.5 and eur = -278055 and  hkd = -2254.5','')")

    con:query("insert into check_sql values(-2504,'delete from transaction_total_check where cny = -2504 and jpy = -250400 and gbp = -1752.8 and eur = -277944 and  hkd = -2253.6','')")

    con:query("insert into check_sql values(-2503,'delete from transaction_total_check where cny = -2503 and jpy = -250300 and gbp = -1752.1 and eur = -277833 and  hkd = -2252.7','')")

    con:query("insert into check_sql values(-2502,'delete from transaction_total_check where cny = -2502 and jpy = -250200 and gbp = -1751.4 and eur = -277722 and  hkd = -2251.8','')")

    con:query("insert into check_sql values(-2501,'delete from transaction_total_check where cny = -2501 and jpy = -250100 and gbp = -1750.7 and eur = -277611 and  hkd = -2250.9','')")

    con:query("insert into check_sql values(-2500,'delete from transaction_total_check where cny = -2500 and jpy = -250000 and gbp = -1750.0 and eur = -277500 and  hkd = -2250.0','')")

    con:query("insert into check_sql values(-2499,'delete from transaction_total_check where cny = -2499 and jpy = -249900 and gbp = -1749.3 and eur = -277389 and  hkd = -2249.1','')")

    con:query("insert into check_sql values(-2498,'delete from transaction_total_check where cny = -2498 and jpy = -249800 and gbp = -1748.6 and eur = -277278 and  hkd = -2248.2','')")

    con:query("insert into check_sql values(-2497,'delete from transaction_total_check where cny = -2497 and jpy = -249700 and gbp = -1747.9 and eur = -277167 and  hkd = -2247.3','')")

    con:query("insert into check_sql values(-2496,'delete from transaction_total_check where cny = -2496 and jpy = -249600 and gbp = -1747.2 and eur = -277056 and  hkd = -2246.4','')")

    con:query("insert into check_sql values(-2495,'delete from transaction_total_check where cny = -2495 and jpy = -249500 and gbp = -1746.5 and eur = -276945 and  hkd = -2245.5','')")

    con:query("insert into check_sql values(-2494,'delete from transaction_total_check where cny = -2494 and jpy = -249400 and gbp = -1745.8 and eur = -276834 and  hkd = -2244.6','')")

    con:query("insert into check_sql values(-2493,'delete from transaction_total_check where cny = -2493 and jpy = -249300 and gbp = -1745.1 and eur = -276723 and  hkd = -2243.7','')")

    con:query("insert into check_sql values(-2492,'delete from transaction_total_check where cny = -2492 and jpy = -249200 and gbp = -1744.4 and eur = -276612 and  hkd = -2242.8','')")

    con:query("insert into check_sql values(-2491,'delete from transaction_total_check where cny = -2491 and jpy = -249100 and gbp = -1743.7 and eur = -276501 and  hkd = -2241.9','')")

    con:query("insert into check_sql values(-2490,'delete from transaction_total_check where cny = -2490 and jpy = -249000 and gbp = -1743.0 and eur = -276390 and  hkd = -2241.0','')")

    con:query("insert into check_sql values(-2489,'delete from transaction_total_check where cny = -2489 and jpy = -248900 and gbp = -1742.3 and eur = -276279 and  hkd = -2240.1','')")

    con:query("insert into check_sql values(-2488,'delete from transaction_total_check where cny = -2488 and jpy = -248800 and gbp = -1741.6 and eur = -276168 and  hkd = -2239.2','')")

    con:query("insert into check_sql values(-2487,'delete from transaction_total_check where cny = -2487 and jpy = -248700 and gbp = -1740.9 and eur = -276057 and  hkd = -2238.3','')")

    con:query("insert into check_sql values(-2486,'delete from transaction_total_check where cny = -2486 and jpy = -248600 and gbp = -1740.2 and eur = -275946 and  hkd = -2237.4','')")

    con:query("insert into check_sql values(-2485,'delete from transaction_total_check where cny = -2485 and jpy = -248500 and gbp = -1739.5 and eur = -275835 and  hkd = -2236.5','')")

    con:query("insert into check_sql values(-2484,'delete from transaction_total_check where cny = -2484 and jpy = -248400 and gbp = -1738.8 and eur = -275724 and  hkd = -2235.6','')")

    con:query("insert into check_sql values(-2483,'delete from transaction_total_check where cny = -2483 and jpy = -248300 and gbp = -1738.1 and eur = -275613 and  hkd = -2234.7','')")

    con:query("insert into check_sql values(-2482,'delete from transaction_total_check where cny = -2482 and jpy = -248200 and gbp = -1737.4 and eur = -275502 and  hkd = -2233.8','')")

    con:query("insert into check_sql values(-2481,'delete from transaction_total_check where cny = -2481 and jpy = -248100 and gbp = -1736.7 and eur = -275391 and  hkd = -2232.9','')")

    con:query("insert into check_sql values(-2480,'delete from transaction_total_check where cny = -2480 and jpy = -248000 and gbp = -1736.0 and eur = -275280 and  hkd = -2232.0','')")

    con:query("insert into check_sql values(-2479,'delete from transaction_total_check where cny = -2479 and jpy = -247900 and gbp = -1735.3 and eur = -275169 and  hkd = -2231.1','')")

    con:query("insert into check_sql values(-2478,'delete from transaction_total_check where cny = -2478 and jpy = -247800 and gbp = -1734.6 and eur = -275058 and  hkd = -2230.2','')")

    con:query("insert into check_sql values(-2477,'delete from transaction_total_check where cny = -2477 and jpy = -247700 and gbp = -1733.9 and eur = -274947 and  hkd = -2229.3','')")

    con:query("insert into check_sql values(-2476,'delete from transaction_total_check where cny = -2476 and jpy = -247600 and gbp = -1733.2 and eur = -274836 and  hkd = -2228.4','')")

    con:query("insert into check_sql values(-2475,'delete from transaction_total_check where cny = -2475 and jpy = -247500 and gbp = -1732.5 and eur = -274725 and  hkd = -2227.5','')")

    con:query("insert into check_sql values(-2474,'delete from transaction_total_check where cny = -2474 and jpy = -247400 and gbp = -1731.8 and eur = -274614 and  hkd = -2226.6','')")

    con:query("insert into check_sql values(-2473,'delete from transaction_total_check where cny = -2473 and jpy = -247300 and gbp = -1731.1 and eur = -274503 and  hkd = -2225.7','')")

    con:query("insert into check_sql values(-2472,'delete from transaction_total_check where cny = -2472 and jpy = -247200 and gbp = -1730.4 and eur = -274392 and  hkd = -2224.8','')")

    con:query("insert into check_sql values(-2471,'delete from transaction_total_check where cny = -2471 and jpy = -247100 and gbp = -1729.7 and eur = -274281 and  hkd = -2223.9','')")

    con:query("insert into check_sql values(-2470,'delete from transaction_total_check where cny = -2470 and jpy = -247000 and gbp = -1729.0 and eur = -274170 and  hkd = -2223.0','')")

    con:query("insert into check_sql values(-2469,'delete from transaction_total_check where cny = -2469 and jpy = -246900 and gbp = -1728.3 and eur = -274059 and  hkd = -2222.1','')")

    con:query("insert into check_sql values(-2468,'delete from transaction_total_check where cny = -2468 and jpy = -246800 and gbp = -1727.6 and eur = -273948 and  hkd = -2221.2','')")

    con:query("insert into check_sql values(-2467,'delete from transaction_total_check where cny = -2467 and jpy = -246700 and gbp = -1726.9 and eur = -273837 and  hkd = -2220.3','')")

    con:query("insert into check_sql values(-2466,'delete from transaction_total_check where cny = -2466 and jpy = -246600 and gbp = -1726.2 and eur = -273726 and  hkd = -2219.4','')")

    con:query("insert into check_sql values(-2465,'delete from transaction_total_check where cny = -2465 and jpy = -246500 and gbp = -1725.5 and eur = -273615 and  hkd = -2218.5','')")

    con:query("insert into check_sql values(-2464,'delete from transaction_total_check where cny = -2464 and jpy = -246400 and gbp = -1724.8 and eur = -273504 and  hkd = -2217.6','')")

    con:query("insert into check_sql values(-2463,'delete from transaction_total_check where cny = -2463 and jpy = -246300 and gbp = -1724.1 and eur = -273393 and  hkd = -2216.7','')")

    con:query("insert into check_sql values(-2462,'delete from transaction_total_check where cny = -2462 and jpy = -246200 and gbp = -1723.4 and eur = -273282 and  hkd = -2215.8','')")

    con:query("insert into check_sql values(-2461,'delete from transaction_total_check where cny = -2461 and jpy = -246100 and gbp = -1722.7 and eur = -273171 and  hkd = -2214.9','')")

    con:query("insert into check_sql values(-2460,'delete from transaction_total_check where cny = -2460 and jpy = -246000 and gbp = -1722.0 and eur = -273060 and  hkd = -2214.0','')")

    con:query("insert into check_sql values(-2459,'delete from transaction_total_check where cny = -2459 and jpy = -245900 and gbp = -1721.3 and eur = -272949 and  hkd = -2213.1','')")

    con:query("insert into check_sql values(-2458,'delete from transaction_total_check where cny = -2458 and jpy = -245800 and gbp = -1720.6 and eur = -272838 and  hkd = -2212.2','')")

    con:query("insert into check_sql values(-2457,'delete from transaction_total_check where cny = -2457 and jpy = -245700 and gbp = -1719.9 and eur = -272727 and  hkd = -2211.3','')")

    con:query("insert into check_sql values(-2456,'delete from transaction_total_check where cny = -2456 and jpy = -245600 and gbp = -1719.2 and eur = -272616 and  hkd = -2210.4','')")

    con:query("insert into check_sql values(-2455,'delete from transaction_total_check where cny = -2455 and jpy = -245500 and gbp = -1718.5 and eur = -272505 and  hkd = -2209.5','')")

    con:query("insert into check_sql values(-2454,'delete from transaction_total_check where cny = -2454 and jpy = -245400 and gbp = -1717.8 and eur = -272394 and  hkd = -2208.6','')")

    con:query("insert into check_sql values(-2453,'delete from transaction_total_check where cny = -2453 and jpy = -245300 and gbp = -1717.1 and eur = -272283 and  hkd = -2207.7','')")

    con:query("insert into check_sql values(-2452,'delete from transaction_total_check where cny = -2452 and jpy = -245200 and gbp = -1716.4 and eur = -272172 and  hkd = -2206.8','')")

    con:query("insert into check_sql values(-2451,'delete from transaction_total_check where cny = -2451 and jpy = -245100 and gbp = -1715.7 and eur = -272061 and  hkd = -2205.9','')")

    con:query("insert into check_sql values(-2450,'delete from transaction_total_check where cny = -2450 and jpy = -245000 and gbp = -1715.0 and eur = -271950 and  hkd = -2205.0','')")

    con:query("insert into check_sql values(-2449,'delete from transaction_total_check where cny = -2449 and jpy = -244900 and gbp = -1714.3 and eur = -271839 and  hkd = -2204.1','')")

    con:query("insert into check_sql values(-2448,'delete from transaction_total_check where cny = -2448 and jpy = -244800 and gbp = -1713.6 and eur = -271728 and  hkd = -2203.2','')")

    con:query("insert into check_sql values(-2447,'delete from transaction_total_check where cny = -2447 and jpy = -244700 and gbp = -1712.9 and eur = -271617 and  hkd = -2202.3','')")

    con:query("insert into check_sql values(-2446,'delete from transaction_total_check where cny = -2446 and jpy = -244600 and gbp = -1712.2 and eur = -271506 and  hkd = -2201.4','')")

    con:query("insert into check_sql values(-2445,'delete from transaction_total_check where cny = -2445 and jpy = -244500 and gbp = -1711.5 and eur = -271395 and  hkd = -2200.5','')")

    con:query("insert into check_sql values(-2444,'delete from transaction_total_check where cny = -2444 and jpy = -244400 and gbp = -1710.8 and eur = -271284 and  hkd = -2199.6','')")

    con:query("insert into check_sql values(-2443,'delete from transaction_total_check where cny = -2443 and jpy = -244300 and gbp = -1710.1 and eur = -271173 and  hkd = -2198.7','')")

    con:query("insert into check_sql values(-2442,'delete from transaction_total_check where cny = -2442 and jpy = -244200 and gbp = -1709.4 and eur = -271062 and  hkd = -2197.8','')")

    con:query("insert into check_sql values(-2441,'delete from transaction_total_check where cny = -2441 and jpy = -244100 and gbp = -1708.7 and eur = -270951 and  hkd = -2196.9','')")

    con:query("insert into check_sql values(-2440,'delete from transaction_total_check where cny = -2440 and jpy = -244000 and gbp = -1708.0 and eur = -270840 and  hkd = -2196.0','')")

    con:query("insert into check_sql values(-2439,'delete from transaction_total_check where cny = -2439 and jpy = -243900 and gbp = -1707.3 and eur = -270729 and  hkd = -2195.1','')")

    con:query("insert into check_sql values(-2438,'delete from transaction_total_check where cny = -2438 and jpy = -243800 and gbp = -1706.6 and eur = -270618 and  hkd = -2194.2','')")

    con:query("insert into check_sql values(-2437,'delete from transaction_total_check where cny = -2437 and jpy = -243700 and gbp = -1705.9 and eur = -270507 and  hkd = -2193.3','')")

    con:query("insert into check_sql values(-2436,'delete from transaction_total_check where cny = -2436 and jpy = -243600 and gbp = -1705.2 and eur = -270396 and  hkd = -2192.4','')")

    con:query("insert into check_sql values(-2435,'delete from transaction_total_check where cny = -2435 and jpy = -243500 and gbp = -1704.5 and eur = -270285 and  hkd = -2191.5','')")

    con:query("insert into check_sql values(-2434,'delete from transaction_total_check where cny = -2434 and jpy = -243400 and gbp = -1703.8 and eur = -270174 and  hkd = -2190.6','')")

    con:query("insert into check_sql values(-2433,'delete from transaction_total_check where cny = -2433 and jpy = -243300 and gbp = -1703.1 and eur = -270063 and  hkd = -2189.7','')")

    con:query("insert into check_sql values(-2432,'delete from transaction_total_check where cny = -2432 and jpy = -243200 and gbp = -1702.4 and eur = -269952 and  hkd = -2188.8','')")

    con:query("insert into check_sql values(-2431,'delete from transaction_total_check where cny = -2431 and jpy = -243100 and gbp = -1701.7 and eur = -269841 and  hkd = -2187.9','')")

    con:query("insert into check_sql values(-2430,'delete from transaction_total_check where cny = -2430 and jpy = -243000 and gbp = -1701.0 and eur = -269730 and  hkd = -2187.0','')")

    con:query("insert into check_sql values(-2429,'delete from transaction_total_check where cny = -2429 and jpy = -242900 and gbp = -1700.3 and eur = -269619 and  hkd = -2186.1','')")

    con:query("insert into check_sql values(-2428,'delete from transaction_total_check where cny = -2428 and jpy = -242800 and gbp = -1699.6 and eur = -269508 and  hkd = -2185.2','')")

    con:query("insert into check_sql values(-2427,'delete from transaction_total_check where cny = -2427 and jpy = -242700 and gbp = -1698.9 and eur = -269397 and  hkd = -2184.3','')")

    con:query("insert into check_sql values(-2426,'delete from transaction_total_check where cny = -2426 and jpy = -242600 and gbp = -1698.2 and eur = -269286 and  hkd = -2183.4','')")

    con:query("insert into check_sql values(-2425,'delete from transaction_total_check where cny = -2425 and jpy = -242500 and gbp = -1697.5 and eur = -269175 and  hkd = -2182.5','')")

    con:query("insert into check_sql values(-2424,'delete from transaction_total_check where cny = -2424 and jpy = -242400 and gbp = -1696.8 and eur = -269064 and  hkd = -2181.6','')")

    con:query("insert into check_sql values(-2423,'delete from transaction_total_check where cny = -2423 and jpy = -242300 and gbp = -1696.1 and eur = -268953 and  hkd = -2180.7','')")

    con:query("insert into check_sql values(-2422,'delete from transaction_total_check where cny = -2422 and jpy = -242200 and gbp = -1695.4 and eur = -268842 and  hkd = -2179.8','')")

    con:query("insert into check_sql values(-2421,'delete from transaction_total_check where cny = -2421 and jpy = -242100 and gbp = -1694.7 and eur = -268731 and  hkd = -2178.9','')")

    con:query("insert into check_sql values(-2420,'delete from transaction_total_check where cny = -2420 and jpy = -242000 and gbp = -1694.0 and eur = -268620 and  hkd = -2178.0','')")

    con:query("insert into check_sql values(-2419,'delete from transaction_total_check where cny = -2419 and jpy = -241900 and gbp = -1693.3 and eur = -268509 and  hkd = -2177.1','')")

    con:query("insert into check_sql values(-2418,'delete from transaction_total_check where cny = -2418 and jpy = -241800 and gbp = -1692.6 and eur = -268398 and  hkd = -2176.2','')")

    con:query("insert into check_sql values(-2417,'delete from transaction_total_check where cny = -2417 and jpy = -241700 and gbp = -1691.9 and eur = -268287 and  hkd = -2175.3','')")

    con:query("insert into check_sql values(-2416,'delete from transaction_total_check where cny = -2416 and jpy = -241600 and gbp = -1691.2 and eur = -268176 and  hkd = -2174.4','')")

    con:query("insert into check_sql values(-2415,'delete from transaction_total_check where cny = -2415 and jpy = -241500 and gbp = -1690.5 and eur = -268065 and  hkd = -2173.5','')")

    con:query("insert into check_sql values(-2414,'delete from transaction_total_check where cny = -2414 and jpy = -241400 and gbp = -1689.8 and eur = -267954 and  hkd = -2172.6','')")

    con:query("insert into check_sql values(-2413,'delete from transaction_total_check where cny = -2413 and jpy = -241300 and gbp = -1689.1 and eur = -267843 and  hkd = -2171.7','')")

    con:query("insert into check_sql values(-2412,'delete from transaction_total_check where cny = -2412 and jpy = -241200 and gbp = -1688.4 and eur = -267732 and  hkd = -2170.8','')")

    con:query("insert into check_sql values(-2411,'delete from transaction_total_check where cny = -2411 and jpy = -241100 and gbp = -1687.7 and eur = -267621 and  hkd = -2169.9','')")

    con:query("insert into check_sql values(-2410,'delete from transaction_total_check where cny = -2410 and jpy = -241000 and gbp = -1687.0 and eur = -267510 and  hkd = -2169.0','')")

    con:query("insert into check_sql values(-2409,'delete from transaction_total_check where cny = -2409 and jpy = -240900 and gbp = -1686.3 and eur = -267399 and  hkd = -2168.1','')")

    con:query("insert into check_sql values(-2408,'delete from transaction_total_check where cny = -2408 and jpy = -240800 and gbp = -1685.6 and eur = -267288 and  hkd = -2167.2','')")

    con:query("insert into check_sql values(-2407,'delete from transaction_total_check where cny = -2407 and jpy = -240700 and gbp = -1684.9 and eur = -267177 and  hkd = -2166.3','')")

    con:query("insert into check_sql values(-2406,'delete from transaction_total_check where cny = -2406 and jpy = -240600 and gbp = -1684.2 and eur = -267066 and  hkd = -2165.4','')")

    con:query("insert into check_sql values(-2405,'delete from transaction_total_check where cny = -2405 and jpy = -240500 and gbp = -1683.5 and eur = -266955 and  hkd = -2164.5','')")

    con:query("insert into check_sql values(-2404,'delete from transaction_total_check where cny = -2404 and jpy = -240400 and gbp = -1682.8 and eur = -266844 and  hkd = -2163.6','')")

    con:query("insert into check_sql values(-2403,'delete from transaction_total_check where cny = -2403 and jpy = -240300 and gbp = -1682.1 and eur = -266733 and  hkd = -2162.7','')")

    con:query("insert into check_sql values(-2402,'delete from transaction_total_check where cny = -2402 and jpy = -240200 and gbp = -1681.4 and eur = -266622 and  hkd = -2161.8','')")

    con:query("insert into check_sql values(-2401,'delete from transaction_total_check where cny = -2401 and jpy = -240100 and gbp = -1680.7 and eur = -266511 and  hkd = -2160.9','')")

    con:query("insert into check_sql values(-2400,'delete from transaction_total_check where cny = -2400 and jpy = -240000 and gbp = -1680.0 and eur = -266400 and  hkd = -2160.0','')")

    con:query("insert into check_sql values(-2399,'delete from transaction_total_check where cny = -2399 and jpy = -239900 and gbp = -1679.3 and eur = -266289 and  hkd = -2159.1','')")

    con:query("insert into check_sql values(-2398,'delete from transaction_total_check where cny = -2398 and jpy = -239800 and gbp = -1678.6 and eur = -266178 and  hkd = -2158.2','')")

    con:query("insert into check_sql values(-2397,'delete from transaction_total_check where cny = -2397 and jpy = -239700 and gbp = -1677.9 and eur = -266067 and  hkd = -2157.3','')")

    con:query("insert into check_sql values(-2396,'delete from transaction_total_check where cny = -2396 and jpy = -239600 and gbp = -1677.2 and eur = -265956 and  hkd = -2156.4','')")

    con:query("insert into check_sql values(-2395,'delete from transaction_total_check where cny = -2395 and jpy = -239500 and gbp = -1676.5 and eur = -265845 and  hkd = -2155.5','')")

    con:query("insert into check_sql values(-2394,'delete from transaction_total_check where cny = -2394 and jpy = -239400 and gbp = -1675.8 and eur = -265734 and  hkd = -2154.6','')")

    con:query("insert into check_sql values(-2393,'delete from transaction_total_check where cny = -2393 and jpy = -239300 and gbp = -1675.1 and eur = -265623 and  hkd = -2153.7','')")

    con:query("insert into check_sql values(-2392,'delete from transaction_total_check where cny = -2392 and jpy = -239200 and gbp = -1674.4 and eur = -265512 and  hkd = -2152.8','')")

    con:query("insert into check_sql values(-2391,'delete from transaction_total_check where cny = -2391 and jpy = -239100 and gbp = -1673.7 and eur = -265401 and  hkd = -2151.9','')")

    con:query("insert into check_sql values(-2390,'delete from transaction_total_check where cny = -2390 and jpy = -239000 and gbp = -1673.0 and eur = -265290 and  hkd = -2151.0','')")

    con:query("insert into check_sql values(-2389,'delete from transaction_total_check where cny = -2389 and jpy = -238900 and gbp = -1672.3 and eur = -265179 and  hkd = -2150.1','')")

    con:query("insert into check_sql values(-2388,'delete from transaction_total_check where cny = -2388 and jpy = -238800 and gbp = -1671.6 and eur = -265068 and  hkd = -2149.2','')")

    con:query("insert into check_sql values(-2387,'delete from transaction_total_check where cny = -2387 and jpy = -238700 and gbp = -1670.9 and eur = -264957 and  hkd = -2148.3','')")

    con:query("insert into check_sql values(-2386,'delete from transaction_total_check where cny = -2386 and jpy = -238600 and gbp = -1670.2 and eur = -264846 and  hkd = -2147.4','')")

    con:query("insert into check_sql values(-2385,'delete from transaction_total_check where cny = -2385 and jpy = -238500 and gbp = -1669.5 and eur = -264735 and  hkd = -2146.5','')")

    con:query("insert into check_sql values(-2384,'delete from transaction_total_check where cny = -2384 and jpy = -238400 and gbp = -1668.8 and eur = -264624 and  hkd = -2145.6','')")

    con:query("insert into check_sql values(-2383,'delete from transaction_total_check where cny = -2383 and jpy = -238300 and gbp = -1668.1 and eur = -264513 and  hkd = -2144.7','')")

    con:query("insert into check_sql values(-2382,'delete from transaction_total_check where cny = -2382 and jpy = -238200 and gbp = -1667.4 and eur = -264402 and  hkd = -2143.8','')")

    con:query("insert into check_sql values(-2381,'delete from transaction_total_check where cny = -2381 and jpy = -238100 and gbp = -1666.7 and eur = -264291 and  hkd = -2142.9','')")

    con:query("insert into check_sql values(-2380,'delete from transaction_total_check where cny = -2380 and jpy = -238000 and gbp = -1666.0 and eur = -264180 and  hkd = -2142.0','')")

    con:query("insert into check_sql values(-2379,'delete from transaction_total_check where cny = -2379 and jpy = -237900 and gbp = -1665.3 and eur = -264069 and  hkd = -2141.1','')")

    con:query("insert into check_sql values(-2378,'delete from transaction_total_check where cny = -2378 and jpy = -237800 and gbp = -1664.6 and eur = -263958 and  hkd = -2140.2','')")

    con:query("insert into check_sql values(-2377,'delete from transaction_total_check where cny = -2377 and jpy = -237700 and gbp = -1663.9 and eur = -263847 and  hkd = -2139.3','')")

    con:query("insert into check_sql values(-2376,'delete from transaction_total_check where cny = -2376 and jpy = -237600 and gbp = -1663.2 and eur = -263736 and  hkd = -2138.4','')")

    con:query("insert into check_sql values(-2375,'delete from transaction_total_check where cny = -2375 and jpy = -237500 and gbp = -1662.5 and eur = -263625 and  hkd = -2137.5','')")

    con:query("insert into check_sql values(-2374,'delete from transaction_total_check where cny = -2374 and jpy = -237400 and gbp = -1661.8 and eur = -263514 and  hkd = -2136.6','')")

    con:query("insert into check_sql values(-2373,'delete from transaction_total_check where cny = -2373 and jpy = -237300 and gbp = -1661.1 and eur = -263403 and  hkd = -2135.7','')")

    con:query("insert into check_sql values(-2372,'delete from transaction_total_check where cny = -2372 and jpy = -237200 and gbp = -1660.4 and eur = -263292 and  hkd = -2134.8','')")

    con:query("insert into check_sql values(-2371,'delete from transaction_total_check where cny = -2371 and jpy = -237100 and gbp = -1659.7 and eur = -263181 and  hkd = -2133.9','')")

    con:query("insert into check_sql values(-2370,'delete from transaction_total_check where cny = -2370 and jpy = -237000 and gbp = -1659.0 and eur = -263070 and  hkd = -2133.0','')")

    con:query("insert into check_sql values(-2369,'delete from transaction_total_check where cny = -2369 and jpy = -236900 and gbp = -1658.3 and eur = -262959 and  hkd = -2132.1','')")

    con:query("insert into check_sql values(-2368,'delete from transaction_total_check where cny = -2368 and jpy = -236800 and gbp = -1657.6 and eur = -262848 and  hkd = -2131.2','')")

    con:query("insert into check_sql values(-2367,'delete from transaction_total_check where cny = -2367 and jpy = -236700 and gbp = -1656.9 and eur = -262737 and  hkd = -2130.3','')")

    con:query("insert into check_sql values(-2366,'delete from transaction_total_check where cny = -2366 and jpy = -236600 and gbp = -1656.2 and eur = -262626 and  hkd = -2129.4','')")

    con:query("insert into check_sql values(-2365,'delete from transaction_total_check where cny = -2365 and jpy = -236500 and gbp = -1655.5 and eur = -262515 and  hkd = -2128.5','')")

    con:query("insert into check_sql values(-2364,'delete from transaction_total_check where cny = -2364 and jpy = -236400 and gbp = -1654.8 and eur = -262404 and  hkd = -2127.6','')")

    con:query("insert into check_sql values(-2363,'delete from transaction_total_check where cny = -2363 and jpy = -236300 and gbp = -1654.1 and eur = -262293 and  hkd = -2126.7','')")

    con:query("insert into check_sql values(-2362,'delete from transaction_total_check where cny = -2362 and jpy = -236200 and gbp = -1653.4 and eur = -262182 and  hkd = -2125.8','')")

    con:query("insert into check_sql values(-2361,'delete from transaction_total_check where cny = -2361 and jpy = -236100 and gbp = -1652.7 and eur = -262071 and  hkd = -2124.9','')")

    con:query("insert into check_sql values(-2360,'delete from transaction_total_check where cny = -2360 and jpy = -236000 and gbp = -1652.0 and eur = -261960 and  hkd = -2124.0','')")

    con:query("insert into check_sql values(-2359,'delete from transaction_total_check where cny = -2359 and jpy = -235900 and gbp = -1651.3 and eur = -261849 and  hkd = -2123.1','')")

    con:query("insert into check_sql values(-2358,'delete from transaction_total_check where cny = -2358 and jpy = -235800 and gbp = -1650.6 and eur = -261738 and  hkd = -2122.2','')")

    con:query("insert into check_sql values(-2357,'delete from transaction_total_check where cny = -2357 and jpy = -235700 and gbp = -1649.9 and eur = -261627 and  hkd = -2121.3','')")

    con:query("insert into check_sql values(-2356,'delete from transaction_total_check where cny = -2356 and jpy = -235600 and gbp = -1649.2 and eur = -261516 and  hkd = -2120.4','')")

    con:query("insert into check_sql values(-2355,'delete from transaction_total_check where cny = -2355 and jpy = -235500 and gbp = -1648.5 and eur = -261405 and  hkd = -2119.5','')")

    con:query("insert into check_sql values(-2354,'delete from transaction_total_check where cny = -2354 and jpy = -235400 and gbp = -1647.8 and eur = -261294 and  hkd = -2118.6','')")

    con:query("insert into check_sql values(-2353,'delete from transaction_total_check where cny = -2353 and jpy = -235300 and gbp = -1647.1 and eur = -261183 and  hkd = -2117.7','')")

    con:query("insert into check_sql values(-2352,'delete from transaction_total_check where cny = -2352 and jpy = -235200 and gbp = -1646.4 and eur = -261072 and  hkd = -2116.8','')")

    con:query("insert into check_sql values(-2351,'delete from transaction_total_check where cny = -2351 and jpy = -235100 and gbp = -1645.7 and eur = -260961 and  hkd = -2115.9','')")

    con:query("insert into check_sql values(-2350,'delete from transaction_total_check where cny = -2350 and jpy = -235000 and gbp = -1645.0 and eur = -260850 and  hkd = -2115.0','')")

    con:query("insert into check_sql values(-2349,'delete from transaction_total_check where cny = -2349 and jpy = -234900 and gbp = -1644.3 and eur = -260739 and  hkd = -2114.1','')")

    con:query("insert into check_sql values(-2348,'delete from transaction_total_check where cny = -2348 and jpy = -234800 and gbp = -1643.6 and eur = -260628 and  hkd = -2113.2','')")

    con:query("insert into check_sql values(-2347,'delete from transaction_total_check where cny = -2347 and jpy = -234700 and gbp = -1642.9 and eur = -260517 and  hkd = -2112.3','')")

    con:query("insert into check_sql values(-2346,'delete from transaction_total_check where cny = -2346 and jpy = -234600 and gbp = -1642.2 and eur = -260406 and  hkd = -2111.4','')")

    con:query("insert into check_sql values(-2345,'delete from transaction_total_check where cny = -2345 and jpy = -234500 and gbp = -1641.5 and eur = -260295 and  hkd = -2110.5','')")

    con:query("insert into check_sql values(-2344,'delete from transaction_total_check where cny = -2344 and jpy = -234400 and gbp = -1640.8 and eur = -260184 and  hkd = -2109.6','')")

    con:query("insert into check_sql values(-2343,'delete from transaction_total_check where cny = -2343 and jpy = -234300 and gbp = -1640.1 and eur = -260073 and  hkd = -2108.7','')")

    con:query("insert into check_sql values(-2342,'delete from transaction_total_check where cny = -2342 and jpy = -234200 and gbp = -1639.4 and eur = -259962 and  hkd = -2107.8','')")

    con:query("insert into check_sql values(-2341,'delete from transaction_total_check where cny = -2341 and jpy = -234100 and gbp = -1638.7 and eur = -259851 and  hkd = -2106.9','')")

    con:query("insert into check_sql values(-2340,'delete from transaction_total_check where cny = -2340 and jpy = -234000 and gbp = -1638.0 and eur = -259740 and  hkd = -2106.0','')")

    con:query("insert into check_sql values(-2339,'delete from transaction_total_check where cny = -2339 and jpy = -233900 and gbp = -1637.3 and eur = -259629 and  hkd = -2105.1','')")

    con:query("insert into check_sql values(-2338,'delete from transaction_total_check where cny = -2338 and jpy = -233800 and gbp = -1636.6 and eur = -259518 and  hkd = -2104.2','')")

    con:query("insert into check_sql values(-2337,'delete from transaction_total_check where cny = -2337 and jpy = -233700 and gbp = -1635.9 and eur = -259407 and  hkd = -2103.3','')")

    con:query("insert into check_sql values(-2336,'delete from transaction_total_check where cny = -2336 and jpy = -233600 and gbp = -1635.2 and eur = -259296 and  hkd = -2102.4','')")

    con:query("insert into check_sql values(-2335,'delete from transaction_total_check where cny = -2335 and jpy = -233500 and gbp = -1634.5 and eur = -259185 and  hkd = -2101.5','')")

    con:query("insert into check_sql values(-2334,'delete from transaction_total_check where cny = -2334 and jpy = -233400 and gbp = -1633.8 and eur = -259074 and  hkd = -2100.6','')")

    con:query("insert into check_sql values(-2333,'delete from transaction_total_check where cny = -2333 and jpy = -233300 and gbp = -1633.1 and eur = -258963 and  hkd = -2099.7','')")

    con:query("insert into check_sql values(-2332,'delete from transaction_total_check where cny = -2332 and jpy = -233200 and gbp = -1632.4 and eur = -258852 and  hkd = -2098.8','')")

    con:query("insert into check_sql values(-2331,'delete from transaction_total_check where cny = -2331 and jpy = -233100 and gbp = -1631.7 and eur = -258741 and  hkd = -2097.9','')")

    con:query("insert into check_sql values(-2330,'delete from transaction_total_check where cny = -2330 and jpy = -233000 and gbp = -1631.0 and eur = -258630 and  hkd = -2097.0','')")

    con:query("insert into check_sql values(-2329,'delete from transaction_total_check where cny = -2329 and jpy = -232900 and gbp = -1630.3 and eur = -258519 and  hkd = -2096.1','')")

    con:query("insert into check_sql values(-2328,'delete from transaction_total_check where cny = -2328 and jpy = -232800 and gbp = -1629.6 and eur = -258408 and  hkd = -2095.2','')")

    con:query("insert into check_sql values(-2327,'delete from transaction_total_check where cny = -2327 and jpy = -232700 and gbp = -1628.9 and eur = -258297 and  hkd = -2094.3','')")

    con:query("insert into check_sql values(-2326,'delete from transaction_total_check where cny = -2326 and jpy = -232600 and gbp = -1628.2 and eur = -258186 and  hkd = -2093.4','')")

    con:query("insert into check_sql values(-2325,'delete from transaction_total_check where cny = -2325 and jpy = -232500 and gbp = -1627.5 and eur = -258075 and  hkd = -2092.5','')")

    con:query("insert into check_sql values(-2324,'delete from transaction_total_check where cny = -2324 and jpy = -232400 and gbp = -1626.8 and eur = -257964 and  hkd = -2091.6','')")

    con:query("insert into check_sql values(-2323,'delete from transaction_total_check where cny = -2323 and jpy = -232300 and gbp = -1626.1 and eur = -257853 and  hkd = -2090.7','')")

    con:query("insert into check_sql values(-2322,'delete from transaction_total_check where cny = -2322 and jpy = -232200 and gbp = -1625.4 and eur = -257742 and  hkd = -2089.8','')")

    con:query("insert into check_sql values(-2321,'delete from transaction_total_check where cny = -2321 and jpy = -232100 and gbp = -1624.7 and eur = -257631 and  hkd = -2088.9','')")

    con:query("insert into check_sql values(-2320,'delete from transaction_total_check where cny = -2320 and jpy = -232000 and gbp = -1624.0 and eur = -257520 and  hkd = -2088.0','')")

    con:query("insert into check_sql values(-2319,'delete from transaction_total_check where cny = -2319 and jpy = -231900 and gbp = -1623.3 and eur = -257409 and  hkd = -2087.1','')")

    con:query("insert into check_sql values(-2318,'delete from transaction_total_check where cny = -2318 and jpy = -231800 and gbp = -1622.6 and eur = -257298 and  hkd = -2086.2','')")

    con:query("insert into check_sql values(-2317,'delete from transaction_total_check where cny = -2317 and jpy = -231700 and gbp = -1621.9 and eur = -257187 and  hkd = -2085.3','')")

    con:query("insert into check_sql values(-2316,'delete from transaction_total_check where cny = -2316 and jpy = -231600 and gbp = -1621.2 and eur = -257076 and  hkd = -2084.4','')")

    con:query("insert into check_sql values(-2315,'delete from transaction_total_check where cny = -2315 and jpy = -231500 and gbp = -1620.5 and eur = -256965 and  hkd = -2083.5','')")

    con:query("insert into check_sql values(-2314,'delete from transaction_total_check where cny = -2314 and jpy = -231400 and gbp = -1619.8 and eur = -256854 and  hkd = -2082.6','')")

    con:query("insert into check_sql values(-2313,'delete from transaction_total_check where cny = -2313 and jpy = -231300 and gbp = -1619.1 and eur = -256743 and  hkd = -2081.7','')")

    con:query("insert into check_sql values(-2312,'delete from transaction_total_check where cny = -2312 and jpy = -231200 and gbp = -1618.4 and eur = -256632 and  hkd = -2080.8','')")

    con:query("insert into check_sql values(-2311,'delete from transaction_total_check where cny = -2311 and jpy = -231100 and gbp = -1617.7 and eur = -256521 and  hkd = -2079.9','')")

    con:query("insert into check_sql values(-2310,'delete from transaction_total_check where cny = -2310 and jpy = -231000 and gbp = -1617.0 and eur = -256410 and  hkd = -2079.0','')")

    con:query("insert into check_sql values(-2309,'delete from transaction_total_check where cny = -2309 and jpy = -230900 and gbp = -1616.3 and eur = -256299 and  hkd = -2078.1','')")

    con:query("insert into check_sql values(-2308,'delete from transaction_total_check where cny = -2308 and jpy = -230800 and gbp = -1615.6 and eur = -256188 and  hkd = -2077.2','')")

    con:query("insert into check_sql values(-2307,'delete from transaction_total_check where cny = -2307 and jpy = -230700 and gbp = -1614.9 and eur = -256077 and  hkd = -2076.3','')")

    con:query("insert into check_sql values(-2306,'delete from transaction_total_check where cny = -2306 and jpy = -230600 and gbp = -1614.2 and eur = -255966 and  hkd = -2075.4','')")

    con:query("insert into check_sql values(-2305,'delete from transaction_total_check where cny = -2305 and jpy = -230500 and gbp = -1613.5 and eur = -255855 and  hkd = -2074.5','')")

    con:query("insert into check_sql values(-2304,'delete from transaction_total_check where cny = -2304 and jpy = -230400 and gbp = -1612.8 and eur = -255744 and  hkd = -2073.6','')")

    con:query("insert into check_sql values(-2303,'delete from transaction_total_check where cny = -2303 and jpy = -230300 and gbp = -1612.1 and eur = -255633 and  hkd = -2072.7','')")

    con:query("insert into check_sql values(-2302,'delete from transaction_total_check where cny = -2302 and jpy = -230200 and gbp = -1611.4 and eur = -255522 and  hkd = -2071.8','')")

    con:query("insert into check_sql values(-2301,'delete from transaction_total_check where cny = -2301 and jpy = -230100 and gbp = -1610.7 and eur = -255411 and  hkd = -2070.9','')")

    con:query("insert into check_sql values(-2300,'delete from transaction_total_check where cny = -2300 and jpy = -230000 and gbp = -1610.0 and eur = -255300 and  hkd = -2070.0','')")

    con:query("insert into check_sql values(-2299,'delete from transaction_total_check where cny = -2299 and jpy = -229900 and gbp = -1609.3 and eur = -255189 and  hkd = -2069.1','')")

    con:query("insert into check_sql values(-2298,'delete from transaction_total_check where cny = -2298 and jpy = -229800 and gbp = -1608.6 and eur = -255078 and  hkd = -2068.2','')")

    con:query("insert into check_sql values(-2297,'delete from transaction_total_check where cny = -2297 and jpy = -229700 and gbp = -1607.9 and eur = -254967 and  hkd = -2067.3','')")

    con:query("insert into check_sql values(-2296,'delete from transaction_total_check where cny = -2296 and jpy = -229600 and gbp = -1607.2 and eur = -254856 and  hkd = -2066.4','')")

    con:query("insert into check_sql values(-2295,'delete from transaction_total_check where cny = -2295 and jpy = -229500 and gbp = -1606.5 and eur = -254745 and  hkd = -2065.5','')")

    con:query("insert into check_sql values(-2294,'delete from transaction_total_check where cny = -2294 and jpy = -229400 and gbp = -1605.8 and eur = -254634 and  hkd = -2064.6','')")

    con:query("insert into check_sql values(-2293,'delete from transaction_total_check where cny = -2293 and jpy = -229300 and gbp = -1605.1 and eur = -254523 and  hkd = -2063.7','')")

    con:query("insert into check_sql values(-2292,'delete from transaction_total_check where cny = -2292 and jpy = -229200 and gbp = -1604.4 and eur = -254412 and  hkd = -2062.8','')")

    con:query("insert into check_sql values(-2291,'delete from transaction_total_check where cny = -2291 and jpy = -229100 and gbp = -1603.7 and eur = -254301 and  hkd = -2061.9','')")

    con:query("insert into check_sql values(-2290,'delete from transaction_total_check where cny = -2290 and jpy = -229000 and gbp = -1603.0 and eur = -254190 and  hkd = -2061.0','')")

    con:query("insert into check_sql values(-2289,'delete from transaction_total_check where cny = -2289 and jpy = -228900 and gbp = -1602.3 and eur = -254079 and  hkd = -2060.1','')")

    con:query("insert into check_sql values(-2288,'delete from transaction_total_check where cny = -2288 and jpy = -228800 and gbp = -1601.6 and eur = -253968 and  hkd = -2059.2','')")

    con:query("insert into check_sql values(-2287,'delete from transaction_total_check where cny = -2287 and jpy = -228700 and gbp = -1600.9 and eur = -253857 and  hkd = -2058.3','')")

    con:query("insert into check_sql values(-2286,'delete from transaction_total_check where cny = -2286 and jpy = -228600 and gbp = -1600.2 and eur = -253746 and  hkd = -2057.4','')")

    con:query("insert into check_sql values(-2285,'delete from transaction_total_check where cny = -2285 and jpy = -228500 and gbp = -1599.5 and eur = -253635 and  hkd = -2056.5','')")

    con:query("insert into check_sql values(-2284,'delete from transaction_total_check where cny = -2284 and jpy = -228400 and gbp = -1598.8 and eur = -253524 and  hkd = -2055.6','')")

    con:query("insert into check_sql values(-2283,'delete from transaction_total_check where cny = -2283 and jpy = -228300 and gbp = -1598.1 and eur = -253413 and  hkd = -2054.7','')")

    con:query("insert into check_sql values(-2282,'delete from transaction_total_check where cny = -2282 and jpy = -228200 and gbp = -1597.4 and eur = -253302 and  hkd = -2053.8','')")

    con:query("insert into check_sql values(-2281,'delete from transaction_total_check where cny = -2281 and jpy = -228100 and gbp = -1596.7 and eur = -253191 and  hkd = -2052.9','')")

    con:query("insert into check_sql values(-2280,'delete from transaction_total_check where cny = -2280 and jpy = -228000 and gbp = -1596.0 and eur = -253080 and  hkd = -2052.0','')")

    con:query("insert into check_sql values(-2279,'delete from transaction_total_check where cny = -2279 and jpy = -227900 and gbp = -1595.3 and eur = -252969 and  hkd = -2051.1','')")

    con:query("insert into check_sql values(-2278,'delete from transaction_total_check where cny = -2278 and jpy = -227800 and gbp = -1594.6 and eur = -252858 and  hkd = -2050.2','')")

    con:query("insert into check_sql values(-2277,'delete from transaction_total_check where cny = -2277 and jpy = -227700 and gbp = -1593.9 and eur = -252747 and  hkd = -2049.3','')")

    con:query("insert into check_sql values(-2276,'delete from transaction_total_check where cny = -2276 and jpy = -227600 and gbp = -1593.2 and eur = -252636 and  hkd = -2048.4','')")

    con:query("insert into check_sql values(-2275,'delete from transaction_total_check where cny = -2275 and jpy = -227500 and gbp = -1592.5 and eur = -252525 and  hkd = -2047.5','')")

    con:query("insert into check_sql values(-2274,'delete from transaction_total_check where cny = -2274 and jpy = -227400 and gbp = -1591.8 and eur = -252414 and  hkd = -2046.6','')")

    con:query("insert into check_sql values(-2273,'delete from transaction_total_check where cny = -2273 and jpy = -227300 and gbp = -1591.1 and eur = -252303 and  hkd = -2045.7','')")

    con:query("insert into check_sql values(-2272,'delete from transaction_total_check where cny = -2272 and jpy = -227200 and gbp = -1590.4 and eur = -252192 and  hkd = -2044.8','')")

    con:query("insert into check_sql values(-2271,'delete from transaction_total_check where cny = -2271 and jpy = -227100 and gbp = -1589.7 and eur = -252081 and  hkd = -2043.9','')")

    con:query("insert into check_sql values(-2270,'delete from transaction_total_check where cny = -2270 and jpy = -227000 and gbp = -1589.0 and eur = -251970 and  hkd = -2043.0','')")

    con:query("insert into check_sql values(-2269,'delete from transaction_total_check where cny = -2269 and jpy = -226900 and gbp = -1588.3 and eur = -251859 and  hkd = -2042.1','')")

    con:query("insert into check_sql values(-2268,'delete from transaction_total_check where cny = -2268 and jpy = -226800 and gbp = -1587.6 and eur = -251748 and  hkd = -2041.2','')")

    con:query("insert into check_sql values(-2267,'delete from transaction_total_check where cny = -2267 and jpy = -226700 and gbp = -1586.9 and eur = -251637 and  hkd = -2040.3','')")

    con:query("insert into check_sql values(-2266,'delete from transaction_total_check where cny = -2266 and jpy = -226600 and gbp = -1586.2 and eur = -251526 and  hkd = -2039.4','')")

    con:query("insert into check_sql values(-2265,'delete from transaction_total_check where cny = -2265 and jpy = -226500 and gbp = -1585.5 and eur = -251415 and  hkd = -2038.5','')")

    con:query("insert into check_sql values(-2264,'delete from transaction_total_check where cny = -2264 and jpy = -226400 and gbp = -1584.8 and eur = -251304 and  hkd = -2037.6','')")

    con:query("insert into check_sql values(-2263,'delete from transaction_total_check where cny = -2263 and jpy = -226300 and gbp = -1584.1 and eur = -251193 and  hkd = -2036.7','')")

    con:query("insert into check_sql values(-2262,'delete from transaction_total_check where cny = -2262 and jpy = -226200 and gbp = -1583.4 and eur = -251082 and  hkd = -2035.8','')")

    con:query("insert into check_sql values(-2261,'delete from transaction_total_check where cny = -2261 and jpy = -226100 and gbp = -1582.7 and eur = -250971 and  hkd = -2034.9','')")

    con:query("insert into check_sql values(-2260,'delete from transaction_total_check where cny = -2260 and jpy = -226000 and gbp = -1582.0 and eur = -250860 and  hkd = -2034.0','')")

    con:query("insert into check_sql values(-2259,'delete from transaction_total_check where cny = -2259 and jpy = -225900 and gbp = -1581.3 and eur = -250749 and  hkd = -2033.1','')")

    con:query("insert into check_sql values(-2258,'delete from transaction_total_check where cny = -2258 and jpy = -225800 and gbp = -1580.6 and eur = -250638 and  hkd = -2032.2','')")

    con:query("insert into check_sql values(-2257,'delete from transaction_total_check where cny = -2257 and jpy = -225700 and gbp = -1579.9 and eur = -250527 and  hkd = -2031.3','')")

    con:query("insert into check_sql values(-2256,'delete from transaction_total_check where cny = -2256 and jpy = -225600 and gbp = -1579.2 and eur = -250416 and  hkd = -2030.4','')")

    con:query("insert into check_sql values(-2255,'delete from transaction_total_check where cny = -2255 and jpy = -225500 and gbp = -1578.5 and eur = -250305 and  hkd = -2029.5','')")

    con:query("insert into check_sql values(-2254,'delete from transaction_total_check where cny = -2254 and jpy = -225400 and gbp = -1577.8 and eur = -250194 and  hkd = -2028.6','')")

    con:query("insert into check_sql values(-2253,'delete from transaction_total_check where cny = -2253 and jpy = -225300 and gbp = -1577.1 and eur = -250083 and  hkd = -2027.7','')")

    con:query("insert into check_sql values(-2252,'delete from transaction_total_check where cny = -2252 and jpy = -225200 and gbp = -1576.4 and eur = -249972 and  hkd = -2026.8','')")

    con:query("insert into check_sql values(-2251,'delete from transaction_total_check where cny = -2251 and jpy = -225100 and gbp = -1575.7 and eur = -249861 and  hkd = -2025.9','')")

    con:query("insert into check_sql values(-2250,'delete from transaction_total_check where cny = -2250 and jpy = -225000 and gbp = -1575.0 and eur = -249750 and  hkd = -2025.0','')")

    con:query("insert into check_sql values(-2249,'delete from transaction_total_check where cny = -2249 and jpy = -224900 and gbp = -1574.3 and eur = -249639 and  hkd = -2024.1','')")

    con:query("insert into check_sql values(-2248,'delete from transaction_total_check where cny = -2248 and jpy = -224800 and gbp = -1573.6 and eur = -249528 and  hkd = -2023.2','')")

    con:query("insert into check_sql values(-2247,'delete from transaction_total_check where cny = -2247 and jpy = -224700 and gbp = -1572.9 and eur = -249417 and  hkd = -2022.3','')")

    con:query("insert into check_sql values(-2246,'delete from transaction_total_check where cny = -2246 and jpy = -224600 and gbp = -1572.2 and eur = -249306 and  hkd = -2021.4','')")

    con:query("insert into check_sql values(-2245,'delete from transaction_total_check where cny = -2245 and jpy = -224500 and gbp = -1571.5 and eur = -249195 and  hkd = -2020.5','')")

    con:query("insert into check_sql values(-2244,'delete from transaction_total_check where cny = -2244 and jpy = -224400 and gbp = -1570.8 and eur = -249084 and  hkd = -2019.6','')")

    con:query("insert into check_sql values(-2243,'delete from transaction_total_check where cny = -2243 and jpy = -224300 and gbp = -1570.1 and eur = -248973 and  hkd = -2018.7','')")

    con:query("insert into check_sql values(-2242,'delete from transaction_total_check where cny = -2242 and jpy = -224200 and gbp = -1569.4 and eur = -248862 and  hkd = -2017.8','')")

    con:query("insert into check_sql values(-2241,'delete from transaction_total_check where cny = -2241 and jpy = -224100 and gbp = -1568.7 and eur = -248751 and  hkd = -2016.9','')")

    con:query("insert into check_sql values(-2240,'delete from transaction_total_check where cny = -2240 and jpy = -224000 and gbp = -1568.0 and eur = -248640 and  hkd = -2016.0','')")

    con:query("insert into check_sql values(-2239,'delete from transaction_total_check where cny = -2239 and jpy = -223900 and gbp = -1567.3 and eur = -248529 and  hkd = -2015.1','')")

    con:query("insert into check_sql values(-2238,'delete from transaction_total_check where cny = -2238 and jpy = -223800 and gbp = -1566.6 and eur = -248418 and  hkd = -2014.2','')")

    con:query("insert into check_sql values(-2237,'delete from transaction_total_check where cny = -2237 and jpy = -223700 and gbp = -1565.9 and eur = -248307 and  hkd = -2013.3','')")

    con:query("insert into check_sql values(-2236,'delete from transaction_total_check where cny = -2236 and jpy = -223600 and gbp = -1565.2 and eur = -248196 and  hkd = -2012.4','')")

    con:query("insert into check_sql values(-2235,'delete from transaction_total_check where cny = -2235 and jpy = -223500 and gbp = -1564.5 and eur = -248085 and  hkd = -2011.5','')")

    con:query("insert into check_sql values(-2234,'delete from transaction_total_check where cny = -2234 and jpy = -223400 and gbp = -1563.8 and eur = -247974 and  hkd = -2010.6','')")

    con:query("insert into check_sql values(-2233,'delete from transaction_total_check where cny = -2233 and jpy = -223300 and gbp = -1563.1 and eur = -247863 and  hkd = -2009.7','')")

    con:query("insert into check_sql values(-2232,'delete from transaction_total_check where cny = -2232 and jpy = -223200 and gbp = -1562.4 and eur = -247752 and  hkd = -2008.8','')")

    con:query("insert into check_sql values(-2231,'delete from transaction_total_check where cny = -2231 and jpy = -223100 and gbp = -1561.7 and eur = -247641 and  hkd = -2007.9','')")

    con:query("insert into check_sql values(-2230,'delete from transaction_total_check where cny = -2230 and jpy = -223000 and gbp = -1561.0 and eur = -247530 and  hkd = -2007.0','')")

    con:query("insert into check_sql values(-2229,'delete from transaction_total_check where cny = -2229 and jpy = -222900 and gbp = -1560.3 and eur = -247419 and  hkd = -2006.1','')")

    con:query("insert into check_sql values(-2228,'delete from transaction_total_check where cny = -2228 and jpy = -222800 and gbp = -1559.6 and eur = -247308 and  hkd = -2005.2','')")

    con:query("insert into check_sql values(-2227,'delete from transaction_total_check where cny = -2227 and jpy = -222700 and gbp = -1558.9 and eur = -247197 and  hkd = -2004.3','')")

    con:query("insert into check_sql values(-2226,'delete from transaction_total_check where cny = -2226 and jpy = -222600 and gbp = -1558.2 and eur = -247086 and  hkd = -2003.4','')")

    con:query("insert into check_sql values(-2225,'delete from transaction_total_check where cny = -2225 and jpy = -222500 and gbp = -1557.5 and eur = -246975 and  hkd = -2002.5','')")

    con:query("insert into check_sql values(-2224,'delete from transaction_total_check where cny = -2224 and jpy = -222400 and gbp = -1556.8 and eur = -246864 and  hkd = -2001.6','')")

    con:query("insert into check_sql values(-2223,'delete from transaction_total_check where cny = -2223 and jpy = -222300 and gbp = -1556.1 and eur = -246753 and  hkd = -2000.7','')")

    con:query("insert into check_sql values(-2222,'delete from transaction_total_check where cny = -2222 and jpy = -222200 and gbp = -1555.4 and eur = -246642 and  hkd = -1999.8','')")

    con:query("insert into check_sql values(-2221,'delete from transaction_total_check where cny = -2221 and jpy = -222100 and gbp = -1554.7 and eur = -246531 and  hkd = -1998.9','')")

    con:query("insert into check_sql values(-2220,'delete from transaction_total_check where cny = -2220 and jpy = -222000 and gbp = -1554.0 and eur = -246420 and  hkd = -1998.0','')")

    con:query("insert into check_sql values(-2219,'delete from transaction_total_check where cny = -2219 and jpy = -221900 and gbp = -1553.3 and eur = -246309 and  hkd = -1997.1','')")

    con:query("insert into check_sql values(-2218,'delete from transaction_total_check where cny = -2218 and jpy = -221800 and gbp = -1552.6 and eur = -246198 and  hkd = -1996.2','')")

    con:query("insert into check_sql values(-2217,'delete from transaction_total_check where cny = -2217 and jpy = -221700 and gbp = -1551.9 and eur = -246087 and  hkd = -1995.3','')")

    con:query("insert into check_sql values(-2216,'delete from transaction_total_check where cny = -2216 and jpy = -221600 and gbp = -1551.2 and eur = -245976 and  hkd = -1994.4','')")

    con:query("insert into check_sql values(-2215,'delete from transaction_total_check where cny = -2215 and jpy = -221500 and gbp = -1550.5 and eur = -245865 and  hkd = -1993.5','')")

    con:query("insert into check_sql values(-2214,'delete from transaction_total_check where cny = -2214 and jpy = -221400 and gbp = -1549.8 and eur = -245754 and  hkd = -1992.6','')")

    con:query("insert into check_sql values(-2213,'delete from transaction_total_check where cny = -2213 and jpy = -221300 and gbp = -1549.1 and eur = -245643 and  hkd = -1991.7','')")

    con:query("insert into check_sql values(-2212,'delete from transaction_total_check where cny = -2212 and jpy = -221200 and gbp = -1548.4 and eur = -245532 and  hkd = -1990.8','')")

    con:query("insert into check_sql values(-2211,'delete from transaction_total_check where cny = -2211 and jpy = -221100 and gbp = -1547.7 and eur = -245421 and  hkd = -1989.9','')")

    con:query("insert into check_sql values(-2210,'delete from transaction_total_check where cny = -2210 and jpy = -221000 and gbp = -1547.0 and eur = -245310 and  hkd = -1989.0','')")

    con:query("insert into check_sql values(-2209,'delete from transaction_total_check where cny = -2209 and jpy = -220900 and gbp = -1546.3 and eur = -245199 and  hkd = -1988.1','')")

    con:query("insert into check_sql values(-2208,'delete from transaction_total_check where cny = -2208 and jpy = -220800 and gbp = -1545.6 and eur = -245088 and  hkd = -1987.2','')")

    con:query("insert into check_sql values(-2207,'delete from transaction_total_check where cny = -2207 and jpy = -220700 and gbp = -1544.9 and eur = -244977 and  hkd = -1986.3','')")

    con:query("insert into check_sql values(-2206,'delete from transaction_total_check where cny = -2206 and jpy = -220600 and gbp = -1544.2 and eur = -244866 and  hkd = -1985.4','')")

    con:query("insert into check_sql values(-2205,'delete from transaction_total_check where cny = -2205 and jpy = -220500 and gbp = -1543.5 and eur = -244755 and  hkd = -1984.5','')")

    con:query("insert into check_sql values(-2204,'delete from transaction_total_check where cny = -2204 and jpy = -220400 and gbp = -1542.8 and eur = -244644 and  hkd = -1983.6','')")

    con:query("insert into check_sql values(-2203,'delete from transaction_total_check where cny = -2203 and jpy = -220300 and gbp = -1542.1 and eur = -244533 and  hkd = -1982.7','')")

    con:query("insert into check_sql values(-2202,'delete from transaction_total_check where cny = -2202 and jpy = -220200 and gbp = -1541.4 and eur = -244422 and  hkd = -1981.8','')")

    con:query("insert into check_sql values(-2201,'delete from transaction_total_check where cny = -2201 and jpy = -220100 and gbp = -1540.7 and eur = -244311 and  hkd = -1980.9','')")

    con:query("insert into check_sql values(-2200,'delete from transaction_total_check where cny = -2200 and jpy = -220000 and gbp = -1540.0 and eur = -244200 and  hkd = -1980.0','')")

    con:query("insert into check_sql values(-2199,'delete from transaction_total_check where cny = -2199 and jpy = -219900 and gbp = -1539.3 and eur = -244089 and  hkd = -1979.1','')")

    con:query("insert into check_sql values(-2198,'delete from transaction_total_check where cny = -2198 and jpy = -219800 and gbp = -1538.6 and eur = -243978 and  hkd = -1978.2','')")

    con:query("insert into check_sql values(-2197,'delete from transaction_total_check where cny = -2197 and jpy = -219700 and gbp = -1537.9 and eur = -243867 and  hkd = -1977.3','')")

    con:query("insert into check_sql values(-2196,'delete from transaction_total_check where cny = -2196 and jpy = -219600 and gbp = -1537.2 and eur = -243756 and  hkd = -1976.4','')")

    con:query("insert into check_sql values(-2195,'delete from transaction_total_check where cny = -2195 and jpy = -219500 and gbp = -1536.5 and eur = -243645 and  hkd = -1975.5','')")

    con:query("insert into check_sql values(-2194,'delete from transaction_total_check where cny = -2194 and jpy = -219400 and gbp = -1535.8 and eur = -243534 and  hkd = -1974.6','')")

    con:query("insert into check_sql values(-2193,'delete from transaction_total_check where cny = -2193 and jpy = -219300 and gbp = -1535.1 and eur = -243423 and  hkd = -1973.7','')")

    con:query("insert into check_sql values(-2192,'delete from transaction_total_check where cny = -2192 and jpy = -219200 and gbp = -1534.4 and eur = -243312 and  hkd = -1972.8','')")

    con:query("insert into check_sql values(-2191,'delete from transaction_total_check where cny = -2191 and jpy = -219100 and gbp = -1533.7 and eur = -243201 and  hkd = -1971.9','')")

    con:query("insert into check_sql values(-2190,'delete from transaction_total_check where cny = -2190 and jpy = -219000 and gbp = -1533.0 and eur = -243090 and  hkd = -1971.0','')")

    con:query("insert into check_sql values(-2189,'delete from transaction_total_check where cny = -2189 and jpy = -218900 and gbp = -1532.3 and eur = -242979 and  hkd = -1970.1','')")

    con:query("insert into check_sql values(-2188,'delete from transaction_total_check where cny = -2188 and jpy = -218800 and gbp = -1531.6 and eur = -242868 and  hkd = -1969.2','')")

    con:query("insert into check_sql values(-2187,'delete from transaction_total_check where cny = -2187 and jpy = -218700 and gbp = -1530.9 and eur = -242757 and  hkd = -1968.3','')")

    con:query("insert into check_sql values(-2186,'delete from transaction_total_check where cny = -2186 and jpy = -218600 and gbp = -1530.2 and eur = -242646 and  hkd = -1967.4','')")

    con:query("insert into check_sql values(-2185,'delete from transaction_total_check where cny = -2185 and jpy = -218500 and gbp = -1529.5 and eur = -242535 and  hkd = -1966.5','')")

    con:query("insert into check_sql values(-2184,'delete from transaction_total_check where cny = -2184 and jpy = -218400 and gbp = -1528.8 and eur = -242424 and  hkd = -1965.6','')")

    con:query("insert into check_sql values(-2183,'delete from transaction_total_check where cny = -2183 and jpy = -218300 and gbp = -1528.1 and eur = -242313 and  hkd = -1964.7','')")

    con:query("insert into check_sql values(-2182,'delete from transaction_total_check where cny = -2182 and jpy = -218200 and gbp = -1527.4 and eur = -242202 and  hkd = -1963.8','')")

    con:query("insert into check_sql values(-2181,'delete from transaction_total_check where cny = -2181 and jpy = -218100 and gbp = -1526.7 and eur = -242091 and  hkd = -1962.9','')")

    con:query("insert into check_sql values(-2180,'delete from transaction_total_check where cny = -2180 and jpy = -218000 and gbp = -1526.0 and eur = -241980 and  hkd = -1962.0','')")

    con:query("insert into check_sql values(-2179,'delete from transaction_total_check where cny = -2179 and jpy = -217900 and gbp = -1525.3 and eur = -241869 and  hkd = -1961.1','')")

    con:query("insert into check_sql values(-2178,'delete from transaction_total_check where cny = -2178 and jpy = -217800 and gbp = -1524.6 and eur = -241758 and  hkd = -1960.2','')")

    con:query("insert into check_sql values(-2177,'delete from transaction_total_check where cny = -2177 and jpy = -217700 and gbp = -1523.9 and eur = -241647 and  hkd = -1959.3','')")

    con:query("insert into check_sql values(-2176,'delete from transaction_total_check where cny = -2176 and jpy = -217600 and gbp = -1523.2 and eur = -241536 and  hkd = -1958.4','')")

    con:query("insert into check_sql values(-2175,'delete from transaction_total_check where cny = -2175 and jpy = -217500 and gbp = -1522.5 and eur = -241425 and  hkd = -1957.5','')")

    con:query("insert into check_sql values(-2174,'delete from transaction_total_check where cny = -2174 and jpy = -217400 and gbp = -1521.8 and eur = -241314 and  hkd = -1956.6','')")

    con:query("insert into check_sql values(-2173,'delete from transaction_total_check where cny = -2173 and jpy = -217300 and gbp = -1521.1 and eur = -241203 and  hkd = -1955.7','')")

    con:query("insert into check_sql values(-2172,'delete from transaction_total_check where cny = -2172 and jpy = -217200 and gbp = -1520.4 and eur = -241092 and  hkd = -1954.8','')")

    con:query("insert into check_sql values(-2171,'delete from transaction_total_check where cny = -2171 and jpy = -217100 and gbp = -1519.7 and eur = -240981 and  hkd = -1953.9','')")

    con:query("insert into check_sql values(-2170,'delete from transaction_total_check where cny = -2170 and jpy = -217000 and gbp = -1519.0 and eur = -240870 and  hkd = -1953.0','')")

    con:query("insert into check_sql values(-2169,'delete from transaction_total_check where cny = -2169 and jpy = -216900 and gbp = -1518.3 and eur = -240759 and  hkd = -1952.1','')")

    con:query("insert into check_sql values(-2168,'delete from transaction_total_check where cny = -2168 and jpy = -216800 and gbp = -1517.6 and eur = -240648 and  hkd = -1951.2','')")

    con:query("insert into check_sql values(-2167,'delete from transaction_total_check where cny = -2167 and jpy = -216700 and gbp = -1516.9 and eur = -240537 and  hkd = -1950.3','')")

    con:query("insert into check_sql values(-2166,'delete from transaction_total_check where cny = -2166 and jpy = -216600 and gbp = -1516.2 and eur = -240426 and  hkd = -1949.4','')")

    con:query("insert into check_sql values(-2165,'delete from transaction_total_check where cny = -2165 and jpy = -216500 and gbp = -1515.5 and eur = -240315 and  hkd = -1948.5','')")

    con:query("insert into check_sql values(-2164,'delete from transaction_total_check where cny = -2164 and jpy = -216400 and gbp = -1514.8 and eur = -240204 and  hkd = -1947.6','')")

    con:query("insert into check_sql values(-2163,'delete from transaction_total_check where cny = -2163 and jpy = -216300 and gbp = -1514.1 and eur = -240093 and  hkd = -1946.7','')")

    con:query("insert into check_sql values(-2162,'delete from transaction_total_check where cny = -2162 and jpy = -216200 and gbp = -1513.4 and eur = -239982 and  hkd = -1945.8','')")

    con:query("insert into check_sql values(-2161,'delete from transaction_total_check where cny = -2161 and jpy = -216100 and gbp = -1512.7 and eur = -239871 and  hkd = -1944.9','')")

    con:query("insert into check_sql values(-2160,'delete from transaction_total_check where cny = -2160 and jpy = -216000 and gbp = -1512.0 and eur = -239760 and  hkd = -1944.0','')")

    con:query("insert into check_sql values(-2159,'delete from transaction_total_check where cny = -2159 and jpy = -215900 and gbp = -1511.3 and eur = -239649 and  hkd = -1943.1','')")

    con:query("insert into check_sql values(-2158,'delete from transaction_total_check where cny = -2158 and jpy = -215800 and gbp = -1510.6 and eur = -239538 and  hkd = -1942.2','')")

    con:query("insert into check_sql values(-2157,'delete from transaction_total_check where cny = -2157 and jpy = -215700 and gbp = -1509.9 and eur = -239427 and  hkd = -1941.3','')")

    con:query("insert into check_sql values(-2156,'delete from transaction_total_check where cny = -2156 and jpy = -215600 and gbp = -1509.2 and eur = -239316 and  hkd = -1940.4','')")

    con:query("insert into check_sql values(-2155,'delete from transaction_total_check where cny = -2155 and jpy = -215500 and gbp = -1508.5 and eur = -239205 and  hkd = -1939.5','')")

    con:query("insert into check_sql values(-2154,'delete from transaction_total_check where cny = -2154 and jpy = -215400 and gbp = -1507.8 and eur = -239094 and  hkd = -1938.6','')")

    con:query("insert into check_sql values(-2153,'delete from transaction_total_check where cny = -2153 and jpy = -215300 and gbp = -1507.1 and eur = -238983 and  hkd = -1937.7','')")

    con:query("insert into check_sql values(-2152,'delete from transaction_total_check where cny = -2152 and jpy = -215200 and gbp = -1506.4 and eur = -238872 and  hkd = -1936.8','')")

    con:query("insert into check_sql values(-2151,'delete from transaction_total_check where cny = -2151 and jpy = -215100 and gbp = -1505.7 and eur = -238761 and  hkd = -1935.9','')")

    con:query("insert into check_sql values(-2150,'delete from transaction_total_check where cny = -2150 and jpy = -215000 and gbp = -1505.0 and eur = -238650 and  hkd = -1935.0','')")

    con:query("insert into check_sql values(-2149,'delete from transaction_total_check where cny = -2149 and jpy = -214900 and gbp = -1504.3 and eur = -238539 and  hkd = -1934.1','')")

    con:query("insert into check_sql values(-2148,'delete from transaction_total_check where cny = -2148 and jpy = -214800 and gbp = -1503.6 and eur = -238428 and  hkd = -1933.2','')")

    con:query("insert into check_sql values(-2147,'delete from transaction_total_check where cny = -2147 and jpy = -214700 and gbp = -1502.9 and eur = -238317 and  hkd = -1932.3','')")

    con:query("insert into check_sql values(-2146,'delete from transaction_total_check where cny = -2146 and jpy = -214600 and gbp = -1502.2 and eur = -238206 and  hkd = -1931.4','')")

    con:query("insert into check_sql values(-2145,'delete from transaction_total_check where cny = -2145 and jpy = -214500 and gbp = -1501.5 and eur = -238095 and  hkd = -1930.5','')")

    con:query("insert into check_sql values(-2144,'delete from transaction_total_check where cny = -2144 and jpy = -214400 and gbp = -1500.8 and eur = -237984 and  hkd = -1929.6','')")

    con:query("insert into check_sql values(-2143,'delete from transaction_total_check where cny = -2143 and jpy = -214300 and gbp = -1500.1 and eur = -237873 and  hkd = -1928.7','')")

    con:query("insert into check_sql values(-2142,'delete from transaction_total_check where cny = -2142 and jpy = -214200 and gbp = -1499.4 and eur = -237762 and  hkd = -1927.8','')")

    con:query("insert into check_sql values(-2141,'delete from transaction_total_check where cny = -2141 and jpy = -214100 and gbp = -1498.7 and eur = -237651 and  hkd = -1926.9','')")

    con:query("insert into check_sql values(-2140,'delete from transaction_total_check where cny = -2140 and jpy = -214000 and gbp = -1498.0 and eur = -237540 and  hkd = -1926.0','')")

    con:query("insert into check_sql values(-2139,'delete from transaction_total_check where cny = -2139 and jpy = -213900 and gbp = -1497.3 and eur = -237429 and  hkd = -1925.1','')")

    con:query("insert into check_sql values(-2138,'delete from transaction_total_check where cny = -2138 and jpy = -213800 and gbp = -1496.6 and eur = -237318 and  hkd = -1924.2','')")

    con:query("insert into check_sql values(-2137,'delete from transaction_total_check where cny = -2137 and jpy = -213700 and gbp = -1495.9 and eur = -237207 and  hkd = -1923.3','')")

    con:query("insert into check_sql values(-2136,'delete from transaction_total_check where cny = -2136 and jpy = -213600 and gbp = -1495.2 and eur = -237096 and  hkd = -1922.4','')")

    con:query("insert into check_sql values(-2135,'delete from transaction_total_check where cny = -2135 and jpy = -213500 and gbp = -1494.5 and eur = -236985 and  hkd = -1921.5','')")

    con:query("insert into check_sql values(-2134,'delete from transaction_total_check where cny = -2134 and jpy = -213400 and gbp = -1493.8 and eur = -236874 and  hkd = -1920.6','')")

    con:query("insert into check_sql values(-2133,'delete from transaction_total_check where cny = -2133 and jpy = -213300 and gbp = -1493.1 and eur = -236763 and  hkd = -1919.7','')")

    con:query("insert into check_sql values(-2132,'delete from transaction_total_check where cny = -2132 and jpy = -213200 and gbp = -1492.4 and eur = -236652 and  hkd = -1918.8','')")

    con:query("insert into check_sql values(-2131,'delete from transaction_total_check where cny = -2131 and jpy = -213100 and gbp = -1491.7 and eur = -236541 and  hkd = -1917.9','')")

    con:query("insert into check_sql values(-2130,'delete from transaction_total_check where cny = -2130 and jpy = -213000 and gbp = -1491.0 and eur = -236430 and  hkd = -1917.0','')")

    con:query("insert into check_sql values(-2129,'delete from transaction_total_check where cny = -2129 and jpy = -212900 and gbp = -1490.3 and eur = -236319 and  hkd = -1916.1','')")

    con:query("insert into check_sql values(-2128,'delete from transaction_total_check where cny = -2128 and jpy = -212800 and gbp = -1489.6 and eur = -236208 and  hkd = -1915.2','')")

    con:query("insert into check_sql values(-2127,'delete from transaction_total_check where cny = -2127 and jpy = -212700 and gbp = -1488.9 and eur = -236097 and  hkd = -1914.3','')")

    con:query("insert into check_sql values(-2126,'delete from transaction_total_check where cny = -2126 and jpy = -212600 and gbp = -1488.2 and eur = -235986 and  hkd = -1913.4','')")

    con:query("insert into check_sql values(-2125,'delete from transaction_total_check where cny = -2125 and jpy = -212500 and gbp = -1487.5 and eur = -235875 and  hkd = -1912.5','')")

    con:query("insert into check_sql values(-2124,'delete from transaction_total_check where cny = -2124 and jpy = -212400 and gbp = -1486.8 and eur = -235764 and  hkd = -1911.6','')")

    con:query("insert into check_sql values(-2123,'delete from transaction_total_check where cny = -2123 and jpy = -212300 and gbp = -1486.1 and eur = -235653 and  hkd = -1910.7','')")

    con:query("insert into check_sql values(-2122,'delete from transaction_total_check where cny = -2122 and jpy = -212200 and gbp = -1485.4 and eur = -235542 and  hkd = -1909.8','')")

    con:query("insert into check_sql values(-2121,'delete from transaction_total_check where cny = -2121 and jpy = -212100 and gbp = -1484.7 and eur = -235431 and  hkd = -1908.9','')")

    con:query("insert into check_sql values(-2120,'delete from transaction_total_check where cny = -2120 and jpy = -212000 and gbp = -1484.0 and eur = -235320 and  hkd = -1908.0','')")

    con:query("insert into check_sql values(-2119,'delete from transaction_total_check where cny = -2119 and jpy = -211900 and gbp = -1483.3 and eur = -235209 and  hkd = -1907.1','')")

    con:query("insert into check_sql values(-2118,'delete from transaction_total_check where cny = -2118 and jpy = -211800 and gbp = -1482.6 and eur = -235098 and  hkd = -1906.2','')")

    con:query("insert into check_sql values(-2117,'delete from transaction_total_check where cny = -2117 and jpy = -211700 and gbp = -1481.9 and eur = -234987 and  hkd = -1905.3','')")

    con:query("insert into check_sql values(-2116,'delete from transaction_total_check where cny = -2116 and jpy = -211600 and gbp = -1481.2 and eur = -234876 and  hkd = -1904.4','')")

    con:query("insert into check_sql values(-2115,'delete from transaction_total_check where cny = -2115 and jpy = -211500 and gbp = -1480.5 and eur = -234765 and  hkd = -1903.5','')")

    con:query("insert into check_sql values(-2114,'delete from transaction_total_check where cny = -2114 and jpy = -211400 and gbp = -1479.8 and eur = -234654 and  hkd = -1902.6','')")

    con:query("insert into check_sql values(-2113,'delete from transaction_total_check where cny = -2113 and jpy = -211300 and gbp = -1479.1 and eur = -234543 and  hkd = -1901.7','')")

    con:query("insert into check_sql values(-2112,'delete from transaction_total_check where cny = -2112 and jpy = -211200 and gbp = -1478.4 and eur = -234432 and  hkd = -1900.8','')")

    con:query("insert into check_sql values(-2111,'delete from transaction_total_check where cny = -2111 and jpy = -211100 and gbp = -1477.7 and eur = -234321 and  hkd = -1899.9','')")

    con:query("insert into check_sql values(-2110,'delete from transaction_total_check where cny = -2110 and jpy = -211000 and gbp = -1477.0 and eur = -234210 and  hkd = -1899.0','')")

    con:query("insert into check_sql values(-2109,'delete from transaction_total_check where cny = -2109 and jpy = -210900 and gbp = -1476.3 and eur = -234099 and  hkd = -1898.1','')")

    con:query("insert into check_sql values(-2108,'delete from transaction_total_check where cny = -2108 and jpy = -210800 and gbp = -1475.6 and eur = -233988 and  hkd = -1897.2','')")

    con:query("insert into check_sql values(-2107,'delete from transaction_total_check where cny = -2107 and jpy = -210700 and gbp = -1474.9 and eur = -233877 and  hkd = -1896.3','')")

    con:query("insert into check_sql values(-2106,'delete from transaction_total_check where cny = -2106 and jpy = -210600 and gbp = -1474.2 and eur = -233766 and  hkd = -1895.4','')")

    con:query("insert into check_sql values(-2105,'delete from transaction_total_check where cny = -2105 and jpy = -210500 and gbp = -1473.5 and eur = -233655 and  hkd = -1894.5','')")

    con:query("insert into check_sql values(-2104,'delete from transaction_total_check where cny = -2104 and jpy = -210400 and gbp = -1472.8 and eur = -233544 and  hkd = -1893.6','')")

    con:query("insert into check_sql values(-2103,'delete from transaction_total_check where cny = -2103 and jpy = -210300 and gbp = -1472.1 and eur = -233433 and  hkd = -1892.7','')")

    con:query("insert into check_sql values(-2102,'delete from transaction_total_check where cny = -2102 and jpy = -210200 and gbp = -1471.4 and eur = -233322 and  hkd = -1891.8','')")

    con:query("insert into check_sql values(-2101,'delete from transaction_total_check where cny = -2101 and jpy = -210100 and gbp = -1470.7 and eur = -233211 and  hkd = -1890.9','')")

    con:query("insert into check_sql values(-2100,'delete from transaction_total_check where cny = -2100 and jpy = -210000 and gbp = -1470.0 and eur = -233100 and  hkd = -1890.0','')")

    con:query("insert into check_sql values(-2099,'delete from transaction_total_check where cny = -2099 and jpy = -209900 and gbp = -1469.3 and eur = -232989 and  hkd = -1889.1','')")

    con:query("insert into check_sql values(-2098,'delete from transaction_total_check where cny = -2098 and jpy = -209800 and gbp = -1468.6 and eur = -232878 and  hkd = -1888.2','')")

    con:query("insert into check_sql values(-2097,'delete from transaction_total_check where cny = -2097 and jpy = -209700 and gbp = -1467.9 and eur = -232767 and  hkd = -1887.3','')")

    con:query("insert into check_sql values(-2096,'delete from transaction_total_check where cny = -2096 and jpy = -209600 and gbp = -1467.2 and eur = -232656 and  hkd = -1886.4','')")

    con:query("insert into check_sql values(-2095,'delete from transaction_total_check where cny = -2095 and jpy = -209500 and gbp = -1466.5 and eur = -232545 and  hkd = -1885.5','')")

    con:query("insert into check_sql values(-2094,'delete from transaction_total_check where cny = -2094 and jpy = -209400 and gbp = -1465.8 and eur = -232434 and  hkd = -1884.6','')")

    con:query("insert into check_sql values(-2093,'delete from transaction_total_check where cny = -2093 and jpy = -209300 and gbp = -1465.1 and eur = -232323 and  hkd = -1883.7','')")

    con:query("insert into check_sql values(-2092,'delete from transaction_total_check where cny = -2092 and jpy = -209200 and gbp = -1464.4 and eur = -232212 and  hkd = -1882.8','')")

    con:query("insert into check_sql values(-2091,'delete from transaction_total_check where cny = -2091 and jpy = -209100 and gbp = -1463.7 and eur = -232101 and  hkd = -1881.9','')")

    con:query("insert into check_sql values(-2090,'delete from transaction_total_check where cny = -2090 and jpy = -209000 and gbp = -1463.0 and eur = -231990 and  hkd = -1881.0','')")

    con:query("insert into check_sql values(-2089,'delete from transaction_total_check where cny = -2089 and jpy = -208900 and gbp = -1462.3 and eur = -231879 and  hkd = -1880.1','')")

    con:query("insert into check_sql values(-2088,'delete from transaction_total_check where cny = -2088 and jpy = -208800 and gbp = -1461.6 and eur = -231768 and  hkd = -1879.2','')")

    con:query("insert into check_sql values(-2087,'delete from transaction_total_check where cny = -2087 and jpy = -208700 and gbp = -1460.9 and eur = -231657 and  hkd = -1878.3','')")

    con:query("insert into check_sql values(-2086,'delete from transaction_total_check where cny = -2086 and jpy = -208600 and gbp = -1460.2 and eur = -231546 and  hkd = -1877.4','')")

    con:query("insert into check_sql values(-2085,'delete from transaction_total_check where cny = -2085 and jpy = -208500 and gbp = -1459.5 and eur = -231435 and  hkd = -1876.5','')")

    con:query("insert into check_sql values(-2084,'delete from transaction_total_check where cny = -2084 and jpy = -208400 and gbp = -1458.8 and eur = -231324 and  hkd = -1875.6','')")

    con:query("insert into check_sql values(-2083,'delete from transaction_total_check where cny = -2083 and jpy = -208300 and gbp = -1458.1 and eur = -231213 and  hkd = -1874.7','')")

    con:query("insert into check_sql values(-2082,'delete from transaction_total_check where cny = -2082 and jpy = -208200 and gbp = -1457.4 and eur = -231102 and  hkd = -1873.8','')")

    con:query("insert into check_sql values(-2081,'delete from transaction_total_check where cny = -2081 and jpy = -208100 and gbp = -1456.7 and eur = -230991 and  hkd = -1872.9','')")

    con:query("insert into check_sql values(-2080,'delete from transaction_total_check where cny = -2080 and jpy = -208000 and gbp = -1456.0 and eur = -230880 and  hkd = -1872.0','')")

    con:query("insert into check_sql values(-2079,'delete from transaction_total_check where cny = -2079 and jpy = -207900 and gbp = -1455.3 and eur = -230769 and  hkd = -1871.1','')")

    con:query("insert into check_sql values(-2078,'delete from transaction_total_check where cny = -2078 and jpy = -207800 and gbp = -1454.6 and eur = -230658 and  hkd = -1870.2','')")

    con:query("insert into check_sql values(-2077,'delete from transaction_total_check where cny = -2077 and jpy = -207700 and gbp = -1453.9 and eur = -230547 and  hkd = -1869.3','')")

    con:query("insert into check_sql values(-2076,'delete from transaction_total_check where cny = -2076 and jpy = -207600 and gbp = -1453.2 and eur = -230436 and  hkd = -1868.4','')")

    con:query("insert into check_sql values(-2075,'delete from transaction_total_check where cny = -2075 and jpy = -207500 and gbp = -1452.5 and eur = -230325 and  hkd = -1867.5','')")

    con:query("insert into check_sql values(-2074,'delete from transaction_total_check where cny = -2074 and jpy = -207400 and gbp = -1451.8 and eur = -230214 and  hkd = -1866.6','')")

    con:query("insert into check_sql values(-2073,'delete from transaction_total_check where cny = -2073 and jpy = -207300 and gbp = -1451.1 and eur = -230103 and  hkd = -1865.7','')")

    con:query("insert into check_sql values(-2072,'delete from transaction_total_check where cny = -2072 and jpy = -207200 and gbp = -1450.4 and eur = -229992 and  hkd = -1864.8','')")

    con:query("insert into check_sql values(-2071,'delete from transaction_total_check where cny = -2071 and jpy = -207100 and gbp = -1449.7 and eur = -229881 and  hkd = -1863.9','')")

    con:query("insert into check_sql values(-2070,'delete from transaction_total_check where cny = -2070 and jpy = -207000 and gbp = -1449.0 and eur = -229770 and  hkd = -1863.0','')")

    con:query("insert into check_sql values(-2069,'delete from transaction_total_check where cny = -2069 and jpy = -206900 and gbp = -1448.3 and eur = -229659 and  hkd = -1862.1','')")

    con:query("insert into check_sql values(-2068,'delete from transaction_total_check where cny = -2068 and jpy = -206800 and gbp = -1447.6 and eur = -229548 and  hkd = -1861.2','')")

    con:query("insert into check_sql values(-2067,'delete from transaction_total_check where cny = -2067 and jpy = -206700 and gbp = -1446.9 and eur = -229437 and  hkd = -1860.3','')")

    con:query("insert into check_sql values(-2066,'delete from transaction_total_check where cny = -2066 and jpy = -206600 and gbp = -1446.2 and eur = -229326 and  hkd = -1859.4','')")

    con:query("insert into check_sql values(-2065,'delete from transaction_total_check where cny = -2065 and jpy = -206500 and gbp = -1445.5 and eur = -229215 and  hkd = -1858.5','')")

    con:query("insert into check_sql values(-2064,'delete from transaction_total_check where cny = -2064 and jpy = -206400 and gbp = -1444.8 and eur = -229104 and  hkd = -1857.6','')")

    con:query("insert into check_sql values(-2063,'delete from transaction_total_check where cny = -2063 and jpy = -206300 and gbp = -1444.1 and eur = -228993 and  hkd = -1856.7','')")

    con:query("insert into check_sql values(-2062,'delete from transaction_total_check where cny = -2062 and jpy = -206200 and gbp = -1443.4 and eur = -228882 and  hkd = -1855.8','')")

    con:query("insert into check_sql values(-2061,'delete from transaction_total_check where cny = -2061 and jpy = -206100 and gbp = -1442.7 and eur = -228771 and  hkd = -1854.9','')")

    con:query("insert into check_sql values(-2060,'delete from transaction_total_check where cny = -2060 and jpy = -206000 and gbp = -1442.0 and eur = -228660 and  hkd = -1854.0','')")

    con:query("insert into check_sql values(-2059,'delete from transaction_total_check where cny = -2059 and jpy = -205900 and gbp = -1441.3 and eur = -228549 and  hkd = -1853.1','')")

    con:query("insert into check_sql values(-2058,'delete from transaction_total_check where cny = -2058 and jpy = -205800 and gbp = -1440.6 and eur = -228438 and  hkd = -1852.2','')")

    con:query("insert into check_sql values(-2057,'delete from transaction_total_check where cny = -2057 and jpy = -205700 and gbp = -1439.9 and eur = -228327 and  hkd = -1851.3','')")

    con:query("insert into check_sql values(-2056,'delete from transaction_total_check where cny = -2056 and jpy = -205600 and gbp = -1439.2 and eur = -228216 and  hkd = -1850.4','')")

    con:query("insert into check_sql values(-2055,'delete from transaction_total_check where cny = -2055 and jpy = -205500 and gbp = -1438.5 and eur = -228105 and  hkd = -1849.5','')")

    con:query("insert into check_sql values(-2054,'delete from transaction_total_check where cny = -2054 and jpy = -205400 and gbp = -1437.8 and eur = -227994 and  hkd = -1848.6','')")

    con:query("insert into check_sql values(-2053,'delete from transaction_total_check where cny = -2053 and jpy = -205300 and gbp = -1437.1 and eur = -227883 and  hkd = -1847.7','')")

    con:query("insert into check_sql values(-2052,'delete from transaction_total_check where cny = -2052 and jpy = -205200 and gbp = -1436.4 and eur = -227772 and  hkd = -1846.8','')")

    con:query("insert into check_sql values(-2051,'delete from transaction_total_check where cny = -2051 and jpy = -205100 and gbp = -1435.7 and eur = -227661 and  hkd = -1845.9','')")

    con:query("insert into check_sql values(-2050,'delete from transaction_total_check where cny = -2050 and jpy = -205000 and gbp = -1435.0 and eur = -227550 and  hkd = -1845.0','')")

    con:query("insert into check_sql values(-2049,'delete from transaction_total_check where cny = -2049 and jpy = -204900 and gbp = -1434.3 and eur = -227439 and  hkd = -1844.1','')")

    con:query("insert into check_sql values(-2048,'delete from transaction_total_check where cny = -2048 and jpy = -204800 and gbp = -1433.6 and eur = -227328 and  hkd = -1843.2','')")

    con:query("insert into check_sql values(-2047,'delete from transaction_total_check where cny = -2047 and jpy = -204700 and gbp = -1432.9 and eur = -227217 and  hkd = -1842.3','')")

    con:query("insert into check_sql values(-2046,'delete from transaction_total_check where cny = -2046 and jpy = -204600 and gbp = -1432.2 and eur = -227106 and  hkd = -1841.4','')")

    con:query("insert into check_sql values(-2045,'delete from transaction_total_check where cny = -2045 and jpy = -204500 and gbp = -1431.5 and eur = -226995 and  hkd = -1840.5','')")

    con:query("insert into check_sql values(-2044,'delete from transaction_total_check where cny = -2044 and jpy = -204400 and gbp = -1430.8 and eur = -226884 and  hkd = -1839.6','')")

    con:query("insert into check_sql values(-2043,'delete from transaction_total_check where cny = -2043 and jpy = -204300 and gbp = -1430.1 and eur = -226773 and  hkd = -1838.7','')")

    con:query("insert into check_sql values(-2042,'delete from transaction_total_check where cny = -2042 and jpy = -204200 and gbp = -1429.4 and eur = -226662 and  hkd = -1837.8','')")

    con:query("insert into check_sql values(-2041,'delete from transaction_total_check where cny = -2041 and jpy = -204100 and gbp = -1428.7 and eur = -226551 and  hkd = -1836.9','')")

    con:query("insert into check_sql values(-2040,'delete from transaction_total_check where cny = -2040 and jpy = -204000 and gbp = -1428.0 and eur = -226440 and  hkd = -1836.0','')")

    con:query("insert into check_sql values(-2039,'delete from transaction_total_check where cny = -2039 and jpy = -203900 and gbp = -1427.3 and eur = -226329 and  hkd = -1835.1','')")

    con:query("insert into check_sql values(-2038,'delete from transaction_total_check where cny = -2038 and jpy = -203800 and gbp = -1426.6 and eur = -226218 and  hkd = -1834.2','')")

    con:query("insert into check_sql values(-2037,'delete from transaction_total_check where cny = -2037 and jpy = -203700 and gbp = -1425.9 and eur = -226107 and  hkd = -1833.3','')")

    con:query("insert into check_sql values(-2036,'delete from transaction_total_check where cny = -2036 and jpy = -203600 and gbp = -1425.2 and eur = -225996 and  hkd = -1832.4','')")

    con:query("insert into check_sql values(-2035,'delete from transaction_total_check where cny = -2035 and jpy = -203500 and gbp = -1424.5 and eur = -225885 and  hkd = -1831.5','')")

    con:query("insert into check_sql values(-2034,'delete from transaction_total_check where cny = -2034 and jpy = -203400 and gbp = -1423.8 and eur = -225774 and  hkd = -1830.6','')")

    con:query("insert into check_sql values(-2033,'delete from transaction_total_check where cny = -2033 and jpy = -203300 and gbp = -1423.1 and eur = -225663 and  hkd = -1829.7','')")

    con:query("insert into check_sql values(-2032,'delete from transaction_total_check where cny = -2032 and jpy = -203200 and gbp = -1422.4 and eur = -225552 and  hkd = -1828.8','')")

    con:query("insert into check_sql values(-2031,'delete from transaction_total_check where cny = -2031 and jpy = -203100 and gbp = -1421.7 and eur = -225441 and  hkd = -1827.9','')")

    con:query("insert into check_sql values(-2030,'delete from transaction_total_check where cny = -2030 and jpy = -203000 and gbp = -1421.0 and eur = -225330 and  hkd = -1827.0','')")

    con:query("insert into check_sql values(-2029,'delete from transaction_total_check where cny = -2029 and jpy = -202900 and gbp = -1420.3 and eur = -225219 and  hkd = -1826.1','')")

    con:query("insert into check_sql values(-2028,'delete from transaction_total_check where cny = -2028 and jpy = -202800 and gbp = -1419.6 and eur = -225108 and  hkd = -1825.2','')")

    con:query("insert into check_sql values(-2027,'delete from transaction_total_check where cny = -2027 and jpy = -202700 and gbp = -1418.9 and eur = -224997 and  hkd = -1824.3','')")

    con:query("insert into check_sql values(-2026,'delete from transaction_total_check where cny = -2026 and jpy = -202600 and gbp = -1418.2 and eur = -224886 and  hkd = -1823.4','')")

    con:query("insert into check_sql values(-2025,'delete from transaction_total_check where cny = -2025 and jpy = -202500 and gbp = -1417.5 and eur = -224775 and  hkd = -1822.5','')")

    con:query("insert into check_sql values(-2024,'delete from transaction_total_check where cny = -2024 and jpy = -202400 and gbp = -1416.8 and eur = -224664 and  hkd = -1821.6','')")

    con:query("insert into check_sql values(-2023,'delete from transaction_total_check where cny = -2023 and jpy = -202300 and gbp = -1416.1 and eur = -224553 and  hkd = -1820.7','')")

    con:query("insert into check_sql values(-2022,'delete from transaction_total_check where cny = -2022 and jpy = -202200 and gbp = -1415.4 and eur = -224442 and  hkd = -1819.8','')")

    con:query("insert into check_sql values(-2021,'delete from transaction_total_check where cny = -2021 and jpy = -202100 and gbp = -1414.7 and eur = -224331 and  hkd = -1818.9','')")

    con:query("insert into check_sql values(-2020,'delete from transaction_total_check where cny = -2020 and jpy = -202000 and gbp = -1414.0 and eur = -224220 and  hkd = -1818.0','')")

    con:query("insert into check_sql values(-2019,'delete from transaction_total_check where cny = -2019 and jpy = -201900 and gbp = -1413.3 and eur = -224109 and  hkd = -1817.1','')")

    con:query("insert into check_sql values(-2018,'delete from transaction_total_check where cny = -2018 and jpy = -201800 and gbp = -1412.6 and eur = -223998 and  hkd = -1816.2','')")

    con:query("insert into check_sql values(-2017,'delete from transaction_total_check where cny = -2017 and jpy = -201700 and gbp = -1411.9 and eur = -223887 and  hkd = -1815.3','')")

    con:query("insert into check_sql values(-2016,'delete from transaction_total_check where cny = -2016 and jpy = -201600 and gbp = -1411.2 and eur = -223776 and  hkd = -1814.4','')")

    con:query("insert into check_sql values(-2015,'delete from transaction_total_check where cny = -2015 and jpy = -201500 and gbp = -1410.5 and eur = -223665 and  hkd = -1813.5','')")

    con:query("insert into check_sql values(-2014,'delete from transaction_total_check where cny = -2014 and jpy = -201400 and gbp = -1409.8 and eur = -223554 and  hkd = -1812.6','')")

    con:query("insert into check_sql values(-2013,'delete from transaction_total_check where cny = -2013 and jpy = -201300 and gbp = -1409.1 and eur = -223443 and  hkd = -1811.7','')")

    con:query("insert into check_sql values(-2012,'delete from transaction_total_check where cny = -2012 and jpy = -201200 and gbp = -1408.4 and eur = -223332 and  hkd = -1810.8','')")

    con:query("insert into check_sql values(-2011,'delete from transaction_total_check where cny = -2011 and jpy = -201100 and gbp = -1407.7 and eur = -223221 and  hkd = -1809.9','')")

    con:query("insert into check_sql values(-2010,'delete from transaction_total_check where cny = -2010 and jpy = -201000 and gbp = -1407.0 and eur = -223110 and  hkd = -1809.0','')")

    con:query("insert into check_sql values(-2009,'delete from transaction_total_check where cny = -2009 and jpy = -200900 and gbp = -1406.3 and eur = -222999 and  hkd = -1808.1','')")

    con:query("insert into check_sql values(-2008,'delete from transaction_total_check where cny = -2008 and jpy = -200800 and gbp = -1405.6 and eur = -222888 and  hkd = -1807.2','')")

    con:query("insert into check_sql values(-2007,'delete from transaction_total_check where cny = -2007 and jpy = -200700 and gbp = -1404.9 and eur = -222777 and  hkd = -1806.3','')")

    con:query("insert into check_sql values(-2006,'delete from transaction_total_check where cny = -2006 and jpy = -200600 and gbp = -1404.2 and eur = -222666 and  hkd = -1805.4','')")

    con:query("insert into check_sql values(-2005,'delete from transaction_total_check where cny = -2005 and jpy = -200500 and gbp = -1403.5 and eur = -222555 and  hkd = -1804.5','')")

    con:query("insert into check_sql values(-2004,'delete from transaction_total_check where cny = -2004 and jpy = -200400 and gbp = -1402.8 and eur = -222444 and  hkd = -1803.6','')")

    con:query("insert into check_sql values(-2003,'delete from transaction_total_check where cny = -2003 and jpy = -200300 and gbp = -1402.1 and eur = -222333 and  hkd = -1802.7','')")

    con:query("insert into check_sql values(-2002,'delete from transaction_total_check where cny = -2002 and jpy = -200200 and gbp = -1401.4 and eur = -222222 and  hkd = -1801.8','')")

    con:query("insert into check_sql values(-2001,'delete from transaction_total_check where cny = -2001 and jpy = -200100 and gbp = -1400.7 and eur = -222111 and  hkd = -1800.9','')")

    con:query("insert into check_sql values(-2000,'delete from transaction_total_check where cny = -2000 and jpy = -200000 and gbp = -1400.0 and eur = -222000 and  hkd = -1800.0','')")

    con:query("insert into check_sql values(-1999,'delete from transaction_total_check where cny = -1999 and jpy = -199900 and gbp = -1399.3 and eur = -221889 and  hkd = -1799.1','')")

    con:query("insert into check_sql values(-1998,'delete from transaction_total_check where cny = -1998 and jpy = -199800 and gbp = -1398.6 and eur = -221778 and  hkd = -1798.2','')")

    con:query("insert into check_sql values(-1997,'delete from transaction_total_check where cny = -1997 and jpy = -199700 and gbp = -1397.9 and eur = -221667 and  hkd = -1797.3','')")

    con:query("insert into check_sql values(-1996,'delete from transaction_total_check where cny = -1996 and jpy = -199600 and gbp = -1397.2 and eur = -221556 and  hkd = -1796.4','')")

    con:query("insert into check_sql values(-1995,'delete from transaction_total_check where cny = -1995 and jpy = -199500 and gbp = -1396.5 and eur = -221445 and  hkd = -1795.5','')")

    con:query("insert into check_sql values(-1994,'delete from transaction_total_check where cny = -1994 and jpy = -199400 and gbp = -1395.8 and eur = -221334 and  hkd = -1794.6','')")

    con:query("insert into check_sql values(-1993,'delete from transaction_total_check where cny = -1993 and jpy = -199300 and gbp = -1395.1 and eur = -221223 and  hkd = -1793.7','')")

    con:query("insert into check_sql values(-1992,'delete from transaction_total_check where cny = -1992 and jpy = -199200 and gbp = -1394.4 and eur = -221112 and  hkd = -1792.8','')")

    con:query("insert into check_sql values(-1991,'delete from transaction_total_check where cny = -1991 and jpy = -199100 and gbp = -1393.7 and eur = -221001 and  hkd = -1791.9','')")

    con:query("insert into check_sql values(-1990,'delete from transaction_total_check where cny = -1990 and jpy = -199000 and gbp = -1393.0 and eur = -220890 and  hkd = -1791.0','')")

    con:query("insert into check_sql values(-1989,'delete from transaction_total_check where cny = -1989 and jpy = -198900 and gbp = -1392.3 and eur = -220779 and  hkd = -1790.1','')")

    con:query("insert into check_sql values(-1988,'delete from transaction_total_check where cny = -1988 and jpy = -198800 and gbp = -1391.6 and eur = -220668 and  hkd = -1789.2','')")

    con:query("insert into check_sql values(-1987,'delete from transaction_total_check where cny = -1987 and jpy = -198700 and gbp = -1390.9 and eur = -220557 and  hkd = -1788.3','')")

    con:query("insert into check_sql values(-1986,'delete from transaction_total_check where cny = -1986 and jpy = -198600 and gbp = -1390.2 and eur = -220446 and  hkd = -1787.4','')")

    con:query("insert into check_sql values(-1985,'delete from transaction_total_check where cny = -1985 and jpy = -198500 and gbp = -1389.5 and eur = -220335 and  hkd = -1786.5','')")

    con:query("insert into check_sql values(-1984,'delete from transaction_total_check where cny = -1984 and jpy = -198400 and gbp = -1388.8 and eur = -220224 and  hkd = -1785.6','')")

    con:query("insert into check_sql values(-1983,'delete from transaction_total_check where cny = -1983 and jpy = -198300 and gbp = -1388.1 and eur = -220113 and  hkd = -1784.7','')")

    con:query("insert into check_sql values(-1982,'delete from transaction_total_check where cny = -1982 and jpy = -198200 and gbp = -1387.4 and eur = -220002 and  hkd = -1783.8','')")

    con:query("insert into check_sql values(-1981,'delete from transaction_total_check where cny = -1981 and jpy = -198100 and gbp = -1386.7 and eur = -219891 and  hkd = -1782.9','')")

    con:query("insert into check_sql values(-1980,'delete from transaction_total_check where cny = -1980 and jpy = -198000 and gbp = -1386.0 and eur = -219780 and  hkd = -1782.0','')")

    con:query("insert into check_sql values(-1979,'delete from transaction_total_check where cny = -1979 and jpy = -197900 and gbp = -1385.3 and eur = -219669 and  hkd = -1781.1','')")

    con:query("insert into check_sql values(-1978,'delete from transaction_total_check where cny = -1978 and jpy = -197800 and gbp = -1384.6 and eur = -219558 and  hkd = -1780.2','')")

    con:query("insert into check_sql values(-1977,'delete from transaction_total_check where cny = -1977 and jpy = -197700 and gbp = -1383.9 and eur = -219447 and  hkd = -1779.3','')")

    con:query("insert into check_sql values(-1976,'delete from transaction_total_check where cny = -1976 and jpy = -197600 and gbp = -1383.2 and eur = -219336 and  hkd = -1778.4','')")

    con:query("insert into check_sql values(-1975,'delete from transaction_total_check where cny = -1975 and jpy = -197500 and gbp = -1382.5 and eur = -219225 and  hkd = -1777.5','')")

    con:query("insert into check_sql values(-1974,'delete from transaction_total_check where cny = -1974 and jpy = -197400 and gbp = -1381.8 and eur = -219114 and  hkd = -1776.6','')")

    con:query("insert into check_sql values(-1973,'delete from transaction_total_check where cny = -1973 and jpy = -197300 and gbp = -1381.1 and eur = -219003 and  hkd = -1775.7','')")

    con:query("insert into check_sql values(-1972,'delete from transaction_total_check where cny = -1972 and jpy = -197200 and gbp = -1380.4 and eur = -218892 and  hkd = -1774.8','')")

    con:query("insert into check_sql values(-1971,'delete from transaction_total_check where cny = -1971 and jpy = -197100 and gbp = -1379.7 and eur = -218781 and  hkd = -1773.9','')")

    con:query("insert into check_sql values(-1970,'delete from transaction_total_check where cny = -1970 and jpy = -197000 and gbp = -1379.0 and eur = -218670 and  hkd = -1773.0','')")

    con:query("insert into check_sql values(-1969,'delete from transaction_total_check where cny = -1969 and jpy = -196900 and gbp = -1378.3 and eur = -218559 and  hkd = -1772.1','')")

    con:query("insert into check_sql values(-1968,'delete from transaction_total_check where cny = -1968 and jpy = -196800 and gbp = -1377.6 and eur = -218448 and  hkd = -1771.2','')")

    con:query("insert into check_sql values(-1967,'delete from transaction_total_check where cny = -1967 and jpy = -196700 and gbp = -1376.9 and eur = -218337 and  hkd = -1770.3','')")

    con:query("insert into check_sql values(-1966,'delete from transaction_total_check where cny = -1966 and jpy = -196600 and gbp = -1376.2 and eur = -218226 and  hkd = -1769.4','')")

    con:query("insert into check_sql values(-1965,'delete from transaction_total_check where cny = -1965 and jpy = -196500 and gbp = -1375.5 and eur = -218115 and  hkd = -1768.5','')")

    con:query("insert into check_sql values(-1964,'delete from transaction_total_check where cny = -1964 and jpy = -196400 and gbp = -1374.8 and eur = -218004 and  hkd = -1767.6','')")

    con:query("insert into check_sql values(-1963,'delete from transaction_total_check where cny = -1963 and jpy = -196300 and gbp = -1374.1 and eur = -217893 and  hkd = -1766.7','')")

    con:query("insert into check_sql values(-1962,'delete from transaction_total_check where cny = -1962 and jpy = -196200 and gbp = -1373.4 and eur = -217782 and  hkd = -1765.8','')")

    con:query("insert into check_sql values(-1961,'delete from transaction_total_check where cny = -1961 and jpy = -196100 and gbp = -1372.7 and eur = -217671 and  hkd = -1764.9','')")

    con:query("insert into check_sql values(-1960,'delete from transaction_total_check where cny = -1960 and jpy = -196000 and gbp = -1372.0 and eur = -217560 and  hkd = -1764.0','')")

    con:query("insert into check_sql values(-1959,'delete from transaction_total_check where cny = -1959 and jpy = -195900 and gbp = -1371.3 and eur = -217449 and  hkd = -1763.1','')")

    con:query("insert into check_sql values(-1958,'delete from transaction_total_check where cny = -1958 and jpy = -195800 and gbp = -1370.6 and eur = -217338 and  hkd = -1762.2','')")

    con:query("insert into check_sql values(-1957,'delete from transaction_total_check where cny = -1957 and jpy = -195700 and gbp = -1369.9 and eur = -217227 and  hkd = -1761.3','')")

    con:query("insert into check_sql values(-1956,'delete from transaction_total_check where cny = -1956 and jpy = -195600 and gbp = -1369.2 and eur = -217116 and  hkd = -1760.4','')")

    con:query("insert into check_sql values(-1955,'delete from transaction_total_check where cny = -1955 and jpy = -195500 and gbp = -1368.5 and eur = -217005 and  hkd = -1759.5','')")

    con:query("insert into check_sql values(-1954,'delete from transaction_total_check where cny = -1954 and jpy = -195400 and gbp = -1367.8 and eur = -216894 and  hkd = -1758.6','')")

    con:query("insert into check_sql values(-1953,'delete from transaction_total_check where cny = -1953 and jpy = -195300 and gbp = -1367.1 and eur = -216783 and  hkd = -1757.7','')")

    con:query("insert into check_sql values(-1952,'delete from transaction_total_check where cny = -1952 and jpy = -195200 and gbp = -1366.4 and eur = -216672 and  hkd = -1756.8','')")

    con:query("insert into check_sql values(-1951,'delete from transaction_total_check where cny = -1951 and jpy = -195100 and gbp = -1365.7 and eur = -216561 and  hkd = -1755.9','')")

    con:query("insert into check_sql values(-1950,'delete from transaction_total_check where cny = -1950 and jpy = -195000 and gbp = -1365.0 and eur = -216450 and  hkd = -1755.0','')")

    con:query("insert into check_sql values(-1949,'delete from transaction_total_check where cny = -1949 and jpy = -194900 and gbp = -1364.3 and eur = -216339 and  hkd = -1754.1','')")

    con:query("insert into check_sql values(-1948,'delete from transaction_total_check where cny = -1948 and jpy = -194800 and gbp = -1363.6 and eur = -216228 and  hkd = -1753.2','')")

    con:query("insert into check_sql values(-1947,'delete from transaction_total_check where cny = -1947 and jpy = -194700 and gbp = -1362.9 and eur = -216117 and  hkd = -1752.3','')")

    con:query("insert into check_sql values(-1946,'delete from transaction_total_check where cny = -1946 and jpy = -194600 and gbp = -1362.2 and eur = -216006 and  hkd = -1751.4','')")

    con:query("insert into check_sql values(-1945,'delete from transaction_total_check where cny = -1945 and jpy = -194500 and gbp = -1361.5 and eur = -215895 and  hkd = -1750.5','')")

    con:query("insert into check_sql values(-1944,'delete from transaction_total_check where cny = -1944 and jpy = -194400 and gbp = -1360.8 and eur = -215784 and  hkd = -1749.6','')")

    con:query("insert into check_sql values(-1943,'delete from transaction_total_check where cny = -1943 and jpy = -194300 and gbp = -1360.1 and eur = -215673 and  hkd = -1748.7','')")

    con:query("insert into check_sql values(-1942,'delete from transaction_total_check where cny = -1942 and jpy = -194200 and gbp = -1359.4 and eur = -215562 and  hkd = -1747.8','')")

    con:query("insert into check_sql values(-1941,'delete from transaction_total_check where cny = -1941 and jpy = -194100 and gbp = -1358.7 and eur = -215451 and  hkd = -1746.9','')")

    con:query("insert into check_sql values(-1940,'delete from transaction_total_check where cny = -1940 and jpy = -194000 and gbp = -1358.0 and eur = -215340 and  hkd = -1746.0','')")

    con:query("insert into check_sql values(-1939,'delete from transaction_total_check where cny = -1939 and jpy = -193900 and gbp = -1357.3 and eur = -215229 and  hkd = -1745.1','')")

    con:query("insert into check_sql values(-1938,'delete from transaction_total_check where cny = -1938 and jpy = -193800 and gbp = -1356.6 and eur = -215118 and  hkd = -1744.2','')")

    con:query("insert into check_sql values(-1937,'delete from transaction_total_check where cny = -1937 and jpy = -193700 and gbp = -1355.9 and eur = -215007 and  hkd = -1743.3','')")

    con:query("insert into check_sql values(-1936,'delete from transaction_total_check where cny = -1936 and jpy = -193600 and gbp = -1355.2 and eur = -214896 and  hkd = -1742.4','')")

    con:query("insert into check_sql values(-1935,'delete from transaction_total_check where cny = -1935 and jpy = -193500 and gbp = -1354.5 and eur = -214785 and  hkd = -1741.5','')")

    con:query("insert into check_sql values(-1934,'delete from transaction_total_check where cny = -1934 and jpy = -193400 and gbp = -1353.8 and eur = -214674 and  hkd = -1740.6','')")

    con:query("insert into check_sql values(-1933,'delete from transaction_total_check where cny = -1933 and jpy = -193300 and gbp = -1353.1 and eur = -214563 and  hkd = -1739.7','')")

    con:query("insert into check_sql values(-1932,'delete from transaction_total_check where cny = -1932 and jpy = -193200 and gbp = -1352.4 and eur = -214452 and  hkd = -1738.8','')")

    con:query("insert into check_sql values(-1931,'delete from transaction_total_check where cny = -1931 and jpy = -193100 and gbp = -1351.7 and eur = -214341 and  hkd = -1737.9','')")

    con:query("insert into check_sql values(-1930,'delete from transaction_total_check where cny = -1930 and jpy = -193000 and gbp = -1351.0 and eur = -214230 and  hkd = -1737.0','')")

    con:query("insert into check_sql values(-1929,'delete from transaction_total_check where cny = -1929 and jpy = -192900 and gbp = -1350.3 and eur = -214119 and  hkd = -1736.1','')")

    con:query("insert into check_sql values(-1928,'delete from transaction_total_check where cny = -1928 and jpy = -192800 and gbp = -1349.6 and eur = -214008 and  hkd = -1735.2','')")

    con:query("insert into check_sql values(-1927,'delete from transaction_total_check where cny = -1927 and jpy = -192700 and gbp = -1348.9 and eur = -213897 and  hkd = -1734.3','')")

    con:query("insert into check_sql values(-1926,'delete from transaction_total_check where cny = -1926 and jpy = -192600 and gbp = -1348.2 and eur = -213786 and  hkd = -1733.4','')")

    con:query("insert into check_sql values(-1925,'delete from transaction_total_check where cny = -1925 and jpy = -192500 and gbp = -1347.5 and eur = -213675 and  hkd = -1732.5','')")

    con:query("insert into check_sql values(-1924,'delete from transaction_total_check where cny = -1924 and jpy = -192400 and gbp = -1346.8 and eur = -213564 and  hkd = -1731.6','')")

    con:query("insert into check_sql values(-1923,'delete from transaction_total_check where cny = -1923 and jpy = -192300 and gbp = -1346.1 and eur = -213453 and  hkd = -1730.7','')")

    con:query("insert into check_sql values(-1922,'delete from transaction_total_check where cny = -1922 and jpy = -192200 and gbp = -1345.4 and eur = -213342 and  hkd = -1729.8','')")

    con:query("insert into check_sql values(-1921,'delete from transaction_total_check where cny = -1921 and jpy = -192100 and gbp = -1344.7 and eur = -213231 and  hkd = -1728.9','')")

    con:query("insert into check_sql values(-1920,'delete from transaction_total_check where cny = -1920 and jpy = -192000 and gbp = -1344.0 and eur = -213120 and  hkd = -1728.0','')")

    con:query("insert into check_sql values(-1919,'delete from transaction_total_check where cny = -1919 and jpy = -191900 and gbp = -1343.3 and eur = -213009 and  hkd = -1727.1','')")

    con:query("insert into check_sql values(-1918,'delete from transaction_total_check where cny = -1918 and jpy = -191800 and gbp = -1342.6 and eur = -212898 and  hkd = -1726.2','')")

    con:query("insert into check_sql values(-1917,'delete from transaction_total_check where cny = -1917 and jpy = -191700 and gbp = -1341.9 and eur = -212787 and  hkd = -1725.3','')")

    con:query("insert into check_sql values(-1916,'delete from transaction_total_check where cny = -1916 and jpy = -191600 and gbp = -1341.2 and eur = -212676 and  hkd = -1724.4','')")

    con:query("insert into check_sql values(-1915,'delete from transaction_total_check where cny = -1915 and jpy = -191500 and gbp = -1340.5 and eur = -212565 and  hkd = -1723.5','')")

    con:query("insert into check_sql values(-1914,'delete from transaction_total_check where cny = -1914 and jpy = -191400 and gbp = -1339.8 and eur = -212454 and  hkd = -1722.6','')")

    con:query("insert into check_sql values(-1913,'delete from transaction_total_check where cny = -1913 and jpy = -191300 and gbp = -1339.1 and eur = -212343 and  hkd = -1721.7','')")

    con:query("insert into check_sql values(-1912,'delete from transaction_total_check where cny = -1912 and jpy = -191200 and gbp = -1338.4 and eur = -212232 and  hkd = -1720.8','')")

    con:query("insert into check_sql values(-1911,'delete from transaction_total_check where cny = -1911 and jpy = -191100 and gbp = -1337.7 and eur = -212121 and  hkd = -1719.9','')")

    con:query("insert into check_sql values(-1910,'delete from transaction_total_check where cny = -1910 and jpy = -191000 and gbp = -1337.0 and eur = -212010 and  hkd = -1719.0','')")

    con:query("insert into check_sql values(-1909,'delete from transaction_total_check where cny = -1909 and jpy = -190900 and gbp = -1336.3 and eur = -211899 and  hkd = -1718.1','')")

    con:query("insert into check_sql values(-1908,'delete from transaction_total_check where cny = -1908 and jpy = -190800 and gbp = -1335.6 and eur = -211788 and  hkd = -1717.2','')")

    con:query("insert into check_sql values(-1907,'delete from transaction_total_check where cny = -1907 and jpy = -190700 and gbp = -1334.9 and eur = -211677 and  hkd = -1716.3','')")

    con:query("insert into check_sql values(-1906,'delete from transaction_total_check where cny = -1906 and jpy = -190600 and gbp = -1334.2 and eur = -211566 and  hkd = -1715.4','')")

    con:query("insert into check_sql values(-1905,'delete from transaction_total_check where cny = -1905 and jpy = -190500 and gbp = -1333.5 and eur = -211455 and  hkd = -1714.5','')")

    con:query("insert into check_sql values(-1904,'delete from transaction_total_check where cny = -1904 and jpy = -190400 and gbp = -1332.8 and eur = -211344 and  hkd = -1713.6','')")

    con:query("insert into check_sql values(-1903,'delete from transaction_total_check where cny = -1903 and jpy = -190300 and gbp = -1332.1 and eur = -211233 and  hkd = -1712.7','')")

    con:query("insert into check_sql values(-1902,'delete from transaction_total_check where cny = -1902 and jpy = -190200 and gbp = -1331.4 and eur = -211122 and  hkd = -1711.8','')")

    con:query("insert into check_sql values(-1901,'delete from transaction_total_check where cny = -1901 and jpy = -190100 and gbp = -1330.7 and eur = -211011 and  hkd = -1710.9','')")

    con:query("insert into check_sql values(-1900,'delete from transaction_total_check where cny = -1900 and jpy = -190000 and gbp = -1330.0 and eur = -210900 and  hkd = -1710.0','')")

    con:query("insert into check_sql values(-1899,'delete from transaction_total_check where cny = -1899 and jpy = -189900 and gbp = -1329.3 and eur = -210789 and  hkd = -1709.1','')")

    con:query("insert into check_sql values(-1898,'delete from transaction_total_check where cny = -1898 and jpy = -189800 and gbp = -1328.6 and eur = -210678 and  hkd = -1708.2','')")

    con:query("insert into check_sql values(-1897,'delete from transaction_total_check where cny = -1897 and jpy = -189700 and gbp = -1327.9 and eur = -210567 and  hkd = -1707.3','')")

    con:query("insert into check_sql values(-1896,'delete from transaction_total_check where cny = -1896 and jpy = -189600 and gbp = -1327.2 and eur = -210456 and  hkd = -1706.4','')")

    con:query("insert into check_sql values(-1895,'delete from transaction_total_check where cny = -1895 and jpy = -189500 and gbp = -1326.5 and eur = -210345 and  hkd = -1705.5','')")

    con:query("insert into check_sql values(-1894,'delete from transaction_total_check where cny = -1894 and jpy = -189400 and gbp = -1325.8 and eur = -210234 and  hkd = -1704.6','')")

    con:query("insert into check_sql values(-1893,'delete from transaction_total_check where cny = -1893 and jpy = -189300 and gbp = -1325.1 and eur = -210123 and  hkd = -1703.7','')")

    con:query("insert into check_sql values(-1892,'delete from transaction_total_check where cny = -1892 and jpy = -189200 and gbp = -1324.4 and eur = -210012 and  hkd = -1702.8','')")

    con:query("insert into check_sql values(-1891,'delete from transaction_total_check where cny = -1891 and jpy = -189100 and gbp = -1323.7 and eur = -209901 and  hkd = -1701.9','')")

    con:query("insert into check_sql values(-1890,'delete from transaction_total_check where cny = -1890 and jpy = -189000 and gbp = -1323.0 and eur = -209790 and  hkd = -1701.0','')")

    con:query("insert into check_sql values(-1889,'delete from transaction_total_check where cny = -1889 and jpy = -188900 and gbp = -1322.3 and eur = -209679 and  hkd = -1700.1','')")

    con:query("insert into check_sql values(-1888,'delete from transaction_total_check where cny = -1888 and jpy = -188800 and gbp = -1321.6 and eur = -209568 and  hkd = -1699.2','')")

    con:query("insert into check_sql values(-1887,'delete from transaction_total_check where cny = -1887 and jpy = -188700 and gbp = -1320.9 and eur = -209457 and  hkd = -1698.3','')")

    con:query("insert into check_sql values(-1886,'delete from transaction_total_check where cny = -1886 and jpy = -188600 and gbp = -1320.2 and eur = -209346 and  hkd = -1697.4','')")

    con:query("insert into check_sql values(-1885,'delete from transaction_total_check where cny = -1885 and jpy = -188500 and gbp = -1319.5 and eur = -209235 and  hkd = -1696.5','')")

    con:query("insert into check_sql values(-1884,'delete from transaction_total_check where cny = -1884 and jpy = -188400 and gbp = -1318.8 and eur = -209124 and  hkd = -1695.6','')")

    con:query("insert into check_sql values(-1883,'delete from transaction_total_check where cny = -1883 and jpy = -188300 and gbp = -1318.1 and eur = -209013 and  hkd = -1694.7','')")

    con:query("insert into check_sql values(-1882,'delete from transaction_total_check where cny = -1882 and jpy = -188200 and gbp = -1317.4 and eur = -208902 and  hkd = -1693.8','')")

    con:query("insert into check_sql values(-1881,'delete from transaction_total_check where cny = -1881 and jpy = -188100 and gbp = -1316.7 and eur = -208791 and  hkd = -1692.9','')")

    con:query("insert into check_sql values(-1880,'delete from transaction_total_check where cny = -1880 and jpy = -188000 and gbp = -1316.0 and eur = -208680 and  hkd = -1692.0','')")

    con:query("insert into check_sql values(-1879,'delete from transaction_total_check where cny = -1879 and jpy = -187900 and gbp = -1315.3 and eur = -208569 and  hkd = -1691.1','')")

    con:query("insert into check_sql values(-1878,'delete from transaction_total_check where cny = -1878 and jpy = -187800 and gbp = -1314.6 and eur = -208458 and  hkd = -1690.2','')")

    con:query("insert into check_sql values(-1877,'delete from transaction_total_check where cny = -1877 and jpy = -187700 and gbp = -1313.9 and eur = -208347 and  hkd = -1689.3','')")

    con:query("insert into check_sql values(-1876,'delete from transaction_total_check where cny = -1876 and jpy = -187600 and gbp = -1313.2 and eur = -208236 and  hkd = -1688.4','')")

    con:query("insert into check_sql values(-1875,'delete from transaction_total_check where cny = -1875 and jpy = -187500 and gbp = -1312.5 and eur = -208125 and  hkd = -1687.5','')")

    con:query("insert into check_sql values(-1874,'delete from transaction_total_check where cny = -1874 and jpy = -187400 and gbp = -1311.8 and eur = -208014 and  hkd = -1686.6','')")

    con:query("insert into check_sql values(-1873,'delete from transaction_total_check where cny = -1873 and jpy = -187300 and gbp = -1311.1 and eur = -207903 and  hkd = -1685.7','')")

    con:query("insert into check_sql values(-1872,'delete from transaction_total_check where cny = -1872 and jpy = -187200 and gbp = -1310.4 and eur = -207792 and  hkd = -1684.8','')")

    con:query("insert into check_sql values(-1871,'delete from transaction_total_check where cny = -1871 and jpy = -187100 and gbp = -1309.7 and eur = -207681 and  hkd = -1683.9','')")

    con:query("insert into check_sql values(-1870,'delete from transaction_total_check where cny = -1870 and jpy = -187000 and gbp = -1309.0 and eur = -207570 and  hkd = -1683.0','')")

    con:query("insert into check_sql values(-1869,'delete from transaction_total_check where cny = -1869 and jpy = -186900 and gbp = -1308.3 and eur = -207459 and  hkd = -1682.1','')")

    con:query("insert into check_sql values(-1868,'delete from transaction_total_check where cny = -1868 and jpy = -186800 and gbp = -1307.6 and eur = -207348 and  hkd = -1681.2','')")

    con:query("insert into check_sql values(-1867,'delete from transaction_total_check where cny = -1867 and jpy = -186700 and gbp = -1306.9 and eur = -207237 and  hkd = -1680.3','')")

    con:query("insert into check_sql values(-1866,'delete from transaction_total_check where cny = -1866 and jpy = -186600 and gbp = -1306.2 and eur = -207126 and  hkd = -1679.4','')")

    con:query("insert into check_sql values(-1865,'delete from transaction_total_check where cny = -1865 and jpy = -186500 and gbp = -1305.5 and eur = -207015 and  hkd = -1678.5','')")

    con:query("insert into check_sql values(-1864,'delete from transaction_total_check where cny = -1864 and jpy = -186400 and gbp = -1304.8 and eur = -206904 and  hkd = -1677.6','')")

    con:query("insert into check_sql values(-1863,'delete from transaction_total_check where cny = -1863 and jpy = -186300 and gbp = -1304.1 and eur = -206793 and  hkd = -1676.7','')")

    con:query("insert into check_sql values(-1862,'delete from transaction_total_check where cny = -1862 and jpy = -186200 and gbp = -1303.4 and eur = -206682 and  hkd = -1675.8','')")

    con:query("insert into check_sql values(-1861,'delete from transaction_total_check where cny = -1861 and jpy = -186100 and gbp = -1302.7 and eur = -206571 and  hkd = -1674.9','')")

    con:query("insert into check_sql values(-1860,'delete from transaction_total_check where cny = -1860 and jpy = -186000 and gbp = -1302.0 and eur = -206460 and  hkd = -1674.0','')")

    con:query("insert into check_sql values(-1859,'delete from transaction_total_check where cny = -1859 and jpy = -185900 and gbp = -1301.3 and eur = -206349 and  hkd = -1673.1','')")

    con:query("insert into check_sql values(-1858,'delete from transaction_total_check where cny = -1858 and jpy = -185800 and gbp = -1300.6 and eur = -206238 and  hkd = -1672.2','')")

    con:query("insert into check_sql values(-1857,'delete from transaction_total_check where cny = -1857 and jpy = -185700 and gbp = -1299.9 and eur = -206127 and  hkd = -1671.3','')")

    con:query("insert into check_sql values(-1856,'delete from transaction_total_check where cny = -1856 and jpy = -185600 and gbp = -1299.2 and eur = -206016 and  hkd = -1670.4','')")

    con:query("insert into check_sql values(-1855,'delete from transaction_total_check where cny = -1855 and jpy = -185500 and gbp = -1298.5 and eur = -205905 and  hkd = -1669.5','')")

    con:query("insert into check_sql values(-1854,'delete from transaction_total_check where cny = -1854 and jpy = -185400 and gbp = -1297.8 and eur = -205794 and  hkd = -1668.6','')")

    con:query("insert into check_sql values(-1853,'delete from transaction_total_check where cny = -1853 and jpy = -185300 and gbp = -1297.1 and eur = -205683 and  hkd = -1667.7','')")

    con:query("insert into check_sql values(-1852,'delete from transaction_total_check where cny = -1852 and jpy = -185200 and gbp = -1296.4 and eur = -205572 and  hkd = -1666.8','')")

    con:query("insert into check_sql values(-1851,'delete from transaction_total_check where cny = -1851 and jpy = -185100 and gbp = -1295.7 and eur = -205461 and  hkd = -1665.9','')")

    con:query("insert into check_sql values(-1850,'delete from transaction_total_check where cny = -1850 and jpy = -185000 and gbp = -1295.0 and eur = -205350 and  hkd = -1665.0','')")

    con:query("insert into check_sql values(-1849,'delete from transaction_total_check where cny = -1849 and jpy = -184900 and gbp = -1294.3 and eur = -205239 and  hkd = -1664.1','')")

    con:query("insert into check_sql values(-1848,'delete from transaction_total_check where cny = -1848 and jpy = -184800 and gbp = -1293.6 and eur = -205128 and  hkd = -1663.2','')")

    con:query("insert into check_sql values(-1847,'delete from transaction_total_check where cny = -1847 and jpy = -184700 and gbp = -1292.9 and eur = -205017 and  hkd = -1662.3','')")

    con:query("insert into check_sql values(-1846,'delete from transaction_total_check where cny = -1846 and jpy = -184600 and gbp = -1292.2 and eur = -204906 and  hkd = -1661.4','')")

    con:query("insert into check_sql values(-1845,'delete from transaction_total_check where cny = -1845 and jpy = -184500 and gbp = -1291.5 and eur = -204795 and  hkd = -1660.5','')")

    con:query("insert into check_sql values(-1844,'delete from transaction_total_check where cny = -1844 and jpy = -184400 and gbp = -1290.8 and eur = -204684 and  hkd = -1659.6','')")

    con:query("insert into check_sql values(-1843,'delete from transaction_total_check where cny = -1843 and jpy = -184300 and gbp = -1290.1 and eur = -204573 and  hkd = -1658.7','')")

    con:query("insert into check_sql values(-1842,'delete from transaction_total_check where cny = -1842 and jpy = -184200 and gbp = -1289.4 and eur = -204462 and  hkd = -1657.8','')")

    con:query("insert into check_sql values(-1841,'delete from transaction_total_check where cny = -1841 and jpy = -184100 and gbp = -1288.7 and eur = -204351 and  hkd = -1656.9','')")

    con:query("insert into check_sql values(-1840,'delete from transaction_total_check where cny = -1840 and jpy = -184000 and gbp = -1288.0 and eur = -204240 and  hkd = -1656.0','')")

    con:query("insert into check_sql values(-1839,'delete from transaction_total_check where cny = -1839 and jpy = -183900 and gbp = -1287.3 and eur = -204129 and  hkd = -1655.1','')")

    con:query("insert into check_sql values(-1838,'delete from transaction_total_check where cny = -1838 and jpy = -183800 and gbp = -1286.6 and eur = -204018 and  hkd = -1654.2','')")

    con:query("insert into check_sql values(-1837,'delete from transaction_total_check where cny = -1837 and jpy = -183700 and gbp = -1285.9 and eur = -203907 and  hkd = -1653.3','')")

    con:query("insert into check_sql values(-1836,'delete from transaction_total_check where cny = -1836 and jpy = -183600 and gbp = -1285.2 and eur = -203796 and  hkd = -1652.4','')")

    con:query("insert into check_sql values(-1835,'delete from transaction_total_check where cny = -1835 and jpy = -183500 and gbp = -1284.5 and eur = -203685 and  hkd = -1651.5','')")

    con:query("insert into check_sql values(-1834,'delete from transaction_total_check where cny = -1834 and jpy = -183400 and gbp = -1283.8 and eur = -203574 and  hkd = -1650.6','')")

    con:query("insert into check_sql values(-1833,'delete from transaction_total_check where cny = -1833 and jpy = -183300 and gbp = -1283.1 and eur = -203463 and  hkd = -1649.7','')")

    con:query("insert into check_sql values(-1832,'delete from transaction_total_check where cny = -1832 and jpy = -183200 and gbp = -1282.4 and eur = -203352 and  hkd = -1648.8','')")

    con:query("insert into check_sql values(-1831,'delete from transaction_total_check where cny = -1831 and jpy = -183100 and gbp = -1281.7 and eur = -203241 and  hkd = -1647.9','')")

    con:query("insert into check_sql values(-1830,'delete from transaction_total_check where cny = -1830 and jpy = -183000 and gbp = -1281.0 and eur = -203130 and  hkd = -1647.0','')")

    con:query("insert into check_sql values(-1829,'delete from transaction_total_check where cny = -1829 and jpy = -182900 and gbp = -1280.3 and eur = -203019 and  hkd = -1646.1','')")

    con:query("insert into check_sql values(-1828,'delete from transaction_total_check where cny = -1828 and jpy = -182800 and gbp = -1279.6 and eur = -202908 and  hkd = -1645.2','')")

    con:query("insert into check_sql values(-1827,'delete from transaction_total_check where cny = -1827 and jpy = -182700 and gbp = -1278.9 and eur = -202797 and  hkd = -1644.3','')")

    con:query("insert into check_sql values(-1826,'delete from transaction_total_check where cny = -1826 and jpy = -182600 and gbp = -1278.2 and eur = -202686 and  hkd = -1643.4','')")

    con:query("insert into check_sql values(-1825,'delete from transaction_total_check where cny = -1825 and jpy = -182500 and gbp = -1277.5 and eur = -202575 and  hkd = -1642.5','')")

    con:query("insert into check_sql values(-1824,'delete from transaction_total_check where cny = -1824 and jpy = -182400 and gbp = -1276.8 and eur = -202464 and  hkd = -1641.6','')")

    con:query("insert into check_sql values(-1823,'delete from transaction_total_check where cny = -1823 and jpy = -182300 and gbp = -1276.1 and eur = -202353 and  hkd = -1640.7','')")

    con:query("insert into check_sql values(-1822,'delete from transaction_total_check where cny = -1822 and jpy = -182200 and gbp = -1275.4 and eur = -202242 and  hkd = -1639.8','')")

    con:query("insert into check_sql values(-1821,'delete from transaction_total_check where cny = -1821 and jpy = -182100 and gbp = -1274.7 and eur = -202131 and  hkd = -1638.9','')")

    con:query("insert into check_sql values(-1820,'delete from transaction_total_check where cny = -1820 and jpy = -182000 and gbp = -1274.0 and eur = -202020 and  hkd = -1638.0','')")

    con:query("insert into check_sql values(-1819,'delete from transaction_total_check where cny = -1819 and jpy = -181900 and gbp = -1273.3 and eur = -201909 and  hkd = -1637.1','')")

    con:query("insert into check_sql values(-1818,'delete from transaction_total_check where cny = -1818 and jpy = -181800 and gbp = -1272.6 and eur = -201798 and  hkd = -1636.2','')")

    con:query("insert into check_sql values(-1817,'delete from transaction_total_check where cny = -1817 and jpy = -181700 and gbp = -1271.9 and eur = -201687 and  hkd = -1635.3','')")

    con:query("insert into check_sql values(-1816,'delete from transaction_total_check where cny = -1816 and jpy = -181600 and gbp = -1271.2 and eur = -201576 and  hkd = -1634.4','')")

    con:query("insert into check_sql values(-1815,'delete from transaction_total_check where cny = -1815 and jpy = -181500 and gbp = -1270.5 and eur = -201465 and  hkd = -1633.5','')")

    con:query("insert into check_sql values(-1814,'delete from transaction_total_check where cny = -1814 and jpy = -181400 and gbp = -1269.8 and eur = -201354 and  hkd = -1632.6','')")

    con:query("insert into check_sql values(-1813,'delete from transaction_total_check where cny = -1813 and jpy = -181300 and gbp = -1269.1 and eur = -201243 and  hkd = -1631.7','')")

    con:query("insert into check_sql values(-1812,'delete from transaction_total_check where cny = -1812 and jpy = -181200 and gbp = -1268.4 and eur = -201132 and  hkd = -1630.8','')")

    con:query("insert into check_sql values(-1811,'delete from transaction_total_check where cny = -1811 and jpy = -181100 and gbp = -1267.7 and eur = -201021 and  hkd = -1629.9','')")

    con:query("insert into check_sql values(-1810,'delete from transaction_total_check where cny = -1810 and jpy = -181000 and gbp = -1267.0 and eur = -200910 and  hkd = -1629.0','')")

    con:query("insert into check_sql values(-1809,'delete from transaction_total_check where cny = -1809 and jpy = -180900 and gbp = -1266.3 and eur = -200799 and  hkd = -1628.1','')")

    con:query("insert into check_sql values(-1808,'delete from transaction_total_check where cny = -1808 and jpy = -180800 and gbp = -1265.6 and eur = -200688 and  hkd = -1627.2','')")

    con:query("insert into check_sql values(-1807,'delete from transaction_total_check where cny = -1807 and jpy = -180700 and gbp = -1264.9 and eur = -200577 and  hkd = -1626.3','')")

    con:query("insert into check_sql values(-1806,'delete from transaction_total_check where cny = -1806 and jpy = -180600 and gbp = -1264.2 and eur = -200466 and  hkd = -1625.4','')")

    con:query("insert into check_sql values(-1805,'delete from transaction_total_check where cny = -1805 and jpy = -180500 and gbp = -1263.5 and eur = -200355 and  hkd = -1624.5','')")

    con:query("insert into check_sql values(-1804,'delete from transaction_total_check where cny = -1804 and jpy = -180400 and gbp = -1262.8 and eur = -200244 and  hkd = -1623.6','')")

    con:query("insert into check_sql values(-1803,'delete from transaction_total_check where cny = -1803 and jpy = -180300 and gbp = -1262.1 and eur = -200133 and  hkd = -1622.7','')")

    con:query("insert into check_sql values(-1802,'delete from transaction_total_check where cny = -1802 and jpy = -180200 and gbp = -1261.4 and eur = -200022 and  hkd = -1621.8','')")

    con:query("insert into check_sql values(-1801,'delete from transaction_total_check where cny = -1801 and jpy = -180100 and gbp = -1260.7 and eur = -199911 and  hkd = -1620.9','')")

    con:query("insert into check_sql values(-1800,'delete from transaction_total_check where cny = -1800 and jpy = -180000 and gbp = -1260.0 and eur = -199800 and  hkd = -1620.0','')")

    con:query("insert into check_sql values(-1799,'delete from transaction_total_check where cny = -1799 and jpy = -179900 and gbp = -1259.3 and eur = -199689 and  hkd = -1619.1','')")

    con:query("insert into check_sql values(-1798,'delete from transaction_total_check where cny = -1798 and jpy = -179800 and gbp = -1258.6 and eur = -199578 and  hkd = -1618.2','')")

    con:query("insert into check_sql values(-1797,'delete from transaction_total_check where cny = -1797 and jpy = -179700 and gbp = -1257.9 and eur = -199467 and  hkd = -1617.3','')")

    con:query("insert into check_sql values(-1796,'delete from transaction_total_check where cny = -1796 and jpy = -179600 and gbp = -1257.2 and eur = -199356 and  hkd = -1616.4','')")

    con:query("insert into check_sql values(-1795,'delete from transaction_total_check where cny = -1795 and jpy = -179500 and gbp = -1256.5 and eur = -199245 and  hkd = -1615.5','')")

    con:query("insert into check_sql values(-1794,'delete from transaction_total_check where cny = -1794 and jpy = -179400 and gbp = -1255.8 and eur = -199134 and  hkd = -1614.6','')")

    con:query("insert into check_sql values(-1793,'delete from transaction_total_check where cny = -1793 and jpy = -179300 and gbp = -1255.1 and eur = -199023 and  hkd = -1613.7','')")

    con:query("insert into check_sql values(-1792,'delete from transaction_total_check where cny = -1792 and jpy = -179200 and gbp = -1254.4 and eur = -198912 and  hkd = -1612.8','')")

    con:query("insert into check_sql values(-1791,'delete from transaction_total_check where cny = -1791 and jpy = -179100 and gbp = -1253.7 and eur = -198801 and  hkd = -1611.9','')")

    con:query("insert into check_sql values(-1790,'delete from transaction_total_check where cny = -1790 and jpy = -179000 and gbp = -1253.0 and eur = -198690 and  hkd = -1611.0','')")

    con:query("insert into check_sql values(-1789,'delete from transaction_total_check where cny = -1789 and jpy = -178900 and gbp = -1252.3 and eur = -198579 and  hkd = -1610.1','')")

    con:query("insert into check_sql values(-1788,'delete from transaction_total_check where cny = -1788 and jpy = -178800 and gbp = -1251.6 and eur = -198468 and  hkd = -1609.2','')")

    con:query("insert into check_sql values(-1787,'delete from transaction_total_check where cny = -1787 and jpy = -178700 and gbp = -1250.9 and eur = -198357 and  hkd = -1608.3','')")

    con:query("insert into check_sql values(-1786,'delete from transaction_total_check where cny = -1786 and jpy = -178600 and gbp = -1250.2 and eur = -198246 and  hkd = -1607.4','')")

    con:query("insert into check_sql values(-1785,'delete from transaction_total_check where cny = -1785 and jpy = -178500 and gbp = -1249.5 and eur = -198135 and  hkd = -1606.5','')")

    con:query("insert into check_sql values(-1784,'delete from transaction_total_check where cny = -1784 and jpy = -178400 and gbp = -1248.8 and eur = -198024 and  hkd = -1605.6','')")

    con:query("insert into check_sql values(-1783,'delete from transaction_total_check where cny = -1783 and jpy = -178300 and gbp = -1248.1 and eur = -197913 and  hkd = -1604.7','')")

    con:query("insert into check_sql values(-1782,'delete from transaction_total_check where cny = -1782 and jpy = -178200 and gbp = -1247.4 and eur = -197802 and  hkd = -1603.8','')")

    con:query("insert into check_sql values(-1781,'delete from transaction_total_check where cny = -1781 and jpy = -178100 and gbp = -1246.7 and eur = -197691 and  hkd = -1602.9','')")

    con:query("insert into check_sql values(-1780,'delete from transaction_total_check where cny = -1780 and jpy = -178000 and gbp = -1246.0 and eur = -197580 and  hkd = -1602.0','')")

    con:query("insert into check_sql values(-1779,'delete from transaction_total_check where cny = -1779 and jpy = -177900 and gbp = -1245.3 and eur = -197469 and  hkd = -1601.1','')")

    con:query("insert into check_sql values(-1778,'delete from transaction_total_check where cny = -1778 and jpy = -177800 and gbp = -1244.6 and eur = -197358 and  hkd = -1600.2','')")

    con:query("insert into check_sql values(-1777,'delete from transaction_total_check where cny = -1777 and jpy = -177700 and gbp = -1243.9 and eur = -197247 and  hkd = -1599.3','')")

    con:query("insert into check_sql values(-1776,'delete from transaction_total_check where cny = -1776 and jpy = -177600 and gbp = -1243.2 and eur = -197136 and  hkd = -1598.4','')")

    con:query("insert into check_sql values(-1775,'delete from transaction_total_check where cny = -1775 and jpy = -177500 and gbp = -1242.5 and eur = -197025 and  hkd = -1597.5','')")

    con:query("insert into check_sql values(-1774,'delete from transaction_total_check where cny = -1774 and jpy = -177400 and gbp = -1241.8 and eur = -196914 and  hkd = -1596.6','')")

    con:query("insert into check_sql values(-1773,'delete from transaction_total_check where cny = -1773 and jpy = -177300 and gbp = -1241.1 and eur = -196803 and  hkd = -1595.7','')")

    con:query("insert into check_sql values(-1772,'delete from transaction_total_check where cny = -1772 and jpy = -177200 and gbp = -1240.4 and eur = -196692 and  hkd = -1594.8','')")

    con:query("insert into check_sql values(-1771,'delete from transaction_total_check where cny = -1771 and jpy = -177100 and gbp = -1239.7 and eur = -196581 and  hkd = -1593.9','')")

    con:query("insert into check_sql values(-1770,'delete from transaction_total_check where cny = -1770 and jpy = -177000 and gbp = -1239.0 and eur = -196470 and  hkd = -1593.0','')")

    con:query("insert into check_sql values(-1769,'delete from transaction_total_check where cny = -1769 and jpy = -176900 and gbp = -1238.3 and eur = -196359 and  hkd = -1592.1','')")

    con:query("insert into check_sql values(-1768,'delete from transaction_total_check where cny = -1768 and jpy = -176800 and gbp = -1237.6 and eur = -196248 and  hkd = -1591.2','')")

    con:query("insert into check_sql values(-1767,'delete from transaction_total_check where cny = -1767 and jpy = -176700 and gbp = -1236.9 and eur = -196137 and  hkd = -1590.3','')")

    con:query("insert into check_sql values(-1766,'delete from transaction_total_check where cny = -1766 and jpy = -176600 and gbp = -1236.2 and eur = -196026 and  hkd = -1589.4','')")

    con:query("insert into check_sql values(-1765,'delete from transaction_total_check where cny = -1765 and jpy = -176500 and gbp = -1235.5 and eur = -195915 and  hkd = -1588.5','')")

    con:query("insert into check_sql values(-1764,'delete from transaction_total_check where cny = -1764 and jpy = -176400 and gbp = -1234.8 and eur = -195804 and  hkd = -1587.6','')")

    con:query("insert into check_sql values(-1763,'delete from transaction_total_check where cny = -1763 and jpy = -176300 and gbp = -1234.1 and eur = -195693 and  hkd = -1586.7','')")

    con:query("insert into check_sql values(-1762,'delete from transaction_total_check where cny = -1762 and jpy = -176200 and gbp = -1233.4 and eur = -195582 and  hkd = -1585.8','')")

    con:query("insert into check_sql values(-1761,'delete from transaction_total_check where cny = -1761 and jpy = -176100 and gbp = -1232.7 and eur = -195471 and  hkd = -1584.9','')")

    con:query("insert into check_sql values(-1760,'delete from transaction_total_check where cny = -1760 and jpy = -176000 and gbp = -1232.0 and eur = -195360 and  hkd = -1584.0','')")

    con:query("insert into check_sql values(-1759,'delete from transaction_total_check where cny = -1759 and jpy = -175900 and gbp = -1231.3 and eur = -195249 and  hkd = -1583.1','')")

    con:query("insert into check_sql values(-1758,'delete from transaction_total_check where cny = -1758 and jpy = -175800 and gbp = -1230.6 and eur = -195138 and  hkd = -1582.2','')")

    con:query("insert into check_sql values(-1757,'delete from transaction_total_check where cny = -1757 and jpy = -175700 and gbp = -1229.9 and eur = -195027 and  hkd = -1581.3','')")

    con:query("insert into check_sql values(-1756,'delete from transaction_total_check where cny = -1756 and jpy = -175600 and gbp = -1229.2 and eur = -194916 and  hkd = -1580.4','')")

    con:query("insert into check_sql values(-1755,'delete from transaction_total_check where cny = -1755 and jpy = -175500 and gbp = -1228.5 and eur = -194805 and  hkd = -1579.5','')")

    con:query("insert into check_sql values(-1754,'delete from transaction_total_check where cny = -1754 and jpy = -175400 and gbp = -1227.8 and eur = -194694 and  hkd = -1578.6','')")

    con:query("insert into check_sql values(-1753,'delete from transaction_total_check where cny = -1753 and jpy = -175300 and gbp = -1227.1 and eur = -194583 and  hkd = -1577.7','')")

    con:query("insert into check_sql values(-1752,'delete from transaction_total_check where cny = -1752 and jpy = -175200 and gbp = -1226.4 and eur = -194472 and  hkd = -1576.8','')")

    con:query("insert into check_sql values(-1751,'delete from transaction_total_check where cny = -1751 and jpy = -175100 and gbp = -1225.7 and eur = -194361 and  hkd = -1575.9','')")

    con:query("insert into check_sql values(-1750,'delete from transaction_total_check where cny = -1750 and jpy = -175000 and gbp = -1225.0 and eur = -194250 and  hkd = -1575.0','')")

    con:query("insert into check_sql values(-1749,'delete from transaction_total_check where cny = -1749 and jpy = -174900 and gbp = -1224.3 and eur = -194139 and  hkd = -1574.1','')")

    con:query("insert into check_sql values(-1748,'delete from transaction_total_check where cny = -1748 and jpy = -174800 and gbp = -1223.6 and eur = -194028 and  hkd = -1573.2','')")

    con:query("insert into check_sql values(-1747,'delete from transaction_total_check where cny = -1747 and jpy = -174700 and gbp = -1222.9 and eur = -193917 and  hkd = -1572.3','')")

    con:query("insert into check_sql values(-1746,'delete from transaction_total_check where cny = -1746 and jpy = -174600 and gbp = -1222.2 and eur = -193806 and  hkd = -1571.4','')")

    con:query("insert into check_sql values(-1745,'delete from transaction_total_check where cny = -1745 and jpy = -174500 and gbp = -1221.5 and eur = -193695 and  hkd = -1570.5','')")

    con:query("insert into check_sql values(-1744,'delete from transaction_total_check where cny = -1744 and jpy = -174400 and gbp = -1220.8 and eur = -193584 and  hkd = -1569.6','')")

    con:query("insert into check_sql values(-1743,'delete from transaction_total_check where cny = -1743 and jpy = -174300 and gbp = -1220.1 and eur = -193473 and  hkd = -1568.7','')")

    con:query("insert into check_sql values(-1742,'delete from transaction_total_check where cny = -1742 and jpy = -174200 and gbp = -1219.4 and eur = -193362 and  hkd = -1567.8','')")

    con:query("insert into check_sql values(-1741,'delete from transaction_total_check where cny = -1741 and jpy = -174100 and gbp = -1218.7 and eur = -193251 and  hkd = -1566.9','')")

    con:query("insert into check_sql values(-1740,'delete from transaction_total_check where cny = -1740 and jpy = -174000 and gbp = -1218.0 and eur = -193140 and  hkd = -1566.0','')")

    con:query("insert into check_sql values(-1739,'delete from transaction_total_check where cny = -1739 and jpy = -173900 and gbp = -1217.3 and eur = -193029 and  hkd = -1565.1','')")

    con:query("insert into check_sql values(-1738,'delete from transaction_total_check where cny = -1738 and jpy = -173800 and gbp = -1216.6 and eur = -192918 and  hkd = -1564.2','')")

    con:query("insert into check_sql values(-1737,'delete from transaction_total_check where cny = -1737 and jpy = -173700 and gbp = -1215.9 and eur = -192807 and  hkd = -1563.3','')")

    con:query("insert into check_sql values(-1736,'delete from transaction_total_check where cny = -1736 and jpy = -173600 and gbp = -1215.2 and eur = -192696 and  hkd = -1562.4','')")

    con:query("insert into check_sql values(-1735,'delete from transaction_total_check where cny = -1735 and jpy = -173500 and gbp = -1214.5 and eur = -192585 and  hkd = -1561.5','')")

    con:query("insert into check_sql values(-1734,'delete from transaction_total_check where cny = -1734 and jpy = -173400 and gbp = -1213.8 and eur = -192474 and  hkd = -1560.6','')")

    con:query("insert into check_sql values(-1733,'delete from transaction_total_check where cny = -1733 and jpy = -173300 and gbp = -1213.1 and eur = -192363 and  hkd = -1559.7','')")

    con:query("insert into check_sql values(-1732,'delete from transaction_total_check where cny = -1732 and jpy = -173200 and gbp = -1212.4 and eur = -192252 and  hkd = -1558.8','')")

    con:query("insert into check_sql values(-1731,'delete from transaction_total_check where cny = -1731 and jpy = -173100 and gbp = -1211.7 and eur = -192141 and  hkd = -1557.9','')")

    con:query("insert into check_sql values(-1730,'delete from transaction_total_check where cny = -1730 and jpy = -173000 and gbp = -1211.0 and eur = -192030 and  hkd = -1557.0','')")

    con:query("insert into check_sql values(-1729,'delete from transaction_total_check where cny = -1729 and jpy = -172900 and gbp = -1210.3 and eur = -191919 and  hkd = -1556.1','')")

    con:query("insert into check_sql values(-1728,'delete from transaction_total_check where cny = -1728 and jpy = -172800 and gbp = -1209.6 and eur = -191808 and  hkd = -1555.2','')")

    con:query("insert into check_sql values(-1727,'delete from transaction_total_check where cny = -1727 and jpy = -172700 and gbp = -1208.9 and eur = -191697 and  hkd = -1554.3','')")

    con:query("insert into check_sql values(-1726,'delete from transaction_total_check where cny = -1726 and jpy = -172600 and gbp = -1208.2 and eur = -191586 and  hkd = -1553.4','')")

    con:query("insert into check_sql values(-1725,'delete from transaction_total_check where cny = -1725 and jpy = -172500 and gbp = -1207.5 and eur = -191475 and  hkd = -1552.5','')")

    con:query("insert into check_sql values(-1724,'delete from transaction_total_check where cny = -1724 and jpy = -172400 and gbp = -1206.8 and eur = -191364 and  hkd = -1551.6','')")

    con:query("insert into check_sql values(-1723,'delete from transaction_total_check where cny = -1723 and jpy = -172300 and gbp = -1206.1 and eur = -191253 and  hkd = -1550.7','')")

    con:query("insert into check_sql values(-1722,'delete from transaction_total_check where cny = -1722 and jpy = -172200 and gbp = -1205.4 and eur = -191142 and  hkd = -1549.8','')")

    con:query("insert into check_sql values(-1721,'delete from transaction_total_check where cny = -1721 and jpy = -172100 and gbp = -1204.7 and eur = -191031 and  hkd = -1548.9','')")

    con:query("insert into check_sql values(-1720,'delete from transaction_total_check where cny = -1720 and jpy = -172000 and gbp = -1204.0 and eur = -190920 and  hkd = -1548.0','')")

    con:query("insert into check_sql values(-1719,'delete from transaction_total_check where cny = -1719 and jpy = -171900 and gbp = -1203.3 and eur = -190809 and  hkd = -1547.1','')")

    con:query("insert into check_sql values(-1718,'delete from transaction_total_check where cny = -1718 and jpy = -171800 and gbp = -1202.6 and eur = -190698 and  hkd = -1546.2','')")

    con:query("insert into check_sql values(-1717,'delete from transaction_total_check where cny = -1717 and jpy = -171700 and gbp = -1201.9 and eur = -190587 and  hkd = -1545.3','')")

    con:query("insert into check_sql values(-1716,'delete from transaction_total_check where cny = -1716 and jpy = -171600 and gbp = -1201.2 and eur = -190476 and  hkd = -1544.4','')")

    con:query("insert into check_sql values(-1715,'delete from transaction_total_check where cny = -1715 and jpy = -171500 and gbp = -1200.5 and eur = -190365 and  hkd = -1543.5','')")

    con:query("insert into check_sql values(-1714,'delete from transaction_total_check where cny = -1714 and jpy = -171400 and gbp = -1199.8 and eur = -190254 and  hkd = -1542.6','')")

    con:query("insert into check_sql values(-1713,'delete from transaction_total_check where cny = -1713 and jpy = -171300 and gbp = -1199.1 and eur = -190143 and  hkd = -1541.7','')")

    con:query("insert into check_sql values(-1712,'delete from transaction_total_check where cny = -1712 and jpy = -171200 and gbp = -1198.4 and eur = -190032 and  hkd = -1540.8','')")

    con:query("insert into check_sql values(-1711,'delete from transaction_total_check where cny = -1711 and jpy = -171100 and gbp = -1197.7 and eur = -189921 and  hkd = -1539.9','')")

    con:query("insert into check_sql values(-1710,'delete from transaction_total_check where cny = -1710 and jpy = -171000 and gbp = -1197.0 and eur = -189810 and  hkd = -1539.0','')")

    con:query("insert into check_sql values(-1709,'delete from transaction_total_check where cny = -1709 and jpy = -170900 and gbp = -1196.3 and eur = -189699 and  hkd = -1538.1','')")

    con:query("insert into check_sql values(-1708,'delete from transaction_total_check where cny = -1708 and jpy = -170800 and gbp = -1195.6 and eur = -189588 and  hkd = -1537.2','')")

    con:query("insert into check_sql values(-1707,'delete from transaction_total_check where cny = -1707 and jpy = -170700 and gbp = -1194.9 and eur = -189477 and  hkd = -1536.3','')")

    con:query("insert into check_sql values(-1706,'delete from transaction_total_check where cny = -1706 and jpy = -170600 and gbp = -1194.2 and eur = -189366 and  hkd = -1535.4','')")

    con:query("insert into check_sql values(-1705,'delete from transaction_total_check where cny = -1705 and jpy = -170500 and gbp = -1193.5 and eur = -189255 and  hkd = -1534.5','')")

    con:query("insert into check_sql values(-1704,'delete from transaction_total_check where cny = -1704 and jpy = -170400 and gbp = -1192.8 and eur = -189144 and  hkd = -1533.6','')")

    con:query("insert into check_sql values(-1703,'delete from transaction_total_check where cny = -1703 and jpy = -170300 and gbp = -1192.1 and eur = -189033 and  hkd = -1532.7','')")

    con:query("insert into check_sql values(-1702,'delete from transaction_total_check where cny = -1702 and jpy = -170200 and gbp = -1191.4 and eur = -188922 and  hkd = -1531.8','')")

    con:query("insert into check_sql values(-1701,'delete from transaction_total_check where cny = -1701 and jpy = -170100 and gbp = -1190.7 and eur = -188811 and  hkd = -1530.9','')")

    con:query("insert into check_sql values(-1700,'delete from transaction_total_check where cny = -1700 and jpy = -170000 and gbp = -1190.0 and eur = -188700 and  hkd = -1530.0','')")

    con:query("insert into check_sql values(-1699,'delete from transaction_total_check where cny = -1699 and jpy = -169900 and gbp = -1189.3 and eur = -188589 and  hkd = -1529.1','')")

    con:query("insert into check_sql values(-1698,'delete from transaction_total_check where cny = -1698 and jpy = -169800 and gbp = -1188.6 and eur = -188478 and  hkd = -1528.2','')")

    con:query("insert into check_sql values(-1697,'delete from transaction_total_check where cny = -1697 and jpy = -169700 and gbp = -1187.9 and eur = -188367 and  hkd = -1527.3','')")

    con:query("insert into check_sql values(-1696,'delete from transaction_total_check where cny = -1696 and jpy = -169600 and gbp = -1187.2 and eur = -188256 and  hkd = -1526.4','')")

    con:query("insert into check_sql values(-1695,'delete from transaction_total_check where cny = -1695 and jpy = -169500 and gbp = -1186.5 and eur = -188145 and  hkd = -1525.5','')")

    con:query("insert into check_sql values(-1694,'delete from transaction_total_check where cny = -1694 and jpy = -169400 and gbp = -1185.8 and eur = -188034 and  hkd = -1524.6','')")

    con:query("insert into check_sql values(-1693,'delete from transaction_total_check where cny = -1693 and jpy = -169300 and gbp = -1185.1 and eur = -187923 and  hkd = -1523.7','')")

    con:query("insert into check_sql values(-1692,'delete from transaction_total_check where cny = -1692 and jpy = -169200 and gbp = -1184.4 and eur = -187812 and  hkd = -1522.8','')")

    con:query("insert into check_sql values(-1691,'delete from transaction_total_check where cny = -1691 and jpy = -169100 and gbp = -1183.7 and eur = -187701 and  hkd = -1521.9','')")

    con:query("insert into check_sql values(-1690,'delete from transaction_total_check where cny = -1690 and jpy = -169000 and gbp = -1183.0 and eur = -187590 and  hkd = -1521.0','')")

    con:query("insert into check_sql values(-1689,'delete from transaction_total_check where cny = -1689 and jpy = -168900 and gbp = -1182.3 and eur = -187479 and  hkd = -1520.1','')")

    con:query("insert into check_sql values(-1688,'delete from transaction_total_check where cny = -1688 and jpy = -168800 and gbp = -1181.6 and eur = -187368 and  hkd = -1519.2','')")

    con:query("insert into check_sql values(-1687,'delete from transaction_total_check where cny = -1687 and jpy = -168700 and gbp = -1180.9 and eur = -187257 and  hkd = -1518.3','')")

    con:query("insert into check_sql values(-1686,'delete from transaction_total_check where cny = -1686 and jpy = -168600 and gbp = -1180.2 and eur = -187146 and  hkd = -1517.4','')")

    con:query("insert into check_sql values(-1685,'delete from transaction_total_check where cny = -1685 and jpy = -168500 and gbp = -1179.5 and eur = -187035 and  hkd = -1516.5','')")

    con:query("insert into check_sql values(-1684,'delete from transaction_total_check where cny = -1684 and jpy = -168400 and gbp = -1178.8 and eur = -186924 and  hkd = -1515.6','')")

    con:query("insert into check_sql values(-1683,'delete from transaction_total_check where cny = -1683 and jpy = -168300 and gbp = -1178.1 and eur = -186813 and  hkd = -1514.7','')")

    con:query("insert into check_sql values(-1682,'delete from transaction_total_check where cny = -1682 and jpy = -168200 and gbp = -1177.4 and eur = -186702 and  hkd = -1513.8','')")

    con:query("insert into check_sql values(-1681,'delete from transaction_total_check where cny = -1681 and jpy = -168100 and gbp = -1176.7 and eur = -186591 and  hkd = -1512.9','')")

    con:query("insert into check_sql values(-1680,'delete from transaction_total_check where cny = -1680 and jpy = -168000 and gbp = -1176.0 and eur = -186480 and  hkd = -1512.0','')")

    con:query("insert into check_sql values(-1679,'delete from transaction_total_check where cny = -1679 and jpy = -167900 and gbp = -1175.3 and eur = -186369 and  hkd = -1511.1','')")

    con:query("insert into check_sql values(-1678,'delete from transaction_total_check where cny = -1678 and jpy = -167800 and gbp = -1174.6 and eur = -186258 and  hkd = -1510.2','')")

    con:query("insert into check_sql values(-1677,'delete from transaction_total_check where cny = -1677 and jpy = -167700 and gbp = -1173.9 and eur = -186147 and  hkd = -1509.3','')")

    con:query("insert into check_sql values(-1676,'delete from transaction_total_check where cny = -1676 and jpy = -167600 and gbp = -1173.2 and eur = -186036 and  hkd = -1508.4','')")

    con:query("insert into check_sql values(-1675,'delete from transaction_total_check where cny = -1675 and jpy = -167500 and gbp = -1172.5 and eur = -185925 and  hkd = -1507.5','')")

    con:query("insert into check_sql values(-1674,'delete from transaction_total_check where cny = -1674 and jpy = -167400 and gbp = -1171.8 and eur = -185814 and  hkd = -1506.6','')")

    con:query("insert into check_sql values(-1673,'delete from transaction_total_check where cny = -1673 and jpy = -167300 and gbp = -1171.1 and eur = -185703 and  hkd = -1505.7','')")

    con:query("insert into check_sql values(-1672,'delete from transaction_total_check where cny = -1672 and jpy = -167200 and gbp = -1170.4 and eur = -185592 and  hkd = -1504.8','')")

    con:query("insert into check_sql values(-1671,'delete from transaction_total_check where cny = -1671 and jpy = -167100 and gbp = -1169.7 and eur = -185481 and  hkd = -1503.9','')")

    con:query("insert into check_sql values(-1670,'delete from transaction_total_check where cny = -1670 and jpy = -167000 and gbp = -1169.0 and eur = -185370 and  hkd = -1503.0','')")

    con:query("insert into check_sql values(-1669,'delete from transaction_total_check where cny = -1669 and jpy = -166900 and gbp = -1168.3 and eur = -185259 and  hkd = -1502.1','')")

    con:query("insert into check_sql values(-1668,'delete from transaction_total_check where cny = -1668 and jpy = -166800 and gbp = -1167.6 and eur = -185148 and  hkd = -1501.2','')")

    con:query("insert into check_sql values(-1667,'delete from transaction_total_check where cny = -1667 and jpy = -166700 and gbp = -1166.9 and eur = -185037 and  hkd = -1500.3','')")

    con:query("insert into check_sql values(-1666,'delete from transaction_total_check where cny = -1666 and jpy = -166600 and gbp = -1166.2 and eur = -184926 and  hkd = -1499.4','')")

    con:query("insert into check_sql values(-1665,'delete from transaction_total_check where cny = -1665 and jpy = -166500 and gbp = -1165.5 and eur = -184815 and  hkd = -1498.5','')")

    con:query("insert into check_sql values(-1664,'delete from transaction_total_check where cny = -1664 and jpy = -166400 and gbp = -1164.8 and eur = -184704 and  hkd = -1497.6','')")

    con:query("insert into check_sql values(-1663,'delete from transaction_total_check where cny = -1663 and jpy = -166300 and gbp = -1164.1 and eur = -184593 and  hkd = -1496.7','')")

    con:query("insert into check_sql values(-1662,'delete from transaction_total_check where cny = -1662 and jpy = -166200 and gbp = -1163.4 and eur = -184482 and  hkd = -1495.8','')")

    con:query("insert into check_sql values(-1661,'delete from transaction_total_check where cny = -1661 and jpy = -166100 and gbp = -1162.7 and eur = -184371 and  hkd = -1494.9','')")

    con:query("insert into check_sql values(-1660,'delete from transaction_total_check where cny = -1660 and jpy = -166000 and gbp = -1162.0 and eur = -184260 and  hkd = -1494.0','')")

    con:query("insert into check_sql values(-1659,'delete from transaction_total_check where cny = -1659 and jpy = -165900 and gbp = -1161.3 and eur = -184149 and  hkd = -1493.1','')")

    con:query("insert into check_sql values(-1658,'delete from transaction_total_check where cny = -1658 and jpy = -165800 and gbp = -1160.6 and eur = -184038 and  hkd = -1492.2','')")

    con:query("insert into check_sql values(-1657,'delete from transaction_total_check where cny = -1657 and jpy = -165700 and gbp = -1159.9 and eur = -183927 and  hkd = -1491.3','')")

    con:query("insert into check_sql values(-1656,'delete from transaction_total_check where cny = -1656 and jpy = -165600 and gbp = -1159.2 and eur = -183816 and  hkd = -1490.4','')")

    con:query("insert into check_sql values(-1655,'delete from transaction_total_check where cny = -1655 and jpy = -165500 and gbp = -1158.5 and eur = -183705 and  hkd = -1489.5','')")

    con:query("insert into check_sql values(-1654,'delete from transaction_total_check where cny = -1654 and jpy = -165400 and gbp = -1157.8 and eur = -183594 and  hkd = -1488.6','')")

    con:query("insert into check_sql values(-1653,'delete from transaction_total_check where cny = -1653 and jpy = -165300 and gbp = -1157.1 and eur = -183483 and  hkd = -1487.7','')")

    con:query("insert into check_sql values(-1652,'delete from transaction_total_check where cny = -1652 and jpy = -165200 and gbp = -1156.4 and eur = -183372 and  hkd = -1486.8','')")

    con:query("insert into check_sql values(-1651,'delete from transaction_total_check where cny = -1651 and jpy = -165100 and gbp = -1155.7 and eur = -183261 and  hkd = -1485.9','')")

    con:query("insert into check_sql values(-1650,'delete from transaction_total_check where cny = -1650 and jpy = -165000 and gbp = -1155.0 and eur = -183150 and  hkd = -1485.0','')")

    con:query("insert into check_sql values(-1649,'delete from transaction_total_check where cny = -1649 and jpy = -164900 and gbp = -1154.3 and eur = -183039 and  hkd = -1484.1','')")

    con:query("insert into check_sql values(-1648,'delete from transaction_total_check where cny = -1648 and jpy = -164800 and gbp = -1153.6 and eur = -182928 and  hkd = -1483.2','')")

    con:query("insert into check_sql values(-1647,'delete from transaction_total_check where cny = -1647 and jpy = -164700 and gbp = -1152.9 and eur = -182817 and  hkd = -1482.3','')")

    con:query("insert into check_sql values(-1646,'delete from transaction_total_check where cny = -1646 and jpy = -164600 and gbp = -1152.2 and eur = -182706 and  hkd = -1481.4','')")

    con:query("insert into check_sql values(-1645,'delete from transaction_total_check where cny = -1645 and jpy = -164500 and gbp = -1151.5 and eur = -182595 and  hkd = -1480.5','')")

    con:query("insert into check_sql values(-1644,'delete from transaction_total_check where cny = -1644 and jpy = -164400 and gbp = -1150.8 and eur = -182484 and  hkd = -1479.6','')")

    con:query("insert into check_sql values(-1643,'delete from transaction_total_check where cny = -1643 and jpy = -164300 and gbp = -1150.1 and eur = -182373 and  hkd = -1478.7','')")

    con:query("insert into check_sql values(-1642,'delete from transaction_total_check where cny = -1642 and jpy = -164200 and gbp = -1149.4 and eur = -182262 and  hkd = -1477.8','')")

    con:query("insert into check_sql values(-1641,'delete from transaction_total_check where cny = -1641 and jpy = -164100 and gbp = -1148.7 and eur = -182151 and  hkd = -1476.9','')")

    con:query("insert into check_sql values(-1640,'delete from transaction_total_check where cny = -1640 and jpy = -164000 and gbp = -1148.0 and eur = -182040 and  hkd = -1476.0','')")

    con:query("insert into check_sql values(-1639,'delete from transaction_total_check where cny = -1639 and jpy = -163900 and gbp = -1147.3 and eur = -181929 and  hkd = -1475.1','')")

    con:query("insert into check_sql values(-1638,'delete from transaction_total_check where cny = -1638 and jpy = -163800 and gbp = -1146.6 and eur = -181818 and  hkd = -1474.2','')")

    con:query("insert into check_sql values(-1637,'delete from transaction_total_check where cny = -1637 and jpy = -163700 and gbp = -1145.9 and eur = -181707 and  hkd = -1473.3','')")

    con:query("insert into check_sql values(-1636,'delete from transaction_total_check where cny = -1636 and jpy = -163600 and gbp = -1145.2 and eur = -181596 and  hkd = -1472.4','')")

    con:query("insert into check_sql values(-1635,'delete from transaction_total_check where cny = -1635 and jpy = -163500 and gbp = -1144.5 and eur = -181485 and  hkd = -1471.5','')")

    con:query("insert into check_sql values(-1634,'delete from transaction_total_check where cny = -1634 and jpy = -163400 and gbp = -1143.8 and eur = -181374 and  hkd = -1470.6','')")

    con:query("insert into check_sql values(-1633,'delete from transaction_total_check where cny = -1633 and jpy = -163300 and gbp = -1143.1 and eur = -181263 and  hkd = -1469.7','')")

    con:query("insert into check_sql values(-1632,'delete from transaction_total_check where cny = -1632 and jpy = -163200 and gbp = -1142.4 and eur = -181152 and  hkd = -1468.8','')")

    con:query("insert into check_sql values(-1631,'delete from transaction_total_check where cny = -1631 and jpy = -163100 and gbp = -1141.7 and eur = -181041 and  hkd = -1467.9','')")

    con:query("insert into check_sql values(-1630,'delete from transaction_total_check where cny = -1630 and jpy = -163000 and gbp = -1141.0 and eur = -180930 and  hkd = -1467.0','')")

    con:query("insert into check_sql values(-1629,'delete from transaction_total_check where cny = -1629 and jpy = -162900 and gbp = -1140.3 and eur = -180819 and  hkd = -1466.1','')")

    con:query("insert into check_sql values(-1628,'delete from transaction_total_check where cny = -1628 and jpy = -162800 and gbp = -1139.6 and eur = -180708 and  hkd = -1465.2','')")

    con:query("insert into check_sql values(-1627,'delete from transaction_total_check where cny = -1627 and jpy = -162700 and gbp = -1138.9 and eur = -180597 and  hkd = -1464.3','')")

    con:query("insert into check_sql values(-1626,'delete from transaction_total_check where cny = -1626 and jpy = -162600 and gbp = -1138.2 and eur = -180486 and  hkd = -1463.4','')")

    con:query("insert into check_sql values(-1625,'delete from transaction_total_check where cny = -1625 and jpy = -162500 and gbp = -1137.5 and eur = -180375 and  hkd = -1462.5','')")

    con:query("insert into check_sql values(-1624,'delete from transaction_total_check where cny = -1624 and jpy = -162400 and gbp = -1136.8 and eur = -180264 and  hkd = -1461.6','')")

    con:query("insert into check_sql values(-1623,'delete from transaction_total_check where cny = -1623 and jpy = -162300 and gbp = -1136.1 and eur = -180153 and  hkd = -1460.7','')")

    con:query("insert into check_sql values(-1622,'delete from transaction_total_check where cny = -1622 and jpy = -162200 and gbp = -1135.4 and eur = -180042 and  hkd = -1459.8','')")

    con:query("insert into check_sql values(-1621,'delete from transaction_total_check where cny = -1621 and jpy = -162100 and gbp = -1134.7 and eur = -179931 and  hkd = -1458.9','')")

    con:query("insert into check_sql values(-1620,'delete from transaction_total_check where cny = -1620 and jpy = -162000 and gbp = -1134.0 and eur = -179820 and  hkd = -1458.0','')")

    con:query("insert into check_sql values(-1619,'delete from transaction_total_check where cny = -1619 and jpy = -161900 and gbp = -1133.3 and eur = -179709 and  hkd = -1457.1','')")

    con:query("insert into check_sql values(-1618,'delete from transaction_total_check where cny = -1618 and jpy = -161800 and gbp = -1132.6 and eur = -179598 and  hkd = -1456.2','')")

    con:query("insert into check_sql values(-1617,'delete from transaction_total_check where cny = -1617 and jpy = -161700 and gbp = -1131.9 and eur = -179487 and  hkd = -1455.3','')")

    con:query("insert into check_sql values(-1616,'delete from transaction_total_check where cny = -1616 and jpy = -161600 and gbp = -1131.2 and eur = -179376 and  hkd = -1454.4','')")

    con:query("insert into check_sql values(-1615,'delete from transaction_total_check where cny = -1615 and jpy = -161500 and gbp = -1130.5 and eur = -179265 and  hkd = -1453.5','')")

    con:query("insert into check_sql values(-1614,'delete from transaction_total_check where cny = -1614 and jpy = -161400 and gbp = -1129.8 and eur = -179154 and  hkd = -1452.6','')")

    con:query("insert into check_sql values(-1613,'delete from transaction_total_check where cny = -1613 and jpy = -161300 and gbp = -1129.1 and eur = -179043 and  hkd = -1451.7','')")

    con:query("insert into check_sql values(-1612,'delete from transaction_total_check where cny = -1612 and jpy = -161200 and gbp = -1128.4 and eur = -178932 and  hkd = -1450.8','')")

    con:query("insert into check_sql values(-1611,'delete from transaction_total_check where cny = -1611 and jpy = -161100 and gbp = -1127.7 and eur = -178821 and  hkd = -1449.9','')")

    con:query("insert into check_sql values(-1610,'delete from transaction_total_check where cny = -1610 and jpy = -161000 and gbp = -1127.0 and eur = -178710 and  hkd = -1449.0','')")

    con:query("insert into check_sql values(-1609,'delete from transaction_total_check where cny = -1609 and jpy = -160900 and gbp = -1126.3 and eur = -178599 and  hkd = -1448.1','')")

    con:query("insert into check_sql values(-1608,'delete from transaction_total_check where cny = -1608 and jpy = -160800 and gbp = -1125.6 and eur = -178488 and  hkd = -1447.2','')")

    con:query("insert into check_sql values(-1607,'delete from transaction_total_check where cny = -1607 and jpy = -160700 and gbp = -1124.9 and eur = -178377 and  hkd = -1446.3','')")

    con:query("insert into check_sql values(-1606,'delete from transaction_total_check where cny = -1606 and jpy = -160600 and gbp = -1124.2 and eur = -178266 and  hkd = -1445.4','')")

    con:query("insert into check_sql values(-1605,'delete from transaction_total_check where cny = -1605 and jpy = -160500 and gbp = -1123.5 and eur = -178155 and  hkd = -1444.5','')")

    con:query("insert into check_sql values(-1604,'delete from transaction_total_check where cny = -1604 and jpy = -160400 and gbp = -1122.8 and eur = -178044 and  hkd = -1443.6','')")

    con:query("insert into check_sql values(-1603,'delete from transaction_total_check where cny = -1603 and jpy = -160300 and gbp = -1122.1 and eur = -177933 and  hkd = -1442.7','')")

    con:query("insert into check_sql values(-1602,'delete from transaction_total_check where cny = -1602 and jpy = -160200 and gbp = -1121.4 and eur = -177822 and  hkd = -1441.8','')")

    con:query("insert into check_sql values(-1601,'delete from transaction_total_check where cny = -1601 and jpy = -160100 and gbp = -1120.7 and eur = -177711 and  hkd = -1440.9','')")

    con:query("insert into check_sql values(-1600,'delete from transaction_total_check where cny = -1600 and jpy = -160000 and gbp = -1120.0 and eur = -177600 and  hkd = -1440.0','')")

    con:query("insert into check_sql values(-1599,'delete from transaction_total_check where cny = -1599 and jpy = -159900 and gbp = -1119.3 and eur = -177489 and  hkd = -1439.1','')")

    con:query("insert into check_sql values(-1598,'delete from transaction_total_check where cny = -1598 and jpy = -159800 and gbp = -1118.6 and eur = -177378 and  hkd = -1438.2','')")

    con:query("insert into check_sql values(-1597,'delete from transaction_total_check where cny = -1597 and jpy = -159700 and gbp = -1117.9 and eur = -177267 and  hkd = -1437.3','')")

    con:query("insert into check_sql values(-1596,'delete from transaction_total_check where cny = -1596 and jpy = -159600 and gbp = -1117.2 and eur = -177156 and  hkd = -1436.4','')")

    con:query("insert into check_sql values(-1595,'delete from transaction_total_check where cny = -1595 and jpy = -159500 and gbp = -1116.5 and eur = -177045 and  hkd = -1435.5','')")

    con:query("insert into check_sql values(-1594,'delete from transaction_total_check where cny = -1594 and jpy = -159400 and gbp = -1115.8 and eur = -176934 and  hkd = -1434.6','')")

    con:query("insert into check_sql values(-1593,'delete from transaction_total_check where cny = -1593 and jpy = -159300 and gbp = -1115.1 and eur = -176823 and  hkd = -1433.7','')")

    con:query("insert into check_sql values(-1592,'delete from transaction_total_check where cny = -1592 and jpy = -159200 and gbp = -1114.4 and eur = -176712 and  hkd = -1432.8','')")

    con:query("insert into check_sql values(-1591,'delete from transaction_total_check where cny = -1591 and jpy = -159100 and gbp = -1113.7 and eur = -176601 and  hkd = -1431.9','')")

    con:query("insert into check_sql values(-1590,'delete from transaction_total_check where cny = -1590 and jpy = -159000 and gbp = -1113.0 and eur = -176490 and  hkd = -1431.0','')")

    con:query("insert into check_sql values(-1589,'delete from transaction_total_check where cny = -1589 and jpy = -158900 and gbp = -1112.3 and eur = -176379 and  hkd = -1430.1','')")

    con:query("insert into check_sql values(-1588,'delete from transaction_total_check where cny = -1588 and jpy = -158800 and gbp = -1111.6 and eur = -176268 and  hkd = -1429.2','')")

    con:query("insert into check_sql values(-1587,'delete from transaction_total_check where cny = -1587 and jpy = -158700 and gbp = -1110.9 and eur = -176157 and  hkd = -1428.3','')")

    con:query("insert into check_sql values(-1586,'delete from transaction_total_check where cny = -1586 and jpy = -158600 and gbp = -1110.2 and eur = -176046 and  hkd = -1427.4','')")

    con:query("insert into check_sql values(-1585,'delete from transaction_total_check where cny = -1585 and jpy = -158500 and gbp = -1109.5 and eur = -175935 and  hkd = -1426.5','')")

    con:query("insert into check_sql values(-1584,'delete from transaction_total_check where cny = -1584 and jpy = -158400 and gbp = -1108.8 and eur = -175824 and  hkd = -1425.6','')")

    con:query("insert into check_sql values(-1583,'delete from transaction_total_check where cny = -1583 and jpy = -158300 and gbp = -1108.1 and eur = -175713 and  hkd = -1424.7','')")

    con:query("insert into check_sql values(-1582,'delete from transaction_total_check where cny = -1582 and jpy = -158200 and gbp = -1107.4 and eur = -175602 and  hkd = -1423.8','')")

    con:query("insert into check_sql values(-1581,'delete from transaction_total_check where cny = -1581 and jpy = -158100 and gbp = -1106.7 and eur = -175491 and  hkd = -1422.9','')")

    con:query("insert into check_sql values(-1580,'delete from transaction_total_check where cny = -1580 and jpy = -158000 and gbp = -1106.0 and eur = -175380 and  hkd = -1422.0','')")

    con:query("insert into check_sql values(-1579,'delete from transaction_total_check where cny = -1579 and jpy = -157900 and gbp = -1105.3 and eur = -175269 and  hkd = -1421.1','')")

    con:query("insert into check_sql values(-1578,'delete from transaction_total_check where cny = -1578 and jpy = -157800 and gbp = -1104.6 and eur = -175158 and  hkd = -1420.2','')")

    con:query("insert into check_sql values(-1577,'delete from transaction_total_check where cny = -1577 and jpy = -157700 and gbp = -1103.9 and eur = -175047 and  hkd = -1419.3','')")

    con:query("insert into check_sql values(-1576,'delete from transaction_total_check where cny = -1576 and jpy = -157600 and gbp = -1103.2 and eur = -174936 and  hkd = -1418.4','')")

    con:query("insert into check_sql values(-1575,'delete from transaction_total_check where cny = -1575 and jpy = -157500 and gbp = -1102.5 and eur = -174825 and  hkd = -1417.5','')")

    con:query("insert into check_sql values(-1574,'delete from transaction_total_check where cny = -1574 and jpy = -157400 and gbp = -1101.8 and eur = -174714 and  hkd = -1416.6','')")

    con:query("insert into check_sql values(-1573,'delete from transaction_total_check where cny = -1573 and jpy = -157300 and gbp = -1101.1 and eur = -174603 and  hkd = -1415.7','')")

    con:query("insert into check_sql values(-1572,'delete from transaction_total_check where cny = -1572 and jpy = -157200 and gbp = -1100.4 and eur = -174492 and  hkd = -1414.8','')")

    con:query("insert into check_sql values(-1571,'delete from transaction_total_check where cny = -1571 and jpy = -157100 and gbp = -1099.7 and eur = -174381 and  hkd = -1413.9','')")

    con:query("insert into check_sql values(-1570,'delete from transaction_total_check where cny = -1570 and jpy = -157000 and gbp = -1099.0 and eur = -174270 and  hkd = -1413.0','')")

    con:query("insert into check_sql values(-1569,'delete from transaction_total_check where cny = -1569 and jpy = -156900 and gbp = -1098.3 and eur = -174159 and  hkd = -1412.1','')")

    con:query("insert into check_sql values(-1568,'delete from transaction_total_check where cny = -1568 and jpy = -156800 and gbp = -1097.6 and eur = -174048 and  hkd = -1411.2','')")

    con:query("insert into check_sql values(-1567,'delete from transaction_total_check where cny = -1567 and jpy = -156700 and gbp = -1096.9 and eur = -173937 and  hkd = -1410.3','')")

    con:query("insert into check_sql values(-1566,'delete from transaction_total_check where cny = -1566 and jpy = -156600 and gbp = -1096.2 and eur = -173826 and  hkd = -1409.4','')")

    con:query("insert into check_sql values(-1565,'delete from transaction_total_check where cny = -1565 and jpy = -156500 and gbp = -1095.5 and eur = -173715 and  hkd = -1408.5','')")

    con:query("insert into check_sql values(-1564,'delete from transaction_total_check where cny = -1564 and jpy = -156400 and gbp = -1094.8 and eur = -173604 and  hkd = -1407.6','')")

    con:query("insert into check_sql values(-1563,'delete from transaction_total_check where cny = -1563 and jpy = -156300 and gbp = -1094.1 and eur = -173493 and  hkd = -1406.7','')")

    con:query("insert into check_sql values(-1562,'delete from transaction_total_check where cny = -1562 and jpy = -156200 and gbp = -1093.4 and eur = -173382 and  hkd = -1405.8','')")

    con:query("insert into check_sql values(-1561,'delete from transaction_total_check where cny = -1561 and jpy = -156100 and gbp = -1092.7 and eur = -173271 and  hkd = -1404.9','')")

    con:query("insert into check_sql values(-1560,'delete from transaction_total_check where cny = -1560 and jpy = -156000 and gbp = -1092.0 and eur = -173160 and  hkd = -1404.0','')")

    con:query("insert into check_sql values(-1559,'delete from transaction_total_check where cny = -1559 and jpy = -155900 and gbp = -1091.3 and eur = -173049 and  hkd = -1403.1','')")

    con:query("insert into check_sql values(-1558,'delete from transaction_total_check where cny = -1558 and jpy = -155800 and gbp = -1090.6 and eur = -172938 and  hkd = -1402.2','')")

    con:query("insert into check_sql values(-1557,'delete from transaction_total_check where cny = -1557 and jpy = -155700 and gbp = -1089.9 and eur = -172827 and  hkd = -1401.3','')")

    con:query("insert into check_sql values(-1556,'delete from transaction_total_check where cny = -1556 and jpy = -155600 and gbp = -1089.2 and eur = -172716 and  hkd = -1400.4','')")

    con:query("insert into check_sql values(-1555,'delete from transaction_total_check where cny = -1555 and jpy = -155500 and gbp = -1088.5 and eur = -172605 and  hkd = -1399.5','')")

    con:query("insert into check_sql values(-1554,'delete from transaction_total_check where cny = -1554 and jpy = -155400 and gbp = -1087.8 and eur = -172494 and  hkd = -1398.6','')")

    con:query("insert into check_sql values(-1553,'delete from transaction_total_check where cny = -1553 and jpy = -155300 and gbp = -1087.1 and eur = -172383 and  hkd = -1397.7','')")

    con:query("insert into check_sql values(-1552,'delete from transaction_total_check where cny = -1552 and jpy = -155200 and gbp = -1086.4 and eur = -172272 and  hkd = -1396.8','')")

    con:query("insert into check_sql values(-1551,'delete from transaction_total_check where cny = -1551 and jpy = -155100 and gbp = -1085.7 and eur = -172161 and  hkd = -1395.9','')")

    con:query("insert into check_sql values(-1550,'delete from transaction_total_check where cny = -1550 and jpy = -155000 and gbp = -1085.0 and eur = -172050 and  hkd = -1395.0','')")

    con:query("insert into check_sql values(-1549,'delete from transaction_total_check where cny = -1549 and jpy = -154900 and gbp = -1084.3 and eur = -171939 and  hkd = -1394.1','')")

    con:query("insert into check_sql values(-1548,'delete from transaction_total_check where cny = -1548 and jpy = -154800 and gbp = -1083.6 and eur = -171828 and  hkd = -1393.2','')")

    con:query("insert into check_sql values(-1547,'delete from transaction_total_check where cny = -1547 and jpy = -154700 and gbp = -1082.9 and eur = -171717 and  hkd = -1392.3','')")

    con:query("insert into check_sql values(-1546,'delete from transaction_total_check where cny = -1546 and jpy = -154600 and gbp = -1082.2 and eur = -171606 and  hkd = -1391.4','')")

    con:query("insert into check_sql values(-1545,'delete from transaction_total_check where cny = -1545 and jpy = -154500 and gbp = -1081.5 and eur = -171495 and  hkd = -1390.5','')")

    con:query("insert into check_sql values(-1544,'delete from transaction_total_check where cny = -1544 and jpy = -154400 and gbp = -1080.8 and eur = -171384 and  hkd = -1389.6','')")

    con:query("insert into check_sql values(-1543,'delete from transaction_total_check where cny = -1543 and jpy = -154300 and gbp = -1080.1 and eur = -171273 and  hkd = -1388.7','')")

    con:query("insert into check_sql values(-1542,'delete from transaction_total_check where cny = -1542 and jpy = -154200 and gbp = -1079.4 and eur = -171162 and  hkd = -1387.8','')")

    con:query("insert into check_sql values(-1541,'delete from transaction_total_check where cny = -1541 and jpy = -154100 and gbp = -1078.7 and eur = -171051 and  hkd = -1386.9','')")

    con:query("insert into check_sql values(-1540,'delete from transaction_total_check where cny = -1540 and jpy = -154000 and gbp = -1078.0 and eur = -170940 and  hkd = -1386.0','')")

    con:query("insert into check_sql values(-1539,'delete from transaction_total_check where cny = -1539 and jpy = -153900 and gbp = -1077.3 and eur = -170829 and  hkd = -1385.1','')")

    con:query("insert into check_sql values(-1538,'delete from transaction_total_check where cny = -1538 and jpy = -153800 and gbp = -1076.6 and eur = -170718 and  hkd = -1384.2','')")

    con:query("insert into check_sql values(-1537,'delete from transaction_total_check where cny = -1537 and jpy = -153700 and gbp = -1075.9 and eur = -170607 and  hkd = -1383.3','')")

    con:query("insert into check_sql values(-1536,'delete from transaction_total_check where cny = -1536 and jpy = -153600 and gbp = -1075.2 and eur = -170496 and  hkd = -1382.4','')")

    con:query("insert into check_sql values(-1535,'delete from transaction_total_check where cny = -1535 and jpy = -153500 and gbp = -1074.5 and eur = -170385 and  hkd = -1381.5','')")

    con:query("insert into check_sql values(-1534,'delete from transaction_total_check where cny = -1534 and jpy = -153400 and gbp = -1073.8 and eur = -170274 and  hkd = -1380.6','')")

    con:query("insert into check_sql values(-1533,'delete from transaction_total_check where cny = -1533 and jpy = -153300 and gbp = -1073.1 and eur = -170163 and  hkd = -1379.7','')")

    con:query("insert into check_sql values(-1532,'delete from transaction_total_check where cny = -1532 and jpy = -153200 and gbp = -1072.4 and eur = -170052 and  hkd = -1378.8','')")

    con:query("insert into check_sql values(-1531,'delete from transaction_total_check where cny = -1531 and jpy = -153100 and gbp = -1071.7 and eur = -169941 and  hkd = -1377.9','')")

    con:query("insert into check_sql values(-1530,'delete from transaction_total_check where cny = -1530 and jpy = -153000 and gbp = -1071.0 and eur = -169830 and  hkd = -1377.0','')")

    con:query("insert into check_sql values(-1529,'delete from transaction_total_check where cny = -1529 and jpy = -152900 and gbp = -1070.3 and eur = -169719 and  hkd = -1376.1','')")

    con:query("insert into check_sql values(-1528,'delete from transaction_total_check where cny = -1528 and jpy = -152800 and gbp = -1069.6 and eur = -169608 and  hkd = -1375.2','')")

    con:query("insert into check_sql values(-1527,'delete from transaction_total_check where cny = -1527 and jpy = -152700 and gbp = -1068.9 and eur = -169497 and  hkd = -1374.3','')")

    con:query("insert into check_sql values(-1526,'delete from transaction_total_check where cny = -1526 and jpy = -152600 and gbp = -1068.2 and eur = -169386 and  hkd = -1373.4','')")

    con:query("insert into check_sql values(-1525,'delete from transaction_total_check where cny = -1525 and jpy = -152500 and gbp = -1067.5 and eur = -169275 and  hkd = -1372.5','')")

    con:query("insert into check_sql values(-1524,'delete from transaction_total_check where cny = -1524 and jpy = -152400 and gbp = -1066.8 and eur = -169164 and  hkd = -1371.6','')")

    con:query("insert into check_sql values(-1523,'delete from transaction_total_check where cny = -1523 and jpy = -152300 and gbp = -1066.1 and eur = -169053 and  hkd = -1370.7','')")

    con:query("insert into check_sql values(-1522,'delete from transaction_total_check where cny = -1522 and jpy = -152200 and gbp = -1065.4 and eur = -168942 and  hkd = -1369.8','')")

    con:query("insert into check_sql values(-1521,'delete from transaction_total_check where cny = -1521 and jpy = -152100 and gbp = -1064.7 and eur = -168831 and  hkd = -1368.9','')")

    con:query("insert into check_sql values(-1520,'delete from transaction_total_check where cny = -1520 and jpy = -152000 and gbp = -1064.0 and eur = -168720 and  hkd = -1368.0','')")

    con:query("insert into check_sql values(-1519,'delete from transaction_total_check where cny = -1519 and jpy = -151900 and gbp = -1063.3 and eur = -168609 and  hkd = -1367.1','')")

    con:query("insert into check_sql values(-1518,'delete from transaction_total_check where cny = -1518 and jpy = -151800 and gbp = -1062.6 and eur = -168498 and  hkd = -1366.2','')")

    con:query("insert into check_sql values(-1517,'delete from transaction_total_check where cny = -1517 and jpy = -151700 and gbp = -1061.9 and eur = -168387 and  hkd = -1365.3','')")

    con:query("insert into check_sql values(-1516,'delete from transaction_total_check where cny = -1516 and jpy = -151600 and gbp = -1061.2 and eur = -168276 and  hkd = -1364.4','')")

    con:query("insert into check_sql values(-1515,'delete from transaction_total_check where cny = -1515 and jpy = -151500 and gbp = -1060.5 and eur = -168165 and  hkd = -1363.5','')")

    con:query("insert into check_sql values(-1514,'delete from transaction_total_check where cny = -1514 and jpy = -151400 and gbp = -1059.8 and eur = -168054 and  hkd = -1362.6','')")

    con:query("insert into check_sql values(-1513,'delete from transaction_total_check where cny = -1513 and jpy = -151300 and gbp = -1059.1 and eur = -167943 and  hkd = -1361.7','')")

    con:query("insert into check_sql values(-1512,'delete from transaction_total_check where cny = -1512 and jpy = -151200 and gbp = -1058.4 and eur = -167832 and  hkd = -1360.8','')")

    con:query("insert into check_sql values(-1511,'delete from transaction_total_check where cny = -1511 and jpy = -151100 and gbp = -1057.7 and eur = -167721 and  hkd = -1359.9','')")

    con:query("insert into check_sql values(-1510,'delete from transaction_total_check where cny = -1510 and jpy = -151000 and gbp = -1057.0 and eur = -167610 and  hkd = -1359.0','')")

    con:query("insert into check_sql values(-1509,'delete from transaction_total_check where cny = -1509 and jpy = -150900 and gbp = -1056.3 and eur = -167499 and  hkd = -1358.1','')")

    con:query("insert into check_sql values(-1508,'delete from transaction_total_check where cny = -1508 and jpy = -150800 and gbp = -1055.6 and eur = -167388 and  hkd = -1357.2','')")

    con:query("insert into check_sql values(-1507,'delete from transaction_total_check where cny = -1507 and jpy = -150700 and gbp = -1054.9 and eur = -167277 and  hkd = -1356.3','')")

    con:query("insert into check_sql values(-1506,'delete from transaction_total_check where cny = -1506 and jpy = -150600 and gbp = -1054.2 and eur = -167166 and  hkd = -1355.4','')")

    con:query("insert into check_sql values(-1505,'delete from transaction_total_check where cny = -1505 and jpy = -150500 and gbp = -1053.5 and eur = -167055 and  hkd = -1354.5','')")

    con:query("insert into check_sql values(-1504,'delete from transaction_total_check where cny = -1504 and jpy = -150400 and gbp = -1052.8 and eur = -166944 and  hkd = -1353.6','')")

    con:query("insert into check_sql values(-1503,'delete from transaction_total_check where cny = -1503 and jpy = -150300 and gbp = -1052.1 and eur = -166833 and  hkd = -1352.7','')")

    con:query("insert into check_sql values(-1502,'delete from transaction_total_check where cny = -1502 and jpy = -150200 and gbp = -1051.4 and eur = -166722 and  hkd = -1351.8','')")

    con:query("insert into check_sql values(-1501,'delete from transaction_total_check where cny = -1501 and jpy = -150100 and gbp = -1050.7 and eur = -166611 and  hkd = -1350.9','')")

    con:query("insert into check_sql values(-1500,'delete from transaction_total_check where cny = -1500 and jpy = -150000 and gbp = -1050.0 and eur = -166500 and  hkd = -1350.0','')")

    con:query("insert into check_sql values(-1499,'delete from transaction_total_check where cny = -1499 and jpy = -149900 and gbp = -1049.3 and eur = -166389 and  hkd = -1349.1','')")

    con:query("insert into check_sql values(-1498,'delete from transaction_total_check where cny = -1498 and jpy = -149800 and gbp = -1048.6 and eur = -166278 and  hkd = -1348.2','')")

    con:query("insert into check_sql values(-1497,'delete from transaction_total_check where cny = -1497 and jpy = -149700 and gbp = -1047.9 and eur = -166167 and  hkd = -1347.3','')")

    con:query("insert into check_sql values(-1496,'delete from transaction_total_check where cny = -1496 and jpy = -149600 and gbp = -1047.2 and eur = -166056 and  hkd = -1346.4','')")

    con:query("insert into check_sql values(-1495,'delete from transaction_total_check where cny = -1495 and jpy = -149500 and gbp = -1046.5 and eur = -165945 and  hkd = -1345.5','')")

    con:query("insert into check_sql values(-1494,'delete from transaction_total_check where cny = -1494 and jpy = -149400 and gbp = -1045.8 and eur = -165834 and  hkd = -1344.6','')")

    con:query("insert into check_sql values(-1493,'delete from transaction_total_check where cny = -1493 and jpy = -149300 and gbp = -1045.1 and eur = -165723 and  hkd = -1343.7','')")

    con:query("insert into check_sql values(-1492,'delete from transaction_total_check where cny = -1492 and jpy = -149200 and gbp = -1044.4 and eur = -165612 and  hkd = -1342.8','')")

    con:query("insert into check_sql values(-1491,'delete from transaction_total_check where cny = -1491 and jpy = -149100 and gbp = -1043.7 and eur = -165501 and  hkd = -1341.9','')")

    con:query("insert into check_sql values(-1490,'delete from transaction_total_check where cny = -1490 and jpy = -149000 and gbp = -1043.0 and eur = -165390 and  hkd = -1341.0','')")

    con:query("insert into check_sql values(-1489,'delete from transaction_total_check where cny = -1489 and jpy = -148900 and gbp = -1042.3 and eur = -165279 and  hkd = -1340.1','')")

    con:query("insert into check_sql values(-1488,'delete from transaction_total_check where cny = -1488 and jpy = -148800 and gbp = -1041.6 and eur = -165168 and  hkd = -1339.2','')")

    con:query("insert into check_sql values(-1487,'delete from transaction_total_check where cny = -1487 and jpy = -148700 and gbp = -1040.9 and eur = -165057 and  hkd = -1338.3','')")

    con:query("insert into check_sql values(-1486,'delete from transaction_total_check where cny = -1486 and jpy = -148600 and gbp = -1040.2 and eur = -164946 and  hkd = -1337.4','')")

    con:query("insert into check_sql values(-1485,'delete from transaction_total_check where cny = -1485 and jpy = -148500 and gbp = -1039.5 and eur = -164835 and  hkd = -1336.5','')")

    con:query("insert into check_sql values(-1484,'delete from transaction_total_check where cny = -1484 and jpy = -148400 and gbp = -1038.8 and eur = -164724 and  hkd = -1335.6','')")

    con:query("insert into check_sql values(-1483,'delete from transaction_total_check where cny = -1483 and jpy = -148300 and gbp = -1038.1 and eur = -164613 and  hkd = -1334.7','')")

    con:query("insert into check_sql values(-1482,'delete from transaction_total_check where cny = -1482 and jpy = -148200 and gbp = -1037.4 and eur = -164502 and  hkd = -1333.8','')")

    con:query("insert into check_sql values(-1481,'delete from transaction_total_check where cny = -1481 and jpy = -148100 and gbp = -1036.7 and eur = -164391 and  hkd = -1332.9','')")

    con:query("insert into check_sql values(-1480,'delete from transaction_total_check where cny = -1480 and jpy = -148000 and gbp = -1036.0 and eur = -164280 and  hkd = -1332.0','')")

    con:query("insert into check_sql values(-1479,'delete from transaction_total_check where cny = -1479 and jpy = -147900 and gbp = -1035.3 and eur = -164169 and  hkd = -1331.1','')")

    con:query("insert into check_sql values(-1478,'delete from transaction_total_check where cny = -1478 and jpy = -147800 and gbp = -1034.6 and eur = -164058 and  hkd = -1330.2','')")

    con:query("insert into check_sql values(-1477,'delete from transaction_total_check where cny = -1477 and jpy = -147700 and gbp = -1033.9 and eur = -163947 and  hkd = -1329.3','')")

    con:query("insert into check_sql values(-1476,'delete from transaction_total_check where cny = -1476 and jpy = -147600 and gbp = -1033.2 and eur = -163836 and  hkd = -1328.4','')")

    con:query("insert into check_sql values(-1475,'delete from transaction_total_check where cny = -1475 and jpy = -147500 and gbp = -1032.5 and eur = -163725 and  hkd = -1327.5','')")

    con:query("insert into check_sql values(-1474,'delete from transaction_total_check where cny = -1474 and jpy = -147400 and gbp = -1031.8 and eur = -163614 and  hkd = -1326.6','')")

    con:query("insert into check_sql values(-1473,'delete from transaction_total_check where cny = -1473 and jpy = -147300 and gbp = -1031.1 and eur = -163503 and  hkd = -1325.7','')")

    con:query("insert into check_sql values(-1472,'delete from transaction_total_check where cny = -1472 and jpy = -147200 and gbp = -1030.4 and eur = -163392 and  hkd = -1324.8','')")

    con:query("insert into check_sql values(-1471,'delete from transaction_total_check where cny = -1471 and jpy = -147100 and gbp = -1029.7 and eur = -163281 and  hkd = -1323.9','')")

    con:query("insert into check_sql values(-1470,'delete from transaction_total_check where cny = -1470 and jpy = -147000 and gbp = -1029.0 and eur = -163170 and  hkd = -1323.0','')")

    con:query("insert into check_sql values(-1469,'delete from transaction_total_check where cny = -1469 and jpy = -146900 and gbp = -1028.3 and eur = -163059 and  hkd = -1322.1','')")

    con:query("insert into check_sql values(-1468,'delete from transaction_total_check where cny = -1468 and jpy = -146800 and gbp = -1027.6 and eur = -162948 and  hkd = -1321.2','')")

    con:query("insert into check_sql values(-1467,'delete from transaction_total_check where cny = -1467 and jpy = -146700 and gbp = -1026.9 and eur = -162837 and  hkd = -1320.3','')")

    con:query("insert into check_sql values(-1466,'delete from transaction_total_check where cny = -1466 and jpy = -146600 and gbp = -1026.2 and eur = -162726 and  hkd = -1319.4','')")

    con:query("insert into check_sql values(-1465,'delete from transaction_total_check where cny = -1465 and jpy = -146500 and gbp = -1025.5 and eur = -162615 and  hkd = -1318.5','')")

    con:query("insert into check_sql values(-1464,'delete from transaction_total_check where cny = -1464 and jpy = -146400 and gbp = -1024.8 and eur = -162504 and  hkd = -1317.6','')")

    con:query("insert into check_sql values(-1463,'delete from transaction_total_check where cny = -1463 and jpy = -146300 and gbp = -1024.1 and eur = -162393 and  hkd = -1316.7','')")

    con:query("insert into check_sql values(-1462,'delete from transaction_total_check where cny = -1462 and jpy = -146200 and gbp = -1023.4 and eur = -162282 and  hkd = -1315.8','')")

    con:query("insert into check_sql values(-1461,'delete from transaction_total_check where cny = -1461 and jpy = -146100 and gbp = -1022.7 and eur = -162171 and  hkd = -1314.9','')")

    con:query("insert into check_sql values(-1460,'delete from transaction_total_check where cny = -1460 and jpy = -146000 and gbp = -1022.0 and eur = -162060 and  hkd = -1314.0','')")

    con:query("insert into check_sql values(-1459,'delete from transaction_total_check where cny = -1459 and jpy = -145900 and gbp = -1021.3 and eur = -161949 and  hkd = -1313.1','')")

    con:query("insert into check_sql values(-1458,'delete from transaction_total_check where cny = -1458 and jpy = -145800 and gbp = -1020.6 and eur = -161838 and  hkd = -1312.2','')")

    con:query("insert into check_sql values(-1457,'delete from transaction_total_check where cny = -1457 and jpy = -145700 and gbp = -1019.9 and eur = -161727 and  hkd = -1311.3','')")

    con:query("insert into check_sql values(-1456,'delete from transaction_total_check where cny = -1456 and jpy = -145600 and gbp = -1019.2 and eur = -161616 and  hkd = -1310.4','')")

    con:query("insert into check_sql values(-1455,'delete from transaction_total_check where cny = -1455 and jpy = -145500 and gbp = -1018.5 and eur = -161505 and  hkd = -1309.5','')")

    con:query("insert into check_sql values(-1454,'delete from transaction_total_check where cny = -1454 and jpy = -145400 and gbp = -1017.8 and eur = -161394 and  hkd = -1308.6','')")

    con:query("insert into check_sql values(-1453,'delete from transaction_total_check where cny = -1453 and jpy = -145300 and gbp = -1017.1 and eur = -161283 and  hkd = -1307.7','')")

    con:query("insert into check_sql values(-1452,'delete from transaction_total_check where cny = -1452 and jpy = -145200 and gbp = -1016.4 and eur = -161172 and  hkd = -1306.8','')")

    con:query("insert into check_sql values(-1451,'delete from transaction_total_check where cny = -1451 and jpy = -145100 and gbp = -1015.7 and eur = -161061 and  hkd = -1305.9','')")

    con:query("insert into check_sql values(-1450,'delete from transaction_total_check where cny = -1450 and jpy = -145000 and gbp = -1015.0 and eur = -160950 and  hkd = -1305.0','')")

    con:query("insert into check_sql values(-1449,'delete from transaction_total_check where cny = -1449 and jpy = -144900 and gbp = -1014.3 and eur = -160839 and  hkd = -1304.1','')")

    con:query("insert into check_sql values(-1448,'delete from transaction_total_check where cny = -1448 and jpy = -144800 and gbp = -1013.6 and eur = -160728 and  hkd = -1303.2','')")

    con:query("insert into check_sql values(-1447,'delete from transaction_total_check where cny = -1447 and jpy = -144700 and gbp = -1012.9 and eur = -160617 and  hkd = -1302.3','')")

    con:query("insert into check_sql values(-1446,'delete from transaction_total_check where cny = -1446 and jpy = -144600 and gbp = -1012.2 and eur = -160506 and  hkd = -1301.4','')")

    con:query("insert into check_sql values(-1445,'delete from transaction_total_check where cny = -1445 and jpy = -144500 and gbp = -1011.5 and eur = -160395 and  hkd = -1300.5','')")

    con:query("insert into check_sql values(-1444,'delete from transaction_total_check where cny = -1444 and jpy = -144400 and gbp = -1010.8 and eur = -160284 and  hkd = -1299.6','')")

    con:query("insert into check_sql values(-1443,'delete from transaction_total_check where cny = -1443 and jpy = -144300 and gbp = -1010.1 and eur = -160173 and  hkd = -1298.7','')")

    con:query("insert into check_sql values(-1442,'delete from transaction_total_check where cny = -1442 and jpy = -144200 and gbp = -1009.4 and eur = -160062 and  hkd = -1297.8','')")

    con:query("insert into check_sql values(-1441,'delete from transaction_total_check where cny = -1441 and jpy = -144100 and gbp = -1008.7 and eur = -159951 and  hkd = -1296.9','')")

    con:query("insert into check_sql values(-1440,'delete from transaction_total_check where cny = -1440 and jpy = -144000 and gbp = -1008.0 and eur = -159840 and  hkd = -1296.0','')")

    con:query("insert into check_sql values(-1439,'delete from transaction_total_check where cny = -1439 and jpy = -143900 and gbp = -1007.3 and eur = -159729 and  hkd = -1295.1','')")

    con:query("insert into check_sql values(-1438,'delete from transaction_total_check where cny = -1438 and jpy = -143800 and gbp = -1006.6 and eur = -159618 and  hkd = -1294.2','')")

    con:query("insert into check_sql values(-1437,'delete from transaction_total_check where cny = -1437 and jpy = -143700 and gbp = -1005.9 and eur = -159507 and  hkd = -1293.3','')")

    con:query("insert into check_sql values(-1436,'delete from transaction_total_check where cny = -1436 and jpy = -143600 and gbp = -1005.2 and eur = -159396 and  hkd = -1292.4','')")

    con:query("insert into check_sql values(-1435,'delete from transaction_total_check where cny = -1435 and jpy = -143500 and gbp = -1004.5 and eur = -159285 and  hkd = -1291.5','')")

    con:query("insert into check_sql values(-1434,'delete from transaction_total_check where cny = -1434 and jpy = -143400 and gbp = -1003.8 and eur = -159174 and  hkd = -1290.6','')")

    con:query("insert into check_sql values(-1433,'delete from transaction_total_check where cny = -1433 and jpy = -143300 and gbp = -1003.1 and eur = -159063 and  hkd = -1289.7','')")

    con:query("insert into check_sql values(-1432,'delete from transaction_total_check where cny = -1432 and jpy = -143200 and gbp = -1002.4 and eur = -158952 and  hkd = -1288.8','')")

    con:query("insert into check_sql values(-1431,'delete from transaction_total_check where cny = -1431 and jpy = -143100 and gbp = -1001.7 and eur = -158841 and  hkd = -1287.9','')")

    con:query("insert into check_sql values(-1430,'delete from transaction_total_check where cny = -1430 and jpy = -143000 and gbp = -1001.0 and eur = -158730 and  hkd = -1287.0','')")

    con:query("insert into check_sql values(-1429,'delete from transaction_total_check where cny = -1429 and jpy = -142900 and gbp = -1000.3 and eur = -158619 and  hkd = -1286.1','')")

    con:query("insert into check_sql values(-1428,'delete from transaction_total_check where cny = -1428 and jpy = -142800 and gbp = -999.6 and eur = -158508 and  hkd = -1285.2','')")

    con:query("insert into check_sql values(-1427,'delete from transaction_total_check where cny = -1427 and jpy = -142700 and gbp = -998.9 and eur = -158397 and  hkd = -1284.3','')")

    con:query("insert into check_sql values(-1426,'delete from transaction_total_check where cny = -1426 and jpy = -142600 and gbp = -998.2 and eur = -158286 and  hkd = -1283.4','')")

    con:query("insert into check_sql values(-1425,'delete from transaction_total_check where cny = -1425 and jpy = -142500 and gbp = -997.5 and eur = -158175 and  hkd = -1282.5','')")

    con:query("insert into check_sql values(-1424,'delete from transaction_total_check where cny = -1424 and jpy = -142400 and gbp = -996.8 and eur = -158064 and  hkd = -1281.6','')")

    con:query("insert into check_sql values(-1423,'delete from transaction_total_check where cny = -1423 and jpy = -142300 and gbp = -996.1 and eur = -157953 and  hkd = -1280.7','')")

    con:query("insert into check_sql values(-1422,'delete from transaction_total_check where cny = -1422 and jpy = -142200 and gbp = -995.4 and eur = -157842 and  hkd = -1279.8','')")

    con:query("insert into check_sql values(-1421,'delete from transaction_total_check where cny = -1421 and jpy = -142100 and gbp = -994.7 and eur = -157731 and  hkd = -1278.9','')")

    con:query("insert into check_sql values(-1420,'delete from transaction_total_check where cny = -1420 and jpy = -142000 and gbp = -994.0 and eur = -157620 and  hkd = -1278.0','')")

    con:query("insert into check_sql values(-1419,'delete from transaction_total_check where cny = -1419 and jpy = -141900 and gbp = -993.3 and eur = -157509 and  hkd = -1277.1','')")

    con:query("insert into check_sql values(-1418,'delete from transaction_total_check where cny = -1418 and jpy = -141800 and gbp = -992.6 and eur = -157398 and  hkd = -1276.2','')")

    con:query("insert into check_sql values(-1417,'delete from transaction_total_check where cny = -1417 and jpy = -141700 and gbp = -991.9 and eur = -157287 and  hkd = -1275.3','')")

    con:query("insert into check_sql values(-1416,'delete from transaction_total_check where cny = -1416 and jpy = -141600 and gbp = -991.2 and eur = -157176 and  hkd = -1274.4','')")

    con:query("insert into check_sql values(-1415,'delete from transaction_total_check where cny = -1415 and jpy = -141500 and gbp = -990.5 and eur = -157065 and  hkd = -1273.5','')")

    con:query("insert into check_sql values(-1414,'delete from transaction_total_check where cny = -1414 and jpy = -141400 and gbp = -989.8 and eur = -156954 and  hkd = -1272.6','')")

    con:query("insert into check_sql values(-1413,'delete from transaction_total_check where cny = -1413 and jpy = -141300 and gbp = -989.1 and eur = -156843 and  hkd = -1271.7','')")

    con:query("insert into check_sql values(-1412,'delete from transaction_total_check where cny = -1412 and jpy = -141200 and gbp = -988.4 and eur = -156732 and  hkd = -1270.8','')")

    con:query("insert into check_sql values(-1411,'delete from transaction_total_check where cny = -1411 and jpy = -141100 and gbp = -987.7 and eur = -156621 and  hkd = -1269.9','')")

    con:query("insert into check_sql values(-1410,'delete from transaction_total_check where cny = -1410 and jpy = -141000 and gbp = -987.0 and eur = -156510 and  hkd = -1269.0','')")

    con:query("insert into check_sql values(-1409,'delete from transaction_total_check where cny = -1409 and jpy = -140900 and gbp = -986.3 and eur = -156399 and  hkd = -1268.1','')")

    con:query("insert into check_sql values(-1408,'delete from transaction_total_check where cny = -1408 and jpy = -140800 and gbp = -985.6 and eur = -156288 and  hkd = -1267.2','')")

    con:query("insert into check_sql values(-1407,'delete from transaction_total_check where cny = -1407 and jpy = -140700 and gbp = -984.9 and eur = -156177 and  hkd = -1266.3','')")

    con:query("insert into check_sql values(-1406,'delete from transaction_total_check where cny = -1406 and jpy = -140600 and gbp = -984.2 and eur = -156066 and  hkd = -1265.4','')")

    con:query("insert into check_sql values(-1405,'delete from transaction_total_check where cny = -1405 and jpy = -140500 and gbp = -983.5 and eur = -155955 and  hkd = -1264.5','')")

    con:query("insert into check_sql values(-1404,'delete from transaction_total_check where cny = -1404 and jpy = -140400 and gbp = -982.8 and eur = -155844 and  hkd = -1263.6','')")

    con:query("insert into check_sql values(-1403,'delete from transaction_total_check where cny = -1403 and jpy = -140300 and gbp = -982.1 and eur = -155733 and  hkd = -1262.7','')")

    con:query("insert into check_sql values(-1402,'delete from transaction_total_check where cny = -1402 and jpy = -140200 and gbp = -981.4 and eur = -155622 and  hkd = -1261.8','')")

    con:query("insert into check_sql values(-1401,'delete from transaction_total_check where cny = -1401 and jpy = -140100 and gbp = -980.7 and eur = -155511 and  hkd = -1260.9','')")

    con:query("insert into check_sql values(-1400,'delete from transaction_total_check where cny = -1400 and jpy = -140000 and gbp = -980.0 and eur = -155400 and  hkd = -1260.0','')")

    con:query("insert into check_sql values(-1399,'delete from transaction_total_check where cny = -1399 and jpy = -139900 and gbp = -979.3 and eur = -155289 and  hkd = -1259.1','')")

    con:query("insert into check_sql values(-1398,'delete from transaction_total_check where cny = -1398 and jpy = -139800 and gbp = -978.6 and eur = -155178 and  hkd = -1258.2','')")

    con:query("insert into check_sql values(-1397,'delete from transaction_total_check where cny = -1397 and jpy = -139700 and gbp = -977.9 and eur = -155067 and  hkd = -1257.3','')")

    con:query("insert into check_sql values(-1396,'delete from transaction_total_check where cny = -1396 and jpy = -139600 and gbp = -977.2 and eur = -154956 and  hkd = -1256.4','')")

    con:query("insert into check_sql values(-1395,'delete from transaction_total_check where cny = -1395 and jpy = -139500 and gbp = -976.5 and eur = -154845 and  hkd = -1255.5','')")

    con:query("insert into check_sql values(-1394,'delete from transaction_total_check where cny = -1394 and jpy = -139400 and gbp = -975.8 and eur = -154734 and  hkd = -1254.6','')")

    con:query("insert into check_sql values(-1393,'delete from transaction_total_check where cny = -1393 and jpy = -139300 and gbp = -975.1 and eur = -154623 and  hkd = -1253.7','')")

    con:query("insert into check_sql values(-1392,'delete from transaction_total_check where cny = -1392 and jpy = -139200 and gbp = -974.4 and eur = -154512 and  hkd = -1252.8','')")

    con:query("insert into check_sql values(-1391,'delete from transaction_total_check where cny = -1391 and jpy = -139100 and gbp = -973.7 and eur = -154401 and  hkd = -1251.9','')")

    con:query("insert into check_sql values(-1390,'delete from transaction_total_check where cny = -1390 and jpy = -139000 and gbp = -973.0 and eur = -154290 and  hkd = -1251.0','')")

    con:query("insert into check_sql values(-1389,'delete from transaction_total_check where cny = -1389 and jpy = -138900 and gbp = -972.3 and eur = -154179 and  hkd = -1250.1','')")

    con:query("insert into check_sql values(-1388,'delete from transaction_total_check where cny = -1388 and jpy = -138800 and gbp = -971.6 and eur = -154068 and  hkd = -1249.2','')")

    con:query("insert into check_sql values(-1387,'delete from transaction_total_check where cny = -1387 and jpy = -138700 and gbp = -970.9 and eur = -153957 and  hkd = -1248.3','')")

    con:query("insert into check_sql values(-1386,'delete from transaction_total_check where cny = -1386 and jpy = -138600 and gbp = -970.2 and eur = -153846 and  hkd = -1247.4','')")

    con:query("insert into check_sql values(-1385,'delete from transaction_total_check where cny = -1385 and jpy = -138500 and gbp = -969.5 and eur = -153735 and  hkd = -1246.5','')")

    con:query("insert into check_sql values(-1384,'delete from transaction_total_check where cny = -1384 and jpy = -138400 and gbp = -968.8 and eur = -153624 and  hkd = -1245.6','')")

    con:query("insert into check_sql values(-1383,'delete from transaction_total_check where cny = -1383 and jpy = -138300 and gbp = -968.1 and eur = -153513 and  hkd = -1244.7','')")

    con:query("insert into check_sql values(-1382,'delete from transaction_total_check where cny = -1382 and jpy = -138200 and gbp = -967.4 and eur = -153402 and  hkd = -1243.8','')")

    con:query("insert into check_sql values(-1381,'delete from transaction_total_check where cny = -1381 and jpy = -138100 and gbp = -966.7 and eur = -153291 and  hkd = -1242.9','')")

    con:query("insert into check_sql values(-1380,'delete from transaction_total_check where cny = -1380 and jpy = -138000 and gbp = -966.0 and eur = -153180 and  hkd = -1242.0','')")

    con:query("insert into check_sql values(-1379,'delete from transaction_total_check where cny = -1379 and jpy = -137900 and gbp = -965.3 and eur = -153069 and  hkd = -1241.1','')")

    con:query("insert into check_sql values(-1378,'delete from transaction_total_check where cny = -1378 and jpy = -137800 and gbp = -964.6 and eur = -152958 and  hkd = -1240.2','')")

    con:query("insert into check_sql values(-1377,'delete from transaction_total_check where cny = -1377 and jpy = -137700 and gbp = -963.9 and eur = -152847 and  hkd = -1239.3','')")

    con:query("insert into check_sql values(-1376,'delete from transaction_total_check where cny = -1376 and jpy = -137600 and gbp = -963.2 and eur = -152736 and  hkd = -1238.4','')")

    con:query("insert into check_sql values(-1375,'delete from transaction_total_check where cny = -1375 and jpy = -137500 and gbp = -962.5 and eur = -152625 and  hkd = -1237.5','')")

    con:query("insert into check_sql values(-1374,'delete from transaction_total_check where cny = -1374 and jpy = -137400 and gbp = -961.8 and eur = -152514 and  hkd = -1236.6','')")

    con:query("insert into check_sql values(-1373,'delete from transaction_total_check where cny = -1373 and jpy = -137300 and gbp = -961.1 and eur = -152403 and  hkd = -1235.7','')")

    con:query("insert into check_sql values(-1372,'delete from transaction_total_check where cny = -1372 and jpy = -137200 and gbp = -960.4 and eur = -152292 and  hkd = -1234.8','')")

    con:query("insert into check_sql values(-1371,'delete from transaction_total_check where cny = -1371 and jpy = -137100 and gbp = -959.7 and eur = -152181 and  hkd = -1233.9','')")

    con:query("insert into check_sql values(-1370,'delete from transaction_total_check where cny = -1370 and jpy = -137000 and gbp = -959.0 and eur = -152070 and  hkd = -1233.0','')")

    con:query("insert into check_sql values(-1369,'delete from transaction_total_check where cny = -1369 and jpy = -136900 and gbp = -958.3 and eur = -151959 and  hkd = -1232.1','')")

    con:query("insert into check_sql values(-1368,'delete from transaction_total_check where cny = -1368 and jpy = -136800 and gbp = -957.6 and eur = -151848 and  hkd = -1231.2','')")

    con:query("insert into check_sql values(-1367,'delete from transaction_total_check where cny = -1367 and jpy = -136700 and gbp = -956.9 and eur = -151737 and  hkd = -1230.3','')")

    con:query("insert into check_sql values(-1366,'delete from transaction_total_check where cny = -1366 and jpy = -136600 and gbp = -956.2 and eur = -151626 and  hkd = -1229.4','')")

    con:query("insert into check_sql values(-1365,'delete from transaction_total_check where cny = -1365 and jpy = -136500 and gbp = -955.5 and eur = -151515 and  hkd = -1228.5','')")

    con:query("insert into check_sql values(-1364,'delete from transaction_total_check where cny = -1364 and jpy = -136400 and gbp = -954.8 and eur = -151404 and  hkd = -1227.6','')")

    con:query("insert into check_sql values(-1363,'delete from transaction_total_check where cny = -1363 and jpy = -136300 and gbp = -954.1 and eur = -151293 and  hkd = -1226.7','')")

    con:query("insert into check_sql values(-1362,'delete from transaction_total_check where cny = -1362 and jpy = -136200 and gbp = -953.4 and eur = -151182 and  hkd = -1225.8','')")

    con:query("insert into check_sql values(-1361,'delete from transaction_total_check where cny = -1361 and jpy = -136100 and gbp = -952.7 and eur = -151071 and  hkd = -1224.9','')")

    con:query("insert into check_sql values(-1360,'delete from transaction_total_check where cny = -1360 and jpy = -136000 and gbp = -952.0 and eur = -150960 and  hkd = -1224.0','')")

    con:query("insert into check_sql values(-1359,'delete from transaction_total_check where cny = -1359 and jpy = -135900 and gbp = -951.3 and eur = -150849 and  hkd = -1223.1','')")

    con:query("insert into check_sql values(-1358,'delete from transaction_total_check where cny = -1358 and jpy = -135800 and gbp = -950.6 and eur = -150738 and  hkd = -1222.2','')")

    con:query("insert into check_sql values(-1357,'delete from transaction_total_check where cny = -1357 and jpy = -135700 and gbp = -949.9 and eur = -150627 and  hkd = -1221.3','')")

    con:query("insert into check_sql values(-1356,'delete from transaction_total_check where cny = -1356 and jpy = -135600 and gbp = -949.2 and eur = -150516 and  hkd = -1220.4','')")

    con:query("insert into check_sql values(-1355,'delete from transaction_total_check where cny = -1355 and jpy = -135500 and gbp = -948.5 and eur = -150405 and  hkd = -1219.5','')")

    con:query("insert into check_sql values(-1354,'delete from transaction_total_check where cny = -1354 and jpy = -135400 and gbp = -947.8 and eur = -150294 and  hkd = -1218.6','')")

    con:query("insert into check_sql values(-1353,'delete from transaction_total_check where cny = -1353 and jpy = -135300 and gbp = -947.1 and eur = -150183 and  hkd = -1217.7','')")

    con:query("insert into check_sql values(-1352,'delete from transaction_total_check where cny = -1352 and jpy = -135200 and gbp = -946.4 and eur = -150072 and  hkd = -1216.8','')")

    con:query("insert into check_sql values(-1351,'delete from transaction_total_check where cny = -1351 and jpy = -135100 and gbp = -945.7 and eur = -149961 and  hkd = -1215.9','')")

    con:query("insert into check_sql values(-1350,'delete from transaction_total_check where cny = -1350 and jpy = -135000 and gbp = -945.0 and eur = -149850 and  hkd = -1215.0','')")

    con:query("insert into check_sql values(-1349,'delete from transaction_total_check where cny = -1349 and jpy = -134900 and gbp = -944.3 and eur = -149739 and  hkd = -1214.1','')")

    con:query("insert into check_sql values(-1348,'delete from transaction_total_check where cny = -1348 and jpy = -134800 and gbp = -943.6 and eur = -149628 and  hkd = -1213.2','')")

    con:query("insert into check_sql values(-1347,'delete from transaction_total_check where cny = -1347 and jpy = -134700 and gbp = -942.9 and eur = -149517 and  hkd = -1212.3','')")

    con:query("insert into check_sql values(-1346,'delete from transaction_total_check where cny = -1346 and jpy = -134600 and gbp = -942.2 and eur = -149406 and  hkd = -1211.4','')")

    con:query("insert into check_sql values(-1345,'delete from transaction_total_check where cny = -1345 and jpy = -134500 and gbp = -941.5 and eur = -149295 and  hkd = -1210.5','')")

    con:query("insert into check_sql values(-1344,'delete from transaction_total_check where cny = -1344 and jpy = -134400 and gbp = -940.8 and eur = -149184 and  hkd = -1209.6','')")

    con:query("insert into check_sql values(-1343,'delete from transaction_total_check where cny = -1343 and jpy = -134300 and gbp = -940.1 and eur = -149073 and  hkd = -1208.7','')")

    con:query("insert into check_sql values(-1342,'delete from transaction_total_check where cny = -1342 and jpy = -134200 and gbp = -939.4 and eur = -148962 and  hkd = -1207.8','')")

    con:query("insert into check_sql values(-1341,'delete from transaction_total_check where cny = -1341 and jpy = -134100 and gbp = -938.7 and eur = -148851 and  hkd = -1206.9','')")

    con:query("insert into check_sql values(-1340,'delete from transaction_total_check where cny = -1340 and jpy = -134000 and gbp = -938.0 and eur = -148740 and  hkd = -1206.0','')")

    con:query("insert into check_sql values(-1339,'delete from transaction_total_check where cny = -1339 and jpy = -133900 and gbp = -937.3 and eur = -148629 and  hkd = -1205.1','')")

    con:query("insert into check_sql values(-1338,'delete from transaction_total_check where cny = -1338 and jpy = -133800 and gbp = -936.6 and eur = -148518 and  hkd = -1204.2','')")

    con:query("insert into check_sql values(-1337,'delete from transaction_total_check where cny = -1337 and jpy = -133700 and gbp = -935.9 and eur = -148407 and  hkd = -1203.3','')")

    con:query("insert into check_sql values(-1336,'delete from transaction_total_check where cny = -1336 and jpy = -133600 and gbp = -935.2 and eur = -148296 and  hkd = -1202.4','')")

    con:query("insert into check_sql values(-1335,'delete from transaction_total_check where cny = -1335 and jpy = -133500 and gbp = -934.5 and eur = -148185 and  hkd = -1201.5','')")

    con:query("insert into check_sql values(-1334,'delete from transaction_total_check where cny = -1334 and jpy = -133400 and gbp = -933.8 and eur = -148074 and  hkd = -1200.6','')")

    con:query("insert into check_sql values(-1333,'delete from transaction_total_check where cny = -1333 and jpy = -133300 and gbp = -933.1 and eur = -147963 and  hkd = -1199.7','')")

    con:query("insert into check_sql values(-1332,'delete from transaction_total_check where cny = -1332 and jpy = -133200 and gbp = -932.4 and eur = -147852 and  hkd = -1198.8','')")

    con:query("insert into check_sql values(-1331,'delete from transaction_total_check where cny = -1331 and jpy = -133100 and gbp = -931.7 and eur = -147741 and  hkd = -1197.9','')")

    con:query("insert into check_sql values(-1330,'delete from transaction_total_check where cny = -1330 and jpy = -133000 and gbp = -931.0 and eur = -147630 and  hkd = -1197.0','')")

    con:query("insert into check_sql values(-1329,'delete from transaction_total_check where cny = -1329 and jpy = -132900 and gbp = -930.3 and eur = -147519 and  hkd = -1196.1','')")

    con:query("insert into check_sql values(-1328,'delete from transaction_total_check where cny = -1328 and jpy = -132800 and gbp = -929.6 and eur = -147408 and  hkd = -1195.2','')")

    con:query("insert into check_sql values(-1327,'delete from transaction_total_check where cny = -1327 and jpy = -132700 and gbp = -928.9 and eur = -147297 and  hkd = -1194.3','')")

    con:query("insert into check_sql values(-1326,'delete from transaction_total_check where cny = -1326 and jpy = -132600 and gbp = -928.2 and eur = -147186 and  hkd = -1193.4','')")

    con:query("insert into check_sql values(-1325,'delete from transaction_total_check where cny = -1325 and jpy = -132500 and gbp = -927.5 and eur = -147075 and  hkd = -1192.5','')")

    con:query("insert into check_sql values(-1324,'delete from transaction_total_check where cny = -1324 and jpy = -132400 and gbp = -926.8 and eur = -146964 and  hkd = -1191.6','')")

    con:query("insert into check_sql values(-1323,'delete from transaction_total_check where cny = -1323 and jpy = -132300 and gbp = -926.1 and eur = -146853 and  hkd = -1190.7','')")

    con:query("insert into check_sql values(-1322,'delete from transaction_total_check where cny = -1322 and jpy = -132200 and gbp = -925.4 and eur = -146742 and  hkd = -1189.8','')")

    con:query("insert into check_sql values(-1321,'delete from transaction_total_check where cny = -1321 and jpy = -132100 and gbp = -924.7 and eur = -146631 and  hkd = -1188.9','')")

    con:query("insert into check_sql values(-1320,'delete from transaction_total_check where cny = -1320 and jpy = -132000 and gbp = -924.0 and eur = -146520 and  hkd = -1188.0','')")

    con:query("insert into check_sql values(-1319,'delete from transaction_total_check where cny = -1319 and jpy = -131900 and gbp = -923.3 and eur = -146409 and  hkd = -1187.1','')")

    con:query("insert into check_sql values(-1318,'delete from transaction_total_check where cny = -1318 and jpy = -131800 and gbp = -922.6 and eur = -146298 and  hkd = -1186.2','')")

    con:query("insert into check_sql values(-1317,'delete from transaction_total_check where cny = -1317 and jpy = -131700 and gbp = -921.9 and eur = -146187 and  hkd = -1185.3','')")

    con:query("insert into check_sql values(-1316,'delete from transaction_total_check where cny = -1316 and jpy = -131600 and gbp = -921.2 and eur = -146076 and  hkd = -1184.4','')")

    con:query("insert into check_sql values(-1315,'delete from transaction_total_check where cny = -1315 and jpy = -131500 and gbp = -920.5 and eur = -145965 and  hkd = -1183.5','')")

    con:query("insert into check_sql values(-1314,'delete from transaction_total_check where cny = -1314 and jpy = -131400 and gbp = -919.8 and eur = -145854 and  hkd = -1182.6','')")

    con:query("insert into check_sql values(-1313,'delete from transaction_total_check where cny = -1313 and jpy = -131300 and gbp = -919.1 and eur = -145743 and  hkd = -1181.7','')")

    con:query("insert into check_sql values(-1312,'delete from transaction_total_check where cny = -1312 and jpy = -131200 and gbp = -918.4 and eur = -145632 and  hkd = -1180.8','')")

    con:query("insert into check_sql values(-1311,'delete from transaction_total_check where cny = -1311 and jpy = -131100 and gbp = -917.7 and eur = -145521 and  hkd = -1179.9','')")

    con:query("insert into check_sql values(-1310,'delete from transaction_total_check where cny = -1310 and jpy = -131000 and gbp = -917.0 and eur = -145410 and  hkd = -1179.0','')")

    con:query("insert into check_sql values(-1309,'delete from transaction_total_check where cny = -1309 and jpy = -130900 and gbp = -916.3 and eur = -145299 and  hkd = -1178.1','')")

    con:query("insert into check_sql values(-1308,'delete from transaction_total_check where cny = -1308 and jpy = -130800 and gbp = -915.6 and eur = -145188 and  hkd = -1177.2','')")

    con:query("insert into check_sql values(-1307,'delete from transaction_total_check where cny = -1307 and jpy = -130700 and gbp = -914.9 and eur = -145077 and  hkd = -1176.3','')")

    con:query("insert into check_sql values(-1306,'delete from transaction_total_check where cny = -1306 and jpy = -130600 and gbp = -914.2 and eur = -144966 and  hkd = -1175.4','')")

    con:query("insert into check_sql values(-1305,'delete from transaction_total_check where cny = -1305 and jpy = -130500 and gbp = -913.5 and eur = -144855 and  hkd = -1174.5','')")

    con:query("insert into check_sql values(-1304,'delete from transaction_total_check where cny = -1304 and jpy = -130400 and gbp = -912.8 and eur = -144744 and  hkd = -1173.6','')")

    con:query("insert into check_sql values(-1303,'delete from transaction_total_check where cny = -1303 and jpy = -130300 and gbp = -912.1 and eur = -144633 and  hkd = -1172.7','')")

    con:query("insert into check_sql values(-1302,'delete from transaction_total_check where cny = -1302 and jpy = -130200 and gbp = -911.4 and eur = -144522 and  hkd = -1171.8','')")

    con:query("insert into check_sql values(-1301,'delete from transaction_total_check where cny = -1301 and jpy = -130100 and gbp = -910.7 and eur = -144411 and  hkd = -1170.9','')")

    con:query("insert into check_sql values(-1300,'delete from transaction_total_check where cny = -1300 and jpy = -130000 and gbp = -910.0 and eur = -144300 and  hkd = -1170.0','')")

    con:query("insert into check_sql values(-1299,'delete from transaction_total_check where cny = -1299 and jpy = -129900 and gbp = -909.3 and eur = -144189 and  hkd = -1169.1','')")

    con:query("insert into check_sql values(-1298,'delete from transaction_total_check where cny = -1298 and jpy = -129800 and gbp = -908.6 and eur = -144078 and  hkd = -1168.2','')")

    con:query("insert into check_sql values(-1297,'delete from transaction_total_check where cny = -1297 and jpy = -129700 and gbp = -907.9 and eur = -143967 and  hkd = -1167.3','')")

    con:query("insert into check_sql values(-1296,'delete from transaction_total_check where cny = -1296 and jpy = -129600 and gbp = -907.2 and eur = -143856 and  hkd = -1166.4','')")

    con:query("insert into check_sql values(-1295,'delete from transaction_total_check where cny = -1295 and jpy = -129500 and gbp = -906.5 and eur = -143745 and  hkd = -1165.5','')")

    con:query("insert into check_sql values(-1294,'delete from transaction_total_check where cny = -1294 and jpy = -129400 and gbp = -905.8 and eur = -143634 and  hkd = -1164.6','')")

    con:query("insert into check_sql values(-1293,'delete from transaction_total_check where cny = -1293 and jpy = -129300 and gbp = -905.1 and eur = -143523 and  hkd = -1163.7','')")

    con:query("insert into check_sql values(-1292,'delete from transaction_total_check where cny = -1292 and jpy = -129200 and gbp = -904.4 and eur = -143412 and  hkd = -1162.8','')")

    con:query("insert into check_sql values(-1291,'delete from transaction_total_check where cny = -1291 and jpy = -129100 and gbp = -903.7 and eur = -143301 and  hkd = -1161.9','')")

    con:query("insert into check_sql values(-1290,'delete from transaction_total_check where cny = -1290 and jpy = -129000 and gbp = -903.0 and eur = -143190 and  hkd = -1161.0','')")

    con:query("insert into check_sql values(-1289,'delete from transaction_total_check where cny = -1289 and jpy = -128900 and gbp = -902.3 and eur = -143079 and  hkd = -1160.1','')")

    con:query("insert into check_sql values(-1288,'delete from transaction_total_check where cny = -1288 and jpy = -128800 and gbp = -901.6 and eur = -142968 and  hkd = -1159.2','')")

    con:query("insert into check_sql values(-1287,'delete from transaction_total_check where cny = -1287 and jpy = -128700 and gbp = -900.9 and eur = -142857 and  hkd = -1158.3','')")

    con:query("insert into check_sql values(-1286,'delete from transaction_total_check where cny = -1286 and jpy = -128600 and gbp = -900.2 and eur = -142746 and  hkd = -1157.4','')")

    con:query("insert into check_sql values(-1285,'delete from transaction_total_check where cny = -1285 and jpy = -128500 and gbp = -899.5 and eur = -142635 and  hkd = -1156.5','')")

    con:query("insert into check_sql values(-1284,'delete from transaction_total_check where cny = -1284 and jpy = -128400 and gbp = -898.8 and eur = -142524 and  hkd = -1155.6','')")

    con:query("insert into check_sql values(-1283,'delete from transaction_total_check where cny = -1283 and jpy = -128300 and gbp = -898.1 and eur = -142413 and  hkd = -1154.7','')")

    con:query("insert into check_sql values(-1282,'delete from transaction_total_check where cny = -1282 and jpy = -128200 and gbp = -897.4 and eur = -142302 and  hkd = -1153.8','')")

    con:query("insert into check_sql values(-1281,'delete from transaction_total_check where cny = -1281 and jpy = -128100 and gbp = -896.7 and eur = -142191 and  hkd = -1152.9','')")

    con:query("insert into check_sql values(-1280,'delete from transaction_total_check where cny = -1280 and jpy = -128000 and gbp = -896.0 and eur = -142080 and  hkd = -1152.0','')")

    con:query("insert into check_sql values(-1279,'delete from transaction_total_check where cny = -1279 and jpy = -127900 and gbp = -895.3 and eur = -141969 and  hkd = -1151.1','')")

    con:query("insert into check_sql values(-1278,'delete from transaction_total_check where cny = -1278 and jpy = -127800 and gbp = -894.6 and eur = -141858 and  hkd = -1150.2','')")

    con:query("insert into check_sql values(-1277,'delete from transaction_total_check where cny = -1277 and jpy = -127700 and gbp = -893.9 and eur = -141747 and  hkd = -1149.3','')")

    con:query("insert into check_sql values(-1276,'delete from transaction_total_check where cny = -1276 and jpy = -127600 and gbp = -893.2 and eur = -141636 and  hkd = -1148.4','')")

    con:query("insert into check_sql values(-1275,'delete from transaction_total_check where cny = -1275 and jpy = -127500 and gbp = -892.5 and eur = -141525 and  hkd = -1147.5','')")

    con:query("insert into check_sql values(-1274,'delete from transaction_total_check where cny = -1274 and jpy = -127400 and gbp = -891.8 and eur = -141414 and  hkd = -1146.6','')")

    con:query("insert into check_sql values(-1273,'delete from transaction_total_check where cny = -1273 and jpy = -127300 and gbp = -891.1 and eur = -141303 and  hkd = -1145.7','')")

    con:query("insert into check_sql values(-1272,'delete from transaction_total_check where cny = -1272 and jpy = -127200 and gbp = -890.4 and eur = -141192 and  hkd = -1144.8','')")

    con:query("insert into check_sql values(-1271,'delete from transaction_total_check where cny = -1271 and jpy = -127100 and gbp = -889.7 and eur = -141081 and  hkd = -1143.9','')")

    con:query("insert into check_sql values(-1270,'delete from transaction_total_check where cny = -1270 and jpy = -127000 and gbp = -889.0 and eur = -140970 and  hkd = -1143.0','')")

    con:query("insert into check_sql values(-1269,'delete from transaction_total_check where cny = -1269 and jpy = -126900 and gbp = -888.3 and eur = -140859 and  hkd = -1142.1','')")

    con:query("insert into check_sql values(-1268,'delete from transaction_total_check where cny = -1268 and jpy = -126800 and gbp = -887.6 and eur = -140748 and  hkd = -1141.2','')")

    con:query("insert into check_sql values(-1267,'delete from transaction_total_check where cny = -1267 and jpy = -126700 and gbp = -886.9 and eur = -140637 and  hkd = -1140.3','')")

    con:query("insert into check_sql values(-1266,'delete from transaction_total_check where cny = -1266 and jpy = -126600 and gbp = -886.2 and eur = -140526 and  hkd = -1139.4','')")

    con:query("insert into check_sql values(-1265,'delete from transaction_total_check where cny = -1265 and jpy = -126500 and gbp = -885.5 and eur = -140415 and  hkd = -1138.5','')")

    con:query("insert into check_sql values(-1264,'delete from transaction_total_check where cny = -1264 and jpy = -126400 and gbp = -884.8 and eur = -140304 and  hkd = -1137.6','')")

    con:query("insert into check_sql values(-1263,'delete from transaction_total_check where cny = -1263 and jpy = -126300 and gbp = -884.1 and eur = -140193 and  hkd = -1136.7','')")

    con:query("insert into check_sql values(-1262,'delete from transaction_total_check where cny = -1262 and jpy = -126200 and gbp = -883.4 and eur = -140082 and  hkd = -1135.8','')")

    con:query("insert into check_sql values(-1261,'delete from transaction_total_check where cny = -1261 and jpy = -126100 and gbp = -882.7 and eur = -139971 and  hkd = -1134.9','')")

    con:query("insert into check_sql values(-1260,'delete from transaction_total_check where cny = -1260 and jpy = -126000 and gbp = -882.0 and eur = -139860 and  hkd = -1134.0','')")

    con:query("insert into check_sql values(-1259,'delete from transaction_total_check where cny = -1259 and jpy = -125900 and gbp = -881.3 and eur = -139749 and  hkd = -1133.1','')")

    con:query("insert into check_sql values(-1258,'delete from transaction_total_check where cny = -1258 and jpy = -125800 and gbp = -880.6 and eur = -139638 and  hkd = -1132.2','')")

    con:query("insert into check_sql values(-1257,'delete from transaction_total_check where cny = -1257 and jpy = -125700 and gbp = -879.9 and eur = -139527 and  hkd = -1131.3','')")

    con:query("insert into check_sql values(-1256,'delete from transaction_total_check where cny = -1256 and jpy = -125600 and gbp = -879.2 and eur = -139416 and  hkd = -1130.4','')")

    con:query("insert into check_sql values(-1255,'delete from transaction_total_check where cny = -1255 and jpy = -125500 and gbp = -878.5 and eur = -139305 and  hkd = -1129.5','')")

    con:query("insert into check_sql values(-1254,'delete from transaction_total_check where cny = -1254 and jpy = -125400 and gbp = -877.8 and eur = -139194 and  hkd = -1128.6','')")

    con:query("insert into check_sql values(-1253,'delete from transaction_total_check where cny = -1253 and jpy = -125300 and gbp = -877.1 and eur = -139083 and  hkd = -1127.7','')")

    con:query("insert into check_sql values(-1252,'delete from transaction_total_check where cny = -1252 and jpy = -125200 and gbp = -876.4 and eur = -138972 and  hkd = -1126.8','')")

    con:query("insert into check_sql values(-1251,'delete from transaction_total_check where cny = -1251 and jpy = -125100 and gbp = -875.7 and eur = -138861 and  hkd = -1125.9','')")

    con:query("insert into check_sql values(-1250,'delete from transaction_total_check where cny = -1250 and jpy = -125000 and gbp = -875.0 and eur = -138750 and  hkd = -1125.0','')")

    con:query("insert into check_sql values(-1249,'delete from transaction_total_check where cny = -1249 and jpy = -124900 and gbp = -874.3 and eur = -138639 and  hkd = -1124.1','')")

    con:query("insert into check_sql values(-1248,'delete from transaction_total_check where cny = -1248 and jpy = -124800 and gbp = -873.6 and eur = -138528 and  hkd = -1123.2','')")

    con:query("insert into check_sql values(-1247,'delete from transaction_total_check where cny = -1247 and jpy = -124700 and gbp = -872.9 and eur = -138417 and  hkd = -1122.3','')")

    con:query("insert into check_sql values(-1246,'delete from transaction_total_check where cny = -1246 and jpy = -124600 and gbp = -872.2 and eur = -138306 and  hkd = -1121.4','')")

    con:query("insert into check_sql values(-1245,'delete from transaction_total_check where cny = -1245 and jpy = -124500 and gbp = -871.5 and eur = -138195 and  hkd = -1120.5','')")

    con:query("insert into check_sql values(-1244,'delete from transaction_total_check where cny = -1244 and jpy = -124400 and gbp = -870.8 and eur = -138084 and  hkd = -1119.6','')")

    con:query("insert into check_sql values(-1243,'delete from transaction_total_check where cny = -1243 and jpy = -124300 and gbp = -870.1 and eur = -137973 and  hkd = -1118.7','')")

    con:query("insert into check_sql values(-1242,'delete from transaction_total_check where cny = -1242 and jpy = -124200 and gbp = -869.4 and eur = -137862 and  hkd = -1117.8','')")

    con:query("insert into check_sql values(-1241,'delete from transaction_total_check where cny = -1241 and jpy = -124100 and gbp = -868.7 and eur = -137751 and  hkd = -1116.9','')")

    con:query("insert into check_sql values(-1240,'delete from transaction_total_check where cny = -1240 and jpy = -124000 and gbp = -868.0 and eur = -137640 and  hkd = -1116.0','')")

    con:query("insert into check_sql values(-1239,'delete from transaction_total_check where cny = -1239 and jpy = -123900 and gbp = -867.3 and eur = -137529 and  hkd = -1115.1','')")

    con:query("insert into check_sql values(-1238,'delete from transaction_total_check where cny = -1238 and jpy = -123800 and gbp = -866.6 and eur = -137418 and  hkd = -1114.2','')")

    con:query("insert into check_sql values(-1237,'delete from transaction_total_check where cny = -1237 and jpy = -123700 and gbp = -865.9 and eur = -137307 and  hkd = -1113.3','')")

    con:query("insert into check_sql values(-1236,'delete from transaction_total_check where cny = -1236 and jpy = -123600 and gbp = -865.2 and eur = -137196 and  hkd = -1112.4','')")

    con:query("insert into check_sql values(-1235,'delete from transaction_total_check where cny = -1235 and jpy = -123500 and gbp = -864.5 and eur = -137085 and  hkd = -1111.5','')")

    con:query("insert into check_sql values(-1234,'delete from transaction_total_check where cny = -1234 and jpy = -123400 and gbp = -863.8 and eur = -136974 and  hkd = -1110.6','')")

    con:query("insert into check_sql values(-1233,'delete from transaction_total_check where cny = -1233 and jpy = -123300 and gbp = -863.1 and eur = -136863 and  hkd = -1109.7','')")

    con:query("insert into check_sql values(-1232,'delete from transaction_total_check where cny = -1232 and jpy = -123200 and gbp = -862.4 and eur = -136752 and  hkd = -1108.8','')")

    con:query("insert into check_sql values(-1231,'delete from transaction_total_check where cny = -1231 and jpy = -123100 and gbp = -861.7 and eur = -136641 and  hkd = -1107.9','')")

    con:query("insert into check_sql values(-1230,'delete from transaction_total_check where cny = -1230 and jpy = -123000 and gbp = -861.0 and eur = -136530 and  hkd = -1107.0','')")

    con:query("insert into check_sql values(-1229,'delete from transaction_total_check where cny = -1229 and jpy = -122900 and gbp = -860.3 and eur = -136419 and  hkd = -1106.1','')")

    con:query("insert into check_sql values(-1228,'delete from transaction_total_check where cny = -1228 and jpy = -122800 and gbp = -859.6 and eur = -136308 and  hkd = -1105.2','')")

    con:query("insert into check_sql values(-1227,'delete from transaction_total_check where cny = -1227 and jpy = -122700 and gbp = -858.9 and eur = -136197 and  hkd = -1104.3','')")

    con:query("insert into check_sql values(-1226,'delete from transaction_total_check where cny = -1226 and jpy = -122600 and gbp = -858.2 and eur = -136086 and  hkd = -1103.4','')")

    con:query("insert into check_sql values(-1225,'delete from transaction_total_check where cny = -1225 and jpy = -122500 and gbp = -857.5 and eur = -135975 and  hkd = -1102.5','')")

    con:query("insert into check_sql values(-1224,'delete from transaction_total_check where cny = -1224 and jpy = -122400 and gbp = -856.8 and eur = -135864 and  hkd = -1101.6','')")

    con:query("insert into check_sql values(-1223,'delete from transaction_total_check where cny = -1223 and jpy = -122300 and gbp = -856.1 and eur = -135753 and  hkd = -1100.7','')")

    con:query("insert into check_sql values(-1222,'delete from transaction_total_check where cny = -1222 and jpy = -122200 and gbp = -855.4 and eur = -135642 and  hkd = -1099.8','')")

    con:query("insert into check_sql values(-1221,'delete from transaction_total_check where cny = -1221 and jpy = -122100 and gbp = -854.7 and eur = -135531 and  hkd = -1098.9','')")

    con:query("insert into check_sql values(-1220,'delete from transaction_total_check where cny = -1220 and jpy = -122000 and gbp = -854.0 and eur = -135420 and  hkd = -1098.0','')")

    con:query("insert into check_sql values(-1219,'delete from transaction_total_check where cny = -1219 and jpy = -121900 and gbp = -853.3 and eur = -135309 and  hkd = -1097.1','')")

    con:query("insert into check_sql values(-1218,'delete from transaction_total_check where cny = -1218 and jpy = -121800 and gbp = -852.6 and eur = -135198 and  hkd = -1096.2','')")

    con:query("insert into check_sql values(-1217,'delete from transaction_total_check where cny = -1217 and jpy = -121700 and gbp = -851.9 and eur = -135087 and  hkd = -1095.3','')")

    con:query("insert into check_sql values(-1216,'delete from transaction_total_check where cny = -1216 and jpy = -121600 and gbp = -851.2 and eur = -134976 and  hkd = -1094.4','')")

    con:query("insert into check_sql values(-1215,'delete from transaction_total_check where cny = -1215 and jpy = -121500 and gbp = -850.5 and eur = -134865 and  hkd = -1093.5','')")

    con:query("insert into check_sql values(-1214,'delete from transaction_total_check where cny = -1214 and jpy = -121400 and gbp = -849.8 and eur = -134754 and  hkd = -1092.6','')")

    con:query("insert into check_sql values(-1213,'delete from transaction_total_check where cny = -1213 and jpy = -121300 and gbp = -849.1 and eur = -134643 and  hkd = -1091.7','')")

    con:query("insert into check_sql values(-1212,'delete from transaction_total_check where cny = -1212 and jpy = -121200 and gbp = -848.4 and eur = -134532 and  hkd = -1090.8','')")

    con:query("insert into check_sql values(-1211,'delete from transaction_total_check where cny = -1211 and jpy = -121100 and gbp = -847.7 and eur = -134421 and  hkd = -1089.9','')")

    con:query("insert into check_sql values(-1210,'delete from transaction_total_check where cny = -1210 and jpy = -121000 and gbp = -847.0 and eur = -134310 and  hkd = -1089.0','')")

    con:query("insert into check_sql values(-1209,'delete from transaction_total_check where cny = -1209 and jpy = -120900 and gbp = -846.3 and eur = -134199 and  hkd = -1088.1','')")

    con:query("insert into check_sql values(-1208,'delete from transaction_total_check where cny = -1208 and jpy = -120800 and gbp = -845.6 and eur = -134088 and  hkd = -1087.2','')")

    con:query("insert into check_sql values(-1207,'delete from transaction_total_check where cny = -1207 and jpy = -120700 and gbp = -844.9 and eur = -133977 and  hkd = -1086.3','')")

    con:query("insert into check_sql values(-1206,'delete from transaction_total_check where cny = -1206 and jpy = -120600 and gbp = -844.2 and eur = -133866 and  hkd = -1085.4','')")

    con:query("insert into check_sql values(-1205,'delete from transaction_total_check where cny = -1205 and jpy = -120500 and gbp = -843.5 and eur = -133755 and  hkd = -1084.5','')")

    con:query("insert into check_sql values(-1204,'delete from transaction_total_check where cny = -1204 and jpy = -120400 and gbp = -842.8 and eur = -133644 and  hkd = -1083.6','')")

    con:query("insert into check_sql values(-1203,'delete from transaction_total_check where cny = -1203 and jpy = -120300 and gbp = -842.1 and eur = -133533 and  hkd = -1082.7','')")

    con:query("insert into check_sql values(-1202,'delete from transaction_total_check where cny = -1202 and jpy = -120200 and gbp = -841.4 and eur = -133422 and  hkd = -1081.8','')")

    con:query("insert into check_sql values(-1201,'delete from transaction_total_check where cny = -1201 and jpy = -120100 and gbp = -840.7 and eur = -133311 and  hkd = -1080.9','')")

    con:query("insert into check_sql values(-1200,'delete from transaction_total_check where cny = -1200 and jpy = -120000 and gbp = -840.0 and eur = -133200 and  hkd = -1080.0','')")

    con:query("insert into check_sql values(-1199,'delete from transaction_total_check where cny = -1199 and jpy = -119900 and gbp = -839.3 and eur = -133089 and  hkd = -1079.1','')")

    con:query("insert into check_sql values(-1198,'delete from transaction_total_check where cny = -1198 and jpy = -119800 and gbp = -838.6 and eur = -132978 and  hkd = -1078.2','')")

    con:query("insert into check_sql values(-1197,'delete from transaction_total_check where cny = -1197 and jpy = -119700 and gbp = -837.9 and eur = -132867 and  hkd = -1077.3','')")

    con:query("insert into check_sql values(-1196,'delete from transaction_total_check where cny = -1196 and jpy = -119600 and gbp = -837.2 and eur = -132756 and  hkd = -1076.4','')")

    con:query("insert into check_sql values(-1195,'delete from transaction_total_check where cny = -1195 and jpy = -119500 and gbp = -836.5 and eur = -132645 and  hkd = -1075.5','')")

    con:query("insert into check_sql values(-1194,'delete from transaction_total_check where cny = -1194 and jpy = -119400 and gbp = -835.8 and eur = -132534 and  hkd = -1074.6','')")

    con:query("insert into check_sql values(-1193,'delete from transaction_total_check where cny = -1193 and jpy = -119300 and gbp = -835.1 and eur = -132423 and  hkd = -1073.7','')")

    con:query("insert into check_sql values(-1192,'delete from transaction_total_check where cny = -1192 and jpy = -119200 and gbp = -834.4 and eur = -132312 and  hkd = -1072.8','')")

    con:query("insert into check_sql values(-1191,'delete from transaction_total_check where cny = -1191 and jpy = -119100 and gbp = -833.7 and eur = -132201 and  hkd = -1071.9','')")

    con:query("insert into check_sql values(-1190,'delete from transaction_total_check where cny = -1190 and jpy = -119000 and gbp = -833.0 and eur = -132090 and  hkd = -1071.0','')")

    con:query("insert into check_sql values(-1189,'delete from transaction_total_check where cny = -1189 and jpy = -118900 and gbp = -832.3 and eur = -131979 and  hkd = -1070.1','')")

    con:query("insert into check_sql values(-1188,'delete from transaction_total_check where cny = -1188 and jpy = -118800 and gbp = -831.6 and eur = -131868 and  hkd = -1069.2','')")

    con:query("insert into check_sql values(-1187,'delete from transaction_total_check where cny = -1187 and jpy = -118700 and gbp = -830.9 and eur = -131757 and  hkd = -1068.3','')")

    con:query("insert into check_sql values(-1186,'delete from transaction_total_check where cny = -1186 and jpy = -118600 and gbp = -830.2 and eur = -131646 and  hkd = -1067.4','')")

    con:query("insert into check_sql values(-1185,'delete from transaction_total_check where cny = -1185 and jpy = -118500 and gbp = -829.5 and eur = -131535 and  hkd = -1066.5','')")

    con:query("insert into check_sql values(-1184,'delete from transaction_total_check where cny = -1184 and jpy = -118400 and gbp = -828.8 and eur = -131424 and  hkd = -1065.6','')")

    con:query("insert into check_sql values(-1183,'delete from transaction_total_check where cny = -1183 and jpy = -118300 and gbp = -828.1 and eur = -131313 and  hkd = -1064.7','')")

    con:query("insert into check_sql values(-1182,'delete from transaction_total_check where cny = -1182 and jpy = -118200 and gbp = -827.4 and eur = -131202 and  hkd = -1063.8','')")

    con:query("insert into check_sql values(-1181,'delete from transaction_total_check where cny = -1181 and jpy = -118100 and gbp = -826.7 and eur = -131091 and  hkd = -1062.9','')")

    con:query("insert into check_sql values(-1180,'delete from transaction_total_check where cny = -1180 and jpy = -118000 and gbp = -826.0 and eur = -130980 and  hkd = -1062.0','')")

    con:query("insert into check_sql values(-1179,'delete from transaction_total_check where cny = -1179 and jpy = -117900 and gbp = -825.3 and eur = -130869 and  hkd = -1061.1','')")

    con:query("insert into check_sql values(-1178,'delete from transaction_total_check where cny = -1178 and jpy = -117800 and gbp = -824.6 and eur = -130758 and  hkd = -1060.2','')")

    con:query("insert into check_sql values(-1177,'delete from transaction_total_check where cny = -1177 and jpy = -117700 and gbp = -823.9 and eur = -130647 and  hkd = -1059.3','')")

    con:query("insert into check_sql values(-1176,'delete from transaction_total_check where cny = -1176 and jpy = -117600 and gbp = -823.2 and eur = -130536 and  hkd = -1058.4','')")

    con:query("insert into check_sql values(-1175,'delete from transaction_total_check where cny = -1175 and jpy = -117500 and gbp = -822.5 and eur = -130425 and  hkd = -1057.5','')")

    con:query("insert into check_sql values(-1174,'delete from transaction_total_check where cny = -1174 and jpy = -117400 and gbp = -821.8 and eur = -130314 and  hkd = -1056.6','')")

    con:query("insert into check_sql values(-1173,'delete from transaction_total_check where cny = -1173 and jpy = -117300 and gbp = -821.1 and eur = -130203 and  hkd = -1055.7','')")

    con:query("insert into check_sql values(-1172,'delete from transaction_total_check where cny = -1172 and jpy = -117200 and gbp = -820.4 and eur = -130092 and  hkd = -1054.8','')")

    con:query("insert into check_sql values(-1171,'delete from transaction_total_check where cny = -1171 and jpy = -117100 and gbp = -819.7 and eur = -129981 and  hkd = -1053.9','')")

    con:query("insert into check_sql values(-1170,'delete from transaction_total_check where cny = -1170 and jpy = -117000 and gbp = -819.0 and eur = -129870 and  hkd = -1053.0','')")

    con:query("insert into check_sql values(-1169,'delete from transaction_total_check where cny = -1169 and jpy = -116900 and gbp = -818.3 and eur = -129759 and  hkd = -1052.1','')")

    con:query("insert into check_sql values(-1168,'delete from transaction_total_check where cny = -1168 and jpy = -116800 and gbp = -817.6 and eur = -129648 and  hkd = -1051.2','')")

    con:query("insert into check_sql values(-1167,'delete from transaction_total_check where cny = -1167 and jpy = -116700 and gbp = -816.9 and eur = -129537 and  hkd = -1050.3','')")

    con:query("insert into check_sql values(-1166,'delete from transaction_total_check where cny = -1166 and jpy = -116600 and gbp = -816.2 and eur = -129426 and  hkd = -1049.4','')")

    con:query("insert into check_sql values(-1165,'delete from transaction_total_check where cny = -1165 and jpy = -116500 and gbp = -815.5 and eur = -129315 and  hkd = -1048.5','')")

    con:query("insert into check_sql values(-1164,'delete from transaction_total_check where cny = -1164 and jpy = -116400 and gbp = -814.8 and eur = -129204 and  hkd = -1047.6','')")

    con:query("insert into check_sql values(-1163,'delete from transaction_total_check where cny = -1163 and jpy = -116300 and gbp = -814.1 and eur = -129093 and  hkd = -1046.7','')")

    con:query("insert into check_sql values(-1162,'delete from transaction_total_check where cny = -1162 and jpy = -116200 and gbp = -813.4 and eur = -128982 and  hkd = -1045.8','')")

    con:query("insert into check_sql values(-1161,'delete from transaction_total_check where cny = -1161 and jpy = -116100 and gbp = -812.7 and eur = -128871 and  hkd = -1044.9','')")

    con:query("insert into check_sql values(-1160,'delete from transaction_total_check where cny = -1160 and jpy = -116000 and gbp = -812.0 and eur = -128760 and  hkd = -1044.0','')")

    con:query("insert into check_sql values(-1159,'delete from transaction_total_check where cny = -1159 and jpy = -115900 and gbp = -811.3 and eur = -128649 and  hkd = -1043.1','')")

    con:query("insert into check_sql values(-1158,'delete from transaction_total_check where cny = -1158 and jpy = -115800 and gbp = -810.6 and eur = -128538 and  hkd = -1042.2','')")

    con:query("insert into check_sql values(-1157,'delete from transaction_total_check where cny = -1157 and jpy = -115700 and gbp = -809.9 and eur = -128427 and  hkd = -1041.3','')")

    con:query("insert into check_sql values(-1156,'delete from transaction_total_check where cny = -1156 and jpy = -115600 and gbp = -809.2 and eur = -128316 and  hkd = -1040.4','')")

    con:query("insert into check_sql values(-1155,'delete from transaction_total_check where cny = -1155 and jpy = -115500 and gbp = -808.5 and eur = -128205 and  hkd = -1039.5','')")

    con:query("insert into check_sql values(-1154,'delete from transaction_total_check where cny = -1154 and jpy = -115400 and gbp = -807.8 and eur = -128094 and  hkd = -1038.6','')")

    con:query("insert into check_sql values(-1153,'delete from transaction_total_check where cny = -1153 and jpy = -115300 and gbp = -807.1 and eur = -127983 and  hkd = -1037.7','')")

    con:query("insert into check_sql values(-1152,'delete from transaction_total_check where cny = -1152 and jpy = -115200 and gbp = -806.4 and eur = -127872 and  hkd = -1036.8','')")

    con:query("insert into check_sql values(-1151,'delete from transaction_total_check where cny = -1151 and jpy = -115100 and gbp = -805.7 and eur = -127761 and  hkd = -1035.9','')")

    con:query("insert into check_sql values(-1150,'delete from transaction_total_check where cny = -1150 and jpy = -115000 and gbp = -805.0 and eur = -127650 and  hkd = -1035.0','')")

    con:query("insert into check_sql values(-1149,'delete from transaction_total_check where cny = -1149 and jpy = -114900 and gbp = -804.3 and eur = -127539 and  hkd = -1034.1','')")

    con:query("insert into check_sql values(-1148,'delete from transaction_total_check where cny = -1148 and jpy = -114800 and gbp = -803.6 and eur = -127428 and  hkd = -1033.2','')")

    con:query("insert into check_sql values(-1147,'delete from transaction_total_check where cny = -1147 and jpy = -114700 and gbp = -802.9 and eur = -127317 and  hkd = -1032.3','')")

    con:query("insert into check_sql values(-1146,'delete from transaction_total_check where cny = -1146 and jpy = -114600 and gbp = -802.2 and eur = -127206 and  hkd = -1031.4','')")

    con:query("insert into check_sql values(-1145,'delete from transaction_total_check where cny = -1145 and jpy = -114500 and gbp = -801.5 and eur = -127095 and  hkd = -1030.5','')")

    con:query("insert into check_sql values(-1144,'delete from transaction_total_check where cny = -1144 and jpy = -114400 and gbp = -800.8 and eur = -126984 and  hkd = -1029.6','')")

    con:query("insert into check_sql values(-1143,'delete from transaction_total_check where cny = -1143 and jpy = -114300 and gbp = -800.1 and eur = -126873 and  hkd = -1028.7','')")

    con:query("insert into check_sql values(-1142,'delete from transaction_total_check where cny = -1142 and jpy = -114200 and gbp = -799.4 and eur = -126762 and  hkd = -1027.8','')")

    con:query("insert into check_sql values(-1141,'delete from transaction_total_check where cny = -1141 and jpy = -114100 and gbp = -798.7 and eur = -126651 and  hkd = -1026.9','')")

    con:query("insert into check_sql values(-1140,'delete from transaction_total_check where cny = -1140 and jpy = -114000 and gbp = -798.0 and eur = -126540 and  hkd = -1026.0','')")

    con:query("insert into check_sql values(-1139,'delete from transaction_total_check where cny = -1139 and jpy = -113900 and gbp = -797.3 and eur = -126429 and  hkd = -1025.1','')")

    con:query("insert into check_sql values(-1138,'delete from transaction_total_check where cny = -1138 and jpy = -113800 and gbp = -796.6 and eur = -126318 and  hkd = -1024.2','')")

    con:query("insert into check_sql values(-1137,'delete from transaction_total_check where cny = -1137 and jpy = -113700 and gbp = -795.9 and eur = -126207 and  hkd = -1023.3','')")

    con:query("insert into check_sql values(-1136,'delete from transaction_total_check where cny = -1136 and jpy = -113600 and gbp = -795.2 and eur = -126096 and  hkd = -1022.4','')")

    con:query("insert into check_sql values(-1135,'delete from transaction_total_check where cny = -1135 and jpy = -113500 and gbp = -794.5 and eur = -125985 and  hkd = -1021.5','')")

    con:query("insert into check_sql values(-1134,'delete from transaction_total_check where cny = -1134 and jpy = -113400 and gbp = -793.8 and eur = -125874 and  hkd = -1020.6','')")

    con:query("insert into check_sql values(-1133,'delete from transaction_total_check where cny = -1133 and jpy = -113300 and gbp = -793.1 and eur = -125763 and  hkd = -1019.7','')")

    con:query("insert into check_sql values(-1132,'delete from transaction_total_check where cny = -1132 and jpy = -113200 and gbp = -792.4 and eur = -125652 and  hkd = -1018.8','')")

    con:query("insert into check_sql values(-1131,'delete from transaction_total_check where cny = -1131 and jpy = -113100 and gbp = -791.7 and eur = -125541 and  hkd = -1017.9','')")

    con:query("insert into check_sql values(-1130,'delete from transaction_total_check where cny = -1130 and jpy = -113000 and gbp = -791.0 and eur = -125430 and  hkd = -1017.0','')")

    con:query("insert into check_sql values(-1129,'delete from transaction_total_check where cny = -1129 and jpy = -112900 and gbp = -790.3 and eur = -125319 and  hkd = -1016.1','')")

    con:query("insert into check_sql values(-1128,'delete from transaction_total_check where cny = -1128 and jpy = -112800 and gbp = -789.6 and eur = -125208 and  hkd = -1015.2','')")

    con:query("insert into check_sql values(-1127,'delete from transaction_total_check where cny = -1127 and jpy = -112700 and gbp = -788.9 and eur = -125097 and  hkd = -1014.3','')")

    con:query("insert into check_sql values(-1126,'delete from transaction_total_check where cny = -1126 and jpy = -112600 and gbp = -788.2 and eur = -124986 and  hkd = -1013.4','')")

    con:query("insert into check_sql values(-1125,'delete from transaction_total_check where cny = -1125 and jpy = -112500 and gbp = -787.5 and eur = -124875 and  hkd = -1012.5','')")

    con:query("insert into check_sql values(-1124,'delete from transaction_total_check where cny = -1124 and jpy = -112400 and gbp = -786.8 and eur = -124764 and  hkd = -1011.6','')")

    con:query("insert into check_sql values(-1123,'delete from transaction_total_check where cny = -1123 and jpy = -112300 and gbp = -786.1 and eur = -124653 and  hkd = -1010.7','')")

    con:query("insert into check_sql values(-1122,'delete from transaction_total_check where cny = -1122 and jpy = -112200 and gbp = -785.4 and eur = -124542 and  hkd = -1009.8','')")

    con:query("insert into check_sql values(-1121,'delete from transaction_total_check where cny = -1121 and jpy = -112100 and gbp = -784.7 and eur = -124431 and  hkd = -1008.9','')")

    con:query("insert into check_sql values(-1120,'delete from transaction_total_check where cny = -1120 and jpy = -112000 and gbp = -784.0 and eur = -124320 and  hkd = -1008.0','')")

    con:query("insert into check_sql values(-1119,'delete from transaction_total_check where cny = -1119 and jpy = -111900 and gbp = -783.3 and eur = -124209 and  hkd = -1007.1','')")

    con:query("insert into check_sql values(-1118,'delete from transaction_total_check where cny = -1118 and jpy = -111800 and gbp = -782.6 and eur = -124098 and  hkd = -1006.2','')")

    con:query("insert into check_sql values(-1117,'delete from transaction_total_check where cny = -1117 and jpy = -111700 and gbp = -781.9 and eur = -123987 and  hkd = -1005.3','')")

    con:query("insert into check_sql values(-1116,'delete from transaction_total_check where cny = -1116 and jpy = -111600 and gbp = -781.2 and eur = -123876 and  hkd = -1004.4','')")

    con:query("insert into check_sql values(-1115,'delete from transaction_total_check where cny = -1115 and jpy = -111500 and gbp = -780.5 and eur = -123765 and  hkd = -1003.5','')")

    con:query("insert into check_sql values(-1114,'delete from transaction_total_check where cny = -1114 and jpy = -111400 and gbp = -779.8 and eur = -123654 and  hkd = -1002.6','')")

    con:query("insert into check_sql values(-1113,'delete from transaction_total_check where cny = -1113 and jpy = -111300 and gbp = -779.1 and eur = -123543 and  hkd = -1001.7','')")

    con:query("insert into check_sql values(-1112,'delete from transaction_total_check where cny = -1112 and jpy = -111200 and gbp = -778.4 and eur = -123432 and  hkd = -1000.8','')")

    con:query("insert into check_sql values(-1111,'delete from transaction_total_check where cny = -1111 and jpy = -111100 and gbp = -777.7 and eur = -123321 and  hkd = -999.9','')")

    con:query("insert into check_sql values(-1110,'delete from transaction_total_check where cny = -1110 and jpy = -111000 and gbp = -777.0 and eur = -123210 and  hkd = -999.0','')")

    con:query("insert into check_sql values(-1109,'delete from transaction_total_check where cny = -1109 and jpy = -110900 and gbp = -776.3 and eur = -123099 and  hkd = -998.1','')")

    con:query("insert into check_sql values(-1108,'delete from transaction_total_check where cny = -1108 and jpy = -110800 and gbp = -775.6 and eur = -122988 and  hkd = -997.2','')")

    con:query("insert into check_sql values(-1107,'delete from transaction_total_check where cny = -1107 and jpy = -110700 and gbp = -774.9 and eur = -122877 and  hkd = -996.3','')")

    con:query("insert into check_sql values(-1106,'delete from transaction_total_check where cny = -1106 and jpy = -110600 and gbp = -774.2 and eur = -122766 and  hkd = -995.4','')")

    con:query("insert into check_sql values(-1105,'delete from transaction_total_check where cny = -1105 and jpy = -110500 and gbp = -773.5 and eur = -122655 and  hkd = -994.5','')")

    con:query("insert into check_sql values(-1104,'delete from transaction_total_check where cny = -1104 and jpy = -110400 and gbp = -772.8 and eur = -122544 and  hkd = -993.6','')")

    con:query("insert into check_sql values(-1103,'delete from transaction_total_check where cny = -1103 and jpy = -110300 and gbp = -772.1 and eur = -122433 and  hkd = -992.7','')")

    con:query("insert into check_sql values(-1102,'delete from transaction_total_check where cny = -1102 and jpy = -110200 and gbp = -771.4 and eur = -122322 and  hkd = -991.8','')")

    con:query("insert into check_sql values(-1101,'delete from transaction_total_check where cny = -1101 and jpy = -110100 and gbp = -770.7 and eur = -122211 and  hkd = -990.9','')")

    con:query("insert into check_sql values(-1100,'delete from transaction_total_check where cny = -1100 and jpy = -110000 and gbp = -770.0 and eur = -122100 and  hkd = -990.0','')")

    con:query("insert into check_sql values(-1099,'delete from transaction_total_check where cny = -1099 and jpy = -109900 and gbp = -769.3 and eur = -121989 and  hkd = -989.1','')")

    con:query("insert into check_sql values(-1098,'delete from transaction_total_check where cny = -1098 and jpy = -109800 and gbp = -768.6 and eur = -121878 and  hkd = -988.2','')")

    con:query("insert into check_sql values(-1097,'delete from transaction_total_check where cny = -1097 and jpy = -109700 and gbp = -767.9 and eur = -121767 and  hkd = -987.3','')")

    con:query("insert into check_sql values(-1096,'delete from transaction_total_check where cny = -1096 and jpy = -109600 and gbp = -767.2 and eur = -121656 and  hkd = -986.4','')")

    con:query("insert into check_sql values(-1095,'delete from transaction_total_check where cny = -1095 and jpy = -109500 and gbp = -766.5 and eur = -121545 and  hkd = -985.5','')")

    con:query("insert into check_sql values(-1094,'delete from transaction_total_check where cny = -1094 and jpy = -109400 and gbp = -765.8 and eur = -121434 and  hkd = -984.6','')")

    con:query("insert into check_sql values(-1093,'delete from transaction_total_check where cny = -1093 and jpy = -109300 and gbp = -765.1 and eur = -121323 and  hkd = -983.7','')")

    con:query("insert into check_sql values(-1092,'delete from transaction_total_check where cny = -1092 and jpy = -109200 and gbp = -764.4 and eur = -121212 and  hkd = -982.8','')")

    con:query("insert into check_sql values(-1091,'delete from transaction_total_check where cny = -1091 and jpy = -109100 and gbp = -763.7 and eur = -121101 and  hkd = -981.9','')")

    con:query("insert into check_sql values(-1090,'delete from transaction_total_check where cny = -1090 and jpy = -109000 and gbp = -763.0 and eur = -120990 and  hkd = -981.0','')")

    con:query("insert into check_sql values(-1089,'delete from transaction_total_check where cny = -1089 and jpy = -108900 and gbp = -762.3 and eur = -120879 and  hkd = -980.1','')")

    con:query("insert into check_sql values(-1088,'delete from transaction_total_check where cny = -1088 and jpy = -108800 and gbp = -761.6 and eur = -120768 and  hkd = -979.2','')")

    con:query("insert into check_sql values(-1087,'delete from transaction_total_check where cny = -1087 and jpy = -108700 and gbp = -760.9 and eur = -120657 and  hkd = -978.3','')")

    con:query("insert into check_sql values(-1086,'delete from transaction_total_check where cny = -1086 and jpy = -108600 and gbp = -760.2 and eur = -120546 and  hkd = -977.4','')")

    con:query("insert into check_sql values(-1085,'delete from transaction_total_check where cny = -1085 and jpy = -108500 and gbp = -759.5 and eur = -120435 and  hkd = -976.5','')")

    con:query("insert into check_sql values(-1084,'delete from transaction_total_check where cny = -1084 and jpy = -108400 and gbp = -758.8 and eur = -120324 and  hkd = -975.6','')")

    con:query("insert into check_sql values(-1083,'delete from transaction_total_check where cny = -1083 and jpy = -108300 and gbp = -758.1 and eur = -120213 and  hkd = -974.7','')")

    con:query("insert into check_sql values(-1082,'delete from transaction_total_check where cny = -1082 and jpy = -108200 and gbp = -757.4 and eur = -120102 and  hkd = -973.8','')")

    con:query("insert into check_sql values(-1081,'delete from transaction_total_check where cny = -1081 and jpy = -108100 and gbp = -756.7 and eur = -119991 and  hkd = -972.9','')")

    con:query("insert into check_sql values(-1080,'delete from transaction_total_check where cny = -1080 and jpy = -108000 and gbp = -756.0 and eur = -119880 and  hkd = -972.0','')")

    con:query("insert into check_sql values(-1079,'delete from transaction_total_check where cny = -1079 and jpy = -107900 and gbp = -755.3 and eur = -119769 and  hkd = -971.1','')")

    con:query("insert into check_sql values(-1078,'delete from transaction_total_check where cny = -1078 and jpy = -107800 and gbp = -754.6 and eur = -119658 and  hkd = -970.2','')")

    con:query("insert into check_sql values(-1077,'delete from transaction_total_check where cny = -1077 and jpy = -107700 and gbp = -753.9 and eur = -119547 and  hkd = -969.3','')")

    con:query("insert into check_sql values(-1076,'delete from transaction_total_check where cny = -1076 and jpy = -107600 and gbp = -753.2 and eur = -119436 and  hkd = -968.4','')")

    con:query("insert into check_sql values(-1075,'delete from transaction_total_check where cny = -1075 and jpy = -107500 and gbp = -752.5 and eur = -119325 and  hkd = -967.5','')")

    con:query("insert into check_sql values(-1074,'delete from transaction_total_check where cny = -1074 and jpy = -107400 and gbp = -751.8 and eur = -119214 and  hkd = -966.6','')")

    con:query("insert into check_sql values(-1073,'delete from transaction_total_check where cny = -1073 and jpy = -107300 and gbp = -751.1 and eur = -119103 and  hkd = -965.7','')")

    con:query("insert into check_sql values(-1072,'delete from transaction_total_check where cny = -1072 and jpy = -107200 and gbp = -750.4 and eur = -118992 and  hkd = -964.8','')")

    con:query("insert into check_sql values(-1071,'delete from transaction_total_check where cny = -1071 and jpy = -107100 and gbp = -749.7 and eur = -118881 and  hkd = -963.9','')")

    con:query("insert into check_sql values(-1070,'delete from transaction_total_check where cny = -1070 and jpy = -107000 and gbp = -749.0 and eur = -118770 and  hkd = -963.0','')")

    con:query("insert into check_sql values(-1069,'delete from transaction_total_check where cny = -1069 and jpy = -106900 and gbp = -748.3 and eur = -118659 and  hkd = -962.1','')")

    con:query("insert into check_sql values(-1068,'delete from transaction_total_check where cny = -1068 and jpy = -106800 and gbp = -747.6 and eur = -118548 and  hkd = -961.2','')")

    con:query("insert into check_sql values(-1067,'delete from transaction_total_check where cny = -1067 and jpy = -106700 and gbp = -746.9 and eur = -118437 and  hkd = -960.3','')")

    con:query("insert into check_sql values(-1066,'delete from transaction_total_check where cny = -1066 and jpy = -106600 and gbp = -746.2 and eur = -118326 and  hkd = -959.4','')")

    con:query("insert into check_sql values(-1065,'delete from transaction_total_check where cny = -1065 and jpy = -106500 and gbp = -745.5 and eur = -118215 and  hkd = -958.5','')")

    con:query("insert into check_sql values(-1064,'delete from transaction_total_check where cny = -1064 and jpy = -106400 and gbp = -744.8 and eur = -118104 and  hkd = -957.6','')")

    con:query("insert into check_sql values(-1063,'delete from transaction_total_check where cny = -1063 and jpy = -106300 and gbp = -744.1 and eur = -117993 and  hkd = -956.7','')")

    con:query("insert into check_sql values(-1062,'delete from transaction_total_check where cny = -1062 and jpy = -106200 and gbp = -743.4 and eur = -117882 and  hkd = -955.8','')")

    con:query("insert into check_sql values(-1061,'delete from transaction_total_check where cny = -1061 and jpy = -106100 and gbp = -742.7 and eur = -117771 and  hkd = -954.9','')")

    con:query("insert into check_sql values(-1060,'delete from transaction_total_check where cny = -1060 and jpy = -106000 and gbp = -742.0 and eur = -117660 and  hkd = -954.0','')")

    con:query("insert into check_sql values(-1059,'delete from transaction_total_check where cny = -1059 and jpy = -105900 and gbp = -741.3 and eur = -117549 and  hkd = -953.1','')")

    con:query("insert into check_sql values(-1058,'delete from transaction_total_check where cny = -1058 and jpy = -105800 and gbp = -740.6 and eur = -117438 and  hkd = -952.2','')")

    con:query("insert into check_sql values(-1057,'delete from transaction_total_check where cny = -1057 and jpy = -105700 and gbp = -739.9 and eur = -117327 and  hkd = -951.3','')")

    con:query("insert into check_sql values(-1056,'delete from transaction_total_check where cny = -1056 and jpy = -105600 and gbp = -739.2 and eur = -117216 and  hkd = -950.4','')")

    con:query("insert into check_sql values(-1055,'delete from transaction_total_check where cny = -1055 and jpy = -105500 and gbp = -738.5 and eur = -117105 and  hkd = -949.5','')")

    con:query("insert into check_sql values(-1054,'delete from transaction_total_check where cny = -1054 and jpy = -105400 and gbp = -737.8 and eur = -116994 and  hkd = -948.6','')")

    con:query("insert into check_sql values(-1053,'delete from transaction_total_check where cny = -1053 and jpy = -105300 and gbp = -737.1 and eur = -116883 and  hkd = -947.7','')")

    con:query("insert into check_sql values(-1052,'delete from transaction_total_check where cny = -1052 and jpy = -105200 and gbp = -736.4 and eur = -116772 and  hkd = -946.8','')")

    con:query("insert into check_sql values(-1051,'delete from transaction_total_check where cny = -1051 and jpy = -105100 and gbp = -735.7 and eur = -116661 and  hkd = -945.9','')")

    con:query("insert into check_sql values(-1050,'delete from transaction_total_check where cny = -1050 and jpy = -105000 and gbp = -735.0 and eur = -116550 and  hkd = -945.0','')")

    con:query("insert into check_sql values(-1049,'delete from transaction_total_check where cny = -1049 and jpy = -104900 and gbp = -734.3 and eur = -116439 and  hkd = -944.1','')")

    con:query("insert into check_sql values(-1048,'delete from transaction_total_check where cny = -1048 and jpy = -104800 and gbp = -733.6 and eur = -116328 and  hkd = -943.2','')")

    con:query("insert into check_sql values(-1047,'delete from transaction_total_check where cny = -1047 and jpy = -104700 and gbp = -732.9 and eur = -116217 and  hkd = -942.3','')")

    con:query("insert into check_sql values(-1046,'delete from transaction_total_check where cny = -1046 and jpy = -104600 and gbp = -732.2 and eur = -116106 and  hkd = -941.4','')")

    con:query("insert into check_sql values(-1045,'delete from transaction_total_check where cny = -1045 and jpy = -104500 and gbp = -731.5 and eur = -115995 and  hkd = -940.5','')")

    con:query("insert into check_sql values(-1044,'delete from transaction_total_check where cny = -1044 and jpy = -104400 and gbp = -730.8 and eur = -115884 and  hkd = -939.6','')")

    con:query("insert into check_sql values(-1043,'delete from transaction_total_check where cny = -1043 and jpy = -104300 and gbp = -730.1 and eur = -115773 and  hkd = -938.7','')")

    con:query("insert into check_sql values(-1042,'delete from transaction_total_check where cny = -1042 and jpy = -104200 and gbp = -729.4 and eur = -115662 and  hkd = -937.8','')")

    con:query("insert into check_sql values(-1041,'delete from transaction_total_check where cny = -1041 and jpy = -104100 and gbp = -728.7 and eur = -115551 and  hkd = -936.9','')")

    con:query("insert into check_sql values(-1040,'delete from transaction_total_check where cny = -1040 and jpy = -104000 and gbp = -728.0 and eur = -115440 and  hkd = -936.0','')")

    con:query("insert into check_sql values(-1039,'delete from transaction_total_check where cny = -1039 and jpy = -103900 and gbp = -727.3 and eur = -115329 and  hkd = -935.1','')")

    con:query("insert into check_sql values(-1038,'delete from transaction_total_check where cny = -1038 and jpy = -103800 and gbp = -726.6 and eur = -115218 and  hkd = -934.2','')")

    con:query("insert into check_sql values(-1037,'delete from transaction_total_check where cny = -1037 and jpy = -103700 and gbp = -725.9 and eur = -115107 and  hkd = -933.3','')")

    con:query("insert into check_sql values(-1036,'delete from transaction_total_check where cny = -1036 and jpy = -103600 and gbp = -725.2 and eur = -114996 and  hkd = -932.4','')")

    con:query("insert into check_sql values(-1035,'delete from transaction_total_check where cny = -1035 and jpy = -103500 and gbp = -724.5 and eur = -114885 and  hkd = -931.5','')")

    con:query("insert into check_sql values(-1034,'delete from transaction_total_check where cny = -1034 and jpy = -103400 and gbp = -723.8 and eur = -114774 and  hkd = -930.6','')")

    con:query("insert into check_sql values(-1033,'delete from transaction_total_check where cny = -1033 and jpy = -103300 and gbp = -723.1 and eur = -114663 and  hkd = -929.7','')")

    con:query("insert into check_sql values(-1032,'delete from transaction_total_check where cny = -1032 and jpy = -103200 and gbp = -722.4 and eur = -114552 and  hkd = -928.8','')")

    con:query("insert into check_sql values(-1031,'delete from transaction_total_check where cny = -1031 and jpy = -103100 and gbp = -721.7 and eur = -114441 and  hkd = -927.9','')")

    con:query("insert into check_sql values(-1030,'delete from transaction_total_check where cny = -1030 and jpy = -103000 and gbp = -721.0 and eur = -114330 and  hkd = -927.0','')")

    con:query("insert into check_sql values(-1029,'delete from transaction_total_check where cny = -1029 and jpy = -102900 and gbp = -720.3 and eur = -114219 and  hkd = -926.1','')")

    con:query("insert into check_sql values(-1028,'delete from transaction_total_check where cny = -1028 and jpy = -102800 and gbp = -719.6 and eur = -114108 and  hkd = -925.2','')")

    con:query("insert into check_sql values(-1027,'delete from transaction_total_check where cny = -1027 and jpy = -102700 and gbp = -718.9 and eur = -113997 and  hkd = -924.3','')")

    con:query("insert into check_sql values(-1026,'delete from transaction_total_check where cny = -1026 and jpy = -102600 and gbp = -718.2 and eur = -113886 and  hkd = -923.4','')")

    con:query("insert into check_sql values(-1025,'delete from transaction_total_check where cny = -1025 and jpy = -102500 and gbp = -717.5 and eur = -113775 and  hkd = -922.5','')")

    con:query("insert into check_sql values(-1024,'delete from transaction_total_check where cny = -1024 and jpy = -102400 and gbp = -716.8 and eur = -113664 and  hkd = -921.6','')")

    con:query("insert into check_sql values(-1023,'delete from transaction_total_check where cny = -1023 and jpy = -102300 and gbp = -716.1 and eur = -113553 and  hkd = -920.7','')")

    con:query("insert into check_sql values(-1022,'delete from transaction_total_check where cny = -1022 and jpy = -102200 and gbp = -715.4 and eur = -113442 and  hkd = -919.8','')")

    con:query("insert into check_sql values(-1021,'delete from transaction_total_check where cny = -1021 and jpy = -102100 and gbp = -714.7 and eur = -113331 and  hkd = -918.9','')")

    con:query("insert into check_sql values(-1020,'delete from transaction_total_check where cny = -1020 and jpy = -102000 and gbp = -714.0 and eur = -113220 and  hkd = -918.0','')")

    con:query("insert into check_sql values(-1019,'delete from transaction_total_check where cny = -1019 and jpy = -101900 and gbp = -713.3 and eur = -113109 and  hkd = -917.1','')")

    con:query("insert into check_sql values(-1018,'delete from transaction_total_check where cny = -1018 and jpy = -101800 and gbp = -712.6 and eur = -112998 and  hkd = -916.2','')")

    con:query("insert into check_sql values(-1017,'delete from transaction_total_check where cny = -1017 and jpy = -101700 and gbp = -711.9 and eur = -112887 and  hkd = -915.3','')")

    con:query("insert into check_sql values(-1016,'delete from transaction_total_check where cny = -1016 and jpy = -101600 and gbp = -711.2 and eur = -112776 and  hkd = -914.4','')")

    con:query("insert into check_sql values(-1015,'delete from transaction_total_check where cny = -1015 and jpy = -101500 and gbp = -710.5 and eur = -112665 and  hkd = -913.5','')")

    con:query("insert into check_sql values(-1014,'delete from transaction_total_check where cny = -1014 and jpy = -101400 and gbp = -709.8 and eur = -112554 and  hkd = -912.6','')")

    con:query("insert into check_sql values(-1013,'delete from transaction_total_check where cny = -1013 and jpy = -101300 and gbp = -709.1 and eur = -112443 and  hkd = -911.7','')")

    con:query("insert into check_sql values(-1012,'delete from transaction_total_check where cny = -1012 and jpy = -101200 and gbp = -708.4 and eur = -112332 and  hkd = -910.8','')")

    con:query("insert into check_sql values(-1011,'delete from transaction_total_check where cny = -1011 and jpy = -101100 and gbp = -707.7 and eur = -112221 and  hkd = -909.9','')")

    con:query("insert into check_sql values(-1010,'delete from transaction_total_check where cny = -1010 and jpy = -101000 and gbp = -707.0 and eur = -112110 and  hkd = -909.0','')")

    con:query("insert into check_sql values(-1009,'delete from transaction_total_check where cny = -1009 and jpy = -100900 and gbp = -706.3 and eur = -111999 and  hkd = -908.1','')")

    con:query("insert into check_sql values(-1008,'delete from transaction_total_check where cny = -1008 and jpy = -100800 and gbp = -705.6 and eur = -111888 and  hkd = -907.2','')")

    con:query("insert into check_sql values(-1007,'delete from transaction_total_check where cny = -1007 and jpy = -100700 and gbp = -704.9 and eur = -111777 and  hkd = -906.3','')")

    con:query("insert into check_sql values(-1006,'delete from transaction_total_check where cny = -1006 and jpy = -100600 and gbp = -704.2 and eur = -111666 and  hkd = -905.4','')")

    con:query("insert into check_sql values(-1005,'delete from transaction_total_check where cny = -1005 and jpy = -100500 and gbp = -703.5 and eur = -111555 and  hkd = -904.5','')")

    con:query("insert into check_sql values(-1004,'delete from transaction_total_check where cny = -1004 and jpy = -100400 and gbp = -702.8 and eur = -111444 and  hkd = -903.6','')")

    con:query("insert into check_sql values(-1003,'delete from transaction_total_check where cny = -1003 and jpy = -100300 and gbp = -702.1 and eur = -111333 and  hkd = -902.7','')")

    con:query("insert into check_sql values(-1002,'delete from transaction_total_check where cny = -1002 and jpy = -100200 and gbp = -701.4 and eur = -111222 and  hkd = -901.8','')")

    con:query("insert into check_sql values(-1001,'delete from transaction_total_check where cny = -1001 and jpy = -100100 and gbp = -700.7 and eur = -111111 and  hkd = -900.9','')")

    con:query("insert into check_sql values(-1000,'delete from transaction_total_check where cny = -1000 and jpy = -100000 and gbp = -700.0 and eur = -111000 and  hkd = -900.0','')")

    con:query("insert into check_sql values(-999,'delete from transaction_total_check where cny = -999 and jpy = -99900 and gbp = -699.3 and eur = -110889 and  hkd = -899.1','')")

    con:query("insert into check_sql values(-998,'delete from transaction_total_check where cny = -998 and jpy = -99800 and gbp = -698.6 and eur = -110778 and  hkd = -898.2','')")

    con:query("insert into check_sql values(-997,'delete from transaction_total_check where cny = -997 and jpy = -99700 and gbp = -697.9 and eur = -110667 and  hkd = -897.3','')")

    con:query("insert into check_sql values(-996,'delete from transaction_total_check where cny = -996 and jpy = -99600 and gbp = -697.2 and eur = -110556 and  hkd = -896.4','')")

    con:query("insert into check_sql values(-995,'delete from transaction_total_check where cny = -995 and jpy = -99500 and gbp = -696.5 and eur = -110445 and  hkd = -895.5','')")

    con:query("insert into check_sql values(-994,'delete from transaction_total_check where cny = -994 and jpy = -99400 and gbp = -695.8 and eur = -110334 and  hkd = -894.6','')")

    con:query("insert into check_sql values(-993,'delete from transaction_total_check where cny = -993 and jpy = -99300 and gbp = -695.1 and eur = -110223 and  hkd = -893.7','')")

    con:query("insert into check_sql values(-992,'delete from transaction_total_check where cny = -992 and jpy = -99200 and gbp = -694.4 and eur = -110112 and  hkd = -892.8','')")

    con:query("insert into check_sql values(-991,'delete from transaction_total_check where cny = -991 and jpy = -99100 and gbp = -693.7 and eur = -110001 and  hkd = -891.9','')")

    con:query("insert into check_sql values(-990,'delete from transaction_total_check where cny = -990 and jpy = -99000 and gbp = -693.0 and eur = -109890 and  hkd = -891.0','')")

    con:query("insert into check_sql values(-989,'delete from transaction_total_check where cny = -989 and jpy = -98900 and gbp = -692.3 and eur = -109779 and  hkd = -890.1','')")

    con:query("insert into check_sql values(-988,'delete from transaction_total_check where cny = -988 and jpy = -98800 and gbp = -691.6 and eur = -109668 and  hkd = -889.2','')")

    con:query("insert into check_sql values(-987,'delete from transaction_total_check where cny = -987 and jpy = -98700 and gbp = -690.9 and eur = -109557 and  hkd = -888.3','')")

    con:query("insert into check_sql values(-986,'delete from transaction_total_check where cny = -986 and jpy = -98600 and gbp = -690.2 and eur = -109446 and  hkd = -887.4','')")

    con:query("insert into check_sql values(-985,'delete from transaction_total_check where cny = -985 and jpy = -98500 and gbp = -689.5 and eur = -109335 and  hkd = -886.5','')")

    con:query("insert into check_sql values(-984,'delete from transaction_total_check where cny = -984 and jpy = -98400 and gbp = -688.8 and eur = -109224 and  hkd = -885.6','')")

    con:query("insert into check_sql values(-983,'delete from transaction_total_check where cny = -983 and jpy = -98300 and gbp = -688.1 and eur = -109113 and  hkd = -884.7','')")

    con:query("insert into check_sql values(-982,'delete from transaction_total_check where cny = -982 and jpy = -98200 and gbp = -687.4 and eur = -109002 and  hkd = -883.8','')")

    con:query("insert into check_sql values(-981,'delete from transaction_total_check where cny = -981 and jpy = -98100 and gbp = -686.7 and eur = -108891 and  hkd = -882.9','')")

    con:query("insert into check_sql values(-980,'delete from transaction_total_check where cny = -980 and jpy = -98000 and gbp = -686.0 and eur = -108780 and  hkd = -882.0','')")

    con:query("insert into check_sql values(-979,'delete from transaction_total_check where cny = -979 and jpy = -97900 and gbp = -685.3 and eur = -108669 and  hkd = -881.1','')")

    con:query("insert into check_sql values(-978,'delete from transaction_total_check where cny = -978 and jpy = -97800 and gbp = -684.6 and eur = -108558 and  hkd = -880.2','')")

    con:query("insert into check_sql values(-977,'delete from transaction_total_check where cny = -977 and jpy = -97700 and gbp = -683.9 and eur = -108447 and  hkd = -879.3','')")

    con:query("insert into check_sql values(-976,'delete from transaction_total_check where cny = -976 and jpy = -97600 and gbp = -683.2 and eur = -108336 and  hkd = -878.4','')")

    con:query("insert into check_sql values(-975,'delete from transaction_total_check where cny = -975 and jpy = -97500 and gbp = -682.5 and eur = -108225 and  hkd = -877.5','')")

    con:query("insert into check_sql values(-974,'delete from transaction_total_check where cny = -974 and jpy = -97400 and gbp = -681.8 and eur = -108114 and  hkd = -876.6','')")

    con:query("insert into check_sql values(-973,'delete from transaction_total_check where cny = -973 and jpy = -97300 and gbp = -681.1 and eur = -108003 and  hkd = -875.7','')")

    con:query("insert into check_sql values(-972,'delete from transaction_total_check where cny = -972 and jpy = -97200 and gbp = -680.4 and eur = -107892 and  hkd = -874.8','')")

    con:query("insert into check_sql values(-971,'delete from transaction_total_check where cny = -971 and jpy = -97100 and gbp = -679.7 and eur = -107781 and  hkd = -873.9','')")

    con:query("insert into check_sql values(-970,'delete from transaction_total_check where cny = -970 and jpy = -97000 and gbp = -679.0 and eur = -107670 and  hkd = -873.0','')")

    con:query("insert into check_sql values(-969,'delete from transaction_total_check where cny = -969 and jpy = -96900 and gbp = -678.3 and eur = -107559 and  hkd = -872.1','')")

    con:query("insert into check_sql values(-968,'delete from transaction_total_check where cny = -968 and jpy = -96800 and gbp = -677.6 and eur = -107448 and  hkd = -871.2','')")

    con:query("insert into check_sql values(-967,'delete from transaction_total_check where cny = -967 and jpy = -96700 and gbp = -676.9 and eur = -107337 and  hkd = -870.3','')")

    con:query("insert into check_sql values(-966,'delete from transaction_total_check where cny = -966 and jpy = -96600 and gbp = -676.2 and eur = -107226 and  hkd = -869.4','')")

    con:query("insert into check_sql values(-965,'delete from transaction_total_check where cny = -965 and jpy = -96500 and gbp = -675.5 and eur = -107115 and  hkd = -868.5','')")

    con:query("insert into check_sql values(-964,'delete from transaction_total_check where cny = -964 and jpy = -96400 and gbp = -674.8 and eur = -107004 and  hkd = -867.6','')")

    con:query("insert into check_sql values(-963,'delete from transaction_total_check where cny = -963 and jpy = -96300 and gbp = -674.1 and eur = -106893 and  hkd = -866.7','')")

    con:query("insert into check_sql values(-962,'delete from transaction_total_check where cny = -962 and jpy = -96200 and gbp = -673.4 and eur = -106782 and  hkd = -865.8','')")

    con:query("insert into check_sql values(-961,'delete from transaction_total_check where cny = -961 and jpy = -96100 and gbp = -672.7 and eur = -106671 and  hkd = -864.9','')")

    con:query("insert into check_sql values(-960,'delete from transaction_total_check where cny = -960 and jpy = -96000 and gbp = -672.0 and eur = -106560 and  hkd = -864.0','')")

    con:query("insert into check_sql values(-959,'delete from transaction_total_check where cny = -959 and jpy = -95900 and gbp = -671.3 and eur = -106449 and  hkd = -863.1','')")

    con:query("insert into check_sql values(-958,'delete from transaction_total_check where cny = -958 and jpy = -95800 and gbp = -670.6 and eur = -106338 and  hkd = -862.2','')")

    con:query("insert into check_sql values(-957,'delete from transaction_total_check where cny = -957 and jpy = -95700 and gbp = -669.9 and eur = -106227 and  hkd = -861.3','')")

    con:query("insert into check_sql values(-956,'delete from transaction_total_check where cny = -956 and jpy = -95600 and gbp = -669.2 and eur = -106116 and  hkd = -860.4','')")

    con:query("insert into check_sql values(-955,'delete from transaction_total_check where cny = -955 and jpy = -95500 and gbp = -668.5 and eur = -106005 and  hkd = -859.5','')")

    con:query("insert into check_sql values(-954,'delete from transaction_total_check where cny = -954 and jpy = -95400 and gbp = -667.8 and eur = -105894 and  hkd = -858.6','')")

    con:query("insert into check_sql values(-953,'delete from transaction_total_check where cny = -953 and jpy = -95300 and gbp = -667.1 and eur = -105783 and  hkd = -857.7','')")

    con:query("insert into check_sql values(-952,'delete from transaction_total_check where cny = -952 and jpy = -95200 and gbp = -666.4 and eur = -105672 and  hkd = -856.8','')")

    con:query("insert into check_sql values(-951,'delete from transaction_total_check where cny = -951 and jpy = -95100 and gbp = -665.7 and eur = -105561 and  hkd = -855.9','')")

    con:query("insert into check_sql values(-950,'delete from transaction_total_check where cny = -950 and jpy = -95000 and gbp = -665.0 and eur = -105450 and  hkd = -855.0','')")

    con:query("insert into check_sql values(-949,'delete from transaction_total_check where cny = -949 and jpy = -94900 and gbp = -664.3 and eur = -105339 and  hkd = -854.1','')")

    con:query("insert into check_sql values(-948,'delete from transaction_total_check where cny = -948 and jpy = -94800 and gbp = -663.6 and eur = -105228 and  hkd = -853.2','')")

    con:query("insert into check_sql values(-947,'delete from transaction_total_check where cny = -947 and jpy = -94700 and gbp = -662.9 and eur = -105117 and  hkd = -852.3','')")

    con:query("insert into check_sql values(-946,'delete from transaction_total_check where cny = -946 and jpy = -94600 and gbp = -662.2 and eur = -105006 and  hkd = -851.4','')")

    con:query("insert into check_sql values(-945,'delete from transaction_total_check where cny = -945 and jpy = -94500 and gbp = -661.5 and eur = -104895 and  hkd = -850.5','')")

    con:query("insert into check_sql values(-944,'delete from transaction_total_check where cny = -944 and jpy = -94400 and gbp = -660.8 and eur = -104784 and  hkd = -849.6','')")

    con:query("insert into check_sql values(-943,'delete from transaction_total_check where cny = -943 and jpy = -94300 and gbp = -660.1 and eur = -104673 and  hkd = -848.7','')")

    con:query("insert into check_sql values(-942,'delete from transaction_total_check where cny = -942 and jpy = -94200 and gbp = -659.4 and eur = -104562 and  hkd = -847.8','')")

    con:query("insert into check_sql values(-941,'delete from transaction_total_check where cny = -941 and jpy = -94100 and gbp = -658.7 and eur = -104451 and  hkd = -846.9','')")

    con:query("insert into check_sql values(-940,'delete from transaction_total_check where cny = -940 and jpy = -94000 and gbp = -658.0 and eur = -104340 and  hkd = -846.0','')")

    con:query("insert into check_sql values(-939,'delete from transaction_total_check where cny = -939 and jpy = -93900 and gbp = -657.3 and eur = -104229 and  hkd = -845.1','')")

    con:query("insert into check_sql values(-938,'delete from transaction_total_check where cny = -938 and jpy = -93800 and gbp = -656.6 and eur = -104118 and  hkd = -844.2','')")

    con:query("insert into check_sql values(-937,'delete from transaction_total_check where cny = -937 and jpy = -93700 and gbp = -655.9 and eur = -104007 and  hkd = -843.3','')")

    con:query("insert into check_sql values(-936,'delete from transaction_total_check where cny = -936 and jpy = -93600 and gbp = -655.2 and eur = -103896 and  hkd = -842.4','')")

    con:query("insert into check_sql values(-935,'delete from transaction_total_check where cny = -935 and jpy = -93500 and gbp = -654.5 and eur = -103785 and  hkd = -841.5','')")

    con:query("insert into check_sql values(-934,'delete from transaction_total_check where cny = -934 and jpy = -93400 and gbp = -653.8 and eur = -103674 and  hkd = -840.6','')")

    con:query("insert into check_sql values(-933,'delete from transaction_total_check where cny = -933 and jpy = -93300 and gbp = -653.1 and eur = -103563 and  hkd = -839.7','')")

    con:query("insert into check_sql values(-932,'delete from transaction_total_check where cny = -932 and jpy = -93200 and gbp = -652.4 and eur = -103452 and  hkd = -838.8','')")

    con:query("insert into check_sql values(-931,'delete from transaction_total_check where cny = -931 and jpy = -93100 and gbp = -651.7 and eur = -103341 and  hkd = -837.9','')")

    con:query("insert into check_sql values(-930,'delete from transaction_total_check where cny = -930 and jpy = -93000 and gbp = -651.0 and eur = -103230 and  hkd = -837.0','')")

    con:query("insert into check_sql values(-929,'delete from transaction_total_check where cny = -929 and jpy = -92900 and gbp = -650.3 and eur = -103119 and  hkd = -836.1','')")

    con:query("insert into check_sql values(-928,'delete from transaction_total_check where cny = -928 and jpy = -92800 and gbp = -649.6 and eur = -103008 and  hkd = -835.2','')")

    con:query("insert into check_sql values(-927,'delete from transaction_total_check where cny = -927 and jpy = -92700 and gbp = -648.9 and eur = -102897 and  hkd = -834.3','')")

    con:query("insert into check_sql values(-926,'delete from transaction_total_check where cny = -926 and jpy = -92600 and gbp = -648.2 and eur = -102786 and  hkd = -833.4','')")

    con:query("insert into check_sql values(-925,'delete from transaction_total_check where cny = -925 and jpy = -92500 and gbp = -647.5 and eur = -102675 and  hkd = -832.5','')")

    con:query("insert into check_sql values(-924,'delete from transaction_total_check where cny = -924 and jpy = -92400 and gbp = -646.8 and eur = -102564 and  hkd = -831.6','')")

    con:query("insert into check_sql values(-923,'delete from transaction_total_check where cny = -923 and jpy = -92300 and gbp = -646.1 and eur = -102453 and  hkd = -830.7','')")

    con:query("insert into check_sql values(-922,'delete from transaction_total_check where cny = -922 and jpy = -92200 and gbp = -645.4 and eur = -102342 and  hkd = -829.8','')")

    con:query("insert into check_sql values(-921,'delete from transaction_total_check where cny = -921 and jpy = -92100 and gbp = -644.7 and eur = -102231 and  hkd = -828.9','')")

    con:query("insert into check_sql values(-920,'delete from transaction_total_check where cny = -920 and jpy = -92000 and gbp = -644.0 and eur = -102120 and  hkd = -828.0','')")

    con:query("insert into check_sql values(-919,'delete from transaction_total_check where cny = -919 and jpy = -91900 and gbp = -643.3 and eur = -102009 and  hkd = -827.1','')")

    con:query("insert into check_sql values(-918,'delete from transaction_total_check where cny = -918 and jpy = -91800 and gbp = -642.6 and eur = -101898 and  hkd = -826.2','')")

    con:query("insert into check_sql values(-917,'delete from transaction_total_check where cny = -917 and jpy = -91700 and gbp = -641.9 and eur = -101787 and  hkd = -825.3','')")

    con:query("insert into check_sql values(-916,'delete from transaction_total_check where cny = -916 and jpy = -91600 and gbp = -641.2 and eur = -101676 and  hkd = -824.4','')")

    con:query("insert into check_sql values(-915,'delete from transaction_total_check where cny = -915 and jpy = -91500 and gbp = -640.5 and eur = -101565 and  hkd = -823.5','')")

    con:query("insert into check_sql values(-914,'delete from transaction_total_check where cny = -914 and jpy = -91400 and gbp = -639.8 and eur = -101454 and  hkd = -822.6','')")

    con:query("insert into check_sql values(-913,'delete from transaction_total_check where cny = -913 and jpy = -91300 and gbp = -639.1 and eur = -101343 and  hkd = -821.7','')")

    con:query("insert into check_sql values(-912,'delete from transaction_total_check where cny = -912 and jpy = -91200 and gbp = -638.4 and eur = -101232 and  hkd = -820.8','')")

    con:query("insert into check_sql values(-911,'delete from transaction_total_check where cny = -911 and jpy = -91100 and gbp = -637.7 and eur = -101121 and  hkd = -819.9','')")

    con:query("insert into check_sql values(-910,'delete from transaction_total_check where cny = -910 and jpy = -91000 and gbp = -637.0 and eur = -101010 and  hkd = -819.0','')")

    con:query("insert into check_sql values(-909,'delete from transaction_total_check where cny = -909 and jpy = -90900 and gbp = -636.3 and eur = -100899 and  hkd = -818.1','')")

    con:query("insert into check_sql values(-908,'delete from transaction_total_check where cny = -908 and jpy = -90800 and gbp = -635.6 and eur = -100788 and  hkd = -817.2','')")

    con:query("insert into check_sql values(-907,'delete from transaction_total_check where cny = -907 and jpy = -90700 and gbp = -634.9 and eur = -100677 and  hkd = -816.3','')")

    con:query("insert into check_sql values(-906,'delete from transaction_total_check where cny = -906 and jpy = -90600 and gbp = -634.2 and eur = -100566 and  hkd = -815.4','')")

    con:query("insert into check_sql values(-905,'delete from transaction_total_check where cny = -905 and jpy = -90500 and gbp = -633.5 and eur = -100455 and  hkd = -814.5','')")

    con:query("insert into check_sql values(-904,'delete from transaction_total_check where cny = -904 and jpy = -90400 and gbp = -632.8 and eur = -100344 and  hkd = -813.6','')")

    con:query("insert into check_sql values(-903,'delete from transaction_total_check where cny = -903 and jpy = -90300 and gbp = -632.1 and eur = -100233 and  hkd = -812.7','')")

    con:query("insert into check_sql values(-902,'delete from transaction_total_check where cny = -902 and jpy = -90200 and gbp = -631.4 and eur = -100122 and  hkd = -811.8','')")

    con:query("insert into check_sql values(-901,'delete from transaction_total_check where cny = -901 and jpy = -90100 and gbp = -630.7 and eur = -100011 and  hkd = -810.9','')")

    con:query("insert into check_sql values(-900,'delete from transaction_total_check where cny = -900 and jpy = -90000 and gbp = -630.0 and eur = -99900 and  hkd = -810.0','')")

    con:query("insert into check_sql values(-899,'delete from transaction_total_check where cny = -899 and jpy = -89900 and gbp = -629.3 and eur = -99789 and  hkd = -809.1','')")

    con:query("insert into check_sql values(-898,'delete from transaction_total_check where cny = -898 and jpy = -89800 and gbp = -628.6 and eur = -99678 and  hkd = -808.2','')")

    con:query("insert into check_sql values(-897,'delete from transaction_total_check where cny = -897 and jpy = -89700 and gbp = -627.9 and eur = -99567 and  hkd = -807.3','')")

    con:query("insert into check_sql values(-896,'delete from transaction_total_check where cny = -896 and jpy = -89600 and gbp = -627.2 and eur = -99456 and  hkd = -806.4','')")

    con:query("insert into check_sql values(-895,'delete from transaction_total_check where cny = -895 and jpy = -89500 and gbp = -626.5 and eur = -99345 and  hkd = -805.5','')")

    con:query("insert into check_sql values(-894,'delete from transaction_total_check where cny = -894 and jpy = -89400 and gbp = -625.8 and eur = -99234 and  hkd = -804.6','')")

    con:query("insert into check_sql values(-893,'delete from transaction_total_check where cny = -893 and jpy = -89300 and gbp = -625.1 and eur = -99123 and  hkd = -803.7','')")

    con:query("insert into check_sql values(-892,'delete from transaction_total_check where cny = -892 and jpy = -89200 and gbp = -624.4 and eur = -99012 and  hkd = -802.8','')")

    con:query("insert into check_sql values(-891,'delete from transaction_total_check where cny = -891 and jpy = -89100 and gbp = -623.7 and eur = -98901 and  hkd = -801.9','')")

    con:query("insert into check_sql values(-890,'delete from transaction_total_check where cny = -890 and jpy = -89000 and gbp = -623.0 and eur = -98790 and  hkd = -801.0','')")

    con:query("insert into check_sql values(-889,'delete from transaction_total_check where cny = -889 and jpy = -88900 and gbp = -622.3 and eur = -98679 and  hkd = -800.1','')")

    con:query("insert into check_sql values(-888,'delete from transaction_total_check where cny = -888 and jpy = -88800 and gbp = -621.6 and eur = -98568 and  hkd = -799.2','')")

    con:query("insert into check_sql values(-887,'delete from transaction_total_check where cny = -887 and jpy = -88700 and gbp = -620.9 and eur = -98457 and  hkd = -798.3','')")

    con:query("insert into check_sql values(-886,'delete from transaction_total_check where cny = -886 and jpy = -88600 and gbp = -620.2 and eur = -98346 and  hkd = -797.4','')")

    con:query("insert into check_sql values(-885,'delete from transaction_total_check where cny = -885 and jpy = -88500 and gbp = -619.5 and eur = -98235 and  hkd = -796.5','')")

    con:query("insert into check_sql values(-884,'delete from transaction_total_check where cny = -884 and jpy = -88400 and gbp = -618.8 and eur = -98124 and  hkd = -795.6','')")

    con:query("insert into check_sql values(-883,'delete from transaction_total_check where cny = -883 and jpy = -88300 and gbp = -618.1 and eur = -98013 and  hkd = -794.7','')")

    con:query("insert into check_sql values(-882,'delete from transaction_total_check where cny = -882 and jpy = -88200 and gbp = -617.4 and eur = -97902 and  hkd = -793.8','')")

    con:query("insert into check_sql values(-881,'delete from transaction_total_check where cny = -881 and jpy = -88100 and gbp = -616.7 and eur = -97791 and  hkd = -792.9','')")

    con:query("insert into check_sql values(-880,'delete from transaction_total_check where cny = -880 and jpy = -88000 and gbp = -616.0 and eur = -97680 and  hkd = -792.0','')")

    con:query("insert into check_sql values(-879,'delete from transaction_total_check where cny = -879 and jpy = -87900 and gbp = -615.3 and eur = -97569 and  hkd = -791.1','')")

    con:query("insert into check_sql values(-878,'delete from transaction_total_check where cny = -878 and jpy = -87800 and gbp = -614.6 and eur = -97458 and  hkd = -790.2','')")

    con:query("insert into check_sql values(-877,'delete from transaction_total_check where cny = -877 and jpy = -87700 and gbp = -613.9 and eur = -97347 and  hkd = -789.3','')")

    con:query("insert into check_sql values(-876,'delete from transaction_total_check where cny = -876 and jpy = -87600 and gbp = -613.2 and eur = -97236 and  hkd = -788.4','')")

    con:query("insert into check_sql values(-875,'delete from transaction_total_check where cny = -875 and jpy = -87500 and gbp = -612.5 and eur = -97125 and  hkd = -787.5','')")

    con:query("insert into check_sql values(-874,'delete from transaction_total_check where cny = -874 and jpy = -87400 and gbp = -611.8 and eur = -97014 and  hkd = -786.6','')")

    con:query("insert into check_sql values(-873,'delete from transaction_total_check where cny = -873 and jpy = -87300 and gbp = -611.1 and eur = -96903 and  hkd = -785.7','')")

    con:query("insert into check_sql values(-872,'delete from transaction_total_check where cny = -872 and jpy = -87200 and gbp = -610.4 and eur = -96792 and  hkd = -784.8','')")

    con:query("insert into check_sql values(-871,'delete from transaction_total_check where cny = -871 and jpy = -87100 and gbp = -609.7 and eur = -96681 and  hkd = -783.9','')")

    con:query("insert into check_sql values(-870,'delete from transaction_total_check where cny = -870 and jpy = -87000 and gbp = -609.0 and eur = -96570 and  hkd = -783.0','')")

    con:query("insert into check_sql values(-869,'delete from transaction_total_check where cny = -869 and jpy = -86900 and gbp = -608.3 and eur = -96459 and  hkd = -782.1','')")

    con:query("insert into check_sql values(-868,'delete from transaction_total_check where cny = -868 and jpy = -86800 and gbp = -607.6 and eur = -96348 and  hkd = -781.2','')")

    con:query("insert into check_sql values(-867,'delete from transaction_total_check where cny = -867 and jpy = -86700 and gbp = -606.9 and eur = -96237 and  hkd = -780.3','')")

    con:query("insert into check_sql values(-866,'delete from transaction_total_check where cny = -866 and jpy = -86600 and gbp = -606.2 and eur = -96126 and  hkd = -779.4','')")

    con:query("insert into check_sql values(-865,'delete from transaction_total_check where cny = -865 and jpy = -86500 and gbp = -605.5 and eur = -96015 and  hkd = -778.5','')")

    con:query("insert into check_sql values(-864,'delete from transaction_total_check where cny = -864 and jpy = -86400 and gbp = -604.8 and eur = -95904 and  hkd = -777.6','')")

    con:query("insert into check_sql values(-863,'delete from transaction_total_check where cny = -863 and jpy = -86300 and gbp = -604.1 and eur = -95793 and  hkd = -776.7','')")

    con:query("insert into check_sql values(-862,'delete from transaction_total_check where cny = -862 and jpy = -86200 and gbp = -603.4 and eur = -95682 and  hkd = -775.8','')")

    con:query("insert into check_sql values(-861,'delete from transaction_total_check where cny = -861 and jpy = -86100 and gbp = -602.7 and eur = -95571 and  hkd = -774.9','')")

    con:query("insert into check_sql values(-860,'delete from transaction_total_check where cny = -860 and jpy = -86000 and gbp = -602.0 and eur = -95460 and  hkd = -774.0','')")

    con:query("insert into check_sql values(-859,'delete from transaction_total_check where cny = -859 and jpy = -85900 and gbp = -601.3 and eur = -95349 and  hkd = -773.1','')")

    con:query("insert into check_sql values(-858,'delete from transaction_total_check where cny = -858 and jpy = -85800 and gbp = -600.6 and eur = -95238 and  hkd = -772.2','')")

    con:query("insert into check_sql values(-857,'delete from transaction_total_check where cny = -857 and jpy = -85700 and gbp = -599.9 and eur = -95127 and  hkd = -771.3','')")

    con:query("insert into check_sql values(-856,'delete from transaction_total_check where cny = -856 and jpy = -85600 and gbp = -599.2 and eur = -95016 and  hkd = -770.4','')")

    con:query("insert into check_sql values(-855,'delete from transaction_total_check where cny = -855 and jpy = -85500 and gbp = -598.5 and eur = -94905 and  hkd = -769.5','')")

    con:query("insert into check_sql values(-854,'delete from transaction_total_check where cny = -854 and jpy = -85400 and gbp = -597.8 and eur = -94794 and  hkd = -768.6','')")

    con:query("insert into check_sql values(-853,'delete from transaction_total_check where cny = -853 and jpy = -85300 and gbp = -597.1 and eur = -94683 and  hkd = -767.7','')")

    con:query("insert into check_sql values(-852,'delete from transaction_total_check where cny = -852 and jpy = -85200 and gbp = -596.4 and eur = -94572 and  hkd = -766.8','')")

    con:query("insert into check_sql values(-851,'delete from transaction_total_check where cny = -851 and jpy = -85100 and gbp = -595.7 and eur = -94461 and  hkd = -765.9','')")

    con:query("insert into check_sql values(-850,'delete from transaction_total_check where cny = -850 and jpy = -85000 and gbp = -595.0 and eur = -94350 and  hkd = -765.0','')")

    con:query("insert into check_sql values(-849,'delete from transaction_total_check where cny = -849 and jpy = -84900 and gbp = -594.3 and eur = -94239 and  hkd = -764.1','')")

    con:query("insert into check_sql values(-848,'delete from transaction_total_check where cny = -848 and jpy = -84800 and gbp = -593.6 and eur = -94128 and  hkd = -763.2','')")

    con:query("insert into check_sql values(-847,'delete from transaction_total_check where cny = -847 and jpy = -84700 and gbp = -592.9 and eur = -94017 and  hkd = -762.3','')")

    con:query("insert into check_sql values(-846,'delete from transaction_total_check where cny = -846 and jpy = -84600 and gbp = -592.2 and eur = -93906 and  hkd = -761.4','')")

    con:query("insert into check_sql values(-845,'delete from transaction_total_check where cny = -845 and jpy = -84500 and gbp = -591.5 and eur = -93795 and  hkd = -760.5','')")

    con:query("insert into check_sql values(-844,'delete from transaction_total_check where cny = -844 and jpy = -84400 and gbp = -590.8 and eur = -93684 and  hkd = -759.6','')")

    con:query("insert into check_sql values(-843,'delete from transaction_total_check where cny = -843 and jpy = -84300 and gbp = -590.1 and eur = -93573 and  hkd = -758.7','')")

    con:query("insert into check_sql values(-842,'delete from transaction_total_check where cny = -842 and jpy = -84200 and gbp = -589.4 and eur = -93462 and  hkd = -757.8','')")

    con:query("insert into check_sql values(-841,'delete from transaction_total_check where cny = -841 and jpy = -84100 and gbp = -588.7 and eur = -93351 and  hkd = -756.9','')")

    con:query("insert into check_sql values(-840,'delete from transaction_total_check where cny = -840 and jpy = -84000 and gbp = -588.0 and eur = -93240 and  hkd = -756.0','')")

    con:query("insert into check_sql values(-839,'delete from transaction_total_check where cny = -839 and jpy = -83900 and gbp = -587.3 and eur = -93129 and  hkd = -755.1','')")

    con:query("insert into check_sql values(-838,'delete from transaction_total_check where cny = -838 and jpy = -83800 and gbp = -586.6 and eur = -93018 and  hkd = -754.2','')")

    con:query("insert into check_sql values(-837,'delete from transaction_total_check where cny = -837 and jpy = -83700 and gbp = -585.9 and eur = -92907 and  hkd = -753.3','')")

    con:query("insert into check_sql values(-836,'delete from transaction_total_check where cny = -836 and jpy = -83600 and gbp = -585.2 and eur = -92796 and  hkd = -752.4','')")

    con:query("insert into check_sql values(-835,'delete from transaction_total_check where cny = -835 and jpy = -83500 and gbp = -584.5 and eur = -92685 and  hkd = -751.5','')")

    con:query("insert into check_sql values(-834,'delete from transaction_total_check where cny = -834 and jpy = -83400 and gbp = -583.8 and eur = -92574 and  hkd = -750.6','')")

    con:query("insert into check_sql values(-833,'delete from transaction_total_check where cny = -833 and jpy = -83300 and gbp = -583.1 and eur = -92463 and  hkd = -749.7','')")

    con:query("insert into check_sql values(-832,'delete from transaction_total_check where cny = -832 and jpy = -83200 and gbp = -582.4 and eur = -92352 and  hkd = -748.8','')")

    con:query("insert into check_sql values(-831,'delete from transaction_total_check where cny = -831 and jpy = -83100 and gbp = -581.7 and eur = -92241 and  hkd = -747.9','')")

    con:query("insert into check_sql values(-830,'delete from transaction_total_check where cny = -830 and jpy = -83000 and gbp = -581.0 and eur = -92130 and  hkd = -747.0','')")

    con:query("insert into check_sql values(-829,'delete from transaction_total_check where cny = -829 and jpy = -82900 and gbp = -580.3 and eur = -92019 and  hkd = -746.1','')")

    con:query("insert into check_sql values(-828,'delete from transaction_total_check where cny = -828 and jpy = -82800 and gbp = -579.6 and eur = -91908 and  hkd = -745.2','')")

    con:query("insert into check_sql values(-827,'delete from transaction_total_check where cny = -827 and jpy = -82700 and gbp = -578.9 and eur = -91797 and  hkd = -744.3','')")

    con:query("insert into check_sql values(-826,'delete from transaction_total_check where cny = -826 and jpy = -82600 and gbp = -578.2 and eur = -91686 and  hkd = -743.4','')")

    con:query("insert into check_sql values(-825,'delete from transaction_total_check where cny = -825 and jpy = -82500 and gbp = -577.5 and eur = -91575 and  hkd = -742.5','')")

    con:query("insert into check_sql values(-824,'delete from transaction_total_check where cny = -824 and jpy = -82400 and gbp = -576.8 and eur = -91464 and  hkd = -741.6','')")

    con:query("insert into check_sql values(-823,'delete from transaction_total_check where cny = -823 and jpy = -82300 and gbp = -576.1 and eur = -91353 and  hkd = -740.7','')")

    con:query("insert into check_sql values(-822,'delete from transaction_total_check where cny = -822 and jpy = -82200 and gbp = -575.4 and eur = -91242 and  hkd = -739.8','')")

    con:query("insert into check_sql values(-821,'delete from transaction_total_check where cny = -821 and jpy = -82100 and gbp = -574.7 and eur = -91131 and  hkd = -738.9','')")

    con:query("insert into check_sql values(-820,'delete from transaction_total_check where cny = -820 and jpy = -82000 and gbp = -574.0 and eur = -91020 and  hkd = -738.0','')")

    con:query("insert into check_sql values(-819,'delete from transaction_total_check where cny = -819 and jpy = -81900 and gbp = -573.3 and eur = -90909 and  hkd = -737.1','')")

    con:query("insert into check_sql values(-818,'delete from transaction_total_check where cny = -818 and jpy = -81800 and gbp = -572.6 and eur = -90798 and  hkd = -736.2','')")

    con:query("insert into check_sql values(-817,'delete from transaction_total_check where cny = -817 and jpy = -81700 and gbp = -571.9 and eur = -90687 and  hkd = -735.3','')")

    con:query("insert into check_sql values(-816,'delete from transaction_total_check where cny = -816 and jpy = -81600 and gbp = -571.2 and eur = -90576 and  hkd = -734.4','')")

    con:query("insert into check_sql values(-815,'delete from transaction_total_check where cny = -815 and jpy = -81500 and gbp = -570.5 and eur = -90465 and  hkd = -733.5','')")

    con:query("insert into check_sql values(-814,'delete from transaction_total_check where cny = -814 and jpy = -81400 and gbp = -569.8 and eur = -90354 and  hkd = -732.6','')")

    con:query("insert into check_sql values(-813,'delete from transaction_total_check where cny = -813 and jpy = -81300 and gbp = -569.1 and eur = -90243 and  hkd = -731.7','')")

    con:query("insert into check_sql values(-812,'delete from transaction_total_check where cny = -812 and jpy = -81200 and gbp = -568.4 and eur = -90132 and  hkd = -730.8','')")

    con:query("insert into check_sql values(-811,'delete from transaction_total_check where cny = -811 and jpy = -81100 and gbp = -567.7 and eur = -90021 and  hkd = -729.9','')")

    con:query("insert into check_sql values(-810,'delete from transaction_total_check where cny = -810 and jpy = -81000 and gbp = -567.0 and eur = -89910 and  hkd = -729.0','')")

    con:query("insert into check_sql values(-809,'delete from transaction_total_check where cny = -809 and jpy = -80900 and gbp = -566.3 and eur = -89799 and  hkd = -728.1','')")

    con:query("insert into check_sql values(-808,'delete from transaction_total_check where cny = -808 and jpy = -80800 and gbp = -565.6 and eur = -89688 and  hkd = -727.2','')")

    con:query("insert into check_sql values(-807,'delete from transaction_total_check where cny = -807 and jpy = -80700 and gbp = -564.9 and eur = -89577 and  hkd = -726.3','')")

    con:query("insert into check_sql values(-806,'delete from transaction_total_check where cny = -806 and jpy = -80600 and gbp = -564.2 and eur = -89466 and  hkd = -725.4','')")

    con:query("insert into check_sql values(-805,'delete from transaction_total_check where cny = -805 and jpy = -80500 and gbp = -563.5 and eur = -89355 and  hkd = -724.5','')")

    con:query("insert into check_sql values(-804,'delete from transaction_total_check where cny = -804 and jpy = -80400 and gbp = -562.8 and eur = -89244 and  hkd = -723.6','')")

    con:query("insert into check_sql values(-803,'delete from transaction_total_check where cny = -803 and jpy = -80300 and gbp = -562.1 and eur = -89133 and  hkd = -722.7','')")

    con:query("insert into check_sql values(-802,'delete from transaction_total_check where cny = -802 and jpy = -80200 and gbp = -561.4 and eur = -89022 and  hkd = -721.8','')")

    con:query("insert into check_sql values(-801,'delete from transaction_total_check where cny = -801 and jpy = -80100 and gbp = -560.7 and eur = -88911 and  hkd = -720.9','')")

    con:query("insert into check_sql values(-800,'delete from transaction_total_check where cny = -800 and jpy = -80000 and gbp = -560.0 and eur = -88800 and  hkd = -720.0','')")

    con:query("insert into check_sql values(-799,'delete from transaction_total_check where cny = -799 and jpy = -79900 and gbp = -559.3 and eur = -88689 and  hkd = -719.1','')")

    con:query("insert into check_sql values(-798,'delete from transaction_total_check where cny = -798 and jpy = -79800 and gbp = -558.6 and eur = -88578 and  hkd = -718.2','')")

    con:query("insert into check_sql values(-797,'delete from transaction_total_check where cny = -797 and jpy = -79700 and gbp = -557.9 and eur = -88467 and  hkd = -717.3','')")

    con:query("insert into check_sql values(-796,'delete from transaction_total_check where cny = -796 and jpy = -79600 and gbp = -557.2 and eur = -88356 and  hkd = -716.4','')")

    con:query("insert into check_sql values(-795,'delete from transaction_total_check where cny = -795 and jpy = -79500 and gbp = -556.5 and eur = -88245 and  hkd = -715.5','')")

    con:query("insert into check_sql values(-794,'delete from transaction_total_check where cny = -794 and jpy = -79400 and gbp = -555.8 and eur = -88134 and  hkd = -714.6','')")

    con:query("insert into check_sql values(-793,'delete from transaction_total_check where cny = -793 and jpy = -79300 and gbp = -555.1 and eur = -88023 and  hkd = -713.7','')")

    con:query("insert into check_sql values(-792,'delete from transaction_total_check where cny = -792 and jpy = -79200 and gbp = -554.4 and eur = -87912 and  hkd = -712.8','')")

    con:query("insert into check_sql values(-791,'delete from transaction_total_check where cny = -791 and jpy = -79100 and gbp = -553.7 and eur = -87801 and  hkd = -711.9','')")

    con:query("insert into check_sql values(-790,'delete from transaction_total_check where cny = -790 and jpy = -79000 and gbp = -553.0 and eur = -87690 and  hkd = -711.0','')")

    con:query("insert into check_sql values(-789,'delete from transaction_total_check where cny = -789 and jpy = -78900 and gbp = -552.3 and eur = -87579 and  hkd = -710.1','')")

    con:query("insert into check_sql values(-788,'delete from transaction_total_check where cny = -788 and jpy = -78800 and gbp = -551.6 and eur = -87468 and  hkd = -709.2','')")

    con:query("insert into check_sql values(-787,'delete from transaction_total_check where cny = -787 and jpy = -78700 and gbp = -550.9 and eur = -87357 and  hkd = -708.3','')")

    con:query("insert into check_sql values(-786,'delete from transaction_total_check where cny = -786 and jpy = -78600 and gbp = -550.2 and eur = -87246 and  hkd = -707.4','')")

    con:query("insert into check_sql values(-785,'delete from transaction_total_check where cny = -785 and jpy = -78500 and gbp = -549.5 and eur = -87135 and  hkd = -706.5','')")

    con:query("insert into check_sql values(-784,'delete from transaction_total_check where cny = -784 and jpy = -78400 and gbp = -548.8 and eur = -87024 and  hkd = -705.6','')")

    con:query("insert into check_sql values(-783,'delete from transaction_total_check where cny = -783 and jpy = -78300 and gbp = -548.1 and eur = -86913 and  hkd = -704.7','')")

    con:query("insert into check_sql values(-782,'delete from transaction_total_check where cny = -782 and jpy = -78200 and gbp = -547.4 and eur = -86802 and  hkd = -703.8','')")

    con:query("insert into check_sql values(-781,'delete from transaction_total_check where cny = -781 and jpy = -78100 and gbp = -546.7 and eur = -86691 and  hkd = -702.9','')")

    con:query("insert into check_sql values(-780,'delete from transaction_total_check where cny = -780 and jpy = -78000 and gbp = -546.0 and eur = -86580 and  hkd = -702.0','')")

    con:query("insert into check_sql values(-779,'delete from transaction_total_check where cny = -779 and jpy = -77900 and gbp = -545.3 and eur = -86469 and  hkd = -701.1','')")

    con:query("insert into check_sql values(-778,'delete from transaction_total_check where cny = -778 and jpy = -77800 and gbp = -544.6 and eur = -86358 and  hkd = -700.2','')")

    con:query("insert into check_sql values(-777,'delete from transaction_total_check where cny = -777 and jpy = -77700 and gbp = -543.9 and eur = -86247 and  hkd = -699.3','')")

    con:query("insert into check_sql values(-776,'delete from transaction_total_check where cny = -776 and jpy = -77600 and gbp = -543.2 and eur = -86136 and  hkd = -698.4','')")

    con:query("insert into check_sql values(-775,'delete from transaction_total_check where cny = -775 and jpy = -77500 and gbp = -542.5 and eur = -86025 and  hkd = -697.5','')")

    con:query("insert into check_sql values(-774,'delete from transaction_total_check where cny = -774 and jpy = -77400 and gbp = -541.8 and eur = -85914 and  hkd = -696.6','')")

    con:query("insert into check_sql values(-773,'delete from transaction_total_check where cny = -773 and jpy = -77300 and gbp = -541.1 and eur = -85803 and  hkd = -695.7','')")

    con:query("insert into check_sql values(-772,'delete from transaction_total_check where cny = -772 and jpy = -77200 and gbp = -540.4 and eur = -85692 and  hkd = -694.8','')")

    con:query("insert into check_sql values(-771,'delete from transaction_total_check where cny = -771 and jpy = -77100 and gbp = -539.7 and eur = -85581 and  hkd = -693.9','')")

    con:query("insert into check_sql values(-770,'delete from transaction_total_check where cny = -770 and jpy = -77000 and gbp = -539.0 and eur = -85470 and  hkd = -693.0','')")

    con:query("insert into check_sql values(-769,'delete from transaction_total_check where cny = -769 and jpy = -76900 and gbp = -538.3 and eur = -85359 and  hkd = -692.1','')")

    con:query("insert into check_sql values(-768,'delete from transaction_total_check where cny = -768 and jpy = -76800 and gbp = -537.6 and eur = -85248 and  hkd = -691.2','')")

    con:query("insert into check_sql values(-767,'delete from transaction_total_check where cny = -767 and jpy = -76700 and gbp = -536.9 and eur = -85137 and  hkd = -690.3','')")

    con:query("insert into check_sql values(-766,'delete from transaction_total_check where cny = -766 and jpy = -76600 and gbp = -536.2 and eur = -85026 and  hkd = -689.4','')")

    con:query("insert into check_sql values(-765,'delete from transaction_total_check where cny = -765 and jpy = -76500 and gbp = -535.5 and eur = -84915 and  hkd = -688.5','')")

    con:query("insert into check_sql values(-764,'delete from transaction_total_check where cny = -764 and jpy = -76400 and gbp = -534.8 and eur = -84804 and  hkd = -687.6','')")

    con:query("insert into check_sql values(-763,'delete from transaction_total_check where cny = -763 and jpy = -76300 and gbp = -534.1 and eur = -84693 and  hkd = -686.7','')")

    con:query("insert into check_sql values(-762,'delete from transaction_total_check where cny = -762 and jpy = -76200 and gbp = -533.4 and eur = -84582 and  hkd = -685.8','')")

    con:query("insert into check_sql values(-761,'delete from transaction_total_check where cny = -761 and jpy = -76100 and gbp = -532.7 and eur = -84471 and  hkd = -684.9','')")

    con:query("insert into check_sql values(-760,'delete from transaction_total_check where cny = -760 and jpy = -76000 and gbp = -532.0 and eur = -84360 and  hkd = -684.0','')")

    con:query("insert into check_sql values(-759,'delete from transaction_total_check where cny = -759 and jpy = -75900 and gbp = -531.3 and eur = -84249 and  hkd = -683.1','')")

    con:query("insert into check_sql values(-758,'delete from transaction_total_check where cny = -758 and jpy = -75800 and gbp = -530.6 and eur = -84138 and  hkd = -682.2','')")

    con:query("insert into check_sql values(-757,'delete from transaction_total_check where cny = -757 and jpy = -75700 and gbp = -529.9 and eur = -84027 and  hkd = -681.3','')")

    con:query("insert into check_sql values(-756,'delete from transaction_total_check where cny = -756 and jpy = -75600 and gbp = -529.2 and eur = -83916 and  hkd = -680.4','')")

    con:query("insert into check_sql values(-755,'delete from transaction_total_check where cny = -755 and jpy = -75500 and gbp = -528.5 and eur = -83805 and  hkd = -679.5','')")

    con:query("insert into check_sql values(-754,'delete from transaction_total_check where cny = -754 and jpy = -75400 and gbp = -527.8 and eur = -83694 and  hkd = -678.6','')")

    con:query("insert into check_sql values(-753,'delete from transaction_total_check where cny = -753 and jpy = -75300 and gbp = -527.1 and eur = -83583 and  hkd = -677.7','')")

    con:query("insert into check_sql values(-752,'delete from transaction_total_check where cny = -752 and jpy = -75200 and gbp = -526.4 and eur = -83472 and  hkd = -676.8','')")

    con:query("insert into check_sql values(-751,'delete from transaction_total_check where cny = -751 and jpy = -75100 and gbp = -525.7 and eur = -83361 and  hkd = -675.9','')")

    con:query("insert into check_sql values(-750,'delete from transaction_total_check where cny = -750 and jpy = -75000 and gbp = -525.0 and eur = -83250 and  hkd = -675.0','')")

    con:query("insert into check_sql values(-749,'delete from transaction_total_check where cny = -749 and jpy = -74900 and gbp = -524.3 and eur = -83139 and  hkd = -674.1','')")

    con:query("insert into check_sql values(-748,'delete from transaction_total_check where cny = -748 and jpy = -74800 and gbp = -523.6 and eur = -83028 and  hkd = -673.2','')")

    con:query("insert into check_sql values(-747,'delete from transaction_total_check where cny = -747 and jpy = -74700 and gbp = -522.9 and eur = -82917 and  hkd = -672.3','')")

    con:query("insert into check_sql values(-746,'delete from transaction_total_check where cny = -746 and jpy = -74600 and gbp = -522.2 and eur = -82806 and  hkd = -671.4','')")

    con:query("insert into check_sql values(-745,'delete from transaction_total_check where cny = -745 and jpy = -74500 and gbp = -521.5 and eur = -82695 and  hkd = -670.5','')")

    con:query("insert into check_sql values(-744,'delete from transaction_total_check where cny = -744 and jpy = -74400 and gbp = -520.8 and eur = -82584 and  hkd = -669.6','')")

    con:query("insert into check_sql values(-743,'delete from transaction_total_check where cny = -743 and jpy = -74300 and gbp = -520.1 and eur = -82473 and  hkd = -668.7','')")

    con:query("insert into check_sql values(-742,'delete from transaction_total_check where cny = -742 and jpy = -74200 and gbp = -519.4 and eur = -82362 and  hkd = -667.8','')")

    con:query("insert into check_sql values(-741,'delete from transaction_total_check where cny = -741 and jpy = -74100 and gbp = -518.7 and eur = -82251 and  hkd = -666.9','')")

    con:query("insert into check_sql values(-740,'delete from transaction_total_check where cny = -740 and jpy = -74000 and gbp = -518.0 and eur = -82140 and  hkd = -666.0','')")

    con:query("insert into check_sql values(-739,'delete from transaction_total_check where cny = -739 and jpy = -73900 and gbp = -517.3 and eur = -82029 and  hkd = -665.1','')")

    con:query("insert into check_sql values(-738,'delete from transaction_total_check where cny = -738 and jpy = -73800 and gbp = -516.6 and eur = -81918 and  hkd = -664.2','')")

    con:query("insert into check_sql values(-737,'delete from transaction_total_check where cny = -737 and jpy = -73700 and gbp = -515.9 and eur = -81807 and  hkd = -663.3','')")

    con:query("insert into check_sql values(-736,'delete from transaction_total_check where cny = -736 and jpy = -73600 and gbp = -515.2 and eur = -81696 and  hkd = -662.4','')")

    con:query("insert into check_sql values(-735,'delete from transaction_total_check where cny = -735 and jpy = -73500 and gbp = -514.5 and eur = -81585 and  hkd = -661.5','')")

    con:query("insert into check_sql values(-734,'delete from transaction_total_check where cny = -734 and jpy = -73400 and gbp = -513.8 and eur = -81474 and  hkd = -660.6','')")

    con:query("insert into check_sql values(-733,'delete from transaction_total_check where cny = -733 and jpy = -73300 and gbp = -513.1 and eur = -81363 and  hkd = -659.7','')")

    con:query("insert into check_sql values(-732,'delete from transaction_total_check where cny = -732 and jpy = -73200 and gbp = -512.4 and eur = -81252 and  hkd = -658.8','')")

    con:query("insert into check_sql values(-731,'delete from transaction_total_check where cny = -731 and jpy = -73100 and gbp = -511.7 and eur = -81141 and  hkd = -657.9','')")

    con:query("insert into check_sql values(-730,'delete from transaction_total_check where cny = -730 and jpy = -73000 and gbp = -511.0 and eur = -81030 and  hkd = -657.0','')")

    con:query("insert into check_sql values(-729,'delete from transaction_total_check where cny = -729 and jpy = -72900 and gbp = -510.3 and eur = -80919 and  hkd = -656.1','')")

    con:query("insert into check_sql values(-728,'delete from transaction_total_check where cny = -728 and jpy = -72800 and gbp = -509.6 and eur = -80808 and  hkd = -655.2','')")

    con:query("insert into check_sql values(-727,'delete from transaction_total_check where cny = -727 and jpy = -72700 and gbp = -508.9 and eur = -80697 and  hkd = -654.3','')")

    con:query("insert into check_sql values(-726,'delete from transaction_total_check where cny = -726 and jpy = -72600 and gbp = -508.2 and eur = -80586 and  hkd = -653.4','')")

    con:query("insert into check_sql values(-725,'delete from transaction_total_check where cny = -725 and jpy = -72500 and gbp = -507.5 and eur = -80475 and  hkd = -652.5','')")

    con:query("insert into check_sql values(-724,'delete from transaction_total_check where cny = -724 and jpy = -72400 and gbp = -506.8 and eur = -80364 and  hkd = -651.6','')")

    con:query("insert into check_sql values(-723,'delete from transaction_total_check where cny = -723 and jpy = -72300 and gbp = -506.1 and eur = -80253 and  hkd = -650.7','')")

    con:query("insert into check_sql values(-722,'delete from transaction_total_check where cny = -722 and jpy = -72200 and gbp = -505.4 and eur = -80142 and  hkd = -649.8','')")

    con:query("insert into check_sql values(-721,'delete from transaction_total_check where cny = -721 and jpy = -72100 and gbp = -504.7 and eur = -80031 and  hkd = -648.9','')")

    con:query("insert into check_sql values(-720,'delete from transaction_total_check where cny = -720 and jpy = -72000 and gbp = -504.0 and eur = -79920 and  hkd = -648.0','')")

    con:query("insert into check_sql values(-719,'delete from transaction_total_check where cny = -719 and jpy = -71900 and gbp = -503.3 and eur = -79809 and  hkd = -647.1','')")

    con:query("insert into check_sql values(-718,'delete from transaction_total_check where cny = -718 and jpy = -71800 and gbp = -502.6 and eur = -79698 and  hkd = -646.2','')")

    con:query("insert into check_sql values(-717,'delete from transaction_total_check where cny = -717 and jpy = -71700 and gbp = -501.9 and eur = -79587 and  hkd = -645.3','')")

    con:query("insert into check_sql values(-716,'delete from transaction_total_check where cny = -716 and jpy = -71600 and gbp = -501.2 and eur = -79476 and  hkd = -644.4','')")

    con:query("insert into check_sql values(-715,'delete from transaction_total_check where cny = -715 and jpy = -71500 and gbp = -500.5 and eur = -79365 and  hkd = -643.5','')")

    con:query("insert into check_sql values(-714,'delete from transaction_total_check where cny = -714 and jpy = -71400 and gbp = -499.8 and eur = -79254 and  hkd = -642.6','')")

    con:query("insert into check_sql values(-713,'delete from transaction_total_check where cny = -713 and jpy = -71300 and gbp = -499.1 and eur = -79143 and  hkd = -641.7','')")

    con:query("insert into check_sql values(-712,'delete from transaction_total_check where cny = -712 and jpy = -71200 and gbp = -498.4 and eur = -79032 and  hkd = -640.8','')")

    con:query("insert into check_sql values(-711,'delete from transaction_total_check where cny = -711 and jpy = -71100 and gbp = -497.7 and eur = -78921 and  hkd = -639.9','')")

    con:query("insert into check_sql values(-710,'delete from transaction_total_check where cny = -710 and jpy = -71000 and gbp = -497.0 and eur = -78810 and  hkd = -639.0','')")

    con:query("insert into check_sql values(-709,'delete from transaction_total_check where cny = -709 and jpy = -70900 and gbp = -496.3 and eur = -78699 and  hkd = -638.1','')")

    con:query("insert into check_sql values(-708,'delete from transaction_total_check where cny = -708 and jpy = -70800 and gbp = -495.6 and eur = -78588 and  hkd = -637.2','')")

    con:query("insert into check_sql values(-707,'delete from transaction_total_check where cny = -707 and jpy = -70700 and gbp = -494.9 and eur = -78477 and  hkd = -636.3','')")

    con:query("insert into check_sql values(-706,'delete from transaction_total_check where cny = -706 and jpy = -70600 and gbp = -494.2 and eur = -78366 and  hkd = -635.4','')")

    con:query("insert into check_sql values(-705,'delete from transaction_total_check where cny = -705 and jpy = -70500 and gbp = -493.5 and eur = -78255 and  hkd = -634.5','')")

    con:query("insert into check_sql values(-704,'delete from transaction_total_check where cny = -704 and jpy = -70400 and gbp = -492.8 and eur = -78144 and  hkd = -633.6','')")

    con:query("insert into check_sql values(-703,'delete from transaction_total_check where cny = -703 and jpy = -70300 and gbp = -492.1 and eur = -78033 and  hkd = -632.7','')")

    con:query("insert into check_sql values(-702,'delete from transaction_total_check where cny = -702 and jpy = -70200 and gbp = -491.4 and eur = -77922 and  hkd = -631.8','')")

    con:query("insert into check_sql values(-701,'delete from transaction_total_check where cny = -701 and jpy = -70100 and gbp = -490.7 and eur = -77811 and  hkd = -630.9','')")

    con:query("insert into check_sql values(-700,'delete from transaction_total_check where cny = -700 and jpy = -70000 and gbp = -490.0 and eur = -77700 and  hkd = -630.0','')")

    con:query("insert into check_sql values(-699,'delete from transaction_total_check where cny = -699 and jpy = -69900 and gbp = -489.3 and eur = -77589 and  hkd = -629.1','')")

    con:query("insert into check_sql values(-698,'delete from transaction_total_check where cny = -698 and jpy = -69800 and gbp = -488.6 and eur = -77478 and  hkd = -628.2','')")

    con:query("insert into check_sql values(-697,'delete from transaction_total_check where cny = -697 and jpy = -69700 and gbp = -487.9 and eur = -77367 and  hkd = -627.3','')")

    con:query("insert into check_sql values(-696,'delete from transaction_total_check where cny = -696 and jpy = -69600 and gbp = -487.2 and eur = -77256 and  hkd = -626.4','')")

    con:query("insert into check_sql values(-695,'delete from transaction_total_check where cny = -695 and jpy = -69500 and gbp = -486.5 and eur = -77145 and  hkd = -625.5','')")

    con:query("insert into check_sql values(-694,'delete from transaction_total_check where cny = -694 and jpy = -69400 and gbp = -485.8 and eur = -77034 and  hkd = -624.6','')")

    con:query("insert into check_sql values(-693,'delete from transaction_total_check where cny = -693 and jpy = -69300 and gbp = -485.1 and eur = -76923 and  hkd = -623.7','')")

    con:query("insert into check_sql values(-692,'delete from transaction_total_check where cny = -692 and jpy = -69200 and gbp = -484.4 and eur = -76812 and  hkd = -622.8','')")

    con:query("insert into check_sql values(-691,'delete from transaction_total_check where cny = -691 and jpy = -69100 and gbp = -483.7 and eur = -76701 and  hkd = -621.9','')")

    con:query("insert into check_sql values(-690,'delete from transaction_total_check where cny = -690 and jpy = -69000 and gbp = -483.0 and eur = -76590 and  hkd = -621.0','')")

    con:query("insert into check_sql values(-689,'delete from transaction_total_check where cny = -689 and jpy = -68900 and gbp = -482.3 and eur = -76479 and  hkd = -620.1','')")

    con:query("insert into check_sql values(-688,'delete from transaction_total_check where cny = -688 and jpy = -68800 and gbp = -481.6 and eur = -76368 and  hkd = -619.2','')")

    con:query("insert into check_sql values(-687,'delete from transaction_total_check where cny = -687 and jpy = -68700 and gbp = -480.9 and eur = -76257 and  hkd = -618.3','')")

    con:query("insert into check_sql values(-686,'delete from transaction_total_check where cny = -686 and jpy = -68600 and gbp = -480.2 and eur = -76146 and  hkd = -617.4','')")

    con:query("insert into check_sql values(-685,'delete from transaction_total_check where cny = -685 and jpy = -68500 and gbp = -479.5 and eur = -76035 and  hkd = -616.5','')")

    con:query("insert into check_sql values(-684,'delete from transaction_total_check where cny = -684 and jpy = -68400 and gbp = -478.8 and eur = -75924 and  hkd = -615.6','')")

    con:query("insert into check_sql values(-683,'delete from transaction_total_check where cny = -683 and jpy = -68300 and gbp = -478.1 and eur = -75813 and  hkd = -614.7','')")

    con:query("insert into check_sql values(-682,'delete from transaction_total_check where cny = -682 and jpy = -68200 and gbp = -477.4 and eur = -75702 and  hkd = -613.8','')")

    con:query("insert into check_sql values(-681,'delete from transaction_total_check where cny = -681 and jpy = -68100 and gbp = -476.7 and eur = -75591 and  hkd = -612.9','')")

    con:query("insert into check_sql values(-680,'delete from transaction_total_check where cny = -680 and jpy = -68000 and gbp = -476.0 and eur = -75480 and  hkd = -612.0','')")

    con:query("insert into check_sql values(-679,'delete from transaction_total_check where cny = -679 and jpy = -67900 and gbp = -475.3 and eur = -75369 and  hkd = -611.1','')")

    con:query("insert into check_sql values(-678,'delete from transaction_total_check where cny = -678 and jpy = -67800 and gbp = -474.6 and eur = -75258 and  hkd = -610.2','')")

    con:query("insert into check_sql values(-677,'delete from transaction_total_check where cny = -677 and jpy = -67700 and gbp = -473.9 and eur = -75147 and  hkd = -609.3','')")

    con:query("insert into check_sql values(-676,'delete from transaction_total_check where cny = -676 and jpy = -67600 and gbp = -473.2 and eur = -75036 and  hkd = -608.4','')")

    con:query("insert into check_sql values(-675,'delete from transaction_total_check where cny = -675 and jpy = -67500 and gbp = -472.5 and eur = -74925 and  hkd = -607.5','')")

    con:query("insert into check_sql values(-674,'delete from transaction_total_check where cny = -674 and jpy = -67400 and gbp = -471.8 and eur = -74814 and  hkd = -606.6','')")

    con:query("insert into check_sql values(-673,'delete from transaction_total_check where cny = -673 and jpy = -67300 and gbp = -471.1 and eur = -74703 and  hkd = -605.7','')")

    con:query("insert into check_sql values(-672,'delete from transaction_total_check where cny = -672 and jpy = -67200 and gbp = -470.4 and eur = -74592 and  hkd = -604.8','')")

    con:query("insert into check_sql values(-671,'delete from transaction_total_check where cny = -671 and jpy = -67100 and gbp = -469.7 and eur = -74481 and  hkd = -603.9','')")

    con:query("insert into check_sql values(-670,'delete from transaction_total_check where cny = -670 and jpy = -67000 and gbp = -469.0 and eur = -74370 and  hkd = -603.0','')")

    con:query("insert into check_sql values(-669,'delete from transaction_total_check where cny = -669 and jpy = -66900 and gbp = -468.3 and eur = -74259 and  hkd = -602.1','')")

    con:query("insert into check_sql values(-668,'delete from transaction_total_check where cny = -668 and jpy = -66800 and gbp = -467.6 and eur = -74148 and  hkd = -601.2','')")

    con:query("insert into check_sql values(-667,'delete from transaction_total_check where cny = -667 and jpy = -66700 and gbp = -466.9 and eur = -74037 and  hkd = -600.3','')")

    con:query("insert into check_sql values(-666,'delete from transaction_total_check where cny = -666 and jpy = -66600 and gbp = -466.2 and eur = -73926 and  hkd = -599.4','')")

    con:query("insert into check_sql values(-665,'delete from transaction_total_check where cny = -665 and jpy = -66500 and gbp = -465.5 and eur = -73815 and  hkd = -598.5','')")

    con:query("insert into check_sql values(-664,'delete from transaction_total_check where cny = -664 and jpy = -66400 and gbp = -464.8 and eur = -73704 and  hkd = -597.6','')")

    con:query("insert into check_sql values(-663,'delete from transaction_total_check where cny = -663 and jpy = -66300 and gbp = -464.1 and eur = -73593 and  hkd = -596.7','')")

    con:query("insert into check_sql values(-662,'delete from transaction_total_check where cny = -662 and jpy = -66200 and gbp = -463.4 and eur = -73482 and  hkd = -595.8','')")

    con:query("insert into check_sql values(-661,'delete from transaction_total_check where cny = -661 and jpy = -66100 and gbp = -462.7 and eur = -73371 and  hkd = -594.9','')")

    con:query("insert into check_sql values(-660,'delete from transaction_total_check where cny = -660 and jpy = -66000 and gbp = -462.0 and eur = -73260 and  hkd = -594.0','')")

    con:query("insert into check_sql values(-659,'delete from transaction_total_check where cny = -659 and jpy = -65900 and gbp = -461.3 and eur = -73149 and  hkd = -593.1','')")

    con:query("insert into check_sql values(-658,'delete from transaction_total_check where cny = -658 and jpy = -65800 and gbp = -460.6 and eur = -73038 and  hkd = -592.2','')")

    con:query("insert into check_sql values(-657,'delete from transaction_total_check where cny = -657 and jpy = -65700 and gbp = -459.9 and eur = -72927 and  hkd = -591.3','')")

    con:query("insert into check_sql values(-656,'delete from transaction_total_check where cny = -656 and jpy = -65600 and gbp = -459.2 and eur = -72816 and  hkd = -590.4','')")

    con:query("insert into check_sql values(-655,'delete from transaction_total_check where cny = -655 and jpy = -65500 and gbp = -458.5 and eur = -72705 and  hkd = -589.5','')")

    con:query("insert into check_sql values(-654,'delete from transaction_total_check where cny = -654 and jpy = -65400 and gbp = -457.8 and eur = -72594 and  hkd = -588.6','')")

    con:query("insert into check_sql values(-653,'delete from transaction_total_check where cny = -653 and jpy = -65300 and gbp = -457.1 and eur = -72483 and  hkd = -587.7','')")

    con:query("insert into check_sql values(-652,'delete from transaction_total_check where cny = -652 and jpy = -65200 and gbp = -456.4 and eur = -72372 and  hkd = -586.8','')")

    con:query("insert into check_sql values(-651,'delete from transaction_total_check where cny = -651 and jpy = -65100 and gbp = -455.7 and eur = -72261 and  hkd = -585.9','')")

    con:query("insert into check_sql values(-650,'delete from transaction_total_check where cny = -650 and jpy = -65000 and gbp = -455.0 and eur = -72150 and  hkd = -585.0','')")

    con:query("insert into check_sql values(-649,'delete from transaction_total_check where cny = -649 and jpy = -64900 and gbp = -454.3 and eur = -72039 and  hkd = -584.1','')")

    con:query("insert into check_sql values(-648,'delete from transaction_total_check where cny = -648 and jpy = -64800 and gbp = -453.6 and eur = -71928 and  hkd = -583.2','')")

    con:query("insert into check_sql values(-647,'delete from transaction_total_check where cny = -647 and jpy = -64700 and gbp = -452.9 and eur = -71817 and  hkd = -582.3','')")

    con:query("insert into check_sql values(-646,'delete from transaction_total_check where cny = -646 and jpy = -64600 and gbp = -452.2 and eur = -71706 and  hkd = -581.4','')")

    con:query("insert into check_sql values(-645,'delete from transaction_total_check where cny = -645 and jpy = -64500 and gbp = -451.5 and eur = -71595 and  hkd = -580.5','')")

    con:query("insert into check_sql values(-644,'delete from transaction_total_check where cny = -644 and jpy = -64400 and gbp = -450.8 and eur = -71484 and  hkd = -579.6','')")

    con:query("insert into check_sql values(-643,'delete from transaction_total_check where cny = -643 and jpy = -64300 and gbp = -450.1 and eur = -71373 and  hkd = -578.7','')")

    con:query("insert into check_sql values(-642,'delete from transaction_total_check where cny = -642 and jpy = -64200 and gbp = -449.4 and eur = -71262 and  hkd = -577.8','')")

    con:query("insert into check_sql values(-641,'delete from transaction_total_check where cny = -641 and jpy = -64100 and gbp = -448.7 and eur = -71151 and  hkd = -576.9','')")

    con:query("insert into check_sql values(-640,'delete from transaction_total_check where cny = -640 and jpy = -64000 and gbp = -448.0 and eur = -71040 and  hkd = -576.0','')")

    con:query("insert into check_sql values(-639,'delete from transaction_total_check where cny = -639 and jpy = -63900 and gbp = -447.3 and eur = -70929 and  hkd = -575.1','')")

    con:query("insert into check_sql values(-638,'delete from transaction_total_check where cny = -638 and jpy = -63800 and gbp = -446.6 and eur = -70818 and  hkd = -574.2','')")

    con:query("insert into check_sql values(-637,'delete from transaction_total_check where cny = -637 and jpy = -63700 and gbp = -445.9 and eur = -70707 and  hkd = -573.3','')")

    con:query("insert into check_sql values(-636,'delete from transaction_total_check where cny = -636 and jpy = -63600 and gbp = -445.2 and eur = -70596 and  hkd = -572.4','')")

    con:query("insert into check_sql values(-635,'delete from transaction_total_check where cny = -635 and jpy = -63500 and gbp = -444.5 and eur = -70485 and  hkd = -571.5','')")

    con:query("insert into check_sql values(-634,'delete from transaction_total_check where cny = -634 and jpy = -63400 and gbp = -443.8 and eur = -70374 and  hkd = -570.6','')")

    con:query("insert into check_sql values(-633,'delete from transaction_total_check where cny = -633 and jpy = -63300 and gbp = -443.1 and eur = -70263 and  hkd = -569.7','')")

    con:query("insert into check_sql values(-632,'delete from transaction_total_check where cny = -632 and jpy = -63200 and gbp = -442.4 and eur = -70152 and  hkd = -568.8','')")

    con:query("insert into check_sql values(-631,'delete from transaction_total_check where cny = -631 and jpy = -63100 and gbp = -441.7 and eur = -70041 and  hkd = -567.9','')")

    con:query("insert into check_sql values(-630,'delete from transaction_total_check where cny = -630 and jpy = -63000 and gbp = -441.0 and eur = -69930 and  hkd = -567.0','')")

    con:query("insert into check_sql values(-629,'delete from transaction_total_check where cny = -629 and jpy = -62900 and gbp = -440.3 and eur = -69819 and  hkd = -566.1','')")

    con:query("insert into check_sql values(-628,'delete from transaction_total_check where cny = -628 and jpy = -62800 and gbp = -439.6 and eur = -69708 and  hkd = -565.2','')")

    con:query("insert into check_sql values(-627,'delete from transaction_total_check where cny = -627 and jpy = -62700 and gbp = -438.9 and eur = -69597 and  hkd = -564.3','')")

    con:query("insert into check_sql values(-626,'delete from transaction_total_check where cny = -626 and jpy = -62600 and gbp = -438.2 and eur = -69486 and  hkd = -563.4','')")

    con:query("insert into check_sql values(-625,'delete from transaction_total_check where cny = -625 and jpy = -62500 and gbp = -437.5 and eur = -69375 and  hkd = -562.5','')")

    con:query("insert into check_sql values(-624,'delete from transaction_total_check where cny = -624 and jpy = -62400 and gbp = -436.8 and eur = -69264 and  hkd = -561.6','')")

    con:query("insert into check_sql values(-623,'delete from transaction_total_check where cny = -623 and jpy = -62300 and gbp = -436.1 and eur = -69153 and  hkd = -560.7','')")

    con:query("insert into check_sql values(-622,'delete from transaction_total_check where cny = -622 and jpy = -62200 and gbp = -435.4 and eur = -69042 and  hkd = -559.8','')")

    con:query("insert into check_sql values(-621,'delete from transaction_total_check where cny = -621 and jpy = -62100 and gbp = -434.7 and eur = -68931 and  hkd = -558.9','')")

    con:query("insert into check_sql values(-620,'delete from transaction_total_check where cny = -620 and jpy = -62000 and gbp = -434.0 and eur = -68820 and  hkd = -558.0','')")

    con:query("insert into check_sql values(-619,'delete from transaction_total_check where cny = -619 and jpy = -61900 and gbp = -433.3 and eur = -68709 and  hkd = -557.1','')")

    con:query("insert into check_sql values(-618,'delete from transaction_total_check where cny = -618 and jpy = -61800 and gbp = -432.6 and eur = -68598 and  hkd = -556.2','')")

    con:query("insert into check_sql values(-617,'delete from transaction_total_check where cny = -617 and jpy = -61700 and gbp = -431.9 and eur = -68487 and  hkd = -555.3','')")

    con:query("insert into check_sql values(-616,'delete from transaction_total_check where cny = -616 and jpy = -61600 and gbp = -431.2 and eur = -68376 and  hkd = -554.4','')")

    con:query("insert into check_sql values(-615,'delete from transaction_total_check where cny = -615 and jpy = -61500 and gbp = -430.5 and eur = -68265 and  hkd = -553.5','')")

    con:query("insert into check_sql values(-614,'delete from transaction_total_check where cny = -614 and jpy = -61400 and gbp = -429.8 and eur = -68154 and  hkd = -552.6','')")

    con:query("insert into check_sql values(-613,'delete from transaction_total_check where cny = -613 and jpy = -61300 and gbp = -429.1 and eur = -68043 and  hkd = -551.7','')")

    con:query("insert into check_sql values(-612,'delete from transaction_total_check where cny = -612 and jpy = -61200 and gbp = -428.4 and eur = -67932 and  hkd = -550.8','')")

    con:query("insert into check_sql values(-611,'delete from transaction_total_check where cny = -611 and jpy = -61100 and gbp = -427.7 and eur = -67821 and  hkd = -549.9','')")

    con:query("insert into check_sql values(-610,'delete from transaction_total_check where cny = -610 and jpy = -61000 and gbp = -427.0 and eur = -67710 and  hkd = -549.0','')")

    con:query("insert into check_sql values(-609,'delete from transaction_total_check where cny = -609 and jpy = -60900 and gbp = -426.3 and eur = -67599 and  hkd = -548.1','')")

    con:query("insert into check_sql values(-608,'delete from transaction_total_check where cny = -608 and jpy = -60800 and gbp = -425.6 and eur = -67488 and  hkd = -547.2','')")

    con:query("insert into check_sql values(-607,'delete from transaction_total_check where cny = -607 and jpy = -60700 and gbp = -424.9 and eur = -67377 and  hkd = -546.3','')")

    con:query("insert into check_sql values(-606,'delete from transaction_total_check where cny = -606 and jpy = -60600 and gbp = -424.2 and eur = -67266 and  hkd = -545.4','')")

    con:query("insert into check_sql values(-605,'delete from transaction_total_check where cny = -605 and jpy = -60500 and gbp = -423.5 and eur = -67155 and  hkd = -544.5','')")

    con:query("insert into check_sql values(-604,'delete from transaction_total_check where cny = -604 and jpy = -60400 and gbp = -422.8 and eur = -67044 and  hkd = -543.6','')")

    con:query("insert into check_sql values(-603,'delete from transaction_total_check where cny = -603 and jpy = -60300 and gbp = -422.1 and eur = -66933 and  hkd = -542.7','')")

    con:query("insert into check_sql values(-602,'delete from transaction_total_check where cny = -602 and jpy = -60200 and gbp = -421.4 and eur = -66822 and  hkd = -541.8','')")

    con:query("insert into check_sql values(-601,'delete from transaction_total_check where cny = -601 and jpy = -60100 and gbp = -420.7 and eur = -66711 and  hkd = -540.9','')")

    con:query("insert into check_sql values(-600,'delete from transaction_total_check where cny = -600 and jpy = -60000 and gbp = -420.0 and eur = -66600 and  hkd = -540.0','')")

    con:query("insert into check_sql values(-599,'delete from transaction_total_check where cny = -599 and jpy = -59900 and gbp = -419.3 and eur = -66489 and  hkd = -539.1','')")

    con:query("insert into check_sql values(-598,'delete from transaction_total_check where cny = -598 and jpy = -59800 and gbp = -418.6 and eur = -66378 and  hkd = -538.2','')")

    con:query("insert into check_sql values(-597,'delete from transaction_total_check where cny = -597 and jpy = -59700 and gbp = -417.9 and eur = -66267 and  hkd = -537.3','')")

    con:query("insert into check_sql values(-596,'delete from transaction_total_check where cny = -596 and jpy = -59600 and gbp = -417.2 and eur = -66156 and  hkd = -536.4','')")

    con:query("insert into check_sql values(-595,'delete from transaction_total_check where cny = -595 and jpy = -59500 and gbp = -416.5 and eur = -66045 and  hkd = -535.5','')")

    con:query("insert into check_sql values(-594,'delete from transaction_total_check where cny = -594 and jpy = -59400 and gbp = -415.8 and eur = -65934 and  hkd = -534.6','')")

    con:query("insert into check_sql values(-593,'delete from transaction_total_check where cny = -593 and jpy = -59300 and gbp = -415.1 and eur = -65823 and  hkd = -533.7','')")

    con:query("insert into check_sql values(-592,'delete from transaction_total_check where cny = -592 and jpy = -59200 and gbp = -414.4 and eur = -65712 and  hkd = -532.8','')")

    con:query("insert into check_sql values(-591,'delete from transaction_total_check where cny = -591 and jpy = -59100 and gbp = -413.7 and eur = -65601 and  hkd = -531.9','')")

    con:query("insert into check_sql values(-590,'delete from transaction_total_check where cny = -590 and jpy = -59000 and gbp = -413.0 and eur = -65490 and  hkd = -531.0','')")

    con:query("insert into check_sql values(-589,'delete from transaction_total_check where cny = -589 and jpy = -58900 and gbp = -412.3 and eur = -65379 and  hkd = -530.1','')")

    con:query("insert into check_sql values(-588,'delete from transaction_total_check where cny = -588 and jpy = -58800 and gbp = -411.6 and eur = -65268 and  hkd = -529.2','')")

    con:query("insert into check_sql values(-587,'delete from transaction_total_check where cny = -587 and jpy = -58700 and gbp = -410.9 and eur = -65157 and  hkd = -528.3','')")

    con:query("insert into check_sql values(-586,'delete from transaction_total_check where cny = -586 and jpy = -58600 and gbp = -410.2 and eur = -65046 and  hkd = -527.4','')")

    con:query("insert into check_sql values(-585,'delete from transaction_total_check where cny = -585 and jpy = -58500 and gbp = -409.5 and eur = -64935 and  hkd = -526.5','')")

    con:query("insert into check_sql values(-584,'delete from transaction_total_check where cny = -584 and jpy = -58400 and gbp = -408.8 and eur = -64824 and  hkd = -525.6','')")

    con:query("insert into check_sql values(-583,'delete from transaction_total_check where cny = -583 and jpy = -58300 and gbp = -408.1 and eur = -64713 and  hkd = -524.7','')")

    con:query("insert into check_sql values(-582,'delete from transaction_total_check where cny = -582 and jpy = -58200 and gbp = -407.4 and eur = -64602 and  hkd = -523.8','')")

    con:query("insert into check_sql values(-581,'delete from transaction_total_check where cny = -581 and jpy = -58100 and gbp = -406.7 and eur = -64491 and  hkd = -522.9','')")

    con:query("insert into check_sql values(-580,'delete from transaction_total_check where cny = -580 and jpy = -58000 and gbp = -406.0 and eur = -64380 and  hkd = -522.0','')")

    con:query("insert into check_sql values(-579,'delete from transaction_total_check where cny = -579 and jpy = -57900 and gbp = -405.3 and eur = -64269 and  hkd = -521.1','')")

    con:query("insert into check_sql values(-578,'delete from transaction_total_check where cny = -578 and jpy = -57800 and gbp = -404.6 and eur = -64158 and  hkd = -520.2','')")

    con:query("insert into check_sql values(-577,'delete from transaction_total_check where cny = -577 and jpy = -57700 and gbp = -403.9 and eur = -64047 and  hkd = -519.3','')")

    con:query("insert into check_sql values(-576,'delete from transaction_total_check where cny = -576 and jpy = -57600 and gbp = -403.2 and eur = -63936 and  hkd = -518.4','')")

    con:query("insert into check_sql values(-575,'delete from transaction_total_check where cny = -575 and jpy = -57500 and gbp = -402.5 and eur = -63825 and  hkd = -517.5','')")

    con:query("insert into check_sql values(-574,'delete from transaction_total_check where cny = -574 and jpy = -57400 and gbp = -401.8 and eur = -63714 and  hkd = -516.6','')")

    con:query("insert into check_sql values(-573,'delete from transaction_total_check where cny = -573 and jpy = -57300 and gbp = -401.1 and eur = -63603 and  hkd = -515.7','')")

    con:query("insert into check_sql values(-572,'delete from transaction_total_check where cny = -572 and jpy = -57200 and gbp = -400.4 and eur = -63492 and  hkd = -514.8','')")

    con:query("insert into check_sql values(-571,'delete from transaction_total_check where cny = -571 and jpy = -57100 and gbp = -399.7 and eur = -63381 and  hkd = -513.9','')")

    con:query("insert into check_sql values(-570,'delete from transaction_total_check where cny = -570 and jpy = -57000 and gbp = -399.0 and eur = -63270 and  hkd = -513.0','')")

    con:query("insert into check_sql values(-569,'delete from transaction_total_check where cny = -569 and jpy = -56900 and gbp = -398.3 and eur = -63159 and  hkd = -512.1','')")

    con:query("insert into check_sql values(-568,'delete from transaction_total_check where cny = -568 and jpy = -56800 and gbp = -397.6 and eur = -63048 and  hkd = -511.2','')")

    con:query("insert into check_sql values(-567,'delete from transaction_total_check where cny = -567 and jpy = -56700 and gbp = -396.9 and eur = -62937 and  hkd = -510.3','')")

    con:query("insert into check_sql values(-566,'delete from transaction_total_check where cny = -566 and jpy = -56600 and gbp = -396.2 and eur = -62826 and  hkd = -509.4','')")

    con:query("insert into check_sql values(-565,'delete from transaction_total_check where cny = -565 and jpy = -56500 and gbp = -395.5 and eur = -62715 and  hkd = -508.5','')")

    con:query("insert into check_sql values(-564,'delete from transaction_total_check where cny = -564 and jpy = -56400 and gbp = -394.8 and eur = -62604 and  hkd = -507.6','')")

    con:query("insert into check_sql values(-563,'delete from transaction_total_check where cny = -563 and jpy = -56300 and gbp = -394.1 and eur = -62493 and  hkd = -506.7','')")

    con:query("insert into check_sql values(-562,'delete from transaction_total_check where cny = -562 and jpy = -56200 and gbp = -393.4 and eur = -62382 and  hkd = -505.8','')")

    con:query("insert into check_sql values(-561,'delete from transaction_total_check where cny = -561 and jpy = -56100 and gbp = -392.7 and eur = -62271 and  hkd = -504.9','')")

    con:query("insert into check_sql values(-560,'delete from transaction_total_check where cny = -560 and jpy = -56000 and gbp = -392.0 and eur = -62160 and  hkd = -504.0','')")

    con:query("insert into check_sql values(-559,'delete from transaction_total_check where cny = -559 and jpy = -55900 and gbp = -391.3 and eur = -62049 and  hkd = -503.1','')")

    con:query("insert into check_sql values(-558,'delete from transaction_total_check where cny = -558 and jpy = -55800 and gbp = -390.6 and eur = -61938 and  hkd = -502.2','')")

    con:query("insert into check_sql values(-557,'delete from transaction_total_check where cny = -557 and jpy = -55700 and gbp = -389.9 and eur = -61827 and  hkd = -501.3','')")

    con:query("insert into check_sql values(-556,'delete from transaction_total_check where cny = -556 and jpy = -55600 and gbp = -389.2 and eur = -61716 and  hkd = -500.4','')")

    con:query("insert into check_sql values(-555,'delete from transaction_total_check where cny = -555 and jpy = -55500 and gbp = -388.5 and eur = -61605 and  hkd = -499.5','')")

    con:query("insert into check_sql values(-554,'delete from transaction_total_check where cny = -554 and jpy = -55400 and gbp = -387.8 and eur = -61494 and  hkd = -498.6','')")

    con:query("insert into check_sql values(-553,'delete from transaction_total_check where cny = -553 and jpy = -55300 and gbp = -387.1 and eur = -61383 and  hkd = -497.7','')")

    con:query("insert into check_sql values(-552,'delete from transaction_total_check where cny = -552 and jpy = -55200 and gbp = -386.4 and eur = -61272 and  hkd = -496.8','')")

    con:query("insert into check_sql values(-551,'delete from transaction_total_check where cny = -551 and jpy = -55100 and gbp = -385.7 and eur = -61161 and  hkd = -495.9','')")

    con:query("insert into check_sql values(-550,'delete from transaction_total_check where cny = -550 and jpy = -55000 and gbp = -385.0 and eur = -61050 and  hkd = -495.0','')")

    con:query("insert into check_sql values(-549,'delete from transaction_total_check where cny = -549 and jpy = -54900 and gbp = -384.3 and eur = -60939 and  hkd = -494.1','')")

    con:query("insert into check_sql values(-548,'delete from transaction_total_check where cny = -548 and jpy = -54800 and gbp = -383.6 and eur = -60828 and  hkd = -493.2','')")

    con:query("insert into check_sql values(-547,'delete from transaction_total_check where cny = -547 and jpy = -54700 and gbp = -382.9 and eur = -60717 and  hkd = -492.3','')")

    con:query("insert into check_sql values(-546,'delete from transaction_total_check where cny = -546 and jpy = -54600 and gbp = -382.2 and eur = -60606 and  hkd = -491.4','')")

    con:query("insert into check_sql values(-545,'delete from transaction_total_check where cny = -545 and jpy = -54500 and gbp = -381.5 and eur = -60495 and  hkd = -490.5','')")

    con:query("insert into check_sql values(-544,'delete from transaction_total_check where cny = -544 and jpy = -54400 and gbp = -380.8 and eur = -60384 and  hkd = -489.6','')")

    con:query("insert into check_sql values(-543,'delete from transaction_total_check where cny = -543 and jpy = -54300 and gbp = -380.1 and eur = -60273 and  hkd = -488.7','')")

    con:query("insert into check_sql values(-542,'delete from transaction_total_check where cny = -542 and jpy = -54200 and gbp = -379.4 and eur = -60162 and  hkd = -487.8','')")

    con:query("insert into check_sql values(-541,'delete from transaction_total_check where cny = -541 and jpy = -54100 and gbp = -378.7 and eur = -60051 and  hkd = -486.9','')")

    con:query("insert into check_sql values(-540,'delete from transaction_total_check where cny = -540 and jpy = -54000 and gbp = -378.0 and eur = -59940 and  hkd = -486.0','')")

    con:query("insert into check_sql values(-539,'delete from transaction_total_check where cny = -539 and jpy = -53900 and gbp = -377.3 and eur = -59829 and  hkd = -485.1','')")

    con:query("insert into check_sql values(-538,'delete from transaction_total_check where cny = -538 and jpy = -53800 and gbp = -376.6 and eur = -59718 and  hkd = -484.2','')")

    con:query("insert into check_sql values(-537,'delete from transaction_total_check where cny = -537 and jpy = -53700 and gbp = -375.9 and eur = -59607 and  hkd = -483.3','')")

    con:query("insert into check_sql values(-536,'delete from transaction_total_check where cny = -536 and jpy = -53600 and gbp = -375.2 and eur = -59496 and  hkd = -482.4','')")

    con:query("insert into check_sql values(-535,'delete from transaction_total_check where cny = -535 and jpy = -53500 and gbp = -374.5 and eur = -59385 and  hkd = -481.5','')")

    con:query("insert into check_sql values(-534,'delete from transaction_total_check where cny = -534 and jpy = -53400 and gbp = -373.8 and eur = -59274 and  hkd = -480.6','')")

    con:query("insert into check_sql values(-533,'delete from transaction_total_check where cny = -533 and jpy = -53300 and gbp = -373.1 and eur = -59163 and  hkd = -479.7','')")

    con:query("insert into check_sql values(-532,'delete from transaction_total_check where cny = -532 and jpy = -53200 and gbp = -372.4 and eur = -59052 and  hkd = -478.8','')")

    con:query("insert into check_sql values(-531,'delete from transaction_total_check where cny = -531 and jpy = -53100 and gbp = -371.7 and eur = -58941 and  hkd = -477.9','')")

    con:query("insert into check_sql values(-530,'delete from transaction_total_check where cny = -530 and jpy = -53000 and gbp = -371.0 and eur = -58830 and  hkd = -477.0','')")

    con:query("insert into check_sql values(-529,'delete from transaction_total_check where cny = -529 and jpy = -52900 and gbp = -370.3 and eur = -58719 and  hkd = -476.1','')")

    con:query("insert into check_sql values(-528,'delete from transaction_total_check where cny = -528 and jpy = -52800 and gbp = -369.6 and eur = -58608 and  hkd = -475.2','')")

    con:query("insert into check_sql values(-527,'delete from transaction_total_check where cny = -527 and jpy = -52700 and gbp = -368.9 and eur = -58497 and  hkd = -474.3','')")

    con:query("insert into check_sql values(-526,'delete from transaction_total_check where cny = -526 and jpy = -52600 and gbp = -368.2 and eur = -58386 and  hkd = -473.4','')")

    con:query("insert into check_sql values(-525,'delete from transaction_total_check where cny = -525 and jpy = -52500 and gbp = -367.5 and eur = -58275 and  hkd = -472.5','')")

    con:query("insert into check_sql values(-524,'delete from transaction_total_check where cny = -524 and jpy = -52400 and gbp = -366.8 and eur = -58164 and  hkd = -471.6','')")

    con:query("insert into check_sql values(-523,'delete from transaction_total_check where cny = -523 and jpy = -52300 and gbp = -366.1 and eur = -58053 and  hkd = -470.7','')")

    con:query("insert into check_sql values(-522,'delete from transaction_total_check where cny = -522 and jpy = -52200 and gbp = -365.4 and eur = -57942 and  hkd = -469.8','')")

    con:query("insert into check_sql values(-521,'delete from transaction_total_check where cny = -521 and jpy = -52100 and gbp = -364.7 and eur = -57831 and  hkd = -468.9','')")

    con:query("insert into check_sql values(-520,'delete from transaction_total_check where cny = -520 and jpy = -52000 and gbp = -364.0 and eur = -57720 and  hkd = -468.0','')")

    con:query("insert into check_sql values(-519,'delete from transaction_total_check where cny = -519 and jpy = -51900 and gbp = -363.3 and eur = -57609 and  hkd = -467.1','')")

    con:query("insert into check_sql values(-518,'delete from transaction_total_check where cny = -518 and jpy = -51800 and gbp = -362.6 and eur = -57498 and  hkd = -466.2','')")

    con:query("insert into check_sql values(-517,'delete from transaction_total_check where cny = -517 and jpy = -51700 and gbp = -361.9 and eur = -57387 and  hkd = -465.3','')")

    con:query("insert into check_sql values(-516,'delete from transaction_total_check where cny = -516 and jpy = -51600 and gbp = -361.2 and eur = -57276 and  hkd = -464.4','')")

    con:query("insert into check_sql values(-515,'delete from transaction_total_check where cny = -515 and jpy = -51500 and gbp = -360.5 and eur = -57165 and  hkd = -463.5','')")

    con:query("insert into check_sql values(-514,'delete from transaction_total_check where cny = -514 and jpy = -51400 and gbp = -359.8 and eur = -57054 and  hkd = -462.6','')")

    con:query("insert into check_sql values(-513,'delete from transaction_total_check where cny = -513 and jpy = -51300 and gbp = -359.1 and eur = -56943 and  hkd = -461.7','')")

    con:query("insert into check_sql values(-512,'delete from transaction_total_check where cny = -512 and jpy = -51200 and gbp = -358.4 and eur = -56832 and  hkd = -460.8','')")

    con:query("insert into check_sql values(-511,'delete from transaction_total_check where cny = -511 and jpy = -51100 and gbp = -357.7 and eur = -56721 and  hkd = -459.9','')")

    con:query("insert into check_sql values(-510,'delete from transaction_total_check where cny = -510 and jpy = -51000 and gbp = -357.0 and eur = -56610 and  hkd = -459.0','')")

    con:query("insert into check_sql values(-509,'delete from transaction_total_check where cny = -509 and jpy = -50900 and gbp = -356.3 and eur = -56499 and  hkd = -458.1','')")

    con:query("insert into check_sql values(-508,'delete from transaction_total_check where cny = -508 and jpy = -50800 and gbp = -355.6 and eur = -56388 and  hkd = -457.2','')")

    con:query("insert into check_sql values(-507,'delete from transaction_total_check where cny = -507 and jpy = -50700 and gbp = -354.9 and eur = -56277 and  hkd = -456.3','')")

    con:query("insert into check_sql values(-506,'delete from transaction_total_check where cny = -506 and jpy = -50600 and gbp = -354.2 and eur = -56166 and  hkd = -455.4','')")

    con:query("insert into check_sql values(-505,'delete from transaction_total_check where cny = -505 and jpy = -50500 and gbp = -353.5 and eur = -56055 and  hkd = -454.5','')")

    con:query("insert into check_sql values(-504,'delete from transaction_total_check where cny = -504 and jpy = -50400 and gbp = -352.8 and eur = -55944 and  hkd = -453.6','')")

    con:query("insert into check_sql values(-503,'delete from transaction_total_check where cny = -503 and jpy = -50300 and gbp = -352.1 and eur = -55833 and  hkd = -452.7','')")

    con:query("insert into check_sql values(-502,'delete from transaction_total_check where cny = -502 and jpy = -50200 and gbp = -351.4 and eur = -55722 and  hkd = -451.8','')")

    con:query("insert into check_sql values(-501,'delete from transaction_total_check where cny = -501 and jpy = -50100 and gbp = -350.7 and eur = -55611 and  hkd = -450.9','')")

    con:query("insert into check_sql values(-500,'delete from transaction_total_check where cny = -500 and jpy = -50000 and gbp = -350.0 and eur = -55500 and  hkd = -450.0','')")

    con:query("insert into check_sql values(-499,'delete from transaction_total_check where cny = -499 and jpy = -49900 and gbp = -349.3 and eur = -55389 and  hkd = -449.1','')")

    con:query("insert into check_sql values(-498,'delete from transaction_total_check where cny = -498 and jpy = -49800 and gbp = -348.6 and eur = -55278 and  hkd = -448.2','')")

    con:query("insert into check_sql values(-497,'delete from transaction_total_check where cny = -497 and jpy = -49700 and gbp = -347.9 and eur = -55167 and  hkd = -447.3','')")

    con:query("insert into check_sql values(-496,'delete from transaction_total_check where cny = -496 and jpy = -49600 and gbp = -347.2 and eur = -55056 and  hkd = -446.4','')")

    con:query("insert into check_sql values(-495,'delete from transaction_total_check where cny = -495 and jpy = -49500 and gbp = -346.5 and eur = -54945 and  hkd = -445.5','')")

    con:query("insert into check_sql values(-494,'delete from transaction_total_check where cny = -494 and jpy = -49400 and gbp = -345.8 and eur = -54834 and  hkd = -444.6','')")

    con:query("insert into check_sql values(-493,'delete from transaction_total_check where cny = -493 and jpy = -49300 and gbp = -345.1 and eur = -54723 and  hkd = -443.7','')")

    con:query("insert into check_sql values(-492,'delete from transaction_total_check where cny = -492 and jpy = -49200 and gbp = -344.4 and eur = -54612 and  hkd = -442.8','')")

    con:query("insert into check_sql values(-491,'delete from transaction_total_check where cny = -491 and jpy = -49100 and gbp = -343.7 and eur = -54501 and  hkd = -441.9','')")

    con:query("insert into check_sql values(-490,'delete from transaction_total_check where cny = -490 and jpy = -49000 and gbp = -343.0 and eur = -54390 and  hkd = -441.0','')")

    con:query("insert into check_sql values(-489,'delete from transaction_total_check where cny = -489 and jpy = -48900 and gbp = -342.3 and eur = -54279 and  hkd = -440.1','')")

    con:query("insert into check_sql values(-488,'delete from transaction_total_check where cny = -488 and jpy = -48800 and gbp = -341.6 and eur = -54168 and  hkd = -439.2','')")

    con:query("insert into check_sql values(-487,'delete from transaction_total_check where cny = -487 and jpy = -48700 and gbp = -340.9 and eur = -54057 and  hkd = -438.3','')")

    con:query("insert into check_sql values(-486,'delete from transaction_total_check where cny = -486 and jpy = -48600 and gbp = -340.2 and eur = -53946 and  hkd = -437.4','')")

    con:query("insert into check_sql values(-485,'delete from transaction_total_check where cny = -485 and jpy = -48500 and gbp = -339.5 and eur = -53835 and  hkd = -436.5','')")

    con:query("insert into check_sql values(-484,'delete from transaction_total_check where cny = -484 and jpy = -48400 and gbp = -338.8 and eur = -53724 and  hkd = -435.6','')")

    con:query("insert into check_sql values(-483,'delete from transaction_total_check where cny = -483 and jpy = -48300 and gbp = -338.1 and eur = -53613 and  hkd = -434.7','')")

    con:query("insert into check_sql values(-482,'delete from transaction_total_check where cny = -482 and jpy = -48200 and gbp = -337.4 and eur = -53502 and  hkd = -433.8','')")

    con:query("insert into check_sql values(-481,'delete from transaction_total_check where cny = -481 and jpy = -48100 and gbp = -336.7 and eur = -53391 and  hkd = -432.9','')")

    con:query("insert into check_sql values(-480,'delete from transaction_total_check where cny = -480 and jpy = -48000 and gbp = -336.0 and eur = -53280 and  hkd = -432.0','')")

    con:query("insert into check_sql values(-479,'delete from transaction_total_check where cny = -479 and jpy = -47900 and gbp = -335.3 and eur = -53169 and  hkd = -431.1','')")

    con:query("insert into check_sql values(-478,'delete from transaction_total_check where cny = -478 and jpy = -47800 and gbp = -334.6 and eur = -53058 and  hkd = -430.2','')")

    con:query("insert into check_sql values(-477,'delete from transaction_total_check where cny = -477 and jpy = -47700 and gbp = -333.9 and eur = -52947 and  hkd = -429.3','')")

    con:query("insert into check_sql values(-476,'delete from transaction_total_check where cny = -476 and jpy = -47600 and gbp = -333.2 and eur = -52836 and  hkd = -428.4','')")

    con:query("insert into check_sql values(-475,'delete from transaction_total_check where cny = -475 and jpy = -47500 and gbp = -332.5 and eur = -52725 and  hkd = -427.5','')")

    con:query("insert into check_sql values(-474,'delete from transaction_total_check where cny = -474 and jpy = -47400 and gbp = -331.8 and eur = -52614 and  hkd = -426.6','')")

    con:query("insert into check_sql values(-473,'delete from transaction_total_check where cny = -473 and jpy = -47300 and gbp = -331.1 and eur = -52503 and  hkd = -425.7','')")

    con:query("insert into check_sql values(-472,'delete from transaction_total_check where cny = -472 and jpy = -47200 and gbp = -330.4 and eur = -52392 and  hkd = -424.8','')")

    con:query("insert into check_sql values(-471,'delete from transaction_total_check where cny = -471 and jpy = -47100 and gbp = -329.7 and eur = -52281 and  hkd = -423.9','')")

    con:query("insert into check_sql values(-470,'delete from transaction_total_check where cny = -470 and jpy = -47000 and gbp = -329.0 and eur = -52170 and  hkd = -423.0','')")

    con:query("insert into check_sql values(-469,'delete from transaction_total_check where cny = -469 and jpy = -46900 and gbp = -328.3 and eur = -52059 and  hkd = -422.1','')")

    con:query("insert into check_sql values(-468,'delete from transaction_total_check where cny = -468 and jpy = -46800 and gbp = -327.6 and eur = -51948 and  hkd = -421.2','')")

    con:query("insert into check_sql values(-467,'delete from transaction_total_check where cny = -467 and jpy = -46700 and gbp = -326.9 and eur = -51837 and  hkd = -420.3','')")

    con:query("insert into check_sql values(-466,'delete from transaction_total_check where cny = -466 and jpy = -46600 and gbp = -326.2 and eur = -51726 and  hkd = -419.4','')")

    con:query("insert into check_sql values(-465,'delete from transaction_total_check where cny = -465 and jpy = -46500 and gbp = -325.5 and eur = -51615 and  hkd = -418.5','')")

    con:query("insert into check_sql values(-464,'delete from transaction_total_check where cny = -464 and jpy = -46400 and gbp = -324.8 and eur = -51504 and  hkd = -417.6','')")

    con:query("insert into check_sql values(-463,'delete from transaction_total_check where cny = -463 and jpy = -46300 and gbp = -324.1 and eur = -51393 and  hkd = -416.7','')")

    con:query("insert into check_sql values(-462,'delete from transaction_total_check where cny = -462 and jpy = -46200 and gbp = -323.4 and eur = -51282 and  hkd = -415.8','')")

    con:query("insert into check_sql values(-461,'delete from transaction_total_check where cny = -461 and jpy = -46100 and gbp = -322.7 and eur = -51171 and  hkd = -414.9','')")

    con:query("insert into check_sql values(-460,'delete from transaction_total_check where cny = -460 and jpy = -46000 and gbp = -322.0 and eur = -51060 and  hkd = -414.0','')")

    con:query("insert into check_sql values(-459,'delete from transaction_total_check where cny = -459 and jpy = -45900 and gbp = -321.3 and eur = -50949 and  hkd = -413.1','')")

    con:query("insert into check_sql values(-458,'delete from transaction_total_check where cny = -458 and jpy = -45800 and gbp = -320.6 and eur = -50838 and  hkd = -412.2','')")

    con:query("insert into check_sql values(-457,'delete from transaction_total_check where cny = -457 and jpy = -45700 and gbp = -319.9 and eur = -50727 and  hkd = -411.3','')")

    con:query("insert into check_sql values(-456,'delete from transaction_total_check where cny = -456 and jpy = -45600 and gbp = -319.2 and eur = -50616 and  hkd = -410.4','')")

    con:query("insert into check_sql values(-455,'delete from transaction_total_check where cny = -455 and jpy = -45500 and gbp = -318.5 and eur = -50505 and  hkd = -409.5','')")

    con:query("insert into check_sql values(-454,'delete from transaction_total_check where cny = -454 and jpy = -45400 and gbp = -317.8 and eur = -50394 and  hkd = -408.6','')")

    con:query("insert into check_sql values(-453,'delete from transaction_total_check where cny = -453 and jpy = -45300 and gbp = -317.1 and eur = -50283 and  hkd = -407.7','')")

    con:query("insert into check_sql values(-452,'delete from transaction_total_check where cny = -452 and jpy = -45200 and gbp = -316.4 and eur = -50172 and  hkd = -406.8','')")

    con:query("insert into check_sql values(-451,'delete from transaction_total_check where cny = -451 and jpy = -45100 and gbp = -315.7 and eur = -50061 and  hkd = -405.9','')")

    con:query("insert into check_sql values(-450,'delete from transaction_total_check where cny = -450 and jpy = -45000 and gbp = -315.0 and eur = -49950 and  hkd = -405.0','')")

    con:query("insert into check_sql values(-449,'delete from transaction_total_check where cny = -449 and jpy = -44900 and gbp = -314.3 and eur = -49839 and  hkd = -404.1','')")

    con:query("insert into check_sql values(-448,'delete from transaction_total_check where cny = -448 and jpy = -44800 and gbp = -313.6 and eur = -49728 and  hkd = -403.2','')")

    con:query("insert into check_sql values(-447,'delete from transaction_total_check where cny = -447 and jpy = -44700 and gbp = -312.9 and eur = -49617 and  hkd = -402.3','')")

    con:query("insert into check_sql values(-446,'delete from transaction_total_check where cny = -446 and jpy = -44600 and gbp = -312.2 and eur = -49506 and  hkd = -401.4','')")

    con:query("insert into check_sql values(-445,'delete from transaction_total_check where cny = -445 and jpy = -44500 and gbp = -311.5 and eur = -49395 and  hkd = -400.5','')")

    con:query("insert into check_sql values(-444,'delete from transaction_total_check where cny = -444 and jpy = -44400 and gbp = -310.8 and eur = -49284 and  hkd = -399.6','')")

    con:query("insert into check_sql values(-443,'delete from transaction_total_check where cny = -443 and jpy = -44300 and gbp = -310.1 and eur = -49173 and  hkd = -398.7','')")

    con:query("insert into check_sql values(-442,'delete from transaction_total_check where cny = -442 and jpy = -44200 and gbp = -309.4 and eur = -49062 and  hkd = -397.8','')")

    con:query("insert into check_sql values(-441,'delete from transaction_total_check where cny = -441 and jpy = -44100 and gbp = -308.7 and eur = -48951 and  hkd = -396.9','')")

    con:query("insert into check_sql values(-440,'delete from transaction_total_check where cny = -440 and jpy = -44000 and gbp = -308.0 and eur = -48840 and  hkd = -396.0','')")

    con:query("insert into check_sql values(-439,'delete from transaction_total_check where cny = -439 and jpy = -43900 and gbp = -307.3 and eur = -48729 and  hkd = -395.1','')")

    con:query("insert into check_sql values(-438,'delete from transaction_total_check where cny = -438 and jpy = -43800 and gbp = -306.6 and eur = -48618 and  hkd = -394.2','')")

    con:query("insert into check_sql values(-437,'delete from transaction_total_check where cny = -437 and jpy = -43700 and gbp = -305.9 and eur = -48507 and  hkd = -393.3','')")

    con:query("insert into check_sql values(-436,'delete from transaction_total_check where cny = -436 and jpy = -43600 and gbp = -305.2 and eur = -48396 and  hkd = -392.4','')")

    con:query("insert into check_sql values(-435,'delete from transaction_total_check where cny = -435 and jpy = -43500 and gbp = -304.5 and eur = -48285 and  hkd = -391.5','')")

    con:query("insert into check_sql values(-434,'delete from transaction_total_check where cny = -434 and jpy = -43400 and gbp = -303.8 and eur = -48174 and  hkd = -390.6','')")

    con:query("insert into check_sql values(-433,'delete from transaction_total_check where cny = -433 and jpy = -43300 and gbp = -303.1 and eur = -48063 and  hkd = -389.7','')")

    con:query("insert into check_sql values(-432,'delete from transaction_total_check where cny = -432 and jpy = -43200 and gbp = -302.4 and eur = -47952 and  hkd = -388.8','')")

    con:query("insert into check_sql values(-431,'delete from transaction_total_check where cny = -431 and jpy = -43100 and gbp = -301.7 and eur = -47841 and  hkd = -387.9','')")

    con:query("insert into check_sql values(-430,'delete from transaction_total_check where cny = -430 and jpy = -43000 and gbp = -301.0 and eur = -47730 and  hkd = -387.0','')")

    con:query("insert into check_sql values(-429,'delete from transaction_total_check where cny = -429 and jpy = -42900 and gbp = -300.3 and eur = -47619 and  hkd = -386.1','')")

    con:query("insert into check_sql values(-428,'delete from transaction_total_check where cny = -428 and jpy = -42800 and gbp = -299.6 and eur = -47508 and  hkd = -385.2','')")

    con:query("insert into check_sql values(-427,'delete from transaction_total_check where cny = -427 and jpy = -42700 and gbp = -298.9 and eur = -47397 and  hkd = -384.3','')")

    con:query("insert into check_sql values(-426,'delete from transaction_total_check where cny = -426 and jpy = -42600 and gbp = -298.2 and eur = -47286 and  hkd = -383.4','')")

    con:query("insert into check_sql values(-425,'delete from transaction_total_check where cny = -425 and jpy = -42500 and gbp = -297.5 and eur = -47175 and  hkd = -382.5','')")

    con:query("insert into check_sql values(-424,'delete from transaction_total_check where cny = -424 and jpy = -42400 and gbp = -296.8 and eur = -47064 and  hkd = -381.6','')")

    con:query("insert into check_sql values(-423,'delete from transaction_total_check where cny = -423 and jpy = -42300 and gbp = -296.1 and eur = -46953 and  hkd = -380.7','')")

    con:query("insert into check_sql values(-422,'delete from transaction_total_check where cny = -422 and jpy = -42200 and gbp = -295.4 and eur = -46842 and  hkd = -379.8','')")

    con:query("insert into check_sql values(-421,'delete from transaction_total_check where cny = -421 and jpy = -42100 and gbp = -294.7 and eur = -46731 and  hkd = -378.9','')")

    con:query("insert into check_sql values(-420,'delete from transaction_total_check where cny = -420 and jpy = -42000 and gbp = -294.0 and eur = -46620 and  hkd = -378.0','')")

    con:query("insert into check_sql values(-419,'delete from transaction_total_check where cny = -419 and jpy = -41900 and gbp = -293.3 and eur = -46509 and  hkd = -377.1','')")

    con:query("insert into check_sql values(-418,'delete from transaction_total_check where cny = -418 and jpy = -41800 and gbp = -292.6 and eur = -46398 and  hkd = -376.2','')")

    con:query("insert into check_sql values(-417,'delete from transaction_total_check where cny = -417 and jpy = -41700 and gbp = -291.9 and eur = -46287 and  hkd = -375.3','')")

    con:query("insert into check_sql values(-416,'delete from transaction_total_check where cny = -416 and jpy = -41600 and gbp = -291.2 and eur = -46176 and  hkd = -374.4','')")

    con:query("insert into check_sql values(-415,'delete from transaction_total_check where cny = -415 and jpy = -41500 and gbp = -290.5 and eur = -46065 and  hkd = -373.5','')")

    con:query("insert into check_sql values(-414,'delete from transaction_total_check where cny = -414 and jpy = -41400 and gbp = -289.8 and eur = -45954 and  hkd = -372.6','')")

    con:query("insert into check_sql values(-413,'delete from transaction_total_check where cny = -413 and jpy = -41300 and gbp = -289.1 and eur = -45843 and  hkd = -371.7','')")

    con:query("insert into check_sql values(-412,'delete from transaction_total_check where cny = -412 and jpy = -41200 and gbp = -288.4 and eur = -45732 and  hkd = -370.8','')")

    con:query("insert into check_sql values(-411,'delete from transaction_total_check where cny = -411 and jpy = -41100 and gbp = -287.7 and eur = -45621 and  hkd = -369.9','')")

    con:query("insert into check_sql values(-410,'delete from transaction_total_check where cny = -410 and jpy = -41000 and gbp = -287.0 and eur = -45510 and  hkd = -369.0','')")

    con:query("insert into check_sql values(-409,'delete from transaction_total_check where cny = -409 and jpy = -40900 and gbp = -286.3 and eur = -45399 and  hkd = -368.1','')")

    con:query("insert into check_sql values(-408,'delete from transaction_total_check where cny = -408 and jpy = -40800 and gbp = -285.6 and eur = -45288 and  hkd = -367.2','')")

    con:query("insert into check_sql values(-407,'delete from transaction_total_check where cny = -407 and jpy = -40700 and gbp = -284.9 and eur = -45177 and  hkd = -366.3','')")

    con:query("insert into check_sql values(-406,'delete from transaction_total_check where cny = -406 and jpy = -40600 and gbp = -284.2 and eur = -45066 and  hkd = -365.4','')")

    con:query("insert into check_sql values(-405,'delete from transaction_total_check where cny = -405 and jpy = -40500 and gbp = -283.5 and eur = -44955 and  hkd = -364.5','')")

    con:query("insert into check_sql values(-404,'delete from transaction_total_check where cny = -404 and jpy = -40400 and gbp = -282.8 and eur = -44844 and  hkd = -363.6','')")

    con:query("insert into check_sql values(-403,'delete from transaction_total_check where cny = -403 and jpy = -40300 and gbp = -282.1 and eur = -44733 and  hkd = -362.7','')")

    con:query("insert into check_sql values(-402,'delete from transaction_total_check where cny = -402 and jpy = -40200 and gbp = -281.4 and eur = -44622 and  hkd = -361.8','')")

    con:query("insert into check_sql values(-401,'delete from transaction_total_check where cny = -401 and jpy = -40100 and gbp = -280.7 and eur = -44511 and  hkd = -360.9','')")

    con:query("insert into check_sql values(-400,'delete from transaction_total_check where cny = -400 and jpy = -40000 and gbp = -280.0 and eur = -44400 and  hkd = -360.0','')")

    con:query("insert into check_sql values(-399,'delete from transaction_total_check where cny = -399 and jpy = -39900 and gbp = -279.3 and eur = -44289 and  hkd = -359.1','')")

    con:query("insert into check_sql values(-398,'delete from transaction_total_check where cny = -398 and jpy = -39800 and gbp = -278.6 and eur = -44178 and  hkd = -358.2','')")

    con:query("insert into check_sql values(-397,'delete from transaction_total_check where cny = -397 and jpy = -39700 and gbp = -277.9 and eur = -44067 and  hkd = -357.3','')")

    con:query("insert into check_sql values(-396,'delete from transaction_total_check where cny = -396 and jpy = -39600 and gbp = -277.2 and eur = -43956 and  hkd = -356.4','')")

    con:query("insert into check_sql values(-395,'delete from transaction_total_check where cny = -395 and jpy = -39500 and gbp = -276.5 and eur = -43845 and  hkd = -355.5','')")

    con:query("insert into check_sql values(-394,'delete from transaction_total_check where cny = -394 and jpy = -39400 and gbp = -275.8 and eur = -43734 and  hkd = -354.6','')")

    con:query("insert into check_sql values(-393,'delete from transaction_total_check where cny = -393 and jpy = -39300 and gbp = -275.1 and eur = -43623 and  hkd = -353.7','')")

    con:query("insert into check_sql values(-392,'delete from transaction_total_check where cny = -392 and jpy = -39200 and gbp = -274.4 and eur = -43512 and  hkd = -352.8','')")

    con:query("insert into check_sql values(-391,'delete from transaction_total_check where cny = -391 and jpy = -39100 and gbp = -273.7 and eur = -43401 and  hkd = -351.9','')")

    con:query("insert into check_sql values(-390,'delete from transaction_total_check where cny = -390 and jpy = -39000 and gbp = -273.0 and eur = -43290 and  hkd = -351.0','')")

    con:query("insert into check_sql values(-389,'delete from transaction_total_check where cny = -389 and jpy = -38900 and gbp = -272.3 and eur = -43179 and  hkd = -350.1','')")

    con:query("insert into check_sql values(-388,'delete from transaction_total_check where cny = -388 and jpy = -38800 and gbp = -271.6 and eur = -43068 and  hkd = -349.2','')")

    con:query("insert into check_sql values(-387,'delete from transaction_total_check where cny = -387 and jpy = -38700 and gbp = -270.9 and eur = -42957 and  hkd = -348.3','')")

    con:query("insert into check_sql values(-386,'delete from transaction_total_check where cny = -386 and jpy = -38600 and gbp = -270.2 and eur = -42846 and  hkd = -347.4','')")

    con:query("insert into check_sql values(-385,'delete from transaction_total_check where cny = -385 and jpy = -38500 and gbp = -269.5 and eur = -42735 and  hkd = -346.5','')")

    con:query("insert into check_sql values(-384,'delete from transaction_total_check where cny = -384 and jpy = -38400 and gbp = -268.8 and eur = -42624 and  hkd = -345.6','')")

    con:query("insert into check_sql values(-383,'delete from transaction_total_check where cny = -383 and jpy = -38300 and gbp = -268.1 and eur = -42513 and  hkd = -344.7','')")

    con:query("insert into check_sql values(-382,'delete from transaction_total_check where cny = -382 and jpy = -38200 and gbp = -267.4 and eur = -42402 and  hkd = -343.8','')")

    con:query("insert into check_sql values(-381,'delete from transaction_total_check where cny = -381 and jpy = -38100 and gbp = -266.7 and eur = -42291 and  hkd = -342.9','')")

    con:query("insert into check_sql values(-380,'delete from transaction_total_check where cny = -380 and jpy = -38000 and gbp = -266.0 and eur = -42180 and  hkd = -342.0','')")

    con:query("insert into check_sql values(-379,'delete from transaction_total_check where cny = -379 and jpy = -37900 and gbp = -265.3 and eur = -42069 and  hkd = -341.1','')")

    con:query("insert into check_sql values(-378,'delete from transaction_total_check where cny = -378 and jpy = -37800 and gbp = -264.6 and eur = -41958 and  hkd = -340.2','')")

    con:query("insert into check_sql values(-377,'delete from transaction_total_check where cny = -377 and jpy = -37700 and gbp = -263.9 and eur = -41847 and  hkd = -339.3','')")

    con:query("insert into check_sql values(-376,'delete from transaction_total_check where cny = -376 and jpy = -37600 and gbp = -263.2 and eur = -41736 and  hkd = -338.4','')")

    con:query("insert into check_sql values(-375,'delete from transaction_total_check where cny = -375 and jpy = -37500 and gbp = -262.5 and eur = -41625 and  hkd = -337.5','')")

    con:query("insert into check_sql values(-374,'delete from transaction_total_check where cny = -374 and jpy = -37400 and gbp = -261.8 and eur = -41514 and  hkd = -336.6','')")

    con:query("insert into check_sql values(-373,'delete from transaction_total_check where cny = -373 and jpy = -37300 and gbp = -261.1 and eur = -41403 and  hkd = -335.7','')")

    con:query("insert into check_sql values(-372,'delete from transaction_total_check where cny = -372 and jpy = -37200 and gbp = -260.4 and eur = -41292 and  hkd = -334.8','')")

    con:query("insert into check_sql values(-371,'delete from transaction_total_check where cny = -371 and jpy = -37100 and gbp = -259.7 and eur = -41181 and  hkd = -333.9','')")

    con:query("insert into check_sql values(-370,'delete from transaction_total_check where cny = -370 and jpy = -37000 and gbp = -259.0 and eur = -41070 and  hkd = -333.0','')")

    con:query("insert into check_sql values(-369,'delete from transaction_total_check where cny = -369 and jpy = -36900 and gbp = -258.3 and eur = -40959 and  hkd = -332.1','')")

    con:query("insert into check_sql values(-368,'delete from transaction_total_check where cny = -368 and jpy = -36800 and gbp = -257.6 and eur = -40848 and  hkd = -331.2','')")

    con:query("insert into check_sql values(-367,'delete from transaction_total_check where cny = -367 and jpy = -36700 and gbp = -256.9 and eur = -40737 and  hkd = -330.3','')")

    con:query("insert into check_sql values(-366,'delete from transaction_total_check where cny = -366 and jpy = -36600 and gbp = -256.2 and eur = -40626 and  hkd = -329.4','')")

    con:query("insert into check_sql values(-365,'delete from transaction_total_check where cny = -365 and jpy = -36500 and gbp = -255.5 and eur = -40515 and  hkd = -328.5','')")

    con:query("insert into check_sql values(-364,'delete from transaction_total_check where cny = -364 and jpy = -36400 and gbp = -254.8 and eur = -40404 and  hkd = -327.6','')")

    con:query("insert into check_sql values(-363,'delete from transaction_total_check where cny = -363 and jpy = -36300 and gbp = -254.1 and eur = -40293 and  hkd = -326.7','')")

    con:query("insert into check_sql values(-362,'delete from transaction_total_check where cny = -362 and jpy = -36200 and gbp = -253.4 and eur = -40182 and  hkd = -325.8','')")

    con:query("insert into check_sql values(-361,'delete from transaction_total_check where cny = -361 and jpy = -36100 and gbp = -252.7 and eur = -40071 and  hkd = -324.9','')")

    con:query("insert into check_sql values(-360,'delete from transaction_total_check where cny = -360 and jpy = -36000 and gbp = -252.0 and eur = -39960 and  hkd = -324.0','')")

    con:query("insert into check_sql values(-359,'delete from transaction_total_check where cny = -359 and jpy = -35900 and gbp = -251.3 and eur = -39849 and  hkd = -323.1','')")

    con:query("insert into check_sql values(-358,'delete from transaction_total_check where cny = -358 and jpy = -35800 and gbp = -250.6 and eur = -39738 and  hkd = -322.2','')")

    con:query("insert into check_sql values(-357,'delete from transaction_total_check where cny = -357 and jpy = -35700 and gbp = -249.9 and eur = -39627 and  hkd = -321.3','')")

    con:query("insert into check_sql values(-356,'delete from transaction_total_check where cny = -356 and jpy = -35600 and gbp = -249.2 and eur = -39516 and  hkd = -320.4','')")

    con:query("insert into check_sql values(-355,'delete from transaction_total_check where cny = -355 and jpy = -35500 and gbp = -248.5 and eur = -39405 and  hkd = -319.5','')")

    con:query("insert into check_sql values(-354,'delete from transaction_total_check where cny = -354 and jpy = -35400 and gbp = -247.8 and eur = -39294 and  hkd = -318.6','')")

    con:query("insert into check_sql values(-353,'delete from transaction_total_check where cny = -353 and jpy = -35300 and gbp = -247.1 and eur = -39183 and  hkd = -317.7','')")

    con:query("insert into check_sql values(-352,'delete from transaction_total_check where cny = -352 and jpy = -35200 and gbp = -246.4 and eur = -39072 and  hkd = -316.8','')")

    con:query("insert into check_sql values(-351,'delete from transaction_total_check where cny = -351 and jpy = -35100 and gbp = -245.7 and eur = -38961 and  hkd = -315.9','')")

    con:query("insert into check_sql values(-350,'delete from transaction_total_check where cny = -350 and jpy = -35000 and gbp = -245.0 and eur = -38850 and  hkd = -315.0','')")

    con:query("insert into check_sql values(-349,'delete from transaction_total_check where cny = -349 and jpy = -34900 and gbp = -244.3 and eur = -38739 and  hkd = -314.1','')")

    con:query("insert into check_sql values(-348,'delete from transaction_total_check where cny = -348 and jpy = -34800 and gbp = -243.6 and eur = -38628 and  hkd = -313.2','')")

    con:query("insert into check_sql values(-347,'delete from transaction_total_check where cny = -347 and jpy = -34700 and gbp = -242.9 and eur = -38517 and  hkd = -312.3','')")

    con:query("insert into check_sql values(-346,'delete from transaction_total_check where cny = -346 and jpy = -34600 and gbp = -242.2 and eur = -38406 and  hkd = -311.4','')")

    con:query("insert into check_sql values(-345,'delete from transaction_total_check where cny = -345 and jpy = -34500 and gbp = -241.5 and eur = -38295 and  hkd = -310.5','')")

    con:query("insert into check_sql values(-344,'delete from transaction_total_check where cny = -344 and jpy = -34400 and gbp = -240.8 and eur = -38184 and  hkd = -309.6','')")

    con:query("insert into check_sql values(-343,'delete from transaction_total_check where cny = -343 and jpy = -34300 and gbp = -240.1 and eur = -38073 and  hkd = -308.7','')")

    con:query("insert into check_sql values(-342,'delete from transaction_total_check where cny = -342 and jpy = -34200 and gbp = -239.4 and eur = -37962 and  hkd = -307.8','')")

    con:query("insert into check_sql values(-341,'delete from transaction_total_check where cny = -341 and jpy = -34100 and gbp = -238.7 and eur = -37851 and  hkd = -306.9','')")

    con:query("insert into check_sql values(-340,'delete from transaction_total_check where cny = -340 and jpy = -34000 and gbp = -238.0 and eur = -37740 and  hkd = -306.0','')")

    con:query("insert into check_sql values(-339,'delete from transaction_total_check where cny = -339 and jpy = -33900 and gbp = -237.3 and eur = -37629 and  hkd = -305.1','')")

    con:query("insert into check_sql values(-338,'delete from transaction_total_check where cny = -338 and jpy = -33800 and gbp = -236.6 and eur = -37518 and  hkd = -304.2','')")

    con:query("insert into check_sql values(-337,'delete from transaction_total_check where cny = -337 and jpy = -33700 and gbp = -235.9 and eur = -37407 and  hkd = -303.3','')")

    con:query("insert into check_sql values(-336,'delete from transaction_total_check where cny = -336 and jpy = -33600 and gbp = -235.2 and eur = -37296 and  hkd = -302.4','')")

    con:query("insert into check_sql values(-335,'delete from transaction_total_check where cny = -335 and jpy = -33500 and gbp = -234.5 and eur = -37185 and  hkd = -301.5','')")

    con:query("insert into check_sql values(-334,'delete from transaction_total_check where cny = -334 and jpy = -33400 and gbp = -233.8 and eur = -37074 and  hkd = -300.6','')")

    con:query("insert into check_sql values(-333,'delete from transaction_total_check where cny = -333 and jpy = -33300 and gbp = -233.1 and eur = -36963 and  hkd = -299.7','')")

    con:query("insert into check_sql values(-332,'delete from transaction_total_check where cny = -332 and jpy = -33200 and gbp = -232.4 and eur = -36852 and  hkd = -298.8','')")

    con:query("insert into check_sql values(-331,'delete from transaction_total_check where cny = -331 and jpy = -33100 and gbp = -231.7 and eur = -36741 and  hkd = -297.9','')")

    con:query("insert into check_sql values(-330,'delete from transaction_total_check where cny = -330 and jpy = -33000 and gbp = -231.0 and eur = -36630 and  hkd = -297.0','')")

    con:query("insert into check_sql values(-329,'delete from transaction_total_check where cny = -329 and jpy = -32900 and gbp = -230.3 and eur = -36519 and  hkd = -296.1','')")

    con:query("insert into check_sql values(-328,'delete from transaction_total_check where cny = -328 and jpy = -32800 and gbp = -229.6 and eur = -36408 and  hkd = -295.2','')")

    con:query("insert into check_sql values(-327,'delete from transaction_total_check where cny = -327 and jpy = -32700 and gbp = -228.9 and eur = -36297 and  hkd = -294.3','')")

    con:query("insert into check_sql values(-326,'delete from transaction_total_check where cny = -326 and jpy = -32600 and gbp = -228.2 and eur = -36186 and  hkd = -293.4','')")

    con:query("insert into check_sql values(-325,'delete from transaction_total_check where cny = -325 and jpy = -32500 and gbp = -227.5 and eur = -36075 and  hkd = -292.5','')")

    con:query("insert into check_sql values(-324,'delete from transaction_total_check where cny = -324 and jpy = -32400 and gbp = -226.8 and eur = -35964 and  hkd = -291.6','')")

    con:query("insert into check_sql values(-323,'delete from transaction_total_check where cny = -323 and jpy = -32300 and gbp = -226.1 and eur = -35853 and  hkd = -290.7','')")

    con:query("insert into check_sql values(-322,'delete from transaction_total_check where cny = -322 and jpy = -32200 and gbp = -225.4 and eur = -35742 and  hkd = -289.8','')")

    con:query("insert into check_sql values(-321,'delete from transaction_total_check where cny = -321 and jpy = -32100 and gbp = -224.7 and eur = -35631 and  hkd = -288.9','')")

    con:query("insert into check_sql values(-320,'delete from transaction_total_check where cny = -320 and jpy = -32000 and gbp = -224.0 and eur = -35520 and  hkd = -288.0','')")

    con:query("insert into check_sql values(-319,'delete from transaction_total_check where cny = -319 and jpy = -31900 and gbp = -223.3 and eur = -35409 and  hkd = -287.1','')")

    con:query("insert into check_sql values(-318,'delete from transaction_total_check where cny = -318 and jpy = -31800 and gbp = -222.6 and eur = -35298 and  hkd = -286.2','')")

    con:query("insert into check_sql values(-317,'delete from transaction_total_check where cny = -317 and jpy = -31700 and gbp = -221.9 and eur = -35187 and  hkd = -285.3','')")

    con:query("insert into check_sql values(-316,'delete from transaction_total_check where cny = -316 and jpy = -31600 and gbp = -221.2 and eur = -35076 and  hkd = -284.4','')")

    con:query("insert into check_sql values(-315,'delete from transaction_total_check where cny = -315 and jpy = -31500 and gbp = -220.5 and eur = -34965 and  hkd = -283.5','')")

    con:query("insert into check_sql values(-314,'delete from transaction_total_check where cny = -314 and jpy = -31400 and gbp = -219.8 and eur = -34854 and  hkd = -282.6','')")

    con:query("insert into check_sql values(-313,'delete from transaction_total_check where cny = -313 and jpy = -31300 and gbp = -219.1 and eur = -34743 and  hkd = -281.7','')")

    con:query("insert into check_sql values(-312,'delete from transaction_total_check where cny = -312 and jpy = -31200 and gbp = -218.4 and eur = -34632 and  hkd = -280.8','')")

    con:query("insert into check_sql values(-311,'delete from transaction_total_check where cny = -311 and jpy = -31100 and gbp = -217.7 and eur = -34521 and  hkd = -279.9','')")

    con:query("insert into check_sql values(-310,'delete from transaction_total_check where cny = -310 and jpy = -31000 and gbp = -217.0 and eur = -34410 and  hkd = -279.0','')")

    con:query("insert into check_sql values(-309,'delete from transaction_total_check where cny = -309 and jpy = -30900 and gbp = -216.3 and eur = -34299 and  hkd = -278.1','')")

    con:query("insert into check_sql values(-308,'delete from transaction_total_check where cny = -308 and jpy = -30800 and gbp = -215.6 and eur = -34188 and  hkd = -277.2','')")

    con:query("insert into check_sql values(-307,'delete from transaction_total_check where cny = -307 and jpy = -30700 and gbp = -214.9 and eur = -34077 and  hkd = -276.3','')")

    con:query("insert into check_sql values(-306,'delete from transaction_total_check where cny = -306 and jpy = -30600 and gbp = -214.2 and eur = -33966 and  hkd = -275.4','')")

    con:query("insert into check_sql values(-305,'delete from transaction_total_check where cny = -305 and jpy = -30500 and gbp = -213.5 and eur = -33855 and  hkd = -274.5','')")

    con:query("insert into check_sql values(-304,'delete from transaction_total_check where cny = -304 and jpy = -30400 and gbp = -212.8 and eur = -33744 and  hkd = -273.6','')")

    con:query("insert into check_sql values(-303,'delete from transaction_total_check where cny = -303 and jpy = -30300 and gbp = -212.1 and eur = -33633 and  hkd = -272.7','')")

    con:query("insert into check_sql values(-302,'delete from transaction_total_check where cny = -302 and jpy = -30200 and gbp = -211.4 and eur = -33522 and  hkd = -271.8','')")

    con:query("insert into check_sql values(-301,'delete from transaction_total_check where cny = -301 and jpy = -30100 and gbp = -210.7 and eur = -33411 and  hkd = -270.9','')")

    con:query("insert into check_sql values(-300,'delete from transaction_total_check where cny = -300 and jpy = -30000 and gbp = -210.0 and eur = -33300 and  hkd = -270.0','')")

    con:query("insert into check_sql values(-299,'delete from transaction_total_check where cny = -299 and jpy = -29900 and gbp = -209.3 and eur = -33189 and  hkd = -269.1','')")

    con:query("insert into check_sql values(-298,'delete from transaction_total_check where cny = -298 and jpy = -29800 and gbp = -208.6 and eur = -33078 and  hkd = -268.2','')")

    con:query("insert into check_sql values(-297,'delete from transaction_total_check where cny = -297 and jpy = -29700 and gbp = -207.9 and eur = -32967 and  hkd = -267.3','')")

    con:query("insert into check_sql values(-296,'delete from transaction_total_check where cny = -296 and jpy = -29600 and gbp = -207.2 and eur = -32856 and  hkd = -266.4','')")

    con:query("insert into check_sql values(-295,'delete from transaction_total_check where cny = -295 and jpy = -29500 and gbp = -206.5 and eur = -32745 and  hkd = -265.5','')")

    con:query("insert into check_sql values(-294,'delete from transaction_total_check where cny = -294 and jpy = -29400 and gbp = -205.8 and eur = -32634 and  hkd = -264.6','')")

    con:query("insert into check_sql values(-293,'delete from transaction_total_check where cny = -293 and jpy = -29300 and gbp = -205.1 and eur = -32523 and  hkd = -263.7','')")

    con:query("insert into check_sql values(-292,'delete from transaction_total_check where cny = -292 and jpy = -29200 and gbp = -204.4 and eur = -32412 and  hkd = -262.8','')")

    con:query("insert into check_sql values(-291,'delete from transaction_total_check where cny = -291 and jpy = -29100 and gbp = -203.7 and eur = -32301 and  hkd = -261.9','')")

    con:query("insert into check_sql values(-290,'delete from transaction_total_check where cny = -290 and jpy = -29000 and gbp = -203.0 and eur = -32190 and  hkd = -261.0','')")

    con:query("insert into check_sql values(-289,'delete from transaction_total_check where cny = -289 and jpy = -28900 and gbp = -202.3 and eur = -32079 and  hkd = -260.1','')")

    con:query("insert into check_sql values(-288,'delete from transaction_total_check where cny = -288 and jpy = -28800 and gbp = -201.6 and eur = -31968 and  hkd = -259.2','')")

    con:query("insert into check_sql values(-287,'delete from transaction_total_check where cny = -287 and jpy = -28700 and gbp = -200.9 and eur = -31857 and  hkd = -258.3','')")

    con:query("insert into check_sql values(-286,'delete from transaction_total_check where cny = -286 and jpy = -28600 and gbp = -200.2 and eur = -31746 and  hkd = -257.4','')")

    con:query("insert into check_sql values(-285,'delete from transaction_total_check where cny = -285 and jpy = -28500 and gbp = -199.5 and eur = -31635 and  hkd = -256.5','')")

    con:query("insert into check_sql values(-284,'delete from transaction_total_check where cny = -284 and jpy = -28400 and gbp = -198.8 and eur = -31524 and  hkd = -255.6','')")

    con:query("insert into check_sql values(-283,'delete from transaction_total_check where cny = -283 and jpy = -28300 and gbp = -198.1 and eur = -31413 and  hkd = -254.7','')")

    con:query("insert into check_sql values(-282,'delete from transaction_total_check where cny = -282 and jpy = -28200 and gbp = -197.4 and eur = -31302 and  hkd = -253.8','')")

    con:query("insert into check_sql values(-281,'delete from transaction_total_check where cny = -281 and jpy = -28100 and gbp = -196.7 and eur = -31191 and  hkd = -252.9','')")

    con:query("insert into check_sql values(-280,'delete from transaction_total_check where cny = -280 and jpy = -28000 and gbp = -196.0 and eur = -31080 and  hkd = -252.0','')")

    con:query("insert into check_sql values(-279,'delete from transaction_total_check where cny = -279 and jpy = -27900 and gbp = -195.3 and eur = -30969 and  hkd = -251.1','')")

    con:query("insert into check_sql values(-278,'delete from transaction_total_check where cny = -278 and jpy = -27800 and gbp = -194.6 and eur = -30858 and  hkd = -250.2','')")

    con:query("insert into check_sql values(-277,'delete from transaction_total_check where cny = -277 and jpy = -27700 and gbp = -193.9 and eur = -30747 and  hkd = -249.3','')")

    con:query("insert into check_sql values(-276,'delete from transaction_total_check where cny = -276 and jpy = -27600 and gbp = -193.2 and eur = -30636 and  hkd = -248.4','')")

    con:query("insert into check_sql values(-275,'delete from transaction_total_check where cny = -275 and jpy = -27500 and gbp = -192.5 and eur = -30525 and  hkd = -247.5','')")

    con:query("insert into check_sql values(-274,'delete from transaction_total_check where cny = -274 and jpy = -27400 and gbp = -191.8 and eur = -30414 and  hkd = -246.6','')")

    con:query("insert into check_sql values(-273,'delete from transaction_total_check where cny = -273 and jpy = -27300 and gbp = -191.1 and eur = -30303 and  hkd = -245.7','')")

    con:query("insert into check_sql values(-272,'delete from transaction_total_check where cny = -272 and jpy = -27200 and gbp = -190.4 and eur = -30192 and  hkd = -244.8','')")

    con:query("insert into check_sql values(-271,'delete from transaction_total_check where cny = -271 and jpy = -27100 and gbp = -189.7 and eur = -30081 and  hkd = -243.9','')")

    con:query("insert into check_sql values(-270,'delete from transaction_total_check where cny = -270 and jpy = -27000 and gbp = -189.0 and eur = -29970 and  hkd = -243.0','')")

    con:query("insert into check_sql values(-269,'delete from transaction_total_check where cny = -269 and jpy = -26900 and gbp = -188.3 and eur = -29859 and  hkd = -242.1','')")

    con:query("insert into check_sql values(-268,'delete from transaction_total_check where cny = -268 and jpy = -26800 and gbp = -187.6 and eur = -29748 and  hkd = -241.2','')")

    con:query("insert into check_sql values(-267,'delete from transaction_total_check where cny = -267 and jpy = -26700 and gbp = -186.9 and eur = -29637 and  hkd = -240.3','')")

    con:query("insert into check_sql values(-266,'delete from transaction_total_check where cny = -266 and jpy = -26600 and gbp = -186.2 and eur = -29526 and  hkd = -239.4','')")

    con:query("insert into check_sql values(-265,'delete from transaction_total_check where cny = -265 and jpy = -26500 and gbp = -185.5 and eur = -29415 and  hkd = -238.5','')")

    con:query("insert into check_sql values(-264,'delete from transaction_total_check where cny = -264 and jpy = -26400 and gbp = -184.8 and eur = -29304 and  hkd = -237.6','')")

    con:query("insert into check_sql values(-263,'delete from transaction_total_check where cny = -263 and jpy = -26300 and gbp = -184.1 and eur = -29193 and  hkd = -236.7','')")

    con:query("insert into check_sql values(-262,'delete from transaction_total_check where cny = -262 and jpy = -26200 and gbp = -183.4 and eur = -29082 and  hkd = -235.8','')")

    con:query("insert into check_sql values(-261,'delete from transaction_total_check where cny = -261 and jpy = -26100 and gbp = -182.7 and eur = -28971 and  hkd = -234.9','')")

    con:query("insert into check_sql values(-260,'delete from transaction_total_check where cny = -260 and jpy = -26000 and gbp = -182.0 and eur = -28860 and  hkd = -234.0','')")

    con:query("insert into check_sql values(-259,'delete from transaction_total_check where cny = -259 and jpy = -25900 and gbp = -181.3 and eur = -28749 and  hkd = -233.1','')")

    con:query("insert into check_sql values(-258,'delete from transaction_total_check where cny = -258 and jpy = -25800 and gbp = -180.6 and eur = -28638 and  hkd = -232.2','')")

    con:query("insert into check_sql values(-257,'delete from transaction_total_check where cny = -257 and jpy = -25700 and gbp = -179.9 and eur = -28527 and  hkd = -231.3','')")

    con:query("insert into check_sql values(-256,'delete from transaction_total_check where cny = -256 and jpy = -25600 and gbp = -179.2 and eur = -28416 and  hkd = -230.4','')")

    con:query("insert into check_sql values(-255,'delete from transaction_total_check where cny = -255 and jpy = -25500 and gbp = -178.5 and eur = -28305 and  hkd = -229.5','')")

    con:query("insert into check_sql values(-254,'delete from transaction_total_check where cny = -254 and jpy = -25400 and gbp = -177.8 and eur = -28194 and  hkd = -228.6','')")

    con:query("insert into check_sql values(-253,'delete from transaction_total_check where cny = -253 and jpy = -25300 and gbp = -177.1 and eur = -28083 and  hkd = -227.7','')")

    con:query("insert into check_sql values(-252,'delete from transaction_total_check where cny = -252 and jpy = -25200 and gbp = -176.4 and eur = -27972 and  hkd = -226.8','')")

    con:query("insert into check_sql values(-251,'delete from transaction_total_check where cny = -251 and jpy = -25100 and gbp = -175.7 and eur = -27861 and  hkd = -225.9','')")

    con:query("insert into check_sql values(-250,'delete from transaction_total_check where cny = -250 and jpy = -25000 and gbp = -175.0 and eur = -27750 and  hkd = -225.0','')")

    con:query("insert into check_sql values(-249,'delete from transaction_total_check where cny = -249 and jpy = -24900 and gbp = -174.3 and eur = -27639 and  hkd = -224.1','')")

    con:query("insert into check_sql values(-248,'delete from transaction_total_check where cny = -248 and jpy = -24800 and gbp = -173.6 and eur = -27528 and  hkd = -223.2','')")

    con:query("insert into check_sql values(-247,'delete from transaction_total_check where cny = -247 and jpy = -24700 and gbp = -172.9 and eur = -27417 and  hkd = -222.3','')")

    con:query("insert into check_sql values(-246,'delete from transaction_total_check where cny = -246 and jpy = -24600 and gbp = -172.2 and eur = -27306 and  hkd = -221.4','')")

    con:query("insert into check_sql values(-245,'delete from transaction_total_check where cny = -245 and jpy = -24500 and gbp = -171.5 and eur = -27195 and  hkd = -220.5','')")

    con:query("insert into check_sql values(-244,'delete from transaction_total_check where cny = -244 and jpy = -24400 and gbp = -170.8 and eur = -27084 and  hkd = -219.6','')")

    con:query("insert into check_sql values(-243,'delete from transaction_total_check where cny = -243 and jpy = -24300 and gbp = -170.1 and eur = -26973 and  hkd = -218.7','')")

    con:query("insert into check_sql values(-242,'delete from transaction_total_check where cny = -242 and jpy = -24200 and gbp = -169.4 and eur = -26862 and  hkd = -217.8','')")

    con:query("insert into check_sql values(-241,'delete from transaction_total_check where cny = -241 and jpy = -24100 and gbp = -168.7 and eur = -26751 and  hkd = -216.9','')")

    con:query("insert into check_sql values(-240,'delete from transaction_total_check where cny = -240 and jpy = -24000 and gbp = -168.0 and eur = -26640 and  hkd = -216.0','')")

    con:query("insert into check_sql values(-239,'delete from transaction_total_check where cny = -239 and jpy = -23900 and gbp = -167.3 and eur = -26529 and  hkd = -215.1','')")

    con:query("insert into check_sql values(-238,'delete from transaction_total_check where cny = -238 and jpy = -23800 and gbp = -166.6 and eur = -26418 and  hkd = -214.2','')")

    con:query("insert into check_sql values(-237,'delete from transaction_total_check where cny = -237 and jpy = -23700 and gbp = -165.9 and eur = -26307 and  hkd = -213.3','')")

    con:query("insert into check_sql values(-236,'delete from transaction_total_check where cny = -236 and jpy = -23600 and gbp = -165.2 and eur = -26196 and  hkd = -212.4','')")

    con:query("insert into check_sql values(-235,'delete from transaction_total_check where cny = -235 and jpy = -23500 and gbp = -164.5 and eur = -26085 and  hkd = -211.5','')")

    con:query("insert into check_sql values(-234,'delete from transaction_total_check where cny = -234 and jpy = -23400 and gbp = -163.8 and eur = -25974 and  hkd = -210.6','')")

    con:query("insert into check_sql values(-233,'delete from transaction_total_check where cny = -233 and jpy = -23300 and gbp = -163.1 and eur = -25863 and  hkd = -209.7','')")

    con:query("insert into check_sql values(-232,'delete from transaction_total_check where cny = -232 and jpy = -23200 and gbp = -162.4 and eur = -25752 and  hkd = -208.8','')")

    con:query("insert into check_sql values(-231,'delete from transaction_total_check where cny = -231 and jpy = -23100 and gbp = -161.7 and eur = -25641 and  hkd = -207.9','')")

    con:query("insert into check_sql values(-230,'delete from transaction_total_check where cny = -230 and jpy = -23000 and gbp = -161.0 and eur = -25530 and  hkd = -207.0','')")

    con:query("insert into check_sql values(-229,'delete from transaction_total_check where cny = -229 and jpy = -22900 and gbp = -160.3 and eur = -25419 and  hkd = -206.1','')")

    con:query("insert into check_sql values(-228,'delete from transaction_total_check where cny = -228 and jpy = -22800 and gbp = -159.6 and eur = -25308 and  hkd = -205.2','')")

    con:query("insert into check_sql values(-227,'delete from transaction_total_check where cny = -227 and jpy = -22700 and gbp = -158.9 and eur = -25197 and  hkd = -204.3','')")

    con:query("insert into check_sql values(-226,'delete from transaction_total_check where cny = -226 and jpy = -22600 and gbp = -158.2 and eur = -25086 and  hkd = -203.4','')")

    con:query("insert into check_sql values(-225,'delete from transaction_total_check where cny = -225 and jpy = -22500 and gbp = -157.5 and eur = -24975 and  hkd = -202.5','')")

    con:query("insert into check_sql values(-224,'delete from transaction_total_check where cny = -224 and jpy = -22400 and gbp = -156.8 and eur = -24864 and  hkd = -201.6','')")

    con:query("insert into check_sql values(-223,'delete from transaction_total_check where cny = -223 and jpy = -22300 and gbp = -156.1 and eur = -24753 and  hkd = -200.7','')")

    con:query("insert into check_sql values(-222,'delete from transaction_total_check where cny = -222 and jpy = -22200 and gbp = -155.4 and eur = -24642 and  hkd = -199.8','')")

    con:query("insert into check_sql values(-221,'delete from transaction_total_check where cny = -221 and jpy = -22100 and gbp = -154.7 and eur = -24531 and  hkd = -198.9','')")

    con:query("insert into check_sql values(-220,'delete from transaction_total_check where cny = -220 and jpy = -22000 and gbp = -154.0 and eur = -24420 and  hkd = -198.0','')")

    con:query("insert into check_sql values(-219,'delete from transaction_total_check where cny = -219 and jpy = -21900 and gbp = -153.3 and eur = -24309 and  hkd = -197.1','')")

    con:query("insert into check_sql values(-218,'delete from transaction_total_check where cny = -218 and jpy = -21800 and gbp = -152.6 and eur = -24198 and  hkd = -196.2','')")

    con:query("insert into check_sql values(-217,'delete from transaction_total_check where cny = -217 and jpy = -21700 and gbp = -151.9 and eur = -24087 and  hkd = -195.3','')")

    con:query("insert into check_sql values(-216,'delete from transaction_total_check where cny = -216 and jpy = -21600 and gbp = -151.2 and eur = -23976 and  hkd = -194.4','')")

    con:query("insert into check_sql values(-215,'delete from transaction_total_check where cny = -215 and jpy = -21500 and gbp = -150.5 and eur = -23865 and  hkd = -193.5','')")

    con:query("insert into check_sql values(-214,'delete from transaction_total_check where cny = -214 and jpy = -21400 and gbp = -149.8 and eur = -23754 and  hkd = -192.6','')")

    con:query("insert into check_sql values(-213,'delete from transaction_total_check where cny = -213 and jpy = -21300 and gbp = -149.1 and eur = -23643 and  hkd = -191.7','')")

    con:query("insert into check_sql values(-212,'delete from transaction_total_check where cny = -212 and jpy = -21200 and gbp = -148.4 and eur = -23532 and  hkd = -190.8','')")

    con:query("insert into check_sql values(-211,'delete from transaction_total_check where cny = -211 and jpy = -21100 and gbp = -147.7 and eur = -23421 and  hkd = -189.9','')")

    con:query("insert into check_sql values(-210,'delete from transaction_total_check where cny = -210 and jpy = -21000 and gbp = -147.0 and eur = -23310 and  hkd = -189.0','')")

    con:query("insert into check_sql values(-209,'delete from transaction_total_check where cny = -209 and jpy = -20900 and gbp = -146.3 and eur = -23199 and  hkd = -188.1','')")

    con:query("insert into check_sql values(-208,'delete from transaction_total_check where cny = -208 and jpy = -20800 and gbp = -145.6 and eur = -23088 and  hkd = -187.2','')")

    con:query("insert into check_sql values(-207,'delete from transaction_total_check where cny = -207 and jpy = -20700 and gbp = -144.9 and eur = -22977 and  hkd = -186.3','')")

    con:query("insert into check_sql values(-206,'delete from transaction_total_check where cny = -206 and jpy = -20600 and gbp = -144.2 and eur = -22866 and  hkd = -185.4','')")

    con:query("insert into check_sql values(-205,'delete from transaction_total_check where cny = -205 and jpy = -20500 and gbp = -143.5 and eur = -22755 and  hkd = -184.5','')")

    con:query("insert into check_sql values(-204,'delete from transaction_total_check where cny = -204 and jpy = -20400 and gbp = -142.8 and eur = -22644 and  hkd = -183.6','')")

    con:query("insert into check_sql values(-203,'delete from transaction_total_check where cny = -203 and jpy = -20300 and gbp = -142.1 and eur = -22533 and  hkd = -182.7','')")

    con:query("insert into check_sql values(-202,'delete from transaction_total_check where cny = -202 and jpy = -20200 and gbp = -141.4 and eur = -22422 and  hkd = -181.8','')")

    con:query("insert into check_sql values(-201,'delete from transaction_total_check where cny = -201 and jpy = -20100 and gbp = -140.7 and eur = -22311 and  hkd = -180.9','')")

    con:query("insert into check_sql values(-200,'delete from transaction_total_check where cny = -200 and jpy = -20000 and gbp = -140.0 and eur = -22200 and  hkd = -180.0','')")

    con:query("insert into check_sql values(-199,'delete from transaction_total_check where cny = -199 and jpy = -19900 and gbp = -139.3 and eur = -22089 and  hkd = -179.1','')")

    con:query("insert into check_sql values(-198,'delete from transaction_total_check where cny = -198 and jpy = -19800 and gbp = -138.6 and eur = -21978 and  hkd = -178.2','')")

    con:query("insert into check_sql values(-197,'delete from transaction_total_check where cny = -197 and jpy = -19700 and gbp = -137.9 and eur = -21867 and  hkd = -177.3','')")

    con:query("insert into check_sql values(-196,'delete from transaction_total_check where cny = -196 and jpy = -19600 and gbp = -137.2 and eur = -21756 and  hkd = -176.4','')")

    con:query("insert into check_sql values(-195,'delete from transaction_total_check where cny = -195 and jpy = -19500 and gbp = -136.5 and eur = -21645 and  hkd = -175.5','')")

    con:query("insert into check_sql values(-194,'delete from transaction_total_check where cny = -194 and jpy = -19400 and gbp = -135.8 and eur = -21534 and  hkd = -174.6','')")

    con:query("insert into check_sql values(-193,'delete from transaction_total_check where cny = -193 and jpy = -19300 and gbp = -135.1 and eur = -21423 and  hkd = -173.7','')")

    con:query("insert into check_sql values(-192,'delete from transaction_total_check where cny = -192 and jpy = -19200 and gbp = -134.4 and eur = -21312 and  hkd = -172.8','')")

    con:query("insert into check_sql values(-191,'delete from transaction_total_check where cny = -191 and jpy = -19100 and gbp = -133.7 and eur = -21201 and  hkd = -171.9','')")

    con:query("insert into check_sql values(-190,'delete from transaction_total_check where cny = -190 and jpy = -19000 and gbp = -133.0 and eur = -21090 and  hkd = -171.0','')")

    con:query("insert into check_sql values(-189,'delete from transaction_total_check where cny = -189 and jpy = -18900 and gbp = -132.3 and eur = -20979 and  hkd = -170.1','')")

    con:query("insert into check_sql values(-188,'delete from transaction_total_check where cny = -188 and jpy = -18800 and gbp = -131.6 and eur = -20868 and  hkd = -169.2','')")

    con:query("insert into check_sql values(-187,'delete from transaction_total_check where cny = -187 and jpy = -18700 and gbp = -130.9 and eur = -20757 and  hkd = -168.3','')")

    con:query("insert into check_sql values(-186,'delete from transaction_total_check where cny = -186 and jpy = -18600 and gbp = -130.2 and eur = -20646 and  hkd = -167.4','')")

    con:query("insert into check_sql values(-185,'delete from transaction_total_check where cny = -185 and jpy = -18500 and gbp = -129.5 and eur = -20535 and  hkd = -166.5','')")

    con:query("insert into check_sql values(-184,'delete from transaction_total_check where cny = -184 and jpy = -18400 and gbp = -128.8 and eur = -20424 and  hkd = -165.6','')")

    con:query("insert into check_sql values(-183,'delete from transaction_total_check where cny = -183 and jpy = -18300 and gbp = -128.1 and eur = -20313 and  hkd = -164.7','')")

    con:query("insert into check_sql values(-182,'delete from transaction_total_check where cny = -182 and jpy = -18200 and gbp = -127.4 and eur = -20202 and  hkd = -163.8','')")

    con:query("insert into check_sql values(-181,'delete from transaction_total_check where cny = -181 and jpy = -18100 and gbp = -126.7 and eur = -20091 and  hkd = -162.9','')")

    con:query("insert into check_sql values(-180,'delete from transaction_total_check where cny = -180 and jpy = -18000 and gbp = -126.0 and eur = -19980 and  hkd = -162.0','')")

    con:query("insert into check_sql values(-179,'delete from transaction_total_check where cny = -179 and jpy = -17900 and gbp = -125.3 and eur = -19869 and  hkd = -161.1','')")

    con:query("insert into check_sql values(-178,'delete from transaction_total_check where cny = -178 and jpy = -17800 and gbp = -124.6 and eur = -19758 and  hkd = -160.2','')")

    con:query("insert into check_sql values(-177,'delete from transaction_total_check where cny = -177 and jpy = -17700 and gbp = -123.9 and eur = -19647 and  hkd = -159.3','')")

    con:query("insert into check_sql values(-176,'delete from transaction_total_check where cny = -176 and jpy = -17600 and gbp = -123.2 and eur = -19536 and  hkd = -158.4','')")

    con:query("insert into check_sql values(-175,'delete from transaction_total_check where cny = -175 and jpy = -17500 and gbp = -122.5 and eur = -19425 and  hkd = -157.5','')")

    con:query("insert into check_sql values(-174,'delete from transaction_total_check where cny = -174 and jpy = -17400 and gbp = -121.8 and eur = -19314 and  hkd = -156.6','')")

    con:query("insert into check_sql values(-173,'delete from transaction_total_check where cny = -173 and jpy = -17300 and gbp = -121.1 and eur = -19203 and  hkd = -155.7','')")

    con:query("insert into check_sql values(-172,'delete from transaction_total_check where cny = -172 and jpy = -17200 and gbp = -120.4 and eur = -19092 and  hkd = -154.8','')")

    con:query("insert into check_sql values(-171,'delete from transaction_total_check where cny = -171 and jpy = -17100 and gbp = -119.7 and eur = -18981 and  hkd = -153.9','')")

    con:query("insert into check_sql values(-170,'delete from transaction_total_check where cny = -170 and jpy = -17000 and gbp = -119.0 and eur = -18870 and  hkd = -153.0','')")

    con:query("insert into check_sql values(-169,'delete from transaction_total_check where cny = -169 and jpy = -16900 and gbp = -118.3 and eur = -18759 and  hkd = -152.1','')")

    con:query("insert into check_sql values(-168,'delete from transaction_total_check where cny = -168 and jpy = -16800 and gbp = -117.6 and eur = -18648 and  hkd = -151.2','')")

    con:query("insert into check_sql values(-167,'delete from transaction_total_check where cny = -167 and jpy = -16700 and gbp = -116.9 and eur = -18537 and  hkd = -150.3','')")

    con:query("insert into check_sql values(-166,'delete from transaction_total_check where cny = -166 and jpy = -16600 and gbp = -116.2 and eur = -18426 and  hkd = -149.4','')")

    con:query("insert into check_sql values(-165,'delete from transaction_total_check where cny = -165 and jpy = -16500 and gbp = -115.5 and eur = -18315 and  hkd = -148.5','')")

    con:query("insert into check_sql values(-164,'delete from transaction_total_check where cny = -164 and jpy = -16400 and gbp = -114.8 and eur = -18204 and  hkd = -147.6','')")

    con:query("insert into check_sql values(-163,'delete from transaction_total_check where cny = -163 and jpy = -16300 and gbp = -114.1 and eur = -18093 and  hkd = -146.7','')")

    con:query("insert into check_sql values(-162,'delete from transaction_total_check where cny = -162 and jpy = -16200 and gbp = -113.4 and eur = -17982 and  hkd = -145.8','')")

    con:query("insert into check_sql values(-161,'delete from transaction_total_check where cny = -161 and jpy = -16100 and gbp = -112.7 and eur = -17871 and  hkd = -144.9','')")

    con:query("insert into check_sql values(-160,'delete from transaction_total_check where cny = -160 and jpy = -16000 and gbp = -112.0 and eur = -17760 and  hkd = -144.0','')")

    con:query("insert into check_sql values(-159,'delete from transaction_total_check where cny = -159 and jpy = -15900 and gbp = -111.3 and eur = -17649 and  hkd = -143.1','')")

    con:query("insert into check_sql values(-158,'delete from transaction_total_check where cny = -158 and jpy = -15800 and gbp = -110.6 and eur = -17538 and  hkd = -142.2','')")

    con:query("insert into check_sql values(-157,'delete from transaction_total_check where cny = -157 and jpy = -15700 and gbp = -109.9 and eur = -17427 and  hkd = -141.3','')")

    con:query("insert into check_sql values(-156,'delete from transaction_total_check where cny = -156 and jpy = -15600 and gbp = -109.2 and eur = -17316 and  hkd = -140.4','')")

    con:query("insert into check_sql values(-155,'delete from transaction_total_check where cny = -155 and jpy = -15500 and gbp = -108.5 and eur = -17205 and  hkd = -139.5','')")

    con:query("insert into check_sql values(-154,'delete from transaction_total_check where cny = -154 and jpy = -15400 and gbp = -107.8 and eur = -17094 and  hkd = -138.6','')")

    con:query("insert into check_sql values(-153,'delete from transaction_total_check where cny = -153 and jpy = -15300 and gbp = -107.1 and eur = -16983 and  hkd = -137.7','')")

    con:query("insert into check_sql values(-152,'delete from transaction_total_check where cny = -152 and jpy = -15200 and gbp = -106.4 and eur = -16872 and  hkd = -136.8','')")

    con:query("insert into check_sql values(-151,'delete from transaction_total_check where cny = -151 and jpy = -15100 and gbp = -105.7 and eur = -16761 and  hkd = -135.9','')")

    con:query("insert into check_sql values(-150,'delete from transaction_total_check where cny = -150 and jpy = -15000 and gbp = -105.0 and eur = -16650 and  hkd = -135.0','')")

    con:query("insert into check_sql values(-149,'delete from transaction_total_check where cny = -149 and jpy = -14900 and gbp = -104.3 and eur = -16539 and  hkd = -134.1','')")

    con:query("insert into check_sql values(-148,'delete from transaction_total_check where cny = -148 and jpy = -14800 and gbp = -103.6 and eur = -16428 and  hkd = -133.2','')")

    con:query("insert into check_sql values(-147,'delete from transaction_total_check where cny = -147 and jpy = -14700 and gbp = -102.9 and eur = -16317 and  hkd = -132.3','')")

    con:query("insert into check_sql values(-146,'delete from transaction_total_check where cny = -146 and jpy = -14600 and gbp = -102.2 and eur = -16206 and  hkd = -131.4','')")

    con:query("insert into check_sql values(-145,'delete from transaction_total_check where cny = -145 and jpy = -14500 and gbp = -101.5 and eur = -16095 and  hkd = -130.5','')")

    con:query("insert into check_sql values(-144,'delete from transaction_total_check where cny = -144 and jpy = -14400 and gbp = -100.8 and eur = -15984 and  hkd = -129.6','')")

    con:query("insert into check_sql values(-143,'delete from transaction_total_check where cny = -143 and jpy = -14300 and gbp = -100.1 and eur = -15873 and  hkd = -128.7','')")

    con:query("insert into check_sql values(-142,'delete from transaction_total_check where cny = -142 and jpy = -14200 and gbp = -99.4 and eur = -15762 and  hkd = -127.8','')")

    con:query("insert into check_sql values(-141,'delete from transaction_total_check where cny = -141 and jpy = -14100 and gbp = -98.7 and eur = -15651 and  hkd = -126.9','')")

    con:query("insert into check_sql values(-140,'delete from transaction_total_check where cny = -140 and jpy = -14000 and gbp = -98.0 and eur = -15540 and  hkd = -126.0','')")

    con:query("insert into check_sql values(-139,'delete from transaction_total_check where cny = -139 and jpy = -13900 and gbp = -97.3 and eur = -15429 and  hkd = -125.1','')")

    con:query("insert into check_sql values(-138,'delete from transaction_total_check where cny = -138 and jpy = -13800 and gbp = -96.6 and eur = -15318 and  hkd = -124.2','')")

    con:query("insert into check_sql values(-137,'delete from transaction_total_check where cny = -137 and jpy = -13700 and gbp = -95.9 and eur = -15207 and  hkd = -123.3','')")

    con:query("insert into check_sql values(-136,'delete from transaction_total_check where cny = -136 and jpy = -13600 and gbp = -95.2 and eur = -15096 and  hkd = -122.4','')")

    con:query("insert into check_sql values(-135,'delete from transaction_total_check where cny = -135 and jpy = -13500 and gbp = -94.5 and eur = -14985 and  hkd = -121.5','')")

    con:query("insert into check_sql values(-134,'delete from transaction_total_check where cny = -134 and jpy = -13400 and gbp = -93.8 and eur = -14874 and  hkd = -120.6','')")

    con:query("insert into check_sql values(-133,'delete from transaction_total_check where cny = -133 and jpy = -13300 and gbp = -93.1 and eur = -14763 and  hkd = -119.7','')")

    con:query("insert into check_sql values(-132,'delete from transaction_total_check where cny = -132 and jpy = -13200 and gbp = -92.4 and eur = -14652 and  hkd = -118.8','')")

    con:query("insert into check_sql values(-131,'delete from transaction_total_check where cny = -131 and jpy = -13100 and gbp = -91.7 and eur = -14541 and  hkd = -117.9','')")

    con:query("insert into check_sql values(-130,'delete from transaction_total_check where cny = -130 and jpy = -13000 and gbp = -91.0 and eur = -14430 and  hkd = -117.0','')")

    con:query("insert into check_sql values(-129,'delete from transaction_total_check where cny = -129 and jpy = -12900 and gbp = -90.3 and eur = -14319 and  hkd = -116.1','')")

    con:query("insert into check_sql values(-128,'delete from transaction_total_check where cny = -128 and jpy = -12800 and gbp = -89.6 and eur = -14208 and  hkd = -115.2','')")

    con:query("insert into check_sql values(-127,'delete from transaction_total_check where cny = -127 and jpy = -12700 and gbp = -88.9 and eur = -14097 and  hkd = -114.3','')")

    con:query("insert into check_sql values(-126,'delete from transaction_total_check where cny = -126 and jpy = -12600 and gbp = -88.2 and eur = -13986 and  hkd = -113.4','')")

    con:query("insert into check_sql values(-125,'delete from transaction_total_check where cny = -125 and jpy = -12500 and gbp = -87.5 and eur = -13875 and  hkd = -112.5','')")

    con:query("insert into check_sql values(-124,'delete from transaction_total_check where cny = -124 and jpy = -12400 and gbp = -86.8 and eur = -13764 and  hkd = -111.6','')")

    con:query("insert into check_sql values(-123,'delete from transaction_total_check where cny = -123 and jpy = -12300 and gbp = -86.1 and eur = -13653 and  hkd = -110.7','')")

    con:query("insert into check_sql values(-122,'delete from transaction_total_check where cny = -122 and jpy = -12200 and gbp = -85.4 and eur = -13542 and  hkd = -109.8','')")

    con:query("insert into check_sql values(-121,'delete from transaction_total_check where cny = -121 and jpy = -12100 and gbp = -84.7 and eur = -13431 and  hkd = -108.9','')")

    con:query("insert into check_sql values(-120,'delete from transaction_total_check where cny = -120 and jpy = -12000 and gbp = -84.0 and eur = -13320 and  hkd = -108.0','')")

    con:query("insert into check_sql values(-119,'delete from transaction_total_check where cny = -119 and jpy = -11900 and gbp = -83.3 and eur = -13209 and  hkd = -107.1','')")

    con:query("insert into check_sql values(-118,'delete from transaction_total_check where cny = -118 and jpy = -11800 and gbp = -82.6 and eur = -13098 and  hkd = -106.2','')")

    con:query("insert into check_sql values(-117,'delete from transaction_total_check where cny = -117 and jpy = -11700 and gbp = -81.9 and eur = -12987 and  hkd = -105.3','')")

    con:query("insert into check_sql values(-116,'delete from transaction_total_check where cny = -116 and jpy = -11600 and gbp = -81.2 and eur = -12876 and  hkd = -104.4','')")

    con:query("insert into check_sql values(-115,'delete from transaction_total_check where cny = -115 and jpy = -11500 and gbp = -80.5 and eur = -12765 and  hkd = -103.5','')")

    con:query("insert into check_sql values(-114,'delete from transaction_total_check where cny = -114 and jpy = -11400 and gbp = -79.8 and eur = -12654 and  hkd = -102.6','')")

    con:query("insert into check_sql values(-113,'delete from transaction_total_check where cny = -113 and jpy = -11300 and gbp = -79.1 and eur = -12543 and  hkd = -101.7','')")

    con:query("insert into check_sql values(-112,'delete from transaction_total_check where cny = -112 and jpy = -11200 and gbp = -78.4 and eur = -12432 and  hkd = -100.8','')")

    con:query("insert into check_sql values(-111,'delete from transaction_total_check where cny = -111 and jpy = -11100 and gbp = -77.7 and eur = -12321 and  hkd = -99.9','')")

    con:query("insert into check_sql values(-110,'delete from transaction_total_check where cny = -110 and jpy = -11000 and gbp = -77.0 and eur = -12210 and  hkd = -99.0','')")

    con:query("insert into check_sql values(-109,'delete from transaction_total_check where cny = -109 and jpy = -10900 and gbp = -76.3 and eur = -12099 and  hkd = -98.1','')")

    con:query("insert into check_sql values(-108,'delete from transaction_total_check where cny = -108 and jpy = -10800 and gbp = -75.6 and eur = -11988 and  hkd = -97.2','')")

    con:query("insert into check_sql values(-107,'delete from transaction_total_check where cny = -107 and jpy = -10700 and gbp = -74.9 and eur = -11877 and  hkd = -96.3','')")

    con:query("insert into check_sql values(-106,'delete from transaction_total_check where cny = -106 and jpy = -10600 and gbp = -74.2 and eur = -11766 and  hkd = -95.4','')")

    con:query("insert into check_sql values(-105,'delete from transaction_total_check where cny = -105 and jpy = -10500 and gbp = -73.5 and eur = -11655 and  hkd = -94.5','')")

    con:query("insert into check_sql values(-104,'delete from transaction_total_check where cny = -104 and jpy = -10400 and gbp = -72.8 and eur = -11544 and  hkd = -93.6','')")

    con:query("insert into check_sql values(-103,'delete from transaction_total_check where cny = -103 and jpy = -10300 and gbp = -72.1 and eur = -11433 and  hkd = -92.7','')")

    con:query("insert into check_sql values(-102,'delete from transaction_total_check where cny = -102 and jpy = -10200 and gbp = -71.4 and eur = -11322 and  hkd = -91.8','')")

    con:query("insert into check_sql values(-101,'delete from transaction_total_check where cny = -101 and jpy = -10100 and gbp = -70.7 and eur = -11211 and  hkd = -90.9','')")

    con:query("insert into check_sql values(-100,'delete from transaction_total_check where cny = -100 and jpy = -10000 and gbp = -70.0 and eur = -11100 and  hkd = -90.0','')")

    con:query("insert into check_sql values(-99,'delete from transaction_total_check where cny = -99 and jpy = -9900 and gbp = -69.3 and eur = -10989 and  hkd = -89.1','')")

    con:query("insert into check_sql values(-98,'delete from transaction_total_check where cny = -98 and jpy = -9800 and gbp = -68.6 and eur = -10878 and  hkd = -88.2','')")

    con:query("insert into check_sql values(-97,'delete from transaction_total_check where cny = -97 and jpy = -9700 and gbp = -67.9 and eur = -10767 and  hkd = -87.3','')")

    con:query("insert into check_sql values(-96,'delete from transaction_total_check where cny = -96 and jpy = -9600 and gbp = -67.2 and eur = -10656 and  hkd = -86.4','')")

    con:query("insert into check_sql values(-95,'delete from transaction_total_check where cny = -95 and jpy = -9500 and gbp = -66.5 and eur = -10545 and  hkd = -85.5','')")

    con:query("insert into check_sql values(-94,'delete from transaction_total_check where cny = -94 and jpy = -9400 and gbp = -65.8 and eur = -10434 and  hkd = -84.6','')")

    con:query("insert into check_sql values(-93,'delete from transaction_total_check where cny = -93 and jpy = -9300 and gbp = -65.1 and eur = -10323 and  hkd = -83.7','')")

    con:query("insert into check_sql values(-92,'delete from transaction_total_check where cny = -92 and jpy = -9200 and gbp = -64.4 and eur = -10212 and  hkd = -82.8','')")

    con:query("insert into check_sql values(-91,'delete from transaction_total_check where cny = -91 and jpy = -9100 and gbp = -63.7 and eur = -10101 and  hkd = -81.9','')")

    con:query("insert into check_sql values(-90,'delete from transaction_total_check where cny = -90 and jpy = -9000 and gbp = -63.0 and eur = -9990 and  hkd = -81.0','')")

    con:query("insert into check_sql values(-89,'delete from transaction_total_check where cny = -89 and jpy = -8900 and gbp = -62.3 and eur = -9879 and  hkd = -80.1','')")

    con:query("insert into check_sql values(-88,'delete from transaction_total_check where cny = -88 and jpy = -8800 and gbp = -61.6 and eur = -9768 and  hkd = -79.2','')")

    con:query("insert into check_sql values(-87,'delete from transaction_total_check where cny = -87 and jpy = -8700 and gbp = -60.9 and eur = -9657 and  hkd = -78.3','')")

    con:query("insert into check_sql values(-86,'delete from transaction_total_check where cny = -86 and jpy = -8600 and gbp = -60.2 and eur = -9546 and  hkd = -77.4','')")

    con:query("insert into check_sql values(-85,'delete from transaction_total_check where cny = -85 and jpy = -8500 and gbp = -59.5 and eur = -9435 and  hkd = -76.5','')")

    con:query("insert into check_sql values(-84,'delete from transaction_total_check where cny = -84 and jpy = -8400 and gbp = -58.8 and eur = -9324 and  hkd = -75.6','')")

    con:query("insert into check_sql values(-83,'delete from transaction_total_check where cny = -83 and jpy = -8300 and gbp = -58.1 and eur = -9213 and  hkd = -74.7','')")

    con:query("insert into check_sql values(-82,'delete from transaction_total_check where cny = -82 and jpy = -8200 and gbp = -57.4 and eur = -9102 and  hkd = -73.8','')")

    con:query("insert into check_sql values(-81,'delete from transaction_total_check where cny = -81 and jpy = -8100 and gbp = -56.7 and eur = -8991 and  hkd = -72.9','')")

    con:query("insert into check_sql values(-80,'delete from transaction_total_check where cny = -80 and jpy = -8000 and gbp = -56.0 and eur = -8880 and  hkd = -72.0','')")

    con:query("insert into check_sql values(-79,'delete from transaction_total_check where cny = -79 and jpy = -7900 and gbp = -55.3 and eur = -8769 and  hkd = -71.1','')")

    con:query("insert into check_sql values(-78,'delete from transaction_total_check where cny = -78 and jpy = -7800 and gbp = -54.6 and eur = -8658 and  hkd = -70.2','')")

    con:query("insert into check_sql values(-77,'delete from transaction_total_check where cny = -77 and jpy = -7700 and gbp = -53.9 and eur = -8547 and  hkd = -69.3','')")

    con:query("insert into check_sql values(-76,'delete from transaction_total_check where cny = -76 and jpy = -7600 and gbp = -53.2 and eur = -8436 and  hkd = -68.4','')")

    con:query("insert into check_sql values(-75,'delete from transaction_total_check where cny = -75 and jpy = -7500 and gbp = -52.5 and eur = -8325 and  hkd = -67.5','')")

    con:query("insert into check_sql values(-74,'delete from transaction_total_check where cny = -74 and jpy = -7400 and gbp = -51.8 and eur = -8214 and  hkd = -66.6','')")

    con:query("insert into check_sql values(-73,'delete from transaction_total_check where cny = -73 and jpy = -7300 and gbp = -51.1 and eur = -8103 and  hkd = -65.7','')")

    con:query("insert into check_sql values(-72,'delete from transaction_total_check where cny = -72 and jpy = -7200 and gbp = -50.4 and eur = -7992 and  hkd = -64.8','')")

    con:query("insert into check_sql values(-71,'delete from transaction_total_check where cny = -71 and jpy = -7100 and gbp = -49.7 and eur = -7881 and  hkd = -63.9','')")

    con:query("insert into check_sql values(-70,'delete from transaction_total_check where cny = -70 and jpy = -7000 and gbp = -49.0 and eur = -7770 and  hkd = -63.0','')")

    con:query("insert into check_sql values(-69,'delete from transaction_total_check where cny = -69 and jpy = -6900 and gbp = -48.3 and eur = -7659 and  hkd = -62.1','')")

    con:query("insert into check_sql values(-68,'delete from transaction_total_check where cny = -68 and jpy = -6800 and gbp = -47.6 and eur = -7548 and  hkd = -61.2','')")

    con:query("insert into check_sql values(-67,'delete from transaction_total_check where cny = -67 and jpy = -6700 and gbp = -46.9 and eur = -7437 and  hkd = -60.3','')")

    con:query("insert into check_sql values(-66,'delete from transaction_total_check where cny = -66 and jpy = -6600 and gbp = -46.2 and eur = -7326 and  hkd = -59.4','')")

    con:query("insert into check_sql values(-65,'delete from transaction_total_check where cny = -65 and jpy = -6500 and gbp = -45.5 and eur = -7215 and  hkd = -58.5','')")

    con:query("insert into check_sql values(-64,'delete from transaction_total_check where cny = -64 and jpy = -6400 and gbp = -44.8 and eur = -7104 and  hkd = -57.6','')")

    con:query("insert into check_sql values(-63,'delete from transaction_total_check where cny = -63 and jpy = -6300 and gbp = -44.1 and eur = -6993 and  hkd = -56.7','')")

    con:query("insert into check_sql values(-62,'delete from transaction_total_check where cny = -62 and jpy = -6200 and gbp = -43.4 and eur = -6882 and  hkd = -55.8','')")

    con:query("insert into check_sql values(-61,'delete from transaction_total_check where cny = -61 and jpy = -6100 and gbp = -42.7 and eur = -6771 and  hkd = -54.9','')")

    con:query("insert into check_sql values(-60,'delete from transaction_total_check where cny = -60 and jpy = -6000 and gbp = -42.0 and eur = -6660 and  hkd = -54.0','')")

    con:query("insert into check_sql values(-59,'delete from transaction_total_check where cny = -59 and jpy = -5900 and gbp = -41.3 and eur = -6549 and  hkd = -53.1','')")

    con:query("insert into check_sql values(-58,'delete from transaction_total_check where cny = -58 and jpy = -5800 and gbp = -40.6 and eur = -6438 and  hkd = -52.2','')")

    con:query("insert into check_sql values(-57,'delete from transaction_total_check where cny = -57 and jpy = -5700 and gbp = -39.9 and eur = -6327 and  hkd = -51.3','')")

    con:query("insert into check_sql values(-56,'delete from transaction_total_check where cny = -56 and jpy = -5600 and gbp = -39.2 and eur = -6216 and  hkd = -50.4','')")

    con:query("insert into check_sql values(-55,'delete from transaction_total_check where cny = -55 and jpy = -5500 and gbp = -38.5 and eur = -6105 and  hkd = -49.5','')")

    con:query("insert into check_sql values(-54,'delete from transaction_total_check where cny = -54 and jpy = -5400 and gbp = -37.8 and eur = -5994 and  hkd = -48.6','')")

    con:query("insert into check_sql values(-53,'delete from transaction_total_check where cny = -53 and jpy = -5300 and gbp = -37.1 and eur = -5883 and  hkd = -47.7','')")

    con:query("insert into check_sql values(-52,'delete from transaction_total_check where cny = -52 and jpy = -5200 and gbp = -36.4 and eur = -5772 and  hkd = -46.8','')")

    con:query("insert into check_sql values(-51,'delete from transaction_total_check where cny = -51 and jpy = -5100 and gbp = -35.7 and eur = -5661 and  hkd = -45.9','')")

    con:query("insert into check_sql values(-50,'delete from transaction_total_check where cny = -50 and jpy = -5000 and gbp = -35.0 and eur = -5550 and  hkd = -45.0','')")

    con:query("insert into check_sql values(-49,'delete from transaction_total_check where cny = -49 and jpy = -4900 and gbp = -34.3 and eur = -5439 and  hkd = -44.1','')")

    con:query("insert into check_sql values(-48,'delete from transaction_total_check where cny = -48 and jpy = -4800 and gbp = -33.6 and eur = -5328 and  hkd = -43.2','')")

    con:query("insert into check_sql values(-47,'delete from transaction_total_check where cny = -47 and jpy = -4700 and gbp = -32.9 and eur = -5217 and  hkd = -42.3','')")

    con:query("insert into check_sql values(-46,'delete from transaction_total_check where cny = -46 and jpy = -4600 and gbp = -32.2 and eur = -5106 and  hkd = -41.4','')")

    con:query("insert into check_sql values(-45,'delete from transaction_total_check where cny = -45 and jpy = -4500 and gbp = -31.5 and eur = -4995 and  hkd = -40.5','')")

    con:query("insert into check_sql values(-44,'delete from transaction_total_check where cny = -44 and jpy = -4400 and gbp = -30.8 and eur = -4884 and  hkd = -39.6','')")

    con:query("insert into check_sql values(-43,'delete from transaction_total_check where cny = -43 and jpy = -4300 and gbp = -30.1 and eur = -4773 and  hkd = -38.7','')")

    con:query("insert into check_sql values(-42,'delete from transaction_total_check where cny = -42 and jpy = -4200 and gbp = -29.4 and eur = -4662 and  hkd = -37.8','')")

    con:query("insert into check_sql values(-41,'delete from transaction_total_check where cny = -41 and jpy = -4100 and gbp = -28.7 and eur = -4551 and  hkd = -36.9','')")

    con:query("insert into check_sql values(-40,'delete from transaction_total_check where cny = -40 and jpy = -4000 and gbp = -28.0 and eur = -4440 and  hkd = -36.0','')")

    con:query("insert into check_sql values(-39,'delete from transaction_total_check where cny = -39 and jpy = -3900 and gbp = -27.3 and eur = -4329 and  hkd = -35.1','')")

    con:query("insert into check_sql values(-38,'delete from transaction_total_check where cny = -38 and jpy = -3800 and gbp = -26.6 and eur = -4218 and  hkd = -34.2','')")

    con:query("insert into check_sql values(-37,'delete from transaction_total_check where cny = -37 and jpy = -3700 and gbp = -25.9 and eur = -4107 and  hkd = -33.3','')")

    con:query("insert into check_sql values(-36,'delete from transaction_total_check where cny = -36 and jpy = -3600 and gbp = -25.2 and eur = -3996 and  hkd = -32.4','')")

    con:query("insert into check_sql values(-35,'delete from transaction_total_check where cny = -35 and jpy = -3500 and gbp = -24.5 and eur = -3885 and  hkd = -31.5','')")

    con:query("insert into check_sql values(-34,'delete from transaction_total_check where cny = -34 and jpy = -3400 and gbp = -23.8 and eur = -3774 and  hkd = -30.6','')")

    con:query("insert into check_sql values(-33,'delete from transaction_total_check where cny = -33 and jpy = -3300 and gbp = -23.1 and eur = -3663 and  hkd = -29.7','')")

    con:query("insert into check_sql values(-32,'delete from transaction_total_check where cny = -32 and jpy = -3200 and gbp = -22.4 and eur = -3552 and  hkd = -28.8','')")

    con:query("insert into check_sql values(-31,'delete from transaction_total_check where cny = -31 and jpy = -3100 and gbp = -21.7 and eur = -3441 and  hkd = -27.9','')")

    con:query("insert into check_sql values(-30,'delete from transaction_total_check where cny = -30 and jpy = -3000 and gbp = -21.0 and eur = -3330 and  hkd = -27.0','')")

    con:query("insert into check_sql values(-29,'delete from transaction_total_check where cny = -29 and jpy = -2900 and gbp = -20.3 and eur = -3219 and  hkd = -26.1','')")

    con:query("insert into check_sql values(-28,'delete from transaction_total_check where cny = -28 and jpy = -2800 and gbp = -19.6 and eur = -3108 and  hkd = -25.2','')")

    con:query("insert into check_sql values(-27,'delete from transaction_total_check where cny = -27 and jpy = -2700 and gbp = -18.9 and eur = -2997 and  hkd = -24.3','')")

    con:query("insert into check_sql values(-26,'delete from transaction_total_check where cny = -26 and jpy = -2600 and gbp = -18.2 and eur = -2886 and  hkd = -23.4','')")

    con:query("insert into check_sql values(-25,'delete from transaction_total_check where cny = -25 and jpy = -2500 and gbp = -17.5 and eur = -2775 and  hkd = -22.5','')")

    con:query("insert into check_sql values(-24,'delete from transaction_total_check where cny = -24 and jpy = -2400 and gbp = -16.8 and eur = -2664 and  hkd = -21.6','')")

    con:query("insert into check_sql values(-23,'delete from transaction_total_check where cny = -23 and jpy = -2300 and gbp = -16.1 and eur = -2553 and  hkd = -20.7','')")

    con:query("insert into check_sql values(-22,'delete from transaction_total_check where cny = -22 and jpy = -2200 and gbp = -15.4 and eur = -2442 and  hkd = -19.8','')")

    con:query("insert into check_sql values(-21,'delete from transaction_total_check where cny = -21 and jpy = -2100 and gbp = -14.7 and eur = -2331 and  hkd = -18.9','')")

    con:query("insert into check_sql values(-20,'delete from transaction_total_check where cny = -20 and jpy = -2000 and gbp = -14.0 and eur = -2220 and  hkd = -18.0','')")

    con:query("insert into check_sql values(-19,'delete from transaction_total_check where cny = -19 and jpy = -1900 and gbp = -13.3 and eur = -2109 and  hkd = -17.1','')")

    con:query("insert into check_sql values(-18,'delete from transaction_total_check where cny = -18 and jpy = -1800 and gbp = -12.6 and eur = -1998 and  hkd = -16.2','')")

    con:query("insert into check_sql values(-17,'delete from transaction_total_check where cny = -17 and jpy = -1700 and gbp = -11.9 and eur = -1887 and  hkd = -15.3','')")

    con:query("insert into check_sql values(-16,'delete from transaction_total_check where cny = -16 and jpy = -1600 and gbp = -11.2 and eur = -1776 and  hkd = -14.4','')")

    con:query("insert into check_sql values(-15,'delete from transaction_total_check where cny = -15 and jpy = -1500 and gbp = -10.5 and eur = -1665 and  hkd = -13.5','')")

    con:query("insert into check_sql values(-14,'delete from transaction_total_check where cny = -14 and jpy = -1400 and gbp = -9.8 and eur = -1554 and  hkd = -12.6','')")

    con:query("insert into check_sql values(-13,'delete from transaction_total_check where cny = -13 and jpy = -1300 and gbp = -9.1 and eur = -1443 and  hkd = -11.7','')")

    con:query("insert into check_sql values(-12,'delete from transaction_total_check where cny = -12 and jpy = -1200 and gbp = -8.4 and eur = -1332 and  hkd = -10.8','')")

    con:query("insert into check_sql values(-11,'delete from transaction_total_check where cny = -11 and jpy = -1100 and gbp = -7.7 and eur = -1221 and  hkd = -9.9','')")

    con:query("insert into check_sql values(-10,'delete from transaction_total_check where cny = -10 and jpy = -1000 and gbp = -7.0 and eur = -1110 and  hkd = -9.0','')")

    con:query("insert into check_sql values(-9,'delete from transaction_total_check where cny = -9 and jpy = -900 and gbp = -6.3 and eur = -999 and  hkd = -8.1','')")

    con:query("insert into check_sql values(-8,'delete from transaction_total_check where cny = -8 and jpy = -800 and gbp = -5.6 and eur = -888 and  hkd = -7.2','')")

    con:query("insert into check_sql values(-7,'delete from transaction_total_check where cny = -7 and jpy = -700 and gbp = -4.9 and eur = -777 and  hkd = -6.3','')")

    con:query("insert into check_sql values(-6,'delete from transaction_total_check where cny = -6 and jpy = -600 and gbp = -4.2 and eur = -666 and  hkd = -5.4','')")

    con:query("insert into check_sql values(-5,'delete from transaction_total_check where cny = -5 and jpy = -500 and gbp = -3.5 and eur = -555 and  hkd = -4.5','')")

    con:query("insert into check_sql values(-4,'delete from transaction_total_check where cny = -4 and jpy = -400 and gbp = -2.8 and eur = -444 and  hkd = -3.6','')")

    con:query("insert into check_sql values(-3,'delete from transaction_total_check where cny = -3 and jpy = -300 and gbp = -2.1 and eur = -333 and  hkd = -2.7','')")

    con:query("insert into check_sql values(-2,'delete from transaction_total_check where cny = -2 and jpy = -200 and gbp = -1.4 and eur = -222 and  hkd = -1.8','')")

    con:query("insert into check_sql values(-1,'delete from transaction_total_check where cny = -1 and jpy = -100 and gbp = -0.7 and eur = -111 and  hkd = -0.9','')")

    con:query("insert into check_sql values(0,'delete from transaction_total_check where cny = 0 and jpy = 0 and gbp = 0.0 and eur = 0 and  hkd = 0.0','')")

    con:query("insert into check_sql values(1,'delete from transaction_total_check where cny = 1 and jpy = 100 and gbp = 0.7 and eur = 111 and  hkd = 0.9','')")

    con:query("insert into check_sql values(2,'delete from transaction_total_check where cny = 2 and jpy = 200 and gbp = 1.4 and eur = 222 and  hkd = 1.8','')")

    con:query("insert into check_sql values(3,'delete from transaction_total_check where cny = 3 and jpy = 300 and gbp = 2.1 and eur = 333 and  hkd = 2.7','')")

    con:query("insert into check_sql values(4,'delete from transaction_total_check where cny = 4 and jpy = 400 and gbp = 2.8 and eur = 444 and  hkd = 3.6','')")

    con:query("insert into check_sql values(5,'delete from transaction_total_check where cny = 5 and jpy = 500 and gbp = 3.5 and eur = 555 and  hkd = 4.5','')")

    con:query("insert into check_sql values(6,'delete from transaction_total_check where cny = 6 and jpy = 600 and gbp = 4.2 and eur = 666 and  hkd = 5.4','')")

    con:query("insert into check_sql values(7,'delete from transaction_total_check where cny = 7 and jpy = 700 and gbp = 4.9 and eur = 777 and  hkd = 6.3','')")

    con:query("insert into check_sql values(8,'delete from transaction_total_check where cny = 8 and jpy = 800 and gbp = 5.6 and eur = 888 and  hkd = 7.2','')")

    con:query("insert into check_sql values(9,'delete from transaction_total_check where cny = 9 and jpy = 900 and gbp = 6.3 and eur = 999 and  hkd = 8.1','')")

    con:query("insert into check_sql values(10,'delete from transaction_total_check where cny = 10 and jpy = 1000 and gbp = 7.0 and eur = 1110 and  hkd = 9.0','')")

    con:query("insert into check_sql values(11,'delete from transaction_total_check where cny = 11 and jpy = 1100 and gbp = 7.7 and eur = 1221 and  hkd = 9.9','')")

    con:query("insert into check_sql values(12,'delete from transaction_total_check where cny = 12 and jpy = 1200 and gbp = 8.4 and eur = 1332 and  hkd = 10.8','')")

    con:query("insert into check_sql values(13,'delete from transaction_total_check where cny = 13 and jpy = 1300 and gbp = 9.1 and eur = 1443 and  hkd = 11.7','')")

    con:query("insert into check_sql values(14,'delete from transaction_total_check where cny = 14 and jpy = 1400 and gbp = 9.8 and eur = 1554 and  hkd = 12.6','')")

    con:query("insert into check_sql values(15,'delete from transaction_total_check where cny = 15 and jpy = 1500 and gbp = 10.5 and eur = 1665 and  hkd = 13.5','')")

    con:query("insert into check_sql values(16,'delete from transaction_total_check where cny = 16 and jpy = 1600 and gbp = 11.2 and eur = 1776 and  hkd = 14.4','')")

    con:query("insert into check_sql values(17,'delete from transaction_total_check where cny = 17 and jpy = 1700 and gbp = 11.9 and eur = 1887 and  hkd = 15.3','')")

    con:query("insert into check_sql values(18,'delete from transaction_total_check where cny = 18 and jpy = 1800 and gbp = 12.6 and eur = 1998 and  hkd = 16.2','')")

    con:query("insert into check_sql values(19,'delete from transaction_total_check where cny = 19 and jpy = 1900 and gbp = 13.3 and eur = 2109 and  hkd = 17.1','')")

    con:query("insert into check_sql values(20,'delete from transaction_total_check where cny = 20 and jpy = 2000 and gbp = 14.0 and eur = 2220 and  hkd = 18.0','')")

    con:query("insert into check_sql values(21,'delete from transaction_total_check where cny = 21 and jpy = 2100 and gbp = 14.7 and eur = 2331 and  hkd = 18.9','')")

    con:query("insert into check_sql values(22,'delete from transaction_total_check where cny = 22 and jpy = 2200 and gbp = 15.4 and eur = 2442 and  hkd = 19.8','')")

    con:query("insert into check_sql values(23,'delete from transaction_total_check where cny = 23 and jpy = 2300 and gbp = 16.1 and eur = 2553 and  hkd = 20.7','')")

    con:query("insert into check_sql values(24,'delete from transaction_total_check where cny = 24 and jpy = 2400 and gbp = 16.8 and eur = 2664 and  hkd = 21.6','')")

    con:query("insert into check_sql values(25,'delete from transaction_total_check where cny = 25 and jpy = 2500 and gbp = 17.5 and eur = 2775 and  hkd = 22.5','')")

    con:query("insert into check_sql values(26,'delete from transaction_total_check where cny = 26 and jpy = 2600 and gbp = 18.2 and eur = 2886 and  hkd = 23.4','')")

    con:query("insert into check_sql values(27,'delete from transaction_total_check where cny = 27 and jpy = 2700 and gbp = 18.9 and eur = 2997 and  hkd = 24.3','')")

    con:query("insert into check_sql values(28,'delete from transaction_total_check where cny = 28 and jpy = 2800 and gbp = 19.6 and eur = 3108 and  hkd = 25.2','')")

    con:query("insert into check_sql values(29,'delete from transaction_total_check where cny = 29 and jpy = 2900 and gbp = 20.3 and eur = 3219 and  hkd = 26.1','')")

    con:query("insert into check_sql values(30,'delete from transaction_total_check where cny = 30 and jpy = 3000 and gbp = 21.0 and eur = 3330 and  hkd = 27.0','')")

    con:query("insert into check_sql values(31,'delete from transaction_total_check where cny = 31 and jpy = 3100 and gbp = 21.7 and eur = 3441 and  hkd = 27.9','')")

    con:query("insert into check_sql values(32,'delete from transaction_total_check where cny = 32 and jpy = 3200 and gbp = 22.4 and eur = 3552 and  hkd = 28.8','')")

    con:query("insert into check_sql values(33,'delete from transaction_total_check where cny = 33 and jpy = 3300 and gbp = 23.1 and eur = 3663 and  hkd = 29.7','')")

    con:query("insert into check_sql values(34,'delete from transaction_total_check where cny = 34 and jpy = 3400 and gbp = 23.8 and eur = 3774 and  hkd = 30.6','')")

    con:query("insert into check_sql values(35,'delete from transaction_total_check where cny = 35 and jpy = 3500 and gbp = 24.5 and eur = 3885 and  hkd = 31.5','')")

    con:query("insert into check_sql values(36,'delete from transaction_total_check where cny = 36 and jpy = 3600 and gbp = 25.2 and eur = 3996 and  hkd = 32.4','')")

    con:query("insert into check_sql values(37,'delete from transaction_total_check where cny = 37 and jpy = 3700 and gbp = 25.9 and eur = 4107 and  hkd = 33.3','')")

    con:query("insert into check_sql values(38,'delete from transaction_total_check where cny = 38 and jpy = 3800 and gbp = 26.6 and eur = 4218 and  hkd = 34.2','')")

    con:query("insert into check_sql values(39,'delete from transaction_total_check where cny = 39 and jpy = 3900 and gbp = 27.3 and eur = 4329 and  hkd = 35.1','')")

    con:query("insert into check_sql values(40,'delete from transaction_total_check where cny = 40 and jpy = 4000 and gbp = 28.0 and eur = 4440 and  hkd = 36.0','')")

    con:query("insert into check_sql values(41,'delete from transaction_total_check where cny = 41 and jpy = 4100 and gbp = 28.7 and eur = 4551 and  hkd = 36.9','')")

    con:query("insert into check_sql values(42,'delete from transaction_total_check where cny = 42 and jpy = 4200 and gbp = 29.4 and eur = 4662 and  hkd = 37.8','')")

    con:query("insert into check_sql values(43,'delete from transaction_total_check where cny = 43 and jpy = 4300 and gbp = 30.1 and eur = 4773 and  hkd = 38.7','')")

    con:query("insert into check_sql values(44,'delete from transaction_total_check where cny = 44 and jpy = 4400 and gbp = 30.8 and eur = 4884 and  hkd = 39.6','')")

    con:query("insert into check_sql values(45,'delete from transaction_total_check where cny = 45 and jpy = 4500 and gbp = 31.5 and eur = 4995 and  hkd = 40.5','')")

    con:query("insert into check_sql values(46,'delete from transaction_total_check where cny = 46 and jpy = 4600 and gbp = 32.2 and eur = 5106 and  hkd = 41.4','')")

    con:query("insert into check_sql values(47,'delete from transaction_total_check where cny = 47 and jpy = 4700 and gbp = 32.9 and eur = 5217 and  hkd = 42.3','')")

    con:query("insert into check_sql values(48,'delete from transaction_total_check where cny = 48 and jpy = 4800 and gbp = 33.6 and eur = 5328 and  hkd = 43.2','')")

    con:query("insert into check_sql values(49,'delete from transaction_total_check where cny = 49 and jpy = 4900 and gbp = 34.3 and eur = 5439 and  hkd = 44.1','')")

    con:query("insert into check_sql values(50,'delete from transaction_total_check where cny = 50 and jpy = 5000 and gbp = 35.0 and eur = 5550 and  hkd = 45.0','')")

    con:query("insert into check_sql values(51,'delete from transaction_total_check where cny = 51 and jpy = 5100 and gbp = 35.7 and eur = 5661 and  hkd = 45.9','')")

    con:query("insert into check_sql values(52,'delete from transaction_total_check where cny = 52 and jpy = 5200 and gbp = 36.4 and eur = 5772 and  hkd = 46.8','')")

    con:query("insert into check_sql values(53,'delete from transaction_total_check where cny = 53 and jpy = 5300 and gbp = 37.1 and eur = 5883 and  hkd = 47.7','')")

    con:query("insert into check_sql values(54,'delete from transaction_total_check where cny = 54 and jpy = 5400 and gbp = 37.8 and eur = 5994 and  hkd = 48.6','')")

    con:query("insert into check_sql values(55,'delete from transaction_total_check where cny = 55 and jpy = 5500 and gbp = 38.5 and eur = 6105 and  hkd = 49.5','')")

    con:query("insert into check_sql values(56,'delete from transaction_total_check where cny = 56 and jpy = 5600 and gbp = 39.2 and eur = 6216 and  hkd = 50.4','')")

    con:query("insert into check_sql values(57,'delete from transaction_total_check where cny = 57 and jpy = 5700 and gbp = 39.9 and eur = 6327 and  hkd = 51.3','')")

    con:query("insert into check_sql values(58,'delete from transaction_total_check where cny = 58 and jpy = 5800 and gbp = 40.6 and eur = 6438 and  hkd = 52.2','')")

    con:query("insert into check_sql values(59,'delete from transaction_total_check where cny = 59 and jpy = 5900 and gbp = 41.3 and eur = 6549 and  hkd = 53.1','')")

    con:query("insert into check_sql values(60,'delete from transaction_total_check where cny = 60 and jpy = 6000 and gbp = 42.0 and eur = 6660 and  hkd = 54.0','')")

    con:query("insert into check_sql values(61,'delete from transaction_total_check where cny = 61 and jpy = 6100 and gbp = 42.7 and eur = 6771 and  hkd = 54.9','')")

    con:query("insert into check_sql values(62,'delete from transaction_total_check where cny = 62 and jpy = 6200 and gbp = 43.4 and eur = 6882 and  hkd = 55.8','')")

    con:query("insert into check_sql values(63,'delete from transaction_total_check where cny = 63 and jpy = 6300 and gbp = 44.1 and eur = 6993 and  hkd = 56.7','')")

    con:query("insert into check_sql values(64,'delete from transaction_total_check where cny = 64 and jpy = 6400 and gbp = 44.8 and eur = 7104 and  hkd = 57.6','')")

    con:query("insert into check_sql values(65,'delete from transaction_total_check where cny = 65 and jpy = 6500 and gbp = 45.5 and eur = 7215 and  hkd = 58.5','')")

    con:query("insert into check_sql values(66,'delete from transaction_total_check where cny = 66 and jpy = 6600 and gbp = 46.2 and eur = 7326 and  hkd = 59.4','')")

    con:query("insert into check_sql values(67,'delete from transaction_total_check where cny = 67 and jpy = 6700 and gbp = 46.9 and eur = 7437 and  hkd = 60.3','')")

    con:query("insert into check_sql values(68,'delete from transaction_total_check where cny = 68 and jpy = 6800 and gbp = 47.6 and eur = 7548 and  hkd = 61.2','')")

    con:query("insert into check_sql values(69,'delete from transaction_total_check where cny = 69 and jpy = 6900 and gbp = 48.3 and eur = 7659 and  hkd = 62.1','')")

    con:query("insert into check_sql values(70,'delete from transaction_total_check where cny = 70 and jpy = 7000 and gbp = 49.0 and eur = 7770 and  hkd = 63.0','')")

    con:query("insert into check_sql values(71,'delete from transaction_total_check where cny = 71 and jpy = 7100 and gbp = 49.7 and eur = 7881 and  hkd = 63.9','')")

    con:query("insert into check_sql values(72,'delete from transaction_total_check where cny = 72 and jpy = 7200 and gbp = 50.4 and eur = 7992 and  hkd = 64.8','')")

    con:query("insert into check_sql values(73,'delete from transaction_total_check where cny = 73 and jpy = 7300 and gbp = 51.1 and eur = 8103 and  hkd = 65.7','')")

    con:query("insert into check_sql values(74,'delete from transaction_total_check where cny = 74 and jpy = 7400 and gbp = 51.8 and eur = 8214 and  hkd = 66.6','')")

    con:query("insert into check_sql values(75,'delete from transaction_total_check where cny = 75 and jpy = 7500 and gbp = 52.5 and eur = 8325 and  hkd = 67.5','')")

    con:query("insert into check_sql values(76,'delete from transaction_total_check where cny = 76 and jpy = 7600 and gbp = 53.2 and eur = 8436 and  hkd = 68.4','')")

    con:query("insert into check_sql values(77,'delete from transaction_total_check where cny = 77 and jpy = 7700 and gbp = 53.9 and eur = 8547 and  hkd = 69.3','')")

    con:query("insert into check_sql values(78,'delete from transaction_total_check where cny = 78 and jpy = 7800 and gbp = 54.6 and eur = 8658 and  hkd = 70.2','')")

    con:query("insert into check_sql values(79,'delete from transaction_total_check where cny = 79 and jpy = 7900 and gbp = 55.3 and eur = 8769 and  hkd = 71.1','')")

    con:query("insert into check_sql values(80,'delete from transaction_total_check where cny = 80 and jpy = 8000 and gbp = 56.0 and eur = 8880 and  hkd = 72.0','')")

    con:query("insert into check_sql values(81,'delete from transaction_total_check where cny = 81 and jpy = 8100 and gbp = 56.7 and eur = 8991 and  hkd = 72.9','')")

    con:query("insert into check_sql values(82,'delete from transaction_total_check where cny = 82 and jpy = 8200 and gbp = 57.4 and eur = 9102 and  hkd = 73.8','')")

    con:query("insert into check_sql values(83,'delete from transaction_total_check where cny = 83 and jpy = 8300 and gbp = 58.1 and eur = 9213 and  hkd = 74.7','')")

    con:query("insert into check_sql values(84,'delete from transaction_total_check where cny = 84 and jpy = 8400 and gbp = 58.8 and eur = 9324 and  hkd = 75.6','')")

    con:query("insert into check_sql values(85,'delete from transaction_total_check where cny = 85 and jpy = 8500 and gbp = 59.5 and eur = 9435 and  hkd = 76.5','')")

    con:query("insert into check_sql values(86,'delete from transaction_total_check where cny = 86 and jpy = 8600 and gbp = 60.2 and eur = 9546 and  hkd = 77.4','')")

    con:query("insert into check_sql values(87,'delete from transaction_total_check where cny = 87 and jpy = 8700 and gbp = 60.9 and eur = 9657 and  hkd = 78.3','')")

    con:query("insert into check_sql values(88,'delete from transaction_total_check where cny = 88 and jpy = 8800 and gbp = 61.6 and eur = 9768 and  hkd = 79.2','')")

    con:query("insert into check_sql values(89,'delete from transaction_total_check where cny = 89 and jpy = 8900 and gbp = 62.3 and eur = 9879 and  hkd = 80.1','')")

    con:query("insert into check_sql values(90,'delete from transaction_total_check where cny = 90 and jpy = 9000 and gbp = 63.0 and eur = 9990 and  hkd = 81.0','')")

    con:query("insert into check_sql values(91,'delete from transaction_total_check where cny = 91 and jpy = 9100 and gbp = 63.7 and eur = 10101 and  hkd = 81.9','')")

    con:query("insert into check_sql values(92,'delete from transaction_total_check where cny = 92 and jpy = 9200 and gbp = 64.4 and eur = 10212 and  hkd = 82.8','')")

    con:query("insert into check_sql values(93,'delete from transaction_total_check where cny = 93 and jpy = 9300 and gbp = 65.1 and eur = 10323 and  hkd = 83.7','')")

    con:query("insert into check_sql values(94,'delete from transaction_total_check where cny = 94 and jpy = 9400 and gbp = 65.8 and eur = 10434 and  hkd = 84.6','')")

    con:query("insert into check_sql values(95,'delete from transaction_total_check where cny = 95 and jpy = 9500 and gbp = 66.5 and eur = 10545 and  hkd = 85.5','')")

    con:query("insert into check_sql values(96,'delete from transaction_total_check where cny = 96 and jpy = 9600 and gbp = 67.2 and eur = 10656 and  hkd = 86.4','')")

    con:query("insert into check_sql values(97,'delete from transaction_total_check where cny = 97 and jpy = 9700 and gbp = 67.9 and eur = 10767 and  hkd = 87.3','')")

    con:query("insert into check_sql values(98,'delete from transaction_total_check where cny = 98 and jpy = 9800 and gbp = 68.6 and eur = 10878 and  hkd = 88.2','')")

    con:query("insert into check_sql values(99,'delete from transaction_total_check where cny = 99 and jpy = 9900 and gbp = 69.3 and eur = 10989 and  hkd = 89.1','')")

    con:query("insert into check_sql values(100,'delete from transaction_total_check where cny = 100 and jpy = 10000 and gbp = 70.0 and eur = 11100 and  hkd = 90.0','')")

    con:query("insert into check_sql values(101,'delete from transaction_total_check where cny = 101 and jpy = 10100 and gbp = 70.7 and eur = 11211 and  hkd = 90.9','')")

    con:query("insert into check_sql values(102,'delete from transaction_total_check where cny = 102 and jpy = 10200 and gbp = 71.4 and eur = 11322 and  hkd = 91.8','')")

    con:query("insert into check_sql values(103,'delete from transaction_total_check where cny = 103 and jpy = 10300 and gbp = 72.1 and eur = 11433 and  hkd = 92.7','')")

    con:query("insert into check_sql values(104,'delete from transaction_total_check where cny = 104 and jpy = 10400 and gbp = 72.8 and eur = 11544 and  hkd = 93.6','')")

    con:query("insert into check_sql values(105,'delete from transaction_total_check where cny = 105 and jpy = 10500 and gbp = 73.5 and eur = 11655 and  hkd = 94.5','')")

    con:query("insert into check_sql values(106,'delete from transaction_total_check where cny = 106 and jpy = 10600 and gbp = 74.2 and eur = 11766 and  hkd = 95.4','')")

    con:query("insert into check_sql values(107,'delete from transaction_total_check where cny = 107 and jpy = 10700 and gbp = 74.9 and eur = 11877 and  hkd = 96.3','')")

    con:query("insert into check_sql values(108,'delete from transaction_total_check where cny = 108 and jpy = 10800 and gbp = 75.6 and eur = 11988 and  hkd = 97.2','')")

    con:query("insert into check_sql values(109,'delete from transaction_total_check where cny = 109 and jpy = 10900 and gbp = 76.3 and eur = 12099 and  hkd = 98.1','')")

    con:query("insert into check_sql values(110,'delete from transaction_total_check where cny = 110 and jpy = 11000 and gbp = 77.0 and eur = 12210 and  hkd = 99.0','')")

    con:query("insert into check_sql values(111,'delete from transaction_total_check where cny = 111 and jpy = 11100 and gbp = 77.7 and eur = 12321 and  hkd = 99.9','')")

    con:query("insert into check_sql values(112,'delete from transaction_total_check where cny = 112 and jpy = 11200 and gbp = 78.4 and eur = 12432 and  hkd = 100.8','')")

    con:query("insert into check_sql values(113,'delete from transaction_total_check where cny = 113 and jpy = 11300 and gbp = 79.1 and eur = 12543 and  hkd = 101.7','')")

    con:query("insert into check_sql values(114,'delete from transaction_total_check where cny = 114 and jpy = 11400 and gbp = 79.8 and eur = 12654 and  hkd = 102.6','')")

    con:query("insert into check_sql values(115,'delete from transaction_total_check where cny = 115 and jpy = 11500 and gbp = 80.5 and eur = 12765 and  hkd = 103.5','')")

    con:query("insert into check_sql values(116,'delete from transaction_total_check where cny = 116 and jpy = 11600 and gbp = 81.2 and eur = 12876 and  hkd = 104.4','')")

    con:query("insert into check_sql values(117,'delete from transaction_total_check where cny = 117 and jpy = 11700 and gbp = 81.9 and eur = 12987 and  hkd = 105.3','')")

    con:query("insert into check_sql values(118,'delete from transaction_total_check where cny = 118 and jpy = 11800 and gbp = 82.6 and eur = 13098 and  hkd = 106.2','')")

    con:query("insert into check_sql values(119,'delete from transaction_total_check where cny = 119 and jpy = 11900 and gbp = 83.3 and eur = 13209 and  hkd = 107.1','')")

    con:query("insert into check_sql values(120,'delete from transaction_total_check where cny = 120 and jpy = 12000 and gbp = 84.0 and eur = 13320 and  hkd = 108.0','')")

    con:query("insert into check_sql values(121,'delete from transaction_total_check where cny = 121 and jpy = 12100 and gbp = 84.7 and eur = 13431 and  hkd = 108.9','')")

    con:query("insert into check_sql values(122,'delete from transaction_total_check where cny = 122 and jpy = 12200 and gbp = 85.4 and eur = 13542 and  hkd = 109.8','')")

    con:query("insert into check_sql values(123,'delete from transaction_total_check where cny = 123 and jpy = 12300 and gbp = 86.1 and eur = 13653 and  hkd = 110.7','')")

    con:query("insert into check_sql values(124,'delete from transaction_total_check where cny = 124 and jpy = 12400 and gbp = 86.8 and eur = 13764 and  hkd = 111.6','')")

    con:query("insert into check_sql values(125,'delete from transaction_total_check where cny = 125 and jpy = 12500 and gbp = 87.5 and eur = 13875 and  hkd = 112.5','')")

    con:query("insert into check_sql values(126,'delete from transaction_total_check where cny = 126 and jpy = 12600 and gbp = 88.2 and eur = 13986 and  hkd = 113.4','')")

    con:query("insert into check_sql values(127,'delete from transaction_total_check where cny = 127 and jpy = 12700 and gbp = 88.9 and eur = 14097 and  hkd = 114.3','')")

    con:query("insert into check_sql values(128,'delete from transaction_total_check where cny = 128 and jpy = 12800 and gbp = 89.6 and eur = 14208 and  hkd = 115.2','')")

    con:query("insert into check_sql values(129,'delete from transaction_total_check where cny = 129 and jpy = 12900 and gbp = 90.3 and eur = 14319 and  hkd = 116.1','')")

    con:query("insert into check_sql values(130,'delete from transaction_total_check where cny = 130 and jpy = 13000 and gbp = 91.0 and eur = 14430 and  hkd = 117.0','')")

    con:query("insert into check_sql values(131,'delete from transaction_total_check where cny = 131 and jpy = 13100 and gbp = 91.7 and eur = 14541 and  hkd = 117.9','')")

    con:query("insert into check_sql values(132,'delete from transaction_total_check where cny = 132 and jpy = 13200 and gbp = 92.4 and eur = 14652 and  hkd = 118.8','')")

    con:query("insert into check_sql values(133,'delete from transaction_total_check where cny = 133 and jpy = 13300 and gbp = 93.1 and eur = 14763 and  hkd = 119.7','')")

    con:query("insert into check_sql values(134,'delete from transaction_total_check where cny = 134 and jpy = 13400 and gbp = 93.8 and eur = 14874 and  hkd = 120.6','')")

    con:query("insert into check_sql values(135,'delete from transaction_total_check where cny = 135 and jpy = 13500 and gbp = 94.5 and eur = 14985 and  hkd = 121.5','')")

    con:query("insert into check_sql values(136,'delete from transaction_total_check where cny = 136 and jpy = 13600 and gbp = 95.2 and eur = 15096 and  hkd = 122.4','')")

    con:query("insert into check_sql values(137,'delete from transaction_total_check where cny = 137 and jpy = 13700 and gbp = 95.9 and eur = 15207 and  hkd = 123.3','')")

    con:query("insert into check_sql values(138,'delete from transaction_total_check where cny = 138 and jpy = 13800 and gbp = 96.6 and eur = 15318 and  hkd = 124.2','')")

    con:query("insert into check_sql values(139,'delete from transaction_total_check where cny = 139 and jpy = 13900 and gbp = 97.3 and eur = 15429 and  hkd = 125.1','')")

    con:query("insert into check_sql values(140,'delete from transaction_total_check where cny = 140 and jpy = 14000 and gbp = 98.0 and eur = 15540 and  hkd = 126.0','')")

    con:query("insert into check_sql values(141,'delete from transaction_total_check where cny = 141 and jpy = 14100 and gbp = 98.7 and eur = 15651 and  hkd = 126.9','')")

    con:query("insert into check_sql values(142,'delete from transaction_total_check where cny = 142 and jpy = 14200 and gbp = 99.4 and eur = 15762 and  hkd = 127.8','')")

    con:query("insert into check_sql values(143,'delete from transaction_total_check where cny = 143 and jpy = 14300 and gbp = 100.1 and eur = 15873 and  hkd = 128.7','')")

    con:query("insert into check_sql values(144,'delete from transaction_total_check where cny = 144 and jpy = 14400 and gbp = 100.8 and eur = 15984 and  hkd = 129.6','')")

    con:query("insert into check_sql values(145,'delete from transaction_total_check where cny = 145 and jpy = 14500 and gbp = 101.5 and eur = 16095 and  hkd = 130.5','')")

    con:query("insert into check_sql values(146,'delete from transaction_total_check where cny = 146 and jpy = 14600 and gbp = 102.2 and eur = 16206 and  hkd = 131.4','')")

    con:query("insert into check_sql values(147,'delete from transaction_total_check where cny = 147 and jpy = 14700 and gbp = 102.9 and eur = 16317 and  hkd = 132.3','')")

    con:query("insert into check_sql values(148,'delete from transaction_total_check where cny = 148 and jpy = 14800 and gbp = 103.6 and eur = 16428 and  hkd = 133.2','')")

    con:query("insert into check_sql values(149,'delete from transaction_total_check where cny = 149 and jpy = 14900 and gbp = 104.3 and eur = 16539 and  hkd = 134.1','')")

    con:query("insert into check_sql values(150,'delete from transaction_total_check where cny = 150 and jpy = 15000 and gbp = 105.0 and eur = 16650 and  hkd = 135.0','')")

    con:query("insert into check_sql values(151,'delete from transaction_total_check where cny = 151 and jpy = 15100 and gbp = 105.7 and eur = 16761 and  hkd = 135.9','')")

    con:query("insert into check_sql values(152,'delete from transaction_total_check where cny = 152 and jpy = 15200 and gbp = 106.4 and eur = 16872 and  hkd = 136.8','')")

    con:query("insert into check_sql values(153,'delete from transaction_total_check where cny = 153 and jpy = 15300 and gbp = 107.1 and eur = 16983 and  hkd = 137.7','')")

    con:query("insert into check_sql values(154,'delete from transaction_total_check where cny = 154 and jpy = 15400 and gbp = 107.8 and eur = 17094 and  hkd = 138.6','')")

    con:query("insert into check_sql values(155,'delete from transaction_total_check where cny = 155 and jpy = 15500 and gbp = 108.5 and eur = 17205 and  hkd = 139.5','')")

    con:query("insert into check_sql values(156,'delete from transaction_total_check where cny = 156 and jpy = 15600 and gbp = 109.2 and eur = 17316 and  hkd = 140.4','')")

    con:query("insert into check_sql values(157,'delete from transaction_total_check where cny = 157 and jpy = 15700 and gbp = 109.9 and eur = 17427 and  hkd = 141.3','')")

    con:query("insert into check_sql values(158,'delete from transaction_total_check where cny = 158 and jpy = 15800 and gbp = 110.6 and eur = 17538 and  hkd = 142.2','')")

    con:query("insert into check_sql values(159,'delete from transaction_total_check where cny = 159 and jpy = 15900 and gbp = 111.3 and eur = 17649 and  hkd = 143.1','')")

    con:query("insert into check_sql values(160,'delete from transaction_total_check where cny = 160 and jpy = 16000 and gbp = 112.0 and eur = 17760 and  hkd = 144.0','')")

    con:query("insert into check_sql values(161,'delete from transaction_total_check where cny = 161 and jpy = 16100 and gbp = 112.7 and eur = 17871 and  hkd = 144.9','')")

    con:query("insert into check_sql values(162,'delete from transaction_total_check where cny = 162 and jpy = 16200 and gbp = 113.4 and eur = 17982 and  hkd = 145.8','')")

    con:query("insert into check_sql values(163,'delete from transaction_total_check where cny = 163 and jpy = 16300 and gbp = 114.1 and eur = 18093 and  hkd = 146.7','')")

    con:query("insert into check_sql values(164,'delete from transaction_total_check where cny = 164 and jpy = 16400 and gbp = 114.8 and eur = 18204 and  hkd = 147.6','')")

    con:query("insert into check_sql values(165,'delete from transaction_total_check where cny = 165 and jpy = 16500 and gbp = 115.5 and eur = 18315 and  hkd = 148.5','')")

    con:query("insert into check_sql values(166,'delete from transaction_total_check where cny = 166 and jpy = 16600 and gbp = 116.2 and eur = 18426 and  hkd = 149.4','')")

    con:query("insert into check_sql values(167,'delete from transaction_total_check where cny = 167 and jpy = 16700 and gbp = 116.9 and eur = 18537 and  hkd = 150.3','')")

    con:query("insert into check_sql values(168,'delete from transaction_total_check where cny = 168 and jpy = 16800 and gbp = 117.6 and eur = 18648 and  hkd = 151.2','')")

    con:query("insert into check_sql values(169,'delete from transaction_total_check where cny = 169 and jpy = 16900 and gbp = 118.3 and eur = 18759 and  hkd = 152.1','')")

    con:query("insert into check_sql values(170,'delete from transaction_total_check where cny = 170 and jpy = 17000 and gbp = 119.0 and eur = 18870 and  hkd = 153.0','')")

    con:query("insert into check_sql values(171,'delete from transaction_total_check where cny = 171 and jpy = 17100 and gbp = 119.7 and eur = 18981 and  hkd = 153.9','')")

    con:query("insert into check_sql values(172,'delete from transaction_total_check where cny = 172 and jpy = 17200 and gbp = 120.4 and eur = 19092 and  hkd = 154.8','')")

    con:query("insert into check_sql values(173,'delete from transaction_total_check where cny = 173 and jpy = 17300 and gbp = 121.1 and eur = 19203 and  hkd = 155.7','')")

    con:query("insert into check_sql values(174,'delete from transaction_total_check where cny = 174 and jpy = 17400 and gbp = 121.8 and eur = 19314 and  hkd = 156.6','')")

    con:query("insert into check_sql values(175,'delete from transaction_total_check where cny = 175 and jpy = 17500 and gbp = 122.5 and eur = 19425 and  hkd = 157.5','')")

    con:query("insert into check_sql values(176,'delete from transaction_total_check where cny = 176 and jpy = 17600 and gbp = 123.2 and eur = 19536 and  hkd = 158.4','')")

    con:query("insert into check_sql values(177,'delete from transaction_total_check where cny = 177 and jpy = 17700 and gbp = 123.9 and eur = 19647 and  hkd = 159.3','')")

    con:query("insert into check_sql values(178,'delete from transaction_total_check where cny = 178 and jpy = 17800 and gbp = 124.6 and eur = 19758 and  hkd = 160.2','')")

    con:query("insert into check_sql values(179,'delete from transaction_total_check where cny = 179 and jpy = 17900 and gbp = 125.3 and eur = 19869 and  hkd = 161.1','')")

    con:query("insert into check_sql values(180,'delete from transaction_total_check where cny = 180 and jpy = 18000 and gbp = 126.0 and eur = 19980 and  hkd = 162.0','')")

    con:query("insert into check_sql values(181,'delete from transaction_total_check where cny = 181 and jpy = 18100 and gbp = 126.7 and eur = 20091 and  hkd = 162.9','')")

    con:query("insert into check_sql values(182,'delete from transaction_total_check where cny = 182 and jpy = 18200 and gbp = 127.4 and eur = 20202 and  hkd = 163.8','')")

    con:query("insert into check_sql values(183,'delete from transaction_total_check where cny = 183 and jpy = 18300 and gbp = 128.1 and eur = 20313 and  hkd = 164.7','')")

    con:query("insert into check_sql values(184,'delete from transaction_total_check where cny = 184 and jpy = 18400 and gbp = 128.8 and eur = 20424 and  hkd = 165.6','')")

    con:query("insert into check_sql values(185,'delete from transaction_total_check where cny = 185 and jpy = 18500 and gbp = 129.5 and eur = 20535 and  hkd = 166.5','')")

    con:query("insert into check_sql values(186,'delete from transaction_total_check where cny = 186 and jpy = 18600 and gbp = 130.2 and eur = 20646 and  hkd = 167.4','')")

    con:query("insert into check_sql values(187,'delete from transaction_total_check where cny = 187 and jpy = 18700 and gbp = 130.9 and eur = 20757 and  hkd = 168.3','')")

    con:query("insert into check_sql values(188,'delete from transaction_total_check where cny = 188 and jpy = 18800 and gbp = 131.6 and eur = 20868 and  hkd = 169.2','')")

    con:query("insert into check_sql values(189,'delete from transaction_total_check where cny = 189 and jpy = 18900 and gbp = 132.3 and eur = 20979 and  hkd = 170.1','')")

    con:query("insert into check_sql values(190,'delete from transaction_total_check where cny = 190 and jpy = 19000 and gbp = 133.0 and eur = 21090 and  hkd = 171.0','')")

    con:query("insert into check_sql values(191,'delete from transaction_total_check where cny = 191 and jpy = 19100 and gbp = 133.7 and eur = 21201 and  hkd = 171.9','')")

    con:query("insert into check_sql values(192,'delete from transaction_total_check where cny = 192 and jpy = 19200 and gbp = 134.4 and eur = 21312 and  hkd = 172.8','')")

    con:query("insert into check_sql values(193,'delete from transaction_total_check where cny = 193 and jpy = 19300 and gbp = 135.1 and eur = 21423 and  hkd = 173.7','')")

    con:query("insert into check_sql values(194,'delete from transaction_total_check where cny = 194 and jpy = 19400 and gbp = 135.8 and eur = 21534 and  hkd = 174.6','')")

    con:query("insert into check_sql values(195,'delete from transaction_total_check where cny = 195 and jpy = 19500 and gbp = 136.5 and eur = 21645 and  hkd = 175.5','')")

    con:query("insert into check_sql values(196,'delete from transaction_total_check where cny = 196 and jpy = 19600 and gbp = 137.2 and eur = 21756 and  hkd = 176.4','')")

    con:query("insert into check_sql values(197,'delete from transaction_total_check where cny = 197 and jpy = 19700 and gbp = 137.9 and eur = 21867 and  hkd = 177.3','')")

    con:query("insert into check_sql values(198,'delete from transaction_total_check where cny = 198 and jpy = 19800 and gbp = 138.6 and eur = 21978 and  hkd = 178.2','')")

    con:query("insert into check_sql values(199,'delete from transaction_total_check where cny = 199 and jpy = 19900 and gbp = 139.3 and eur = 22089 and  hkd = 179.1','')")

    con:query("insert into check_sql values(200,'delete from transaction_total_check where cny = 200 and jpy = 20000 and gbp = 140.0 and eur = 22200 and  hkd = 180.0','')")

    con:query("insert into check_sql values(201,'delete from transaction_total_check where cny = 201 and jpy = 20100 and gbp = 140.7 and eur = 22311 and  hkd = 180.9','')")

    con:query("insert into check_sql values(202,'delete from transaction_total_check where cny = 202 and jpy = 20200 and gbp = 141.4 and eur = 22422 and  hkd = 181.8','')")

    con:query("insert into check_sql values(203,'delete from transaction_total_check where cny = 203 and jpy = 20300 and gbp = 142.1 and eur = 22533 and  hkd = 182.7','')")

    con:query("insert into check_sql values(204,'delete from transaction_total_check where cny = 204 and jpy = 20400 and gbp = 142.8 and eur = 22644 and  hkd = 183.6','')")

    con:query("insert into check_sql values(205,'delete from transaction_total_check where cny = 205 and jpy = 20500 and gbp = 143.5 and eur = 22755 and  hkd = 184.5','')")

    con:query("insert into check_sql values(206,'delete from transaction_total_check where cny = 206 and jpy = 20600 and gbp = 144.2 and eur = 22866 and  hkd = 185.4','')")

    con:query("insert into check_sql values(207,'delete from transaction_total_check where cny = 207 and jpy = 20700 and gbp = 144.9 and eur = 22977 and  hkd = 186.3','')")

    con:query("insert into check_sql values(208,'delete from transaction_total_check where cny = 208 and jpy = 20800 and gbp = 145.6 and eur = 23088 and  hkd = 187.2','')")

    con:query("insert into check_sql values(209,'delete from transaction_total_check where cny = 209 and jpy = 20900 and gbp = 146.3 and eur = 23199 and  hkd = 188.1','')")

    con:query("insert into check_sql values(210,'delete from transaction_total_check where cny = 210 and jpy = 21000 and gbp = 147.0 and eur = 23310 and  hkd = 189.0','')")

    con:query("insert into check_sql values(211,'delete from transaction_total_check where cny = 211 and jpy = 21100 and gbp = 147.7 and eur = 23421 and  hkd = 189.9','')")

    con:query("insert into check_sql values(212,'delete from transaction_total_check where cny = 212 and jpy = 21200 and gbp = 148.4 and eur = 23532 and  hkd = 190.8','')")

    con:query("insert into check_sql values(213,'delete from transaction_total_check where cny = 213 and jpy = 21300 and gbp = 149.1 and eur = 23643 and  hkd = 191.7','')")

    con:query("insert into check_sql values(214,'delete from transaction_total_check where cny = 214 and jpy = 21400 and gbp = 149.8 and eur = 23754 and  hkd = 192.6','')")

    con:query("insert into check_sql values(215,'delete from transaction_total_check where cny = 215 and jpy = 21500 and gbp = 150.5 and eur = 23865 and  hkd = 193.5','')")

    con:query("insert into check_sql values(216,'delete from transaction_total_check where cny = 216 and jpy = 21600 and gbp = 151.2 and eur = 23976 and  hkd = 194.4','')")

    con:query("insert into check_sql values(217,'delete from transaction_total_check where cny = 217 and jpy = 21700 and gbp = 151.9 and eur = 24087 and  hkd = 195.3','')")

    con:query("insert into check_sql values(218,'delete from transaction_total_check where cny = 218 and jpy = 21800 and gbp = 152.6 and eur = 24198 and  hkd = 196.2','')")

    con:query("insert into check_sql values(219,'delete from transaction_total_check where cny = 219 and jpy = 21900 and gbp = 153.3 and eur = 24309 and  hkd = 197.1','')")

    con:query("insert into check_sql values(220,'delete from transaction_total_check where cny = 220 and jpy = 22000 and gbp = 154.0 and eur = 24420 and  hkd = 198.0','')")

    con:query("insert into check_sql values(221,'delete from transaction_total_check where cny = 221 and jpy = 22100 and gbp = 154.7 and eur = 24531 and  hkd = 198.9','')")

    con:query("insert into check_sql values(222,'delete from transaction_total_check where cny = 222 and jpy = 22200 and gbp = 155.4 and eur = 24642 and  hkd = 199.8','')")

    con:query("insert into check_sql values(223,'delete from transaction_total_check where cny = 223 and jpy = 22300 and gbp = 156.1 and eur = 24753 and  hkd = 200.7','')")

    con:query("insert into check_sql values(224,'delete from transaction_total_check where cny = 224 and jpy = 22400 and gbp = 156.8 and eur = 24864 and  hkd = 201.6','')")

    con:query("insert into check_sql values(225,'delete from transaction_total_check where cny = 225 and jpy = 22500 and gbp = 157.5 and eur = 24975 and  hkd = 202.5','')")

    con:query("insert into check_sql values(226,'delete from transaction_total_check where cny = 226 and jpy = 22600 and gbp = 158.2 and eur = 25086 and  hkd = 203.4','')")

    con:query("insert into check_sql values(227,'delete from transaction_total_check where cny = 227 and jpy = 22700 and gbp = 158.9 and eur = 25197 and  hkd = 204.3','')")

    con:query("insert into check_sql values(228,'delete from transaction_total_check where cny = 228 and jpy = 22800 and gbp = 159.6 and eur = 25308 and  hkd = 205.2','')")

    con:query("insert into check_sql values(229,'delete from transaction_total_check where cny = 229 and jpy = 22900 and gbp = 160.3 and eur = 25419 and  hkd = 206.1','')")

    con:query("insert into check_sql values(230,'delete from transaction_total_check where cny = 230 and jpy = 23000 and gbp = 161.0 and eur = 25530 and  hkd = 207.0','')")

    con:query("insert into check_sql values(231,'delete from transaction_total_check where cny = 231 and jpy = 23100 and gbp = 161.7 and eur = 25641 and  hkd = 207.9','')")

    con:query("insert into check_sql values(232,'delete from transaction_total_check where cny = 232 and jpy = 23200 and gbp = 162.4 and eur = 25752 and  hkd = 208.8','')")

    con:query("insert into check_sql values(233,'delete from transaction_total_check where cny = 233 and jpy = 23300 and gbp = 163.1 and eur = 25863 and  hkd = 209.7','')")

    con:query("insert into check_sql values(234,'delete from transaction_total_check where cny = 234 and jpy = 23400 and gbp = 163.8 and eur = 25974 and  hkd = 210.6','')")

    con:query("insert into check_sql values(235,'delete from transaction_total_check where cny = 235 and jpy = 23500 and gbp = 164.5 and eur = 26085 and  hkd = 211.5','')")

    con:query("insert into check_sql values(236,'delete from transaction_total_check where cny = 236 and jpy = 23600 and gbp = 165.2 and eur = 26196 and  hkd = 212.4','')")

    con:query("insert into check_sql values(237,'delete from transaction_total_check where cny = 237 and jpy = 23700 and gbp = 165.9 and eur = 26307 and  hkd = 213.3','')")

    con:query("insert into check_sql values(238,'delete from transaction_total_check where cny = 238 and jpy = 23800 and gbp = 166.6 and eur = 26418 and  hkd = 214.2','')")

    con:query("insert into check_sql values(239,'delete from transaction_total_check where cny = 239 and jpy = 23900 and gbp = 167.3 and eur = 26529 and  hkd = 215.1','')")

    con:query("insert into check_sql values(240,'delete from transaction_total_check where cny = 240 and jpy = 24000 and gbp = 168.0 and eur = 26640 and  hkd = 216.0','')")

    con:query("insert into check_sql values(241,'delete from transaction_total_check where cny = 241 and jpy = 24100 and gbp = 168.7 and eur = 26751 and  hkd = 216.9','')")

    con:query("insert into check_sql values(242,'delete from transaction_total_check where cny = 242 and jpy = 24200 and gbp = 169.4 and eur = 26862 and  hkd = 217.8','')")

    con:query("insert into check_sql values(243,'delete from transaction_total_check where cny = 243 and jpy = 24300 and gbp = 170.1 and eur = 26973 and  hkd = 218.7','')")

    con:query("insert into check_sql values(244,'delete from transaction_total_check where cny = 244 and jpy = 24400 and gbp = 170.8 and eur = 27084 and  hkd = 219.6','')")

    con:query("insert into check_sql values(245,'delete from transaction_total_check where cny = 245 and jpy = 24500 and gbp = 171.5 and eur = 27195 and  hkd = 220.5','')")

    con:query("insert into check_sql values(246,'delete from transaction_total_check where cny = 246 and jpy = 24600 and gbp = 172.2 and eur = 27306 and  hkd = 221.4','')")

    con:query("insert into check_sql values(247,'delete from transaction_total_check where cny = 247 and jpy = 24700 and gbp = 172.9 and eur = 27417 and  hkd = 222.3','')")

    con:query("insert into check_sql values(248,'delete from transaction_total_check where cny = 248 and jpy = 24800 and gbp = 173.6 and eur = 27528 and  hkd = 223.2','')")

    con:query("insert into check_sql values(249,'delete from transaction_total_check where cny = 249 and jpy = 24900 and gbp = 174.3 and eur = 27639 and  hkd = 224.1','')")

    con:query("insert into check_sql values(250,'delete from transaction_total_check where cny = 250 and jpy = 25000 and gbp = 175.0 and eur = 27750 and  hkd = 225.0','')")

    con:query("insert into check_sql values(251,'delete from transaction_total_check where cny = 251 and jpy = 25100 and gbp = 175.7 and eur = 27861 and  hkd = 225.9','')")

    con:query("insert into check_sql values(252,'delete from transaction_total_check where cny = 252 and jpy = 25200 and gbp = 176.4 and eur = 27972 and  hkd = 226.8','')")

    con:query("insert into check_sql values(253,'delete from transaction_total_check where cny = 253 and jpy = 25300 and gbp = 177.1 and eur = 28083 and  hkd = 227.7','')")

    con:query("insert into check_sql values(254,'delete from transaction_total_check where cny = 254 and jpy = 25400 and gbp = 177.8 and eur = 28194 and  hkd = 228.6','')")

    con:query("insert into check_sql values(255,'delete from transaction_total_check where cny = 255 and jpy = 25500 and gbp = 178.5 and eur = 28305 and  hkd = 229.5','')")

    con:query("insert into check_sql values(256,'delete from transaction_total_check where cny = 256 and jpy = 25600 and gbp = 179.2 and eur = 28416 and  hkd = 230.4','')")

    con:query("insert into check_sql values(257,'delete from transaction_total_check where cny = 257 and jpy = 25700 and gbp = 179.9 and eur = 28527 and  hkd = 231.3','')")

    con:query("insert into check_sql values(258,'delete from transaction_total_check where cny = 258 and jpy = 25800 and gbp = 180.6 and eur = 28638 and  hkd = 232.2','')")

    con:query("insert into check_sql values(259,'delete from transaction_total_check where cny = 259 and jpy = 25900 and gbp = 181.3 and eur = 28749 and  hkd = 233.1','')")

    con:query("insert into check_sql values(260,'delete from transaction_total_check where cny = 260 and jpy = 26000 and gbp = 182.0 and eur = 28860 and  hkd = 234.0','')")

    con:query("insert into check_sql values(261,'delete from transaction_total_check where cny = 261 and jpy = 26100 and gbp = 182.7 and eur = 28971 and  hkd = 234.9','')")

    con:query("insert into check_sql values(262,'delete from transaction_total_check where cny = 262 and jpy = 26200 and gbp = 183.4 and eur = 29082 and  hkd = 235.8','')")

    con:query("insert into check_sql values(263,'delete from transaction_total_check where cny = 263 and jpy = 26300 and gbp = 184.1 and eur = 29193 and  hkd = 236.7','')")

    con:query("insert into check_sql values(264,'delete from transaction_total_check where cny = 264 and jpy = 26400 and gbp = 184.8 and eur = 29304 and  hkd = 237.6','')")

    con:query("insert into check_sql values(265,'delete from transaction_total_check where cny = 265 and jpy = 26500 and gbp = 185.5 and eur = 29415 and  hkd = 238.5','')")

    con:query("insert into check_sql values(266,'delete from transaction_total_check where cny = 266 and jpy = 26600 and gbp = 186.2 and eur = 29526 and  hkd = 239.4','')")

    con:query("insert into check_sql values(267,'delete from transaction_total_check where cny = 267 and jpy = 26700 and gbp = 186.9 and eur = 29637 and  hkd = 240.3','')")

    con:query("insert into check_sql values(268,'delete from transaction_total_check where cny = 268 and jpy = 26800 and gbp = 187.6 and eur = 29748 and  hkd = 241.2','')")

    con:query("insert into check_sql values(269,'delete from transaction_total_check where cny = 269 and jpy = 26900 and gbp = 188.3 and eur = 29859 and  hkd = 242.1','')")

    con:query("insert into check_sql values(270,'delete from transaction_total_check where cny = 270 and jpy = 27000 and gbp = 189.0 and eur = 29970 and  hkd = 243.0','')")

    con:query("insert into check_sql values(271,'delete from transaction_total_check where cny = 271 and jpy = 27100 and gbp = 189.7 and eur = 30081 and  hkd = 243.9','')")

    con:query("insert into check_sql values(272,'delete from transaction_total_check where cny = 272 and jpy = 27200 and gbp = 190.4 and eur = 30192 and  hkd = 244.8','')")

    con:query("insert into check_sql values(273,'delete from transaction_total_check where cny = 273 and jpy = 27300 and gbp = 191.1 and eur = 30303 and  hkd = 245.7','')")

    con:query("insert into check_sql values(274,'delete from transaction_total_check where cny = 274 and jpy = 27400 and gbp = 191.8 and eur = 30414 and  hkd = 246.6','')")

    con:query("insert into check_sql values(275,'delete from transaction_total_check where cny = 275 and jpy = 27500 and gbp = 192.5 and eur = 30525 and  hkd = 247.5','')")

    con:query("insert into check_sql values(276,'delete from transaction_total_check where cny = 276 and jpy = 27600 and gbp = 193.2 and eur = 30636 and  hkd = 248.4','')")

    con:query("insert into check_sql values(277,'delete from transaction_total_check where cny = 277 and jpy = 27700 and gbp = 193.9 and eur = 30747 and  hkd = 249.3','')")

    con:query("insert into check_sql values(278,'delete from transaction_total_check where cny = 278 and jpy = 27800 and gbp = 194.6 and eur = 30858 and  hkd = 250.2','')")

    con:query("insert into check_sql values(279,'delete from transaction_total_check where cny = 279 and jpy = 27900 and gbp = 195.3 and eur = 30969 and  hkd = 251.1','')")

    con:query("insert into check_sql values(280,'delete from transaction_total_check where cny = 280 and jpy = 28000 and gbp = 196.0 and eur = 31080 and  hkd = 252.0','')")

    con:query("insert into check_sql values(281,'delete from transaction_total_check where cny = 281 and jpy = 28100 and gbp = 196.7 and eur = 31191 and  hkd = 252.9','')")

    con:query("insert into check_sql values(282,'delete from transaction_total_check where cny = 282 and jpy = 28200 and gbp = 197.4 and eur = 31302 and  hkd = 253.8','')")

    con:query("insert into check_sql values(283,'delete from transaction_total_check where cny = 283 and jpy = 28300 and gbp = 198.1 and eur = 31413 and  hkd = 254.7','')")

    con:query("insert into check_sql values(284,'delete from transaction_total_check where cny = 284 and jpy = 28400 and gbp = 198.8 and eur = 31524 and  hkd = 255.6','')")

    con:query("insert into check_sql values(285,'delete from transaction_total_check where cny = 285 and jpy = 28500 and gbp = 199.5 and eur = 31635 and  hkd = 256.5','')")

    con:query("insert into check_sql values(286,'delete from transaction_total_check where cny = 286 and jpy = 28600 and gbp = 200.2 and eur = 31746 and  hkd = 257.4','')")

    con:query("insert into check_sql values(287,'delete from transaction_total_check where cny = 287 and jpy = 28700 and gbp = 200.9 and eur = 31857 and  hkd = 258.3','')")

    con:query("insert into check_sql values(288,'delete from transaction_total_check where cny = 288 and jpy = 28800 and gbp = 201.6 and eur = 31968 and  hkd = 259.2','')")

    con:query("insert into check_sql values(289,'delete from transaction_total_check where cny = 289 and jpy = 28900 and gbp = 202.3 and eur = 32079 and  hkd = 260.1','')")

    con:query("insert into check_sql values(290,'delete from transaction_total_check where cny = 290 and jpy = 29000 and gbp = 203.0 and eur = 32190 and  hkd = 261.0','')")

    con:query("insert into check_sql values(291,'delete from transaction_total_check where cny = 291 and jpy = 29100 and gbp = 203.7 and eur = 32301 and  hkd = 261.9','')")

    con:query("insert into check_sql values(292,'delete from transaction_total_check where cny = 292 and jpy = 29200 and gbp = 204.4 and eur = 32412 and  hkd = 262.8','')")

    con:query("insert into check_sql values(293,'delete from transaction_total_check where cny = 293 and jpy = 29300 and gbp = 205.1 and eur = 32523 and  hkd = 263.7','')")

    con:query("insert into check_sql values(294,'delete from transaction_total_check where cny = 294 and jpy = 29400 and gbp = 205.8 and eur = 32634 and  hkd = 264.6','')")

    con:query("insert into check_sql values(295,'delete from transaction_total_check where cny = 295 and jpy = 29500 and gbp = 206.5 and eur = 32745 and  hkd = 265.5','')")

    con:query("insert into check_sql values(296,'delete from transaction_total_check where cny = 296 and jpy = 29600 and gbp = 207.2 and eur = 32856 and  hkd = 266.4','')")

    con:query("insert into check_sql values(297,'delete from transaction_total_check where cny = 297 and jpy = 29700 and gbp = 207.9 and eur = 32967 and  hkd = 267.3','')")

    con:query("insert into check_sql values(298,'delete from transaction_total_check where cny = 298 and jpy = 29800 and gbp = 208.6 and eur = 33078 and  hkd = 268.2','')")

    con:query("insert into check_sql values(299,'delete from transaction_total_check where cny = 299 and jpy = 29900 and gbp = 209.3 and eur = 33189 and  hkd = 269.1','')")

    con:query("insert into check_sql values(300,'delete from transaction_total_check where cny = 300 and jpy = 30000 and gbp = 210.0 and eur = 33300 and  hkd = 270.0','')")

    con:query("insert into check_sql values(301,'delete from transaction_total_check where cny = 301 and jpy = 30100 and gbp = 210.7 and eur = 33411 and  hkd = 270.9','')")

    con:query("insert into check_sql values(302,'delete from transaction_total_check where cny = 302 and jpy = 30200 and gbp = 211.4 and eur = 33522 and  hkd = 271.8','')")

    con:query("insert into check_sql values(303,'delete from transaction_total_check where cny = 303 and jpy = 30300 and gbp = 212.1 and eur = 33633 and  hkd = 272.7','')")

    con:query("insert into check_sql values(304,'delete from transaction_total_check where cny = 304 and jpy = 30400 and gbp = 212.8 and eur = 33744 and  hkd = 273.6','')")

    con:query("insert into check_sql values(305,'delete from transaction_total_check where cny = 305 and jpy = 30500 and gbp = 213.5 and eur = 33855 and  hkd = 274.5','')")

    con:query("insert into check_sql values(306,'delete from transaction_total_check where cny = 306 and jpy = 30600 and gbp = 214.2 and eur = 33966 and  hkd = 275.4','')")

    con:query("insert into check_sql values(307,'delete from transaction_total_check where cny = 307 and jpy = 30700 and gbp = 214.9 and eur = 34077 and  hkd = 276.3','')")

    con:query("insert into check_sql values(308,'delete from transaction_total_check where cny = 308 and jpy = 30800 and gbp = 215.6 and eur = 34188 and  hkd = 277.2','')")

    con:query("insert into check_sql values(309,'delete from transaction_total_check where cny = 309 and jpy = 30900 and gbp = 216.3 and eur = 34299 and  hkd = 278.1','')")

    con:query("insert into check_sql values(310,'delete from transaction_total_check where cny = 310 and jpy = 31000 and gbp = 217.0 and eur = 34410 and  hkd = 279.0','')")

    con:query("insert into check_sql values(311,'delete from transaction_total_check where cny = 311 and jpy = 31100 and gbp = 217.7 and eur = 34521 and  hkd = 279.9','')")

    con:query("insert into check_sql values(312,'delete from transaction_total_check where cny = 312 and jpy = 31200 and gbp = 218.4 and eur = 34632 and  hkd = 280.8','')")

    con:query("insert into check_sql values(313,'delete from transaction_total_check where cny = 313 and jpy = 31300 and gbp = 219.1 and eur = 34743 and  hkd = 281.7','')")

    con:query("insert into check_sql values(314,'delete from transaction_total_check where cny = 314 and jpy = 31400 and gbp = 219.8 and eur = 34854 and  hkd = 282.6','')")

    con:query("insert into check_sql values(315,'delete from transaction_total_check where cny = 315 and jpy = 31500 and gbp = 220.5 and eur = 34965 and  hkd = 283.5','')")

    con:query("insert into check_sql values(316,'delete from transaction_total_check where cny = 316 and jpy = 31600 and gbp = 221.2 and eur = 35076 and  hkd = 284.4','')")

    con:query("insert into check_sql values(317,'delete from transaction_total_check where cny = 317 and jpy = 31700 and gbp = 221.9 and eur = 35187 and  hkd = 285.3','')")

    con:query("insert into check_sql values(318,'delete from transaction_total_check where cny = 318 and jpy = 31800 and gbp = 222.6 and eur = 35298 and  hkd = 286.2','')")

    con:query("insert into check_sql values(319,'delete from transaction_total_check where cny = 319 and jpy = 31900 and gbp = 223.3 and eur = 35409 and  hkd = 287.1','')")

    con:query("insert into check_sql values(320,'delete from transaction_total_check where cny = 320 and jpy = 32000 and gbp = 224.0 and eur = 35520 and  hkd = 288.0','')")

    con:query("insert into check_sql values(321,'delete from transaction_total_check where cny = 321 and jpy = 32100 and gbp = 224.7 and eur = 35631 and  hkd = 288.9','')")

    con:query("insert into check_sql values(322,'delete from transaction_total_check where cny = 322 and jpy = 32200 and gbp = 225.4 and eur = 35742 and  hkd = 289.8','')")

    con:query("insert into check_sql values(323,'delete from transaction_total_check where cny = 323 and jpy = 32300 and gbp = 226.1 and eur = 35853 and  hkd = 290.7','')")

    con:query("insert into check_sql values(324,'delete from transaction_total_check where cny = 324 and jpy = 32400 and gbp = 226.8 and eur = 35964 and  hkd = 291.6','')")

    con:query("insert into check_sql values(325,'delete from transaction_total_check where cny = 325 and jpy = 32500 and gbp = 227.5 and eur = 36075 and  hkd = 292.5','')")

    con:query("insert into check_sql values(326,'delete from transaction_total_check where cny = 326 and jpy = 32600 and gbp = 228.2 and eur = 36186 and  hkd = 293.4','')")

    con:query("insert into check_sql values(327,'delete from transaction_total_check where cny = 327 and jpy = 32700 and gbp = 228.9 and eur = 36297 and  hkd = 294.3','')")

    con:query("insert into check_sql values(328,'delete from transaction_total_check where cny = 328 and jpy = 32800 and gbp = 229.6 and eur = 36408 and  hkd = 295.2','')")

    con:query("insert into check_sql values(329,'delete from transaction_total_check where cny = 329 and jpy = 32900 and gbp = 230.3 and eur = 36519 and  hkd = 296.1','')")

    con:query("insert into check_sql values(330,'delete from transaction_total_check where cny = 330 and jpy = 33000 and gbp = 231.0 and eur = 36630 and  hkd = 297.0','')")

    con:query("insert into check_sql values(331,'delete from transaction_total_check where cny = 331 and jpy = 33100 and gbp = 231.7 and eur = 36741 and  hkd = 297.9','')")

    con:query("insert into check_sql values(332,'delete from transaction_total_check where cny = 332 and jpy = 33200 and gbp = 232.4 and eur = 36852 and  hkd = 298.8','')")

    con:query("insert into check_sql values(333,'delete from transaction_total_check where cny = 333 and jpy = 33300 and gbp = 233.1 and eur = 36963 and  hkd = 299.7','')")

    con:query("insert into check_sql values(334,'delete from transaction_total_check where cny = 334 and jpy = 33400 and gbp = 233.8 and eur = 37074 and  hkd = 300.6','')")

    con:query("insert into check_sql values(335,'delete from transaction_total_check where cny = 335 and jpy = 33500 and gbp = 234.5 and eur = 37185 and  hkd = 301.5','')")

    con:query("insert into check_sql values(336,'delete from transaction_total_check where cny = 336 and jpy = 33600 and gbp = 235.2 and eur = 37296 and  hkd = 302.4','')")

    con:query("insert into check_sql values(337,'delete from transaction_total_check where cny = 337 and jpy = 33700 and gbp = 235.9 and eur = 37407 and  hkd = 303.3','')")

    con:query("insert into check_sql values(338,'delete from transaction_total_check where cny = 338 and jpy = 33800 and gbp = 236.6 and eur = 37518 and  hkd = 304.2','')")

    con:query("insert into check_sql values(339,'delete from transaction_total_check where cny = 339 and jpy = 33900 and gbp = 237.3 and eur = 37629 and  hkd = 305.1','')")

    con:query("insert into check_sql values(340,'delete from transaction_total_check where cny = 340 and jpy = 34000 and gbp = 238.0 and eur = 37740 and  hkd = 306.0','')")

    con:query("insert into check_sql values(341,'delete from transaction_total_check where cny = 341 and jpy = 34100 and gbp = 238.7 and eur = 37851 and  hkd = 306.9','')")

    con:query("insert into check_sql values(342,'delete from transaction_total_check where cny = 342 and jpy = 34200 and gbp = 239.4 and eur = 37962 and  hkd = 307.8','')")

    con:query("insert into check_sql values(343,'delete from transaction_total_check where cny = 343 and jpy = 34300 and gbp = 240.1 and eur = 38073 and  hkd = 308.7','')")

    con:query("insert into check_sql values(344,'delete from transaction_total_check where cny = 344 and jpy = 34400 and gbp = 240.8 and eur = 38184 and  hkd = 309.6','')")

    con:query("insert into check_sql values(345,'delete from transaction_total_check where cny = 345 and jpy = 34500 and gbp = 241.5 and eur = 38295 and  hkd = 310.5','')")

    con:query("insert into check_sql values(346,'delete from transaction_total_check where cny = 346 and jpy = 34600 and gbp = 242.2 and eur = 38406 and  hkd = 311.4','')")

    con:query("insert into check_sql values(347,'delete from transaction_total_check where cny = 347 and jpy = 34700 and gbp = 242.9 and eur = 38517 and  hkd = 312.3','')")

    con:query("insert into check_sql values(348,'delete from transaction_total_check where cny = 348 and jpy = 34800 and gbp = 243.6 and eur = 38628 and  hkd = 313.2','')")

    con:query("insert into check_sql values(349,'delete from transaction_total_check where cny = 349 and jpy = 34900 and gbp = 244.3 and eur = 38739 and  hkd = 314.1','')")

    con:query("insert into check_sql values(350,'delete from transaction_total_check where cny = 350 and jpy = 35000 and gbp = 245.0 and eur = 38850 and  hkd = 315.0','')")

    con:query("insert into check_sql values(351,'delete from transaction_total_check where cny = 351 and jpy = 35100 and gbp = 245.7 and eur = 38961 and  hkd = 315.9','')")

    con:query("insert into check_sql values(352,'delete from transaction_total_check where cny = 352 and jpy = 35200 and gbp = 246.4 and eur = 39072 and  hkd = 316.8','')")

    con:query("insert into check_sql values(353,'delete from transaction_total_check where cny = 353 and jpy = 35300 and gbp = 247.1 and eur = 39183 and  hkd = 317.7','')")

    con:query("insert into check_sql values(354,'delete from transaction_total_check where cny = 354 and jpy = 35400 and gbp = 247.8 and eur = 39294 and  hkd = 318.6','')")

    con:query("insert into check_sql values(355,'delete from transaction_total_check where cny = 355 and jpy = 35500 and gbp = 248.5 and eur = 39405 and  hkd = 319.5','')")

    con:query("insert into check_sql values(356,'delete from transaction_total_check where cny = 356 and jpy = 35600 and gbp = 249.2 and eur = 39516 and  hkd = 320.4','')")

    con:query("insert into check_sql values(357,'delete from transaction_total_check where cny = 357 and jpy = 35700 and gbp = 249.9 and eur = 39627 and  hkd = 321.3','')")

    con:query("insert into check_sql values(358,'delete from transaction_total_check where cny = 358 and jpy = 35800 and gbp = 250.6 and eur = 39738 and  hkd = 322.2','')")

    con:query("insert into check_sql values(359,'delete from transaction_total_check where cny = 359 and jpy = 35900 and gbp = 251.3 and eur = 39849 and  hkd = 323.1','')")

    con:query("insert into check_sql values(360,'delete from transaction_total_check where cny = 360 and jpy = 36000 and gbp = 252.0 and eur = 39960 and  hkd = 324.0','')")

    con:query("insert into check_sql values(361,'delete from transaction_total_check where cny = 361 and jpy = 36100 and gbp = 252.7 and eur = 40071 and  hkd = 324.9','')")

    con:query("insert into check_sql values(362,'delete from transaction_total_check where cny = 362 and jpy = 36200 and gbp = 253.4 and eur = 40182 and  hkd = 325.8','')")

    con:query("insert into check_sql values(363,'delete from transaction_total_check where cny = 363 and jpy = 36300 and gbp = 254.1 and eur = 40293 and  hkd = 326.7','')")

    con:query("insert into check_sql values(364,'delete from transaction_total_check where cny = 364 and jpy = 36400 and gbp = 254.8 and eur = 40404 and  hkd = 327.6','')")

    con:query("insert into check_sql values(365,'delete from transaction_total_check where cny = 365 and jpy = 36500 and gbp = 255.5 and eur = 40515 and  hkd = 328.5','')")

    con:query("insert into check_sql values(366,'delete from transaction_total_check where cny = 366 and jpy = 36600 and gbp = 256.2 and eur = 40626 and  hkd = 329.4','')")

    con:query("insert into check_sql values(367,'delete from transaction_total_check where cny = 367 and jpy = 36700 and gbp = 256.9 and eur = 40737 and  hkd = 330.3','')")

    con:query("insert into check_sql values(368,'delete from transaction_total_check where cny = 368 and jpy = 36800 and gbp = 257.6 and eur = 40848 and  hkd = 331.2','')")

    con:query("insert into check_sql values(369,'delete from transaction_total_check where cny = 369 and jpy = 36900 and gbp = 258.3 and eur = 40959 and  hkd = 332.1','')")

    con:query("insert into check_sql values(370,'delete from transaction_total_check where cny = 370 and jpy = 37000 and gbp = 259.0 and eur = 41070 and  hkd = 333.0','')")

    con:query("insert into check_sql values(371,'delete from transaction_total_check where cny = 371 and jpy = 37100 and gbp = 259.7 and eur = 41181 and  hkd = 333.9','')")

    con:query("insert into check_sql values(372,'delete from transaction_total_check where cny = 372 and jpy = 37200 and gbp = 260.4 and eur = 41292 and  hkd = 334.8','')")

    con:query("insert into check_sql values(373,'delete from transaction_total_check where cny = 373 and jpy = 37300 and gbp = 261.1 and eur = 41403 and  hkd = 335.7','')")

    con:query("insert into check_sql values(374,'delete from transaction_total_check where cny = 374 and jpy = 37400 and gbp = 261.8 and eur = 41514 and  hkd = 336.6','')")

    con:query("insert into check_sql values(375,'delete from transaction_total_check where cny = 375 and jpy = 37500 and gbp = 262.5 and eur = 41625 and  hkd = 337.5','')")

    con:query("insert into check_sql values(376,'delete from transaction_total_check where cny = 376 and jpy = 37600 and gbp = 263.2 and eur = 41736 and  hkd = 338.4','')")

    con:query("insert into check_sql values(377,'delete from transaction_total_check where cny = 377 and jpy = 37700 and gbp = 263.9 and eur = 41847 and  hkd = 339.3','')")

    con:query("insert into check_sql values(378,'delete from transaction_total_check where cny = 378 and jpy = 37800 and gbp = 264.6 and eur = 41958 and  hkd = 340.2','')")

    con:query("insert into check_sql values(379,'delete from transaction_total_check where cny = 379 and jpy = 37900 and gbp = 265.3 and eur = 42069 and  hkd = 341.1','')")

    con:query("insert into check_sql values(380,'delete from transaction_total_check where cny = 380 and jpy = 38000 and gbp = 266.0 and eur = 42180 and  hkd = 342.0','')")

    con:query("insert into check_sql values(381,'delete from transaction_total_check where cny = 381 and jpy = 38100 and gbp = 266.7 and eur = 42291 and  hkd = 342.9','')")

    con:query("insert into check_sql values(382,'delete from transaction_total_check where cny = 382 and jpy = 38200 and gbp = 267.4 and eur = 42402 and  hkd = 343.8','')")

    con:query("insert into check_sql values(383,'delete from transaction_total_check where cny = 383 and jpy = 38300 and gbp = 268.1 and eur = 42513 and  hkd = 344.7','')")

    con:query("insert into check_sql values(384,'delete from transaction_total_check where cny = 384 and jpy = 38400 and gbp = 268.8 and eur = 42624 and  hkd = 345.6','')")

    con:query("insert into check_sql values(385,'delete from transaction_total_check where cny = 385 and jpy = 38500 and gbp = 269.5 and eur = 42735 and  hkd = 346.5','')")

    con:query("insert into check_sql values(386,'delete from transaction_total_check where cny = 386 and jpy = 38600 and gbp = 270.2 and eur = 42846 and  hkd = 347.4','')")

    con:query("insert into check_sql values(387,'delete from transaction_total_check where cny = 387 and jpy = 38700 and gbp = 270.9 and eur = 42957 and  hkd = 348.3','')")

    con:query("insert into check_sql values(388,'delete from transaction_total_check where cny = 388 and jpy = 38800 and gbp = 271.6 and eur = 43068 and  hkd = 349.2','')")

    con:query("insert into check_sql values(389,'delete from transaction_total_check where cny = 389 and jpy = 38900 and gbp = 272.3 and eur = 43179 and  hkd = 350.1','')")

    con:query("insert into check_sql values(390,'delete from transaction_total_check where cny = 390 and jpy = 39000 and gbp = 273.0 and eur = 43290 and  hkd = 351.0','')")

    con:query("insert into check_sql values(391,'delete from transaction_total_check where cny = 391 and jpy = 39100 and gbp = 273.7 and eur = 43401 and  hkd = 351.9','')")

    con:query("insert into check_sql values(392,'delete from transaction_total_check where cny = 392 and jpy = 39200 and gbp = 274.4 and eur = 43512 and  hkd = 352.8','')")

    con:query("insert into check_sql values(393,'delete from transaction_total_check where cny = 393 and jpy = 39300 and gbp = 275.1 and eur = 43623 and  hkd = 353.7','')")

    con:query("insert into check_sql values(394,'delete from transaction_total_check where cny = 394 and jpy = 39400 and gbp = 275.8 and eur = 43734 and  hkd = 354.6','')")

    con:query("insert into check_sql values(395,'delete from transaction_total_check where cny = 395 and jpy = 39500 and gbp = 276.5 and eur = 43845 and  hkd = 355.5','')")

    con:query("insert into check_sql values(396,'delete from transaction_total_check where cny = 396 and jpy = 39600 and gbp = 277.2 and eur = 43956 and  hkd = 356.4','')")

    con:query("insert into check_sql values(397,'delete from transaction_total_check where cny = 397 and jpy = 39700 and gbp = 277.9 and eur = 44067 and  hkd = 357.3','')")

    con:query("insert into check_sql values(398,'delete from transaction_total_check where cny = 398 and jpy = 39800 and gbp = 278.6 and eur = 44178 and  hkd = 358.2','')")

    con:query("insert into check_sql values(399,'delete from transaction_total_check where cny = 399 and jpy = 39900 and gbp = 279.3 and eur = 44289 and  hkd = 359.1','')")

    con:query("insert into check_sql values(400,'delete from transaction_total_check where cny = 400 and jpy = 40000 and gbp = 280.0 and eur = 44400 and  hkd = 360.0','')")

    con:query("insert into check_sql values(401,'delete from transaction_total_check where cny = 401 and jpy = 40100 and gbp = 280.7 and eur = 44511 and  hkd = 360.9','')")

    con:query("insert into check_sql values(402,'delete from transaction_total_check where cny = 402 and jpy = 40200 and gbp = 281.4 and eur = 44622 and  hkd = 361.8','')")

    con:query("insert into check_sql values(403,'delete from transaction_total_check where cny = 403 and jpy = 40300 and gbp = 282.1 and eur = 44733 and  hkd = 362.7','')")

    con:query("insert into check_sql values(404,'delete from transaction_total_check where cny = 404 and jpy = 40400 and gbp = 282.8 and eur = 44844 and  hkd = 363.6','')")

    con:query("insert into check_sql values(405,'delete from transaction_total_check where cny = 405 and jpy = 40500 and gbp = 283.5 and eur = 44955 and  hkd = 364.5','')")

    con:query("insert into check_sql values(406,'delete from transaction_total_check where cny = 406 and jpy = 40600 and gbp = 284.2 and eur = 45066 and  hkd = 365.4','')")

    con:query("insert into check_sql values(407,'delete from transaction_total_check where cny = 407 and jpy = 40700 and gbp = 284.9 and eur = 45177 and  hkd = 366.3','')")

    con:query("insert into check_sql values(408,'delete from transaction_total_check where cny = 408 and jpy = 40800 and gbp = 285.6 and eur = 45288 and  hkd = 367.2','')")

    con:query("insert into check_sql values(409,'delete from transaction_total_check where cny = 409 and jpy = 40900 and gbp = 286.3 and eur = 45399 and  hkd = 368.1','')")

    con:query("insert into check_sql values(410,'delete from transaction_total_check where cny = 410 and jpy = 41000 and gbp = 287.0 and eur = 45510 and  hkd = 369.0','')")

    con:query("insert into check_sql values(411,'delete from transaction_total_check where cny = 411 and jpy = 41100 and gbp = 287.7 and eur = 45621 and  hkd = 369.9','')")

    con:query("insert into check_sql values(412,'delete from transaction_total_check where cny = 412 and jpy = 41200 and gbp = 288.4 and eur = 45732 and  hkd = 370.8','')")

    con:query("insert into check_sql values(413,'delete from transaction_total_check where cny = 413 and jpy = 41300 and gbp = 289.1 and eur = 45843 and  hkd = 371.7','')")

    con:query("insert into check_sql values(414,'delete from transaction_total_check where cny = 414 and jpy = 41400 and gbp = 289.8 and eur = 45954 and  hkd = 372.6','')")

    con:query("insert into check_sql values(415,'delete from transaction_total_check where cny = 415 and jpy = 41500 and gbp = 290.5 and eur = 46065 and  hkd = 373.5','')")

    con:query("insert into check_sql values(416,'delete from transaction_total_check where cny = 416 and jpy = 41600 and gbp = 291.2 and eur = 46176 and  hkd = 374.4','')")

    con:query("insert into check_sql values(417,'delete from transaction_total_check where cny = 417 and jpy = 41700 and gbp = 291.9 and eur = 46287 and  hkd = 375.3','')")

    con:query("insert into check_sql values(418,'delete from transaction_total_check where cny = 418 and jpy = 41800 and gbp = 292.6 and eur = 46398 and  hkd = 376.2','')")

    con:query("insert into check_sql values(419,'delete from transaction_total_check where cny = 419 and jpy = 41900 and gbp = 293.3 and eur = 46509 and  hkd = 377.1','')")

    con:query("insert into check_sql values(420,'delete from transaction_total_check where cny = 420 and jpy = 42000 and gbp = 294.0 and eur = 46620 and  hkd = 378.0','')")

    con:query("insert into check_sql values(421,'delete from transaction_total_check where cny = 421 and jpy = 42100 and gbp = 294.7 and eur = 46731 and  hkd = 378.9','')")

    con:query("insert into check_sql values(422,'delete from transaction_total_check where cny = 422 and jpy = 42200 and gbp = 295.4 and eur = 46842 and  hkd = 379.8','')")

    con:query("insert into check_sql values(423,'delete from transaction_total_check where cny = 423 and jpy = 42300 and gbp = 296.1 and eur = 46953 and  hkd = 380.7','')")

    con:query("insert into check_sql values(424,'delete from transaction_total_check where cny = 424 and jpy = 42400 and gbp = 296.8 and eur = 47064 and  hkd = 381.6','')")

    con:query("insert into check_sql values(425,'delete from transaction_total_check where cny = 425 and jpy = 42500 and gbp = 297.5 and eur = 47175 and  hkd = 382.5','')")

    con:query("insert into check_sql values(426,'delete from transaction_total_check where cny = 426 and jpy = 42600 and gbp = 298.2 and eur = 47286 and  hkd = 383.4','')")

    con:query("insert into check_sql values(427,'delete from transaction_total_check where cny = 427 and jpy = 42700 and gbp = 298.9 and eur = 47397 and  hkd = 384.3','')")

    con:query("insert into check_sql values(428,'delete from transaction_total_check where cny = 428 and jpy = 42800 and gbp = 299.6 and eur = 47508 and  hkd = 385.2','')")

    con:query("insert into check_sql values(429,'delete from transaction_total_check where cny = 429 and jpy = 42900 and gbp = 300.3 and eur = 47619 and  hkd = 386.1','')")

    con:query("insert into check_sql values(430,'delete from transaction_total_check where cny = 430 and jpy = 43000 and gbp = 301.0 and eur = 47730 and  hkd = 387.0','')")

    con:query("insert into check_sql values(431,'delete from transaction_total_check where cny = 431 and jpy = 43100 and gbp = 301.7 and eur = 47841 and  hkd = 387.9','')")

    con:query("insert into check_sql values(432,'delete from transaction_total_check where cny = 432 and jpy = 43200 and gbp = 302.4 and eur = 47952 and  hkd = 388.8','')")

    con:query("insert into check_sql values(433,'delete from transaction_total_check where cny = 433 and jpy = 43300 and gbp = 303.1 and eur = 48063 and  hkd = 389.7','')")

    con:query("insert into check_sql values(434,'delete from transaction_total_check where cny = 434 and jpy = 43400 and gbp = 303.8 and eur = 48174 and  hkd = 390.6','')")

    con:query("insert into check_sql values(435,'delete from transaction_total_check where cny = 435 and jpy = 43500 and gbp = 304.5 and eur = 48285 and  hkd = 391.5','')")

    con:query("insert into check_sql values(436,'delete from transaction_total_check where cny = 436 and jpy = 43600 and gbp = 305.2 and eur = 48396 and  hkd = 392.4','')")

    con:query("insert into check_sql values(437,'delete from transaction_total_check where cny = 437 and jpy = 43700 and gbp = 305.9 and eur = 48507 and  hkd = 393.3','')")

    con:query("insert into check_sql values(438,'delete from transaction_total_check where cny = 438 and jpy = 43800 and gbp = 306.6 and eur = 48618 and  hkd = 394.2','')")

    con:query("insert into check_sql values(439,'delete from transaction_total_check where cny = 439 and jpy = 43900 and gbp = 307.3 and eur = 48729 and  hkd = 395.1','')")

    con:query("insert into check_sql values(440,'delete from transaction_total_check where cny = 440 and jpy = 44000 and gbp = 308.0 and eur = 48840 and  hkd = 396.0','')")

    con:query("insert into check_sql values(441,'delete from transaction_total_check where cny = 441 and jpy = 44100 and gbp = 308.7 and eur = 48951 and  hkd = 396.9','')")

    con:query("insert into check_sql values(442,'delete from transaction_total_check where cny = 442 and jpy = 44200 and gbp = 309.4 and eur = 49062 and  hkd = 397.8','')")

    con:query("insert into check_sql values(443,'delete from transaction_total_check where cny = 443 and jpy = 44300 and gbp = 310.1 and eur = 49173 and  hkd = 398.7','')")

    con:query("insert into check_sql values(444,'delete from transaction_total_check where cny = 444 and jpy = 44400 and gbp = 310.8 and eur = 49284 and  hkd = 399.6','')")

    con:query("insert into check_sql values(445,'delete from transaction_total_check where cny = 445 and jpy = 44500 and gbp = 311.5 and eur = 49395 and  hkd = 400.5','')")

    con:query("insert into check_sql values(446,'delete from transaction_total_check where cny = 446 and jpy = 44600 and gbp = 312.2 and eur = 49506 and  hkd = 401.4','')")

    con:query("insert into check_sql values(447,'delete from transaction_total_check where cny = 447 and jpy = 44700 and gbp = 312.9 and eur = 49617 and  hkd = 402.3','')")

    con:query("insert into check_sql values(448,'delete from transaction_total_check where cny = 448 and jpy = 44800 and gbp = 313.6 and eur = 49728 and  hkd = 403.2','')")

    con:query("insert into check_sql values(449,'delete from transaction_total_check where cny = 449 and jpy = 44900 and gbp = 314.3 and eur = 49839 and  hkd = 404.1','')")

    con:query("insert into check_sql values(450,'delete from transaction_total_check where cny = 450 and jpy = 45000 and gbp = 315.0 and eur = 49950 and  hkd = 405.0','')")

    con:query("insert into check_sql values(451,'delete from transaction_total_check where cny = 451 and jpy = 45100 and gbp = 315.7 and eur = 50061 and  hkd = 405.9','')")

    con:query("insert into check_sql values(452,'delete from transaction_total_check where cny = 452 and jpy = 45200 and gbp = 316.4 and eur = 50172 and  hkd = 406.8','')")

    con:query("insert into check_sql values(453,'delete from transaction_total_check where cny = 453 and jpy = 45300 and gbp = 317.1 and eur = 50283 and  hkd = 407.7','')")

    con:query("insert into check_sql values(454,'delete from transaction_total_check where cny = 454 and jpy = 45400 and gbp = 317.8 and eur = 50394 and  hkd = 408.6','')")

    con:query("insert into check_sql values(455,'delete from transaction_total_check where cny = 455 and jpy = 45500 and gbp = 318.5 and eur = 50505 and  hkd = 409.5','')")

    con:query("insert into check_sql values(456,'delete from transaction_total_check where cny = 456 and jpy = 45600 and gbp = 319.2 and eur = 50616 and  hkd = 410.4','')")

    con:query("insert into check_sql values(457,'delete from transaction_total_check where cny = 457 and jpy = 45700 and gbp = 319.9 and eur = 50727 and  hkd = 411.3','')")

    con:query("insert into check_sql values(458,'delete from transaction_total_check where cny = 458 and jpy = 45800 and gbp = 320.6 and eur = 50838 and  hkd = 412.2','')")

    con:query("insert into check_sql values(459,'delete from transaction_total_check where cny = 459 and jpy = 45900 and gbp = 321.3 and eur = 50949 and  hkd = 413.1','')")

    con:query("insert into check_sql values(460,'delete from transaction_total_check where cny = 460 and jpy = 46000 and gbp = 322.0 and eur = 51060 and  hkd = 414.0','')")

    con:query("insert into check_sql values(461,'delete from transaction_total_check where cny = 461 and jpy = 46100 and gbp = 322.7 and eur = 51171 and  hkd = 414.9','')")

    con:query("insert into check_sql values(462,'delete from transaction_total_check where cny = 462 and jpy = 46200 and gbp = 323.4 and eur = 51282 and  hkd = 415.8','')")

    con:query("insert into check_sql values(463,'delete from transaction_total_check where cny = 463 and jpy = 46300 and gbp = 324.1 and eur = 51393 and  hkd = 416.7','')")

    con:query("insert into check_sql values(464,'delete from transaction_total_check where cny = 464 and jpy = 46400 and gbp = 324.8 and eur = 51504 and  hkd = 417.6','')")

    con:query("insert into check_sql values(465,'delete from transaction_total_check where cny = 465 and jpy = 46500 and gbp = 325.5 and eur = 51615 and  hkd = 418.5','')")

    con:query("insert into check_sql values(466,'delete from transaction_total_check where cny = 466 and jpy = 46600 and gbp = 326.2 and eur = 51726 and  hkd = 419.4','')")

    con:query("insert into check_sql values(467,'delete from transaction_total_check where cny = 467 and jpy = 46700 and gbp = 326.9 and eur = 51837 and  hkd = 420.3','')")

    con:query("insert into check_sql values(468,'delete from transaction_total_check where cny = 468 and jpy = 46800 and gbp = 327.6 and eur = 51948 and  hkd = 421.2','')")

    con:query("insert into check_sql values(469,'delete from transaction_total_check where cny = 469 and jpy = 46900 and gbp = 328.3 and eur = 52059 and  hkd = 422.1','')")

    con:query("insert into check_sql values(470,'delete from transaction_total_check where cny = 470 and jpy = 47000 and gbp = 329.0 and eur = 52170 and  hkd = 423.0','')")

    con:query("insert into check_sql values(471,'delete from transaction_total_check where cny = 471 and jpy = 47100 and gbp = 329.7 and eur = 52281 and  hkd = 423.9','')")

    con:query("insert into check_sql values(472,'delete from transaction_total_check where cny = 472 and jpy = 47200 and gbp = 330.4 and eur = 52392 and  hkd = 424.8','')")

    con:query("insert into check_sql values(473,'delete from transaction_total_check where cny = 473 and jpy = 47300 and gbp = 331.1 and eur = 52503 and  hkd = 425.7','')")

    con:query("insert into check_sql values(474,'delete from transaction_total_check where cny = 474 and jpy = 47400 and gbp = 331.8 and eur = 52614 and  hkd = 426.6','')")

    con:query("insert into check_sql values(475,'delete from transaction_total_check where cny = 475 and jpy = 47500 and gbp = 332.5 and eur = 52725 and  hkd = 427.5','')")

    con:query("insert into check_sql values(476,'delete from transaction_total_check where cny = 476 and jpy = 47600 and gbp = 333.2 and eur = 52836 and  hkd = 428.4','')")

    con:query("insert into check_sql values(477,'delete from transaction_total_check where cny = 477 and jpy = 47700 and gbp = 333.9 and eur = 52947 and  hkd = 429.3','')")

    con:query("insert into check_sql values(478,'delete from transaction_total_check where cny = 478 and jpy = 47800 and gbp = 334.6 and eur = 53058 and  hkd = 430.2','')")

    con:query("insert into check_sql values(479,'delete from transaction_total_check where cny = 479 and jpy = 47900 and gbp = 335.3 and eur = 53169 and  hkd = 431.1','')")

    con:query("insert into check_sql values(480,'delete from transaction_total_check where cny = 480 and jpy = 48000 and gbp = 336.0 and eur = 53280 and  hkd = 432.0','')")

    con:query("insert into check_sql values(481,'delete from transaction_total_check where cny = 481 and jpy = 48100 and gbp = 336.7 and eur = 53391 and  hkd = 432.9','')")

    con:query("insert into check_sql values(482,'delete from transaction_total_check where cny = 482 and jpy = 48200 and gbp = 337.4 and eur = 53502 and  hkd = 433.8','')")

    con:query("insert into check_sql values(483,'delete from transaction_total_check where cny = 483 and jpy = 48300 and gbp = 338.1 and eur = 53613 and  hkd = 434.7','')")

    con:query("insert into check_sql values(484,'delete from transaction_total_check where cny = 484 and jpy = 48400 and gbp = 338.8 and eur = 53724 and  hkd = 435.6','')")

    con:query("insert into check_sql values(485,'delete from transaction_total_check where cny = 485 and jpy = 48500 and gbp = 339.5 and eur = 53835 and  hkd = 436.5','')")

    con:query("insert into check_sql values(486,'delete from transaction_total_check where cny = 486 and jpy = 48600 and gbp = 340.2 and eur = 53946 and  hkd = 437.4','')")

    con:query("insert into check_sql values(487,'delete from transaction_total_check where cny = 487 and jpy = 48700 and gbp = 340.9 and eur = 54057 and  hkd = 438.3','')")

    con:query("insert into check_sql values(488,'delete from transaction_total_check where cny = 488 and jpy = 48800 and gbp = 341.6 and eur = 54168 and  hkd = 439.2','')")

    con:query("insert into check_sql values(489,'delete from transaction_total_check where cny = 489 and jpy = 48900 and gbp = 342.3 and eur = 54279 and  hkd = 440.1','')")

    con:query("insert into check_sql values(490,'delete from transaction_total_check where cny = 490 and jpy = 49000 and gbp = 343.0 and eur = 54390 and  hkd = 441.0','')")

    con:query("insert into check_sql values(491,'delete from transaction_total_check where cny = 491 and jpy = 49100 and gbp = 343.7 and eur = 54501 and  hkd = 441.9','')")

    con:query("insert into check_sql values(492,'delete from transaction_total_check where cny = 492 and jpy = 49200 and gbp = 344.4 and eur = 54612 and  hkd = 442.8','')")

    con:query("insert into check_sql values(493,'delete from transaction_total_check where cny = 493 and jpy = 49300 and gbp = 345.1 and eur = 54723 and  hkd = 443.7','')")

    con:query("insert into check_sql values(494,'delete from transaction_total_check where cny = 494 and jpy = 49400 and gbp = 345.8 and eur = 54834 and  hkd = 444.6','')")

    con:query("insert into check_sql values(495,'delete from transaction_total_check where cny = 495 and jpy = 49500 and gbp = 346.5 and eur = 54945 and  hkd = 445.5','')")

    con:query("insert into check_sql values(496,'delete from transaction_total_check where cny = 496 and jpy = 49600 and gbp = 347.2 and eur = 55056 and  hkd = 446.4','')")

    con:query("insert into check_sql values(497,'delete from transaction_total_check where cny = 497 and jpy = 49700 and gbp = 347.9 and eur = 55167 and  hkd = 447.3','')")

    con:query("insert into check_sql values(498,'delete from transaction_total_check where cny = 498 and jpy = 49800 and gbp = 348.6 and eur = 55278 and  hkd = 448.2','')")

    con:query("insert into check_sql values(499,'delete from transaction_total_check where cny = 499 and jpy = 49900 and gbp = 349.3 and eur = 55389 and  hkd = 449.1','')")

    con:query("insert into check_sql values(500,'delete from transaction_total_check where cny = 500 and jpy = 50000 and gbp = 350.0 and eur = 55500 and  hkd = 450.0','')")

    con:query("insert into check_sql values(501,'delete from transaction_total_check where cny = 501 and jpy = 50100 and gbp = 350.7 and eur = 55611 and  hkd = 450.9','')")

    con:query("insert into check_sql values(502,'delete from transaction_total_check where cny = 502 and jpy = 50200 and gbp = 351.4 and eur = 55722 and  hkd = 451.8','')")

    con:query("insert into check_sql values(503,'delete from transaction_total_check where cny = 503 and jpy = 50300 and gbp = 352.1 and eur = 55833 and  hkd = 452.7','')")

    con:query("insert into check_sql values(504,'delete from transaction_total_check where cny = 504 and jpy = 50400 and gbp = 352.8 and eur = 55944 and  hkd = 453.6','')")

    con:query("insert into check_sql values(505,'delete from transaction_total_check where cny = 505 and jpy = 50500 and gbp = 353.5 and eur = 56055 and  hkd = 454.5','')")

    con:query("insert into check_sql values(506,'delete from transaction_total_check where cny = 506 and jpy = 50600 and gbp = 354.2 and eur = 56166 and  hkd = 455.4','')")

    con:query("insert into check_sql values(507,'delete from transaction_total_check where cny = 507 and jpy = 50700 and gbp = 354.9 and eur = 56277 and  hkd = 456.3','')")

    con:query("insert into check_sql values(508,'delete from transaction_total_check where cny = 508 and jpy = 50800 and gbp = 355.6 and eur = 56388 and  hkd = 457.2','')")

    con:query("insert into check_sql values(509,'delete from transaction_total_check where cny = 509 and jpy = 50900 and gbp = 356.3 and eur = 56499 and  hkd = 458.1','')")

    con:query("insert into check_sql values(510,'delete from transaction_total_check where cny = 510 and jpy = 51000 and gbp = 357.0 and eur = 56610 and  hkd = 459.0','')")

    con:query("insert into check_sql values(511,'delete from transaction_total_check where cny = 511 and jpy = 51100 and gbp = 357.7 and eur = 56721 and  hkd = 459.9','')")

    con:query("insert into check_sql values(512,'delete from transaction_total_check where cny = 512 and jpy = 51200 and gbp = 358.4 and eur = 56832 and  hkd = 460.8','')")

    con:query("insert into check_sql values(513,'delete from transaction_total_check where cny = 513 and jpy = 51300 and gbp = 359.1 and eur = 56943 and  hkd = 461.7','')")

    con:query("insert into check_sql values(514,'delete from transaction_total_check where cny = 514 and jpy = 51400 and gbp = 359.8 and eur = 57054 and  hkd = 462.6','')")

    con:query("insert into check_sql values(515,'delete from transaction_total_check where cny = 515 and jpy = 51500 and gbp = 360.5 and eur = 57165 and  hkd = 463.5','')")

    con:query("insert into check_sql values(516,'delete from transaction_total_check where cny = 516 and jpy = 51600 and gbp = 361.2 and eur = 57276 and  hkd = 464.4','')")

    con:query("insert into check_sql values(517,'delete from transaction_total_check where cny = 517 and jpy = 51700 and gbp = 361.9 and eur = 57387 and  hkd = 465.3','')")

    con:query("insert into check_sql values(518,'delete from transaction_total_check where cny = 518 and jpy = 51800 and gbp = 362.6 and eur = 57498 and  hkd = 466.2','')")

    con:query("insert into check_sql values(519,'delete from transaction_total_check where cny = 519 and jpy = 51900 and gbp = 363.3 and eur = 57609 and  hkd = 467.1','')")

    con:query("insert into check_sql values(520,'delete from transaction_total_check where cny = 520 and jpy = 52000 and gbp = 364.0 and eur = 57720 and  hkd = 468.0','')")

    con:query("insert into check_sql values(521,'delete from transaction_total_check where cny = 521 and jpy = 52100 and gbp = 364.7 and eur = 57831 and  hkd = 468.9','')")

    con:query("insert into check_sql values(522,'delete from transaction_total_check where cny = 522 and jpy = 52200 and gbp = 365.4 and eur = 57942 and  hkd = 469.8','')")

    con:query("insert into check_sql values(523,'delete from transaction_total_check where cny = 523 and jpy = 52300 and gbp = 366.1 and eur = 58053 and  hkd = 470.7','')")

    con:query("insert into check_sql values(524,'delete from transaction_total_check where cny = 524 and jpy = 52400 and gbp = 366.8 and eur = 58164 and  hkd = 471.6','')")

    con:query("insert into check_sql values(525,'delete from transaction_total_check where cny = 525 and jpy = 52500 and gbp = 367.5 and eur = 58275 and  hkd = 472.5','')")

    con:query("insert into check_sql values(526,'delete from transaction_total_check where cny = 526 and jpy = 52600 and gbp = 368.2 and eur = 58386 and  hkd = 473.4','')")

    con:query("insert into check_sql values(527,'delete from transaction_total_check where cny = 527 and jpy = 52700 and gbp = 368.9 and eur = 58497 and  hkd = 474.3','')")

    con:query("insert into check_sql values(528,'delete from transaction_total_check where cny = 528 and jpy = 52800 and gbp = 369.6 and eur = 58608 and  hkd = 475.2','')")

    con:query("insert into check_sql values(529,'delete from transaction_total_check where cny = 529 and jpy = 52900 and gbp = 370.3 and eur = 58719 and  hkd = 476.1','')")

    con:query("insert into check_sql values(530,'delete from transaction_total_check where cny = 530 and jpy = 53000 and gbp = 371.0 and eur = 58830 and  hkd = 477.0','')")

    con:query("insert into check_sql values(531,'delete from transaction_total_check where cny = 531 and jpy = 53100 and gbp = 371.7 and eur = 58941 and  hkd = 477.9','')")

    con:query("insert into check_sql values(532,'delete from transaction_total_check where cny = 532 and jpy = 53200 and gbp = 372.4 and eur = 59052 and  hkd = 478.8','')")

    con:query("insert into check_sql values(533,'delete from transaction_total_check where cny = 533 and jpy = 53300 and gbp = 373.1 and eur = 59163 and  hkd = 479.7','')")

    con:query("insert into check_sql values(534,'delete from transaction_total_check where cny = 534 and jpy = 53400 and gbp = 373.8 and eur = 59274 and  hkd = 480.6','')")

    con:query("insert into check_sql values(535,'delete from transaction_total_check where cny = 535 and jpy = 53500 and gbp = 374.5 and eur = 59385 and  hkd = 481.5','')")

    con:query("insert into check_sql values(536,'delete from transaction_total_check where cny = 536 and jpy = 53600 and gbp = 375.2 and eur = 59496 and  hkd = 482.4','')")

    con:query("insert into check_sql values(537,'delete from transaction_total_check where cny = 537 and jpy = 53700 and gbp = 375.9 and eur = 59607 and  hkd = 483.3','')")

    con:query("insert into check_sql values(538,'delete from transaction_total_check where cny = 538 and jpy = 53800 and gbp = 376.6 and eur = 59718 and  hkd = 484.2','')")

    con:query("insert into check_sql values(539,'delete from transaction_total_check where cny = 539 and jpy = 53900 and gbp = 377.3 and eur = 59829 and  hkd = 485.1','')")

    con:query("insert into check_sql values(540,'delete from transaction_total_check where cny = 540 and jpy = 54000 and gbp = 378.0 and eur = 59940 and  hkd = 486.0','')")

    con:query("insert into check_sql values(541,'delete from transaction_total_check where cny = 541 and jpy = 54100 and gbp = 378.7 and eur = 60051 and  hkd = 486.9','')")

    con:query("insert into check_sql values(542,'delete from transaction_total_check where cny = 542 and jpy = 54200 and gbp = 379.4 and eur = 60162 and  hkd = 487.8','')")

    con:query("insert into check_sql values(543,'delete from transaction_total_check where cny = 543 and jpy = 54300 and gbp = 380.1 and eur = 60273 and  hkd = 488.7','')")

    con:query("insert into check_sql values(544,'delete from transaction_total_check where cny = 544 and jpy = 54400 and gbp = 380.8 and eur = 60384 and  hkd = 489.6','')")

    con:query("insert into check_sql values(545,'delete from transaction_total_check where cny = 545 and jpy = 54500 and gbp = 381.5 and eur = 60495 and  hkd = 490.5','')")

    con:query("insert into check_sql values(546,'delete from transaction_total_check where cny = 546 and jpy = 54600 and gbp = 382.2 and eur = 60606 and  hkd = 491.4','')")

    con:query("insert into check_sql values(547,'delete from transaction_total_check where cny = 547 and jpy = 54700 and gbp = 382.9 and eur = 60717 and  hkd = 492.3','')")

    con:query("insert into check_sql values(548,'delete from transaction_total_check where cny = 548 and jpy = 54800 and gbp = 383.6 and eur = 60828 and  hkd = 493.2','')")

    con:query("insert into check_sql values(549,'delete from transaction_total_check where cny = 549 and jpy = 54900 and gbp = 384.3 and eur = 60939 and  hkd = 494.1','')")

    con:query("insert into check_sql values(550,'delete from transaction_total_check where cny = 550 and jpy = 55000 and gbp = 385.0 and eur = 61050 and  hkd = 495.0','')")

    con:query("insert into check_sql values(551,'delete from transaction_total_check where cny = 551 and jpy = 55100 and gbp = 385.7 and eur = 61161 and  hkd = 495.9','')")

    con:query("insert into check_sql values(552,'delete from transaction_total_check where cny = 552 and jpy = 55200 and gbp = 386.4 and eur = 61272 and  hkd = 496.8','')")

    con:query("insert into check_sql values(553,'delete from transaction_total_check where cny = 553 and jpy = 55300 and gbp = 387.1 and eur = 61383 and  hkd = 497.7','')")

    con:query("insert into check_sql values(554,'delete from transaction_total_check where cny = 554 and jpy = 55400 and gbp = 387.8 and eur = 61494 and  hkd = 498.6','')")

    con:query("insert into check_sql values(555,'delete from transaction_total_check where cny = 555 and jpy = 55500 and gbp = 388.5 and eur = 61605 and  hkd = 499.5','')")

    con:query("insert into check_sql values(556,'delete from transaction_total_check where cny = 556 and jpy = 55600 and gbp = 389.2 and eur = 61716 and  hkd = 500.4','')")

    con:query("insert into check_sql values(557,'delete from transaction_total_check where cny = 557 and jpy = 55700 and gbp = 389.9 and eur = 61827 and  hkd = 501.3','')")

    con:query("insert into check_sql values(558,'delete from transaction_total_check where cny = 558 and jpy = 55800 and gbp = 390.6 and eur = 61938 and  hkd = 502.2','')")

    con:query("insert into check_sql values(559,'delete from transaction_total_check where cny = 559 and jpy = 55900 and gbp = 391.3 and eur = 62049 and  hkd = 503.1','')")

    con:query("insert into check_sql values(560,'delete from transaction_total_check where cny = 560 and jpy = 56000 and gbp = 392.0 and eur = 62160 and  hkd = 504.0','')")

    con:query("insert into check_sql values(561,'delete from transaction_total_check where cny = 561 and jpy = 56100 and gbp = 392.7 and eur = 62271 and  hkd = 504.9','')")

    con:query("insert into check_sql values(562,'delete from transaction_total_check where cny = 562 and jpy = 56200 and gbp = 393.4 and eur = 62382 and  hkd = 505.8','')")

    con:query("insert into check_sql values(563,'delete from transaction_total_check where cny = 563 and jpy = 56300 and gbp = 394.1 and eur = 62493 and  hkd = 506.7','')")

    con:query("insert into check_sql values(564,'delete from transaction_total_check where cny = 564 and jpy = 56400 and gbp = 394.8 and eur = 62604 and  hkd = 507.6','')")

    con:query("insert into check_sql values(565,'delete from transaction_total_check where cny = 565 and jpy = 56500 and gbp = 395.5 and eur = 62715 and  hkd = 508.5','')")

    con:query("insert into check_sql values(566,'delete from transaction_total_check where cny = 566 and jpy = 56600 and gbp = 396.2 and eur = 62826 and  hkd = 509.4','')")

    con:query("insert into check_sql values(567,'delete from transaction_total_check where cny = 567 and jpy = 56700 and gbp = 396.9 and eur = 62937 and  hkd = 510.3','')")

    con:query("insert into check_sql values(568,'delete from transaction_total_check where cny = 568 and jpy = 56800 and gbp = 397.6 and eur = 63048 and  hkd = 511.2','')")

    con:query("insert into check_sql values(569,'delete from transaction_total_check where cny = 569 and jpy = 56900 and gbp = 398.3 and eur = 63159 and  hkd = 512.1','')")

    con:query("insert into check_sql values(570,'delete from transaction_total_check where cny = 570 and jpy = 57000 and gbp = 399.0 and eur = 63270 and  hkd = 513.0','')")

    con:query("insert into check_sql values(571,'delete from transaction_total_check where cny = 571 and jpy = 57100 and gbp = 399.7 and eur = 63381 and  hkd = 513.9','')")

    con:query("insert into check_sql values(572,'delete from transaction_total_check where cny = 572 and jpy = 57200 and gbp = 400.4 and eur = 63492 and  hkd = 514.8','')")

    con:query("insert into check_sql values(573,'delete from transaction_total_check where cny = 573 and jpy = 57300 and gbp = 401.1 and eur = 63603 and  hkd = 515.7','')")

    con:query("insert into check_sql values(574,'delete from transaction_total_check where cny = 574 and jpy = 57400 and gbp = 401.8 and eur = 63714 and  hkd = 516.6','')")

    con:query("insert into check_sql values(575,'delete from transaction_total_check where cny = 575 and jpy = 57500 and gbp = 402.5 and eur = 63825 and  hkd = 517.5','')")

    con:query("insert into check_sql values(576,'delete from transaction_total_check where cny = 576 and jpy = 57600 and gbp = 403.2 and eur = 63936 and  hkd = 518.4','')")

    con:query("insert into check_sql values(577,'delete from transaction_total_check where cny = 577 and jpy = 57700 and gbp = 403.9 and eur = 64047 and  hkd = 519.3','')")

    con:query("insert into check_sql values(578,'delete from transaction_total_check where cny = 578 and jpy = 57800 and gbp = 404.6 and eur = 64158 and  hkd = 520.2','')")

    con:query("insert into check_sql values(579,'delete from transaction_total_check where cny = 579 and jpy = 57900 and gbp = 405.3 and eur = 64269 and  hkd = 521.1','')")

    con:query("insert into check_sql values(580,'delete from transaction_total_check where cny = 580 and jpy = 58000 and gbp = 406.0 and eur = 64380 and  hkd = 522.0','')")

    con:query("insert into check_sql values(581,'delete from transaction_total_check where cny = 581 and jpy = 58100 and gbp = 406.7 and eur = 64491 and  hkd = 522.9','')")

    con:query("insert into check_sql values(582,'delete from transaction_total_check where cny = 582 and jpy = 58200 and gbp = 407.4 and eur = 64602 and  hkd = 523.8','')")

    con:query("insert into check_sql values(583,'delete from transaction_total_check where cny = 583 and jpy = 58300 and gbp = 408.1 and eur = 64713 and  hkd = 524.7','')")

    con:query("insert into check_sql values(584,'delete from transaction_total_check where cny = 584 and jpy = 58400 and gbp = 408.8 and eur = 64824 and  hkd = 525.6','')")

    con:query("insert into check_sql values(585,'delete from transaction_total_check where cny = 585 and jpy = 58500 and gbp = 409.5 and eur = 64935 and  hkd = 526.5','')")

    con:query("insert into check_sql values(586,'delete from transaction_total_check where cny = 586 and jpy = 58600 and gbp = 410.2 and eur = 65046 and  hkd = 527.4','')")

    con:query("insert into check_sql values(587,'delete from transaction_total_check where cny = 587 and jpy = 58700 and gbp = 410.9 and eur = 65157 and  hkd = 528.3','')")

    con:query("insert into check_sql values(588,'delete from transaction_total_check where cny = 588 and jpy = 58800 and gbp = 411.6 and eur = 65268 and  hkd = 529.2','')")

    con:query("insert into check_sql values(589,'delete from transaction_total_check where cny = 589 and jpy = 58900 and gbp = 412.3 and eur = 65379 and  hkd = 530.1','')")

    con:query("insert into check_sql values(590,'delete from transaction_total_check where cny = 590 and jpy = 59000 and gbp = 413.0 and eur = 65490 and  hkd = 531.0','')")

    con:query("insert into check_sql values(591,'delete from transaction_total_check where cny = 591 and jpy = 59100 and gbp = 413.7 and eur = 65601 and  hkd = 531.9','')")

    con:query("insert into check_sql values(592,'delete from transaction_total_check where cny = 592 and jpy = 59200 and gbp = 414.4 and eur = 65712 and  hkd = 532.8','')")

    con:query("insert into check_sql values(593,'delete from transaction_total_check where cny = 593 and jpy = 59300 and gbp = 415.1 and eur = 65823 and  hkd = 533.7','')")

    con:query("insert into check_sql values(594,'delete from transaction_total_check where cny = 594 and jpy = 59400 and gbp = 415.8 and eur = 65934 and  hkd = 534.6','')")

    con:query("insert into check_sql values(595,'delete from transaction_total_check where cny = 595 and jpy = 59500 and gbp = 416.5 and eur = 66045 and  hkd = 535.5','')")

    con:query("insert into check_sql values(596,'delete from transaction_total_check where cny = 596 and jpy = 59600 and gbp = 417.2 and eur = 66156 and  hkd = 536.4','')")

    con:query("insert into check_sql values(597,'delete from transaction_total_check where cny = 597 and jpy = 59700 and gbp = 417.9 and eur = 66267 and  hkd = 537.3','')")

    con:query("insert into check_sql values(598,'delete from transaction_total_check where cny = 598 and jpy = 59800 and gbp = 418.6 and eur = 66378 and  hkd = 538.2','')")

    con:query("insert into check_sql values(599,'delete from transaction_total_check where cny = 599 and jpy = 59900 and gbp = 419.3 and eur = 66489 and  hkd = 539.1','')")

    con:query("insert into check_sql values(600,'delete from transaction_total_check where cny = 600 and jpy = 60000 and gbp = 420.0 and eur = 66600 and  hkd = 540.0','')")

    con:query("insert into check_sql values(601,'delete from transaction_total_check where cny = 601 and jpy = 60100 and gbp = 420.7 and eur = 66711 and  hkd = 540.9','')")

    con:query("insert into check_sql values(602,'delete from transaction_total_check where cny = 602 and jpy = 60200 and gbp = 421.4 and eur = 66822 and  hkd = 541.8','')")

    con:query("insert into check_sql values(603,'delete from transaction_total_check where cny = 603 and jpy = 60300 and gbp = 422.1 and eur = 66933 and  hkd = 542.7','')")

    con:query("insert into check_sql values(604,'delete from transaction_total_check where cny = 604 and jpy = 60400 and gbp = 422.8 and eur = 67044 and  hkd = 543.6','')")

    con:query("insert into check_sql values(605,'delete from transaction_total_check where cny = 605 and jpy = 60500 and gbp = 423.5 and eur = 67155 and  hkd = 544.5','')")

    con:query("insert into check_sql values(606,'delete from transaction_total_check where cny = 606 and jpy = 60600 and gbp = 424.2 and eur = 67266 and  hkd = 545.4','')")

    con:query("insert into check_sql values(607,'delete from transaction_total_check where cny = 607 and jpy = 60700 and gbp = 424.9 and eur = 67377 and  hkd = 546.3','')")

    con:query("insert into check_sql values(608,'delete from transaction_total_check where cny = 608 and jpy = 60800 and gbp = 425.6 and eur = 67488 and  hkd = 547.2','')")

    con:query("insert into check_sql values(609,'delete from transaction_total_check where cny = 609 and jpy = 60900 and gbp = 426.3 and eur = 67599 and  hkd = 548.1','')")

    con:query("insert into check_sql values(610,'delete from transaction_total_check where cny = 610 and jpy = 61000 and gbp = 427.0 and eur = 67710 and  hkd = 549.0','')")

    con:query("insert into check_sql values(611,'delete from transaction_total_check where cny = 611 and jpy = 61100 and gbp = 427.7 and eur = 67821 and  hkd = 549.9','')")

    con:query("insert into check_sql values(612,'delete from transaction_total_check where cny = 612 and jpy = 61200 and gbp = 428.4 and eur = 67932 and  hkd = 550.8','')")

    con:query("insert into check_sql values(613,'delete from transaction_total_check where cny = 613 and jpy = 61300 and gbp = 429.1 and eur = 68043 and  hkd = 551.7','')")

    con:query("insert into check_sql values(614,'delete from transaction_total_check where cny = 614 and jpy = 61400 and gbp = 429.8 and eur = 68154 and  hkd = 552.6','')")

    con:query("insert into check_sql values(615,'delete from transaction_total_check where cny = 615 and jpy = 61500 and gbp = 430.5 and eur = 68265 and  hkd = 553.5','')")

    con:query("insert into check_sql values(616,'delete from transaction_total_check where cny = 616 and jpy = 61600 and gbp = 431.2 and eur = 68376 and  hkd = 554.4','')")

    con:query("insert into check_sql values(617,'delete from transaction_total_check where cny = 617 and jpy = 61700 and gbp = 431.9 and eur = 68487 and  hkd = 555.3','')")

    con:query("insert into check_sql values(618,'delete from transaction_total_check where cny = 618 and jpy = 61800 and gbp = 432.6 and eur = 68598 and  hkd = 556.2','')")

    con:query("insert into check_sql values(619,'delete from transaction_total_check where cny = 619 and jpy = 61900 and gbp = 433.3 and eur = 68709 and  hkd = 557.1','')")

    con:query("insert into check_sql values(620,'delete from transaction_total_check where cny = 620 and jpy = 62000 and gbp = 434.0 and eur = 68820 and  hkd = 558.0','')")

    con:query("insert into check_sql values(621,'delete from transaction_total_check where cny = 621 and jpy = 62100 and gbp = 434.7 and eur = 68931 and  hkd = 558.9','')")

    con:query("insert into check_sql values(622,'delete from transaction_total_check where cny = 622 and jpy = 62200 and gbp = 435.4 and eur = 69042 and  hkd = 559.8','')")

    con:query("insert into check_sql values(623,'delete from transaction_total_check where cny = 623 and jpy = 62300 and gbp = 436.1 and eur = 69153 and  hkd = 560.7','')")

    con:query("insert into check_sql values(624,'delete from transaction_total_check where cny = 624 and jpy = 62400 and gbp = 436.8 and eur = 69264 and  hkd = 561.6','')")

    con:query("insert into check_sql values(625,'delete from transaction_total_check where cny = 625 and jpy = 62500 and gbp = 437.5 and eur = 69375 and  hkd = 562.5','')")

    con:query("insert into check_sql values(626,'delete from transaction_total_check where cny = 626 and jpy = 62600 and gbp = 438.2 and eur = 69486 and  hkd = 563.4','')")

    con:query("insert into check_sql values(627,'delete from transaction_total_check where cny = 627 and jpy = 62700 and gbp = 438.9 and eur = 69597 and  hkd = 564.3','')")

    con:query("insert into check_sql values(628,'delete from transaction_total_check where cny = 628 and jpy = 62800 and gbp = 439.6 and eur = 69708 and  hkd = 565.2','')")

    con:query("insert into check_sql values(629,'delete from transaction_total_check where cny = 629 and jpy = 62900 and gbp = 440.3 and eur = 69819 and  hkd = 566.1','')")

    con:query("insert into check_sql values(630,'delete from transaction_total_check where cny = 630 and jpy = 63000 and gbp = 441.0 and eur = 69930 and  hkd = 567.0','')")

    con:query("insert into check_sql values(631,'delete from transaction_total_check where cny = 631 and jpy = 63100 and gbp = 441.7 and eur = 70041 and  hkd = 567.9','')")

    con:query("insert into check_sql values(632,'delete from transaction_total_check where cny = 632 and jpy = 63200 and gbp = 442.4 and eur = 70152 and  hkd = 568.8','')")

    con:query("insert into check_sql values(633,'delete from transaction_total_check where cny = 633 and jpy = 63300 and gbp = 443.1 and eur = 70263 and  hkd = 569.7','')")

    con:query("insert into check_sql values(634,'delete from transaction_total_check where cny = 634 and jpy = 63400 and gbp = 443.8 and eur = 70374 and  hkd = 570.6','')")

    con:query("insert into check_sql values(635,'delete from transaction_total_check where cny = 635 and jpy = 63500 and gbp = 444.5 and eur = 70485 and  hkd = 571.5','')")

    con:query("insert into check_sql values(636,'delete from transaction_total_check where cny = 636 and jpy = 63600 and gbp = 445.2 and eur = 70596 and  hkd = 572.4','')")

    con:query("insert into check_sql values(637,'delete from transaction_total_check where cny = 637 and jpy = 63700 and gbp = 445.9 and eur = 70707 and  hkd = 573.3','')")

    con:query("insert into check_sql values(638,'delete from transaction_total_check where cny = 638 and jpy = 63800 and gbp = 446.6 and eur = 70818 and  hkd = 574.2','')")

    con:query("insert into check_sql values(639,'delete from transaction_total_check where cny = 639 and jpy = 63900 and gbp = 447.3 and eur = 70929 and  hkd = 575.1','')")

    con:query("insert into check_sql values(640,'delete from transaction_total_check where cny = 640 and jpy = 64000 and gbp = 448.0 and eur = 71040 and  hkd = 576.0','')")

    con:query("insert into check_sql values(641,'delete from transaction_total_check where cny = 641 and jpy = 64100 and gbp = 448.7 and eur = 71151 and  hkd = 576.9','')")

    con:query("insert into check_sql values(642,'delete from transaction_total_check where cny = 642 and jpy = 64200 and gbp = 449.4 and eur = 71262 and  hkd = 577.8','')")

    con:query("insert into check_sql values(643,'delete from transaction_total_check where cny = 643 and jpy = 64300 and gbp = 450.1 and eur = 71373 and  hkd = 578.7','')")

    con:query("insert into check_sql values(644,'delete from transaction_total_check where cny = 644 and jpy = 64400 and gbp = 450.8 and eur = 71484 and  hkd = 579.6','')")

    con:query("insert into check_sql values(645,'delete from transaction_total_check where cny = 645 and jpy = 64500 and gbp = 451.5 and eur = 71595 and  hkd = 580.5','')")

    con:query("insert into check_sql values(646,'delete from transaction_total_check where cny = 646 and jpy = 64600 and gbp = 452.2 and eur = 71706 and  hkd = 581.4','')")

    con:query("insert into check_sql values(647,'delete from transaction_total_check where cny = 647 and jpy = 64700 and gbp = 452.9 and eur = 71817 and  hkd = 582.3','')")

    con:query("insert into check_sql values(648,'delete from transaction_total_check where cny = 648 and jpy = 64800 and gbp = 453.6 and eur = 71928 and  hkd = 583.2','')")

    con:query("insert into check_sql values(649,'delete from transaction_total_check where cny = 649 and jpy = 64900 and gbp = 454.3 and eur = 72039 and  hkd = 584.1','')")

    con:query("insert into check_sql values(650,'delete from transaction_total_check where cny = 650 and jpy = 65000 and gbp = 455.0 and eur = 72150 and  hkd = 585.0','')")

    con:query("insert into check_sql values(651,'delete from transaction_total_check where cny = 651 and jpy = 65100 and gbp = 455.7 and eur = 72261 and  hkd = 585.9','')")

    con:query("insert into check_sql values(652,'delete from transaction_total_check where cny = 652 and jpy = 65200 and gbp = 456.4 and eur = 72372 and  hkd = 586.8','')")

    con:query("insert into check_sql values(653,'delete from transaction_total_check where cny = 653 and jpy = 65300 and gbp = 457.1 and eur = 72483 and  hkd = 587.7','')")

    con:query("insert into check_sql values(654,'delete from transaction_total_check where cny = 654 and jpy = 65400 and gbp = 457.8 and eur = 72594 and  hkd = 588.6','')")

    con:query("insert into check_sql values(655,'delete from transaction_total_check where cny = 655 and jpy = 65500 and gbp = 458.5 and eur = 72705 and  hkd = 589.5','')")

    con:query("insert into check_sql values(656,'delete from transaction_total_check where cny = 656 and jpy = 65600 and gbp = 459.2 and eur = 72816 and  hkd = 590.4','')")

    con:query("insert into check_sql values(657,'delete from transaction_total_check where cny = 657 and jpy = 65700 and gbp = 459.9 and eur = 72927 and  hkd = 591.3','')")

    con:query("insert into check_sql values(658,'delete from transaction_total_check where cny = 658 and jpy = 65800 and gbp = 460.6 and eur = 73038 and  hkd = 592.2','')")

    con:query("insert into check_sql values(659,'delete from transaction_total_check where cny = 659 and jpy = 65900 and gbp = 461.3 and eur = 73149 and  hkd = 593.1','')")

    con:query("insert into check_sql values(660,'delete from transaction_total_check where cny = 660 and jpy = 66000 and gbp = 462.0 and eur = 73260 and  hkd = 594.0','')")

    con:query("insert into check_sql values(661,'delete from transaction_total_check where cny = 661 and jpy = 66100 and gbp = 462.7 and eur = 73371 and  hkd = 594.9','')")

    con:query("insert into check_sql values(662,'delete from transaction_total_check where cny = 662 and jpy = 66200 and gbp = 463.4 and eur = 73482 and  hkd = 595.8','')")

    con:query("insert into check_sql values(663,'delete from transaction_total_check where cny = 663 and jpy = 66300 and gbp = 464.1 and eur = 73593 and  hkd = 596.7','')")

    con:query("insert into check_sql values(664,'delete from transaction_total_check where cny = 664 and jpy = 66400 and gbp = 464.8 and eur = 73704 and  hkd = 597.6','')")

    con:query("insert into check_sql values(665,'delete from transaction_total_check where cny = 665 and jpy = 66500 and gbp = 465.5 and eur = 73815 and  hkd = 598.5','')")

    con:query("insert into check_sql values(666,'delete from transaction_total_check where cny = 666 and jpy = 66600 and gbp = 466.2 and eur = 73926 and  hkd = 599.4','')")

    con:query("insert into check_sql values(667,'delete from transaction_total_check where cny = 667 and jpy = 66700 and gbp = 466.9 and eur = 74037 and  hkd = 600.3','')")

    con:query("insert into check_sql values(668,'delete from transaction_total_check where cny = 668 and jpy = 66800 and gbp = 467.6 and eur = 74148 and  hkd = 601.2','')")

    con:query("insert into check_sql values(669,'delete from transaction_total_check where cny = 669 and jpy = 66900 and gbp = 468.3 and eur = 74259 and  hkd = 602.1','')")

    con:query("insert into check_sql values(670,'delete from transaction_total_check where cny = 670 and jpy = 67000 and gbp = 469.0 and eur = 74370 and  hkd = 603.0','')")

    con:query("insert into check_sql values(671,'delete from transaction_total_check where cny = 671 and jpy = 67100 and gbp = 469.7 and eur = 74481 and  hkd = 603.9','')")

    con:query("insert into check_sql values(672,'delete from transaction_total_check where cny = 672 and jpy = 67200 and gbp = 470.4 and eur = 74592 and  hkd = 604.8','')")

    con:query("insert into check_sql values(673,'delete from transaction_total_check where cny = 673 and jpy = 67300 and gbp = 471.1 and eur = 74703 and  hkd = 605.7','')")

    con:query("insert into check_sql values(674,'delete from transaction_total_check where cny = 674 and jpy = 67400 and gbp = 471.8 and eur = 74814 and  hkd = 606.6','')")

    con:query("insert into check_sql values(675,'delete from transaction_total_check where cny = 675 and jpy = 67500 and gbp = 472.5 and eur = 74925 and  hkd = 607.5','')")

    con:query("insert into check_sql values(676,'delete from transaction_total_check where cny = 676 and jpy = 67600 and gbp = 473.2 and eur = 75036 and  hkd = 608.4','')")

    con:query("insert into check_sql values(677,'delete from transaction_total_check where cny = 677 and jpy = 67700 and gbp = 473.9 and eur = 75147 and  hkd = 609.3','')")

    con:query("insert into check_sql values(678,'delete from transaction_total_check where cny = 678 and jpy = 67800 and gbp = 474.6 and eur = 75258 and  hkd = 610.2','')")

    con:query("insert into check_sql values(679,'delete from transaction_total_check where cny = 679 and jpy = 67900 and gbp = 475.3 and eur = 75369 and  hkd = 611.1','')")

    con:query("insert into check_sql values(680,'delete from transaction_total_check where cny = 680 and jpy = 68000 and gbp = 476.0 and eur = 75480 and  hkd = 612.0','')")

    con:query("insert into check_sql values(681,'delete from transaction_total_check where cny = 681 and jpy = 68100 and gbp = 476.7 and eur = 75591 and  hkd = 612.9','')")

    con:query("insert into check_sql values(682,'delete from transaction_total_check where cny = 682 and jpy = 68200 and gbp = 477.4 and eur = 75702 and  hkd = 613.8','')")

    con:query("insert into check_sql values(683,'delete from transaction_total_check where cny = 683 and jpy = 68300 and gbp = 478.1 and eur = 75813 and  hkd = 614.7','')")

    con:query("insert into check_sql values(684,'delete from transaction_total_check where cny = 684 and jpy = 68400 and gbp = 478.8 and eur = 75924 and  hkd = 615.6','')")

    con:query("insert into check_sql values(685,'delete from transaction_total_check where cny = 685 and jpy = 68500 and gbp = 479.5 and eur = 76035 and  hkd = 616.5','')")

    con:query("insert into check_sql values(686,'delete from transaction_total_check where cny = 686 and jpy = 68600 and gbp = 480.2 and eur = 76146 and  hkd = 617.4','')")

    con:query("insert into check_sql values(687,'delete from transaction_total_check where cny = 687 and jpy = 68700 and gbp = 480.9 and eur = 76257 and  hkd = 618.3','')")

    con:query("insert into check_sql values(688,'delete from transaction_total_check where cny = 688 and jpy = 68800 and gbp = 481.6 and eur = 76368 and  hkd = 619.2','')")

    con:query("insert into check_sql values(689,'delete from transaction_total_check where cny = 689 and jpy = 68900 and gbp = 482.3 and eur = 76479 and  hkd = 620.1','')")

    con:query("insert into check_sql values(690,'delete from transaction_total_check where cny = 690 and jpy = 69000 and gbp = 483.0 and eur = 76590 and  hkd = 621.0','')")

    con:query("insert into check_sql values(691,'delete from transaction_total_check where cny = 691 and jpy = 69100 and gbp = 483.7 and eur = 76701 and  hkd = 621.9','')")

    con:query("insert into check_sql values(692,'delete from transaction_total_check where cny = 692 and jpy = 69200 and gbp = 484.4 and eur = 76812 and  hkd = 622.8','')")

    con:query("insert into check_sql values(693,'delete from transaction_total_check where cny = 693 and jpy = 69300 and gbp = 485.1 and eur = 76923 and  hkd = 623.7','')")

    con:query("insert into check_sql values(694,'delete from transaction_total_check where cny = 694 and jpy = 69400 and gbp = 485.8 and eur = 77034 and  hkd = 624.6','')")

    con:query("insert into check_sql values(695,'delete from transaction_total_check where cny = 695 and jpy = 69500 and gbp = 486.5 and eur = 77145 and  hkd = 625.5','')")

    con:query("insert into check_sql values(696,'delete from transaction_total_check where cny = 696 and jpy = 69600 and gbp = 487.2 and eur = 77256 and  hkd = 626.4','')")

    con:query("insert into check_sql values(697,'delete from transaction_total_check where cny = 697 and jpy = 69700 and gbp = 487.9 and eur = 77367 and  hkd = 627.3','')")

    con:query("insert into check_sql values(698,'delete from transaction_total_check where cny = 698 and jpy = 69800 and gbp = 488.6 and eur = 77478 and  hkd = 628.2','')")

    con:query("insert into check_sql values(699,'delete from transaction_total_check where cny = 699 and jpy = 69900 and gbp = 489.3 and eur = 77589 and  hkd = 629.1','')")

    con:query("insert into check_sql values(700,'delete from transaction_total_check where cny = 700 and jpy = 70000 and gbp = 490.0 and eur = 77700 and  hkd = 630.0','')")

    con:query("insert into check_sql values(701,'delete from transaction_total_check where cny = 701 and jpy = 70100 and gbp = 490.7 and eur = 77811 and  hkd = 630.9','')")

    con:query("insert into check_sql values(702,'delete from transaction_total_check where cny = 702 and jpy = 70200 and gbp = 491.4 and eur = 77922 and  hkd = 631.8','')")

    con:query("insert into check_sql values(703,'delete from transaction_total_check where cny = 703 and jpy = 70300 and gbp = 492.1 and eur = 78033 and  hkd = 632.7','')")

    con:query("insert into check_sql values(704,'delete from transaction_total_check where cny = 704 and jpy = 70400 and gbp = 492.8 and eur = 78144 and  hkd = 633.6','')")

    con:query("insert into check_sql values(705,'delete from transaction_total_check where cny = 705 and jpy = 70500 and gbp = 493.5 and eur = 78255 and  hkd = 634.5','')")

    con:query("insert into check_sql values(706,'delete from transaction_total_check where cny = 706 and jpy = 70600 and gbp = 494.2 and eur = 78366 and  hkd = 635.4','')")

    con:query("insert into check_sql values(707,'delete from transaction_total_check where cny = 707 and jpy = 70700 and gbp = 494.9 and eur = 78477 and  hkd = 636.3','')")

    con:query("insert into check_sql values(708,'delete from transaction_total_check where cny = 708 and jpy = 70800 and gbp = 495.6 and eur = 78588 and  hkd = 637.2','')")

    con:query("insert into check_sql values(709,'delete from transaction_total_check where cny = 709 and jpy = 70900 and gbp = 496.3 and eur = 78699 and  hkd = 638.1','')")

    con:query("insert into check_sql values(710,'delete from transaction_total_check where cny = 710 and jpy = 71000 and gbp = 497.0 and eur = 78810 and  hkd = 639.0','')")

    con:query("insert into check_sql values(711,'delete from transaction_total_check where cny = 711 and jpy = 71100 and gbp = 497.7 and eur = 78921 and  hkd = 639.9','')")

    con:query("insert into check_sql values(712,'delete from transaction_total_check where cny = 712 and jpy = 71200 and gbp = 498.4 and eur = 79032 and  hkd = 640.8','')")

    con:query("insert into check_sql values(713,'delete from transaction_total_check where cny = 713 and jpy = 71300 and gbp = 499.1 and eur = 79143 and  hkd = 641.7','')")

    con:query("insert into check_sql values(714,'delete from transaction_total_check where cny = 714 and jpy = 71400 and gbp = 499.8 and eur = 79254 and  hkd = 642.6','')")

    con:query("insert into check_sql values(715,'delete from transaction_total_check where cny = 715 and jpy = 71500 and gbp = 500.5 and eur = 79365 and  hkd = 643.5','')")

    con:query("insert into check_sql values(716,'delete from transaction_total_check where cny = 716 and jpy = 71600 and gbp = 501.2 and eur = 79476 and  hkd = 644.4','')")

    con:query("insert into check_sql values(717,'delete from transaction_total_check where cny = 717 and jpy = 71700 and gbp = 501.9 and eur = 79587 and  hkd = 645.3','')")

    con:query("insert into check_sql values(718,'delete from transaction_total_check where cny = 718 and jpy = 71800 and gbp = 502.6 and eur = 79698 and  hkd = 646.2','')")

    con:query("insert into check_sql values(719,'delete from transaction_total_check where cny = 719 and jpy = 71900 and gbp = 503.3 and eur = 79809 and  hkd = 647.1','')")

    con:query("insert into check_sql values(720,'delete from transaction_total_check where cny = 720 and jpy = 72000 and gbp = 504.0 and eur = 79920 and  hkd = 648.0','')")

    con:query("insert into check_sql values(721,'delete from transaction_total_check where cny = 721 and jpy = 72100 and gbp = 504.7 and eur = 80031 and  hkd = 648.9','')")

    con:query("insert into check_sql values(722,'delete from transaction_total_check where cny = 722 and jpy = 72200 and gbp = 505.4 and eur = 80142 and  hkd = 649.8','')")

    con:query("insert into check_sql values(723,'delete from transaction_total_check where cny = 723 and jpy = 72300 and gbp = 506.1 and eur = 80253 and  hkd = 650.7','')")

    con:query("insert into check_sql values(724,'delete from transaction_total_check where cny = 724 and jpy = 72400 and gbp = 506.8 and eur = 80364 and  hkd = 651.6','')")

    con:query("insert into check_sql values(725,'delete from transaction_total_check where cny = 725 and jpy = 72500 and gbp = 507.5 and eur = 80475 and  hkd = 652.5','')")

    con:query("insert into check_sql values(726,'delete from transaction_total_check where cny = 726 and jpy = 72600 and gbp = 508.2 and eur = 80586 and  hkd = 653.4','')")

    con:query("insert into check_sql values(727,'delete from transaction_total_check where cny = 727 and jpy = 72700 and gbp = 508.9 and eur = 80697 and  hkd = 654.3','')")

    con:query("insert into check_sql values(728,'delete from transaction_total_check where cny = 728 and jpy = 72800 and gbp = 509.6 and eur = 80808 and  hkd = 655.2','')")

    con:query("insert into check_sql values(729,'delete from transaction_total_check where cny = 729 and jpy = 72900 and gbp = 510.3 and eur = 80919 and  hkd = 656.1','')")

    con:query("insert into check_sql values(730,'delete from transaction_total_check where cny = 730 and jpy = 73000 and gbp = 511.0 and eur = 81030 and  hkd = 657.0','')")

    con:query("insert into check_sql values(731,'delete from transaction_total_check where cny = 731 and jpy = 73100 and gbp = 511.7 and eur = 81141 and  hkd = 657.9','')")

    con:query("insert into check_sql values(732,'delete from transaction_total_check where cny = 732 and jpy = 73200 and gbp = 512.4 and eur = 81252 and  hkd = 658.8','')")

    con:query("insert into check_sql values(733,'delete from transaction_total_check where cny = 733 and jpy = 73300 and gbp = 513.1 and eur = 81363 and  hkd = 659.7','')")

    con:query("insert into check_sql values(734,'delete from transaction_total_check where cny = 734 and jpy = 73400 and gbp = 513.8 and eur = 81474 and  hkd = 660.6','')")

    con:query("insert into check_sql values(735,'delete from transaction_total_check where cny = 735 and jpy = 73500 and gbp = 514.5 and eur = 81585 and  hkd = 661.5','')")

    con:query("insert into check_sql values(736,'delete from transaction_total_check where cny = 736 and jpy = 73600 and gbp = 515.2 and eur = 81696 and  hkd = 662.4','')")

    con:query("insert into check_sql values(737,'delete from transaction_total_check where cny = 737 and jpy = 73700 and gbp = 515.9 and eur = 81807 and  hkd = 663.3','')")

    con:query("insert into check_sql values(738,'delete from transaction_total_check where cny = 738 and jpy = 73800 and gbp = 516.6 and eur = 81918 and  hkd = 664.2','')")

    con:query("insert into check_sql values(739,'delete from transaction_total_check where cny = 739 and jpy = 73900 and gbp = 517.3 and eur = 82029 and  hkd = 665.1','')")

    con:query("insert into check_sql values(740,'delete from transaction_total_check where cny = 740 and jpy = 74000 and gbp = 518.0 and eur = 82140 and  hkd = 666.0','')")

    con:query("insert into check_sql values(741,'delete from transaction_total_check where cny = 741 and jpy = 74100 and gbp = 518.7 and eur = 82251 and  hkd = 666.9','')")

    con:query("insert into check_sql values(742,'delete from transaction_total_check where cny = 742 and jpy = 74200 and gbp = 519.4 and eur = 82362 and  hkd = 667.8','')")

    con:query("insert into check_sql values(743,'delete from transaction_total_check where cny = 743 and jpy = 74300 and gbp = 520.1 and eur = 82473 and  hkd = 668.7','')")

    con:query("insert into check_sql values(744,'delete from transaction_total_check where cny = 744 and jpy = 74400 and gbp = 520.8 and eur = 82584 and  hkd = 669.6','')")

    con:query("insert into check_sql values(745,'delete from transaction_total_check where cny = 745 and jpy = 74500 and gbp = 521.5 and eur = 82695 and  hkd = 670.5','')")

    con:query("insert into check_sql values(746,'delete from transaction_total_check where cny = 746 and jpy = 74600 and gbp = 522.2 and eur = 82806 and  hkd = 671.4','')")

    con:query("insert into check_sql values(747,'delete from transaction_total_check where cny = 747 and jpy = 74700 and gbp = 522.9 and eur = 82917 and  hkd = 672.3','')")

    con:query("insert into check_sql values(748,'delete from transaction_total_check where cny = 748 and jpy = 74800 and gbp = 523.6 and eur = 83028 and  hkd = 673.2','')")

    con:query("insert into check_sql values(749,'delete from transaction_total_check where cny = 749 and jpy = 74900 and gbp = 524.3 and eur = 83139 and  hkd = 674.1','')")

    con:query("insert into check_sql values(750,'delete from transaction_total_check where cny = 750 and jpy = 75000 and gbp = 525.0 and eur = 83250 and  hkd = 675.0','')")

    con:query("insert into check_sql values(751,'delete from transaction_total_check where cny = 751 and jpy = 75100 and gbp = 525.7 and eur = 83361 and  hkd = 675.9','')")

    con:query("insert into check_sql values(752,'delete from transaction_total_check where cny = 752 and jpy = 75200 and gbp = 526.4 and eur = 83472 and  hkd = 676.8','')")

    con:query("insert into check_sql values(753,'delete from transaction_total_check where cny = 753 and jpy = 75300 and gbp = 527.1 and eur = 83583 and  hkd = 677.7','')")

    con:query("insert into check_sql values(754,'delete from transaction_total_check where cny = 754 and jpy = 75400 and gbp = 527.8 and eur = 83694 and  hkd = 678.6','')")

    con:query("insert into check_sql values(755,'delete from transaction_total_check where cny = 755 and jpy = 75500 and gbp = 528.5 and eur = 83805 and  hkd = 679.5','')")

    con:query("insert into check_sql values(756,'delete from transaction_total_check where cny = 756 and jpy = 75600 and gbp = 529.2 and eur = 83916 and  hkd = 680.4','')")

    con:query("insert into check_sql values(757,'delete from transaction_total_check where cny = 757 and jpy = 75700 and gbp = 529.9 and eur = 84027 and  hkd = 681.3','')")

    con:query("insert into check_sql values(758,'delete from transaction_total_check where cny = 758 and jpy = 75800 and gbp = 530.6 and eur = 84138 and  hkd = 682.2','')")

    con:query("insert into check_sql values(759,'delete from transaction_total_check where cny = 759 and jpy = 75900 and gbp = 531.3 and eur = 84249 and  hkd = 683.1','')")

    con:query("insert into check_sql values(760,'delete from transaction_total_check where cny = 760 and jpy = 76000 and gbp = 532.0 and eur = 84360 and  hkd = 684.0','')")

    con:query("insert into check_sql values(761,'delete from transaction_total_check where cny = 761 and jpy = 76100 and gbp = 532.7 and eur = 84471 and  hkd = 684.9','')")

    con:query("insert into check_sql values(762,'delete from transaction_total_check where cny = 762 and jpy = 76200 and gbp = 533.4 and eur = 84582 and  hkd = 685.8','')")

    con:query("insert into check_sql values(763,'delete from transaction_total_check where cny = 763 and jpy = 76300 and gbp = 534.1 and eur = 84693 and  hkd = 686.7','')")

    con:query("insert into check_sql values(764,'delete from transaction_total_check where cny = 764 and jpy = 76400 and gbp = 534.8 and eur = 84804 and  hkd = 687.6','')")

    con:query("insert into check_sql values(765,'delete from transaction_total_check where cny = 765 and jpy = 76500 and gbp = 535.5 and eur = 84915 and  hkd = 688.5','')")

    con:query("insert into check_sql values(766,'delete from transaction_total_check where cny = 766 and jpy = 76600 and gbp = 536.2 and eur = 85026 and  hkd = 689.4','')")

    con:query("insert into check_sql values(767,'delete from transaction_total_check where cny = 767 and jpy = 76700 and gbp = 536.9 and eur = 85137 and  hkd = 690.3','')")

    con:query("insert into check_sql values(768,'delete from transaction_total_check where cny = 768 and jpy = 76800 and gbp = 537.6 and eur = 85248 and  hkd = 691.2','')")

    con:query("insert into check_sql values(769,'delete from transaction_total_check where cny = 769 and jpy = 76900 and gbp = 538.3 and eur = 85359 and  hkd = 692.1','')")

    con:query("insert into check_sql values(770,'delete from transaction_total_check where cny = 770 and jpy = 77000 and gbp = 539.0 and eur = 85470 and  hkd = 693.0','')")

    con:query("insert into check_sql values(771,'delete from transaction_total_check where cny = 771 and jpy = 77100 and gbp = 539.7 and eur = 85581 and  hkd = 693.9','')")

    con:query("insert into check_sql values(772,'delete from transaction_total_check where cny = 772 and jpy = 77200 and gbp = 540.4 and eur = 85692 and  hkd = 694.8','')")

    con:query("insert into check_sql values(773,'delete from transaction_total_check where cny = 773 and jpy = 77300 and gbp = 541.1 and eur = 85803 and  hkd = 695.7','')")

    con:query("insert into check_sql values(774,'delete from transaction_total_check where cny = 774 and jpy = 77400 and gbp = 541.8 and eur = 85914 and  hkd = 696.6','')")

    con:query("insert into check_sql values(775,'delete from transaction_total_check where cny = 775 and jpy = 77500 and gbp = 542.5 and eur = 86025 and  hkd = 697.5','')")

    con:query("insert into check_sql values(776,'delete from transaction_total_check where cny = 776 and jpy = 77600 and gbp = 543.2 and eur = 86136 and  hkd = 698.4','')")

    con:query("insert into check_sql values(777,'delete from transaction_total_check where cny = 777 and jpy = 77700 and gbp = 543.9 and eur = 86247 and  hkd = 699.3','')")

    con:query("insert into check_sql values(778,'delete from transaction_total_check where cny = 778 and jpy = 77800 and gbp = 544.6 and eur = 86358 and  hkd = 700.2','')")

    con:query("insert into check_sql values(779,'delete from transaction_total_check where cny = 779 and jpy = 77900 and gbp = 545.3 and eur = 86469 and  hkd = 701.1','')")

    con:query("insert into check_sql values(780,'delete from transaction_total_check where cny = 780 and jpy = 78000 and gbp = 546.0 and eur = 86580 and  hkd = 702.0','')")

    con:query("insert into check_sql values(781,'delete from transaction_total_check where cny = 781 and jpy = 78100 and gbp = 546.7 and eur = 86691 and  hkd = 702.9','')")

    con:query("insert into check_sql values(782,'delete from transaction_total_check where cny = 782 and jpy = 78200 and gbp = 547.4 and eur = 86802 and  hkd = 703.8','')")

    con:query("insert into check_sql values(783,'delete from transaction_total_check where cny = 783 and jpy = 78300 and gbp = 548.1 and eur = 86913 and  hkd = 704.7','')")

    con:query("insert into check_sql values(784,'delete from transaction_total_check where cny = 784 and jpy = 78400 and gbp = 548.8 and eur = 87024 and  hkd = 705.6','')")

    con:query("insert into check_sql values(785,'delete from transaction_total_check where cny = 785 and jpy = 78500 and gbp = 549.5 and eur = 87135 and  hkd = 706.5','')")

    con:query("insert into check_sql values(786,'delete from transaction_total_check where cny = 786 and jpy = 78600 and gbp = 550.2 and eur = 87246 and  hkd = 707.4','')")

    con:query("insert into check_sql values(787,'delete from transaction_total_check where cny = 787 and jpy = 78700 and gbp = 550.9 and eur = 87357 and  hkd = 708.3','')")

    con:query("insert into check_sql values(788,'delete from transaction_total_check where cny = 788 and jpy = 78800 and gbp = 551.6 and eur = 87468 and  hkd = 709.2','')")

    con:query("insert into check_sql values(789,'delete from transaction_total_check where cny = 789 and jpy = 78900 and gbp = 552.3 and eur = 87579 and  hkd = 710.1','')")

    con:query("insert into check_sql values(790,'delete from transaction_total_check where cny = 790 and jpy = 79000 and gbp = 553.0 and eur = 87690 and  hkd = 711.0','')")

    con:query("insert into check_sql values(791,'delete from transaction_total_check where cny = 791 and jpy = 79100 and gbp = 553.7 and eur = 87801 and  hkd = 711.9','')")

    con:query("insert into check_sql values(792,'delete from transaction_total_check where cny = 792 and jpy = 79200 and gbp = 554.4 and eur = 87912 and  hkd = 712.8','')")

    con:query("insert into check_sql values(793,'delete from transaction_total_check where cny = 793 and jpy = 79300 and gbp = 555.1 and eur = 88023 and  hkd = 713.7','')")

    con:query("insert into check_sql values(794,'delete from transaction_total_check where cny = 794 and jpy = 79400 and gbp = 555.8 and eur = 88134 and  hkd = 714.6','')")

    con:query("insert into check_sql values(795,'delete from transaction_total_check where cny = 795 and jpy = 79500 and gbp = 556.5 and eur = 88245 and  hkd = 715.5','')")

    con:query("insert into check_sql values(796,'delete from transaction_total_check where cny = 796 and jpy = 79600 and gbp = 557.2 and eur = 88356 and  hkd = 716.4','')")

    con:query("insert into check_sql values(797,'delete from transaction_total_check where cny = 797 and jpy = 79700 and gbp = 557.9 and eur = 88467 and  hkd = 717.3','')")

    con:query("insert into check_sql values(798,'delete from transaction_total_check where cny = 798 and jpy = 79800 and gbp = 558.6 and eur = 88578 and  hkd = 718.2','')")

    con:query("insert into check_sql values(799,'delete from transaction_total_check where cny = 799 and jpy = 79900 and gbp = 559.3 and eur = 88689 and  hkd = 719.1','')")

    con:query("insert into check_sql values(800,'delete from transaction_total_check where cny = 800 and jpy = 80000 and gbp = 560.0 and eur = 88800 and  hkd = 720.0','')")

    con:query("insert into check_sql values(801,'delete from transaction_total_check where cny = 801 and jpy = 80100 and gbp = 560.7 and eur = 88911 and  hkd = 720.9','')")

    con:query("insert into check_sql values(802,'delete from transaction_total_check where cny = 802 and jpy = 80200 and gbp = 561.4 and eur = 89022 and  hkd = 721.8','')")

    con:query("insert into check_sql values(803,'delete from transaction_total_check where cny = 803 and jpy = 80300 and gbp = 562.1 and eur = 89133 and  hkd = 722.7','')")

    con:query("insert into check_sql values(804,'delete from transaction_total_check where cny = 804 and jpy = 80400 and gbp = 562.8 and eur = 89244 and  hkd = 723.6','')")

    con:query("insert into check_sql values(805,'delete from transaction_total_check where cny = 805 and jpy = 80500 and gbp = 563.5 and eur = 89355 and  hkd = 724.5','')")

    con:query("insert into check_sql values(806,'delete from transaction_total_check where cny = 806 and jpy = 80600 and gbp = 564.2 and eur = 89466 and  hkd = 725.4','')")

    con:query("insert into check_sql values(807,'delete from transaction_total_check where cny = 807 and jpy = 80700 and gbp = 564.9 and eur = 89577 and  hkd = 726.3','')")

    con:query("insert into check_sql values(808,'delete from transaction_total_check where cny = 808 and jpy = 80800 and gbp = 565.6 and eur = 89688 and  hkd = 727.2','')")

    con:query("insert into check_sql values(809,'delete from transaction_total_check where cny = 809 and jpy = 80900 and gbp = 566.3 and eur = 89799 and  hkd = 728.1','')")

    con:query("insert into check_sql values(810,'delete from transaction_total_check where cny = 810 and jpy = 81000 and gbp = 567.0 and eur = 89910 and  hkd = 729.0','')")

    con:query("insert into check_sql values(811,'delete from transaction_total_check where cny = 811 and jpy = 81100 and gbp = 567.7 and eur = 90021 and  hkd = 729.9','')")

    con:query("insert into check_sql values(812,'delete from transaction_total_check where cny = 812 and jpy = 81200 and gbp = 568.4 and eur = 90132 and  hkd = 730.8','')")

    con:query("insert into check_sql values(813,'delete from transaction_total_check where cny = 813 and jpy = 81300 and gbp = 569.1 and eur = 90243 and  hkd = 731.7','')")

    con:query("insert into check_sql values(814,'delete from transaction_total_check where cny = 814 and jpy = 81400 and gbp = 569.8 and eur = 90354 and  hkd = 732.6','')")

    con:query("insert into check_sql values(815,'delete from transaction_total_check where cny = 815 and jpy = 81500 and gbp = 570.5 and eur = 90465 and  hkd = 733.5','')")

    con:query("insert into check_sql values(816,'delete from transaction_total_check where cny = 816 and jpy = 81600 and gbp = 571.2 and eur = 90576 and  hkd = 734.4','')")

    con:query("insert into check_sql values(817,'delete from transaction_total_check where cny = 817 and jpy = 81700 and gbp = 571.9 and eur = 90687 and  hkd = 735.3','')")

    con:query("insert into check_sql values(818,'delete from transaction_total_check where cny = 818 and jpy = 81800 and gbp = 572.6 and eur = 90798 and  hkd = 736.2','')")

    con:query("insert into check_sql values(819,'delete from transaction_total_check where cny = 819 and jpy = 81900 and gbp = 573.3 and eur = 90909 and  hkd = 737.1','')")

    con:query("insert into check_sql values(820,'delete from transaction_total_check where cny = 820 and jpy = 82000 and gbp = 574.0 and eur = 91020 and  hkd = 738.0','')")

    con:query("insert into check_sql values(821,'delete from transaction_total_check where cny = 821 and jpy = 82100 and gbp = 574.7 and eur = 91131 and  hkd = 738.9','')")

    con:query("insert into check_sql values(822,'delete from transaction_total_check where cny = 822 and jpy = 82200 and gbp = 575.4 and eur = 91242 and  hkd = 739.8','')")

    con:query("insert into check_sql values(823,'delete from transaction_total_check where cny = 823 and jpy = 82300 and gbp = 576.1 and eur = 91353 and  hkd = 740.7','')")

    con:query("insert into check_sql values(824,'delete from transaction_total_check where cny = 824 and jpy = 82400 and gbp = 576.8 and eur = 91464 and  hkd = 741.6','')")

    con:query("insert into check_sql values(825,'delete from transaction_total_check where cny = 825 and jpy = 82500 and gbp = 577.5 and eur = 91575 and  hkd = 742.5','')")

    con:query("insert into check_sql values(826,'delete from transaction_total_check where cny = 826 and jpy = 82600 and gbp = 578.2 and eur = 91686 and  hkd = 743.4','')")

    con:query("insert into check_sql values(827,'delete from transaction_total_check where cny = 827 and jpy = 82700 and gbp = 578.9 and eur = 91797 and  hkd = 744.3','')")

    con:query("insert into check_sql values(828,'delete from transaction_total_check where cny = 828 and jpy = 82800 and gbp = 579.6 and eur = 91908 and  hkd = 745.2','')")

    con:query("insert into check_sql values(829,'delete from transaction_total_check where cny = 829 and jpy = 82900 and gbp = 580.3 and eur = 92019 and  hkd = 746.1','')")

    con:query("insert into check_sql values(830,'delete from transaction_total_check where cny = 830 and jpy = 83000 and gbp = 581.0 and eur = 92130 and  hkd = 747.0','')")

    con:query("insert into check_sql values(831,'delete from transaction_total_check where cny = 831 and jpy = 83100 and gbp = 581.7 and eur = 92241 and  hkd = 747.9','')")

    con:query("insert into check_sql values(832,'delete from transaction_total_check where cny = 832 and jpy = 83200 and gbp = 582.4 and eur = 92352 and  hkd = 748.8','')")

    con:query("insert into check_sql values(833,'delete from transaction_total_check where cny = 833 and jpy = 83300 and gbp = 583.1 and eur = 92463 and  hkd = 749.7','')")

    con:query("insert into check_sql values(834,'delete from transaction_total_check where cny = 834 and jpy = 83400 and gbp = 583.8 and eur = 92574 and  hkd = 750.6','')")

    con:query("insert into check_sql values(835,'delete from transaction_total_check where cny = 835 and jpy = 83500 and gbp = 584.5 and eur = 92685 and  hkd = 751.5','')")

    con:query("insert into check_sql values(836,'delete from transaction_total_check where cny = 836 and jpy = 83600 and gbp = 585.2 and eur = 92796 and  hkd = 752.4','')")

    con:query("insert into check_sql values(837,'delete from transaction_total_check where cny = 837 and jpy = 83700 and gbp = 585.9 and eur = 92907 and  hkd = 753.3','')")

    con:query("insert into check_sql values(838,'delete from transaction_total_check where cny = 838 and jpy = 83800 and gbp = 586.6 and eur = 93018 and  hkd = 754.2','')")

    con:query("insert into check_sql values(839,'delete from transaction_total_check where cny = 839 and jpy = 83900 and gbp = 587.3 and eur = 93129 and  hkd = 755.1','')")

    con:query("insert into check_sql values(840,'delete from transaction_total_check where cny = 840 and jpy = 84000 and gbp = 588.0 and eur = 93240 and  hkd = 756.0','')")

    con:query("insert into check_sql values(841,'delete from transaction_total_check where cny = 841 and jpy = 84100 and gbp = 588.7 and eur = 93351 and  hkd = 756.9','')")

    con:query("insert into check_sql values(842,'delete from transaction_total_check where cny = 842 and jpy = 84200 and gbp = 589.4 and eur = 93462 and  hkd = 757.8','')")

    con:query("insert into check_sql values(843,'delete from transaction_total_check where cny = 843 and jpy = 84300 and gbp = 590.1 and eur = 93573 and  hkd = 758.7','')")

    con:query("insert into check_sql values(844,'delete from transaction_total_check where cny = 844 and jpy = 84400 and gbp = 590.8 and eur = 93684 and  hkd = 759.6','')")

    con:query("insert into check_sql values(845,'delete from transaction_total_check where cny = 845 and jpy = 84500 and gbp = 591.5 and eur = 93795 and  hkd = 760.5','')")

    con:query("insert into check_sql values(846,'delete from transaction_total_check where cny = 846 and jpy = 84600 and gbp = 592.2 and eur = 93906 and  hkd = 761.4','')")

    con:query("insert into check_sql values(847,'delete from transaction_total_check where cny = 847 and jpy = 84700 and gbp = 592.9 and eur = 94017 and  hkd = 762.3','')")

    con:query("insert into check_sql values(848,'delete from transaction_total_check where cny = 848 and jpy = 84800 and gbp = 593.6 and eur = 94128 and  hkd = 763.2','')")

    con:query("insert into check_sql values(849,'delete from transaction_total_check where cny = 849 and jpy = 84900 and gbp = 594.3 and eur = 94239 and  hkd = 764.1','')")

    con:query("insert into check_sql values(850,'delete from transaction_total_check where cny = 850 and jpy = 85000 and gbp = 595.0 and eur = 94350 and  hkd = 765.0','')")

    con:query("insert into check_sql values(851,'delete from transaction_total_check where cny = 851 and jpy = 85100 and gbp = 595.7 and eur = 94461 and  hkd = 765.9','')")

    con:query("insert into check_sql values(852,'delete from transaction_total_check where cny = 852 and jpy = 85200 and gbp = 596.4 and eur = 94572 and  hkd = 766.8','')")

    con:query("insert into check_sql values(853,'delete from transaction_total_check where cny = 853 and jpy = 85300 and gbp = 597.1 and eur = 94683 and  hkd = 767.7','')")

    con:query("insert into check_sql values(854,'delete from transaction_total_check where cny = 854 and jpy = 85400 and gbp = 597.8 and eur = 94794 and  hkd = 768.6','')")

    con:query("insert into check_sql values(855,'delete from transaction_total_check where cny = 855 and jpy = 85500 and gbp = 598.5 and eur = 94905 and  hkd = 769.5','')")

    con:query("insert into check_sql values(856,'delete from transaction_total_check where cny = 856 and jpy = 85600 and gbp = 599.2 and eur = 95016 and  hkd = 770.4','')")

    con:query("insert into check_sql values(857,'delete from transaction_total_check where cny = 857 and jpy = 85700 and gbp = 599.9 and eur = 95127 and  hkd = 771.3','')")

    con:query("insert into check_sql values(858,'delete from transaction_total_check where cny = 858 and jpy = 85800 and gbp = 600.6 and eur = 95238 and  hkd = 772.2','')")

    con:query("insert into check_sql values(859,'delete from transaction_total_check where cny = 859 and jpy = 85900 and gbp = 601.3 and eur = 95349 and  hkd = 773.1','')")

    con:query("insert into check_sql values(860,'delete from transaction_total_check where cny = 860 and jpy = 86000 and gbp = 602.0 and eur = 95460 and  hkd = 774.0','')")

    con:query("insert into check_sql values(861,'delete from transaction_total_check where cny = 861 and jpy = 86100 and gbp = 602.7 and eur = 95571 and  hkd = 774.9','')")

    con:query("insert into check_sql values(862,'delete from transaction_total_check where cny = 862 and jpy = 86200 and gbp = 603.4 and eur = 95682 and  hkd = 775.8','')")

    con:query("insert into check_sql values(863,'delete from transaction_total_check where cny = 863 and jpy = 86300 and gbp = 604.1 and eur = 95793 and  hkd = 776.7','')")

    con:query("insert into check_sql values(864,'delete from transaction_total_check where cny = 864 and jpy = 86400 and gbp = 604.8 and eur = 95904 and  hkd = 777.6','')")

    con:query("insert into check_sql values(865,'delete from transaction_total_check where cny = 865 and jpy = 86500 and gbp = 605.5 and eur = 96015 and  hkd = 778.5','')")

    con:query("insert into check_sql values(866,'delete from transaction_total_check where cny = 866 and jpy = 86600 and gbp = 606.2 and eur = 96126 and  hkd = 779.4','')")

    con:query("insert into check_sql values(867,'delete from transaction_total_check where cny = 867 and jpy = 86700 and gbp = 606.9 and eur = 96237 and  hkd = 780.3','')")

    con:query("insert into check_sql values(868,'delete from transaction_total_check where cny = 868 and jpy = 86800 and gbp = 607.6 and eur = 96348 and  hkd = 781.2','')")

    con:query("insert into check_sql values(869,'delete from transaction_total_check where cny = 869 and jpy = 86900 and gbp = 608.3 and eur = 96459 and  hkd = 782.1','')")

    con:query("insert into check_sql values(870,'delete from transaction_total_check where cny = 870 and jpy = 87000 and gbp = 609.0 and eur = 96570 and  hkd = 783.0','')")

    con:query("insert into check_sql values(871,'delete from transaction_total_check where cny = 871 and jpy = 87100 and gbp = 609.7 and eur = 96681 and  hkd = 783.9','')")

    con:query("insert into check_sql values(872,'delete from transaction_total_check where cny = 872 and jpy = 87200 and gbp = 610.4 and eur = 96792 and  hkd = 784.8','')")

    con:query("insert into check_sql values(873,'delete from transaction_total_check where cny = 873 and jpy = 87300 and gbp = 611.1 and eur = 96903 and  hkd = 785.7','')")

    con:query("insert into check_sql values(874,'delete from transaction_total_check where cny = 874 and jpy = 87400 and gbp = 611.8 and eur = 97014 and  hkd = 786.6','')")

    con:query("insert into check_sql values(875,'delete from transaction_total_check where cny = 875 and jpy = 87500 and gbp = 612.5 and eur = 97125 and  hkd = 787.5','')")

    con:query("insert into check_sql values(876,'delete from transaction_total_check where cny = 876 and jpy = 87600 and gbp = 613.2 and eur = 97236 and  hkd = 788.4','')")

    con:query("insert into check_sql values(877,'delete from transaction_total_check where cny = 877 and jpy = 87700 and gbp = 613.9 and eur = 97347 and  hkd = 789.3','')")

    con:query("insert into check_sql values(878,'delete from transaction_total_check where cny = 878 and jpy = 87800 and gbp = 614.6 and eur = 97458 and  hkd = 790.2','')")

    con:query("insert into check_sql values(879,'delete from transaction_total_check where cny = 879 and jpy = 87900 and gbp = 615.3 and eur = 97569 and  hkd = 791.1','')")

    con:query("insert into check_sql values(880,'delete from transaction_total_check where cny = 880 and jpy = 88000 and gbp = 616.0 and eur = 97680 and  hkd = 792.0','')")

    con:query("insert into check_sql values(881,'delete from transaction_total_check where cny = 881 and jpy = 88100 and gbp = 616.7 and eur = 97791 and  hkd = 792.9','')")

    con:query("insert into check_sql values(882,'delete from transaction_total_check where cny = 882 and jpy = 88200 and gbp = 617.4 and eur = 97902 and  hkd = 793.8','')")

    con:query("insert into check_sql values(883,'delete from transaction_total_check where cny = 883 and jpy = 88300 and gbp = 618.1 and eur = 98013 and  hkd = 794.7','')")

    con:query("insert into check_sql values(884,'delete from transaction_total_check where cny = 884 and jpy = 88400 and gbp = 618.8 and eur = 98124 and  hkd = 795.6','')")

    con:query("insert into check_sql values(885,'delete from transaction_total_check where cny = 885 and jpy = 88500 and gbp = 619.5 and eur = 98235 and  hkd = 796.5','')")

    con:query("insert into check_sql values(886,'delete from transaction_total_check where cny = 886 and jpy = 88600 and gbp = 620.2 and eur = 98346 and  hkd = 797.4','')")

    con:query("insert into check_sql values(887,'delete from transaction_total_check where cny = 887 and jpy = 88700 and gbp = 620.9 and eur = 98457 and  hkd = 798.3','')")

    con:query("insert into check_sql values(888,'delete from transaction_total_check where cny = 888 and jpy = 88800 and gbp = 621.6 and eur = 98568 and  hkd = 799.2','')")

    con:query("insert into check_sql values(889,'delete from transaction_total_check where cny = 889 and jpy = 88900 and gbp = 622.3 and eur = 98679 and  hkd = 800.1','')")

    con:query("insert into check_sql values(890,'delete from transaction_total_check where cny = 890 and jpy = 89000 and gbp = 623.0 and eur = 98790 and  hkd = 801.0','')")

    con:query("insert into check_sql values(891,'delete from transaction_total_check where cny = 891 and jpy = 89100 and gbp = 623.7 and eur = 98901 and  hkd = 801.9','')")

    con:query("insert into check_sql values(892,'delete from transaction_total_check where cny = 892 and jpy = 89200 and gbp = 624.4 and eur = 99012 and  hkd = 802.8','')")

    con:query("insert into check_sql values(893,'delete from transaction_total_check where cny = 893 and jpy = 89300 and gbp = 625.1 and eur = 99123 and  hkd = 803.7','')")

    con:query("insert into check_sql values(894,'delete from transaction_total_check where cny = 894 and jpy = 89400 and gbp = 625.8 and eur = 99234 and  hkd = 804.6','')")

    con:query("insert into check_sql values(895,'delete from transaction_total_check where cny = 895 and jpy = 89500 and gbp = 626.5 and eur = 99345 and  hkd = 805.5','')")

    con:query("insert into check_sql values(896,'delete from transaction_total_check where cny = 896 and jpy = 89600 and gbp = 627.2 and eur = 99456 and  hkd = 806.4','')")

    con:query("insert into check_sql values(897,'delete from transaction_total_check where cny = 897 and jpy = 89700 and gbp = 627.9 and eur = 99567 and  hkd = 807.3','')")

    con:query("insert into check_sql values(898,'delete from transaction_total_check where cny = 898 and jpy = 89800 and gbp = 628.6 and eur = 99678 and  hkd = 808.2','')")

    con:query("insert into check_sql values(899,'delete from transaction_total_check where cny = 899 and jpy = 89900 and gbp = 629.3 and eur = 99789 and  hkd = 809.1','')")

    con:query("insert into check_sql values(900,'delete from transaction_total_check where cny = 900 and jpy = 90000 and gbp = 630.0 and eur = 99900 and  hkd = 810.0','')")

    con:query("insert into check_sql values(901,'delete from transaction_total_check where cny = 901 and jpy = 90100 and gbp = 630.7 and eur = 100011 and  hkd = 810.9','')")

    con:query("insert into check_sql values(902,'delete from transaction_total_check where cny = 902 and jpy = 90200 and gbp = 631.4 and eur = 100122 and  hkd = 811.8','')")

    con:query("insert into check_sql values(903,'delete from transaction_total_check where cny = 903 and jpy = 90300 and gbp = 632.1 and eur = 100233 and  hkd = 812.7','')")

    con:query("insert into check_sql values(904,'delete from transaction_total_check where cny = 904 and jpy = 90400 and gbp = 632.8 and eur = 100344 and  hkd = 813.6','')")

    con:query("insert into check_sql values(905,'delete from transaction_total_check where cny = 905 and jpy = 90500 and gbp = 633.5 and eur = 100455 and  hkd = 814.5','')")

    con:query("insert into check_sql values(906,'delete from transaction_total_check where cny = 906 and jpy = 90600 and gbp = 634.2 and eur = 100566 and  hkd = 815.4','')")

    con:query("insert into check_sql values(907,'delete from transaction_total_check where cny = 907 and jpy = 90700 and gbp = 634.9 and eur = 100677 and  hkd = 816.3','')")

    con:query("insert into check_sql values(908,'delete from transaction_total_check where cny = 908 and jpy = 90800 and gbp = 635.6 and eur = 100788 and  hkd = 817.2','')")

    con:query("insert into check_sql values(909,'delete from transaction_total_check where cny = 909 and jpy = 90900 and gbp = 636.3 and eur = 100899 and  hkd = 818.1','')")

    con:query("insert into check_sql values(910,'delete from transaction_total_check where cny = 910 and jpy = 91000 and gbp = 637.0 and eur = 101010 and  hkd = 819.0','')")

    con:query("insert into check_sql values(911,'delete from transaction_total_check where cny = 911 and jpy = 91100 and gbp = 637.7 and eur = 101121 and  hkd = 819.9','')")

    con:query("insert into check_sql values(912,'delete from transaction_total_check where cny = 912 and jpy = 91200 and gbp = 638.4 and eur = 101232 and  hkd = 820.8','')")

    con:query("insert into check_sql values(913,'delete from transaction_total_check where cny = 913 and jpy = 91300 and gbp = 639.1 and eur = 101343 and  hkd = 821.7','')")

    con:query("insert into check_sql values(914,'delete from transaction_total_check where cny = 914 and jpy = 91400 and gbp = 639.8 and eur = 101454 and  hkd = 822.6','')")

    con:query("insert into check_sql values(915,'delete from transaction_total_check where cny = 915 and jpy = 91500 and gbp = 640.5 and eur = 101565 and  hkd = 823.5','')")

    con:query("insert into check_sql values(916,'delete from transaction_total_check where cny = 916 and jpy = 91600 and gbp = 641.2 and eur = 101676 and  hkd = 824.4','')")

    con:query("insert into check_sql values(917,'delete from transaction_total_check where cny = 917 and jpy = 91700 and gbp = 641.9 and eur = 101787 and  hkd = 825.3','')")

    con:query("insert into check_sql values(918,'delete from transaction_total_check where cny = 918 and jpy = 91800 and gbp = 642.6 and eur = 101898 and  hkd = 826.2','')")

    con:query("insert into check_sql values(919,'delete from transaction_total_check where cny = 919 and jpy = 91900 and gbp = 643.3 and eur = 102009 and  hkd = 827.1','')")

    con:query("insert into check_sql values(920,'delete from transaction_total_check where cny = 920 and jpy = 92000 and gbp = 644.0 and eur = 102120 and  hkd = 828.0','')")

    con:query("insert into check_sql values(921,'delete from transaction_total_check where cny = 921 and jpy = 92100 and gbp = 644.7 and eur = 102231 and  hkd = 828.9','')")

    con:query("insert into check_sql values(922,'delete from transaction_total_check where cny = 922 and jpy = 92200 and gbp = 645.4 and eur = 102342 and  hkd = 829.8','')")

    con:query("insert into check_sql values(923,'delete from transaction_total_check where cny = 923 and jpy = 92300 and gbp = 646.1 and eur = 102453 and  hkd = 830.7','')")

    con:query("insert into check_sql values(924,'delete from transaction_total_check where cny = 924 and jpy = 92400 and gbp = 646.8 and eur = 102564 and  hkd = 831.6','')")

    con:query("insert into check_sql values(925,'delete from transaction_total_check where cny = 925 and jpy = 92500 and gbp = 647.5 and eur = 102675 and  hkd = 832.5','')")

    con:query("insert into check_sql values(926,'delete from transaction_total_check where cny = 926 and jpy = 92600 and gbp = 648.2 and eur = 102786 and  hkd = 833.4','')")

    con:query("insert into check_sql values(927,'delete from transaction_total_check where cny = 927 and jpy = 92700 and gbp = 648.9 and eur = 102897 and  hkd = 834.3','')")

    con:query("insert into check_sql values(928,'delete from transaction_total_check where cny = 928 and jpy = 92800 and gbp = 649.6 and eur = 103008 and  hkd = 835.2','')")

    con:query("insert into check_sql values(929,'delete from transaction_total_check where cny = 929 and jpy = 92900 and gbp = 650.3 and eur = 103119 and  hkd = 836.1','')")

    con:query("insert into check_sql values(930,'delete from transaction_total_check where cny = 930 and jpy = 93000 and gbp = 651.0 and eur = 103230 and  hkd = 837.0','')")

    con:query("insert into check_sql values(931,'delete from transaction_total_check where cny = 931 and jpy = 93100 and gbp = 651.7 and eur = 103341 and  hkd = 837.9','')")

    con:query("insert into check_sql values(932,'delete from transaction_total_check where cny = 932 and jpy = 93200 and gbp = 652.4 and eur = 103452 and  hkd = 838.8','')")

    con:query("insert into check_sql values(933,'delete from transaction_total_check where cny = 933 and jpy = 93300 and gbp = 653.1 and eur = 103563 and  hkd = 839.7','')")

    con:query("insert into check_sql values(934,'delete from transaction_total_check where cny = 934 and jpy = 93400 and gbp = 653.8 and eur = 103674 and  hkd = 840.6','')")

    con:query("insert into check_sql values(935,'delete from transaction_total_check where cny = 935 and jpy = 93500 and gbp = 654.5 and eur = 103785 and  hkd = 841.5','')")

    con:query("insert into check_sql values(936,'delete from transaction_total_check where cny = 936 and jpy = 93600 and gbp = 655.2 and eur = 103896 and  hkd = 842.4','')")

    con:query("insert into check_sql values(937,'delete from transaction_total_check where cny = 937 and jpy = 93700 and gbp = 655.9 and eur = 104007 and  hkd = 843.3','')")

    con:query("insert into check_sql values(938,'delete from transaction_total_check where cny = 938 and jpy = 93800 and gbp = 656.6 and eur = 104118 and  hkd = 844.2','')")

    con:query("insert into check_sql values(939,'delete from transaction_total_check where cny = 939 and jpy = 93900 and gbp = 657.3 and eur = 104229 and  hkd = 845.1','')")

    con:query("insert into check_sql values(940,'delete from transaction_total_check where cny = 940 and jpy = 94000 and gbp = 658.0 and eur = 104340 and  hkd = 846.0','')")

    con:query("insert into check_sql values(941,'delete from transaction_total_check where cny = 941 and jpy = 94100 and gbp = 658.7 and eur = 104451 and  hkd = 846.9','')")

    con:query("insert into check_sql values(942,'delete from transaction_total_check where cny = 942 and jpy = 94200 and gbp = 659.4 and eur = 104562 and  hkd = 847.8','')")

    con:query("insert into check_sql values(943,'delete from transaction_total_check where cny = 943 and jpy = 94300 and gbp = 660.1 and eur = 104673 and  hkd = 848.7','')")

    con:query("insert into check_sql values(944,'delete from transaction_total_check where cny = 944 and jpy = 94400 and gbp = 660.8 and eur = 104784 and  hkd = 849.6','')")

    con:query("insert into check_sql values(945,'delete from transaction_total_check where cny = 945 and jpy = 94500 and gbp = 661.5 and eur = 104895 and  hkd = 850.5','')")

    con:query("insert into check_sql values(946,'delete from transaction_total_check where cny = 946 and jpy = 94600 and gbp = 662.2 and eur = 105006 and  hkd = 851.4','')")

    con:query("insert into check_sql values(947,'delete from transaction_total_check where cny = 947 and jpy = 94700 and gbp = 662.9 and eur = 105117 and  hkd = 852.3','')")

    con:query("insert into check_sql values(948,'delete from transaction_total_check where cny = 948 and jpy = 94800 and gbp = 663.6 and eur = 105228 and  hkd = 853.2','')")

    con:query("insert into check_sql values(949,'delete from transaction_total_check where cny = 949 and jpy = 94900 and gbp = 664.3 and eur = 105339 and  hkd = 854.1','')")

    con:query("insert into check_sql values(950,'delete from transaction_total_check where cny = 950 and jpy = 95000 and gbp = 665.0 and eur = 105450 and  hkd = 855.0','')")

    con:query("insert into check_sql values(951,'delete from transaction_total_check where cny = 951 and jpy = 95100 and gbp = 665.7 and eur = 105561 and  hkd = 855.9','')")

    con:query("insert into check_sql values(952,'delete from transaction_total_check where cny = 952 and jpy = 95200 and gbp = 666.4 and eur = 105672 and  hkd = 856.8','')")

    con:query("insert into check_sql values(953,'delete from transaction_total_check where cny = 953 and jpy = 95300 and gbp = 667.1 and eur = 105783 and  hkd = 857.7','')")

    con:query("insert into check_sql values(954,'delete from transaction_total_check where cny = 954 and jpy = 95400 and gbp = 667.8 and eur = 105894 and  hkd = 858.6','')")

    con:query("insert into check_sql values(955,'delete from transaction_total_check where cny = 955 and jpy = 95500 and gbp = 668.5 and eur = 106005 and  hkd = 859.5','')")

    con:query("insert into check_sql values(956,'delete from transaction_total_check where cny = 956 and jpy = 95600 and gbp = 669.2 and eur = 106116 and  hkd = 860.4','')")

    con:query("insert into check_sql values(957,'delete from transaction_total_check where cny = 957 and jpy = 95700 and gbp = 669.9 and eur = 106227 and  hkd = 861.3','')")

    con:query("insert into check_sql values(958,'delete from transaction_total_check where cny = 958 and jpy = 95800 and gbp = 670.6 and eur = 106338 and  hkd = 862.2','')")

    con:query("insert into check_sql values(959,'delete from transaction_total_check where cny = 959 and jpy = 95900 and gbp = 671.3 and eur = 106449 and  hkd = 863.1','')")

    con:query("insert into check_sql values(960,'delete from transaction_total_check where cny = 960 and jpy = 96000 and gbp = 672.0 and eur = 106560 and  hkd = 864.0','')")

    con:query("insert into check_sql values(961,'delete from transaction_total_check where cny = 961 and jpy = 96100 and gbp = 672.7 and eur = 106671 and  hkd = 864.9','')")

    con:query("insert into check_sql values(962,'delete from transaction_total_check where cny = 962 and jpy = 96200 and gbp = 673.4 and eur = 106782 and  hkd = 865.8','')")

    con:query("insert into check_sql values(963,'delete from transaction_total_check where cny = 963 and jpy = 96300 and gbp = 674.1 and eur = 106893 and  hkd = 866.7','')")

    con:query("insert into check_sql values(964,'delete from transaction_total_check where cny = 964 and jpy = 96400 and gbp = 674.8 and eur = 107004 and  hkd = 867.6','')")

    con:query("insert into check_sql values(965,'delete from transaction_total_check where cny = 965 and jpy = 96500 and gbp = 675.5 and eur = 107115 and  hkd = 868.5','')")

    con:query("insert into check_sql values(966,'delete from transaction_total_check where cny = 966 and jpy = 96600 and gbp = 676.2 and eur = 107226 and  hkd = 869.4','')")

    con:query("insert into check_sql values(967,'delete from transaction_total_check where cny = 967 and jpy = 96700 and gbp = 676.9 and eur = 107337 and  hkd = 870.3','')")

    con:query("insert into check_sql values(968,'delete from transaction_total_check where cny = 968 and jpy = 96800 and gbp = 677.6 and eur = 107448 and  hkd = 871.2','')")

    con:query("insert into check_sql values(969,'delete from transaction_total_check where cny = 969 and jpy = 96900 and gbp = 678.3 and eur = 107559 and  hkd = 872.1','')")

    con:query("insert into check_sql values(970,'delete from transaction_total_check where cny = 970 and jpy = 97000 and gbp = 679.0 and eur = 107670 and  hkd = 873.0','')")

    con:query("insert into check_sql values(971,'delete from transaction_total_check where cny = 971 and jpy = 97100 and gbp = 679.7 and eur = 107781 and  hkd = 873.9','')")

    con:query("insert into check_sql values(972,'delete from transaction_total_check where cny = 972 and jpy = 97200 and gbp = 680.4 and eur = 107892 and  hkd = 874.8','')")

    con:query("insert into check_sql values(973,'delete from transaction_total_check where cny = 973 and jpy = 97300 and gbp = 681.1 and eur = 108003 and  hkd = 875.7','')")

    con:query("insert into check_sql values(974,'delete from transaction_total_check where cny = 974 and jpy = 97400 and gbp = 681.8 and eur = 108114 and  hkd = 876.6','')")

    con:query("insert into check_sql values(975,'delete from transaction_total_check where cny = 975 and jpy = 97500 and gbp = 682.5 and eur = 108225 and  hkd = 877.5','')")

    con:query("insert into check_sql values(976,'delete from transaction_total_check where cny = 976 and jpy = 97600 and gbp = 683.2 and eur = 108336 and  hkd = 878.4','')")

    con:query("insert into check_sql values(977,'delete from transaction_total_check where cny = 977 and jpy = 97700 and gbp = 683.9 and eur = 108447 and  hkd = 879.3','')")

    con:query("insert into check_sql values(978,'delete from transaction_total_check where cny = 978 and jpy = 97800 and gbp = 684.6 and eur = 108558 and  hkd = 880.2','')")

    con:query("insert into check_sql values(979,'delete from transaction_total_check where cny = 979 and jpy = 97900 and gbp = 685.3 and eur = 108669 and  hkd = 881.1','')")

    con:query("insert into check_sql values(980,'delete from transaction_total_check where cny = 980 and jpy = 98000 and gbp = 686.0 and eur = 108780 and  hkd = 882.0','')")

    con:query("insert into check_sql values(981,'delete from transaction_total_check where cny = 981 and jpy = 98100 and gbp = 686.7 and eur = 108891 and  hkd = 882.9','')")

    con:query("insert into check_sql values(982,'delete from transaction_total_check where cny = 982 and jpy = 98200 and gbp = 687.4 and eur = 109002 and  hkd = 883.8','')")

    con:query("insert into check_sql values(983,'delete from transaction_total_check where cny = 983 and jpy = 98300 and gbp = 688.1 and eur = 109113 and  hkd = 884.7','')")

    con:query("insert into check_sql values(984,'delete from transaction_total_check where cny = 984 and jpy = 98400 and gbp = 688.8 and eur = 109224 and  hkd = 885.6','')")

    con:query("insert into check_sql values(985,'delete from transaction_total_check where cny = 985 and jpy = 98500 and gbp = 689.5 and eur = 109335 and  hkd = 886.5','')")

    con:query("insert into check_sql values(986,'delete from transaction_total_check where cny = 986 and jpy = 98600 and gbp = 690.2 and eur = 109446 and  hkd = 887.4','')")

    con:query("insert into check_sql values(987,'delete from transaction_total_check where cny = 987 and jpy = 98700 and gbp = 690.9 and eur = 109557 and  hkd = 888.3','')")

    con:query("insert into check_sql values(988,'delete from transaction_total_check where cny = 988 and jpy = 98800 and gbp = 691.6 and eur = 109668 and  hkd = 889.2','')")

    con:query("insert into check_sql values(989,'delete from transaction_total_check where cny = 989 and jpy = 98900 and gbp = 692.3 and eur = 109779 and  hkd = 890.1','')")

    con:query("insert into check_sql values(990,'delete from transaction_total_check where cny = 990 and jpy = 99000 and gbp = 693.0 and eur = 109890 and  hkd = 891.0','')")

    con:query("insert into check_sql values(991,'delete from transaction_total_check where cny = 991 and jpy = 99100 and gbp = 693.7 and eur = 110001 and  hkd = 891.9','')")

    con:query("insert into check_sql values(992,'delete from transaction_total_check where cny = 992 and jpy = 99200 and gbp = 694.4 and eur = 110112 and  hkd = 892.8','')")

    con:query("insert into check_sql values(993,'delete from transaction_total_check where cny = 993 and jpy = 99300 and gbp = 695.1 and eur = 110223 and  hkd = 893.7','')")

    con:query("insert into check_sql values(994,'delete from transaction_total_check where cny = 994 and jpy = 99400 and gbp = 695.8 and eur = 110334 and  hkd = 894.6','')")

    con:query("insert into check_sql values(995,'delete from transaction_total_check where cny = 995 and jpy = 99500 and gbp = 696.5 and eur = 110445 and  hkd = 895.5','')")

    con:query("insert into check_sql values(996,'delete from transaction_total_check where cny = 996 and jpy = 99600 and gbp = 697.2 and eur = 110556 and  hkd = 896.4','')")

    con:query("insert into check_sql values(997,'delete from transaction_total_check where cny = 997 and jpy = 99700 and gbp = 697.9 and eur = 110667 and  hkd = 897.3','')")

    con:query("insert into check_sql values(998,'delete from transaction_total_check where cny = 998 and jpy = 99800 and gbp = 698.6 and eur = 110778 and  hkd = 898.2','')")

    con:query("insert into check_sql values(999,'delete from transaction_total_check where cny = 999 and jpy = 99900 and gbp = 699.3 and eur = 110889 and  hkd = 899.1','')")

    con:query("insert into check_sql values(1000,'delete from transaction_total_check where cny = 1000 and jpy = 100000 and gbp = 700.0 and eur = 111000 and  hkd = 900.0','')")

    con:query("insert into check_sql values(1001,'delete from transaction_total_check where cny = 1001 and jpy = 100100 and gbp = 700.7 and eur = 111111 and  hkd = 900.9','')")

    con:query("insert into check_sql values(1002,'delete from transaction_total_check where cny = 1002 and jpy = 100200 and gbp = 701.4 and eur = 111222 and  hkd = 901.8','')")

    con:query("insert into check_sql values(1003,'delete from transaction_total_check where cny = 1003 and jpy = 100300 and gbp = 702.1 and eur = 111333 and  hkd = 902.7','')")

    con:query("insert into check_sql values(1004,'delete from transaction_total_check where cny = 1004 and jpy = 100400 and gbp = 702.8 and eur = 111444 and  hkd = 903.6','')")

    con:query("insert into check_sql values(1005,'delete from transaction_total_check where cny = 1005 and jpy = 100500 and gbp = 703.5 and eur = 111555 and  hkd = 904.5','')")

    con:query("insert into check_sql values(1006,'delete from transaction_total_check where cny = 1006 and jpy = 100600 and gbp = 704.2 and eur = 111666 and  hkd = 905.4','')")

    con:query("insert into check_sql values(1007,'delete from transaction_total_check where cny = 1007 and jpy = 100700 and gbp = 704.9 and eur = 111777 and  hkd = 906.3','')")

    con:query("insert into check_sql values(1008,'delete from transaction_total_check where cny = 1008 and jpy = 100800 and gbp = 705.6 and eur = 111888 and  hkd = 907.2','')")

    con:query("insert into check_sql values(1009,'delete from transaction_total_check where cny = 1009 and jpy = 100900 and gbp = 706.3 and eur = 111999 and  hkd = 908.1','')")

    con:query("insert into check_sql values(1010,'delete from transaction_total_check where cny = 1010 and jpy = 101000 and gbp = 707.0 and eur = 112110 and  hkd = 909.0','')")

    con:query("insert into check_sql values(1011,'delete from transaction_total_check where cny = 1011 and jpy = 101100 and gbp = 707.7 and eur = 112221 and  hkd = 909.9','')")

    con:query("insert into check_sql values(1012,'delete from transaction_total_check where cny = 1012 and jpy = 101200 and gbp = 708.4 and eur = 112332 and  hkd = 910.8','')")

    con:query("insert into check_sql values(1013,'delete from transaction_total_check where cny = 1013 and jpy = 101300 and gbp = 709.1 and eur = 112443 and  hkd = 911.7','')")

    con:query("insert into check_sql values(1014,'delete from transaction_total_check where cny = 1014 and jpy = 101400 and gbp = 709.8 and eur = 112554 and  hkd = 912.6','')")

    con:query("insert into check_sql values(1015,'delete from transaction_total_check where cny = 1015 and jpy = 101500 and gbp = 710.5 and eur = 112665 and  hkd = 913.5','')")

    con:query("insert into check_sql values(1016,'delete from transaction_total_check where cny = 1016 and jpy = 101600 and gbp = 711.2 and eur = 112776 and  hkd = 914.4','')")

    con:query("insert into check_sql values(1017,'delete from transaction_total_check where cny = 1017 and jpy = 101700 and gbp = 711.9 and eur = 112887 and  hkd = 915.3','')")

    con:query("insert into check_sql values(1018,'delete from transaction_total_check where cny = 1018 and jpy = 101800 and gbp = 712.6 and eur = 112998 and  hkd = 916.2','')")

    con:query("insert into check_sql values(1019,'delete from transaction_total_check where cny = 1019 and jpy = 101900 and gbp = 713.3 and eur = 113109 and  hkd = 917.1','')")

    con:query("insert into check_sql values(1020,'delete from transaction_total_check where cny = 1020 and jpy = 102000 and gbp = 714.0 and eur = 113220 and  hkd = 918.0','')")

    con:query("insert into check_sql values(1021,'delete from transaction_total_check where cny = 1021 and jpy = 102100 and gbp = 714.7 and eur = 113331 and  hkd = 918.9','')")

    con:query("insert into check_sql values(1022,'delete from transaction_total_check where cny = 1022 and jpy = 102200 and gbp = 715.4 and eur = 113442 and  hkd = 919.8','')")

    con:query("insert into check_sql values(1023,'delete from transaction_total_check where cny = 1023 and jpy = 102300 and gbp = 716.1 and eur = 113553 and  hkd = 920.7','')")

    con:query("insert into check_sql values(1024,'delete from transaction_total_check where cny = 1024 and jpy = 102400 and gbp = 716.8 and eur = 113664 and  hkd = 921.6','')")

    con:query("insert into check_sql values(1025,'delete from transaction_total_check where cny = 1025 and jpy = 102500 and gbp = 717.5 and eur = 113775 and  hkd = 922.5','')")

    con:query("insert into check_sql values(1026,'delete from transaction_total_check where cny = 1026 and jpy = 102600 and gbp = 718.2 and eur = 113886 and  hkd = 923.4','')")

    con:query("insert into check_sql values(1027,'delete from transaction_total_check where cny = 1027 and jpy = 102700 and gbp = 718.9 and eur = 113997 and  hkd = 924.3','')")

    con:query("insert into check_sql values(1028,'delete from transaction_total_check where cny = 1028 and jpy = 102800 and gbp = 719.6 and eur = 114108 and  hkd = 925.2','')")

    con:query("insert into check_sql values(1029,'delete from transaction_total_check where cny = 1029 and jpy = 102900 and gbp = 720.3 and eur = 114219 and  hkd = 926.1','')")

    con:query("insert into check_sql values(1030,'delete from transaction_total_check where cny = 1030 and jpy = 103000 and gbp = 721.0 and eur = 114330 and  hkd = 927.0','')")

    con:query("insert into check_sql values(1031,'delete from transaction_total_check where cny = 1031 and jpy = 103100 and gbp = 721.7 and eur = 114441 and  hkd = 927.9','')")

    con:query("insert into check_sql values(1032,'delete from transaction_total_check where cny = 1032 and jpy = 103200 and gbp = 722.4 and eur = 114552 and  hkd = 928.8','')")

    con:query("insert into check_sql values(1033,'delete from transaction_total_check where cny = 1033 and jpy = 103300 and gbp = 723.1 and eur = 114663 and  hkd = 929.7','')")

    con:query("insert into check_sql values(1034,'delete from transaction_total_check where cny = 1034 and jpy = 103400 and gbp = 723.8 and eur = 114774 and  hkd = 930.6','')")

    con:query("insert into check_sql values(1035,'delete from transaction_total_check where cny = 1035 and jpy = 103500 and gbp = 724.5 and eur = 114885 and  hkd = 931.5','')")

    con:query("insert into check_sql values(1036,'delete from transaction_total_check where cny = 1036 and jpy = 103600 and gbp = 725.2 and eur = 114996 and  hkd = 932.4','')")

    con:query("insert into check_sql values(1037,'delete from transaction_total_check where cny = 1037 and jpy = 103700 and gbp = 725.9 and eur = 115107 and  hkd = 933.3','')")

    con:query("insert into check_sql values(1038,'delete from transaction_total_check where cny = 1038 and jpy = 103800 and gbp = 726.6 and eur = 115218 and  hkd = 934.2','')")

    con:query("insert into check_sql values(1039,'delete from transaction_total_check where cny = 1039 and jpy = 103900 and gbp = 727.3 and eur = 115329 and  hkd = 935.1','')")

    con:query("insert into check_sql values(1040,'delete from transaction_total_check where cny = 1040 and jpy = 104000 and gbp = 728.0 and eur = 115440 and  hkd = 936.0','')")

    con:query("insert into check_sql values(1041,'delete from transaction_total_check where cny = 1041 and jpy = 104100 and gbp = 728.7 and eur = 115551 and  hkd = 936.9','')")

    con:query("insert into check_sql values(1042,'delete from transaction_total_check where cny = 1042 and jpy = 104200 and gbp = 729.4 and eur = 115662 and  hkd = 937.8','')")

    con:query("insert into check_sql values(1043,'delete from transaction_total_check where cny = 1043 and jpy = 104300 and gbp = 730.1 and eur = 115773 and  hkd = 938.7','')")

    con:query("insert into check_sql values(1044,'delete from transaction_total_check where cny = 1044 and jpy = 104400 and gbp = 730.8 and eur = 115884 and  hkd = 939.6','')")

    con:query("insert into check_sql values(1045,'delete from transaction_total_check where cny = 1045 and jpy = 104500 and gbp = 731.5 and eur = 115995 and  hkd = 940.5','')")

    con:query("insert into check_sql values(1046,'delete from transaction_total_check where cny = 1046 and jpy = 104600 and gbp = 732.2 and eur = 116106 and  hkd = 941.4','')")

    con:query("insert into check_sql values(1047,'delete from transaction_total_check where cny = 1047 and jpy = 104700 and gbp = 732.9 and eur = 116217 and  hkd = 942.3','')")

    con:query("insert into check_sql values(1048,'delete from transaction_total_check where cny = 1048 and jpy = 104800 and gbp = 733.6 and eur = 116328 and  hkd = 943.2','')")

    con:query("insert into check_sql values(1049,'delete from transaction_total_check where cny = 1049 and jpy = 104900 and gbp = 734.3 and eur = 116439 and  hkd = 944.1','')")

    con:query("insert into check_sql values(1050,'delete from transaction_total_check where cny = 1050 and jpy = 105000 and gbp = 735.0 and eur = 116550 and  hkd = 945.0','')")

    con:query("insert into check_sql values(1051,'delete from transaction_total_check where cny = 1051 and jpy = 105100 and gbp = 735.7 and eur = 116661 and  hkd = 945.9','')")

    con:query("insert into check_sql values(1052,'delete from transaction_total_check where cny = 1052 and jpy = 105200 and gbp = 736.4 and eur = 116772 and  hkd = 946.8','')")

    con:query("insert into check_sql values(1053,'delete from transaction_total_check where cny = 1053 and jpy = 105300 and gbp = 737.1 and eur = 116883 and  hkd = 947.7','')")

    con:query("insert into check_sql values(1054,'delete from transaction_total_check where cny = 1054 and jpy = 105400 and gbp = 737.8 and eur = 116994 and  hkd = 948.6','')")

    con:query("insert into check_sql values(1055,'delete from transaction_total_check where cny = 1055 and jpy = 105500 and gbp = 738.5 and eur = 117105 and  hkd = 949.5','')")

    con:query("insert into check_sql values(1056,'delete from transaction_total_check where cny = 1056 and jpy = 105600 and gbp = 739.2 and eur = 117216 and  hkd = 950.4','')")

    con:query("insert into check_sql values(1057,'delete from transaction_total_check where cny = 1057 and jpy = 105700 and gbp = 739.9 and eur = 117327 and  hkd = 951.3','')")

    con:query("insert into check_sql values(1058,'delete from transaction_total_check where cny = 1058 and jpy = 105800 and gbp = 740.6 and eur = 117438 and  hkd = 952.2','')")

    con:query("insert into check_sql values(1059,'delete from transaction_total_check where cny = 1059 and jpy = 105900 and gbp = 741.3 and eur = 117549 and  hkd = 953.1','')")

    con:query("insert into check_sql values(1060,'delete from transaction_total_check where cny = 1060 and jpy = 106000 and gbp = 742.0 and eur = 117660 and  hkd = 954.0','')")

    con:query("insert into check_sql values(1061,'delete from transaction_total_check where cny = 1061 and jpy = 106100 and gbp = 742.7 and eur = 117771 and  hkd = 954.9','')")

    con:query("insert into check_sql values(1062,'delete from transaction_total_check where cny = 1062 and jpy = 106200 and gbp = 743.4 and eur = 117882 and  hkd = 955.8','')")

    con:query("insert into check_sql values(1063,'delete from transaction_total_check where cny = 1063 and jpy = 106300 and gbp = 744.1 and eur = 117993 and  hkd = 956.7','')")

    con:query("insert into check_sql values(1064,'delete from transaction_total_check where cny = 1064 and jpy = 106400 and gbp = 744.8 and eur = 118104 and  hkd = 957.6','')")

    con:query("insert into check_sql values(1065,'delete from transaction_total_check where cny = 1065 and jpy = 106500 and gbp = 745.5 and eur = 118215 and  hkd = 958.5','')")

    con:query("insert into check_sql values(1066,'delete from transaction_total_check where cny = 1066 and jpy = 106600 and gbp = 746.2 and eur = 118326 and  hkd = 959.4','')")

    con:query("insert into check_sql values(1067,'delete from transaction_total_check where cny = 1067 and jpy = 106700 and gbp = 746.9 and eur = 118437 and  hkd = 960.3','')")

    con:query("insert into check_sql values(1068,'delete from transaction_total_check where cny = 1068 and jpy = 106800 and gbp = 747.6 and eur = 118548 and  hkd = 961.2','')")

    con:query("insert into check_sql values(1069,'delete from transaction_total_check where cny = 1069 and jpy = 106900 and gbp = 748.3 and eur = 118659 and  hkd = 962.1','')")

    con:query("insert into check_sql values(1070,'delete from transaction_total_check where cny = 1070 and jpy = 107000 and gbp = 749.0 and eur = 118770 and  hkd = 963.0','')")

    con:query("insert into check_sql values(1071,'delete from transaction_total_check where cny = 1071 and jpy = 107100 and gbp = 749.7 and eur = 118881 and  hkd = 963.9','')")

    con:query("insert into check_sql values(1072,'delete from transaction_total_check where cny = 1072 and jpy = 107200 and gbp = 750.4 and eur = 118992 and  hkd = 964.8','')")

    con:query("insert into check_sql values(1073,'delete from transaction_total_check where cny = 1073 and jpy = 107300 and gbp = 751.1 and eur = 119103 and  hkd = 965.7','')")

    con:query("insert into check_sql values(1074,'delete from transaction_total_check where cny = 1074 and jpy = 107400 and gbp = 751.8 and eur = 119214 and  hkd = 966.6','')")

    con:query("insert into check_sql values(1075,'delete from transaction_total_check where cny = 1075 and jpy = 107500 and gbp = 752.5 and eur = 119325 and  hkd = 967.5','')")

    con:query("insert into check_sql values(1076,'delete from transaction_total_check where cny = 1076 and jpy = 107600 and gbp = 753.2 and eur = 119436 and  hkd = 968.4','')")

    con:query("insert into check_sql values(1077,'delete from transaction_total_check where cny = 1077 and jpy = 107700 and gbp = 753.9 and eur = 119547 and  hkd = 969.3','')")

    con:query("insert into check_sql values(1078,'delete from transaction_total_check where cny = 1078 and jpy = 107800 and gbp = 754.6 and eur = 119658 and  hkd = 970.2','')")

    con:query("insert into check_sql values(1079,'delete from transaction_total_check where cny = 1079 and jpy = 107900 and gbp = 755.3 and eur = 119769 and  hkd = 971.1','')")

    con:query("insert into check_sql values(1080,'delete from transaction_total_check where cny = 1080 and jpy = 108000 and gbp = 756.0 and eur = 119880 and  hkd = 972.0','')")

    con:query("insert into check_sql values(1081,'delete from transaction_total_check where cny = 1081 and jpy = 108100 and gbp = 756.7 and eur = 119991 and  hkd = 972.9','')")

    con:query("insert into check_sql values(1082,'delete from transaction_total_check where cny = 1082 and jpy = 108200 and gbp = 757.4 and eur = 120102 and  hkd = 973.8','')")

    con:query("insert into check_sql values(1083,'delete from transaction_total_check where cny = 1083 and jpy = 108300 and gbp = 758.1 and eur = 120213 and  hkd = 974.7','')")

    con:query("insert into check_sql values(1084,'delete from transaction_total_check where cny = 1084 and jpy = 108400 and gbp = 758.8 and eur = 120324 and  hkd = 975.6','')")

    con:query("insert into check_sql values(1085,'delete from transaction_total_check where cny = 1085 and jpy = 108500 and gbp = 759.5 and eur = 120435 and  hkd = 976.5','')")

    con:query("insert into check_sql values(1086,'delete from transaction_total_check where cny = 1086 and jpy = 108600 and gbp = 760.2 and eur = 120546 and  hkd = 977.4','')")

    con:query("insert into check_sql values(1087,'delete from transaction_total_check where cny = 1087 and jpy = 108700 and gbp = 760.9 and eur = 120657 and  hkd = 978.3','')")

    con:query("insert into check_sql values(1088,'delete from transaction_total_check where cny = 1088 and jpy = 108800 and gbp = 761.6 and eur = 120768 and  hkd = 979.2','')")

    con:query("insert into check_sql values(1089,'delete from transaction_total_check where cny = 1089 and jpy = 108900 and gbp = 762.3 and eur = 120879 and  hkd = 980.1','')")

    con:query("insert into check_sql values(1090,'delete from transaction_total_check where cny = 1090 and jpy = 109000 and gbp = 763.0 and eur = 120990 and  hkd = 981.0','')")

    con:query("insert into check_sql values(1091,'delete from transaction_total_check where cny = 1091 and jpy = 109100 and gbp = 763.7 and eur = 121101 and  hkd = 981.9','')")

    con:query("insert into check_sql values(1092,'delete from transaction_total_check where cny = 1092 and jpy = 109200 and gbp = 764.4 and eur = 121212 and  hkd = 982.8','')")

    con:query("insert into check_sql values(1093,'delete from transaction_total_check where cny = 1093 and jpy = 109300 and gbp = 765.1 and eur = 121323 and  hkd = 983.7','')")

    con:query("insert into check_sql values(1094,'delete from transaction_total_check where cny = 1094 and jpy = 109400 and gbp = 765.8 and eur = 121434 and  hkd = 984.6','')")

    con:query("insert into check_sql values(1095,'delete from transaction_total_check where cny = 1095 and jpy = 109500 and gbp = 766.5 and eur = 121545 and  hkd = 985.5','')")

    con:query("insert into check_sql values(1096,'delete from transaction_total_check where cny = 1096 and jpy = 109600 and gbp = 767.2 and eur = 121656 and  hkd = 986.4','')")

    con:query("insert into check_sql values(1097,'delete from transaction_total_check where cny = 1097 and jpy = 109700 and gbp = 767.9 and eur = 121767 and  hkd = 987.3','')")

    con:query("insert into check_sql values(1098,'delete from transaction_total_check where cny = 1098 and jpy = 109800 and gbp = 768.6 and eur = 121878 and  hkd = 988.2','')")

    con:query("insert into check_sql values(1099,'delete from transaction_total_check where cny = 1099 and jpy = 109900 and gbp = 769.3 and eur = 121989 and  hkd = 989.1','')")

    con:query("insert into check_sql values(1100,'delete from transaction_total_check where cny = 1100 and jpy = 110000 and gbp = 770.0 and eur = 122100 and  hkd = 990.0','')")

    con:query("insert into check_sql values(1101,'delete from transaction_total_check where cny = 1101 and jpy = 110100 and gbp = 770.7 and eur = 122211 and  hkd = 990.9','')")

    con:query("insert into check_sql values(1102,'delete from transaction_total_check where cny = 1102 and jpy = 110200 and gbp = 771.4 and eur = 122322 and  hkd = 991.8','')")

    con:query("insert into check_sql values(1103,'delete from transaction_total_check where cny = 1103 and jpy = 110300 and gbp = 772.1 and eur = 122433 and  hkd = 992.7','')")

    con:query("insert into check_sql values(1104,'delete from transaction_total_check where cny = 1104 and jpy = 110400 and gbp = 772.8 and eur = 122544 and  hkd = 993.6','')")

    con:query("insert into check_sql values(1105,'delete from transaction_total_check where cny = 1105 and jpy = 110500 and gbp = 773.5 and eur = 122655 and  hkd = 994.5','')")

    con:query("insert into check_sql values(1106,'delete from transaction_total_check where cny = 1106 and jpy = 110600 and gbp = 774.2 and eur = 122766 and  hkd = 995.4','')")

    con:query("insert into check_sql values(1107,'delete from transaction_total_check where cny = 1107 and jpy = 110700 and gbp = 774.9 and eur = 122877 and  hkd = 996.3','')")

    con:query("insert into check_sql values(1108,'delete from transaction_total_check where cny = 1108 and jpy = 110800 and gbp = 775.6 and eur = 122988 and  hkd = 997.2','')")

    con:query("insert into check_sql values(1109,'delete from transaction_total_check where cny = 1109 and jpy = 110900 and gbp = 776.3 and eur = 123099 and  hkd = 998.1','')")

    con:query("insert into check_sql values(1110,'delete from transaction_total_check where cny = 1110 and jpy = 111000 and gbp = 777.0 and eur = 123210 and  hkd = 999.0','')")

    con:query("insert into check_sql values(1111,'delete from transaction_total_check where cny = 1111 and jpy = 111100 and gbp = 777.7 and eur = 123321 and  hkd = 999.9','')")

    con:query("insert into check_sql values(1112,'delete from transaction_total_check where cny = 1112 and jpy = 111200 and gbp = 778.4 and eur = 123432 and  hkd = 1000.8','')")

    con:query("insert into check_sql values(1113,'delete from transaction_total_check where cny = 1113 and jpy = 111300 and gbp = 779.1 and eur = 123543 and  hkd = 1001.7','')")

    con:query("insert into check_sql values(1114,'delete from transaction_total_check where cny = 1114 and jpy = 111400 and gbp = 779.8 and eur = 123654 and  hkd = 1002.6','')")

    con:query("insert into check_sql values(1115,'delete from transaction_total_check where cny = 1115 and jpy = 111500 and gbp = 780.5 and eur = 123765 and  hkd = 1003.5','')")

    con:query("insert into check_sql values(1116,'delete from transaction_total_check where cny = 1116 and jpy = 111600 and gbp = 781.2 and eur = 123876 and  hkd = 1004.4','')")

    con:query("insert into check_sql values(1117,'delete from transaction_total_check where cny = 1117 and jpy = 111700 and gbp = 781.9 and eur = 123987 and  hkd = 1005.3','')")

    con:query("insert into check_sql values(1118,'delete from transaction_total_check where cny = 1118 and jpy = 111800 and gbp = 782.6 and eur = 124098 and  hkd = 1006.2','')")

    con:query("insert into check_sql values(1119,'delete from transaction_total_check where cny = 1119 and jpy = 111900 and gbp = 783.3 and eur = 124209 and  hkd = 1007.1','')")

    con:query("insert into check_sql values(1120,'delete from transaction_total_check where cny = 1120 and jpy = 112000 and gbp = 784.0 and eur = 124320 and  hkd = 1008.0','')")

    con:query("insert into check_sql values(1121,'delete from transaction_total_check where cny = 1121 and jpy = 112100 and gbp = 784.7 and eur = 124431 and  hkd = 1008.9','')")

    con:query("insert into check_sql values(1122,'delete from transaction_total_check where cny = 1122 and jpy = 112200 and gbp = 785.4 and eur = 124542 and  hkd = 1009.8','')")

    con:query("insert into check_sql values(1123,'delete from transaction_total_check where cny = 1123 and jpy = 112300 and gbp = 786.1 and eur = 124653 and  hkd = 1010.7','')")

    con:query("insert into check_sql values(1124,'delete from transaction_total_check where cny = 1124 and jpy = 112400 and gbp = 786.8 and eur = 124764 and  hkd = 1011.6','')")

    con:query("insert into check_sql values(1125,'delete from transaction_total_check where cny = 1125 and jpy = 112500 and gbp = 787.5 and eur = 124875 and  hkd = 1012.5','')")

    con:query("insert into check_sql values(1126,'delete from transaction_total_check where cny = 1126 and jpy = 112600 and gbp = 788.2 and eur = 124986 and  hkd = 1013.4','')")

    con:query("insert into check_sql values(1127,'delete from transaction_total_check where cny = 1127 and jpy = 112700 and gbp = 788.9 and eur = 125097 and  hkd = 1014.3','')")

    con:query("insert into check_sql values(1128,'delete from transaction_total_check where cny = 1128 and jpy = 112800 and gbp = 789.6 and eur = 125208 and  hkd = 1015.2','')")

    con:query("insert into check_sql values(1129,'delete from transaction_total_check where cny = 1129 and jpy = 112900 and gbp = 790.3 and eur = 125319 and  hkd = 1016.1','')")

    con:query("insert into check_sql values(1130,'delete from transaction_total_check where cny = 1130 and jpy = 113000 and gbp = 791.0 and eur = 125430 and  hkd = 1017.0','')")

    con:query("insert into check_sql values(1131,'delete from transaction_total_check where cny = 1131 and jpy = 113100 and gbp = 791.7 and eur = 125541 and  hkd = 1017.9','')")

    con:query("insert into check_sql values(1132,'delete from transaction_total_check where cny = 1132 and jpy = 113200 and gbp = 792.4 and eur = 125652 and  hkd = 1018.8','')")

    con:query("insert into check_sql values(1133,'delete from transaction_total_check where cny = 1133 and jpy = 113300 and gbp = 793.1 and eur = 125763 and  hkd = 1019.7','')")

    con:query("insert into check_sql values(1134,'delete from transaction_total_check where cny = 1134 and jpy = 113400 and gbp = 793.8 and eur = 125874 and  hkd = 1020.6','')")

    con:query("insert into check_sql values(1135,'delete from transaction_total_check where cny = 1135 and jpy = 113500 and gbp = 794.5 and eur = 125985 and  hkd = 1021.5','')")

    con:query("insert into check_sql values(1136,'delete from transaction_total_check where cny = 1136 and jpy = 113600 and gbp = 795.2 and eur = 126096 and  hkd = 1022.4','')")

    con:query("insert into check_sql values(1137,'delete from transaction_total_check where cny = 1137 and jpy = 113700 and gbp = 795.9 and eur = 126207 and  hkd = 1023.3','')")

    con:query("insert into check_sql values(1138,'delete from transaction_total_check where cny = 1138 and jpy = 113800 and gbp = 796.6 and eur = 126318 and  hkd = 1024.2','')")

    con:query("insert into check_sql values(1139,'delete from transaction_total_check where cny = 1139 and jpy = 113900 and gbp = 797.3 and eur = 126429 and  hkd = 1025.1','')")

    con:query("insert into check_sql values(1140,'delete from transaction_total_check where cny = 1140 and jpy = 114000 and gbp = 798.0 and eur = 126540 and  hkd = 1026.0','')")

    con:query("insert into check_sql values(1141,'delete from transaction_total_check where cny = 1141 and jpy = 114100 and gbp = 798.7 and eur = 126651 and  hkd = 1026.9','')")

    con:query("insert into check_sql values(1142,'delete from transaction_total_check where cny = 1142 and jpy = 114200 and gbp = 799.4 and eur = 126762 and  hkd = 1027.8','')")

    con:query("insert into check_sql values(1143,'delete from transaction_total_check where cny = 1143 and jpy = 114300 and gbp = 800.1 and eur = 126873 and  hkd = 1028.7','')")

    con:query("insert into check_sql values(1144,'delete from transaction_total_check where cny = 1144 and jpy = 114400 and gbp = 800.8 and eur = 126984 and  hkd = 1029.6','')")

    con:query("insert into check_sql values(1145,'delete from transaction_total_check where cny = 1145 and jpy = 114500 and gbp = 801.5 and eur = 127095 and  hkd = 1030.5','')")

    con:query("insert into check_sql values(1146,'delete from transaction_total_check where cny = 1146 and jpy = 114600 and gbp = 802.2 and eur = 127206 and  hkd = 1031.4','')")

    con:query("insert into check_sql values(1147,'delete from transaction_total_check where cny = 1147 and jpy = 114700 and gbp = 802.9 and eur = 127317 and  hkd = 1032.3','')")

    con:query("insert into check_sql values(1148,'delete from transaction_total_check where cny = 1148 and jpy = 114800 and gbp = 803.6 and eur = 127428 and  hkd = 1033.2','')")

    con:query("insert into check_sql values(1149,'delete from transaction_total_check where cny = 1149 and jpy = 114900 and gbp = 804.3 and eur = 127539 and  hkd = 1034.1','')")

    con:query("insert into check_sql values(1150,'delete from transaction_total_check where cny = 1150 and jpy = 115000 and gbp = 805.0 and eur = 127650 and  hkd = 1035.0','')")

    con:query("insert into check_sql values(1151,'delete from transaction_total_check where cny = 1151 and jpy = 115100 and gbp = 805.7 and eur = 127761 and  hkd = 1035.9','')")

    con:query("insert into check_sql values(1152,'delete from transaction_total_check where cny = 1152 and jpy = 115200 and gbp = 806.4 and eur = 127872 and  hkd = 1036.8','')")

    con:query("insert into check_sql values(1153,'delete from transaction_total_check where cny = 1153 and jpy = 115300 and gbp = 807.1 and eur = 127983 and  hkd = 1037.7','')")

    con:query("insert into check_sql values(1154,'delete from transaction_total_check where cny = 1154 and jpy = 115400 and gbp = 807.8 and eur = 128094 and  hkd = 1038.6','')")

    con:query("insert into check_sql values(1155,'delete from transaction_total_check where cny = 1155 and jpy = 115500 and gbp = 808.5 and eur = 128205 and  hkd = 1039.5','')")

    con:query("insert into check_sql values(1156,'delete from transaction_total_check where cny = 1156 and jpy = 115600 and gbp = 809.2 and eur = 128316 and  hkd = 1040.4','')")

    con:query("insert into check_sql values(1157,'delete from transaction_total_check where cny = 1157 and jpy = 115700 and gbp = 809.9 and eur = 128427 and  hkd = 1041.3','')")

    con:query("insert into check_sql values(1158,'delete from transaction_total_check where cny = 1158 and jpy = 115800 and gbp = 810.6 and eur = 128538 and  hkd = 1042.2','')")

    con:query("insert into check_sql values(1159,'delete from transaction_total_check where cny = 1159 and jpy = 115900 and gbp = 811.3 and eur = 128649 and  hkd = 1043.1','')")

    con:query("insert into check_sql values(1160,'delete from transaction_total_check where cny = 1160 and jpy = 116000 and gbp = 812.0 and eur = 128760 and  hkd = 1044.0','')")

    con:query("insert into check_sql values(1161,'delete from transaction_total_check where cny = 1161 and jpy = 116100 and gbp = 812.7 and eur = 128871 and  hkd = 1044.9','')")

    con:query("insert into check_sql values(1162,'delete from transaction_total_check where cny = 1162 and jpy = 116200 and gbp = 813.4 and eur = 128982 and  hkd = 1045.8','')")

    con:query("insert into check_sql values(1163,'delete from transaction_total_check where cny = 1163 and jpy = 116300 and gbp = 814.1 and eur = 129093 and  hkd = 1046.7','')")

    con:query("insert into check_sql values(1164,'delete from transaction_total_check where cny = 1164 and jpy = 116400 and gbp = 814.8 and eur = 129204 and  hkd = 1047.6','')")

    con:query("insert into check_sql values(1165,'delete from transaction_total_check where cny = 1165 and jpy = 116500 and gbp = 815.5 and eur = 129315 and  hkd = 1048.5','')")

    con:query("insert into check_sql values(1166,'delete from transaction_total_check where cny = 1166 and jpy = 116600 and gbp = 816.2 and eur = 129426 and  hkd = 1049.4','')")

    con:query("insert into check_sql values(1167,'delete from transaction_total_check where cny = 1167 and jpy = 116700 and gbp = 816.9 and eur = 129537 and  hkd = 1050.3','')")

    con:query("insert into check_sql values(1168,'delete from transaction_total_check where cny = 1168 and jpy = 116800 and gbp = 817.6 and eur = 129648 and  hkd = 1051.2','')")

    con:query("insert into check_sql values(1169,'delete from transaction_total_check where cny = 1169 and jpy = 116900 and gbp = 818.3 and eur = 129759 and  hkd = 1052.1','')")

    con:query("insert into check_sql values(1170,'delete from transaction_total_check where cny = 1170 and jpy = 117000 and gbp = 819.0 and eur = 129870 and  hkd = 1053.0','')")

    con:query("insert into check_sql values(1171,'delete from transaction_total_check where cny = 1171 and jpy = 117100 and gbp = 819.7 and eur = 129981 and  hkd = 1053.9','')")

    con:query("insert into check_sql values(1172,'delete from transaction_total_check where cny = 1172 and jpy = 117200 and gbp = 820.4 and eur = 130092 and  hkd = 1054.8','')")

    con:query("insert into check_sql values(1173,'delete from transaction_total_check where cny = 1173 and jpy = 117300 and gbp = 821.1 and eur = 130203 and  hkd = 1055.7','')")

    con:query("insert into check_sql values(1174,'delete from transaction_total_check where cny = 1174 and jpy = 117400 and gbp = 821.8 and eur = 130314 and  hkd = 1056.6','')")

    con:query("insert into check_sql values(1175,'delete from transaction_total_check where cny = 1175 and jpy = 117500 and gbp = 822.5 and eur = 130425 and  hkd = 1057.5','')")

    con:query("insert into check_sql values(1176,'delete from transaction_total_check where cny = 1176 and jpy = 117600 and gbp = 823.2 and eur = 130536 and  hkd = 1058.4','')")

    con:query("insert into check_sql values(1177,'delete from transaction_total_check where cny = 1177 and jpy = 117700 and gbp = 823.9 and eur = 130647 and  hkd = 1059.3','')")

    con:query("insert into check_sql values(1178,'delete from transaction_total_check where cny = 1178 and jpy = 117800 and gbp = 824.6 and eur = 130758 and  hkd = 1060.2','')")

    con:query("insert into check_sql values(1179,'delete from transaction_total_check where cny = 1179 and jpy = 117900 and gbp = 825.3 and eur = 130869 and  hkd = 1061.1','')")

    con:query("insert into check_sql values(1180,'delete from transaction_total_check where cny = 1180 and jpy = 118000 and gbp = 826.0 and eur = 130980 and  hkd = 1062.0','')")

    con:query("insert into check_sql values(1181,'delete from transaction_total_check where cny = 1181 and jpy = 118100 and gbp = 826.7 and eur = 131091 and  hkd = 1062.9','')")

    con:query("insert into check_sql values(1182,'delete from transaction_total_check where cny = 1182 and jpy = 118200 and gbp = 827.4 and eur = 131202 and  hkd = 1063.8','')")

    con:query("insert into check_sql values(1183,'delete from transaction_total_check where cny = 1183 and jpy = 118300 and gbp = 828.1 and eur = 131313 and  hkd = 1064.7','')")

    con:query("insert into check_sql values(1184,'delete from transaction_total_check where cny = 1184 and jpy = 118400 and gbp = 828.8 and eur = 131424 and  hkd = 1065.6','')")

    con:query("insert into check_sql values(1185,'delete from transaction_total_check where cny = 1185 and jpy = 118500 and gbp = 829.5 and eur = 131535 and  hkd = 1066.5','')")

    con:query("insert into check_sql values(1186,'delete from transaction_total_check where cny = 1186 and jpy = 118600 and gbp = 830.2 and eur = 131646 and  hkd = 1067.4','')")

    con:query("insert into check_sql values(1187,'delete from transaction_total_check where cny = 1187 and jpy = 118700 and gbp = 830.9 and eur = 131757 and  hkd = 1068.3','')")

    con:query("insert into check_sql values(1188,'delete from transaction_total_check where cny = 1188 and jpy = 118800 and gbp = 831.6 and eur = 131868 and  hkd = 1069.2','')")

    con:query("insert into check_sql values(1189,'delete from transaction_total_check where cny = 1189 and jpy = 118900 and gbp = 832.3 and eur = 131979 and  hkd = 1070.1','')")

    con:query("insert into check_sql values(1190,'delete from transaction_total_check where cny = 1190 and jpy = 119000 and gbp = 833.0 and eur = 132090 and  hkd = 1071.0','')")

    con:query("insert into check_sql values(1191,'delete from transaction_total_check where cny = 1191 and jpy = 119100 and gbp = 833.7 and eur = 132201 and  hkd = 1071.9','')")

    con:query("insert into check_sql values(1192,'delete from transaction_total_check where cny = 1192 and jpy = 119200 and gbp = 834.4 and eur = 132312 and  hkd = 1072.8','')")

    con:query("insert into check_sql values(1193,'delete from transaction_total_check where cny = 1193 and jpy = 119300 and gbp = 835.1 and eur = 132423 and  hkd = 1073.7','')")

    con:query("insert into check_sql values(1194,'delete from transaction_total_check where cny = 1194 and jpy = 119400 and gbp = 835.8 and eur = 132534 and  hkd = 1074.6','')")

    con:query("insert into check_sql values(1195,'delete from transaction_total_check where cny = 1195 and jpy = 119500 and gbp = 836.5 and eur = 132645 and  hkd = 1075.5','')")

    con:query("insert into check_sql values(1196,'delete from transaction_total_check where cny = 1196 and jpy = 119600 and gbp = 837.2 and eur = 132756 and  hkd = 1076.4','')")

    con:query("insert into check_sql values(1197,'delete from transaction_total_check where cny = 1197 and jpy = 119700 and gbp = 837.9 and eur = 132867 and  hkd = 1077.3','')")

    con:query("insert into check_sql values(1198,'delete from transaction_total_check where cny = 1198 and jpy = 119800 and gbp = 838.6 and eur = 132978 and  hkd = 1078.2','')")

    con:query("insert into check_sql values(1199,'delete from transaction_total_check where cny = 1199 and jpy = 119900 and gbp = 839.3 and eur = 133089 and  hkd = 1079.1','')")

    con:query("insert into check_sql values(1200,'delete from transaction_total_check where cny = 1200 and jpy = 120000 and gbp = 840.0 and eur = 133200 and  hkd = 1080.0','')")

    con:query("insert into check_sql values(1201,'delete from transaction_total_check where cny = 1201 and jpy = 120100 and gbp = 840.7 and eur = 133311 and  hkd = 1080.9','')")

    con:query("insert into check_sql values(1202,'delete from transaction_total_check where cny = 1202 and jpy = 120200 and gbp = 841.4 and eur = 133422 and  hkd = 1081.8','')")

    con:query("insert into check_sql values(1203,'delete from transaction_total_check where cny = 1203 and jpy = 120300 and gbp = 842.1 and eur = 133533 and  hkd = 1082.7','')")

    con:query("insert into check_sql values(1204,'delete from transaction_total_check where cny = 1204 and jpy = 120400 and gbp = 842.8 and eur = 133644 and  hkd = 1083.6','')")

    con:query("insert into check_sql values(1205,'delete from transaction_total_check where cny = 1205 and jpy = 120500 and gbp = 843.5 and eur = 133755 and  hkd = 1084.5','')")

    con:query("insert into check_sql values(1206,'delete from transaction_total_check where cny = 1206 and jpy = 120600 and gbp = 844.2 and eur = 133866 and  hkd = 1085.4','')")

    con:query("insert into check_sql values(1207,'delete from transaction_total_check where cny = 1207 and jpy = 120700 and gbp = 844.9 and eur = 133977 and  hkd = 1086.3','')")

    con:query("insert into check_sql values(1208,'delete from transaction_total_check where cny = 1208 and jpy = 120800 and gbp = 845.6 and eur = 134088 and  hkd = 1087.2','')")

    con:query("insert into check_sql values(1209,'delete from transaction_total_check where cny = 1209 and jpy = 120900 and gbp = 846.3 and eur = 134199 and  hkd = 1088.1','')")

    con:query("insert into check_sql values(1210,'delete from transaction_total_check where cny = 1210 and jpy = 121000 and gbp = 847.0 and eur = 134310 and  hkd = 1089.0','')")

    con:query("insert into check_sql values(1211,'delete from transaction_total_check where cny = 1211 and jpy = 121100 and gbp = 847.7 and eur = 134421 and  hkd = 1089.9','')")

    con:query("insert into check_sql values(1212,'delete from transaction_total_check where cny = 1212 and jpy = 121200 and gbp = 848.4 and eur = 134532 and  hkd = 1090.8','')")

    con:query("insert into check_sql values(1213,'delete from transaction_total_check where cny = 1213 and jpy = 121300 and gbp = 849.1 and eur = 134643 and  hkd = 1091.7','')")

    con:query("insert into check_sql values(1214,'delete from transaction_total_check where cny = 1214 and jpy = 121400 and gbp = 849.8 and eur = 134754 and  hkd = 1092.6','')")

    con:query("insert into check_sql values(1215,'delete from transaction_total_check where cny = 1215 and jpy = 121500 and gbp = 850.5 and eur = 134865 and  hkd = 1093.5','')")

    con:query("insert into check_sql values(1216,'delete from transaction_total_check where cny = 1216 and jpy = 121600 and gbp = 851.2 and eur = 134976 and  hkd = 1094.4','')")

    con:query("insert into check_sql values(1217,'delete from transaction_total_check where cny = 1217 and jpy = 121700 and gbp = 851.9 and eur = 135087 and  hkd = 1095.3','')")

    con:query("insert into check_sql values(1218,'delete from transaction_total_check where cny = 1218 and jpy = 121800 and gbp = 852.6 and eur = 135198 and  hkd = 1096.2','')")

    con:query("insert into check_sql values(1219,'delete from transaction_total_check where cny = 1219 and jpy = 121900 and gbp = 853.3 and eur = 135309 and  hkd = 1097.1','')")

    con:query("insert into check_sql values(1220,'delete from transaction_total_check where cny = 1220 and jpy = 122000 and gbp = 854.0 and eur = 135420 and  hkd = 1098.0','')")

    con:query("insert into check_sql values(1221,'delete from transaction_total_check where cny = 1221 and jpy = 122100 and gbp = 854.7 and eur = 135531 and  hkd = 1098.9','')")

    con:query("insert into check_sql values(1222,'delete from transaction_total_check where cny = 1222 and jpy = 122200 and gbp = 855.4 and eur = 135642 and  hkd = 1099.8','')")

    con:query("insert into check_sql values(1223,'delete from transaction_total_check where cny = 1223 and jpy = 122300 and gbp = 856.1 and eur = 135753 and  hkd = 1100.7','')")

    con:query("insert into check_sql values(1224,'delete from transaction_total_check where cny = 1224 and jpy = 122400 and gbp = 856.8 and eur = 135864 and  hkd = 1101.6','')")

    con:query("insert into check_sql values(1225,'delete from transaction_total_check where cny = 1225 and jpy = 122500 and gbp = 857.5 and eur = 135975 and  hkd = 1102.5','')")

    con:query("insert into check_sql values(1226,'delete from transaction_total_check where cny = 1226 and jpy = 122600 and gbp = 858.2 and eur = 136086 and  hkd = 1103.4','')")

    con:query("insert into check_sql values(1227,'delete from transaction_total_check where cny = 1227 and jpy = 122700 and gbp = 858.9 and eur = 136197 and  hkd = 1104.3','')")

    con:query("insert into check_sql values(1228,'delete from transaction_total_check where cny = 1228 and jpy = 122800 and gbp = 859.6 and eur = 136308 and  hkd = 1105.2','')")

    con:query("insert into check_sql values(1229,'delete from transaction_total_check where cny = 1229 and jpy = 122900 and gbp = 860.3 and eur = 136419 and  hkd = 1106.1','')")

    con:query("insert into check_sql values(1230,'delete from transaction_total_check where cny = 1230 and jpy = 123000 and gbp = 861.0 and eur = 136530 and  hkd = 1107.0','')")

    con:query("insert into check_sql values(1231,'delete from transaction_total_check where cny = 1231 and jpy = 123100 and gbp = 861.7 and eur = 136641 and  hkd = 1107.9','')")

    con:query("insert into check_sql values(1232,'delete from transaction_total_check where cny = 1232 and jpy = 123200 and gbp = 862.4 and eur = 136752 and  hkd = 1108.8','')")

    con:query("insert into check_sql values(1233,'delete from transaction_total_check where cny = 1233 and jpy = 123300 and gbp = 863.1 and eur = 136863 and  hkd = 1109.7','')")

    con:query("insert into check_sql values(1234,'delete from transaction_total_check where cny = 1234 and jpy = 123400 and gbp = 863.8 and eur = 136974 and  hkd = 1110.6','')")

    con:query("insert into check_sql values(1235,'delete from transaction_total_check where cny = 1235 and jpy = 123500 and gbp = 864.5 and eur = 137085 and  hkd = 1111.5','')")

    con:query("insert into check_sql values(1236,'delete from transaction_total_check where cny = 1236 and jpy = 123600 and gbp = 865.2 and eur = 137196 and  hkd = 1112.4','')")

    con:query("insert into check_sql values(1237,'delete from transaction_total_check where cny = 1237 and jpy = 123700 and gbp = 865.9 and eur = 137307 and  hkd = 1113.3','')")

    con:query("insert into check_sql values(1238,'delete from transaction_total_check where cny = 1238 and jpy = 123800 and gbp = 866.6 and eur = 137418 and  hkd = 1114.2','')")

    con:query("insert into check_sql values(1239,'delete from transaction_total_check where cny = 1239 and jpy = 123900 and gbp = 867.3 and eur = 137529 and  hkd = 1115.1','')")

    con:query("insert into check_sql values(1240,'delete from transaction_total_check where cny = 1240 and jpy = 124000 and gbp = 868.0 and eur = 137640 and  hkd = 1116.0','')")

    con:query("insert into check_sql values(1241,'delete from transaction_total_check where cny = 1241 and jpy = 124100 and gbp = 868.7 and eur = 137751 and  hkd = 1116.9','')")

    con:query("insert into check_sql values(1242,'delete from transaction_total_check where cny = 1242 and jpy = 124200 and gbp = 869.4 and eur = 137862 and  hkd = 1117.8','')")

    con:query("insert into check_sql values(1243,'delete from transaction_total_check where cny = 1243 and jpy = 124300 and gbp = 870.1 and eur = 137973 and  hkd = 1118.7','')")

    con:query("insert into check_sql values(1244,'delete from transaction_total_check where cny = 1244 and jpy = 124400 and gbp = 870.8 and eur = 138084 and  hkd = 1119.6','')")

    con:query("insert into check_sql values(1245,'delete from transaction_total_check where cny = 1245 and jpy = 124500 and gbp = 871.5 and eur = 138195 and  hkd = 1120.5','')")

    con:query("insert into check_sql values(1246,'delete from transaction_total_check where cny = 1246 and jpy = 124600 and gbp = 872.2 and eur = 138306 and  hkd = 1121.4','')")

    con:query("insert into check_sql values(1247,'delete from transaction_total_check where cny = 1247 and jpy = 124700 and gbp = 872.9 and eur = 138417 and  hkd = 1122.3','')")

    con:query("insert into check_sql values(1248,'delete from transaction_total_check where cny = 1248 and jpy = 124800 and gbp = 873.6 and eur = 138528 and  hkd = 1123.2','')")

    con:query("insert into check_sql values(1249,'delete from transaction_total_check where cny = 1249 and jpy = 124900 and gbp = 874.3 and eur = 138639 and  hkd = 1124.1','')")

    con:query("insert into check_sql values(1250,'delete from transaction_total_check where cny = 1250 and jpy = 125000 and gbp = 875.0 and eur = 138750 and  hkd = 1125.0','')")

    con:query("insert into check_sql values(1251,'delete from transaction_total_check where cny = 1251 and jpy = 125100 and gbp = 875.7 and eur = 138861 and  hkd = 1125.9','')")

    con:query("insert into check_sql values(1252,'delete from transaction_total_check where cny = 1252 and jpy = 125200 and gbp = 876.4 and eur = 138972 and  hkd = 1126.8','')")

    con:query("insert into check_sql values(1253,'delete from transaction_total_check where cny = 1253 and jpy = 125300 and gbp = 877.1 and eur = 139083 and  hkd = 1127.7','')")

    con:query("insert into check_sql values(1254,'delete from transaction_total_check where cny = 1254 and jpy = 125400 and gbp = 877.8 and eur = 139194 and  hkd = 1128.6','')")

    con:query("insert into check_sql values(1255,'delete from transaction_total_check where cny = 1255 and jpy = 125500 and gbp = 878.5 and eur = 139305 and  hkd = 1129.5','')")

    con:query("insert into check_sql values(1256,'delete from transaction_total_check where cny = 1256 and jpy = 125600 and gbp = 879.2 and eur = 139416 and  hkd = 1130.4','')")

    con:query("insert into check_sql values(1257,'delete from transaction_total_check where cny = 1257 and jpy = 125700 and gbp = 879.9 and eur = 139527 and  hkd = 1131.3','')")

    con:query("insert into check_sql values(1258,'delete from transaction_total_check where cny = 1258 and jpy = 125800 and gbp = 880.6 and eur = 139638 and  hkd = 1132.2','')")

    con:query("insert into check_sql values(1259,'delete from transaction_total_check where cny = 1259 and jpy = 125900 and gbp = 881.3 and eur = 139749 and  hkd = 1133.1','')")

    con:query("insert into check_sql values(1260,'delete from transaction_total_check where cny = 1260 and jpy = 126000 and gbp = 882.0 and eur = 139860 and  hkd = 1134.0','')")

    con:query("insert into check_sql values(1261,'delete from transaction_total_check where cny = 1261 and jpy = 126100 and gbp = 882.7 and eur = 139971 and  hkd = 1134.9','')")

    con:query("insert into check_sql values(1262,'delete from transaction_total_check where cny = 1262 and jpy = 126200 and gbp = 883.4 and eur = 140082 and  hkd = 1135.8','')")

    con:query("insert into check_sql values(1263,'delete from transaction_total_check where cny = 1263 and jpy = 126300 and gbp = 884.1 and eur = 140193 and  hkd = 1136.7','')")

    con:query("insert into check_sql values(1264,'delete from transaction_total_check where cny = 1264 and jpy = 126400 and gbp = 884.8 and eur = 140304 and  hkd = 1137.6','')")

    con:query("insert into check_sql values(1265,'delete from transaction_total_check where cny = 1265 and jpy = 126500 and gbp = 885.5 and eur = 140415 and  hkd = 1138.5','')")

    con:query("insert into check_sql values(1266,'delete from transaction_total_check where cny = 1266 and jpy = 126600 and gbp = 886.2 and eur = 140526 and  hkd = 1139.4','')")

    con:query("insert into check_sql values(1267,'delete from transaction_total_check where cny = 1267 and jpy = 126700 and gbp = 886.9 and eur = 140637 and  hkd = 1140.3','')")

    con:query("insert into check_sql values(1268,'delete from transaction_total_check where cny = 1268 and jpy = 126800 and gbp = 887.6 and eur = 140748 and  hkd = 1141.2','')")

    con:query("insert into check_sql values(1269,'delete from transaction_total_check where cny = 1269 and jpy = 126900 and gbp = 888.3 and eur = 140859 and  hkd = 1142.1','')")

    con:query("insert into check_sql values(1270,'delete from transaction_total_check where cny = 1270 and jpy = 127000 and gbp = 889.0 and eur = 140970 and  hkd = 1143.0','')")

    con:query("insert into check_sql values(1271,'delete from transaction_total_check where cny = 1271 and jpy = 127100 and gbp = 889.7 and eur = 141081 and  hkd = 1143.9','')")

    con:query("insert into check_sql values(1272,'delete from transaction_total_check where cny = 1272 and jpy = 127200 and gbp = 890.4 and eur = 141192 and  hkd = 1144.8','')")

    con:query("insert into check_sql values(1273,'delete from transaction_total_check where cny = 1273 and jpy = 127300 and gbp = 891.1 and eur = 141303 and  hkd = 1145.7','')")

    con:query("insert into check_sql values(1274,'delete from transaction_total_check where cny = 1274 and jpy = 127400 and gbp = 891.8 and eur = 141414 and  hkd = 1146.6','')")

    con:query("insert into check_sql values(1275,'delete from transaction_total_check where cny = 1275 and jpy = 127500 and gbp = 892.5 and eur = 141525 and  hkd = 1147.5','')")

    con:query("insert into check_sql values(1276,'delete from transaction_total_check where cny = 1276 and jpy = 127600 and gbp = 893.2 and eur = 141636 and  hkd = 1148.4','')")

    con:query("insert into check_sql values(1277,'delete from transaction_total_check where cny = 1277 and jpy = 127700 and gbp = 893.9 and eur = 141747 and  hkd = 1149.3','')")

    con:query("insert into check_sql values(1278,'delete from transaction_total_check where cny = 1278 and jpy = 127800 and gbp = 894.6 and eur = 141858 and  hkd = 1150.2','')")

    con:query("insert into check_sql values(1279,'delete from transaction_total_check where cny = 1279 and jpy = 127900 and gbp = 895.3 and eur = 141969 and  hkd = 1151.1','')")

    con:query("insert into check_sql values(1280,'delete from transaction_total_check where cny = 1280 and jpy = 128000 and gbp = 896.0 and eur = 142080 and  hkd = 1152.0','')")

    con:query("insert into check_sql values(1281,'delete from transaction_total_check where cny = 1281 and jpy = 128100 and gbp = 896.7 and eur = 142191 and  hkd = 1152.9','')")

    con:query("insert into check_sql values(1282,'delete from transaction_total_check where cny = 1282 and jpy = 128200 and gbp = 897.4 and eur = 142302 and  hkd = 1153.8','')")

    con:query("insert into check_sql values(1283,'delete from transaction_total_check where cny = 1283 and jpy = 128300 and gbp = 898.1 and eur = 142413 and  hkd = 1154.7','')")

    con:query("insert into check_sql values(1284,'delete from transaction_total_check where cny = 1284 and jpy = 128400 and gbp = 898.8 and eur = 142524 and  hkd = 1155.6','')")

    con:query("insert into check_sql values(1285,'delete from transaction_total_check where cny = 1285 and jpy = 128500 and gbp = 899.5 and eur = 142635 and  hkd = 1156.5','')")

    con:query("insert into check_sql values(1286,'delete from transaction_total_check where cny = 1286 and jpy = 128600 and gbp = 900.2 and eur = 142746 and  hkd = 1157.4','')")

    con:query("insert into check_sql values(1287,'delete from transaction_total_check where cny = 1287 and jpy = 128700 and gbp = 900.9 and eur = 142857 and  hkd = 1158.3','')")

    con:query("insert into check_sql values(1288,'delete from transaction_total_check where cny = 1288 and jpy = 128800 and gbp = 901.6 and eur = 142968 and  hkd = 1159.2','')")

    con:query("insert into check_sql values(1289,'delete from transaction_total_check where cny = 1289 and jpy = 128900 and gbp = 902.3 and eur = 143079 and  hkd = 1160.1','')")

    con:query("insert into check_sql values(1290,'delete from transaction_total_check where cny = 1290 and jpy = 129000 and gbp = 903.0 and eur = 143190 and  hkd = 1161.0','')")

    con:query("insert into check_sql values(1291,'delete from transaction_total_check where cny = 1291 and jpy = 129100 and gbp = 903.7 and eur = 143301 and  hkd = 1161.9','')")

    con:query("insert into check_sql values(1292,'delete from transaction_total_check where cny = 1292 and jpy = 129200 and gbp = 904.4 and eur = 143412 and  hkd = 1162.8','')")

    con:query("insert into check_sql values(1293,'delete from transaction_total_check where cny = 1293 and jpy = 129300 and gbp = 905.1 and eur = 143523 and  hkd = 1163.7','')")

    con:query("insert into check_sql values(1294,'delete from transaction_total_check where cny = 1294 and jpy = 129400 and gbp = 905.8 and eur = 143634 and  hkd = 1164.6','')")

    con:query("insert into check_sql values(1295,'delete from transaction_total_check where cny = 1295 and jpy = 129500 and gbp = 906.5 and eur = 143745 and  hkd = 1165.5','')")

    con:query("insert into check_sql values(1296,'delete from transaction_total_check where cny = 1296 and jpy = 129600 and gbp = 907.2 and eur = 143856 and  hkd = 1166.4','')")

    con:query("insert into check_sql values(1297,'delete from transaction_total_check where cny = 1297 and jpy = 129700 and gbp = 907.9 and eur = 143967 and  hkd = 1167.3','')")

    con:query("insert into check_sql values(1298,'delete from transaction_total_check where cny = 1298 and jpy = 129800 and gbp = 908.6 and eur = 144078 and  hkd = 1168.2','')")

    con:query("insert into check_sql values(1299,'delete from transaction_total_check where cny = 1299 and jpy = 129900 and gbp = 909.3 and eur = 144189 and  hkd = 1169.1','')")

    con:query("insert into check_sql values(1300,'delete from transaction_total_check where cny = 1300 and jpy = 130000 and gbp = 910.0 and eur = 144300 and  hkd = 1170.0','')")

    con:query("insert into check_sql values(1301,'delete from transaction_total_check where cny = 1301 and jpy = 130100 and gbp = 910.7 and eur = 144411 and  hkd = 1170.9','')")

    con:query("insert into check_sql values(1302,'delete from transaction_total_check where cny = 1302 and jpy = 130200 and gbp = 911.4 and eur = 144522 and  hkd = 1171.8','')")

    con:query("insert into check_sql values(1303,'delete from transaction_total_check where cny = 1303 and jpy = 130300 and gbp = 912.1 and eur = 144633 and  hkd = 1172.7','')")

    con:query("insert into check_sql values(1304,'delete from transaction_total_check where cny = 1304 and jpy = 130400 and gbp = 912.8 and eur = 144744 and  hkd = 1173.6','')")

    con:query("insert into check_sql values(1305,'delete from transaction_total_check where cny = 1305 and jpy = 130500 and gbp = 913.5 and eur = 144855 and  hkd = 1174.5','')")

    con:query("insert into check_sql values(1306,'delete from transaction_total_check where cny = 1306 and jpy = 130600 and gbp = 914.2 and eur = 144966 and  hkd = 1175.4','')")

    con:query("insert into check_sql values(1307,'delete from transaction_total_check where cny = 1307 and jpy = 130700 and gbp = 914.9 and eur = 145077 and  hkd = 1176.3','')")

    con:query("insert into check_sql values(1308,'delete from transaction_total_check where cny = 1308 and jpy = 130800 and gbp = 915.6 and eur = 145188 and  hkd = 1177.2','')")

    con:query("insert into check_sql values(1309,'delete from transaction_total_check where cny = 1309 and jpy = 130900 and gbp = 916.3 and eur = 145299 and  hkd = 1178.1','')")

    con:query("insert into check_sql values(1310,'delete from transaction_total_check where cny = 1310 and jpy = 131000 and gbp = 917.0 and eur = 145410 and  hkd = 1179.0','')")

    con:query("insert into check_sql values(1311,'delete from transaction_total_check where cny = 1311 and jpy = 131100 and gbp = 917.7 and eur = 145521 and  hkd = 1179.9','')")

    con:query("insert into check_sql values(1312,'delete from transaction_total_check where cny = 1312 and jpy = 131200 and gbp = 918.4 and eur = 145632 and  hkd = 1180.8','')")

    con:query("insert into check_sql values(1313,'delete from transaction_total_check where cny = 1313 and jpy = 131300 and gbp = 919.1 and eur = 145743 and  hkd = 1181.7','')")

    con:query("insert into check_sql values(1314,'delete from transaction_total_check where cny = 1314 and jpy = 131400 and gbp = 919.8 and eur = 145854 and  hkd = 1182.6','')")

    con:query("insert into check_sql values(1315,'delete from transaction_total_check where cny = 1315 and jpy = 131500 and gbp = 920.5 and eur = 145965 and  hkd = 1183.5','')")

    con:query("insert into check_sql values(1316,'delete from transaction_total_check where cny = 1316 and jpy = 131600 and gbp = 921.2 and eur = 146076 and  hkd = 1184.4','')")

    con:query("insert into check_sql values(1317,'delete from transaction_total_check where cny = 1317 and jpy = 131700 and gbp = 921.9 and eur = 146187 and  hkd = 1185.3','')")

    con:query("insert into check_sql values(1318,'delete from transaction_total_check where cny = 1318 and jpy = 131800 and gbp = 922.6 and eur = 146298 and  hkd = 1186.2','')")

    con:query("insert into check_sql values(1319,'delete from transaction_total_check where cny = 1319 and jpy = 131900 and gbp = 923.3 and eur = 146409 and  hkd = 1187.1','')")

    con:query("insert into check_sql values(1320,'delete from transaction_total_check where cny = 1320 and jpy = 132000 and gbp = 924.0 and eur = 146520 and  hkd = 1188.0','')")

    con:query("insert into check_sql values(1321,'delete from transaction_total_check where cny = 1321 and jpy = 132100 and gbp = 924.7 and eur = 146631 and  hkd = 1188.9','')")

    con:query("insert into check_sql values(1322,'delete from transaction_total_check where cny = 1322 and jpy = 132200 and gbp = 925.4 and eur = 146742 and  hkd = 1189.8','')")

    con:query("insert into check_sql values(1323,'delete from transaction_total_check where cny = 1323 and jpy = 132300 and gbp = 926.1 and eur = 146853 and  hkd = 1190.7','')")

    con:query("insert into check_sql values(1324,'delete from transaction_total_check where cny = 1324 and jpy = 132400 and gbp = 926.8 and eur = 146964 and  hkd = 1191.6','')")

    con:query("insert into check_sql values(1325,'delete from transaction_total_check where cny = 1325 and jpy = 132500 and gbp = 927.5 and eur = 147075 and  hkd = 1192.5','')")

    con:query("insert into check_sql values(1326,'delete from transaction_total_check where cny = 1326 and jpy = 132600 and gbp = 928.2 and eur = 147186 and  hkd = 1193.4','')")

    con:query("insert into check_sql values(1327,'delete from transaction_total_check where cny = 1327 and jpy = 132700 and gbp = 928.9 and eur = 147297 and  hkd = 1194.3','')")

    con:query("insert into check_sql values(1328,'delete from transaction_total_check where cny = 1328 and jpy = 132800 and gbp = 929.6 and eur = 147408 and  hkd = 1195.2','')")

    con:query("insert into check_sql values(1329,'delete from transaction_total_check where cny = 1329 and jpy = 132900 and gbp = 930.3 and eur = 147519 and  hkd = 1196.1','')")

    con:query("insert into check_sql values(1330,'delete from transaction_total_check where cny = 1330 and jpy = 133000 and gbp = 931.0 and eur = 147630 and  hkd = 1197.0','')")

    con:query("insert into check_sql values(1331,'delete from transaction_total_check where cny = 1331 and jpy = 133100 and gbp = 931.7 and eur = 147741 and  hkd = 1197.9','')")

    con:query("insert into check_sql values(1332,'delete from transaction_total_check where cny = 1332 and jpy = 133200 and gbp = 932.4 and eur = 147852 and  hkd = 1198.8','')")

    con:query("insert into check_sql values(1333,'delete from transaction_total_check where cny = 1333 and jpy = 133300 and gbp = 933.1 and eur = 147963 and  hkd = 1199.7','')")

    con:query("insert into check_sql values(1334,'delete from transaction_total_check where cny = 1334 and jpy = 133400 and gbp = 933.8 and eur = 148074 and  hkd = 1200.6','')")

    con:query("insert into check_sql values(1335,'delete from transaction_total_check where cny = 1335 and jpy = 133500 and gbp = 934.5 and eur = 148185 and  hkd = 1201.5','')")

    con:query("insert into check_sql values(1336,'delete from transaction_total_check where cny = 1336 and jpy = 133600 and gbp = 935.2 and eur = 148296 and  hkd = 1202.4','')")

    con:query("insert into check_sql values(1337,'delete from transaction_total_check where cny = 1337 and jpy = 133700 and gbp = 935.9 and eur = 148407 and  hkd = 1203.3','')")

    con:query("insert into check_sql values(1338,'delete from transaction_total_check where cny = 1338 and jpy = 133800 and gbp = 936.6 and eur = 148518 and  hkd = 1204.2','')")

    con:query("insert into check_sql values(1339,'delete from transaction_total_check where cny = 1339 and jpy = 133900 and gbp = 937.3 and eur = 148629 and  hkd = 1205.1','')")

    con:query("insert into check_sql values(1340,'delete from transaction_total_check where cny = 1340 and jpy = 134000 and gbp = 938.0 and eur = 148740 and  hkd = 1206.0','')")

    con:query("insert into check_sql values(1341,'delete from transaction_total_check where cny = 1341 and jpy = 134100 and gbp = 938.7 and eur = 148851 and  hkd = 1206.9','')")

    con:query("insert into check_sql values(1342,'delete from transaction_total_check where cny = 1342 and jpy = 134200 and gbp = 939.4 and eur = 148962 and  hkd = 1207.8','')")

    con:query("insert into check_sql values(1343,'delete from transaction_total_check where cny = 1343 and jpy = 134300 and gbp = 940.1 and eur = 149073 and  hkd = 1208.7','')")

    con:query("insert into check_sql values(1344,'delete from transaction_total_check where cny = 1344 and jpy = 134400 and gbp = 940.8 and eur = 149184 and  hkd = 1209.6','')")

    con:query("insert into check_sql values(1345,'delete from transaction_total_check where cny = 1345 and jpy = 134500 and gbp = 941.5 and eur = 149295 and  hkd = 1210.5','')")

    con:query("insert into check_sql values(1346,'delete from transaction_total_check where cny = 1346 and jpy = 134600 and gbp = 942.2 and eur = 149406 and  hkd = 1211.4','')")

    con:query("insert into check_sql values(1347,'delete from transaction_total_check where cny = 1347 and jpy = 134700 and gbp = 942.9 and eur = 149517 and  hkd = 1212.3','')")

    con:query("insert into check_sql values(1348,'delete from transaction_total_check where cny = 1348 and jpy = 134800 and gbp = 943.6 and eur = 149628 and  hkd = 1213.2','')")

    con:query("insert into check_sql values(1349,'delete from transaction_total_check where cny = 1349 and jpy = 134900 and gbp = 944.3 and eur = 149739 and  hkd = 1214.1','')")

    con:query("insert into check_sql values(1350,'delete from transaction_total_check where cny = 1350 and jpy = 135000 and gbp = 945.0 and eur = 149850 and  hkd = 1215.0','')")

    con:query("insert into check_sql values(1351,'delete from transaction_total_check where cny = 1351 and jpy = 135100 and gbp = 945.7 and eur = 149961 and  hkd = 1215.9','')")

    con:query("insert into check_sql values(1352,'delete from transaction_total_check where cny = 1352 and jpy = 135200 and gbp = 946.4 and eur = 150072 and  hkd = 1216.8','')")

    con:query("insert into check_sql values(1353,'delete from transaction_total_check where cny = 1353 and jpy = 135300 and gbp = 947.1 and eur = 150183 and  hkd = 1217.7','')")

    con:query("insert into check_sql values(1354,'delete from transaction_total_check where cny = 1354 and jpy = 135400 and gbp = 947.8 and eur = 150294 and  hkd = 1218.6','')")

    con:query("insert into check_sql values(1355,'delete from transaction_total_check where cny = 1355 and jpy = 135500 and gbp = 948.5 and eur = 150405 and  hkd = 1219.5','')")

    con:query("insert into check_sql values(1356,'delete from transaction_total_check where cny = 1356 and jpy = 135600 and gbp = 949.2 and eur = 150516 and  hkd = 1220.4','')")

    con:query("insert into check_sql values(1357,'delete from transaction_total_check where cny = 1357 and jpy = 135700 and gbp = 949.9 and eur = 150627 and  hkd = 1221.3','')")

    con:query("insert into check_sql values(1358,'delete from transaction_total_check where cny = 1358 and jpy = 135800 and gbp = 950.6 and eur = 150738 and  hkd = 1222.2','')")

    con:query("insert into check_sql values(1359,'delete from transaction_total_check where cny = 1359 and jpy = 135900 and gbp = 951.3 and eur = 150849 and  hkd = 1223.1','')")

    con:query("insert into check_sql values(1360,'delete from transaction_total_check where cny = 1360 and jpy = 136000 and gbp = 952.0 and eur = 150960 and  hkd = 1224.0','')")

    con:query("insert into check_sql values(1361,'delete from transaction_total_check where cny = 1361 and jpy = 136100 and gbp = 952.7 and eur = 151071 and  hkd = 1224.9','')")

    con:query("insert into check_sql values(1362,'delete from transaction_total_check where cny = 1362 and jpy = 136200 and gbp = 953.4 and eur = 151182 and  hkd = 1225.8','')")

    con:query("insert into check_sql values(1363,'delete from transaction_total_check where cny = 1363 and jpy = 136300 and gbp = 954.1 and eur = 151293 and  hkd = 1226.7','')")

    con:query("insert into check_sql values(1364,'delete from transaction_total_check where cny = 1364 and jpy = 136400 and gbp = 954.8 and eur = 151404 and  hkd = 1227.6','')")

    con:query("insert into check_sql values(1365,'delete from transaction_total_check where cny = 1365 and jpy = 136500 and gbp = 955.5 and eur = 151515 and  hkd = 1228.5','')")

    con:query("insert into check_sql values(1366,'delete from transaction_total_check where cny = 1366 and jpy = 136600 and gbp = 956.2 and eur = 151626 and  hkd = 1229.4','')")

    con:query("insert into check_sql values(1367,'delete from transaction_total_check where cny = 1367 and jpy = 136700 and gbp = 956.9 and eur = 151737 and  hkd = 1230.3','')")

    con:query("insert into check_sql values(1368,'delete from transaction_total_check where cny = 1368 and jpy = 136800 and gbp = 957.6 and eur = 151848 and  hkd = 1231.2','')")

    con:query("insert into check_sql values(1369,'delete from transaction_total_check where cny = 1369 and jpy = 136900 and gbp = 958.3 and eur = 151959 and  hkd = 1232.1','')")

    con:query("insert into check_sql values(1370,'delete from transaction_total_check where cny = 1370 and jpy = 137000 and gbp = 959.0 and eur = 152070 and  hkd = 1233.0','')")

    con:query("insert into check_sql values(1371,'delete from transaction_total_check where cny = 1371 and jpy = 137100 and gbp = 959.7 and eur = 152181 and  hkd = 1233.9','')")

    con:query("insert into check_sql values(1372,'delete from transaction_total_check where cny = 1372 and jpy = 137200 and gbp = 960.4 and eur = 152292 and  hkd = 1234.8','')")

    con:query("insert into check_sql values(1373,'delete from transaction_total_check where cny = 1373 and jpy = 137300 and gbp = 961.1 and eur = 152403 and  hkd = 1235.7','')")

    con:query("insert into check_sql values(1374,'delete from transaction_total_check where cny = 1374 and jpy = 137400 and gbp = 961.8 and eur = 152514 and  hkd = 1236.6','')")

    con:query("insert into check_sql values(1375,'delete from transaction_total_check where cny = 1375 and jpy = 137500 and gbp = 962.5 and eur = 152625 and  hkd = 1237.5','')")

    con:query("insert into check_sql values(1376,'delete from transaction_total_check where cny = 1376 and jpy = 137600 and gbp = 963.2 and eur = 152736 and  hkd = 1238.4','')")

    con:query("insert into check_sql values(1377,'delete from transaction_total_check where cny = 1377 and jpy = 137700 and gbp = 963.9 and eur = 152847 and  hkd = 1239.3','')")

    con:query("insert into check_sql values(1378,'delete from transaction_total_check where cny = 1378 and jpy = 137800 and gbp = 964.6 and eur = 152958 and  hkd = 1240.2','')")

    con:query("insert into check_sql values(1379,'delete from transaction_total_check where cny = 1379 and jpy = 137900 and gbp = 965.3 and eur = 153069 and  hkd = 1241.1','')")

    con:query("insert into check_sql values(1380,'delete from transaction_total_check where cny = 1380 and jpy = 138000 and gbp = 966.0 and eur = 153180 and  hkd = 1242.0','')")

    con:query("insert into check_sql values(1381,'delete from transaction_total_check where cny = 1381 and jpy = 138100 and gbp = 966.7 and eur = 153291 and  hkd = 1242.9','')")

    con:query("insert into check_sql values(1382,'delete from transaction_total_check where cny = 1382 and jpy = 138200 and gbp = 967.4 and eur = 153402 and  hkd = 1243.8','')")

    con:query("insert into check_sql values(1383,'delete from transaction_total_check where cny = 1383 and jpy = 138300 and gbp = 968.1 and eur = 153513 and  hkd = 1244.7','')")

    con:query("insert into check_sql values(1384,'delete from transaction_total_check where cny = 1384 and jpy = 138400 and gbp = 968.8 and eur = 153624 and  hkd = 1245.6','')")

    con:query("insert into check_sql values(1385,'delete from transaction_total_check where cny = 1385 and jpy = 138500 and gbp = 969.5 and eur = 153735 and  hkd = 1246.5','')")

    con:query("insert into check_sql values(1386,'delete from transaction_total_check where cny = 1386 and jpy = 138600 and gbp = 970.2 and eur = 153846 and  hkd = 1247.4','')")

    con:query("insert into check_sql values(1387,'delete from transaction_total_check where cny = 1387 and jpy = 138700 and gbp = 970.9 and eur = 153957 and  hkd = 1248.3','')")

    con:query("insert into check_sql values(1388,'delete from transaction_total_check where cny = 1388 and jpy = 138800 and gbp = 971.6 and eur = 154068 and  hkd = 1249.2','')")

    con:query("insert into check_sql values(1389,'delete from transaction_total_check where cny = 1389 and jpy = 138900 and gbp = 972.3 and eur = 154179 and  hkd = 1250.1','')")

    con:query("insert into check_sql values(1390,'delete from transaction_total_check where cny = 1390 and jpy = 139000 and gbp = 973.0 and eur = 154290 and  hkd = 1251.0','')")

    con:query("insert into check_sql values(1391,'delete from transaction_total_check where cny = 1391 and jpy = 139100 and gbp = 973.7 and eur = 154401 and  hkd = 1251.9','')")

    con:query("insert into check_sql values(1392,'delete from transaction_total_check where cny = 1392 and jpy = 139200 and gbp = 974.4 and eur = 154512 and  hkd = 1252.8','')")

    con:query("insert into check_sql values(1393,'delete from transaction_total_check where cny = 1393 and jpy = 139300 and gbp = 975.1 and eur = 154623 and  hkd = 1253.7','')")

    con:query("insert into check_sql values(1394,'delete from transaction_total_check where cny = 1394 and jpy = 139400 and gbp = 975.8 and eur = 154734 and  hkd = 1254.6','')")

    con:query("insert into check_sql values(1395,'delete from transaction_total_check where cny = 1395 and jpy = 139500 and gbp = 976.5 and eur = 154845 and  hkd = 1255.5','')")

    con:query("insert into check_sql values(1396,'delete from transaction_total_check where cny = 1396 and jpy = 139600 and gbp = 977.2 and eur = 154956 and  hkd = 1256.4','')")

    con:query("insert into check_sql values(1397,'delete from transaction_total_check where cny = 1397 and jpy = 139700 and gbp = 977.9 and eur = 155067 and  hkd = 1257.3','')")

    con:query("insert into check_sql values(1398,'delete from transaction_total_check where cny = 1398 and jpy = 139800 and gbp = 978.6 and eur = 155178 and  hkd = 1258.2','')")

    con:query("insert into check_sql values(1399,'delete from transaction_total_check where cny = 1399 and jpy = 139900 and gbp = 979.3 and eur = 155289 and  hkd = 1259.1','')")

    con:query("insert into check_sql values(1400,'delete from transaction_total_check where cny = 1400 and jpy = 140000 and gbp = 980.0 and eur = 155400 and  hkd = 1260.0','')")

    con:query("insert into check_sql values(1401,'delete from transaction_total_check where cny = 1401 and jpy = 140100 and gbp = 980.7 and eur = 155511 and  hkd = 1260.9','')")

    con:query("insert into check_sql values(1402,'delete from transaction_total_check where cny = 1402 and jpy = 140200 and gbp = 981.4 and eur = 155622 and  hkd = 1261.8','')")

    con:query("insert into check_sql values(1403,'delete from transaction_total_check where cny = 1403 and jpy = 140300 and gbp = 982.1 and eur = 155733 and  hkd = 1262.7','')")

    con:query("insert into check_sql values(1404,'delete from transaction_total_check where cny = 1404 and jpy = 140400 and gbp = 982.8 and eur = 155844 and  hkd = 1263.6','')")

    con:query("insert into check_sql values(1405,'delete from transaction_total_check where cny = 1405 and jpy = 140500 and gbp = 983.5 and eur = 155955 and  hkd = 1264.5','')")

    con:query("insert into check_sql values(1406,'delete from transaction_total_check where cny = 1406 and jpy = 140600 and gbp = 984.2 and eur = 156066 and  hkd = 1265.4','')")

    con:query("insert into check_sql values(1407,'delete from transaction_total_check where cny = 1407 and jpy = 140700 and gbp = 984.9 and eur = 156177 and  hkd = 1266.3','')")

    con:query("insert into check_sql values(1408,'delete from transaction_total_check where cny = 1408 and jpy = 140800 and gbp = 985.6 and eur = 156288 and  hkd = 1267.2','')")

    con:query("insert into check_sql values(1409,'delete from transaction_total_check where cny = 1409 and jpy = 140900 and gbp = 986.3 and eur = 156399 and  hkd = 1268.1','')")

    con:query("insert into check_sql values(1410,'delete from transaction_total_check where cny = 1410 and jpy = 141000 and gbp = 987.0 and eur = 156510 and  hkd = 1269.0','')")

    con:query("insert into check_sql values(1411,'delete from transaction_total_check where cny = 1411 and jpy = 141100 and gbp = 987.7 and eur = 156621 and  hkd = 1269.9','')")

    con:query("insert into check_sql values(1412,'delete from transaction_total_check where cny = 1412 and jpy = 141200 and gbp = 988.4 and eur = 156732 and  hkd = 1270.8','')")

    con:query("insert into check_sql values(1413,'delete from transaction_total_check where cny = 1413 and jpy = 141300 and gbp = 989.1 and eur = 156843 and  hkd = 1271.7','')")

    con:query("insert into check_sql values(1414,'delete from transaction_total_check where cny = 1414 and jpy = 141400 and gbp = 989.8 and eur = 156954 and  hkd = 1272.6','')")

    con:query("insert into check_sql values(1415,'delete from transaction_total_check where cny = 1415 and jpy = 141500 and gbp = 990.5 and eur = 157065 and  hkd = 1273.5','')")

    con:query("insert into check_sql values(1416,'delete from transaction_total_check where cny = 1416 and jpy = 141600 and gbp = 991.2 and eur = 157176 and  hkd = 1274.4','')")

    con:query("insert into check_sql values(1417,'delete from transaction_total_check where cny = 1417 and jpy = 141700 and gbp = 991.9 and eur = 157287 and  hkd = 1275.3','')")

    con:query("insert into check_sql values(1418,'delete from transaction_total_check where cny = 1418 and jpy = 141800 and gbp = 992.6 and eur = 157398 and  hkd = 1276.2','')")

    con:query("insert into check_sql values(1419,'delete from transaction_total_check where cny = 1419 and jpy = 141900 and gbp = 993.3 and eur = 157509 and  hkd = 1277.1','')")

    con:query("insert into check_sql values(1420,'delete from transaction_total_check where cny = 1420 and jpy = 142000 and gbp = 994.0 and eur = 157620 and  hkd = 1278.0','')")

    con:query("insert into check_sql values(1421,'delete from transaction_total_check where cny = 1421 and jpy = 142100 and gbp = 994.7 and eur = 157731 and  hkd = 1278.9','')")

    con:query("insert into check_sql values(1422,'delete from transaction_total_check where cny = 1422 and jpy = 142200 and gbp = 995.4 and eur = 157842 and  hkd = 1279.8','')")

    con:query("insert into check_sql values(1423,'delete from transaction_total_check where cny = 1423 and jpy = 142300 and gbp = 996.1 and eur = 157953 and  hkd = 1280.7','')")

    con:query("insert into check_sql values(1424,'delete from transaction_total_check where cny = 1424 and jpy = 142400 and gbp = 996.8 and eur = 158064 and  hkd = 1281.6','')")

    con:query("insert into check_sql values(1425,'delete from transaction_total_check where cny = 1425 and jpy = 142500 and gbp = 997.5 and eur = 158175 and  hkd = 1282.5','')")

    con:query("insert into check_sql values(1426,'delete from transaction_total_check where cny = 1426 and jpy = 142600 and gbp = 998.2 and eur = 158286 and  hkd = 1283.4','')")

    con:query("insert into check_sql values(1427,'delete from transaction_total_check where cny = 1427 and jpy = 142700 and gbp = 998.9 and eur = 158397 and  hkd = 1284.3','')")

    con:query("insert into check_sql values(1428,'delete from transaction_total_check where cny = 1428 and jpy = 142800 and gbp = 999.6 and eur = 158508 and  hkd = 1285.2','')")

    con:query("insert into check_sql values(1429,'delete from transaction_total_check where cny = 1429 and jpy = 142900 and gbp = 1000.3 and eur = 158619 and  hkd = 1286.1','')")

    con:query("insert into check_sql values(1430,'delete from transaction_total_check where cny = 1430 and jpy = 143000 and gbp = 1001.0 and eur = 158730 and  hkd = 1287.0','')")

    con:query("insert into check_sql values(1431,'delete from transaction_total_check where cny = 1431 and jpy = 143100 and gbp = 1001.7 and eur = 158841 and  hkd = 1287.9','')")

    con:query("insert into check_sql values(1432,'delete from transaction_total_check where cny = 1432 and jpy = 143200 and gbp = 1002.4 and eur = 158952 and  hkd = 1288.8','')")

    con:query("insert into check_sql values(1433,'delete from transaction_total_check where cny = 1433 and jpy = 143300 and gbp = 1003.1 and eur = 159063 and  hkd = 1289.7','')")

    con:query("insert into check_sql values(1434,'delete from transaction_total_check where cny = 1434 and jpy = 143400 and gbp = 1003.8 and eur = 159174 and  hkd = 1290.6','')")

    con:query("insert into check_sql values(1435,'delete from transaction_total_check where cny = 1435 and jpy = 143500 and gbp = 1004.5 and eur = 159285 and  hkd = 1291.5','')")

    con:query("insert into check_sql values(1436,'delete from transaction_total_check where cny = 1436 and jpy = 143600 and gbp = 1005.2 and eur = 159396 and  hkd = 1292.4','')")

    con:query("insert into check_sql values(1437,'delete from transaction_total_check where cny = 1437 and jpy = 143700 and gbp = 1005.9 and eur = 159507 and  hkd = 1293.3','')")

    con:query("insert into check_sql values(1438,'delete from transaction_total_check where cny = 1438 and jpy = 143800 and gbp = 1006.6 and eur = 159618 and  hkd = 1294.2','')")

    con:query("insert into check_sql values(1439,'delete from transaction_total_check where cny = 1439 and jpy = 143900 and gbp = 1007.3 and eur = 159729 and  hkd = 1295.1','')")

    con:query("insert into check_sql values(1440,'delete from transaction_total_check where cny = 1440 and jpy = 144000 and gbp = 1008.0 and eur = 159840 and  hkd = 1296.0','')")

    con:query("insert into check_sql values(1441,'delete from transaction_total_check where cny = 1441 and jpy = 144100 and gbp = 1008.7 and eur = 159951 and  hkd = 1296.9','')")

    con:query("insert into check_sql values(1442,'delete from transaction_total_check where cny = 1442 and jpy = 144200 and gbp = 1009.4 and eur = 160062 and  hkd = 1297.8','')")

    con:query("insert into check_sql values(1443,'delete from transaction_total_check where cny = 1443 and jpy = 144300 and gbp = 1010.1 and eur = 160173 and  hkd = 1298.7','')")

    con:query("insert into check_sql values(1444,'delete from transaction_total_check where cny = 1444 and jpy = 144400 and gbp = 1010.8 and eur = 160284 and  hkd = 1299.6','')")

    con:query("insert into check_sql values(1445,'delete from transaction_total_check where cny = 1445 and jpy = 144500 and gbp = 1011.5 and eur = 160395 and  hkd = 1300.5','')")

    con:query("insert into check_sql values(1446,'delete from transaction_total_check where cny = 1446 and jpy = 144600 and gbp = 1012.2 and eur = 160506 and  hkd = 1301.4','')")

    con:query("insert into check_sql values(1447,'delete from transaction_total_check where cny = 1447 and jpy = 144700 and gbp = 1012.9 and eur = 160617 and  hkd = 1302.3','')")

    con:query("insert into check_sql values(1448,'delete from transaction_total_check where cny = 1448 and jpy = 144800 and gbp = 1013.6 and eur = 160728 and  hkd = 1303.2','')")

    con:query("insert into check_sql values(1449,'delete from transaction_total_check where cny = 1449 and jpy = 144900 and gbp = 1014.3 and eur = 160839 and  hkd = 1304.1','')")

    con:query("insert into check_sql values(1450,'delete from transaction_total_check where cny = 1450 and jpy = 145000 and gbp = 1015.0 and eur = 160950 and  hkd = 1305.0','')")

    con:query("insert into check_sql values(1451,'delete from transaction_total_check where cny = 1451 and jpy = 145100 and gbp = 1015.7 and eur = 161061 and  hkd = 1305.9','')")

    con:query("insert into check_sql values(1452,'delete from transaction_total_check where cny = 1452 and jpy = 145200 and gbp = 1016.4 and eur = 161172 and  hkd = 1306.8','')")

    con:query("insert into check_sql values(1453,'delete from transaction_total_check where cny = 1453 and jpy = 145300 and gbp = 1017.1 and eur = 161283 and  hkd = 1307.7','')")

    con:query("insert into check_sql values(1454,'delete from transaction_total_check where cny = 1454 and jpy = 145400 and gbp = 1017.8 and eur = 161394 and  hkd = 1308.6','')")

    con:query("insert into check_sql values(1455,'delete from transaction_total_check where cny = 1455 and jpy = 145500 and gbp = 1018.5 and eur = 161505 and  hkd = 1309.5','')")

    con:query("insert into check_sql values(1456,'delete from transaction_total_check where cny = 1456 and jpy = 145600 and gbp = 1019.2 and eur = 161616 and  hkd = 1310.4','')")

    con:query("insert into check_sql values(1457,'delete from transaction_total_check where cny = 1457 and jpy = 145700 and gbp = 1019.9 and eur = 161727 and  hkd = 1311.3','')")

    con:query("insert into check_sql values(1458,'delete from transaction_total_check where cny = 1458 and jpy = 145800 and gbp = 1020.6 and eur = 161838 and  hkd = 1312.2','')")

    con:query("insert into check_sql values(1459,'delete from transaction_total_check where cny = 1459 and jpy = 145900 and gbp = 1021.3 and eur = 161949 and  hkd = 1313.1','')")

    con:query("insert into check_sql values(1460,'delete from transaction_total_check where cny = 1460 and jpy = 146000 and gbp = 1022.0 and eur = 162060 and  hkd = 1314.0','')")

    con:query("insert into check_sql values(1461,'delete from transaction_total_check where cny = 1461 and jpy = 146100 and gbp = 1022.7 and eur = 162171 and  hkd = 1314.9','')")

    con:query("insert into check_sql values(1462,'delete from transaction_total_check where cny = 1462 and jpy = 146200 and gbp = 1023.4 and eur = 162282 and  hkd = 1315.8','')")

    con:query("insert into check_sql values(1463,'delete from transaction_total_check where cny = 1463 and jpy = 146300 and gbp = 1024.1 and eur = 162393 and  hkd = 1316.7','')")

    con:query("insert into check_sql values(1464,'delete from transaction_total_check where cny = 1464 and jpy = 146400 and gbp = 1024.8 and eur = 162504 and  hkd = 1317.6','')")

    con:query("insert into check_sql values(1465,'delete from transaction_total_check where cny = 1465 and jpy = 146500 and gbp = 1025.5 and eur = 162615 and  hkd = 1318.5','')")

    con:query("insert into check_sql values(1466,'delete from transaction_total_check where cny = 1466 and jpy = 146600 and gbp = 1026.2 and eur = 162726 and  hkd = 1319.4','')")

    con:query("insert into check_sql values(1467,'delete from transaction_total_check where cny = 1467 and jpy = 146700 and gbp = 1026.9 and eur = 162837 and  hkd = 1320.3','')")

    con:query("insert into check_sql values(1468,'delete from transaction_total_check where cny = 1468 and jpy = 146800 and gbp = 1027.6 and eur = 162948 and  hkd = 1321.2','')")

    con:query("insert into check_sql values(1469,'delete from transaction_total_check where cny = 1469 and jpy = 146900 and gbp = 1028.3 and eur = 163059 and  hkd = 1322.1','')")

    con:query("insert into check_sql values(1470,'delete from transaction_total_check where cny = 1470 and jpy = 147000 and gbp = 1029.0 and eur = 163170 and  hkd = 1323.0','')")

    con:query("insert into check_sql values(1471,'delete from transaction_total_check where cny = 1471 and jpy = 147100 and gbp = 1029.7 and eur = 163281 and  hkd = 1323.9','')")

    con:query("insert into check_sql values(1472,'delete from transaction_total_check where cny = 1472 and jpy = 147200 and gbp = 1030.4 and eur = 163392 and  hkd = 1324.8','')")

    con:query("insert into check_sql values(1473,'delete from transaction_total_check where cny = 1473 and jpy = 147300 and gbp = 1031.1 and eur = 163503 and  hkd = 1325.7','')")

    con:query("insert into check_sql values(1474,'delete from transaction_total_check where cny = 1474 and jpy = 147400 and gbp = 1031.8 and eur = 163614 and  hkd = 1326.6','')")

    con:query("insert into check_sql values(1475,'delete from transaction_total_check where cny = 1475 and jpy = 147500 and gbp = 1032.5 and eur = 163725 and  hkd = 1327.5','')")

    con:query("insert into check_sql values(1476,'delete from transaction_total_check where cny = 1476 and jpy = 147600 and gbp = 1033.2 and eur = 163836 and  hkd = 1328.4','')")

    con:query("insert into check_sql values(1477,'delete from transaction_total_check where cny = 1477 and jpy = 147700 and gbp = 1033.9 and eur = 163947 and  hkd = 1329.3','')")

    con:query("insert into check_sql values(1478,'delete from transaction_total_check where cny = 1478 and jpy = 147800 and gbp = 1034.6 and eur = 164058 and  hkd = 1330.2','')")

    con:query("insert into check_sql values(1479,'delete from transaction_total_check where cny = 1479 and jpy = 147900 and gbp = 1035.3 and eur = 164169 and  hkd = 1331.1','')")

    con:query("insert into check_sql values(1480,'delete from transaction_total_check where cny = 1480 and jpy = 148000 and gbp = 1036.0 and eur = 164280 and  hkd = 1332.0','')")

    con:query("insert into check_sql values(1481,'delete from transaction_total_check where cny = 1481 and jpy = 148100 and gbp = 1036.7 and eur = 164391 and  hkd = 1332.9','')")

    con:query("insert into check_sql values(1482,'delete from transaction_total_check where cny = 1482 and jpy = 148200 and gbp = 1037.4 and eur = 164502 and  hkd = 1333.8','')")

    con:query("insert into check_sql values(1483,'delete from transaction_total_check where cny = 1483 and jpy = 148300 and gbp = 1038.1 and eur = 164613 and  hkd = 1334.7','')")

    con:query("insert into check_sql values(1484,'delete from transaction_total_check where cny = 1484 and jpy = 148400 and gbp = 1038.8 and eur = 164724 and  hkd = 1335.6','')")

    con:query("insert into check_sql values(1485,'delete from transaction_total_check where cny = 1485 and jpy = 148500 and gbp = 1039.5 and eur = 164835 and  hkd = 1336.5','')")

    con:query("insert into check_sql values(1486,'delete from transaction_total_check where cny = 1486 and jpy = 148600 and gbp = 1040.2 and eur = 164946 and  hkd = 1337.4','')")

    con:query("insert into check_sql values(1487,'delete from transaction_total_check where cny = 1487 and jpy = 148700 and gbp = 1040.9 and eur = 165057 and  hkd = 1338.3','')")

    con:query("insert into check_sql values(1488,'delete from transaction_total_check where cny = 1488 and jpy = 148800 and gbp = 1041.6 and eur = 165168 and  hkd = 1339.2','')")

    con:query("insert into check_sql values(1489,'delete from transaction_total_check where cny = 1489 and jpy = 148900 and gbp = 1042.3 and eur = 165279 and  hkd = 1340.1','')")

    con:query("insert into check_sql values(1490,'delete from transaction_total_check where cny = 1490 and jpy = 149000 and gbp = 1043.0 and eur = 165390 and  hkd = 1341.0','')")

    con:query("insert into check_sql values(1491,'delete from transaction_total_check where cny = 1491 and jpy = 149100 and gbp = 1043.7 and eur = 165501 and  hkd = 1341.9','')")

    con:query("insert into check_sql values(1492,'delete from transaction_total_check where cny = 1492 and jpy = 149200 and gbp = 1044.4 and eur = 165612 and  hkd = 1342.8','')")

    con:query("insert into check_sql values(1493,'delete from transaction_total_check where cny = 1493 and jpy = 149300 and gbp = 1045.1 and eur = 165723 and  hkd = 1343.7','')")

    con:query("insert into check_sql values(1494,'delete from transaction_total_check where cny = 1494 and jpy = 149400 and gbp = 1045.8 and eur = 165834 and  hkd = 1344.6','')")

    con:query("insert into check_sql values(1495,'delete from transaction_total_check where cny = 1495 and jpy = 149500 and gbp = 1046.5 and eur = 165945 and  hkd = 1345.5','')")

    con:query("insert into check_sql values(1496,'delete from transaction_total_check where cny = 1496 and jpy = 149600 and gbp = 1047.2 and eur = 166056 and  hkd = 1346.4','')")

    con:query("insert into check_sql values(1497,'delete from transaction_total_check where cny = 1497 and jpy = 149700 and gbp = 1047.9 and eur = 166167 and  hkd = 1347.3','')")

    con:query("insert into check_sql values(1498,'delete from transaction_total_check where cny = 1498 and jpy = 149800 and gbp = 1048.6 and eur = 166278 and  hkd = 1348.2','')")

    con:query("insert into check_sql values(1499,'delete from transaction_total_check where cny = 1499 and jpy = 149900 and gbp = 1049.3 and eur = 166389 and  hkd = 1349.1','')")

    con:query("insert into check_sql values(1500,'delete from transaction_total_check where cny = 1500 and jpy = 150000 and gbp = 1050.0 and eur = 166500 and  hkd = 1350.0','')")

    con:query("insert into check_sql values(1501,'delete from transaction_total_check where cny = 1501 and jpy = 150100 and gbp = 1050.7 and eur = 166611 and  hkd = 1350.9','')")

    con:query("insert into check_sql values(1502,'delete from transaction_total_check where cny = 1502 and jpy = 150200 and gbp = 1051.4 and eur = 166722 and  hkd = 1351.8','')")

    con:query("insert into check_sql values(1503,'delete from transaction_total_check where cny = 1503 and jpy = 150300 and gbp = 1052.1 and eur = 166833 and  hkd = 1352.7','')")

    con:query("insert into check_sql values(1504,'delete from transaction_total_check where cny = 1504 and jpy = 150400 and gbp = 1052.8 and eur = 166944 and  hkd = 1353.6','')")

    con:query("insert into check_sql values(1505,'delete from transaction_total_check where cny = 1505 and jpy = 150500 and gbp = 1053.5 and eur = 167055 and  hkd = 1354.5','')")

    con:query("insert into check_sql values(1506,'delete from transaction_total_check where cny = 1506 and jpy = 150600 and gbp = 1054.2 and eur = 167166 and  hkd = 1355.4','')")

    con:query("insert into check_sql values(1507,'delete from transaction_total_check where cny = 1507 and jpy = 150700 and gbp = 1054.9 and eur = 167277 and  hkd = 1356.3','')")

    con:query("insert into check_sql values(1508,'delete from transaction_total_check where cny = 1508 and jpy = 150800 and gbp = 1055.6 and eur = 167388 and  hkd = 1357.2','')")

    con:query("insert into check_sql values(1509,'delete from transaction_total_check where cny = 1509 and jpy = 150900 and gbp = 1056.3 and eur = 167499 and  hkd = 1358.1','')")

    con:query("insert into check_sql values(1510,'delete from transaction_total_check where cny = 1510 and jpy = 151000 and gbp = 1057.0 and eur = 167610 and  hkd = 1359.0','')")

    con:query("insert into check_sql values(1511,'delete from transaction_total_check where cny = 1511 and jpy = 151100 and gbp = 1057.7 and eur = 167721 and  hkd = 1359.9','')")

    con:query("insert into check_sql values(1512,'delete from transaction_total_check where cny = 1512 and jpy = 151200 and gbp = 1058.4 and eur = 167832 and  hkd = 1360.8','')")

    con:query("insert into check_sql values(1513,'delete from transaction_total_check where cny = 1513 and jpy = 151300 and gbp = 1059.1 and eur = 167943 and  hkd = 1361.7','')")

    con:query("insert into check_sql values(1514,'delete from transaction_total_check where cny = 1514 and jpy = 151400 and gbp = 1059.8 and eur = 168054 and  hkd = 1362.6','')")

    con:query("insert into check_sql values(1515,'delete from transaction_total_check where cny = 1515 and jpy = 151500 and gbp = 1060.5 and eur = 168165 and  hkd = 1363.5','')")

    con:query("insert into check_sql values(1516,'delete from transaction_total_check where cny = 1516 and jpy = 151600 and gbp = 1061.2 and eur = 168276 and  hkd = 1364.4','')")

    con:query("insert into check_sql values(1517,'delete from transaction_total_check where cny = 1517 and jpy = 151700 and gbp = 1061.9 and eur = 168387 and  hkd = 1365.3','')")

    con:query("insert into check_sql values(1518,'delete from transaction_total_check where cny = 1518 and jpy = 151800 and gbp = 1062.6 and eur = 168498 and  hkd = 1366.2','')")

    con:query("insert into check_sql values(1519,'delete from transaction_total_check where cny = 1519 and jpy = 151900 and gbp = 1063.3 and eur = 168609 and  hkd = 1367.1','')")

    con:query("insert into check_sql values(1520,'delete from transaction_total_check where cny = 1520 and jpy = 152000 and gbp = 1064.0 and eur = 168720 and  hkd = 1368.0','')")

    con:query("insert into check_sql values(1521,'delete from transaction_total_check where cny = 1521 and jpy = 152100 and gbp = 1064.7 and eur = 168831 and  hkd = 1368.9','')")

    con:query("insert into check_sql values(1522,'delete from transaction_total_check where cny = 1522 and jpy = 152200 and gbp = 1065.4 and eur = 168942 and  hkd = 1369.8','')")

    con:query("insert into check_sql values(1523,'delete from transaction_total_check where cny = 1523 and jpy = 152300 and gbp = 1066.1 and eur = 169053 and  hkd = 1370.7','')")

    con:query("insert into check_sql values(1524,'delete from transaction_total_check where cny = 1524 and jpy = 152400 and gbp = 1066.8 and eur = 169164 and  hkd = 1371.6','')")

    con:query("insert into check_sql values(1525,'delete from transaction_total_check where cny = 1525 and jpy = 152500 and gbp = 1067.5 and eur = 169275 and  hkd = 1372.5','')")

    con:query("insert into check_sql values(1526,'delete from transaction_total_check where cny = 1526 and jpy = 152600 and gbp = 1068.2 and eur = 169386 and  hkd = 1373.4','')")

    con:query("insert into check_sql values(1527,'delete from transaction_total_check where cny = 1527 and jpy = 152700 and gbp = 1068.9 and eur = 169497 and  hkd = 1374.3','')")

    con:query("insert into check_sql values(1528,'delete from transaction_total_check where cny = 1528 and jpy = 152800 and gbp = 1069.6 and eur = 169608 and  hkd = 1375.2','')")

    con:query("insert into check_sql values(1529,'delete from transaction_total_check where cny = 1529 and jpy = 152900 and gbp = 1070.3 and eur = 169719 and  hkd = 1376.1','')")

    con:query("insert into check_sql values(1530,'delete from transaction_total_check where cny = 1530 and jpy = 153000 and gbp = 1071.0 and eur = 169830 and  hkd = 1377.0','')")

    con:query("insert into check_sql values(1531,'delete from transaction_total_check where cny = 1531 and jpy = 153100 and gbp = 1071.7 and eur = 169941 and  hkd = 1377.9','')")

    con:query("insert into check_sql values(1532,'delete from transaction_total_check where cny = 1532 and jpy = 153200 and gbp = 1072.4 and eur = 170052 and  hkd = 1378.8','')")

    con:query("insert into check_sql values(1533,'delete from transaction_total_check where cny = 1533 and jpy = 153300 and gbp = 1073.1 and eur = 170163 and  hkd = 1379.7','')")

    con:query("insert into check_sql values(1534,'delete from transaction_total_check where cny = 1534 and jpy = 153400 and gbp = 1073.8 and eur = 170274 and  hkd = 1380.6','')")

    con:query("insert into check_sql values(1535,'delete from transaction_total_check where cny = 1535 and jpy = 153500 and gbp = 1074.5 and eur = 170385 and  hkd = 1381.5','')")

    con:query("insert into check_sql values(1536,'delete from transaction_total_check where cny = 1536 and jpy = 153600 and gbp = 1075.2 and eur = 170496 and  hkd = 1382.4','')")

    con:query("insert into check_sql values(1537,'delete from transaction_total_check where cny = 1537 and jpy = 153700 and gbp = 1075.9 and eur = 170607 and  hkd = 1383.3','')")

    con:query("insert into check_sql values(1538,'delete from transaction_total_check where cny = 1538 and jpy = 153800 and gbp = 1076.6 and eur = 170718 and  hkd = 1384.2','')")

    con:query("insert into check_sql values(1539,'delete from transaction_total_check where cny = 1539 and jpy = 153900 and gbp = 1077.3 and eur = 170829 and  hkd = 1385.1','')")

    con:query("insert into check_sql values(1540,'delete from transaction_total_check where cny = 1540 and jpy = 154000 and gbp = 1078.0 and eur = 170940 and  hkd = 1386.0','')")

    con:query("insert into check_sql values(1541,'delete from transaction_total_check where cny = 1541 and jpy = 154100 and gbp = 1078.7 and eur = 171051 and  hkd = 1386.9','')")

    con:query("insert into check_sql values(1542,'delete from transaction_total_check where cny = 1542 and jpy = 154200 and gbp = 1079.4 and eur = 171162 and  hkd = 1387.8','')")

    con:query("insert into check_sql values(1543,'delete from transaction_total_check where cny = 1543 and jpy = 154300 and gbp = 1080.1 and eur = 171273 and  hkd = 1388.7','')")

    con:query("insert into check_sql values(1544,'delete from transaction_total_check where cny = 1544 and jpy = 154400 and gbp = 1080.8 and eur = 171384 and  hkd = 1389.6','')")

    con:query("insert into check_sql values(1545,'delete from transaction_total_check where cny = 1545 and jpy = 154500 and gbp = 1081.5 and eur = 171495 and  hkd = 1390.5','')")

    con:query("insert into check_sql values(1546,'delete from transaction_total_check where cny = 1546 and jpy = 154600 and gbp = 1082.2 and eur = 171606 and  hkd = 1391.4','')")

    con:query("insert into check_sql values(1547,'delete from transaction_total_check where cny = 1547 and jpy = 154700 and gbp = 1082.9 and eur = 171717 and  hkd = 1392.3','')")

    con:query("insert into check_sql values(1548,'delete from transaction_total_check where cny = 1548 and jpy = 154800 and gbp = 1083.6 and eur = 171828 and  hkd = 1393.2','')")

    con:query("insert into check_sql values(1549,'delete from transaction_total_check where cny = 1549 and jpy = 154900 and gbp = 1084.3 and eur = 171939 and  hkd = 1394.1','')")

    con:query("insert into check_sql values(1550,'delete from transaction_total_check where cny = 1550 and jpy = 155000 and gbp = 1085.0 and eur = 172050 and  hkd = 1395.0','')")

    con:query("insert into check_sql values(1551,'delete from transaction_total_check where cny = 1551 and jpy = 155100 and gbp = 1085.7 and eur = 172161 and  hkd = 1395.9','')")

    con:query("insert into check_sql values(1552,'delete from transaction_total_check where cny = 1552 and jpy = 155200 and gbp = 1086.4 and eur = 172272 and  hkd = 1396.8','')")

    con:query("insert into check_sql values(1553,'delete from transaction_total_check where cny = 1553 and jpy = 155300 and gbp = 1087.1 and eur = 172383 and  hkd = 1397.7','')")

    con:query("insert into check_sql values(1554,'delete from transaction_total_check where cny = 1554 and jpy = 155400 and gbp = 1087.8 and eur = 172494 and  hkd = 1398.6','')")

    con:query("insert into check_sql values(1555,'delete from transaction_total_check where cny = 1555 and jpy = 155500 and gbp = 1088.5 and eur = 172605 and  hkd = 1399.5','')")

    con:query("insert into check_sql values(1556,'delete from transaction_total_check where cny = 1556 and jpy = 155600 and gbp = 1089.2 and eur = 172716 and  hkd = 1400.4','')")

    con:query("insert into check_sql values(1557,'delete from transaction_total_check where cny = 1557 and jpy = 155700 and gbp = 1089.9 and eur = 172827 and  hkd = 1401.3','')")

    con:query("insert into check_sql values(1558,'delete from transaction_total_check where cny = 1558 and jpy = 155800 and gbp = 1090.6 and eur = 172938 and  hkd = 1402.2','')")

    con:query("insert into check_sql values(1559,'delete from transaction_total_check where cny = 1559 and jpy = 155900 and gbp = 1091.3 and eur = 173049 and  hkd = 1403.1','')")

    con:query("insert into check_sql values(1560,'delete from transaction_total_check where cny = 1560 and jpy = 156000 and gbp = 1092.0 and eur = 173160 and  hkd = 1404.0','')")

    con:query("insert into check_sql values(1561,'delete from transaction_total_check where cny = 1561 and jpy = 156100 and gbp = 1092.7 and eur = 173271 and  hkd = 1404.9','')")

    con:query("insert into check_sql values(1562,'delete from transaction_total_check where cny = 1562 and jpy = 156200 and gbp = 1093.4 and eur = 173382 and  hkd = 1405.8','')")

    con:query("insert into check_sql values(1563,'delete from transaction_total_check where cny = 1563 and jpy = 156300 and gbp = 1094.1 and eur = 173493 and  hkd = 1406.7','')")

    con:query("insert into check_sql values(1564,'delete from transaction_total_check where cny = 1564 and jpy = 156400 and gbp = 1094.8 and eur = 173604 and  hkd = 1407.6','')")

    con:query("insert into check_sql values(1565,'delete from transaction_total_check where cny = 1565 and jpy = 156500 and gbp = 1095.5 and eur = 173715 and  hkd = 1408.5','')")

    con:query("insert into check_sql values(1566,'delete from transaction_total_check where cny = 1566 and jpy = 156600 and gbp = 1096.2 and eur = 173826 and  hkd = 1409.4','')")

    con:query("insert into check_sql values(1567,'delete from transaction_total_check where cny = 1567 and jpy = 156700 and gbp = 1096.9 and eur = 173937 and  hkd = 1410.3','')")

    con:query("insert into check_sql values(1568,'delete from transaction_total_check where cny = 1568 and jpy = 156800 and gbp = 1097.6 and eur = 174048 and  hkd = 1411.2','')")

    con:query("insert into check_sql values(1569,'delete from transaction_total_check where cny = 1569 and jpy = 156900 and gbp = 1098.3 and eur = 174159 and  hkd = 1412.1','')")

    con:query("insert into check_sql values(1570,'delete from transaction_total_check where cny = 1570 and jpy = 157000 and gbp = 1099.0 and eur = 174270 and  hkd = 1413.0','')")

    con:query("insert into check_sql values(1571,'delete from transaction_total_check where cny = 1571 and jpy = 157100 and gbp = 1099.7 and eur = 174381 and  hkd = 1413.9','')")

    con:query("insert into check_sql values(1572,'delete from transaction_total_check where cny = 1572 and jpy = 157200 and gbp = 1100.4 and eur = 174492 and  hkd = 1414.8','')")

    con:query("insert into check_sql values(1573,'delete from transaction_total_check where cny = 1573 and jpy = 157300 and gbp = 1101.1 and eur = 174603 and  hkd = 1415.7','')")

    con:query("insert into check_sql values(1574,'delete from transaction_total_check where cny = 1574 and jpy = 157400 and gbp = 1101.8 and eur = 174714 and  hkd = 1416.6','')")

    con:query("insert into check_sql values(1575,'delete from transaction_total_check where cny = 1575 and jpy = 157500 and gbp = 1102.5 and eur = 174825 and  hkd = 1417.5','')")

    con:query("insert into check_sql values(1576,'delete from transaction_total_check where cny = 1576 and jpy = 157600 and gbp = 1103.2 and eur = 174936 and  hkd = 1418.4','')")

    con:query("insert into check_sql values(1577,'delete from transaction_total_check where cny = 1577 and jpy = 157700 and gbp = 1103.9 and eur = 175047 and  hkd = 1419.3','')")

    con:query("insert into check_sql values(1578,'delete from transaction_total_check where cny = 1578 and jpy = 157800 and gbp = 1104.6 and eur = 175158 and  hkd = 1420.2','')")

    con:query("insert into check_sql values(1579,'delete from transaction_total_check where cny = 1579 and jpy = 157900 and gbp = 1105.3 and eur = 175269 and  hkd = 1421.1','')")

    con:query("insert into check_sql values(1580,'delete from transaction_total_check where cny = 1580 and jpy = 158000 and gbp = 1106.0 and eur = 175380 and  hkd = 1422.0','')")

    con:query("insert into check_sql values(1581,'delete from transaction_total_check where cny = 1581 and jpy = 158100 and gbp = 1106.7 and eur = 175491 and  hkd = 1422.9','')")

    con:query("insert into check_sql values(1582,'delete from transaction_total_check where cny = 1582 and jpy = 158200 and gbp = 1107.4 and eur = 175602 and  hkd = 1423.8','')")

    con:query("insert into check_sql values(1583,'delete from transaction_total_check where cny = 1583 and jpy = 158300 and gbp = 1108.1 and eur = 175713 and  hkd = 1424.7','')")

    con:query("insert into check_sql values(1584,'delete from transaction_total_check where cny = 1584 and jpy = 158400 and gbp = 1108.8 and eur = 175824 and  hkd = 1425.6','')")

    con:query("insert into check_sql values(1585,'delete from transaction_total_check where cny = 1585 and jpy = 158500 and gbp = 1109.5 and eur = 175935 and  hkd = 1426.5','')")

    con:query("insert into check_sql values(1586,'delete from transaction_total_check where cny = 1586 and jpy = 158600 and gbp = 1110.2 and eur = 176046 and  hkd = 1427.4','')")

    con:query("insert into check_sql values(1587,'delete from transaction_total_check where cny = 1587 and jpy = 158700 and gbp = 1110.9 and eur = 176157 and  hkd = 1428.3','')")

    con:query("insert into check_sql values(1588,'delete from transaction_total_check where cny = 1588 and jpy = 158800 and gbp = 1111.6 and eur = 176268 and  hkd = 1429.2','')")

    con:query("insert into check_sql values(1589,'delete from transaction_total_check where cny = 1589 and jpy = 158900 and gbp = 1112.3 and eur = 176379 and  hkd = 1430.1','')")

    con:query("insert into check_sql values(1590,'delete from transaction_total_check where cny = 1590 and jpy = 159000 and gbp = 1113.0 and eur = 176490 and  hkd = 1431.0','')")

    con:query("insert into check_sql values(1591,'delete from transaction_total_check where cny = 1591 and jpy = 159100 and gbp = 1113.7 and eur = 176601 and  hkd = 1431.9','')")

    con:query("insert into check_sql values(1592,'delete from transaction_total_check where cny = 1592 and jpy = 159200 and gbp = 1114.4 and eur = 176712 and  hkd = 1432.8','')")

    con:query("insert into check_sql values(1593,'delete from transaction_total_check where cny = 1593 and jpy = 159300 and gbp = 1115.1 and eur = 176823 and  hkd = 1433.7','')")

    con:query("insert into check_sql values(1594,'delete from transaction_total_check where cny = 1594 and jpy = 159400 and gbp = 1115.8 and eur = 176934 and  hkd = 1434.6','')")

    con:query("insert into check_sql values(1595,'delete from transaction_total_check where cny = 1595 and jpy = 159500 and gbp = 1116.5 and eur = 177045 and  hkd = 1435.5','')")

    con:query("insert into check_sql values(1596,'delete from transaction_total_check where cny = 1596 and jpy = 159600 and gbp = 1117.2 and eur = 177156 and  hkd = 1436.4','')")

    con:query("insert into check_sql values(1597,'delete from transaction_total_check where cny = 1597 and jpy = 159700 and gbp = 1117.9 and eur = 177267 and  hkd = 1437.3','')")

    con:query("insert into check_sql values(1598,'delete from transaction_total_check where cny = 1598 and jpy = 159800 and gbp = 1118.6 and eur = 177378 and  hkd = 1438.2','')")

    con:query("insert into check_sql values(1599,'delete from transaction_total_check where cny = 1599 and jpy = 159900 and gbp = 1119.3 and eur = 177489 and  hkd = 1439.1','')")

    con:query("insert into check_sql values(1600,'delete from transaction_total_check where cny = 1600 and jpy = 160000 and gbp = 1120.0 and eur = 177600 and  hkd = 1440.0','')")

    con:query("insert into check_sql values(1601,'delete from transaction_total_check where cny = 1601 and jpy = 160100 and gbp = 1120.7 and eur = 177711 and  hkd = 1440.9','')")

    con:query("insert into check_sql values(1602,'delete from transaction_total_check where cny = 1602 and jpy = 160200 and gbp = 1121.4 and eur = 177822 and  hkd = 1441.8','')")

    con:query("insert into check_sql values(1603,'delete from transaction_total_check where cny = 1603 and jpy = 160300 and gbp = 1122.1 and eur = 177933 and  hkd = 1442.7','')")

    con:query("insert into check_sql values(1604,'delete from transaction_total_check where cny = 1604 and jpy = 160400 and gbp = 1122.8 and eur = 178044 and  hkd = 1443.6','')")

    con:query("insert into check_sql values(1605,'delete from transaction_total_check where cny = 1605 and jpy = 160500 and gbp = 1123.5 and eur = 178155 and  hkd = 1444.5','')")

    con:query("insert into check_sql values(1606,'delete from transaction_total_check where cny = 1606 and jpy = 160600 and gbp = 1124.2 and eur = 178266 and  hkd = 1445.4','')")

    con:query("insert into check_sql values(1607,'delete from transaction_total_check where cny = 1607 and jpy = 160700 and gbp = 1124.9 and eur = 178377 and  hkd = 1446.3','')")

    con:query("insert into check_sql values(1608,'delete from transaction_total_check where cny = 1608 and jpy = 160800 and gbp = 1125.6 and eur = 178488 and  hkd = 1447.2','')")

    con:query("insert into check_sql values(1609,'delete from transaction_total_check where cny = 1609 and jpy = 160900 and gbp = 1126.3 and eur = 178599 and  hkd = 1448.1','')")

    con:query("insert into check_sql values(1610,'delete from transaction_total_check where cny = 1610 and jpy = 161000 and gbp = 1127.0 and eur = 178710 and  hkd = 1449.0','')")

    con:query("insert into check_sql values(1611,'delete from transaction_total_check where cny = 1611 and jpy = 161100 and gbp = 1127.7 and eur = 178821 and  hkd = 1449.9','')")

    con:query("insert into check_sql values(1612,'delete from transaction_total_check where cny = 1612 and jpy = 161200 and gbp = 1128.4 and eur = 178932 and  hkd = 1450.8','')")

    con:query("insert into check_sql values(1613,'delete from transaction_total_check where cny = 1613 and jpy = 161300 and gbp = 1129.1 and eur = 179043 and  hkd = 1451.7','')")

    con:query("insert into check_sql values(1614,'delete from transaction_total_check where cny = 1614 and jpy = 161400 and gbp = 1129.8 and eur = 179154 and  hkd = 1452.6','')")

    con:query("insert into check_sql values(1615,'delete from transaction_total_check where cny = 1615 and jpy = 161500 and gbp = 1130.5 and eur = 179265 and  hkd = 1453.5','')")

    con:query("insert into check_sql values(1616,'delete from transaction_total_check where cny = 1616 and jpy = 161600 and gbp = 1131.2 and eur = 179376 and  hkd = 1454.4','')")

    con:query("insert into check_sql values(1617,'delete from transaction_total_check where cny = 1617 and jpy = 161700 and gbp = 1131.9 and eur = 179487 and  hkd = 1455.3','')")

    con:query("insert into check_sql values(1618,'delete from transaction_total_check where cny = 1618 and jpy = 161800 and gbp = 1132.6 and eur = 179598 and  hkd = 1456.2','')")

    con:query("insert into check_sql values(1619,'delete from transaction_total_check where cny = 1619 and jpy = 161900 and gbp = 1133.3 and eur = 179709 and  hkd = 1457.1','')")

    con:query("insert into check_sql values(1620,'delete from transaction_total_check where cny = 1620 and jpy = 162000 and gbp = 1134.0 and eur = 179820 and  hkd = 1458.0','')")

    con:query("insert into check_sql values(1621,'delete from transaction_total_check where cny = 1621 and jpy = 162100 and gbp = 1134.7 and eur = 179931 and  hkd = 1458.9','')")

    con:query("insert into check_sql values(1622,'delete from transaction_total_check where cny = 1622 and jpy = 162200 and gbp = 1135.4 and eur = 180042 and  hkd = 1459.8','')")

    con:query("insert into check_sql values(1623,'delete from transaction_total_check where cny = 1623 and jpy = 162300 and gbp = 1136.1 and eur = 180153 and  hkd = 1460.7','')")

    con:query("insert into check_sql values(1624,'delete from transaction_total_check where cny = 1624 and jpy = 162400 and gbp = 1136.8 and eur = 180264 and  hkd = 1461.6','')")

    con:query("insert into check_sql values(1625,'delete from transaction_total_check where cny = 1625 and jpy = 162500 and gbp = 1137.5 and eur = 180375 and  hkd = 1462.5','')")

    con:query("insert into check_sql values(1626,'delete from transaction_total_check where cny = 1626 and jpy = 162600 and gbp = 1138.2 and eur = 180486 and  hkd = 1463.4','')")

    con:query("insert into check_sql values(1627,'delete from transaction_total_check where cny = 1627 and jpy = 162700 and gbp = 1138.9 and eur = 180597 and  hkd = 1464.3','')")

    con:query("insert into check_sql values(1628,'delete from transaction_total_check where cny = 1628 and jpy = 162800 and gbp = 1139.6 and eur = 180708 and  hkd = 1465.2','')")

    con:query("insert into check_sql values(1629,'delete from transaction_total_check where cny = 1629 and jpy = 162900 and gbp = 1140.3 and eur = 180819 and  hkd = 1466.1','')")

    con:query("insert into check_sql values(1630,'delete from transaction_total_check where cny = 1630 and jpy = 163000 and gbp = 1141.0 and eur = 180930 and  hkd = 1467.0','')")

    con:query("insert into check_sql values(1631,'delete from transaction_total_check where cny = 1631 and jpy = 163100 and gbp = 1141.7 and eur = 181041 and  hkd = 1467.9','')")

    con:query("insert into check_sql values(1632,'delete from transaction_total_check where cny = 1632 and jpy = 163200 and gbp = 1142.4 and eur = 181152 and  hkd = 1468.8','')")

    con:query("insert into check_sql values(1633,'delete from transaction_total_check where cny = 1633 and jpy = 163300 and gbp = 1143.1 and eur = 181263 and  hkd = 1469.7','')")

    con:query("insert into check_sql values(1634,'delete from transaction_total_check where cny = 1634 and jpy = 163400 and gbp = 1143.8 and eur = 181374 and  hkd = 1470.6','')")

    con:query("insert into check_sql values(1635,'delete from transaction_total_check where cny = 1635 and jpy = 163500 and gbp = 1144.5 and eur = 181485 and  hkd = 1471.5','')")

    con:query("insert into check_sql values(1636,'delete from transaction_total_check where cny = 1636 and jpy = 163600 and gbp = 1145.2 and eur = 181596 and  hkd = 1472.4','')")

    con:query("insert into check_sql values(1637,'delete from transaction_total_check where cny = 1637 and jpy = 163700 and gbp = 1145.9 and eur = 181707 and  hkd = 1473.3','')")

    con:query("insert into check_sql values(1638,'delete from transaction_total_check where cny = 1638 and jpy = 163800 and gbp = 1146.6 and eur = 181818 and  hkd = 1474.2','')")

    con:query("insert into check_sql values(1639,'delete from transaction_total_check where cny = 1639 and jpy = 163900 and gbp = 1147.3 and eur = 181929 and  hkd = 1475.1','')")

    con:query("insert into check_sql values(1640,'delete from transaction_total_check where cny = 1640 and jpy = 164000 and gbp = 1148.0 and eur = 182040 and  hkd = 1476.0','')")

    con:query("insert into check_sql values(1641,'delete from transaction_total_check where cny = 1641 and jpy = 164100 and gbp = 1148.7 and eur = 182151 and  hkd = 1476.9','')")

    con:query("insert into check_sql values(1642,'delete from transaction_total_check where cny = 1642 and jpy = 164200 and gbp = 1149.4 and eur = 182262 and  hkd = 1477.8','')")

    con:query("insert into check_sql values(1643,'delete from transaction_total_check where cny = 1643 and jpy = 164300 and gbp = 1150.1 and eur = 182373 and  hkd = 1478.7','')")

    con:query("insert into check_sql values(1644,'delete from transaction_total_check where cny = 1644 and jpy = 164400 and gbp = 1150.8 and eur = 182484 and  hkd = 1479.6','')")

    con:query("insert into check_sql values(1645,'delete from transaction_total_check where cny = 1645 and jpy = 164500 and gbp = 1151.5 and eur = 182595 and  hkd = 1480.5','')")

    con:query("insert into check_sql values(1646,'delete from transaction_total_check where cny = 1646 and jpy = 164600 and gbp = 1152.2 and eur = 182706 and  hkd = 1481.4','')")

    con:query("insert into check_sql values(1647,'delete from transaction_total_check where cny = 1647 and jpy = 164700 and gbp = 1152.9 and eur = 182817 and  hkd = 1482.3','')")

    con:query("insert into check_sql values(1648,'delete from transaction_total_check where cny = 1648 and jpy = 164800 and gbp = 1153.6 and eur = 182928 and  hkd = 1483.2','')")

    con:query("insert into check_sql values(1649,'delete from transaction_total_check where cny = 1649 and jpy = 164900 and gbp = 1154.3 and eur = 183039 and  hkd = 1484.1','')")

    con:query("insert into check_sql values(1650,'delete from transaction_total_check where cny = 1650 and jpy = 165000 and gbp = 1155.0 and eur = 183150 and  hkd = 1485.0','')")

    con:query("insert into check_sql values(1651,'delete from transaction_total_check where cny = 1651 and jpy = 165100 and gbp = 1155.7 and eur = 183261 and  hkd = 1485.9','')")

    con:query("insert into check_sql values(1652,'delete from transaction_total_check where cny = 1652 and jpy = 165200 and gbp = 1156.4 and eur = 183372 and  hkd = 1486.8','')")

    con:query("insert into check_sql values(1653,'delete from transaction_total_check where cny = 1653 and jpy = 165300 and gbp = 1157.1 and eur = 183483 and  hkd = 1487.7','')")

    con:query("insert into check_sql values(1654,'delete from transaction_total_check where cny = 1654 and jpy = 165400 and gbp = 1157.8 and eur = 183594 and  hkd = 1488.6','')")

    con:query("insert into check_sql values(1655,'delete from transaction_total_check where cny = 1655 and jpy = 165500 and gbp = 1158.5 and eur = 183705 and  hkd = 1489.5','')")

    con:query("insert into check_sql values(1656,'delete from transaction_total_check where cny = 1656 and jpy = 165600 and gbp = 1159.2 and eur = 183816 and  hkd = 1490.4','')")

    con:query("insert into check_sql values(1657,'delete from transaction_total_check where cny = 1657 and jpy = 165700 and gbp = 1159.9 and eur = 183927 and  hkd = 1491.3','')")

    con:query("insert into check_sql values(1658,'delete from transaction_total_check where cny = 1658 and jpy = 165800 and gbp = 1160.6 and eur = 184038 and  hkd = 1492.2','')")

    con:query("insert into check_sql values(1659,'delete from transaction_total_check where cny = 1659 and jpy = 165900 and gbp = 1161.3 and eur = 184149 and  hkd = 1493.1','')")

    con:query("insert into check_sql values(1660,'delete from transaction_total_check where cny = 1660 and jpy = 166000 and gbp = 1162.0 and eur = 184260 and  hkd = 1494.0','')")

    con:query("insert into check_sql values(1661,'delete from transaction_total_check where cny = 1661 and jpy = 166100 and gbp = 1162.7 and eur = 184371 and  hkd = 1494.9','')")

    con:query("insert into check_sql values(1662,'delete from transaction_total_check where cny = 1662 and jpy = 166200 and gbp = 1163.4 and eur = 184482 and  hkd = 1495.8','')")

    con:query("insert into check_sql values(1663,'delete from transaction_total_check where cny = 1663 and jpy = 166300 and gbp = 1164.1 and eur = 184593 and  hkd = 1496.7','')")

    con:query("insert into check_sql values(1664,'delete from transaction_total_check where cny = 1664 and jpy = 166400 and gbp = 1164.8 and eur = 184704 and  hkd = 1497.6','')")

    con:query("insert into check_sql values(1665,'delete from transaction_total_check where cny = 1665 and jpy = 166500 and gbp = 1165.5 and eur = 184815 and  hkd = 1498.5','')")

    con:query("insert into check_sql values(1666,'delete from transaction_total_check where cny = 1666 and jpy = 166600 and gbp = 1166.2 and eur = 184926 and  hkd = 1499.4','')")

    con:query("insert into check_sql values(1667,'delete from transaction_total_check where cny = 1667 and jpy = 166700 and gbp = 1166.9 and eur = 185037 and  hkd = 1500.3','')")

    con:query("insert into check_sql values(1668,'delete from transaction_total_check where cny = 1668 and jpy = 166800 and gbp = 1167.6 and eur = 185148 and  hkd = 1501.2','')")

    con:query("insert into check_sql values(1669,'delete from transaction_total_check where cny = 1669 and jpy = 166900 and gbp = 1168.3 and eur = 185259 and  hkd = 1502.1','')")

    con:query("insert into check_sql values(1670,'delete from transaction_total_check where cny = 1670 and jpy = 167000 and gbp = 1169.0 and eur = 185370 and  hkd = 1503.0','')")

    con:query("insert into check_sql values(1671,'delete from transaction_total_check where cny = 1671 and jpy = 167100 and gbp = 1169.7 and eur = 185481 and  hkd = 1503.9','')")

    con:query("insert into check_sql values(1672,'delete from transaction_total_check where cny = 1672 and jpy = 167200 and gbp = 1170.4 and eur = 185592 and  hkd = 1504.8','')")

    con:query("insert into check_sql values(1673,'delete from transaction_total_check where cny = 1673 and jpy = 167300 and gbp = 1171.1 and eur = 185703 and  hkd = 1505.7','')")

    con:query("insert into check_sql values(1674,'delete from transaction_total_check where cny = 1674 and jpy = 167400 and gbp = 1171.8 and eur = 185814 and  hkd = 1506.6','')")

    con:query("insert into check_sql values(1675,'delete from transaction_total_check where cny = 1675 and jpy = 167500 and gbp = 1172.5 and eur = 185925 and  hkd = 1507.5','')")

    con:query("insert into check_sql values(1676,'delete from transaction_total_check where cny = 1676 and jpy = 167600 and gbp = 1173.2 and eur = 186036 and  hkd = 1508.4','')")

    con:query("insert into check_sql values(1677,'delete from transaction_total_check where cny = 1677 and jpy = 167700 and gbp = 1173.9 and eur = 186147 and  hkd = 1509.3','')")

    con:query("insert into check_sql values(1678,'delete from transaction_total_check where cny = 1678 and jpy = 167800 and gbp = 1174.6 and eur = 186258 and  hkd = 1510.2','')")

    con:query("insert into check_sql values(1679,'delete from transaction_total_check where cny = 1679 and jpy = 167900 and gbp = 1175.3 and eur = 186369 and  hkd = 1511.1','')")

    con:query("insert into check_sql values(1680,'delete from transaction_total_check where cny = 1680 and jpy = 168000 and gbp = 1176.0 and eur = 186480 and  hkd = 1512.0','')")

    con:query("insert into check_sql values(1681,'delete from transaction_total_check where cny = 1681 and jpy = 168100 and gbp = 1176.7 and eur = 186591 and  hkd = 1512.9','')")

    con:query("insert into check_sql values(1682,'delete from transaction_total_check where cny = 1682 and jpy = 168200 and gbp = 1177.4 and eur = 186702 and  hkd = 1513.8','')")

    con:query("insert into check_sql values(1683,'delete from transaction_total_check where cny = 1683 and jpy = 168300 and gbp = 1178.1 and eur = 186813 and  hkd = 1514.7','')")

    con:query("insert into check_sql values(1684,'delete from transaction_total_check where cny = 1684 and jpy = 168400 and gbp = 1178.8 and eur = 186924 and  hkd = 1515.6','')")

    con:query("insert into check_sql values(1685,'delete from transaction_total_check where cny = 1685 and jpy = 168500 and gbp = 1179.5 and eur = 187035 and  hkd = 1516.5','')")

    con:query("insert into check_sql values(1686,'delete from transaction_total_check where cny = 1686 and jpy = 168600 and gbp = 1180.2 and eur = 187146 and  hkd = 1517.4','')")

    con:query("insert into check_sql values(1687,'delete from transaction_total_check where cny = 1687 and jpy = 168700 and gbp = 1180.9 and eur = 187257 and  hkd = 1518.3','')")

    con:query("insert into check_sql values(1688,'delete from transaction_total_check where cny = 1688 and jpy = 168800 and gbp = 1181.6 and eur = 187368 and  hkd = 1519.2','')")

    con:query("insert into check_sql values(1689,'delete from transaction_total_check where cny = 1689 and jpy = 168900 and gbp = 1182.3 and eur = 187479 and  hkd = 1520.1','')")

    con:query("insert into check_sql values(1690,'delete from transaction_total_check where cny = 1690 and jpy = 169000 and gbp = 1183.0 and eur = 187590 and  hkd = 1521.0','')")

    con:query("insert into check_sql values(1691,'delete from transaction_total_check where cny = 1691 and jpy = 169100 and gbp = 1183.7 and eur = 187701 and  hkd = 1521.9','')")

    con:query("insert into check_sql values(1692,'delete from transaction_total_check where cny = 1692 and jpy = 169200 and gbp = 1184.4 and eur = 187812 and  hkd = 1522.8','')")

    con:query("insert into check_sql values(1693,'delete from transaction_total_check where cny = 1693 and jpy = 169300 and gbp = 1185.1 and eur = 187923 and  hkd = 1523.7','')")

    con:query("insert into check_sql values(1694,'delete from transaction_total_check where cny = 1694 and jpy = 169400 and gbp = 1185.8 and eur = 188034 and  hkd = 1524.6','')")

    con:query("insert into check_sql values(1695,'delete from transaction_total_check where cny = 1695 and jpy = 169500 and gbp = 1186.5 and eur = 188145 and  hkd = 1525.5','')")

    con:query("insert into check_sql values(1696,'delete from transaction_total_check where cny = 1696 and jpy = 169600 and gbp = 1187.2 and eur = 188256 and  hkd = 1526.4','')")

    con:query("insert into check_sql values(1697,'delete from transaction_total_check where cny = 1697 and jpy = 169700 and gbp = 1187.9 and eur = 188367 and  hkd = 1527.3','')")

    con:query("insert into check_sql values(1698,'delete from transaction_total_check where cny = 1698 and jpy = 169800 and gbp = 1188.6 and eur = 188478 and  hkd = 1528.2','')")

    con:query("insert into check_sql values(1699,'delete from transaction_total_check where cny = 1699 and jpy = 169900 and gbp = 1189.3 and eur = 188589 and  hkd = 1529.1','')")

    con:query("insert into check_sql values(1700,'delete from transaction_total_check where cny = 1700 and jpy = 170000 and gbp = 1190.0 and eur = 188700 and  hkd = 1530.0','')")

    con:query("insert into check_sql values(1701,'delete from transaction_total_check where cny = 1701 and jpy = 170100 and gbp = 1190.7 and eur = 188811 and  hkd = 1530.9','')")

    con:query("insert into check_sql values(1702,'delete from transaction_total_check where cny = 1702 and jpy = 170200 and gbp = 1191.4 and eur = 188922 and  hkd = 1531.8','')")

    con:query("insert into check_sql values(1703,'delete from transaction_total_check where cny = 1703 and jpy = 170300 and gbp = 1192.1 and eur = 189033 and  hkd = 1532.7','')")

    con:query("insert into check_sql values(1704,'delete from transaction_total_check where cny = 1704 and jpy = 170400 and gbp = 1192.8 and eur = 189144 and  hkd = 1533.6','')")

    con:query("insert into check_sql values(1705,'delete from transaction_total_check where cny = 1705 and jpy = 170500 and gbp = 1193.5 and eur = 189255 and  hkd = 1534.5','')")

    con:query("insert into check_sql values(1706,'delete from transaction_total_check where cny = 1706 and jpy = 170600 and gbp = 1194.2 and eur = 189366 and  hkd = 1535.4','')")

    con:query("insert into check_sql values(1707,'delete from transaction_total_check where cny = 1707 and jpy = 170700 and gbp = 1194.9 and eur = 189477 and  hkd = 1536.3','')")

    con:query("insert into check_sql values(1708,'delete from transaction_total_check where cny = 1708 and jpy = 170800 and gbp = 1195.6 and eur = 189588 and  hkd = 1537.2','')")

    con:query("insert into check_sql values(1709,'delete from transaction_total_check where cny = 1709 and jpy = 170900 and gbp = 1196.3 and eur = 189699 and  hkd = 1538.1','')")

    con:query("insert into check_sql values(1710,'delete from transaction_total_check where cny = 1710 and jpy = 171000 and gbp = 1197.0 and eur = 189810 and  hkd = 1539.0','')")

    con:query("insert into check_sql values(1711,'delete from transaction_total_check where cny = 1711 and jpy = 171100 and gbp = 1197.7 and eur = 189921 and  hkd = 1539.9','')")

    con:query("insert into check_sql values(1712,'delete from transaction_total_check where cny = 1712 and jpy = 171200 and gbp = 1198.4 and eur = 190032 and  hkd = 1540.8','')")

    con:query("insert into check_sql values(1713,'delete from transaction_total_check where cny = 1713 and jpy = 171300 and gbp = 1199.1 and eur = 190143 and  hkd = 1541.7','')")

    con:query("insert into check_sql values(1714,'delete from transaction_total_check where cny = 1714 and jpy = 171400 and gbp = 1199.8 and eur = 190254 and  hkd = 1542.6','')")

    con:query("insert into check_sql values(1715,'delete from transaction_total_check where cny = 1715 and jpy = 171500 and gbp = 1200.5 and eur = 190365 and  hkd = 1543.5','')")

    con:query("insert into check_sql values(1716,'delete from transaction_total_check where cny = 1716 and jpy = 171600 and gbp = 1201.2 and eur = 190476 and  hkd = 1544.4','')")

    con:query("insert into check_sql values(1717,'delete from transaction_total_check where cny = 1717 and jpy = 171700 and gbp = 1201.9 and eur = 190587 and  hkd = 1545.3','')")

    con:query("insert into check_sql values(1718,'delete from transaction_total_check where cny = 1718 and jpy = 171800 and gbp = 1202.6 and eur = 190698 and  hkd = 1546.2','')")

    con:query("insert into check_sql values(1719,'delete from transaction_total_check where cny = 1719 and jpy = 171900 and gbp = 1203.3 and eur = 190809 and  hkd = 1547.1','')")

    con:query("insert into check_sql values(1720,'delete from transaction_total_check where cny = 1720 and jpy = 172000 and gbp = 1204.0 and eur = 190920 and  hkd = 1548.0','')")

    con:query("insert into check_sql values(1721,'delete from transaction_total_check where cny = 1721 and jpy = 172100 and gbp = 1204.7 and eur = 191031 and  hkd = 1548.9','')")

    con:query("insert into check_sql values(1722,'delete from transaction_total_check where cny = 1722 and jpy = 172200 and gbp = 1205.4 and eur = 191142 and  hkd = 1549.8','')")

    con:query("insert into check_sql values(1723,'delete from transaction_total_check where cny = 1723 and jpy = 172300 and gbp = 1206.1 and eur = 191253 and  hkd = 1550.7','')")

    con:query("insert into check_sql values(1724,'delete from transaction_total_check where cny = 1724 and jpy = 172400 and gbp = 1206.8 and eur = 191364 and  hkd = 1551.6','')")

    con:query("insert into check_sql values(1725,'delete from transaction_total_check where cny = 1725 and jpy = 172500 and gbp = 1207.5 and eur = 191475 and  hkd = 1552.5','')")

    con:query("insert into check_sql values(1726,'delete from transaction_total_check where cny = 1726 and jpy = 172600 and gbp = 1208.2 and eur = 191586 and  hkd = 1553.4','')")

    con:query("insert into check_sql values(1727,'delete from transaction_total_check where cny = 1727 and jpy = 172700 and gbp = 1208.9 and eur = 191697 and  hkd = 1554.3','')")

    con:query("insert into check_sql values(1728,'delete from transaction_total_check where cny = 1728 and jpy = 172800 and gbp = 1209.6 and eur = 191808 and  hkd = 1555.2','')")

    con:query("insert into check_sql values(1729,'delete from transaction_total_check where cny = 1729 and jpy = 172900 and gbp = 1210.3 and eur = 191919 and  hkd = 1556.1','')")

    con:query("insert into check_sql values(1730,'delete from transaction_total_check where cny = 1730 and jpy = 173000 and gbp = 1211.0 and eur = 192030 and  hkd = 1557.0','')")

    con:query("insert into check_sql values(1731,'delete from transaction_total_check where cny = 1731 and jpy = 173100 and gbp = 1211.7 and eur = 192141 and  hkd = 1557.9','')")

    con:query("insert into check_sql values(1732,'delete from transaction_total_check where cny = 1732 and jpy = 173200 and gbp = 1212.4 and eur = 192252 and  hkd = 1558.8','')")

    con:query("insert into check_sql values(1733,'delete from transaction_total_check where cny = 1733 and jpy = 173300 and gbp = 1213.1 and eur = 192363 and  hkd = 1559.7','')")

    con:query("insert into check_sql values(1734,'delete from transaction_total_check where cny = 1734 and jpy = 173400 and gbp = 1213.8 and eur = 192474 and  hkd = 1560.6','')")

    con:query("insert into check_sql values(1735,'delete from transaction_total_check where cny = 1735 and jpy = 173500 and gbp = 1214.5 and eur = 192585 and  hkd = 1561.5','')")

    con:query("insert into check_sql values(1736,'delete from transaction_total_check where cny = 1736 and jpy = 173600 and gbp = 1215.2 and eur = 192696 and  hkd = 1562.4','')")

    con:query("insert into check_sql values(1737,'delete from transaction_total_check where cny = 1737 and jpy = 173700 and gbp = 1215.9 and eur = 192807 and  hkd = 1563.3','')")

    con:query("insert into check_sql values(1738,'delete from transaction_total_check where cny = 1738 and jpy = 173800 and gbp = 1216.6 and eur = 192918 and  hkd = 1564.2','')")

    con:query("insert into check_sql values(1739,'delete from transaction_total_check where cny = 1739 and jpy = 173900 and gbp = 1217.3 and eur = 193029 and  hkd = 1565.1','')")

    con:query("insert into check_sql values(1740,'delete from transaction_total_check where cny = 1740 and jpy = 174000 and gbp = 1218.0 and eur = 193140 and  hkd = 1566.0','')")

    con:query("insert into check_sql values(1741,'delete from transaction_total_check where cny = 1741 and jpy = 174100 and gbp = 1218.7 and eur = 193251 and  hkd = 1566.9','')")

    con:query("insert into check_sql values(1742,'delete from transaction_total_check where cny = 1742 and jpy = 174200 and gbp = 1219.4 and eur = 193362 and  hkd = 1567.8','')")

    con:query("insert into check_sql values(1743,'delete from transaction_total_check where cny = 1743 and jpy = 174300 and gbp = 1220.1 and eur = 193473 and  hkd = 1568.7','')")

    con:query("insert into check_sql values(1744,'delete from transaction_total_check where cny = 1744 and jpy = 174400 and gbp = 1220.8 and eur = 193584 and  hkd = 1569.6','')")

    con:query("insert into check_sql values(1745,'delete from transaction_total_check where cny = 1745 and jpy = 174500 and gbp = 1221.5 and eur = 193695 and  hkd = 1570.5','')")

    con:query("insert into check_sql values(1746,'delete from transaction_total_check where cny = 1746 and jpy = 174600 and gbp = 1222.2 and eur = 193806 and  hkd = 1571.4','')")

    con:query("insert into check_sql values(1747,'delete from transaction_total_check where cny = 1747 and jpy = 174700 and gbp = 1222.9 and eur = 193917 and  hkd = 1572.3','')")

    con:query("insert into check_sql values(1748,'delete from transaction_total_check where cny = 1748 and jpy = 174800 and gbp = 1223.6 and eur = 194028 and  hkd = 1573.2','')")

    con:query("insert into check_sql values(1749,'delete from transaction_total_check where cny = 1749 and jpy = 174900 and gbp = 1224.3 and eur = 194139 and  hkd = 1574.1','')")

    con:query("insert into check_sql values(1750,'delete from transaction_total_check where cny = 1750 and jpy = 175000 and gbp = 1225.0 and eur = 194250 and  hkd = 1575.0','')")

    con:query("insert into check_sql values(1751,'delete from transaction_total_check where cny = 1751 and jpy = 175100 and gbp = 1225.7 and eur = 194361 and  hkd = 1575.9','')")

    con:query("insert into check_sql values(1752,'delete from transaction_total_check where cny = 1752 and jpy = 175200 and gbp = 1226.4 and eur = 194472 and  hkd = 1576.8','')")

    con:query("insert into check_sql values(1753,'delete from transaction_total_check where cny = 1753 and jpy = 175300 and gbp = 1227.1 and eur = 194583 and  hkd = 1577.7','')")

    con:query("insert into check_sql values(1754,'delete from transaction_total_check where cny = 1754 and jpy = 175400 and gbp = 1227.8 and eur = 194694 and  hkd = 1578.6','')")

    con:query("insert into check_sql values(1755,'delete from transaction_total_check where cny = 1755 and jpy = 175500 and gbp = 1228.5 and eur = 194805 and  hkd = 1579.5','')")

    con:query("insert into check_sql values(1756,'delete from transaction_total_check where cny = 1756 and jpy = 175600 and gbp = 1229.2 and eur = 194916 and  hkd = 1580.4','')")

    con:query("insert into check_sql values(1757,'delete from transaction_total_check where cny = 1757 and jpy = 175700 and gbp = 1229.9 and eur = 195027 and  hkd = 1581.3','')")

    con:query("insert into check_sql values(1758,'delete from transaction_total_check where cny = 1758 and jpy = 175800 and gbp = 1230.6 and eur = 195138 and  hkd = 1582.2','')")

    con:query("insert into check_sql values(1759,'delete from transaction_total_check where cny = 1759 and jpy = 175900 and gbp = 1231.3 and eur = 195249 and  hkd = 1583.1','')")

    con:query("insert into check_sql values(1760,'delete from transaction_total_check where cny = 1760 and jpy = 176000 and gbp = 1232.0 and eur = 195360 and  hkd = 1584.0','')")

    con:query("insert into check_sql values(1761,'delete from transaction_total_check where cny = 1761 and jpy = 176100 and gbp = 1232.7 and eur = 195471 and  hkd = 1584.9','')")

    con:query("insert into check_sql values(1762,'delete from transaction_total_check where cny = 1762 and jpy = 176200 and gbp = 1233.4 and eur = 195582 and  hkd = 1585.8','')")

    con:query("insert into check_sql values(1763,'delete from transaction_total_check where cny = 1763 and jpy = 176300 and gbp = 1234.1 and eur = 195693 and  hkd = 1586.7','')")

    con:query("insert into check_sql values(1764,'delete from transaction_total_check where cny = 1764 and jpy = 176400 and gbp = 1234.8 and eur = 195804 and  hkd = 1587.6','')")

    con:query("insert into check_sql values(1765,'delete from transaction_total_check where cny = 1765 and jpy = 176500 and gbp = 1235.5 and eur = 195915 and  hkd = 1588.5','')")

    con:query("insert into check_sql values(1766,'delete from transaction_total_check where cny = 1766 and jpy = 176600 and gbp = 1236.2 and eur = 196026 and  hkd = 1589.4','')")

    con:query("insert into check_sql values(1767,'delete from transaction_total_check where cny = 1767 and jpy = 176700 and gbp = 1236.9 and eur = 196137 and  hkd = 1590.3','')")

    con:query("insert into check_sql values(1768,'delete from transaction_total_check where cny = 1768 and jpy = 176800 and gbp = 1237.6 and eur = 196248 and  hkd = 1591.2','')")

    con:query("insert into check_sql values(1769,'delete from transaction_total_check where cny = 1769 and jpy = 176900 and gbp = 1238.3 and eur = 196359 and  hkd = 1592.1','')")

    con:query("insert into check_sql values(1770,'delete from transaction_total_check where cny = 1770 and jpy = 177000 and gbp = 1239.0 and eur = 196470 and  hkd = 1593.0','')")

    con:query("insert into check_sql values(1771,'delete from transaction_total_check where cny = 1771 and jpy = 177100 and gbp = 1239.7 and eur = 196581 and  hkd = 1593.9','')")

    con:query("insert into check_sql values(1772,'delete from transaction_total_check where cny = 1772 and jpy = 177200 and gbp = 1240.4 and eur = 196692 and  hkd = 1594.8','')")

    con:query("insert into check_sql values(1773,'delete from transaction_total_check where cny = 1773 and jpy = 177300 and gbp = 1241.1 and eur = 196803 and  hkd = 1595.7','')")

    con:query("insert into check_sql values(1774,'delete from transaction_total_check where cny = 1774 and jpy = 177400 and gbp = 1241.8 and eur = 196914 and  hkd = 1596.6','')")

    con:query("insert into check_sql values(1775,'delete from transaction_total_check where cny = 1775 and jpy = 177500 and gbp = 1242.5 and eur = 197025 and  hkd = 1597.5','')")

    con:query("insert into check_sql values(1776,'delete from transaction_total_check where cny = 1776 and jpy = 177600 and gbp = 1243.2 and eur = 197136 and  hkd = 1598.4','')")

    con:query("insert into check_sql values(1777,'delete from transaction_total_check where cny = 1777 and jpy = 177700 and gbp = 1243.9 and eur = 197247 and  hkd = 1599.3','')")

    con:query("insert into check_sql values(1778,'delete from transaction_total_check where cny = 1778 and jpy = 177800 and gbp = 1244.6 and eur = 197358 and  hkd = 1600.2','')")

    con:query("insert into check_sql values(1779,'delete from transaction_total_check where cny = 1779 and jpy = 177900 and gbp = 1245.3 and eur = 197469 and  hkd = 1601.1','')")

    con:query("insert into check_sql values(1780,'delete from transaction_total_check where cny = 1780 and jpy = 178000 and gbp = 1246.0 and eur = 197580 and  hkd = 1602.0','')")

    con:query("insert into check_sql values(1781,'delete from transaction_total_check where cny = 1781 and jpy = 178100 and gbp = 1246.7 and eur = 197691 and  hkd = 1602.9','')")

    con:query("insert into check_sql values(1782,'delete from transaction_total_check where cny = 1782 and jpy = 178200 and gbp = 1247.4 and eur = 197802 and  hkd = 1603.8','')")

    con:query("insert into check_sql values(1783,'delete from transaction_total_check where cny = 1783 and jpy = 178300 and gbp = 1248.1 and eur = 197913 and  hkd = 1604.7','')")

    con:query("insert into check_sql values(1784,'delete from transaction_total_check where cny = 1784 and jpy = 178400 and gbp = 1248.8 and eur = 198024 and  hkd = 1605.6','')")

    con:query("insert into check_sql values(1785,'delete from transaction_total_check where cny = 1785 and jpy = 178500 and gbp = 1249.5 and eur = 198135 and  hkd = 1606.5','')")

    con:query("insert into check_sql values(1786,'delete from transaction_total_check where cny = 1786 and jpy = 178600 and gbp = 1250.2 and eur = 198246 and  hkd = 1607.4','')")

    con:query("insert into check_sql values(1787,'delete from transaction_total_check where cny = 1787 and jpy = 178700 and gbp = 1250.9 and eur = 198357 and  hkd = 1608.3','')")

    con:query("insert into check_sql values(1788,'delete from transaction_total_check where cny = 1788 and jpy = 178800 and gbp = 1251.6 and eur = 198468 and  hkd = 1609.2','')")

    con:query("insert into check_sql values(1789,'delete from transaction_total_check where cny = 1789 and jpy = 178900 and gbp = 1252.3 and eur = 198579 and  hkd = 1610.1','')")

    con:query("insert into check_sql values(1790,'delete from transaction_total_check where cny = 1790 and jpy = 179000 and gbp = 1253.0 and eur = 198690 and  hkd = 1611.0','')")

    con:query("insert into check_sql values(1791,'delete from transaction_total_check where cny = 1791 and jpy = 179100 and gbp = 1253.7 and eur = 198801 and  hkd = 1611.9','')")

    con:query("insert into check_sql values(1792,'delete from transaction_total_check where cny = 1792 and jpy = 179200 and gbp = 1254.4 and eur = 198912 and  hkd = 1612.8','')")

    con:query("insert into check_sql values(1793,'delete from transaction_total_check where cny = 1793 and jpy = 179300 and gbp = 1255.1 and eur = 199023 and  hkd = 1613.7','')")

    con:query("insert into check_sql values(1794,'delete from transaction_total_check where cny = 1794 and jpy = 179400 and gbp = 1255.8 and eur = 199134 and  hkd = 1614.6','')")

    con:query("insert into check_sql values(1795,'delete from transaction_total_check where cny = 1795 and jpy = 179500 and gbp = 1256.5 and eur = 199245 and  hkd = 1615.5','')")

    con:query("insert into check_sql values(1796,'delete from transaction_total_check where cny = 1796 and jpy = 179600 and gbp = 1257.2 and eur = 199356 and  hkd = 1616.4','')")

    con:query("insert into check_sql values(1797,'delete from transaction_total_check where cny = 1797 and jpy = 179700 and gbp = 1257.9 and eur = 199467 and  hkd = 1617.3','')")

    con:query("insert into check_sql values(1798,'delete from transaction_total_check where cny = 1798 and jpy = 179800 and gbp = 1258.6 and eur = 199578 and  hkd = 1618.2','')")

    con:query("insert into check_sql values(1799,'delete from transaction_total_check where cny = 1799 and jpy = 179900 and gbp = 1259.3 and eur = 199689 and  hkd = 1619.1','')")

    con:query("insert into check_sql values(1800,'delete from transaction_total_check where cny = 1800 and jpy = 180000 and gbp = 1260.0 and eur = 199800 and  hkd = 1620.0','')")

    con:query("insert into check_sql values(1801,'delete from transaction_total_check where cny = 1801 and jpy = 180100 and gbp = 1260.7 and eur = 199911 and  hkd = 1620.9','')")

    con:query("insert into check_sql values(1802,'delete from transaction_total_check where cny = 1802 and jpy = 180200 and gbp = 1261.4 and eur = 200022 and  hkd = 1621.8','')")

    con:query("insert into check_sql values(1803,'delete from transaction_total_check where cny = 1803 and jpy = 180300 and gbp = 1262.1 and eur = 200133 and  hkd = 1622.7','')")

    con:query("insert into check_sql values(1804,'delete from transaction_total_check where cny = 1804 and jpy = 180400 and gbp = 1262.8 and eur = 200244 and  hkd = 1623.6','')")

    con:query("insert into check_sql values(1805,'delete from transaction_total_check where cny = 1805 and jpy = 180500 and gbp = 1263.5 and eur = 200355 and  hkd = 1624.5','')")

    con:query("insert into check_sql values(1806,'delete from transaction_total_check where cny = 1806 and jpy = 180600 and gbp = 1264.2 and eur = 200466 and  hkd = 1625.4','')")

    con:query("insert into check_sql values(1807,'delete from transaction_total_check where cny = 1807 and jpy = 180700 and gbp = 1264.9 and eur = 200577 and  hkd = 1626.3','')")

    con:query("insert into check_sql values(1808,'delete from transaction_total_check where cny = 1808 and jpy = 180800 and gbp = 1265.6 and eur = 200688 and  hkd = 1627.2','')")

    con:query("insert into check_sql values(1809,'delete from transaction_total_check where cny = 1809 and jpy = 180900 and gbp = 1266.3 and eur = 200799 and  hkd = 1628.1','')")

    con:query("insert into check_sql values(1810,'delete from transaction_total_check where cny = 1810 and jpy = 181000 and gbp = 1267.0 and eur = 200910 and  hkd = 1629.0','')")

    con:query("insert into check_sql values(1811,'delete from transaction_total_check where cny = 1811 and jpy = 181100 and gbp = 1267.7 and eur = 201021 and  hkd = 1629.9','')")

    con:query("insert into check_sql values(1812,'delete from transaction_total_check where cny = 1812 and jpy = 181200 and gbp = 1268.4 and eur = 201132 and  hkd = 1630.8','')")

    con:query("insert into check_sql values(1813,'delete from transaction_total_check where cny = 1813 and jpy = 181300 and gbp = 1269.1 and eur = 201243 and  hkd = 1631.7','')")

    con:query("insert into check_sql values(1814,'delete from transaction_total_check where cny = 1814 and jpy = 181400 and gbp = 1269.8 and eur = 201354 and  hkd = 1632.6','')")

    con:query("insert into check_sql values(1815,'delete from transaction_total_check where cny = 1815 and jpy = 181500 and gbp = 1270.5 and eur = 201465 and  hkd = 1633.5','')")

    con:query("insert into check_sql values(1816,'delete from transaction_total_check where cny = 1816 and jpy = 181600 and gbp = 1271.2 and eur = 201576 and  hkd = 1634.4','')")

    con:query("insert into check_sql values(1817,'delete from transaction_total_check where cny = 1817 and jpy = 181700 and gbp = 1271.9 and eur = 201687 and  hkd = 1635.3','')")

    con:query("insert into check_sql values(1818,'delete from transaction_total_check where cny = 1818 and jpy = 181800 and gbp = 1272.6 and eur = 201798 and  hkd = 1636.2','')")

    con:query("insert into check_sql values(1819,'delete from transaction_total_check where cny = 1819 and jpy = 181900 and gbp = 1273.3 and eur = 201909 and  hkd = 1637.1','')")

    con:query("insert into check_sql values(1820,'delete from transaction_total_check where cny = 1820 and jpy = 182000 and gbp = 1274.0 and eur = 202020 and  hkd = 1638.0','')")

    con:query("insert into check_sql values(1821,'delete from transaction_total_check where cny = 1821 and jpy = 182100 and gbp = 1274.7 and eur = 202131 and  hkd = 1638.9','')")

    con:query("insert into check_sql values(1822,'delete from transaction_total_check where cny = 1822 and jpy = 182200 and gbp = 1275.4 and eur = 202242 and  hkd = 1639.8','')")

    con:query("insert into check_sql values(1823,'delete from transaction_total_check where cny = 1823 and jpy = 182300 and gbp = 1276.1 and eur = 202353 and  hkd = 1640.7','')")

    con:query("insert into check_sql values(1824,'delete from transaction_total_check where cny = 1824 and jpy = 182400 and gbp = 1276.8 and eur = 202464 and  hkd = 1641.6','')")

    con:query("insert into check_sql values(1825,'delete from transaction_total_check where cny = 1825 and jpy = 182500 and gbp = 1277.5 and eur = 202575 and  hkd = 1642.5','')")

    con:query("insert into check_sql values(1826,'delete from transaction_total_check where cny = 1826 and jpy = 182600 and gbp = 1278.2 and eur = 202686 and  hkd = 1643.4','')")

    con:query("insert into check_sql values(1827,'delete from transaction_total_check where cny = 1827 and jpy = 182700 and gbp = 1278.9 and eur = 202797 and  hkd = 1644.3','')")

    con:query("insert into check_sql values(1828,'delete from transaction_total_check where cny = 1828 and jpy = 182800 and gbp = 1279.6 and eur = 202908 and  hkd = 1645.2','')")

    con:query("insert into check_sql values(1829,'delete from transaction_total_check where cny = 1829 and jpy = 182900 and gbp = 1280.3 and eur = 203019 and  hkd = 1646.1','')")

    con:query("insert into check_sql values(1830,'delete from transaction_total_check where cny = 1830 and jpy = 183000 and gbp = 1281.0 and eur = 203130 and  hkd = 1647.0','')")

    con:query("insert into check_sql values(1831,'delete from transaction_total_check where cny = 1831 and jpy = 183100 and gbp = 1281.7 and eur = 203241 and  hkd = 1647.9','')")

    con:query("insert into check_sql values(1832,'delete from transaction_total_check where cny = 1832 and jpy = 183200 and gbp = 1282.4 and eur = 203352 and  hkd = 1648.8','')")

    con:query("insert into check_sql values(1833,'delete from transaction_total_check where cny = 1833 and jpy = 183300 and gbp = 1283.1 and eur = 203463 and  hkd = 1649.7','')")

    con:query("insert into check_sql values(1834,'delete from transaction_total_check where cny = 1834 and jpy = 183400 and gbp = 1283.8 and eur = 203574 and  hkd = 1650.6','')")

    con:query("insert into check_sql values(1835,'delete from transaction_total_check where cny = 1835 and jpy = 183500 and gbp = 1284.5 and eur = 203685 and  hkd = 1651.5','')")

    con:query("insert into check_sql values(1836,'delete from transaction_total_check where cny = 1836 and jpy = 183600 and gbp = 1285.2 and eur = 203796 and  hkd = 1652.4','')")

    con:query("insert into check_sql values(1837,'delete from transaction_total_check where cny = 1837 and jpy = 183700 and gbp = 1285.9 and eur = 203907 and  hkd = 1653.3','')")

    con:query("insert into check_sql values(1838,'delete from transaction_total_check where cny = 1838 and jpy = 183800 and gbp = 1286.6 and eur = 204018 and  hkd = 1654.2','')")

    con:query("insert into check_sql values(1839,'delete from transaction_total_check where cny = 1839 and jpy = 183900 and gbp = 1287.3 and eur = 204129 and  hkd = 1655.1','')")

    con:query("insert into check_sql values(1840,'delete from transaction_total_check where cny = 1840 and jpy = 184000 and gbp = 1288.0 and eur = 204240 and  hkd = 1656.0','')")

    con:query("insert into check_sql values(1841,'delete from transaction_total_check where cny = 1841 and jpy = 184100 and gbp = 1288.7 and eur = 204351 and  hkd = 1656.9','')")

    con:query("insert into check_sql values(1842,'delete from transaction_total_check where cny = 1842 and jpy = 184200 and gbp = 1289.4 and eur = 204462 and  hkd = 1657.8','')")

    con:query("insert into check_sql values(1843,'delete from transaction_total_check where cny = 1843 and jpy = 184300 and gbp = 1290.1 and eur = 204573 and  hkd = 1658.7','')")

    con:query("insert into check_sql values(1844,'delete from transaction_total_check where cny = 1844 and jpy = 184400 and gbp = 1290.8 and eur = 204684 and  hkd = 1659.6','')")

    con:query("insert into check_sql values(1845,'delete from transaction_total_check where cny = 1845 and jpy = 184500 and gbp = 1291.5 and eur = 204795 and  hkd = 1660.5','')")

    con:query("insert into check_sql values(1846,'delete from transaction_total_check where cny = 1846 and jpy = 184600 and gbp = 1292.2 and eur = 204906 and  hkd = 1661.4','')")

    con:query("insert into check_sql values(1847,'delete from transaction_total_check where cny = 1847 and jpy = 184700 and gbp = 1292.9 and eur = 205017 and  hkd = 1662.3','')")

    con:query("insert into check_sql values(1848,'delete from transaction_total_check where cny = 1848 and jpy = 184800 and gbp = 1293.6 and eur = 205128 and  hkd = 1663.2','')")

    con:query("insert into check_sql values(1849,'delete from transaction_total_check where cny = 1849 and jpy = 184900 and gbp = 1294.3 and eur = 205239 and  hkd = 1664.1','')")

    con:query("insert into check_sql values(1850,'delete from transaction_total_check where cny = 1850 and jpy = 185000 and gbp = 1295.0 and eur = 205350 and  hkd = 1665.0','')")

    con:query("insert into check_sql values(1851,'delete from transaction_total_check where cny = 1851 and jpy = 185100 and gbp = 1295.7 and eur = 205461 and  hkd = 1665.9','')")

    con:query("insert into check_sql values(1852,'delete from transaction_total_check where cny = 1852 and jpy = 185200 and gbp = 1296.4 and eur = 205572 and  hkd = 1666.8','')")

    con:query("insert into check_sql values(1853,'delete from transaction_total_check where cny = 1853 and jpy = 185300 and gbp = 1297.1 and eur = 205683 and  hkd = 1667.7','')")

    con:query("insert into check_sql values(1854,'delete from transaction_total_check where cny = 1854 and jpy = 185400 and gbp = 1297.8 and eur = 205794 and  hkd = 1668.6','')")

    con:query("insert into check_sql values(1855,'delete from transaction_total_check where cny = 1855 and jpy = 185500 and gbp = 1298.5 and eur = 205905 and  hkd = 1669.5','')")

    con:query("insert into check_sql values(1856,'delete from transaction_total_check where cny = 1856 and jpy = 185600 and gbp = 1299.2 and eur = 206016 and  hkd = 1670.4','')")

    con:query("insert into check_sql values(1857,'delete from transaction_total_check where cny = 1857 and jpy = 185700 and gbp = 1299.9 and eur = 206127 and  hkd = 1671.3','')")

    con:query("insert into check_sql values(1858,'delete from transaction_total_check where cny = 1858 and jpy = 185800 and gbp = 1300.6 and eur = 206238 and  hkd = 1672.2','')")

    con:query("insert into check_sql values(1859,'delete from transaction_total_check where cny = 1859 and jpy = 185900 and gbp = 1301.3 and eur = 206349 and  hkd = 1673.1','')")

    con:query("insert into check_sql values(1860,'delete from transaction_total_check where cny = 1860 and jpy = 186000 and gbp = 1302.0 and eur = 206460 and  hkd = 1674.0','')")

    con:query("insert into check_sql values(1861,'delete from transaction_total_check where cny = 1861 and jpy = 186100 and gbp = 1302.7 and eur = 206571 and  hkd = 1674.9','')")

    con:query("insert into check_sql values(1862,'delete from transaction_total_check where cny = 1862 and jpy = 186200 and gbp = 1303.4 and eur = 206682 and  hkd = 1675.8','')")

    con:query("insert into check_sql values(1863,'delete from transaction_total_check where cny = 1863 and jpy = 186300 and gbp = 1304.1 and eur = 206793 and  hkd = 1676.7','')")

    con:query("insert into check_sql values(1864,'delete from transaction_total_check where cny = 1864 and jpy = 186400 and gbp = 1304.8 and eur = 206904 and  hkd = 1677.6','')")

    con:query("insert into check_sql values(1865,'delete from transaction_total_check where cny = 1865 and jpy = 186500 and gbp = 1305.5 and eur = 207015 and  hkd = 1678.5','')")

    con:query("insert into check_sql values(1866,'delete from transaction_total_check where cny = 1866 and jpy = 186600 and gbp = 1306.2 and eur = 207126 and  hkd = 1679.4','')")

    con:query("insert into check_sql values(1867,'delete from transaction_total_check where cny = 1867 and jpy = 186700 and gbp = 1306.9 and eur = 207237 and  hkd = 1680.3','')")

    con:query("insert into check_sql values(1868,'delete from transaction_total_check where cny = 1868 and jpy = 186800 and gbp = 1307.6 and eur = 207348 and  hkd = 1681.2','')")

    con:query("insert into check_sql values(1869,'delete from transaction_total_check where cny = 1869 and jpy = 186900 and gbp = 1308.3 and eur = 207459 and  hkd = 1682.1','')")

    con:query("insert into check_sql values(1870,'delete from transaction_total_check where cny = 1870 and jpy = 187000 and gbp = 1309.0 and eur = 207570 and  hkd = 1683.0','')")

    con:query("insert into check_sql values(1871,'delete from transaction_total_check where cny = 1871 and jpy = 187100 and gbp = 1309.7 and eur = 207681 and  hkd = 1683.9','')")

    con:query("insert into check_sql values(1872,'delete from transaction_total_check where cny = 1872 and jpy = 187200 and gbp = 1310.4 and eur = 207792 and  hkd = 1684.8','')")

    con:query("insert into check_sql values(1873,'delete from transaction_total_check where cny = 1873 and jpy = 187300 and gbp = 1311.1 and eur = 207903 and  hkd = 1685.7','')")

    con:query("insert into check_sql values(1874,'delete from transaction_total_check where cny = 1874 and jpy = 187400 and gbp = 1311.8 and eur = 208014 and  hkd = 1686.6','')")

    con:query("insert into check_sql values(1875,'delete from transaction_total_check where cny = 1875 and jpy = 187500 and gbp = 1312.5 and eur = 208125 and  hkd = 1687.5','')")

    con:query("insert into check_sql values(1876,'delete from transaction_total_check where cny = 1876 and jpy = 187600 and gbp = 1313.2 and eur = 208236 and  hkd = 1688.4','')")

    con:query("insert into check_sql values(1877,'delete from transaction_total_check where cny = 1877 and jpy = 187700 and gbp = 1313.9 and eur = 208347 and  hkd = 1689.3','')")

    con:query("insert into check_sql values(1878,'delete from transaction_total_check where cny = 1878 and jpy = 187800 and gbp = 1314.6 and eur = 208458 and  hkd = 1690.2','')")

    con:query("insert into check_sql values(1879,'delete from transaction_total_check where cny = 1879 and jpy = 187900 and gbp = 1315.3 and eur = 208569 and  hkd = 1691.1','')")

    con:query("insert into check_sql values(1880,'delete from transaction_total_check where cny = 1880 and jpy = 188000 and gbp = 1316.0 and eur = 208680 and  hkd = 1692.0','')")

    con:query("insert into check_sql values(1881,'delete from transaction_total_check where cny = 1881 and jpy = 188100 and gbp = 1316.7 and eur = 208791 and  hkd = 1692.9','')")

    con:query("insert into check_sql values(1882,'delete from transaction_total_check where cny = 1882 and jpy = 188200 and gbp = 1317.4 and eur = 208902 and  hkd = 1693.8','')")

    con:query("insert into check_sql values(1883,'delete from transaction_total_check where cny = 1883 and jpy = 188300 and gbp = 1318.1 and eur = 209013 and  hkd = 1694.7','')")

    con:query("insert into check_sql values(1884,'delete from transaction_total_check where cny = 1884 and jpy = 188400 and gbp = 1318.8 and eur = 209124 and  hkd = 1695.6','')")

    con:query("insert into check_sql values(1885,'delete from transaction_total_check where cny = 1885 and jpy = 188500 and gbp = 1319.5 and eur = 209235 and  hkd = 1696.5','')")

    con:query("insert into check_sql values(1886,'delete from transaction_total_check where cny = 1886 and jpy = 188600 and gbp = 1320.2 and eur = 209346 and  hkd = 1697.4','')")

    con:query("insert into check_sql values(1887,'delete from transaction_total_check where cny = 1887 and jpy = 188700 and gbp = 1320.9 and eur = 209457 and  hkd = 1698.3','')")

    con:query("insert into check_sql values(1888,'delete from transaction_total_check where cny = 1888 and jpy = 188800 and gbp = 1321.6 and eur = 209568 and  hkd = 1699.2','')")

    con:query("insert into check_sql values(1889,'delete from transaction_total_check where cny = 1889 and jpy = 188900 and gbp = 1322.3 and eur = 209679 and  hkd = 1700.1','')")

    con:query("insert into check_sql values(1890,'delete from transaction_total_check where cny = 1890 and jpy = 189000 and gbp = 1323.0 and eur = 209790 and  hkd = 1701.0','')")

    con:query("insert into check_sql values(1891,'delete from transaction_total_check where cny = 1891 and jpy = 189100 and gbp = 1323.7 and eur = 209901 and  hkd = 1701.9','')")

    con:query("insert into check_sql values(1892,'delete from transaction_total_check where cny = 1892 and jpy = 189200 and gbp = 1324.4 and eur = 210012 and  hkd = 1702.8','')")

    con:query("insert into check_sql values(1893,'delete from transaction_total_check where cny = 1893 and jpy = 189300 and gbp = 1325.1 and eur = 210123 and  hkd = 1703.7','')")

    con:query("insert into check_sql values(1894,'delete from transaction_total_check where cny = 1894 and jpy = 189400 and gbp = 1325.8 and eur = 210234 and  hkd = 1704.6','')")

    con:query("insert into check_sql values(1895,'delete from transaction_total_check where cny = 1895 and jpy = 189500 and gbp = 1326.5 and eur = 210345 and  hkd = 1705.5','')")

    con:query("insert into check_sql values(1896,'delete from transaction_total_check where cny = 1896 and jpy = 189600 and gbp = 1327.2 and eur = 210456 and  hkd = 1706.4','')")

    con:query("insert into check_sql values(1897,'delete from transaction_total_check where cny = 1897 and jpy = 189700 and gbp = 1327.9 and eur = 210567 and  hkd = 1707.3','')")

    con:query("insert into check_sql values(1898,'delete from transaction_total_check where cny = 1898 and jpy = 189800 and gbp = 1328.6 and eur = 210678 and  hkd = 1708.2','')")

    con:query("insert into check_sql values(1899,'delete from transaction_total_check where cny = 1899 and jpy = 189900 and gbp = 1329.3 and eur = 210789 and  hkd = 1709.1','')")

    con:query("insert into check_sql values(1900,'delete from transaction_total_check where cny = 1900 and jpy = 190000 and gbp = 1330.0 and eur = 210900 and  hkd = 1710.0','')")

    con:query("insert into check_sql values(1901,'delete from transaction_total_check where cny = 1901 and jpy = 190100 and gbp = 1330.7 and eur = 211011 and  hkd = 1710.9','')")

    con:query("insert into check_sql values(1902,'delete from transaction_total_check where cny = 1902 and jpy = 190200 and gbp = 1331.4 and eur = 211122 and  hkd = 1711.8','')")

    con:query("insert into check_sql values(1903,'delete from transaction_total_check where cny = 1903 and jpy = 190300 and gbp = 1332.1 and eur = 211233 and  hkd = 1712.7','')")

    con:query("insert into check_sql values(1904,'delete from transaction_total_check where cny = 1904 and jpy = 190400 and gbp = 1332.8 and eur = 211344 and  hkd = 1713.6','')")

    con:query("insert into check_sql values(1905,'delete from transaction_total_check where cny = 1905 and jpy = 190500 and gbp = 1333.5 and eur = 211455 and  hkd = 1714.5','')")

    con:query("insert into check_sql values(1906,'delete from transaction_total_check where cny = 1906 and jpy = 190600 and gbp = 1334.2 and eur = 211566 and  hkd = 1715.4','')")

    con:query("insert into check_sql values(1907,'delete from transaction_total_check where cny = 1907 and jpy = 190700 and gbp = 1334.9 and eur = 211677 and  hkd = 1716.3','')")

    con:query("insert into check_sql values(1908,'delete from transaction_total_check where cny = 1908 and jpy = 190800 and gbp = 1335.6 and eur = 211788 and  hkd = 1717.2','')")

    con:query("insert into check_sql values(1909,'delete from transaction_total_check where cny = 1909 and jpy = 190900 and gbp = 1336.3 and eur = 211899 and  hkd = 1718.1','')")

    con:query("insert into check_sql values(1910,'delete from transaction_total_check where cny = 1910 and jpy = 191000 and gbp = 1337.0 and eur = 212010 and  hkd = 1719.0','')")

    con:query("insert into check_sql values(1911,'delete from transaction_total_check where cny = 1911 and jpy = 191100 and gbp = 1337.7 and eur = 212121 and  hkd = 1719.9','')")

    con:query("insert into check_sql values(1912,'delete from transaction_total_check where cny = 1912 and jpy = 191200 and gbp = 1338.4 and eur = 212232 and  hkd = 1720.8','')")

    con:query("insert into check_sql values(1913,'delete from transaction_total_check where cny = 1913 and jpy = 191300 and gbp = 1339.1 and eur = 212343 and  hkd = 1721.7','')")

    con:query("insert into check_sql values(1914,'delete from transaction_total_check where cny = 1914 and jpy = 191400 and gbp = 1339.8 and eur = 212454 and  hkd = 1722.6','')")

    con:query("insert into check_sql values(1915,'delete from transaction_total_check where cny = 1915 and jpy = 191500 and gbp = 1340.5 and eur = 212565 and  hkd = 1723.5','')")

    con:query("insert into check_sql values(1916,'delete from transaction_total_check where cny = 1916 and jpy = 191600 and gbp = 1341.2 and eur = 212676 and  hkd = 1724.4','')")

    con:query("insert into check_sql values(1917,'delete from transaction_total_check where cny = 1917 and jpy = 191700 and gbp = 1341.9 and eur = 212787 and  hkd = 1725.3','')")

    con:query("insert into check_sql values(1918,'delete from transaction_total_check where cny = 1918 and jpy = 191800 and gbp = 1342.6 and eur = 212898 and  hkd = 1726.2','')")

    con:query("insert into check_sql values(1919,'delete from transaction_total_check where cny = 1919 and jpy = 191900 and gbp = 1343.3 and eur = 213009 and  hkd = 1727.1','')")

    con:query("insert into check_sql values(1920,'delete from transaction_total_check where cny = 1920 and jpy = 192000 and gbp = 1344.0 and eur = 213120 and  hkd = 1728.0','')")

    con:query("insert into check_sql values(1921,'delete from transaction_total_check where cny = 1921 and jpy = 192100 and gbp = 1344.7 and eur = 213231 and  hkd = 1728.9','')")

    con:query("insert into check_sql values(1922,'delete from transaction_total_check where cny = 1922 and jpy = 192200 and gbp = 1345.4 and eur = 213342 and  hkd = 1729.8','')")

    con:query("insert into check_sql values(1923,'delete from transaction_total_check where cny = 1923 and jpy = 192300 and gbp = 1346.1 and eur = 213453 and  hkd = 1730.7','')")

    con:query("insert into check_sql values(1924,'delete from transaction_total_check where cny = 1924 and jpy = 192400 and gbp = 1346.8 and eur = 213564 and  hkd = 1731.6','')")

    con:query("insert into check_sql values(1925,'delete from transaction_total_check where cny = 1925 and jpy = 192500 and gbp = 1347.5 and eur = 213675 and  hkd = 1732.5','')")

    con:query("insert into check_sql values(1926,'delete from transaction_total_check where cny = 1926 and jpy = 192600 and gbp = 1348.2 and eur = 213786 and  hkd = 1733.4','')")

    con:query("insert into check_sql values(1927,'delete from transaction_total_check where cny = 1927 and jpy = 192700 and gbp = 1348.9 and eur = 213897 and  hkd = 1734.3','')")

    con:query("insert into check_sql values(1928,'delete from transaction_total_check where cny = 1928 and jpy = 192800 and gbp = 1349.6 and eur = 214008 and  hkd = 1735.2','')")

    con:query("insert into check_sql values(1929,'delete from transaction_total_check where cny = 1929 and jpy = 192900 and gbp = 1350.3 and eur = 214119 and  hkd = 1736.1','')")

    con:query("insert into check_sql values(1930,'delete from transaction_total_check where cny = 1930 and jpy = 193000 and gbp = 1351.0 and eur = 214230 and  hkd = 1737.0','')")

    con:query("insert into check_sql values(1931,'delete from transaction_total_check where cny = 1931 and jpy = 193100 and gbp = 1351.7 and eur = 214341 and  hkd = 1737.9','')")

    con:query("insert into check_sql values(1932,'delete from transaction_total_check where cny = 1932 and jpy = 193200 and gbp = 1352.4 and eur = 214452 and  hkd = 1738.8','')")

    con:query("insert into check_sql values(1933,'delete from transaction_total_check where cny = 1933 and jpy = 193300 and gbp = 1353.1 and eur = 214563 and  hkd = 1739.7','')")

    con:query("insert into check_sql values(1934,'delete from transaction_total_check where cny = 1934 and jpy = 193400 and gbp = 1353.8 and eur = 214674 and  hkd = 1740.6','')")

    con:query("insert into check_sql values(1935,'delete from transaction_total_check where cny = 1935 and jpy = 193500 and gbp = 1354.5 and eur = 214785 and  hkd = 1741.5','')")

    con:query("insert into check_sql values(1936,'delete from transaction_total_check where cny = 1936 and jpy = 193600 and gbp = 1355.2 and eur = 214896 and  hkd = 1742.4','')")

    con:query("insert into check_sql values(1937,'delete from transaction_total_check where cny = 1937 and jpy = 193700 and gbp = 1355.9 and eur = 215007 and  hkd = 1743.3','')")

    con:query("insert into check_sql values(1938,'delete from transaction_total_check where cny = 1938 and jpy = 193800 and gbp = 1356.6 and eur = 215118 and  hkd = 1744.2','')")

    con:query("insert into check_sql values(1939,'delete from transaction_total_check where cny = 1939 and jpy = 193900 and gbp = 1357.3 and eur = 215229 and  hkd = 1745.1','')")

    con:query("insert into check_sql values(1940,'delete from transaction_total_check where cny = 1940 and jpy = 194000 and gbp = 1358.0 and eur = 215340 and  hkd = 1746.0','')")

    con:query("insert into check_sql values(1941,'delete from transaction_total_check where cny = 1941 and jpy = 194100 and gbp = 1358.7 and eur = 215451 and  hkd = 1746.9','')")

    con:query("insert into check_sql values(1942,'delete from transaction_total_check where cny = 1942 and jpy = 194200 and gbp = 1359.4 and eur = 215562 and  hkd = 1747.8','')")

    con:query("insert into check_sql values(1943,'delete from transaction_total_check where cny = 1943 and jpy = 194300 and gbp = 1360.1 and eur = 215673 and  hkd = 1748.7','')")

    con:query("insert into check_sql values(1944,'delete from transaction_total_check where cny = 1944 and jpy = 194400 and gbp = 1360.8 and eur = 215784 and  hkd = 1749.6','')")

    con:query("insert into check_sql values(1945,'delete from transaction_total_check where cny = 1945 and jpy = 194500 and gbp = 1361.5 and eur = 215895 and  hkd = 1750.5','')")

    con:query("insert into check_sql values(1946,'delete from transaction_total_check where cny = 1946 and jpy = 194600 and gbp = 1362.2 and eur = 216006 and  hkd = 1751.4','')")

    con:query("insert into check_sql values(1947,'delete from transaction_total_check where cny = 1947 and jpy = 194700 and gbp = 1362.9 and eur = 216117 and  hkd = 1752.3','')")

    con:query("insert into check_sql values(1948,'delete from transaction_total_check where cny = 1948 and jpy = 194800 and gbp = 1363.6 and eur = 216228 and  hkd = 1753.2','')")

    con:query("insert into check_sql values(1949,'delete from transaction_total_check where cny = 1949 and jpy = 194900 and gbp = 1364.3 and eur = 216339 and  hkd = 1754.1','')")

    con:query("insert into check_sql values(1950,'delete from transaction_total_check where cny = 1950 and jpy = 195000 and gbp = 1365.0 and eur = 216450 and  hkd = 1755.0','')")

    con:query("insert into check_sql values(1951,'delete from transaction_total_check where cny = 1951 and jpy = 195100 and gbp = 1365.7 and eur = 216561 and  hkd = 1755.9','')")

    con:query("insert into check_sql values(1952,'delete from transaction_total_check where cny = 1952 and jpy = 195200 and gbp = 1366.4 and eur = 216672 and  hkd = 1756.8','')")

    con:query("insert into check_sql values(1953,'delete from transaction_total_check where cny = 1953 and jpy = 195300 and gbp = 1367.1 and eur = 216783 and  hkd = 1757.7','')")

    con:query("insert into check_sql values(1954,'delete from transaction_total_check where cny = 1954 and jpy = 195400 and gbp = 1367.8 and eur = 216894 and  hkd = 1758.6','')")

    con:query("insert into check_sql values(1955,'delete from transaction_total_check where cny = 1955 and jpy = 195500 and gbp = 1368.5 and eur = 217005 and  hkd = 1759.5','')")

    con:query("insert into check_sql values(1956,'delete from transaction_total_check where cny = 1956 and jpy = 195600 and gbp = 1369.2 and eur = 217116 and  hkd = 1760.4','')")

    con:query("insert into check_sql values(1957,'delete from transaction_total_check where cny = 1957 and jpy = 195700 and gbp = 1369.9 and eur = 217227 and  hkd = 1761.3','')")

    con:query("insert into check_sql values(1958,'delete from transaction_total_check where cny = 1958 and jpy = 195800 and gbp = 1370.6 and eur = 217338 and  hkd = 1762.2','')")

    con:query("insert into check_sql values(1959,'delete from transaction_total_check where cny = 1959 and jpy = 195900 and gbp = 1371.3 and eur = 217449 and  hkd = 1763.1','')")

    con:query("insert into check_sql values(1960,'delete from transaction_total_check where cny = 1960 and jpy = 196000 and gbp = 1372.0 and eur = 217560 and  hkd = 1764.0','')")

    con:query("insert into check_sql values(1961,'delete from transaction_total_check where cny = 1961 and jpy = 196100 and gbp = 1372.7 and eur = 217671 and  hkd = 1764.9','')")

    con:query("insert into check_sql values(1962,'delete from transaction_total_check where cny = 1962 and jpy = 196200 and gbp = 1373.4 and eur = 217782 and  hkd = 1765.8','')")

    con:query("insert into check_sql values(1963,'delete from transaction_total_check where cny = 1963 and jpy = 196300 and gbp = 1374.1 and eur = 217893 and  hkd = 1766.7','')")

    con:query("insert into check_sql values(1964,'delete from transaction_total_check where cny = 1964 and jpy = 196400 and gbp = 1374.8 and eur = 218004 and  hkd = 1767.6','')")

    con:query("insert into check_sql values(1965,'delete from transaction_total_check where cny = 1965 and jpy = 196500 and gbp = 1375.5 and eur = 218115 and  hkd = 1768.5','')")

    con:query("insert into check_sql values(1966,'delete from transaction_total_check where cny = 1966 and jpy = 196600 and gbp = 1376.2 and eur = 218226 and  hkd = 1769.4','')")

    con:query("insert into check_sql values(1967,'delete from transaction_total_check where cny = 1967 and jpy = 196700 and gbp = 1376.9 and eur = 218337 and  hkd = 1770.3','')")

    con:query("insert into check_sql values(1968,'delete from transaction_total_check where cny = 1968 and jpy = 196800 and gbp = 1377.6 and eur = 218448 and  hkd = 1771.2','')")

    con:query("insert into check_sql values(1969,'delete from transaction_total_check where cny = 1969 and jpy = 196900 and gbp = 1378.3 and eur = 218559 and  hkd = 1772.1','')")

    con:query("insert into check_sql values(1970,'delete from transaction_total_check where cny = 1970 and jpy = 197000 and gbp = 1379.0 and eur = 218670 and  hkd = 1773.0','')")

    con:query("insert into check_sql values(1971,'delete from transaction_total_check where cny = 1971 and jpy = 197100 and gbp = 1379.7 and eur = 218781 and  hkd = 1773.9','')")

    con:query("insert into check_sql values(1972,'delete from transaction_total_check where cny = 1972 and jpy = 197200 and gbp = 1380.4 and eur = 218892 and  hkd = 1774.8','')")

    con:query("insert into check_sql values(1973,'delete from transaction_total_check where cny = 1973 and jpy = 197300 and gbp = 1381.1 and eur = 219003 and  hkd = 1775.7','')")

    con:query("insert into check_sql values(1974,'delete from transaction_total_check where cny = 1974 and jpy = 197400 and gbp = 1381.8 and eur = 219114 and  hkd = 1776.6','')")

    con:query("insert into check_sql values(1975,'delete from transaction_total_check where cny = 1975 and jpy = 197500 and gbp = 1382.5 and eur = 219225 and  hkd = 1777.5','')")

    con:query("insert into check_sql values(1976,'delete from transaction_total_check where cny = 1976 and jpy = 197600 and gbp = 1383.2 and eur = 219336 and  hkd = 1778.4','')")

    con:query("insert into check_sql values(1977,'delete from transaction_total_check where cny = 1977 and jpy = 197700 and gbp = 1383.9 and eur = 219447 and  hkd = 1779.3','')")

    con:query("insert into check_sql values(1978,'delete from transaction_total_check where cny = 1978 and jpy = 197800 and gbp = 1384.6 and eur = 219558 and  hkd = 1780.2','')")

    con:query("insert into check_sql values(1979,'delete from transaction_total_check where cny = 1979 and jpy = 197900 and gbp = 1385.3 and eur = 219669 and  hkd = 1781.1','')")

    con:query("insert into check_sql values(1980,'delete from transaction_total_check where cny = 1980 and jpy = 198000 and gbp = 1386.0 and eur = 219780 and  hkd = 1782.0','')")

    con:query("insert into check_sql values(1981,'delete from transaction_total_check where cny = 1981 and jpy = 198100 and gbp = 1386.7 and eur = 219891 and  hkd = 1782.9','')")

    con:query("insert into check_sql values(1982,'delete from transaction_total_check where cny = 1982 and jpy = 198200 and gbp = 1387.4 and eur = 220002 and  hkd = 1783.8','')")

    con:query("insert into check_sql values(1983,'delete from transaction_total_check where cny = 1983 and jpy = 198300 and gbp = 1388.1 and eur = 220113 and  hkd = 1784.7','')")

    con:query("insert into check_sql values(1984,'delete from transaction_total_check where cny = 1984 and jpy = 198400 and gbp = 1388.8 and eur = 220224 and  hkd = 1785.6','')")

    con:query("insert into check_sql values(1985,'delete from transaction_total_check where cny = 1985 and jpy = 198500 and gbp = 1389.5 and eur = 220335 and  hkd = 1786.5','')")

    con:query("insert into check_sql values(1986,'delete from transaction_total_check where cny = 1986 and jpy = 198600 and gbp = 1390.2 and eur = 220446 and  hkd = 1787.4','')")

    con:query("insert into check_sql values(1987,'delete from transaction_total_check where cny = 1987 and jpy = 198700 and gbp = 1390.9 and eur = 220557 and  hkd = 1788.3','')")

    con:query("insert into check_sql values(1988,'delete from transaction_total_check where cny = 1988 and jpy = 198800 and gbp = 1391.6 and eur = 220668 and  hkd = 1789.2','')")

    con:query("insert into check_sql values(1989,'delete from transaction_total_check where cny = 1989 and jpy = 198900 and gbp = 1392.3 and eur = 220779 and  hkd = 1790.1','')")

    con:query("insert into check_sql values(1990,'delete from transaction_total_check where cny = 1990 and jpy = 199000 and gbp = 1393.0 and eur = 220890 and  hkd = 1791.0','')")

    con:query("insert into check_sql values(1991,'delete from transaction_total_check where cny = 1991 and jpy = 199100 and gbp = 1393.7 and eur = 221001 and  hkd = 1791.9','')")

    con:query("insert into check_sql values(1992,'delete from transaction_total_check where cny = 1992 and jpy = 199200 and gbp = 1394.4 and eur = 221112 and  hkd = 1792.8','')")

    con:query("insert into check_sql values(1993,'delete from transaction_total_check where cny = 1993 and jpy = 199300 and gbp = 1395.1 and eur = 221223 and  hkd = 1793.7','')")

    con:query("insert into check_sql values(1994,'delete from transaction_total_check where cny = 1994 and jpy = 199400 and gbp = 1395.8 and eur = 221334 and  hkd = 1794.6','')")

    con:query("insert into check_sql values(1995,'delete from transaction_total_check where cny = 1995 and jpy = 199500 and gbp = 1396.5 and eur = 221445 and  hkd = 1795.5','')")

    con:query("insert into check_sql values(1996,'delete from transaction_total_check where cny = 1996 and jpy = 199600 and gbp = 1397.2 and eur = 221556 and  hkd = 1796.4','')")

    con:query("insert into check_sql values(1997,'delete from transaction_total_check where cny = 1997 and jpy = 199700 and gbp = 1397.9 and eur = 221667 and  hkd = 1797.3','')")

    con:query("insert into check_sql values(1998,'delete from transaction_total_check where cny = 1998 and jpy = 199800 and gbp = 1398.6 and eur = 221778 and  hkd = 1798.2','')")

    con:query("insert into check_sql values(1999,'delete from transaction_total_check where cny = 1999 and jpy = 199900 and gbp = 1399.3 and eur = 221889 and  hkd = 1799.1','')")

    con:query("insert into check_sql values(2000,'delete from transaction_total_check where cny = 2000 and jpy = 200000 and gbp = 1400.0 and eur = 222000 and  hkd = 1800.0','')")

    con:query("insert into check_sql values(2001,'delete from transaction_total_check where cny = 2001 and jpy = 200100 and gbp = 1400.7 and eur = 222111 and  hkd = 1800.9','')")

    con:query("insert into check_sql values(2002,'delete from transaction_total_check where cny = 2002 and jpy = 200200 and gbp = 1401.4 and eur = 222222 and  hkd = 1801.8','')")

    con:query("insert into check_sql values(2003,'delete from transaction_total_check where cny = 2003 and jpy = 200300 and gbp = 1402.1 and eur = 222333 and  hkd = 1802.7','')")

    con:query("insert into check_sql values(2004,'delete from transaction_total_check where cny = 2004 and jpy = 200400 and gbp = 1402.8 and eur = 222444 and  hkd = 1803.6','')")

    con:query("insert into check_sql values(2005,'delete from transaction_total_check where cny = 2005 and jpy = 200500 and gbp = 1403.5 and eur = 222555 and  hkd = 1804.5','')")

    con:query("insert into check_sql values(2006,'delete from transaction_total_check where cny = 2006 and jpy = 200600 and gbp = 1404.2 and eur = 222666 and  hkd = 1805.4','')")

    con:query("insert into check_sql values(2007,'delete from transaction_total_check where cny = 2007 and jpy = 200700 and gbp = 1404.9 and eur = 222777 and  hkd = 1806.3','')")

    con:query("insert into check_sql values(2008,'delete from transaction_total_check where cny = 2008 and jpy = 200800 and gbp = 1405.6 and eur = 222888 and  hkd = 1807.2','')")

    con:query("insert into check_sql values(2009,'delete from transaction_total_check where cny = 2009 and jpy = 200900 and gbp = 1406.3 and eur = 222999 and  hkd = 1808.1','')")

    con:query("insert into check_sql values(2010,'delete from transaction_total_check where cny = 2010 and jpy = 201000 and gbp = 1407.0 and eur = 223110 and  hkd = 1809.0','')")

    con:query("insert into check_sql values(2011,'delete from transaction_total_check where cny = 2011 and jpy = 201100 and gbp = 1407.7 and eur = 223221 and  hkd = 1809.9','')")

    con:query("insert into check_sql values(2012,'delete from transaction_total_check where cny = 2012 and jpy = 201200 and gbp = 1408.4 and eur = 223332 and  hkd = 1810.8','')")

    con:query("insert into check_sql values(2013,'delete from transaction_total_check where cny = 2013 and jpy = 201300 and gbp = 1409.1 and eur = 223443 and  hkd = 1811.7','')")

    con:query("insert into check_sql values(2014,'delete from transaction_total_check where cny = 2014 and jpy = 201400 and gbp = 1409.8 and eur = 223554 and  hkd = 1812.6','')")

    con:query("insert into check_sql values(2015,'delete from transaction_total_check where cny = 2015 and jpy = 201500 and gbp = 1410.5 and eur = 223665 and  hkd = 1813.5','')")

    con:query("insert into check_sql values(2016,'delete from transaction_total_check where cny = 2016 and jpy = 201600 and gbp = 1411.2 and eur = 223776 and  hkd = 1814.4','')")

    con:query("insert into check_sql values(2017,'delete from transaction_total_check where cny = 2017 and jpy = 201700 and gbp = 1411.9 and eur = 223887 and  hkd = 1815.3','')")

    con:query("insert into check_sql values(2018,'delete from transaction_total_check where cny = 2018 and jpy = 201800 and gbp = 1412.6 and eur = 223998 and  hkd = 1816.2','')")

    con:query("insert into check_sql values(2019,'delete from transaction_total_check where cny = 2019 and jpy = 201900 and gbp = 1413.3 and eur = 224109 and  hkd = 1817.1','')")

    con:query("insert into check_sql values(2020,'delete from transaction_total_check where cny = 2020 and jpy = 202000 and gbp = 1414.0 and eur = 224220 and  hkd = 1818.0','')")

    con:query("insert into check_sql values(2021,'delete from transaction_total_check where cny = 2021 and jpy = 202100 and gbp = 1414.7 and eur = 224331 and  hkd = 1818.9','')")

    con:query("insert into check_sql values(2022,'delete from transaction_total_check where cny = 2022 and jpy = 202200 and gbp = 1415.4 and eur = 224442 and  hkd = 1819.8','')")

    con:query("insert into check_sql values(2023,'delete from transaction_total_check where cny = 2023 and jpy = 202300 and gbp = 1416.1 and eur = 224553 and  hkd = 1820.7','')")

    con:query("insert into check_sql values(2024,'delete from transaction_total_check where cny = 2024 and jpy = 202400 and gbp = 1416.8 and eur = 224664 and  hkd = 1821.6','')")

    con:query("insert into check_sql values(2025,'delete from transaction_total_check where cny = 2025 and jpy = 202500 and gbp = 1417.5 and eur = 224775 and  hkd = 1822.5','')")

    con:query("insert into check_sql values(2026,'delete from transaction_total_check where cny = 2026 and jpy = 202600 and gbp = 1418.2 and eur = 224886 and  hkd = 1823.4','')")

    con:query("insert into check_sql values(2027,'delete from transaction_total_check where cny = 2027 and jpy = 202700 and gbp = 1418.9 and eur = 224997 and  hkd = 1824.3','')")

    con:query("insert into check_sql values(2028,'delete from transaction_total_check where cny = 2028 and jpy = 202800 and gbp = 1419.6 and eur = 225108 and  hkd = 1825.2','')")

    con:query("insert into check_sql values(2029,'delete from transaction_total_check where cny = 2029 and jpy = 202900 and gbp = 1420.3 and eur = 225219 and  hkd = 1826.1','')")

    con:query("insert into check_sql values(2030,'delete from transaction_total_check where cny = 2030 and jpy = 203000 and gbp = 1421.0 and eur = 225330 and  hkd = 1827.0','')")

    con:query("insert into check_sql values(2031,'delete from transaction_total_check where cny = 2031 and jpy = 203100 and gbp = 1421.7 and eur = 225441 and  hkd = 1827.9','')")

    con:query("insert into check_sql values(2032,'delete from transaction_total_check where cny = 2032 and jpy = 203200 and gbp = 1422.4 and eur = 225552 and  hkd = 1828.8','')")

    con:query("insert into check_sql values(2033,'delete from transaction_total_check where cny = 2033 and jpy = 203300 and gbp = 1423.1 and eur = 225663 and  hkd = 1829.7','')")

    con:query("insert into check_sql values(2034,'delete from transaction_total_check where cny = 2034 and jpy = 203400 and gbp = 1423.8 and eur = 225774 and  hkd = 1830.6','')")

    con:query("insert into check_sql values(2035,'delete from transaction_total_check where cny = 2035 and jpy = 203500 and gbp = 1424.5 and eur = 225885 and  hkd = 1831.5','')")

    con:query("insert into check_sql values(2036,'delete from transaction_total_check where cny = 2036 and jpy = 203600 and gbp = 1425.2 and eur = 225996 and  hkd = 1832.4','')")

    con:query("insert into check_sql values(2037,'delete from transaction_total_check where cny = 2037 and jpy = 203700 and gbp = 1425.9 and eur = 226107 and  hkd = 1833.3','')")

    con:query("insert into check_sql values(2038,'delete from transaction_total_check where cny = 2038 and jpy = 203800 and gbp = 1426.6 and eur = 226218 and  hkd = 1834.2','')")

    con:query("insert into check_sql values(2039,'delete from transaction_total_check where cny = 2039 and jpy = 203900 and gbp = 1427.3 and eur = 226329 and  hkd = 1835.1','')")

    con:query("insert into check_sql values(2040,'delete from transaction_total_check where cny = 2040 and jpy = 204000 and gbp = 1428.0 and eur = 226440 and  hkd = 1836.0','')")

    con:query("insert into check_sql values(2041,'delete from transaction_total_check where cny = 2041 and jpy = 204100 and gbp = 1428.7 and eur = 226551 and  hkd = 1836.9','')")

    con:query("insert into check_sql values(2042,'delete from transaction_total_check where cny = 2042 and jpy = 204200 and gbp = 1429.4 and eur = 226662 and  hkd = 1837.8','')")

    con:query("insert into check_sql values(2043,'delete from transaction_total_check where cny = 2043 and jpy = 204300 and gbp = 1430.1 and eur = 226773 and  hkd = 1838.7','')")

    con:query("insert into check_sql values(2044,'delete from transaction_total_check where cny = 2044 and jpy = 204400 and gbp = 1430.8 and eur = 226884 and  hkd = 1839.6','')")

    con:query("insert into check_sql values(2045,'delete from transaction_total_check where cny = 2045 and jpy = 204500 and gbp = 1431.5 and eur = 226995 and  hkd = 1840.5','')")

    con:query("insert into check_sql values(2046,'delete from transaction_total_check where cny = 2046 and jpy = 204600 and gbp = 1432.2 and eur = 227106 and  hkd = 1841.4','')")

    con:query("insert into check_sql values(2047,'delete from transaction_total_check where cny = 2047 and jpy = 204700 and gbp = 1432.9 and eur = 227217 and  hkd = 1842.3','')")

    con:query("insert into check_sql values(2048,'delete from transaction_total_check where cny = 2048 and jpy = 204800 and gbp = 1433.6 and eur = 227328 and  hkd = 1843.2','')")

    con:query("insert into check_sql values(2049,'delete from transaction_total_check where cny = 2049 and jpy = 204900 and gbp = 1434.3 and eur = 227439 and  hkd = 1844.1','')")

    con:query("insert into check_sql values(2050,'delete from transaction_total_check where cny = 2050 and jpy = 205000 and gbp = 1435.0 and eur = 227550 and  hkd = 1845.0','')")

    con:query("insert into check_sql values(2051,'delete from transaction_total_check where cny = 2051 and jpy = 205100 and gbp = 1435.7 and eur = 227661 and  hkd = 1845.9','')")

    con:query("insert into check_sql values(2052,'delete from transaction_total_check where cny = 2052 and jpy = 205200 and gbp = 1436.4 and eur = 227772 and  hkd = 1846.8','')")

    con:query("insert into check_sql values(2053,'delete from transaction_total_check where cny = 2053 and jpy = 205300 and gbp = 1437.1 and eur = 227883 and  hkd = 1847.7','')")

    con:query("insert into check_sql values(2054,'delete from transaction_total_check where cny = 2054 and jpy = 205400 and gbp = 1437.8 and eur = 227994 and  hkd = 1848.6','')")

    con:query("insert into check_sql values(2055,'delete from transaction_total_check where cny = 2055 and jpy = 205500 and gbp = 1438.5 and eur = 228105 and  hkd = 1849.5','')")

    con:query("insert into check_sql values(2056,'delete from transaction_total_check where cny = 2056 and jpy = 205600 and gbp = 1439.2 and eur = 228216 and  hkd = 1850.4','')")

    con:query("insert into check_sql values(2057,'delete from transaction_total_check where cny = 2057 and jpy = 205700 and gbp = 1439.9 and eur = 228327 and  hkd = 1851.3','')")

    con:query("insert into check_sql values(2058,'delete from transaction_total_check where cny = 2058 and jpy = 205800 and gbp = 1440.6 and eur = 228438 and  hkd = 1852.2','')")

    con:query("insert into check_sql values(2059,'delete from transaction_total_check where cny = 2059 and jpy = 205900 and gbp = 1441.3 and eur = 228549 and  hkd = 1853.1','')")

    con:query("insert into check_sql values(2060,'delete from transaction_total_check where cny = 2060 and jpy = 206000 and gbp = 1442.0 and eur = 228660 and  hkd = 1854.0','')")

    con:query("insert into check_sql values(2061,'delete from transaction_total_check where cny = 2061 and jpy = 206100 and gbp = 1442.7 and eur = 228771 and  hkd = 1854.9','')")

    con:query("insert into check_sql values(2062,'delete from transaction_total_check where cny = 2062 and jpy = 206200 and gbp = 1443.4 and eur = 228882 and  hkd = 1855.8','')")

    con:query("insert into check_sql values(2063,'delete from transaction_total_check where cny = 2063 and jpy = 206300 and gbp = 1444.1 and eur = 228993 and  hkd = 1856.7','')")

    con:query("insert into check_sql values(2064,'delete from transaction_total_check where cny = 2064 and jpy = 206400 and gbp = 1444.8 and eur = 229104 and  hkd = 1857.6','')")

    con:query("insert into check_sql values(2065,'delete from transaction_total_check where cny = 2065 and jpy = 206500 and gbp = 1445.5 and eur = 229215 and  hkd = 1858.5','')")

    con:query("insert into check_sql values(2066,'delete from transaction_total_check where cny = 2066 and jpy = 206600 and gbp = 1446.2 and eur = 229326 and  hkd = 1859.4','')")

    con:query("insert into check_sql values(2067,'delete from transaction_total_check where cny = 2067 and jpy = 206700 and gbp = 1446.9 and eur = 229437 and  hkd = 1860.3','')")

    con:query("insert into check_sql values(2068,'delete from transaction_total_check where cny = 2068 and jpy = 206800 and gbp = 1447.6 and eur = 229548 and  hkd = 1861.2','')")

    con:query("insert into check_sql values(2069,'delete from transaction_total_check where cny = 2069 and jpy = 206900 and gbp = 1448.3 and eur = 229659 and  hkd = 1862.1','')")

    con:query("insert into check_sql values(2070,'delete from transaction_total_check where cny = 2070 and jpy = 207000 and gbp = 1449.0 and eur = 229770 and  hkd = 1863.0','')")

    con:query("insert into check_sql values(2071,'delete from transaction_total_check where cny = 2071 and jpy = 207100 and gbp = 1449.7 and eur = 229881 and  hkd = 1863.9','')")

    con:query("insert into check_sql values(2072,'delete from transaction_total_check where cny = 2072 and jpy = 207200 and gbp = 1450.4 and eur = 229992 and  hkd = 1864.8','')")

    con:query("insert into check_sql values(2073,'delete from transaction_total_check where cny = 2073 and jpy = 207300 and gbp = 1451.1 and eur = 230103 and  hkd = 1865.7','')")

    con:query("insert into check_sql values(2074,'delete from transaction_total_check where cny = 2074 and jpy = 207400 and gbp = 1451.8 and eur = 230214 and  hkd = 1866.6','')")

    con:query("insert into check_sql values(2075,'delete from transaction_total_check where cny = 2075 and jpy = 207500 and gbp = 1452.5 and eur = 230325 and  hkd = 1867.5','')")

    con:query("insert into check_sql values(2076,'delete from transaction_total_check where cny = 2076 and jpy = 207600 and gbp = 1453.2 and eur = 230436 and  hkd = 1868.4','')")

    con:query("insert into check_sql values(2077,'delete from transaction_total_check where cny = 2077 and jpy = 207700 and gbp = 1453.9 and eur = 230547 and  hkd = 1869.3','')")

    con:query("insert into check_sql values(2078,'delete from transaction_total_check where cny = 2078 and jpy = 207800 and gbp = 1454.6 and eur = 230658 and  hkd = 1870.2','')")

    con:query("insert into check_sql values(2079,'delete from transaction_total_check where cny = 2079 and jpy = 207900 and gbp = 1455.3 and eur = 230769 and  hkd = 1871.1','')")

    con:query("insert into check_sql values(2080,'delete from transaction_total_check where cny = 2080 and jpy = 208000 and gbp = 1456.0 and eur = 230880 and  hkd = 1872.0','')")

    con:query("insert into check_sql values(2081,'delete from transaction_total_check where cny = 2081 and jpy = 208100 and gbp = 1456.7 and eur = 230991 and  hkd = 1872.9','')")

    con:query("insert into check_sql values(2082,'delete from transaction_total_check where cny = 2082 and jpy = 208200 and gbp = 1457.4 and eur = 231102 and  hkd = 1873.8','')")

    con:query("insert into check_sql values(2083,'delete from transaction_total_check where cny = 2083 and jpy = 208300 and gbp = 1458.1 and eur = 231213 and  hkd = 1874.7','')")

    con:query("insert into check_sql values(2084,'delete from transaction_total_check where cny = 2084 and jpy = 208400 and gbp = 1458.8 and eur = 231324 and  hkd = 1875.6','')")

    con:query("insert into check_sql values(2085,'delete from transaction_total_check where cny = 2085 and jpy = 208500 and gbp = 1459.5 and eur = 231435 and  hkd = 1876.5','')")

    con:query("insert into check_sql values(2086,'delete from transaction_total_check where cny = 2086 and jpy = 208600 and gbp = 1460.2 and eur = 231546 and  hkd = 1877.4','')")

    con:query("insert into check_sql values(2087,'delete from transaction_total_check where cny = 2087 and jpy = 208700 and gbp = 1460.9 and eur = 231657 and  hkd = 1878.3','')")

    con:query("insert into check_sql values(2088,'delete from transaction_total_check where cny = 2088 and jpy = 208800 and gbp = 1461.6 and eur = 231768 and  hkd = 1879.2','')")

    con:query("insert into check_sql values(2089,'delete from transaction_total_check where cny = 2089 and jpy = 208900 and gbp = 1462.3 and eur = 231879 and  hkd = 1880.1','')")

    con:query("insert into check_sql values(2090,'delete from transaction_total_check where cny = 2090 and jpy = 209000 and gbp = 1463.0 and eur = 231990 and  hkd = 1881.0','')")

    con:query("insert into check_sql values(2091,'delete from transaction_total_check where cny = 2091 and jpy = 209100 and gbp = 1463.7 and eur = 232101 and  hkd = 1881.9','')")

    con:query("insert into check_sql values(2092,'delete from transaction_total_check where cny = 2092 and jpy = 209200 and gbp = 1464.4 and eur = 232212 and  hkd = 1882.8','')")

    con:query("insert into check_sql values(2093,'delete from transaction_total_check where cny = 2093 and jpy = 209300 and gbp = 1465.1 and eur = 232323 and  hkd = 1883.7','')")

    con:query("insert into check_sql values(2094,'delete from transaction_total_check where cny = 2094 and jpy = 209400 and gbp = 1465.8 and eur = 232434 and  hkd = 1884.6','')")

    con:query("insert into check_sql values(2095,'delete from transaction_total_check where cny = 2095 and jpy = 209500 and gbp = 1466.5 and eur = 232545 and  hkd = 1885.5','')")

    con:query("insert into check_sql values(2096,'delete from transaction_total_check where cny = 2096 and jpy = 209600 and gbp = 1467.2 and eur = 232656 and  hkd = 1886.4','')")

    con:query("insert into check_sql values(2097,'delete from transaction_total_check where cny = 2097 and jpy = 209700 and gbp = 1467.9 and eur = 232767 and  hkd = 1887.3','')")

    con:query("insert into check_sql values(2098,'delete from transaction_total_check where cny = 2098 and jpy = 209800 and gbp = 1468.6 and eur = 232878 and  hkd = 1888.2','')")

    con:query("insert into check_sql values(2099,'delete from transaction_total_check where cny = 2099 and jpy = 209900 and gbp = 1469.3 and eur = 232989 and  hkd = 1889.1','')")

    con:query("insert into check_sql values(2100,'delete from transaction_total_check where cny = 2100 and jpy = 210000 and gbp = 1470.0 and eur = 233100 and  hkd = 1890.0','')")

    con:query("insert into check_sql values(2101,'delete from transaction_total_check where cny = 2101 and jpy = 210100 and gbp = 1470.7 and eur = 233211 and  hkd = 1890.9','')")

    con:query("insert into check_sql values(2102,'delete from transaction_total_check where cny = 2102 and jpy = 210200 and gbp = 1471.4 and eur = 233322 and  hkd = 1891.8','')")

    con:query("insert into check_sql values(2103,'delete from transaction_total_check where cny = 2103 and jpy = 210300 and gbp = 1472.1 and eur = 233433 and  hkd = 1892.7','')")

    con:query("insert into check_sql values(2104,'delete from transaction_total_check where cny = 2104 and jpy = 210400 and gbp = 1472.8 and eur = 233544 and  hkd = 1893.6','')")

    con:query("insert into check_sql values(2105,'delete from transaction_total_check where cny = 2105 and jpy = 210500 and gbp = 1473.5 and eur = 233655 and  hkd = 1894.5','')")

    con:query("insert into check_sql values(2106,'delete from transaction_total_check where cny = 2106 and jpy = 210600 and gbp = 1474.2 and eur = 233766 and  hkd = 1895.4','')")

    con:query("insert into check_sql values(2107,'delete from transaction_total_check where cny = 2107 and jpy = 210700 and gbp = 1474.9 and eur = 233877 and  hkd = 1896.3','')")

    con:query("insert into check_sql values(2108,'delete from transaction_total_check where cny = 2108 and jpy = 210800 and gbp = 1475.6 and eur = 233988 and  hkd = 1897.2','')")

    con:query("insert into check_sql values(2109,'delete from transaction_total_check where cny = 2109 and jpy = 210900 and gbp = 1476.3 and eur = 234099 and  hkd = 1898.1','')")

    con:query("insert into check_sql values(2110,'delete from transaction_total_check where cny = 2110 and jpy = 211000 and gbp = 1477.0 and eur = 234210 and  hkd = 1899.0','')")

    con:query("insert into check_sql values(2111,'delete from transaction_total_check where cny = 2111 and jpy = 211100 and gbp = 1477.7 and eur = 234321 and  hkd = 1899.9','')")

    con:query("insert into check_sql values(2112,'delete from transaction_total_check where cny = 2112 and jpy = 211200 and gbp = 1478.4 and eur = 234432 and  hkd = 1900.8','')")

    con:query("insert into check_sql values(2113,'delete from transaction_total_check where cny = 2113 and jpy = 211300 and gbp = 1479.1 and eur = 234543 and  hkd = 1901.7','')")

    con:query("insert into check_sql values(2114,'delete from transaction_total_check where cny = 2114 and jpy = 211400 and gbp = 1479.8 and eur = 234654 and  hkd = 1902.6','')")

    con:query("insert into check_sql values(2115,'delete from transaction_total_check where cny = 2115 and jpy = 211500 and gbp = 1480.5 and eur = 234765 and  hkd = 1903.5','')")

    con:query("insert into check_sql values(2116,'delete from transaction_total_check where cny = 2116 and jpy = 211600 and gbp = 1481.2 and eur = 234876 and  hkd = 1904.4','')")

    con:query("insert into check_sql values(2117,'delete from transaction_total_check where cny = 2117 and jpy = 211700 and gbp = 1481.9 and eur = 234987 and  hkd = 1905.3','')")

    con:query("insert into check_sql values(2118,'delete from transaction_total_check where cny = 2118 and jpy = 211800 and gbp = 1482.6 and eur = 235098 and  hkd = 1906.2','')")

    con:query("insert into check_sql values(2119,'delete from transaction_total_check where cny = 2119 and jpy = 211900 and gbp = 1483.3 and eur = 235209 and  hkd = 1907.1','')")

    con:query("insert into check_sql values(2120,'delete from transaction_total_check where cny = 2120 and jpy = 212000 and gbp = 1484.0 and eur = 235320 and  hkd = 1908.0','')")

    con:query("insert into check_sql values(2121,'delete from transaction_total_check where cny = 2121 and jpy = 212100 and gbp = 1484.7 and eur = 235431 and  hkd = 1908.9','')")

    con:query("insert into check_sql values(2122,'delete from transaction_total_check where cny = 2122 and jpy = 212200 and gbp = 1485.4 and eur = 235542 and  hkd = 1909.8','')")

    con:query("insert into check_sql values(2123,'delete from transaction_total_check where cny = 2123 and jpy = 212300 and gbp = 1486.1 and eur = 235653 and  hkd = 1910.7','')")

    con:query("insert into check_sql values(2124,'delete from transaction_total_check where cny = 2124 and jpy = 212400 and gbp = 1486.8 and eur = 235764 and  hkd = 1911.6','')")

    con:query("insert into check_sql values(2125,'delete from transaction_total_check where cny = 2125 and jpy = 212500 and gbp = 1487.5 and eur = 235875 and  hkd = 1912.5','')")

    con:query("insert into check_sql values(2126,'delete from transaction_total_check where cny = 2126 and jpy = 212600 and gbp = 1488.2 and eur = 235986 and  hkd = 1913.4','')")

    con:query("insert into check_sql values(2127,'delete from transaction_total_check where cny = 2127 and jpy = 212700 and gbp = 1488.9 and eur = 236097 and  hkd = 1914.3','')")

    con:query("insert into check_sql values(2128,'delete from transaction_total_check where cny = 2128 and jpy = 212800 and gbp = 1489.6 and eur = 236208 and  hkd = 1915.2','')")

    con:query("insert into check_sql values(2129,'delete from transaction_total_check where cny = 2129 and jpy = 212900 and gbp = 1490.3 and eur = 236319 and  hkd = 1916.1','')")

    con:query("insert into check_sql values(2130,'delete from transaction_total_check where cny = 2130 and jpy = 213000 and gbp = 1491.0 and eur = 236430 and  hkd = 1917.0','')")

    con:query("insert into check_sql values(2131,'delete from transaction_total_check where cny = 2131 and jpy = 213100 and gbp = 1491.7 and eur = 236541 and  hkd = 1917.9','')")

    con:query("insert into check_sql values(2132,'delete from transaction_total_check where cny = 2132 and jpy = 213200 and gbp = 1492.4 and eur = 236652 and  hkd = 1918.8','')")

    con:query("insert into check_sql values(2133,'delete from transaction_total_check where cny = 2133 and jpy = 213300 and gbp = 1493.1 and eur = 236763 and  hkd = 1919.7','')")

    con:query("insert into check_sql values(2134,'delete from transaction_total_check where cny = 2134 and jpy = 213400 and gbp = 1493.8 and eur = 236874 and  hkd = 1920.6','')")

    con:query("insert into check_sql values(2135,'delete from transaction_total_check where cny = 2135 and jpy = 213500 and gbp = 1494.5 and eur = 236985 and  hkd = 1921.5','')")

    con:query("insert into check_sql values(2136,'delete from transaction_total_check where cny = 2136 and jpy = 213600 and gbp = 1495.2 and eur = 237096 and  hkd = 1922.4','')")

    con:query("insert into check_sql values(2137,'delete from transaction_total_check where cny = 2137 and jpy = 213700 and gbp = 1495.9 and eur = 237207 and  hkd = 1923.3','')")

    con:query("insert into check_sql values(2138,'delete from transaction_total_check where cny = 2138 and jpy = 213800 and gbp = 1496.6 and eur = 237318 and  hkd = 1924.2','')")

    con:query("insert into check_sql values(2139,'delete from transaction_total_check where cny = 2139 and jpy = 213900 and gbp = 1497.3 and eur = 237429 and  hkd = 1925.1','')")

    con:query("insert into check_sql values(2140,'delete from transaction_total_check where cny = 2140 and jpy = 214000 and gbp = 1498.0 and eur = 237540 and  hkd = 1926.0','')")

    con:query("insert into check_sql values(2141,'delete from transaction_total_check where cny = 2141 and jpy = 214100 and gbp = 1498.7 and eur = 237651 and  hkd = 1926.9','')")

    con:query("insert into check_sql values(2142,'delete from transaction_total_check where cny = 2142 and jpy = 214200 and gbp = 1499.4 and eur = 237762 and  hkd = 1927.8','')")

    con:query("insert into check_sql values(2143,'delete from transaction_total_check where cny = 2143 and jpy = 214300 and gbp = 1500.1 and eur = 237873 and  hkd = 1928.7','')")

    con:query("insert into check_sql values(2144,'delete from transaction_total_check where cny = 2144 and jpy = 214400 and gbp = 1500.8 and eur = 237984 and  hkd = 1929.6','')")

    con:query("insert into check_sql values(2145,'delete from transaction_total_check where cny = 2145 and jpy = 214500 and gbp = 1501.5 and eur = 238095 and  hkd = 1930.5','')")

    con:query("insert into check_sql values(2146,'delete from transaction_total_check where cny = 2146 and jpy = 214600 and gbp = 1502.2 and eur = 238206 and  hkd = 1931.4','')")

    con:query("insert into check_sql values(2147,'delete from transaction_total_check where cny = 2147 and jpy = 214700 and gbp = 1502.9 and eur = 238317 and  hkd = 1932.3','')")

    con:query("insert into check_sql values(2148,'delete from transaction_total_check where cny = 2148 and jpy = 214800 and gbp = 1503.6 and eur = 238428 and  hkd = 1933.2','')")

    con:query("insert into check_sql values(2149,'delete from transaction_total_check where cny = 2149 and jpy = 214900 and gbp = 1504.3 and eur = 238539 and  hkd = 1934.1','')")

    con:query("insert into check_sql values(2150,'delete from transaction_total_check where cny = 2150 and jpy = 215000 and gbp = 1505.0 and eur = 238650 and  hkd = 1935.0','')")

    con:query("insert into check_sql values(2151,'delete from transaction_total_check where cny = 2151 and jpy = 215100 and gbp = 1505.7 and eur = 238761 and  hkd = 1935.9','')")

    con:query("insert into check_sql values(2152,'delete from transaction_total_check where cny = 2152 and jpy = 215200 and gbp = 1506.4 and eur = 238872 and  hkd = 1936.8','')")

    con:query("insert into check_sql values(2153,'delete from transaction_total_check where cny = 2153 and jpy = 215300 and gbp = 1507.1 and eur = 238983 and  hkd = 1937.7','')")

    con:query("insert into check_sql values(2154,'delete from transaction_total_check where cny = 2154 and jpy = 215400 and gbp = 1507.8 and eur = 239094 and  hkd = 1938.6','')")

    con:query("insert into check_sql values(2155,'delete from transaction_total_check where cny = 2155 and jpy = 215500 and gbp = 1508.5 and eur = 239205 and  hkd = 1939.5','')")

    con:query("insert into check_sql values(2156,'delete from transaction_total_check where cny = 2156 and jpy = 215600 and gbp = 1509.2 and eur = 239316 and  hkd = 1940.4','')")

    con:query("insert into check_sql values(2157,'delete from transaction_total_check where cny = 2157 and jpy = 215700 and gbp = 1509.9 and eur = 239427 and  hkd = 1941.3','')")

    con:query("insert into check_sql values(2158,'delete from transaction_total_check where cny = 2158 and jpy = 215800 and gbp = 1510.6 and eur = 239538 and  hkd = 1942.2','')")

    con:query("insert into check_sql values(2159,'delete from transaction_total_check where cny = 2159 and jpy = 215900 and gbp = 1511.3 and eur = 239649 and  hkd = 1943.1','')")

    con:query("insert into check_sql values(2160,'delete from transaction_total_check where cny = 2160 and jpy = 216000 and gbp = 1512.0 and eur = 239760 and  hkd = 1944.0','')")

    con:query("insert into check_sql values(2161,'delete from transaction_total_check where cny = 2161 and jpy = 216100 and gbp = 1512.7 and eur = 239871 and  hkd = 1944.9','')")

    con:query("insert into check_sql values(2162,'delete from transaction_total_check where cny = 2162 and jpy = 216200 and gbp = 1513.4 and eur = 239982 and  hkd = 1945.8','')")

    con:query("insert into check_sql values(2163,'delete from transaction_total_check where cny = 2163 and jpy = 216300 and gbp = 1514.1 and eur = 240093 and  hkd = 1946.7','')")

    con:query("insert into check_sql values(2164,'delete from transaction_total_check where cny = 2164 and jpy = 216400 and gbp = 1514.8 and eur = 240204 and  hkd = 1947.6','')")

    con:query("insert into check_sql values(2165,'delete from transaction_total_check where cny = 2165 and jpy = 216500 and gbp = 1515.5 and eur = 240315 and  hkd = 1948.5','')")

    con:query("insert into check_sql values(2166,'delete from transaction_total_check where cny = 2166 and jpy = 216600 and gbp = 1516.2 and eur = 240426 and  hkd = 1949.4','')")

    con:query("insert into check_sql values(2167,'delete from transaction_total_check where cny = 2167 and jpy = 216700 and gbp = 1516.9 and eur = 240537 and  hkd = 1950.3','')")

    con:query("insert into check_sql values(2168,'delete from transaction_total_check where cny = 2168 and jpy = 216800 and gbp = 1517.6 and eur = 240648 and  hkd = 1951.2','')")

    con:query("insert into check_sql values(2169,'delete from transaction_total_check where cny = 2169 and jpy = 216900 and gbp = 1518.3 and eur = 240759 and  hkd = 1952.1','')")

    con:query("insert into check_sql values(2170,'delete from transaction_total_check where cny = 2170 and jpy = 217000 and gbp = 1519.0 and eur = 240870 and  hkd = 1953.0','')")

    con:query("insert into check_sql values(2171,'delete from transaction_total_check where cny = 2171 and jpy = 217100 and gbp = 1519.7 and eur = 240981 and  hkd = 1953.9','')")

    con:query("insert into check_sql values(2172,'delete from transaction_total_check where cny = 2172 and jpy = 217200 and gbp = 1520.4 and eur = 241092 and  hkd = 1954.8','')")

    con:query("insert into check_sql values(2173,'delete from transaction_total_check where cny = 2173 and jpy = 217300 and gbp = 1521.1 and eur = 241203 and  hkd = 1955.7','')")

    con:query("insert into check_sql values(2174,'delete from transaction_total_check where cny = 2174 and jpy = 217400 and gbp = 1521.8 and eur = 241314 and  hkd = 1956.6','')")

    con:query("insert into check_sql values(2175,'delete from transaction_total_check where cny = 2175 and jpy = 217500 and gbp = 1522.5 and eur = 241425 and  hkd = 1957.5','')")

    con:query("insert into check_sql values(2176,'delete from transaction_total_check where cny = 2176 and jpy = 217600 and gbp = 1523.2 and eur = 241536 and  hkd = 1958.4','')")

    con:query("insert into check_sql values(2177,'delete from transaction_total_check where cny = 2177 and jpy = 217700 and gbp = 1523.9 and eur = 241647 and  hkd = 1959.3','')")

    con:query("insert into check_sql values(2178,'delete from transaction_total_check where cny = 2178 and jpy = 217800 and gbp = 1524.6 and eur = 241758 and  hkd = 1960.2','')")

    con:query("insert into check_sql values(2179,'delete from transaction_total_check where cny = 2179 and jpy = 217900 and gbp = 1525.3 and eur = 241869 and  hkd = 1961.1','')")

    con:query("insert into check_sql values(2180,'delete from transaction_total_check where cny = 2180 and jpy = 218000 and gbp = 1526.0 and eur = 241980 and  hkd = 1962.0','')")

    con:query("insert into check_sql values(2181,'delete from transaction_total_check where cny = 2181 and jpy = 218100 and gbp = 1526.7 and eur = 242091 and  hkd = 1962.9','')")

    con:query("insert into check_sql values(2182,'delete from transaction_total_check where cny = 2182 and jpy = 218200 and gbp = 1527.4 and eur = 242202 and  hkd = 1963.8','')")

    con:query("insert into check_sql values(2183,'delete from transaction_total_check where cny = 2183 and jpy = 218300 and gbp = 1528.1 and eur = 242313 and  hkd = 1964.7','')")

    con:query("insert into check_sql values(2184,'delete from transaction_total_check where cny = 2184 and jpy = 218400 and gbp = 1528.8 and eur = 242424 and  hkd = 1965.6','')")

    con:query("insert into check_sql values(2185,'delete from transaction_total_check where cny = 2185 and jpy = 218500 and gbp = 1529.5 and eur = 242535 and  hkd = 1966.5','')")

    con:query("insert into check_sql values(2186,'delete from transaction_total_check where cny = 2186 and jpy = 218600 and gbp = 1530.2 and eur = 242646 and  hkd = 1967.4','')")

    con:query("insert into check_sql values(2187,'delete from transaction_total_check where cny = 2187 and jpy = 218700 and gbp = 1530.9 and eur = 242757 and  hkd = 1968.3','')")

    con:query("insert into check_sql values(2188,'delete from transaction_total_check where cny = 2188 and jpy = 218800 and gbp = 1531.6 and eur = 242868 and  hkd = 1969.2','')")

    con:query("insert into check_sql values(2189,'delete from transaction_total_check where cny = 2189 and jpy = 218900 and gbp = 1532.3 and eur = 242979 and  hkd = 1970.1','')")

    con:query("insert into check_sql values(2190,'delete from transaction_total_check where cny = 2190 and jpy = 219000 and gbp = 1533.0 and eur = 243090 and  hkd = 1971.0','')")

    con:query("insert into check_sql values(2191,'delete from transaction_total_check where cny = 2191 and jpy = 219100 and gbp = 1533.7 and eur = 243201 and  hkd = 1971.9','')")

    con:query("insert into check_sql values(2192,'delete from transaction_total_check where cny = 2192 and jpy = 219200 and gbp = 1534.4 and eur = 243312 and  hkd = 1972.8','')")

    con:query("insert into check_sql values(2193,'delete from transaction_total_check where cny = 2193 and jpy = 219300 and gbp = 1535.1 and eur = 243423 and  hkd = 1973.7','')")

    con:query("insert into check_sql values(2194,'delete from transaction_total_check where cny = 2194 and jpy = 219400 and gbp = 1535.8 and eur = 243534 and  hkd = 1974.6','')")

    con:query("insert into check_sql values(2195,'delete from transaction_total_check where cny = 2195 and jpy = 219500 and gbp = 1536.5 and eur = 243645 and  hkd = 1975.5','')")

    con:query("insert into check_sql values(2196,'delete from transaction_total_check where cny = 2196 and jpy = 219600 and gbp = 1537.2 and eur = 243756 and  hkd = 1976.4','')")

    con:query("insert into check_sql values(2197,'delete from transaction_total_check where cny = 2197 and jpy = 219700 and gbp = 1537.9 and eur = 243867 and  hkd = 1977.3','')")

    con:query("insert into check_sql values(2198,'delete from transaction_total_check where cny = 2198 and jpy = 219800 and gbp = 1538.6 and eur = 243978 and  hkd = 1978.2','')")

    con:query("insert into check_sql values(2199,'delete from transaction_total_check where cny = 2199 and jpy = 219900 and gbp = 1539.3 and eur = 244089 and  hkd = 1979.1','')")

    con:query("insert into check_sql values(2200,'delete from transaction_total_check where cny = 2200 and jpy = 220000 and gbp = 1540.0 and eur = 244200 and  hkd = 1980.0','')")

    con:query("insert into check_sql values(2201,'delete from transaction_total_check where cny = 2201 and jpy = 220100 and gbp = 1540.7 and eur = 244311 and  hkd = 1980.9','')")

    con:query("insert into check_sql values(2202,'delete from transaction_total_check where cny = 2202 and jpy = 220200 and gbp = 1541.4 and eur = 244422 and  hkd = 1981.8','')")

    con:query("insert into check_sql values(2203,'delete from transaction_total_check where cny = 2203 and jpy = 220300 and gbp = 1542.1 and eur = 244533 and  hkd = 1982.7','')")

    con:query("insert into check_sql values(2204,'delete from transaction_total_check where cny = 2204 and jpy = 220400 and gbp = 1542.8 and eur = 244644 and  hkd = 1983.6','')")

    con:query("insert into check_sql values(2205,'delete from transaction_total_check where cny = 2205 and jpy = 220500 and gbp = 1543.5 and eur = 244755 and  hkd = 1984.5','')")

    con:query("insert into check_sql values(2206,'delete from transaction_total_check where cny = 2206 and jpy = 220600 and gbp = 1544.2 and eur = 244866 and  hkd = 1985.4','')")

    con:query("insert into check_sql values(2207,'delete from transaction_total_check where cny = 2207 and jpy = 220700 and gbp = 1544.9 and eur = 244977 and  hkd = 1986.3','')")

    con:query("insert into check_sql values(2208,'delete from transaction_total_check where cny = 2208 and jpy = 220800 and gbp = 1545.6 and eur = 245088 and  hkd = 1987.2','')")

    con:query("insert into check_sql values(2209,'delete from transaction_total_check where cny = 2209 and jpy = 220900 and gbp = 1546.3 and eur = 245199 and  hkd = 1988.1','')")

    con:query("insert into check_sql values(2210,'delete from transaction_total_check where cny = 2210 and jpy = 221000 and gbp = 1547.0 and eur = 245310 and  hkd = 1989.0','')")

    con:query("insert into check_sql values(2211,'delete from transaction_total_check where cny = 2211 and jpy = 221100 and gbp = 1547.7 and eur = 245421 and  hkd = 1989.9','')")

    con:query("insert into check_sql values(2212,'delete from transaction_total_check where cny = 2212 and jpy = 221200 and gbp = 1548.4 and eur = 245532 and  hkd = 1990.8','')")

    con:query("insert into check_sql values(2213,'delete from transaction_total_check where cny = 2213 and jpy = 221300 and gbp = 1549.1 and eur = 245643 and  hkd = 1991.7','')")

    con:query("insert into check_sql values(2214,'delete from transaction_total_check where cny = 2214 and jpy = 221400 and gbp = 1549.8 and eur = 245754 and  hkd = 1992.6','')")

    con:query("insert into check_sql values(2215,'delete from transaction_total_check where cny = 2215 and jpy = 221500 and gbp = 1550.5 and eur = 245865 and  hkd = 1993.5','')")

    con:query("insert into check_sql values(2216,'delete from transaction_total_check where cny = 2216 and jpy = 221600 and gbp = 1551.2 and eur = 245976 and  hkd = 1994.4','')")

    con:query("insert into check_sql values(2217,'delete from transaction_total_check where cny = 2217 and jpy = 221700 and gbp = 1551.9 and eur = 246087 and  hkd = 1995.3','')")

    con:query("insert into check_sql values(2218,'delete from transaction_total_check where cny = 2218 and jpy = 221800 and gbp = 1552.6 and eur = 246198 and  hkd = 1996.2','')")

    con:query("insert into check_sql values(2219,'delete from transaction_total_check where cny = 2219 and jpy = 221900 and gbp = 1553.3 and eur = 246309 and  hkd = 1997.1','')")

    con:query("insert into check_sql values(2220,'delete from transaction_total_check where cny = 2220 and jpy = 222000 and gbp = 1554.0 and eur = 246420 and  hkd = 1998.0','')")

    con:query("insert into check_sql values(2221,'delete from transaction_total_check where cny = 2221 and jpy = 222100 and gbp = 1554.7 and eur = 246531 and  hkd = 1998.9','')")

    con:query("insert into check_sql values(2222,'delete from transaction_total_check where cny = 2222 and jpy = 222200 and gbp = 1555.4 and eur = 246642 and  hkd = 1999.8','')")

    con:query("insert into check_sql values(2223,'delete from transaction_total_check where cny = 2223 and jpy = 222300 and gbp = 1556.1 and eur = 246753 and  hkd = 2000.7','')")

    con:query("insert into check_sql values(2224,'delete from transaction_total_check where cny = 2224 and jpy = 222400 and gbp = 1556.8 and eur = 246864 and  hkd = 2001.6','')")

    con:query("insert into check_sql values(2225,'delete from transaction_total_check where cny = 2225 and jpy = 222500 and gbp = 1557.5 and eur = 246975 and  hkd = 2002.5','')")

    con:query("insert into check_sql values(2226,'delete from transaction_total_check where cny = 2226 and jpy = 222600 and gbp = 1558.2 and eur = 247086 and  hkd = 2003.4','')")

    con:query("insert into check_sql values(2227,'delete from transaction_total_check where cny = 2227 and jpy = 222700 and gbp = 1558.9 and eur = 247197 and  hkd = 2004.3','')")

    con:query("insert into check_sql values(2228,'delete from transaction_total_check where cny = 2228 and jpy = 222800 and gbp = 1559.6 and eur = 247308 and  hkd = 2005.2','')")

    con:query("insert into check_sql values(2229,'delete from transaction_total_check where cny = 2229 and jpy = 222900 and gbp = 1560.3 and eur = 247419 and  hkd = 2006.1','')")

    con:query("insert into check_sql values(2230,'delete from transaction_total_check where cny = 2230 and jpy = 223000 and gbp = 1561.0 and eur = 247530 and  hkd = 2007.0','')")

    con:query("insert into check_sql values(2231,'delete from transaction_total_check where cny = 2231 and jpy = 223100 and gbp = 1561.7 and eur = 247641 and  hkd = 2007.9','')")

    con:query("insert into check_sql values(2232,'delete from transaction_total_check where cny = 2232 and jpy = 223200 and gbp = 1562.4 and eur = 247752 and  hkd = 2008.8','')")

    con:query("insert into check_sql values(2233,'delete from transaction_total_check where cny = 2233 and jpy = 223300 and gbp = 1563.1 and eur = 247863 and  hkd = 2009.7','')")

    con:query("insert into check_sql values(2234,'delete from transaction_total_check where cny = 2234 and jpy = 223400 and gbp = 1563.8 and eur = 247974 and  hkd = 2010.6','')")

    con:query("insert into check_sql values(2235,'delete from transaction_total_check where cny = 2235 and jpy = 223500 and gbp = 1564.5 and eur = 248085 and  hkd = 2011.5','')")

    con:query("insert into check_sql values(2236,'delete from transaction_total_check where cny = 2236 and jpy = 223600 and gbp = 1565.2 and eur = 248196 and  hkd = 2012.4','')")

    con:query("insert into check_sql values(2237,'delete from transaction_total_check where cny = 2237 and jpy = 223700 and gbp = 1565.9 and eur = 248307 and  hkd = 2013.3','')")

    con:query("insert into check_sql values(2238,'delete from transaction_total_check where cny = 2238 and jpy = 223800 and gbp = 1566.6 and eur = 248418 and  hkd = 2014.2','')")

    con:query("insert into check_sql values(2239,'delete from transaction_total_check where cny = 2239 and jpy = 223900 and gbp = 1567.3 and eur = 248529 and  hkd = 2015.1','')")

    con:query("insert into check_sql values(2240,'delete from transaction_total_check where cny = 2240 and jpy = 224000 and gbp = 1568.0 and eur = 248640 and  hkd = 2016.0','')")

    con:query("insert into check_sql values(2241,'delete from transaction_total_check where cny = 2241 and jpy = 224100 and gbp = 1568.7 and eur = 248751 and  hkd = 2016.9','')")

    con:query("insert into check_sql values(2242,'delete from transaction_total_check where cny = 2242 and jpy = 224200 and gbp = 1569.4 and eur = 248862 and  hkd = 2017.8','')")

    con:query("insert into check_sql values(2243,'delete from transaction_total_check where cny = 2243 and jpy = 224300 and gbp = 1570.1 and eur = 248973 and  hkd = 2018.7','')")

    con:query("insert into check_sql values(2244,'delete from transaction_total_check where cny = 2244 and jpy = 224400 and gbp = 1570.8 and eur = 249084 and  hkd = 2019.6','')")

    con:query("insert into check_sql values(2245,'delete from transaction_total_check where cny = 2245 and jpy = 224500 and gbp = 1571.5 and eur = 249195 and  hkd = 2020.5','')")

    con:query("insert into check_sql values(2246,'delete from transaction_total_check where cny = 2246 and jpy = 224600 and gbp = 1572.2 and eur = 249306 and  hkd = 2021.4','')")

    con:query("insert into check_sql values(2247,'delete from transaction_total_check where cny = 2247 and jpy = 224700 and gbp = 1572.9 and eur = 249417 and  hkd = 2022.3','')")

    con:query("insert into check_sql values(2248,'delete from transaction_total_check where cny = 2248 and jpy = 224800 and gbp = 1573.6 and eur = 249528 and  hkd = 2023.2','')")

    con:query("insert into check_sql values(2249,'delete from transaction_total_check where cny = 2249 and jpy = 224900 and gbp = 1574.3 and eur = 249639 and  hkd = 2024.1','')")

    con:query("insert into check_sql values(2250,'delete from transaction_total_check where cny = 2250 and jpy = 225000 and gbp = 1575.0 and eur = 249750 and  hkd = 2025.0','')")

    con:query("insert into check_sql values(2251,'delete from transaction_total_check where cny = 2251 and jpy = 225100 and gbp = 1575.7 and eur = 249861 and  hkd = 2025.9','')")

    con:query("insert into check_sql values(2252,'delete from transaction_total_check where cny = 2252 and jpy = 225200 and gbp = 1576.4 and eur = 249972 and  hkd = 2026.8','')")

    con:query("insert into check_sql values(2253,'delete from transaction_total_check where cny = 2253 and jpy = 225300 and gbp = 1577.1 and eur = 250083 and  hkd = 2027.7','')")

    con:query("insert into check_sql values(2254,'delete from transaction_total_check where cny = 2254 and jpy = 225400 and gbp = 1577.8 and eur = 250194 and  hkd = 2028.6','')")

    con:query("insert into check_sql values(2255,'delete from transaction_total_check where cny = 2255 and jpy = 225500 and gbp = 1578.5 and eur = 250305 and  hkd = 2029.5','')")

    con:query("insert into check_sql values(2256,'delete from transaction_total_check where cny = 2256 and jpy = 225600 and gbp = 1579.2 and eur = 250416 and  hkd = 2030.4','')")

    con:query("insert into check_sql values(2257,'delete from transaction_total_check where cny = 2257 and jpy = 225700 and gbp = 1579.9 and eur = 250527 and  hkd = 2031.3','')")

    con:query("insert into check_sql values(2258,'delete from transaction_total_check where cny = 2258 and jpy = 225800 and gbp = 1580.6 and eur = 250638 and  hkd = 2032.2','')")

    con:query("insert into check_sql values(2259,'delete from transaction_total_check where cny = 2259 and jpy = 225900 and gbp = 1581.3 and eur = 250749 and  hkd = 2033.1','')")

    con:query("insert into check_sql values(2260,'delete from transaction_total_check where cny = 2260 and jpy = 226000 and gbp = 1582.0 and eur = 250860 and  hkd = 2034.0','')")

    con:query("insert into check_sql values(2261,'delete from transaction_total_check where cny = 2261 and jpy = 226100 and gbp = 1582.7 and eur = 250971 and  hkd = 2034.9','')")

    con:query("insert into check_sql values(2262,'delete from transaction_total_check where cny = 2262 and jpy = 226200 and gbp = 1583.4 and eur = 251082 and  hkd = 2035.8','')")

    con:query("insert into check_sql values(2263,'delete from transaction_total_check where cny = 2263 and jpy = 226300 and gbp = 1584.1 and eur = 251193 and  hkd = 2036.7','')")

    con:query("insert into check_sql values(2264,'delete from transaction_total_check where cny = 2264 and jpy = 226400 and gbp = 1584.8 and eur = 251304 and  hkd = 2037.6','')")

    con:query("insert into check_sql values(2265,'delete from transaction_total_check where cny = 2265 and jpy = 226500 and gbp = 1585.5 and eur = 251415 and  hkd = 2038.5','')")

    con:query("insert into check_sql values(2266,'delete from transaction_total_check where cny = 2266 and jpy = 226600 and gbp = 1586.2 and eur = 251526 and  hkd = 2039.4','')")

    con:query("insert into check_sql values(2267,'delete from transaction_total_check where cny = 2267 and jpy = 226700 and gbp = 1586.9 and eur = 251637 and  hkd = 2040.3','')")

    con:query("insert into check_sql values(2268,'delete from transaction_total_check where cny = 2268 and jpy = 226800 and gbp = 1587.6 and eur = 251748 and  hkd = 2041.2','')")

    con:query("insert into check_sql values(2269,'delete from transaction_total_check where cny = 2269 and jpy = 226900 and gbp = 1588.3 and eur = 251859 and  hkd = 2042.1','')")

    con:query("insert into check_sql values(2270,'delete from transaction_total_check where cny = 2270 and jpy = 227000 and gbp = 1589.0 and eur = 251970 and  hkd = 2043.0','')")

    con:query("insert into check_sql values(2271,'delete from transaction_total_check where cny = 2271 and jpy = 227100 and gbp = 1589.7 and eur = 252081 and  hkd = 2043.9','')")

    con:query("insert into check_sql values(2272,'delete from transaction_total_check where cny = 2272 and jpy = 227200 and gbp = 1590.4 and eur = 252192 and  hkd = 2044.8','')")

    con:query("insert into check_sql values(2273,'delete from transaction_total_check where cny = 2273 and jpy = 227300 and gbp = 1591.1 and eur = 252303 and  hkd = 2045.7','')")

    con:query("insert into check_sql values(2274,'delete from transaction_total_check where cny = 2274 and jpy = 227400 and gbp = 1591.8 and eur = 252414 and  hkd = 2046.6','')")

    con:query("insert into check_sql values(2275,'delete from transaction_total_check where cny = 2275 and jpy = 227500 and gbp = 1592.5 and eur = 252525 and  hkd = 2047.5','')")

    con:query("insert into check_sql values(2276,'delete from transaction_total_check where cny = 2276 and jpy = 227600 and gbp = 1593.2 and eur = 252636 and  hkd = 2048.4','')")

    con:query("insert into check_sql values(2277,'delete from transaction_total_check where cny = 2277 and jpy = 227700 and gbp = 1593.9 and eur = 252747 and  hkd = 2049.3','')")

    con:query("insert into check_sql values(2278,'delete from transaction_total_check where cny = 2278 and jpy = 227800 and gbp = 1594.6 and eur = 252858 and  hkd = 2050.2','')")

    con:query("insert into check_sql values(2279,'delete from transaction_total_check where cny = 2279 and jpy = 227900 and gbp = 1595.3 and eur = 252969 and  hkd = 2051.1','')")

    con:query("insert into check_sql values(2280,'delete from transaction_total_check where cny = 2280 and jpy = 228000 and gbp = 1596.0 and eur = 253080 and  hkd = 2052.0','')")

    con:query("insert into check_sql values(2281,'delete from transaction_total_check where cny = 2281 and jpy = 228100 and gbp = 1596.7 and eur = 253191 and  hkd = 2052.9','')")

    con:query("insert into check_sql values(2282,'delete from transaction_total_check where cny = 2282 and jpy = 228200 and gbp = 1597.4 and eur = 253302 and  hkd = 2053.8','')")

    con:query("insert into check_sql values(2283,'delete from transaction_total_check where cny = 2283 and jpy = 228300 and gbp = 1598.1 and eur = 253413 and  hkd = 2054.7','')")

    con:query("insert into check_sql values(2284,'delete from transaction_total_check where cny = 2284 and jpy = 228400 and gbp = 1598.8 and eur = 253524 and  hkd = 2055.6','')")

    con:query("insert into check_sql values(2285,'delete from transaction_total_check where cny = 2285 and jpy = 228500 and gbp = 1599.5 and eur = 253635 and  hkd = 2056.5','')")

    con:query("insert into check_sql values(2286,'delete from transaction_total_check where cny = 2286 and jpy = 228600 and gbp = 1600.2 and eur = 253746 and  hkd = 2057.4','')")

    con:query("insert into check_sql values(2287,'delete from transaction_total_check where cny = 2287 and jpy = 228700 and gbp = 1600.9 and eur = 253857 and  hkd = 2058.3','')")

    con:query("insert into check_sql values(2288,'delete from transaction_total_check where cny = 2288 and jpy = 228800 and gbp = 1601.6 and eur = 253968 and  hkd = 2059.2','')")

    con:query("insert into check_sql values(2289,'delete from transaction_total_check where cny = 2289 and jpy = 228900 and gbp = 1602.3 and eur = 254079 and  hkd = 2060.1','')")

    con:query("insert into check_sql values(2290,'delete from transaction_total_check where cny = 2290 and jpy = 229000 and gbp = 1603.0 and eur = 254190 and  hkd = 2061.0','')")

    con:query("insert into check_sql values(2291,'delete from transaction_total_check where cny = 2291 and jpy = 229100 and gbp = 1603.7 and eur = 254301 and  hkd = 2061.9','')")

    con:query("insert into check_sql values(2292,'delete from transaction_total_check where cny = 2292 and jpy = 229200 and gbp = 1604.4 and eur = 254412 and  hkd = 2062.8','')")

    con:query("insert into check_sql values(2293,'delete from transaction_total_check where cny = 2293 and jpy = 229300 and gbp = 1605.1 and eur = 254523 and  hkd = 2063.7','')")

    con:query("insert into check_sql values(2294,'delete from transaction_total_check where cny = 2294 and jpy = 229400 and gbp = 1605.8 and eur = 254634 and  hkd = 2064.6','')")

    con:query("insert into check_sql values(2295,'delete from transaction_total_check where cny = 2295 and jpy = 229500 and gbp = 1606.5 and eur = 254745 and  hkd = 2065.5','')")

    con:query("insert into check_sql values(2296,'delete from transaction_total_check where cny = 2296 and jpy = 229600 and gbp = 1607.2 and eur = 254856 and  hkd = 2066.4','')")

    con:query("insert into check_sql values(2297,'delete from transaction_total_check where cny = 2297 and jpy = 229700 and gbp = 1607.9 and eur = 254967 and  hkd = 2067.3','')")

    con:query("insert into check_sql values(2298,'delete from transaction_total_check where cny = 2298 and jpy = 229800 and gbp = 1608.6 and eur = 255078 and  hkd = 2068.2','')")

    con:query("insert into check_sql values(2299,'delete from transaction_total_check where cny = 2299 and jpy = 229900 and gbp = 1609.3 and eur = 255189 and  hkd = 2069.1','')")

    con:query("insert into check_sql values(2300,'delete from transaction_total_check where cny = 2300 and jpy = 230000 and gbp = 1610.0 and eur = 255300 and  hkd = 2070.0','')")

    con:query("insert into check_sql values(2301,'delete from transaction_total_check where cny = 2301 and jpy = 230100 and gbp = 1610.7 and eur = 255411 and  hkd = 2070.9','')")

    con:query("insert into check_sql values(2302,'delete from transaction_total_check where cny = 2302 and jpy = 230200 and gbp = 1611.4 and eur = 255522 and  hkd = 2071.8','')")

    con:query("insert into check_sql values(2303,'delete from transaction_total_check where cny = 2303 and jpy = 230300 and gbp = 1612.1 and eur = 255633 and  hkd = 2072.7','')")

    con:query("insert into check_sql values(2304,'delete from transaction_total_check where cny = 2304 and jpy = 230400 and gbp = 1612.8 and eur = 255744 and  hkd = 2073.6','')")

    con:query("insert into check_sql values(2305,'delete from transaction_total_check where cny = 2305 and jpy = 230500 and gbp = 1613.5 and eur = 255855 and  hkd = 2074.5','')")

    con:query("insert into check_sql values(2306,'delete from transaction_total_check where cny = 2306 and jpy = 230600 and gbp = 1614.2 and eur = 255966 and  hkd = 2075.4','')")

    con:query("insert into check_sql values(2307,'delete from transaction_total_check where cny = 2307 and jpy = 230700 and gbp = 1614.9 and eur = 256077 and  hkd = 2076.3','')")

    con:query("insert into check_sql values(2308,'delete from transaction_total_check where cny = 2308 and jpy = 230800 and gbp = 1615.6 and eur = 256188 and  hkd = 2077.2','')")

    con:query("insert into check_sql values(2309,'delete from transaction_total_check where cny = 2309 and jpy = 230900 and gbp = 1616.3 and eur = 256299 and  hkd = 2078.1','')")

    con:query("insert into check_sql values(2310,'delete from transaction_total_check where cny = 2310 and jpy = 231000 and gbp = 1617.0 and eur = 256410 and  hkd = 2079.0','')")

    con:query("insert into check_sql values(2311,'delete from transaction_total_check where cny = 2311 and jpy = 231100 and gbp = 1617.7 and eur = 256521 and  hkd = 2079.9','')")

    con:query("insert into check_sql values(2312,'delete from transaction_total_check where cny = 2312 and jpy = 231200 and gbp = 1618.4 and eur = 256632 and  hkd = 2080.8','')")

    con:query("insert into check_sql values(2313,'delete from transaction_total_check where cny = 2313 and jpy = 231300 and gbp = 1619.1 and eur = 256743 and  hkd = 2081.7','')")

    con:query("insert into check_sql values(2314,'delete from transaction_total_check where cny = 2314 and jpy = 231400 and gbp = 1619.8 and eur = 256854 and  hkd = 2082.6','')")

    con:query("insert into check_sql values(2315,'delete from transaction_total_check where cny = 2315 and jpy = 231500 and gbp = 1620.5 and eur = 256965 and  hkd = 2083.5','')")

    con:query("insert into check_sql values(2316,'delete from transaction_total_check where cny = 2316 and jpy = 231600 and gbp = 1621.2 and eur = 257076 and  hkd = 2084.4','')")

    con:query("insert into check_sql values(2317,'delete from transaction_total_check where cny = 2317 and jpy = 231700 and gbp = 1621.9 and eur = 257187 and  hkd = 2085.3','')")

    con:query("insert into check_sql values(2318,'delete from transaction_total_check where cny = 2318 and jpy = 231800 and gbp = 1622.6 and eur = 257298 and  hkd = 2086.2','')")

    con:query("insert into check_sql values(2319,'delete from transaction_total_check where cny = 2319 and jpy = 231900 and gbp = 1623.3 and eur = 257409 and  hkd = 2087.1','')")

    con:query("insert into check_sql values(2320,'delete from transaction_total_check where cny = 2320 and jpy = 232000 and gbp = 1624.0 and eur = 257520 and  hkd = 2088.0','')")

    con:query("insert into check_sql values(2321,'delete from transaction_total_check where cny = 2321 and jpy = 232100 and gbp = 1624.7 and eur = 257631 and  hkd = 2088.9','')")

    con:query("insert into check_sql values(2322,'delete from transaction_total_check where cny = 2322 and jpy = 232200 and gbp = 1625.4 and eur = 257742 and  hkd = 2089.8','')")

    con:query("insert into check_sql values(2323,'delete from transaction_total_check where cny = 2323 and jpy = 232300 and gbp = 1626.1 and eur = 257853 and  hkd = 2090.7','')")

    con:query("insert into check_sql values(2324,'delete from transaction_total_check where cny = 2324 and jpy = 232400 and gbp = 1626.8 and eur = 257964 and  hkd = 2091.6','')")

    con:query("insert into check_sql values(2325,'delete from transaction_total_check where cny = 2325 and jpy = 232500 and gbp = 1627.5 and eur = 258075 and  hkd = 2092.5','')")

    con:query("insert into check_sql values(2326,'delete from transaction_total_check where cny = 2326 and jpy = 232600 and gbp = 1628.2 and eur = 258186 and  hkd = 2093.4','')")

    con:query("insert into check_sql values(2327,'delete from transaction_total_check where cny = 2327 and jpy = 232700 and gbp = 1628.9 and eur = 258297 and  hkd = 2094.3','')")

    con:query("insert into check_sql values(2328,'delete from transaction_total_check where cny = 2328 and jpy = 232800 and gbp = 1629.6 and eur = 258408 and  hkd = 2095.2','')")

    con:query("insert into check_sql values(2329,'delete from transaction_total_check where cny = 2329 and jpy = 232900 and gbp = 1630.3 and eur = 258519 and  hkd = 2096.1','')")

    con:query("insert into check_sql values(2330,'delete from transaction_total_check where cny = 2330 and jpy = 233000 and gbp = 1631.0 and eur = 258630 and  hkd = 2097.0','')")

    con:query("insert into check_sql values(2331,'delete from transaction_total_check where cny = 2331 and jpy = 233100 and gbp = 1631.7 and eur = 258741 and  hkd = 2097.9','')")

    con:query("insert into check_sql values(2332,'delete from transaction_total_check where cny = 2332 and jpy = 233200 and gbp = 1632.4 and eur = 258852 and  hkd = 2098.8','')")

    con:query("insert into check_sql values(2333,'delete from transaction_total_check where cny = 2333 and jpy = 233300 and gbp = 1633.1 and eur = 258963 and  hkd = 2099.7','')")

    con:query("insert into check_sql values(2334,'delete from transaction_total_check where cny = 2334 and jpy = 233400 and gbp = 1633.8 and eur = 259074 and  hkd = 2100.6','')")

    con:query("insert into check_sql values(2335,'delete from transaction_total_check where cny = 2335 and jpy = 233500 and gbp = 1634.5 and eur = 259185 and  hkd = 2101.5','')")

    con:query("insert into check_sql values(2336,'delete from transaction_total_check where cny = 2336 and jpy = 233600 and gbp = 1635.2 and eur = 259296 and  hkd = 2102.4','')")

    con:query("insert into check_sql values(2337,'delete from transaction_total_check where cny = 2337 and jpy = 233700 and gbp = 1635.9 and eur = 259407 and  hkd = 2103.3','')")

    con:query("insert into check_sql values(2338,'delete from transaction_total_check where cny = 2338 and jpy = 233800 and gbp = 1636.6 and eur = 259518 and  hkd = 2104.2','')")

    con:query("insert into check_sql values(2339,'delete from transaction_total_check where cny = 2339 and jpy = 233900 and gbp = 1637.3 and eur = 259629 and  hkd = 2105.1','')")

    con:query("insert into check_sql values(2340,'delete from transaction_total_check where cny = 2340 and jpy = 234000 and gbp = 1638.0 and eur = 259740 and  hkd = 2106.0','')")

    con:query("insert into check_sql values(2341,'delete from transaction_total_check where cny = 2341 and jpy = 234100 and gbp = 1638.7 and eur = 259851 and  hkd = 2106.9','')")

    con:query("insert into check_sql values(2342,'delete from transaction_total_check where cny = 2342 and jpy = 234200 and gbp = 1639.4 and eur = 259962 and  hkd = 2107.8','')")

    con:query("insert into check_sql values(2343,'delete from transaction_total_check where cny = 2343 and jpy = 234300 and gbp = 1640.1 and eur = 260073 and  hkd = 2108.7','')")

    con:query("insert into check_sql values(2344,'delete from transaction_total_check where cny = 2344 and jpy = 234400 and gbp = 1640.8 and eur = 260184 and  hkd = 2109.6','')")

    con:query("insert into check_sql values(2345,'delete from transaction_total_check where cny = 2345 and jpy = 234500 and gbp = 1641.5 and eur = 260295 and  hkd = 2110.5','')")

    con:query("insert into check_sql values(2346,'delete from transaction_total_check where cny = 2346 and jpy = 234600 and gbp = 1642.2 and eur = 260406 and  hkd = 2111.4','')")

    con:query("insert into check_sql values(2347,'delete from transaction_total_check where cny = 2347 and jpy = 234700 and gbp = 1642.9 and eur = 260517 and  hkd = 2112.3','')")

    con:query("insert into check_sql values(2348,'delete from transaction_total_check where cny = 2348 and jpy = 234800 and gbp = 1643.6 and eur = 260628 and  hkd = 2113.2','')")

    con:query("insert into check_sql values(2349,'delete from transaction_total_check where cny = 2349 and jpy = 234900 and gbp = 1644.3 and eur = 260739 and  hkd = 2114.1','')")

    con:query("insert into check_sql values(2350,'delete from transaction_total_check where cny = 2350 and jpy = 235000 and gbp = 1645.0 and eur = 260850 and  hkd = 2115.0','')")

    con:query("insert into check_sql values(2351,'delete from transaction_total_check where cny = 2351 and jpy = 235100 and gbp = 1645.7 and eur = 260961 and  hkd = 2115.9','')")

    con:query("insert into check_sql values(2352,'delete from transaction_total_check where cny = 2352 and jpy = 235200 and gbp = 1646.4 and eur = 261072 and  hkd = 2116.8','')")

    con:query("insert into check_sql values(2353,'delete from transaction_total_check where cny = 2353 and jpy = 235300 and gbp = 1647.1 and eur = 261183 and  hkd = 2117.7','')")

    con:query("insert into check_sql values(2354,'delete from transaction_total_check where cny = 2354 and jpy = 235400 and gbp = 1647.8 and eur = 261294 and  hkd = 2118.6','')")

    con:query("insert into check_sql values(2355,'delete from transaction_total_check where cny = 2355 and jpy = 235500 and gbp = 1648.5 and eur = 261405 and  hkd = 2119.5','')")

    con:query("insert into check_sql values(2356,'delete from transaction_total_check where cny = 2356 and jpy = 235600 and gbp = 1649.2 and eur = 261516 and  hkd = 2120.4','')")

    con:query("insert into check_sql values(2357,'delete from transaction_total_check where cny = 2357 and jpy = 235700 and gbp = 1649.9 and eur = 261627 and  hkd = 2121.3','')")

    con:query("insert into check_sql values(2358,'delete from transaction_total_check where cny = 2358 and jpy = 235800 and gbp = 1650.6 and eur = 261738 and  hkd = 2122.2','')")

    con:query("insert into check_sql values(2359,'delete from transaction_total_check where cny = 2359 and jpy = 235900 and gbp = 1651.3 and eur = 261849 and  hkd = 2123.1','')")

    con:query("insert into check_sql values(2360,'delete from transaction_total_check where cny = 2360 and jpy = 236000 and gbp = 1652.0 and eur = 261960 and  hkd = 2124.0','')")

    con:query("insert into check_sql values(2361,'delete from transaction_total_check where cny = 2361 and jpy = 236100 and gbp = 1652.7 and eur = 262071 and  hkd = 2124.9','')")

    con:query("insert into check_sql values(2362,'delete from transaction_total_check where cny = 2362 and jpy = 236200 and gbp = 1653.4 and eur = 262182 and  hkd = 2125.8','')")

    con:query("insert into check_sql values(2363,'delete from transaction_total_check where cny = 2363 and jpy = 236300 and gbp = 1654.1 and eur = 262293 and  hkd = 2126.7','')")

    con:query("insert into check_sql values(2364,'delete from transaction_total_check where cny = 2364 and jpy = 236400 and gbp = 1654.8 and eur = 262404 and  hkd = 2127.6','')")

    con:query("insert into check_sql values(2365,'delete from transaction_total_check where cny = 2365 and jpy = 236500 and gbp = 1655.5 and eur = 262515 and  hkd = 2128.5','')")

    con:query("insert into check_sql values(2366,'delete from transaction_total_check where cny = 2366 and jpy = 236600 and gbp = 1656.2 and eur = 262626 and  hkd = 2129.4','')")

    con:query("insert into check_sql values(2367,'delete from transaction_total_check where cny = 2367 and jpy = 236700 and gbp = 1656.9 and eur = 262737 and  hkd = 2130.3','')")

    con:query("insert into check_sql values(2368,'delete from transaction_total_check where cny = 2368 and jpy = 236800 and gbp = 1657.6 and eur = 262848 and  hkd = 2131.2','')")

    con:query("insert into check_sql values(2369,'delete from transaction_total_check where cny = 2369 and jpy = 236900 and gbp = 1658.3 and eur = 262959 and  hkd = 2132.1','')")

    con:query("insert into check_sql values(2370,'delete from transaction_total_check where cny = 2370 and jpy = 237000 and gbp = 1659.0 and eur = 263070 and  hkd = 2133.0','')")

    con:query("insert into check_sql values(2371,'delete from transaction_total_check where cny = 2371 and jpy = 237100 and gbp = 1659.7 and eur = 263181 and  hkd = 2133.9','')")

    con:query("insert into check_sql values(2372,'delete from transaction_total_check where cny = 2372 and jpy = 237200 and gbp = 1660.4 and eur = 263292 and  hkd = 2134.8','')")

    con:query("insert into check_sql values(2373,'delete from transaction_total_check where cny = 2373 and jpy = 237300 and gbp = 1661.1 and eur = 263403 and  hkd = 2135.7','')")

    con:query("insert into check_sql values(2374,'delete from transaction_total_check where cny = 2374 and jpy = 237400 and gbp = 1661.8 and eur = 263514 and  hkd = 2136.6','')")

    con:query("insert into check_sql values(2375,'delete from transaction_total_check where cny = 2375 and jpy = 237500 and gbp = 1662.5 and eur = 263625 and  hkd = 2137.5','')")

    con:query("insert into check_sql values(2376,'delete from transaction_total_check where cny = 2376 and jpy = 237600 and gbp = 1663.2 and eur = 263736 and  hkd = 2138.4','')")

    con:query("insert into check_sql values(2377,'delete from transaction_total_check where cny = 2377 and jpy = 237700 and gbp = 1663.9 and eur = 263847 and  hkd = 2139.3','')")

    con:query("insert into check_sql values(2378,'delete from transaction_total_check where cny = 2378 and jpy = 237800 and gbp = 1664.6 and eur = 263958 and  hkd = 2140.2','')")

    con:query("insert into check_sql values(2379,'delete from transaction_total_check where cny = 2379 and jpy = 237900 and gbp = 1665.3 and eur = 264069 and  hkd = 2141.1','')")

    con:query("insert into check_sql values(2380,'delete from transaction_total_check where cny = 2380 and jpy = 238000 and gbp = 1666.0 and eur = 264180 and  hkd = 2142.0','')")

    con:query("insert into check_sql values(2381,'delete from transaction_total_check where cny = 2381 and jpy = 238100 and gbp = 1666.7 and eur = 264291 and  hkd = 2142.9','')")

    con:query("insert into check_sql values(2382,'delete from transaction_total_check where cny = 2382 and jpy = 238200 and gbp = 1667.4 and eur = 264402 and  hkd = 2143.8','')")

    con:query("insert into check_sql values(2383,'delete from transaction_total_check where cny = 2383 and jpy = 238300 and gbp = 1668.1 and eur = 264513 and  hkd = 2144.7','')")

    con:query("insert into check_sql values(2384,'delete from transaction_total_check where cny = 2384 and jpy = 238400 and gbp = 1668.8 and eur = 264624 and  hkd = 2145.6','')")

    con:query("insert into check_sql values(2385,'delete from transaction_total_check where cny = 2385 and jpy = 238500 and gbp = 1669.5 and eur = 264735 and  hkd = 2146.5','')")

    con:query("insert into check_sql values(2386,'delete from transaction_total_check where cny = 2386 and jpy = 238600 and gbp = 1670.2 and eur = 264846 and  hkd = 2147.4','')")

    con:query("insert into check_sql values(2387,'delete from transaction_total_check where cny = 2387 and jpy = 238700 and gbp = 1670.9 and eur = 264957 and  hkd = 2148.3','')")

    con:query("insert into check_sql values(2388,'delete from transaction_total_check where cny = 2388 and jpy = 238800 and gbp = 1671.6 and eur = 265068 and  hkd = 2149.2','')")

    con:query("insert into check_sql values(2389,'delete from transaction_total_check where cny = 2389 and jpy = 238900 and gbp = 1672.3 and eur = 265179 and  hkd = 2150.1','')")

    con:query("insert into check_sql values(2390,'delete from transaction_total_check where cny = 2390 and jpy = 239000 and gbp = 1673.0 and eur = 265290 and  hkd = 2151.0','')")

    con:query("insert into check_sql values(2391,'delete from transaction_total_check where cny = 2391 and jpy = 239100 and gbp = 1673.7 and eur = 265401 and  hkd = 2151.9','')")

    con:query("insert into check_sql values(2392,'delete from transaction_total_check where cny = 2392 and jpy = 239200 and gbp = 1674.4 and eur = 265512 and  hkd = 2152.8','')")

    con:query("insert into check_sql values(2393,'delete from transaction_total_check where cny = 2393 and jpy = 239300 and gbp = 1675.1 and eur = 265623 and  hkd = 2153.7','')")

    con:query("insert into check_sql values(2394,'delete from transaction_total_check where cny = 2394 and jpy = 239400 and gbp = 1675.8 and eur = 265734 and  hkd = 2154.6','')")

    con:query("insert into check_sql values(2395,'delete from transaction_total_check where cny = 2395 and jpy = 239500 and gbp = 1676.5 and eur = 265845 and  hkd = 2155.5','')")

    con:query("insert into check_sql values(2396,'delete from transaction_total_check where cny = 2396 and jpy = 239600 and gbp = 1677.2 and eur = 265956 and  hkd = 2156.4','')")

    con:query("insert into check_sql values(2397,'delete from transaction_total_check where cny = 2397 and jpy = 239700 and gbp = 1677.9 and eur = 266067 and  hkd = 2157.3','')")

    con:query("insert into check_sql values(2398,'delete from transaction_total_check where cny = 2398 and jpy = 239800 and gbp = 1678.6 and eur = 266178 and  hkd = 2158.2','')")

    con:query("insert into check_sql values(2399,'delete from transaction_total_check where cny = 2399 and jpy = 239900 and gbp = 1679.3 and eur = 266289 and  hkd = 2159.1','')")

    con:query("insert into check_sql values(2400,'delete from transaction_total_check where cny = 2400 and jpy = 240000 and gbp = 1680.0 and eur = 266400 and  hkd = 2160.0','')")

    con:query("insert into check_sql values(2401,'delete from transaction_total_check where cny = 2401 and jpy = 240100 and gbp = 1680.7 and eur = 266511 and  hkd = 2160.9','')")

    con:query("insert into check_sql values(2402,'delete from transaction_total_check where cny = 2402 and jpy = 240200 and gbp = 1681.4 and eur = 266622 and  hkd = 2161.8','')")

    con:query("insert into check_sql values(2403,'delete from transaction_total_check where cny = 2403 and jpy = 240300 and gbp = 1682.1 and eur = 266733 and  hkd = 2162.7','')")

    con:query("insert into check_sql values(2404,'delete from transaction_total_check where cny = 2404 and jpy = 240400 and gbp = 1682.8 and eur = 266844 and  hkd = 2163.6','')")

    con:query("insert into check_sql values(2405,'delete from transaction_total_check where cny = 2405 and jpy = 240500 and gbp = 1683.5 and eur = 266955 and  hkd = 2164.5','')")

    con:query("insert into check_sql values(2406,'delete from transaction_total_check where cny = 2406 and jpy = 240600 and gbp = 1684.2 and eur = 267066 and  hkd = 2165.4','')")

    con:query("insert into check_sql values(2407,'delete from transaction_total_check where cny = 2407 and jpy = 240700 and gbp = 1684.9 and eur = 267177 and  hkd = 2166.3','')")

    con:query("insert into check_sql values(2408,'delete from transaction_total_check where cny = 2408 and jpy = 240800 and gbp = 1685.6 and eur = 267288 and  hkd = 2167.2','')")

    con:query("insert into check_sql values(2409,'delete from transaction_total_check where cny = 2409 and jpy = 240900 and gbp = 1686.3 and eur = 267399 and  hkd = 2168.1','')")

    con:query("insert into check_sql values(2410,'delete from transaction_total_check where cny = 2410 and jpy = 241000 and gbp = 1687.0 and eur = 267510 and  hkd = 2169.0','')")

    con:query("insert into check_sql values(2411,'delete from transaction_total_check where cny = 2411 and jpy = 241100 and gbp = 1687.7 and eur = 267621 and  hkd = 2169.9','')")

    con:query("insert into check_sql values(2412,'delete from transaction_total_check where cny = 2412 and jpy = 241200 and gbp = 1688.4 and eur = 267732 and  hkd = 2170.8','')")

    con:query("insert into check_sql values(2413,'delete from transaction_total_check where cny = 2413 and jpy = 241300 and gbp = 1689.1 and eur = 267843 and  hkd = 2171.7','')")

    con:query("insert into check_sql values(2414,'delete from transaction_total_check where cny = 2414 and jpy = 241400 and gbp = 1689.8 and eur = 267954 and  hkd = 2172.6','')")

    con:query("insert into check_sql values(2415,'delete from transaction_total_check where cny = 2415 and jpy = 241500 and gbp = 1690.5 and eur = 268065 and  hkd = 2173.5','')")

    con:query("insert into check_sql values(2416,'delete from transaction_total_check where cny = 2416 and jpy = 241600 and gbp = 1691.2 and eur = 268176 and  hkd = 2174.4','')")

    con:query("insert into check_sql values(2417,'delete from transaction_total_check where cny = 2417 and jpy = 241700 and gbp = 1691.9 and eur = 268287 and  hkd = 2175.3','')")

    con:query("insert into check_sql values(2418,'delete from transaction_total_check where cny = 2418 and jpy = 241800 and gbp = 1692.6 and eur = 268398 and  hkd = 2176.2','')")

    con:query("insert into check_sql values(2419,'delete from transaction_total_check where cny = 2419 and jpy = 241900 and gbp = 1693.3 and eur = 268509 and  hkd = 2177.1','')")

    con:query("insert into check_sql values(2420,'delete from transaction_total_check where cny = 2420 and jpy = 242000 and gbp = 1694.0 and eur = 268620 and  hkd = 2178.0','')")

    con:query("insert into check_sql values(2421,'delete from transaction_total_check where cny = 2421 and jpy = 242100 and gbp = 1694.7 and eur = 268731 and  hkd = 2178.9','')")

    con:query("insert into check_sql values(2422,'delete from transaction_total_check where cny = 2422 and jpy = 242200 and gbp = 1695.4 and eur = 268842 and  hkd = 2179.8','')")

    con:query("insert into check_sql values(2423,'delete from transaction_total_check where cny = 2423 and jpy = 242300 and gbp = 1696.1 and eur = 268953 and  hkd = 2180.7','')")

    con:query("insert into check_sql values(2424,'delete from transaction_total_check where cny = 2424 and jpy = 242400 and gbp = 1696.8 and eur = 269064 and  hkd = 2181.6','')")

    con:query("insert into check_sql values(2425,'delete from transaction_total_check where cny = 2425 and jpy = 242500 and gbp = 1697.5 and eur = 269175 and  hkd = 2182.5','')")

    con:query("insert into check_sql values(2426,'delete from transaction_total_check where cny = 2426 and jpy = 242600 and gbp = 1698.2 and eur = 269286 and  hkd = 2183.4','')")

    con:query("insert into check_sql values(2427,'delete from transaction_total_check where cny = 2427 and jpy = 242700 and gbp = 1698.9 and eur = 269397 and  hkd = 2184.3','')")

    con:query("insert into check_sql values(2428,'delete from transaction_total_check where cny = 2428 and jpy = 242800 and gbp = 1699.6 and eur = 269508 and  hkd = 2185.2','')")

    con:query("insert into check_sql values(2429,'delete from transaction_total_check where cny = 2429 and jpy = 242900 and gbp = 1700.3 and eur = 269619 and  hkd = 2186.1','')")

    con:query("insert into check_sql values(2430,'delete from transaction_total_check where cny = 2430 and jpy = 243000 and gbp = 1701.0 and eur = 269730 and  hkd = 2187.0','')")

    con:query("insert into check_sql values(2431,'delete from transaction_total_check where cny = 2431 and jpy = 243100 and gbp = 1701.7 and eur = 269841 and  hkd = 2187.9','')")

    con:query("insert into check_sql values(2432,'delete from transaction_total_check where cny = 2432 and jpy = 243200 and gbp = 1702.4 and eur = 269952 and  hkd = 2188.8','')")

    con:query("insert into check_sql values(2433,'delete from transaction_total_check where cny = 2433 and jpy = 243300 and gbp = 1703.1 and eur = 270063 and  hkd = 2189.7','')")

    con:query("insert into check_sql values(2434,'delete from transaction_total_check where cny = 2434 and jpy = 243400 and gbp = 1703.8 and eur = 270174 and  hkd = 2190.6','')")

    con:query("insert into check_sql values(2435,'delete from transaction_total_check where cny = 2435 and jpy = 243500 and gbp = 1704.5 and eur = 270285 and  hkd = 2191.5','')")

    con:query("insert into check_sql values(2436,'delete from transaction_total_check where cny = 2436 and jpy = 243600 and gbp = 1705.2 and eur = 270396 and  hkd = 2192.4','')")

    con:query("insert into check_sql values(2437,'delete from transaction_total_check where cny = 2437 and jpy = 243700 and gbp = 1705.9 and eur = 270507 and  hkd = 2193.3','')")

    con:query("insert into check_sql values(2438,'delete from transaction_total_check where cny = 2438 and jpy = 243800 and gbp = 1706.6 and eur = 270618 and  hkd = 2194.2','')")

    con:query("insert into check_sql values(2439,'delete from transaction_total_check where cny = 2439 and jpy = 243900 and gbp = 1707.3 and eur = 270729 and  hkd = 2195.1','')")

    con:query("insert into check_sql values(2440,'delete from transaction_total_check where cny = 2440 and jpy = 244000 and gbp = 1708.0 and eur = 270840 and  hkd = 2196.0','')")

    con:query("insert into check_sql values(2441,'delete from transaction_total_check where cny = 2441 and jpy = 244100 and gbp = 1708.7 and eur = 270951 and  hkd = 2196.9','')")

    con:query("insert into check_sql values(2442,'delete from transaction_total_check where cny = 2442 and jpy = 244200 and gbp = 1709.4 and eur = 271062 and  hkd = 2197.8','')")

    con:query("insert into check_sql values(2443,'delete from transaction_total_check where cny = 2443 and jpy = 244300 and gbp = 1710.1 and eur = 271173 and  hkd = 2198.7','')")

    con:query("insert into check_sql values(2444,'delete from transaction_total_check where cny = 2444 and jpy = 244400 and gbp = 1710.8 and eur = 271284 and  hkd = 2199.6','')")

    con:query("insert into check_sql values(2445,'delete from transaction_total_check where cny = 2445 and jpy = 244500 and gbp = 1711.5 and eur = 271395 and  hkd = 2200.5','')")

    con:query("insert into check_sql values(2446,'delete from transaction_total_check where cny = 2446 and jpy = 244600 and gbp = 1712.2 and eur = 271506 and  hkd = 2201.4','')")

    con:query("insert into check_sql values(2447,'delete from transaction_total_check where cny = 2447 and jpy = 244700 and gbp = 1712.9 and eur = 271617 and  hkd = 2202.3','')")

    con:query("insert into check_sql values(2448,'delete from transaction_total_check where cny = 2448 and jpy = 244800 and gbp = 1713.6 and eur = 271728 and  hkd = 2203.2','')")

    con:query("insert into check_sql values(2449,'delete from transaction_total_check where cny = 2449 and jpy = 244900 and gbp = 1714.3 and eur = 271839 and  hkd = 2204.1','')")

    con:query("insert into check_sql values(2450,'delete from transaction_total_check where cny = 2450 and jpy = 245000 and gbp = 1715.0 and eur = 271950 and  hkd = 2205.0','')")

    con:query("insert into check_sql values(2451,'delete from transaction_total_check where cny = 2451 and jpy = 245100 and gbp = 1715.7 and eur = 272061 and  hkd = 2205.9','')")

    con:query("insert into check_sql values(2452,'delete from transaction_total_check where cny = 2452 and jpy = 245200 and gbp = 1716.4 and eur = 272172 and  hkd = 2206.8','')")

    con:query("insert into check_sql values(2453,'delete from transaction_total_check where cny = 2453 and jpy = 245300 and gbp = 1717.1 and eur = 272283 and  hkd = 2207.7','')")

    con:query("insert into check_sql values(2454,'delete from transaction_total_check where cny = 2454 and jpy = 245400 and gbp = 1717.8 and eur = 272394 and  hkd = 2208.6','')")

    con:query("insert into check_sql values(2455,'delete from transaction_total_check where cny = 2455 and jpy = 245500 and gbp = 1718.5 and eur = 272505 and  hkd = 2209.5','')")

    con:query("insert into check_sql values(2456,'delete from transaction_total_check where cny = 2456 and jpy = 245600 and gbp = 1719.2 and eur = 272616 and  hkd = 2210.4','')")

    con:query("insert into check_sql values(2457,'delete from transaction_total_check where cny = 2457 and jpy = 245700 and gbp = 1719.9 and eur = 272727 and  hkd = 2211.3','')")

    con:query("insert into check_sql values(2458,'delete from transaction_total_check where cny = 2458 and jpy = 245800 and gbp = 1720.6 and eur = 272838 and  hkd = 2212.2','')")

    con:query("insert into check_sql values(2459,'delete from transaction_total_check where cny = 2459 and jpy = 245900 and gbp = 1721.3 and eur = 272949 and  hkd = 2213.1','')")

    con:query("insert into check_sql values(2460,'delete from transaction_total_check where cny = 2460 and jpy = 246000 and gbp = 1722.0 and eur = 273060 and  hkd = 2214.0','')")

    con:query("insert into check_sql values(2461,'delete from transaction_total_check where cny = 2461 and jpy = 246100 and gbp = 1722.7 and eur = 273171 and  hkd = 2214.9','')")

    con:query("insert into check_sql values(2462,'delete from transaction_total_check where cny = 2462 and jpy = 246200 and gbp = 1723.4 and eur = 273282 and  hkd = 2215.8','')")

    con:query("insert into check_sql values(2463,'delete from transaction_total_check where cny = 2463 and jpy = 246300 and gbp = 1724.1 and eur = 273393 and  hkd = 2216.7','')")

    con:query("insert into check_sql values(2464,'delete from transaction_total_check where cny = 2464 and jpy = 246400 and gbp = 1724.8 and eur = 273504 and  hkd = 2217.6','')")

    con:query("insert into check_sql values(2465,'delete from transaction_total_check where cny = 2465 and jpy = 246500 and gbp = 1725.5 and eur = 273615 and  hkd = 2218.5','')")

    con:query("insert into check_sql values(2466,'delete from transaction_total_check where cny = 2466 and jpy = 246600 and gbp = 1726.2 and eur = 273726 and  hkd = 2219.4','')")

    con:query("insert into check_sql values(2467,'delete from transaction_total_check where cny = 2467 and jpy = 246700 and gbp = 1726.9 and eur = 273837 and  hkd = 2220.3','')")

    con:query("insert into check_sql values(2468,'delete from transaction_total_check where cny = 2468 and jpy = 246800 and gbp = 1727.6 and eur = 273948 and  hkd = 2221.2','')")

    con:query("insert into check_sql values(2469,'delete from transaction_total_check where cny = 2469 and jpy = 246900 and gbp = 1728.3 and eur = 274059 and  hkd = 2222.1','')")

    con:query("insert into check_sql values(2470,'delete from transaction_total_check where cny = 2470 and jpy = 247000 and gbp = 1729.0 and eur = 274170 and  hkd = 2223.0','')")

    con:query("insert into check_sql values(2471,'delete from transaction_total_check where cny = 2471 and jpy = 247100 and gbp = 1729.7 and eur = 274281 and  hkd = 2223.9','')")

    con:query("insert into check_sql values(2472,'delete from transaction_total_check where cny = 2472 and jpy = 247200 and gbp = 1730.4 and eur = 274392 and  hkd = 2224.8','')")

    con:query("insert into check_sql values(2473,'delete from transaction_total_check where cny = 2473 and jpy = 247300 and gbp = 1731.1 and eur = 274503 and  hkd = 2225.7','')")

    con:query("insert into check_sql values(2474,'delete from transaction_total_check where cny = 2474 and jpy = 247400 and gbp = 1731.8 and eur = 274614 and  hkd = 2226.6','')")

    con:query("insert into check_sql values(2475,'delete from transaction_total_check where cny = 2475 and jpy = 247500 and gbp = 1732.5 and eur = 274725 and  hkd = 2227.5','')")

    con:query("insert into check_sql values(2476,'delete from transaction_total_check where cny = 2476 and jpy = 247600 and gbp = 1733.2 and eur = 274836 and  hkd = 2228.4','')")

    con:query("insert into check_sql values(2477,'delete from transaction_total_check where cny = 2477 and jpy = 247700 and gbp = 1733.9 and eur = 274947 and  hkd = 2229.3','')")

    con:query("insert into check_sql values(2478,'delete from transaction_total_check where cny = 2478 and jpy = 247800 and gbp = 1734.6 and eur = 275058 and  hkd = 2230.2','')")

    con:query("insert into check_sql values(2479,'delete from transaction_total_check where cny = 2479 and jpy = 247900 and gbp = 1735.3 and eur = 275169 and  hkd = 2231.1','')")

    con:query("insert into check_sql values(2480,'delete from transaction_total_check where cny = 2480 and jpy = 248000 and gbp = 1736.0 and eur = 275280 and  hkd = 2232.0','')")

    con:query("insert into check_sql values(2481,'delete from transaction_total_check where cny = 2481 and jpy = 248100 and gbp = 1736.7 and eur = 275391 and  hkd = 2232.9','')")

    con:query("insert into check_sql values(2482,'delete from transaction_total_check where cny = 2482 and jpy = 248200 and gbp = 1737.4 and eur = 275502 and  hkd = 2233.8','')")

    con:query("insert into check_sql values(2483,'delete from transaction_total_check where cny = 2483 and jpy = 248300 and gbp = 1738.1 and eur = 275613 and  hkd = 2234.7','')")

    con:query("insert into check_sql values(2484,'delete from transaction_total_check where cny = 2484 and jpy = 248400 and gbp = 1738.8 and eur = 275724 and  hkd = 2235.6','')")

    con:query("insert into check_sql values(2485,'delete from transaction_total_check where cny = 2485 and jpy = 248500 and gbp = 1739.5 and eur = 275835 and  hkd = 2236.5','')")

    con:query("insert into check_sql values(2486,'delete from transaction_total_check where cny = 2486 and jpy = 248600 and gbp = 1740.2 and eur = 275946 and  hkd = 2237.4','')")

    con:query("insert into check_sql values(2487,'delete from transaction_total_check where cny = 2487 and jpy = 248700 and gbp = 1740.9 and eur = 276057 and  hkd = 2238.3','')")

    con:query("insert into check_sql values(2488,'delete from transaction_total_check where cny = 2488 and jpy = 248800 and gbp = 1741.6 and eur = 276168 and  hkd = 2239.2','')")

    con:query("insert into check_sql values(2489,'delete from transaction_total_check where cny = 2489 and jpy = 248900 and gbp = 1742.3 and eur = 276279 and  hkd = 2240.1','')")

    con:query("insert into check_sql values(2490,'delete from transaction_total_check where cny = 2490 and jpy = 249000 and gbp = 1743.0 and eur = 276390 and  hkd = 2241.0','')")

    con:query("insert into check_sql values(2491,'delete from transaction_total_check where cny = 2491 and jpy = 249100 and gbp = 1743.7 and eur = 276501 and  hkd = 2241.9','')")

    con:query("insert into check_sql values(2492,'delete from transaction_total_check where cny = 2492 and jpy = 249200 and gbp = 1744.4 and eur = 276612 and  hkd = 2242.8','')")

    con:query("insert into check_sql values(2493,'delete from transaction_total_check where cny = 2493 and jpy = 249300 and gbp = 1745.1 and eur = 276723 and  hkd = 2243.7','')")

    con:query("insert into check_sql values(2494,'delete from transaction_total_check where cny = 2494 and jpy = 249400 and gbp = 1745.8 and eur = 276834 and  hkd = 2244.6','')")

    con:query("insert into check_sql values(2495,'delete from transaction_total_check where cny = 2495 and jpy = 249500 and gbp = 1746.5 and eur = 276945 and  hkd = 2245.5','')")

    con:query("insert into check_sql values(2496,'delete from transaction_total_check where cny = 2496 and jpy = 249600 and gbp = 1747.2 and eur = 277056 and  hkd = 2246.4','')")

    con:query("insert into check_sql values(2497,'delete from transaction_total_check where cny = 2497 and jpy = 249700 and gbp = 1747.9 and eur = 277167 and  hkd = 2247.3','')")

    con:query("insert into check_sql values(2498,'delete from transaction_total_check where cny = 2498 and jpy = 249800 and gbp = 1748.6 and eur = 277278 and  hkd = 2248.2','')")

    con:query("insert into check_sql values(2499,'delete from transaction_total_check where cny = 2499 and jpy = 249900 and gbp = 1749.3 and eur = 277389 and  hkd = 2249.1','')")

    con:query("insert into check_sql values(2500,'delete from transaction_total_check where cny = 2500 and jpy = 250000 and gbp = 1750.0 and eur = 277500 and  hkd = 2250.0','')")

    con:query("insert into check_sql values(2501,'delete from transaction_total_check where cny = 2501 and jpy = 250100 and gbp = 1750.7 and eur = 277611 and  hkd = 2250.9','')")

    con:query("insert into check_sql values(2502,'delete from transaction_total_check where cny = 2502 and jpy = 250200 and gbp = 1751.4 and eur = 277722 and  hkd = 2251.8','')")

    con:query("insert into check_sql values(2503,'delete from transaction_total_check where cny = 2503 and jpy = 250300 and gbp = 1752.1 and eur = 277833 and  hkd = 2252.7','')")

    con:query("insert into check_sql values(2504,'delete from transaction_total_check where cny = 2504 and jpy = 250400 and gbp = 1752.8 and eur = 277944 and  hkd = 2253.6','')")

    con:query("insert into check_sql values(2505,'delete from transaction_total_check where cny = 2505 and jpy = 250500 and gbp = 1753.5 and eur = 278055 and  hkd = 2254.5','')")

    con:query("insert into check_sql values(2506,'delete from transaction_total_check where cny = 2506 and jpy = 250600 and gbp = 1754.2 and eur = 278166 and  hkd = 2255.4','')")

    con:query("insert into check_sql values(2507,'delete from transaction_total_check where cny = 2507 and jpy = 250700 and gbp = 1754.9 and eur = 278277 and  hkd = 2256.3','')")

    con:query("insert into check_sql values(2508,'delete from transaction_total_check where cny = 2508 and jpy = 250800 and gbp = 1755.6 and eur = 278388 and  hkd = 2257.2','')")

    con:query("insert into check_sql values(2509,'delete from transaction_total_check where cny = 2509 and jpy = 250900 and gbp = 1756.3 and eur = 278499 and  hkd = 2258.1','')")

    con:query("insert into check_sql values(2510,'delete from transaction_total_check where cny = 2510 and jpy = 251000 and gbp = 1757.0 and eur = 278610 and  hkd = 2259.0','')")

    con:query("insert into check_sql values(2511,'delete from transaction_total_check where cny = 2511 and jpy = 251100 and gbp = 1757.7 and eur = 278721 and  hkd = 2259.9','')")

    con:query("insert into check_sql values(2512,'delete from transaction_total_check where cny = 2512 and jpy = 251200 and gbp = 1758.4 and eur = 278832 and  hkd = 2260.8','')")

    con:query("insert into check_sql values(2513,'delete from transaction_total_check where cny = 2513 and jpy = 251300 and gbp = 1759.1 and eur = 278943 and  hkd = 2261.7','')")

    con:query("insert into check_sql values(2514,'delete from transaction_total_check where cny = 2514 and jpy = 251400 and gbp = 1759.8 and eur = 279054 and  hkd = 2262.6','')")

    con:query("insert into check_sql values(2515,'delete from transaction_total_check where cny = 2515 and jpy = 251500 and gbp = 1760.5 and eur = 279165 and  hkd = 2263.5','')")

    con:query("insert into check_sql values(2516,'delete from transaction_total_check where cny = 2516 and jpy = 251600 and gbp = 1761.2 and eur = 279276 and  hkd = 2264.4','')")

    con:query("insert into check_sql values(2517,'delete from transaction_total_check where cny = 2517 and jpy = 251700 and gbp = 1761.9 and eur = 279387 and  hkd = 2265.3','')")

    con:query("insert into check_sql values(2518,'delete from transaction_total_check where cny = 2518 and jpy = 251800 and gbp = 1762.6 and eur = 279498 and  hkd = 2266.2','')")

    con:query("insert into check_sql values(2519,'delete from transaction_total_check where cny = 2519 and jpy = 251900 and gbp = 1763.3 and eur = 279609 and  hkd = 2267.1','')")

    con:query("insert into check_sql values(2520,'delete from transaction_total_check where cny = 2520 and jpy = 252000 and gbp = 1764.0 and eur = 279720 and  hkd = 2268.0','')")

    con:query("insert into check_sql values(2521,'delete from transaction_total_check where cny = 2521 and jpy = 252100 and gbp = 1764.7 and eur = 279831 and  hkd = 2268.9','')")

    con:query("insert into check_sql values(2522,'delete from transaction_total_check where cny = 2522 and jpy = 252200 and gbp = 1765.4 and eur = 279942 and  hkd = 2269.8','')")

    con:query("insert into check_sql values(2523,'delete from transaction_total_check where cny = 2523 and jpy = 252300 and gbp = 1766.1 and eur = 280053 and  hkd = 2270.7','')")

    con:query("insert into check_sql values(2524,'delete from transaction_total_check where cny = 2524 and jpy = 252400 and gbp = 1766.8 and eur = 280164 and  hkd = 2271.6','')")

    con:query("insert into check_sql values(2525,'delete from transaction_total_check where cny = 2525 and jpy = 252500 and gbp = 1767.5 and eur = 280275 and  hkd = 2272.5','')")

    con:query("insert into check_sql values(2526,'delete from transaction_total_check where cny = 2526 and jpy = 252600 and gbp = 1768.2 and eur = 280386 and  hkd = 2273.4','')")

    con:query("insert into check_sql values(2527,'delete from transaction_total_check where cny = 2527 and jpy = 252700 and gbp = 1768.9 and eur = 280497 and  hkd = 2274.3','')")

    con:query("insert into check_sql values(2528,'delete from transaction_total_check where cny = 2528 and jpy = 252800 and gbp = 1769.6 and eur = 280608 and  hkd = 2275.2','')")

    con:query("insert into check_sql values(2529,'delete from transaction_total_check where cny = 2529 and jpy = 252900 and gbp = 1770.3 and eur = 280719 and  hkd = 2276.1','')")

    con:query("insert into check_sql values(2530,'delete from transaction_total_check where cny = 2530 and jpy = 253000 and gbp = 1771.0 and eur = 280830 and  hkd = 2277.0','')")

    con:query("insert into check_sql values(2531,'delete from transaction_total_check where cny = 2531 and jpy = 253100 and gbp = 1771.7 and eur = 280941 and  hkd = 2277.9','')")

    con:query("insert into check_sql values(2532,'delete from transaction_total_check where cny = 2532 and jpy = 253200 and gbp = 1772.4 and eur = 281052 and  hkd = 2278.8','')")

    con:query("insert into check_sql values(2533,'delete from transaction_total_check where cny = 2533 and jpy = 253300 and gbp = 1773.1 and eur = 281163 and  hkd = 2279.7','')")

    con:query("insert into check_sql values(2534,'delete from transaction_total_check where cny = 2534 and jpy = 253400 and gbp = 1773.8 and eur = 281274 and  hkd = 2280.6','')")

    con:query("insert into check_sql values(2535,'delete from transaction_total_check where cny = 2535 and jpy = 253500 and gbp = 1774.5 and eur = 281385 and  hkd = 2281.5','')")

    con:query("insert into check_sql values(2536,'delete from transaction_total_check where cny = 2536 and jpy = 253600 and gbp = 1775.2 and eur = 281496 and  hkd = 2282.4','')")

    con:query("insert into check_sql values(2537,'delete from transaction_total_check where cny = 2537 and jpy = 253700 and gbp = 1775.9 and eur = 281607 and  hkd = 2283.3','')")

    con:query("insert into check_sql values(2538,'delete from transaction_total_check where cny = 2538 and jpy = 253800 and gbp = 1776.6 and eur = 281718 and  hkd = 2284.2','')")

    con:query("insert into check_sql values(2539,'delete from transaction_total_check where cny = 2539 and jpy = 253900 and gbp = 1777.3 and eur = 281829 and  hkd = 2285.1','')")

    con:query("insert into check_sql values(2540,'delete from transaction_total_check where cny = 2540 and jpy = 254000 and gbp = 1778.0 and eur = 281940 and  hkd = 2286.0','')")

    con:query("insert into check_sql values(2541,'delete from transaction_total_check where cny = 2541 and jpy = 254100 and gbp = 1778.7 and eur = 282051 and  hkd = 2286.9','')")

    con:query("insert into check_sql values(2542,'delete from transaction_total_check where cny = 2542 and jpy = 254200 and gbp = 1779.4 and eur = 282162 and  hkd = 2287.8','')")

    con:query("insert into check_sql values(2543,'delete from transaction_total_check where cny = 2543 and jpy = 254300 and gbp = 1780.1 and eur = 282273 and  hkd = 2288.7','')")

    con:query("insert into check_sql values(2544,'delete from transaction_total_check where cny = 2544 and jpy = 254400 and gbp = 1780.8 and eur = 282384 and  hkd = 2289.6','')")

    con:query("insert into check_sql values(2545,'delete from transaction_total_check where cny = 2545 and jpy = 254500 and gbp = 1781.5 and eur = 282495 and  hkd = 2290.5','')")

    con:query("insert into check_sql values(2546,'delete from transaction_total_check where cny = 2546 and jpy = 254600 and gbp = 1782.2 and eur = 282606 and  hkd = 2291.4','')")

    con:query("insert into check_sql values(2547,'delete from transaction_total_check where cny = 2547 and jpy = 254700 and gbp = 1782.9 and eur = 282717 and  hkd = 2292.3','')")

    con:query("insert into check_sql values(2548,'delete from transaction_total_check where cny = 2548 and jpy = 254800 and gbp = 1783.6 and eur = 282828 and  hkd = 2293.2','')")

    con:query("insert into check_sql values(2549,'delete from transaction_total_check where cny = 2549 and jpy = 254900 and gbp = 1784.3 and eur = 282939 and  hkd = 2294.1','')")

    con:query("insert into check_sql values(2550,'delete from transaction_total_check where cny = 2550 and jpy = 255000 and gbp = 1785.0 and eur = 283050 and  hkd = 2295.0','')")

    con:query("insert into check_sql values(2551,'delete from transaction_total_check where cny = 2551 and jpy = 255100 and gbp = 1785.7 and eur = 283161 and  hkd = 2295.9','')")

    con:query("insert into check_sql values(2552,'delete from transaction_total_check where cny = 2552 and jpy = 255200 and gbp = 1786.4 and eur = 283272 and  hkd = 2296.8','')")

    con:query("insert into check_sql values(2553,'delete from transaction_total_check where cny = 2553 and jpy = 255300 and gbp = 1787.1 and eur = 283383 and  hkd = 2297.7','')")

    con:query("insert into check_sql values(2554,'delete from transaction_total_check where cny = 2554 and jpy = 255400 and gbp = 1787.8 and eur = 283494 and  hkd = 2298.6','')")

    con:query("insert into check_sql values(2555,'delete from transaction_total_check where cny = 2555 and jpy = 255500 and gbp = 1788.5 and eur = 283605 and  hkd = 2299.5','')")

    con:query("insert into check_sql values(2556,'delete from transaction_total_check where cny = 2556 and jpy = 255600 and gbp = 1789.2 and eur = 283716 and  hkd = 2300.4','')")

    con:query("insert into check_sql values(2557,'delete from transaction_total_check where cny = 2557 and jpy = 255700 and gbp = 1789.9 and eur = 283827 and  hkd = 2301.3','')")

    con:query("insert into check_sql values(2558,'delete from transaction_total_check where cny = 2558 and jpy = 255800 and gbp = 1790.6 and eur = 283938 and  hkd = 2302.2','')")

    con:query("insert into check_sql values(2559,'delete from transaction_total_check where cny = 2559 and jpy = 255900 and gbp = 1791.3 and eur = 284049 and  hkd = 2303.1','')")

    con:query("insert into check_sql values(2560,'delete from transaction_total_check where cny = 2560 and jpy = 256000 and gbp = 1792.0 and eur = 284160 and  hkd = 2304.0','')")

    con:query("insert into check_sql values(2561,'delete from transaction_total_check where cny = 2561 and jpy = 256100 and gbp = 1792.7 and eur = 284271 and  hkd = 2304.9','')")

    con:query("insert into check_sql values(2562,'delete from transaction_total_check where cny = 2562 and jpy = 256200 and gbp = 1793.4 and eur = 284382 and  hkd = 2305.8','')")

    con:query("insert into check_sql values(2563,'delete from transaction_total_check where cny = 2563 and jpy = 256300 and gbp = 1794.1 and eur = 284493 and  hkd = 2306.7','')")

    con:query("insert into check_sql values(2564,'delete from transaction_total_check where cny = 2564 and jpy = 256400 and gbp = 1794.8 and eur = 284604 and  hkd = 2307.6','')")

    con:query("insert into check_sql values(2565,'delete from transaction_total_check where cny = 2565 and jpy = 256500 and gbp = 1795.5 and eur = 284715 and  hkd = 2308.5','')")

    con:query("insert into check_sql values(2566,'delete from transaction_total_check where cny = 2566 and jpy = 256600 and gbp = 1796.2 and eur = 284826 and  hkd = 2309.4','')")

    con:query("insert into check_sql values(2567,'delete from transaction_total_check where cny = 2567 and jpy = 256700 and gbp = 1796.9 and eur = 284937 and  hkd = 2310.3','')")

    con:query("insert into check_sql values(2568,'delete from transaction_total_check where cny = 2568 and jpy = 256800 and gbp = 1797.6 and eur = 285048 and  hkd = 2311.2','')")

    con:query("insert into check_sql values(2569,'delete from transaction_total_check where cny = 2569 and jpy = 256900 and gbp = 1798.3 and eur = 285159 and  hkd = 2312.1','')")

    con:query("insert into check_sql values(2570,'delete from transaction_total_check where cny = 2570 and jpy = 257000 and gbp = 1799.0 and eur = 285270 and  hkd = 2313.0','')")

    con:query("insert into check_sql values(2571,'delete from transaction_total_check where cny = 2571 and jpy = 257100 and gbp = 1799.7 and eur = 285381 and  hkd = 2313.9','')")

    con:query("insert into check_sql values(2572,'delete from transaction_total_check where cny = 2572 and jpy = 257200 and gbp = 1800.4 and eur = 285492 and  hkd = 2314.8','')")

    con:query("insert into check_sql values(2573,'delete from transaction_total_check where cny = 2573 and jpy = 257300 and gbp = 1801.1 and eur = 285603 and  hkd = 2315.7','')")

    con:query("insert into check_sql values(2574,'delete from transaction_total_check where cny = 2574 and jpy = 257400 and gbp = 1801.8 and eur = 285714 and  hkd = 2316.6','')")

    con:query("insert into check_sql values(2575,'delete from transaction_total_check where cny = 2575 and jpy = 257500 and gbp = 1802.5 and eur = 285825 and  hkd = 2317.5','')")

    con:query("insert into check_sql values(2576,'delete from transaction_total_check where cny = 2576 and jpy = 257600 and gbp = 1803.2 and eur = 285936 and  hkd = 2318.4','')")

    con:query("insert into check_sql values(2577,'delete from transaction_total_check where cny = 2577 and jpy = 257700 and gbp = 1803.9 and eur = 286047 and  hkd = 2319.3','')")

    con:query("insert into check_sql values(2578,'delete from transaction_total_check where cny = 2578 and jpy = 257800 and gbp = 1804.6 and eur = 286158 and  hkd = 2320.2','')")

    con:query("insert into check_sql values(2579,'delete from transaction_total_check where cny = 2579 and jpy = 257900 and gbp = 1805.3 and eur = 286269 and  hkd = 2321.1','')")

    con:query("insert into check_sql values(2580,'delete from transaction_total_check where cny = 2580 and jpy = 258000 and gbp = 1806.0 and eur = 286380 and  hkd = 2322.0','')")

    con:query("insert into check_sql values(2581,'delete from transaction_total_check where cny = 2581 and jpy = 258100 and gbp = 1806.7 and eur = 286491 and  hkd = 2322.9','')")

    con:query("insert into check_sql values(2582,'delete from transaction_total_check where cny = 2582 and jpy = 258200 and gbp = 1807.4 and eur = 286602 and  hkd = 2323.8','')")

    con:query("insert into check_sql values(2583,'delete from transaction_total_check where cny = 2583 and jpy = 258300 and gbp = 1808.1 and eur = 286713 and  hkd = 2324.7','')")

    con:query("insert into check_sql values(2584,'delete from transaction_total_check where cny = 2584 and jpy = 258400 and gbp = 1808.8 and eur = 286824 and  hkd = 2325.6','')")

    con:query("insert into check_sql values(2585,'delete from transaction_total_check where cny = 2585 and jpy = 258500 and gbp = 1809.5 and eur = 286935 and  hkd = 2326.5','')")

    con:query("insert into check_sql values(2586,'delete from transaction_total_check where cny = 2586 and jpy = 258600 and gbp = 1810.2 and eur = 287046 and  hkd = 2327.4','')")

    con:query("insert into check_sql values(2587,'delete from transaction_total_check where cny = 2587 and jpy = 258700 and gbp = 1810.9 and eur = 287157 and  hkd = 2328.3','')")

    con:query("insert into check_sql values(2588,'delete from transaction_total_check where cny = 2588 and jpy = 258800 and gbp = 1811.6 and eur = 287268 and  hkd = 2329.2','')")

    con:query("insert into check_sql values(2589,'delete from transaction_total_check where cny = 2589 and jpy = 258900 and gbp = 1812.3 and eur = 287379 and  hkd = 2330.1','')")

    con:query("insert into check_sql values(2590,'delete from transaction_total_check where cny = 2590 and jpy = 259000 and gbp = 1813.0 and eur = 287490 and  hkd = 2331.0','')")

    con:query("insert into check_sql values(2591,'delete from transaction_total_check where cny = 2591 and jpy = 259100 and gbp = 1813.7 and eur = 287601 and  hkd = 2331.9','')")

    con:query("insert into check_sql values(2592,'delete from transaction_total_check where cny = 2592 and jpy = 259200 and gbp = 1814.4 and eur = 287712 and  hkd = 2332.8','')")

    con:query("insert into check_sql values(2593,'delete from transaction_total_check where cny = 2593 and jpy = 259300 and gbp = 1815.1 and eur = 287823 and  hkd = 2333.7','')")

    con:query("insert into check_sql values(2594,'delete from transaction_total_check where cny = 2594 and jpy = 259400 and gbp = 1815.8 and eur = 287934 and  hkd = 2334.6','')")

    con:query("insert into check_sql values(2595,'delete from transaction_total_check where cny = 2595 and jpy = 259500 and gbp = 1816.5 and eur = 288045 and  hkd = 2335.5','')")

    con:query("insert into check_sql values(2596,'delete from transaction_total_check where cny = 2596 and jpy = 259600 and gbp = 1817.2 and eur = 288156 and  hkd = 2336.4','')")

    con:query("insert into check_sql values(2597,'delete from transaction_total_check where cny = 2597 and jpy = 259700 and gbp = 1817.9 and eur = 288267 and  hkd = 2337.3','')")

    con:query("insert into check_sql values(2598,'delete from transaction_total_check where cny = 2598 and jpy = 259800 and gbp = 1818.6 and eur = 288378 and  hkd = 2338.2','')")

    con:query("insert into check_sql values(2599,'delete from transaction_total_check where cny = 2599 and jpy = 259900 and gbp = 1819.3 and eur = 288489 and  hkd = 2339.1','')")

    con:query("insert into check_sql values(2600,'delete from transaction_total_check where cny = 2600 and jpy = 260000 and gbp = 1820.0 and eur = 288600 and  hkd = 2340.0','')")

    con:query("insert into check_sql values(2601,'delete from transaction_total_check where cny = 2601 and jpy = 260100 and gbp = 1820.7 and eur = 288711 and  hkd = 2340.9','')")

    con:query("insert into check_sql values(2602,'delete from transaction_total_check where cny = 2602 and jpy = 260200 and gbp = 1821.4 and eur = 288822 and  hkd = 2341.8','')")

    con:query("insert into check_sql values(2603,'delete from transaction_total_check where cny = 2603 and jpy = 260300 and gbp = 1822.1 and eur = 288933 and  hkd = 2342.7','')")

    con:query("insert into check_sql values(2604,'delete from transaction_total_check where cny = 2604 and jpy = 260400 and gbp = 1822.8 and eur = 289044 and  hkd = 2343.6','')")

    con:query("insert into check_sql values(2605,'delete from transaction_total_check where cny = 2605 and jpy = 260500 and gbp = 1823.5 and eur = 289155 and  hkd = 2344.5','')")

    con:query("insert into check_sql values(2606,'delete from transaction_total_check where cny = 2606 and jpy = 260600 and gbp = 1824.2 and eur = 289266 and  hkd = 2345.4','')")

    con:query("insert into check_sql values(2607,'delete from transaction_total_check where cny = 2607 and jpy = 260700 and gbp = 1824.9 and eur = 289377 and  hkd = 2346.3','')")

    con:query("insert into check_sql values(2608,'delete from transaction_total_check where cny = 2608 and jpy = 260800 and gbp = 1825.6 and eur = 289488 and  hkd = 2347.2','')")

    con:query("insert into check_sql values(2609,'delete from transaction_total_check where cny = 2609 and jpy = 260900 and gbp = 1826.3 and eur = 289599 and  hkd = 2348.1','')")

    con:query("insert into check_sql values(2610,'delete from transaction_total_check where cny = 2610 and jpy = 261000 and gbp = 1827.0 and eur = 289710 and  hkd = 2349.0','')")

    con:query("insert into check_sql values(2611,'delete from transaction_total_check where cny = 2611 and jpy = 261100 and gbp = 1827.7 and eur = 289821 and  hkd = 2349.9','')")

    con:query("insert into check_sql values(2612,'delete from transaction_total_check where cny = 2612 and jpy = 261200 and gbp = 1828.4 and eur = 289932 and  hkd = 2350.8','')")

    con:query("insert into check_sql values(2613,'delete from transaction_total_check where cny = 2613 and jpy = 261300 and gbp = 1829.1 and eur = 290043 and  hkd = 2351.7','')")

    con:query("insert into check_sql values(2614,'delete from transaction_total_check where cny = 2614 and jpy = 261400 and gbp = 1829.8 and eur = 290154 and  hkd = 2352.6','')")

    con:query("insert into check_sql values(2615,'delete from transaction_total_check where cny = 2615 and jpy = 261500 and gbp = 1830.5 and eur = 290265 and  hkd = 2353.5','')")

    con:query("insert into check_sql values(2616,'delete from transaction_total_check where cny = 2616 and jpy = 261600 and gbp = 1831.2 and eur = 290376 and  hkd = 2354.4','')")

    con:query("insert into check_sql values(2617,'delete from transaction_total_check where cny = 2617 and jpy = 261700 and gbp = 1831.9 and eur = 290487 and  hkd = 2355.3','')")

    con:query("insert into check_sql values(2618,'delete from transaction_total_check where cny = 2618 and jpy = 261800 and gbp = 1832.6 and eur = 290598 and  hkd = 2356.2','')")

    con:query("insert into check_sql values(2619,'delete from transaction_total_check where cny = 2619 and jpy = 261900 and gbp = 1833.3 and eur = 290709 and  hkd = 2357.1','')")

    con:query("insert into check_sql values(2620,'delete from transaction_total_check where cny = 2620 and jpy = 262000 and gbp = 1834.0 and eur = 290820 and  hkd = 2358.0','')")

    con:query("insert into check_sql values(2621,'delete from transaction_total_check where cny = 2621 and jpy = 262100 and gbp = 1834.7 and eur = 290931 and  hkd = 2358.9','')")

    con:query("insert into check_sql values(2622,'delete from transaction_total_check where cny = 2622 and jpy = 262200 and gbp = 1835.4 and eur = 291042 and  hkd = 2359.8','')")

    con:query("insert into check_sql values(2623,'delete from transaction_total_check where cny = 2623 and jpy = 262300 and gbp = 1836.1 and eur = 291153 and  hkd = 2360.7','')")

    con:query("insert into check_sql values(2624,'delete from transaction_total_check where cny = 2624 and jpy = 262400 and gbp = 1836.8 and eur = 291264 and  hkd = 2361.6','')")

    con:query("insert into check_sql values(2625,'delete from transaction_total_check where cny = 2625 and jpy = 262500 and gbp = 1837.5 and eur = 291375 and  hkd = 2362.5','')")

    con:query("insert into check_sql values(2626,'delete from transaction_total_check where cny = 2626 and jpy = 262600 and gbp = 1838.2 and eur = 291486 and  hkd = 2363.4','')")

    con:query("insert into check_sql values(2627,'delete from transaction_total_check where cny = 2627 and jpy = 262700 and gbp = 1838.9 and eur = 291597 and  hkd = 2364.3','')")

    con:query("insert into check_sql values(2628,'delete from transaction_total_check where cny = 2628 and jpy = 262800 and gbp = 1839.6 and eur = 291708 and  hkd = 2365.2','')")

    con:query("insert into check_sql values(2629,'delete from transaction_total_check where cny = 2629 and jpy = 262900 and gbp = 1840.3 and eur = 291819 and  hkd = 2366.1','')")

    con:query("insert into check_sql values(2630,'delete from transaction_total_check where cny = 2630 and jpy = 263000 and gbp = 1841.0 and eur = 291930 and  hkd = 2367.0','')")

    con:query("insert into check_sql values(2631,'delete from transaction_total_check where cny = 2631 and jpy = 263100 and gbp = 1841.7 and eur = 292041 and  hkd = 2367.9','')")

    con:query("insert into check_sql values(2632,'delete from transaction_total_check where cny = 2632 and jpy = 263200 and gbp = 1842.4 and eur = 292152 and  hkd = 2368.8','')")

    con:query("insert into check_sql values(2633,'delete from transaction_total_check where cny = 2633 and jpy = 263300 and gbp = 1843.1 and eur = 292263 and  hkd = 2369.7','')")

    con:query("insert into check_sql values(2634,'delete from transaction_total_check where cny = 2634 and jpy = 263400 and gbp = 1843.8 and eur = 292374 and  hkd = 2370.6','')")

    con:query("insert into check_sql values(2635,'delete from transaction_total_check where cny = 2635 and jpy = 263500 and gbp = 1844.5 and eur = 292485 and  hkd = 2371.5','')")

    con:query("insert into check_sql values(2636,'delete from transaction_total_check where cny = 2636 and jpy = 263600 and gbp = 1845.2 and eur = 292596 and  hkd = 2372.4','')")

    con:query("insert into check_sql values(2637,'delete from transaction_total_check where cny = 2637 and jpy = 263700 and gbp = 1845.9 and eur = 292707 and  hkd = 2373.3','')")

    con:query("insert into check_sql values(2638,'delete from transaction_total_check where cny = 2638 and jpy = 263800 and gbp = 1846.6 and eur = 292818 and  hkd = 2374.2','')")

    con:query("insert into check_sql values(2639,'delete from transaction_total_check where cny = 2639 and jpy = 263900 and gbp = 1847.3 and eur = 292929 and  hkd = 2375.1','')")

    con:query("insert into check_sql values(2640,'delete from transaction_total_check where cny = 2640 and jpy = 264000 and gbp = 1848.0 and eur = 293040 and  hkd = 2376.0','')")

    con:query("insert into check_sql values(2641,'delete from transaction_total_check where cny = 2641 and jpy = 264100 and gbp = 1848.7 and eur = 293151 and  hkd = 2376.9','')")

    con:query("insert into check_sql values(2642,'delete from transaction_total_check where cny = 2642 and jpy = 264200 and gbp = 1849.4 and eur = 293262 and  hkd = 2377.8','')")

    con:query("insert into check_sql values(2643,'delete from transaction_total_check where cny = 2643 and jpy = 264300 and gbp = 1850.1 and eur = 293373 and  hkd = 2378.7','')")

    con:query("insert into check_sql values(2644,'delete from transaction_total_check where cny = 2644 and jpy = 264400 and gbp = 1850.8 and eur = 293484 and  hkd = 2379.6','')")

    con:query("insert into check_sql values(2645,'delete from transaction_total_check where cny = 2645 and jpy = 264500 and gbp = 1851.5 and eur = 293595 and  hkd = 2380.5','')")

    con:query("insert into check_sql values(2646,'delete from transaction_total_check where cny = 2646 and jpy = 264600 and gbp = 1852.2 and eur = 293706 and  hkd = 2381.4','')")

    con:query("insert into check_sql values(2647,'delete from transaction_total_check where cny = 2647 and jpy = 264700 and gbp = 1852.9 and eur = 293817 and  hkd = 2382.3','')")

    con:query("insert into check_sql values(2648,'delete from transaction_total_check where cny = 2648 and jpy = 264800 and gbp = 1853.6 and eur = 293928 and  hkd = 2383.2','')")

    con:query("insert into check_sql values(2649,'delete from transaction_total_check where cny = 2649 and jpy = 264900 and gbp = 1854.3 and eur = 294039 and  hkd = 2384.1','')")

    con:query("insert into check_sql values(2650,'delete from transaction_total_check where cny = 2650 and jpy = 265000 and gbp = 1855.0 and eur = 294150 and  hkd = 2385.0','')")

    con:query("insert into check_sql values(2651,'delete from transaction_total_check where cny = 2651 and jpy = 265100 and gbp = 1855.7 and eur = 294261 and  hkd = 2385.9','')")

    con:query("insert into check_sql values(2652,'delete from transaction_total_check where cny = 2652 and jpy = 265200 and gbp = 1856.4 and eur = 294372 and  hkd = 2386.8','')")

    con:query("insert into check_sql values(2653,'delete from transaction_total_check where cny = 2653 and jpy = 265300 and gbp = 1857.1 and eur = 294483 and  hkd = 2387.7','')")

    con:query("insert into check_sql values(2654,'delete from transaction_total_check where cny = 2654 and jpy = 265400 and gbp = 1857.8 and eur = 294594 and  hkd = 2388.6','')")

    con:query("insert into check_sql values(2655,'delete from transaction_total_check where cny = 2655 and jpy = 265500 and gbp = 1858.5 and eur = 294705 and  hkd = 2389.5','')")

    con:query("insert into check_sql values(2656,'delete from transaction_total_check where cny = 2656 and jpy = 265600 and gbp = 1859.2 and eur = 294816 and  hkd = 2390.4','')")

    con:query("insert into check_sql values(2657,'delete from transaction_total_check where cny = 2657 and jpy = 265700 and gbp = 1859.9 and eur = 294927 and  hkd = 2391.3','')")

    con:query("insert into check_sql values(2658,'delete from transaction_total_check where cny = 2658 and jpy = 265800 and gbp = 1860.6 and eur = 295038 and  hkd = 2392.2','')")

    con:query("insert into check_sql values(2659,'delete from transaction_total_check where cny = 2659 and jpy = 265900 and gbp = 1861.3 and eur = 295149 and  hkd = 2393.1','')")

    con:query("insert into check_sql values(2660,'delete from transaction_total_check where cny = 2660 and jpy = 266000 and gbp = 1862.0 and eur = 295260 and  hkd = 2394.0','')")

    con:query("insert into check_sql values(2661,'delete from transaction_total_check where cny = 2661 and jpy = 266100 and gbp = 1862.7 and eur = 295371 and  hkd = 2394.9','')")

    con:query("insert into check_sql values(2662,'delete from transaction_total_check where cny = 2662 and jpy = 266200 and gbp = 1863.4 and eur = 295482 and  hkd = 2395.8','')")

    con:query("insert into check_sql values(2663,'delete from transaction_total_check where cny = 2663 and jpy = 266300 and gbp = 1864.1 and eur = 295593 and  hkd = 2396.7','')")

    con:query("insert into check_sql values(2664,'delete from transaction_total_check where cny = 2664 and jpy = 266400 and gbp = 1864.8 and eur = 295704 and  hkd = 2397.6','')")

    con:query("insert into check_sql values(2665,'delete from transaction_total_check where cny = 2665 and jpy = 266500 and gbp = 1865.5 and eur = 295815 and  hkd = 2398.5','')")

    con:query("insert into check_sql values(2666,'delete from transaction_total_check where cny = 2666 and jpy = 266600 and gbp = 1866.2 and eur = 295926 and  hkd = 2399.4','')")

    con:query("insert into check_sql values(2667,'delete from transaction_total_check where cny = 2667 and jpy = 266700 and gbp = 1866.9 and eur = 296037 and  hkd = 2400.3','')")

    con:query("insert into check_sql values(2668,'delete from transaction_total_check where cny = 2668 and jpy = 266800 and gbp = 1867.6 and eur = 296148 and  hkd = 2401.2','')")

    con:query("insert into check_sql values(2669,'delete from transaction_total_check where cny = 2669 and jpy = 266900 and gbp = 1868.3 and eur = 296259 and  hkd = 2402.1','')")

    con:query("insert into check_sql values(2670,'delete from transaction_total_check where cny = 2670 and jpy = 267000 and gbp = 1869.0 and eur = 296370 and  hkd = 2403.0','')")

    con:query("insert into check_sql values(2671,'delete from transaction_total_check where cny = 2671 and jpy = 267100 and gbp = 1869.7 and eur = 296481 and  hkd = 2403.9','')")

    con:query("insert into check_sql values(2672,'delete from transaction_total_check where cny = 2672 and jpy = 267200 and gbp = 1870.4 and eur = 296592 and  hkd = 2404.8','')")

    con:query("insert into check_sql values(2673,'delete from transaction_total_check where cny = 2673 and jpy = 267300 and gbp = 1871.1 and eur = 296703 and  hkd = 2405.7','')")

    con:query("insert into check_sql values(2674,'delete from transaction_total_check where cny = 2674 and jpy = 267400 and gbp = 1871.8 and eur = 296814 and  hkd = 2406.6','')")

    con:query("insert into check_sql values(2675,'delete from transaction_total_check where cny = 2675 and jpy = 267500 and gbp = 1872.5 and eur = 296925 and  hkd = 2407.5','')")

    con:query("insert into check_sql values(2676,'delete from transaction_total_check where cny = 2676 and jpy = 267600 and gbp = 1873.2 and eur = 297036 and  hkd = 2408.4','')")

    con:query("insert into check_sql values(2677,'delete from transaction_total_check where cny = 2677 and jpy = 267700 and gbp = 1873.9 and eur = 297147 and  hkd = 2409.3','')")

    con:query("insert into check_sql values(2678,'delete from transaction_total_check where cny = 2678 and jpy = 267800 and gbp = 1874.6 and eur = 297258 and  hkd = 2410.2','')")

    con:query("insert into check_sql values(2679,'delete from transaction_total_check where cny = 2679 and jpy = 267900 and gbp = 1875.3 and eur = 297369 and  hkd = 2411.1','')")

    con:query("insert into check_sql values(2680,'delete from transaction_total_check where cny = 2680 and jpy = 268000 and gbp = 1876.0 and eur = 297480 and  hkd = 2412.0','')")

    con:query("insert into check_sql values(2681,'delete from transaction_total_check where cny = 2681 and jpy = 268100 and gbp = 1876.7 and eur = 297591 and  hkd = 2412.9','')")

    con:query("insert into check_sql values(2682,'delete from transaction_total_check where cny = 2682 and jpy = 268200 and gbp = 1877.4 and eur = 297702 and  hkd = 2413.8','')")

    con:query("insert into check_sql values(2683,'delete from transaction_total_check where cny = 2683 and jpy = 268300 and gbp = 1878.1 and eur = 297813 and  hkd = 2414.7','')")

    con:query("insert into check_sql values(2684,'delete from transaction_total_check where cny = 2684 and jpy = 268400 and gbp = 1878.8 and eur = 297924 and  hkd = 2415.6','')")

    con:query("insert into check_sql values(2685,'delete from transaction_total_check where cny = 2685 and jpy = 268500 and gbp = 1879.5 and eur = 298035 and  hkd = 2416.5','')")

    con:query("insert into check_sql values(2686,'delete from transaction_total_check where cny = 2686 and jpy = 268600 and gbp = 1880.2 and eur = 298146 and  hkd = 2417.4','')")

    con:query("insert into check_sql values(2687,'delete from transaction_total_check where cny = 2687 and jpy = 268700 and gbp = 1880.9 and eur = 298257 and  hkd = 2418.3','')")

    con:query("insert into check_sql values(2688,'delete from transaction_total_check where cny = 2688 and jpy = 268800 and gbp = 1881.6 and eur = 298368 and  hkd = 2419.2','')")

    con:query("insert into check_sql values(2689,'delete from transaction_total_check where cny = 2689 and jpy = 268900 and gbp = 1882.3 and eur = 298479 and  hkd = 2420.1','')")

    con:query("insert into check_sql values(2690,'delete from transaction_total_check where cny = 2690 and jpy = 269000 and gbp = 1883.0 and eur = 298590 and  hkd = 2421.0','')")

    con:query("insert into check_sql values(2691,'delete from transaction_total_check where cny = 2691 and jpy = 269100 and gbp = 1883.7 and eur = 298701 and  hkd = 2421.9','')")

    con:query("insert into check_sql values(2692,'delete from transaction_total_check where cny = 2692 and jpy = 269200 and gbp = 1884.4 and eur = 298812 and  hkd = 2422.8','')")

    con:query("insert into check_sql values(2693,'delete from transaction_total_check where cny = 2693 and jpy = 269300 and gbp = 1885.1 and eur = 298923 and  hkd = 2423.7','')")

    con:query("insert into check_sql values(2694,'delete from transaction_total_check where cny = 2694 and jpy = 269400 and gbp = 1885.8 and eur = 299034 and  hkd = 2424.6','')")

    con:query("insert into check_sql values(2695,'delete from transaction_total_check where cny = 2695 and jpy = 269500 and gbp = 1886.5 and eur = 299145 and  hkd = 2425.5','')")

    con:query("insert into check_sql values(2696,'delete from transaction_total_check where cny = 2696 and jpy = 269600 and gbp = 1887.2 and eur = 299256 and  hkd = 2426.4','')")

    con:query("insert into check_sql values(2697,'delete from transaction_total_check where cny = 2697 and jpy = 269700 and gbp = 1887.9 and eur = 299367 and  hkd = 2427.3','')")

    con:query("insert into check_sql values(2698,'delete from transaction_total_check where cny = 2698 and jpy = 269800 and gbp = 1888.6 and eur = 299478 and  hkd = 2428.2','')")

    con:query("insert into check_sql values(2699,'delete from transaction_total_check where cny = 2699 and jpy = 269900 and gbp = 1889.3 and eur = 299589 and  hkd = 2429.1','')")

    con:query("insert into check_sql values(2700,'delete from transaction_total_check where cny = 2700 and jpy = 270000 and gbp = 1890.0 and eur = 299700 and  hkd = 2430.0','')")

    con:query("insert into check_sql values(2701,'delete from transaction_total_check where cny = 2701 and jpy = 270100 and gbp = 1890.7 and eur = 299811 and  hkd = 2430.9','')")

    con:query("insert into check_sql values(2702,'delete from transaction_total_check where cny = 2702 and jpy = 270200 and gbp = 1891.4 and eur = 299922 and  hkd = 2431.8','')")

    con:query("insert into check_sql values(2703,'delete from transaction_total_check where cny = 2703 and jpy = 270300 and gbp = 1892.1 and eur = 300033 and  hkd = 2432.7','')")

    con:query("insert into check_sql values(2704,'delete from transaction_total_check where cny = 2704 and jpy = 270400 and gbp = 1892.8 and eur = 300144 and  hkd = 2433.6','')")

    con:query("insert into check_sql values(2705,'delete from transaction_total_check where cny = 2705 and jpy = 270500 and gbp = 1893.5 and eur = 300255 and  hkd = 2434.5','')")

    con:query("insert into check_sql values(2706,'delete from transaction_total_check where cny = 2706 and jpy = 270600 and gbp = 1894.2 and eur = 300366 and  hkd = 2435.4','')")

    con:query("insert into check_sql values(2707,'delete from transaction_total_check where cny = 2707 and jpy = 270700 and gbp = 1894.9 and eur = 300477 and  hkd = 2436.3','')")

    con:query("insert into check_sql values(2708,'delete from transaction_total_check where cny = 2708 and jpy = 270800 and gbp = 1895.6 and eur = 300588 and  hkd = 2437.2','')")

    con:query("insert into check_sql values(2709,'delete from transaction_total_check where cny = 2709 and jpy = 270900 and gbp = 1896.3 and eur = 300699 and  hkd = 2438.1','')")

    con:query("insert into check_sql values(2710,'delete from transaction_total_check where cny = 2710 and jpy = 271000 and gbp = 1897.0 and eur = 300810 and  hkd = 2439.0','')")

    con:query("insert into check_sql values(2711,'delete from transaction_total_check where cny = 2711 and jpy = 271100 and gbp = 1897.7 and eur = 300921 and  hkd = 2439.9','')")

    con:query("insert into check_sql values(2712,'delete from transaction_total_check where cny = 2712 and jpy = 271200 and gbp = 1898.4 and eur = 301032 and  hkd = 2440.8','')")

    con:query("insert into check_sql values(2713,'delete from transaction_total_check where cny = 2713 and jpy = 271300 and gbp = 1899.1 and eur = 301143 and  hkd = 2441.7','')")

    con:query("insert into check_sql values(2714,'delete from transaction_total_check where cny = 2714 and jpy = 271400 and gbp = 1899.8 and eur = 301254 and  hkd = 2442.6','')")

    con:query("insert into check_sql values(2715,'delete from transaction_total_check where cny = 2715 and jpy = 271500 and gbp = 1900.5 and eur = 301365 and  hkd = 2443.5','')")

    con:query("insert into check_sql values(2716,'delete from transaction_total_check where cny = 2716 and jpy = 271600 and gbp = 1901.2 and eur = 301476 and  hkd = 2444.4','')")

    con:query("insert into check_sql values(2717,'delete from transaction_total_check where cny = 2717 and jpy = 271700 and gbp = 1901.9 and eur = 301587 and  hkd = 2445.3','')")

    con:query("insert into check_sql values(2718,'delete from transaction_total_check where cny = 2718 and jpy = 271800 and gbp = 1902.6 and eur = 301698 and  hkd = 2446.2','')")

    con:query("insert into check_sql values(2719,'delete from transaction_total_check where cny = 2719 and jpy = 271900 and gbp = 1903.3 and eur = 301809 and  hkd = 2447.1','')")

    con:query("insert into check_sql values(2720,'delete from transaction_total_check where cny = 2720 and jpy = 272000 and gbp = 1904.0 and eur = 301920 and  hkd = 2448.0','')")

    con:query("insert into check_sql values(2721,'delete from transaction_total_check where cny = 2721 and jpy = 272100 and gbp = 1904.7 and eur = 302031 and  hkd = 2448.9','')")

    con:query("insert into check_sql values(2722,'delete from transaction_total_check where cny = 2722 and jpy = 272200 and gbp = 1905.4 and eur = 302142 and  hkd = 2449.8','')")

    con:query("insert into check_sql values(2723,'delete from transaction_total_check where cny = 2723 and jpy = 272300 and gbp = 1906.1 and eur = 302253 and  hkd = 2450.7','')")

    con:query("insert into check_sql values(2724,'delete from transaction_total_check where cny = 2724 and jpy = 272400 and gbp = 1906.8 and eur = 302364 and  hkd = 2451.6','')")

    con:query("insert into check_sql values(2725,'delete from transaction_total_check where cny = 2725 and jpy = 272500 and gbp = 1907.5 and eur = 302475 and  hkd = 2452.5','')")

    con:query("insert into check_sql values(2726,'delete from transaction_total_check where cny = 2726 and jpy = 272600 and gbp = 1908.2 and eur = 302586 and  hkd = 2453.4','')")

    con:query("insert into check_sql values(2727,'delete from transaction_total_check where cny = 2727 and jpy = 272700 and gbp = 1908.9 and eur = 302697 and  hkd = 2454.3','')")

    con:query("insert into check_sql values(2728,'delete from transaction_total_check where cny = 2728 and jpy = 272800 and gbp = 1909.6 and eur = 302808 and  hkd = 2455.2','')")

    con:query("insert into check_sql values(2729,'delete from transaction_total_check where cny = 2729 and jpy = 272900 and gbp = 1910.3 and eur = 302919 and  hkd = 2456.1','')")

    con:query("insert into check_sql values(2730,'delete from transaction_total_check where cny = 2730 and jpy = 273000 and gbp = 1911.0 and eur = 303030 and  hkd = 2457.0','')")

    con:query("insert into check_sql values(2731,'delete from transaction_total_check where cny = 2731 and jpy = 273100 and gbp = 1911.7 and eur = 303141 and  hkd = 2457.9','')")

    con:query("insert into check_sql values(2732,'delete from transaction_total_check where cny = 2732 and jpy = 273200 and gbp = 1912.4 and eur = 303252 and  hkd = 2458.8','')")

    con:query("insert into check_sql values(2733,'delete from transaction_total_check where cny = 2733 and jpy = 273300 and gbp = 1913.1 and eur = 303363 and  hkd = 2459.7','')")

    con:query("insert into check_sql values(2734,'delete from transaction_total_check where cny = 2734 and jpy = 273400 and gbp = 1913.8 and eur = 303474 and  hkd = 2460.6','')")

    con:query("insert into check_sql values(2735,'delete from transaction_total_check where cny = 2735 and jpy = 273500 and gbp = 1914.5 and eur = 303585 and  hkd = 2461.5','')")

    con:query("insert into check_sql values(2736,'delete from transaction_total_check where cny = 2736 and jpy = 273600 and gbp = 1915.2 and eur = 303696 and  hkd = 2462.4','')")

    con:query("insert into check_sql values(2737,'delete from transaction_total_check where cny = 2737 and jpy = 273700 and gbp = 1915.9 and eur = 303807 and  hkd = 2463.3','')")

    con:query("insert into check_sql values(2738,'delete from transaction_total_check where cny = 2738 and jpy = 273800 and gbp = 1916.6 and eur = 303918 and  hkd = 2464.2','')")

    con:query("insert into check_sql values(2739,'delete from transaction_total_check where cny = 2739 and jpy = 273900 and gbp = 1917.3 and eur = 304029 and  hkd = 2465.1','')")

    con:query("insert into check_sql values(2740,'delete from transaction_total_check where cny = 2740 and jpy = 274000 and gbp = 1918.0 and eur = 304140 and  hkd = 2466.0','')")

    con:query("insert into check_sql values(2741,'delete from transaction_total_check where cny = 2741 and jpy = 274100 and gbp = 1918.7 and eur = 304251 and  hkd = 2466.9','')")

    con:query("insert into check_sql values(2742,'delete from transaction_total_check where cny = 2742 and jpy = 274200 and gbp = 1919.4 and eur = 304362 and  hkd = 2467.8','')")

    con:query("insert into check_sql values(2743,'delete from transaction_total_check where cny = 2743 and jpy = 274300 and gbp = 1920.1 and eur = 304473 and  hkd = 2468.7','')")

    con:query("insert into check_sql values(2744,'delete from transaction_total_check where cny = 2744 and jpy = 274400 and gbp = 1920.8 and eur = 304584 and  hkd = 2469.6','')")

    con:query("insert into check_sql values(2745,'delete from transaction_total_check where cny = 2745 and jpy = 274500 and gbp = 1921.5 and eur = 304695 and  hkd = 2470.5','')")

    con:query("insert into check_sql values(2746,'delete from transaction_total_check where cny = 2746 and jpy = 274600 and gbp = 1922.2 and eur = 304806 and  hkd = 2471.4','')")

    con:query("insert into check_sql values(2747,'delete from transaction_total_check where cny = 2747 and jpy = 274700 and gbp = 1922.9 and eur = 304917 and  hkd = 2472.3','')")

    con:query("insert into check_sql values(2748,'delete from transaction_total_check where cny = 2748 and jpy = 274800 and gbp = 1923.6 and eur = 305028 and  hkd = 2473.2','')")

    con:query("insert into check_sql values(2749,'delete from transaction_total_check where cny = 2749 and jpy = 274900 and gbp = 1924.3 and eur = 305139 and  hkd = 2474.1','')")

    con:query("insert into check_sql values(2750,'delete from transaction_total_check where cny = 2750 and jpy = 275000 and gbp = 1925.0 and eur = 305250 and  hkd = 2475.0','')")

    con:query("insert into check_sql values(2751,'delete from transaction_total_check where cny = 2751 and jpy = 275100 and gbp = 1925.7 and eur = 305361 and  hkd = 2475.9','')")

    con:query("insert into check_sql values(2752,'delete from transaction_total_check where cny = 2752 and jpy = 275200 and gbp = 1926.4 and eur = 305472 and  hkd = 2476.8','')")

    con:query("insert into check_sql values(2753,'delete from transaction_total_check where cny = 2753 and jpy = 275300 and gbp = 1927.1 and eur = 305583 and  hkd = 2477.7','')")

    con:query("insert into check_sql values(2754,'delete from transaction_total_check where cny = 2754 and jpy = 275400 and gbp = 1927.8 and eur = 305694 and  hkd = 2478.6','')")

    con:query("insert into check_sql values(2755,'delete from transaction_total_check where cny = 2755 and jpy = 275500 and gbp = 1928.5 and eur = 305805 and  hkd = 2479.5','')")

    con:query("insert into check_sql values(2756,'delete from transaction_total_check where cny = 2756 and jpy = 275600 and gbp = 1929.2 and eur = 305916 and  hkd = 2480.4','')")

    con:query("insert into check_sql values(2757,'delete from transaction_total_check where cny = 2757 and jpy = 275700 and gbp = 1929.9 and eur = 306027 and  hkd = 2481.3','')")

    con:query("insert into check_sql values(2758,'delete from transaction_total_check where cny = 2758 and jpy = 275800 and gbp = 1930.6 and eur = 306138 and  hkd = 2482.2','')")

    con:query("insert into check_sql values(2759,'delete from transaction_total_check where cny = 2759 and jpy = 275900 and gbp = 1931.3 and eur = 306249 and  hkd = 2483.1','')")

    con:query("insert into check_sql values(2760,'delete from transaction_total_check where cny = 2760 and jpy = 276000 and gbp = 1932.0 and eur = 306360 and  hkd = 2484.0','')")

    con:query("insert into check_sql values(2761,'delete from transaction_total_check where cny = 2761 and jpy = 276100 and gbp = 1932.7 and eur = 306471 and  hkd = 2484.9','')")

    con:query("insert into check_sql values(2762,'delete from transaction_total_check where cny = 2762 and jpy = 276200 and gbp = 1933.4 and eur = 306582 and  hkd = 2485.8','')")

    con:query("insert into check_sql values(2763,'delete from transaction_total_check where cny = 2763 and jpy = 276300 and gbp = 1934.1 and eur = 306693 and  hkd = 2486.7','')")

    con:query("insert into check_sql values(2764,'delete from transaction_total_check where cny = 2764 and jpy = 276400 and gbp = 1934.8 and eur = 306804 and  hkd = 2487.6','')")

    con:query("insert into check_sql values(2765,'delete from transaction_total_check where cny = 2765 and jpy = 276500 and gbp = 1935.5 and eur = 306915 and  hkd = 2488.5','')")

    con:query("insert into check_sql values(2766,'delete from transaction_total_check where cny = 2766 and jpy = 276600 and gbp = 1936.2 and eur = 307026 and  hkd = 2489.4','')")

    con:query("insert into check_sql values(2767,'delete from transaction_total_check where cny = 2767 and jpy = 276700 and gbp = 1936.9 and eur = 307137 and  hkd = 2490.3','')")

    con:query("insert into check_sql values(2768,'delete from transaction_total_check where cny = 2768 and jpy = 276800 and gbp = 1937.6 and eur = 307248 and  hkd = 2491.2','')")

    con:query("insert into check_sql values(2769,'delete from transaction_total_check where cny = 2769 and jpy = 276900 and gbp = 1938.3 and eur = 307359 and  hkd = 2492.1','')")

    con:query("insert into check_sql values(2770,'delete from transaction_total_check where cny = 2770 and jpy = 277000 and gbp = 1939.0 and eur = 307470 and  hkd = 2493.0','')")

    con:query("insert into check_sql values(2771,'delete from transaction_total_check where cny = 2771 and jpy = 277100 and gbp = 1939.7 and eur = 307581 and  hkd = 2493.9','')")

    con:query("insert into check_sql values(2772,'delete from transaction_total_check where cny = 2772 and jpy = 277200 and gbp = 1940.4 and eur = 307692 and  hkd = 2494.8','')")

    con:query("insert into check_sql values(2773,'delete from transaction_total_check where cny = 2773 and jpy = 277300 and gbp = 1941.1 and eur = 307803 and  hkd = 2495.7','')")

    con:query("insert into check_sql values(2774,'delete from transaction_total_check where cny = 2774 and jpy = 277400 and gbp = 1941.8 and eur = 307914 and  hkd = 2496.6','')")

    con:query("insert into check_sql values(2775,'delete from transaction_total_check where cny = 2775 and jpy = 277500 and gbp = 1942.5 and eur = 308025 and  hkd = 2497.5','')")

    con:query("insert into check_sql values(2776,'delete from transaction_total_check where cny = 2776 and jpy = 277600 and gbp = 1943.2 and eur = 308136 and  hkd = 2498.4','')")

    con:query("insert into check_sql values(2777,'delete from transaction_total_check where cny = 2777 and jpy = 277700 and gbp = 1943.9 and eur = 308247 and  hkd = 2499.3','')")

    con:query("insert into check_sql values(2778,'delete from transaction_total_check where cny = 2778 and jpy = 277800 and gbp = 1944.6 and eur = 308358 and  hkd = 2500.2','')")

    con:query("insert into check_sql values(2779,'delete from transaction_total_check where cny = 2779 and jpy = 277900 and gbp = 1945.3 and eur = 308469 and  hkd = 2501.1','')")

    con:query("insert into check_sql values(2780,'delete from transaction_total_check where cny = 2780 and jpy = 278000 and gbp = 1946.0 and eur = 308580 and  hkd = 2502.0','')")

    con:query("insert into check_sql values(2781,'delete from transaction_total_check where cny = 2781 and jpy = 278100 and gbp = 1946.7 and eur = 308691 and  hkd = 2502.9','')")

    con:query("insert into check_sql values(2782,'delete from transaction_total_check where cny = 2782 and jpy = 278200 and gbp = 1947.4 and eur = 308802 and  hkd = 2503.8','')")

    con:query("insert into check_sql values(2783,'delete from transaction_total_check where cny = 2783 and jpy = 278300 and gbp = 1948.1 and eur = 308913 and  hkd = 2504.7','')")

    con:query("insert into check_sql values(2784,'delete from transaction_total_check where cny = 2784 and jpy = 278400 and gbp = 1948.8 and eur = 309024 and  hkd = 2505.6','')")

    con:query("insert into check_sql values(2785,'delete from transaction_total_check where cny = 2785 and jpy = 278500 and gbp = 1949.5 and eur = 309135 and  hkd = 2506.5','')")

    con:query("insert into check_sql values(2786,'delete from transaction_total_check where cny = 2786 and jpy = 278600 and gbp = 1950.2 and eur = 309246 and  hkd = 2507.4','')")

    con:query("insert into check_sql values(2787,'delete from transaction_total_check where cny = 2787 and jpy = 278700 and gbp = 1950.9 and eur = 309357 and  hkd = 2508.3','')")

    con:query("insert into check_sql values(2788,'delete from transaction_total_check where cny = 2788 and jpy = 278800 and gbp = 1951.6 and eur = 309468 and  hkd = 2509.2','')")

    con:query("insert into check_sql values(2789,'delete from transaction_total_check where cny = 2789 and jpy = 278900 and gbp = 1952.3 and eur = 309579 and  hkd = 2510.1','')")

    con:query("insert into check_sql values(2790,'delete from transaction_total_check where cny = 2790 and jpy = 279000 and gbp = 1953.0 and eur = 309690 and  hkd = 2511.0','')")

    con:query("insert into check_sql values(2791,'delete from transaction_total_check where cny = 2791 and jpy = 279100 and gbp = 1953.7 and eur = 309801 and  hkd = 2511.9','')")

    con:query("insert into check_sql values(2792,'delete from transaction_total_check where cny = 2792 and jpy = 279200 and gbp = 1954.4 and eur = 309912 and  hkd = 2512.8','')")

    con:query("insert into check_sql values(2793,'delete from transaction_total_check where cny = 2793 and jpy = 279300 and gbp = 1955.1 and eur = 310023 and  hkd = 2513.7','')")

    con:query("insert into check_sql values(2794,'delete from transaction_total_check where cny = 2794 and jpy = 279400 and gbp = 1955.8 and eur = 310134 and  hkd = 2514.6','')")

    con:query("insert into check_sql values(2795,'delete from transaction_total_check where cny = 2795 and jpy = 279500 and gbp = 1956.5 and eur = 310245 and  hkd = 2515.5','')")

    con:query("insert into check_sql values(2796,'delete from transaction_total_check where cny = 2796 and jpy = 279600 and gbp = 1957.2 and eur = 310356 and  hkd = 2516.4','')")

    con:query("insert into check_sql values(2797,'delete from transaction_total_check where cny = 2797 and jpy = 279700 and gbp = 1957.9 and eur = 310467 and  hkd = 2517.3','')")

    con:query("insert into check_sql values(2798,'delete from transaction_total_check where cny = 2798 and jpy = 279800 and gbp = 1958.6 and eur = 310578 and  hkd = 2518.2','')")

    con:query("insert into check_sql values(2799,'delete from transaction_total_check where cny = 2799 and jpy = 279900 and gbp = 1959.3 and eur = 310689 and  hkd = 2519.1','')")

    con:query("insert into check_sql values(2800,'delete from transaction_total_check where cny = 2800 and jpy = 280000 and gbp = 1960.0 and eur = 310800 and  hkd = 2520.0','')")

    con:query("insert into check_sql values(2801,'delete from transaction_total_check where cny = 2801 and jpy = 280100 and gbp = 1960.7 and eur = 310911 and  hkd = 2520.9','')")

    con:query("insert into check_sql values(2802,'delete from transaction_total_check where cny = 2802 and jpy = 280200 and gbp = 1961.4 and eur = 311022 and  hkd = 2521.8','')")

    con:query("insert into check_sql values(2803,'delete from transaction_total_check where cny = 2803 and jpy = 280300 and gbp = 1962.1 and eur = 311133 and  hkd = 2522.7','')")

    con:query("insert into check_sql values(2804,'delete from transaction_total_check where cny = 2804 and jpy = 280400 and gbp = 1962.8 and eur = 311244 and  hkd = 2523.6','')")

    con:query("insert into check_sql values(2805,'delete from transaction_total_check where cny = 2805 and jpy = 280500 and gbp = 1963.5 and eur = 311355 and  hkd = 2524.5','')")

    con:query("insert into check_sql values(2806,'delete from transaction_total_check where cny = 2806 and jpy = 280600 and gbp = 1964.2 and eur = 311466 and  hkd = 2525.4','')")

    con:query("insert into check_sql values(2807,'delete from transaction_total_check where cny = 2807 and jpy = 280700 and gbp = 1964.9 and eur = 311577 and  hkd = 2526.3','')")

    con:query("insert into check_sql values(2808,'delete from transaction_total_check where cny = 2808 and jpy = 280800 and gbp = 1965.6 and eur = 311688 and  hkd = 2527.2','')")

    con:query("insert into check_sql values(2809,'delete from transaction_total_check where cny = 2809 and jpy = 280900 and gbp = 1966.3 and eur = 311799 and  hkd = 2528.1','')")

    con:query("insert into check_sql values(2810,'delete from transaction_total_check where cny = 2810 and jpy = 281000 and gbp = 1967.0 and eur = 311910 and  hkd = 2529.0','')")

    con:query("insert into check_sql values(2811,'delete from transaction_total_check where cny = 2811 and jpy = 281100 and gbp = 1967.7 and eur = 312021 and  hkd = 2529.9','')")

    con:query("insert into check_sql values(2812,'delete from transaction_total_check where cny = 2812 and jpy = 281200 and gbp = 1968.4 and eur = 312132 and  hkd = 2530.8','')")

    con:query("insert into check_sql values(2813,'delete from transaction_total_check where cny = 2813 and jpy = 281300 and gbp = 1969.1 and eur = 312243 and  hkd = 2531.7','')")

    con:query("insert into check_sql values(2814,'delete from transaction_total_check where cny = 2814 and jpy = 281400 and gbp = 1969.8 and eur = 312354 and  hkd = 2532.6','')")

    con:query("insert into check_sql values(2815,'delete from transaction_total_check where cny = 2815 and jpy = 281500 and gbp = 1970.5 and eur = 312465 and  hkd = 2533.5','')")

    con:query("insert into check_sql values(2816,'delete from transaction_total_check where cny = 2816 and jpy = 281600 and gbp = 1971.2 and eur = 312576 and  hkd = 2534.4','')")

    con:query("insert into check_sql values(2817,'delete from transaction_total_check where cny = 2817 and jpy = 281700 and gbp = 1971.9 and eur = 312687 and  hkd = 2535.3','')")

    con:query("insert into check_sql values(2818,'delete from transaction_total_check where cny = 2818 and jpy = 281800 and gbp = 1972.6 and eur = 312798 and  hkd = 2536.2','')")

    con:query("insert into check_sql values(2819,'delete from transaction_total_check where cny = 2819 and jpy = 281900 and gbp = 1973.3 and eur = 312909 and  hkd = 2537.1','')")

    con:query("insert into check_sql values(2820,'delete from transaction_total_check where cny = 2820 and jpy = 282000 and gbp = 1974.0 and eur = 313020 and  hkd = 2538.0','')")

    con:query("insert into check_sql values(2821,'delete from transaction_total_check where cny = 2821 and jpy = 282100 and gbp = 1974.7 and eur = 313131 and  hkd = 2538.9','')")

    con:query("insert into check_sql values(2822,'delete from transaction_total_check where cny = 2822 and jpy = 282200 and gbp = 1975.4 and eur = 313242 and  hkd = 2539.8','')")

    con:query("insert into check_sql values(2823,'delete from transaction_total_check where cny = 2823 and jpy = 282300 and gbp = 1976.1 and eur = 313353 and  hkd = 2540.7','')")

    con:query("insert into check_sql values(2824,'delete from transaction_total_check where cny = 2824 and jpy = 282400 and gbp = 1976.8 and eur = 313464 and  hkd = 2541.6','')")

    con:query("insert into check_sql values(2825,'delete from transaction_total_check where cny = 2825 and jpy = 282500 and gbp = 1977.5 and eur = 313575 and  hkd = 2542.5','')")

    con:query("insert into check_sql values(2826,'delete from transaction_total_check where cny = 2826 and jpy = 282600 and gbp = 1978.2 and eur = 313686 and  hkd = 2543.4','')")

    con:query("insert into check_sql values(2827,'delete from transaction_total_check where cny = 2827 and jpy = 282700 and gbp = 1978.9 and eur = 313797 and  hkd = 2544.3','')")

    con:query("insert into check_sql values(2828,'delete from transaction_total_check where cny = 2828 and jpy = 282800 and gbp = 1979.6 and eur = 313908 and  hkd = 2545.2','')")

    con:query("insert into check_sql values(2829,'delete from transaction_total_check where cny = 2829 and jpy = 282900 and gbp = 1980.3 and eur = 314019 and  hkd = 2546.1','')")

    con:query("insert into check_sql values(2830,'delete from transaction_total_check where cny = 2830 and jpy = 283000 and gbp = 1981.0 and eur = 314130 and  hkd = 2547.0','')")

    con:query("insert into check_sql values(2831,'delete from transaction_total_check where cny = 2831 and jpy = 283100 and gbp = 1981.7 and eur = 314241 and  hkd = 2547.9','')")

    con:query("insert into check_sql values(2832,'delete from transaction_total_check where cny = 2832 and jpy = 283200 and gbp = 1982.4 and eur = 314352 and  hkd = 2548.8','')")

    con:query("insert into check_sql values(2833,'delete from transaction_total_check where cny = 2833 and jpy = 283300 and gbp = 1983.1 and eur = 314463 and  hkd = 2549.7','')")

    con:query("insert into check_sql values(2834,'delete from transaction_total_check where cny = 2834 and jpy = 283400 and gbp = 1983.8 and eur = 314574 and  hkd = 2550.6','')")

    con:query("insert into check_sql values(2835,'delete from transaction_total_check where cny = 2835 and jpy = 283500 and gbp = 1984.5 and eur = 314685 and  hkd = 2551.5','')")

    con:query("insert into check_sql values(2836,'delete from transaction_total_check where cny = 2836 and jpy = 283600 and gbp = 1985.2 and eur = 314796 and  hkd = 2552.4','')")

    con:query("insert into check_sql values(2837,'delete from transaction_total_check where cny = 2837 and jpy = 283700 and gbp = 1985.9 and eur = 314907 and  hkd = 2553.3','')")

    con:query("insert into check_sql values(2838,'delete from transaction_total_check where cny = 2838 and jpy = 283800 and gbp = 1986.6 and eur = 315018 and  hkd = 2554.2','')")

    con:query("insert into check_sql values(2839,'delete from transaction_total_check where cny = 2839 and jpy = 283900 and gbp = 1987.3 and eur = 315129 and  hkd = 2555.1','')")

    con:query("insert into check_sql values(2840,'delete from transaction_total_check where cny = 2840 and jpy = 284000 and gbp = 1988.0 and eur = 315240 and  hkd = 2556.0','')")

    con:query("insert into check_sql values(2841,'delete from transaction_total_check where cny = 2841 and jpy = 284100 and gbp = 1988.7 and eur = 315351 and  hkd = 2556.9','')")

    con:query("insert into check_sql values(2842,'delete from transaction_total_check where cny = 2842 and jpy = 284200 and gbp = 1989.4 and eur = 315462 and  hkd = 2557.8','')")

    con:query("insert into check_sql values(2843,'delete from transaction_total_check where cny = 2843 and jpy = 284300 and gbp = 1990.1 and eur = 315573 and  hkd = 2558.7','')")

    con:query("insert into check_sql values(2844,'delete from transaction_total_check where cny = 2844 and jpy = 284400 and gbp = 1990.8 and eur = 315684 and  hkd = 2559.6','')")

    con:query("insert into check_sql values(2845,'delete from transaction_total_check where cny = 2845 and jpy = 284500 and gbp = 1991.5 and eur = 315795 and  hkd = 2560.5','')")

    con:query("insert into check_sql values(2846,'delete from transaction_total_check where cny = 2846 and jpy = 284600 and gbp = 1992.2 and eur = 315906 and  hkd = 2561.4','')")

    con:query("insert into check_sql values(2847,'delete from transaction_total_check where cny = 2847 and jpy = 284700 and gbp = 1992.9 and eur = 316017 and  hkd = 2562.3','')")

    con:query("insert into check_sql values(2848,'delete from transaction_total_check where cny = 2848 and jpy = 284800 and gbp = 1993.6 and eur = 316128 and  hkd = 2563.2','')")

    con:query("insert into check_sql values(2849,'delete from transaction_total_check where cny = 2849 and jpy = 284900 and gbp = 1994.3 and eur = 316239 and  hkd = 2564.1','')")

    con:query("insert into check_sql values(2850,'delete from transaction_total_check where cny = 2850 and jpy = 285000 and gbp = 1995.0 and eur = 316350 and  hkd = 2565.0','')")

    con:query("insert into check_sql values(2851,'delete from transaction_total_check where cny = 2851 and jpy = 285100 and gbp = 1995.7 and eur = 316461 and  hkd = 2565.9','')")

    con:query("insert into check_sql values(2852,'delete from transaction_total_check where cny = 2852 and jpy = 285200 and gbp = 1996.4 and eur = 316572 and  hkd = 2566.8','')")

    con:query("insert into check_sql values(2853,'delete from transaction_total_check where cny = 2853 and jpy = 285300 and gbp = 1997.1 and eur = 316683 and  hkd = 2567.7','')")

    con:query("insert into check_sql values(2854,'delete from transaction_total_check where cny = 2854 and jpy = 285400 and gbp = 1997.8 and eur = 316794 and  hkd = 2568.6','')")

    con:query("insert into check_sql values(2855,'delete from transaction_total_check where cny = 2855 and jpy = 285500 and gbp = 1998.5 and eur = 316905 and  hkd = 2569.5','')")

    con:query("insert into check_sql values(2856,'delete from transaction_total_check where cny = 2856 and jpy = 285600 and gbp = 1999.2 and eur = 317016 and  hkd = 2570.4','')")

    con:query("insert into check_sql values(2857,'delete from transaction_total_check where cny = 2857 and jpy = 285700 and gbp = 1999.9 and eur = 317127 and  hkd = 2571.3','')")

    con:query("insert into check_sql values(2858,'delete from transaction_total_check where cny = 2858 and jpy = 285800 and gbp = 2000.6 and eur = 317238 and  hkd = 2572.2','')")

    con:query("insert into check_sql values(2859,'delete from transaction_total_check where cny = 2859 and jpy = 285900 and gbp = 2001.3 and eur = 317349 and  hkd = 2573.1','')")

    con:query("insert into check_sql values(2860,'delete from transaction_total_check where cny = 2860 and jpy = 286000 and gbp = 2002.0 and eur = 317460 and  hkd = 2574.0','')")

    con:query("insert into check_sql values(2861,'delete from transaction_total_check where cny = 2861 and jpy = 286100 and gbp = 2002.7 and eur = 317571 and  hkd = 2574.9','')")

    con:query("insert into check_sql values(2862,'delete from transaction_total_check where cny = 2862 and jpy = 286200 and gbp = 2003.4 and eur = 317682 and  hkd = 2575.8','')")

    con:query("insert into check_sql values(2863,'delete from transaction_total_check where cny = 2863 and jpy = 286300 and gbp = 2004.1 and eur = 317793 and  hkd = 2576.7','')")

    con:query("insert into check_sql values(2864,'delete from transaction_total_check where cny = 2864 and jpy = 286400 and gbp = 2004.8 and eur = 317904 and  hkd = 2577.6','')")

    con:query("insert into check_sql values(2865,'delete from transaction_total_check where cny = 2865 and jpy = 286500 and gbp = 2005.5 and eur = 318015 and  hkd = 2578.5','')")

    con:query("insert into check_sql values(2866,'delete from transaction_total_check where cny = 2866 and jpy = 286600 and gbp = 2006.2 and eur = 318126 and  hkd = 2579.4','')")

    con:query("insert into check_sql values(2867,'delete from transaction_total_check where cny = 2867 and jpy = 286700 and gbp = 2006.9 and eur = 318237 and  hkd = 2580.3','')")

    con:query("insert into check_sql values(2868,'delete from transaction_total_check where cny = 2868 and jpy = 286800 and gbp = 2007.6 and eur = 318348 and  hkd = 2581.2','')")

    con:query("insert into check_sql values(2869,'delete from transaction_total_check where cny = 2869 and jpy = 286900 and gbp = 2008.3 and eur = 318459 and  hkd = 2582.1','')")

    con:query("insert into check_sql values(2870,'delete from transaction_total_check where cny = 2870 and jpy = 287000 and gbp = 2009.0 and eur = 318570 and  hkd = 2583.0','')")

    con:query("insert into check_sql values(2871,'delete from transaction_total_check where cny = 2871 and jpy = 287100 and gbp = 2009.7 and eur = 318681 and  hkd = 2583.9','')")

    con:query("insert into check_sql values(2872,'delete from transaction_total_check where cny = 2872 and jpy = 287200 and gbp = 2010.4 and eur = 318792 and  hkd = 2584.8','')")

    con:query("insert into check_sql values(2873,'delete from transaction_total_check where cny = 2873 and jpy = 287300 and gbp = 2011.1 and eur = 318903 and  hkd = 2585.7','')")

    con:query("insert into check_sql values(2874,'delete from transaction_total_check where cny = 2874 and jpy = 287400 and gbp = 2011.8 and eur = 319014 and  hkd = 2586.6','')")

    con:query("insert into check_sql values(2875,'delete from transaction_total_check where cny = 2875 and jpy = 287500 and gbp = 2012.5 and eur = 319125 and  hkd = 2587.5','')")

    con:query("insert into check_sql values(2876,'delete from transaction_total_check where cny = 2876 and jpy = 287600 and gbp = 2013.2 and eur = 319236 and  hkd = 2588.4','')")

    con:query("insert into check_sql values(2877,'delete from transaction_total_check where cny = 2877 and jpy = 287700 and gbp = 2013.9 and eur = 319347 and  hkd = 2589.3','')")

    con:query("insert into check_sql values(2878,'delete from transaction_total_check where cny = 2878 and jpy = 287800 and gbp = 2014.6 and eur = 319458 and  hkd = 2590.2','')")

    con:query("insert into check_sql values(2879,'delete from transaction_total_check where cny = 2879 and jpy = 287900 and gbp = 2015.3 and eur = 319569 and  hkd = 2591.1','')")

    con:query("insert into check_sql values(2880,'delete from transaction_total_check where cny = 2880 and jpy = 288000 and gbp = 2016.0 and eur = 319680 and  hkd = 2592.0','')")

    con:query("insert into check_sql values(2881,'delete from transaction_total_check where cny = 2881 and jpy = 288100 and gbp = 2016.7 and eur = 319791 and  hkd = 2592.9','')")

    con:query("insert into check_sql values(2882,'delete from transaction_total_check where cny = 2882 and jpy = 288200 and gbp = 2017.4 and eur = 319902 and  hkd = 2593.8','')")

    con:query("insert into check_sql values(2883,'delete from transaction_total_check where cny = 2883 and jpy = 288300 and gbp = 2018.1 and eur = 320013 and  hkd = 2594.7','')")

    con:query("insert into check_sql values(2884,'delete from transaction_total_check where cny = 2884 and jpy = 288400 and gbp = 2018.8 and eur = 320124 and  hkd = 2595.6','')")

    con:query("insert into check_sql values(2885,'delete from transaction_total_check where cny = 2885 and jpy = 288500 and gbp = 2019.5 and eur = 320235 and  hkd = 2596.5','')")

    con:query("insert into check_sql values(2886,'delete from transaction_total_check where cny = 2886 and jpy = 288600 and gbp = 2020.2 and eur = 320346 and  hkd = 2597.4','')")

    con:query("insert into check_sql values(2887,'delete from transaction_total_check where cny = 2887 and jpy = 288700 and gbp = 2020.9 and eur = 320457 and  hkd = 2598.3','')")

    con:query("insert into check_sql values(2888,'delete from transaction_total_check where cny = 2888 and jpy = 288800 and gbp = 2021.6 and eur = 320568 and  hkd = 2599.2','')")

    con:query("insert into check_sql values(2889,'delete from transaction_total_check where cny = 2889 and jpy = 288900 and gbp = 2022.3 and eur = 320679 and  hkd = 2600.1','')")

    con:query("insert into check_sql values(2890,'delete from transaction_total_check where cny = 2890 and jpy = 289000 and gbp = 2023.0 and eur = 320790 and  hkd = 2601.0','')")

    con:query("insert into check_sql values(2891,'delete from transaction_total_check where cny = 2891 and jpy = 289100 and gbp = 2023.7 and eur = 320901 and  hkd = 2601.9','')")

    con:query("insert into check_sql values(2892,'delete from transaction_total_check where cny = 2892 and jpy = 289200 and gbp = 2024.4 and eur = 321012 and  hkd = 2602.8','')")

    con:query("insert into check_sql values(2893,'delete from transaction_total_check where cny = 2893 and jpy = 289300 and gbp = 2025.1 and eur = 321123 and  hkd = 2603.7','')")

    con:query("insert into check_sql values(2894,'delete from transaction_total_check where cny = 2894 and jpy = 289400 and gbp = 2025.8 and eur = 321234 and  hkd = 2604.6','')")

    con:query("insert into check_sql values(2895,'delete from transaction_total_check where cny = 2895 and jpy = 289500 and gbp = 2026.5 and eur = 321345 and  hkd = 2605.5','')")

    con:query("insert into check_sql values(2896,'delete from transaction_total_check where cny = 2896 and jpy = 289600 and gbp = 2027.2 and eur = 321456 and  hkd = 2606.4','')")

    con:query("insert into check_sql values(2897,'delete from transaction_total_check where cny = 2897 and jpy = 289700 and gbp = 2027.9 and eur = 321567 and  hkd = 2607.3','')")

    con:query("insert into check_sql values(2898,'delete from transaction_total_check where cny = 2898 and jpy = 289800 and gbp = 2028.6 and eur = 321678 and  hkd = 2608.2','')")

    con:query("insert into check_sql values(2899,'delete from transaction_total_check where cny = 2899 and jpy = 289900 and gbp = 2029.3 and eur = 321789 and  hkd = 2609.1','')")

    con:query("insert into check_sql values(2900,'delete from transaction_total_check where cny = 2900 and jpy = 290000 and gbp = 2030.0 and eur = 321900 and  hkd = 2610.0','')")

    con:query("insert into check_sql values(2901,'delete from transaction_total_check where cny = 2901 and jpy = 290100 and gbp = 2030.7 and eur = 322011 and  hkd = 2610.9','')")

    con:query("insert into check_sql values(2902,'delete from transaction_total_check where cny = 2902 and jpy = 290200 and gbp = 2031.4 and eur = 322122 and  hkd = 2611.8','')")

    con:query("insert into check_sql values(2903,'delete from transaction_total_check where cny = 2903 and jpy = 290300 and gbp = 2032.1 and eur = 322233 and  hkd = 2612.7','')")

    con:query("insert into check_sql values(2904,'delete from transaction_total_check where cny = 2904 and jpy = 290400 and gbp = 2032.8 and eur = 322344 and  hkd = 2613.6','')")

    con:query("insert into check_sql values(2905,'delete from transaction_total_check where cny = 2905 and jpy = 290500 and gbp = 2033.5 and eur = 322455 and  hkd = 2614.5','')")

    con:query("insert into check_sql values(2906,'delete from transaction_total_check where cny = 2906 and jpy = 290600 and gbp = 2034.2 and eur = 322566 and  hkd = 2615.4','')")

    con:query("insert into check_sql values(2907,'delete from transaction_total_check where cny = 2907 and jpy = 290700 and gbp = 2034.9 and eur = 322677 and  hkd = 2616.3','')")

    con:query("insert into check_sql values(2908,'delete from transaction_total_check where cny = 2908 and jpy = 290800 and gbp = 2035.6 and eur = 322788 and  hkd = 2617.2','')")

    con:query("insert into check_sql values(2909,'delete from transaction_total_check where cny = 2909 and jpy = 290900 and gbp = 2036.3 and eur = 322899 and  hkd = 2618.1','')")

    con:query("insert into check_sql values(2910,'delete from transaction_total_check where cny = 2910 and jpy = 291000 and gbp = 2037.0 and eur = 323010 and  hkd = 2619.0','')")

    con:query("insert into check_sql values(2911,'delete from transaction_total_check where cny = 2911 and jpy = 291100 and gbp = 2037.7 and eur = 323121 and  hkd = 2619.9','')")

    con:query("insert into check_sql values(2912,'delete from transaction_total_check where cny = 2912 and jpy = 291200 and gbp = 2038.4 and eur = 323232 and  hkd = 2620.8','')")

    con:query("insert into check_sql values(2913,'delete from transaction_total_check where cny = 2913 and jpy = 291300 and gbp = 2039.1 and eur = 323343 and  hkd = 2621.7','')")

    con:query("insert into check_sql values(2914,'delete from transaction_total_check where cny = 2914 and jpy = 291400 and gbp = 2039.8 and eur = 323454 and  hkd = 2622.6','')")

    con:query("insert into check_sql values(2915,'delete from transaction_total_check where cny = 2915 and jpy = 291500 and gbp = 2040.5 and eur = 323565 and  hkd = 2623.5','')")

    con:query("insert into check_sql values(2916,'delete from transaction_total_check where cny = 2916 and jpy = 291600 and gbp = 2041.2 and eur = 323676 and  hkd = 2624.4','')")

    con:query("insert into check_sql values(2917,'delete from transaction_total_check where cny = 2917 and jpy = 291700 and gbp = 2041.9 and eur = 323787 and  hkd = 2625.3','')")

    con:query("insert into check_sql values(2918,'delete from transaction_total_check where cny = 2918 and jpy = 291800 and gbp = 2042.6 and eur = 323898 and  hkd = 2626.2','')")

    con:query("insert into check_sql values(2919,'delete from transaction_total_check where cny = 2919 and jpy = 291900 and gbp = 2043.3 and eur = 324009 and  hkd = 2627.1','')")

    con:query("insert into check_sql values(2920,'delete from transaction_total_check where cny = 2920 and jpy = 292000 and gbp = 2044.0 and eur = 324120 and  hkd = 2628.0','')")

    con:query("insert into check_sql values(2921,'delete from transaction_total_check where cny = 2921 and jpy = 292100 and gbp = 2044.7 and eur = 324231 and  hkd = 2628.9','')")

    con:query("insert into check_sql values(2922,'delete from transaction_total_check where cny = 2922 and jpy = 292200 and gbp = 2045.4 and eur = 324342 and  hkd = 2629.8','')")

    con:query("insert into check_sql values(2923,'delete from transaction_total_check where cny = 2923 and jpy = 292300 and gbp = 2046.1 and eur = 324453 and  hkd = 2630.7','')")

    con:query("insert into check_sql values(2924,'delete from transaction_total_check where cny = 2924 and jpy = 292400 and gbp = 2046.8 and eur = 324564 and  hkd = 2631.6','')")

    con:query("insert into check_sql values(2925,'delete from transaction_total_check where cny = 2925 and jpy = 292500 and gbp = 2047.5 and eur = 324675 and  hkd = 2632.5','')")

    con:query("insert into check_sql values(2926,'delete from transaction_total_check where cny = 2926 and jpy = 292600 and gbp = 2048.2 and eur = 324786 and  hkd = 2633.4','')")

    con:query("insert into check_sql values(2927,'delete from transaction_total_check where cny = 2927 and jpy = 292700 and gbp = 2048.9 and eur = 324897 and  hkd = 2634.3','')")

    con:query("insert into check_sql values(2928,'delete from transaction_total_check where cny = 2928 and jpy = 292800 and gbp = 2049.6 and eur = 325008 and  hkd = 2635.2','')")

    con:query("insert into check_sql values(2929,'delete from transaction_total_check where cny = 2929 and jpy = 292900 and gbp = 2050.3 and eur = 325119 and  hkd = 2636.1','')")

    con:query("insert into check_sql values(2930,'delete from transaction_total_check where cny = 2930 and jpy = 293000 and gbp = 2051.0 and eur = 325230 and  hkd = 2637.0','')")

    con:query("insert into check_sql values(2931,'delete from transaction_total_check where cny = 2931 and jpy = 293100 and gbp = 2051.7 and eur = 325341 and  hkd = 2637.9','')")

    con:query("insert into check_sql values(2932,'delete from transaction_total_check where cny = 2932 and jpy = 293200 and gbp = 2052.4 and eur = 325452 and  hkd = 2638.8','')")

    con:query("insert into check_sql values(2933,'delete from transaction_total_check where cny = 2933 and jpy = 293300 and gbp = 2053.1 and eur = 325563 and  hkd = 2639.7','')")

    con:query("insert into check_sql values(2934,'delete from transaction_total_check where cny = 2934 and jpy = 293400 and gbp = 2053.8 and eur = 325674 and  hkd = 2640.6','')")

    con:query("insert into check_sql values(2935,'delete from transaction_total_check where cny = 2935 and jpy = 293500 and gbp = 2054.5 and eur = 325785 and  hkd = 2641.5','')")

    con:query("insert into check_sql values(2936,'delete from transaction_total_check where cny = 2936 and jpy = 293600 and gbp = 2055.2 and eur = 325896 and  hkd = 2642.4','')")

    con:query("insert into check_sql values(2937,'delete from transaction_total_check where cny = 2937 and jpy = 293700 and gbp = 2055.9 and eur = 326007 and  hkd = 2643.3','')")

    con:query("insert into check_sql values(2938,'delete from transaction_total_check where cny = 2938 and jpy = 293800 and gbp = 2056.6 and eur = 326118 and  hkd = 2644.2','')")

    con:query("insert into check_sql values(2939,'delete from transaction_total_check where cny = 2939 and jpy = 293900 and gbp = 2057.3 and eur = 326229 and  hkd = 2645.1','')")

    con:query("insert into check_sql values(2940,'delete from transaction_total_check where cny = 2940 and jpy = 294000 and gbp = 2058.0 and eur = 326340 and  hkd = 2646.0','')")

    con:query("insert into check_sql values(2941,'delete from transaction_total_check where cny = 2941 and jpy = 294100 and gbp = 2058.7 and eur = 326451 and  hkd = 2646.9','')")

    con:query("insert into check_sql values(2942,'delete from transaction_total_check where cny = 2942 and jpy = 294200 and gbp = 2059.4 and eur = 326562 and  hkd = 2647.8','')")

    con:query("insert into check_sql values(2943,'delete from transaction_total_check where cny = 2943 and jpy = 294300 and gbp = 2060.1 and eur = 326673 and  hkd = 2648.7','')")

    con:query("insert into check_sql values(2944,'delete from transaction_total_check where cny = 2944 and jpy = 294400 and gbp = 2060.8 and eur = 326784 and  hkd = 2649.6','')")

    con:query("insert into check_sql values(2945,'delete from transaction_total_check where cny = 2945 and jpy = 294500 and gbp = 2061.5 and eur = 326895 and  hkd = 2650.5','')")

    con:query("insert into check_sql values(2946,'delete from transaction_total_check where cny = 2946 and jpy = 294600 and gbp = 2062.2 and eur = 327006 and  hkd = 2651.4','')")

    con:query("insert into check_sql values(2947,'delete from transaction_total_check where cny = 2947 and jpy = 294700 and gbp = 2062.9 and eur = 327117 and  hkd = 2652.3','')")

    con:query("insert into check_sql values(2948,'delete from transaction_total_check where cny = 2948 and jpy = 294800 and gbp = 2063.6 and eur = 327228 and  hkd = 2653.2','')")

    con:query("insert into check_sql values(2949,'delete from transaction_total_check where cny = 2949 and jpy = 294900 and gbp = 2064.3 and eur = 327339 and  hkd = 2654.1','')")

    con:query("insert into check_sql values(2950,'delete from transaction_total_check where cny = 2950 and jpy = 295000 and gbp = 2065.0 and eur = 327450 and  hkd = 2655.0','')")

    con:query("insert into check_sql values(2951,'delete from transaction_total_check where cny = 2951 and jpy = 295100 and gbp = 2065.7 and eur = 327561 and  hkd = 2655.9','')")

    con:query("insert into check_sql values(2952,'delete from transaction_total_check where cny = 2952 and jpy = 295200 and gbp = 2066.4 and eur = 327672 and  hkd = 2656.8','')")

    con:query("insert into check_sql values(2953,'delete from transaction_total_check where cny = 2953 and jpy = 295300 and gbp = 2067.1 and eur = 327783 and  hkd = 2657.7','')")

    con:query("insert into check_sql values(2954,'delete from transaction_total_check where cny = 2954 and jpy = 295400 and gbp = 2067.8 and eur = 327894 and  hkd = 2658.6','')")

    con:query("insert into check_sql values(2955,'delete from transaction_total_check where cny = 2955 and jpy = 295500 and gbp = 2068.5 and eur = 328005 and  hkd = 2659.5','')")

    con:query("insert into check_sql values(2956,'delete from transaction_total_check where cny = 2956 and jpy = 295600 and gbp = 2069.2 and eur = 328116 and  hkd = 2660.4','')")

    con:query("insert into check_sql values(2957,'delete from transaction_total_check where cny = 2957 and jpy = 295700 and gbp = 2069.9 and eur = 328227 and  hkd = 2661.3','')")

    con:query("insert into check_sql values(2958,'delete from transaction_total_check where cny = 2958 and jpy = 295800 and gbp = 2070.6 and eur = 328338 and  hkd = 2662.2','')")

    con:query("insert into check_sql values(2959,'delete from transaction_total_check where cny = 2959 and jpy = 295900 and gbp = 2071.3 and eur = 328449 and  hkd = 2663.1','')")

    con:query("insert into check_sql values(2960,'delete from transaction_total_check where cny = 2960 and jpy = 296000 and gbp = 2072.0 and eur = 328560 and  hkd = 2664.0','')")

    con:query("insert into check_sql values(2961,'delete from transaction_total_check where cny = 2961 and jpy = 296100 and gbp = 2072.7 and eur = 328671 and  hkd = 2664.9','')")

    con:query("insert into check_sql values(2962,'delete from transaction_total_check where cny = 2962 and jpy = 296200 and gbp = 2073.4 and eur = 328782 and  hkd = 2665.8','')")

    con:query("insert into check_sql values(2963,'delete from transaction_total_check where cny = 2963 and jpy = 296300 and gbp = 2074.1 and eur = 328893 and  hkd = 2666.7','')")

    con:query("insert into check_sql values(2964,'delete from transaction_total_check where cny = 2964 and jpy = 296400 and gbp = 2074.8 and eur = 329004 and  hkd = 2667.6','')")

    con:query("insert into check_sql values(2965,'delete from transaction_total_check where cny = 2965 and jpy = 296500 and gbp = 2075.5 and eur = 329115 and  hkd = 2668.5','')")

    con:query("insert into check_sql values(2966,'delete from transaction_total_check where cny = 2966 and jpy = 296600 and gbp = 2076.2 and eur = 329226 and  hkd = 2669.4','')")

    con:query("insert into check_sql values(2967,'delete from transaction_total_check where cny = 2967 and jpy = 296700 and gbp = 2076.9 and eur = 329337 and  hkd = 2670.3','')")

    con:query("insert into check_sql values(2968,'delete from transaction_total_check where cny = 2968 and jpy = 296800 and gbp = 2077.6 and eur = 329448 and  hkd = 2671.2','')")

    con:query("insert into check_sql values(2969,'delete from transaction_total_check where cny = 2969 and jpy = 296900 and gbp = 2078.3 and eur = 329559 and  hkd = 2672.1','')")

    con:query("insert into check_sql values(2970,'delete from transaction_total_check where cny = 2970 and jpy = 297000 and gbp = 2079.0 and eur = 329670 and  hkd = 2673.0','')")

    con:query("insert into check_sql values(2971,'delete from transaction_total_check where cny = 2971 and jpy = 297100 and gbp = 2079.7 and eur = 329781 and  hkd = 2673.9','')")

    con:query("insert into check_sql values(2972,'delete from transaction_total_check where cny = 2972 and jpy = 297200 and gbp = 2080.4 and eur = 329892 and  hkd = 2674.8','')")

    con:query("insert into check_sql values(2973,'delete from transaction_total_check where cny = 2973 and jpy = 297300 and gbp = 2081.1 and eur = 330003 and  hkd = 2675.7','')")

    con:query("insert into check_sql values(2974,'delete from transaction_total_check where cny = 2974 and jpy = 297400 and gbp = 2081.8 and eur = 330114 and  hkd = 2676.6','')")

    con:query("insert into check_sql values(2975,'delete from transaction_total_check where cny = 2975 and jpy = 297500 and gbp = 2082.5 and eur = 330225 and  hkd = 2677.5','')")

    con:query("insert into check_sql values(2976,'delete from transaction_total_check where cny = 2976 and jpy = 297600 and gbp = 2083.2 and eur = 330336 and  hkd = 2678.4','')")

    con:query("insert into check_sql values(2977,'delete from transaction_total_check where cny = 2977 and jpy = 297700 and gbp = 2083.9 and eur = 330447 and  hkd = 2679.3','')")

    con:query("insert into check_sql values(2978,'delete from transaction_total_check where cny = 2978 and jpy = 297800 and gbp = 2084.6 and eur = 330558 and  hkd = 2680.2','')")

    con:query("insert into check_sql values(2979,'delete from transaction_total_check where cny = 2979 and jpy = 297900 and gbp = 2085.3 and eur = 330669 and  hkd = 2681.1','')")

    con:query("insert into check_sql values(2980,'delete from transaction_total_check where cny = 2980 and jpy = 298000 and gbp = 2086.0 and eur = 330780 and  hkd = 2682.0','')")

    con:query("insert into check_sql values(2981,'delete from transaction_total_check where cny = 2981 and jpy = 298100 and gbp = 2086.7 and eur = 330891 and  hkd = 2682.9','')")

    con:query("insert into check_sql values(2982,'delete from transaction_total_check where cny = 2982 and jpy = 298200 and gbp = 2087.4 and eur = 331002 and  hkd = 2683.8','')")

    con:query("insert into check_sql values(2983,'delete from transaction_total_check where cny = 2983 and jpy = 298300 and gbp = 2088.1 and eur = 331113 and  hkd = 2684.7','')")

    con:query("insert into check_sql values(2984,'delete from transaction_total_check where cny = 2984 and jpy = 298400 and gbp = 2088.8 and eur = 331224 and  hkd = 2685.6','')")

    con:query("insert into check_sql values(2985,'delete from transaction_total_check where cny = 2985 and jpy = 298500 and gbp = 2089.5 and eur = 331335 and  hkd = 2686.5','')")

    con:query("insert into check_sql values(2986,'delete from transaction_total_check where cny = 2986 and jpy = 298600 and gbp = 2090.2 and eur = 331446 and  hkd = 2687.4','')")

    con:query("insert into check_sql values(2987,'delete from transaction_total_check where cny = 2987 and jpy = 298700 and gbp = 2090.9 and eur = 331557 and  hkd = 2688.3','')")

    con:query("insert into check_sql values(2988,'delete from transaction_total_check where cny = 2988 and jpy = 298800 and gbp = 2091.6 and eur = 331668 and  hkd = 2689.2','')")

    con:query("insert into check_sql values(2989,'delete from transaction_total_check where cny = 2989 and jpy = 298900 and gbp = 2092.3 and eur = 331779 and  hkd = 2690.1','')")

    con:query("insert into check_sql values(2990,'delete from transaction_total_check where cny = 2990 and jpy = 299000 and gbp = 2093.0 and eur = 331890 and  hkd = 2691.0','')")

    con:query("insert into check_sql values(2991,'delete from transaction_total_check where cny = 2991 and jpy = 299100 and gbp = 2093.7 and eur = 332001 and  hkd = 2691.9','')")

    con:query("insert into check_sql values(2992,'delete from transaction_total_check where cny = 2992 and jpy = 299200 and gbp = 2094.4 and eur = 332112 and  hkd = 2692.8','')")

    con:query("insert into check_sql values(2993,'delete from transaction_total_check where cny = 2993 and jpy = 299300 and gbp = 2095.1 and eur = 332223 and  hkd = 2693.7','')")

    con:query("insert into check_sql values(2994,'delete from transaction_total_check where cny = 2994 and jpy = 299400 and gbp = 2095.8 and eur = 332334 and  hkd = 2694.6','')")

    con:query("insert into check_sql values(2995,'delete from transaction_total_check where cny = 2995 and jpy = 299500 and gbp = 2096.5 and eur = 332445 and  hkd = 2695.5','')")

    con:query("insert into check_sql values(2996,'delete from transaction_total_check where cny = 2996 and jpy = 299600 and gbp = 2097.2 and eur = 332556 and  hkd = 2696.4','')")

    con:query("insert into check_sql values(2997,'delete from transaction_total_check where cny = 2997 and jpy = 299700 and gbp = 2097.9 and eur = 332667 and  hkd = 2697.3','')")

    con:query("insert into check_sql values(2998,'delete from transaction_total_check where cny = 2998 and jpy = 299800 and gbp = 2098.6 and eur = 332778 and  hkd = 2698.2','')")

    con:query("insert into check_sql values(2999,'delete from transaction_total_check where cny = 2999 and jpy = 299900 and gbp = 2099.3 and eur = 332889 and  hkd = 2699.1','')")

    con:query("insert into check_sql values(3000,'delete from transaction_total_check where cny = 3000 and jpy = 300000 and gbp = 2100.0 and eur = 333000 and  hkd = 2700.0','')")

    con:query("insert into check_sql values(3001,'delete from transaction_total_check where cny = 3001 and jpy = 300100 and gbp = 2100.7 and eur = 333111 and  hkd = 2700.9','')")

    con:query("insert into check_sql values(3002,'delete from transaction_total_check where cny = 3002 and jpy = 300200 and gbp = 2101.4 and eur = 333222 and  hkd = 2701.8','')")

    con:query("insert into check_sql values(3003,'delete from transaction_total_check where cny = 3003 and jpy = 300300 and gbp = 2102.1 and eur = 333333 and  hkd = 2702.7','')")

    con:query("insert into check_sql values(3004,'delete from transaction_total_check where cny = 3004 and jpy = 300400 and gbp = 2102.8 and eur = 333444 and  hkd = 2703.6','')")

    con:query("insert into check_sql values(3005,'delete from transaction_total_check where cny = 3005 and jpy = 300500 and gbp = 2103.5 and eur = 333555 and  hkd = 2704.5','')")

    con:query("insert into check_sql values(3006,'delete from transaction_total_check where cny = 3006 and jpy = 300600 and gbp = 2104.2 and eur = 333666 and  hkd = 2705.4','')")

    con:query("insert into check_sql values(3007,'delete from transaction_total_check where cny = 3007 and jpy = 300700 and gbp = 2104.9 and eur = 333777 and  hkd = 2706.3','')")

    con:query("insert into check_sql values(3008,'delete from transaction_total_check where cny = 3008 and jpy = 300800 and gbp = 2105.6 and eur = 333888 and  hkd = 2707.2','')")

    con:query("insert into check_sql values(3009,'delete from transaction_total_check where cny = 3009 and jpy = 300900 and gbp = 2106.3 and eur = 333999 and  hkd = 2708.1','')")

    con:query("insert into check_sql values(3010,'delete from transaction_total_check where cny = 3010 and jpy = 301000 and gbp = 2107.0 and eur = 334110 and  hkd = 2709.0','')")

    con:query("insert into check_sql values(3011,'delete from transaction_total_check where cny = 3011 and jpy = 301100 and gbp = 2107.7 and eur = 334221 and  hkd = 2709.9','')")

    con:query("insert into check_sql values(3012,'delete from transaction_total_check where cny = 3012 and jpy = 301200 and gbp = 2108.4 and eur = 334332 and  hkd = 2710.8','')")

    con:query("insert into check_sql values(3013,'delete from transaction_total_check where cny = 3013 and jpy = 301300 and gbp = 2109.1 and eur = 334443 and  hkd = 2711.7','')")

    con:query("insert into check_sql values(3014,'delete from transaction_total_check where cny = 3014 and jpy = 301400 and gbp = 2109.8 and eur = 334554 and  hkd = 2712.6','')")

    con:query("insert into check_sql values(3015,'delete from transaction_total_check where cny = 3015 and jpy = 301500 and gbp = 2110.5 and eur = 334665 and  hkd = 2713.5','')")

    con:query("insert into check_sql values(3016,'delete from transaction_total_check where cny = 3016 and jpy = 301600 and gbp = 2111.2 and eur = 334776 and  hkd = 2714.4','')")

    con:query("insert into check_sql values(3017,'delete from transaction_total_check where cny = 3017 and jpy = 301700 and gbp = 2111.9 and eur = 334887 and  hkd = 2715.3','')")

    con:query("insert into check_sql values(3018,'delete from transaction_total_check where cny = 3018 and jpy = 301800 and gbp = 2112.6 and eur = 334998 and  hkd = 2716.2','')")

    con:query("insert into check_sql values(3019,'delete from transaction_total_check where cny = 3019 and jpy = 301900 and gbp = 2113.3 and eur = 335109 and  hkd = 2717.1','')")

    con:query("insert into check_sql values(3020,'delete from transaction_total_check where cny = 3020 and jpy = 302000 and gbp = 2114.0 and eur = 335220 and  hkd = 2718.0','')")

    con:query("insert into check_sql values(3021,'delete from transaction_total_check where cny = 3021 and jpy = 302100 and gbp = 2114.7 and eur = 335331 and  hkd = 2718.9','')")

    con:query("insert into check_sql values(3022,'delete from transaction_total_check where cny = 3022 and jpy = 302200 and gbp = 2115.4 and eur = 335442 and  hkd = 2719.8','')")

    con:query("insert into check_sql values(3023,'delete from transaction_total_check where cny = 3023 and jpy = 302300 and gbp = 2116.1 and eur = 335553 and  hkd = 2720.7','')")

    con:query("insert into check_sql values(3024,'delete from transaction_total_check where cny = 3024 and jpy = 302400 and gbp = 2116.8 and eur = 335664 and  hkd = 2721.6','')")

    con:query("insert into check_sql values(3025,'delete from transaction_total_check where cny = 3025 and jpy = 302500 and gbp = 2117.5 and eur = 335775 and  hkd = 2722.5','')")

    con:query("insert into check_sql values(3026,'delete from transaction_total_check where cny = 3026 and jpy = 302600 and gbp = 2118.2 and eur = 335886 and  hkd = 2723.4','')")

    con:query("insert into check_sql values(3027,'delete from transaction_total_check where cny = 3027 and jpy = 302700 and gbp = 2118.9 and eur = 335997 and  hkd = 2724.3','')")

    con:query("insert into check_sql values(3028,'delete from transaction_total_check where cny = 3028 and jpy = 302800 and gbp = 2119.6 and eur = 336108 and  hkd = 2725.2','')")

    con:query("insert into check_sql values(3029,'delete from transaction_total_check where cny = 3029 and jpy = 302900 and gbp = 2120.3 and eur = 336219 and  hkd = 2726.1','')")

    con:query("insert into check_sql values(3030,'delete from transaction_total_check where cny = 3030 and jpy = 303000 and gbp = 2121.0 and eur = 336330 and  hkd = 2727.0','')")

    con:query("insert into check_sql values(3031,'delete from transaction_total_check where cny = 3031 and jpy = 303100 and gbp = 2121.7 and eur = 336441 and  hkd = 2727.9','')")

    con:query("insert into check_sql values(3032,'delete from transaction_total_check where cny = 3032 and jpy = 303200 and gbp = 2122.4 and eur = 336552 and  hkd = 2728.8','')")

    con:query("insert into check_sql values(3033,'delete from transaction_total_check where cny = 3033 and jpy = 303300 and gbp = 2123.1 and eur = 336663 and  hkd = 2729.7','')")

    con:query("insert into check_sql values(3034,'delete from transaction_total_check where cny = 3034 and jpy = 303400 and gbp = 2123.8 and eur = 336774 and  hkd = 2730.6','')")

    con:query("insert into check_sql values(3035,'delete from transaction_total_check where cny = 3035 and jpy = 303500 and gbp = 2124.5 and eur = 336885 and  hkd = 2731.5','')")

    con:query("insert into check_sql values(3036,'delete from transaction_total_check where cny = 3036 and jpy = 303600 and gbp = 2125.2 and eur = 336996 and  hkd = 2732.4','')")

    con:query("insert into check_sql values(3037,'delete from transaction_total_check where cny = 3037 and jpy = 303700 and gbp = 2125.9 and eur = 337107 and  hkd = 2733.3','')")

    con:query("insert into check_sql values(3038,'delete from transaction_total_check where cny = 3038 and jpy = 303800 and gbp = 2126.6 and eur = 337218 and  hkd = 2734.2','')")

    con:query("insert into check_sql values(3039,'delete from transaction_total_check where cny = 3039 and jpy = 303900 and gbp = 2127.3 and eur = 337329 and  hkd = 2735.1','')")

    con:query("insert into check_sql values(3040,'delete from transaction_total_check where cny = 3040 and jpy = 304000 and gbp = 2128.0 and eur = 337440 and  hkd = 2736.0','')")

    con:query("insert into check_sql values(3041,'delete from transaction_total_check where cny = 3041 and jpy = 304100 and gbp = 2128.7 and eur = 337551 and  hkd = 2736.9','')")

    con:query("insert into check_sql values(3042,'delete from transaction_total_check where cny = 3042 and jpy = 304200 and gbp = 2129.4 and eur = 337662 and  hkd = 2737.8','')")

    con:query("insert into check_sql values(3043,'delete from transaction_total_check where cny = 3043 and jpy = 304300 and gbp = 2130.1 and eur = 337773 and  hkd = 2738.7','')")

    con:query("insert into check_sql values(3044,'delete from transaction_total_check where cny = 3044 and jpy = 304400 and gbp = 2130.8 and eur = 337884 and  hkd = 2739.6','')")

    con:query("insert into check_sql values(3045,'delete from transaction_total_check where cny = 3045 and jpy = 304500 and gbp = 2131.5 and eur = 337995 and  hkd = 2740.5','')")

    con:query("insert into check_sql values(3046,'delete from transaction_total_check where cny = 3046 and jpy = 304600 and gbp = 2132.2 and eur = 338106 and  hkd = 2741.4','')")

    con:query("insert into check_sql values(3047,'delete from transaction_total_check where cny = 3047 and jpy = 304700 and gbp = 2132.9 and eur = 338217 and  hkd = 2742.3','')")

    con:query("insert into check_sql values(3048,'delete from transaction_total_check where cny = 3048 and jpy = 304800 and gbp = 2133.6 and eur = 338328 and  hkd = 2743.2','')")

    con:query("insert into check_sql values(3049,'delete from transaction_total_check where cny = 3049 and jpy = 304900 and gbp = 2134.3 and eur = 338439 and  hkd = 2744.1','')")

    con:query("insert into check_sql values(3050,'delete from transaction_total_check where cny = 3050 and jpy = 305000 and gbp = 2135.0 and eur = 338550 and  hkd = 2745.0','')")

    con:query("insert into check_sql values(3051,'delete from transaction_total_check where cny = 3051 and jpy = 305100 and gbp = 2135.7 and eur = 338661 and  hkd = 2745.9','')")

    con:query("insert into check_sql values(3052,'delete from transaction_total_check where cny = 3052 and jpy = 305200 and gbp = 2136.4 and eur = 338772 and  hkd = 2746.8','')")

    con:query("insert into check_sql values(3053,'delete from transaction_total_check where cny = 3053 and jpy = 305300 and gbp = 2137.1 and eur = 338883 and  hkd = 2747.7','')")

    con:query("insert into check_sql values(3054,'delete from transaction_total_check where cny = 3054 and jpy = 305400 and gbp = 2137.8 and eur = 338994 and  hkd = 2748.6','')")

    con:query("insert into check_sql values(3055,'delete from transaction_total_check where cny = 3055 and jpy = 305500 and gbp = 2138.5 and eur = 339105 and  hkd = 2749.5','')")

    con:query("insert into check_sql values(3056,'delete from transaction_total_check where cny = 3056 and jpy = 305600 and gbp = 2139.2 and eur = 339216 and  hkd = 2750.4','')")

    con:query("insert into check_sql values(3057,'delete from transaction_total_check where cny = 3057 and jpy = 305700 and gbp = 2139.9 and eur = 339327 and  hkd = 2751.3','')")

    con:query("insert into check_sql values(3058,'delete from transaction_total_check where cny = 3058 and jpy = 305800 and gbp = 2140.6 and eur = 339438 and  hkd = 2752.2','')")

    con:query("insert into check_sql values(3059,'delete from transaction_total_check where cny = 3059 and jpy = 305900 and gbp = 2141.3 and eur = 339549 and  hkd = 2753.1','')")

    con:query("insert into check_sql values(3060,'delete from transaction_total_check where cny = 3060 and jpy = 306000 and gbp = 2142.0 and eur = 339660 and  hkd = 2754.0','')")

    con:query("insert into check_sql values(3061,'delete from transaction_total_check where cny = 3061 and jpy = 306100 and gbp = 2142.7 and eur = 339771 and  hkd = 2754.9','')")

    con:query("insert into check_sql values(3062,'delete from transaction_total_check where cny = 3062 and jpy = 306200 and gbp = 2143.4 and eur = 339882 and  hkd = 2755.8','')")

    con:query("insert into check_sql values(3063,'delete from transaction_total_check where cny = 3063 and jpy = 306300 and gbp = 2144.1 and eur = 339993 and  hkd = 2756.7','')")

    con:query("insert into check_sql values(3064,'delete from transaction_total_check where cny = 3064 and jpy = 306400 and gbp = 2144.8 and eur = 340104 and  hkd = 2757.6','')")

    con:query("insert into check_sql values(3065,'delete from transaction_total_check where cny = 3065 and jpy = 306500 and gbp = 2145.5 and eur = 340215 and  hkd = 2758.5','')")

    con:query("insert into check_sql values(3066,'delete from transaction_total_check where cny = 3066 and jpy = 306600 and gbp = 2146.2 and eur = 340326 and  hkd = 2759.4','')")

    con:query("insert into check_sql values(3067,'delete from transaction_total_check where cny = 3067 and jpy = 306700 and gbp = 2146.9 and eur = 340437 and  hkd = 2760.3','')")

    con:query("insert into check_sql values(3068,'delete from transaction_total_check where cny = 3068 and jpy = 306800 and gbp = 2147.6 and eur = 340548 and  hkd = 2761.2','')")

    con:query("insert into check_sql values(3069,'delete from transaction_total_check where cny = 3069 and jpy = 306900 and gbp = 2148.3 and eur = 340659 and  hkd = 2762.1','')")

    con:query("insert into check_sql values(3070,'delete from transaction_total_check where cny = 3070 and jpy = 307000 and gbp = 2149.0 and eur = 340770 and  hkd = 2763.0','')")

    con:query("insert into check_sql values(3071,'delete from transaction_total_check where cny = 3071 and jpy = 307100 and gbp = 2149.7 and eur = 340881 and  hkd = 2763.9','')")

    con:query("insert into check_sql values(3072,'delete from transaction_total_check where cny = 3072 and jpy = 307200 and gbp = 2150.4 and eur = 340992 and  hkd = 2764.8','')")

    con:query("insert into check_sql values(3073,'delete from transaction_total_check where cny = 3073 and jpy = 307300 and gbp = 2151.1 and eur = 341103 and  hkd = 2765.7','')")

    con:query("insert into check_sql values(3074,'delete from transaction_total_check where cny = 3074 and jpy = 307400 and gbp = 2151.8 and eur = 341214 and  hkd = 2766.6','')")

    con:query("insert into check_sql values(3075,'delete from transaction_total_check where cny = 3075 and jpy = 307500 and gbp = 2152.5 and eur = 341325 and  hkd = 2767.5','')")

    con:query("insert into check_sql values(3076,'delete from transaction_total_check where cny = 3076 and jpy = 307600 and gbp = 2153.2 and eur = 341436 and  hkd = 2768.4','')")

    con:query("insert into check_sql values(3077,'delete from transaction_total_check where cny = 3077 and jpy = 307700 and gbp = 2153.9 and eur = 341547 and  hkd = 2769.3','')")

    con:query("insert into check_sql values(3078,'delete from transaction_total_check where cny = 3078 and jpy = 307800 and gbp = 2154.6 and eur = 341658 and  hkd = 2770.2','')")

    con:query("insert into check_sql values(3079,'delete from transaction_total_check where cny = 3079 and jpy = 307900 and gbp = 2155.3 and eur = 341769 and  hkd = 2771.1','')")

    con:query("insert into check_sql values(3080,'delete from transaction_total_check where cny = 3080 and jpy = 308000 and gbp = 2156.0 and eur = 341880 and  hkd = 2772.0','')")

    con:query("insert into check_sql values(3081,'delete from transaction_total_check where cny = 3081 and jpy = 308100 and gbp = 2156.7 and eur = 341991 and  hkd = 2772.9','')")

    con:query("insert into check_sql values(3082,'delete from transaction_total_check where cny = 3082 and jpy = 308200 and gbp = 2157.4 and eur = 342102 and  hkd = 2773.8','')")

    con:query("insert into check_sql values(3083,'delete from transaction_total_check where cny = 3083 and jpy = 308300 and gbp = 2158.1 and eur = 342213 and  hkd = 2774.7','')")

    con:query("insert into check_sql values(3084,'delete from transaction_total_check where cny = 3084 and jpy = 308400 and gbp = 2158.8 and eur = 342324 and  hkd = 2775.6','')")

    con:query("insert into check_sql values(3085,'delete from transaction_total_check where cny = 3085 and jpy = 308500 and gbp = 2159.5 and eur = 342435 and  hkd = 2776.5','')")

    con:query("insert into check_sql values(3086,'delete from transaction_total_check where cny = 3086 and jpy = 308600 and gbp = 2160.2 and eur = 342546 and  hkd = 2777.4','')")

    con:query("insert into check_sql values(3087,'delete from transaction_total_check where cny = 3087 and jpy = 308700 and gbp = 2160.9 and eur = 342657 and  hkd = 2778.3','')")

    con:query("insert into check_sql values(3088,'delete from transaction_total_check where cny = 3088 and jpy = 308800 and gbp = 2161.6 and eur = 342768 and  hkd = 2779.2','')")

    con:query("insert into check_sql values(3089,'delete from transaction_total_check where cny = 3089 and jpy = 308900 and gbp = 2162.3 and eur = 342879 and  hkd = 2780.1','')")

    con:query("insert into check_sql values(3090,'delete from transaction_total_check where cny = 3090 and jpy = 309000 and gbp = 2163.0 and eur = 342990 and  hkd = 2781.0','')")

    con:query("insert into check_sql values(3091,'delete from transaction_total_check where cny = 3091 and jpy = 309100 and gbp = 2163.7 and eur = 343101 and  hkd = 2781.9','')")

    con:query("insert into check_sql values(3092,'delete from transaction_total_check where cny = 3092 and jpy = 309200 and gbp = 2164.4 and eur = 343212 and  hkd = 2782.8','')")

    con:query("insert into check_sql values(3093,'delete from transaction_total_check where cny = 3093 and jpy = 309300 and gbp = 2165.1 and eur = 343323 and  hkd = 2783.7','')")

    con:query("insert into check_sql values(3094,'delete from transaction_total_check where cny = 3094 and jpy = 309400 and gbp = 2165.8 and eur = 343434 and  hkd = 2784.6','')")

    con:query("insert into check_sql values(3095,'delete from transaction_total_check where cny = 3095 and jpy = 309500 and gbp = 2166.5 and eur = 343545 and  hkd = 2785.5','')")

    con:query("insert into check_sql values(3096,'delete from transaction_total_check where cny = 3096 and jpy = 309600 and gbp = 2167.2 and eur = 343656 and  hkd = 2786.4','')")

    con:query("insert into check_sql values(3097,'delete from transaction_total_check where cny = 3097 and jpy = 309700 and gbp = 2167.9 and eur = 343767 and  hkd = 2787.3','')")

    con:query("insert into check_sql values(3098,'delete from transaction_total_check where cny = 3098 and jpy = 309800 and gbp = 2168.6 and eur = 343878 and  hkd = 2788.2','')")

    con:query("insert into check_sql values(3099,'delete from transaction_total_check where cny = 3099 and jpy = 309900 and gbp = 2169.3 and eur = 343989 and  hkd = 2789.1','')")

    con:query("insert into check_sql values(3100,'delete from transaction_total_check where cny = 3100 and jpy = 310000 and gbp = 2170.0 and eur = 344100 and  hkd = 2790.0','')")

    con:query("insert into check_sql values(3101,'delete from transaction_total_check where cny = 3101 and jpy = 310100 and gbp = 2170.7 and eur = 344211 and  hkd = 2790.9','')")

    con:query("insert into check_sql values(3102,'delete from transaction_total_check where cny = 3102 and jpy = 310200 and gbp = 2171.4 and eur = 344322 and  hkd = 2791.8','')")

    con:query("insert into check_sql values(3103,'delete from transaction_total_check where cny = 3103 and jpy = 310300 and gbp = 2172.1 and eur = 344433 and  hkd = 2792.7','')")

    con:query("insert into check_sql values(3104,'delete from transaction_total_check where cny = 3104 and jpy = 310400 and gbp = 2172.8 and eur = 344544 and  hkd = 2793.6','')")

    con:query("insert into check_sql values(3105,'delete from transaction_total_check where cny = 3105 and jpy = 310500 and gbp = 2173.5 and eur = 344655 and  hkd = 2794.5','')")

    con:query("insert into check_sql values(3106,'delete from transaction_total_check where cny = 3106 and jpy = 310600 and gbp = 2174.2 and eur = 344766 and  hkd = 2795.4','')")

    con:query("insert into check_sql values(3107,'delete from transaction_total_check where cny = 3107 and jpy = 310700 and gbp = 2174.9 and eur = 344877 and  hkd = 2796.3','')")

    con:query("insert into check_sql values(3108,'delete from transaction_total_check where cny = 3108 and jpy = 310800 and gbp = 2175.6 and eur = 344988 and  hkd = 2797.2','')")

    con:query("insert into check_sql values(3109,'delete from transaction_total_check where cny = 3109 and jpy = 310900 and gbp = 2176.3 and eur = 345099 and  hkd = 2798.1','')")

    con:query("insert into check_sql values(3110,'delete from transaction_total_check where cny = 3110 and jpy = 311000 and gbp = 2177.0 and eur = 345210 and  hkd = 2799.0','')")

    con:query("insert into check_sql values(3111,'delete from transaction_total_check where cny = 3111 and jpy = 311100 and gbp = 2177.7 and eur = 345321 and  hkd = 2799.9','')")

    con:query("insert into check_sql values(3112,'delete from transaction_total_check where cny = 3112 and jpy = 311200 and gbp = 2178.4 and eur = 345432 and  hkd = 2800.8','')")

    con:query("insert into check_sql values(3113,'delete from transaction_total_check where cny = 3113 and jpy = 311300 and gbp = 2179.1 and eur = 345543 and  hkd = 2801.7','')")

    con:query("insert into check_sql values(3114,'delete from transaction_total_check where cny = 3114 and jpy = 311400 and gbp = 2179.8 and eur = 345654 and  hkd = 2802.6','')")

    con:query("insert into check_sql values(3115,'delete from transaction_total_check where cny = 3115 and jpy = 311500 and gbp = 2180.5 and eur = 345765 and  hkd = 2803.5','')")

    con:query("insert into check_sql values(3116,'delete from transaction_total_check where cny = 3116 and jpy = 311600 and gbp = 2181.2 and eur = 345876 and  hkd = 2804.4','')")

    con:query("insert into check_sql values(3117,'delete from transaction_total_check where cny = 3117 and jpy = 311700 and gbp = 2181.9 and eur = 345987 and  hkd = 2805.3','')")

    con:query("insert into check_sql values(3118,'delete from transaction_total_check where cny = 3118 and jpy = 311800 and gbp = 2182.6 and eur = 346098 and  hkd = 2806.2','')")

    con:query("insert into check_sql values(3119,'delete from transaction_total_check where cny = 3119 and jpy = 311900 and gbp = 2183.3 and eur = 346209 and  hkd = 2807.1','')")

    con:query("insert into check_sql values(3120,'delete from transaction_total_check where cny = 3120 and jpy = 312000 and gbp = 2184.0 and eur = 346320 and  hkd = 2808.0','')")

    con:query("insert into check_sql values(3121,'delete from transaction_total_check where cny = 3121 and jpy = 312100 and gbp = 2184.7 and eur = 346431 and  hkd = 2808.9','')")

    con:query("insert into check_sql values(3122,'delete from transaction_total_check where cny = 3122 and jpy = 312200 and gbp = 2185.4 and eur = 346542 and  hkd = 2809.8','')")

    con:query("insert into check_sql values(3123,'delete from transaction_total_check where cny = 3123 and jpy = 312300 and gbp = 2186.1 and eur = 346653 and  hkd = 2810.7','')")

    con:query("insert into check_sql values(3124,'delete from transaction_total_check where cny = 3124 and jpy = 312400 and gbp = 2186.8 and eur = 346764 and  hkd = 2811.6','')")

    con:query("insert into check_sql values(3125,'delete from transaction_total_check where cny = 3125 and jpy = 312500 and gbp = 2187.5 and eur = 346875 and  hkd = 2812.5','')")

    con:query("insert into check_sql values(3126,'delete from transaction_total_check where cny = 3126 and jpy = 312600 and gbp = 2188.2 and eur = 346986 and  hkd = 2813.4','')")

    con:query("insert into check_sql values(3127,'delete from transaction_total_check where cny = 3127 and jpy = 312700 and gbp = 2188.9 and eur = 347097 and  hkd = 2814.3','')")

    con:query("insert into check_sql values(3128,'delete from transaction_total_check where cny = 3128 and jpy = 312800 and gbp = 2189.6 and eur = 347208 and  hkd = 2815.2','')")

    con:query("insert into check_sql values(3129,'delete from transaction_total_check where cny = 3129 and jpy = 312900 and gbp = 2190.3 and eur = 347319 and  hkd = 2816.1','')")

    con:query("insert into check_sql values(3130,'delete from transaction_total_check where cny = 3130 and jpy = 313000 and gbp = 2191.0 and eur = 347430 and  hkd = 2817.0','')")

    con:query("insert into check_sql values(3131,'delete from transaction_total_check where cny = 3131 and jpy = 313100 and gbp = 2191.7 and eur = 347541 and  hkd = 2817.9','')")

    con:query("insert into check_sql values(3132,'delete from transaction_total_check where cny = 3132 and jpy = 313200 and gbp = 2192.4 and eur = 347652 and  hkd = 2818.8','')")

    con:query("insert into check_sql values(3133,'delete from transaction_total_check where cny = 3133 and jpy = 313300 and gbp = 2193.1 and eur = 347763 and  hkd = 2819.7','')")

    con:query("insert into check_sql values(3134,'delete from transaction_total_check where cny = 3134 and jpy = 313400 and gbp = 2193.8 and eur = 347874 and  hkd = 2820.6','')")

    con:query("insert into check_sql values(3135,'delete from transaction_total_check where cny = 3135 and jpy = 313500 and gbp = 2194.5 and eur = 347985 and  hkd = 2821.5','')")

    con:query("insert into check_sql values(3136,'delete from transaction_total_check where cny = 3136 and jpy = 313600 and gbp = 2195.2 and eur = 348096 and  hkd = 2822.4','')")

    con:query("insert into check_sql values(3137,'delete from transaction_total_check where cny = 3137 and jpy = 313700 and gbp = 2195.9 and eur = 348207 and  hkd = 2823.3','')")

    con:query("insert into check_sql values(3138,'delete from transaction_total_check where cny = 3138 and jpy = 313800 and gbp = 2196.6 and eur = 348318 and  hkd = 2824.2','')")

    con:query("insert into check_sql values(3139,'delete from transaction_total_check where cny = 3139 and jpy = 313900 and gbp = 2197.3 and eur = 348429 and  hkd = 2825.1','')")

    con:query("insert into check_sql values(3140,'delete from transaction_total_check where cny = 3140 and jpy = 314000 and gbp = 2198.0 and eur = 348540 and  hkd = 2826.0','')")

    con:query("insert into check_sql values(3141,'delete from transaction_total_check where cny = 3141 and jpy = 314100 and gbp = 2198.7 and eur = 348651 and  hkd = 2826.9','')")

    con:query("insert into check_sql values(3142,'delete from transaction_total_check where cny = 3142 and jpy = 314200 and gbp = 2199.4 and eur = 348762 and  hkd = 2827.8','')")

    con:query("insert into check_sql values(3143,'delete from transaction_total_check where cny = 3143 and jpy = 314300 and gbp = 2200.1 and eur = 348873 and  hkd = 2828.7','')")

    con:query("insert into check_sql values(3144,'delete from transaction_total_check where cny = 3144 and jpy = 314400 and gbp = 2200.8 and eur = 348984 and  hkd = 2829.6','')")

    con:query("insert into check_sql values(3145,'delete from transaction_total_check where cny = 3145 and jpy = 314500 and gbp = 2201.5 and eur = 349095 and  hkd = 2830.5','')")

    con:query("insert into check_sql values(3146,'delete from transaction_total_check where cny = 3146 and jpy = 314600 and gbp = 2202.2 and eur = 349206 and  hkd = 2831.4','')")

    con:query("insert into check_sql values(3147,'delete from transaction_total_check where cny = 3147 and jpy = 314700 and gbp = 2202.9 and eur = 349317 and  hkd = 2832.3','')")

    con:query("insert into check_sql values(3148,'delete from transaction_total_check where cny = 3148 and jpy = 314800 and gbp = 2203.6 and eur = 349428 and  hkd = 2833.2','')")

    con:query("insert into check_sql values(3149,'delete from transaction_total_check where cny = 3149 and jpy = 314900 and gbp = 2204.3 and eur = 349539 and  hkd = 2834.1','')")

    con:query("insert into check_sql values(3150,'delete from transaction_total_check where cny = 3150 and jpy = 315000 and gbp = 2205.0 and eur = 349650 and  hkd = 2835.0','')")

    con:query("insert into check_sql values(3151,'delete from transaction_total_check where cny = 3151 and jpy = 315100 and gbp = 2205.7 and eur = 349761 and  hkd = 2835.9','')")

    con:query("insert into check_sql values(3152,'delete from transaction_total_check where cny = 3152 and jpy = 315200 and gbp = 2206.4 and eur = 349872 and  hkd = 2836.8','')")

    con:query("insert into check_sql values(3153,'delete from transaction_total_check where cny = 3153 and jpy = 315300 and gbp = 2207.1 and eur = 349983 and  hkd = 2837.7','')")

    con:query("insert into check_sql values(3154,'delete from transaction_total_check where cny = 3154 and jpy = 315400 and gbp = 2207.8 and eur = 350094 and  hkd = 2838.6','')")

    con:query("insert into check_sql values(3155,'delete from transaction_total_check where cny = 3155 and jpy = 315500 and gbp = 2208.5 and eur = 350205 and  hkd = 2839.5','')")

    con:query("insert into check_sql values(3156,'delete from transaction_total_check where cny = 3156 and jpy = 315600 and gbp = 2209.2 and eur = 350316 and  hkd = 2840.4','')")

    con:query("insert into check_sql values(3157,'delete from transaction_total_check where cny = 3157 and jpy = 315700 and gbp = 2209.9 and eur = 350427 and  hkd = 2841.3','')")

    con:query("insert into check_sql values(3158,'delete from transaction_total_check where cny = 3158 and jpy = 315800 and gbp = 2210.6 and eur = 350538 and  hkd = 2842.2','')")

    con:query("insert into check_sql values(3159,'delete from transaction_total_check where cny = 3159 and jpy = 315900 and gbp = 2211.3 and eur = 350649 and  hkd = 2843.1','')")

    con:query("insert into check_sql values(3160,'delete from transaction_total_check where cny = 3160 and jpy = 316000 and gbp = 2212.0 and eur = 350760 and  hkd = 2844.0','')")

    con:query("insert into check_sql values(3161,'delete from transaction_total_check where cny = 3161 and jpy = 316100 and gbp = 2212.7 and eur = 350871 and  hkd = 2844.9','')")

    con:query("insert into check_sql values(3162,'delete from transaction_total_check where cny = 3162 and jpy = 316200 and gbp = 2213.4 and eur = 350982 and  hkd = 2845.8','')")

    con:query("insert into check_sql values(3163,'delete from transaction_total_check where cny = 3163 and jpy = 316300 and gbp = 2214.1 and eur = 351093 and  hkd = 2846.7','')")

    con:query("insert into check_sql values(3164,'delete from transaction_total_check where cny = 3164 and jpy = 316400 and gbp = 2214.8 and eur = 351204 and  hkd = 2847.6','')")

    con:query("insert into check_sql values(3165,'delete from transaction_total_check where cny = 3165 and jpy = 316500 and gbp = 2215.5 and eur = 351315 and  hkd = 2848.5','')")

    con:query("insert into check_sql values(3166,'delete from transaction_total_check where cny = 3166 and jpy = 316600 and gbp = 2216.2 and eur = 351426 and  hkd = 2849.4','')")

    con:query("insert into check_sql values(3167,'delete from transaction_total_check where cny = 3167 and jpy = 316700 and gbp = 2216.9 and eur = 351537 and  hkd = 2850.3','')")

    con:query("insert into check_sql values(3168,'delete from transaction_total_check where cny = 3168 and jpy = 316800 and gbp = 2217.6 and eur = 351648 and  hkd = 2851.2','')")

    con:query("insert into check_sql values(3169,'delete from transaction_total_check where cny = 3169 and jpy = 316900 and gbp = 2218.3 and eur = 351759 and  hkd = 2852.1','')")

    con:query("insert into check_sql values(3170,'delete from transaction_total_check where cny = 3170 and jpy = 317000 and gbp = 2219.0 and eur = 351870 and  hkd = 2853.0','')")

    con:query("insert into check_sql values(3171,'delete from transaction_total_check where cny = 3171 and jpy = 317100 and gbp = 2219.7 and eur = 351981 and  hkd = 2853.9','')")

    con:query("insert into check_sql values(3172,'delete from transaction_total_check where cny = 3172 and jpy = 317200 and gbp = 2220.4 and eur = 352092 and  hkd = 2854.8','')")

    con:query("insert into check_sql values(3173,'delete from transaction_total_check where cny = 3173 and jpy = 317300 and gbp = 2221.1 and eur = 352203 and  hkd = 2855.7','')")

    con:query("insert into check_sql values(3174,'delete from transaction_total_check where cny = 3174 and jpy = 317400 and gbp = 2221.8 and eur = 352314 and  hkd = 2856.6','')")

    con:query("insert into check_sql values(3175,'delete from transaction_total_check where cny = 3175 and jpy = 317500 and gbp = 2222.5 and eur = 352425 and  hkd = 2857.5','')")

    con:query("insert into check_sql values(3176,'delete from transaction_total_check where cny = 3176 and jpy = 317600 and gbp = 2223.2 and eur = 352536 and  hkd = 2858.4','')")

    con:query("insert into check_sql values(3177,'delete from transaction_total_check where cny = 3177 and jpy = 317700 and gbp = 2223.9 and eur = 352647 and  hkd = 2859.3','')")

    con:query("insert into check_sql values(3178,'delete from transaction_total_check where cny = 3178 and jpy = 317800 and gbp = 2224.6 and eur = 352758 and  hkd = 2860.2','')")

    con:query("insert into check_sql values(3179,'delete from transaction_total_check where cny = 3179 and jpy = 317900 and gbp = 2225.3 and eur = 352869 and  hkd = 2861.1','')")

    con:query("insert into check_sql values(3180,'delete from transaction_total_check where cny = 3180 and jpy = 318000 and gbp = 2226.0 and eur = 352980 and  hkd = 2862.0','')")

    con:query("insert into check_sql values(3181,'delete from transaction_total_check where cny = 3181 and jpy = 318100 and gbp = 2226.7 and eur = 353091 and  hkd = 2862.9','')")

    con:query("insert into check_sql values(3182,'delete from transaction_total_check where cny = 3182 and jpy = 318200 and gbp = 2227.4 and eur = 353202 and  hkd = 2863.8','')")

    con:query("insert into check_sql values(3183,'delete from transaction_total_check where cny = 3183 and jpy = 318300 and gbp = 2228.1 and eur = 353313 and  hkd = 2864.7','')")

    con:query("insert into check_sql values(3184,'delete from transaction_total_check where cny = 3184 and jpy = 318400 and gbp = 2228.8 and eur = 353424 and  hkd = 2865.6','')")

    con:query("insert into check_sql values(3185,'delete from transaction_total_check where cny = 3185 and jpy = 318500 and gbp = 2229.5 and eur = 353535 and  hkd = 2866.5','')")

    con:query("insert into check_sql values(3186,'delete from transaction_total_check where cny = 3186 and jpy = 318600 and gbp = 2230.2 and eur = 353646 and  hkd = 2867.4','')")

    con:query("insert into check_sql values(3187,'delete from transaction_total_check where cny = 3187 and jpy = 318700 and gbp = 2230.9 and eur = 353757 and  hkd = 2868.3','')")

    con:query("insert into check_sql values(3188,'delete from transaction_total_check where cny = 3188 and jpy = 318800 and gbp = 2231.6 and eur = 353868 and  hkd = 2869.2','')")

    con:query("insert into check_sql values(3189,'delete from transaction_total_check where cny = 3189 and jpy = 318900 and gbp = 2232.3 and eur = 353979 and  hkd = 2870.1','')")

    con:query("insert into check_sql values(3190,'delete from transaction_total_check where cny = 3190 and jpy = 319000 and gbp = 2233.0 and eur = 354090 and  hkd = 2871.0','')")

    con:query("insert into check_sql values(3191,'delete from transaction_total_check where cny = 3191 and jpy = 319100 and gbp = 2233.7 and eur = 354201 and  hkd = 2871.9','')")

    con:query("insert into check_sql values(3192,'delete from transaction_total_check where cny = 3192 and jpy = 319200 and gbp = 2234.4 and eur = 354312 and  hkd = 2872.8','')")

    con:query("insert into check_sql values(3193,'delete from transaction_total_check where cny = 3193 and jpy = 319300 and gbp = 2235.1 and eur = 354423 and  hkd = 2873.7','')")

    con:query("insert into check_sql values(3194,'delete from transaction_total_check where cny = 3194 and jpy = 319400 and gbp = 2235.8 and eur = 354534 and  hkd = 2874.6','')")

    con:query("insert into check_sql values(3195,'delete from transaction_total_check where cny = 3195 and jpy = 319500 and gbp = 2236.5 and eur = 354645 and  hkd = 2875.5','')")

    con:query("insert into check_sql values(3196,'delete from transaction_total_check where cny = 3196 and jpy = 319600 and gbp = 2237.2 and eur = 354756 and  hkd = 2876.4','')")

    con:query("insert into check_sql values(3197,'delete from transaction_total_check where cny = 3197 and jpy = 319700 and gbp = 2237.9 and eur = 354867 and  hkd = 2877.3','')")

    con:query("insert into check_sql values(3198,'delete from transaction_total_check where cny = 3198 and jpy = 319800 and gbp = 2238.6 and eur = 354978 and  hkd = 2878.2','')")

    con:query("insert into check_sql values(3199,'delete from transaction_total_check where cny = 3199 and jpy = 319900 and gbp = 2239.3 and eur = 355089 and  hkd = 2879.1','')")

    con:query("insert into check_sql values(3200,'delete from transaction_total_check where cny = 3200 and jpy = 320000 and gbp = 2240.0 and eur = 355200 and  hkd = 2880.0','')")

    con:query("insert into check_sql values(3201,'delete from transaction_total_check where cny = 3201 and jpy = 320100 and gbp = 2240.7 and eur = 355311 and  hkd = 2880.9','')")

    con:query("insert into check_sql values(3202,'delete from transaction_total_check where cny = 3202 and jpy = 320200 and gbp = 2241.4 and eur = 355422 and  hkd = 2881.8','')")

    con:query("insert into check_sql values(3203,'delete from transaction_total_check where cny = 3203 and jpy = 320300 and gbp = 2242.1 and eur = 355533 and  hkd = 2882.7','')")

    con:query("insert into check_sql values(3204,'delete from transaction_total_check where cny = 3204 and jpy = 320400 and gbp = 2242.8 and eur = 355644 and  hkd = 2883.6','')")

    con:query("insert into check_sql values(3205,'delete from transaction_total_check where cny = 3205 and jpy = 320500 and gbp = 2243.5 and eur = 355755 and  hkd = 2884.5','')")

    con:query("insert into check_sql values(3206,'delete from transaction_total_check where cny = 3206 and jpy = 320600 and gbp = 2244.2 and eur = 355866 and  hkd = 2885.4','')")

    con:query("insert into check_sql values(3207,'delete from transaction_total_check where cny = 3207 and jpy = 320700 and gbp = 2244.9 and eur = 355977 and  hkd = 2886.3','')")

    con:query("insert into check_sql values(3208,'delete from transaction_total_check where cny = 3208 and jpy = 320800 and gbp = 2245.6 and eur = 356088 and  hkd = 2887.2','')")

    con:query("insert into check_sql values(3209,'delete from transaction_total_check where cny = 3209 and jpy = 320900 and gbp = 2246.3 and eur = 356199 and  hkd = 2888.1','')")

    con:query("insert into check_sql values(3210,'delete from transaction_total_check where cny = 3210 and jpy = 321000 and gbp = 2247.0 and eur = 356310 and  hkd = 2889.0','')")

    con:query("insert into check_sql values(3211,'delete from transaction_total_check where cny = 3211 and jpy = 321100 and gbp = 2247.7 and eur = 356421 and  hkd = 2889.9','')")

    con:query("insert into check_sql values(3212,'delete from transaction_total_check where cny = 3212 and jpy = 321200 and gbp = 2248.4 and eur = 356532 and  hkd = 2890.8','')")

    con:query("insert into check_sql values(3213,'delete from transaction_total_check where cny = 3213 and jpy = 321300 and gbp = 2249.1 and eur = 356643 and  hkd = 2891.7','')")

    con:query("insert into check_sql values(3214,'delete from transaction_total_check where cny = 3214 and jpy = 321400 and gbp = 2249.8 and eur = 356754 and  hkd = 2892.6','')")

    con:query("insert into check_sql values(3215,'delete from transaction_total_check where cny = 3215 and jpy = 321500 and gbp = 2250.5 and eur = 356865 and  hkd = 2893.5','')")

    con:query("insert into check_sql values(3216,'delete from transaction_total_check where cny = 3216 and jpy = 321600 and gbp = 2251.2 and eur = 356976 and  hkd = 2894.4','')")

    con:query("insert into check_sql values(3217,'delete from transaction_total_check where cny = 3217 and jpy = 321700 and gbp = 2251.9 and eur = 357087 and  hkd = 2895.3','')")

    con:query("insert into check_sql values(3218,'delete from transaction_total_check where cny = 3218 and jpy = 321800 and gbp = 2252.6 and eur = 357198 and  hkd = 2896.2','')")

    con:query("insert into check_sql values(3219,'delete from transaction_total_check where cny = 3219 and jpy = 321900 and gbp = 2253.3 and eur = 357309 and  hkd = 2897.1','')")

    con:query("insert into check_sql values(3220,'delete from transaction_total_check where cny = 3220 and jpy = 322000 and gbp = 2254.0 and eur = 357420 and  hkd = 2898.0','')")

    con:query("insert into check_sql values(3221,'delete from transaction_total_check where cny = 3221 and jpy = 322100 and gbp = 2254.7 and eur = 357531 and  hkd = 2898.9','')")

    con:query("insert into check_sql values(3222,'delete from transaction_total_check where cny = 3222 and jpy = 322200 and gbp = 2255.4 and eur = 357642 and  hkd = 2899.8','')")

    con:query("insert into check_sql values(3223,'delete from transaction_total_check where cny = 3223 and jpy = 322300 and gbp = 2256.1 and eur = 357753 and  hkd = 2900.7','')")

    con:query("insert into check_sql values(3224,'delete from transaction_total_check where cny = 3224 and jpy = 322400 and gbp = 2256.8 and eur = 357864 and  hkd = 2901.6','')")

    con:query("insert into check_sql values(3225,'delete from transaction_total_check where cny = 3225 and jpy = 322500 and gbp = 2257.5 and eur = 357975 and  hkd = 2902.5','')")

    con:query("insert into check_sql values(3226,'delete from transaction_total_check where cny = 3226 and jpy = 322600 and gbp = 2258.2 and eur = 358086 and  hkd = 2903.4','')")

    con:query("insert into check_sql values(3227,'delete from transaction_total_check where cny = 3227 and jpy = 322700 and gbp = 2258.9 and eur = 358197 and  hkd = 2904.3','')")

    con:query("insert into check_sql values(3228,'delete from transaction_total_check where cny = 3228 and jpy = 322800 and gbp = 2259.6 and eur = 358308 and  hkd = 2905.2','')")

    con:query("insert into check_sql values(3229,'delete from transaction_total_check where cny = 3229 and jpy = 322900 and gbp = 2260.3 and eur = 358419 and  hkd = 2906.1','')")

    con:query("insert into check_sql values(3230,'delete from transaction_total_check where cny = 3230 and jpy = 323000 and gbp = 2261.0 and eur = 358530 and  hkd = 2907.0','')")

    con:query("insert into check_sql values(3231,'delete from transaction_total_check where cny = 3231 and jpy = 323100 and gbp = 2261.7 and eur = 358641 and  hkd = 2907.9','')")

    con:query("insert into check_sql values(3232,'delete from transaction_total_check where cny = 3232 and jpy = 323200 and gbp = 2262.4 and eur = 358752 and  hkd = 2908.8','')")

    con:query("insert into check_sql values(3233,'delete from transaction_total_check where cny = 3233 and jpy = 323300 and gbp = 2263.1 and eur = 358863 and  hkd = 2909.7','')")

    con:query("insert into check_sql values(3234,'delete from transaction_total_check where cny = 3234 and jpy = 323400 and gbp = 2263.8 and eur = 358974 and  hkd = 2910.6','')")

    con:query("insert into check_sql values(3235,'delete from transaction_total_check where cny = 3235 and jpy = 323500 and gbp = 2264.5 and eur = 359085 and  hkd = 2911.5','')")

    con:query("insert into check_sql values(3236,'delete from transaction_total_check where cny = 3236 and jpy = 323600 and gbp = 2265.2 and eur = 359196 and  hkd = 2912.4','')")

    con:query("insert into check_sql values(3237,'delete from transaction_total_check where cny = 3237 and jpy = 323700 and gbp = 2265.9 and eur = 359307 and  hkd = 2913.3','')")

    con:query("insert into check_sql values(3238,'delete from transaction_total_check where cny = 3238 and jpy = 323800 and gbp = 2266.6 and eur = 359418 and  hkd = 2914.2','')")

    con:query("insert into check_sql values(3239,'delete from transaction_total_check where cny = 3239 and jpy = 323900 and gbp = 2267.3 and eur = 359529 and  hkd = 2915.1','')")

    con:query("insert into check_sql values(3240,'delete from transaction_total_check where cny = 3240 and jpy = 324000 and gbp = 2268.0 and eur = 359640 and  hkd = 2916.0','')")

    con:query("insert into check_sql values(3241,'delete from transaction_total_check where cny = 3241 and jpy = 324100 and gbp = 2268.7 and eur = 359751 and  hkd = 2916.9','')")

    con:query("insert into check_sql values(3242,'delete from transaction_total_check where cny = 3242 and jpy = 324200 and gbp = 2269.4 and eur = 359862 and  hkd = 2917.8','')")

    con:query("insert into check_sql values(3243,'delete from transaction_total_check where cny = 3243 and jpy = 324300 and gbp = 2270.1 and eur = 359973 and  hkd = 2918.7','')")

    con:query("insert into check_sql values(3244,'delete from transaction_total_check where cny = 3244 and jpy = 324400 and gbp = 2270.8 and eur = 360084 and  hkd = 2919.6','')")

    con:query("insert into check_sql values(3245,'delete from transaction_total_check where cny = 3245 and jpy = 324500 and gbp = 2271.5 and eur = 360195 and  hkd = 2920.5','')")

    con:query("insert into check_sql values(3246,'delete from transaction_total_check where cny = 3246 and jpy = 324600 and gbp = 2272.2 and eur = 360306 and  hkd = 2921.4','')")

    con:query("insert into check_sql values(3247,'delete from transaction_total_check where cny = 3247 and jpy = 324700 and gbp = 2272.9 and eur = 360417 and  hkd = 2922.3','')")

    con:query("insert into check_sql values(3248,'delete from transaction_total_check where cny = 3248 and jpy = 324800 and gbp = 2273.6 and eur = 360528 and  hkd = 2923.2','')")

    con:query("insert into check_sql values(3249,'delete from transaction_total_check where cny = 3249 and jpy = 324900 and gbp = 2274.3 and eur = 360639 and  hkd = 2924.1','')")

    con:query("insert into check_sql values(3250,'delete from transaction_total_check where cny = 3250 and jpy = 325000 and gbp = 2275.0 and eur = 360750 and  hkd = 2925.0','')")

    con:query("insert into check_sql values(3251,'delete from transaction_total_check where cny = 3251 and jpy = 325100 and gbp = 2275.7 and eur = 360861 and  hkd = 2925.9','')")

    con:query("insert into check_sql values(3252,'delete from transaction_total_check where cny = 3252 and jpy = 325200 and gbp = 2276.4 and eur = 360972 and  hkd = 2926.8','')")

    con:query("insert into check_sql values(3253,'delete from transaction_total_check where cny = 3253 and jpy = 325300 and gbp = 2277.1 and eur = 361083 and  hkd = 2927.7','')")

    con:query("insert into check_sql values(3254,'delete from transaction_total_check where cny = 3254 and jpy = 325400 and gbp = 2277.8 and eur = 361194 and  hkd = 2928.6','')")

    con:query("insert into check_sql values(3255,'delete from transaction_total_check where cny = 3255 and jpy = 325500 and gbp = 2278.5 and eur = 361305 and  hkd = 2929.5','')")

    con:query("insert into check_sql values(3256,'delete from transaction_total_check where cny = 3256 and jpy = 325600 and gbp = 2279.2 and eur = 361416 and  hkd = 2930.4','')")

    con:query("insert into check_sql values(3257,'delete from transaction_total_check where cny = 3257 and jpy = 325700 and gbp = 2279.9 and eur = 361527 and  hkd = 2931.3','')")

    con:query("insert into check_sql values(3258,'delete from transaction_total_check where cny = 3258 and jpy = 325800 and gbp = 2280.6 and eur = 361638 and  hkd = 2932.2','')")

    con:query("insert into check_sql values(3259,'delete from transaction_total_check where cny = 3259 and jpy = 325900 and gbp = 2281.3 and eur = 361749 and  hkd = 2933.1','')")

    con:query("insert into check_sql values(3260,'delete from transaction_total_check where cny = 3260 and jpy = 326000 and gbp = 2282.0 and eur = 361860 and  hkd = 2934.0','')")

    con:query("insert into check_sql values(3261,'delete from transaction_total_check where cny = 3261 and jpy = 326100 and gbp = 2282.7 and eur = 361971 and  hkd = 2934.9','')")

    con:query("insert into check_sql values(3262,'delete from transaction_total_check where cny = 3262 and jpy = 326200 and gbp = 2283.4 and eur = 362082 and  hkd = 2935.8','')")

    con:query("insert into check_sql values(3263,'delete from transaction_total_check where cny = 3263 and jpy = 326300 and gbp = 2284.1 and eur = 362193 and  hkd = 2936.7','')")

    con:query("insert into check_sql values(3264,'delete from transaction_total_check where cny = 3264 and jpy = 326400 and gbp = 2284.8 and eur = 362304 and  hkd = 2937.6','')")

    con:query("insert into check_sql values(3265,'delete from transaction_total_check where cny = 3265 and jpy = 326500 and gbp = 2285.5 and eur = 362415 and  hkd = 2938.5','')")

    con:query("insert into check_sql values(3266,'delete from transaction_total_check where cny = 3266 and jpy = 326600 and gbp = 2286.2 and eur = 362526 and  hkd = 2939.4','')")

    con:query("insert into check_sql values(3267,'delete from transaction_total_check where cny = 3267 and jpy = 326700 and gbp = 2286.9 and eur = 362637 and  hkd = 2940.3','')")

    con:query("insert into check_sql values(3268,'delete from transaction_total_check where cny = 3268 and jpy = 326800 and gbp = 2287.6 and eur = 362748 and  hkd = 2941.2','')")

    con:query("insert into check_sql values(3269,'delete from transaction_total_check where cny = 3269 and jpy = 326900 and gbp = 2288.3 and eur = 362859 and  hkd = 2942.1','')")

    con:query("insert into check_sql values(3270,'delete from transaction_total_check where cny = 3270 and jpy = 327000 and gbp = 2289.0 and eur = 362970 and  hkd = 2943.0','')")

    con:query("insert into check_sql values(3271,'delete from transaction_total_check where cny = 3271 and jpy = 327100 and gbp = 2289.7 and eur = 363081 and  hkd = 2943.9','')")

    con:query("insert into check_sql values(3272,'delete from transaction_total_check where cny = 3272 and jpy = 327200 and gbp = 2290.4 and eur = 363192 and  hkd = 2944.8','')")

    con:query("insert into check_sql values(3273,'delete from transaction_total_check where cny = 3273 and jpy = 327300 and gbp = 2291.1 and eur = 363303 and  hkd = 2945.7','')")

    con:query("insert into check_sql values(3274,'delete from transaction_total_check where cny = 3274 and jpy = 327400 and gbp = 2291.8 and eur = 363414 and  hkd = 2946.6','')")

    con:query("insert into check_sql values(3275,'delete from transaction_total_check where cny = 3275 and jpy = 327500 and gbp = 2292.5 and eur = 363525 and  hkd = 2947.5','')")

    con:query("insert into check_sql values(3276,'delete from transaction_total_check where cny = 3276 and jpy = 327600 and gbp = 2293.2 and eur = 363636 and  hkd = 2948.4','')")

    con:query("insert into check_sql values(3277,'delete from transaction_total_check where cny = 3277 and jpy = 327700 and gbp = 2293.9 and eur = 363747 and  hkd = 2949.3','')")

    con:query("insert into check_sql values(3278,'delete from transaction_total_check where cny = 3278 and jpy = 327800 and gbp = 2294.6 and eur = 363858 and  hkd = 2950.2','')")

    con:query("insert into check_sql values(3279,'delete from transaction_total_check where cny = 3279 and jpy = 327900 and gbp = 2295.3 and eur = 363969 and  hkd = 2951.1','')")

    con:query("insert into check_sql values(3280,'delete from transaction_total_check where cny = 3280 and jpy = 328000 and gbp = 2296.0 and eur = 364080 and  hkd = 2952.0','')")

    con:query("insert into check_sql values(3281,'delete from transaction_total_check where cny = 3281 and jpy = 328100 and gbp = 2296.7 and eur = 364191 and  hkd = 2952.9','')")

    con:query("insert into check_sql values(3282,'delete from transaction_total_check where cny = 3282 and jpy = 328200 and gbp = 2297.4 and eur = 364302 and  hkd = 2953.8','')")

    con:query("insert into check_sql values(3283,'delete from transaction_total_check where cny = 3283 and jpy = 328300 and gbp = 2298.1 and eur = 364413 and  hkd = 2954.7','')")

    con:query("insert into check_sql values(3284,'delete from transaction_total_check where cny = 3284 and jpy = 328400 and gbp = 2298.8 and eur = 364524 and  hkd = 2955.6','')")

    con:query("insert into check_sql values(3285,'delete from transaction_total_check where cny = 3285 and jpy = 328500 and gbp = 2299.5 and eur = 364635 and  hkd = 2956.5','')")

    con:query("insert into check_sql values(3286,'delete from transaction_total_check where cny = 3286 and jpy = 328600 and gbp = 2300.2 and eur = 364746 and  hkd = 2957.4','')")

    con:query("insert into check_sql values(3287,'delete from transaction_total_check where cny = 3287 and jpy = 328700 and gbp = 2300.9 and eur = 364857 and  hkd = 2958.3','')")

    con:query("insert into check_sql values(3288,'delete from transaction_total_check where cny = 3288 and jpy = 328800 and gbp = 2301.6 and eur = 364968 and  hkd = 2959.2','')")

    con:query("insert into check_sql values(3289,'delete from transaction_total_check where cny = 3289 and jpy = 328900 and gbp = 2302.3 and eur = 365079 and  hkd = 2960.1','')")

    con:query("insert into check_sql values(3290,'delete from transaction_total_check where cny = 3290 and jpy = 329000 and gbp = 2303.0 and eur = 365190 and  hkd = 2961.0','')")

    con:query("insert into check_sql values(3291,'delete from transaction_total_check where cny = 3291 and jpy = 329100 and gbp = 2303.7 and eur = 365301 and  hkd = 2961.9','')")

    con:query("insert into check_sql values(3292,'delete from transaction_total_check where cny = 3292 and jpy = 329200 and gbp = 2304.4 and eur = 365412 and  hkd = 2962.8','')")

    con:query("insert into check_sql values(3293,'delete from transaction_total_check where cny = 3293 and jpy = 329300 and gbp = 2305.1 and eur = 365523 and  hkd = 2963.7','')")

    con:query("insert into check_sql values(3294,'delete from transaction_total_check where cny = 3294 and jpy = 329400 and gbp = 2305.8 and eur = 365634 and  hkd = 2964.6','')")

    con:query("insert into check_sql values(3295,'delete from transaction_total_check where cny = 3295 and jpy = 329500 and gbp = 2306.5 and eur = 365745 and  hkd = 2965.5','')")

    con:query("insert into check_sql values(3296,'delete from transaction_total_check where cny = 3296 and jpy = 329600 and gbp = 2307.2 and eur = 365856 and  hkd = 2966.4','')")

    con:query("insert into check_sql values(3297,'delete from transaction_total_check where cny = 3297 and jpy = 329700 and gbp = 2307.9 and eur = 365967 and  hkd = 2967.3','')")

    con:query("insert into check_sql values(3298,'delete from transaction_total_check where cny = 3298 and jpy = 329800 and gbp = 2308.6 and eur = 366078 and  hkd = 2968.2','')")

    con:query("insert into check_sql values(3299,'delete from transaction_total_check where cny = 3299 and jpy = 329900 and gbp = 2309.3 and eur = 366189 and  hkd = 2969.1','')")

    con:query("insert into check_sql values(3300,'delete from transaction_total_check where cny = 3300 and jpy = 330000 and gbp = 2310.0 and eur = 366300 and  hkd = 2970.0','')")

    con:query("insert into check_sql values(3301,'delete from transaction_total_check where cny = 3301 and jpy = 330100 and gbp = 2310.7 and eur = 366411 and  hkd = 2970.9','')")

    con:query("insert into check_sql values(3302,'delete from transaction_total_check where cny = 3302 and jpy = 330200 and gbp = 2311.4 and eur = 366522 and  hkd = 2971.8','')")

    con:query("insert into check_sql values(3303,'delete from transaction_total_check where cny = 3303 and jpy = 330300 and gbp = 2312.1 and eur = 366633 and  hkd = 2972.7','')")

    con:query("insert into check_sql values(3304,'delete from transaction_total_check where cny = 3304 and jpy = 330400 and gbp = 2312.8 and eur = 366744 and  hkd = 2973.6','')")

    con:query("insert into check_sql values(3305,'delete from transaction_total_check where cny = 3305 and jpy = 330500 and gbp = 2313.5 and eur = 366855 and  hkd = 2974.5','')")

    con:query("insert into check_sql values(3306,'delete from transaction_total_check where cny = 3306 and jpy = 330600 and gbp = 2314.2 and eur = 366966 and  hkd = 2975.4','')")

    con:query("insert into check_sql values(3307,'delete from transaction_total_check where cny = 3307 and jpy = 330700 and gbp = 2314.9 and eur = 367077 and  hkd = 2976.3','')")

    con:query("insert into check_sql values(3308,'delete from transaction_total_check where cny = 3308 and jpy = 330800 and gbp = 2315.6 and eur = 367188 and  hkd = 2977.2','')")

    con:query("insert into check_sql values(3309,'delete from transaction_total_check where cny = 3309 and jpy = 330900 and gbp = 2316.3 and eur = 367299 and  hkd = 2978.1','')")

    con:query("insert into check_sql values(3310,'delete from transaction_total_check where cny = 3310 and jpy = 331000 and gbp = 2317.0 and eur = 367410 and  hkd = 2979.0','')")

    con:query("insert into check_sql values(3311,'delete from transaction_total_check where cny = 3311 and jpy = 331100 and gbp = 2317.7 and eur = 367521 and  hkd = 2979.9','')")

    con:query("insert into check_sql values(3312,'delete from transaction_total_check where cny = 3312 and jpy = 331200 and gbp = 2318.4 and eur = 367632 and  hkd = 2980.8','')")

    con:query("insert into check_sql values(3313,'delete from transaction_total_check where cny = 3313 and jpy = 331300 and gbp = 2319.1 and eur = 367743 and  hkd = 2981.7','')")

    con:query("insert into check_sql values(3314,'delete from transaction_total_check where cny = 3314 and jpy = 331400 and gbp = 2319.8 and eur = 367854 and  hkd = 2982.6','')")

    con:query("insert into check_sql values(3315,'delete from transaction_total_check where cny = 3315 and jpy = 331500 and gbp = 2320.5 and eur = 367965 and  hkd = 2983.5','')")

    con:query("insert into check_sql values(3316,'delete from transaction_total_check where cny = 3316 and jpy = 331600 and gbp = 2321.2 and eur = 368076 and  hkd = 2984.4','')")

    con:query("insert into check_sql values(3317,'delete from transaction_total_check where cny = 3317 and jpy = 331700 and gbp = 2321.9 and eur = 368187 and  hkd = 2985.3','')")

    con:query("insert into check_sql values(3318,'delete from transaction_total_check where cny = 3318 and jpy = 331800 and gbp = 2322.6 and eur = 368298 and  hkd = 2986.2','')")

    con:query("insert into check_sql values(3319,'delete from transaction_total_check where cny = 3319 and jpy = 331900 and gbp = 2323.3 and eur = 368409 and  hkd = 2987.1','')")

    con:query("insert into check_sql values(3320,'delete from transaction_total_check where cny = 3320 and jpy = 332000 and gbp = 2324.0 and eur = 368520 and  hkd = 2988.0','')")

    con:query("insert into check_sql values(3321,'delete from transaction_total_check where cny = 3321 and jpy = 332100 and gbp = 2324.7 and eur = 368631 and  hkd = 2988.9','')")

    con:query("insert into check_sql values(3322,'delete from transaction_total_check where cny = 3322 and jpy = 332200 and gbp = 2325.4 and eur = 368742 and  hkd = 2989.8','')")

    con:query("insert into check_sql values(3323,'delete from transaction_total_check where cny = 3323 and jpy = 332300 and gbp = 2326.1 and eur = 368853 and  hkd = 2990.7','')")

    con:query("insert into check_sql values(3324,'delete from transaction_total_check where cny = 3324 and jpy = 332400 and gbp = 2326.8 and eur = 368964 and  hkd = 2991.6','')")

    con:query("insert into check_sql values(3325,'delete from transaction_total_check where cny = 3325 and jpy = 332500 and gbp = 2327.5 and eur = 369075 and  hkd = 2992.5','')")

    con:query("insert into check_sql values(3326,'delete from transaction_total_check where cny = 3326 and jpy = 332600 and gbp = 2328.2 and eur = 369186 and  hkd = 2993.4','')")

    con:query("insert into check_sql values(3327,'delete from transaction_total_check where cny = 3327 and jpy = 332700 and gbp = 2328.9 and eur = 369297 and  hkd = 2994.3','')")

    con:query("insert into check_sql values(3328,'delete from transaction_total_check where cny = 3328 and jpy = 332800 and gbp = 2329.6 and eur = 369408 and  hkd = 2995.2','')")

    con:query("insert into check_sql values(3329,'delete from transaction_total_check where cny = 3329 and jpy = 332900 and gbp = 2330.3 and eur = 369519 and  hkd = 2996.1','')")

    con:query("insert into check_sql values(3330,'delete from transaction_total_check where cny = 3330 and jpy = 333000 and gbp = 2331.0 and eur = 369630 and  hkd = 2997.0','')")

    con:query("insert into check_sql values(3331,'delete from transaction_total_check where cny = 3331 and jpy = 333100 and gbp = 2331.7 and eur = 369741 and  hkd = 2997.9','')")

    con:query("insert into check_sql values(3332,'delete from transaction_total_check where cny = 3332 and jpy = 333200 and gbp = 2332.4 and eur = 369852 and  hkd = 2998.8','')")

    con:query("insert into check_sql values(3333,'delete from transaction_total_check where cny = 3333 and jpy = 333300 and gbp = 2333.1 and eur = 369963 and  hkd = 2999.7','')")

    con:query("insert into check_sql values(3334,'delete from transaction_total_check where cny = 3334 and jpy = 333400 and gbp = 2333.8 and eur = 370074 and  hkd = 3000.6','')")

    con:query("insert into check_sql values(3335,'delete from transaction_total_check where cny = 3335 and jpy = 333500 and gbp = 2334.5 and eur = 370185 and  hkd = 3001.5','')")

    con:query("insert into check_sql values(3336,'delete from transaction_total_check where cny = 3336 and jpy = 333600 and gbp = 2335.2 and eur = 370296 and  hkd = 3002.4','')")

    con:query("insert into check_sql values(3337,'delete from transaction_total_check where cny = 3337 and jpy = 333700 and gbp = 2335.9 and eur = 370407 and  hkd = 3003.3','')")

    con:query("insert into check_sql values(3338,'delete from transaction_total_check where cny = 3338 and jpy = 333800 and gbp = 2336.6 and eur = 370518 and  hkd = 3004.2','')")

    con:query("insert into check_sql values(3339,'delete from transaction_total_check where cny = 3339 and jpy = 333900 and gbp = 2337.3 and eur = 370629 and  hkd = 3005.1','')")

    con:query("insert into check_sql values(3340,'delete from transaction_total_check where cny = 3340 and jpy = 334000 and gbp = 2338.0 and eur = 370740 and  hkd = 3006.0','')")

    con:query("insert into check_sql values(3341,'delete from transaction_total_check where cny = 3341 and jpy = 334100 and gbp = 2338.7 and eur = 370851 and  hkd = 3006.9','')")

    con:query("insert into check_sql values(3342,'delete from transaction_total_check where cny = 3342 and jpy = 334200 and gbp = 2339.4 and eur = 370962 and  hkd = 3007.8','')")

    con:query("insert into check_sql values(3343,'delete from transaction_total_check where cny = 3343 and jpy = 334300 and gbp = 2340.1 and eur = 371073 and  hkd = 3008.7','')")

    con:query("insert into check_sql values(3344,'delete from transaction_total_check where cny = 3344 and jpy = 334400 and gbp = 2340.8 and eur = 371184 and  hkd = 3009.6','')")

    con:query("insert into check_sql values(3345,'delete from transaction_total_check where cny = 3345 and jpy = 334500 and gbp = 2341.5 and eur = 371295 and  hkd = 3010.5','')")

    con:query("insert into check_sql values(3346,'delete from transaction_total_check where cny = 3346 and jpy = 334600 and gbp = 2342.2 and eur = 371406 and  hkd = 3011.4','')")

    con:query("insert into check_sql values(3347,'delete from transaction_total_check where cny = 3347 and jpy = 334700 and gbp = 2342.9 and eur = 371517 and  hkd = 3012.3','')")

    con:query("insert into check_sql values(3348,'delete from transaction_total_check where cny = 3348 and jpy = 334800 and gbp = 2343.6 and eur = 371628 and  hkd = 3013.2','')")

    con:query("insert into check_sql values(3349,'delete from transaction_total_check where cny = 3349 and jpy = 334900 and gbp = 2344.3 and eur = 371739 and  hkd = 3014.1','')")

    con:query("insert into check_sql values(3350,'delete from transaction_total_check where cny = 3350 and jpy = 335000 and gbp = 2345.0 and eur = 371850 and  hkd = 3015.0','')")

    con:query("insert into check_sql values(3351,'delete from transaction_total_check where cny = 3351 and jpy = 335100 and gbp = 2345.7 and eur = 371961 and  hkd = 3015.9','')")

    con:query("insert into check_sql values(3352,'delete from transaction_total_check where cny = 3352 and jpy = 335200 and gbp = 2346.4 and eur = 372072 and  hkd = 3016.8','')")

    con:query("insert into check_sql values(3353,'delete from transaction_total_check where cny = 3353 and jpy = 335300 and gbp = 2347.1 and eur = 372183 and  hkd = 3017.7','')")

    con:query("insert into check_sql values(3354,'delete from transaction_total_check where cny = 3354 and jpy = 335400 and gbp = 2347.8 and eur = 372294 and  hkd = 3018.6','')")

    con:query("insert into check_sql values(3355,'delete from transaction_total_check where cny = 3355 and jpy = 335500 and gbp = 2348.5 and eur = 372405 and  hkd = 3019.5','')")

    con:query("insert into check_sql values(3356,'delete from transaction_total_check where cny = 3356 and jpy = 335600 and gbp = 2349.2 and eur = 372516 and  hkd = 3020.4','')")

    con:query("insert into check_sql values(3357,'delete from transaction_total_check where cny = 3357 and jpy = 335700 and gbp = 2349.9 and eur = 372627 and  hkd = 3021.3','')")

    con:query("insert into check_sql values(3358,'delete from transaction_total_check where cny = 3358 and jpy = 335800 and gbp = 2350.6 and eur = 372738 and  hkd = 3022.2','')")

    con:query("insert into check_sql values(3359,'delete from transaction_total_check where cny = 3359 and jpy = 335900 and gbp = 2351.3 and eur = 372849 and  hkd = 3023.1','')")

    con:query("insert into check_sql values(3360,'delete from transaction_total_check where cny = 3360 and jpy = 336000 and gbp = 2352.0 and eur = 372960 and  hkd = 3024.0','')")

    con:query("insert into check_sql values(3361,'delete from transaction_total_check where cny = 3361 and jpy = 336100 and gbp = 2352.7 and eur = 373071 and  hkd = 3024.9','')")

    con:query("insert into check_sql values(3362,'delete from transaction_total_check where cny = 3362 and jpy = 336200 and gbp = 2353.4 and eur = 373182 and  hkd = 3025.8','')")

    con:query("insert into check_sql values(3363,'delete from transaction_total_check where cny = 3363 and jpy = 336300 and gbp = 2354.1 and eur = 373293 and  hkd = 3026.7','')")

    con:query("insert into check_sql values(3364,'delete from transaction_total_check where cny = 3364 and jpy = 336400 and gbp = 2354.8 and eur = 373404 and  hkd = 3027.6','')")

    con:query("insert into check_sql values(3365,'delete from transaction_total_check where cny = 3365 and jpy = 336500 and gbp = 2355.5 and eur = 373515 and  hkd = 3028.5','')")

    con:query("insert into check_sql values(3366,'delete from transaction_total_check where cny = 3366 and jpy = 336600 and gbp = 2356.2 and eur = 373626 and  hkd = 3029.4','')")

    con:query("insert into check_sql values(3367,'delete from transaction_total_check where cny = 3367 and jpy = 336700 and gbp = 2356.9 and eur = 373737 and  hkd = 3030.3','')")

    con:query("insert into check_sql values(3368,'delete from transaction_total_check where cny = 3368 and jpy = 336800 and gbp = 2357.6 and eur = 373848 and  hkd = 3031.2','')")

    con:query("insert into check_sql values(3369,'delete from transaction_total_check where cny = 3369 and jpy = 336900 and gbp = 2358.3 and eur = 373959 and  hkd = 3032.1','')")

    con:query("insert into check_sql values(3370,'delete from transaction_total_check where cny = 3370 and jpy = 337000 and gbp = 2359.0 and eur = 374070 and  hkd = 3033.0','')")

    con:query("insert into check_sql values(3371,'delete from transaction_total_check where cny = 3371 and jpy = 337100 and gbp = 2359.7 and eur = 374181 and  hkd = 3033.9','')")

    con:query("insert into check_sql values(3372,'delete from transaction_total_check where cny = 3372 and jpy = 337200 and gbp = 2360.4 and eur = 374292 and  hkd = 3034.8','')")

    con:query("insert into check_sql values(3373,'delete from transaction_total_check where cny = 3373 and jpy = 337300 and gbp = 2361.1 and eur = 374403 and  hkd = 3035.7','')")

    con:query("insert into check_sql values(3374,'delete from transaction_total_check where cny = 3374 and jpy = 337400 and gbp = 2361.8 and eur = 374514 and  hkd = 3036.6','')")

    con:query("insert into check_sql values(3375,'delete from transaction_total_check where cny = 3375 and jpy = 337500 and gbp = 2362.5 and eur = 374625 and  hkd = 3037.5','')")

    con:query("insert into check_sql values(3376,'delete from transaction_total_check where cny = 3376 and jpy = 337600 and gbp = 2363.2 and eur = 374736 and  hkd = 3038.4','')")

    con:query("insert into check_sql values(3377,'delete from transaction_total_check where cny = 3377 and jpy = 337700 and gbp = 2363.9 and eur = 374847 and  hkd = 3039.3','')")

    con:query("insert into check_sql values(3378,'delete from transaction_total_check where cny = 3378 and jpy = 337800 and gbp = 2364.6 and eur = 374958 and  hkd = 3040.2','')")

    con:query("insert into check_sql values(3379,'delete from transaction_total_check where cny = 3379 and jpy = 337900 and gbp = 2365.3 and eur = 375069 and  hkd = 3041.1','')")

    con:query("insert into check_sql values(3380,'delete from transaction_total_check where cny = 3380 and jpy = 338000 and gbp = 2366.0 and eur = 375180 and  hkd = 3042.0','')")

    con:query("insert into check_sql values(3381,'delete from transaction_total_check where cny = 3381 and jpy = 338100 and gbp = 2366.7 and eur = 375291 and  hkd = 3042.9','')")

    con:query("insert into check_sql values(3382,'delete from transaction_total_check where cny = 3382 and jpy = 338200 and gbp = 2367.4 and eur = 375402 and  hkd = 3043.8','')")

    con:query("insert into check_sql values(3383,'delete from transaction_total_check where cny = 3383 and jpy = 338300 and gbp = 2368.1 and eur = 375513 and  hkd = 3044.7','')")

    con:query("insert into check_sql values(3384,'delete from transaction_total_check where cny = 3384 and jpy = 338400 and gbp = 2368.8 and eur = 375624 and  hkd = 3045.6','')")

    con:query("insert into check_sql values(3385,'delete from transaction_total_check where cny = 3385 and jpy = 338500 and gbp = 2369.5 and eur = 375735 and  hkd = 3046.5','')")

    con:query("insert into check_sql values(3386,'delete from transaction_total_check where cny = 3386 and jpy = 338600 and gbp = 2370.2 and eur = 375846 and  hkd = 3047.4','')")

    con:query("insert into check_sql values(3387,'delete from transaction_total_check where cny = 3387 and jpy = 338700 and gbp = 2370.9 and eur = 375957 and  hkd = 3048.3','')")

    con:query("insert into check_sql values(3388,'delete from transaction_total_check where cny = 3388 and jpy = 338800 and gbp = 2371.6 and eur = 376068 and  hkd = 3049.2','')")

    con:query("insert into check_sql values(3389,'delete from transaction_total_check where cny = 3389 and jpy = 338900 and gbp = 2372.3 and eur = 376179 and  hkd = 3050.1','')")

    con:query("insert into check_sql values(3390,'delete from transaction_total_check where cny = 3390 and jpy = 339000 and gbp = 2373.0 and eur = 376290 and  hkd = 3051.0','')")

    con:query("insert into check_sql values(3391,'delete from transaction_total_check where cny = 3391 and jpy = 339100 and gbp = 2373.7 and eur = 376401 and  hkd = 3051.9','')")

    con:query("insert into check_sql values(3392,'delete from transaction_total_check where cny = 3392 and jpy = 339200 and gbp = 2374.4 and eur = 376512 and  hkd = 3052.8','')")

    con:query("insert into check_sql values(3393,'delete from transaction_total_check where cny = 3393 and jpy = 339300 and gbp = 2375.1 and eur = 376623 and  hkd = 3053.7','')")

    con:query("insert into check_sql values(3394,'delete from transaction_total_check where cny = 3394 and jpy = 339400 and gbp = 2375.8 and eur = 376734 and  hkd = 3054.6','')")

    con:query("insert into check_sql values(3395,'delete from transaction_total_check where cny = 3395 and jpy = 339500 and gbp = 2376.5 and eur = 376845 and  hkd = 3055.5','')")

    con:query("insert into check_sql values(3396,'delete from transaction_total_check where cny = 3396 and jpy = 339600 and gbp = 2377.2 and eur = 376956 and  hkd = 3056.4','')")

    con:query("insert into check_sql values(3397,'delete from transaction_total_check where cny = 3397 and jpy = 339700 and gbp = 2377.9 and eur = 377067 and  hkd = 3057.3','')")

    con:query("insert into check_sql values(3398,'delete from transaction_total_check where cny = 3398 and jpy = 339800 and gbp = 2378.6 and eur = 377178 and  hkd = 3058.2','')")

    con:query("insert into check_sql values(3399,'delete from transaction_total_check where cny = 3399 and jpy = 339900 and gbp = 2379.3 and eur = 377289 and  hkd = 3059.1','')")

    con:query("insert into check_sql values(3400,'delete from transaction_total_check where cny = 3400 and jpy = 340000 and gbp = 2380.0 and eur = 377400 and  hkd = 3060.0','')")

    con:query("insert into check_sql values(3401,'delete from transaction_total_check where cny = 3401 and jpy = 340100 and gbp = 2380.7 and eur = 377511 and  hkd = 3060.9','')")

    con:query("insert into check_sql values(3402,'delete from transaction_total_check where cny = 3402 and jpy = 340200 and gbp = 2381.4 and eur = 377622 and  hkd = 3061.8','')")

    con:query("insert into check_sql values(3403,'delete from transaction_total_check where cny = 3403 and jpy = 340300 and gbp = 2382.1 and eur = 377733 and  hkd = 3062.7','')")

    con:query("insert into check_sql values(3404,'delete from transaction_total_check where cny = 3404 and jpy = 340400 and gbp = 2382.8 and eur = 377844 and  hkd = 3063.6','')")

    con:query("insert into check_sql values(3405,'delete from transaction_total_check where cny = 3405 and jpy = 340500 and gbp = 2383.5 and eur = 377955 and  hkd = 3064.5','')")

    con:query("insert into check_sql values(3406,'delete from transaction_total_check where cny = 3406 and jpy = 340600 and gbp = 2384.2 and eur = 378066 and  hkd = 3065.4','')")

    con:query("insert into check_sql values(3407,'delete from transaction_total_check where cny = 3407 and jpy = 340700 and gbp = 2384.9 and eur = 378177 and  hkd = 3066.3','')")

    con:query("insert into check_sql values(3408,'delete from transaction_total_check where cny = 3408 and jpy = 340800 and gbp = 2385.6 and eur = 378288 and  hkd = 3067.2','')")

    con:query("insert into check_sql values(3409,'delete from transaction_total_check where cny = 3409 and jpy = 340900 and gbp = 2386.3 and eur = 378399 and  hkd = 3068.1','')")

    con:query("insert into check_sql values(3410,'delete from transaction_total_check where cny = 3410 and jpy = 341000 and gbp = 2387.0 and eur = 378510 and  hkd = 3069.0','')")

    con:query("insert into check_sql values(3411,'delete from transaction_total_check where cny = 3411 and jpy = 341100 and gbp = 2387.7 and eur = 378621 and  hkd = 3069.9','')")

    con:query("insert into check_sql values(3412,'delete from transaction_total_check where cny = 3412 and jpy = 341200 and gbp = 2388.4 and eur = 378732 and  hkd = 3070.8','')")

    con:query("insert into check_sql values(3413,'delete from transaction_total_check where cny = 3413 and jpy = 341300 and gbp = 2389.1 and eur = 378843 and  hkd = 3071.7','')")

    con:query("insert into check_sql values(3414,'delete from transaction_total_check where cny = 3414 and jpy = 341400 and gbp = 2389.8 and eur = 378954 and  hkd = 3072.6','')")

    con:query("insert into check_sql values(3415,'delete from transaction_total_check where cny = 3415 and jpy = 341500 and gbp = 2390.5 and eur = 379065 and  hkd = 3073.5','')")

    con:query("insert into check_sql values(3416,'delete from transaction_total_check where cny = 3416 and jpy = 341600 and gbp = 2391.2 and eur = 379176 and  hkd = 3074.4','')")

    con:query("insert into check_sql values(3417,'delete from transaction_total_check where cny = 3417 and jpy = 341700 and gbp = 2391.9 and eur = 379287 and  hkd = 3075.3','')")

    con:query("insert into check_sql values(3418,'delete from transaction_total_check where cny = 3418 and jpy = 341800 and gbp = 2392.6 and eur = 379398 and  hkd = 3076.2','')")

    con:query("insert into check_sql values(3419,'delete from transaction_total_check where cny = 3419 and jpy = 341900 and gbp = 2393.3 and eur = 379509 and  hkd = 3077.1','')")

    con:query("insert into check_sql values(3420,'delete from transaction_total_check where cny = 3420 and jpy = 342000 and gbp = 2394.0 and eur = 379620 and  hkd = 3078.0','')")

    con:query("insert into check_sql values(3421,'delete from transaction_total_check where cny = 3421 and jpy = 342100 and gbp = 2394.7 and eur = 379731 and  hkd = 3078.9','')")

    con:query("insert into check_sql values(3422,'delete from transaction_total_check where cny = 3422 and jpy = 342200 and gbp = 2395.4 and eur = 379842 and  hkd = 3079.8','')")

    con:query("insert into check_sql values(3423,'delete from transaction_total_check where cny = 3423 and jpy = 342300 and gbp = 2396.1 and eur = 379953 and  hkd = 3080.7','')")

    con:query("insert into check_sql values(3424,'delete from transaction_total_check where cny = 3424 and jpy = 342400 and gbp = 2396.8 and eur = 380064 and  hkd = 3081.6','')")

    con:query("insert into check_sql values(3425,'delete from transaction_total_check where cny = 3425 and jpy = 342500 and gbp = 2397.5 and eur = 380175 and  hkd = 3082.5','')")

    con:query("insert into check_sql values(3426,'delete from transaction_total_check where cny = 3426 and jpy = 342600 and gbp = 2398.2 and eur = 380286 and  hkd = 3083.4','')")

    con:query("insert into check_sql values(3427,'delete from transaction_total_check where cny = 3427 and jpy = 342700 and gbp = 2398.9 and eur = 380397 and  hkd = 3084.3','')")

    con:query("insert into check_sql values(3428,'delete from transaction_total_check where cny = 3428 and jpy = 342800 and gbp = 2399.6 and eur = 380508 and  hkd = 3085.2','')")

    con:query("insert into check_sql values(3429,'delete from transaction_total_check where cny = 3429 and jpy = 342900 and gbp = 2400.3 and eur = 380619 and  hkd = 3086.1','')")

    con:query("insert into check_sql values(3430,'delete from transaction_total_check where cny = 3430 and jpy = 343000 and gbp = 2401.0 and eur = 380730 and  hkd = 3087.0','')")

    con:query("insert into check_sql values(3431,'delete from transaction_total_check where cny = 3431 and jpy = 343100 and gbp = 2401.7 and eur = 380841 and  hkd = 3087.9','')")

    con:query("insert into check_sql values(3432,'delete from transaction_total_check where cny = 3432 and jpy = 343200 and gbp = 2402.4 and eur = 380952 and  hkd = 3088.8','')")

    con:query("insert into check_sql values(3433,'delete from transaction_total_check where cny = 3433 and jpy = 343300 and gbp = 2403.1 and eur = 381063 and  hkd = 3089.7','')")

    con:query("insert into check_sql values(3434,'delete from transaction_total_check where cny = 3434 and jpy = 343400 and gbp = 2403.8 and eur = 381174 and  hkd = 3090.6','')")

    con:query("insert into check_sql values(3435,'delete from transaction_total_check where cny = 3435 and jpy = 343500 and gbp = 2404.5 and eur = 381285 and  hkd = 3091.5','')")

    con:query("insert into check_sql values(3436,'delete from transaction_total_check where cny = 3436 and jpy = 343600 and gbp = 2405.2 and eur = 381396 and  hkd = 3092.4','')")

    con:query("insert into check_sql values(3437,'delete from transaction_total_check where cny = 3437 and jpy = 343700 and gbp = 2405.9 and eur = 381507 and  hkd = 3093.3','')")

    con:query("insert into check_sql values(3438,'delete from transaction_total_check where cny = 3438 and jpy = 343800 and gbp = 2406.6 and eur = 381618 and  hkd = 3094.2','')")

    con:query("insert into check_sql values(3439,'delete from transaction_total_check where cny = 3439 and jpy = 343900 and gbp = 2407.3 and eur = 381729 and  hkd = 3095.1','')")

    con:query("insert into check_sql values(3440,'delete from transaction_total_check where cny = 3440 and jpy = 344000 and gbp = 2408.0 and eur = 381840 and  hkd = 3096.0','')")

    con:query("insert into check_sql values(3441,'delete from transaction_total_check where cny = 3441 and jpy = 344100 and gbp = 2408.7 and eur = 381951 and  hkd = 3096.9','')")

    con:query("insert into check_sql values(3442,'delete from transaction_total_check where cny = 3442 and jpy = 344200 and gbp = 2409.4 and eur = 382062 and  hkd = 3097.8','')")

    con:query("insert into check_sql values(3443,'delete from transaction_total_check where cny = 3443 and jpy = 344300 and gbp = 2410.1 and eur = 382173 and  hkd = 3098.7','')")

    con:query("insert into check_sql values(3444,'delete from transaction_total_check where cny = 3444 and jpy = 344400 and gbp = 2410.8 and eur = 382284 and  hkd = 3099.6','')")

    con:query("insert into check_sql values(3445,'delete from transaction_total_check where cny = 3445 and jpy = 344500 and gbp = 2411.5 and eur = 382395 and  hkd = 3100.5','')")

    con:query("insert into check_sql values(3446,'delete from transaction_total_check where cny = 3446 and jpy = 344600 and gbp = 2412.2 and eur = 382506 and  hkd = 3101.4','')")

    con:query("insert into check_sql values(3447,'delete from transaction_total_check where cny = 3447 and jpy = 344700 and gbp = 2412.9 and eur = 382617 and  hkd = 3102.3','')")

    con:query("insert into check_sql values(3448,'delete from transaction_total_check where cny = 3448 and jpy = 344800 and gbp = 2413.6 and eur = 382728 and  hkd = 3103.2','')")

    con:query("insert into check_sql values(3449,'delete from transaction_total_check where cny = 3449 and jpy = 344900 and gbp = 2414.3 and eur = 382839 and  hkd = 3104.1','')")

    con:query("insert into check_sql values(3450,'delete from transaction_total_check where cny = 3450 and jpy = 345000 and gbp = 2415.0 and eur = 382950 and  hkd = 3105.0','')")

    con:query("insert into check_sql values(3451,'delete from transaction_total_check where cny = 3451 and jpy = 345100 and gbp = 2415.7 and eur = 383061 and  hkd = 3105.9','')")

    con:query("insert into check_sql values(3452,'delete from transaction_total_check where cny = 3452 and jpy = 345200 and gbp = 2416.4 and eur = 383172 and  hkd = 3106.8','')")

    con:query("insert into check_sql values(3453,'delete from transaction_total_check where cny = 3453 and jpy = 345300 and gbp = 2417.1 and eur = 383283 and  hkd = 3107.7','')")

    con:query("insert into check_sql values(3454,'delete from transaction_total_check where cny = 3454 and jpy = 345400 and gbp = 2417.8 and eur = 383394 and  hkd = 3108.6','')")

    con:query("insert into check_sql values(3455,'delete from transaction_total_check where cny = 3455 and jpy = 345500 and gbp = 2418.5 and eur = 383505 and  hkd = 3109.5','')")

    con:query("insert into check_sql values(3456,'delete from transaction_total_check where cny = 3456 and jpy = 345600 and gbp = 2419.2 and eur = 383616 and  hkd = 3110.4','')")

    con:query("insert into check_sql values(3457,'delete from transaction_total_check where cny = 3457 and jpy = 345700 and gbp = 2419.9 and eur = 383727 and  hkd = 3111.3','')")

    con:query("insert into check_sql values(3458,'delete from transaction_total_check where cny = 3458 and jpy = 345800 and gbp = 2420.6 and eur = 383838 and  hkd = 3112.2','')")

    con:query("insert into check_sql values(3459,'delete from transaction_total_check where cny = 3459 and jpy = 345900 and gbp = 2421.3 and eur = 383949 and  hkd = 3113.1','')")

    con:query("insert into check_sql values(3460,'delete from transaction_total_check where cny = 3460 and jpy = 346000 and gbp = 2422.0 and eur = 384060 and  hkd = 3114.0','')")

    con:query("insert into check_sql values(3461,'delete from transaction_total_check where cny = 3461 and jpy = 346100 and gbp = 2422.7 and eur = 384171 and  hkd = 3114.9','')")

    con:query("insert into check_sql values(3462,'delete from transaction_total_check where cny = 3462 and jpy = 346200 and gbp = 2423.4 and eur = 384282 and  hkd = 3115.8','')")

    con:query("insert into check_sql values(3463,'delete from transaction_total_check where cny = 3463 and jpy = 346300 and gbp = 2424.1 and eur = 384393 and  hkd = 3116.7','')")

    con:query("insert into check_sql values(3464,'delete from transaction_total_check where cny = 3464 and jpy = 346400 and gbp = 2424.8 and eur = 384504 and  hkd = 3117.6','')")

    con:query("insert into check_sql values(3465,'delete from transaction_total_check where cny = 3465 and jpy = 346500 and gbp = 2425.5 and eur = 384615 and  hkd = 3118.5','')")

    con:query("insert into check_sql values(3466,'delete from transaction_total_check where cny = 3466 and jpy = 346600 and gbp = 2426.2 and eur = 384726 and  hkd = 3119.4','')")

    con:query("insert into check_sql values(3467,'delete from transaction_total_check where cny = 3467 and jpy = 346700 and gbp = 2426.9 and eur = 384837 and  hkd = 3120.3','')")

    con:query("insert into check_sql values(3468,'delete from transaction_total_check where cny = 3468 and jpy = 346800 and gbp = 2427.6 and eur = 384948 and  hkd = 3121.2','')")

    con:query("insert into check_sql values(3469,'delete from transaction_total_check where cny = 3469 and jpy = 346900 and gbp = 2428.3 and eur = 385059 and  hkd = 3122.1','')")

    con:query("insert into check_sql values(3470,'delete from transaction_total_check where cny = 3470 and jpy = 347000 and gbp = 2429.0 and eur = 385170 and  hkd = 3123.0','')")

    con:query("insert into check_sql values(3471,'delete from transaction_total_check where cny = 3471 and jpy = 347100 and gbp = 2429.7 and eur = 385281 and  hkd = 3123.9','')")

    con:query("insert into check_sql values(3472,'delete from transaction_total_check where cny = 3472 and jpy = 347200 and gbp = 2430.4 and eur = 385392 and  hkd = 3124.8','')")

    con:query("insert into check_sql values(3473,'delete from transaction_total_check where cny = 3473 and jpy = 347300 and gbp = 2431.1 and eur = 385503 and  hkd = 3125.7','')")

    con:query("insert into check_sql values(3474,'delete from transaction_total_check where cny = 3474 and jpy = 347400 and gbp = 2431.8 and eur = 385614 and  hkd = 3126.6','')")

    con:query("insert into check_sql values(3475,'delete from transaction_total_check where cny = 3475 and jpy = 347500 and gbp = 2432.5 and eur = 385725 and  hkd = 3127.5','')")

    con:query("insert into check_sql values(3476,'delete from transaction_total_check where cny = 3476 and jpy = 347600 and gbp = 2433.2 and eur = 385836 and  hkd = 3128.4','')")

    con:query("insert into check_sql values(3477,'delete from transaction_total_check where cny = 3477 and jpy = 347700 and gbp = 2433.9 and eur = 385947 and  hkd = 3129.3','')")

    con:query("insert into check_sql values(3478,'delete from transaction_total_check where cny = 3478 and jpy = 347800 and gbp = 2434.6 and eur = 386058 and  hkd = 3130.2','')")

    con:query("insert into check_sql values(3479,'delete from transaction_total_check where cny = 3479 and jpy = 347900 and gbp = 2435.3 and eur = 386169 and  hkd = 3131.1','')")

    con:query("insert into check_sql values(3480,'delete from transaction_total_check where cny = 3480 and jpy = 348000 and gbp = 2436.0 and eur = 386280 and  hkd = 3132.0','')")

    con:query("insert into check_sql values(3481,'delete from transaction_total_check where cny = 3481 and jpy = 348100 and gbp = 2436.7 and eur = 386391 and  hkd = 3132.9','')")

    con:query("insert into check_sql values(3482,'delete from transaction_total_check where cny = 3482 and jpy = 348200 and gbp = 2437.4 and eur = 386502 and  hkd = 3133.8','')")

    con:query("insert into check_sql values(3483,'delete from transaction_total_check where cny = 3483 and jpy = 348300 and gbp = 2438.1 and eur = 386613 and  hkd = 3134.7','')")

    con:query("insert into check_sql values(3484,'delete from transaction_total_check where cny = 3484 and jpy = 348400 and gbp = 2438.8 and eur = 386724 and  hkd = 3135.6','')")

    con:query("insert into check_sql values(3485,'delete from transaction_total_check where cny = 3485 and jpy = 348500 and gbp = 2439.5 and eur = 386835 and  hkd = 3136.5','')")

    con:query("insert into check_sql values(3486,'delete from transaction_total_check where cny = 3486 and jpy = 348600 and gbp = 2440.2 and eur = 386946 and  hkd = 3137.4','')")

    con:query("insert into check_sql values(3487,'delete from transaction_total_check where cny = 3487 and jpy = 348700 and gbp = 2440.9 and eur = 387057 and  hkd = 3138.3','')")

    con:query("insert into check_sql values(3488,'delete from transaction_total_check where cny = 3488 and jpy = 348800 and gbp = 2441.6 and eur = 387168 and  hkd = 3139.2','')")

    con:query("insert into check_sql values(3489,'delete from transaction_total_check where cny = 3489 and jpy = 348900 and gbp = 2442.3 and eur = 387279 and  hkd = 3140.1','')")

    con:query("insert into check_sql values(3490,'delete from transaction_total_check where cny = 3490 and jpy = 349000 and gbp = 2443.0 and eur = 387390 and  hkd = 3141.0','')")

    con:query("insert into check_sql values(3491,'delete from transaction_total_check where cny = 3491 and jpy = 349100 and gbp = 2443.7 and eur = 387501 and  hkd = 3141.9','')")

    con:query("insert into check_sql values(3492,'delete from transaction_total_check where cny = 3492 and jpy = 349200 and gbp = 2444.4 and eur = 387612 and  hkd = 3142.8','')")

    con:query("insert into check_sql values(3493,'delete from transaction_total_check where cny = 3493 and jpy = 349300 and gbp = 2445.1 and eur = 387723 and  hkd = 3143.7','')")

    con:query("insert into check_sql values(3494,'delete from transaction_total_check where cny = 3494 and jpy = 349400 and gbp = 2445.8 and eur = 387834 and  hkd = 3144.6','')")

    con:query("insert into check_sql values(3495,'delete from transaction_total_check where cny = 3495 and jpy = 349500 and gbp = 2446.5 and eur = 387945 and  hkd = 3145.5','')")

    con:query("insert into check_sql values(3496,'delete from transaction_total_check where cny = 3496 and jpy = 349600 and gbp = 2447.2 and eur = 388056 and  hkd = 3146.4','')")

    con:query("insert into check_sql values(3497,'delete from transaction_total_check where cny = 3497 and jpy = 349700 and gbp = 2447.9 and eur = 388167 and  hkd = 3147.3','')")

    con:query("insert into check_sql values(3498,'delete from transaction_total_check where cny = 3498 and jpy = 349800 and gbp = 2448.6 and eur = 388278 and  hkd = 3148.2','')")

    con:query("insert into check_sql values(3499,'delete from transaction_total_check where cny = 3499 and jpy = 349900 and gbp = 2449.3 and eur = 388389 and  hkd = 3149.1','')")

    con:query("insert into check_sql values(3500,'delete from transaction_total_check where cny = 3500 and jpy = 350000 and gbp = 2450.0 and eur = 388500 and  hkd = 3150.0','')")

    con:query("insert into check_sql values(3501,'delete from transaction_total_check where cny = 3501 and jpy = 350100 and gbp = 2450.7 and eur = 388611 and  hkd = 3150.9','')")

    con:query("insert into check_sql values(3502,'delete from transaction_total_check where cny = 3502 and jpy = 350200 and gbp = 2451.4 and eur = 388722 and  hkd = 3151.8','')")

    con:query("insert into check_sql values(3503,'delete from transaction_total_check where cny = 3503 and jpy = 350300 and gbp = 2452.1 and eur = 388833 and  hkd = 3152.7','')")

    con:query("insert into check_sql values(3504,'delete from transaction_total_check where cny = 3504 and jpy = 350400 and gbp = 2452.8 and eur = 388944 and  hkd = 3153.6','')")

    con:query("insert into check_sql values(3505,'delete from transaction_total_check where cny = 3505 and jpy = 350500 and gbp = 2453.5 and eur = 389055 and  hkd = 3154.5','')")

    con:query("insert into check_sql values(3506,'delete from transaction_total_check where cny = 3506 and jpy = 350600 and gbp = 2454.2 and eur = 389166 and  hkd = 3155.4','')")

    con:query("insert into check_sql values(3507,'delete from transaction_total_check where cny = 3507 and jpy = 350700 and gbp = 2454.9 and eur = 389277 and  hkd = 3156.3','')")

    con:query("insert into check_sql values(3508,'delete from transaction_total_check where cny = 3508 and jpy = 350800 and gbp = 2455.6 and eur = 389388 and  hkd = 3157.2','')")

    con:query("insert into check_sql values(3509,'delete from transaction_total_check where cny = 3509 and jpy = 350900 and gbp = 2456.3 and eur = 389499 and  hkd = 3158.1','')")

    con:query("insert into check_sql values(3510,'delete from transaction_total_check where cny = 3510 and jpy = 351000 and gbp = 2457.0 and eur = 389610 and  hkd = 3159.0','')")

    con:query("insert into check_sql values(3511,'delete from transaction_total_check where cny = 3511 and jpy = 351100 and gbp = 2457.7 and eur = 389721 and  hkd = 3159.9','')")

    con:query("insert into check_sql values(3512,'delete from transaction_total_check where cny = 3512 and jpy = 351200 and gbp = 2458.4 and eur = 389832 and  hkd = 3160.8','')")

    con:query("insert into check_sql values(3513,'delete from transaction_total_check where cny = 3513 and jpy = 351300 and gbp = 2459.1 and eur = 389943 and  hkd = 3161.7','')")

    con:query("insert into check_sql values(3514,'delete from transaction_total_check where cny = 3514 and jpy = 351400 and gbp = 2459.8 and eur = 390054 and  hkd = 3162.6','')")

    con:query("insert into check_sql values(3515,'delete from transaction_total_check where cny = 3515 and jpy = 351500 and gbp = 2460.5 and eur = 390165 and  hkd = 3163.5','')")

    con:query("insert into check_sql values(3516,'delete from transaction_total_check where cny = 3516 and jpy = 351600 and gbp = 2461.2 and eur = 390276 and  hkd = 3164.4','')")

    con:query("insert into check_sql values(3517,'delete from transaction_total_check where cny = 3517 and jpy = 351700 and gbp = 2461.9 and eur = 390387 and  hkd = 3165.3','')")

    con:query("insert into check_sql values(3518,'delete from transaction_total_check where cny = 3518 and jpy = 351800 and gbp = 2462.6 and eur = 390498 and  hkd = 3166.2','')")

    con:query("insert into check_sql values(3519,'delete from transaction_total_check where cny = 3519 and jpy = 351900 and gbp = 2463.3 and eur = 390609 and  hkd = 3167.1','')")

    con:query("insert into check_sql values(3520,'delete from transaction_total_check where cny = 3520 and jpy = 352000 and gbp = 2464.0 and eur = 390720 and  hkd = 3168.0','')")

    con:query("insert into check_sql values(3521,'delete from transaction_total_check where cny = 3521 and jpy = 352100 and gbp = 2464.7 and eur = 390831 and  hkd = 3168.9','')")

    con:query("insert into check_sql values(3522,'delete from transaction_total_check where cny = 3522 and jpy = 352200 and gbp = 2465.4 and eur = 390942 and  hkd = 3169.8','')")

    con:query("insert into check_sql values(3523,'delete from transaction_total_check where cny = 3523 and jpy = 352300 and gbp = 2466.1 and eur = 391053 and  hkd = 3170.7','')")

    con:query("insert into check_sql values(3524,'delete from transaction_total_check where cny = 3524 and jpy = 352400 and gbp = 2466.8 and eur = 391164 and  hkd = 3171.6','')")

    con:query("insert into check_sql values(3525,'delete from transaction_total_check where cny = 3525 and jpy = 352500 and gbp = 2467.5 and eur = 391275 and  hkd = 3172.5','')")

    con:query("insert into check_sql values(3526,'delete from transaction_total_check where cny = 3526 and jpy = 352600 and gbp = 2468.2 and eur = 391386 and  hkd = 3173.4','')")

    con:query("insert into check_sql values(3527,'delete from transaction_total_check where cny = 3527 and jpy = 352700 and gbp = 2468.9 and eur = 391497 and  hkd = 3174.3','')")

    con:query("insert into check_sql values(3528,'delete from transaction_total_check where cny = 3528 and jpy = 352800 and gbp = 2469.6 and eur = 391608 and  hkd = 3175.2','')")

    con:query("insert into check_sql values(3529,'delete from transaction_total_check where cny = 3529 and jpy = 352900 and gbp = 2470.3 and eur = 391719 and  hkd = 3176.1','')")

    con:query("insert into check_sql values(3530,'delete from transaction_total_check where cny = 3530 and jpy = 353000 and gbp = 2471.0 and eur = 391830 and  hkd = 3177.0','')")

    con:query("insert into check_sql values(3531,'delete from transaction_total_check where cny = 3531 and jpy = 353100 and gbp = 2471.7 and eur = 391941 and  hkd = 3177.9','')")

    con:query("insert into check_sql values(3532,'delete from transaction_total_check where cny = 3532 and jpy = 353200 and gbp = 2472.4 and eur = 392052 and  hkd = 3178.8','')")

    con:query("insert into check_sql values(3533,'delete from transaction_total_check where cny = 3533 and jpy = 353300 and gbp = 2473.1 and eur = 392163 and  hkd = 3179.7','')")

    con:query("insert into check_sql values(3534,'delete from transaction_total_check where cny = 3534 and jpy = 353400 and gbp = 2473.8 and eur = 392274 and  hkd = 3180.6','')")

    con:query("insert into check_sql values(3535,'delete from transaction_total_check where cny = 3535 and jpy = 353500 and gbp = 2474.5 and eur = 392385 and  hkd = 3181.5','')")

    con:query("insert into check_sql values(3536,'delete from transaction_total_check where cny = 3536 and jpy = 353600 and gbp = 2475.2 and eur = 392496 and  hkd = 3182.4','')")

    con:query("insert into check_sql values(3537,'delete from transaction_total_check where cny = 3537 and jpy = 353700 and gbp = 2475.9 and eur = 392607 and  hkd = 3183.3','')")

    con:query("insert into check_sql values(3538,'delete from transaction_total_check where cny = 3538 and jpy = 353800 and gbp = 2476.6 and eur = 392718 and  hkd = 3184.2','')")

    con:query("insert into check_sql values(3539,'delete from transaction_total_check where cny = 3539 and jpy = 353900 and gbp = 2477.3 and eur = 392829 and  hkd = 3185.1','')")

    con:query("insert into check_sql values(3540,'delete from transaction_total_check where cny = 3540 and jpy = 354000 and gbp = 2478.0 and eur = 392940 and  hkd = 3186.0','')")

    con:query("insert into check_sql values(3541,'delete from transaction_total_check where cny = 3541 and jpy = 354100 and gbp = 2478.7 and eur = 393051 and  hkd = 3186.9','')")

    con:query("insert into check_sql values(3542,'delete from transaction_total_check where cny = 3542 and jpy = 354200 and gbp = 2479.4 and eur = 393162 and  hkd = 3187.8','')")

    con:query("insert into check_sql values(3543,'delete from transaction_total_check where cny = 3543 and jpy = 354300 and gbp = 2480.1 and eur = 393273 and  hkd = 3188.7','')")

    con:query("insert into check_sql values(3544,'delete from transaction_total_check where cny = 3544 and jpy = 354400 and gbp = 2480.8 and eur = 393384 and  hkd = 3189.6','')")

    con:query("insert into check_sql values(3545,'delete from transaction_total_check where cny = 3545 and jpy = 354500 and gbp = 2481.5 and eur = 393495 and  hkd = 3190.5','')")

    con:query("insert into check_sql values(3546,'delete from transaction_total_check where cny = 3546 and jpy = 354600 and gbp = 2482.2 and eur = 393606 and  hkd = 3191.4','')")

    con:query("insert into check_sql values(3547,'delete from transaction_total_check where cny = 3547 and jpy = 354700 and gbp = 2482.9 and eur = 393717 and  hkd = 3192.3','')")

    con:query("insert into check_sql values(3548,'delete from transaction_total_check where cny = 3548 and jpy = 354800 and gbp = 2483.6 and eur = 393828 and  hkd = 3193.2','')")

    con:query("insert into check_sql values(3549,'delete from transaction_total_check where cny = 3549 and jpy = 354900 and gbp = 2484.3 and eur = 393939 and  hkd = 3194.1','')")

    con:query("insert into check_sql values(3550,'delete from transaction_total_check where cny = 3550 and jpy = 355000 and gbp = 2485.0 and eur = 394050 and  hkd = 3195.0','')")

    con:query("insert into check_sql values(3551,'delete from transaction_total_check where cny = 3551 and jpy = 355100 and gbp = 2485.7 and eur = 394161 and  hkd = 3195.9','')")

    con:query("insert into check_sql values(3552,'delete from transaction_total_check where cny = 3552 and jpy = 355200 and gbp = 2486.4 and eur = 394272 and  hkd = 3196.8','')")

    con:query("insert into check_sql values(3553,'delete from transaction_total_check where cny = 3553 and jpy = 355300 and gbp = 2487.1 and eur = 394383 and  hkd = 3197.7','')")

    con:query("insert into check_sql values(3554,'delete from transaction_total_check where cny = 3554 and jpy = 355400 and gbp = 2487.8 and eur = 394494 and  hkd = 3198.6','')")

    con:query("insert into check_sql values(3555,'delete from transaction_total_check where cny = 3555 and jpy = 355500 and gbp = 2488.5 and eur = 394605 and  hkd = 3199.5','')")

    con:query("insert into check_sql values(3556,'delete from transaction_total_check where cny = 3556 and jpy = 355600 and gbp = 2489.2 and eur = 394716 and  hkd = 3200.4','')")

    con:query("insert into check_sql values(3557,'delete from transaction_total_check where cny = 3557 and jpy = 355700 and gbp = 2489.9 and eur = 394827 and  hkd = 3201.3','')")

    con:query("insert into check_sql values(3558,'delete from transaction_total_check where cny = 3558 and jpy = 355800 and gbp = 2490.6 and eur = 394938 and  hkd = 3202.2','')")

    con:query("insert into check_sql values(3559,'delete from transaction_total_check where cny = 3559 and jpy = 355900 and gbp = 2491.3 and eur = 395049 and  hkd = 3203.1','')")

    con:query("insert into check_sql values(3560,'delete from transaction_total_check where cny = 3560 and jpy = 356000 and gbp = 2492.0 and eur = 395160 and  hkd = 3204.0','')")

    con:query("insert into check_sql values(3561,'delete from transaction_total_check where cny = 3561 and jpy = 356100 and gbp = 2492.7 and eur = 395271 and  hkd = 3204.9','')")

    con:query("insert into check_sql values(3562,'delete from transaction_total_check where cny = 3562 and jpy = 356200 and gbp = 2493.4 and eur = 395382 and  hkd = 3205.8','')")

    con:query("insert into check_sql values(3563,'delete from transaction_total_check where cny = 3563 and jpy = 356300 and gbp = 2494.1 and eur = 395493 and  hkd = 3206.7','')")

    con:query("insert into check_sql values(3564,'delete from transaction_total_check where cny = 3564 and jpy = 356400 and gbp = 2494.8 and eur = 395604 and  hkd = 3207.6','')")

    con:query("insert into check_sql values(3565,'delete from transaction_total_check where cny = 3565 and jpy = 356500 and gbp = 2495.5 and eur = 395715 and  hkd = 3208.5','')")

    con:query("insert into check_sql values(3566,'delete from transaction_total_check where cny = 3566 and jpy = 356600 and gbp = 2496.2 and eur = 395826 and  hkd = 3209.4','')")

    con:query("insert into check_sql values(3567,'delete from transaction_total_check where cny = 3567 and jpy = 356700 and gbp = 2496.9 and eur = 395937 and  hkd = 3210.3','')")

    con:query("insert into check_sql values(3568,'delete from transaction_total_check where cny = 3568 and jpy = 356800 and gbp = 2497.6 and eur = 396048 and  hkd = 3211.2','')")

    con:query("insert into check_sql values(3569,'delete from transaction_total_check where cny = 3569 and jpy = 356900 and gbp = 2498.3 and eur = 396159 and  hkd = 3212.1','')")

    con:query("insert into check_sql values(3570,'delete from transaction_total_check where cny = 3570 and jpy = 357000 and gbp = 2499.0 and eur = 396270 and  hkd = 3213.0','')")

    con:query("insert into check_sql values(3571,'delete from transaction_total_check where cny = 3571 and jpy = 357100 and gbp = 2499.7 and eur = 396381 and  hkd = 3213.9','')")

    con:query("insert into check_sql values(3572,'delete from transaction_total_check where cny = 3572 and jpy = 357200 and gbp = 2500.4 and eur = 396492 and  hkd = 3214.8','')")

    con:query("insert into check_sql values(3573,'delete from transaction_total_check where cny = 3573 and jpy = 357300 and gbp = 2501.1 and eur = 396603 and  hkd = 3215.7','')")

    con:query("insert into check_sql values(3574,'delete from transaction_total_check where cny = 3574 and jpy = 357400 and gbp = 2501.8 and eur = 396714 and  hkd = 3216.6','')")

    con:query("insert into check_sql values(3575,'delete from transaction_total_check where cny = 3575 and jpy = 357500 and gbp = 2502.5 and eur = 396825 and  hkd = 3217.5','')")

    con:query("insert into check_sql values(3576,'delete from transaction_total_check where cny = 3576 and jpy = 357600 and gbp = 2503.2 and eur = 396936 and  hkd = 3218.4','')")

    con:query("insert into check_sql values(3577,'delete from transaction_total_check where cny = 3577 and jpy = 357700 and gbp = 2503.9 and eur = 397047 and  hkd = 3219.3','')")

    con:query("insert into check_sql values(3578,'delete from transaction_total_check where cny = 3578 and jpy = 357800 and gbp = 2504.6 and eur = 397158 and  hkd = 3220.2','')")

    con:query("insert into check_sql values(3579,'delete from transaction_total_check where cny = 3579 and jpy = 357900 and gbp = 2505.3 and eur = 397269 and  hkd = 3221.1','')")

    con:query("insert into check_sql values(3580,'delete from transaction_total_check where cny = 3580 and jpy = 358000 and gbp = 2506.0 and eur = 397380 and  hkd = 3222.0','')")

    con:query("insert into check_sql values(3581,'delete from transaction_total_check where cny = 3581 and jpy = 358100 and gbp = 2506.7 and eur = 397491 and  hkd = 3222.9','')")

    con:query("insert into check_sql values(3582,'delete from transaction_total_check where cny = 3582 and jpy = 358200 and gbp = 2507.4 and eur = 397602 and  hkd = 3223.8','')")

    con:query("insert into check_sql values(3583,'delete from transaction_total_check where cny = 3583 and jpy = 358300 and gbp = 2508.1 and eur = 397713 and  hkd = 3224.7','')")

    con:query("insert into check_sql values(3584,'delete from transaction_total_check where cny = 3584 and jpy = 358400 and gbp = 2508.8 and eur = 397824 and  hkd = 3225.6','')")

    con:query("insert into check_sql values(3585,'delete from transaction_total_check where cny = 3585 and jpy = 358500 and gbp = 2509.5 and eur = 397935 and  hkd = 3226.5','')")

    con:query("insert into check_sql values(3586,'delete from transaction_total_check where cny = 3586 and jpy = 358600 and gbp = 2510.2 and eur = 398046 and  hkd = 3227.4','')")

    con:query("insert into check_sql values(3587,'delete from transaction_total_check where cny = 3587 and jpy = 358700 and gbp = 2510.9 and eur = 398157 and  hkd = 3228.3','')")

    con:query("insert into check_sql values(3588,'delete from transaction_total_check where cny = 3588 and jpy = 358800 and gbp = 2511.6 and eur = 398268 and  hkd = 3229.2','')")

    con:query("insert into check_sql values(3589,'delete from transaction_total_check where cny = 3589 and jpy = 358900 and gbp = 2512.3 and eur = 398379 and  hkd = 3230.1','')")

    con:query("insert into check_sql values(3590,'delete from transaction_total_check where cny = 3590 and jpy = 359000 and gbp = 2513.0 and eur = 398490 and  hkd = 3231.0','')")

    con:query("insert into check_sql values(3591,'delete from transaction_total_check where cny = 3591 and jpy = 359100 and gbp = 2513.7 and eur = 398601 and  hkd = 3231.9','')")

    con:query("insert into check_sql values(3592,'delete from transaction_total_check where cny = 3592 and jpy = 359200 and gbp = 2514.4 and eur = 398712 and  hkd = 3232.8','')")

    con:query("insert into check_sql values(3593,'delete from transaction_total_check where cny = 3593 and jpy = 359300 and gbp = 2515.1 and eur = 398823 and  hkd = 3233.7','')")

    con:query("insert into check_sql values(3594,'delete from transaction_total_check where cny = 3594 and jpy = 359400 and gbp = 2515.8 and eur = 398934 and  hkd = 3234.6','')")

    con:query("insert into check_sql values(3595,'delete from transaction_total_check where cny = 3595 and jpy = 359500 and gbp = 2516.5 and eur = 399045 and  hkd = 3235.5','')")

    con:query("insert into check_sql values(3596,'delete from transaction_total_check where cny = 3596 and jpy = 359600 and gbp = 2517.2 and eur = 399156 and  hkd = 3236.4','')")

    con:query("insert into check_sql values(3597,'delete from transaction_total_check where cny = 3597 and jpy = 359700 and gbp = 2517.9 and eur = 399267 and  hkd = 3237.3','')")

    con:query("insert into check_sql values(3598,'delete from transaction_total_check where cny = 3598 and jpy = 359800 and gbp = 2518.6 and eur = 399378 and  hkd = 3238.2','')")

    con:query("insert into check_sql values(3599,'delete from transaction_total_check where cny = 3599 and jpy = 359900 and gbp = 2519.3 and eur = 399489 and  hkd = 3239.1','')")

    con:query("insert into check_sql values(3600,'delete from transaction_total_check where cny = 3600 and jpy = 360000 and gbp = 2520.0 and eur = 399600 and  hkd = 3240.0','')")

    con:query("insert into check_sql values(3601,'delete from transaction_total_check where cny = 3601 and jpy = 360100 and gbp = 2520.7 and eur = 399711 and  hkd = 3240.9','')")

    con:query("insert into check_sql values(3602,'delete from transaction_total_check where cny = 3602 and jpy = 360200 and gbp = 2521.4 and eur = 399822 and  hkd = 3241.8','')")

    con:query("insert into check_sql values(3603,'delete from transaction_total_check where cny = 3603 and jpy = 360300 and gbp = 2522.1 and eur = 399933 and  hkd = 3242.7','')")

    con:query("insert into check_sql values(3604,'delete from transaction_total_check where cny = 3604 and jpy = 360400 and gbp = 2522.8 and eur = 400044 and  hkd = 3243.6','')")

    con:query("insert into check_sql values(3605,'delete from transaction_total_check where cny = 3605 and jpy = 360500 and gbp = 2523.5 and eur = 400155 and  hkd = 3244.5','')")

    con:query("insert into check_sql values(3606,'delete from transaction_total_check where cny = 3606 and jpy = 360600 and gbp = 2524.2 and eur = 400266 and  hkd = 3245.4','')")

    con:query("insert into check_sql values(3607,'delete from transaction_total_check where cny = 3607 and jpy = 360700 and gbp = 2524.9 and eur = 400377 and  hkd = 3246.3','')")

    con:query("insert into check_sql values(3608,'delete from transaction_total_check where cny = 3608 and jpy = 360800 and gbp = 2525.6 and eur = 400488 and  hkd = 3247.2','')")

    con:query("insert into check_sql values(3609,'delete from transaction_total_check where cny = 3609 and jpy = 360900 and gbp = 2526.3 and eur = 400599 and  hkd = 3248.1','')")

    con:query("insert into check_sql values(3610,'delete from transaction_total_check where cny = 3610 and jpy = 361000 and gbp = 2527.0 and eur = 400710 and  hkd = 3249.0','')")

    con:query("insert into check_sql values(3611,'delete from transaction_total_check where cny = 3611 and jpy = 361100 and gbp = 2527.7 and eur = 400821 and  hkd = 3249.9','')")

    con:query("insert into check_sql values(3612,'delete from transaction_total_check where cny = 3612 and jpy = 361200 and gbp = 2528.4 and eur = 400932 and  hkd = 3250.8','')")

    con:query("insert into check_sql values(3613,'delete from transaction_total_check where cny = 3613 and jpy = 361300 and gbp = 2529.1 and eur = 401043 and  hkd = 3251.7','')")

    con:query("insert into check_sql values(3614,'delete from transaction_total_check where cny = 3614 and jpy = 361400 and gbp = 2529.8 and eur = 401154 and  hkd = 3252.6','')")

    con:query("insert into check_sql values(3615,'delete from transaction_total_check where cny = 3615 and jpy = 361500 and gbp = 2530.5 and eur = 401265 and  hkd = 3253.5','')")

    con:query("insert into check_sql values(3616,'delete from transaction_total_check where cny = 3616 and jpy = 361600 and gbp = 2531.2 and eur = 401376 and  hkd = 3254.4','')")

    con:query("insert into check_sql values(3617,'delete from transaction_total_check where cny = 3617 and jpy = 361700 and gbp = 2531.9 and eur = 401487 and  hkd = 3255.3','')")

    con:query("insert into check_sql values(3618,'delete from transaction_total_check where cny = 3618 and jpy = 361800 and gbp = 2532.6 and eur = 401598 and  hkd = 3256.2','')")

    con:query("insert into check_sql values(3619,'delete from transaction_total_check where cny = 3619 and jpy = 361900 and gbp = 2533.3 and eur = 401709 and  hkd = 3257.1','')")

    con:query("insert into check_sql values(3620,'delete from transaction_total_check where cny = 3620 and jpy = 362000 and gbp = 2534.0 and eur = 401820 and  hkd = 3258.0','')")

    con:query("insert into check_sql values(3621,'delete from transaction_total_check where cny = 3621 and jpy = 362100 and gbp = 2534.7 and eur = 401931 and  hkd = 3258.9','')")

    con:query("insert into check_sql values(3622,'delete from transaction_total_check where cny = 3622 and jpy = 362200 and gbp = 2535.4 and eur = 402042 and  hkd = 3259.8','')")

    con:query("insert into check_sql values(3623,'delete from transaction_total_check where cny = 3623 and jpy = 362300 and gbp = 2536.1 and eur = 402153 and  hkd = 3260.7','')")

    con:query("insert into check_sql values(3624,'delete from transaction_total_check where cny = 3624 and jpy = 362400 and gbp = 2536.8 and eur = 402264 and  hkd = 3261.6','')")

    con:query("insert into check_sql values(3625,'delete from transaction_total_check where cny = 3625 and jpy = 362500 and gbp = 2537.5 and eur = 402375 and  hkd = 3262.5','')")

    con:query("insert into check_sql values(3626,'delete from transaction_total_check where cny = 3626 and jpy = 362600 and gbp = 2538.2 and eur = 402486 and  hkd = 3263.4','')")

    con:query("insert into check_sql values(3627,'delete from transaction_total_check where cny = 3627 and jpy = 362700 and gbp = 2538.9 and eur = 402597 and  hkd = 3264.3','')")

    con:query("insert into check_sql values(3628,'delete from transaction_total_check where cny = 3628 and jpy = 362800 and gbp = 2539.6 and eur = 402708 and  hkd = 3265.2','')")

    con:query("insert into check_sql values(3629,'delete from transaction_total_check where cny = 3629 and jpy = 362900 and gbp = 2540.3 and eur = 402819 and  hkd = 3266.1','')")

    con:query("insert into check_sql values(3630,'delete from transaction_total_check where cny = 3630 and jpy = 363000 and gbp = 2541.0 and eur = 402930 and  hkd = 3267.0','')")

    con:query("insert into check_sql values(3631,'delete from transaction_total_check where cny = 3631 and jpy = 363100 and gbp = 2541.7 and eur = 403041 and  hkd = 3267.9','')")

    con:query("insert into check_sql values(3632,'delete from transaction_total_check where cny = 3632 and jpy = 363200 and gbp = 2542.4 and eur = 403152 and  hkd = 3268.8','')")

    con:query("insert into check_sql values(3633,'delete from transaction_total_check where cny = 3633 and jpy = 363300 and gbp = 2543.1 and eur = 403263 and  hkd = 3269.7','')")

    con:query("insert into check_sql values(3634,'delete from transaction_total_check where cny = 3634 and jpy = 363400 and gbp = 2543.8 and eur = 403374 and  hkd = 3270.6','')")

    con:query("insert into check_sql values(3635,'delete from transaction_total_check where cny = 3635 and jpy = 363500 and gbp = 2544.5 and eur = 403485 and  hkd = 3271.5','')")

    con:query("insert into check_sql values(3636,'delete from transaction_total_check where cny = 3636 and jpy = 363600 and gbp = 2545.2 and eur = 403596 and  hkd = 3272.4','')")

    con:query("insert into check_sql values(3637,'delete from transaction_total_check where cny = 3637 and jpy = 363700 and gbp = 2545.9 and eur = 403707 and  hkd = 3273.3','')")

    con:query("insert into check_sql values(3638,'delete from transaction_total_check where cny = 3638 and jpy = 363800 and gbp = 2546.6 and eur = 403818 and  hkd = 3274.2','')")

    con:query("insert into check_sql values(3639,'delete from transaction_total_check where cny = 3639 and jpy = 363900 and gbp = 2547.3 and eur = 403929 and  hkd = 3275.1','')")

    con:query("insert into check_sql values(3640,'delete from transaction_total_check where cny = 3640 and jpy = 364000 and gbp = 2548.0 and eur = 404040 and  hkd = 3276.0','')")

    con:query("insert into check_sql values(3641,'delete from transaction_total_check where cny = 3641 and jpy = 364100 and gbp = 2548.7 and eur = 404151 and  hkd = 3276.9','')")

    con:query("insert into check_sql values(3642,'delete from transaction_total_check where cny = 3642 and jpy = 364200 and gbp = 2549.4 and eur = 404262 and  hkd = 3277.8','')")

    con:query("insert into check_sql values(3643,'delete from transaction_total_check where cny = 3643 and jpy = 364300 and gbp = 2550.1 and eur = 404373 and  hkd = 3278.7','')")

    con:query("insert into check_sql values(3644,'delete from transaction_total_check where cny = 3644 and jpy = 364400 and gbp = 2550.8 and eur = 404484 and  hkd = 3279.6','')")

    con:query("insert into check_sql values(3645,'delete from transaction_total_check where cny = 3645 and jpy = 364500 and gbp = 2551.5 and eur = 404595 and  hkd = 3280.5','')")

    con:query("insert into check_sql values(3646,'delete from transaction_total_check where cny = 3646 and jpy = 364600 and gbp = 2552.2 and eur = 404706 and  hkd = 3281.4','')")

    con:query("insert into check_sql values(3647,'delete from transaction_total_check where cny = 3647 and jpy = 364700 and gbp = 2552.9 and eur = 404817 and  hkd = 3282.3','')")

    con:query("insert into check_sql values(3648,'delete from transaction_total_check where cny = 3648 and jpy = 364800 and gbp = 2553.6 and eur = 404928 and  hkd = 3283.2','')")

    con:query("insert into check_sql values(3649,'delete from transaction_total_check where cny = 3649 and jpy = 364900 and gbp = 2554.3 and eur = 405039 and  hkd = 3284.1','')")

    con:query("insert into check_sql values(3650,'delete from transaction_total_check where cny = 3650 and jpy = 365000 and gbp = 2555.0 and eur = 405150 and  hkd = 3285.0','')")

    con:query("insert into check_sql values(3651,'delete from transaction_total_check where cny = 3651 and jpy = 365100 and gbp = 2555.7 and eur = 405261 and  hkd = 3285.9','')")

    con:query("insert into check_sql values(3652,'delete from transaction_total_check where cny = 3652 and jpy = 365200 and gbp = 2556.4 and eur = 405372 and  hkd = 3286.8','')")

    con:query("insert into check_sql values(3653,'delete from transaction_total_check where cny = 3653 and jpy = 365300 and gbp = 2557.1 and eur = 405483 and  hkd = 3287.7','')")

    con:query("insert into check_sql values(3654,'delete from transaction_total_check where cny = 3654 and jpy = 365400 and gbp = 2557.8 and eur = 405594 and  hkd = 3288.6','')")

    con:query("insert into check_sql values(3655,'delete from transaction_total_check where cny = 3655 and jpy = 365500 and gbp = 2558.5 and eur = 405705 and  hkd = 3289.5','')")

    con:query("insert into check_sql values(3656,'delete from transaction_total_check where cny = 3656 and jpy = 365600 and gbp = 2559.2 and eur = 405816 and  hkd = 3290.4','')")

    con:query("insert into check_sql values(3657,'delete from transaction_total_check where cny = 3657 and jpy = 365700 and gbp = 2559.9 and eur = 405927 and  hkd = 3291.3','')")

    con:query("insert into check_sql values(3658,'delete from transaction_total_check where cny = 3658 and jpy = 365800 and gbp = 2560.6 and eur = 406038 and  hkd = 3292.2','')")

    con:query("insert into check_sql values(3659,'delete from transaction_total_check where cny = 3659 and jpy = 365900 and gbp = 2561.3 and eur = 406149 and  hkd = 3293.1','')")

    con:query("insert into check_sql values(3660,'delete from transaction_total_check where cny = 3660 and jpy = 366000 and gbp = 2562.0 and eur = 406260 and  hkd = 3294.0','')")

    con:query("insert into check_sql values(3661,'delete from transaction_total_check where cny = 3661 and jpy = 366100 and gbp = 2562.7 and eur = 406371 and  hkd = 3294.9','')")

    con:query("insert into check_sql values(3662,'delete from transaction_total_check where cny = 3662 and jpy = 366200 and gbp = 2563.4 and eur = 406482 and  hkd = 3295.8','')")

    con:query("insert into check_sql values(3663,'delete from transaction_total_check where cny = 3663 and jpy = 366300 and gbp = 2564.1 and eur = 406593 and  hkd = 3296.7','')")

    con:query("insert into check_sql values(3664,'delete from transaction_total_check where cny = 3664 and jpy = 366400 and gbp = 2564.8 and eur = 406704 and  hkd = 3297.6','')")

    con:query("insert into check_sql values(3665,'delete from transaction_total_check where cny = 3665 and jpy = 366500 and gbp = 2565.5 and eur = 406815 and  hkd = 3298.5','')")

    con:query("insert into check_sql values(3666,'delete from transaction_total_check where cny = 3666 and jpy = 366600 and gbp = 2566.2 and eur = 406926 and  hkd = 3299.4','')")

    con:query("insert into check_sql values(3667,'delete from transaction_total_check where cny = 3667 and jpy = 366700 and gbp = 2566.9 and eur = 407037 and  hkd = 3300.3','')")

    con:query("insert into check_sql values(3668,'delete from transaction_total_check where cny = 3668 and jpy = 366800 and gbp = 2567.6 and eur = 407148 and  hkd = 3301.2','')")

    con:query("insert into check_sql values(3669,'delete from transaction_total_check where cny = 3669 and jpy = 366900 and gbp = 2568.3 and eur = 407259 and  hkd = 3302.1','')")

    con:query("insert into check_sql values(3670,'delete from transaction_total_check where cny = 3670 and jpy = 367000 and gbp = 2569.0 and eur = 407370 and  hkd = 3303.0','')")

    con:query("insert into check_sql values(3671,'delete from transaction_total_check where cny = 3671 and jpy = 367100 and gbp = 2569.7 and eur = 407481 and  hkd = 3303.9','')")

    con:query("insert into check_sql values(3672,'delete from transaction_total_check where cny = 3672 and jpy = 367200 and gbp = 2570.4 and eur = 407592 and  hkd = 3304.8','')")

    con:query("insert into check_sql values(3673,'delete from transaction_total_check where cny = 3673 and jpy = 367300 and gbp = 2571.1 and eur = 407703 and  hkd = 3305.7','')")

    con:query("insert into check_sql values(3674,'delete from transaction_total_check where cny = 3674 and jpy = 367400 and gbp = 2571.8 and eur = 407814 and  hkd = 3306.6','')")

    con:query("insert into check_sql values(3675,'delete from transaction_total_check where cny = 3675 and jpy = 367500 and gbp = 2572.5 and eur = 407925 and  hkd = 3307.5','')")

    con:query("insert into check_sql values(3676,'delete from transaction_total_check where cny = 3676 and jpy = 367600 and gbp = 2573.2 and eur = 408036 and  hkd = 3308.4','')")

    con:query("insert into check_sql values(3677,'delete from transaction_total_check where cny = 3677 and jpy = 367700 and gbp = 2573.9 and eur = 408147 and  hkd = 3309.3','')")

    con:query("insert into check_sql values(3678,'delete from transaction_total_check where cny = 3678 and jpy = 367800 and gbp = 2574.6 and eur = 408258 and  hkd = 3310.2','')")

    con:query("insert into check_sql values(3679,'delete from transaction_total_check where cny = 3679 and jpy = 367900 and gbp = 2575.3 and eur = 408369 and  hkd = 3311.1','')")

    con:query("insert into check_sql values(3680,'delete from transaction_total_check where cny = 3680 and jpy = 368000 and gbp = 2576.0 and eur = 408480 and  hkd = 3312.0','')")

    con:query("insert into check_sql values(3681,'delete from transaction_total_check where cny = 3681 and jpy = 368100 and gbp = 2576.7 and eur = 408591 and  hkd = 3312.9','')")

    con:query("insert into check_sql values(3682,'delete from transaction_total_check where cny = 3682 and jpy = 368200 and gbp = 2577.4 and eur = 408702 and  hkd = 3313.8','')")

    con:query("insert into check_sql values(3683,'delete from transaction_total_check where cny = 3683 and jpy = 368300 and gbp = 2578.1 and eur = 408813 and  hkd = 3314.7','')")

    con:query("insert into check_sql values(3684,'delete from transaction_total_check where cny = 3684 and jpy = 368400 and gbp = 2578.8 and eur = 408924 and  hkd = 3315.6','')")

    con:query("insert into check_sql values(3685,'delete from transaction_total_check where cny = 3685 and jpy = 368500 and gbp = 2579.5 and eur = 409035 and  hkd = 3316.5','')")

    con:query("insert into check_sql values(3686,'delete from transaction_total_check where cny = 3686 and jpy = 368600 and gbp = 2580.2 and eur = 409146 and  hkd = 3317.4','')")

    con:query("insert into check_sql values(3687,'delete from transaction_total_check where cny = 3687 and jpy = 368700 and gbp = 2580.9 and eur = 409257 and  hkd = 3318.3','')")

    con:query("insert into check_sql values(3688,'delete from transaction_total_check where cny = 3688 and jpy = 368800 and gbp = 2581.6 and eur = 409368 and  hkd = 3319.2','')")

    con:query("insert into check_sql values(3689,'delete from transaction_total_check where cny = 3689 and jpy = 368900 and gbp = 2582.3 and eur = 409479 and  hkd = 3320.1','')")

    con:query("insert into check_sql values(3690,'delete from transaction_total_check where cny = 3690 and jpy = 369000 and gbp = 2583.0 and eur = 409590 and  hkd = 3321.0','')")

    con:query("insert into check_sql values(3691,'delete from transaction_total_check where cny = 3691 and jpy = 369100 and gbp = 2583.7 and eur = 409701 and  hkd = 3321.9','')")

    con:query("insert into check_sql values(3692,'delete from transaction_total_check where cny = 3692 and jpy = 369200 and gbp = 2584.4 and eur = 409812 and  hkd = 3322.8','')")

    con:query("insert into check_sql values(3693,'delete from transaction_total_check where cny = 3693 and jpy = 369300 and gbp = 2585.1 and eur = 409923 and  hkd = 3323.7','')")

    con:query("insert into check_sql values(3694,'delete from transaction_total_check where cny = 3694 and jpy = 369400 and gbp = 2585.8 and eur = 410034 and  hkd = 3324.6','')")

    con:query("insert into check_sql values(3695,'delete from transaction_total_check where cny = 3695 and jpy = 369500 and gbp = 2586.5 and eur = 410145 and  hkd = 3325.5','')")

    con:query("insert into check_sql values(3696,'delete from transaction_total_check where cny = 3696 and jpy = 369600 and gbp = 2587.2 and eur = 410256 and  hkd = 3326.4','')")

    con:query("insert into check_sql values(3697,'delete from transaction_total_check where cny = 3697 and jpy = 369700 and gbp = 2587.9 and eur = 410367 and  hkd = 3327.3','')")

    con:query("insert into check_sql values(3698,'delete from transaction_total_check where cny = 3698 and jpy = 369800 and gbp = 2588.6 and eur = 410478 and  hkd = 3328.2','')")

    con:query("insert into check_sql values(3699,'delete from transaction_total_check where cny = 3699 and jpy = 369900 and gbp = 2589.3 and eur = 410589 and  hkd = 3329.1','')")

    con:query("insert into check_sql values(3700,'delete from transaction_total_check where cny = 3700 and jpy = 370000 and gbp = 2590.0 and eur = 410700 and  hkd = 3330.0','')")

    con:query("insert into check_sql values(3701,'delete from transaction_total_check where cny = 3701 and jpy = 370100 and gbp = 2590.7 and eur = 410811 and  hkd = 3330.9','')")

    con:query("insert into check_sql values(3702,'delete from transaction_total_check where cny = 3702 and jpy = 370200 and gbp = 2591.4 and eur = 410922 and  hkd = 3331.8','')")

    con:query("insert into check_sql values(3703,'delete from transaction_total_check where cny = 3703 and jpy = 370300 and gbp = 2592.1 and eur = 411033 and  hkd = 3332.7','')")

    con:query("insert into check_sql values(3704,'delete from transaction_total_check where cny = 3704 and jpy = 370400 and gbp = 2592.8 and eur = 411144 and  hkd = 3333.6','')")

    con:query("insert into check_sql values(3705,'delete from transaction_total_check where cny = 3705 and jpy = 370500 and gbp = 2593.5 and eur = 411255 and  hkd = 3334.5','')")

    con:query("insert into check_sql values(3706,'delete from transaction_total_check where cny = 3706 and jpy = 370600 and gbp = 2594.2 and eur = 411366 and  hkd = 3335.4','')")

    con:query("insert into check_sql values(3707,'delete from transaction_total_check where cny = 3707 and jpy = 370700 and gbp = 2594.9 and eur = 411477 and  hkd = 3336.3','')")

    con:query("insert into check_sql values(3708,'delete from transaction_total_check where cny = 3708 and jpy = 370800 and gbp = 2595.6 and eur = 411588 and  hkd = 3337.2','')")

    con:query("insert into check_sql values(3709,'delete from transaction_total_check where cny = 3709 and jpy = 370900 and gbp = 2596.3 and eur = 411699 and  hkd = 3338.1','')")

    con:query("insert into check_sql values(3710,'delete from transaction_total_check where cny = 3710 and jpy = 371000 and gbp = 2597.0 and eur = 411810 and  hkd = 3339.0','')")

    con:query("insert into check_sql values(3711,'delete from transaction_total_check where cny = 3711 and jpy = 371100 and gbp = 2597.7 and eur = 411921 and  hkd = 3339.9','')")

    con:query("insert into check_sql values(3712,'delete from transaction_total_check where cny = 3712 and jpy = 371200 and gbp = 2598.4 and eur = 412032 and  hkd = 3340.8','')")

    con:query("insert into check_sql values(3713,'delete from transaction_total_check where cny = 3713 and jpy = 371300 and gbp = 2599.1 and eur = 412143 and  hkd = 3341.7','')")

    con:query("insert into check_sql values(3714,'delete from transaction_total_check where cny = 3714 and jpy = 371400 and gbp = 2599.8 and eur = 412254 and  hkd = 3342.6','')")

    con:query("insert into check_sql values(3715,'delete from transaction_total_check where cny = 3715 and jpy = 371500 and gbp = 2600.5 and eur = 412365 and  hkd = 3343.5','')")

    con:query("insert into check_sql values(3716,'delete from transaction_total_check where cny = 3716 and jpy = 371600 and gbp = 2601.2 and eur = 412476 and  hkd = 3344.4','')")

    con:query("insert into check_sql values(3717,'delete from transaction_total_check where cny = 3717 and jpy = 371700 and gbp = 2601.9 and eur = 412587 and  hkd = 3345.3','')")

    con:query("insert into check_sql values(3718,'delete from transaction_total_check where cny = 3718 and jpy = 371800 and gbp = 2602.6 and eur = 412698 and  hkd = 3346.2','')")

    con:query("insert into check_sql values(3719,'delete from transaction_total_check where cny = 3719 and jpy = 371900 and gbp = 2603.3 and eur = 412809 and  hkd = 3347.1','')")

    con:query("insert into check_sql values(3720,'delete from transaction_total_check where cny = 3720 and jpy = 372000 and gbp = 2604.0 and eur = 412920 and  hkd = 3348.0','')")

    con:query("insert into check_sql values(3721,'delete from transaction_total_check where cny = 3721 and jpy = 372100 and gbp = 2604.7 and eur = 413031 and  hkd = 3348.9','')")

    con:query("insert into check_sql values(3722,'delete from transaction_total_check where cny = 3722 and jpy = 372200 and gbp = 2605.4 and eur = 413142 and  hkd = 3349.8','')")

    con:query("insert into check_sql values(3723,'delete from transaction_total_check where cny = 3723 and jpy = 372300 and gbp = 2606.1 and eur = 413253 and  hkd = 3350.7','')")

    con:query("insert into check_sql values(3724,'delete from transaction_total_check where cny = 3724 and jpy = 372400 and gbp = 2606.8 and eur = 413364 and  hkd = 3351.6','')")

    con:query("insert into check_sql values(3725,'delete from transaction_total_check where cny = 3725 and jpy = 372500 and gbp = 2607.5 and eur = 413475 and  hkd = 3352.5','')")

    con:query("insert into check_sql values(3726,'delete from transaction_total_check where cny = 3726 and jpy = 372600 and gbp = 2608.2 and eur = 413586 and  hkd = 3353.4','')")

    con:query("insert into check_sql values(3727,'delete from transaction_total_check where cny = 3727 and jpy = 372700 and gbp = 2608.9 and eur = 413697 and  hkd = 3354.3','')")

    con:query("insert into check_sql values(3728,'delete from transaction_total_check where cny = 3728 and jpy = 372800 and gbp = 2609.6 and eur = 413808 and  hkd = 3355.2','')")

    con:query("insert into check_sql values(3729,'delete from transaction_total_check where cny = 3729 and jpy = 372900 and gbp = 2610.3 and eur = 413919 and  hkd = 3356.1','')")

    con:query("insert into check_sql values(3730,'delete from transaction_total_check where cny = 3730 and jpy = 373000 and gbp = 2611.0 and eur = 414030 and  hkd = 3357.0','')")

    con:query("insert into check_sql values(3731,'delete from transaction_total_check where cny = 3731 and jpy = 373100 and gbp = 2611.7 and eur = 414141 and  hkd = 3357.9','')")

    con:query("insert into check_sql values(3732,'delete from transaction_total_check where cny = 3732 and jpy = 373200 and gbp = 2612.4 and eur = 414252 and  hkd = 3358.8','')")

    con:query("insert into check_sql values(3733,'delete from transaction_total_check where cny = 3733 and jpy = 373300 and gbp = 2613.1 and eur = 414363 and  hkd = 3359.7','')")

    con:query("insert into check_sql values(3734,'delete from transaction_total_check where cny = 3734 and jpy = 373400 and gbp = 2613.8 and eur = 414474 and  hkd = 3360.6','')")

    con:query("insert into check_sql values(3735,'delete from transaction_total_check where cny = 3735 and jpy = 373500 and gbp = 2614.5 and eur = 414585 and  hkd = 3361.5','')")

    con:query("insert into check_sql values(3736,'delete from transaction_total_check where cny = 3736 and jpy = 373600 and gbp = 2615.2 and eur = 414696 and  hkd = 3362.4','')")

    con:query("insert into check_sql values(3737,'delete from transaction_total_check where cny = 3737 and jpy = 373700 and gbp = 2615.9 and eur = 414807 and  hkd = 3363.3','')")

    con:query("insert into check_sql values(3738,'delete from transaction_total_check where cny = 3738 and jpy = 373800 and gbp = 2616.6 and eur = 414918 and  hkd = 3364.2','')")

    con:query("insert into check_sql values(3739,'delete from transaction_total_check where cny = 3739 and jpy = 373900 and gbp = 2617.3 and eur = 415029 and  hkd = 3365.1','')")

    con:query("insert into check_sql values(3740,'delete from transaction_total_check where cny = 3740 and jpy = 374000 and gbp = 2618.0 and eur = 415140 and  hkd = 3366.0','')")

    con:query("insert into check_sql values(3741,'delete from transaction_total_check where cny = 3741 and jpy = 374100 and gbp = 2618.7 and eur = 415251 and  hkd = 3366.9','')")

    con:query("insert into check_sql values(3742,'delete from transaction_total_check where cny = 3742 and jpy = 374200 and gbp = 2619.4 and eur = 415362 and  hkd = 3367.8','')")

    con:query("insert into check_sql values(3743,'delete from transaction_total_check where cny = 3743 and jpy = 374300 and gbp = 2620.1 and eur = 415473 and  hkd = 3368.7','')")

    con:query("insert into check_sql values(3744,'delete from transaction_total_check where cny = 3744 and jpy = 374400 and gbp = 2620.8 and eur = 415584 and  hkd = 3369.6','')")

    con:query("insert into check_sql values(3745,'delete from transaction_total_check where cny = 3745 and jpy = 374500 and gbp = 2621.5 and eur = 415695 and  hkd = 3370.5','')")

    con:query("insert into check_sql values(3746,'delete from transaction_total_check where cny = 3746 and jpy = 374600 and gbp = 2622.2 and eur = 415806 and  hkd = 3371.4','')")

    con:query("insert into check_sql values(3747,'delete from transaction_total_check where cny = 3747 and jpy = 374700 and gbp = 2622.9 and eur = 415917 and  hkd = 3372.3','')")

    con:query("insert into check_sql values(3748,'delete from transaction_total_check where cny = 3748 and jpy = 374800 and gbp = 2623.6 and eur = 416028 and  hkd = 3373.2','')")

    con:query("insert into check_sql values(3749,'delete from transaction_total_check where cny = 3749 and jpy = 374900 and gbp = 2624.3 and eur = 416139 and  hkd = 3374.1','')")

    con:query("insert into check_sql values(3750,'delete from transaction_total_check where cny = 3750 and jpy = 375000 and gbp = 2625.0 and eur = 416250 and  hkd = 3375.0','')")

    con:query("insert into check_sql values(3751,'delete from transaction_total_check where cny = 3751 and jpy = 375100 and gbp = 2625.7 and eur = 416361 and  hkd = 3375.9','')")

    con:query("insert into check_sql values(3752,'delete from transaction_total_check where cny = 3752 and jpy = 375200 and gbp = 2626.4 and eur = 416472 and  hkd = 3376.8','')")

    con:query("insert into check_sql values(3753,'delete from transaction_total_check where cny = 3753 and jpy = 375300 and gbp = 2627.1 and eur = 416583 and  hkd = 3377.7','')")

    con:query("insert into check_sql values(3754,'delete from transaction_total_check where cny = 3754 and jpy = 375400 and gbp = 2627.8 and eur = 416694 and  hkd = 3378.6','')")

    con:query("insert into check_sql values(3755,'delete from transaction_total_check where cny = 3755 and jpy = 375500 and gbp = 2628.5 and eur = 416805 and  hkd = 3379.5','')")

    con:query("insert into check_sql values(3756,'delete from transaction_total_check where cny = 3756 and jpy = 375600 and gbp = 2629.2 and eur = 416916 and  hkd = 3380.4','')")

    con:query("insert into check_sql values(3757,'delete from transaction_total_check where cny = 3757 and jpy = 375700 and gbp = 2629.9 and eur = 417027 and  hkd = 3381.3','')")

    con:query("insert into check_sql values(3758,'delete from transaction_total_check where cny = 3758 and jpy = 375800 and gbp = 2630.6 and eur = 417138 and  hkd = 3382.2','')")

    con:query("insert into check_sql values(3759,'delete from transaction_total_check where cny = 3759 and jpy = 375900 and gbp = 2631.3 and eur = 417249 and  hkd = 3383.1','')")

    con:query("insert into check_sql values(3760,'delete from transaction_total_check where cny = 3760 and jpy = 376000 and gbp = 2632.0 and eur = 417360 and  hkd = 3384.0','')")

    con:query("insert into check_sql values(3761,'delete from transaction_total_check where cny = 3761 and jpy = 376100 and gbp = 2632.7 and eur = 417471 and  hkd = 3384.9','')")

    con:query("insert into check_sql values(3762,'delete from transaction_total_check where cny = 3762 and jpy = 376200 and gbp = 2633.4 and eur = 417582 and  hkd = 3385.8','')")

    con:query("insert into check_sql values(3763,'delete from transaction_total_check where cny = 3763 and jpy = 376300 and gbp = 2634.1 and eur = 417693 and  hkd = 3386.7','')")

    con:query("insert into check_sql values(3764,'delete from transaction_total_check where cny = 3764 and jpy = 376400 and gbp = 2634.8 and eur = 417804 and  hkd = 3387.6','')")

    con:query("insert into check_sql values(3765,'delete from transaction_total_check where cny = 3765 and jpy = 376500 and gbp = 2635.5 and eur = 417915 and  hkd = 3388.5','')")

    con:query("insert into check_sql values(3766,'delete from transaction_total_check where cny = 3766 and jpy = 376600 and gbp = 2636.2 and eur = 418026 and  hkd = 3389.4','')")

    con:query("insert into check_sql values(3767,'delete from transaction_total_check where cny = 3767 and jpy = 376700 and gbp = 2636.9 and eur = 418137 and  hkd = 3390.3','')")

    con:query("insert into check_sql values(3768,'delete from transaction_total_check where cny = 3768 and jpy = 376800 and gbp = 2637.6 and eur = 418248 and  hkd = 3391.2','')")

    con:query("insert into check_sql values(3769,'delete from transaction_total_check where cny = 3769 and jpy = 376900 and gbp = 2638.3 and eur = 418359 and  hkd = 3392.1','')")

    con:query("insert into check_sql values(3770,'delete from transaction_total_check where cny = 3770 and jpy = 377000 and gbp = 2639.0 and eur = 418470 and  hkd = 3393.0','')")

    con:query("insert into check_sql values(3771,'delete from transaction_total_check where cny = 3771 and jpy = 377100 and gbp = 2639.7 and eur = 418581 and  hkd = 3393.9','')")

    con:query("insert into check_sql values(3772,'delete from transaction_total_check where cny = 3772 and jpy = 377200 and gbp = 2640.4 and eur = 418692 and  hkd = 3394.8','')")

    con:query("insert into check_sql values(3773,'delete from transaction_total_check where cny = 3773 and jpy = 377300 and gbp = 2641.1 and eur = 418803 and  hkd = 3395.7','')")

    con:query("insert into check_sql values(3774,'delete from transaction_total_check where cny = 3774 and jpy = 377400 and gbp = 2641.8 and eur = 418914 and  hkd = 3396.6','')")

    con:query("insert into check_sql values(3775,'delete from transaction_total_check where cny = 3775 and jpy = 377500 and gbp = 2642.5 and eur = 419025 and  hkd = 3397.5','')")

    con:query("insert into check_sql values(3776,'delete from transaction_total_check where cny = 3776 and jpy = 377600 and gbp = 2643.2 and eur = 419136 and  hkd = 3398.4','')")

    con:query("insert into check_sql values(3777,'delete from transaction_total_check where cny = 3777 and jpy = 377700 and gbp = 2643.9 and eur = 419247 and  hkd = 3399.3','')")

    con:query("insert into check_sql values(3778,'delete from transaction_total_check where cny = 3778 and jpy = 377800 and gbp = 2644.6 and eur = 419358 and  hkd = 3400.2','')")

    con:query("insert into check_sql values(3779,'delete from transaction_total_check where cny = 3779 and jpy = 377900 and gbp = 2645.3 and eur = 419469 and  hkd = 3401.1','')")

    con:query("insert into check_sql values(3780,'delete from transaction_total_check where cny = 3780 and jpy = 378000 and gbp = 2646.0 and eur = 419580 and  hkd = 3402.0','')")

    con:query("insert into check_sql values(3781,'delete from transaction_total_check where cny = 3781 and jpy = 378100 and gbp = 2646.7 and eur = 419691 and  hkd = 3402.9','')")

    con:query("insert into check_sql values(3782,'delete from transaction_total_check where cny = 3782 and jpy = 378200 and gbp = 2647.4 and eur = 419802 and  hkd = 3403.8','')")

    con:query("insert into check_sql values(3783,'delete from transaction_total_check where cny = 3783 and jpy = 378300 and gbp = 2648.1 and eur = 419913 and  hkd = 3404.7','')")

    con:query("insert into check_sql values(3784,'delete from transaction_total_check where cny = 3784 and jpy = 378400 and gbp = 2648.8 and eur = 420024 and  hkd = 3405.6','')")

    con:query("insert into check_sql values(3785,'delete from transaction_total_check where cny = 3785 and jpy = 378500 and gbp = 2649.5 and eur = 420135 and  hkd = 3406.5','')")

    con:query("insert into check_sql values(3786,'delete from transaction_total_check where cny = 3786 and jpy = 378600 and gbp = 2650.2 and eur = 420246 and  hkd = 3407.4','')")

    con:query("insert into check_sql values(3787,'delete from transaction_total_check where cny = 3787 and jpy = 378700 and gbp = 2650.9 and eur = 420357 and  hkd = 3408.3','')")

    con:query("insert into check_sql values(3788,'delete from transaction_total_check where cny = 3788 and jpy = 378800 and gbp = 2651.6 and eur = 420468 and  hkd = 3409.2','')")

    con:query("insert into check_sql values(3789,'delete from transaction_total_check where cny = 3789 and jpy = 378900 and gbp = 2652.3 and eur = 420579 and  hkd = 3410.1','')")

    con:query("insert into check_sql values(3790,'delete from transaction_total_check where cny = 3790 and jpy = 379000 and gbp = 2653.0 and eur = 420690 and  hkd = 3411.0','')")

    con:query("insert into check_sql values(3791,'delete from transaction_total_check where cny = 3791 and jpy = 379100 and gbp = 2653.7 and eur = 420801 and  hkd = 3411.9','')")

    con:query("insert into check_sql values(3792,'delete from transaction_total_check where cny = 3792 and jpy = 379200 and gbp = 2654.4 and eur = 420912 and  hkd = 3412.8','')")

    con:query("insert into check_sql values(3793,'delete from transaction_total_check where cny = 3793 and jpy = 379300 and gbp = 2655.1 and eur = 421023 and  hkd = 3413.7','')")

    con:query("insert into check_sql values(3794,'delete from transaction_total_check where cny = 3794 and jpy = 379400 and gbp = 2655.8 and eur = 421134 and  hkd = 3414.6','')")

    con:query("insert into check_sql values(3795,'delete from transaction_total_check where cny = 3795 and jpy = 379500 and gbp = 2656.5 and eur = 421245 and  hkd = 3415.5','')")

    con:query("insert into check_sql values(3796,'delete from transaction_total_check where cny = 3796 and jpy = 379600 and gbp = 2657.2 and eur = 421356 and  hkd = 3416.4','')")

    con:query("insert into check_sql values(3797,'delete from transaction_total_check where cny = 3797 and jpy = 379700 and gbp = 2657.9 and eur = 421467 and  hkd = 3417.3','')")

    con:query("insert into check_sql values(3798,'delete from transaction_total_check where cny = 3798 and jpy = 379800 and gbp = 2658.6 and eur = 421578 and  hkd = 3418.2','')")

    con:query("insert into check_sql values(3799,'delete from transaction_total_check where cny = 3799 and jpy = 379900 and gbp = 2659.3 and eur = 421689 and  hkd = 3419.1','')")

    con:query("insert into check_sql values(3800,'delete from transaction_total_check where cny = 3800 and jpy = 380000 and gbp = 2660.0 and eur = 421800 and  hkd = 3420.0','')")

    con:query("insert into check_sql values(3801,'delete from transaction_total_check where cny = 3801 and jpy = 380100 and gbp = 2660.7 and eur = 421911 and  hkd = 3420.9','')")

    con:query("insert into check_sql values(3802,'delete from transaction_total_check where cny = 3802 and jpy = 380200 and gbp = 2661.4 and eur = 422022 and  hkd = 3421.8','')")

    con:query("insert into check_sql values(3803,'delete from transaction_total_check where cny = 3803 and jpy = 380300 and gbp = 2662.1 and eur = 422133 and  hkd = 3422.7','')")

    con:query("insert into check_sql values(3804,'delete from transaction_total_check where cny = 3804 and jpy = 380400 and gbp = 2662.8 and eur = 422244 and  hkd = 3423.6','')")

    con:query("insert into check_sql values(3805,'delete from transaction_total_check where cny = 3805 and jpy = 380500 and gbp = 2663.5 and eur = 422355 and  hkd = 3424.5','')")

    con:query("insert into check_sql values(3806,'delete from transaction_total_check where cny = 3806 and jpy = 380600 and gbp = 2664.2 and eur = 422466 and  hkd = 3425.4','')")

    con:query("insert into check_sql values(3807,'delete from transaction_total_check where cny = 3807 and jpy = 380700 and gbp = 2664.9 and eur = 422577 and  hkd = 3426.3','')")

    con:query("insert into check_sql values(3808,'delete from transaction_total_check where cny = 3808 and jpy = 380800 and gbp = 2665.6 and eur = 422688 and  hkd = 3427.2','')")

    con:query("insert into check_sql values(3809,'delete from transaction_total_check where cny = 3809 and jpy = 380900 and gbp = 2666.3 and eur = 422799 and  hkd = 3428.1','')")

    con:query("insert into check_sql values(3810,'delete from transaction_total_check where cny = 3810 and jpy = 381000 and gbp = 2667.0 and eur = 422910 and  hkd = 3429.0','')")

    con:query("insert into check_sql values(3811,'delete from transaction_total_check where cny = 3811 and jpy = 381100 and gbp = 2667.7 and eur = 423021 and  hkd = 3429.9','')")

    con:query("insert into check_sql values(3812,'delete from transaction_total_check where cny = 3812 and jpy = 381200 and gbp = 2668.4 and eur = 423132 and  hkd = 3430.8','')")

    con:query("insert into check_sql values(3813,'delete from transaction_total_check where cny = 3813 and jpy = 381300 and gbp = 2669.1 and eur = 423243 and  hkd = 3431.7','')")

    con:query("insert into check_sql values(3814,'delete from transaction_total_check where cny = 3814 and jpy = 381400 and gbp = 2669.8 and eur = 423354 and  hkd = 3432.6','')")

    con:query("insert into check_sql values(3815,'delete from transaction_total_check where cny = 3815 and jpy = 381500 and gbp = 2670.5 and eur = 423465 and  hkd = 3433.5','')")

    con:query("insert into check_sql values(3816,'delete from transaction_total_check where cny = 3816 and jpy = 381600 and gbp = 2671.2 and eur = 423576 and  hkd = 3434.4','')")

    con:query("insert into check_sql values(3817,'delete from transaction_total_check where cny = 3817 and jpy = 381700 and gbp = 2671.9 and eur = 423687 and  hkd = 3435.3','')")

    con:query("insert into check_sql values(3818,'delete from transaction_total_check where cny = 3818 and jpy = 381800 and gbp = 2672.6 and eur = 423798 and  hkd = 3436.2','')")

    con:query("insert into check_sql values(3819,'delete from transaction_total_check where cny = 3819 and jpy = 381900 and gbp = 2673.3 and eur = 423909 and  hkd = 3437.1','')")

    con:query("insert into check_sql values(3820,'delete from transaction_total_check where cny = 3820 and jpy = 382000 and gbp = 2674.0 and eur = 424020 and  hkd = 3438.0','')")

    con:query("insert into check_sql values(3821,'delete from transaction_total_check where cny = 3821 and jpy = 382100 and gbp = 2674.7 and eur = 424131 and  hkd = 3438.9','')")

    con:query("insert into check_sql values(3822,'delete from transaction_total_check where cny = 3822 and jpy = 382200 and gbp = 2675.4 and eur = 424242 and  hkd = 3439.8','')")

    con:query("insert into check_sql values(3823,'delete from transaction_total_check where cny = 3823 and jpy = 382300 and gbp = 2676.1 and eur = 424353 and  hkd = 3440.7','')")

    con:query("insert into check_sql values(3824,'delete from transaction_total_check where cny = 3824 and jpy = 382400 and gbp = 2676.8 and eur = 424464 and  hkd = 3441.6','')")

    con:query("insert into check_sql values(3825,'delete from transaction_total_check where cny = 3825 and jpy = 382500 and gbp = 2677.5 and eur = 424575 and  hkd = 3442.5','')")

    con:query("insert into check_sql values(3826,'delete from transaction_total_check where cny = 3826 and jpy = 382600 and gbp = 2678.2 and eur = 424686 and  hkd = 3443.4','')")

    con:query("insert into check_sql values(3827,'delete from transaction_total_check where cny = 3827 and jpy = 382700 and gbp = 2678.9 and eur = 424797 and  hkd = 3444.3','')")

    con:query("insert into check_sql values(3828,'delete from transaction_total_check where cny = 3828 and jpy = 382800 and gbp = 2679.6 and eur = 424908 and  hkd = 3445.2','')")

    con:query("insert into check_sql values(3829,'delete from transaction_total_check where cny = 3829 and jpy = 382900 and gbp = 2680.3 and eur = 425019 and  hkd = 3446.1','')")

    con:query("insert into check_sql values(3830,'delete from transaction_total_check where cny = 3830 and jpy = 383000 and gbp = 2681.0 and eur = 425130 and  hkd = 3447.0','')")

    con:query("insert into check_sql values(3831,'delete from transaction_total_check where cny = 3831 and jpy = 383100 and gbp = 2681.7 and eur = 425241 and  hkd = 3447.9','')")

    con:query("insert into check_sql values(3832,'delete from transaction_total_check where cny = 3832 and jpy = 383200 and gbp = 2682.4 and eur = 425352 and  hkd = 3448.8','')")

    con:query("insert into check_sql values(3833,'delete from transaction_total_check where cny = 3833 and jpy = 383300 and gbp = 2683.1 and eur = 425463 and  hkd = 3449.7','')")

    con:query("insert into check_sql values(3834,'delete from transaction_total_check where cny = 3834 and jpy = 383400 and gbp = 2683.8 and eur = 425574 and  hkd = 3450.6','')")

    con:query("insert into check_sql values(3835,'delete from transaction_total_check where cny = 3835 and jpy = 383500 and gbp = 2684.5 and eur = 425685 and  hkd = 3451.5','')")

    con:query("insert into check_sql values(3836,'delete from transaction_total_check where cny = 3836 and jpy = 383600 and gbp = 2685.2 and eur = 425796 and  hkd = 3452.4','')")

    con:query("insert into check_sql values(3837,'delete from transaction_total_check where cny = 3837 and jpy = 383700 and gbp = 2685.9 and eur = 425907 and  hkd = 3453.3','')")

    con:query("insert into check_sql values(3838,'delete from transaction_total_check where cny = 3838 and jpy = 383800 and gbp = 2686.6 and eur = 426018 and  hkd = 3454.2','')")

    con:query("insert into check_sql values(3839,'delete from transaction_total_check where cny = 3839 and jpy = 383900 and gbp = 2687.3 and eur = 426129 and  hkd = 3455.1','')")

    con:query("insert into check_sql values(3840,'delete from transaction_total_check where cny = 3840 and jpy = 384000 and gbp = 2688.0 and eur = 426240 and  hkd = 3456.0','')")

    con:query("insert into check_sql values(3841,'delete from transaction_total_check where cny = 3841 and jpy = 384100 and gbp = 2688.7 and eur = 426351 and  hkd = 3456.9','')")

    con:query("insert into check_sql values(3842,'delete from transaction_total_check where cny = 3842 and jpy = 384200 and gbp = 2689.4 and eur = 426462 and  hkd = 3457.8','')")

    con:query("insert into check_sql values(3843,'delete from transaction_total_check where cny = 3843 and jpy = 384300 and gbp = 2690.1 and eur = 426573 and  hkd = 3458.7','')")

    con:query("insert into check_sql values(3844,'delete from transaction_total_check where cny = 3844 and jpy = 384400 and gbp = 2690.8 and eur = 426684 and  hkd = 3459.6','')")

    con:query("insert into check_sql values(3845,'delete from transaction_total_check where cny = 3845 and jpy = 384500 and gbp = 2691.5 and eur = 426795 and  hkd = 3460.5','')")

    con:query("insert into check_sql values(3846,'delete from transaction_total_check where cny = 3846 and jpy = 384600 and gbp = 2692.2 and eur = 426906 and  hkd = 3461.4','')")

    con:query("insert into check_sql values(3847,'delete from transaction_total_check where cny = 3847 and jpy = 384700 and gbp = 2692.9 and eur = 427017 and  hkd = 3462.3','')")

    con:query("insert into check_sql values(3848,'delete from transaction_total_check where cny = 3848 and jpy = 384800 and gbp = 2693.6 and eur = 427128 and  hkd = 3463.2','')")

    con:query("insert into check_sql values(3849,'delete from transaction_total_check where cny = 3849 and jpy = 384900 and gbp = 2694.3 and eur = 427239 and  hkd = 3464.1','')")

    con:query("insert into check_sql values(3850,'delete from transaction_total_check where cny = 3850 and jpy = 385000 and gbp = 2695.0 and eur = 427350 and  hkd = 3465.0','')")

    con:query("insert into check_sql values(3851,'delete from transaction_total_check where cny = 3851 and jpy = 385100 and gbp = 2695.7 and eur = 427461 and  hkd = 3465.9','')")

    con:query("insert into check_sql values(3852,'delete from transaction_total_check where cny = 3852 and jpy = 385200 and gbp = 2696.4 and eur = 427572 and  hkd = 3466.8','')")

    con:query("insert into check_sql values(3853,'delete from transaction_total_check where cny = 3853 and jpy = 385300 and gbp = 2697.1 and eur = 427683 and  hkd = 3467.7','')")

    con:query("insert into check_sql values(3854,'delete from transaction_total_check where cny = 3854 and jpy = 385400 and gbp = 2697.8 and eur = 427794 and  hkd = 3468.6','')")

    con:query("insert into check_sql values(3855,'delete from transaction_total_check where cny = 3855 and jpy = 385500 and gbp = 2698.5 and eur = 427905 and  hkd = 3469.5','')")

    con:query("insert into check_sql values(3856,'delete from transaction_total_check where cny = 3856 and jpy = 385600 and gbp = 2699.2 and eur = 428016 and  hkd = 3470.4','')")

    con:query("insert into check_sql values(3857,'delete from transaction_total_check where cny = 3857 and jpy = 385700 and gbp = 2699.9 and eur = 428127 and  hkd = 3471.3','')")

    con:query("insert into check_sql values(3858,'delete from transaction_total_check where cny = 3858 and jpy = 385800 and gbp = 2700.6 and eur = 428238 and  hkd = 3472.2','')")

    con:query("insert into check_sql values(3859,'delete from transaction_total_check where cny = 3859 and jpy = 385900 and gbp = 2701.3 and eur = 428349 and  hkd = 3473.1','')")

    con:query("insert into check_sql values(3860,'delete from transaction_total_check where cny = 3860 and jpy = 386000 and gbp = 2702.0 and eur = 428460 and  hkd = 3474.0','')")

    con:query("insert into check_sql values(3861,'delete from transaction_total_check where cny = 3861 and jpy = 386100 and gbp = 2702.7 and eur = 428571 and  hkd = 3474.9','')")

    con:query("insert into check_sql values(3862,'delete from transaction_total_check where cny = 3862 and jpy = 386200 and gbp = 2703.4 and eur = 428682 and  hkd = 3475.8','')")

    con:query("insert into check_sql values(3863,'delete from transaction_total_check where cny = 3863 and jpy = 386300 and gbp = 2704.1 and eur = 428793 and  hkd = 3476.7','')")

    con:query("insert into check_sql values(3864,'delete from transaction_total_check where cny = 3864 and jpy = 386400 and gbp = 2704.8 and eur = 428904 and  hkd = 3477.6','')")

    con:query("insert into check_sql values(3865,'delete from transaction_total_check where cny = 3865 and jpy = 386500 and gbp = 2705.5 and eur = 429015 and  hkd = 3478.5','')")

    con:query("insert into check_sql values(3866,'delete from transaction_total_check where cny = 3866 and jpy = 386600 and gbp = 2706.2 and eur = 429126 and  hkd = 3479.4','')")

    con:query("insert into check_sql values(3867,'delete from transaction_total_check where cny = 3867 and jpy = 386700 and gbp = 2706.9 and eur = 429237 and  hkd = 3480.3','')")

    con:query("insert into check_sql values(3868,'delete from transaction_total_check where cny = 3868 and jpy = 386800 and gbp = 2707.6 and eur = 429348 and  hkd = 3481.2','')")

    con:query("insert into check_sql values(3869,'delete from transaction_total_check where cny = 3869 and jpy = 386900 and gbp = 2708.3 and eur = 429459 and  hkd = 3482.1','')")

    con:query("insert into check_sql values(3870,'delete from transaction_total_check where cny = 3870 and jpy = 387000 and gbp = 2709.0 and eur = 429570 and  hkd = 3483.0','')")

    con:query("insert into check_sql values(3871,'delete from transaction_total_check where cny = 3871 and jpy = 387100 and gbp = 2709.7 and eur = 429681 and  hkd = 3483.9','')")

    con:query("insert into check_sql values(3872,'delete from transaction_total_check where cny = 3872 and jpy = 387200 and gbp = 2710.4 and eur = 429792 and  hkd = 3484.8','')")

    con:query("insert into check_sql values(3873,'delete from transaction_total_check where cny = 3873 and jpy = 387300 and gbp = 2711.1 and eur = 429903 and  hkd = 3485.7','')")

    con:query("insert into check_sql values(3874,'delete from transaction_total_check where cny = 3874 and jpy = 387400 and gbp = 2711.8 and eur = 430014 and  hkd = 3486.6','')")

    con:query("insert into check_sql values(3875,'delete from transaction_total_check where cny = 3875 and jpy = 387500 and gbp = 2712.5 and eur = 430125 and  hkd = 3487.5','')")

    con:query("insert into check_sql values(3876,'delete from transaction_total_check where cny = 3876 and jpy = 387600 and gbp = 2713.2 and eur = 430236 and  hkd = 3488.4','')")

    con:query("insert into check_sql values(3877,'delete from transaction_total_check where cny = 3877 and jpy = 387700 and gbp = 2713.9 and eur = 430347 and  hkd = 3489.3','')")

    con:query("insert into check_sql values(3878,'delete from transaction_total_check where cny = 3878 and jpy = 387800 and gbp = 2714.6 and eur = 430458 and  hkd = 3490.2','')")

    con:query("insert into check_sql values(3879,'delete from transaction_total_check where cny = 3879 and jpy = 387900 and gbp = 2715.3 and eur = 430569 and  hkd = 3491.1','')")

    con:query("insert into check_sql values(3880,'delete from transaction_total_check where cny = 3880 and jpy = 388000 and gbp = 2716.0 and eur = 430680 and  hkd = 3492.0','')")

    con:query("insert into check_sql values(3881,'delete from transaction_total_check where cny = 3881 and jpy = 388100 and gbp = 2716.7 and eur = 430791 and  hkd = 3492.9','')")

    con:query("insert into check_sql values(3882,'delete from transaction_total_check where cny = 3882 and jpy = 388200 and gbp = 2717.4 and eur = 430902 and  hkd = 3493.8','')")

    con:query("insert into check_sql values(3883,'delete from transaction_total_check where cny = 3883 and jpy = 388300 and gbp = 2718.1 and eur = 431013 and  hkd = 3494.7','')")

    con:query("insert into check_sql values(3884,'delete from transaction_total_check where cny = 3884 and jpy = 388400 and gbp = 2718.8 and eur = 431124 and  hkd = 3495.6','')")

    con:query("insert into check_sql values(3885,'delete from transaction_total_check where cny = 3885 and jpy = 388500 and gbp = 2719.5 and eur = 431235 and  hkd = 3496.5','')")

    con:query("insert into check_sql values(3886,'delete from transaction_total_check where cny = 3886 and jpy = 388600 and gbp = 2720.2 and eur = 431346 and  hkd = 3497.4','')")

    con:query("insert into check_sql values(3887,'delete from transaction_total_check where cny = 3887 and jpy = 388700 and gbp = 2720.9 and eur = 431457 and  hkd = 3498.3','')")

    con:query("insert into check_sql values(3888,'delete from transaction_total_check where cny = 3888 and jpy = 388800 and gbp = 2721.6 and eur = 431568 and  hkd = 3499.2','')")

    con:query("insert into check_sql values(3889,'delete from transaction_total_check where cny = 3889 and jpy = 388900 and gbp = 2722.3 and eur = 431679 and  hkd = 3500.1','')")

    con:query("insert into check_sql values(3890,'delete from transaction_total_check where cny = 3890 and jpy = 389000 and gbp = 2723.0 and eur = 431790 and  hkd = 3501.0','')")

    con:query("insert into check_sql values(3891,'delete from transaction_total_check where cny = 3891 and jpy = 389100 and gbp = 2723.7 and eur = 431901 and  hkd = 3501.9','')")

    con:query("insert into check_sql values(3892,'delete from transaction_total_check where cny = 3892 and jpy = 389200 and gbp = 2724.4 and eur = 432012 and  hkd = 3502.8','')")

    con:query("insert into check_sql values(3893,'delete from transaction_total_check where cny = 3893 and jpy = 389300 and gbp = 2725.1 and eur = 432123 and  hkd = 3503.7','')")

    con:query("insert into check_sql values(3894,'delete from transaction_total_check where cny = 3894 and jpy = 389400 and gbp = 2725.8 and eur = 432234 and  hkd = 3504.6','')")

    con:query("insert into check_sql values(3895,'delete from transaction_total_check where cny = 3895 and jpy = 389500 and gbp = 2726.5 and eur = 432345 and  hkd = 3505.5','')")

    con:query("insert into check_sql values(3896,'delete from transaction_total_check where cny = 3896 and jpy = 389600 and gbp = 2727.2 and eur = 432456 and  hkd = 3506.4','')")

    con:query("insert into check_sql values(3897,'delete from transaction_total_check where cny = 3897 and jpy = 389700 and gbp = 2727.9 and eur = 432567 and  hkd = 3507.3','')")

    con:query("insert into check_sql values(3898,'delete from transaction_total_check where cny = 3898 and jpy = 389800 and gbp = 2728.6 and eur = 432678 and  hkd = 3508.2','')")

    con:query("insert into check_sql values(3899,'delete from transaction_total_check where cny = 3899 and jpy = 389900 and gbp = 2729.3 and eur = 432789 and  hkd = 3509.1','')")

    con:query("insert into check_sql values(3900,'delete from transaction_total_check where cny = 3900 and jpy = 390000 and gbp = 2730.0 and eur = 432900 and  hkd = 3510.0','')")

    con:query("insert into check_sql values(3901,'delete from transaction_total_check where cny = 3901 and jpy = 390100 and gbp = 2730.7 and eur = 433011 and  hkd = 3510.9','')")

    con:query("insert into check_sql values(3902,'delete from transaction_total_check where cny = 3902 and jpy = 390200 and gbp = 2731.4 and eur = 433122 and  hkd = 3511.8','')")

    con:query("insert into check_sql values(3903,'delete from transaction_total_check where cny = 3903 and jpy = 390300 and gbp = 2732.1 and eur = 433233 and  hkd = 3512.7','')")

    con:query("insert into check_sql values(3904,'delete from transaction_total_check where cny = 3904 and jpy = 390400 and gbp = 2732.8 and eur = 433344 and  hkd = 3513.6','')")

    con:query("insert into check_sql values(3905,'delete from transaction_total_check where cny = 3905 and jpy = 390500 and gbp = 2733.5 and eur = 433455 and  hkd = 3514.5','')")

    con:query("insert into check_sql values(3906,'delete from transaction_total_check where cny = 3906 and jpy = 390600 and gbp = 2734.2 and eur = 433566 and  hkd = 3515.4','')")

    con:query("insert into check_sql values(3907,'delete from transaction_total_check where cny = 3907 and jpy = 390700 and gbp = 2734.9 and eur = 433677 and  hkd = 3516.3','')")

    con:query("insert into check_sql values(3908,'delete from transaction_total_check where cny = 3908 and jpy = 390800 and gbp = 2735.6 and eur = 433788 and  hkd = 3517.2','')")

    con:query("insert into check_sql values(3909,'delete from transaction_total_check where cny = 3909 and jpy = 390900 and gbp = 2736.3 and eur = 433899 and  hkd = 3518.1','')")

    con:query("insert into check_sql values(3910,'delete from transaction_total_check where cny = 3910 and jpy = 391000 and gbp = 2737.0 and eur = 434010 and  hkd = 3519.0','')")

    con:query("insert into check_sql values(3911,'delete from transaction_total_check where cny = 3911 and jpy = 391100 and gbp = 2737.7 and eur = 434121 and  hkd = 3519.9','')")

    con:query("insert into check_sql values(3912,'delete from transaction_total_check where cny = 3912 and jpy = 391200 and gbp = 2738.4 and eur = 434232 and  hkd = 3520.8','')")

    con:query("insert into check_sql values(3913,'delete from transaction_total_check where cny = 3913 and jpy = 391300 and gbp = 2739.1 and eur = 434343 and  hkd = 3521.7','')")

    con:query("insert into check_sql values(3914,'delete from transaction_total_check where cny = 3914 and jpy = 391400 and gbp = 2739.8 and eur = 434454 and  hkd = 3522.6','')")

    con:query("insert into check_sql values(3915,'delete from transaction_total_check where cny = 3915 and jpy = 391500 and gbp = 2740.5 and eur = 434565 and  hkd = 3523.5','')")

    con:query("insert into check_sql values(3916,'delete from transaction_total_check where cny = 3916 and jpy = 391600 and gbp = 2741.2 and eur = 434676 and  hkd = 3524.4','')")

    con:query("insert into check_sql values(3917,'delete from transaction_total_check where cny = 3917 and jpy = 391700 and gbp = 2741.9 and eur = 434787 and  hkd = 3525.3','')")

    con:query("insert into check_sql values(3918,'delete from transaction_total_check where cny = 3918 and jpy = 391800 and gbp = 2742.6 and eur = 434898 and  hkd = 3526.2','')")

    con:query("insert into check_sql values(3919,'delete from transaction_total_check where cny = 3919 and jpy = 391900 and gbp = 2743.3 and eur = 435009 and  hkd = 3527.1','')")

    con:query("insert into check_sql values(3920,'delete from transaction_total_check where cny = 3920 and jpy = 392000 and gbp = 2744.0 and eur = 435120 and  hkd = 3528.0','')")

    con:query("insert into check_sql values(3921,'delete from transaction_total_check where cny = 3921 and jpy = 392100 and gbp = 2744.7 and eur = 435231 and  hkd = 3528.9','')")

    con:query("insert into check_sql values(3922,'delete from transaction_total_check where cny = 3922 and jpy = 392200 and gbp = 2745.4 and eur = 435342 and  hkd = 3529.8','')")

    con:query("insert into check_sql values(3923,'delete from transaction_total_check where cny = 3923 and jpy = 392300 and gbp = 2746.1 and eur = 435453 and  hkd = 3530.7','')")

    con:query("insert into check_sql values(3924,'delete from transaction_total_check where cny = 3924 and jpy = 392400 and gbp = 2746.8 and eur = 435564 and  hkd = 3531.6','')")

    con:query("insert into check_sql values(3925,'delete from transaction_total_check where cny = 3925 and jpy = 392500 and gbp = 2747.5 and eur = 435675 and  hkd = 3532.5','')")

    con:query("insert into check_sql values(3926,'delete from transaction_total_check where cny = 3926 and jpy = 392600 and gbp = 2748.2 and eur = 435786 and  hkd = 3533.4','')")

    con:query("insert into check_sql values(3927,'delete from transaction_total_check where cny = 3927 and jpy = 392700 and gbp = 2748.9 and eur = 435897 and  hkd = 3534.3','')")

    con:query("insert into check_sql values(3928,'delete from transaction_total_check where cny = 3928 and jpy = 392800 and gbp = 2749.6 and eur = 436008 and  hkd = 3535.2','')")

    con:query("insert into check_sql values(3929,'delete from transaction_total_check where cny = 3929 and jpy = 392900 and gbp = 2750.3 and eur = 436119 and  hkd = 3536.1','')")

    con:query("insert into check_sql values(3930,'delete from transaction_total_check where cny = 3930 and jpy = 393000 and gbp = 2751.0 and eur = 436230 and  hkd = 3537.0','')")

    con:query("insert into check_sql values(3931,'delete from transaction_total_check where cny = 3931 and jpy = 393100 and gbp = 2751.7 and eur = 436341 and  hkd = 3537.9','')")

    con:query("insert into check_sql values(3932,'delete from transaction_total_check where cny = 3932 and jpy = 393200 and gbp = 2752.4 and eur = 436452 and  hkd = 3538.8','')")

    con:query("insert into check_sql values(3933,'delete from transaction_total_check where cny = 3933 and jpy = 393300 and gbp = 2753.1 and eur = 436563 and  hkd = 3539.7','')")

    con:query("insert into check_sql values(3934,'delete from transaction_total_check where cny = 3934 and jpy = 393400 and gbp = 2753.8 and eur = 436674 and  hkd = 3540.6','')")

    con:query("insert into check_sql values(3935,'delete from transaction_total_check where cny = 3935 and jpy = 393500 and gbp = 2754.5 and eur = 436785 and  hkd = 3541.5','')")

    con:query("insert into check_sql values(3936,'delete from transaction_total_check where cny = 3936 and jpy = 393600 and gbp = 2755.2 and eur = 436896 and  hkd = 3542.4','')")

    con:query("insert into check_sql values(3937,'delete from transaction_total_check where cny = 3937 and jpy = 393700 and gbp = 2755.9 and eur = 437007 and  hkd = 3543.3','')")

    con:query("insert into check_sql values(3938,'delete from transaction_total_check where cny = 3938 and jpy = 393800 and gbp = 2756.6 and eur = 437118 and  hkd = 3544.2','')")

    con:query("insert into check_sql values(3939,'delete from transaction_total_check where cny = 3939 and jpy = 393900 and gbp = 2757.3 and eur = 437229 and  hkd = 3545.1','')")

    con:query("insert into check_sql values(3940,'delete from transaction_total_check where cny = 3940 and jpy = 394000 and gbp = 2758.0 and eur = 437340 and  hkd = 3546.0','')")

    con:query("insert into check_sql values(3941,'delete from transaction_total_check where cny = 3941 and jpy = 394100 and gbp = 2758.7 and eur = 437451 and  hkd = 3546.9','')")

    con:query("insert into check_sql values(3942,'delete from transaction_total_check where cny = 3942 and jpy = 394200 and gbp = 2759.4 and eur = 437562 and  hkd = 3547.8','')")

    con:query("insert into check_sql values(3943,'delete from transaction_total_check where cny = 3943 and jpy = 394300 and gbp = 2760.1 and eur = 437673 and  hkd = 3548.7','')")

    con:query("insert into check_sql values(3944,'delete from transaction_total_check where cny = 3944 and jpy = 394400 and gbp = 2760.8 and eur = 437784 and  hkd = 3549.6','')")

    con:query("insert into check_sql values(3945,'delete from transaction_total_check where cny = 3945 and jpy = 394500 and gbp = 2761.5 and eur = 437895 and  hkd = 3550.5','')")

    con:query("insert into check_sql values(3946,'delete from transaction_total_check where cny = 3946 and jpy = 394600 and gbp = 2762.2 and eur = 438006 and  hkd = 3551.4','')")

    con:query("insert into check_sql values(3947,'delete from transaction_total_check where cny = 3947 and jpy = 394700 and gbp = 2762.9 and eur = 438117 and  hkd = 3552.3','')")

    con:query("insert into check_sql values(3948,'delete from transaction_total_check where cny = 3948 and jpy = 394800 and gbp = 2763.6 and eur = 438228 and  hkd = 3553.2','')")

    con:query("insert into check_sql values(3949,'delete from transaction_total_check where cny = 3949 and jpy = 394900 and gbp = 2764.3 and eur = 438339 and  hkd = 3554.1','')")

    con:query("insert into check_sql values(3950,'delete from transaction_total_check where cny = 3950 and jpy = 395000 and gbp = 2765.0 and eur = 438450 and  hkd = 3555.0','')")

    con:query("insert into check_sql values(3951,'delete from transaction_total_check where cny = 3951 and jpy = 395100 and gbp = 2765.7 and eur = 438561 and  hkd = 3555.9','')")

    con:query("insert into check_sql values(3952,'delete from transaction_total_check where cny = 3952 and jpy = 395200 and gbp = 2766.4 and eur = 438672 and  hkd = 3556.8','')")

    con:query("insert into check_sql values(3953,'delete from transaction_total_check where cny = 3953 and jpy = 395300 and gbp = 2767.1 and eur = 438783 and  hkd = 3557.7','')")

    con:query("insert into check_sql values(3954,'delete from transaction_total_check where cny = 3954 and jpy = 395400 and gbp = 2767.8 and eur = 438894 and  hkd = 3558.6','')")

    con:query("insert into check_sql values(3955,'delete from transaction_total_check where cny = 3955 and jpy = 395500 and gbp = 2768.5 and eur = 439005 and  hkd = 3559.5','')")

    con:query("insert into check_sql values(3956,'delete from transaction_total_check where cny = 3956 and jpy = 395600 and gbp = 2769.2 and eur = 439116 and  hkd = 3560.4','')")

    con:query("insert into check_sql values(3957,'delete from transaction_total_check where cny = 3957 and jpy = 395700 and gbp = 2769.9 and eur = 439227 and  hkd = 3561.3','')")

    con:query("insert into check_sql values(3958,'delete from transaction_total_check where cny = 3958 and jpy = 395800 and gbp = 2770.6 and eur = 439338 and  hkd = 3562.2','')")

    con:query("insert into check_sql values(3959,'delete from transaction_total_check where cny = 3959 and jpy = 395900 and gbp = 2771.3 and eur = 439449 and  hkd = 3563.1','')")

    con:query("insert into check_sql values(3960,'delete from transaction_total_check where cny = 3960 and jpy = 396000 and gbp = 2772.0 and eur = 439560 and  hkd = 3564.0','')")

    con:query("insert into check_sql values(3961,'delete from transaction_total_check where cny = 3961 and jpy = 396100 and gbp = 2772.7 and eur = 439671 and  hkd = 3564.9','')")

    con:query("insert into check_sql values(3962,'delete from transaction_total_check where cny = 3962 and jpy = 396200 and gbp = 2773.4 and eur = 439782 and  hkd = 3565.8','')")

    con:query("insert into check_sql values(3963,'delete from transaction_total_check where cny = 3963 and jpy = 396300 and gbp = 2774.1 and eur = 439893 and  hkd = 3566.7','')")

    con:query("insert into check_sql values(3964,'delete from transaction_total_check where cny = 3964 and jpy = 396400 and gbp = 2774.8 and eur = 440004 and  hkd = 3567.6','')")

    con:query("insert into check_sql values(3965,'delete from transaction_total_check where cny = 3965 and jpy = 396500 and gbp = 2775.5 and eur = 440115 and  hkd = 3568.5','')")

    con:query("insert into check_sql values(3966,'delete from transaction_total_check where cny = 3966 and jpy = 396600 and gbp = 2776.2 and eur = 440226 and  hkd = 3569.4','')")

    con:query("insert into check_sql values(3967,'delete from transaction_total_check where cny = 3967 and jpy = 396700 and gbp = 2776.9 and eur = 440337 and  hkd = 3570.3','')")

    con:query("insert into check_sql values(3968,'delete from transaction_total_check where cny = 3968 and jpy = 396800 and gbp = 2777.6 and eur = 440448 and  hkd = 3571.2','')")

    con:query("insert into check_sql values(3969,'delete from transaction_total_check where cny = 3969 and jpy = 396900 and gbp = 2778.3 and eur = 440559 and  hkd = 3572.1','')")

    con:query("insert into check_sql values(3970,'delete from transaction_total_check where cny = 3970 and jpy = 397000 and gbp = 2779.0 and eur = 440670 and  hkd = 3573.0','')")

    con:query("insert into check_sql values(3971,'delete from transaction_total_check where cny = 3971 and jpy = 397100 and gbp = 2779.7 and eur = 440781 and  hkd = 3573.9','')")

    con:query("insert into check_sql values(3972,'delete from transaction_total_check where cny = 3972 and jpy = 397200 and gbp = 2780.4 and eur = 440892 and  hkd = 3574.8','')")

    con:query("insert into check_sql values(3973,'delete from transaction_total_check where cny = 3973 and jpy = 397300 and gbp = 2781.1 and eur = 441003 and  hkd = 3575.7','')")

    con:query("insert into check_sql values(3974,'delete from transaction_total_check where cny = 3974 and jpy = 397400 and gbp = 2781.8 and eur = 441114 and  hkd = 3576.6','')")

    con:query("insert into check_sql values(3975,'delete from transaction_total_check where cny = 3975 and jpy = 397500 and gbp = 2782.5 and eur = 441225 and  hkd = 3577.5','')")

    con:query("insert into check_sql values(3976,'delete from transaction_total_check where cny = 3976 and jpy = 397600 and gbp = 2783.2 and eur = 441336 and  hkd = 3578.4','')")

    con:query("insert into check_sql values(3977,'delete from transaction_total_check where cny = 3977 and jpy = 397700 and gbp = 2783.9 and eur = 441447 and  hkd = 3579.3','')")

    con:query("insert into check_sql values(3978,'delete from transaction_total_check where cny = 3978 and jpy = 397800 and gbp = 2784.6 and eur = 441558 and  hkd = 3580.2','')")

    con:query("insert into check_sql values(3979,'delete from transaction_total_check where cny = 3979 and jpy = 397900 and gbp = 2785.3 and eur = 441669 and  hkd = 3581.1','')")

    con:query("insert into check_sql values(3980,'delete from transaction_total_check where cny = 3980 and jpy = 398000 and gbp = 2786.0 and eur = 441780 and  hkd = 3582.0','')")

    con:query("insert into check_sql values(3981,'delete from transaction_total_check where cny = 3981 and jpy = 398100 and gbp = 2786.7 and eur = 441891 and  hkd = 3582.9','')")

    con:query("insert into check_sql values(3982,'delete from transaction_total_check where cny = 3982 and jpy = 398200 and gbp = 2787.4 and eur = 442002 and  hkd = 3583.8','')")

    con:query("insert into check_sql values(3983,'delete from transaction_total_check where cny = 3983 and jpy = 398300 and gbp = 2788.1 and eur = 442113 and  hkd = 3584.7','')")

    con:query("insert into check_sql values(3984,'delete from transaction_total_check where cny = 3984 and jpy = 398400 and gbp = 2788.8 and eur = 442224 and  hkd = 3585.6','')")

    con:query("insert into check_sql values(3985,'delete from transaction_total_check where cny = 3985 and jpy = 398500 and gbp = 2789.5 and eur = 442335 and  hkd = 3586.5','')")

    con:query("insert into check_sql values(3986,'delete from transaction_total_check where cny = 3986 and jpy = 398600 and gbp = 2790.2 and eur = 442446 and  hkd = 3587.4','')")

    con:query("insert into check_sql values(3987,'delete from transaction_total_check where cny = 3987 and jpy = 398700 and gbp = 2790.9 and eur = 442557 and  hkd = 3588.3','')")

    con:query("insert into check_sql values(3988,'delete from transaction_total_check where cny = 3988 and jpy = 398800 and gbp = 2791.6 and eur = 442668 and  hkd = 3589.2','')")

    con:query("insert into check_sql values(3989,'delete from transaction_total_check where cny = 3989 and jpy = 398900 and gbp = 2792.3 and eur = 442779 and  hkd = 3590.1','')")

    con:query("insert into check_sql values(3990,'delete from transaction_total_check where cny = 3990 and jpy = 399000 and gbp = 2793.0 and eur = 442890 and  hkd = 3591.0','')")

    con:query("insert into check_sql values(3991,'delete from transaction_total_check where cny = 3991 and jpy = 399100 and gbp = 2793.7 and eur = 443001 and  hkd = 3591.9','')")

    con:query("insert into check_sql values(3992,'delete from transaction_total_check where cny = 3992 and jpy = 399200 and gbp = 2794.4 and eur = 443112 and  hkd = 3592.8','')")

    con:query("insert into check_sql values(3993,'delete from transaction_total_check where cny = 3993 and jpy = 399300 and gbp = 2795.1 and eur = 443223 and  hkd = 3593.7','')")

    con:query("insert into check_sql values(3994,'delete from transaction_total_check where cny = 3994 and jpy = 399400 and gbp = 2795.8 and eur = 443334 and  hkd = 3594.6','')")

    con:query("insert into check_sql values(3995,'delete from transaction_total_check where cny = 3995 and jpy = 399500 and gbp = 2796.5 and eur = 443445 and  hkd = 3595.5','')")

    con:query("insert into check_sql values(3996,'delete from transaction_total_check where cny = 3996 and jpy = 399600 and gbp = 2797.2 and eur = 443556 and  hkd = 3596.4','')")

    con:query("insert into check_sql values(3997,'delete from transaction_total_check where cny = 3997 and jpy = 399700 and gbp = 2797.9 and eur = 443667 and  hkd = 3597.3','')")

    con:query("insert into check_sql values(3998,'delete from transaction_total_check where cny = 3998 and jpy = 399800 and gbp = 2798.6 and eur = 443778 and  hkd = 3598.2','')")

    con:query("insert into check_sql values(3999,'delete from transaction_total_check where cny = 3999 and jpy = 399900 and gbp = 2799.3 and eur = 443889 and  hkd = 3599.1','')")

    con:query("insert into check_sql values(4000,'delete from transaction_total_check where cny = 4000 and jpy = 400000 and gbp = 2800.0 and eur = 444000 and  hkd = 3600.0','')")

    con:query("insert into check_sql values(4001,'delete from transaction_total_check where cny = 4001 and jpy = 400100 and gbp = 2800.7 and eur = 444111 and  hkd = 3600.9','')")

    con:query("insert into check_sql values(4002,'delete from transaction_total_check where cny = 4002 and jpy = 400200 and gbp = 2801.4 and eur = 444222 and  hkd = 3601.8','')")

    con:query("insert into check_sql values(4003,'delete from transaction_total_check where cny = 4003 and jpy = 400300 and gbp = 2802.1 and eur = 444333 and  hkd = 3602.7','')")

    con:query("insert into check_sql values(4004,'delete from transaction_total_check where cny = 4004 and jpy = 400400 and gbp = 2802.8 and eur = 444444 and  hkd = 3603.6','')")

    con:query("insert into check_sql values(4005,'delete from transaction_total_check where cny = 4005 and jpy = 400500 and gbp = 2803.5 and eur = 444555 and  hkd = 3604.5','')")

    con:query("insert into check_sql values(4006,'delete from transaction_total_check where cny = 4006 and jpy = 400600 and gbp = 2804.2 and eur = 444666 and  hkd = 3605.4','')")

    con:query("insert into check_sql values(4007,'delete from transaction_total_check where cny = 4007 and jpy = 400700 and gbp = 2804.9 and eur = 444777 and  hkd = 3606.3','')")

    con:query("insert into check_sql values(4008,'delete from transaction_total_check where cny = 4008 and jpy = 400800 and gbp = 2805.6 and eur = 444888 and  hkd = 3607.2','')")

    con:query("insert into check_sql values(4009,'delete from transaction_total_check where cny = 4009 and jpy = 400900 and gbp = 2806.3 and eur = 444999 and  hkd = 3608.1','')")

    con:query("insert into check_sql values(4010,'delete from transaction_total_check where cny = 4010 and jpy = 401000 and gbp = 2807.0 and eur = 445110 and  hkd = 3609.0','')")

    con:query("insert into check_sql values(4011,'delete from transaction_total_check where cny = 4011 and jpy = 401100 and gbp = 2807.7 and eur = 445221 and  hkd = 3609.9','')")

    con:query("insert into check_sql values(4012,'delete from transaction_total_check where cny = 4012 and jpy = 401200 and gbp = 2808.4 and eur = 445332 and  hkd = 3610.8','')")

    con:query("insert into check_sql values(4013,'delete from transaction_total_check where cny = 4013 and jpy = 401300 and gbp = 2809.1 and eur = 445443 and  hkd = 3611.7','')")

    con:query("insert into check_sql values(4014,'delete from transaction_total_check where cny = 4014 and jpy = 401400 and gbp = 2809.8 and eur = 445554 and  hkd = 3612.6','')")

    con:query("insert into check_sql values(4015,'delete from transaction_total_check where cny = 4015 and jpy = 401500 and gbp = 2810.5 and eur = 445665 and  hkd = 3613.5','')")

    con:query("insert into check_sql values(4016,'delete from transaction_total_check where cny = 4016 and jpy = 401600 and gbp = 2811.2 and eur = 445776 and  hkd = 3614.4','')")

    con:query("insert into check_sql values(4017,'delete from transaction_total_check where cny = 4017 and jpy = 401700 and gbp = 2811.9 and eur = 445887 and  hkd = 3615.3','')")

    con:query("insert into check_sql values(4018,'delete from transaction_total_check where cny = 4018 and jpy = 401800 and gbp = 2812.6 and eur = 445998 and  hkd = 3616.2','')")

    con:query("insert into check_sql values(4019,'delete from transaction_total_check where cny = 4019 and jpy = 401900 and gbp = 2813.3 and eur = 446109 and  hkd = 3617.1','')")

    con:query("insert into check_sql values(4020,'delete from transaction_total_check where cny = 4020 and jpy = 402000 and gbp = 2814.0 and eur = 446220 and  hkd = 3618.0','')")

    con:query("insert into check_sql values(4021,'delete from transaction_total_check where cny = 4021 and jpy = 402100 and gbp = 2814.7 and eur = 446331 and  hkd = 3618.9','')")

    con:query("insert into check_sql values(4022,'delete from transaction_total_check where cny = 4022 and jpy = 402200 and gbp = 2815.4 and eur = 446442 and  hkd = 3619.8','')")

    con:query("insert into check_sql values(4023,'delete from transaction_total_check where cny = 4023 and jpy = 402300 and gbp = 2816.1 and eur = 446553 and  hkd = 3620.7','')")

    con:query("insert into check_sql values(4024,'delete from transaction_total_check where cny = 4024 and jpy = 402400 and gbp = 2816.8 and eur = 446664 and  hkd = 3621.6','')")

    con:query("insert into check_sql values(4025,'delete from transaction_total_check where cny = 4025 and jpy = 402500 and gbp = 2817.5 and eur = 446775 and  hkd = 3622.5','')")

    con:query("insert into check_sql values(4026,'delete from transaction_total_check where cny = 4026 and jpy = 402600 and gbp = 2818.2 and eur = 446886 and  hkd = 3623.4','')")

    con:query("insert into check_sql values(4027,'delete from transaction_total_check where cny = 4027 and jpy = 402700 and gbp = 2818.9 and eur = 446997 and  hkd = 3624.3','')")

    con:query("insert into check_sql values(4028,'delete from transaction_total_check where cny = 4028 and jpy = 402800 and gbp = 2819.6 and eur = 447108 and  hkd = 3625.2','')")

    con:query("insert into check_sql values(4029,'delete from transaction_total_check where cny = 4029 and jpy = 402900 and gbp = 2820.3 and eur = 447219 and  hkd = 3626.1','')")

    con:query("insert into check_sql values(4030,'delete from transaction_total_check where cny = 4030 and jpy = 403000 and gbp = 2821.0 and eur = 447330 and  hkd = 3627.0','')")

    con:query("insert into check_sql values(4031,'delete from transaction_total_check where cny = 4031 and jpy = 403100 and gbp = 2821.7 and eur = 447441 and  hkd = 3627.9','')")

    con:query("insert into check_sql values(4032,'delete from transaction_total_check where cny = 4032 and jpy = 403200 and gbp = 2822.4 and eur = 447552 and  hkd = 3628.8','')")

    con:query("insert into check_sql values(4033,'delete from transaction_total_check where cny = 4033 and jpy = 403300 and gbp = 2823.1 and eur = 447663 and  hkd = 3629.7','')")

    con:query("insert into check_sql values(4034,'delete from transaction_total_check where cny = 4034 and jpy = 403400 and gbp = 2823.8 and eur = 447774 and  hkd = 3630.6','')")

    con:query("insert into check_sql values(4035,'delete from transaction_total_check where cny = 4035 and jpy = 403500 and gbp = 2824.5 and eur = 447885 and  hkd = 3631.5','')")

    con:query("insert into check_sql values(4036,'delete from transaction_total_check where cny = 4036 and jpy = 403600 and gbp = 2825.2 and eur = 447996 and  hkd = 3632.4','')")

    con:query("insert into check_sql values(4037,'delete from transaction_total_check where cny = 4037 and jpy = 403700 and gbp = 2825.9 and eur = 448107 and  hkd = 3633.3','')")

    con:query("insert into check_sql values(4038,'delete from transaction_total_check where cny = 4038 and jpy = 403800 and gbp = 2826.6 and eur = 448218 and  hkd = 3634.2','')")

    con:query("insert into check_sql values(4039,'delete from transaction_total_check where cny = 4039 and jpy = 403900 and gbp = 2827.3 and eur = 448329 and  hkd = 3635.1','')")

    con:query("insert into check_sql values(4040,'delete from transaction_total_check where cny = 4040 and jpy = 404000 and gbp = 2828.0 and eur = 448440 and  hkd = 3636.0','')")

    con:query("insert into check_sql values(4041,'delete from transaction_total_check where cny = 4041 and jpy = 404100 and gbp = 2828.7 and eur = 448551 and  hkd = 3636.9','')")

    con:query("insert into check_sql values(4042,'delete from transaction_total_check where cny = 4042 and jpy = 404200 and gbp = 2829.4 and eur = 448662 and  hkd = 3637.8','')")

    con:query("insert into check_sql values(4043,'delete from transaction_total_check where cny = 4043 and jpy = 404300 and gbp = 2830.1 and eur = 448773 and  hkd = 3638.7','')")

    con:query("insert into check_sql values(4044,'delete from transaction_total_check where cny = 4044 and jpy = 404400 and gbp = 2830.8 and eur = 448884 and  hkd = 3639.6','')")

    con:query("insert into check_sql values(4045,'delete from transaction_total_check where cny = 4045 and jpy = 404500 and gbp = 2831.5 and eur = 448995 and  hkd = 3640.5','')")

    con:query("insert into check_sql values(4046,'delete from transaction_total_check where cny = 4046 and jpy = 404600 and gbp = 2832.2 and eur = 449106 and  hkd = 3641.4','')")

    con:query("insert into check_sql values(4047,'delete from transaction_total_check where cny = 4047 and jpy = 404700 and gbp = 2832.9 and eur = 449217 and  hkd = 3642.3','')")

    con:query("insert into check_sql values(4048,'delete from transaction_total_check where cny = 4048 and jpy = 404800 and gbp = 2833.6 and eur = 449328 and  hkd = 3643.2','')")

    con:query("insert into check_sql values(4049,'delete from transaction_total_check where cny = 4049 and jpy = 404900 and gbp = 2834.3 and eur = 449439 and  hkd = 3644.1','')")

    con:query("insert into check_sql values(4050,'delete from transaction_total_check where cny = 4050 and jpy = 405000 and gbp = 2835.0 and eur = 449550 and  hkd = 3645.0','')")

    con:query("insert into check_sql values(4051,'delete from transaction_total_check where cny = 4051 and jpy = 405100 and gbp = 2835.7 and eur = 449661 and  hkd = 3645.9','')")

    con:query("insert into check_sql values(4052,'delete from transaction_total_check where cny = 4052 and jpy = 405200 and gbp = 2836.4 and eur = 449772 and  hkd = 3646.8','')")

    con:query("insert into check_sql values(4053,'delete from transaction_total_check where cny = 4053 and jpy = 405300 and gbp = 2837.1 and eur = 449883 and  hkd = 3647.7','')")

    con:query("insert into check_sql values(4054,'delete from transaction_total_check where cny = 4054 and jpy = 405400 and gbp = 2837.8 and eur = 449994 and  hkd = 3648.6','')")

    con:query("insert into check_sql values(4055,'delete from transaction_total_check where cny = 4055 and jpy = 405500 and gbp = 2838.5 and eur = 450105 and  hkd = 3649.5','')")

    con:query("insert into check_sql values(4056,'delete from transaction_total_check where cny = 4056 and jpy = 405600 and gbp = 2839.2 and eur = 450216 and  hkd = 3650.4','')")

    con:query("insert into check_sql values(4057,'delete from transaction_total_check where cny = 4057 and jpy = 405700 and gbp = 2839.9 and eur = 450327 and  hkd = 3651.3','')")

    con:query("insert into check_sql values(4058,'delete from transaction_total_check where cny = 4058 and jpy = 405800 and gbp = 2840.6 and eur = 450438 and  hkd = 3652.2','')")

    con:query("insert into check_sql values(4059,'delete from transaction_total_check where cny = 4059 and jpy = 405900 and gbp = 2841.3 and eur = 450549 and  hkd = 3653.1','')")

    con:query("insert into check_sql values(4060,'delete from transaction_total_check where cny = 4060 and jpy = 406000 and gbp = 2842.0 and eur = 450660 and  hkd = 3654.0','')")

    con:query("insert into check_sql values(4061,'delete from transaction_total_check where cny = 4061 and jpy = 406100 and gbp = 2842.7 and eur = 450771 and  hkd = 3654.9','')")

    con:query("insert into check_sql values(4062,'delete from transaction_total_check where cny = 4062 and jpy = 406200 and gbp = 2843.4 and eur = 450882 and  hkd = 3655.8','')")

    con:query("insert into check_sql values(4063,'delete from transaction_total_check where cny = 4063 and jpy = 406300 and gbp = 2844.1 and eur = 450993 and  hkd = 3656.7','')")

    con:query("insert into check_sql values(4064,'delete from transaction_total_check where cny = 4064 and jpy = 406400 and gbp = 2844.8 and eur = 451104 and  hkd = 3657.6','')")

    con:query("insert into check_sql values(4065,'delete from transaction_total_check where cny = 4065 and jpy = 406500 and gbp = 2845.5 and eur = 451215 and  hkd = 3658.5','')")

    con:query("insert into check_sql values(4066,'delete from transaction_total_check where cny = 4066 and jpy = 406600 and gbp = 2846.2 and eur = 451326 and  hkd = 3659.4','')")

    con:query("insert into check_sql values(4067,'delete from transaction_total_check where cny = 4067 and jpy = 406700 and gbp = 2846.9 and eur = 451437 and  hkd = 3660.3','')")

    con:query("insert into check_sql values(4068,'delete from transaction_total_check where cny = 4068 and jpy = 406800 and gbp = 2847.6 and eur = 451548 and  hkd = 3661.2','')")

    con:query("insert into check_sql values(4069,'delete from transaction_total_check where cny = 4069 and jpy = 406900 and gbp = 2848.3 and eur = 451659 and  hkd = 3662.1','')")

    con:query("insert into check_sql values(4070,'delete from transaction_total_check where cny = 4070 and jpy = 407000 and gbp = 2849.0 and eur = 451770 and  hkd = 3663.0','')")

    con:query("insert into check_sql values(4071,'delete from transaction_total_check where cny = 4071 and jpy = 407100 and gbp = 2849.7 and eur = 451881 and  hkd = 3663.9','')")

    con:query("insert into check_sql values(4072,'delete from transaction_total_check where cny = 4072 and jpy = 407200 and gbp = 2850.4 and eur = 451992 and  hkd = 3664.8','')")

    con:query("insert into check_sql values(4073,'delete from transaction_total_check where cny = 4073 and jpy = 407300 and gbp = 2851.1 and eur = 452103 and  hkd = 3665.7','')")

    con:query("insert into check_sql values(4074,'delete from transaction_total_check where cny = 4074 and jpy = 407400 and gbp = 2851.8 and eur = 452214 and  hkd = 3666.6','')")

    con:query("insert into check_sql values(4075,'delete from transaction_total_check where cny = 4075 and jpy = 407500 and gbp = 2852.5 and eur = 452325 and  hkd = 3667.5','')")

    con:query("insert into check_sql values(4076,'delete from transaction_total_check where cny = 4076 and jpy = 407600 and gbp = 2853.2 and eur = 452436 and  hkd = 3668.4','')")

    con:query("insert into check_sql values(4077,'delete from transaction_total_check where cny = 4077 and jpy = 407700 and gbp = 2853.9 and eur = 452547 and  hkd = 3669.3','')")

    con:query("insert into check_sql values(4078,'delete from transaction_total_check where cny = 4078 and jpy = 407800 and gbp = 2854.6 and eur = 452658 and  hkd = 3670.2','')")

    con:query("insert into check_sql values(4079,'delete from transaction_total_check where cny = 4079 and jpy = 407900 and gbp = 2855.3 and eur = 452769 and  hkd = 3671.1','')")

    con:query("insert into check_sql values(4080,'delete from transaction_total_check where cny = 4080 and jpy = 408000 and gbp = 2856.0 and eur = 452880 and  hkd = 3672.0','')")

    con:query("insert into check_sql values(4081,'delete from transaction_total_check where cny = 4081 and jpy = 408100 and gbp = 2856.7 and eur = 452991 and  hkd = 3672.9','')")

    con:query("insert into check_sql values(4082,'delete from transaction_total_check where cny = 4082 and jpy = 408200 and gbp = 2857.4 and eur = 453102 and  hkd = 3673.8','')")

    con:query("insert into check_sql values(4083,'delete from transaction_total_check where cny = 4083 and jpy = 408300 and gbp = 2858.1 and eur = 453213 and  hkd = 3674.7','')")

    con:query("insert into check_sql values(4084,'delete from transaction_total_check where cny = 4084 and jpy = 408400 and gbp = 2858.8 and eur = 453324 and  hkd = 3675.6','')")

    con:query("insert into check_sql values(4085,'delete from transaction_total_check where cny = 4085 and jpy = 408500 and gbp = 2859.5 and eur = 453435 and  hkd = 3676.5','')")

    con:query("insert into check_sql values(4086,'delete from transaction_total_check where cny = 4086 and jpy = 408600 and gbp = 2860.2 and eur = 453546 and  hkd = 3677.4','')")

    con:query("insert into check_sql values(4087,'delete from transaction_total_check where cny = 4087 and jpy = 408700 and gbp = 2860.9 and eur = 453657 and  hkd = 3678.3','')")

    con:query("insert into check_sql values(4088,'delete from transaction_total_check where cny = 4088 and jpy = 408800 and gbp = 2861.6 and eur = 453768 and  hkd = 3679.2','')")

    con:query("insert into check_sql values(4089,'delete from transaction_total_check where cny = 4089 and jpy = 408900 and gbp = 2862.3 and eur = 453879 and  hkd = 3680.1','')")

    con:query("insert into check_sql values(4090,'delete from transaction_total_check where cny = 4090 and jpy = 409000 and gbp = 2863.0 and eur = 453990 and  hkd = 3681.0','')")

    con:query("insert into check_sql values(4091,'delete from transaction_total_check where cny = 4091 and jpy = 409100 and gbp = 2863.7 and eur = 454101 and  hkd = 3681.9','')")

    con:query("insert into check_sql values(4092,'delete from transaction_total_check where cny = 4092 and jpy = 409200 and gbp = 2864.4 and eur = 454212 and  hkd = 3682.8','')")

    con:query("insert into check_sql values(4093,'delete from transaction_total_check where cny = 4093 and jpy = 409300 and gbp = 2865.1 and eur = 454323 and  hkd = 3683.7','')")

    con:query("insert into check_sql values(4094,'delete from transaction_total_check where cny = 4094 and jpy = 409400 and gbp = 2865.8 and eur = 454434 and  hkd = 3684.6','')")

    con:query("insert into check_sql values(4095,'delete from transaction_total_check where cny = 4095 and jpy = 409500 and gbp = 2866.5 and eur = 454545 and  hkd = 3685.5','')")

    con:query("insert into check_sql values(4096,'delete from transaction_total_check where cny = 4096 and jpy = 409600 and gbp = 2867.2 and eur = 454656 and  hkd = 3686.4','')")

    con:query("insert into check_sql values(4097,'delete from transaction_total_check where cny = 4097 and jpy = 409700 and gbp = 2867.9 and eur = 454767 and  hkd = 3687.3','')")

    con:query("insert into check_sql values(4098,'delete from transaction_total_check where cny = 4098 and jpy = 409800 and gbp = 2868.6 and eur = 454878 and  hkd = 3688.2','')")

    con:query("insert into check_sql values(4099,'delete from transaction_total_check where cny = 4099 and jpy = 409900 and gbp = 2869.3 and eur = 454989 and  hkd = 3689.1','')")

    con:query("insert into check_sql values(4100,'delete from transaction_total_check where cny = 4100 and jpy = 410000 and gbp = 2870.0 and eur = 455100 and  hkd = 3690.0','')")

    con:query("insert into check_sql values(4101,'delete from transaction_total_check where cny = 4101 and jpy = 410100 and gbp = 2870.7 and eur = 455211 and  hkd = 3690.9','')")

    con:query("insert into check_sql values(4102,'delete from transaction_total_check where cny = 4102 and jpy = 410200 and gbp = 2871.4 and eur = 455322 and  hkd = 3691.8','')")

    con:query("insert into check_sql values(4103,'delete from transaction_total_check where cny = 4103 and jpy = 410300 and gbp = 2872.1 and eur = 455433 and  hkd = 3692.7','')")

    con:query("insert into check_sql values(4104,'delete from transaction_total_check where cny = 4104 and jpy = 410400 and gbp = 2872.8 and eur = 455544 and  hkd = 3693.6','')")

    con:query("insert into check_sql values(4105,'delete from transaction_total_check where cny = 4105 and jpy = 410500 and gbp = 2873.5 and eur = 455655 and  hkd = 3694.5','')")

    con:query("insert into check_sql values(4106,'delete from transaction_total_check where cny = 4106 and jpy = 410600 and gbp = 2874.2 and eur = 455766 and  hkd = 3695.4','')")

    con:query("insert into check_sql values(4107,'delete from transaction_total_check where cny = 4107 and jpy = 410700 and gbp = 2874.9 and eur = 455877 and  hkd = 3696.3','')")

    con:query("insert into check_sql values(4108,'delete from transaction_total_check where cny = 4108 and jpy = 410800 and gbp = 2875.6 and eur = 455988 and  hkd = 3697.2','')")

    con:query("insert into check_sql values(4109,'delete from transaction_total_check where cny = 4109 and jpy = 410900 and gbp = 2876.3 and eur = 456099 and  hkd = 3698.1','')")

    con:query("insert into check_sql values(4110,'delete from transaction_total_check where cny = 4110 and jpy = 411000 and gbp = 2877.0 and eur = 456210 and  hkd = 3699.0','')")

    con:query("insert into check_sql values(4111,'delete from transaction_total_check where cny = 4111 and jpy = 411100 and gbp = 2877.7 and eur = 456321 and  hkd = 3699.9','')")

    con:query("insert into check_sql values(4112,'delete from transaction_total_check where cny = 4112 and jpy = 411200 and gbp = 2878.4 and eur = 456432 and  hkd = 3700.8','')")

    con:query("insert into check_sql values(4113,'delete from transaction_total_check where cny = 4113 and jpy = 411300 and gbp = 2879.1 and eur = 456543 and  hkd = 3701.7','')")

    con:query("insert into check_sql values(4114,'delete from transaction_total_check where cny = 4114 and jpy = 411400 and gbp = 2879.8 and eur = 456654 and  hkd = 3702.6','')")

    con:query("insert into check_sql values(4115,'delete from transaction_total_check where cny = 4115 and jpy = 411500 and gbp = 2880.5 and eur = 456765 and  hkd = 3703.5','')")

    con:query("insert into check_sql values(4116,'delete from transaction_total_check where cny = 4116 and jpy = 411600 and gbp = 2881.2 and eur = 456876 and  hkd = 3704.4','')")

    con:query("insert into check_sql values(4117,'delete from transaction_total_check where cny = 4117 and jpy = 411700 and gbp = 2881.9 and eur = 456987 and  hkd = 3705.3','')")

    con:query("insert into check_sql values(4118,'delete from transaction_total_check where cny = 4118 and jpy = 411800 and gbp = 2882.6 and eur = 457098 and  hkd = 3706.2','')")

    con:query("insert into check_sql values(4119,'delete from transaction_total_check where cny = 4119 and jpy = 411900 and gbp = 2883.3 and eur = 457209 and  hkd = 3707.1','')")

    con:query("insert into check_sql values(4120,'delete from transaction_total_check where cny = 4120 and jpy = 412000 and gbp = 2884.0 and eur = 457320 and  hkd = 3708.0','')")

    con:query("insert into check_sql values(4121,'delete from transaction_total_check where cny = 4121 and jpy = 412100 and gbp = 2884.7 and eur = 457431 and  hkd = 3708.9','')")

    con:query("insert into check_sql values(4122,'delete from transaction_total_check where cny = 4122 and jpy = 412200 and gbp = 2885.4 and eur = 457542 and  hkd = 3709.8','')")

    con:query("insert into check_sql values(4123,'delete from transaction_total_check where cny = 4123 and jpy = 412300 and gbp = 2886.1 and eur = 457653 and  hkd = 3710.7','')")

    con:query("insert into check_sql values(4124,'delete from transaction_total_check where cny = 4124 and jpy = 412400 and gbp = 2886.8 and eur = 457764 and  hkd = 3711.6','')")

    con:query("insert into check_sql values(4125,'delete from transaction_total_check where cny = 4125 and jpy = 412500 and gbp = 2887.5 and eur = 457875 and  hkd = 3712.5','')")

    con:query("insert into check_sql values(4126,'delete from transaction_total_check where cny = 4126 and jpy = 412600 and gbp = 2888.2 and eur = 457986 and  hkd = 3713.4','')")

    con:query("insert into check_sql values(4127,'delete from transaction_total_check where cny = 4127 and jpy = 412700 and gbp = 2888.9 and eur = 458097 and  hkd = 3714.3','')")

    con:query("insert into check_sql values(4128,'delete from transaction_total_check where cny = 4128 and jpy = 412800 and gbp = 2889.6 and eur = 458208 and  hkd = 3715.2','')")

    con:query("insert into check_sql values(4129,'delete from transaction_total_check where cny = 4129 and jpy = 412900 and gbp = 2890.3 and eur = 458319 and  hkd = 3716.1','')")

    con:query("insert into check_sql values(4130,'delete from transaction_total_check where cny = 4130 and jpy = 413000 and gbp = 2891.0 and eur = 458430 and  hkd = 3717.0','')")

    con:query("insert into check_sql values(4131,'delete from transaction_total_check where cny = 4131 and jpy = 413100 and gbp = 2891.7 and eur = 458541 and  hkd = 3717.9','')")

    con:query("insert into check_sql values(4132,'delete from transaction_total_check where cny = 4132 and jpy = 413200 and gbp = 2892.4 and eur = 458652 and  hkd = 3718.8','')")

    con:query("insert into check_sql values(4133,'delete from transaction_total_check where cny = 4133 and jpy = 413300 and gbp = 2893.1 and eur = 458763 and  hkd = 3719.7','')")

    con:query("insert into check_sql values(4134,'delete from transaction_total_check where cny = 4134 and jpy = 413400 and gbp = 2893.8 and eur = 458874 and  hkd = 3720.6','')")

    con:query("insert into check_sql values(4135,'delete from transaction_total_check where cny = 4135 and jpy = 413500 and gbp = 2894.5 and eur = 458985 and  hkd = 3721.5','')")

    con:query("insert into check_sql values(4136,'delete from transaction_total_check where cny = 4136 and jpy = 413600 and gbp = 2895.2 and eur = 459096 and  hkd = 3722.4','')")

    con:query("insert into check_sql values(4137,'delete from transaction_total_check where cny = 4137 and jpy = 413700 and gbp = 2895.9 and eur = 459207 and  hkd = 3723.3','')")

    con:query("insert into check_sql values(4138,'delete from transaction_total_check where cny = 4138 and jpy = 413800 and gbp = 2896.6 and eur = 459318 and  hkd = 3724.2','')")

    con:query("insert into check_sql values(4139,'delete from transaction_total_check where cny = 4139 and jpy = 413900 and gbp = 2897.3 and eur = 459429 and  hkd = 3725.1','')")

    con:query("insert into check_sql values(4140,'delete from transaction_total_check where cny = 4140 and jpy = 414000 and gbp = 2898.0 and eur = 459540 and  hkd = 3726.0','')")

    con:query("insert into check_sql values(4141,'delete from transaction_total_check where cny = 4141 and jpy = 414100 and gbp = 2898.7 and eur = 459651 and  hkd = 3726.9','')")

    con:query("insert into check_sql values(4142,'delete from transaction_total_check where cny = 4142 and jpy = 414200 and gbp = 2899.4 and eur = 459762 and  hkd = 3727.8','')")

    con:query("insert into check_sql values(4143,'delete from transaction_total_check where cny = 4143 and jpy = 414300 and gbp = 2900.1 and eur = 459873 and  hkd = 3728.7','')")

    con:query("insert into check_sql values(4144,'delete from transaction_total_check where cny = 4144 and jpy = 414400 and gbp = 2900.8 and eur = 459984 and  hkd = 3729.6','')")

    con:query("insert into check_sql values(4145,'delete from transaction_total_check where cny = 4145 and jpy = 414500 and gbp = 2901.5 and eur = 460095 and  hkd = 3730.5','')")

    con:query("insert into check_sql values(4146,'delete from transaction_total_check where cny = 4146 and jpy = 414600 and gbp = 2902.2 and eur = 460206 and  hkd = 3731.4','')")

    con:query("insert into check_sql values(4147,'delete from transaction_total_check where cny = 4147 and jpy = 414700 and gbp = 2902.9 and eur = 460317 and  hkd = 3732.3','')")

    con:query("insert into check_sql values(4148,'delete from transaction_total_check where cny = 4148 and jpy = 414800 and gbp = 2903.6 and eur = 460428 and  hkd = 3733.2','')")

    con:query("insert into check_sql values(4149,'delete from transaction_total_check where cny = 4149 and jpy = 414900 and gbp = 2904.3 and eur = 460539 and  hkd = 3734.1','')")

    con:query("insert into check_sql values(4150,'delete from transaction_total_check where cny = 4150 and jpy = 415000 and gbp = 2905.0 and eur = 460650 and  hkd = 3735.0','')")

    con:query("insert into check_sql values(4151,'delete from transaction_total_check where cny = 4151 and jpy = 415100 and gbp = 2905.7 and eur = 460761 and  hkd = 3735.9','')")

    con:query("insert into check_sql values(4152,'delete from transaction_total_check where cny = 4152 and jpy = 415200 and gbp = 2906.4 and eur = 460872 and  hkd = 3736.8','')")

    con:query("insert into check_sql values(4153,'delete from transaction_total_check where cny = 4153 and jpy = 415300 and gbp = 2907.1 and eur = 460983 and  hkd = 3737.7','')")

    con:query("insert into check_sql values(4154,'delete from transaction_total_check where cny = 4154 and jpy = 415400 and gbp = 2907.8 and eur = 461094 and  hkd = 3738.6','')")

    con:query("insert into check_sql values(4155,'delete from transaction_total_check where cny = 4155 and jpy = 415500 and gbp = 2908.5 and eur = 461205 and  hkd = 3739.5','')")

    con:query("insert into check_sql values(4156,'delete from transaction_total_check where cny = 4156 and jpy = 415600 and gbp = 2909.2 and eur = 461316 and  hkd = 3740.4','')")

    con:query("insert into check_sql values(4157,'delete from transaction_total_check where cny = 4157 and jpy = 415700 and gbp = 2909.9 and eur = 461427 and  hkd = 3741.3','')")

    con:query("insert into check_sql values(4158,'delete from transaction_total_check where cny = 4158 and jpy = 415800 and gbp = 2910.6 and eur = 461538 and  hkd = 3742.2','')")

    con:query("insert into check_sql values(4159,'delete from transaction_total_check where cny = 4159 and jpy = 415900 and gbp = 2911.3 and eur = 461649 and  hkd = 3743.1','')")

    con:query("insert into check_sql values(4160,'delete from transaction_total_check where cny = 4160 and jpy = 416000 and gbp = 2912.0 and eur = 461760 and  hkd = 3744.0','')")

    con:query("insert into check_sql values(4161,'delete from transaction_total_check where cny = 4161 and jpy = 416100 and gbp = 2912.7 and eur = 461871 and  hkd = 3744.9','')")

    con:query("insert into check_sql values(4162,'delete from transaction_total_check where cny = 4162 and jpy = 416200 and gbp = 2913.4 and eur = 461982 and  hkd = 3745.8','')")

    con:query("insert into check_sql values(4163,'delete from transaction_total_check where cny = 4163 and jpy = 416300 and gbp = 2914.1 and eur = 462093 and  hkd = 3746.7','')")

    con:query("insert into check_sql values(4164,'delete from transaction_total_check where cny = 4164 and jpy = 416400 and gbp = 2914.8 and eur = 462204 and  hkd = 3747.6','')")

    con:query("insert into check_sql values(4165,'delete from transaction_total_check where cny = 4165 and jpy = 416500 and gbp = 2915.5 and eur = 462315 and  hkd = 3748.5','')")

    con:query("insert into check_sql values(4166,'delete from transaction_total_check where cny = 4166 and jpy = 416600 and gbp = 2916.2 and eur = 462426 and  hkd = 3749.4','')")

    con:query("insert into check_sql values(4167,'delete from transaction_total_check where cny = 4167 and jpy = 416700 and gbp = 2916.9 and eur = 462537 and  hkd = 3750.3','')")

    con:query("insert into check_sql values(4168,'delete from transaction_total_check where cny = 4168 and jpy = 416800 and gbp = 2917.6 and eur = 462648 and  hkd = 3751.2','')")

    con:query("insert into check_sql values(4169,'delete from transaction_total_check where cny = 4169 and jpy = 416900 and gbp = 2918.3 and eur = 462759 and  hkd = 3752.1','')")

    con:query("insert into check_sql values(4170,'delete from transaction_total_check where cny = 4170 and jpy = 417000 and gbp = 2919.0 and eur = 462870 and  hkd = 3753.0','')")

    con:query("insert into check_sql values(4171,'delete from transaction_total_check where cny = 4171 and jpy = 417100 and gbp = 2919.7 and eur = 462981 and  hkd = 3753.9','')")

    con:query("insert into check_sql values(4172,'delete from transaction_total_check where cny = 4172 and jpy = 417200 and gbp = 2920.4 and eur = 463092 and  hkd = 3754.8','')")

    con:query("insert into check_sql values(4173,'delete from transaction_total_check where cny = 4173 and jpy = 417300 and gbp = 2921.1 and eur = 463203 and  hkd = 3755.7','')")

    con:query("insert into check_sql values(4174,'delete from transaction_total_check where cny = 4174 and jpy = 417400 and gbp = 2921.8 and eur = 463314 and  hkd = 3756.6','')")

    con:query("insert into check_sql values(4175,'delete from transaction_total_check where cny = 4175 and jpy = 417500 and gbp = 2922.5 and eur = 463425 and  hkd = 3757.5','')")

    con:query("insert into check_sql values(4176,'delete from transaction_total_check where cny = 4176 and jpy = 417600 and gbp = 2923.2 and eur = 463536 and  hkd = 3758.4','')")

    con:query("insert into check_sql values(4177,'delete from transaction_total_check where cny = 4177 and jpy = 417700 and gbp = 2923.9 and eur = 463647 and  hkd = 3759.3','')")

    con:query("insert into check_sql values(4178,'delete from transaction_total_check where cny = 4178 and jpy = 417800 and gbp = 2924.6 and eur = 463758 and  hkd = 3760.2','')")

    con:query("insert into check_sql values(4179,'delete from transaction_total_check where cny = 4179 and jpy = 417900 and gbp = 2925.3 and eur = 463869 and  hkd = 3761.1','')")

    con:query("insert into check_sql values(4180,'delete from transaction_total_check where cny = 4180 and jpy = 418000 and gbp = 2926.0 and eur = 463980 and  hkd = 3762.0','')")

    con:query("insert into check_sql values(4181,'delete from transaction_total_check where cny = 4181 and jpy = 418100 and gbp = 2926.7 and eur = 464091 and  hkd = 3762.9','')")

    con:query("insert into check_sql values(4182,'delete from transaction_total_check where cny = 4182 and jpy = 418200 and gbp = 2927.4 and eur = 464202 and  hkd = 3763.8','')")

    con:query("insert into check_sql values(4183,'delete from transaction_total_check where cny = 4183 and jpy = 418300 and gbp = 2928.1 and eur = 464313 and  hkd = 3764.7','')")

    con:query("insert into check_sql values(4184,'delete from transaction_total_check where cny = 4184 and jpy = 418400 and gbp = 2928.8 and eur = 464424 and  hkd = 3765.6','')")

    con:query("insert into check_sql values(4185,'delete from transaction_total_check where cny = 4185 and jpy = 418500 and gbp = 2929.5 and eur = 464535 and  hkd = 3766.5','')")

    con:query("insert into check_sql values(4186,'delete from transaction_total_check where cny = 4186 and jpy = 418600 and gbp = 2930.2 and eur = 464646 and  hkd = 3767.4','')")

    con:query("insert into check_sql values(4187,'delete from transaction_total_check where cny = 4187 and jpy = 418700 and gbp = 2930.9 and eur = 464757 and  hkd = 3768.3','')")

    con:query("insert into check_sql values(4188,'delete from transaction_total_check where cny = 4188 and jpy = 418800 and gbp = 2931.6 and eur = 464868 and  hkd = 3769.2','')")

    con:query("insert into check_sql values(4189,'delete from transaction_total_check where cny = 4189 and jpy = 418900 and gbp = 2932.3 and eur = 464979 and  hkd = 3770.1','')")

    con:query("insert into check_sql values(4190,'delete from transaction_total_check where cny = 4190 and jpy = 419000 and gbp = 2933.0 and eur = 465090 and  hkd = 3771.0','')")

    con:query("insert into check_sql values(4191,'delete from transaction_total_check where cny = 4191 and jpy = 419100 and gbp = 2933.7 and eur = 465201 and  hkd = 3771.9','')")

    con:query("insert into check_sql values(4192,'delete from transaction_total_check where cny = 4192 and jpy = 419200 and gbp = 2934.4 and eur = 465312 and  hkd = 3772.8','')")

    con:query("insert into check_sql values(4193,'delete from transaction_total_check where cny = 4193 and jpy = 419300 and gbp = 2935.1 and eur = 465423 and  hkd = 3773.7','')")

    con:query("insert into check_sql values(4194,'delete from transaction_total_check where cny = 4194 and jpy = 419400 and gbp = 2935.8 and eur = 465534 and  hkd = 3774.6','')")

    con:query("insert into check_sql values(4195,'delete from transaction_total_check where cny = 4195 and jpy = 419500 and gbp = 2936.5 and eur = 465645 and  hkd = 3775.5','')")

    con:query("insert into check_sql values(4196,'delete from transaction_total_check where cny = 4196 and jpy = 419600 and gbp = 2937.2 and eur = 465756 and  hkd = 3776.4','')")

    con:query("insert into check_sql values(4197,'delete from transaction_total_check where cny = 4197 and jpy = 419700 and gbp = 2937.9 and eur = 465867 and  hkd = 3777.3','')")

    con:query("insert into check_sql values(4198,'delete from transaction_total_check where cny = 4198 and jpy = 419800 and gbp = 2938.6 and eur = 465978 and  hkd = 3778.2','')")

    con:query("insert into check_sql values(4199,'delete from transaction_total_check where cny = 4199 and jpy = 419900 and gbp = 2939.3 and eur = 466089 and  hkd = 3779.1','')")

    con:query("insert into check_sql values(4200,'delete from transaction_total_check where cny = 4200 and jpy = 420000 and gbp = 2940.0 and eur = 466200 and  hkd = 3780.0','')")

    con:query("insert into check_sql values(4201,'delete from transaction_total_check where cny = 4201 and jpy = 420100 and gbp = 2940.7 and eur = 466311 and  hkd = 3780.9','')")

    con:query("insert into check_sql values(4202,'delete from transaction_total_check where cny = 4202 and jpy = 420200 and gbp = 2941.4 and eur = 466422 and  hkd = 3781.8','')")

    con:query("insert into check_sql values(4203,'delete from transaction_total_check where cny = 4203 and jpy = 420300 and gbp = 2942.1 and eur = 466533 and  hkd = 3782.7','')")

    con:query("insert into check_sql values(4204,'delete from transaction_total_check where cny = 4204 and jpy = 420400 and gbp = 2942.8 and eur = 466644 and  hkd = 3783.6','')")

    con:query("insert into check_sql values(4205,'delete from transaction_total_check where cny = 4205 and jpy = 420500 and gbp = 2943.5 and eur = 466755 and  hkd = 3784.5','')")

    con:query("insert into check_sql values(4206,'delete from transaction_total_check where cny = 4206 and jpy = 420600 and gbp = 2944.2 and eur = 466866 and  hkd = 3785.4','')")

    con:query("insert into check_sql values(4207,'delete from transaction_total_check where cny = 4207 and jpy = 420700 and gbp = 2944.9 and eur = 466977 and  hkd = 3786.3','')")

    con:query("insert into check_sql values(4208,'delete from transaction_total_check where cny = 4208 and jpy = 420800 and gbp = 2945.6 and eur = 467088 and  hkd = 3787.2','')")

    con:query("insert into check_sql values(4209,'delete from transaction_total_check where cny = 4209 and jpy = 420900 and gbp = 2946.3 and eur = 467199 and  hkd = 3788.1','')")

    con:query("insert into check_sql values(4210,'delete from transaction_total_check where cny = 4210 and jpy = 421000 and gbp = 2947.0 and eur = 467310 and  hkd = 3789.0','')")

    con:query("insert into check_sql values(4211,'delete from transaction_total_check where cny = 4211 and jpy = 421100 and gbp = 2947.7 and eur = 467421 and  hkd = 3789.9','')")

    con:query("insert into check_sql values(4212,'delete from transaction_total_check where cny = 4212 and jpy = 421200 and gbp = 2948.4 and eur = 467532 and  hkd = 3790.8','')")

    con:query("insert into check_sql values(4213,'delete from transaction_total_check where cny = 4213 and jpy = 421300 and gbp = 2949.1 and eur = 467643 and  hkd = 3791.7','')")

    con:query("insert into check_sql values(4214,'delete from transaction_total_check where cny = 4214 and jpy = 421400 and gbp = 2949.8 and eur = 467754 and  hkd = 3792.6','')")

    con:query("insert into check_sql values(4215,'delete from transaction_total_check where cny = 4215 and jpy = 421500 and gbp = 2950.5 and eur = 467865 and  hkd = 3793.5','')")

    con:query("insert into check_sql values(4216,'delete from transaction_total_check where cny = 4216 and jpy = 421600 and gbp = 2951.2 and eur = 467976 and  hkd = 3794.4','')")

    con:query("insert into check_sql values(4217,'delete from transaction_total_check where cny = 4217 and jpy = 421700 and gbp = 2951.9 and eur = 468087 and  hkd = 3795.3','')")

    con:query("insert into check_sql values(4218,'delete from transaction_total_check where cny = 4218 and jpy = 421800 and gbp = 2952.6 and eur = 468198 and  hkd = 3796.2','')")

    con:query("insert into check_sql values(4219,'delete from transaction_total_check where cny = 4219 and jpy = 421900 and gbp = 2953.3 and eur = 468309 and  hkd = 3797.1','')")

    con:query("insert into check_sql values(4220,'delete from transaction_total_check where cny = 4220 and jpy = 422000 and gbp = 2954.0 and eur = 468420 and  hkd = 3798.0','')")

    con:query("insert into check_sql values(4221,'delete from transaction_total_check where cny = 4221 and jpy = 422100 and gbp = 2954.7 and eur = 468531 and  hkd = 3798.9','')")

    con:query("insert into check_sql values(4222,'delete from transaction_total_check where cny = 4222 and jpy = 422200 and gbp = 2955.4 and eur = 468642 and  hkd = 3799.8','')")

    con:query("insert into check_sql values(4223,'delete from transaction_total_check where cny = 4223 and jpy = 422300 and gbp = 2956.1 and eur = 468753 and  hkd = 3800.7','')")

    con:query("insert into check_sql values(4224,'delete from transaction_total_check where cny = 4224 and jpy = 422400 and gbp = 2956.8 and eur = 468864 and  hkd = 3801.6','')")

    con:query("insert into check_sql values(4225,'delete from transaction_total_check where cny = 4225 and jpy = 422500 and gbp = 2957.5 and eur = 468975 and  hkd = 3802.5','')")

    con:query("insert into check_sql values(4226,'delete from transaction_total_check where cny = 4226 and jpy = 422600 and gbp = 2958.2 and eur = 469086 and  hkd = 3803.4','')")

    con:query("insert into check_sql values(4227,'delete from transaction_total_check where cny = 4227 and jpy = 422700 and gbp = 2958.9 and eur = 469197 and  hkd = 3804.3','')")

    con:query("insert into check_sql values(4228,'delete from transaction_total_check where cny = 4228 and jpy = 422800 and gbp = 2959.6 and eur = 469308 and  hkd = 3805.2','')")

    con:query("insert into check_sql values(4229,'delete from transaction_total_check where cny = 4229 and jpy = 422900 and gbp = 2960.3 and eur = 469419 and  hkd = 3806.1','')")

    con:query("insert into check_sql values(4230,'delete from transaction_total_check where cny = 4230 and jpy = 423000 and gbp = 2961.0 and eur = 469530 and  hkd = 3807.0','')")

    con:query("insert into check_sql values(4231,'delete from transaction_total_check where cny = 4231 and jpy = 423100 and gbp = 2961.7 and eur = 469641 and  hkd = 3807.9','')")

    con:query("insert into check_sql values(4232,'delete from transaction_total_check where cny = 4232 and jpy = 423200 and gbp = 2962.4 and eur = 469752 and  hkd = 3808.8','')")

    con:query("insert into check_sql values(4233,'delete from transaction_total_check where cny = 4233 and jpy = 423300 and gbp = 2963.1 and eur = 469863 and  hkd = 3809.7','')")

    con:query("insert into check_sql values(4234,'delete from transaction_total_check where cny = 4234 and jpy = 423400 and gbp = 2963.8 and eur = 469974 and  hkd = 3810.6','')")

    con:query("insert into check_sql values(4235,'delete from transaction_total_check where cny = 4235 and jpy = 423500 and gbp = 2964.5 and eur = 470085 and  hkd = 3811.5','')")

    con:query("insert into check_sql values(4236,'delete from transaction_total_check where cny = 4236 and jpy = 423600 and gbp = 2965.2 and eur = 470196 and  hkd = 3812.4','')")

    con:query("insert into check_sql values(4237,'delete from transaction_total_check where cny = 4237 and jpy = 423700 and gbp = 2965.9 and eur = 470307 and  hkd = 3813.3','')")

    con:query("insert into check_sql values(4238,'delete from transaction_total_check where cny = 4238 and jpy = 423800 and gbp = 2966.6 and eur = 470418 and  hkd = 3814.2','')")

    con:query("insert into check_sql values(4239,'delete from transaction_total_check where cny = 4239 and jpy = 423900 and gbp = 2967.3 and eur = 470529 and  hkd = 3815.1','')")

    con:query("insert into check_sql values(4240,'delete from transaction_total_check where cny = 4240 and jpy = 424000 and gbp = 2968.0 and eur = 470640 and  hkd = 3816.0','')")

    con:query("insert into check_sql values(4241,'delete from transaction_total_check where cny = 4241 and jpy = 424100 and gbp = 2968.7 and eur = 470751 and  hkd = 3816.9','')")

    con:query("insert into check_sql values(4242,'delete from transaction_total_check where cny = 4242 and jpy = 424200 and gbp = 2969.4 and eur = 470862 and  hkd = 3817.8','')")

    con:query("insert into check_sql values(4243,'delete from transaction_total_check where cny = 4243 and jpy = 424300 and gbp = 2970.1 and eur = 470973 and  hkd = 3818.7','')")

    con:query("insert into check_sql values(4244,'delete from transaction_total_check where cny = 4244 and jpy = 424400 and gbp = 2970.8 and eur = 471084 and  hkd = 3819.6','')")

    con:query("insert into check_sql values(4245,'delete from transaction_total_check where cny = 4245 and jpy = 424500 and gbp = 2971.5 and eur = 471195 and  hkd = 3820.5','')")

    con:query("insert into check_sql values(4246,'delete from transaction_total_check where cny = 4246 and jpy = 424600 and gbp = 2972.2 and eur = 471306 and  hkd = 3821.4','')")

    con:query("insert into check_sql values(4247,'delete from transaction_total_check where cny = 4247 and jpy = 424700 and gbp = 2972.9 and eur = 471417 and  hkd = 3822.3','')")

    con:query("insert into check_sql values(4248,'delete from transaction_total_check where cny = 4248 and jpy = 424800 and gbp = 2973.6 and eur = 471528 and  hkd = 3823.2','')")

    con:query("insert into check_sql values(4249,'delete from transaction_total_check where cny = 4249 and jpy = 424900 and gbp = 2974.3 and eur = 471639 and  hkd = 3824.1','')")

    con:query("insert into check_sql values(4250,'delete from transaction_total_check where cny = 4250 and jpy = 425000 and gbp = 2975.0 and eur = 471750 and  hkd = 3825.0','')")

    con:query("insert into check_sql values(4251,'delete from transaction_total_check where cny = 4251 and jpy = 425100 and gbp = 2975.7 and eur = 471861 and  hkd = 3825.9','')")

    con:query("insert into check_sql values(4252,'delete from transaction_total_check where cny = 4252 and jpy = 425200 and gbp = 2976.4 and eur = 471972 and  hkd = 3826.8','')")

    con:query("insert into check_sql values(4253,'delete from transaction_total_check where cny = 4253 and jpy = 425300 and gbp = 2977.1 and eur = 472083 and  hkd = 3827.7','')")

    con:query("insert into check_sql values(4254,'delete from transaction_total_check where cny = 4254 and jpy = 425400 and gbp = 2977.8 and eur = 472194 and  hkd = 3828.6','')")

    con:query("insert into check_sql values(4255,'delete from transaction_total_check where cny = 4255 and jpy = 425500 and gbp = 2978.5 and eur = 472305 and  hkd = 3829.5','')")

    con:query("insert into check_sql values(4256,'delete from transaction_total_check where cny = 4256 and jpy = 425600 and gbp = 2979.2 and eur = 472416 and  hkd = 3830.4','')")

    con:query("insert into check_sql values(4257,'delete from transaction_total_check where cny = 4257 and jpy = 425700 and gbp = 2979.9 and eur = 472527 and  hkd = 3831.3','')")

    con:query("insert into check_sql values(4258,'delete from transaction_total_check where cny = 4258 and jpy = 425800 and gbp = 2980.6 and eur = 472638 and  hkd = 3832.2','')")

    con:query("insert into check_sql values(4259,'delete from transaction_total_check where cny = 4259 and jpy = 425900 and gbp = 2981.3 and eur = 472749 and  hkd = 3833.1','')")

    con:query("insert into check_sql values(4260,'delete from transaction_total_check where cny = 4260 and jpy = 426000 and gbp = 2982.0 and eur = 472860 and  hkd = 3834.0','')")

    con:query("insert into check_sql values(4261,'delete from transaction_total_check where cny = 4261 and jpy = 426100 and gbp = 2982.7 and eur = 472971 and  hkd = 3834.9','')")

    con:query("insert into check_sql values(4262,'delete from transaction_total_check where cny = 4262 and jpy = 426200 and gbp = 2983.4 and eur = 473082 and  hkd = 3835.8','')")

    con:query("insert into check_sql values(4263,'delete from transaction_total_check where cny = 4263 and jpy = 426300 and gbp = 2984.1 and eur = 473193 and  hkd = 3836.7','')")

    con:query("insert into check_sql values(4264,'delete from transaction_total_check where cny = 4264 and jpy = 426400 and gbp = 2984.8 and eur = 473304 and  hkd = 3837.6','')")

    con:query("insert into check_sql values(4265,'delete from transaction_total_check where cny = 4265 and jpy = 426500 and gbp = 2985.5 and eur = 473415 and  hkd = 3838.5','')")

    con:query("insert into check_sql values(4266,'delete from transaction_total_check where cny = 4266 and jpy = 426600 and gbp = 2986.2 and eur = 473526 and  hkd = 3839.4','')")

    con:query("insert into check_sql values(4267,'delete from transaction_total_check where cny = 4267 and jpy = 426700 and gbp = 2986.9 and eur = 473637 and  hkd = 3840.3','')")

    con:query("insert into check_sql values(4268,'delete from transaction_total_check where cny = 4268 and jpy = 426800 and gbp = 2987.6 and eur = 473748 and  hkd = 3841.2','')")

    con:query("insert into check_sql values(4269,'delete from transaction_total_check where cny = 4269 and jpy = 426900 and gbp = 2988.3 and eur = 473859 and  hkd = 3842.1','')")

    con:query("insert into check_sql values(4270,'delete from transaction_total_check where cny = 4270 and jpy = 427000 and gbp = 2989.0 and eur = 473970 and  hkd = 3843.0','')")

    con:query("insert into check_sql values(4271,'delete from transaction_total_check where cny = 4271 and jpy = 427100 and gbp = 2989.7 and eur = 474081 and  hkd = 3843.9','')")

    con:query("insert into check_sql values(4272,'delete from transaction_total_check where cny = 4272 and jpy = 427200 and gbp = 2990.4 and eur = 474192 and  hkd = 3844.8','')")

    con:query("insert into check_sql values(4273,'delete from transaction_total_check where cny = 4273 and jpy = 427300 and gbp = 2991.1 and eur = 474303 and  hkd = 3845.7','')")

    con:query("insert into check_sql values(4274,'delete from transaction_total_check where cny = 4274 and jpy = 427400 and gbp = 2991.8 and eur = 474414 and  hkd = 3846.6','')")

    con:query("insert into check_sql values(4275,'delete from transaction_total_check where cny = 4275 and jpy = 427500 and gbp = 2992.5 and eur = 474525 and  hkd = 3847.5','')")

    con:query("insert into check_sql values(4276,'delete from transaction_total_check where cny = 4276 and jpy = 427600 and gbp = 2993.2 and eur = 474636 and  hkd = 3848.4','')")

    con:query("insert into check_sql values(4277,'delete from transaction_total_check where cny = 4277 and jpy = 427700 and gbp = 2993.9 and eur = 474747 and  hkd = 3849.3','')")

    con:query("insert into check_sql values(4278,'delete from transaction_total_check where cny = 4278 and jpy = 427800 and gbp = 2994.6 and eur = 474858 and  hkd = 3850.2','')")

    con:query("insert into check_sql values(4279,'delete from transaction_total_check where cny = 4279 and jpy = 427900 and gbp = 2995.3 and eur = 474969 and  hkd = 3851.1','')")

    con:query("insert into check_sql values(4280,'delete from transaction_total_check where cny = 4280 and jpy = 428000 and gbp = 2996.0 and eur = 475080 and  hkd = 3852.0','')")

    con:query("insert into check_sql values(4281,'delete from transaction_total_check where cny = 4281 and jpy = 428100 and gbp = 2996.7 and eur = 475191 and  hkd = 3852.9','')")

    con:query("insert into check_sql values(4282,'delete from transaction_total_check where cny = 4282 and jpy = 428200 and gbp = 2997.4 and eur = 475302 and  hkd = 3853.8','')")

    con:query("insert into check_sql values(4283,'delete from transaction_total_check where cny = 4283 and jpy = 428300 and gbp = 2998.1 and eur = 475413 and  hkd = 3854.7','')")

    con:query("insert into check_sql values(4284,'delete from transaction_total_check where cny = 4284 and jpy = 428400 and gbp = 2998.8 and eur = 475524 and  hkd = 3855.6','')")

    con:query("insert into check_sql values(4285,'delete from transaction_total_check where cny = 4285 and jpy = 428500 and gbp = 2999.5 and eur = 475635 and  hkd = 3856.5','')")

    con:query("insert into check_sql values(4286,'delete from transaction_total_check where cny = 4286 and jpy = 428600 and gbp = 3000.2 and eur = 475746 and  hkd = 3857.4','')")

    con:query("insert into check_sql values(4287,'delete from transaction_total_check where cny = 4287 and jpy = 428700 and gbp = 3000.9 and eur = 475857 and  hkd = 3858.3','')")

    con:query("insert into check_sql values(4288,'delete from transaction_total_check where cny = 4288 and jpy = 428800 and gbp = 3001.6 and eur = 475968 and  hkd = 3859.2','')")

    con:query("insert into check_sql values(4289,'delete from transaction_total_check where cny = 4289 and jpy = 428900 and gbp = 3002.3 and eur = 476079 and  hkd = 3860.1','')")

    con:query("insert into check_sql values(4290,'delete from transaction_total_check where cny = 4290 and jpy = 429000 and gbp = 3003.0 and eur = 476190 and  hkd = 3861.0','')")

    con:query("insert into check_sql values(4291,'delete from transaction_total_check where cny = 4291 and jpy = 429100 and gbp = 3003.7 and eur = 476301 and  hkd = 3861.9','')")

    con:query("insert into check_sql values(4292,'delete from transaction_total_check where cny = 4292 and jpy = 429200 and gbp = 3004.4 and eur = 476412 and  hkd = 3862.8','')")

    con:query("insert into check_sql values(4293,'delete from transaction_total_check where cny = 4293 and jpy = 429300 and gbp = 3005.1 and eur = 476523 and  hkd = 3863.7','')")

    con:query("insert into check_sql values(4294,'delete from transaction_total_check where cny = 4294 and jpy = 429400 and gbp = 3005.8 and eur = 476634 and  hkd = 3864.6','')")

    con:query("insert into check_sql values(4295,'delete from transaction_total_check where cny = 4295 and jpy = 429500 and gbp = 3006.5 and eur = 476745 and  hkd = 3865.5','')")

    con:query("insert into check_sql values(4296,'delete from transaction_total_check where cny = 4296 and jpy = 429600 and gbp = 3007.2 and eur = 476856 and  hkd = 3866.4','')")

    con:query("insert into check_sql values(4297,'delete from transaction_total_check where cny = 4297 and jpy = 429700 and gbp = 3007.9 and eur = 476967 and  hkd = 3867.3','')")

    con:query("insert into check_sql values(4298,'delete from transaction_total_check where cny = 4298 and jpy = 429800 and gbp = 3008.6 and eur = 477078 and  hkd = 3868.2','')")

    con:query("insert into check_sql values(4299,'delete from transaction_total_check where cny = 4299 and jpy = 429900 and gbp = 3009.3 and eur = 477189 and  hkd = 3869.1','')")

    con:query("insert into check_sql values(4300,'delete from transaction_total_check where cny = 4300 and jpy = 430000 and gbp = 3010.0 and eur = 477300 and  hkd = 3870.0','')")

    con:query("insert into check_sql values(4301,'delete from transaction_total_check where cny = 4301 and jpy = 430100 and gbp = 3010.7 and eur = 477411 and  hkd = 3870.9','')")

    con:query("insert into check_sql values(4302,'delete from transaction_total_check where cny = 4302 and jpy = 430200 and gbp = 3011.4 and eur = 477522 and  hkd = 3871.8','')")

    con:query("insert into check_sql values(4303,'delete from transaction_total_check where cny = 4303 and jpy = 430300 and gbp = 3012.1 and eur = 477633 and  hkd = 3872.7','')")

    con:query("insert into check_sql values(4304,'delete from transaction_total_check where cny = 4304 and jpy = 430400 and gbp = 3012.8 and eur = 477744 and  hkd = 3873.6','')")

    con:query("insert into check_sql values(4305,'delete from transaction_total_check where cny = 4305 and jpy = 430500 and gbp = 3013.5 and eur = 477855 and  hkd = 3874.5','')")

    con:query("insert into check_sql values(4306,'delete from transaction_total_check where cny = 4306 and jpy = 430600 and gbp = 3014.2 and eur = 477966 and  hkd = 3875.4','')")

    con:query("insert into check_sql values(4307,'delete from transaction_total_check where cny = 4307 and jpy = 430700 and gbp = 3014.9 and eur = 478077 and  hkd = 3876.3','')")

    con:query("insert into check_sql values(4308,'delete from transaction_total_check where cny = 4308 and jpy = 430800 and gbp = 3015.6 and eur = 478188 and  hkd = 3877.2','')")

    con:query("insert into check_sql values(4309,'delete from transaction_total_check where cny = 4309 and jpy = 430900 and gbp = 3016.3 and eur = 478299 and  hkd = 3878.1','')")

    con:query("insert into check_sql values(4310,'delete from transaction_total_check where cny = 4310 and jpy = 431000 and gbp = 3017.0 and eur = 478410 and  hkd = 3879.0','')")

    con:query("insert into check_sql values(4311,'delete from transaction_total_check where cny = 4311 and jpy = 431100 and gbp = 3017.7 and eur = 478521 and  hkd = 3879.9','')")

    con:query("insert into check_sql values(4312,'delete from transaction_total_check where cny = 4312 and jpy = 431200 and gbp = 3018.4 and eur = 478632 and  hkd = 3880.8','')")

    con:query("insert into check_sql values(4313,'delete from transaction_total_check where cny = 4313 and jpy = 431300 and gbp = 3019.1 and eur = 478743 and  hkd = 3881.7','')")

    con:query("insert into check_sql values(4314,'delete from transaction_total_check where cny = 4314 and jpy = 431400 and gbp = 3019.8 and eur = 478854 and  hkd = 3882.6','')")

    con:query("insert into check_sql values(4315,'delete from transaction_total_check where cny = 4315 and jpy = 431500 and gbp = 3020.5 and eur = 478965 and  hkd = 3883.5','')")

    con:query("insert into check_sql values(4316,'delete from transaction_total_check where cny = 4316 and jpy = 431600 and gbp = 3021.2 and eur = 479076 and  hkd = 3884.4','')")

    con:query("insert into check_sql values(4317,'delete from transaction_total_check where cny = 4317 and jpy = 431700 and gbp = 3021.9 and eur = 479187 and  hkd = 3885.3','')")

    con:query("insert into check_sql values(4318,'delete from transaction_total_check where cny = 4318 and jpy = 431800 and gbp = 3022.6 and eur = 479298 and  hkd = 3886.2','')")

    con:query("insert into check_sql values(4319,'delete from transaction_total_check where cny = 4319 and jpy = 431900 and gbp = 3023.3 and eur = 479409 and  hkd = 3887.1','')")

    con:query("insert into check_sql values(4320,'delete from transaction_total_check where cny = 4320 and jpy = 432000 and gbp = 3024.0 and eur = 479520 and  hkd = 3888.0','')")

    con:query("insert into check_sql values(4321,'delete from transaction_total_check where cny = 4321 and jpy = 432100 and gbp = 3024.7 and eur = 479631 and  hkd = 3888.9','')")

    con:query("insert into check_sql values(4322,'delete from transaction_total_check where cny = 4322 and jpy = 432200 and gbp = 3025.4 and eur = 479742 and  hkd = 3889.8','')")

    con:query("insert into check_sql values(4323,'delete from transaction_total_check where cny = 4323 and jpy = 432300 and gbp = 3026.1 and eur = 479853 and  hkd = 3890.7','')")

    con:query("insert into check_sql values(4324,'delete from transaction_total_check where cny = 4324 and jpy = 432400 and gbp = 3026.8 and eur = 479964 and  hkd = 3891.6','')")

    con:query("insert into check_sql values(4325,'delete from transaction_total_check where cny = 4325 and jpy = 432500 and gbp = 3027.5 and eur = 480075 and  hkd = 3892.5','')")

    con:query("insert into check_sql values(4326,'delete from transaction_total_check where cny = 4326 and jpy = 432600 and gbp = 3028.2 and eur = 480186 and  hkd = 3893.4','')")

    con:query("insert into check_sql values(4327,'delete from transaction_total_check where cny = 4327 and jpy = 432700 and gbp = 3028.9 and eur = 480297 and  hkd = 3894.3','')")

    con:query("insert into check_sql values(4328,'delete from transaction_total_check where cny = 4328 and jpy = 432800 and gbp = 3029.6 and eur = 480408 and  hkd = 3895.2','')")

    con:query("insert into check_sql values(4329,'delete from transaction_total_check where cny = 4329 and jpy = 432900 and gbp = 3030.3 and eur = 480519 and  hkd = 3896.1','')")

    con:query("insert into check_sql values(4330,'delete from transaction_total_check where cny = 4330 and jpy = 433000 and gbp = 3031.0 and eur = 480630 and  hkd = 3897.0','')")

    con:query("insert into check_sql values(4331,'delete from transaction_total_check where cny = 4331 and jpy = 433100 and gbp = 3031.7 and eur = 480741 and  hkd = 3897.9','')")

    con:query("insert into check_sql values(4332,'delete from transaction_total_check where cny = 4332 and jpy = 433200 and gbp = 3032.4 and eur = 480852 and  hkd = 3898.8','')")

    con:query("insert into check_sql values(4333,'delete from transaction_total_check where cny = 4333 and jpy = 433300 and gbp = 3033.1 and eur = 480963 and  hkd = 3899.7','')")

    con:query("insert into check_sql values(4334,'delete from transaction_total_check where cny = 4334 and jpy = 433400 and gbp = 3033.8 and eur = 481074 and  hkd = 3900.6','')")

    con:query("insert into check_sql values(4335,'delete from transaction_total_check where cny = 4335 and jpy = 433500 and gbp = 3034.5 and eur = 481185 and  hkd = 3901.5','')")

    con:query("insert into check_sql values(4336,'delete from transaction_total_check where cny = 4336 and jpy = 433600 and gbp = 3035.2 and eur = 481296 and  hkd = 3902.4','')")

    con:query("insert into check_sql values(4337,'delete from transaction_total_check where cny = 4337 and jpy = 433700 and gbp = 3035.9 and eur = 481407 and  hkd = 3903.3','')")

    con:query("insert into check_sql values(4338,'delete from transaction_total_check where cny = 4338 and jpy = 433800 and gbp = 3036.6 and eur = 481518 and  hkd = 3904.2','')")

    con:query("insert into check_sql values(4339,'delete from transaction_total_check where cny = 4339 and jpy = 433900 and gbp = 3037.3 and eur = 481629 and  hkd = 3905.1','')")

    con:query("insert into check_sql values(4340,'delete from transaction_total_check where cny = 4340 and jpy = 434000 and gbp = 3038.0 and eur = 481740 and  hkd = 3906.0','')")

    con:query("insert into check_sql values(4341,'delete from transaction_total_check where cny = 4341 and jpy = 434100 and gbp = 3038.7 and eur = 481851 and  hkd = 3906.9','')")

    con:query("insert into check_sql values(4342,'delete from transaction_total_check where cny = 4342 and jpy = 434200 and gbp = 3039.4 and eur = 481962 and  hkd = 3907.8','')")

    con:query("insert into check_sql values(4343,'delete from transaction_total_check where cny = 4343 and jpy = 434300 and gbp = 3040.1 and eur = 482073 and  hkd = 3908.7','')")

    con:query("insert into check_sql values(4344,'delete from transaction_total_check where cny = 4344 and jpy = 434400 and gbp = 3040.8 and eur = 482184 and  hkd = 3909.6','')")

    con:query("insert into check_sql values(4345,'delete from transaction_total_check where cny = 4345 and jpy = 434500 and gbp = 3041.5 and eur = 482295 and  hkd = 3910.5','')")

    con:query("insert into check_sql values(4346,'delete from transaction_total_check where cny = 4346 and jpy = 434600 and gbp = 3042.2 and eur = 482406 and  hkd = 3911.4','')")

    con:query("insert into check_sql values(4347,'delete from transaction_total_check where cny = 4347 and jpy = 434700 and gbp = 3042.9 and eur = 482517 and  hkd = 3912.3','')")

    con:query("insert into check_sql values(4348,'delete from transaction_total_check where cny = 4348 and jpy = 434800 and gbp = 3043.6 and eur = 482628 and  hkd = 3913.2','')")

    con:query("insert into check_sql values(4349,'delete from transaction_total_check where cny = 4349 and jpy = 434900 and gbp = 3044.3 and eur = 482739 and  hkd = 3914.1','')")

    con:query("insert into check_sql values(4350,'delete from transaction_total_check where cny = 4350 and jpy = 435000 and gbp = 3045.0 and eur = 482850 and  hkd = 3915.0','')")

    con:query("insert into check_sql values(4351,'delete from transaction_total_check where cny = 4351 and jpy = 435100 and gbp = 3045.7 and eur = 482961 and  hkd = 3915.9','')")

    con:query("insert into check_sql values(4352,'delete from transaction_total_check where cny = 4352 and jpy = 435200 and gbp = 3046.4 and eur = 483072 and  hkd = 3916.8','')")

    con:query("insert into check_sql values(4353,'delete from transaction_total_check where cny = 4353 and jpy = 435300 and gbp = 3047.1 and eur = 483183 and  hkd = 3917.7','')")

    con:query("insert into check_sql values(4354,'delete from transaction_total_check where cny = 4354 and jpy = 435400 and gbp = 3047.8 and eur = 483294 and  hkd = 3918.6','')")

    con:query("insert into check_sql values(4355,'delete from transaction_total_check where cny = 4355 and jpy = 435500 and gbp = 3048.5 and eur = 483405 and  hkd = 3919.5','')")

    con:query("insert into check_sql values(4356,'delete from transaction_total_check where cny = 4356 and jpy = 435600 and gbp = 3049.2 and eur = 483516 and  hkd = 3920.4','')")

    con:query("insert into check_sql values(4357,'delete from transaction_total_check where cny = 4357 and jpy = 435700 and gbp = 3049.9 and eur = 483627 and  hkd = 3921.3','')")

    con:query("insert into check_sql values(4358,'delete from transaction_total_check where cny = 4358 and jpy = 435800 and gbp = 3050.6 and eur = 483738 and  hkd = 3922.2','')")

    con:query("insert into check_sql values(4359,'delete from transaction_total_check where cny = 4359 and jpy = 435900 and gbp = 3051.3 and eur = 483849 and  hkd = 3923.1','')")

    con:query("insert into check_sql values(4360,'delete from transaction_total_check where cny = 4360 and jpy = 436000 and gbp = 3052.0 and eur = 483960 and  hkd = 3924.0','')")

    con:query("insert into check_sql values(4361,'delete from transaction_total_check where cny = 4361 and jpy = 436100 and gbp = 3052.7 and eur = 484071 and  hkd = 3924.9','')")

    con:query("insert into check_sql values(4362,'delete from transaction_total_check where cny = 4362 and jpy = 436200 and gbp = 3053.4 and eur = 484182 and  hkd = 3925.8','')")

    con:query("insert into check_sql values(4363,'delete from transaction_total_check where cny = 4363 and jpy = 436300 and gbp = 3054.1 and eur = 484293 and  hkd = 3926.7','')")

    con:query("insert into check_sql values(4364,'delete from transaction_total_check where cny = 4364 and jpy = 436400 and gbp = 3054.8 and eur = 484404 and  hkd = 3927.6','')")

    con:query("insert into check_sql values(4365,'delete from transaction_total_check where cny = 4365 and jpy = 436500 and gbp = 3055.5 and eur = 484515 and  hkd = 3928.5','')")

    con:query("insert into check_sql values(4366,'delete from transaction_total_check where cny = 4366 and jpy = 436600 and gbp = 3056.2 and eur = 484626 and  hkd = 3929.4','')")

    con:query("insert into check_sql values(4367,'delete from transaction_total_check where cny = 4367 and jpy = 436700 and gbp = 3056.9 and eur = 484737 and  hkd = 3930.3','')")

    con:query("insert into check_sql values(4368,'delete from transaction_total_check where cny = 4368 and jpy = 436800 and gbp = 3057.6 and eur = 484848 and  hkd = 3931.2','')")

    con:query("insert into check_sql values(4369,'delete from transaction_total_check where cny = 4369 and jpy = 436900 and gbp = 3058.3 and eur = 484959 and  hkd = 3932.1','')")

    con:query("insert into check_sql values(4370,'delete from transaction_total_check where cny = 4370 and jpy = 437000 and gbp = 3059.0 and eur = 485070 and  hkd = 3933.0','')")

    con:query("insert into check_sql values(4371,'delete from transaction_total_check where cny = 4371 and jpy = 437100 and gbp = 3059.7 and eur = 485181 and  hkd = 3933.9','')")

    con:query("insert into check_sql values(4372,'delete from transaction_total_check where cny = 4372 and jpy = 437200 and gbp = 3060.4 and eur = 485292 and  hkd = 3934.8','')")

    con:query("insert into check_sql values(4373,'delete from transaction_total_check where cny = 4373 and jpy = 437300 and gbp = 3061.1 and eur = 485403 and  hkd = 3935.7','')")

    con:query("insert into check_sql values(4374,'delete from transaction_total_check where cny = 4374 and jpy = 437400 and gbp = 3061.8 and eur = 485514 and  hkd = 3936.6','')")

    con:query("insert into check_sql values(4375,'delete from transaction_total_check where cny = 4375 and jpy = 437500 and gbp = 3062.5 and eur = 485625 and  hkd = 3937.5','')")

    con:query("insert into check_sql values(4376,'delete from transaction_total_check where cny = 4376 and jpy = 437600 and gbp = 3063.2 and eur = 485736 and  hkd = 3938.4','')")

    con:query("insert into check_sql values(4377,'delete from transaction_total_check where cny = 4377 and jpy = 437700 and gbp = 3063.9 and eur = 485847 and  hkd = 3939.3','')")

    con:query("insert into check_sql values(4378,'delete from transaction_total_check where cny = 4378 and jpy = 437800 and gbp = 3064.6 and eur = 485958 and  hkd = 3940.2','')")

    con:query("insert into check_sql values(4379,'delete from transaction_total_check where cny = 4379 and jpy = 437900 and gbp = 3065.3 and eur = 486069 and  hkd = 3941.1','')")

    con:query("insert into check_sql values(4380,'delete from transaction_total_check where cny = 4380 and jpy = 438000 and gbp = 3066.0 and eur = 486180 and  hkd = 3942.0','')")

    con:query("insert into check_sql values(4381,'delete from transaction_total_check where cny = 4381 and jpy = 438100 and gbp = 3066.7 and eur = 486291 and  hkd = 3942.9','')")

    con:query("insert into check_sql values(4382,'delete from transaction_total_check where cny = 4382 and jpy = 438200 and gbp = 3067.4 and eur = 486402 and  hkd = 3943.8','')")

    con:query("insert into check_sql values(4383,'delete from transaction_total_check where cny = 4383 and jpy = 438300 and gbp = 3068.1 and eur = 486513 and  hkd = 3944.7','')")

    con:query("insert into check_sql values(4384,'delete from transaction_total_check where cny = 4384 and jpy = 438400 and gbp = 3068.8 and eur = 486624 and  hkd = 3945.6','')")

    con:query("insert into check_sql values(4385,'delete from transaction_total_check where cny = 4385 and jpy = 438500 and gbp = 3069.5 and eur = 486735 and  hkd = 3946.5','')")

    con:query("insert into check_sql values(4386,'delete from transaction_total_check where cny = 4386 and jpy = 438600 and gbp = 3070.2 and eur = 486846 and  hkd = 3947.4','')")

    con:query("insert into check_sql values(4387,'delete from transaction_total_check where cny = 4387 and jpy = 438700 and gbp = 3070.9 and eur = 486957 and  hkd = 3948.3','')")

    con:query("insert into check_sql values(4388,'delete from transaction_total_check where cny = 4388 and jpy = 438800 and gbp = 3071.6 and eur = 487068 and  hkd = 3949.2','')")

    con:query("insert into check_sql values(4389,'delete from transaction_total_check where cny = 4389 and jpy = 438900 and gbp = 3072.3 and eur = 487179 and  hkd = 3950.1','')")

    con:query("insert into check_sql values(4390,'delete from transaction_total_check where cny = 4390 and jpy = 439000 and gbp = 3073.0 and eur = 487290 and  hkd = 3951.0','')")

    con:query("insert into check_sql values(4391,'delete from transaction_total_check where cny = 4391 and jpy = 439100 and gbp = 3073.7 and eur = 487401 and  hkd = 3951.9','')")

    con:query("insert into check_sql values(4392,'delete from transaction_total_check where cny = 4392 and jpy = 439200 and gbp = 3074.4 and eur = 487512 and  hkd = 3952.8','')")

    con:query("insert into check_sql values(4393,'delete from transaction_total_check where cny = 4393 and jpy = 439300 and gbp = 3075.1 and eur = 487623 and  hkd = 3953.7','')")

    con:query("insert into check_sql values(4394,'delete from transaction_total_check where cny = 4394 and jpy = 439400 and gbp = 3075.8 and eur = 487734 and  hkd = 3954.6','')")

    con:query("insert into check_sql values(4395,'delete from transaction_total_check where cny = 4395 and jpy = 439500 and gbp = 3076.5 and eur = 487845 and  hkd = 3955.5','')")

    con:query("insert into check_sql values(4396,'delete from transaction_total_check where cny = 4396 and jpy = 439600 and gbp = 3077.2 and eur = 487956 and  hkd = 3956.4','')")

    con:query("insert into check_sql values(4397,'delete from transaction_total_check where cny = 4397 and jpy = 439700 and gbp = 3077.9 and eur = 488067 and  hkd = 3957.3','')")

    con:query("insert into check_sql values(4398,'delete from transaction_total_check where cny = 4398 and jpy = 439800 and gbp = 3078.6 and eur = 488178 and  hkd = 3958.2','')")

    con:query("insert into check_sql values(4399,'delete from transaction_total_check where cny = 4399 and jpy = 439900 and gbp = 3079.3 and eur = 488289 and  hkd = 3959.1','')")

    con:query("insert into check_sql values(4400,'delete from transaction_total_check where cny = 4400 and jpy = 440000 and gbp = 3080.0 and eur = 488400 and  hkd = 3960.0','')")

    con:query("insert into check_sql values(4401,'delete from transaction_total_check where cny = 4401 and jpy = 440100 and gbp = 3080.7 and eur = 488511 and  hkd = 3960.9','')")

    con:query("insert into check_sql values(4402,'delete from transaction_total_check where cny = 4402 and jpy = 440200 and gbp = 3081.4 and eur = 488622 and  hkd = 3961.8','')")

    con:query("insert into check_sql values(4403,'delete from transaction_total_check where cny = 4403 and jpy = 440300 and gbp = 3082.1 and eur = 488733 and  hkd = 3962.7','')")

    con:query("insert into check_sql values(4404,'delete from transaction_total_check where cny = 4404 and jpy = 440400 and gbp = 3082.8 and eur = 488844 and  hkd = 3963.6','')")

    con:query("insert into check_sql values(4405,'delete from transaction_total_check where cny = 4405 and jpy = 440500 and gbp = 3083.5 and eur = 488955 and  hkd = 3964.5','')")

    con:query("insert into check_sql values(4406,'delete from transaction_total_check where cny = 4406 and jpy = 440600 and gbp = 3084.2 and eur = 489066 and  hkd = 3965.4','')")

    con:query("insert into check_sql values(4407,'delete from transaction_total_check where cny = 4407 and jpy = 440700 and gbp = 3084.9 and eur = 489177 and  hkd = 3966.3','')")

    con:query("insert into check_sql values(4408,'delete from transaction_total_check where cny = 4408 and jpy = 440800 and gbp = 3085.6 and eur = 489288 and  hkd = 3967.2','')")

    con:query("insert into check_sql values(4409,'delete from transaction_total_check where cny = 4409 and jpy = 440900 and gbp = 3086.3 and eur = 489399 and  hkd = 3968.1','')")

    con:query("insert into check_sql values(4410,'delete from transaction_total_check where cny = 4410 and jpy = 441000 and gbp = 3087.0 and eur = 489510 and  hkd = 3969.0','')")

    con:query("insert into check_sql values(4411,'delete from transaction_total_check where cny = 4411 and jpy = 441100 and gbp = 3087.7 and eur = 489621 and  hkd = 3969.9','')")

    con:query("insert into check_sql values(4412,'delete from transaction_total_check where cny = 4412 and jpy = 441200 and gbp = 3088.4 and eur = 489732 and  hkd = 3970.8','')")

    con:query("insert into check_sql values(4413,'delete from transaction_total_check where cny = 4413 and jpy = 441300 and gbp = 3089.1 and eur = 489843 and  hkd = 3971.7','')")

    con:query("insert into check_sql values(4414,'delete from transaction_total_check where cny = 4414 and jpy = 441400 and gbp = 3089.8 and eur = 489954 and  hkd = 3972.6','')")

    con:query("insert into check_sql values(4415,'delete from transaction_total_check where cny = 4415 and jpy = 441500 and gbp = 3090.5 and eur = 490065 and  hkd = 3973.5','')")

    con:query("insert into check_sql values(4416,'delete from transaction_total_check where cny = 4416 and jpy = 441600 and gbp = 3091.2 and eur = 490176 and  hkd = 3974.4','')")

    con:query("insert into check_sql values(4417,'delete from transaction_total_check where cny = 4417 and jpy = 441700 and gbp = 3091.9 and eur = 490287 and  hkd = 3975.3','')")

    con:query("insert into check_sql values(4418,'delete from transaction_total_check where cny = 4418 and jpy = 441800 and gbp = 3092.6 and eur = 490398 and  hkd = 3976.2','')")

    con:query("insert into check_sql values(4419,'delete from transaction_total_check where cny = 4419 and jpy = 441900 and gbp = 3093.3 and eur = 490509 and  hkd = 3977.1','')")

    con:query("insert into check_sql values(4420,'delete from transaction_total_check where cny = 4420 and jpy = 442000 and gbp = 3094.0 and eur = 490620 and  hkd = 3978.0','')")

    con:query("insert into check_sql values(4421,'delete from transaction_total_check where cny = 4421 and jpy = 442100 and gbp = 3094.7 and eur = 490731 and  hkd = 3978.9','')")

    con:query("insert into check_sql values(4422,'delete from transaction_total_check where cny = 4422 and jpy = 442200 and gbp = 3095.4 and eur = 490842 and  hkd = 3979.8','')")

    con:query("insert into check_sql values(4423,'delete from transaction_total_check where cny = 4423 and jpy = 442300 and gbp = 3096.1 and eur = 490953 and  hkd = 3980.7','')")

    con:query("insert into check_sql values(4424,'delete from transaction_total_check where cny = 4424 and jpy = 442400 and gbp = 3096.8 and eur = 491064 and  hkd = 3981.6','')")

    con:query("insert into check_sql values(4425,'delete from transaction_total_check where cny = 4425 and jpy = 442500 and gbp = 3097.5 and eur = 491175 and  hkd = 3982.5','')")

    con:query("insert into check_sql values(4426,'delete from transaction_total_check where cny = 4426 and jpy = 442600 and gbp = 3098.2 and eur = 491286 and  hkd = 3983.4','')")

    con:query("insert into check_sql values(4427,'delete from transaction_total_check where cny = 4427 and jpy = 442700 and gbp = 3098.9 and eur = 491397 and  hkd = 3984.3','')")

    con:query("insert into check_sql values(4428,'delete from transaction_total_check where cny = 4428 and jpy = 442800 and gbp = 3099.6 and eur = 491508 and  hkd = 3985.2','')")

    con:query("insert into check_sql values(4429,'delete from transaction_total_check where cny = 4429 and jpy = 442900 and gbp = 3100.3 and eur = 491619 and  hkd = 3986.1','')")

    con:query("insert into check_sql values(4430,'delete from transaction_total_check where cny = 4430 and jpy = 443000 and gbp = 3101.0 and eur = 491730 and  hkd = 3987.0','')")

    con:query("insert into check_sql values(4431,'delete from transaction_total_check where cny = 4431 and jpy = 443100 and gbp = 3101.7 and eur = 491841 and  hkd = 3987.9','')")

    con:query("insert into check_sql values(4432,'delete from transaction_total_check where cny = 4432 and jpy = 443200 and gbp = 3102.4 and eur = 491952 and  hkd = 3988.8','')")

    con:query("insert into check_sql values(4433,'delete from transaction_total_check where cny = 4433 and jpy = 443300 and gbp = 3103.1 and eur = 492063 and  hkd = 3989.7','')")

    con:query("insert into check_sql values(4434,'delete from transaction_total_check where cny = 4434 and jpy = 443400 and gbp = 3103.8 and eur = 492174 and  hkd = 3990.6','')")

    con:query("insert into check_sql values(4435,'delete from transaction_total_check where cny = 4435 and jpy = 443500 and gbp = 3104.5 and eur = 492285 and  hkd = 3991.5','')")

    con:query("insert into check_sql values(4436,'delete from transaction_total_check where cny = 4436 and jpy = 443600 and gbp = 3105.2 and eur = 492396 and  hkd = 3992.4','')")

    con:query("insert into check_sql values(4437,'delete from transaction_total_check where cny = 4437 and jpy = 443700 and gbp = 3105.9 and eur = 492507 and  hkd = 3993.3','')")

    con:query("insert into check_sql values(4438,'delete from transaction_total_check where cny = 4438 and jpy = 443800 and gbp = 3106.6 and eur = 492618 and  hkd = 3994.2','')")

    con:query("insert into check_sql values(4439,'delete from transaction_total_check where cny = 4439 and jpy = 443900 and gbp = 3107.3 and eur = 492729 and  hkd = 3995.1','')")

    con:query("insert into check_sql values(4440,'delete from transaction_total_check where cny = 4440 and jpy = 444000 and gbp = 3108.0 and eur = 492840 and  hkd = 3996.0','')")

    con:query("insert into check_sql values(4441,'delete from transaction_total_check where cny = 4441 and jpy = 444100 and gbp = 3108.7 and eur = 492951 and  hkd = 3996.9','')")

    con:query("insert into check_sql values(4442,'delete from transaction_total_check where cny = 4442 and jpy = 444200 and gbp = 3109.4 and eur = 493062 and  hkd = 3997.8','')")

    con:query("insert into check_sql values(4443,'delete from transaction_total_check where cny = 4443 and jpy = 444300 and gbp = 3110.1 and eur = 493173 and  hkd = 3998.7','')")

    con:query("insert into check_sql values(4444,'delete from transaction_total_check where cny = 4444 and jpy = 444400 and gbp = 3110.8 and eur = 493284 and  hkd = 3999.6','')")

    con:query("insert into check_sql values(4445,'delete from transaction_total_check where cny = 4445 and jpy = 444500 and gbp = 3111.5 and eur = 493395 and  hkd = 4000.5','')")

    con:query("insert into check_sql values(4446,'delete from transaction_total_check where cny = 4446 and jpy = 444600 and gbp = 3112.2 and eur = 493506 and  hkd = 4001.4','')")

    con:query("insert into check_sql values(4447,'delete from transaction_total_check where cny = 4447 and jpy = 444700 and gbp = 3112.9 and eur = 493617 and  hkd = 4002.3','')")

    con:query("insert into check_sql values(4448,'delete from transaction_total_check where cny = 4448 and jpy = 444800 and gbp = 3113.6 and eur = 493728 and  hkd = 4003.2','')")

    con:query("insert into check_sql values(4449,'delete from transaction_total_check where cny = 4449 and jpy = 444900 and gbp = 3114.3 and eur = 493839 and  hkd = 4004.1','')")

    con:query("insert into check_sql values(4450,'delete from transaction_total_check where cny = 4450 and jpy = 445000 and gbp = 3115.0 and eur = 493950 and  hkd = 4005.0','')")

    con:query("insert into check_sql values(4451,'delete from transaction_total_check where cny = 4451 and jpy = 445100 and gbp = 3115.7 and eur = 494061 and  hkd = 4005.9','')")

    con:query("insert into check_sql values(4452,'delete from transaction_total_check where cny = 4452 and jpy = 445200 and gbp = 3116.4 and eur = 494172 and  hkd = 4006.8','')")

    con:query("insert into check_sql values(4453,'delete from transaction_total_check where cny = 4453 and jpy = 445300 and gbp = 3117.1 and eur = 494283 and  hkd = 4007.7','')")

    con:query("insert into check_sql values(4454,'delete from transaction_total_check where cny = 4454 and jpy = 445400 and gbp = 3117.8 and eur = 494394 and  hkd = 4008.6','')")

    con:query("insert into check_sql values(4455,'delete from transaction_total_check where cny = 4455 and jpy = 445500 and gbp = 3118.5 and eur = 494505 and  hkd = 4009.5','')")

    con:query("insert into check_sql values(4456,'delete from transaction_total_check where cny = 4456 and jpy = 445600 and gbp = 3119.2 and eur = 494616 and  hkd = 4010.4','')")

    con:query("insert into check_sql values(4457,'delete from transaction_total_check where cny = 4457 and jpy = 445700 and gbp = 3119.9 and eur = 494727 and  hkd = 4011.3','')")

    con:query("insert into check_sql values(4458,'delete from transaction_total_check where cny = 4458 and jpy = 445800 and gbp = 3120.6 and eur = 494838 and  hkd = 4012.2','')")

    con:query("insert into check_sql values(4459,'delete from transaction_total_check where cny = 4459 and jpy = 445900 and gbp = 3121.3 and eur = 494949 and  hkd = 4013.1','')")

    con:query("insert into check_sql values(4460,'delete from transaction_total_check where cny = 4460 and jpy = 446000 and gbp = 3122.0 and eur = 495060 and  hkd = 4014.0','')")

    con:query("insert into check_sql values(4461,'delete from transaction_total_check where cny = 4461 and jpy = 446100 and gbp = 3122.7 and eur = 495171 and  hkd = 4014.9','')")

    con:query("insert into check_sql values(4462,'delete from transaction_total_check where cny = 4462 and jpy = 446200 and gbp = 3123.4 and eur = 495282 and  hkd = 4015.8','')")

    con:query("insert into check_sql values(4463,'delete from transaction_total_check where cny = 4463 and jpy = 446300 and gbp = 3124.1 and eur = 495393 and  hkd = 4016.7','')")

    con:query("insert into check_sql values(4464,'delete from transaction_total_check where cny = 4464 and jpy = 446400 and gbp = 3124.8 and eur = 495504 and  hkd = 4017.6','')")

    con:query("insert into check_sql values(4465,'delete from transaction_total_check where cny = 4465 and jpy = 446500 and gbp = 3125.5 and eur = 495615 and  hkd = 4018.5','')")

    con:query("insert into check_sql values(4466,'delete from transaction_total_check where cny = 4466 and jpy = 446600 and gbp = 3126.2 and eur = 495726 and  hkd = 4019.4','')")

    con:query("insert into check_sql values(4467,'delete from transaction_total_check where cny = 4467 and jpy = 446700 and gbp = 3126.9 and eur = 495837 and  hkd = 4020.3','')")

    con:query("insert into check_sql values(4468,'delete from transaction_total_check where cny = 4468 and jpy = 446800 and gbp = 3127.6 and eur = 495948 and  hkd = 4021.2','')")

    con:query("insert into check_sql values(4469,'delete from transaction_total_check where cny = 4469 and jpy = 446900 and gbp = 3128.3 and eur = 496059 and  hkd = 4022.1','')")

    con:query("insert into check_sql values(4470,'delete from transaction_total_check where cny = 4470 and jpy = 447000 and gbp = 3129.0 and eur = 496170 and  hkd = 4023.0','')")

    con:query("insert into check_sql values(4471,'delete from transaction_total_check where cny = 4471 and jpy = 447100 and gbp = 3129.7 and eur = 496281 and  hkd = 4023.9','')")

    con:query("insert into check_sql values(4472,'delete from transaction_total_check where cny = 4472 and jpy = 447200 and gbp = 3130.4 and eur = 496392 and  hkd = 4024.8','')")

    con:query("insert into check_sql values(4473,'delete from transaction_total_check where cny = 4473 and jpy = 447300 and gbp = 3131.1 and eur = 496503 and  hkd = 4025.7','')")

    con:query("insert into check_sql values(4474,'delete from transaction_total_check where cny = 4474 and jpy = 447400 and gbp = 3131.8 and eur = 496614 and  hkd = 4026.6','')")

    con:query("insert into check_sql values(4475,'delete from transaction_total_check where cny = 4475 and jpy = 447500 and gbp = 3132.5 and eur = 496725 and  hkd = 4027.5','')")

    con:query("insert into check_sql values(4476,'delete from transaction_total_check where cny = 4476 and jpy = 447600 and gbp = 3133.2 and eur = 496836 and  hkd = 4028.4','')")

    con:query("insert into check_sql values(4477,'delete from transaction_total_check where cny = 4477 and jpy = 447700 and gbp = 3133.9 and eur = 496947 and  hkd = 4029.3','')")

    con:query("insert into check_sql values(4478,'delete from transaction_total_check where cny = 4478 and jpy = 447800 and gbp = 3134.6 and eur = 497058 and  hkd = 4030.2','')")

    con:query("insert into check_sql values(4479,'delete from transaction_total_check where cny = 4479 and jpy = 447900 and gbp = 3135.3 and eur = 497169 and  hkd = 4031.1','')")

    con:query("insert into check_sql values(4480,'delete from transaction_total_check where cny = 4480 and jpy = 448000 and gbp = 3136.0 and eur = 497280 and  hkd = 4032.0','')")

    con:query("insert into check_sql values(4481,'delete from transaction_total_check where cny = 4481 and jpy = 448100 and gbp = 3136.7 and eur = 497391 and  hkd = 4032.9','')")

    con:query("insert into check_sql values(4482,'delete from transaction_total_check where cny = 4482 and jpy = 448200 and gbp = 3137.4 and eur = 497502 and  hkd = 4033.8','')")

    con:query("insert into check_sql values(4483,'delete from transaction_total_check where cny = 4483 and jpy = 448300 and gbp = 3138.1 and eur = 497613 and  hkd = 4034.7','')")

    con:query("insert into check_sql values(4484,'delete from transaction_total_check where cny = 4484 and jpy = 448400 and gbp = 3138.8 and eur = 497724 and  hkd = 4035.6','')")

    con:query("insert into check_sql values(4485,'delete from transaction_total_check where cny = 4485 and jpy = 448500 and gbp = 3139.5 and eur = 497835 and  hkd = 4036.5','')")

    con:query("insert into check_sql values(4486,'delete from transaction_total_check where cny = 4486 and jpy = 448600 and gbp = 3140.2 and eur = 497946 and  hkd = 4037.4','')")

    con:query("insert into check_sql values(4487,'delete from transaction_total_check where cny = 4487 and jpy = 448700 and gbp = 3140.9 and eur = 498057 and  hkd = 4038.3','')")

    con:query("insert into check_sql values(4488,'delete from transaction_total_check where cny = 4488 and jpy = 448800 and gbp = 3141.6 and eur = 498168 and  hkd = 4039.2','')")

    con:query("insert into check_sql values(4489,'delete from transaction_total_check where cny = 4489 and jpy = 448900 and gbp = 3142.3 and eur = 498279 and  hkd = 4040.1','')")

    con:query("insert into check_sql values(4490,'delete from transaction_total_check where cny = 4490 and jpy = 449000 and gbp = 3143.0 and eur = 498390 and  hkd = 4041.0','')")

    con:query("insert into check_sql values(4491,'delete from transaction_total_check where cny = 4491 and jpy = 449100 and gbp = 3143.7 and eur = 498501 and  hkd = 4041.9','')")

    con:query("insert into check_sql values(4492,'delete from transaction_total_check where cny = 4492 and jpy = 449200 and gbp = 3144.4 and eur = 498612 and  hkd = 4042.8','')")

    con:query("insert into check_sql values(4493,'delete from transaction_total_check where cny = 4493 and jpy = 449300 and gbp = 3145.1 and eur = 498723 and  hkd = 4043.7','')")

    con:query("insert into check_sql values(4494,'delete from transaction_total_check where cny = 4494 and jpy = 449400 and gbp = 3145.8 and eur = 498834 and  hkd = 4044.6','')")

    con:query("insert into check_sql values(4495,'delete from transaction_total_check where cny = 4495 and jpy = 449500 and gbp = 3146.5 and eur = 498945 and  hkd = 4045.5','')")

    con:query("insert into check_sql values(4496,'delete from transaction_total_check where cny = 4496 and jpy = 449600 and gbp = 3147.2 and eur = 499056 and  hkd = 4046.4','')")

    con:query("insert into check_sql values(4497,'delete from transaction_total_check where cny = 4497 and jpy = 449700 and gbp = 3147.9 and eur = 499167 and  hkd = 4047.3','')")

    con:query("insert into check_sql values(4498,'delete from transaction_total_check where cny = 4498 and jpy = 449800 and gbp = 3148.6 and eur = 499278 and  hkd = 4048.2','')")

    con:query("insert into check_sql values(4499,'delete from transaction_total_check where cny = 4499 and jpy = 449900 and gbp = 3149.3 and eur = 499389 and  hkd = 4049.1','')")

    con:query("insert into check_sql values(4500,'delete from transaction_total_check where cny = 4500 and jpy = 450000 and gbp = 3150.0 and eur = 499500 and  hkd = 4050.0','')")

    con:query("insert into check_sql values(4501,'delete from transaction_total_check where cny = 4501 and jpy = 450100 and gbp = 3150.7 and eur = 499611 and  hkd = 4050.9','')")

    con:query("insert into check_sql values(4502,'delete from transaction_total_check where cny = 4502 and jpy = 450200 and gbp = 3151.4 and eur = 499722 and  hkd = 4051.8','')")

    con:query("insert into check_sql values(4503,'delete from transaction_total_check where cny = 4503 and jpy = 450300 and gbp = 3152.1 and eur = 499833 and  hkd = 4052.7','')")

    con:query("insert into check_sql values(4504,'delete from transaction_total_check where cny = 4504 and jpy = 450400 and gbp = 3152.8 and eur = 499944 and  hkd = 4053.6','')")

    con:query("insert into check_sql values(4505,'delete from transaction_total_check where cny = 4505 and jpy = 450500 and gbp = 3153.5 and eur = 500055 and  hkd = 4054.5','')")

    con:query("insert into check_sql values(4506,'delete from transaction_total_check where cny = 4506 and jpy = 450600 and gbp = 3154.2 and eur = 500166 and  hkd = 4055.4','')")

    con:query("insert into check_sql values(4507,'delete from transaction_total_check where cny = 4507 and jpy = 450700 and gbp = 3154.9 and eur = 500277 and  hkd = 4056.3','')")

    con:query("insert into check_sql values(4508,'delete from transaction_total_check where cny = 4508 and jpy = 450800 and gbp = 3155.6 and eur = 500388 and  hkd = 4057.2','')")

    con:query("insert into check_sql values(4509,'delete from transaction_total_check where cny = 4509 and jpy = 450900 and gbp = 3156.3 and eur = 500499 and  hkd = 4058.1','')")

    con:query("insert into check_sql values(4510,'delete from transaction_total_check where cny = 4510 and jpy = 451000 and gbp = 3157.0 and eur = 500610 and  hkd = 4059.0','')")

    con:query("insert into check_sql values(4511,'delete from transaction_total_check where cny = 4511 and jpy = 451100 and gbp = 3157.7 and eur = 500721 and  hkd = 4059.9','')")

    con:query("insert into check_sql values(4512,'delete from transaction_total_check where cny = 4512 and jpy = 451200 and gbp = 3158.4 and eur = 500832 and  hkd = 4060.8','')")

    con:query("insert into check_sql values(4513,'delete from transaction_total_check where cny = 4513 and jpy = 451300 and gbp = 3159.1 and eur = 500943 and  hkd = 4061.7','')")

    con:query("insert into check_sql values(4514,'delete from transaction_total_check where cny = 4514 and jpy = 451400 and gbp = 3159.8 and eur = 501054 and  hkd = 4062.6','')")

    con:query("insert into check_sql values(4515,'delete from transaction_total_check where cny = 4515 and jpy = 451500 and gbp = 3160.5 and eur = 501165 and  hkd = 4063.5','')")

    con:query("insert into check_sql values(4516,'delete from transaction_total_check where cny = 4516 and jpy = 451600 and gbp = 3161.2 and eur = 501276 and  hkd = 4064.4','')")

    con:query("insert into check_sql values(4517,'delete from transaction_total_check where cny = 4517 and jpy = 451700 and gbp = 3161.9 and eur = 501387 and  hkd = 4065.3','')")

    con:query("insert into check_sql values(4518,'delete from transaction_total_check where cny = 4518 and jpy = 451800 and gbp = 3162.6 and eur = 501498 and  hkd = 4066.2','')")

    con:query("insert into check_sql values(4519,'delete from transaction_total_check where cny = 4519 and jpy = 451900 and gbp = 3163.3 and eur = 501609 and  hkd = 4067.1','')")

    con:query("insert into check_sql values(4520,'delete from transaction_total_check where cny = 4520 and jpy = 452000 and gbp = 3164.0 and eur = 501720 and  hkd = 4068.0','')")

    con:query("insert into check_sql values(4521,'delete from transaction_total_check where cny = 4521 and jpy = 452100 and gbp = 3164.7 and eur = 501831 and  hkd = 4068.9','')")

    con:query("insert into check_sql values(4522,'delete from transaction_total_check where cny = 4522 and jpy = 452200 and gbp = 3165.4 and eur = 501942 and  hkd = 4069.8','')")

    con:query("insert into check_sql values(4523,'delete from transaction_total_check where cny = 4523 and jpy = 452300 and gbp = 3166.1 and eur = 502053 and  hkd = 4070.7','')")

    con:query("insert into check_sql values(4524,'delete from transaction_total_check where cny = 4524 and jpy = 452400 and gbp = 3166.8 and eur = 502164 and  hkd = 4071.6','')")

    con:query("insert into check_sql values(4525,'delete from transaction_total_check where cny = 4525 and jpy = 452500 and gbp = 3167.5 and eur = 502275 and  hkd = 4072.5','')")

    con:query("insert into check_sql values(4526,'delete from transaction_total_check where cny = 4526 and jpy = 452600 and gbp = 3168.2 and eur = 502386 and  hkd = 4073.4','')")

    con:query("insert into check_sql values(4527,'delete from transaction_total_check where cny = 4527 and jpy = 452700 and gbp = 3168.9 and eur = 502497 and  hkd = 4074.3','')")

    con:query("insert into check_sql values(4528,'delete from transaction_total_check where cny = 4528 and jpy = 452800 and gbp = 3169.6 and eur = 502608 and  hkd = 4075.2','')")

    con:query("insert into check_sql values(4529,'delete from transaction_total_check where cny = 4529 and jpy = 452900 and gbp = 3170.3 and eur = 502719 and  hkd = 4076.1','')")

    con:query("insert into check_sql values(4530,'delete from transaction_total_check where cny = 4530 and jpy = 453000 and gbp = 3171.0 and eur = 502830 and  hkd = 4077.0','')")

    con:query("insert into check_sql values(4531,'delete from transaction_total_check where cny = 4531 and jpy = 453100 and gbp = 3171.7 and eur = 502941 and  hkd = 4077.9','')")

    con:query("insert into check_sql values(4532,'delete from transaction_total_check where cny = 4532 and jpy = 453200 and gbp = 3172.4 and eur = 503052 and  hkd = 4078.8','')")

    con:query("insert into check_sql values(4533,'delete from transaction_total_check where cny = 4533 and jpy = 453300 and gbp = 3173.1 and eur = 503163 and  hkd = 4079.7','')")

    con:query("insert into check_sql values(4534,'delete from transaction_total_check where cny = 4534 and jpy = 453400 and gbp = 3173.8 and eur = 503274 and  hkd = 4080.6','')")

    con:query("insert into check_sql values(4535,'delete from transaction_total_check where cny = 4535 and jpy = 453500 and gbp = 3174.5 and eur = 503385 and  hkd = 4081.5','')")

    con:query("insert into check_sql values(4536,'delete from transaction_total_check where cny = 4536 and jpy = 453600 and gbp = 3175.2 and eur = 503496 and  hkd = 4082.4','')")

    con:query("insert into check_sql values(4537,'delete from transaction_total_check where cny = 4537 and jpy = 453700 and gbp = 3175.9 and eur = 503607 and  hkd = 4083.3','')")

    con:query("insert into check_sql values(4538,'delete from transaction_total_check where cny = 4538 and jpy = 453800 and gbp = 3176.6 and eur = 503718 and  hkd = 4084.2','')")

    con:query("insert into check_sql values(4539,'delete from transaction_total_check where cny = 4539 and jpy = 453900 and gbp = 3177.3 and eur = 503829 and  hkd = 4085.1','')")

    con:query("insert into check_sql values(4540,'delete from transaction_total_check where cny = 4540 and jpy = 454000 and gbp = 3178.0 and eur = 503940 and  hkd = 4086.0','')")

    con:query("insert into check_sql values(4541,'delete from transaction_total_check where cny = 4541 and jpy = 454100 and gbp = 3178.7 and eur = 504051 and  hkd = 4086.9','')")

    con:query("insert into check_sql values(4542,'delete from transaction_total_check where cny = 4542 and jpy = 454200 and gbp = 3179.4 and eur = 504162 and  hkd = 4087.8','')")

    con:query("insert into check_sql values(4543,'delete from transaction_total_check where cny = 4543 and jpy = 454300 and gbp = 3180.1 and eur = 504273 and  hkd = 4088.7','')")

    con:query("insert into check_sql values(4544,'delete from transaction_total_check where cny = 4544 and jpy = 454400 and gbp = 3180.8 and eur = 504384 and  hkd = 4089.6','')")

    con:query("insert into check_sql values(4545,'delete from transaction_total_check where cny = 4545 and jpy = 454500 and gbp = 3181.5 and eur = 504495 and  hkd = 4090.5','')")

    con:query("insert into check_sql values(4546,'delete from transaction_total_check where cny = 4546 and jpy = 454600 and gbp = 3182.2 and eur = 504606 and  hkd = 4091.4','')")

    con:query("insert into check_sql values(4547,'delete from transaction_total_check where cny = 4547 and jpy = 454700 and gbp = 3182.9 and eur = 504717 and  hkd = 4092.3','')")

    con:query("insert into check_sql values(4548,'delete from transaction_total_check where cny = 4548 and jpy = 454800 and gbp = 3183.6 and eur = 504828 and  hkd = 4093.2','')")

    con:query("insert into check_sql values(4549,'delete from transaction_total_check where cny = 4549 and jpy = 454900 and gbp = 3184.3 and eur = 504939 and  hkd = 4094.1','')")

    con:query("insert into check_sql values(4550,'delete from transaction_total_check where cny = 4550 and jpy = 455000 and gbp = 3185.0 and eur = 505050 and  hkd = 4095.0','')")

    con:query("insert into check_sql values(4551,'delete from transaction_total_check where cny = 4551 and jpy = 455100 and gbp = 3185.7 and eur = 505161 and  hkd = 4095.9','')")

    con:query("insert into check_sql values(4552,'delete from transaction_total_check where cny = 4552 and jpy = 455200 and gbp = 3186.4 and eur = 505272 and  hkd = 4096.8','')")

    con:query("insert into check_sql values(4553,'delete from transaction_total_check where cny = 4553 and jpy = 455300 and gbp = 3187.1 and eur = 505383 and  hkd = 4097.7','')")

    con:query("insert into check_sql values(4554,'delete from transaction_total_check where cny = 4554 and jpy = 455400 and gbp = 3187.8 and eur = 505494 and  hkd = 4098.6','')")

    con:query("insert into check_sql values(4555,'delete from transaction_total_check where cny = 4555 and jpy = 455500 and gbp = 3188.5 and eur = 505605 and  hkd = 4099.5','')")

    con:query("insert into check_sql values(4556,'delete from transaction_total_check where cny = 4556 and jpy = 455600 and gbp = 3189.2 and eur = 505716 and  hkd = 4100.4','')")

    con:query("insert into check_sql values(4557,'delete from transaction_total_check where cny = 4557 and jpy = 455700 and gbp = 3189.9 and eur = 505827 and  hkd = 4101.3','')")

    con:query("insert into check_sql values(4558,'delete from transaction_total_check where cny = 4558 and jpy = 455800 and gbp = 3190.6 and eur = 505938 and  hkd = 4102.2','')")

    con:query("insert into check_sql values(4559,'delete from transaction_total_check where cny = 4559 and jpy = 455900 and gbp = 3191.3 and eur = 506049 and  hkd = 4103.1','')")

    con:query("insert into check_sql values(4560,'delete from transaction_total_check where cny = 4560 and jpy = 456000 and gbp = 3192.0 and eur = 506160 and  hkd = 4104.0','')")

    con:query("insert into check_sql values(4561,'delete from transaction_total_check where cny = 4561 and jpy = 456100 and gbp = 3192.7 and eur = 506271 and  hkd = 4104.9','')")

    con:query("insert into check_sql values(4562,'delete from transaction_total_check where cny = 4562 and jpy = 456200 and gbp = 3193.4 and eur = 506382 and  hkd = 4105.8','')")

    con:query("insert into check_sql values(4563,'delete from transaction_total_check where cny = 4563 and jpy = 456300 and gbp = 3194.1 and eur = 506493 and  hkd = 4106.7','')")

    con:query("insert into check_sql values(4564,'delete from transaction_total_check where cny = 4564 and jpy = 456400 and gbp = 3194.8 and eur = 506604 and  hkd = 4107.6','')")

    con:query("insert into check_sql values(4565,'delete from transaction_total_check where cny = 4565 and jpy = 456500 and gbp = 3195.5 and eur = 506715 and  hkd = 4108.5','')")

    con:query("insert into check_sql values(4566,'delete from transaction_total_check where cny = 4566 and jpy = 456600 and gbp = 3196.2 and eur = 506826 and  hkd = 4109.4','')")

    con:query("insert into check_sql values(4567,'delete from transaction_total_check where cny = 4567 and jpy = 456700 and gbp = 3196.9 and eur = 506937 and  hkd = 4110.3','')")

    con:query("insert into check_sql values(4568,'delete from transaction_total_check where cny = 4568 and jpy = 456800 and gbp = 3197.6 and eur = 507048 and  hkd = 4111.2','')")

    con:query("insert into check_sql values(4569,'delete from transaction_total_check where cny = 4569 and jpy = 456900 and gbp = 3198.3 and eur = 507159 and  hkd = 4112.1','')")

    con:query("insert into check_sql values(4570,'delete from transaction_total_check where cny = 4570 and jpy = 457000 and gbp = 3199.0 and eur = 507270 and  hkd = 4113.0','')")

    con:query("insert into check_sql values(4571,'delete from transaction_total_check where cny = 4571 and jpy = 457100 and gbp = 3199.7 and eur = 507381 and  hkd = 4113.9','')")

    con:query("insert into check_sql values(4572,'delete from transaction_total_check where cny = 4572 and jpy = 457200 and gbp = 3200.4 and eur = 507492 and  hkd = 4114.8','')")

    con:query("insert into check_sql values(4573,'delete from transaction_total_check where cny = 4573 and jpy = 457300 and gbp = 3201.1 and eur = 507603 and  hkd = 4115.7','')")

    con:query("insert into check_sql values(4574,'delete from transaction_total_check where cny = 4574 and jpy = 457400 and gbp = 3201.8 and eur = 507714 and  hkd = 4116.6','')")

    con:query("insert into check_sql values(4575,'delete from transaction_total_check where cny = 4575 and jpy = 457500 and gbp = 3202.5 and eur = 507825 and  hkd = 4117.5','')")

    con:query("insert into check_sql values(4576,'delete from transaction_total_check where cny = 4576 and jpy = 457600 and gbp = 3203.2 and eur = 507936 and  hkd = 4118.4','')")

    con:query("insert into check_sql values(4577,'delete from transaction_total_check where cny = 4577 and jpy = 457700 and gbp = 3203.9 and eur = 508047 and  hkd = 4119.3','')")

    con:query("insert into check_sql values(4578,'delete from transaction_total_check where cny = 4578 and jpy = 457800 and gbp = 3204.6 and eur = 508158 and  hkd = 4120.2','')")

    con:query("insert into check_sql values(4579,'delete from transaction_total_check where cny = 4579 and jpy = 457900 and gbp = 3205.3 and eur = 508269 and  hkd = 4121.1','')")

    con:query("insert into check_sql values(4580,'delete from transaction_total_check where cny = 4580 and jpy = 458000 and gbp = 3206.0 and eur = 508380 and  hkd = 4122.0','')")

    con:query("insert into check_sql values(4581,'delete from transaction_total_check where cny = 4581 and jpy = 458100 and gbp = 3206.7 and eur = 508491 and  hkd = 4122.9','')")

    con:query("insert into check_sql values(4582,'delete from transaction_total_check where cny = 4582 and jpy = 458200 and gbp = 3207.4 and eur = 508602 and  hkd = 4123.8','')")

    con:query("insert into check_sql values(4583,'delete from transaction_total_check where cny = 4583 and jpy = 458300 and gbp = 3208.1 and eur = 508713 and  hkd = 4124.7','')")

    con:query("insert into check_sql values(4584,'delete from transaction_total_check where cny = 4584 and jpy = 458400 and gbp = 3208.8 and eur = 508824 and  hkd = 4125.6','')")

    con:query("insert into check_sql values(4585,'delete from transaction_total_check where cny = 4585 and jpy = 458500 and gbp = 3209.5 and eur = 508935 and  hkd = 4126.5','')")

    con:query("insert into check_sql values(4586,'delete from transaction_total_check where cny = 4586 and jpy = 458600 and gbp = 3210.2 and eur = 509046 and  hkd = 4127.4','')")

    con:query("insert into check_sql values(4587,'delete from transaction_total_check where cny = 4587 and jpy = 458700 and gbp = 3210.9 and eur = 509157 and  hkd = 4128.3','')")

    con:query("insert into check_sql values(4588,'delete from transaction_total_check where cny = 4588 and jpy = 458800 and gbp = 3211.6 and eur = 509268 and  hkd = 4129.2','')")

    con:query("insert into check_sql values(4589,'delete from transaction_total_check where cny = 4589 and jpy = 458900 and gbp = 3212.3 and eur = 509379 and  hkd = 4130.1','')")

    con:query("insert into check_sql values(4590,'delete from transaction_total_check where cny = 4590 and jpy = 459000 and gbp = 3213.0 and eur = 509490 and  hkd = 4131.0','')")

    con:query("insert into check_sql values(4591,'delete from transaction_total_check where cny = 4591 and jpy = 459100 and gbp = 3213.7 and eur = 509601 and  hkd = 4131.9','')")

    con:query("insert into check_sql values(4592,'delete from transaction_total_check where cny = 4592 and jpy = 459200 and gbp = 3214.4 and eur = 509712 and  hkd = 4132.8','')")

    con:query("insert into check_sql values(4593,'delete from transaction_total_check where cny = 4593 and jpy = 459300 and gbp = 3215.1 and eur = 509823 and  hkd = 4133.7','')")

    con:query("insert into check_sql values(4594,'delete from transaction_total_check where cny = 4594 and jpy = 459400 and gbp = 3215.8 and eur = 509934 and  hkd = 4134.6','')")

    con:query("insert into check_sql values(4595,'delete from transaction_total_check where cny = 4595 and jpy = 459500 and gbp = 3216.5 and eur = 510045 and  hkd = 4135.5','')")

    con:query("insert into check_sql values(4596,'delete from transaction_total_check where cny = 4596 and jpy = 459600 and gbp = 3217.2 and eur = 510156 and  hkd = 4136.4','')")

    con:query("insert into check_sql values(4597,'delete from transaction_total_check where cny = 4597 and jpy = 459700 and gbp = 3217.9 and eur = 510267 and  hkd = 4137.3','')")

    con:query("insert into check_sql values(4598,'delete from transaction_total_check where cny = 4598 and jpy = 459800 and gbp = 3218.6 and eur = 510378 and  hkd = 4138.2','')")

    con:query("insert into check_sql values(4599,'delete from transaction_total_check where cny = 4599 and jpy = 459900 and gbp = 3219.3 and eur = 510489 and  hkd = 4139.1','')")

    con:query("insert into check_sql values(4600,'delete from transaction_total_check where cny = 4600 and jpy = 460000 and gbp = 3220.0 and eur = 510600 and  hkd = 4140.0','')")

    con:query("insert into check_sql values(4601,'delete from transaction_total_check where cny = 4601 and jpy = 460100 and gbp = 3220.7 and eur = 510711 and  hkd = 4140.9','')")

    con:query("insert into check_sql values(4602,'delete from transaction_total_check where cny = 4602 and jpy = 460200 and gbp = 3221.4 and eur = 510822 and  hkd = 4141.8','')")

    con:query("insert into check_sql values(4603,'delete from transaction_total_check where cny = 4603 and jpy = 460300 and gbp = 3222.1 and eur = 510933 and  hkd = 4142.7','')")

    con:query("insert into check_sql values(4604,'delete from transaction_total_check where cny = 4604 and jpy = 460400 and gbp = 3222.8 and eur = 511044 and  hkd = 4143.6','')")

    con:query("insert into check_sql values(4605,'delete from transaction_total_check where cny = 4605 and jpy = 460500 and gbp = 3223.5 and eur = 511155 and  hkd = 4144.5','')")

    con:query("insert into check_sql values(4606,'delete from transaction_total_check where cny = 4606 and jpy = 460600 and gbp = 3224.2 and eur = 511266 and  hkd = 4145.4','')")

    con:query("insert into check_sql values(4607,'delete from transaction_total_check where cny = 4607 and jpy = 460700 and gbp = 3224.9 and eur = 511377 and  hkd = 4146.3','')")

    con:query("insert into check_sql values(4608,'delete from transaction_total_check where cny = 4608 and jpy = 460800 and gbp = 3225.6 and eur = 511488 and  hkd = 4147.2','')")

    con:query("insert into check_sql values(4609,'delete from transaction_total_check where cny = 4609 and jpy = 460900 and gbp = 3226.3 and eur = 511599 and  hkd = 4148.1','')")

    con:query("insert into check_sql values(4610,'delete from transaction_total_check where cny = 4610 and jpy = 461000 and gbp = 3227.0 and eur = 511710 and  hkd = 4149.0','')")

    con:query("insert into check_sql values(4611,'delete from transaction_total_check where cny = 4611 and jpy = 461100 and gbp = 3227.7 and eur = 511821 and  hkd = 4149.9','')")

    con:query("insert into check_sql values(4612,'delete from transaction_total_check where cny = 4612 and jpy = 461200 and gbp = 3228.4 and eur = 511932 and  hkd = 4150.8','')")

    con:query("insert into check_sql values(4613,'delete from transaction_total_check where cny = 4613 and jpy = 461300 and gbp = 3229.1 and eur = 512043 and  hkd = 4151.7','')")

    con:query("insert into check_sql values(4614,'delete from transaction_total_check where cny = 4614 and jpy = 461400 and gbp = 3229.8 and eur = 512154 and  hkd = 4152.6','')")

    con:query("insert into check_sql values(4615,'delete from transaction_total_check where cny = 4615 and jpy = 461500 and gbp = 3230.5 and eur = 512265 and  hkd = 4153.5','')")

    con:query("insert into check_sql values(4616,'delete from transaction_total_check where cny = 4616 and jpy = 461600 and gbp = 3231.2 and eur = 512376 and  hkd = 4154.4','')")

    con:query("insert into check_sql values(4617,'delete from transaction_total_check where cny = 4617 and jpy = 461700 and gbp = 3231.9 and eur = 512487 and  hkd = 4155.3','')")

    con:query("insert into check_sql values(4618,'delete from transaction_total_check where cny = 4618 and jpy = 461800 and gbp = 3232.6 and eur = 512598 and  hkd = 4156.2','')")

    con:query("insert into check_sql values(4619,'delete from transaction_total_check where cny = 4619 and jpy = 461900 and gbp = 3233.3 and eur = 512709 and  hkd = 4157.1','')")

    con:query("insert into check_sql values(4620,'delete from transaction_total_check where cny = 4620 and jpy = 462000 and gbp = 3234.0 and eur = 512820 and  hkd = 4158.0','')")

    con:query("insert into check_sql values(4621,'delete from transaction_total_check where cny = 4621 and jpy = 462100 and gbp = 3234.7 and eur = 512931 and  hkd = 4158.9','')")

    con:query("insert into check_sql values(4622,'delete from transaction_total_check where cny = 4622 and jpy = 462200 and gbp = 3235.4 and eur = 513042 and  hkd = 4159.8','')")

    con:query("insert into check_sql values(4623,'delete from transaction_total_check where cny = 4623 and jpy = 462300 and gbp = 3236.1 and eur = 513153 and  hkd = 4160.7','')")

    con:query("insert into check_sql values(4624,'delete from transaction_total_check where cny = 4624 and jpy = 462400 and gbp = 3236.8 and eur = 513264 and  hkd = 4161.6','')")

    con:query("insert into check_sql values(4625,'delete from transaction_total_check where cny = 4625 and jpy = 462500 and gbp = 3237.5 and eur = 513375 and  hkd = 4162.5','')")

    con:query("insert into check_sql values(4626,'delete from transaction_total_check where cny = 4626 and jpy = 462600 and gbp = 3238.2 and eur = 513486 and  hkd = 4163.4','')")

    con:query("insert into check_sql values(4627,'delete from transaction_total_check where cny = 4627 and jpy = 462700 and gbp = 3238.9 and eur = 513597 and  hkd = 4164.3','')")

    con:query("insert into check_sql values(4628,'delete from transaction_total_check where cny = 4628 and jpy = 462800 and gbp = 3239.6 and eur = 513708 and  hkd = 4165.2','')")

    con:query("insert into check_sql values(4629,'delete from transaction_total_check where cny = 4629 and jpy = 462900 and gbp = 3240.3 and eur = 513819 and  hkd = 4166.1','')")

    con:query("insert into check_sql values(4630,'delete from transaction_total_check where cny = 4630 and jpy = 463000 and gbp = 3241.0 and eur = 513930 and  hkd = 4167.0','')")

    con:query("insert into check_sql values(4631,'delete from transaction_total_check where cny = 4631 and jpy = 463100 and gbp = 3241.7 and eur = 514041 and  hkd = 4167.9','')")

    con:query("insert into check_sql values(4632,'delete from transaction_total_check where cny = 4632 and jpy = 463200 and gbp = 3242.4 and eur = 514152 and  hkd = 4168.8','')")

    con:query("insert into check_sql values(4633,'delete from transaction_total_check where cny = 4633 and jpy = 463300 and gbp = 3243.1 and eur = 514263 and  hkd = 4169.7','')")

    con:query("insert into check_sql values(4634,'delete from transaction_total_check where cny = 4634 and jpy = 463400 and gbp = 3243.8 and eur = 514374 and  hkd = 4170.6','')")

    con:query("insert into check_sql values(4635,'delete from transaction_total_check where cny = 4635 and jpy = 463500 and gbp = 3244.5 and eur = 514485 and  hkd = 4171.5','')")

    con:query("insert into check_sql values(4636,'delete from transaction_total_check where cny = 4636 and jpy = 463600 and gbp = 3245.2 and eur = 514596 and  hkd = 4172.4','')")

    con:query("insert into check_sql values(4637,'delete from transaction_total_check where cny = 4637 and jpy = 463700 and gbp = 3245.9 and eur = 514707 and  hkd = 4173.3','')")

    con:query("insert into check_sql values(4638,'delete from transaction_total_check where cny = 4638 and jpy = 463800 and gbp = 3246.6 and eur = 514818 and  hkd = 4174.2','')")

    con:query("insert into check_sql values(4639,'delete from transaction_total_check where cny = 4639 and jpy = 463900 and gbp = 3247.3 and eur = 514929 and  hkd = 4175.1','')")

    con:query("insert into check_sql values(4640,'delete from transaction_total_check where cny = 4640 and jpy = 464000 and gbp = 3248.0 and eur = 515040 and  hkd = 4176.0','')")

    con:query("insert into check_sql values(4641,'delete from transaction_total_check where cny = 4641 and jpy = 464100 and gbp = 3248.7 and eur = 515151 and  hkd = 4176.9','')")

    con:query("insert into check_sql values(4642,'delete from transaction_total_check where cny = 4642 and jpy = 464200 and gbp = 3249.4 and eur = 515262 and  hkd = 4177.8','')")

    con:query("insert into check_sql values(4643,'delete from transaction_total_check where cny = 4643 and jpy = 464300 and gbp = 3250.1 and eur = 515373 and  hkd = 4178.7','')")

    con:query("insert into check_sql values(4644,'delete from transaction_total_check where cny = 4644 and jpy = 464400 and gbp = 3250.8 and eur = 515484 and  hkd = 4179.6','')")

    con:query("insert into check_sql values(4645,'delete from transaction_total_check where cny = 4645 and jpy = 464500 and gbp = 3251.5 and eur = 515595 and  hkd = 4180.5','')")

    con:query("insert into check_sql values(4646,'delete from transaction_total_check where cny = 4646 and jpy = 464600 and gbp = 3252.2 and eur = 515706 and  hkd = 4181.4','')")

    con:query("insert into check_sql values(4647,'delete from transaction_total_check where cny = 4647 and jpy = 464700 and gbp = 3252.9 and eur = 515817 and  hkd = 4182.3','')")

    con:query("insert into check_sql values(4648,'delete from transaction_total_check where cny = 4648 and jpy = 464800 and gbp = 3253.6 and eur = 515928 and  hkd = 4183.2','')")

    con:query("insert into check_sql values(4649,'delete from transaction_total_check where cny = 4649 and jpy = 464900 and gbp = 3254.3 and eur = 516039 and  hkd = 4184.1','')")

    con:query("insert into check_sql values(4650,'delete from transaction_total_check where cny = 4650 and jpy = 465000 and gbp = 3255.0 and eur = 516150 and  hkd = 4185.0','')")

    con:query("insert into check_sql values(4651,'delete from transaction_total_check where cny = 4651 and jpy = 465100 and gbp = 3255.7 and eur = 516261 and  hkd = 4185.9','')")

    con:query("insert into check_sql values(4652,'delete from transaction_total_check where cny = 4652 and jpy = 465200 and gbp = 3256.4 and eur = 516372 and  hkd = 4186.8','')")

    con:query("insert into check_sql values(4653,'delete from transaction_total_check where cny = 4653 and jpy = 465300 and gbp = 3257.1 and eur = 516483 and  hkd = 4187.7','')")

    con:query("insert into check_sql values(4654,'delete from transaction_total_check where cny = 4654 and jpy = 465400 and gbp = 3257.8 and eur = 516594 and  hkd = 4188.6','')")

    con:query("insert into check_sql values(4655,'delete from transaction_total_check where cny = 4655 and jpy = 465500 and gbp = 3258.5 and eur = 516705 and  hkd = 4189.5','')")

    con:query("insert into check_sql values(4656,'delete from transaction_total_check where cny = 4656 and jpy = 465600 and gbp = 3259.2 and eur = 516816 and  hkd = 4190.4','')")

    con:query("insert into check_sql values(4657,'delete from transaction_total_check where cny = 4657 and jpy = 465700 and gbp = 3259.9 and eur = 516927 and  hkd = 4191.3','')")

    con:query("insert into check_sql values(4658,'delete from transaction_total_check where cny = 4658 and jpy = 465800 and gbp = 3260.6 and eur = 517038 and  hkd = 4192.2','')")

    con:query("insert into check_sql values(4659,'delete from transaction_total_check where cny = 4659 and jpy = 465900 and gbp = 3261.3 and eur = 517149 and  hkd = 4193.1','')")

    con:query("insert into check_sql values(4660,'delete from transaction_total_check where cny = 4660 and jpy = 466000 and gbp = 3262.0 and eur = 517260 and  hkd = 4194.0','')")

    con:query("insert into check_sql values(4661,'delete from transaction_total_check where cny = 4661 and jpy = 466100 and gbp = 3262.7 and eur = 517371 and  hkd = 4194.9','')")

    con:query("insert into check_sql values(4662,'delete from transaction_total_check where cny = 4662 and jpy = 466200 and gbp = 3263.4 and eur = 517482 and  hkd = 4195.8','')")

    con:query("insert into check_sql values(4663,'delete from transaction_total_check where cny = 4663 and jpy = 466300 and gbp = 3264.1 and eur = 517593 and  hkd = 4196.7','')")

    con:query("insert into check_sql values(4664,'delete from transaction_total_check where cny = 4664 and jpy = 466400 and gbp = 3264.8 and eur = 517704 and  hkd = 4197.6','')")

    con:query("insert into check_sql values(4665,'delete from transaction_total_check where cny = 4665 and jpy = 466500 and gbp = 3265.5 and eur = 517815 and  hkd = 4198.5','')")

    con:query("insert into check_sql values(4666,'delete from transaction_total_check where cny = 4666 and jpy = 466600 and gbp = 3266.2 and eur = 517926 and  hkd = 4199.4','')")

    con:query("insert into check_sql values(4667,'delete from transaction_total_check where cny = 4667 and jpy = 466700 and gbp = 3266.9 and eur = 518037 and  hkd = 4200.3','')")

    con:query("insert into check_sql values(4668,'delete from transaction_total_check where cny = 4668 and jpy = 466800 and gbp = 3267.6 and eur = 518148 and  hkd = 4201.2','')")

    con:query("insert into check_sql values(4669,'delete from transaction_total_check where cny = 4669 and jpy = 466900 and gbp = 3268.3 and eur = 518259 and  hkd = 4202.1','')")

    con:query("insert into check_sql values(4670,'delete from transaction_total_check where cny = 4670 and jpy = 467000 and gbp = 3269.0 and eur = 518370 and  hkd = 4203.0','')")

    con:query("insert into check_sql values(4671,'delete from transaction_total_check where cny = 4671 and jpy = 467100 and gbp = 3269.7 and eur = 518481 and  hkd = 4203.9','')")

    con:query("insert into check_sql values(4672,'delete from transaction_total_check where cny = 4672 and jpy = 467200 and gbp = 3270.4 and eur = 518592 and  hkd = 4204.8','')")

    con:query("insert into check_sql values(4673,'delete from transaction_total_check where cny = 4673 and jpy = 467300 and gbp = 3271.1 and eur = 518703 and  hkd = 4205.7','')")

    con:query("insert into check_sql values(4674,'delete from transaction_total_check where cny = 4674 and jpy = 467400 and gbp = 3271.8 and eur = 518814 and  hkd = 4206.6','')")

    con:query("insert into check_sql values(4675,'delete from transaction_total_check where cny = 4675 and jpy = 467500 and gbp = 3272.5 and eur = 518925 and  hkd = 4207.5','')")

    con:query("insert into check_sql values(4676,'delete from transaction_total_check where cny = 4676 and jpy = 467600 and gbp = 3273.2 and eur = 519036 and  hkd = 4208.4','')")

    con:query("insert into check_sql values(4677,'delete from transaction_total_check where cny = 4677 and jpy = 467700 and gbp = 3273.9 and eur = 519147 and  hkd = 4209.3','')")

    con:query("insert into check_sql values(4678,'delete from transaction_total_check where cny = 4678 and jpy = 467800 and gbp = 3274.6 and eur = 519258 and  hkd = 4210.2','')")

    con:query("insert into check_sql values(4679,'delete from transaction_total_check where cny = 4679 and jpy = 467900 and gbp = 3275.3 and eur = 519369 and  hkd = 4211.1','')")

    con:query("insert into check_sql values(4680,'delete from transaction_total_check where cny = 4680 and jpy = 468000 and gbp = 3276.0 and eur = 519480 and  hkd = 4212.0','')")

    con:query("insert into check_sql values(4681,'delete from transaction_total_check where cny = 4681 and jpy = 468100 and gbp = 3276.7 and eur = 519591 and  hkd = 4212.9','')")

    con:query("insert into check_sql values(4682,'delete from transaction_total_check where cny = 4682 and jpy = 468200 and gbp = 3277.4 and eur = 519702 and  hkd = 4213.8','')")

    con:query("insert into check_sql values(4683,'delete from transaction_total_check where cny = 4683 and jpy = 468300 and gbp = 3278.1 and eur = 519813 and  hkd = 4214.7','')")

    con:query("insert into check_sql values(4684,'delete from transaction_total_check where cny = 4684 and jpy = 468400 and gbp = 3278.8 and eur = 519924 and  hkd = 4215.6','')")

    con:query("insert into check_sql values(4685,'delete from transaction_total_check where cny = 4685 and jpy = 468500 and gbp = 3279.5 and eur = 520035 and  hkd = 4216.5','')")

    con:query("insert into check_sql values(4686,'delete from transaction_total_check where cny = 4686 and jpy = 468600 and gbp = 3280.2 and eur = 520146 and  hkd = 4217.4','')")

    con:query("insert into check_sql values(4687,'delete from transaction_total_check where cny = 4687 and jpy = 468700 and gbp = 3280.9 and eur = 520257 and  hkd = 4218.3','')")

    con:query("insert into check_sql values(4688,'delete from transaction_total_check where cny = 4688 and jpy = 468800 and gbp = 3281.6 and eur = 520368 and  hkd = 4219.2','')")

    con:query("insert into check_sql values(4689,'delete from transaction_total_check where cny = 4689 and jpy = 468900 and gbp = 3282.3 and eur = 520479 and  hkd = 4220.1','')")

    con:query("insert into check_sql values(4690,'delete from transaction_total_check where cny = 4690 and jpy = 469000 and gbp = 3283.0 and eur = 520590 and  hkd = 4221.0','')")

    con:query("insert into check_sql values(4691,'delete from transaction_total_check where cny = 4691 and jpy = 469100 and gbp = 3283.7 and eur = 520701 and  hkd = 4221.9','')")

    con:query("insert into check_sql values(4692,'delete from transaction_total_check where cny = 4692 and jpy = 469200 and gbp = 3284.4 and eur = 520812 and  hkd = 4222.8','')")

    con:query("insert into check_sql values(4693,'delete from transaction_total_check where cny = 4693 and jpy = 469300 and gbp = 3285.1 and eur = 520923 and  hkd = 4223.7','')")

    con:query("insert into check_sql values(4694,'delete from transaction_total_check where cny = 4694 and jpy = 469400 and gbp = 3285.8 and eur = 521034 and  hkd = 4224.6','')")

    con:query("insert into check_sql values(4695,'delete from transaction_total_check where cny = 4695 and jpy = 469500 and gbp = 3286.5 and eur = 521145 and  hkd = 4225.5','')")

    con:query("insert into check_sql values(4696,'delete from transaction_total_check where cny = 4696 and jpy = 469600 and gbp = 3287.2 and eur = 521256 and  hkd = 4226.4','')")

    con:query("insert into check_sql values(4697,'delete from transaction_total_check where cny = 4697 and jpy = 469700 and gbp = 3287.9 and eur = 521367 and  hkd = 4227.3','')")

    con:query("insert into check_sql values(4698,'delete from transaction_total_check where cny = 4698 and jpy = 469800 and gbp = 3288.6 and eur = 521478 and  hkd = 4228.2','')")

    con:query("insert into check_sql values(4699,'delete from transaction_total_check where cny = 4699 and jpy = 469900 and gbp = 3289.3 and eur = 521589 and  hkd = 4229.1','')")

    con:query("insert into check_sql values(4700,'delete from transaction_total_check where cny = 4700 and jpy = 470000 and gbp = 3290.0 and eur = 521700 and  hkd = 4230.0','')")

    con:query("insert into check_sql values(4701,'delete from transaction_total_check where cny = 4701 and jpy = 470100 and gbp = 3290.7 and eur = 521811 and  hkd = 4230.9','')")

    con:query("insert into check_sql values(4702,'delete from transaction_total_check where cny = 4702 and jpy = 470200 and gbp = 3291.4 and eur = 521922 and  hkd = 4231.8','')")

    con:query("insert into check_sql values(4703,'delete from transaction_total_check where cny = 4703 and jpy = 470300 and gbp = 3292.1 and eur = 522033 and  hkd = 4232.7','')")

    con:query("insert into check_sql values(4704,'delete from transaction_total_check where cny = 4704 and jpy = 470400 and gbp = 3292.8 and eur = 522144 and  hkd = 4233.6','')")

    con:query("insert into check_sql values(4705,'delete from transaction_total_check where cny = 4705 and jpy = 470500 and gbp = 3293.5 and eur = 522255 and  hkd = 4234.5','')")

    con:query("insert into check_sql values(4706,'delete from transaction_total_check where cny = 4706 and jpy = 470600 and gbp = 3294.2 and eur = 522366 and  hkd = 4235.4','')")

    con:query("insert into check_sql values(4707,'delete from transaction_total_check where cny = 4707 and jpy = 470700 and gbp = 3294.9 and eur = 522477 and  hkd = 4236.3','')")

    con:query("insert into check_sql values(4708,'delete from transaction_total_check where cny = 4708 and jpy = 470800 and gbp = 3295.6 and eur = 522588 and  hkd = 4237.2','')")

    con:query("insert into check_sql values(4709,'delete from transaction_total_check where cny = 4709 and jpy = 470900 and gbp = 3296.3 and eur = 522699 and  hkd = 4238.1','')")

    con:query("insert into check_sql values(4710,'delete from transaction_total_check where cny = 4710 and jpy = 471000 and gbp = 3297.0 and eur = 522810 and  hkd = 4239.0','')")

    con:query("insert into check_sql values(4711,'delete from transaction_total_check where cny = 4711 and jpy = 471100 and gbp = 3297.7 and eur = 522921 and  hkd = 4239.9','')")

    con:query("insert into check_sql values(4712,'delete from transaction_total_check where cny = 4712 and jpy = 471200 and gbp = 3298.4 and eur = 523032 and  hkd = 4240.8','')")

    con:query("insert into check_sql values(4713,'delete from transaction_total_check where cny = 4713 and jpy = 471300 and gbp = 3299.1 and eur = 523143 and  hkd = 4241.7','')")

    con:query("insert into check_sql values(4714,'delete from transaction_total_check where cny = 4714 and jpy = 471400 and gbp = 3299.8 and eur = 523254 and  hkd = 4242.6','')")

    con:query("insert into check_sql values(4715,'delete from transaction_total_check where cny = 4715 and jpy = 471500 and gbp = 3300.5 and eur = 523365 and  hkd = 4243.5','')")

    con:query("insert into check_sql values(4716,'delete from transaction_total_check where cny = 4716 and jpy = 471600 and gbp = 3301.2 and eur = 523476 and  hkd = 4244.4','')")

    con:query("insert into check_sql values(4717,'delete from transaction_total_check where cny = 4717 and jpy = 471700 and gbp = 3301.9 and eur = 523587 and  hkd = 4245.3','')")

    con:query("insert into check_sql values(4718,'delete from transaction_total_check where cny = 4718 and jpy = 471800 and gbp = 3302.6 and eur = 523698 and  hkd = 4246.2','')")

    con:query("insert into check_sql values(4719,'delete from transaction_total_check where cny = 4719 and jpy = 471900 and gbp = 3303.3 and eur = 523809 and  hkd = 4247.1','')")

    con:query("insert into check_sql values(4720,'delete from transaction_total_check where cny = 4720 and jpy = 472000 and gbp = 3304.0 and eur = 523920 and  hkd = 4248.0','')")

    con:query("insert into check_sql values(4721,'delete from transaction_total_check where cny = 4721 and jpy = 472100 and gbp = 3304.7 and eur = 524031 and  hkd = 4248.9','')")

    con:query("insert into check_sql values(4722,'delete from transaction_total_check where cny = 4722 and jpy = 472200 and gbp = 3305.4 and eur = 524142 and  hkd = 4249.8','')")

    con:query("insert into check_sql values(4723,'delete from transaction_total_check where cny = 4723 and jpy = 472300 and gbp = 3306.1 and eur = 524253 and  hkd = 4250.7','')")

    con:query("insert into check_sql values(4724,'delete from transaction_total_check where cny = 4724 and jpy = 472400 and gbp = 3306.8 and eur = 524364 and  hkd = 4251.6','')")

    con:query("insert into check_sql values(4725,'delete from transaction_total_check where cny = 4725 and jpy = 472500 and gbp = 3307.5 and eur = 524475 and  hkd = 4252.5','')")

    con:query("insert into check_sql values(4726,'delete from transaction_total_check where cny = 4726 and jpy = 472600 and gbp = 3308.2 and eur = 524586 and  hkd = 4253.4','')")

    con:query("insert into check_sql values(4727,'delete from transaction_total_check where cny = 4727 and jpy = 472700 and gbp = 3308.9 and eur = 524697 and  hkd = 4254.3','')")

    con:query("insert into check_sql values(4728,'delete from transaction_total_check where cny = 4728 and jpy = 472800 and gbp = 3309.6 and eur = 524808 and  hkd = 4255.2','')")

    con:query("insert into check_sql values(4729,'delete from transaction_total_check where cny = 4729 and jpy = 472900 and gbp = 3310.3 and eur = 524919 and  hkd = 4256.1','')")

    con:query("insert into check_sql values(4730,'delete from transaction_total_check where cny = 4730 and jpy = 473000 and gbp = 3311.0 and eur = 525030 and  hkd = 4257.0','')")

    con:query("insert into check_sql values(4731,'delete from transaction_total_check where cny = 4731 and jpy = 473100 and gbp = 3311.7 and eur = 525141 and  hkd = 4257.9','')")

    con:query("insert into check_sql values(4732,'delete from transaction_total_check where cny = 4732 and jpy = 473200 and gbp = 3312.4 and eur = 525252 and  hkd = 4258.8','')")

    con:query("insert into check_sql values(4733,'delete from transaction_total_check where cny = 4733 and jpy = 473300 and gbp = 3313.1 and eur = 525363 and  hkd = 4259.7','')")

    con:query("insert into check_sql values(4734,'delete from transaction_total_check where cny = 4734 and jpy = 473400 and gbp = 3313.8 and eur = 525474 and  hkd = 4260.6','')")

    con:query("insert into check_sql values(4735,'delete from transaction_total_check where cny = 4735 and jpy = 473500 and gbp = 3314.5 and eur = 525585 and  hkd = 4261.5','')")

    con:query("insert into check_sql values(4736,'delete from transaction_total_check where cny = 4736 and jpy = 473600 and gbp = 3315.2 and eur = 525696 and  hkd = 4262.4','')")

    con:query("insert into check_sql values(4737,'delete from transaction_total_check where cny = 4737 and jpy = 473700 and gbp = 3315.9 and eur = 525807 and  hkd = 4263.3','')")

    con:query("insert into check_sql values(4738,'delete from transaction_total_check where cny = 4738 and jpy = 473800 and gbp = 3316.6 and eur = 525918 and  hkd = 4264.2','')")

    con:query("insert into check_sql values(4739,'delete from transaction_total_check where cny = 4739 and jpy = 473900 and gbp = 3317.3 and eur = 526029 and  hkd = 4265.1','')")

    con:query("insert into check_sql values(4740,'delete from transaction_total_check where cny = 4740 and jpy = 474000 and gbp = 3318.0 and eur = 526140 and  hkd = 4266.0','')")

    con:query("insert into check_sql values(4741,'delete from transaction_total_check where cny = 4741 and jpy = 474100 and gbp = 3318.7 and eur = 526251 and  hkd = 4266.9','')")

    con:query("insert into check_sql values(4742,'delete from transaction_total_check where cny = 4742 and jpy = 474200 and gbp = 3319.4 and eur = 526362 and  hkd = 4267.8','')")

    con:query("insert into check_sql values(4743,'delete from transaction_total_check where cny = 4743 and jpy = 474300 and gbp = 3320.1 and eur = 526473 and  hkd = 4268.7','')")

    con:query("insert into check_sql values(4744,'delete from transaction_total_check where cny = 4744 and jpy = 474400 and gbp = 3320.8 and eur = 526584 and  hkd = 4269.6','')")

    con:query("insert into check_sql values(4745,'delete from transaction_total_check where cny = 4745 and jpy = 474500 and gbp = 3321.5 and eur = 526695 and  hkd = 4270.5','')")

    con:query("insert into check_sql values(4746,'delete from transaction_total_check where cny = 4746 and jpy = 474600 and gbp = 3322.2 and eur = 526806 and  hkd = 4271.4','')")

    con:query("insert into check_sql values(4747,'delete from transaction_total_check where cny = 4747 and jpy = 474700 and gbp = 3322.9 and eur = 526917 and  hkd = 4272.3','')")

    con:query("insert into check_sql values(4748,'delete from transaction_total_check where cny = 4748 and jpy = 474800 and gbp = 3323.6 and eur = 527028 and  hkd = 4273.2','')")

    con:query("insert into check_sql values(4749,'delete from transaction_total_check where cny = 4749 and jpy = 474900 and gbp = 3324.3 and eur = 527139 and  hkd = 4274.1','')")

    con:query("insert into check_sql values(4750,'delete from transaction_total_check where cny = 4750 and jpy = 475000 and gbp = 3325.0 and eur = 527250 and  hkd = 4275.0','')")

    con:query("insert into check_sql values(4751,'delete from transaction_total_check where cny = 4751 and jpy = 475100 and gbp = 3325.7 and eur = 527361 and  hkd = 4275.9','')")

    con:query("insert into check_sql values(4752,'delete from transaction_total_check where cny = 4752 and jpy = 475200 and gbp = 3326.4 and eur = 527472 and  hkd = 4276.8','')")

    con:query("insert into check_sql values(4753,'delete from transaction_total_check where cny = 4753 and jpy = 475300 and gbp = 3327.1 and eur = 527583 and  hkd = 4277.7','')")

    con:query("insert into check_sql values(4754,'delete from transaction_total_check where cny = 4754 and jpy = 475400 and gbp = 3327.8 and eur = 527694 and  hkd = 4278.6','')")

    con:query("insert into check_sql values(4755,'delete from transaction_total_check where cny = 4755 and jpy = 475500 and gbp = 3328.5 and eur = 527805 and  hkd = 4279.5','')")

    con:query("insert into check_sql values(4756,'delete from transaction_total_check where cny = 4756 and jpy = 475600 and gbp = 3329.2 and eur = 527916 and  hkd = 4280.4','')")

    con:query("insert into check_sql values(4757,'delete from transaction_total_check where cny = 4757 and jpy = 475700 and gbp = 3329.9 and eur = 528027 and  hkd = 4281.3','')")

    con:query("insert into check_sql values(4758,'delete from transaction_total_check where cny = 4758 and jpy = 475800 and gbp = 3330.6 and eur = 528138 and  hkd = 4282.2','')")

    con:query("insert into check_sql values(4759,'delete from transaction_total_check where cny = 4759 and jpy = 475900 and gbp = 3331.3 and eur = 528249 and  hkd = 4283.1','')")

    con:query("insert into check_sql values(4760,'delete from transaction_total_check where cny = 4760 and jpy = 476000 and gbp = 3332.0 and eur = 528360 and  hkd = 4284.0','')")

    con:query("insert into check_sql values(4761,'delete from transaction_total_check where cny = 4761 and jpy = 476100 and gbp = 3332.7 and eur = 528471 and  hkd = 4284.9','')")

    con:query("insert into check_sql values(4762,'delete from transaction_total_check where cny = 4762 and jpy = 476200 and gbp = 3333.4 and eur = 528582 and  hkd = 4285.8','')")

    con:query("insert into check_sql values(4763,'delete from transaction_total_check where cny = 4763 and jpy = 476300 and gbp = 3334.1 and eur = 528693 and  hkd = 4286.7','')")

    con:query("insert into check_sql values(4764,'delete from transaction_total_check where cny = 4764 and jpy = 476400 and gbp = 3334.8 and eur = 528804 and  hkd = 4287.6','')")

    con:query("insert into check_sql values(4765,'delete from transaction_total_check where cny = 4765 and jpy = 476500 and gbp = 3335.5 and eur = 528915 and  hkd = 4288.5','')")

    con:query("insert into check_sql values(4766,'delete from transaction_total_check where cny = 4766 and jpy = 476600 and gbp = 3336.2 and eur = 529026 and  hkd = 4289.4','')")

    con:query("insert into check_sql values(4767,'delete from transaction_total_check where cny = 4767 and jpy = 476700 and gbp = 3336.9 and eur = 529137 and  hkd = 4290.3','')")

    con:query("insert into check_sql values(4768,'delete from transaction_total_check where cny = 4768 and jpy = 476800 and gbp = 3337.6 and eur = 529248 and  hkd = 4291.2','')")

    con:query("insert into check_sql values(4769,'delete from transaction_total_check where cny = 4769 and jpy = 476900 and gbp = 3338.3 and eur = 529359 and  hkd = 4292.1','')")

    con:query("insert into check_sql values(4770,'delete from transaction_total_check where cny = 4770 and jpy = 477000 and gbp = 3339.0 and eur = 529470 and  hkd = 4293.0','')")

    con:query("insert into check_sql values(4771,'delete from transaction_total_check where cny = 4771 and jpy = 477100 and gbp = 3339.7 and eur = 529581 and  hkd = 4293.9','')")

    con:query("insert into check_sql values(4772,'delete from transaction_total_check where cny = 4772 and jpy = 477200 and gbp = 3340.4 and eur = 529692 and  hkd = 4294.8','')")

    con:query("insert into check_sql values(4773,'delete from transaction_total_check where cny = 4773 and jpy = 477300 and gbp = 3341.1 and eur = 529803 and  hkd = 4295.7','')")

    con:query("insert into check_sql values(4774,'delete from transaction_total_check where cny = 4774 and jpy = 477400 and gbp = 3341.8 and eur = 529914 and  hkd = 4296.6','')")

    con:query("insert into check_sql values(4775,'delete from transaction_total_check where cny = 4775 and jpy = 477500 and gbp = 3342.5 and eur = 530025 and  hkd = 4297.5','')")

    con:query("insert into check_sql values(4776,'delete from transaction_total_check where cny = 4776 and jpy = 477600 and gbp = 3343.2 and eur = 530136 and  hkd = 4298.4','')")

    con:query("insert into check_sql values(4777,'delete from transaction_total_check where cny = 4777 and jpy = 477700 and gbp = 3343.9 and eur = 530247 and  hkd = 4299.3','')")

    con:query("insert into check_sql values(4778,'delete from transaction_total_check where cny = 4778 and jpy = 477800 and gbp = 3344.6 and eur = 530358 and  hkd = 4300.2','')")

    con:query("insert into check_sql values(4779,'delete from transaction_total_check where cny = 4779 and jpy = 477900 and gbp = 3345.3 and eur = 530469 and  hkd = 4301.1','')")

    con:query("insert into check_sql values(4780,'delete from transaction_total_check where cny = 4780 and jpy = 478000 and gbp = 3346.0 and eur = 530580 and  hkd = 4302.0','')")

    con:query("insert into check_sql values(4781,'delete from transaction_total_check where cny = 4781 and jpy = 478100 and gbp = 3346.7 and eur = 530691 and  hkd = 4302.9','')")

    con:query("insert into check_sql values(4782,'delete from transaction_total_check where cny = 4782 and jpy = 478200 and gbp = 3347.4 and eur = 530802 and  hkd = 4303.8','')")

    con:query("insert into check_sql values(4783,'delete from transaction_total_check where cny = 4783 and jpy = 478300 and gbp = 3348.1 and eur = 530913 and  hkd = 4304.7','')")

    con:query("insert into check_sql values(4784,'delete from transaction_total_check where cny = 4784 and jpy = 478400 and gbp = 3348.8 and eur = 531024 and  hkd = 4305.6','')")

    con:query("insert into check_sql values(4785,'delete from transaction_total_check where cny = 4785 and jpy = 478500 and gbp = 3349.5 and eur = 531135 and  hkd = 4306.5','')")

    con:query("insert into check_sql values(4786,'delete from transaction_total_check where cny = 4786 and jpy = 478600 and gbp = 3350.2 and eur = 531246 and  hkd = 4307.4','')")

    con:query("insert into check_sql values(4787,'delete from transaction_total_check where cny = 4787 and jpy = 478700 and gbp = 3350.9 and eur = 531357 and  hkd = 4308.3','')")

    con:query("insert into check_sql values(4788,'delete from transaction_total_check where cny = 4788 and jpy = 478800 and gbp = 3351.6 and eur = 531468 and  hkd = 4309.2','')")

    con:query("insert into check_sql values(4789,'delete from transaction_total_check where cny = 4789 and jpy = 478900 and gbp = 3352.3 and eur = 531579 and  hkd = 4310.1','')")

    con:query("insert into check_sql values(4790,'delete from transaction_total_check where cny = 4790 and jpy = 479000 and gbp = 3353.0 and eur = 531690 and  hkd = 4311.0','')")

    con:query("insert into check_sql values(4791,'delete from transaction_total_check where cny = 4791 and jpy = 479100 and gbp = 3353.7 and eur = 531801 and  hkd = 4311.9','')")

    con:query("insert into check_sql values(4792,'delete from transaction_total_check where cny = 4792 and jpy = 479200 and gbp = 3354.4 and eur = 531912 and  hkd = 4312.8','')")

    con:query("insert into check_sql values(4793,'delete from transaction_total_check where cny = 4793 and jpy = 479300 and gbp = 3355.1 and eur = 532023 and  hkd = 4313.7','')")

    con:query("insert into check_sql values(4794,'delete from transaction_total_check where cny = 4794 and jpy = 479400 and gbp = 3355.8 and eur = 532134 and  hkd = 4314.6','')")

    con:query("insert into check_sql values(4795,'delete from transaction_total_check where cny = 4795 and jpy = 479500 and gbp = 3356.5 and eur = 532245 and  hkd = 4315.5','')")

    con:query("insert into check_sql values(4796,'delete from transaction_total_check where cny = 4796 and jpy = 479600 and gbp = 3357.2 and eur = 532356 and  hkd = 4316.4','')")

    con:query("insert into check_sql values(4797,'delete from transaction_total_check where cny = 4797 and jpy = 479700 and gbp = 3357.9 and eur = 532467 and  hkd = 4317.3','')")

    con:query("insert into check_sql values(4798,'delete from transaction_total_check where cny = 4798 and jpy = 479800 and gbp = 3358.6 and eur = 532578 and  hkd = 4318.2','')")

    con:query("insert into check_sql values(4799,'delete from transaction_total_check where cny = 4799 and jpy = 479900 and gbp = 3359.3 and eur = 532689 and  hkd = 4319.1','')")

    con:query("insert into check_sql values(4800,'delete from transaction_total_check where cny = 4800 and jpy = 480000 and gbp = 3360.0 and eur = 532800 and  hkd = 4320.0','')")

    con:query("insert into check_sql values(4801,'delete from transaction_total_check where cny = 4801 and jpy = 480100 and gbp = 3360.7 and eur = 532911 and  hkd = 4320.9','')")

    con:query("insert into check_sql values(4802,'delete from transaction_total_check where cny = 4802 and jpy = 480200 and gbp = 3361.4 and eur = 533022 and  hkd = 4321.8','')")

    con:query("insert into check_sql values(4803,'delete from transaction_total_check where cny = 4803 and jpy = 480300 and gbp = 3362.1 and eur = 533133 and  hkd = 4322.7','')")

    con:query("insert into check_sql values(4804,'delete from transaction_total_check where cny = 4804 and jpy = 480400 and gbp = 3362.8 and eur = 533244 and  hkd = 4323.6','')")

    con:query("insert into check_sql values(4805,'delete from transaction_total_check where cny = 4805 and jpy = 480500 and gbp = 3363.5 and eur = 533355 and  hkd = 4324.5','')")

    con:query("insert into check_sql values(4806,'delete from transaction_total_check where cny = 4806 and jpy = 480600 and gbp = 3364.2 and eur = 533466 and  hkd = 4325.4','')")

    con:query("insert into check_sql values(4807,'delete from transaction_total_check where cny = 4807 and jpy = 480700 and gbp = 3364.9 and eur = 533577 and  hkd = 4326.3','')")

    con:query("insert into check_sql values(4808,'delete from transaction_total_check where cny = 4808 and jpy = 480800 and gbp = 3365.6 and eur = 533688 and  hkd = 4327.2','')")

    con:query("insert into check_sql values(4809,'delete from transaction_total_check where cny = 4809 and jpy = 480900 and gbp = 3366.3 and eur = 533799 and  hkd = 4328.1','')")

    con:query("insert into check_sql values(4810,'delete from transaction_total_check where cny = 4810 and jpy = 481000 and gbp = 3367.0 and eur = 533910 and  hkd = 4329.0','')")

    con:query("insert into check_sql values(4811,'delete from transaction_total_check where cny = 4811 and jpy = 481100 and gbp = 3367.7 and eur = 534021 and  hkd = 4329.9','')")

    con:query("insert into check_sql values(4812,'delete from transaction_total_check where cny = 4812 and jpy = 481200 and gbp = 3368.4 and eur = 534132 and  hkd = 4330.8','')")

    con:query("insert into check_sql values(4813,'delete from transaction_total_check where cny = 4813 and jpy = 481300 and gbp = 3369.1 and eur = 534243 and  hkd = 4331.7','')")

    con:query("insert into check_sql values(4814,'delete from transaction_total_check where cny = 4814 and jpy = 481400 and gbp = 3369.8 and eur = 534354 and  hkd = 4332.6','')")

    con:query("insert into check_sql values(4815,'delete from transaction_total_check where cny = 4815 and jpy = 481500 and gbp = 3370.5 and eur = 534465 and  hkd = 4333.5','')")

    con:query("insert into check_sql values(4816,'delete from transaction_total_check where cny = 4816 and jpy = 481600 and gbp = 3371.2 and eur = 534576 and  hkd = 4334.4','')")

    con:query("insert into check_sql values(4817,'delete from transaction_total_check where cny = 4817 and jpy = 481700 and gbp = 3371.9 and eur = 534687 and  hkd = 4335.3','')")

    con:query("insert into check_sql values(4818,'delete from transaction_total_check where cny = 4818 and jpy = 481800 and gbp = 3372.6 and eur = 534798 and  hkd = 4336.2','')")

    con:query("insert into check_sql values(4819,'delete from transaction_total_check where cny = 4819 and jpy = 481900 and gbp = 3373.3 and eur = 534909 and  hkd = 4337.1','')")

    con:query("insert into check_sql values(4820,'delete from transaction_total_check where cny = 4820 and jpy = 482000 and gbp = 3374.0 and eur = 535020 and  hkd = 4338.0','')")

    con:query("insert into check_sql values(4821,'delete from transaction_total_check where cny = 4821 and jpy = 482100 and gbp = 3374.7 and eur = 535131 and  hkd = 4338.9','')")

    con:query("insert into check_sql values(4822,'delete from transaction_total_check where cny = 4822 and jpy = 482200 and gbp = 3375.4 and eur = 535242 and  hkd = 4339.8','')")

    con:query("insert into check_sql values(4823,'delete from transaction_total_check where cny = 4823 and jpy = 482300 and gbp = 3376.1 and eur = 535353 and  hkd = 4340.7','')")

    con:query("insert into check_sql values(4824,'delete from transaction_total_check where cny = 4824 and jpy = 482400 and gbp = 3376.8 and eur = 535464 and  hkd = 4341.6','')")

    con:query("insert into check_sql values(4825,'delete from transaction_total_check where cny = 4825 and jpy = 482500 and gbp = 3377.5 and eur = 535575 and  hkd = 4342.5','')")

    con:query("insert into check_sql values(4826,'delete from transaction_total_check where cny = 4826 and jpy = 482600 and gbp = 3378.2 and eur = 535686 and  hkd = 4343.4','')")

    con:query("insert into check_sql values(4827,'delete from transaction_total_check where cny = 4827 and jpy = 482700 and gbp = 3378.9 and eur = 535797 and  hkd = 4344.3','')")

    con:query("insert into check_sql values(4828,'delete from transaction_total_check where cny = 4828 and jpy = 482800 and gbp = 3379.6 and eur = 535908 and  hkd = 4345.2','')")

    con:query("insert into check_sql values(4829,'delete from transaction_total_check where cny = 4829 and jpy = 482900 and gbp = 3380.3 and eur = 536019 and  hkd = 4346.1','')")

    con:query("insert into check_sql values(4830,'delete from transaction_total_check where cny = 4830 and jpy = 483000 and gbp = 3381.0 and eur = 536130 and  hkd = 4347.0','')")

    con:query("insert into check_sql values(4831,'delete from transaction_total_check where cny = 4831 and jpy = 483100 and gbp = 3381.7 and eur = 536241 and  hkd = 4347.9','')")

    con:query("insert into check_sql values(4832,'delete from transaction_total_check where cny = 4832 and jpy = 483200 and gbp = 3382.4 and eur = 536352 and  hkd = 4348.8','')")

    con:query("insert into check_sql values(4833,'delete from transaction_total_check where cny = 4833 and jpy = 483300 and gbp = 3383.1 and eur = 536463 and  hkd = 4349.7','')")

    con:query("insert into check_sql values(4834,'delete from transaction_total_check where cny = 4834 and jpy = 483400 and gbp = 3383.8 and eur = 536574 and  hkd = 4350.6','')")

    con:query("insert into check_sql values(4835,'delete from transaction_total_check where cny = 4835 and jpy = 483500 and gbp = 3384.5 and eur = 536685 and  hkd = 4351.5','')")

    con:query("insert into check_sql values(4836,'delete from transaction_total_check where cny = 4836 and jpy = 483600 and gbp = 3385.2 and eur = 536796 and  hkd = 4352.4','')")

    con:query("insert into check_sql values(4837,'delete from transaction_total_check where cny = 4837 and jpy = 483700 and gbp = 3385.9 and eur = 536907 and  hkd = 4353.3','')")

    con:query("insert into check_sql values(4838,'delete from transaction_total_check where cny = 4838 and jpy = 483800 and gbp = 3386.6 and eur = 537018 and  hkd = 4354.2','')")

    con:query("insert into check_sql values(4839,'delete from transaction_total_check where cny = 4839 and jpy = 483900 and gbp = 3387.3 and eur = 537129 and  hkd = 4355.1','')")

    con:query("insert into check_sql values(4840,'delete from transaction_total_check where cny = 4840 and jpy = 484000 and gbp = 3388.0 and eur = 537240 and  hkd = 4356.0','')")

    con:query("insert into check_sql values(4841,'delete from transaction_total_check where cny = 4841 and jpy = 484100 and gbp = 3388.7 and eur = 537351 and  hkd = 4356.9','')")

    con:query("insert into check_sql values(4842,'delete from transaction_total_check where cny = 4842 and jpy = 484200 and gbp = 3389.4 and eur = 537462 and  hkd = 4357.8','')")

    con:query("insert into check_sql values(4843,'delete from transaction_total_check where cny = 4843 and jpy = 484300 and gbp = 3390.1 and eur = 537573 and  hkd = 4358.7','')")

    con:query("insert into check_sql values(4844,'delete from transaction_total_check where cny = 4844 and jpy = 484400 and gbp = 3390.8 and eur = 537684 and  hkd = 4359.6','')")

    con:query("insert into check_sql values(4845,'delete from transaction_total_check where cny = 4845 and jpy = 484500 and gbp = 3391.5 and eur = 537795 and  hkd = 4360.5','')")

    con:query("insert into check_sql values(4846,'delete from transaction_total_check where cny = 4846 and jpy = 484600 and gbp = 3392.2 and eur = 537906 and  hkd = 4361.4','')")

    con:query("insert into check_sql values(4847,'delete from transaction_total_check where cny = 4847 and jpy = 484700 and gbp = 3392.9 and eur = 538017 and  hkd = 4362.3','')")

    con:query("insert into check_sql values(4848,'delete from transaction_total_check where cny = 4848 and jpy = 484800 and gbp = 3393.6 and eur = 538128 and  hkd = 4363.2','')")

    con:query("insert into check_sql values(4849,'delete from transaction_total_check where cny = 4849 and jpy = 484900 and gbp = 3394.3 and eur = 538239 and  hkd = 4364.1','')")

    con:query("insert into check_sql values(4850,'delete from transaction_total_check where cny = 4850 and jpy = 485000 and gbp = 3395.0 and eur = 538350 and  hkd = 4365.0','')")

    con:query("insert into check_sql values(4851,'delete from transaction_total_check where cny = 4851 and jpy = 485100 and gbp = 3395.7 and eur = 538461 and  hkd = 4365.9','')")

    con:query("insert into check_sql values(4852,'delete from transaction_total_check where cny = 4852 and jpy = 485200 and gbp = 3396.4 and eur = 538572 and  hkd = 4366.8','')")

    con:query("insert into check_sql values(4853,'delete from transaction_total_check where cny = 4853 and jpy = 485300 and gbp = 3397.1 and eur = 538683 and  hkd = 4367.7','')")

    con:query("insert into check_sql values(4854,'delete from transaction_total_check where cny = 4854 and jpy = 485400 and gbp = 3397.8 and eur = 538794 and  hkd = 4368.6','')")

    con:query("insert into check_sql values(4855,'delete from transaction_total_check where cny = 4855 and jpy = 485500 and gbp = 3398.5 and eur = 538905 and  hkd = 4369.5','')")

    con:query("insert into check_sql values(4856,'delete from transaction_total_check where cny = 4856 and jpy = 485600 and gbp = 3399.2 and eur = 539016 and  hkd = 4370.4','')")

    con:query("insert into check_sql values(4857,'delete from transaction_total_check where cny = 4857 and jpy = 485700 and gbp = 3399.9 and eur = 539127 and  hkd = 4371.3','')")

    con:query("insert into check_sql values(4858,'delete from transaction_total_check where cny = 4858 and jpy = 485800 and gbp = 3400.6 and eur = 539238 and  hkd = 4372.2','')")

    con:query("insert into check_sql values(4859,'delete from transaction_total_check where cny = 4859 and jpy = 485900 and gbp = 3401.3 and eur = 539349 and  hkd = 4373.1','')")

    con:query("insert into check_sql values(4860,'delete from transaction_total_check where cny = 4860 and jpy = 486000 and gbp = 3402.0 and eur = 539460 and  hkd = 4374.0','')")

    con:query("insert into check_sql values(4861,'delete from transaction_total_check where cny = 4861 and jpy = 486100 and gbp = 3402.7 and eur = 539571 and  hkd = 4374.9','')")

    con:query("insert into check_sql values(4862,'delete from transaction_total_check where cny = 4862 and jpy = 486200 and gbp = 3403.4 and eur = 539682 and  hkd = 4375.8','')")

    con:query("insert into check_sql values(4863,'delete from transaction_total_check where cny = 4863 and jpy = 486300 and gbp = 3404.1 and eur = 539793 and  hkd = 4376.7','')")

    con:query("insert into check_sql values(4864,'delete from transaction_total_check where cny = 4864 and jpy = 486400 and gbp = 3404.8 and eur = 539904 and  hkd = 4377.6','')")

    con:query("insert into check_sql values(4865,'delete from transaction_total_check where cny = 4865 and jpy = 486500 and gbp = 3405.5 and eur = 540015 and  hkd = 4378.5','')")

    con:query("insert into check_sql values(4866,'delete from transaction_total_check where cny = 4866 and jpy = 486600 and gbp = 3406.2 and eur = 540126 and  hkd = 4379.4','')")

    con:query("insert into check_sql values(4867,'delete from transaction_total_check where cny = 4867 and jpy = 486700 and gbp = 3406.9 and eur = 540237 and  hkd = 4380.3','')")

    con:query("insert into check_sql values(4868,'delete from transaction_total_check where cny = 4868 and jpy = 486800 and gbp = 3407.6 and eur = 540348 and  hkd = 4381.2','')")

    con:query("insert into check_sql values(4869,'delete from transaction_total_check where cny = 4869 and jpy = 486900 and gbp = 3408.3 and eur = 540459 and  hkd = 4382.1','')")

    con:query("insert into check_sql values(4870,'delete from transaction_total_check where cny = 4870 and jpy = 487000 and gbp = 3409.0 and eur = 540570 and  hkd = 4383.0','')")

    con:query("insert into check_sql values(4871,'delete from transaction_total_check where cny = 4871 and jpy = 487100 and gbp = 3409.7 and eur = 540681 and  hkd = 4383.9','')")

    con:query("insert into check_sql values(4872,'delete from transaction_total_check where cny = 4872 and jpy = 487200 and gbp = 3410.4 and eur = 540792 and  hkd = 4384.8','')")

    con:query("insert into check_sql values(4873,'delete from transaction_total_check where cny = 4873 and jpy = 487300 and gbp = 3411.1 and eur = 540903 and  hkd = 4385.7','')")

    con:query("insert into check_sql values(4874,'delete from transaction_total_check where cny = 4874 and jpy = 487400 and gbp = 3411.8 and eur = 541014 and  hkd = 4386.6','')")

    con:query("insert into check_sql values(4875,'delete from transaction_total_check where cny = 4875 and jpy = 487500 and gbp = 3412.5 and eur = 541125 and  hkd = 4387.5','')")

    con:query("insert into check_sql values(4876,'delete from transaction_total_check where cny = 4876 and jpy = 487600 and gbp = 3413.2 and eur = 541236 and  hkd = 4388.4','')")

    con:query("insert into check_sql values(4877,'delete from transaction_total_check where cny = 4877 and jpy = 487700 and gbp = 3413.9 and eur = 541347 and  hkd = 4389.3','')")

    con:query("insert into check_sql values(4878,'delete from transaction_total_check where cny = 4878 and jpy = 487800 and gbp = 3414.6 and eur = 541458 and  hkd = 4390.2','')")

    con:query("insert into check_sql values(4879,'delete from transaction_total_check where cny = 4879 and jpy = 487900 and gbp = 3415.3 and eur = 541569 and  hkd = 4391.1','')")

    con:query("insert into check_sql values(4880,'delete from transaction_total_check where cny = 4880 and jpy = 488000 and gbp = 3416.0 and eur = 541680 and  hkd = 4392.0','')")

    con:query("insert into check_sql values(4881,'delete from transaction_total_check where cny = 4881 and jpy = 488100 and gbp = 3416.7 and eur = 541791 and  hkd = 4392.9','')")

    con:query("insert into check_sql values(4882,'delete from transaction_total_check where cny = 4882 and jpy = 488200 and gbp = 3417.4 and eur = 541902 and  hkd = 4393.8','')")

    con:query("insert into check_sql values(4883,'delete from transaction_total_check where cny = 4883 and jpy = 488300 and gbp = 3418.1 and eur = 542013 and  hkd = 4394.7','')")

    con:query("insert into check_sql values(4884,'delete from transaction_total_check where cny = 4884 and jpy = 488400 and gbp = 3418.8 and eur = 542124 and  hkd = 4395.6','')")

    con:query("insert into check_sql values(4885,'delete from transaction_total_check where cny = 4885 and jpy = 488500 and gbp = 3419.5 and eur = 542235 and  hkd = 4396.5','')")

    con:query("insert into check_sql values(4886,'delete from transaction_total_check where cny = 4886 and jpy = 488600 and gbp = 3420.2 and eur = 542346 and  hkd = 4397.4','')")

    con:query("insert into check_sql values(4887,'delete from transaction_total_check where cny = 4887 and jpy = 488700 and gbp = 3420.9 and eur = 542457 and  hkd = 4398.3','')")

    con:query("insert into check_sql values(4888,'delete from transaction_total_check where cny = 4888 and jpy = 488800 and gbp = 3421.6 and eur = 542568 and  hkd = 4399.2','')")

    con:query("insert into check_sql values(4889,'delete from transaction_total_check where cny = 4889 and jpy = 488900 and gbp = 3422.3 and eur = 542679 and  hkd = 4400.1','')")

    con:query("insert into check_sql values(4890,'delete from transaction_total_check where cny = 4890 and jpy = 489000 and gbp = 3423.0 and eur = 542790 and  hkd = 4401.0','')")

    con:query("insert into check_sql values(4891,'delete from transaction_total_check where cny = 4891 and jpy = 489100 and gbp = 3423.7 and eur = 542901 and  hkd = 4401.9','')")

    con:query("insert into check_sql values(4892,'delete from transaction_total_check where cny = 4892 and jpy = 489200 and gbp = 3424.4 and eur = 543012 and  hkd = 4402.8','')")

    con:query("insert into check_sql values(4893,'delete from transaction_total_check where cny = 4893 and jpy = 489300 and gbp = 3425.1 and eur = 543123 and  hkd = 4403.7','')")

    con:query("insert into check_sql values(4894,'delete from transaction_total_check where cny = 4894 and jpy = 489400 and gbp = 3425.8 and eur = 543234 and  hkd = 4404.6','')")

    con:query("insert into check_sql values(4895,'delete from transaction_total_check where cny = 4895 and jpy = 489500 and gbp = 3426.5 and eur = 543345 and  hkd = 4405.5','')")

    con:query("insert into check_sql values(4896,'delete from transaction_total_check where cny = 4896 and jpy = 489600 and gbp = 3427.2 and eur = 543456 and  hkd = 4406.4','')")

    con:query("insert into check_sql values(4897,'delete from transaction_total_check where cny = 4897 and jpy = 489700 and gbp = 3427.9 and eur = 543567 and  hkd = 4407.3','')")

    con:query("insert into check_sql values(4898,'delete from transaction_total_check where cny = 4898 and jpy = 489800 and gbp = 3428.6 and eur = 543678 and  hkd = 4408.2','')")

    con:query("insert into check_sql values(4899,'delete from transaction_total_check where cny = 4899 and jpy = 489900 and gbp = 3429.3 and eur = 543789 and  hkd = 4409.1','')")

    con:query("insert into check_sql values(4900,'delete from transaction_total_check where cny = 4900 and jpy = 490000 and gbp = 3430.0 and eur = 543900 and  hkd = 4410.0','')")

    con:query("insert into check_sql values(4901,'delete from transaction_total_check where cny = 4901 and jpy = 490100 and gbp = 3430.7 and eur = 544011 and  hkd = 4410.9','')")

    con:query("insert into check_sql values(4902,'delete from transaction_total_check where cny = 4902 and jpy = 490200 and gbp = 3431.4 and eur = 544122 and  hkd = 4411.8','')")

    con:query("insert into check_sql values(4903,'delete from transaction_total_check where cny = 4903 and jpy = 490300 and gbp = 3432.1 and eur = 544233 and  hkd = 4412.7','')")

    con:query("insert into check_sql values(4904,'delete from transaction_total_check where cny = 4904 and jpy = 490400 and gbp = 3432.8 and eur = 544344 and  hkd = 4413.6','')")

    con:query("insert into check_sql values(4905,'delete from transaction_total_check where cny = 4905 and jpy = 490500 and gbp = 3433.5 and eur = 544455 and  hkd = 4414.5','')")

    con:query("insert into check_sql values(4906,'delete from transaction_total_check where cny = 4906 and jpy = 490600 and gbp = 3434.2 and eur = 544566 and  hkd = 4415.4','')")

    con:query("insert into check_sql values(4907,'delete from transaction_total_check where cny = 4907 and jpy = 490700 and gbp = 3434.9 and eur = 544677 and  hkd = 4416.3','')")

    con:query("insert into check_sql values(4908,'delete from transaction_total_check where cny = 4908 and jpy = 490800 and gbp = 3435.6 and eur = 544788 and  hkd = 4417.2','')")

    con:query("insert into check_sql values(4909,'delete from transaction_total_check where cny = 4909 and jpy = 490900 and gbp = 3436.3 and eur = 544899 and  hkd = 4418.1','')")

    con:query("insert into check_sql values(4910,'delete from transaction_total_check where cny = 4910 and jpy = 491000 and gbp = 3437.0 and eur = 545010 and  hkd = 4419.0','')")

    con:query("insert into check_sql values(4911,'delete from transaction_total_check where cny = 4911 and jpy = 491100 and gbp = 3437.7 and eur = 545121 and  hkd = 4419.9','')")

    con:query("insert into check_sql values(4912,'delete from transaction_total_check where cny = 4912 and jpy = 491200 and gbp = 3438.4 and eur = 545232 and  hkd = 4420.8','')")

    con:query("insert into check_sql values(4913,'delete from transaction_total_check where cny = 4913 and jpy = 491300 and gbp = 3439.1 and eur = 545343 and  hkd = 4421.7','')")

    con:query("insert into check_sql values(4914,'delete from transaction_total_check where cny = 4914 and jpy = 491400 and gbp = 3439.8 and eur = 545454 and  hkd = 4422.6','')")

    con:query("insert into check_sql values(4915,'delete from transaction_total_check where cny = 4915 and jpy = 491500 and gbp = 3440.5 and eur = 545565 and  hkd = 4423.5','')")

    con:query("insert into check_sql values(4916,'delete from transaction_total_check where cny = 4916 and jpy = 491600 and gbp = 3441.2 and eur = 545676 and  hkd = 4424.4','')")

    con:query("insert into check_sql values(4917,'delete from transaction_total_check where cny = 4917 and jpy = 491700 and gbp = 3441.9 and eur = 545787 and  hkd = 4425.3','')")

    con:query("insert into check_sql values(4918,'delete from transaction_total_check where cny = 4918 and jpy = 491800 and gbp = 3442.6 and eur = 545898 and  hkd = 4426.2','')")

    con:query("insert into check_sql values(4919,'delete from transaction_total_check where cny = 4919 and jpy = 491900 and gbp = 3443.3 and eur = 546009 and  hkd = 4427.1','')")

    con:query("insert into check_sql values(4920,'delete from transaction_total_check where cny = 4920 and jpy = 492000 and gbp = 3444.0 and eur = 546120 and  hkd = 4428.0','')")

    con:query("insert into check_sql values(4921,'delete from transaction_total_check where cny = 4921 and jpy = 492100 and gbp = 3444.7 and eur = 546231 and  hkd = 4428.9','')")

    con:query("insert into check_sql values(4922,'delete from transaction_total_check where cny = 4922 and jpy = 492200 and gbp = 3445.4 and eur = 546342 and  hkd = 4429.8','')")

    con:query("insert into check_sql values(4923,'delete from transaction_total_check where cny = 4923 and jpy = 492300 and gbp = 3446.1 and eur = 546453 and  hkd = 4430.7','')")

    con:query("insert into check_sql values(4924,'delete from transaction_total_check where cny = 4924 and jpy = 492400 and gbp = 3446.8 and eur = 546564 and  hkd = 4431.6','')")

    con:query("insert into check_sql values(4925,'delete from transaction_total_check where cny = 4925 and jpy = 492500 and gbp = 3447.5 and eur = 546675 and  hkd = 4432.5','')")

    con:query("insert into check_sql values(4926,'delete from transaction_total_check where cny = 4926 and jpy = 492600 and gbp = 3448.2 and eur = 546786 and  hkd = 4433.4','')")

    con:query("insert into check_sql values(4927,'delete from transaction_total_check where cny = 4927 and jpy = 492700 and gbp = 3448.9 and eur = 546897 and  hkd = 4434.3','')")

    con:query("insert into check_sql values(4928,'delete from transaction_total_check where cny = 4928 and jpy = 492800 and gbp = 3449.6 and eur = 547008 and  hkd = 4435.2','')")

    con:query("insert into check_sql values(4929,'delete from transaction_total_check where cny = 4929 and jpy = 492900 and gbp = 3450.3 and eur = 547119 and  hkd = 4436.1','')")

    con:query("insert into check_sql values(4930,'delete from transaction_total_check where cny = 4930 and jpy = 493000 and gbp = 3451.0 and eur = 547230 and  hkd = 4437.0','')")

    con:query("insert into check_sql values(4931,'delete from transaction_total_check where cny = 4931 and jpy = 493100 and gbp = 3451.7 and eur = 547341 and  hkd = 4437.9','')")

    con:query("insert into check_sql values(4932,'delete from transaction_total_check where cny = 4932 and jpy = 493200 and gbp = 3452.4 and eur = 547452 and  hkd = 4438.8','')")

    con:query("insert into check_sql values(4933,'delete from transaction_total_check where cny = 4933 and jpy = 493300 and gbp = 3453.1 and eur = 547563 and  hkd = 4439.7','')")

    con:query("insert into check_sql values(4934,'delete from transaction_total_check where cny = 4934 and jpy = 493400 and gbp = 3453.8 and eur = 547674 and  hkd = 4440.6','')")

    con:query("insert into check_sql values(4935,'delete from transaction_total_check where cny = 4935 and jpy = 493500 and gbp = 3454.5 and eur = 547785 and  hkd = 4441.5','')")

    con:query("insert into check_sql values(4936,'delete from transaction_total_check where cny = 4936 and jpy = 493600 and gbp = 3455.2 and eur = 547896 and  hkd = 4442.4','')")

    con:query("insert into check_sql values(4937,'delete from transaction_total_check where cny = 4937 and jpy = 493700 and gbp = 3455.9 and eur = 548007 and  hkd = 4443.3','')")

    con:query("insert into check_sql values(4938,'delete from transaction_total_check where cny = 4938 and jpy = 493800 and gbp = 3456.6 and eur = 548118 and  hkd = 4444.2','')")

    con:query("insert into check_sql values(4939,'delete from transaction_total_check where cny = 4939 and jpy = 493900 and gbp = 3457.3 and eur = 548229 and  hkd = 4445.1','')")

    con:query("insert into check_sql values(4940,'delete from transaction_total_check where cny = 4940 and jpy = 494000 and gbp = 3458.0 and eur = 548340 and  hkd = 4446.0','')")

    con:query("insert into check_sql values(4941,'delete from transaction_total_check where cny = 4941 and jpy = 494100 and gbp = 3458.7 and eur = 548451 and  hkd = 4446.9','')")

    con:query("insert into check_sql values(4942,'delete from transaction_total_check where cny = 4942 and jpy = 494200 and gbp = 3459.4 and eur = 548562 and  hkd = 4447.8','')")

    con:query("insert into check_sql values(4943,'delete from transaction_total_check where cny = 4943 and jpy = 494300 and gbp = 3460.1 and eur = 548673 and  hkd = 4448.7','')")

    con:query("insert into check_sql values(4944,'delete from transaction_total_check where cny = 4944 and jpy = 494400 and gbp = 3460.8 and eur = 548784 and  hkd = 4449.6','')")

    con:query("insert into check_sql values(4945,'delete from transaction_total_check where cny = 4945 and jpy = 494500 and gbp = 3461.5 and eur = 548895 and  hkd = 4450.5','')")

    con:query("insert into check_sql values(4946,'delete from transaction_total_check where cny = 4946 and jpy = 494600 and gbp = 3462.2 and eur = 549006 and  hkd = 4451.4','')")

    con:query("insert into check_sql values(4947,'delete from transaction_total_check where cny = 4947 and jpy = 494700 and gbp = 3462.9 and eur = 549117 and  hkd = 4452.3','')")

    con:query("insert into check_sql values(4948,'delete from transaction_total_check where cny = 4948 and jpy = 494800 and gbp = 3463.6 and eur = 549228 and  hkd = 4453.2','')")

    con:query("insert into check_sql values(4949,'delete from transaction_total_check where cny = 4949 and jpy = 494900 and gbp = 3464.3 and eur = 549339 and  hkd = 4454.1','')")

    con:query("insert into check_sql values(4950,'delete from transaction_total_check where cny = 4950 and jpy = 495000 and gbp = 3465.0 and eur = 549450 and  hkd = 4455.0','')")

    con:query("insert into check_sql values(4951,'delete from transaction_total_check where cny = 4951 and jpy = 495100 and gbp = 3465.7 and eur = 549561 and  hkd = 4455.9','')")

    con:query("insert into check_sql values(4952,'delete from transaction_total_check where cny = 4952 and jpy = 495200 and gbp = 3466.4 and eur = 549672 and  hkd = 4456.8','')")

    con:query("insert into check_sql values(4953,'delete from transaction_total_check where cny = 4953 and jpy = 495300 and gbp = 3467.1 and eur = 549783 and  hkd = 4457.7','')")

    con:query("insert into check_sql values(4954,'delete from transaction_total_check where cny = 4954 and jpy = 495400 and gbp = 3467.8 and eur = 549894 and  hkd = 4458.6','')")

    con:query("insert into check_sql values(4955,'delete from transaction_total_check where cny = 4955 and jpy = 495500 and gbp = 3468.5 and eur = 550005 and  hkd = 4459.5','')")

    con:query("insert into check_sql values(4956,'delete from transaction_total_check where cny = 4956 and jpy = 495600 and gbp = 3469.2 and eur = 550116 and  hkd = 4460.4','')")

    con:query("insert into check_sql values(4957,'delete from transaction_total_check where cny = 4957 and jpy = 495700 and gbp = 3469.9 and eur = 550227 and  hkd = 4461.3','')")

    con:query("insert into check_sql values(4958,'delete from transaction_total_check where cny = 4958 and jpy = 495800 and gbp = 3470.6 and eur = 550338 and  hkd = 4462.2','')")

    con:query("insert into check_sql values(4959,'delete from transaction_total_check where cny = 4959 and jpy = 495900 and gbp = 3471.3 and eur = 550449 and  hkd = 4463.1','')")

    con:query("insert into check_sql values(4960,'delete from transaction_total_check where cny = 4960 and jpy = 496000 and gbp = 3472.0 and eur = 550560 and  hkd = 4464.0','')")

    con:query("insert into check_sql values(4961,'delete from transaction_total_check where cny = 4961 and jpy = 496100 and gbp = 3472.7 and eur = 550671 and  hkd = 4464.9','')")

    con:query("insert into check_sql values(4962,'delete from transaction_total_check where cny = 4962 and jpy = 496200 and gbp = 3473.4 and eur = 550782 and  hkd = 4465.8','')")

    con:query("insert into check_sql values(4963,'delete from transaction_total_check where cny = 4963 and jpy = 496300 and gbp = 3474.1 and eur = 550893 and  hkd = 4466.7','')")

    con:query("insert into check_sql values(4964,'delete from transaction_total_check where cny = 4964 and jpy = 496400 and gbp = 3474.8 and eur = 551004 and  hkd = 4467.6','')")

    con:query("insert into check_sql values(4965,'delete from transaction_total_check where cny = 4965 and jpy = 496500 and gbp = 3475.5 and eur = 551115 and  hkd = 4468.5','')")

    con:query("insert into check_sql values(4966,'delete from transaction_total_check where cny = 4966 and jpy = 496600 and gbp = 3476.2 and eur = 551226 and  hkd = 4469.4','')")

    con:query("insert into check_sql values(4967,'delete from transaction_total_check where cny = 4967 and jpy = 496700 and gbp = 3476.9 and eur = 551337 and  hkd = 4470.3','')")

    con:query("insert into check_sql values(4968,'delete from transaction_total_check where cny = 4968 and jpy = 496800 and gbp = 3477.6 and eur = 551448 and  hkd = 4471.2','')")

    con:query("insert into check_sql values(4969,'delete from transaction_total_check where cny = 4969 and jpy = 496900 and gbp = 3478.3 and eur = 551559 and  hkd = 4472.1','')")

    con:query("insert into check_sql values(4970,'delete from transaction_total_check where cny = 4970 and jpy = 497000 and gbp = 3479.0 and eur = 551670 and  hkd = 4473.0','')")

    con:query("insert into check_sql values(4971,'delete from transaction_total_check where cny = 4971 and jpy = 497100 and gbp = 3479.7 and eur = 551781 and  hkd = 4473.9','')")

    con:query("insert into check_sql values(4972,'delete from transaction_total_check where cny = 4972 and jpy = 497200 and gbp = 3480.4 and eur = 551892 and  hkd = 4474.8','')")

    con:query("insert into check_sql values(4973,'delete from transaction_total_check where cny = 4973 and jpy = 497300 and gbp = 3481.1 and eur = 552003 and  hkd = 4475.7','')")

    con:query("insert into check_sql values(4974,'delete from transaction_total_check where cny = 4974 and jpy = 497400 and gbp = 3481.8 and eur = 552114 and  hkd = 4476.6','')")

    con:query("insert into check_sql values(4975,'delete from transaction_total_check where cny = 4975 and jpy = 497500 and gbp = 3482.5 and eur = 552225 and  hkd = 4477.5','')")

    con:query("insert into check_sql values(4976,'delete from transaction_total_check where cny = 4976 and jpy = 497600 and gbp = 3483.2 and eur = 552336 and  hkd = 4478.4','')")

    con:query("insert into check_sql values(4977,'delete from transaction_total_check where cny = 4977 and jpy = 497700 and gbp = 3483.9 and eur = 552447 and  hkd = 4479.3','')")

    con:query("insert into check_sql values(4978,'delete from transaction_total_check where cny = 4978 and jpy = 497800 and gbp = 3484.6 and eur = 552558 and  hkd = 4480.2','')")

    con:query("insert into check_sql values(4979,'delete from transaction_total_check where cny = 4979 and jpy = 497900 and gbp = 3485.3 and eur = 552669 and  hkd = 4481.1','')")

    con:query("insert into check_sql values(4980,'delete from transaction_total_check where cny = 4980 and jpy = 498000 and gbp = 3486.0 and eur = 552780 and  hkd = 4482.0','')")

    con:query("insert into check_sql values(4981,'delete from transaction_total_check where cny = 4981 and jpy = 498100 and gbp = 3486.7 and eur = 552891 and  hkd = 4482.9','')")

    con:query("insert into check_sql values(4982,'delete from transaction_total_check where cny = 4982 and jpy = 498200 and gbp = 3487.4 and eur = 553002 and  hkd = 4483.8','')")

    con:query("insert into check_sql values(4983,'delete from transaction_total_check where cny = 4983 and jpy = 498300 and gbp = 3488.1 and eur = 553113 and  hkd = 4484.7','')")

    con:query("insert into check_sql values(4984,'delete from transaction_total_check where cny = 4984 and jpy = 498400 and gbp = 3488.8 and eur = 553224 and  hkd = 4485.6','')")

    con:query("insert into check_sql values(4985,'delete from transaction_total_check where cny = 4985 and jpy = 498500 and gbp = 3489.5 and eur = 553335 and  hkd = 4486.5','')")

    con:query("insert into check_sql values(4986,'delete from transaction_total_check where cny = 4986 and jpy = 498600 and gbp = 3490.2 and eur = 553446 and  hkd = 4487.4','')")

    con:query("insert into check_sql values(4987,'delete from transaction_total_check where cny = 4987 and jpy = 498700 and gbp = 3490.9 and eur = 553557 and  hkd = 4488.3','')")

    con:query("insert into check_sql values(4988,'delete from transaction_total_check where cny = 4988 and jpy = 498800 and gbp = 3491.6 and eur = 553668 and  hkd = 4489.2','')")

    con:query("insert into check_sql values(4989,'delete from transaction_total_check where cny = 4989 and jpy = 498900 and gbp = 3492.3 and eur = 553779 and  hkd = 4490.1','')")

    con:query("insert into check_sql values(4990,'delete from transaction_total_check where cny = 4990 and jpy = 499000 and gbp = 3493.0 and eur = 553890 and  hkd = 4491.0','')")

    con:query("insert into check_sql values(4991,'delete from transaction_total_check where cny = 4991 and jpy = 499100 and gbp = 3493.7 and eur = 554001 and  hkd = 4491.9','')")

    con:query("insert into check_sql values(4992,'delete from transaction_total_check where cny = 4992 and jpy = 499200 and gbp = 3494.4 and eur = 554112 and  hkd = 4492.8','')")

    con:query("insert into check_sql values(4993,'delete from transaction_total_check where cny = 4993 and jpy = 499300 and gbp = 3495.1 and eur = 554223 and  hkd = 4493.7','')")

    con:query("insert into check_sql values(4994,'delete from transaction_total_check where cny = 4994 and jpy = 499400 and gbp = 3495.8 and eur = 554334 and  hkd = 4494.6','')")

    con:query("insert into check_sql values(4995,'delete from transaction_total_check where cny = 4995 and jpy = 499500 and gbp = 3496.5 and eur = 554445 and  hkd = 4495.5','')")

    con:query("insert into check_sql values(4996,'delete from transaction_total_check where cny = 4996 and jpy = 499600 and gbp = 3497.2 and eur = 554556 and  hkd = 4496.4','')")

    con:query("insert into check_sql values(4997,'delete from transaction_total_check where cny = 4997 and jpy = 499700 and gbp = 3497.9 and eur = 554667 and  hkd = 4497.3','')")

    con:query("insert into check_sql values(4998,'delete from transaction_total_check where cny = 4998 and jpy = 499800 and gbp = 3498.6 and eur = 554778 and  hkd = 4498.2','')")

    con:query("insert into check_sql values(4999,'delete from transaction_total_check where cny = 4999 and jpy = 499900 and gbp = 3499.3 and eur = 554889 and  hkd = 4499.1','')")

    con:query("insert into check_sql values(5000,'delete from transaction_total_check where cny = 5000 and jpy = 500000 and gbp = 3500.0 and eur = 555000 and  hkd = 4500.0','')")


end

-- 3. init migration table
function init_migration_table()

   local drv = sysbench.sql.driver()
   local con = drv:connect()

   print('init migration table .....')

   drop_migration_table_sql = "drop table if exists ?1 "

   create_migration_table_sql = "create table if not exists ?1 ( transaction_detail_id serial primary key , transaction_id integer , cny decimal ,    jpy decimal ,    gbp decimal ,    eur decimal ,    hkd decimal )"

   for i = 1, migration_table_amount do

        sql = string.gsub(drop_migration_table_sql,"?1", migration_table_name_prefix..tostring(i))

        con:query(sql)

        sql = string.gsub(create_migration_table_sql,"?1",migration_table_name_prefix..tostring(i))

        con:query(sql)

   end

end


function event()

    -- 1. insert

--    insertBatch()

    -- 2. do migration

--    migration()

    -- 3. do check

    do_check()

    -- 4. fo debug
    -- check_all_tables()

end

function insertBatch()

    con:query('begin')

    -- 1. get id

    sql = "select nextval('transaction_total_transaction_id_seq')"

    rs = con:query(sql)

    row = rs:fetch_row()

    transaction_id = row[1]

    -- 2.insert Detail

    depth = math.random(transaction_depth);

    for i = 1,depth do

        do_insert_detail(transaction_id)

    end

    -- 3.insert total

    do_insert_total(transaction_id)

    -- 4.check

    con:query('end')

end


function do_insert_total(transaction_id)

    sql = 'insert into transaction_total ( select transaction_id, sum(cny) cny,sum(jpy), sum(gbp),sum(eur),sum(hkd) from transaction_detail where transaction_id = ? group by transaction_id )'

    con:query(string.gsub(sql,'?',transaction_id))

end

function do_insert_detail(transaction_id)

    sqls = {
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-100,-10000,-70.0,-11100,-90.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-99,-9900,-69.3,-10989,-89.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-98,-9800,-68.6,-10878,-88.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-97,-9700,-67.9,-10767,-87.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-96,-9600,-67.2,-10656,-86.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-95,-9500,-66.5,-10545,-85.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-94,-9400,-65.8,-10434,-84.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-93,-9300,-65.1,-10323,-83.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-92,-9200,-64.4,-10212,-82.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-91,-9100,-63.7,-10101,-81.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-90,-9000,-63.0,-9990,-81.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-89,-8900,-62.3,-9879,-80.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-88,-8800,-61.6,-9768,-79.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-87,-8700,-60.9,-9657,-78.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-86,-8600,-60.2,-9546,-77.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-85,-8500,-59.5,-9435,-76.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-84,-8400,-58.8,-9324,-75.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-83,-8300,-58.1,-9213,-74.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-82,-8200,-57.4,-9102,-73.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-81,-8100,-56.7,-8991,-72.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-80,-8000,-56.0,-8880,-72.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-79,-7900,-55.3,-8769,-71.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-78,-7800,-54.6,-8658,-70.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-77,-7700,-53.9,-8547,-69.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-76,-7600,-53.2,-8436,-68.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-75,-7500,-52.5,-8325,-67.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-74,-7400,-51.8,-8214,-66.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-73,-7300,-51.1,-8103,-65.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-72,-7200,-50.4,-7992,-64.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-71,-7100,-49.7,-7881,-63.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-70,-7000,-49.0,-7770,-63.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-69,-6900,-48.3,-7659,-62.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-68,-6800,-47.6,-7548,-61.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-67,-6700,-46.9,-7437,-60.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-66,-6600,-46.2,-7326,-59.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-65,-6500,-45.5,-7215,-58.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-64,-6400,-44.8,-7104,-57.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-63,-6300,-44.1,-6993,-56.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-62,-6200,-43.4,-6882,-55.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-61,-6100,-42.7,-6771,-54.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-60,-6000,-42.0,-6660,-54.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-59,-5900,-41.3,-6549,-53.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-58,-5800,-40.6,-6438,-52.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-57,-5700,-39.9,-6327,-51.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-56,-5600,-39.2,-6216,-50.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-55,-5500,-38.5,-6105,-49.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-54,-5400,-37.8,-5994,-48.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-53,-5300,-37.1,-5883,-47.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-52,-5200,-36.4,-5772,-46.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-51,-5100,-35.7,-5661,-45.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-50,-5000,-35.0,-5550,-45.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-49,-4900,-34.3,-5439,-44.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-48,-4800,-33.6,-5328,-43.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-47,-4700,-32.9,-5217,-42.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-46,-4600,-32.2,-5106,-41.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-45,-4500,-31.5,-4995,-40.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-44,-4400,-30.8,-4884,-39.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-43,-4300,-30.1,-4773,-38.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-42,-4200,-29.4,-4662,-37.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-41,-4100,-28.7,-4551,-36.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-40,-4000,-28.0,-4440,-36.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-39,-3900,-27.3,-4329,-35.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-38,-3800,-26.6,-4218,-34.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-37,-3700,-25.9,-4107,-33.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-36,-3600,-25.2,-3996,-32.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-35,-3500,-24.5,-3885,-31.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-34,-3400,-23.8,-3774,-30.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-33,-3300,-23.1,-3663,-29.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-32,-3200,-22.4,-3552,-28.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-31,-3100,-21.7,-3441,-27.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-30,-3000,-21.0,-3330,-27.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-29,-2900,-20.3,-3219,-26.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-28,-2800,-19.6,-3108,-25.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-27,-2700,-18.9,-2997,-24.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-26,-2600,-18.2,-2886,-23.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-25,-2500,-17.5,-2775,-22.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-24,-2400,-16.8,-2664,-21.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-23,-2300,-16.1,-2553,-20.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-22,-2200,-15.4,-2442,-19.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-21,-2100,-14.7,-2331,-18.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-20,-2000,-14.0,-2220,-18.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-19,-1900,-13.3,-2109,-17.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-18,-1800,-12.6,-1998,-16.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-17,-1700,-11.9,-1887,-15.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-16,-1600,-11.2,-1776,-14.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-15,-1500,-10.5,-1665,-13.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-14,-1400,-9.8,-1554,-12.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-13,-1300,-9.1,-1443,-11.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-12,-1200,-8.4,-1332,-10.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-11,-1100,-7.7,-1221,-9.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-10,-1000,-7.0,-1110,-9.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-9,-900,-6.3,-999,-8.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-8,-800,-5.6,-888,-7.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-7,-700,-4.9,-777,-6.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-6,-600,-4.2,-666,-5.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-5,-500,-3.5,-555,-4.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-4,-400,-2.8,-444,-3.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-3,-300,-2.1,-333,-2.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-2,-200,-1.4,-222,-1.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,-1,-100,-0.7,-111,-0.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,0,0,0.0,0,0.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,1,100,0.7,111,0.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,2,200,1.4,222,1.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,3,300,2.1,333,2.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,4,400,2.8,444,3.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,5,500,3.5,555,4.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,6,600,4.2,666,5.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,7,700,4.9,777,6.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,8,800,5.6,888,7.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,9,900,6.3,999,8.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,10,1000,7.0,1110,9.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,11,1100,7.7,1221,9.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,12,1200,8.4,1332,10.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,13,1300,9.1,1443,11.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,14,1400,9.8,1554,12.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,15,1500,10.5,1665,13.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,16,1600,11.2,1776,14.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,17,1700,11.9,1887,15.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,18,1800,12.6,1998,16.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,19,1900,13.3,2109,17.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,20,2000,14.0,2220,18.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,21,2100,14.7,2331,18.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,22,2200,15.4,2442,19.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,23,2300,16.1,2553,20.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,24,2400,16.8,2664,21.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,25,2500,17.5,2775,22.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,26,2600,18.2,2886,23.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,27,2700,18.9,2997,24.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,28,2800,19.6,3108,25.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,29,2900,20.3,3219,26.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,30,3000,21.0,3330,27.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,31,3100,21.7,3441,27.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,32,3200,22.4,3552,28.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,33,3300,23.1,3663,29.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,34,3400,23.8,3774,30.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,35,3500,24.5,3885,31.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,36,3600,25.2,3996,32.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,37,3700,25.9,4107,33.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,38,3800,26.6,4218,34.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,39,3900,27.3,4329,35.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,40,4000,28.0,4440,36.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,41,4100,28.7,4551,36.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,42,4200,29.4,4662,37.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,43,4300,30.1,4773,38.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,44,4400,30.8,4884,39.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,45,4500,31.5,4995,40.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,46,4600,32.2,5106,41.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,47,4700,32.9,5217,42.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,48,4800,33.6,5328,43.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,49,4900,34.3,5439,44.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,50,5000,35.0,5550,45.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,51,5100,35.7,5661,45.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,52,5200,36.4,5772,46.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,53,5300,37.1,5883,47.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,54,5400,37.8,5994,48.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,55,5500,38.5,6105,49.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,56,5600,39.2,6216,50.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,57,5700,39.9,6327,51.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,58,5800,40.6,6438,52.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,59,5900,41.3,6549,53.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,60,6000,42.0,6660,54.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,61,6100,42.7,6771,54.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,62,6200,43.4,6882,55.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,63,6300,44.1,6993,56.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,64,6400,44.8,7104,57.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,65,6500,45.5,7215,58.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,66,6600,46.2,7326,59.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,67,6700,46.9,7437,60.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,68,6800,47.6,7548,61.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,69,6900,48.3,7659,62.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,70,7000,49.0,7770,63.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,71,7100,49.7,7881,63.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,72,7200,50.4,7992,64.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,73,7300,51.1,8103,65.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,74,7400,51.8,8214,66.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,75,7500,52.5,8325,67.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,76,7600,53.2,8436,68.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,77,7700,53.9,8547,69.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,78,7800,54.6,8658,70.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,79,7900,55.3,8769,71.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,80,8000,56.0,8880,72.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,81,8100,56.7,8991,72.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,82,8200,57.4,9102,73.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,83,8300,58.1,9213,74.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,84,8400,58.8,9324,75.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,85,8500,59.5,9435,76.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,86,8600,60.2,9546,77.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,87,8700,60.9,9657,78.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,88,8800,61.6,9768,79.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,89,8900,62.3,9879,80.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,90,9000,63.0,9990,81.0)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,91,9100,63.7,10101,81.9)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,92,9200,64.4,10212,82.8)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,93,9300,65.1,10323,83.7)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,94,9400,65.8,10434,84.6)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,95,9500,66.5,10545,85.5)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,96,9600,67.2,10656,86.4)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,97,9700,67.9,10767,87.3)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,98,9800,68.6,10878,88.2)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,99,9900,69.3,10989,89.1)",
        
            "insert into transaction_detail (transaction_id,cny,jpy,gbp,eur,hkd) values(?,100,10000,70.0,11100,90.0)",
        
    }

    num = math.random(201);

    con:query(string.gsub(sqls[num],"?",transaction_id))

end

-- 2. migration

function migration()

    -- copy

    table_id = math.random(migration_table_amount)

    table_name = migration_table_name_prefix..tostring(table_id)

    migration_table_sql = "insert into ?1 ( select * from transaction_detail  where transaction_id in( select transaction_id   from transaction_total   where transaction_id not in (select transaction_id from ?1 )   group by transaction_id  ORDER BY random()  limit ?2 ) )"

    sql = string.gsub(migration_table_sql,"?1",table_name)

    sql = string.gsub(sql,"?2",tostring(migration_limit*2))

    con:query(sql)

    -- delete

    delete_migration_sql = " delete from ?1 where transaction_id in ( select transaction_id from ?1 group by  transaction_id ORDER BY random() limit (  select count(*)/2 from ( select distinct transaction_id from ?1  ) a ) )"

    sql = string.gsub(delete_migration_sql,"?1",table_name)

    sql = string.gsub(sql,"?2",tostring(migration_limit))

    con:query(sql)

end


-- 3. do check

function do_check()

    con:query('begin')

    -- 1. get one table

    table_id = math.random(migration_table_amount)

    table_name = migration_table_name_prefix..tostring(table_id)

    -- 2. get one transaction

    sql = "select transaction_id from ?1 ORDER BY random() limit 1"

    sql = string.gsub(sql,"?1",table_name)

    rs = con:query(sql)

    row = rs:fetch_row()

    -- if table is empty
    if (rs.nrows == 0 )

        then
            print("table is empty : "..table_name )

            con:query("rollback")

            return

        end


    transaction_id = row[1]

    -- 3. copy to check table

    sql = 'insert into transaction_total_check ( select transaction_id, sum(cny) cny,sum(jpy), sum(gbp),sum(eur),sum(hkd) from ?1 where transaction_id = ?2 group by transaction_id )'

    sql = string.gsub(sql,"?1",table_name)

    sql = string.gsub(sql,"?2",transaction_id)

    con:query(sql)

    -- 4. get check sql

    sql = 'select delete_sql from check_sql where key in ( select cny from transaction_total where transaction_id = ?1 )'

    sql = string.gsub(sql,"?1",transaction_id)

    rs2 = con:query(sql)

    if (rs2.nrows == 0)

        then
            print('do not find check sql !')

            con:query('ROLLBACK')

            return

        end

    row2 = rs2:fetch_row()

    delete_sql = row2[1]

    con:query('end')

    -- 5. do delete (check)
    --
    -- print(delete_sql)

    con:query(delete_sql)

    -- 7. check table

    con:query('end')

    do_check_empty()

end

function do_check_empty()

    rs = con:query("select * from transaction_total_check")

    if (rs.nrows > 0 )

    then

        print("Find Incorrect Row!")

        print_dump(rs:fetch_row())

    end

end

function print_dump(data, showMetatable, lastCount)
    if type(data) ~= "table" then
        --Value
        if type(data) == "string" then
            io.write("\"", data, "\"")
        else
            io.write(tostring(data))
        end
    else
        --Format
        local count = lastCount or 0
        count = count + 1
        io.write("{\n")
        --Metatable
        if showMetatable then
            for i = 1,count do io.write("\t") end
            local mt = getmetatable(data)
            io.write("\"__metatable\" = ")
            print_dump(mt, showMetatable, count)
            io.write(",\n")
        end
        --Key
        for key,value in pairs(data) do
            for i = 1,count do io.write("\t") end
            if type(key) == "string" then
                io.write("\"", key, "\" = ")
            elseif type(key) == "number" then
                io.write("[", key, "] = ")
            else
                io.write(tostring(key))
            end
            print_dump(value, showMetatable, count)
            io.write(",\n")
        end
        --Format
        for i = 1,lastCount or 0 do io.write("\t") end
        io.write("}")
    end
    --Format
    if not lastCount then
        io.write("\n")
    end
end